"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayEditor = void 0;
var react_1 = __importStar(require("react"));
var material_1 = require("@mui/material");
var Add_1 = __importDefault(require("@mui/icons-material/Add"));
var arrayReducer_1 = require("../../reducers/arrayReducer");
var valueToString_1 = __importDefault(require("../../utils/valueToString"));
var listWrapStyle = {
    width: '100%',
    flex: 1,
    border: 1,
    borderColor: 'grey.500',
    borderRadius: 1,
    boxSizing: 'border-box',
    overflow: 'auto',
    position: 'relative',
    minHeight: 100,
};
var listStyle = {
    position: 'absolute',
    width: '100%',
};
var listItemTextTypographyStyle = {
    align: 'left',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
};
function ArrayEditor(_a) {
    var onChange = _a.onChange, value = _a.value, newItemValue = _a.newItemValue, onEdit = _a.onEdit;
    var _b = __read((0, react_1.useReducer)(arrayReducer_1.arrayReducer, value), 2), arr = _b[0], dispatch = _b[1];
    (0, react_1.useEffect)(function () {
        onChange(arr);
    }, [arr, onChange]);
    (0, react_1.useEffect)(function () {
        dispatch({ action: arrayReducer_1.ArrayActions.SET, value: value });
    }, [value]);
    var onAdd = function () {
        dispatch({ action: arrayReducer_1.ArrayActions.ADD_ITEM, value: newItemValue(arr) });
    };
    return (react_1.default.createElement(material_1.Stack, { display: "flex", width: "100%", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", spacing: 1, flex: 1 },
        react_1.default.createElement(material_1.Box, { sx: listWrapStyle },
            react_1.default.createElement(material_1.List, { dense: true, sx: listStyle }, arr.map(function (itemValue, index) { return (
            // we do want to use the index here as the key as the items may not be unique
            // eslint-disable-next-line react/no-array-index-key
            react_1.default.createElement(material_1.ListItem, { key: index, disablePadding: true },
                react_1.default.createElement(material_1.ListItemButton, { onClick: function () { return onEdit(index); } },
                    react_1.default.createElement(material_1.ListItemText, { primaryTypographyProps: listItemTextTypographyStyle, primary: (0, valueToString_1.default)(itemValue) })))); }))),
        react_1.default.createElement(material_1.Button, { endIcon: react_1.default.createElement(Add_1.default, null), color: "primary", variant: "outlined", fullWidth: true, onClick: onAdd }, "Add new")));
}
exports.ArrayEditor = ArrayEditor;
//# sourceMappingURL=ArrayEditor.js.map