(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["material-jsoneditor"] = {}));
})(this, (function (exports) { 'use strict';

    function _mergeNamespaces(n, m) {
        m.forEach(function (e) {
            e && typeof e !== 'string' && !Array.isArray(e) && Object.keys(e).forEach(function (k) {
                if (k !== 'default' && !(k in n)) {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        });
        return Object.freeze(n);
    }

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || Array.prototype.slice.call(from));
    }

    const common = {
      black: '#000',
      white: '#fff'
    };
    var common$1 = common;

    const red = {
      50: '#ffebee',
      100: '#ffcdd2',
      200: '#ef9a9a',
      300: '#e57373',
      400: '#ef5350',
      500: '#f44336',
      600: '#e53935',
      700: '#d32f2f',
      800: '#c62828',
      900: '#b71c1c',
      A100: '#ff8a80',
      A200: '#ff5252',
      A400: '#ff1744',
      A700: '#d50000'
    };
    var red$1 = red;

    const purple = {
      50: '#f3e5f5',
      100: '#e1bee7',
      200: '#ce93d8',
      300: '#ba68c8',
      400: '#ab47bc',
      500: '#9c27b0',
      600: '#8e24aa',
      700: '#7b1fa2',
      800: '#6a1b9a',
      900: '#4a148c',
      A100: '#ea80fc',
      A200: '#e040fb',
      A400: '#d500f9',
      A700: '#aa00ff'
    };
    var purple$1 = purple;

    const blue = {
      50: '#e3f2fd',
      100: '#bbdefb',
      200: '#90caf9',
      300: '#64b5f6',
      400: '#42a5f5',
      500: '#2196f3',
      600: '#1e88e5',
      700: '#1976d2',
      800: '#1565c0',
      900: '#0d47a1',
      A100: '#82b1ff',
      A200: '#448aff',
      A400: '#2979ff',
      A700: '#2962ff'
    };
    var blue$1 = blue;

    const lightBlue = {
      50: '#e1f5fe',
      100: '#b3e5fc',
      200: '#81d4fa',
      300: '#4fc3f7',
      400: '#29b6f6',
      500: '#03a9f4',
      600: '#039be5',
      700: '#0288d1',
      800: '#0277bd',
      900: '#01579b',
      A100: '#80d8ff',
      A200: '#40c4ff',
      A400: '#00b0ff',
      A700: '#0091ea'
    };
    var lightBlue$1 = lightBlue;

    const green = {
      50: '#e8f5e9',
      100: '#c8e6c9',
      200: '#a5d6a7',
      300: '#81c784',
      400: '#66bb6a',
      500: '#4caf50',
      600: '#43a047',
      700: '#388e3c',
      800: '#2e7d32',
      900: '#1b5e20',
      A100: '#b9f6ca',
      A200: '#69f0ae',
      A400: '#00e676',
      A700: '#00c853'
    };
    var green$1 = green;

    const orange = {
      50: '#fff3e0',
      100: '#ffe0b2',
      200: '#ffcc80',
      300: '#ffb74d',
      400: '#ffa726',
      500: '#ff9800',
      600: '#fb8c00',
      700: '#f57c00',
      800: '#ef6c00',
      900: '#e65100',
      A100: '#ffd180',
      A200: '#ffab40',
      A400: '#ff9100',
      A700: '#ff6d00'
    };
    var orange$1 = orange;

    const grey = {
      50: '#fafafa',
      100: '#f5f5f5',
      200: '#eeeeee',
      300: '#e0e0e0',
      400: '#bdbdbd',
      500: '#9e9e9e',
      600: '#757575',
      700: '#616161',
      800: '#424242',
      900: '#212121',
      A100: '#f5f5f5',
      A200: '#eeeeee',
      A400: '#bdbdbd',
      A700: '#616161'
    };
    var grey$1 = grey;

    function _extends$1() {
      _extends$1 = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];

          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }

        return target;
      };

      return _extends$1.apply(this, arguments);
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key, i;

      for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
      }

      return target;
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function getDefaultExportFromCjs (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
    }

    function getAugmentedNamespace(n) {
      var f = n.default;
    	if (typeof f == "function") {
    		var a = function () {
    			return f.apply(this, arguments);
    		};
    		a.prototype = f.prototype;
      } else a = {};
      Object.defineProperty(a, '__esModule', {value: true});
    	Object.keys(n).forEach(function (k) {
    		var d = Object.getOwnPropertyDescriptor(n, k);
    		Object.defineProperty(a, k, d.get ? d : {
    			enumerable: true,
    			get: function () {
    				return n[k];
    			}
    		});
    	});
    	return a;
    }

    var _extends = {exports: {}};

    (function (module) {
    	function _extends() {
    	  module.exports = _extends = Object.assign || function (target) {
    	    for (var i = 1; i < arguments.length; i++) {
    	      var source = arguments[i];

    	      for (var key in source) {
    	        if (Object.prototype.hasOwnProperty.call(source, key)) {
    	          target[key] = source[key];
    	        }
    	      }
    	    }

    	    return target;
    	  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
    	  return _extends.apply(this, arguments);
    	}

    	module.exports = _extends, module.exports.__esModule = true, module.exports["default"] = module.exports;
    } (_extends));

    var react = {exports: {}};

    var react_production_min = {};

    /*
    object-assign
    (c) Sindre Sorhus
    @license MIT
    */

    var objectAssign;
    var hasRequiredObjectAssign;

    function requireObjectAssign () {
    	if (hasRequiredObjectAssign) return objectAssign;
    	hasRequiredObjectAssign = 1;
    	/* eslint-disable no-unused-vars */
    	var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    	var hasOwnProperty = Object.prototype.hasOwnProperty;
    	var propIsEnumerable = Object.prototype.propertyIsEnumerable;

    	function toObject(val) {
    		if (val === null || val === undefined) {
    			throw new TypeError('Object.assign cannot be called with null or undefined');
    		}

    		return Object(val);
    	}

    	function shouldUseNative() {
    		try {
    			if (!Object.assign) {
    				return false;
    			}

    			// Detect buggy property enumeration order in older V8 versions.

    			// https://bugs.chromium.org/p/v8/issues/detail?id=4118
    			var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
    			test1[5] = 'de';
    			if (Object.getOwnPropertyNames(test1)[0] === '5') {
    				return false;
    			}

    			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    			var test2 = {};
    			for (var i = 0; i < 10; i++) {
    				test2['_' + String.fromCharCode(i)] = i;
    			}
    			var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
    				return test2[n];
    			});
    			if (order2.join('') !== '0123456789') {
    				return false;
    			}

    			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    			var test3 = {};
    			'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
    				test3[letter] = letter;
    			});
    			if (Object.keys(Object.assign({}, test3)).join('') !==
    					'abcdefghijklmnopqrst') {
    				return false;
    			}

    			return true;
    		} catch (err) {
    			// We don't expect any of the above to throw, but better to be safe.
    			return false;
    		}
    	}

    	objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
    		var from;
    		var to = toObject(target);
    		var symbols;

    		for (var s = 1; s < arguments.length; s++) {
    			from = Object(arguments[s]);

    			for (var key in from) {
    				if (hasOwnProperty.call(from, key)) {
    					to[key] = from[key];
    				}
    			}

    			if (getOwnPropertySymbols) {
    				symbols = getOwnPropertySymbols(from);
    				for (var i = 0; i < symbols.length; i++) {
    					if (propIsEnumerable.call(from, symbols[i])) {
    						to[symbols[i]] = from[symbols[i]];
    					}
    				}
    			}
    		}

    		return to;
    	};
    	return objectAssign;
    }

    /** @license React v17.0.2
     * react.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReact_production_min;

    function requireReact_production_min () {
    	if (hasRequiredReact_production_min) return react_production_min;
    	hasRequiredReact_production_min = 1;
    var l=requireObjectAssign(),n=60103,p=60106;react_production_min.Fragment=60107;react_production_min.StrictMode=60108;react_production_min.Profiler=60114;var q=60109,r=60110,t=60112;react_production_min.Suspense=60113;var u=60115,v=60116;
    	if("function"===typeof Symbol&&Symbol.for){var w=Symbol.for;n=w("react.element");p=w("react.portal");react_production_min.Fragment=w("react.fragment");react_production_min.StrictMode=w("react.strict_mode");react_production_min.Profiler=w("react.profiler");q=w("react.provider");r=w("react.context");t=w("react.forward_ref");react_production_min.Suspense=w("react.suspense");u=w("react.memo");v=w("react.lazy");}var x="function"===typeof Symbol&&Symbol.iterator;
    	function y(a){if(null===a||"object"!==typeof a)return null;a=x&&a[x]||a["@@iterator"];return "function"===typeof a?a:null}function z(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return "Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}
    	var A={isMounted:function(){return !1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},B={};function C(a,b,c){this.props=a;this.context=b;this.refs=B;this.updater=c||A;}C.prototype.isReactComponent={};C.prototype.setState=function(a,b){if("object"!==typeof a&&"function"!==typeof a&&null!=a)throw Error(z(85));this.updater.enqueueSetState(this,a,b,"setState");};C.prototype.forceUpdate=function(a){this.updater.enqueueForceUpdate(this,a,"forceUpdate");};
    	function D(){}D.prototype=C.prototype;function E(a,b,c){this.props=a;this.context=b;this.refs=B;this.updater=c||A;}var F=E.prototype=new D;F.constructor=E;l(F,C.prototype);F.isPureReactComponent=!0;var G={current:null},H=Object.prototype.hasOwnProperty,I={key:!0,ref:!0,__self:!0,__source:!0};
    	function J(a,b,c){var e,d={},k=null,h=null;if(null!=b)for(e in void 0!==b.ref&&(h=b.ref),void 0!==b.key&&(k=""+b.key),b)H.call(b,e)&&!I.hasOwnProperty(e)&&(d[e]=b[e]);var g=arguments.length-2;if(1===g)d.children=c;else if(1<g){for(var f=Array(g),m=0;m<g;m++)f[m]=arguments[m+2];d.children=f;}if(a&&a.defaultProps)for(e in g=a.defaultProps,g)void 0===d[e]&&(d[e]=g[e]);return {$$typeof:n,type:a,key:k,ref:h,props:d,_owner:G.current}}
    	function K(a,b){return {$$typeof:n,type:a.type,key:b,ref:a.ref,props:a.props,_owner:a._owner}}function L(a){return "object"===typeof a&&null!==a&&a.$$typeof===n}function escape(a){var b={"=":"=0",":":"=2"};return "$"+a.replace(/[=:]/g,function(a){return b[a]})}var M=/\/+/g;function N(a,b){return "object"===typeof a&&null!==a&&null!=a.key?escape(""+a.key):b.toString(36)}
    	function O(a,b,c,e,d){var k=typeof a;if("undefined"===k||"boolean"===k)a=null;var h=!1;if(null===a)h=!0;else switch(k){case "string":case "number":h=!0;break;case "object":switch(a.$$typeof){case n:case p:h=!0;}}if(h)return h=a,d=d(h),a=""===e?"."+N(h,0):e,Array.isArray(d)?(c="",null!=a&&(c=a.replace(M,"$&/")+"/"),O(d,b,c,"",function(a){return a})):null!=d&&(L(d)&&(d=K(d,c+(!d.key||h&&h.key===d.key?"":(""+d.key).replace(M,"$&/")+"/")+a)),b.push(d)),1;h=0;e=""===e?".":e+":";if(Array.isArray(a))for(var g=
    	0;g<a.length;g++){k=a[g];var f=e+N(k,g);h+=O(k,b,c,f,d);}else if(f=y(a),"function"===typeof f)for(a=f.call(a),g=0;!(k=a.next()).done;)k=k.value,f=e+N(k,g++),h+=O(k,b,c,f,d);else if("object"===k)throw b=""+a,Error(z(31,"[object Object]"===b?"object with keys {"+Object.keys(a).join(", ")+"}":b));return h}function P(a,b,c){if(null==a)return a;var e=[],d=0;O(a,e,"","",function(a){return b.call(c,a,d++)});return e}
    	function Q(a){if(-1===a._status){var b=a._result;b=b();a._status=0;a._result=b;b.then(function(b){0===a._status&&(b=b.default,a._status=1,a._result=b);},function(b){0===a._status&&(a._status=2,a._result=b);});}if(1===a._status)return a._result;throw a._result;}var R={current:null};function S(){var a=R.current;if(null===a)throw Error(z(321));return a}var T={ReactCurrentDispatcher:R,ReactCurrentBatchConfig:{transition:0},ReactCurrentOwner:G,IsSomeRendererActing:{current:!1},assign:l};
    	react_production_min.Children={map:P,forEach:function(a,b,c){P(a,function(){b.apply(this,arguments);},c);},count:function(a){var b=0;P(a,function(){b++;});return b},toArray:function(a){return P(a,function(a){return a})||[]},only:function(a){if(!L(a))throw Error(z(143));return a}};react_production_min.Component=C;react_production_min.PureComponent=E;react_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=T;
    	react_production_min.cloneElement=function(a,b,c){if(null===a||void 0===a)throw Error(z(267,a));var e=l({},a.props),d=a.key,k=a.ref,h=a._owner;if(null!=b){void 0!==b.ref&&(k=b.ref,h=G.current);void 0!==b.key&&(d=""+b.key);if(a.type&&a.type.defaultProps)var g=a.type.defaultProps;for(f in b)H.call(b,f)&&!I.hasOwnProperty(f)&&(e[f]=void 0===b[f]&&void 0!==g?g[f]:b[f]);}var f=arguments.length-2;if(1===f)e.children=c;else if(1<f){g=Array(f);for(var m=0;m<f;m++)g[m]=arguments[m+2];e.children=g;}return {$$typeof:n,type:a.type,
    	key:d,ref:k,props:e,_owner:h}};react_production_min.createContext=function(a,b){void 0===b&&(b=null);a={$$typeof:r,_calculateChangedBits:b,_currentValue:a,_currentValue2:a,_threadCount:0,Provider:null,Consumer:null};a.Provider={$$typeof:q,_context:a};return a.Consumer=a};react_production_min.createElement=J;react_production_min.createFactory=function(a){var b=J.bind(null,a);b.type=a;return b};react_production_min.createRef=function(){return {current:null}};react_production_min.forwardRef=function(a){return {$$typeof:t,render:a}};react_production_min.isValidElement=L;
    	react_production_min.lazy=function(a){return {$$typeof:v,_payload:{_status:-1,_result:a},_init:Q}};react_production_min.memo=function(a,b){return {$$typeof:u,type:a,compare:void 0===b?null:b}};react_production_min.useCallback=function(a,b){return S().useCallback(a,b)};react_production_min.useContext=function(a,b){return S().useContext(a,b)};react_production_min.useDebugValue=function(){};react_production_min.useEffect=function(a,b){return S().useEffect(a,b)};react_production_min.useImperativeHandle=function(a,b,c){return S().useImperativeHandle(a,b,c)};
    	react_production_min.useLayoutEffect=function(a,b){return S().useLayoutEffect(a,b)};react_production_min.useMemo=function(a,b){return S().useMemo(a,b)};react_production_min.useReducer=function(a,b,c){return S().useReducer(a,b,c)};react_production_min.useRef=function(a){return S().useRef(a)};react_production_min.useState=function(a){return S().useState(a)};react_production_min.version="17.0.2";
    	return react_production_min;
    }

    var react_development = {};

    /** @license React v17.0.2
     * react.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReact_development;

    function requireReact_development () {
    	if (hasRequiredReact_development) return react_development;
    	hasRequiredReact_development = 1;
    	(function (exports) {

    		if (process.env.NODE_ENV !== "production") {
    		  (function() {

    		var _assign = requireObjectAssign();

    		// TODO: this is special because it gets imported during build.
    		var ReactVersion = '17.0.2';

    		// ATTENTION
    		// When adding new symbols to this file,
    		// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
    		// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    		// nor polyfill, then a plain number is used for performance.
    		var REACT_ELEMENT_TYPE = 0xeac7;
    		var REACT_PORTAL_TYPE = 0xeaca;
    		exports.Fragment = 0xeacb;
    		exports.StrictMode = 0xeacc;
    		exports.Profiler = 0xead2;
    		var REACT_PROVIDER_TYPE = 0xeacd;
    		var REACT_CONTEXT_TYPE = 0xeace;
    		var REACT_FORWARD_REF_TYPE = 0xead0;
    		exports.Suspense = 0xead1;
    		var REACT_SUSPENSE_LIST_TYPE = 0xead8;
    		var REACT_MEMO_TYPE = 0xead3;
    		var REACT_LAZY_TYPE = 0xead4;
    		var REACT_BLOCK_TYPE = 0xead9;
    		var REACT_SERVER_BLOCK_TYPE = 0xeada;
    		var REACT_FUNDAMENTAL_TYPE = 0xead5;
    		var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
    		var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

    		if (typeof Symbol === 'function' && Symbol.for) {
    		  var symbolFor = Symbol.for;
    		  REACT_ELEMENT_TYPE = symbolFor('react.element');
    		  REACT_PORTAL_TYPE = symbolFor('react.portal');
    		  exports.Fragment = symbolFor('react.fragment');
    		  exports.StrictMode = symbolFor('react.strict_mode');
    		  exports.Profiler = symbolFor('react.profiler');
    		  REACT_PROVIDER_TYPE = symbolFor('react.provider');
    		  REACT_CONTEXT_TYPE = symbolFor('react.context');
    		  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
    		  exports.Suspense = symbolFor('react.suspense');
    		  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
    		  REACT_MEMO_TYPE = symbolFor('react.memo');
    		  REACT_LAZY_TYPE = symbolFor('react.lazy');
    		  REACT_BLOCK_TYPE = symbolFor('react.block');
    		  REACT_SERVER_BLOCK_TYPE = symbolFor('react.server.block');
    		  REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
    		  symbolFor('react.scope');
    		  symbolFor('react.opaque.id');
    		  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
    		  symbolFor('react.offscreen');
    		  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
    		}

    		var MAYBE_ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    		var FAUX_ITERATOR_SYMBOL = '@@iterator';
    		function getIteratorFn(maybeIterable) {
    		  if (maybeIterable === null || typeof maybeIterable !== 'object') {
    		    return null;
    		  }

    		  var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];

    		  if (typeof maybeIterator === 'function') {
    		    return maybeIterator;
    		  }

    		  return null;
    		}

    		/**
    		 * Keeps track of the current dispatcher.
    		 */
    		var ReactCurrentDispatcher = {
    		  /**
    		   * @internal
    		   * @type {ReactComponent}
    		   */
    		  current: null
    		};

    		/**
    		 * Keeps track of the current batch's configuration such as how long an update
    		 * should suspend for if it needs to.
    		 */
    		var ReactCurrentBatchConfig = {
    		  transition: 0
    		};

    		/**
    		 * Keeps track of the current owner.
    		 *
    		 * The current owner is the component who should own any components that are
    		 * currently being constructed.
    		 */
    		var ReactCurrentOwner = {
    		  /**
    		   * @internal
    		   * @type {ReactComponent}
    		   */
    		  current: null
    		};

    		var ReactDebugCurrentFrame = {};
    		var currentExtraStackFrame = null;
    		function setExtraStackFrame(stack) {
    		  {
    		    currentExtraStackFrame = stack;
    		  }
    		}

    		{
    		  ReactDebugCurrentFrame.setExtraStackFrame = function (stack) {
    		    {
    		      currentExtraStackFrame = stack;
    		    }
    		  }; // Stack implementation injected by the current renderer.


    		  ReactDebugCurrentFrame.getCurrentStack = null;

    		  ReactDebugCurrentFrame.getStackAddendum = function () {
    		    var stack = ''; // Add an extra top frame while an element is being validated

    		    if (currentExtraStackFrame) {
    		      stack += currentExtraStackFrame;
    		    } // Delegate to the injected renderer-specific implementation


    		    var impl = ReactDebugCurrentFrame.getCurrentStack;

    		    if (impl) {
    		      stack += impl() || '';
    		    }

    		    return stack;
    		  };
    		}

    		/**
    		 * Used by act() to track whether you're inside an act() scope.
    		 */
    		var IsSomeRendererActing = {
    		  current: false
    		};

    		var ReactSharedInternals = {
    		  ReactCurrentDispatcher: ReactCurrentDispatcher,
    		  ReactCurrentBatchConfig: ReactCurrentBatchConfig,
    		  ReactCurrentOwner: ReactCurrentOwner,
    		  IsSomeRendererActing: IsSomeRendererActing,
    		  // Used by renderers to avoid bundling object-assign twice in UMD bundles:
    		  assign: _assign
    		};

    		{
    		  ReactSharedInternals.ReactDebugCurrentFrame = ReactDebugCurrentFrame;
    		}

    		// by calls to these methods by a Babel plugin.
    		//
    		// In PROD (or in packages without access to React internals),
    		// they are left as they are instead.

    		function warn(format) {
    		  {
    		    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    		      args[_key - 1] = arguments[_key];
    		    }

    		    printWarning('warn', format, args);
    		  }
    		}
    		function error(format) {
    		  {
    		    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    		      args[_key2 - 1] = arguments[_key2];
    		    }

    		    printWarning('error', format, args);
    		  }
    		}

    		function printWarning(level, format, args) {
    		  // When changing this logic, you might want to also
    		  // update consoleWithStackDev.www.js as well.
    		  {
    		    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
    		    var stack = ReactDebugCurrentFrame.getStackAddendum();

    		    if (stack !== '') {
    		      format += '%s';
    		      args = args.concat([stack]);
    		    }

    		    var argsWithFormat = args.map(function (item) {
    		      return '' + item;
    		    }); // Careful: RN currently depends on this prefix

    		    argsWithFormat.unshift('Warning: ' + format); // We intentionally don't use spread (or .apply) directly because it
    		    // breaks IE9: https://github.com/facebook/react/issues/13610
    		    // eslint-disable-next-line react-internal/no-production-logging

    		    Function.prototype.apply.call(console[level], console, argsWithFormat);
    		  }
    		}

    		var didWarnStateUpdateForUnmountedComponent = {};

    		function warnNoop(publicInstance, callerName) {
    		  {
    		    var _constructor = publicInstance.constructor;
    		    var componentName = _constructor && (_constructor.displayName || _constructor.name) || 'ReactClass';
    		    var warningKey = componentName + "." + callerName;

    		    if (didWarnStateUpdateForUnmountedComponent[warningKey]) {
    		      return;
    		    }

    		    error("Can't call %s on a component that is not yet mounted. " + 'This is a no-op, but it might indicate a bug in your application. ' + 'Instead, assign to `this.state` directly or define a `state = {};` ' + 'class property with the desired state in the %s component.', callerName, componentName);

    		    didWarnStateUpdateForUnmountedComponent[warningKey] = true;
    		  }
    		}
    		/**
    		 * This is the abstract API for an update queue.
    		 */


    		var ReactNoopUpdateQueue = {
    		  /**
    		   * Checks whether or not this composite component is mounted.
    		   * @param {ReactClass} publicInstance The instance we want to test.
    		   * @return {boolean} True if mounted, false otherwise.
    		   * @protected
    		   * @final
    		   */
    		  isMounted: function (publicInstance) {
    		    return false;
    		  },

    		  /**
    		   * Forces an update. This should only be invoked when it is known with
    		   * certainty that we are **not** in a DOM transaction.
    		   *
    		   * You may want to call this when you know that some deeper aspect of the
    		   * component's state has changed but `setState` was not called.
    		   *
    		   * This will not invoke `shouldComponentUpdate`, but it will invoke
    		   * `componentWillUpdate` and `componentDidUpdate`.
    		   *
    		   * @param {ReactClass} publicInstance The instance that should rerender.
    		   * @param {?function} callback Called after component is updated.
    		   * @param {?string} callerName name of the calling function in the public API.
    		   * @internal
    		   */
    		  enqueueForceUpdate: function (publicInstance, callback, callerName) {
    		    warnNoop(publicInstance, 'forceUpdate');
    		  },

    		  /**
    		   * Replaces all of the state. Always use this or `setState` to mutate state.
    		   * You should treat `this.state` as immutable.
    		   *
    		   * There is no guarantee that `this.state` will be immediately updated, so
    		   * accessing `this.state` after calling this method may return the old value.
    		   *
    		   * @param {ReactClass} publicInstance The instance that should rerender.
    		   * @param {object} completeState Next state.
    		   * @param {?function} callback Called after component is updated.
    		   * @param {?string} callerName name of the calling function in the public API.
    		   * @internal
    		   */
    		  enqueueReplaceState: function (publicInstance, completeState, callback, callerName) {
    		    warnNoop(publicInstance, 'replaceState');
    		  },

    		  /**
    		   * Sets a subset of the state. This only exists because _pendingState is
    		   * internal. This provides a merging strategy that is not available to deep
    		   * properties which is confusing. TODO: Expose pendingState or don't use it
    		   * during the merge.
    		   *
    		   * @param {ReactClass} publicInstance The instance that should rerender.
    		   * @param {object} partialState Next partial state to be merged with state.
    		   * @param {?function} callback Called after component is updated.
    		   * @param {?string} Name of the calling function in the public API.
    		   * @internal
    		   */
    		  enqueueSetState: function (publicInstance, partialState, callback, callerName) {
    		    warnNoop(publicInstance, 'setState');
    		  }
    		};

    		var emptyObject = {};

    		{
    		  Object.freeze(emptyObject);
    		}
    		/**
    		 * Base class helpers for the updating state of a component.
    		 */


    		function Component(props, context, updater) {
    		  this.props = props;
    		  this.context = context; // If a component has string refs, we will assign a different object later.

    		  this.refs = emptyObject; // We initialize the default updater but the real one gets injected by the
    		  // renderer.

    		  this.updater = updater || ReactNoopUpdateQueue;
    		}

    		Component.prototype.isReactComponent = {};
    		/**
    		 * Sets a subset of the state. Always use this to mutate
    		 * state. You should treat `this.state` as immutable.
    		 *
    		 * There is no guarantee that `this.state` will be immediately updated, so
    		 * accessing `this.state` after calling this method may return the old value.
    		 *
    		 * There is no guarantee that calls to `setState` will run synchronously,
    		 * as they may eventually be batched together.  You can provide an optional
    		 * callback that will be executed when the call to setState is actually
    		 * completed.
    		 *
    		 * When a function is provided to setState, it will be called at some point in
    		 * the future (not synchronously). It will be called with the up to date
    		 * component arguments (state, props, context). These values can be different
    		 * from this.* because your function may be called after receiveProps but before
    		 * shouldComponentUpdate, and this new state, props, and context will not yet be
    		 * assigned to this.
    		 *
    		 * @param {object|function} partialState Next partial state or function to
    		 *        produce next partial state to be merged with current state.
    		 * @param {?function} callback Called after state is updated.
    		 * @final
    		 * @protected
    		 */

    		Component.prototype.setState = function (partialState, callback) {
    		  if (!(typeof partialState === 'object' || typeof partialState === 'function' || partialState == null)) {
    		    {
    		      throw Error( "setState(...): takes an object of state variables to update or a function which returns an object of state variables." );
    		    }
    		  }

    		  this.updater.enqueueSetState(this, partialState, callback, 'setState');
    		};
    		/**
    		 * Forces an update. This should only be invoked when it is known with
    		 * certainty that we are **not** in a DOM transaction.
    		 *
    		 * You may want to call this when you know that some deeper aspect of the
    		 * component's state has changed but `setState` was not called.
    		 *
    		 * This will not invoke `shouldComponentUpdate`, but it will invoke
    		 * `componentWillUpdate` and `componentDidUpdate`.
    		 *
    		 * @param {?function} callback Called after update is complete.
    		 * @final
    		 * @protected
    		 */


    		Component.prototype.forceUpdate = function (callback) {
    		  this.updater.enqueueForceUpdate(this, callback, 'forceUpdate');
    		};
    		/**
    		 * Deprecated APIs. These APIs used to exist on classic React classes but since
    		 * we would like to deprecate them, we're not going to move them over to this
    		 * modern base class. Instead, we define a getter that warns if it's accessed.
    		 */


    		{
    		  var deprecatedAPIs = {
    		    isMounted: ['isMounted', 'Instead, make sure to clean up subscriptions and pending requests in ' + 'componentWillUnmount to prevent memory leaks.'],
    		    replaceState: ['replaceState', 'Refactor your code to use setState instead (see ' + 'https://github.com/facebook/react/issues/3236).']
    		  };

    		  var defineDeprecationWarning = function (methodName, info) {
    		    Object.defineProperty(Component.prototype, methodName, {
    		      get: function () {
    		        warn('%s(...) is deprecated in plain JavaScript React classes. %s', info[0], info[1]);

    		        return undefined;
    		      }
    		    });
    		  };

    		  for (var fnName in deprecatedAPIs) {
    		    if (deprecatedAPIs.hasOwnProperty(fnName)) {
    		      defineDeprecationWarning(fnName, deprecatedAPIs[fnName]);
    		    }
    		  }
    		}

    		function ComponentDummy() {}

    		ComponentDummy.prototype = Component.prototype;
    		/**
    		 * Convenience component with default shallow equality check for sCU.
    		 */

    		function PureComponent(props, context, updater) {
    		  this.props = props;
    		  this.context = context; // If a component has string refs, we will assign a different object later.

    		  this.refs = emptyObject;
    		  this.updater = updater || ReactNoopUpdateQueue;
    		}

    		var pureComponentPrototype = PureComponent.prototype = new ComponentDummy();
    		pureComponentPrototype.constructor = PureComponent; // Avoid an extra prototype jump for these methods.

    		_assign(pureComponentPrototype, Component.prototype);

    		pureComponentPrototype.isPureReactComponent = true;

    		// an immutable object with a single mutable value
    		function createRef() {
    		  var refObject = {
    		    current: null
    		  };

    		  {
    		    Object.seal(refObject);
    		  }

    		  return refObject;
    		}

    		function getWrappedName(outerType, innerType, wrapperName) {
    		  var functionName = innerType.displayName || innerType.name || '';
    		  return outerType.displayName || (functionName !== '' ? wrapperName + "(" + functionName + ")" : wrapperName);
    		}

    		function getContextName(type) {
    		  return type.displayName || 'Context';
    		}

    		function getComponentName(type) {
    		  if (type == null) {
    		    // Host root, text node or just invalid type.
    		    return null;
    		  }

    		  {
    		    if (typeof type.tag === 'number') {
    		      error('Received an unexpected object in getComponentName(). ' + 'This is likely a bug in React. Please file an issue.');
    		    }
    		  }

    		  if (typeof type === 'function') {
    		    return type.displayName || type.name || null;
    		  }

    		  if (typeof type === 'string') {
    		    return type;
    		  }

    		  switch (type) {
    		    case exports.Fragment:
    		      return 'Fragment';

    		    case REACT_PORTAL_TYPE:
    		      return 'Portal';

    		    case exports.Profiler:
    		      return 'Profiler';

    		    case exports.StrictMode:
    		      return 'StrictMode';

    		    case exports.Suspense:
    		      return 'Suspense';

    		    case REACT_SUSPENSE_LIST_TYPE:
    		      return 'SuspenseList';
    		  }

    		  if (typeof type === 'object') {
    		    switch (type.$$typeof) {
    		      case REACT_CONTEXT_TYPE:
    		        var context = type;
    		        return getContextName(context) + '.Consumer';

    		      case REACT_PROVIDER_TYPE:
    		        var provider = type;
    		        return getContextName(provider._context) + '.Provider';

    		      case REACT_FORWARD_REF_TYPE:
    		        return getWrappedName(type, type.render, 'ForwardRef');

    		      case REACT_MEMO_TYPE:
    		        return getComponentName(type.type);

    		      case REACT_BLOCK_TYPE:
    		        return getComponentName(type._render);

    		      case REACT_LAZY_TYPE:
    		        {
    		          var lazyComponent = type;
    		          var payload = lazyComponent._payload;
    		          var init = lazyComponent._init;

    		          try {
    		            return getComponentName(init(payload));
    		          } catch (x) {
    		            return null;
    		          }
    		        }
    		    }
    		  }

    		  return null;
    		}

    		var hasOwnProperty = Object.prototype.hasOwnProperty;
    		var RESERVED_PROPS = {
    		  key: true,
    		  ref: true,
    		  __self: true,
    		  __source: true
    		};
    		var specialPropKeyWarningShown, specialPropRefWarningShown, didWarnAboutStringRefs;

    		{
    		  didWarnAboutStringRefs = {};
    		}

    		function hasValidRef(config) {
    		  {
    		    if (hasOwnProperty.call(config, 'ref')) {
    		      var getter = Object.getOwnPropertyDescriptor(config, 'ref').get;

    		      if (getter && getter.isReactWarning) {
    		        return false;
    		      }
    		    }
    		  }

    		  return config.ref !== undefined;
    		}

    		function hasValidKey(config) {
    		  {
    		    if (hasOwnProperty.call(config, 'key')) {
    		      var getter = Object.getOwnPropertyDescriptor(config, 'key').get;

    		      if (getter && getter.isReactWarning) {
    		        return false;
    		      }
    		    }
    		  }

    		  return config.key !== undefined;
    		}

    		function defineKeyPropWarningGetter(props, displayName) {
    		  var warnAboutAccessingKey = function () {
    		    {
    		      if (!specialPropKeyWarningShown) {
    		        specialPropKeyWarningShown = true;

    		        error('%s: `key` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
    		      }
    		    }
    		  };

    		  warnAboutAccessingKey.isReactWarning = true;
    		  Object.defineProperty(props, 'key', {
    		    get: warnAboutAccessingKey,
    		    configurable: true
    		  });
    		}

    		function defineRefPropWarningGetter(props, displayName) {
    		  var warnAboutAccessingRef = function () {
    		    {
    		      if (!specialPropRefWarningShown) {
    		        specialPropRefWarningShown = true;

    		        error('%s: `ref` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
    		      }
    		    }
    		  };

    		  warnAboutAccessingRef.isReactWarning = true;
    		  Object.defineProperty(props, 'ref', {
    		    get: warnAboutAccessingRef,
    		    configurable: true
    		  });
    		}

    		function warnIfStringRefCannotBeAutoConverted(config) {
    		  {
    		    if (typeof config.ref === 'string' && ReactCurrentOwner.current && config.__self && ReactCurrentOwner.current.stateNode !== config.__self) {
    		      var componentName = getComponentName(ReactCurrentOwner.current.type);

    		      if (!didWarnAboutStringRefs[componentName]) {
    		        error('Component "%s" contains the string ref "%s". ' + 'Support for string refs will be removed in a future major release. ' + 'This case cannot be automatically converted to an arrow function. ' + 'We ask you to manually fix this case by using useRef() or createRef() instead. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-string-ref', componentName, config.ref);

    		        didWarnAboutStringRefs[componentName] = true;
    		      }
    		    }
    		  }
    		}
    		/**
    		 * Factory method to create a new React element. This no longer adheres to
    		 * the class pattern, so do not use new to call it. Also, instanceof check
    		 * will not work. Instead test $$typeof field against Symbol.for('react.element') to check
    		 * if something is a React Element.
    		 *
    		 * @param {*} type
    		 * @param {*} props
    		 * @param {*} key
    		 * @param {string|object} ref
    		 * @param {*} owner
    		 * @param {*} self A *temporary* helper to detect places where `this` is
    		 * different from the `owner` when React.createElement is called, so that we
    		 * can warn. We want to get rid of owner and replace string `ref`s with arrow
    		 * functions, and as long as `this` and owner are the same, there will be no
    		 * change in behavior.
    		 * @param {*} source An annotation object (added by a transpiler or otherwise)
    		 * indicating filename, line number, and/or other information.
    		 * @internal
    		 */


    		var ReactElement = function (type, key, ref, self, source, owner, props) {
    		  var element = {
    		    // This tag allows us to uniquely identify this as a React Element
    		    $$typeof: REACT_ELEMENT_TYPE,
    		    // Built-in properties that belong on the element
    		    type: type,
    		    key: key,
    		    ref: ref,
    		    props: props,
    		    // Record the component responsible for creating this element.
    		    _owner: owner
    		  };

    		  {
    		    // The validation flag is currently mutative. We put it on
    		    // an external backing store so that we can freeze the whole object.
    		    // This can be replaced with a WeakMap once they are implemented in
    		    // commonly used development environments.
    		    element._store = {}; // To make comparing ReactElements easier for testing purposes, we make
    		    // the validation flag non-enumerable (where possible, which should
    		    // include every environment we run tests in), so the test framework
    		    // ignores it.

    		    Object.defineProperty(element._store, 'validated', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: true,
    		      value: false
    		    }); // self and source are DEV only properties.

    		    Object.defineProperty(element, '_self', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: false,
    		      value: self
    		    }); // Two elements created in two different places should be considered
    		    // equal for testing purposes and therefore we hide it from enumeration.

    		    Object.defineProperty(element, '_source', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: false,
    		      value: source
    		    });

    		    if (Object.freeze) {
    		      Object.freeze(element.props);
    		      Object.freeze(element);
    		    }
    		  }

    		  return element;
    		};
    		/**
    		 * Create and return a new ReactElement of the given type.
    		 * See https://reactjs.org/docs/react-api.html#createelement
    		 */

    		function createElement(type, config, children) {
    		  var propName; // Reserved names are extracted

    		  var props = {};
    		  var key = null;
    		  var ref = null;
    		  var self = null;
    		  var source = null;

    		  if (config != null) {
    		    if (hasValidRef(config)) {
    		      ref = config.ref;

    		      {
    		        warnIfStringRefCannotBeAutoConverted(config);
    		      }
    		    }

    		    if (hasValidKey(config)) {
    		      key = '' + config.key;
    		    }

    		    self = config.__self === undefined ? null : config.__self;
    		    source = config.__source === undefined ? null : config.__source; // Remaining properties are added to a new props object

    		    for (propName in config) {
    		      if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
    		        props[propName] = config[propName];
    		      }
    		    }
    		  } // Children can be more than one argument, and those are transferred onto
    		  // the newly allocated props object.


    		  var childrenLength = arguments.length - 2;

    		  if (childrenLength === 1) {
    		    props.children = children;
    		  } else if (childrenLength > 1) {
    		    var childArray = Array(childrenLength);

    		    for (var i = 0; i < childrenLength; i++) {
    		      childArray[i] = arguments[i + 2];
    		    }

    		    {
    		      if (Object.freeze) {
    		        Object.freeze(childArray);
    		      }
    		    }

    		    props.children = childArray;
    		  } // Resolve default props


    		  if (type && type.defaultProps) {
    		    var defaultProps = type.defaultProps;

    		    for (propName in defaultProps) {
    		      if (props[propName] === undefined) {
    		        props[propName] = defaultProps[propName];
    		      }
    		    }
    		  }

    		  {
    		    if (key || ref) {
    		      var displayName = typeof type === 'function' ? type.displayName || type.name || 'Unknown' : type;

    		      if (key) {
    		        defineKeyPropWarningGetter(props, displayName);
    		      }

    		      if (ref) {
    		        defineRefPropWarningGetter(props, displayName);
    		      }
    		    }
    		  }

    		  return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
    		}
    		function cloneAndReplaceKey(oldElement, newKey) {
    		  var newElement = ReactElement(oldElement.type, newKey, oldElement.ref, oldElement._self, oldElement._source, oldElement._owner, oldElement.props);
    		  return newElement;
    		}
    		/**
    		 * Clone and return a new ReactElement using element as the starting point.
    		 * See https://reactjs.org/docs/react-api.html#cloneelement
    		 */

    		function cloneElement(element, config, children) {
    		  if (!!(element === null || element === undefined)) {
    		    {
    		      throw Error( "React.cloneElement(...): The argument must be a React element, but you passed " + element + "." );
    		    }
    		  }

    		  var propName; // Original props are copied

    		  var props = _assign({}, element.props); // Reserved names are extracted


    		  var key = element.key;
    		  var ref = element.ref; // Self is preserved since the owner is preserved.

    		  var self = element._self; // Source is preserved since cloneElement is unlikely to be targeted by a
    		  // transpiler, and the original source is probably a better indicator of the
    		  // true owner.

    		  var source = element._source; // Owner will be preserved, unless ref is overridden

    		  var owner = element._owner;

    		  if (config != null) {
    		    if (hasValidRef(config)) {
    		      // Silently steal the ref from the parent.
    		      ref = config.ref;
    		      owner = ReactCurrentOwner.current;
    		    }

    		    if (hasValidKey(config)) {
    		      key = '' + config.key;
    		    } // Remaining properties override existing props


    		    var defaultProps;

    		    if (element.type && element.type.defaultProps) {
    		      defaultProps = element.type.defaultProps;
    		    }

    		    for (propName in config) {
    		      if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
    		        if (config[propName] === undefined && defaultProps !== undefined) {
    		          // Resolve default props
    		          props[propName] = defaultProps[propName];
    		        } else {
    		          props[propName] = config[propName];
    		        }
    		      }
    		    }
    		  } // Children can be more than one argument, and those are transferred onto
    		  // the newly allocated props object.


    		  var childrenLength = arguments.length - 2;

    		  if (childrenLength === 1) {
    		    props.children = children;
    		  } else if (childrenLength > 1) {
    		    var childArray = Array(childrenLength);

    		    for (var i = 0; i < childrenLength; i++) {
    		      childArray[i] = arguments[i + 2];
    		    }

    		    props.children = childArray;
    		  }

    		  return ReactElement(element.type, key, ref, self, source, owner, props);
    		}
    		/**
    		 * Verifies the object is a ReactElement.
    		 * See https://reactjs.org/docs/react-api.html#isvalidelement
    		 * @param {?object} object
    		 * @return {boolean} True if `object` is a ReactElement.
    		 * @final
    		 */

    		function isValidElement(object) {
    		  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    		}

    		var SEPARATOR = '.';
    		var SUBSEPARATOR = ':';
    		/**
    		 * Escape and wrap key so it is safe to use as a reactid
    		 *
    		 * @param {string} key to be escaped.
    		 * @return {string} the escaped key.
    		 */

    		function escape(key) {
    		  var escapeRegex = /[=:]/g;
    		  var escaperLookup = {
    		    '=': '=0',
    		    ':': '=2'
    		  };
    		  var escapedString = key.replace(escapeRegex, function (match) {
    		    return escaperLookup[match];
    		  });
    		  return '$' + escapedString;
    		}
    		/**
    		 * TODO: Test that a single child and an array with one item have the same key
    		 * pattern.
    		 */


    		var didWarnAboutMaps = false;
    		var userProvidedKeyEscapeRegex = /\/+/g;

    		function escapeUserProvidedKey(text) {
    		  return text.replace(userProvidedKeyEscapeRegex, '$&/');
    		}
    		/**
    		 * Generate a key string that identifies a element within a set.
    		 *
    		 * @param {*} element A element that could contain a manual key.
    		 * @param {number} index Index that is used if a manual key is not provided.
    		 * @return {string}
    		 */


    		function getElementKey(element, index) {
    		  // Do some typechecking here since we call this blindly. We want to ensure
    		  // that we don't block potential future ES APIs.
    		  if (typeof element === 'object' && element !== null && element.key != null) {
    		    // Explicit key
    		    return escape('' + element.key);
    		  } // Implicit key determined by the index in the set


    		  return index.toString(36);
    		}

    		function mapIntoArray(children, array, escapedPrefix, nameSoFar, callback) {
    		  var type = typeof children;

    		  if (type === 'undefined' || type === 'boolean') {
    		    // All of the above are perceived as null.
    		    children = null;
    		  }

    		  var invokeCallback = false;

    		  if (children === null) {
    		    invokeCallback = true;
    		  } else {
    		    switch (type) {
    		      case 'string':
    		      case 'number':
    		        invokeCallback = true;
    		        break;

    		      case 'object':
    		        switch (children.$$typeof) {
    		          case REACT_ELEMENT_TYPE:
    		          case REACT_PORTAL_TYPE:
    		            invokeCallback = true;
    		        }

    		    }
    		  }

    		  if (invokeCallback) {
    		    var _child = children;
    		    var mappedChild = callback(_child); // If it's the only child, treat the name as if it was wrapped in an array
    		    // so that it's consistent if the number of children grows:

    		    var childKey = nameSoFar === '' ? SEPARATOR + getElementKey(_child, 0) : nameSoFar;

    		    if (Array.isArray(mappedChild)) {
    		      var escapedChildKey = '';

    		      if (childKey != null) {
    		        escapedChildKey = escapeUserProvidedKey(childKey) + '/';
    		      }

    		      mapIntoArray(mappedChild, array, escapedChildKey, '', function (c) {
    		        return c;
    		      });
    		    } else if (mappedChild != null) {
    		      if (isValidElement(mappedChild)) {
    		        mappedChild = cloneAndReplaceKey(mappedChild, // Keep both the (mapped) and old keys if they differ, just as
    		        // traverseAllChildren used to do for objects as children
    		        escapedPrefix + ( // $FlowFixMe Flow incorrectly thinks React.Portal doesn't have a key
    		        mappedChild.key && (!_child || _child.key !== mappedChild.key) ? // $FlowFixMe Flow incorrectly thinks existing element's key can be a number
    		        escapeUserProvidedKey('' + mappedChild.key) + '/' : '') + childKey);
    		      }

    		      array.push(mappedChild);
    		    }

    		    return 1;
    		  }

    		  var child;
    		  var nextName;
    		  var subtreeCount = 0; // Count of children found in the current subtree.

    		  var nextNamePrefix = nameSoFar === '' ? SEPARATOR : nameSoFar + SUBSEPARATOR;

    		  if (Array.isArray(children)) {
    		    for (var i = 0; i < children.length; i++) {
    		      child = children[i];
    		      nextName = nextNamePrefix + getElementKey(child, i);
    		      subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
    		    }
    		  } else {
    		    var iteratorFn = getIteratorFn(children);

    		    if (typeof iteratorFn === 'function') {
    		      var iterableChildren = children;

    		      {
    		        // Warn about using Maps as children
    		        if (iteratorFn === iterableChildren.entries) {
    		          if (!didWarnAboutMaps) {
    		            warn('Using Maps as children is not supported. ' + 'Use an array of keyed ReactElements instead.');
    		          }

    		          didWarnAboutMaps = true;
    		        }
    		      }

    		      var iterator = iteratorFn.call(iterableChildren);
    		      var step;
    		      var ii = 0;

    		      while (!(step = iterator.next()).done) {
    		        child = step.value;
    		        nextName = nextNamePrefix + getElementKey(child, ii++);
    		        subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
    		      }
    		    } else if (type === 'object') {
    		      var childrenString = '' + children;

    		      {
    		        {
    		          throw Error( "Objects are not valid as a React child (found: " + (childrenString === '[object Object]' ? 'object with keys {' + Object.keys(children).join(', ') + '}' : childrenString) + "). If you meant to render a collection of children, use an array instead." );
    		        }
    		      }
    		    }
    		  }

    		  return subtreeCount;
    		}

    		/**
    		 * Maps children that are typically specified as `props.children`.
    		 *
    		 * See https://reactjs.org/docs/react-api.html#reactchildrenmap
    		 *
    		 * The provided mapFunction(child, index) will be called for each
    		 * leaf child.
    		 *
    		 * @param {?*} children Children tree container.
    		 * @param {function(*, int)} func The map function.
    		 * @param {*} context Context for mapFunction.
    		 * @return {object} Object containing the ordered map of results.
    		 */
    		function mapChildren(children, func, context) {
    		  if (children == null) {
    		    return children;
    		  }

    		  var result = [];
    		  var count = 0;
    		  mapIntoArray(children, result, '', '', function (child) {
    		    return func.call(context, child, count++);
    		  });
    		  return result;
    		}
    		/**
    		 * Count the number of children that are typically specified as
    		 * `props.children`.
    		 *
    		 * See https://reactjs.org/docs/react-api.html#reactchildrencount
    		 *
    		 * @param {?*} children Children tree container.
    		 * @return {number} The number of children.
    		 */


    		function countChildren(children) {
    		  var n = 0;
    		  mapChildren(children, function () {
    		    n++; // Don't return anything
    		  });
    		  return n;
    		}

    		/**
    		 * Iterates through children that are typically specified as `props.children`.
    		 *
    		 * See https://reactjs.org/docs/react-api.html#reactchildrenforeach
    		 *
    		 * The provided forEachFunc(child, index) will be called for each
    		 * leaf child.
    		 *
    		 * @param {?*} children Children tree container.
    		 * @param {function(*, int)} forEachFunc
    		 * @param {*} forEachContext Context for forEachContext.
    		 */
    		function forEachChildren(children, forEachFunc, forEachContext) {
    		  mapChildren(children, function () {
    		    forEachFunc.apply(this, arguments); // Don't return anything.
    		  }, forEachContext);
    		}
    		/**
    		 * Flatten a children object (typically specified as `props.children`) and
    		 * return an array with appropriately re-keyed children.
    		 *
    		 * See https://reactjs.org/docs/react-api.html#reactchildrentoarray
    		 */


    		function toArray(children) {
    		  return mapChildren(children, function (child) {
    		    return child;
    		  }) || [];
    		}
    		/**
    		 * Returns the first child in a collection of children and verifies that there
    		 * is only one child in the collection.
    		 *
    		 * See https://reactjs.org/docs/react-api.html#reactchildrenonly
    		 *
    		 * The current implementation of this function assumes that a single child gets
    		 * passed without a wrapper, but the purpose of this helper function is to
    		 * abstract away the particular structure of children.
    		 *
    		 * @param {?object} children Child collection structure.
    		 * @return {ReactElement} The first and only `ReactElement` contained in the
    		 * structure.
    		 */


    		function onlyChild(children) {
    		  if (!isValidElement(children)) {
    		    {
    		      throw Error( "React.Children.only expected to receive a single React element child." );
    		    }
    		  }

    		  return children;
    		}

    		function createContext(defaultValue, calculateChangedBits) {
    		  if (calculateChangedBits === undefined) {
    		    calculateChangedBits = null;
    		  } else {
    		    {
    		      if (calculateChangedBits !== null && typeof calculateChangedBits !== 'function') {
    		        error('createContext: Expected the optional second argument to be a ' + 'function. Instead received: %s', calculateChangedBits);
    		      }
    		    }
    		  }

    		  var context = {
    		    $$typeof: REACT_CONTEXT_TYPE,
    		    _calculateChangedBits: calculateChangedBits,
    		    // As a workaround to support multiple concurrent renderers, we categorize
    		    // some renderers as primary and others as secondary. We only expect
    		    // there to be two concurrent renderers at most: React Native (primary) and
    		    // Fabric (secondary); React DOM (primary) and React ART (secondary).
    		    // Secondary renderers store their context values on separate fields.
    		    _currentValue: defaultValue,
    		    _currentValue2: defaultValue,
    		    // Used to track how many concurrent renderers this context currently
    		    // supports within in a single renderer. Such as parallel server rendering.
    		    _threadCount: 0,
    		    // These are circular
    		    Provider: null,
    		    Consumer: null
    		  };
    		  context.Provider = {
    		    $$typeof: REACT_PROVIDER_TYPE,
    		    _context: context
    		  };
    		  var hasWarnedAboutUsingNestedContextConsumers = false;
    		  var hasWarnedAboutUsingConsumerProvider = false;
    		  var hasWarnedAboutDisplayNameOnConsumer = false;

    		  {
    		    // A separate object, but proxies back to the original context object for
    		    // backwards compatibility. It has a different $$typeof, so we can properly
    		    // warn for the incorrect usage of Context as a Consumer.
    		    var Consumer = {
    		      $$typeof: REACT_CONTEXT_TYPE,
    		      _context: context,
    		      _calculateChangedBits: context._calculateChangedBits
    		    }; // $FlowFixMe: Flow complains about not setting a value, which is intentional here

    		    Object.defineProperties(Consumer, {
    		      Provider: {
    		        get: function () {
    		          if (!hasWarnedAboutUsingConsumerProvider) {
    		            hasWarnedAboutUsingConsumerProvider = true;

    		            error('Rendering <Context.Consumer.Provider> is not supported and will be removed in ' + 'a future major release. Did you mean to render <Context.Provider> instead?');
    		          }

    		          return context.Provider;
    		        },
    		        set: function (_Provider) {
    		          context.Provider = _Provider;
    		        }
    		      },
    		      _currentValue: {
    		        get: function () {
    		          return context._currentValue;
    		        },
    		        set: function (_currentValue) {
    		          context._currentValue = _currentValue;
    		        }
    		      },
    		      _currentValue2: {
    		        get: function () {
    		          return context._currentValue2;
    		        },
    		        set: function (_currentValue2) {
    		          context._currentValue2 = _currentValue2;
    		        }
    		      },
    		      _threadCount: {
    		        get: function () {
    		          return context._threadCount;
    		        },
    		        set: function (_threadCount) {
    		          context._threadCount = _threadCount;
    		        }
    		      },
    		      Consumer: {
    		        get: function () {
    		          if (!hasWarnedAboutUsingNestedContextConsumers) {
    		            hasWarnedAboutUsingNestedContextConsumers = true;

    		            error('Rendering <Context.Consumer.Consumer> is not supported and will be removed in ' + 'a future major release. Did you mean to render <Context.Consumer> instead?');
    		          }

    		          return context.Consumer;
    		        }
    		      },
    		      displayName: {
    		        get: function () {
    		          return context.displayName;
    		        },
    		        set: function (displayName) {
    		          if (!hasWarnedAboutDisplayNameOnConsumer) {
    		            warn('Setting `displayName` on Context.Consumer has no effect. ' + "You should set it directly on the context with Context.displayName = '%s'.", displayName);

    		            hasWarnedAboutDisplayNameOnConsumer = true;
    		          }
    		        }
    		      }
    		    }); // $FlowFixMe: Flow complains about missing properties because it doesn't understand defineProperty

    		    context.Consumer = Consumer;
    		  }

    		  {
    		    context._currentRenderer = null;
    		    context._currentRenderer2 = null;
    		  }

    		  return context;
    		}

    		var Uninitialized = -1;
    		var Pending = 0;
    		var Resolved = 1;
    		var Rejected = 2;

    		function lazyInitializer(payload) {
    		  if (payload._status === Uninitialized) {
    		    var ctor = payload._result;
    		    var thenable = ctor(); // Transition to the next state.

    		    var pending = payload;
    		    pending._status = Pending;
    		    pending._result = thenable;
    		    thenable.then(function (moduleObject) {
    		      if (payload._status === Pending) {
    		        var defaultExport = moduleObject.default;

    		        {
    		          if (defaultExport === undefined) {
    		            error('lazy: Expected the result of a dynamic import() call. ' + 'Instead received: %s\n\nYour code should look like: \n  ' + // Break up imports to avoid accidentally parsing them as dependencies.
    		            'const MyComponent = lazy(() => imp' + "ort('./MyComponent'))", moduleObject);
    		          }
    		        } // Transition to the next state.


    		        var resolved = payload;
    		        resolved._status = Resolved;
    		        resolved._result = defaultExport;
    		      }
    		    }, function (error) {
    		      if (payload._status === Pending) {
    		        // Transition to the next state.
    		        var rejected = payload;
    		        rejected._status = Rejected;
    		        rejected._result = error;
    		      }
    		    });
    		  }

    		  if (payload._status === Resolved) {
    		    return payload._result;
    		  } else {
    		    throw payload._result;
    		  }
    		}

    		function lazy(ctor) {
    		  var payload = {
    		    // We use these fields to store the result.
    		    _status: -1,
    		    _result: ctor
    		  };
    		  var lazyType = {
    		    $$typeof: REACT_LAZY_TYPE,
    		    _payload: payload,
    		    _init: lazyInitializer
    		  };

    		  {
    		    // In production, this would just set it on the object.
    		    var defaultProps;
    		    var propTypes; // $FlowFixMe

    		    Object.defineProperties(lazyType, {
    		      defaultProps: {
    		        configurable: true,
    		        get: function () {
    		          return defaultProps;
    		        },
    		        set: function (newDefaultProps) {
    		          error('React.lazy(...): It is not supported to assign `defaultProps` to ' + 'a lazy component import. Either specify them where the component ' + 'is defined, or create a wrapping component around it.');

    		          defaultProps = newDefaultProps; // Match production behavior more closely:
    		          // $FlowFixMe

    		          Object.defineProperty(lazyType, 'defaultProps', {
    		            enumerable: true
    		          });
    		        }
    		      },
    		      propTypes: {
    		        configurable: true,
    		        get: function () {
    		          return propTypes;
    		        },
    		        set: function (newPropTypes) {
    		          error('React.lazy(...): It is not supported to assign `propTypes` to ' + 'a lazy component import. Either specify them where the component ' + 'is defined, or create a wrapping component around it.');

    		          propTypes = newPropTypes; // Match production behavior more closely:
    		          // $FlowFixMe

    		          Object.defineProperty(lazyType, 'propTypes', {
    		            enumerable: true
    		          });
    		        }
    		      }
    		    });
    		  }

    		  return lazyType;
    		}

    		function forwardRef(render) {
    		  {
    		    if (render != null && render.$$typeof === REACT_MEMO_TYPE) {
    		      error('forwardRef requires a render function but received a `memo` ' + 'component. Instead of forwardRef(memo(...)), use ' + 'memo(forwardRef(...)).');
    		    } else if (typeof render !== 'function') {
    		      error('forwardRef requires a render function but was given %s.', render === null ? 'null' : typeof render);
    		    } else {
    		      if (render.length !== 0 && render.length !== 2) {
    		        error('forwardRef render functions accept exactly two parameters: props and ref. %s', render.length === 1 ? 'Did you forget to use the ref parameter?' : 'Any additional parameter will be undefined.');
    		      }
    		    }

    		    if (render != null) {
    		      if (render.defaultProps != null || render.propTypes != null) {
    		        error('forwardRef render functions do not support propTypes or defaultProps. ' + 'Did you accidentally pass a React component?');
    		      }
    		    }
    		  }

    		  var elementType = {
    		    $$typeof: REACT_FORWARD_REF_TYPE,
    		    render: render
    		  };

    		  {
    		    var ownName;
    		    Object.defineProperty(elementType, 'displayName', {
    		      enumerable: false,
    		      configurable: true,
    		      get: function () {
    		        return ownName;
    		      },
    		      set: function (name) {
    		        ownName = name;

    		        if (render.displayName == null) {
    		          render.displayName = name;
    		        }
    		      }
    		    });
    		  }

    		  return elementType;
    		}

    		// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

    		var enableScopeAPI = false; // Experimental Create Event Handle API.

    		function isValidElementType(type) {
    		  if (typeof type === 'string' || typeof type === 'function') {
    		    return true;
    		  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


    		  if (type === exports.Fragment || type === exports.Profiler || type === REACT_DEBUG_TRACING_MODE_TYPE || type === exports.StrictMode || type === exports.Suspense || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI ) {
    		    return true;
    		  }

    		  if (typeof type === 'object' && type !== null) {
    		    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE) {
    		      return true;
    		    }
    		  }

    		  return false;
    		}

    		function memo(type, compare) {
    		  {
    		    if (!isValidElementType(type)) {
    		      error('memo: The first argument must be a component. Instead ' + 'received: %s', type === null ? 'null' : typeof type);
    		    }
    		  }

    		  var elementType = {
    		    $$typeof: REACT_MEMO_TYPE,
    		    type: type,
    		    compare: compare === undefined ? null : compare
    		  };

    		  {
    		    var ownName;
    		    Object.defineProperty(elementType, 'displayName', {
    		      enumerable: false,
    		      configurable: true,
    		      get: function () {
    		        return ownName;
    		      },
    		      set: function (name) {
    		        ownName = name;

    		        if (type.displayName == null) {
    		          type.displayName = name;
    		        }
    		      }
    		    });
    		  }

    		  return elementType;
    		}

    		function resolveDispatcher() {
    		  var dispatcher = ReactCurrentDispatcher.current;

    		  if (!(dispatcher !== null)) {
    		    {
    		      throw Error( "Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem." );
    		    }
    		  }

    		  return dispatcher;
    		}

    		function useContext(Context, unstable_observedBits) {
    		  var dispatcher = resolveDispatcher();

    		  {
    		    if (unstable_observedBits !== undefined) {
    		      error('useContext() second argument is reserved for future ' + 'use in React. Passing it is not supported. ' + 'You passed: %s.%s', unstable_observedBits, typeof unstable_observedBits === 'number' && Array.isArray(arguments[2]) ? '\n\nDid you call array.map(useContext)? ' + 'Calling Hooks inside a loop is not supported. ' + 'Learn more at https://reactjs.org/link/rules-of-hooks' : '');
    		    } // TODO: add a more generic warning for invalid values.


    		    if (Context._context !== undefined) {
    		      var realContext = Context._context; // Don't deduplicate because this legitimately causes bugs
    		      // and nobody should be using this in existing code.

    		      if (realContext.Consumer === Context) {
    		        error('Calling useContext(Context.Consumer) is not supported, may cause bugs, and will be ' + 'removed in a future major release. Did you mean to call useContext(Context) instead?');
    		      } else if (realContext.Provider === Context) {
    		        error('Calling useContext(Context.Provider) is not supported. ' + 'Did you mean to call useContext(Context) instead?');
    		      }
    		    }
    		  }

    		  return dispatcher.useContext(Context, unstable_observedBits);
    		}
    		function useState(initialState) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useState(initialState);
    		}
    		function useReducer(reducer, initialArg, init) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useReducer(reducer, initialArg, init);
    		}
    		function useRef(initialValue) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useRef(initialValue);
    		}
    		function useEffect(create, deps) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useEffect(create, deps);
    		}
    		function useLayoutEffect(create, deps) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useLayoutEffect(create, deps);
    		}
    		function useCallback(callback, deps) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useCallback(callback, deps);
    		}
    		function useMemo(create, deps) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useMemo(create, deps);
    		}
    		function useImperativeHandle(ref, create, deps) {
    		  var dispatcher = resolveDispatcher();
    		  return dispatcher.useImperativeHandle(ref, create, deps);
    		}
    		function useDebugValue(value, formatterFn) {
    		  {
    		    var dispatcher = resolveDispatcher();
    		    return dispatcher.useDebugValue(value, formatterFn);
    		  }
    		}

    		// Helpers to patch console.logs to avoid logging during side-effect free
    		// replaying on render function. This currently only patches the object
    		// lazily which won't cover if the log function was extracted eagerly.
    		// We could also eagerly patch the method.
    		var disabledDepth = 0;
    		var prevLog;
    		var prevInfo;
    		var prevWarn;
    		var prevError;
    		var prevGroup;
    		var prevGroupCollapsed;
    		var prevGroupEnd;

    		function disabledLog() {}

    		disabledLog.__reactDisabledLog = true;
    		function disableLogs() {
    		  {
    		    if (disabledDepth === 0) {
    		      /* eslint-disable react-internal/no-production-logging */
    		      prevLog = console.log;
    		      prevInfo = console.info;
    		      prevWarn = console.warn;
    		      prevError = console.error;
    		      prevGroup = console.group;
    		      prevGroupCollapsed = console.groupCollapsed;
    		      prevGroupEnd = console.groupEnd; // https://github.com/facebook/react/issues/19099

    		      var props = {
    		        configurable: true,
    		        enumerable: true,
    		        value: disabledLog,
    		        writable: true
    		      }; // $FlowFixMe Flow thinks console is immutable.

    		      Object.defineProperties(console, {
    		        info: props,
    		        log: props,
    		        warn: props,
    		        error: props,
    		        group: props,
    		        groupCollapsed: props,
    		        groupEnd: props
    		      });
    		      /* eslint-enable react-internal/no-production-logging */
    		    }

    		    disabledDepth++;
    		  }
    		}
    		function reenableLogs() {
    		  {
    		    disabledDepth--;

    		    if (disabledDepth === 0) {
    		      /* eslint-disable react-internal/no-production-logging */
    		      var props = {
    		        configurable: true,
    		        enumerable: true,
    		        writable: true
    		      }; // $FlowFixMe Flow thinks console is immutable.

    		      Object.defineProperties(console, {
    		        log: _assign({}, props, {
    		          value: prevLog
    		        }),
    		        info: _assign({}, props, {
    		          value: prevInfo
    		        }),
    		        warn: _assign({}, props, {
    		          value: prevWarn
    		        }),
    		        error: _assign({}, props, {
    		          value: prevError
    		        }),
    		        group: _assign({}, props, {
    		          value: prevGroup
    		        }),
    		        groupCollapsed: _assign({}, props, {
    		          value: prevGroupCollapsed
    		        }),
    		        groupEnd: _assign({}, props, {
    		          value: prevGroupEnd
    		        })
    		      });
    		      /* eslint-enable react-internal/no-production-logging */
    		    }

    		    if (disabledDepth < 0) {
    		      error('disabledDepth fell below zero. ' + 'This is a bug in React. Please file an issue.');
    		    }
    		  }
    		}

    		var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher;
    		var prefix;
    		function describeBuiltInComponentFrame(name, source, ownerFn) {
    		  {
    		    if (prefix === undefined) {
    		      // Extract the VM specific prefix used by each line.
    		      try {
    		        throw Error();
    		      } catch (x) {
    		        var match = x.stack.trim().match(/\n( *(at )?)/);
    		        prefix = match && match[1] || '';
    		      }
    		    } // We use the prefix to ensure our stacks line up with native stack frames.


    		    return '\n' + prefix + name;
    		  }
    		}
    		var reentry = false;
    		var componentFrameCache;

    		{
    		  var PossiblyWeakMap = typeof WeakMap === 'function' ? WeakMap : Map;
    		  componentFrameCache = new PossiblyWeakMap();
    		}

    		function describeNativeComponentFrame(fn, construct) {
    		  // If something asked for a stack inside a fake render, it should get ignored.
    		  if (!fn || reentry) {
    		    return '';
    		  }

    		  {
    		    var frame = componentFrameCache.get(fn);

    		    if (frame !== undefined) {
    		      return frame;
    		    }
    		  }

    		  var control;
    		  reentry = true;
    		  var previousPrepareStackTrace = Error.prepareStackTrace; // $FlowFixMe It does accept undefined.

    		  Error.prepareStackTrace = undefined;
    		  var previousDispatcher;

    		  {
    		    previousDispatcher = ReactCurrentDispatcher$1.current; // Set the dispatcher in DEV because this might be call in the render function
    		    // for warnings.

    		    ReactCurrentDispatcher$1.current = null;
    		    disableLogs();
    		  }

    		  try {
    		    // This should throw.
    		    if (construct) {
    		      // Something should be setting the props in the constructor.
    		      var Fake = function () {
    		        throw Error();
    		      }; // $FlowFixMe


    		      Object.defineProperty(Fake.prototype, 'props', {
    		        set: function () {
    		          // We use a throwing setter instead of frozen or non-writable props
    		          // because that won't throw in a non-strict mode function.
    		          throw Error();
    		        }
    		      });

    		      if (typeof Reflect === 'object' && Reflect.construct) {
    		        // We construct a different control for this case to include any extra
    		        // frames added by the construct call.
    		        try {
    		          Reflect.construct(Fake, []);
    		        } catch (x) {
    		          control = x;
    		        }

    		        Reflect.construct(fn, [], Fake);
    		      } else {
    		        try {
    		          Fake.call();
    		        } catch (x) {
    		          control = x;
    		        }

    		        fn.call(Fake.prototype);
    		      }
    		    } else {
    		      try {
    		        throw Error();
    		      } catch (x) {
    		        control = x;
    		      }

    		      fn();
    		    }
    		  } catch (sample) {
    		    // This is inlined manually because closure doesn't do it for us.
    		    if (sample && control && typeof sample.stack === 'string') {
    		      // This extracts the first frame from the sample that isn't also in the control.
    		      // Skipping one frame that we assume is the frame that calls the two.
    		      var sampleLines = sample.stack.split('\n');
    		      var controlLines = control.stack.split('\n');
    		      var s = sampleLines.length - 1;
    		      var c = controlLines.length - 1;

    		      while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
    		        // We expect at least one stack frame to be shared.
    		        // Typically this will be the root most one. However, stack frames may be
    		        // cut off due to maximum stack limits. In this case, one maybe cut off
    		        // earlier than the other. We assume that the sample is longer or the same
    		        // and there for cut off earlier. So we should find the root most frame in
    		        // the sample somewhere in the control.
    		        c--;
    		      }

    		      for (; s >= 1 && c >= 0; s--, c--) {
    		        // Next we find the first one that isn't the same which should be the
    		        // frame that called our sample function and the control.
    		        if (sampleLines[s] !== controlLines[c]) {
    		          // In V8, the first line is describing the message but other VMs don't.
    		          // If we're about to return the first line, and the control is also on the same
    		          // line, that's a pretty good indicator that our sample threw at same line as
    		          // the control. I.e. before we entered the sample frame. So we ignore this result.
    		          // This can happen if you passed a class to function component, or non-function.
    		          if (s !== 1 || c !== 1) {
    		            do {
    		              s--;
    		              c--; // We may still have similar intermediate frames from the construct call.
    		              // The next one that isn't the same should be our match though.

    		              if (c < 0 || sampleLines[s] !== controlLines[c]) {
    		                // V8 adds a "new" prefix for native classes. Let's remove it to make it prettier.
    		                var _frame = '\n' + sampleLines[s].replace(' at new ', ' at ');

    		                {
    		                  if (typeof fn === 'function') {
    		                    componentFrameCache.set(fn, _frame);
    		                  }
    		                } // Return the line we found.


    		                return _frame;
    		              }
    		            } while (s >= 1 && c >= 0);
    		          }

    		          break;
    		        }
    		      }
    		    }
    		  } finally {
    		    reentry = false;

    		    {
    		      ReactCurrentDispatcher$1.current = previousDispatcher;
    		      reenableLogs();
    		    }

    		    Error.prepareStackTrace = previousPrepareStackTrace;
    		  } // Fallback to just using the name if we couldn't make it throw.


    		  var name = fn ? fn.displayName || fn.name : '';
    		  var syntheticFrame = name ? describeBuiltInComponentFrame(name) : '';

    		  {
    		    if (typeof fn === 'function') {
    		      componentFrameCache.set(fn, syntheticFrame);
    		    }
    		  }

    		  return syntheticFrame;
    		}
    		function describeFunctionComponentFrame(fn, source, ownerFn) {
    		  {
    		    return describeNativeComponentFrame(fn, false);
    		  }
    		}

    		function shouldConstruct(Component) {
    		  var prototype = Component.prototype;
    		  return !!(prototype && prototype.isReactComponent);
    		}

    		function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {

    		  if (type == null) {
    		    return '';
    		  }

    		  if (typeof type === 'function') {
    		    {
    		      return describeNativeComponentFrame(type, shouldConstruct(type));
    		    }
    		  }

    		  if (typeof type === 'string') {
    		    return describeBuiltInComponentFrame(type);
    		  }

    		  switch (type) {
    		    case exports.Suspense:
    		      return describeBuiltInComponentFrame('Suspense');

    		    case REACT_SUSPENSE_LIST_TYPE:
    		      return describeBuiltInComponentFrame('SuspenseList');
    		  }

    		  if (typeof type === 'object') {
    		    switch (type.$$typeof) {
    		      case REACT_FORWARD_REF_TYPE:
    		        return describeFunctionComponentFrame(type.render);

    		      case REACT_MEMO_TYPE:
    		        // Memo may contain any component type so we recursively resolve it.
    		        return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);

    		      case REACT_BLOCK_TYPE:
    		        return describeFunctionComponentFrame(type._render);

    		      case REACT_LAZY_TYPE:
    		        {
    		          var lazyComponent = type;
    		          var payload = lazyComponent._payload;
    		          var init = lazyComponent._init;

    		          try {
    		            // Lazy may contain any component type so we recursively resolve it.
    		            return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
    		          } catch (x) {}
    		        }
    		    }
    		  }

    		  return '';
    		}

    		var loggedTypeFailures = {};
    		var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;

    		function setCurrentlyValidatingElement(element) {
    		  {
    		    if (element) {
    		      var owner = element._owner;
    		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
    		      ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
    		    } else {
    		      ReactDebugCurrentFrame$1.setExtraStackFrame(null);
    		    }
    		  }
    		}

    		function checkPropTypes(typeSpecs, values, location, componentName, element) {
    		  {
    		    // $FlowFixMe This is okay but Flow doesn't know it.
    		    var has = Function.call.bind(Object.prototype.hasOwnProperty);

    		    for (var typeSpecName in typeSpecs) {
    		      if (has(typeSpecs, typeSpecName)) {
    		        var error$1 = void 0; // Prop type validation may throw. In case they do, we don't want to
    		        // fail the render phase where it didn't fail before. So we log it.
    		        // After these have been cleaned up, we'll let them throw.

    		        try {
    		          // This is intentionally an invariant that gets caught. It's the same
    		          // behavior as without this statement except with a better message.
    		          if (typeof typeSpecs[typeSpecName] !== 'function') {
    		            var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' + 'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.');
    		            err.name = 'Invariant Violation';
    		            throw err;
    		          }

    		          error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED');
    		        } catch (ex) {
    		          error$1 = ex;
    		        }

    		        if (error$1 && !(error$1 instanceof Error)) {
    		          setCurrentlyValidatingElement(element);

    		          error('%s: type specification of %s' + ' `%s` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a %s. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).', componentName || 'React class', location, typeSpecName, typeof error$1);

    		          setCurrentlyValidatingElement(null);
    		        }

    		        if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
    		          // Only monitor this failure once because there tends to be a lot of the
    		          // same error.
    		          loggedTypeFailures[error$1.message] = true;
    		          setCurrentlyValidatingElement(element);

    		          error('Failed %s type: %s', location, error$1.message);

    		          setCurrentlyValidatingElement(null);
    		        }
    		      }
    		    }
    		  }
    		}

    		function setCurrentlyValidatingElement$1(element) {
    		  {
    		    if (element) {
    		      var owner = element._owner;
    		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
    		      setExtraStackFrame(stack);
    		    } else {
    		      setExtraStackFrame(null);
    		    }
    		  }
    		}

    		var propTypesMisspellWarningShown;

    		{
    		  propTypesMisspellWarningShown = false;
    		}

    		function getDeclarationErrorAddendum() {
    		  if (ReactCurrentOwner.current) {
    		    var name = getComponentName(ReactCurrentOwner.current.type);

    		    if (name) {
    		      return '\n\nCheck the render method of `' + name + '`.';
    		    }
    		  }

    		  return '';
    		}

    		function getSourceInfoErrorAddendum(source) {
    		  if (source !== undefined) {
    		    var fileName = source.fileName.replace(/^.*[\\\/]/, '');
    		    var lineNumber = source.lineNumber;
    		    return '\n\nCheck your code at ' + fileName + ':' + lineNumber + '.';
    		  }

    		  return '';
    		}

    		function getSourceInfoErrorAddendumForProps(elementProps) {
    		  if (elementProps !== null && elementProps !== undefined) {
    		    return getSourceInfoErrorAddendum(elementProps.__source);
    		  }

    		  return '';
    		}
    		/**
    		 * Warn if there's no key explicitly set on dynamic arrays of children or
    		 * object keys are not valid. This allows us to keep track of children between
    		 * updates.
    		 */


    		var ownerHasKeyUseWarning = {};

    		function getCurrentComponentErrorInfo(parentType) {
    		  var info = getDeclarationErrorAddendum();

    		  if (!info) {
    		    var parentName = typeof parentType === 'string' ? parentType : parentType.displayName || parentType.name;

    		    if (parentName) {
    		      info = "\n\nCheck the top-level render call using <" + parentName + ">.";
    		    }
    		  }

    		  return info;
    		}
    		/**
    		 * Warn if the element doesn't have an explicit key assigned to it.
    		 * This element is in an array. The array could grow and shrink or be
    		 * reordered. All children that haven't already been validated are required to
    		 * have a "key" property assigned to it. Error statuses are cached so a warning
    		 * will only be shown once.
    		 *
    		 * @internal
    		 * @param {ReactElement} element Element that requires a key.
    		 * @param {*} parentType element's parent's type.
    		 */


    		function validateExplicitKey(element, parentType) {
    		  if (!element._store || element._store.validated || element.key != null) {
    		    return;
    		  }

    		  element._store.validated = true;
    		  var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);

    		  if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
    		    return;
    		  }

    		  ownerHasKeyUseWarning[currentComponentErrorInfo] = true; // Usually the current owner is the offender, but if it accepts children as a
    		  // property, it may be the creator of the child that's responsible for
    		  // assigning it a key.

    		  var childOwner = '';

    		  if (element && element._owner && element._owner !== ReactCurrentOwner.current) {
    		    // Give the component that originally created this child.
    		    childOwner = " It was passed a child from " + getComponentName(element._owner.type) + ".";
    		  }

    		  {
    		    setCurrentlyValidatingElement$1(element);

    		    error('Each child in a list should have a unique "key" prop.' + '%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);

    		    setCurrentlyValidatingElement$1(null);
    		  }
    		}
    		/**
    		 * Ensure that every element either is passed in a static location, in an
    		 * array with an explicit keys property defined, or in an object literal
    		 * with valid key property.
    		 *
    		 * @internal
    		 * @param {ReactNode} node Statically passed child of any type.
    		 * @param {*} parentType node's parent's type.
    		 */


    		function validateChildKeys(node, parentType) {
    		  if (typeof node !== 'object') {
    		    return;
    		  }

    		  if (Array.isArray(node)) {
    		    for (var i = 0; i < node.length; i++) {
    		      var child = node[i];

    		      if (isValidElement(child)) {
    		        validateExplicitKey(child, parentType);
    		      }
    		    }
    		  } else if (isValidElement(node)) {
    		    // This element was passed in a valid location.
    		    if (node._store) {
    		      node._store.validated = true;
    		    }
    		  } else if (node) {
    		    var iteratorFn = getIteratorFn(node);

    		    if (typeof iteratorFn === 'function') {
    		      // Entry iterators used to provide implicit keys,
    		      // but now we print a separate warning for them later.
    		      if (iteratorFn !== node.entries) {
    		        var iterator = iteratorFn.call(node);
    		        var step;

    		        while (!(step = iterator.next()).done) {
    		          if (isValidElement(step.value)) {
    		            validateExplicitKey(step.value, parentType);
    		          }
    		        }
    		      }
    		    }
    		  }
    		}
    		/**
    		 * Given an element, validate that its props follow the propTypes definition,
    		 * provided by the type.
    		 *
    		 * @param {ReactElement} element
    		 */


    		function validatePropTypes(element) {
    		  {
    		    var type = element.type;

    		    if (type === null || type === undefined || typeof type === 'string') {
    		      return;
    		    }

    		    var propTypes;

    		    if (typeof type === 'function') {
    		      propTypes = type.propTypes;
    		    } else if (typeof type === 'object' && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
    		    // Inner props are checked in the reconciler.
    		    type.$$typeof === REACT_MEMO_TYPE)) {
    		      propTypes = type.propTypes;
    		    } else {
    		      return;
    		    }

    		    if (propTypes) {
    		      // Intentionally inside to avoid triggering lazy initializers:
    		      var name = getComponentName(type);
    		      checkPropTypes(propTypes, element.props, 'prop', name, element);
    		    } else if (type.PropTypes !== undefined && !propTypesMisspellWarningShown) {
    		      propTypesMisspellWarningShown = true; // Intentionally inside to avoid triggering lazy initializers:

    		      var _name = getComponentName(type);

    		      error('Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?', _name || 'Unknown');
    		    }

    		    if (typeof type.getDefaultProps === 'function' && !type.getDefaultProps.isReactClassApproved) {
    		      error('getDefaultProps is only used on classic React.createClass ' + 'definitions. Use a static property named `defaultProps` instead.');
    		    }
    		  }
    		}
    		/**
    		 * Given a fragment, validate that it can only be provided with fragment props
    		 * @param {ReactElement} fragment
    		 */


    		function validateFragmentProps(fragment) {
    		  {
    		    var keys = Object.keys(fragment.props);

    		    for (var i = 0; i < keys.length; i++) {
    		      var key = keys[i];

    		      if (key !== 'children' && key !== 'key') {
    		        setCurrentlyValidatingElement$1(fragment);

    		        error('Invalid prop `%s` supplied to `React.Fragment`. ' + 'React.Fragment can only have `key` and `children` props.', key);

    		        setCurrentlyValidatingElement$1(null);
    		        break;
    		      }
    		    }

    		    if (fragment.ref !== null) {
    		      setCurrentlyValidatingElement$1(fragment);

    		      error('Invalid attribute `ref` supplied to `React.Fragment`.');

    		      setCurrentlyValidatingElement$1(null);
    		    }
    		  }
    		}
    		function createElementWithValidation(type, props, children) {
    		  var validType = isValidElementType(type); // We warn in this case but don't throw. We expect the element creation to
    		  // succeed and there will likely be errors in render.

    		  if (!validType) {
    		    var info = '';

    		    if (type === undefined || typeof type === 'object' && type !== null && Object.keys(type).length === 0) {
    		      info += ' You likely forgot to export your component from the file ' + "it's defined in, or you might have mixed up default and named imports.";
    		    }

    		    var sourceInfo = getSourceInfoErrorAddendumForProps(props);

    		    if (sourceInfo) {
    		      info += sourceInfo;
    		    } else {
    		      info += getDeclarationErrorAddendum();
    		    }

    		    var typeString;

    		    if (type === null) {
    		      typeString = 'null';
    		    } else if (Array.isArray(type)) {
    		      typeString = 'array';
    		    } else if (type !== undefined && type.$$typeof === REACT_ELEMENT_TYPE) {
    		      typeString = "<" + (getComponentName(type.type) || 'Unknown') + " />";
    		      info = ' Did you accidentally export a JSX literal instead of a component?';
    		    } else {
    		      typeString = typeof type;
    		    }

    		    {
    		      error('React.createElement: type is invalid -- expected a string (for ' + 'built-in components) or a class/function (for composite ' + 'components) but got: %s.%s', typeString, info);
    		    }
    		  }

    		  var element = createElement.apply(this, arguments); // The result can be nullish if a mock or a custom function is used.
    		  // TODO: Drop this when these are no longer allowed as the type argument.

    		  if (element == null) {
    		    return element;
    		  } // Skip key warning if the type isn't valid since our key validation logic
    		  // doesn't expect a non-string/function type and can throw confusing errors.
    		  // We don't want exception behavior to differ between dev and prod.
    		  // (Rendering will throw with a helpful message and as soon as the type is
    		  // fixed, the key warnings will appear.)


    		  if (validType) {
    		    for (var i = 2; i < arguments.length; i++) {
    		      validateChildKeys(arguments[i], type);
    		    }
    		  }

    		  if (type === exports.Fragment) {
    		    validateFragmentProps(element);
    		  } else {
    		    validatePropTypes(element);
    		  }

    		  return element;
    		}
    		var didWarnAboutDeprecatedCreateFactory = false;
    		function createFactoryWithValidation(type) {
    		  var validatedFactory = createElementWithValidation.bind(null, type);
    		  validatedFactory.type = type;

    		  {
    		    if (!didWarnAboutDeprecatedCreateFactory) {
    		      didWarnAboutDeprecatedCreateFactory = true;

    		      warn('React.createFactory() is deprecated and will be removed in ' + 'a future major release. Consider using JSX ' + 'or use React.createElement() directly instead.');
    		    } // Legacy hook: remove it


    		    Object.defineProperty(validatedFactory, 'type', {
    		      enumerable: false,
    		      get: function () {
    		        warn('Factory.type is deprecated. Access the class directly ' + 'before passing it to createFactory.');

    		        Object.defineProperty(this, 'type', {
    		          value: type
    		        });
    		        return type;
    		      }
    		    });
    		  }

    		  return validatedFactory;
    		}
    		function cloneElementWithValidation(element, props, children) {
    		  var newElement = cloneElement.apply(this, arguments);

    		  for (var i = 2; i < arguments.length; i++) {
    		    validateChildKeys(arguments[i], newElement.type);
    		  }

    		  validatePropTypes(newElement);
    		  return newElement;
    		}

    		{

    		  try {
    		    var frozenObject = Object.freeze({});
    		    /* eslint-disable no-new */

    		    new Map([[frozenObject, null]]);
    		    new Set([frozenObject]);
    		    /* eslint-enable no-new */
    		  } catch (e) {
    		  }
    		}

    		var createElement$1 =  createElementWithValidation ;
    		var cloneElement$1 =  cloneElementWithValidation ;
    		var createFactory =  createFactoryWithValidation ;
    		var Children = {
    		  map: mapChildren,
    		  forEach: forEachChildren,
    		  count: countChildren,
    		  toArray: toArray,
    		  only: onlyChild
    		};

    		exports.Children = Children;
    		exports.Component = Component;
    		exports.PureComponent = PureComponent;
    		exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ReactSharedInternals;
    		exports.cloneElement = cloneElement$1;
    		exports.createContext = createContext;
    		exports.createElement = createElement$1;
    		exports.createFactory = createFactory;
    		exports.createRef = createRef;
    		exports.forwardRef = forwardRef;
    		exports.isValidElement = isValidElement;
    		exports.lazy = lazy;
    		exports.memo = memo;
    		exports.useCallback = useCallback;
    		exports.useContext = useContext;
    		exports.useDebugValue = useDebugValue;
    		exports.useEffect = useEffect;
    		exports.useImperativeHandle = useImperativeHandle;
    		exports.useLayoutEffect = useLayoutEffect;
    		exports.useMemo = useMemo;
    		exports.useReducer = useReducer;
    		exports.useRef = useRef;
    		exports.useState = useState;
    		exports.version = ReactVersion;
    		  })();
    		}
    } (react_development));
    	return react_development;
    }

    (function (module) {

    	if (process.env.NODE_ENV === 'production') {
    	  module.exports = requireReact_production_min();
    	} else {
    	  module.exports = requireReact_development();
    	}
    } (react));

    var React = /*@__PURE__*/getDefaultExportFromCjs(react.exports);

    var React$1 = /*#__PURE__*/_mergeNamespaces({
        __proto__: null,
        'default': React
    }, [react.exports]);

    function memoize$1(fn) {
      var cache = Object.create(null);
      return function (arg) {
        if (cache[arg] === undefined) cache[arg] = fn(arg);
        return cache[arg];
      };
    }

    var reactPropsRegex = /^((children|dangerouslySetInnerHTML|key|ref|autoFocus|defaultValue|defaultChecked|innerHTML|suppressContentEditableWarning|suppressHydrationWarning|valueLink|abbr|accept|acceptCharset|accessKey|action|allow|allowUserMedia|allowPaymentRequest|allowFullScreen|allowTransparency|alt|async|autoComplete|autoPlay|capture|cellPadding|cellSpacing|challenge|charSet|checked|cite|classID|className|cols|colSpan|content|contentEditable|contextMenu|controls|controlsList|coords|crossOrigin|data|dateTime|decoding|default|defer|dir|disabled|disablePictureInPicture|download|draggable|encType|enterKeyHint|form|formAction|formEncType|formMethod|formNoValidate|formTarget|frameBorder|headers|height|hidden|high|href|hrefLang|htmlFor|httpEquiv|id|inputMode|integrity|is|keyParams|keyType|kind|label|lang|list|loading|loop|low|marginHeight|marginWidth|max|maxLength|media|mediaGroup|method|min|minLength|multiple|muted|name|nonce|noValidate|open|optimum|pattern|placeholder|playsInline|poster|preload|profile|radioGroup|readOnly|referrerPolicy|rel|required|reversed|role|rows|rowSpan|sandbox|scope|scoped|scrolling|seamless|selected|shape|size|sizes|slot|span|spellCheck|src|srcDoc|srcLang|srcSet|start|step|style|summary|tabIndex|target|title|translate|type|useMap|value|width|wmode|wrap|about|datatype|inlist|prefix|property|resource|typeof|vocab|autoCapitalize|autoCorrect|autoSave|color|incremental|fallback|inert|itemProp|itemScope|itemType|itemID|itemRef|on|option|results|security|unselectable|accentHeight|accumulate|additive|alignmentBaseline|allowReorder|alphabetic|amplitude|arabicForm|ascent|attributeName|attributeType|autoReverse|azimuth|baseFrequency|baselineShift|baseProfile|bbox|begin|bias|by|calcMode|capHeight|clip|clipPathUnits|clipPath|clipRule|colorInterpolation|colorInterpolationFilters|colorProfile|colorRendering|contentScriptType|contentStyleType|cursor|cx|cy|d|decelerate|descent|diffuseConstant|direction|display|divisor|dominantBaseline|dur|dx|dy|edgeMode|elevation|enableBackground|end|exponent|externalResourcesRequired|fill|fillOpacity|fillRule|filter|filterRes|filterUnits|floodColor|floodOpacity|focusable|fontFamily|fontSize|fontSizeAdjust|fontStretch|fontStyle|fontVariant|fontWeight|format|from|fr|fx|fy|g1|g2|glyphName|glyphOrientationHorizontal|glyphOrientationVertical|glyphRef|gradientTransform|gradientUnits|hanging|horizAdvX|horizOriginX|ideographic|imageRendering|in|in2|intercept|k|k1|k2|k3|k4|kernelMatrix|kernelUnitLength|kerning|keyPoints|keySplines|keyTimes|lengthAdjust|letterSpacing|lightingColor|limitingConeAngle|local|markerEnd|markerMid|markerStart|markerHeight|markerUnits|markerWidth|mask|maskContentUnits|maskUnits|mathematical|mode|numOctaves|offset|opacity|operator|order|orient|orientation|origin|overflow|overlinePosition|overlineThickness|panose1|paintOrder|pathLength|patternContentUnits|patternTransform|patternUnits|pointerEvents|points|pointsAtX|pointsAtY|pointsAtZ|preserveAlpha|preserveAspectRatio|primitiveUnits|r|radius|refX|refY|renderingIntent|repeatCount|repeatDur|requiredExtensions|requiredFeatures|restart|result|rotate|rx|ry|scale|seed|shapeRendering|slope|spacing|specularConstant|specularExponent|speed|spreadMethod|startOffset|stdDeviation|stemh|stemv|stitchTiles|stopColor|stopOpacity|strikethroughPosition|strikethroughThickness|string|stroke|strokeDasharray|strokeDashoffset|strokeLinecap|strokeLinejoin|strokeMiterlimit|strokeOpacity|strokeWidth|surfaceScale|systemLanguage|tableValues|targetX|targetY|textAnchor|textDecoration|textRendering|textLength|to|transform|u1|u2|underlinePosition|underlineThickness|unicode|unicodeBidi|unicodeRange|unitsPerEm|vAlphabetic|vHanging|vIdeographic|vMathematical|values|vectorEffect|version|vertAdvY|vertOriginX|vertOriginY|viewBox|viewTarget|visibility|widths|wordSpacing|writingMode|x|xHeight|x1|x2|xChannelSelector|xlinkActuate|xlinkArcrole|xlinkHref|xlinkRole|xlinkShow|xlinkTitle|xlinkType|xmlBase|xmlns|xmlnsXlink|xmlLang|xmlSpace|y|y1|y2|yChannelSelector|z|zoomAndPan|for|class|autofocus)|(([Dd][Aa][Tt][Aa]|[Aa][Rr][Ii][Aa]|x)-.*))$/; // https://esbench.com/bench/5bfee68a4cd7e6009ef61d23

    var isPropValid = /* #__PURE__ */memoize$1(function (prop) {
      return reactPropsRegex.test(prop) || prop.charCodeAt(0) === 111
      /* o */
      && prop.charCodeAt(1) === 110
      /* n */
      && prop.charCodeAt(2) < 91;
    }
    /* Z+1 */
    );

    /*

    Based off glamor's StyleSheet, thanks Sunil ❤️

    high performance StyleSheet for css-in-js systems

    - uses multiple style tags behind the scenes for millions of rules
    - uses `insertRule` for appending in production for *much* faster performance

    // usage

    import { StyleSheet } from '@emotion/sheet'

    let styleSheet = new StyleSheet({ key: '', container: document.head })

    styleSheet.insert('#box { border: 1px solid red; }')
    - appends a css rule into the stylesheet

    styleSheet.flush()
    - empties the stylesheet of all its contents

    */
    // $FlowFixMe
    function sheetForTag(tag) {
      if (tag.sheet) {
        // $FlowFixMe
        return tag.sheet;
      } // this weirdness brought to you by firefox

      /* istanbul ignore next */


      for (var i = 0; i < document.styleSheets.length; i++) {
        if (document.styleSheets[i].ownerNode === tag) {
          // $FlowFixMe
          return document.styleSheets[i];
        }
      }
    }

    function createStyleElement(options) {
      var tag = document.createElement('style');
      tag.setAttribute('data-emotion', options.key);

      if (options.nonce !== undefined) {
        tag.setAttribute('nonce', options.nonce);
      }

      tag.appendChild(document.createTextNode(''));
      tag.setAttribute('data-s', '');
      return tag;
    }

    var StyleSheet = /*#__PURE__*/function () {
      function StyleSheet(options) {
        var _this = this;

        this._insertTag = function (tag) {
          var before;

          if (_this.tags.length === 0) {
            if (_this.insertionPoint) {
              before = _this.insertionPoint.nextSibling;
            } else if (_this.prepend) {
              before = _this.container.firstChild;
            } else {
              before = _this.before;
            }
          } else {
            before = _this.tags[_this.tags.length - 1].nextSibling;
          }

          _this.container.insertBefore(tag, before);

          _this.tags.push(tag);
        };

        this.isSpeedy = options.speedy === undefined ? process.env.NODE_ENV === 'production' : options.speedy;
        this.tags = [];
        this.ctr = 0;
        this.nonce = options.nonce; // key is the value of the data-emotion attribute, it's used to identify different sheets

        this.key = options.key;
        this.container = options.container;
        this.prepend = options.prepend;
        this.insertionPoint = options.insertionPoint;
        this.before = null;
      }

      var _proto = StyleSheet.prototype;

      _proto.hydrate = function hydrate(nodes) {
        nodes.forEach(this._insertTag);
      };

      _proto.insert = function insert(rule) {
        // the max length is how many rules we have per style tag, it's 65000 in speedy mode
        // it's 1 in dev because we insert source maps that map a single rule to a location
        // and you can only have one source map per style tag
        if (this.ctr % (this.isSpeedy ? 65000 : 1) === 0) {
          this._insertTag(createStyleElement(this));
        }

        var tag = this.tags[this.tags.length - 1];

        if (process.env.NODE_ENV !== 'production') {
          var isImportRule = rule.charCodeAt(0) === 64 && rule.charCodeAt(1) === 105;

          if (isImportRule && this._alreadyInsertedOrderInsensitiveRule) {
            // this would only cause problem in speedy mode
            // but we don't want enabling speedy to affect the observable behavior
            // so we report this error at all times
            console.error("You're attempting to insert the following rule:\n" + rule + '\n\n`@import` rules must be before all other types of rules in a stylesheet but other rules have already been inserted. Please ensure that `@import` rules are before all other rules.');
          }
          this._alreadyInsertedOrderInsensitiveRule = this._alreadyInsertedOrderInsensitiveRule || !isImportRule;
        }

        if (this.isSpeedy) {
          var sheet = sheetForTag(tag);

          try {
            // this is the ultrafast version, works across browsers
            // the big drawback is that the css won't be editable in devtools
            sheet.insertRule(rule, sheet.cssRules.length);
          } catch (e) {
            if (process.env.NODE_ENV !== 'production' && !/:(-moz-placeholder|-moz-focus-inner|-moz-focusring|-ms-input-placeholder|-moz-read-write|-moz-read-only|-ms-clear){/.test(rule)) {
              console.error("There was a problem inserting the following rule: \"" + rule + "\"", e);
            }
          }
        } else {
          tag.appendChild(document.createTextNode(rule));
        }

        this.ctr++;
      };

      _proto.flush = function flush() {
        // $FlowFixMe
        this.tags.forEach(function (tag) {
          return tag.parentNode && tag.parentNode.removeChild(tag);
        });
        this.tags = [];
        this.ctr = 0;

        if (process.env.NODE_ENV !== 'production') {
          this._alreadyInsertedOrderInsensitiveRule = false;
        }
      };

      return StyleSheet;
    }();

    var stylis = {exports: {}};

    (function (module, exports) {
    	(function(e,r){r(exports);})(commonjsGlobal,(function(e){var r="-ms-";var a="-moz-";var c="-webkit-";var t="comm";var n="rule";var s="decl";var i="@page";var u="@media";var o="@import";var f="@charset";var l="@viewport";var h="@supports";var p="@document";var v="@namespace";var b="@keyframes";var d="@font-face";var m="@counter-style";var w="@font-feature-values";var k=Math.abs;var $=String.fromCharCode;var g=Object.assign;function x(e,r){return (((r<<2^O(e,0))<<2^O(e,1))<<2^O(e,2))<<2^O(e,3)}function E(e){return e.trim()}function y(e,r){return (e=r.exec(e))?e[0]:e}function T(e,r,a){return e.replace(r,a)}function A(e,r){return e.indexOf(r)}function O(e,r){return e.charCodeAt(r)|0}function C(e,r,a){return e.slice(r,a)}function M(e){return e.length}function S(e){return e.length}function R(e,r){return r.push(e),e}function z(e,r){return e.map(r).join("")}e.line=1;e.column=1;e.length=0;e.position=0;e.character=0;e.characters="";function N(r,a,c,t,n,s,i){return {value:r,root:a,parent:c,type:t,props:n,children:s,line:e.line,column:e.column,length:i,return:""}}function P(e,r){return g(N("",null,null,"",null,null,0),e,{length:-e.length},r)}function j(){return e.character}function U(){e.character=e.position>0?O(e.characters,--e.position):0;if(e.column--,e.character===10)e.column=1,e.line--;return e.character}function _(){e.character=e.position<e.length?O(e.characters,e.position++):0;if(e.column++,e.character===10)e.column=1,e.line++;return e.character}function F(){return O(e.characters,e.position)}function I(){return e.position}function L(r,a){return C(e.characters,r,a)}function D(e){switch(e){case 0:case 9:case 10:case 13:case 32:return 5;case 33:case 43:case 44:case 47:case 62:case 64:case 126:case 59:case 123:case 125:return 4;case 58:return 3;case 34:case 39:case 40:case 91:return 2;case 41:case 93:return 1}return 0}function K(r){return e.line=e.column=1,e.length=M(e.characters=r),e.position=0,[]}function V(r){return e.characters="",r}function W(r){return E(L(e.position-1,Z(r===91?r+2:r===40?r+1:r)))}function Y(e){return V(G(K(e)))}function B(r){while(e.character=F())if(e.character<33)_();else break;return D(r)>2||D(e.character)>3?"":" "}function G(r){while(_())switch(D(e.character)){case 0:R(J(e.position-1),r);break;case 2:R(W(e.character),r);break;default:R($(e.character),r);}return r}function H(r,a){while(--a&&_())if(e.character<48||e.character>102||e.character>57&&e.character<65||e.character>70&&e.character<97)break;return L(r,I()+(a<6&&F()==32&&_()==32))}function Z(r){while(_())switch(e.character){case r:return e.position;case 34:case 39:if(r!==34&&r!==39)Z(e.character);break;case 40:if(r===41)Z(r);break;case 92:_();break}return e.position}function q(r,a){while(_())if(r+e.character===47+10)break;else if(r+e.character===42+42&&F()===47)break;return "/*"+L(a,e.position-1)+"*"+$(r===47?r:_())}function J(r){while(!D(F()))_();return L(r,e.position)}function Q(e){return V(X("",null,null,null,[""],e=K(e),0,[0],e))}function X(e,r,a,c,t,n,s,i,u){var o=0;var f=0;var l=s;var h=0;var p=0;var v=0;var b=1;var d=1;var m=1;var w=0;var k="";var g=t;var x=n;var E=c;var y=k;while(d)switch(v=w,w=_()){case 40:if(v!=108&&y.charCodeAt(l-1)==58){if(A(y+=T(W(w),"&","&\f"),"&\f")!=-1)m=-1;break}case 34:case 39:case 91:y+=W(w);break;case 9:case 10:case 13:case 32:y+=B(v);break;case 92:y+=H(I()-1,7);continue;case 47:switch(F()){case 42:case 47:R(re(q(_(),I()),r,a),u);break;default:y+="/";}break;case 123*b:i[o++]=M(y)*m;case 125*b:case 59:case 0:switch(w){case 0:case 125:d=0;case 59+f:if(p>0&&M(y)-l)R(p>32?ae(y+";",c,a,l-1):ae(T(y," ","")+";",c,a,l-2),u);break;case 59:y+=";";default:R(E=ee(y,r,a,o,f,t,i,k,g=[],x=[],l),n);if(w===123)if(f===0)X(y,r,E,E,g,n,l,i,x);else switch(h){case 100:case 109:case 115:X(e,E,E,c&&R(ee(e,E,E,0,0,t,i,k,t,g=[],l),x),t,x,l,i,c?g:x);break;default:X(y,E,E,E,[""],x,0,i,x);}}o=f=p=0,b=m=1,k=y="",l=s;break;case 58:l=1+M(y),p=v;default:if(b<1)if(w==123)--b;else if(w==125&&b++==0&&U()==125)continue;switch(y+=$(w),w*b){case 38:m=f>0?1:(y+="\f",-1);break;case 44:i[o++]=(M(y)-1)*m,m=1;break;case 64:if(F()===45)y+=W(_());h=F(),f=l=M(k=y+=J(I())),w++;break;case 45:if(v===45&&M(y)==2)b=0;}}return n}function ee(e,r,a,c,t,s,i,u,o,f,l){var h=t-1;var p=t===0?s:[""];var v=S(p);for(var b=0,d=0,m=0;b<c;++b)for(var w=0,$=C(e,h+1,h=k(d=i[b])),g=e;w<v;++w)if(g=E(d>0?p[w]+" "+$:T($,/&\f/g,p[w])))o[m++]=g;return N(e,r,a,t===0?n:u,o,f,l)}function re(e,r,a){return N(e,r,a,t,$(j()),C(e,2,-2),0)}function ae(e,r,a,c){return N(e,r,a,s,C(e,0,c),C(e,c+1,-1),c)}function ce(e,t){switch(x(e,t)){case 5103:return c+"print-"+e+e;case 5737:case 4201:case 3177:case 3433:case 1641:case 4457:case 2921:case 5572:case 6356:case 5844:case 3191:case 6645:case 3005:case 6391:case 5879:case 5623:case 6135:case 4599:case 4855:case 4215:case 6389:case 5109:case 5365:case 5621:case 3829:return c+e+e;case 5349:case 4246:case 4810:case 6968:case 2756:return c+e+a+e+r+e+e;case 6828:case 4268:return c+e+r+e+e;case 6165:return c+e+r+"flex-"+e+e;case 5187:return c+e+T(e,/(\w+).+(:[^]+)/,c+"box-$1$2"+r+"flex-$1$2")+e;case 5443:return c+e+r+"flex-item-"+T(e,/flex-|-self/,"")+e;case 4675:return c+e+r+"flex-line-pack"+T(e,/align-content|flex-|-self/,"")+e;case 5548:return c+e+r+T(e,"shrink","negative")+e;case 5292:return c+e+r+T(e,"basis","preferred-size")+e;case 6060:return c+"box-"+T(e,"-grow","")+c+e+r+T(e,"grow","positive")+e;case 4554:return c+T(e,/([^-])(transform)/g,"$1"+c+"$2")+e;case 6187:return T(T(T(e,/(zoom-|grab)/,c+"$1"),/(image-set)/,c+"$1"),e,"")+e;case 5495:case 3959:return T(e,/(image-set\([^]*)/,c+"$1"+"$`$1");case 4968:return T(T(e,/(.+:)(flex-)?(.*)/,c+"box-pack:$3"+r+"flex-pack:$3"),/s.+-b[^;]+/,"justify")+c+e+e;case 4095:case 3583:case 4068:case 2532:return T(e,/(.+)-inline(.+)/,c+"$1$2")+e;case 8116:case 7059:case 5753:case 5535:case 5445:case 5701:case 4933:case 4677:case 5533:case 5789:case 5021:case 4765:if(M(e)-1-t>6)switch(O(e,t+1)){case 109:if(O(e,t+4)!==45)break;case 102:return T(e,/(.+:)(.+)-([^]+)/,"$1"+c+"$2-$3"+"$1"+a+(O(e,t+3)==108?"$3":"$2-$3"))+e;case 115:return ~A(e,"stretch")?ce(T(e,"stretch","fill-available"),t)+e:e}break;case 4949:if(O(e,t+1)!==115)break;case 6444:switch(O(e,M(e)-3-(~A(e,"!important")&&10))){case 107:return T(e,":",":"+c)+e;case 101:return T(e,/(.+:)([^;!]+)(;|!.+)?/,"$1"+c+(O(e,14)===45?"inline-":"")+"box$3"+"$1"+c+"$2$3"+"$1"+r+"$2box$3")+e}break;case 5936:switch(O(e,t+11)){case 114:return c+e+r+T(e,/[svh]\w+-[tblr]{2}/,"tb")+e;case 108:return c+e+r+T(e,/[svh]\w+-[tblr]{2}/,"tb-rl")+e;case 45:return c+e+r+T(e,/[svh]\w+-[tblr]{2}/,"lr")+e}return c+e+r+e+e}return e}function te(e,r){var a="";var c=S(e);for(var t=0;t<c;t++)a+=r(e[t],t,e,r)||"";return a}function ne(e,r,a,c){switch(e.type){case o:case s:return e.return=e.return||e.value;case t:return "";case b:return e.return=e.value+"{"+te(e.children,c)+"}";case n:e.value=e.props.join(",");}return M(a=te(e.children,c))?e.return=e.value+"{"+a+"}":""}function se(e){var r=S(e);return function(a,c,t,n){var s="";for(var i=0;i<r;i++)s+=e[i](a,c,t,n)||"";return s}}function ie(e){return function(r){if(!r.root)if(r=r.return)e(r);}}function ue(e,t,i,u){if(e.length>-1)if(!e.return)switch(e.type){case s:e.return=ce(e.value,e.length);break;case b:return te([P(e,{value:T(e.value,"@","@"+c)})],u);case n:if(e.length)return z(e.props,(function(t){switch(y(t,/(::plac\w+|:read-\w+)/)){case":read-only":case":read-write":return te([P(e,{props:[T(t,/:(read-\w+)/,":"+a+"$1")]})],u);case"::placeholder":return te([P(e,{props:[T(t,/:(plac\w+)/,":"+c+"input-$1")]}),P(e,{props:[T(t,/:(plac\w+)/,":"+a+"$1")]}),P(e,{props:[T(t,/:(plac\w+)/,r+"input-$1")]})],u)}return ""}))}}function oe(e){switch(e.type){case n:e.props=e.props.map((function(r){return z(Y(r),(function(r,a,c){switch(O(r,0)){case 12:return C(r,1,M(r));case 0:case 40:case 43:case 62:case 126:return r;case 58:if(c[++a]==="global")c[a]="",c[++a]="\f"+C(c[a],a=1,-1);case 32:return a===1?"":r;default:switch(a){case 0:e=r;return S(c)>1?"":r;case a=S(c)-1:case 2:return a===2?r+e+e:r+e;default:return r}}}))}));}}e.CHARSET=f;e.COMMENT=t;e.COUNTER_STYLE=m;e.DECLARATION=s;e.DOCUMENT=p;e.FONT_FACE=d;e.FONT_FEATURE_VALUES=w;e.IMPORT=o;e.KEYFRAMES=b;e.MEDIA=u;e.MOZ=a;e.MS=r;e.NAMESPACE=v;e.PAGE=i;e.RULESET=n;e.SUPPORTS=h;e.VIEWPORT=l;e.WEBKIT=c;e.abs=k;e.alloc=K;e.append=R;e.assign=g;e.caret=I;e.char=j;e.charat=O;e.combine=z;e.comment=re;e.commenter=q;e.compile=Q;e.copy=P;e.dealloc=V;e.declaration=ae;e.delimit=W;e.delimiter=Z;e.escaping=H;e.from=$;e.hash=x;e.identifier=J;e.indexof=A;e.match=y;e.middleware=se;e.namespace=oe;e.next=_;e.node=N;e.parse=X;e.peek=F;e.prefix=ce;e.prefixer=ue;e.prev=U;e.replace=T;e.ruleset=ee;e.rulesheet=ie;e.serialize=te;e.sizeof=S;e.slice=L;e.stringify=ne;e.strlen=M;e.substr=C;e.token=D;e.tokenize=Y;e.tokenizer=G;e.trim=E;e.whitespace=B;Object.defineProperty(e,"__esModule",{value:true});}));
    	
    } (stylis, stylis.exports));

    var weakMemoize = function weakMemoize(func) {
      // $FlowFixMe flow doesn't include all non-primitive types as allowed for weakmaps
      var cache = new WeakMap();
      return function (arg) {
        if (cache.has(arg)) {
          // $FlowFixMe
          return cache.get(arg);
        }

        var ret = func(arg);
        cache.set(arg, ret);
        return ret;
      };
    };

    var last = function last(arr) {
      return arr.length ? arr[arr.length - 1] : null;
    }; // based on https://github.com/thysultan/stylis.js/blob/e6843c373ebcbbfade25ebcc23f540ed8508da0a/src/Tokenizer.js#L239-L244


    var identifierWithPointTracking = function identifierWithPointTracking(begin, points, index) {
      var previous = 0;
      var character = 0;

      while (true) {
        previous = character;
        character = stylis.exports.peek(); // &\f

        if (previous === 38 && character === 12) {
          points[index] = 1;
        }

        if (stylis.exports.token(character)) {
          break;
        }

        stylis.exports.next();
      }

      return stylis.exports.slice(begin, stylis.exports.position);
    };

    var toRules = function toRules(parsed, points) {
      // pretend we've started with a comma
      var index = -1;
      var character = 44;

      do {
        switch (stylis.exports.token(character)) {
          case 0:
            // &\f
            if (character === 38 && stylis.exports.peek() === 12) {
              // this is not 100% correct, we don't account for literal sequences here - like for example quoted strings
              // stylis inserts \f after & to know when & where it should replace this sequence with the context selector
              // and when it should just concatenate the outer and inner selectors
              // it's very unlikely for this sequence to actually appear in a different context, so we just leverage this fact here
              points[index] = 1;
            }

            parsed[index] += identifierWithPointTracking(stylis.exports.position - 1, points, index);
            break;

          case 2:
            parsed[index] += stylis.exports.delimit(character);
            break;

          case 4:
            // comma
            if (character === 44) {
              // colon
              parsed[++index] = stylis.exports.peek() === 58 ? '&\f' : '';
              points[index] = parsed[index].length;
              break;
            }

          // fallthrough

          default:
            parsed[index] += stylis.exports.from(character);
        }
      } while (character = stylis.exports.next());

      return parsed;
    };

    var getRules = function getRules(value, points) {
      return stylis.exports.dealloc(toRules(stylis.exports.alloc(value), points));
    }; // WeakSet would be more appropriate, but only WeakMap is supported in IE11


    var fixedElements = /* #__PURE__ */new WeakMap();
    var compat = function compat(element) {
      if (element.type !== 'rule' || !element.parent || // positive .length indicates that this rule contains pseudo
      // negative .length indicates that this rule has been already prefixed
      element.length < 1) {
        return;
      }

      var value = element.value,
          parent = element.parent;
      var isImplicitRule = element.column === parent.column && element.line === parent.line;

      while (parent.type !== 'rule') {
        parent = parent.parent;
        if (!parent) return;
      } // short-circuit for the simplest case


      if (element.props.length === 1 && value.charCodeAt(0) !== 58
      /* colon */
      && !fixedElements.get(parent)) {
        return;
      } // if this is an implicitly inserted rule (the one eagerly inserted at the each new nested level)
      // then the props has already been manipulated beforehand as they that array is shared between it and its "rule parent"


      if (isImplicitRule) {
        return;
      }

      fixedElements.set(element, true);
      var points = [];
      var rules = getRules(value, points);
      var parentRules = parent.props;

      for (var i = 0, k = 0; i < rules.length; i++) {
        for (var j = 0; j < parentRules.length; j++, k++) {
          element.props[k] = points[i] ? rules[i].replace(/&\f/g, parentRules[j]) : parentRules[j] + " " + rules[i];
        }
      }
    };
    var removeLabel = function removeLabel(element) {
      if (element.type === 'decl') {
        var value = element.value;

        if ( // charcode for l
        value.charCodeAt(0) === 108 && // charcode for b
        value.charCodeAt(2) === 98) {
          // this ignores label
          element["return"] = '';
          element.value = '';
        }
      }
    };
    var ignoreFlag = 'emotion-disable-server-rendering-unsafe-selector-warning-please-do-not-use-this-the-warning-exists-for-a-reason';

    var isIgnoringComment = function isIgnoringComment(element) {
      return !!element && element.type === 'comm' && element.children.indexOf(ignoreFlag) > -1;
    };

    var createUnsafeSelectorsAlarm = function createUnsafeSelectorsAlarm(cache) {
      return function (element, index, children) {
        if (element.type !== 'rule') return;
        var unsafePseudoClasses = element.value.match(/(:first|:nth|:nth-last)-child/g);

        if (unsafePseudoClasses && cache.compat !== true) {
          var prevElement = index > 0 ? children[index - 1] : null;

          if (prevElement && isIgnoringComment(last(prevElement.children))) {
            return;
          }

          unsafePseudoClasses.forEach(function (unsafePseudoClass) {
            console.error("The pseudo class \"" + unsafePseudoClass + "\" is potentially unsafe when doing server-side rendering. Try changing it to \"" + unsafePseudoClass.split('-child')[0] + "-of-type\".");
          });
        }
      };
    };

    var isImportRule = function isImportRule(element) {
      return element.type.charCodeAt(1) === 105 && element.type.charCodeAt(0) === 64;
    };

    var isPrependedWithRegularRules = function isPrependedWithRegularRules(index, children) {
      for (var i = index - 1; i >= 0; i--) {
        if (!isImportRule(children[i])) {
          return true;
        }
      }

      return false;
    }; // use this to remove incorrect elements from further processing
    // so they don't get handed to the `sheet` (or anything else)
    // as that could potentially lead to additional logs which in turn could be overhelming to the user


    var nullifyElement = function nullifyElement(element) {
      element.type = '';
      element.value = '';
      element["return"] = '';
      element.children = '';
      element.props = '';
    };

    var incorrectImportAlarm = function incorrectImportAlarm(element, index, children) {
      if (!isImportRule(element)) {
        return;
      }

      if (element.parent) {
        console.error("`@import` rules can't be nested inside other rules. Please move it to the top level and put it before regular rules. Keep in mind that they can only be used within global styles.");
        nullifyElement(element);
      } else if (isPrependedWithRegularRules(index, children)) {
        console.error("`@import` rules can't be after other rules. Please put your `@import` rules before your other rules.");
        nullifyElement(element);
      }
    };

    var isBrowser$4 = typeof document !== 'undefined';
    var getServerStylisCache = isBrowser$4 ? undefined : weakMemoize(function () {
      return memoize$1(function () {
        var cache = {};
        return function (name) {
          return cache[name];
        };
      });
    });
    var defaultStylisPlugins = [stylis.exports.prefixer];

    var createCache = function createCache(options) {
      var key = options.key;

      if (process.env.NODE_ENV !== 'production' && !key) {
        throw new Error("You have to configure `key` for your cache. Please make sure it's unique (and not equal to 'css') as it's used for linking styles to your cache.\n" + "If multiple caches share the same key they might \"fight\" for each other's style elements.");
      }

      if (isBrowser$4 && key === 'css') {
        var ssrStyles = document.querySelectorAll("style[data-emotion]:not([data-s])"); // get SSRed styles out of the way of React's hydration
        // document.head is a safe place to move them to(though note document.head is not necessarily the last place they will be)
        // note this very very intentionally targets all style elements regardless of the key to ensure
        // that creating a cache works inside of render of a React component

        Array.prototype.forEach.call(ssrStyles, function (node) {
          // we want to only move elements which have a space in the data-emotion attribute value
          // because that indicates that it is an Emotion 11 server-side rendered style elements
          // while we will already ignore Emotion 11 client-side inserted styles because of the :not([data-s]) part in the selector
          // Emotion 10 client-side inserted styles did not have data-s (but importantly did not have a space in their data-emotion attributes)
          // so checking for the space ensures that loading Emotion 11 after Emotion 10 has inserted some styles
          // will not result in the Emotion 10 styles being destroyed
          var dataEmotionAttribute = node.getAttribute('data-emotion');

          if (dataEmotionAttribute.indexOf(' ') === -1) {
            return;
          }
          document.head.appendChild(node);
          node.setAttribute('data-s', '');
        });
      }

      var stylisPlugins = options.stylisPlugins || defaultStylisPlugins;

      if (process.env.NODE_ENV !== 'production') {
        // $FlowFixMe
        if (/[^a-z-]/.test(key)) {
          throw new Error("Emotion key must only contain lower case alphabetical characters and - but \"" + key + "\" was passed");
        }
      }

      var inserted = {}; // $FlowFixMe

      var container;
      var nodesToHydrate = [];

      if (isBrowser$4) {
        container = options.container || document.head;
        Array.prototype.forEach.call( // this means we will ignore elements which don't have a space in them which
        // means that the style elements we're looking at are only Emotion 11 server-rendered style elements
        document.querySelectorAll("style[data-emotion^=\"" + key + " \"]"), function (node) {
          var attrib = node.getAttribute("data-emotion").split(' '); // $FlowFixMe

          for (var i = 1; i < attrib.length; i++) {
            inserted[attrib[i]] = true;
          }

          nodesToHydrate.push(node);
        });
      }

      var _insert;

      var omnipresentPlugins = [compat, removeLabel];

      if (process.env.NODE_ENV !== 'production') {
        omnipresentPlugins.push(createUnsafeSelectorsAlarm({
          get compat() {
            return cache.compat;
          }

        }), incorrectImportAlarm);
      }

      if (isBrowser$4) {
        var currentSheet;
        var finalizingPlugins = [stylis.exports.stringify, process.env.NODE_ENV !== 'production' ? function (element) {
          if (!element.root) {
            if (element["return"]) {
              currentSheet.insert(element["return"]);
            } else if (element.value && element.type !== stylis.exports.COMMENT) {
              // insert empty rule in non-production environments
              // so @emotion/jest can grab `key` from the (JS)DOM for caches without any rules inserted yet
              currentSheet.insert(element.value + "{}");
            }
          }
        } : stylis.exports.rulesheet(function (rule) {
          currentSheet.insert(rule);
        })];
        var serializer = stylis.exports.middleware(omnipresentPlugins.concat(stylisPlugins, finalizingPlugins));

        var stylis$1 = function stylis$1(styles) {
          return stylis.exports.serialize(stylis.exports.compile(styles), serializer);
        };

        _insert = function insert(selector, serialized, sheet, shouldCache) {
          currentSheet = sheet;

          if (process.env.NODE_ENV !== 'production' && serialized.map !== undefined) {
            currentSheet = {
              insert: function insert(rule) {
                sheet.insert(rule + serialized.map);
              }
            };
          }

          stylis$1(selector ? selector + "{" + serialized.styles + "}" : serialized.styles);

          if (shouldCache) {
            cache.inserted[serialized.name] = true;
          }
        };
      } else {
        var _finalizingPlugins = [stylis.exports.stringify];

        var _serializer = stylis.exports.middleware(omnipresentPlugins.concat(stylisPlugins, _finalizingPlugins));

        var _stylis = function _stylis(styles) {
          return stylis.exports.serialize(stylis.exports.compile(styles), _serializer);
        }; // $FlowFixMe


        var serverStylisCache = getServerStylisCache(stylisPlugins)(key);

        var getRules = function getRules(selector, serialized) {
          var name = serialized.name;

          if (serverStylisCache[name] === undefined) {
            serverStylisCache[name] = _stylis(selector ? selector + "{" + serialized.styles + "}" : serialized.styles);
          }

          return serverStylisCache[name];
        };

        _insert = function _insert(selector, serialized, sheet, shouldCache) {
          var name = serialized.name;
          var rules = getRules(selector, serialized);

          if (cache.compat === undefined) {
            // in regular mode, we don't set the styles on the inserted cache
            // since we don't need to and that would be wasting memory
            // we return them so that they are rendered in a style tag
            if (shouldCache) {
              cache.inserted[name] = true;
            }

            if ( // using === development instead of !== production
            // because if people do ssr in tests, the source maps showing up would be annoying
            process.env.NODE_ENV === 'development' && serialized.map !== undefined) {
              return rules + serialized.map;
            }

            return rules;
          } else {
            // in compat mode, we put the styles on the inserted cache so
            // that emotion-server can pull out the styles
            // except when we don't want to cache it which was in Global but now
            // is nowhere but we don't want to do a major right now
            // and just in case we're going to leave the case here
            // it's also not affecting client side bundle size
            // so it's really not a big deal
            if (shouldCache) {
              cache.inserted[name] = rules;
            } else {
              return rules;
            }
          }
        };
      }

      var cache = {
        key: key,
        sheet: new StyleSheet({
          key: key,
          container: container,
          nonce: options.nonce,
          speedy: options.speedy,
          prepend: options.prepend,
          insertionPoint: options.insertionPoint
        }),
        nonce: options.nonce,
        inserted: inserted,
        registered: {},
        insert: _insert
      };
      cache.sheet.hydrate(nodesToHydrate);
      return cache;
    };

    var reactIs$3 = {exports: {}};

    var reactIs_production_min$2 = {};

    /** @license React v16.13.1
     * react-is.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_production_min$2;

    function requireReactIs_production_min$2 () {
    	if (hasRequiredReactIs_production_min$2) return reactIs_production_min$2;
    	hasRequiredReactIs_production_min$2 = 1;
    var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
    	Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
    	function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}reactIs_production_min$2.AsyncMode=l;reactIs_production_min$2.ConcurrentMode=m;reactIs_production_min$2.ContextConsumer=k;reactIs_production_min$2.ContextProvider=h;reactIs_production_min$2.Element=c;reactIs_production_min$2.ForwardRef=n;reactIs_production_min$2.Fragment=e;reactIs_production_min$2.Lazy=t;reactIs_production_min$2.Memo=r;reactIs_production_min$2.Portal=d;
    	reactIs_production_min$2.Profiler=g;reactIs_production_min$2.StrictMode=f;reactIs_production_min$2.Suspense=p;reactIs_production_min$2.isAsyncMode=function(a){return A(a)||z(a)===l};reactIs_production_min$2.isConcurrentMode=A;reactIs_production_min$2.isContextConsumer=function(a){return z(a)===k};reactIs_production_min$2.isContextProvider=function(a){return z(a)===h};reactIs_production_min$2.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};reactIs_production_min$2.isForwardRef=function(a){return z(a)===n};reactIs_production_min$2.isFragment=function(a){return z(a)===e};reactIs_production_min$2.isLazy=function(a){return z(a)===t};
    	reactIs_production_min$2.isMemo=function(a){return z(a)===r};reactIs_production_min$2.isPortal=function(a){return z(a)===d};reactIs_production_min$2.isProfiler=function(a){return z(a)===g};reactIs_production_min$2.isStrictMode=function(a){return z(a)===f};reactIs_production_min$2.isSuspense=function(a){return z(a)===p};
    	reactIs_production_min$2.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};reactIs_production_min$2.typeOf=z;
    	return reactIs_production_min$2;
    }

    var reactIs_development$2 = {};

    /** @license React v16.13.1
     * react-is.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_development$2;

    function requireReactIs_development$2 () {
    	if (hasRequiredReactIs_development$2) return reactIs_development$2;
    	hasRequiredReactIs_development$2 = 1;



    	if (process.env.NODE_ENV !== "production") {
    	  (function() {

    	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    	// nor polyfill, then a plain number is used for performance.
    	var hasSymbol = typeof Symbol === 'function' && Symbol.for;
    	var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
    	var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
    	var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
    	var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
    	var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
    	var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
    	var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
    	// (unstable) APIs that have been removed. Can we remove the symbols?

    	var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
    	var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
    	var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
    	var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
    	var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
    	var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
    	var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
    	var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
    	var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
    	var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
    	var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

    	function isValidElementType(type) {
    	  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
    	  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
    	}

    	function typeOf(object) {
    	  if (typeof object === 'object' && object !== null) {
    	    var $$typeof = object.$$typeof;

    	    switch ($$typeof) {
    	      case REACT_ELEMENT_TYPE:
    	        var type = object.type;

    	        switch (type) {
    	          case REACT_ASYNC_MODE_TYPE:
    	          case REACT_CONCURRENT_MODE_TYPE:
    	          case REACT_FRAGMENT_TYPE:
    	          case REACT_PROFILER_TYPE:
    	          case REACT_STRICT_MODE_TYPE:
    	          case REACT_SUSPENSE_TYPE:
    	            return type;

    	          default:
    	            var $$typeofType = type && type.$$typeof;

    	            switch ($$typeofType) {
    	              case REACT_CONTEXT_TYPE:
    	              case REACT_FORWARD_REF_TYPE:
    	              case REACT_LAZY_TYPE:
    	              case REACT_MEMO_TYPE:
    	              case REACT_PROVIDER_TYPE:
    	                return $$typeofType;

    	              default:
    	                return $$typeof;
    	            }

    	        }

    	      case REACT_PORTAL_TYPE:
    	        return $$typeof;
    	    }
    	  }

    	  return undefined;
    	} // AsyncMode is deprecated along with isAsyncMode

    	var AsyncMode = REACT_ASYNC_MODE_TYPE;
    	var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
    	var ContextConsumer = REACT_CONTEXT_TYPE;
    	var ContextProvider = REACT_PROVIDER_TYPE;
    	var Element = REACT_ELEMENT_TYPE;
    	var ForwardRef = REACT_FORWARD_REF_TYPE;
    	var Fragment = REACT_FRAGMENT_TYPE;
    	var Lazy = REACT_LAZY_TYPE;
    	var Memo = REACT_MEMO_TYPE;
    	var Portal = REACT_PORTAL_TYPE;
    	var Profiler = REACT_PROFILER_TYPE;
    	var StrictMode = REACT_STRICT_MODE_TYPE;
    	var Suspense = REACT_SUSPENSE_TYPE;
    	var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

    	function isAsyncMode(object) {
    	  {
    	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
    	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

    	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    	    }
    	  }

    	  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
    	}
    	function isConcurrentMode(object) {
    	  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
    	}
    	function isContextConsumer(object) {
    	  return typeOf(object) === REACT_CONTEXT_TYPE;
    	}
    	function isContextProvider(object) {
    	  return typeOf(object) === REACT_PROVIDER_TYPE;
    	}
    	function isElement(object) {
    	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    	}
    	function isForwardRef(object) {
    	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
    	}
    	function isFragment(object) {
    	  return typeOf(object) === REACT_FRAGMENT_TYPE;
    	}
    	function isLazy(object) {
    	  return typeOf(object) === REACT_LAZY_TYPE;
    	}
    	function isMemo(object) {
    	  return typeOf(object) === REACT_MEMO_TYPE;
    	}
    	function isPortal(object) {
    	  return typeOf(object) === REACT_PORTAL_TYPE;
    	}
    	function isProfiler(object) {
    	  return typeOf(object) === REACT_PROFILER_TYPE;
    	}
    	function isStrictMode(object) {
    	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
    	}
    	function isSuspense(object) {
    	  return typeOf(object) === REACT_SUSPENSE_TYPE;
    	}

    	reactIs_development$2.AsyncMode = AsyncMode;
    	reactIs_development$2.ConcurrentMode = ConcurrentMode;
    	reactIs_development$2.ContextConsumer = ContextConsumer;
    	reactIs_development$2.ContextProvider = ContextProvider;
    	reactIs_development$2.Element = Element;
    	reactIs_development$2.ForwardRef = ForwardRef;
    	reactIs_development$2.Fragment = Fragment;
    	reactIs_development$2.Lazy = Lazy;
    	reactIs_development$2.Memo = Memo;
    	reactIs_development$2.Portal = Portal;
    	reactIs_development$2.Profiler = Profiler;
    	reactIs_development$2.StrictMode = StrictMode;
    	reactIs_development$2.Suspense = Suspense;
    	reactIs_development$2.isAsyncMode = isAsyncMode;
    	reactIs_development$2.isConcurrentMode = isConcurrentMode;
    	reactIs_development$2.isContextConsumer = isContextConsumer;
    	reactIs_development$2.isContextProvider = isContextProvider;
    	reactIs_development$2.isElement = isElement;
    	reactIs_development$2.isForwardRef = isForwardRef;
    	reactIs_development$2.isFragment = isFragment;
    	reactIs_development$2.isLazy = isLazy;
    	reactIs_development$2.isMemo = isMemo;
    	reactIs_development$2.isPortal = isPortal;
    	reactIs_development$2.isProfiler = isProfiler;
    	reactIs_development$2.isStrictMode = isStrictMode;
    	reactIs_development$2.isSuspense = isSuspense;
    	reactIs_development$2.isValidElementType = isValidElementType;
    	reactIs_development$2.typeOf = typeOf;
    	  })();
    	}
    	return reactIs_development$2;
    }

    (function (module) {

    	if (process.env.NODE_ENV === 'production') {
    	  module.exports = requireReactIs_production_min$2();
    	} else {
    	  module.exports = requireReactIs_development$2();
    	}
    } (reactIs$3));

    var reactIs$2 = reactIs$3.exports;
    var FORWARD_REF_STATICS = {
      '$$typeof': true,
      render: true,
      defaultProps: true,
      displayName: true,
      propTypes: true
    };
    var MEMO_STATICS = {
      '$$typeof': true,
      compare: true,
      defaultProps: true,
      displayName: true,
      propTypes: true,
      type: true
    };
    var TYPE_STATICS = {};
    TYPE_STATICS[reactIs$2.ForwardRef] = FORWARD_REF_STATICS;
    TYPE_STATICS[reactIs$2.Memo] = MEMO_STATICS;

    var isBrowser$3 = typeof document !== 'undefined';
    function getRegisteredStyles(registered, registeredStyles, classNames) {
      var rawClassName = '';
      classNames.split(' ').forEach(function (className) {
        if (registered[className] !== undefined) {
          registeredStyles.push(registered[className] + ";");
        } else {
          rawClassName += className + " ";
        }
      });
      return rawClassName;
    }
    var registerStyles = function registerStyles(cache, serialized, isStringTag) {
      var className = cache.key + "-" + serialized.name;

      if ( // we only need to add the styles to the registered cache if the
      // class name could be used further down
      // the tree but if it's a string tag, we know it won't
      // so we don't have to add it to registered cache.
      // this improves memory usage since we can avoid storing the whole style string
      (isStringTag === false || // we need to always store it if we're in compat mode and
      // in node since emotion-server relies on whether a style is in
      // the registered cache to know whether a style is global or not
      // also, note that this check will be dead code eliminated in the browser
      isBrowser$3 === false && cache.compat !== undefined) && cache.registered[className] === undefined) {
        cache.registered[className] = serialized.styles;
      }
    };
    var insertStyles = function insertStyles(cache, serialized, isStringTag) {
      registerStyles(cache, serialized, isStringTag);
      var className = cache.key + "-" + serialized.name;

      if (cache.inserted[serialized.name] === undefined) {
        var stylesForSSR = '';
        var current = serialized;

        do {
          var maybeStyles = cache.insert(serialized === current ? "." + className : '', current, cache.sheet, true);

          if (!isBrowser$3 && maybeStyles !== undefined) {
            stylesForSSR += maybeStyles;
          }

          current = current.next;
        } while (current !== undefined);

        if (!isBrowser$3 && stylesForSSR.length !== 0) {
          return stylesForSSR;
        }
      }
    };

    /* eslint-disable */
    // Inspired by https://github.com/garycourt/murmurhash-js
    // Ported from https://github.com/aappleby/smhasher/blob/61a0530f28277f2e850bfc39600ce61d02b518de/src/MurmurHash2.cpp#L37-L86
    function murmur2(str) {
      // 'm' and 'r' are mixing constants generated offline.
      // They're not really 'magic', they just happen to work well.
      // const m = 0x5bd1e995;
      // const r = 24;
      // Initialize the hash
      var h = 0; // Mix 4 bytes at a time into the hash

      var k,
          i = 0,
          len = str.length;

      for (; len >= 4; ++i, len -= 4) {
        k = str.charCodeAt(i) & 0xff | (str.charCodeAt(++i) & 0xff) << 8 | (str.charCodeAt(++i) & 0xff) << 16 | (str.charCodeAt(++i) & 0xff) << 24;
        k =
        /* Math.imul(k, m): */
        (k & 0xffff) * 0x5bd1e995 + ((k >>> 16) * 0xe995 << 16);
        k ^=
        /* k >>> r: */
        k >>> 24;
        h =
        /* Math.imul(k, m): */
        (k & 0xffff) * 0x5bd1e995 + ((k >>> 16) * 0xe995 << 16) ^
        /* Math.imul(h, m): */
        (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
      } // Handle the last few bytes of the input array


      switch (len) {
        case 3:
          h ^= (str.charCodeAt(i + 2) & 0xff) << 16;

        case 2:
          h ^= (str.charCodeAt(i + 1) & 0xff) << 8;

        case 1:
          h ^= str.charCodeAt(i) & 0xff;
          h =
          /* Math.imul(h, m): */
          (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
      } // Do a few final mixes of the hash to ensure the last few
      // bytes are well-incorporated.


      h ^= h >>> 13;
      h =
      /* Math.imul(h, m): */
      (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
      return ((h ^ h >>> 15) >>> 0).toString(36);
    }

    var unitless_cjs = {exports: {}};

    var unitless_cjs_prod = {};

    var hasRequiredUnitless_cjs_prod;

    function requireUnitless_cjs_prod () {
    	if (hasRequiredUnitless_cjs_prod) return unitless_cjs_prod;
    	hasRequiredUnitless_cjs_prod = 1;

    	Object.defineProperty(unitless_cjs_prod, "__esModule", {
    	  value: !0
    	});

    	var unitlessKeys = {
    	  animationIterationCount: 1,
    	  borderImageOutset: 1,
    	  borderImageSlice: 1,
    	  borderImageWidth: 1,
    	  boxFlex: 1,
    	  boxFlexGroup: 1,
    	  boxOrdinalGroup: 1,
    	  columnCount: 1,
    	  columns: 1,
    	  flex: 1,
    	  flexGrow: 1,
    	  flexPositive: 1,
    	  flexShrink: 1,
    	  flexNegative: 1,
    	  flexOrder: 1,
    	  gridRow: 1,
    	  gridRowEnd: 1,
    	  gridRowSpan: 1,
    	  gridRowStart: 1,
    	  gridColumn: 1,
    	  gridColumnEnd: 1,
    	  gridColumnSpan: 1,
    	  gridColumnStart: 1,
    	  msGridRow: 1,
    	  msGridRowSpan: 1,
    	  msGridColumn: 1,
    	  msGridColumnSpan: 1,
    	  fontWeight: 1,
    	  lineHeight: 1,
    	  opacity: 1,
    	  order: 1,
    	  orphans: 1,
    	  tabSize: 1,
    	  widows: 1,
    	  zIndex: 1,
    	  zoom: 1,
    	  WebkitLineClamp: 1,
    	  fillOpacity: 1,
    	  floodOpacity: 1,
    	  stopOpacity: 1,
    	  strokeDasharray: 1,
    	  strokeDashoffset: 1,
    	  strokeMiterlimit: 1,
    	  strokeOpacity: 1,
    	  strokeWidth: 1
    	};

    	unitless_cjs_prod.default = unitlessKeys;
    	return unitless_cjs_prod;
    }

    var unitless_cjs_dev = {};

    var hasRequiredUnitless_cjs_dev;

    function requireUnitless_cjs_dev () {
    	if (hasRequiredUnitless_cjs_dev) return unitless_cjs_dev;
    	hasRequiredUnitless_cjs_dev = 1;

    	Object.defineProperty(unitless_cjs_dev, '__esModule', { value: true });

    	var unitlessKeys = {
    	  animationIterationCount: 1,
    	  borderImageOutset: 1,
    	  borderImageSlice: 1,
    	  borderImageWidth: 1,
    	  boxFlex: 1,
    	  boxFlexGroup: 1,
    	  boxOrdinalGroup: 1,
    	  columnCount: 1,
    	  columns: 1,
    	  flex: 1,
    	  flexGrow: 1,
    	  flexPositive: 1,
    	  flexShrink: 1,
    	  flexNegative: 1,
    	  flexOrder: 1,
    	  gridRow: 1,
    	  gridRowEnd: 1,
    	  gridRowSpan: 1,
    	  gridRowStart: 1,
    	  gridColumn: 1,
    	  gridColumnEnd: 1,
    	  gridColumnSpan: 1,
    	  gridColumnStart: 1,
    	  msGridRow: 1,
    	  msGridRowSpan: 1,
    	  msGridColumn: 1,
    	  msGridColumnSpan: 1,
    	  fontWeight: 1,
    	  lineHeight: 1,
    	  opacity: 1,
    	  order: 1,
    	  orphans: 1,
    	  tabSize: 1,
    	  widows: 1,
    	  zIndex: 1,
    	  zoom: 1,
    	  WebkitLineClamp: 1,
    	  // SVG-related properties
    	  fillOpacity: 1,
    	  floodOpacity: 1,
    	  stopOpacity: 1,
    	  strokeDasharray: 1,
    	  strokeDashoffset: 1,
    	  strokeMiterlimit: 1,
    	  strokeOpacity: 1,
    	  strokeWidth: 1
    	};

    	unitless_cjs_dev.default = unitlessKeys;
    	return unitless_cjs_dev;
    }

    (function (module) {

    	if (process.env.NODE_ENV === "production") {
    	  module.exports = requireUnitless_cjs_prod();
    	} else {
    	  module.exports = requireUnitless_cjs_dev();
    	}
    } (unitless_cjs));

    var unitless = /*@__PURE__*/getDefaultExportFromCjs(unitless_cjs.exports);

    var ILLEGAL_ESCAPE_SEQUENCE_ERROR$1 = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";
    var UNDEFINED_AS_OBJECT_KEY_ERROR = "You have passed in falsy value as style object's key (can happen when in example you pass unexported component as computed key).";
    var hyphenateRegex = /[A-Z]|^ms/g;
    var animationRegex = /_EMO_([^_]+?)_([^]*?)_EMO_/g;

    var isCustomProperty = function isCustomProperty(property) {
      return property.charCodeAt(1) === 45;
    };

    var isProcessableValue = function isProcessableValue(value) {
      return value != null && typeof value !== 'boolean';
    };

    var processStyleName = /* #__PURE__ */memoize$1(function (styleName) {
      return isCustomProperty(styleName) ? styleName : styleName.replace(hyphenateRegex, '-$&').toLowerCase();
    });

    var processStyleValue = function processStyleValue(key, value) {
      switch (key) {
        case 'animation':
        case 'animationName':
          {
            if (typeof value === 'string') {
              return value.replace(animationRegex, function (match, p1, p2) {
                cursor = {
                  name: p1,
                  styles: p2,
                  next: cursor
                };
                return p1;
              });
            }
          }
      }

      if (unitless[key] !== 1 && !isCustomProperty(key) && typeof value === 'number' && value !== 0) {
        return value + 'px';
      }

      return value;
    };

    if (process.env.NODE_ENV !== 'production') {
      var contentValuePattern = /(attr|counters?|url|(((repeating-)?(linear|radial))|conic)-gradient)\(|(no-)?(open|close)-quote/;
      var contentValues = ['normal', 'none', 'initial', 'inherit', 'unset'];
      var oldProcessStyleValue = processStyleValue;
      var msPattern = /^-ms-/;
      var hyphenPattern = /-(.)/g;
      var hyphenatedCache = {};

      processStyleValue = function processStyleValue(key, value) {
        if (key === 'content') {
          if (typeof value !== 'string' || contentValues.indexOf(value) === -1 && !contentValuePattern.test(value) && (value.charAt(0) !== value.charAt(value.length - 1) || value.charAt(0) !== '"' && value.charAt(0) !== "'")) {
            throw new Error("You seem to be using a value for 'content' without quotes, try replacing it with `content: '\"" + value + "\"'`");
          }
        }

        var processed = oldProcessStyleValue(key, value);

        if (processed !== '' && !isCustomProperty(key) && key.indexOf('-') !== -1 && hyphenatedCache[key] === undefined) {
          hyphenatedCache[key] = true;
          console.error("Using kebab-case for css properties in objects is not supported. Did you mean " + key.replace(msPattern, 'ms-').replace(hyphenPattern, function (str, _char) {
            return _char.toUpperCase();
          }) + "?");
        }

        return processed;
      };
    }

    function handleInterpolation(mergedProps, registered, interpolation) {
      if (interpolation == null) {
        return '';
      }

      if (interpolation.__emotion_styles !== undefined) {
        if (process.env.NODE_ENV !== 'production' && interpolation.toString() === 'NO_COMPONENT_SELECTOR') {
          throw new Error('Component selectors can only be used in conjunction with @emotion/babel-plugin.');
        }

        return interpolation;
      }

      switch (typeof interpolation) {
        case 'boolean':
          {
            return '';
          }

        case 'object':
          {
            if (interpolation.anim === 1) {
              cursor = {
                name: interpolation.name,
                styles: interpolation.styles,
                next: cursor
              };
              return interpolation.name;
            }

            if (interpolation.styles !== undefined) {
              var next = interpolation.next;

              if (next !== undefined) {
                // not the most efficient thing ever but this is a pretty rare case
                // and there will be very few iterations of this generally
                while (next !== undefined) {
                  cursor = {
                    name: next.name,
                    styles: next.styles,
                    next: cursor
                  };
                  next = next.next;
                }
              }

              var styles = interpolation.styles + ";";

              if (process.env.NODE_ENV !== 'production' && interpolation.map !== undefined) {
                styles += interpolation.map;
              }

              return styles;
            }

            return createStringFromObject(mergedProps, registered, interpolation);
          }

        case 'function':
          {
            if (mergedProps !== undefined) {
              var previousCursor = cursor;
              var result = interpolation(mergedProps);
              cursor = previousCursor;
              return handleInterpolation(mergedProps, registered, result);
            } else if (process.env.NODE_ENV !== 'production') {
              console.error('Functions that are interpolated in css calls will be stringified.\n' + 'If you want to have a css call based on props, create a function that returns a css call like this\n' + 'let dynamicStyle = (props) => css`color: ${props.color}`\n' + 'It can be called directly with props or interpolated in a styled call like this\n' + "let SomeComponent = styled('div')`${dynamicStyle}`");
            }

            break;
          }

        case 'string':
          if (process.env.NODE_ENV !== 'production') {
            var matched = [];
            var replaced = interpolation.replace(animationRegex, function (match, p1, p2) {
              var fakeVarName = "animation" + matched.length;
              matched.push("const " + fakeVarName + " = keyframes`" + p2.replace(/^@keyframes animation-\w+/, '') + "`");
              return "${" + fakeVarName + "}";
            });

            if (matched.length) {
              console.error('`keyframes` output got interpolated into plain string, please wrap it with `css`.\n\n' + 'Instead of doing this:\n\n' + [].concat(matched, ["`" + replaced + "`"]).join('\n') + '\n\nYou should wrap it with `css` like this:\n\n' + ("css`" + replaced + "`"));
            }
          }

          break;
      } // finalize string values (regular strings and functions interpolated into css calls)


      if (registered == null) {
        return interpolation;
      }

      var cached = registered[interpolation];
      return cached !== undefined ? cached : interpolation;
    }

    function createStringFromObject(mergedProps, registered, obj) {
      var string = '';

      if (Array.isArray(obj)) {
        for (var i = 0; i < obj.length; i++) {
          string += handleInterpolation(mergedProps, registered, obj[i]) + ";";
        }
      } else {
        for (var _key in obj) {
          var value = obj[_key];

          if (typeof value !== 'object') {
            if (registered != null && registered[value] !== undefined) {
              string += _key + "{" + registered[value] + "}";
            } else if (isProcessableValue(value)) {
              string += processStyleName(_key) + ":" + processStyleValue(_key, value) + ";";
            }
          } else {
            if (_key === 'NO_COMPONENT_SELECTOR' && process.env.NODE_ENV !== 'production') {
              throw new Error('Component selectors can only be used in conjunction with @emotion/babel-plugin.');
            }

            if (Array.isArray(value) && typeof value[0] === 'string' && (registered == null || registered[value[0]] === undefined)) {
              for (var _i = 0; _i < value.length; _i++) {
                if (isProcessableValue(value[_i])) {
                  string += processStyleName(_key) + ":" + processStyleValue(_key, value[_i]) + ";";
                }
              }
            } else {
              var interpolated = handleInterpolation(mergedProps, registered, value);

              switch (_key) {
                case 'animation':
                case 'animationName':
                  {
                    string += processStyleName(_key) + ":" + interpolated + ";";
                    break;
                  }

                default:
                  {
                    if (process.env.NODE_ENV !== 'production' && _key === 'undefined') {
                      console.error(UNDEFINED_AS_OBJECT_KEY_ERROR);
                    }

                    string += _key + "{" + interpolated + "}";
                  }
              }
            }
          }
        }
      }

      return string;
    }

    var labelPattern = /label:\s*([^\s;\n{]+)\s*(;|$)/g;
    var sourceMapPattern;

    if (process.env.NODE_ENV !== 'production') {
      sourceMapPattern = /\/\*#\ssourceMappingURL=data:application\/json;\S+\s+\*\//g;
    } // this is the cursor for keyframes
    // keyframes are stored on the SerializedStyles object as a linked list


    var cursor;
    var serializeStyles = function serializeStyles(args, registered, mergedProps) {
      if (args.length === 1 && typeof args[0] === 'object' && args[0] !== null && args[0].styles !== undefined) {
        return args[0];
      }

      var stringMode = true;
      var styles = '';
      cursor = undefined;
      var strings = args[0];

      if (strings == null || strings.raw === undefined) {
        stringMode = false;
        styles += handleInterpolation(mergedProps, registered, strings);
      } else {
        if (process.env.NODE_ENV !== 'production' && strings[0] === undefined) {
          console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR$1);
        }

        styles += strings[0];
      } // we start at 1 since we've already handled the first arg


      for (var i = 1; i < args.length; i++) {
        styles += handleInterpolation(mergedProps, registered, args[i]);

        if (stringMode) {
          if (process.env.NODE_ENV !== 'production' && strings[i] === undefined) {
            console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR$1);
          }

          styles += strings[i];
        }
      }

      var sourceMap;

      if (process.env.NODE_ENV !== 'production') {
        styles = styles.replace(sourceMapPattern, function (match) {
          sourceMap = match;
          return '';
        });
      } // using a global regex with .exec is stateful so lastIndex has to be reset each time


      labelPattern.lastIndex = 0;
      var identifierName = '';
      var match; // https://esbench.com/bench/5b809c2cf2949800a0f61fb5

      while ((match = labelPattern.exec(styles)) !== null) {
        identifierName += '-' + // $FlowFixMe we know it's not null
        match[1];
      }

      var name = murmur2(styles) + identifierName;

      if (process.env.NODE_ENV !== 'production') {
        // $FlowFixMe SerializedStyles type doesn't have toString property (and we don't want to add it)
        return {
          name: name,
          styles: styles,
          map: sourceMap,
          next: cursor,
          toString: function toString() {
            return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop).";
          }
        };
      }

      return {
        name: name,
        styles: styles,
        next: cursor
      };
    };

    var isBrowser$2 = typeof document !== 'undefined';
    var hasOwnProperty = {}.hasOwnProperty;

    var EmotionCacheContext = /* #__PURE__ */react.exports.createContext( // we're doing this to avoid preconstruct's dead code elimination in this one case
    // because this module is primarily intended for the browser and node
    // but it's also required in react native and similar environments sometimes
    // and we could have a special build just for that
    // but this is much easier and the native packages
    // might use a different theme context in the future anyway
    typeof HTMLElement !== 'undefined' ? /* #__PURE__ */createCache({
      key: 'css'
    }) : null);

    if (process.env.NODE_ENV !== 'production') {
      EmotionCacheContext.displayName = 'EmotionCacheContext';
    }

    EmotionCacheContext.Provider;

    var withEmotionCache = function withEmotionCache(func) {
      // $FlowFixMe
      return /*#__PURE__*/react.exports.forwardRef(function (props, ref) {
        // the cache will never be null in the browser
        var cache = react.exports.useContext(EmotionCacheContext);
        return func(props, cache, ref);
      });
    };

    if (!isBrowser$2) {
      withEmotionCache = function withEmotionCache(func) {
        return function (props) {
          var cache = react.exports.useContext(EmotionCacheContext);

          if (cache === null) {
            // yes, we're potentially creating this on every render
            // it doesn't actually matter though since it's only on the server
            // so there will only every be a single render
            // that could change in the future because of suspense and etc. but for now,
            // this works and i don't want to optimise for a future thing that we aren't sure about
            cache = createCache({
              key: 'css'
            });
            return /*#__PURE__*/react.exports.createElement(EmotionCacheContext.Provider, {
              value: cache
            }, func(props, cache));
          } else {
            return func(props, cache);
          }
        };
      };
    }

    var ThemeContext$1 = /* #__PURE__ */react.exports.createContext({});

    if (process.env.NODE_ENV !== 'production') {
      ThemeContext$1.displayName = 'EmotionThemeContext';
    }

    var isBrowser$1$1 = typeof document !== 'undefined';
    var useInsertionEffect$1 = React$1['useInsertion' + 'Effect'] ? React$1['useInsertion' + 'Effect'] : function useInsertionEffect(create) {
      create();
    };
    function useInsertionEffectMaybe(create) {
      if (!isBrowser$1$1) {
        return create();
      }

      useInsertionEffect$1(create);
    }

    var typePropName = '__EMOTION_TYPE_PLEASE_DO_NOT_USE__';
    var labelPropName = '__EMOTION_LABEL_PLEASE_DO_NOT_USE__';

    var Insertion$1 = function Insertion(_ref) {
      var cache = _ref.cache,
          serialized = _ref.serialized,
          isStringTag = _ref.isStringTag;
      registerStyles(cache, serialized, isStringTag);
      var rules = useInsertionEffectMaybe(function () {
        return insertStyles(cache, serialized, isStringTag);
      });

      if (!isBrowser$2 && rules !== undefined) {
        var _ref2;

        var serializedNames = serialized.name;
        var next = serialized.next;

        while (next !== undefined) {
          serializedNames += ' ' + next.name;
          next = next.next;
        }

        return /*#__PURE__*/react.exports.createElement("style", (_ref2 = {}, _ref2["data-emotion"] = cache.key + " " + serializedNames, _ref2.dangerouslySetInnerHTML = {
          __html: rules
        }, _ref2.nonce = cache.sheet.nonce, _ref2));
      }

      return null;
    };

    var Emotion = /* #__PURE__ */withEmotionCache(function (props, cache, ref) {
      var cssProp = props.css; // so that using `css` from `emotion` and passing the result to the css prop works
      // not passing the registered cache to serializeStyles because it would
      // make certain babel optimisations not possible

      if (typeof cssProp === 'string' && cache.registered[cssProp] !== undefined) {
        cssProp = cache.registered[cssProp];
      }

      var WrappedComponent = props[typePropName];
      var registeredStyles = [cssProp];
      var className = '';

      if (typeof props.className === 'string') {
        className = getRegisteredStyles(cache.registered, registeredStyles, props.className);
      } else if (props.className != null) {
        className = props.className + " ";
      }

      var serialized = serializeStyles(registeredStyles, undefined, react.exports.useContext(ThemeContext$1));

      if (process.env.NODE_ENV !== 'production' && serialized.name.indexOf('-') === -1) {
        var labelFromStack = props[labelPropName];

        if (labelFromStack) {
          serialized = serializeStyles([serialized, 'label:' + labelFromStack + ';']);
        }
      }

      className += cache.key + "-" + serialized.name;
      var newProps = {};

      for (var key in props) {
        if (hasOwnProperty.call(props, key) && key !== 'css' && key !== typePropName && (process.env.NODE_ENV === 'production' || key !== labelPropName)) {
          newProps[key] = props[key];
        }
      }

      newProps.ref = ref;
      newProps.className = className;
      return /*#__PURE__*/react.exports.createElement(react.exports.Fragment, null, /*#__PURE__*/react.exports.createElement(Insertion$1, {
        cache: cache,
        serialized: serialized,
        isStringTag: typeof WrappedComponent === 'string'
      }), /*#__PURE__*/react.exports.createElement(WrappedComponent, newProps));
    });

    if (process.env.NODE_ENV !== 'production') {
      Emotion.displayName = 'EmotionCssPropInternal';
    }

    var pkg = {
    	name: "@emotion/react",
    	version: "11.8.1",
    	main: "dist/emotion-react.cjs.js",
    	module: "dist/emotion-react.esm.js",
    	browser: {
    		"./dist/emotion-react.cjs.js": "./dist/emotion-react.browser.cjs.js",
    		"./dist/emotion-react.esm.js": "./dist/emotion-react.browser.esm.js"
    	},
    	types: "types/index.d.ts",
    	files: [
    		"src",
    		"dist",
    		"jsx-runtime",
    		"jsx-dev-runtime",
    		"_isolated-hnrs",
    		"types/*.d.ts",
    		"macro.js",
    		"macro.d.ts",
    		"macro.js.flow"
    	],
    	sideEffects: false,
    	author: "Emotion Contributors",
    	license: "MIT",
    	scripts: {
    		"test:typescript": "dtslint types"
    	},
    	dependencies: {
    		"@babel/runtime": "^7.13.10",
    		"@emotion/babel-plugin": "^11.7.1",
    		"@emotion/cache": "^11.7.1",
    		"@emotion/serialize": "^1.0.2",
    		"@emotion/sheet": "^1.1.0",
    		"@emotion/utils": "^1.1.0",
    		"@emotion/weak-memoize": "^0.2.5",
    		"hoist-non-react-statics": "^3.3.1"
    	},
    	peerDependencies: {
    		"@babel/core": "^7.0.0",
    		react: ">=16.8.0"
    	},
    	peerDependenciesMeta: {
    		"@babel/core": {
    			optional: true
    		},
    		"@types/react": {
    			optional: true
    		}
    	},
    	devDependencies: {
    		"@babel/core": "^7.13.10",
    		"@emotion/css": "11.7.1",
    		"@emotion/css-prettifier": "1.0.1",
    		"@emotion/server": "11.4.0",
    		"@emotion/styled": "11.8.1",
    		"@types/react": "^16.9.11",
    		dtslint: "^0.3.0",
    		"html-tag-names": "^1.1.2",
    		react: "16.14.0",
    		"svg-tag-names": "^1.1.1"
    	},
    	repository: "https://github.com/emotion-js/emotion/tree/main/packages/react",
    	publishConfig: {
    		access: "public"
    	},
    	"umd:main": "dist/emotion-react.umd.min.js",
    	preconstruct: {
    		entrypoints: [
    			"./index.js",
    			"./jsx-runtime.js",
    			"./jsx-dev-runtime.js",
    			"./_isolated-hnrs.js"
    		],
    		umdName: "emotionReact"
    	}
    };

    var useInsertionEffect = React$1['useInsertion' + 'Effect'] ? React$1['useInsertion' + 'Effect'] : react.exports.useLayoutEffect;
    var warnedAboutCssPropForGlobal = false; // maintain place over rerenders.
    // initial render from browser, insertBefore context.sheet.tags[0] or if a style hasn't been inserted there yet, appendChild
    // initial client-side render from SSR, use place of hydrating tag

    var Global = /* #__PURE__ */withEmotionCache(function (props, cache) {
      if (process.env.NODE_ENV !== 'production' && !warnedAboutCssPropForGlobal && ( // check for className as well since the user is
      // probably using the custom createElement which
      // means it will be turned into a className prop
      // $FlowFixMe I don't really want to add it to the type since it shouldn't be used
      props.className || props.css)) {
        console.error("It looks like you're using the css prop on Global, did you mean to use the styles prop instead?");
        warnedAboutCssPropForGlobal = true;
      }

      var styles = props.styles;
      var serialized = serializeStyles([styles], undefined, react.exports.useContext(ThemeContext$1));

      if (!isBrowser$2) {
        var _ref;

        var serializedNames = serialized.name;
        var serializedStyles = serialized.styles;
        var next = serialized.next;

        while (next !== undefined) {
          serializedNames += ' ' + next.name;
          serializedStyles += next.styles;
          next = next.next;
        }

        var shouldCache = cache.compat === true;
        var rules = cache.insert("", {
          name: serializedNames,
          styles: serializedStyles
        }, cache.sheet, shouldCache);

        if (shouldCache) {
          return null;
        }

        return /*#__PURE__*/react.exports.createElement("style", (_ref = {}, _ref["data-emotion"] = cache.key + "-global " + serializedNames, _ref.dangerouslySetInnerHTML = {
          __html: rules
        }, _ref.nonce = cache.sheet.nonce, _ref));
      } // yes, i know these hooks are used conditionally
      // but it is based on a constant that will never change at runtime
      // it's effectively like having two implementations and switching them out
      // so it's not actually breaking anything


      var sheetRef = react.exports.useRef();
      useInsertionEffect(function () {
        var key = cache.key + "-global";
        var sheet = new StyleSheet({
          key: key,
          nonce: cache.sheet.nonce,
          container: cache.sheet.container,
          speedy: cache.sheet.isSpeedy
        });
        var rehydrating = false; // $FlowFixMe

        var node = document.querySelector("style[data-emotion=\"" + key + " " + serialized.name + "\"]");

        if (cache.sheet.tags.length) {
          sheet.before = cache.sheet.tags[0];
        }

        if (node !== null) {
          rehydrating = true; // clear the hash so this node won't be recognizable as rehydratable by other <Global/>s

          node.setAttribute('data-emotion', key);
          sheet.hydrate([node]);
        }

        sheetRef.current = [sheet, rehydrating];
        return function () {
          sheet.flush();
        };
      }, [cache]);
      useInsertionEffect(function () {
        var sheetRefCurrent = sheetRef.current;
        var sheet = sheetRefCurrent[0],
            rehydrating = sheetRefCurrent[1];

        if (rehydrating) {
          sheetRefCurrent[1] = false;
          return;
        }

        if (serialized.next !== undefined) {
          // insert keyframes
          insertStyles(cache, serialized.next, true);
        }

        if (sheet.tags.length) {
          // if this doesn't exist then it will be null so the style element will be appended
          var element = sheet.tags[sheet.tags.length - 1].nextElementSibling;
          sheet.before = element;
          sheet.flush();
        }

        cache.insert("", serialized, sheet, false);
      }, [cache, serialized.name]);
      return null;
    });

    if (process.env.NODE_ENV !== 'production') {
      Global.displayName = 'EmotionGlobal';
    }

    function css() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return serializeStyles(args);
    }

    var keyframes = function keyframes() {
      var insertable = css.apply(void 0, arguments);
      var name = "animation-" + insertable.name; // $FlowFixMe

      return {
        name: name,
        styles: "@keyframes " + name + "{" + insertable.styles + "}",
        anim: 1,
        toString: function toString() {
          return "_EMO_" + this.name + "_" + this.styles + "_EMO_";
        }
      };
    };

    var classnames = function classnames(args) {
      var len = args.length;
      var i = 0;
      var cls = '';

      for (; i < len; i++) {
        var arg = args[i];
        if (arg == null) continue;
        var toAdd = void 0;

        switch (typeof arg) {
          case 'boolean':
            break;

          case 'object':
            {
              if (Array.isArray(arg)) {
                toAdd = classnames(arg);
              } else {
                if (process.env.NODE_ENV !== 'production' && arg.styles !== undefined && arg.name !== undefined) {
                  console.error('You have passed styles created with `css` from `@emotion/react` package to the `cx`.\n' + '`cx` is meant to compose class names (strings) so you should convert those styles to a class name by passing them to the `css` received from <ClassNames/> component.');
                }

                toAdd = '';

                for (var k in arg) {
                  if (arg[k] && k) {
                    toAdd && (toAdd += ' ');
                    toAdd += k;
                  }
                }
              }

              break;
            }

          default:
            {
              toAdd = arg;
            }
        }

        if (toAdd) {
          cls && (cls += ' ');
          cls += toAdd;
        }
      }

      return cls;
    };

    function merge$1(registered, css, className) {
      var registeredStyles = [];
      var rawClassName = getRegisteredStyles(registered, registeredStyles, className);

      if (registeredStyles.length < 2) {
        return className;
      }

      return rawClassName + css(registeredStyles);
    }

    var Insertion = function Insertion(_ref) {
      var cache = _ref.cache,
          serializedArr = _ref.serializedArr;
      var rules = useInsertionEffectMaybe(function () {
        var rules = '';

        for (var i = 0; i < serializedArr.length; i++) {
          var res = insertStyles(cache, serializedArr[i], false);

          if (!isBrowser$2 && res !== undefined) {
            rules += res;
          }
        }

        if (!isBrowser$2) {
          return rules;
        }
      });

      if (!isBrowser$2 && rules.length !== 0) {
        var _ref2;

        return /*#__PURE__*/react.exports.createElement("style", (_ref2 = {}, _ref2["data-emotion"] = cache.key + " " + serializedArr.map(function (serialized) {
          return serialized.name;
        }).join(' '), _ref2.dangerouslySetInnerHTML = {
          __html: rules
        }, _ref2.nonce = cache.sheet.nonce, _ref2));
      }

      return null;
    };

    var ClassNames = /* #__PURE__ */withEmotionCache(function (props, cache) {
      var hasRendered = false;
      var serializedArr = [];

      var css = function css() {
        if (hasRendered && process.env.NODE_ENV !== 'production') {
          throw new Error('css can only be used during render');
        }

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var serialized = serializeStyles(args, cache.registered);
        serializedArr.push(serialized); // registration has to happen here as the result of this might get consumed by `cx`

        registerStyles(cache, serialized, false);
        return cache.key + "-" + serialized.name;
      };

      var cx = function cx() {
        if (hasRendered && process.env.NODE_ENV !== 'production') {
          throw new Error('cx can only be used during render');
        }

        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return merge$1(cache.registered, css, classnames(args));
      };

      var content = {
        css: css,
        cx: cx,
        theme: react.exports.useContext(ThemeContext$1)
      };
      var ele = props.children(content);
      hasRendered = true;
      return /*#__PURE__*/react.exports.createElement(react.exports.Fragment, null, /*#__PURE__*/react.exports.createElement(Insertion, {
        cache: cache,
        serializedArr: serializedArr
      }), ele);
    });

    if (process.env.NODE_ENV !== 'production') {
      ClassNames.displayName = 'EmotionClassNames';
    }

    if (process.env.NODE_ENV !== 'production') {
      var isBrowser$1 = typeof document !== 'undefined'; // #1727 for some reason Jest evaluates modules twice if some consuming module gets mocked with jest.mock

      var isJest = typeof jest !== 'undefined';

      if (isBrowser$1 && !isJest) {
        // globalThis has wide browser support - https://caniuse.com/?search=globalThis, Node.js 12 and later
        var globalContext = // $FlowIgnore
        typeof globalThis !== 'undefined' ? globalThis // eslint-disable-line no-undef
        : isBrowser$1 ? window : global;
        var globalKey = "__EMOTION_REACT_" + pkg.version.split('.')[0] + "__";

        if (globalContext[globalKey]) {
          console.warn('You are loading @emotion/react when it is already loaded. Running ' + 'multiple instances may cause problems. This can happen if multiple ' + 'versions are used, or if multiple builds of the same version are ' + 'used.');
        }

        globalContext[globalKey] = true;
      }
    }

    var testOmitPropsOnStringTag = isPropValid;

    var testOmitPropsOnComponent = function testOmitPropsOnComponent(key) {
      return key !== 'theme';
    };

    var getDefaultShouldForwardProp = function getDefaultShouldForwardProp(tag) {
      return typeof tag === 'string' && // 96 is one less than the char code
      // for "a" so this is checking that
      // it's a lowercase character
      tag.charCodeAt(0) > 96 ? testOmitPropsOnStringTag : testOmitPropsOnComponent;
    };
    var composeShouldForwardProps = function composeShouldForwardProps(tag, options, isReal) {
      var shouldForwardProp;

      if (options) {
        var optionsShouldForwardProp = options.shouldForwardProp;
        shouldForwardProp = tag.__emotion_forwardProp && optionsShouldForwardProp ? function (propName) {
          return tag.__emotion_forwardProp(propName) && optionsShouldForwardProp(propName);
        } : optionsShouldForwardProp;
      }

      if (typeof shouldForwardProp !== 'function' && isReal) {
        shouldForwardProp = tag.__emotion_forwardProp;
      }

      return shouldForwardProp;
    };

    var ILLEGAL_ESCAPE_SEQUENCE_ERROR = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";
    var isBrowser = typeof document !== 'undefined';

    var createStyled$1 = function createStyled(tag, options) {
      if (process.env.NODE_ENV !== 'production') {
        if (tag === undefined) {
          throw new Error('You are trying to create a styled element with an undefined component.\nYou may have forgotten to import it.');
        }
      }

      var isReal = tag.__emotion_real === tag;
      var baseTag = isReal && tag.__emotion_base || tag;
      var identifierName;
      var targetClassName;

      if (options !== undefined) {
        identifierName = options.label;
        targetClassName = options.target;
      }

      var shouldForwardProp = composeShouldForwardProps(tag, options, isReal);
      var defaultShouldForwardProp = shouldForwardProp || getDefaultShouldForwardProp(baseTag);
      var shouldUseAs = !defaultShouldForwardProp('as');
      return function () {
        var args = arguments;
        var styles = isReal && tag.__emotion_styles !== undefined ? tag.__emotion_styles.slice(0) : [];

        if (identifierName !== undefined) {
          styles.push("label:" + identifierName + ";");
        }

        if (args[0] == null || args[0].raw === undefined) {
          styles.push.apply(styles, args);
        } else {
          if (process.env.NODE_ENV !== 'production' && args[0][0] === undefined) {
            console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
          }

          styles.push(args[0][0]);
          var len = args.length;
          var i = 1;

          for (; i < len; i++) {
            if (process.env.NODE_ENV !== 'production' && args[0][i] === undefined) {
              console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
            }

            styles.push(args[i], args[0][i]);
          }
        } // $FlowFixMe: we need to cast StatelessFunctionalComponent to our PrivateStyledComponent class


        var Styled = withEmotionCache(function (props, cache, ref) {
          var finalTag = shouldUseAs && props.as || baseTag;
          var className = '';
          var classInterpolations = [];
          var mergedProps = props;

          if (props.theme == null) {
            mergedProps = {};

            for (var key in props) {
              mergedProps[key] = props[key];
            }

            mergedProps.theme = react.exports.useContext(ThemeContext$1);
          }

          if (typeof props.className === 'string') {
            className = getRegisteredStyles(cache.registered, classInterpolations, props.className);
          } else if (props.className != null) {
            className = props.className + " ";
          }

          var serialized = serializeStyles(styles.concat(classInterpolations), cache.registered, mergedProps);
          var rules = insertStyles(cache, serialized, typeof finalTag === 'string');
          className += cache.key + "-" + serialized.name;

          if (targetClassName !== undefined) {
            className += " " + targetClassName;
          }

          var finalShouldForwardProp = shouldUseAs && shouldForwardProp === undefined ? getDefaultShouldForwardProp(finalTag) : defaultShouldForwardProp;
          var newProps = {};

          for (var _key in props) {
            if (shouldUseAs && _key === 'as') continue;

            if ( // $FlowFixMe
            finalShouldForwardProp(_key)) {
              newProps[_key] = props[_key];
            }
          }

          newProps.className = className;
          newProps.ref = ref;
          var ele = /*#__PURE__*/react.exports.createElement(finalTag, newProps);

          if (!isBrowser && rules !== undefined) {
            var _ref;

            var serializedNames = serialized.name;
            var next = serialized.next;

            while (next !== undefined) {
              serializedNames += ' ' + next.name;
              next = next.next;
            }

            return /*#__PURE__*/react.exports.createElement(react.exports.Fragment, null, /*#__PURE__*/react.exports.createElement("style", (_ref = {}, _ref["data-emotion"] = cache.key + " " + serializedNames, _ref.dangerouslySetInnerHTML = {
              __html: rules
            }, _ref.nonce = cache.sheet.nonce, _ref)), ele);
          }

          return ele;
        });
        Styled.displayName = identifierName !== undefined ? identifierName : "Styled(" + (typeof baseTag === 'string' ? baseTag : baseTag.displayName || baseTag.name || 'Component') + ")";
        Styled.defaultProps = tag.defaultProps;
        Styled.__emotion_real = Styled;
        Styled.__emotion_base = baseTag;
        Styled.__emotion_styles = styles;
        Styled.__emotion_forwardProp = shouldForwardProp;
        Object.defineProperty(Styled, 'toString', {
          value: function value() {
            if (targetClassName === undefined && process.env.NODE_ENV !== 'production') {
              return 'NO_COMPONENT_SELECTOR';
            } // $FlowFixMe: coerce undefined to string


            return "." + targetClassName;
          }
        });

        Styled.withComponent = function (nextTag, nextOptions) {
          return createStyled(nextTag, _extends$1({}, options, nextOptions, {
            shouldForwardProp: composeShouldForwardProps(Styled, nextOptions, true)
          })).apply(void 0, styles);
        };

        return Styled;
      };
    };

    var tags = ['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio', 'b', 'base', 'bdi', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'cite', 'code', 'col', 'colgroup', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hgroup', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'marquee', 'menu', 'menuitem', 'meta', 'meter', 'nav', 'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track', 'u', 'ul', 'var', 'video', 'wbr', // SVG
    'circle', 'clipPath', 'defs', 'ellipse', 'foreignObject', 'g', 'image', 'line', 'linearGradient', 'mask', 'path', 'pattern', 'polygon', 'polyline', 'radialGradient', 'rect', 'stop', 'svg', 'text', 'tspan'];

    var newStyled = createStyled$1.bind();
    tags.forEach(function (tagName) {
      // $FlowFixMe: we can ignore this because its exposed type is defined by the CreateStyled type
      newStyled[tagName] = newStyled(tagName);
    });

    var emStyled = newStyled;

    var propTypes = {exports: {}};

    var reactIs$1 = {exports: {}};

    var reactIs_production_min$1 = {};

    /** @license React v16.13.1
     * react-is.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_production_min$1;

    function requireReactIs_production_min$1 () {
    	if (hasRequiredReactIs_production_min$1) return reactIs_production_min$1;
    	hasRequiredReactIs_production_min$1 = 1;
    var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
    	Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
    	function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}reactIs_production_min$1.AsyncMode=l;reactIs_production_min$1.ConcurrentMode=m;reactIs_production_min$1.ContextConsumer=k;reactIs_production_min$1.ContextProvider=h;reactIs_production_min$1.Element=c;reactIs_production_min$1.ForwardRef=n;reactIs_production_min$1.Fragment=e;reactIs_production_min$1.Lazy=t;reactIs_production_min$1.Memo=r;reactIs_production_min$1.Portal=d;
    	reactIs_production_min$1.Profiler=g;reactIs_production_min$1.StrictMode=f;reactIs_production_min$1.Suspense=p;reactIs_production_min$1.isAsyncMode=function(a){return A(a)||z(a)===l};reactIs_production_min$1.isConcurrentMode=A;reactIs_production_min$1.isContextConsumer=function(a){return z(a)===k};reactIs_production_min$1.isContextProvider=function(a){return z(a)===h};reactIs_production_min$1.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};reactIs_production_min$1.isForwardRef=function(a){return z(a)===n};reactIs_production_min$1.isFragment=function(a){return z(a)===e};reactIs_production_min$1.isLazy=function(a){return z(a)===t};
    	reactIs_production_min$1.isMemo=function(a){return z(a)===r};reactIs_production_min$1.isPortal=function(a){return z(a)===d};reactIs_production_min$1.isProfiler=function(a){return z(a)===g};reactIs_production_min$1.isStrictMode=function(a){return z(a)===f};reactIs_production_min$1.isSuspense=function(a){return z(a)===p};
    	reactIs_production_min$1.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};reactIs_production_min$1.typeOf=z;
    	return reactIs_production_min$1;
    }

    var reactIs_development$1 = {};

    /** @license React v16.13.1
     * react-is.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_development$1;

    function requireReactIs_development$1 () {
    	if (hasRequiredReactIs_development$1) return reactIs_development$1;
    	hasRequiredReactIs_development$1 = 1;



    	if (process.env.NODE_ENV !== "production") {
    	  (function() {

    	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    	// nor polyfill, then a plain number is used for performance.
    	var hasSymbol = typeof Symbol === 'function' && Symbol.for;
    	var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
    	var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
    	var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
    	var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
    	var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
    	var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
    	var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
    	// (unstable) APIs that have been removed. Can we remove the symbols?

    	var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
    	var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
    	var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
    	var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
    	var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
    	var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
    	var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
    	var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
    	var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
    	var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
    	var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

    	function isValidElementType(type) {
    	  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
    	  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
    	}

    	function typeOf(object) {
    	  if (typeof object === 'object' && object !== null) {
    	    var $$typeof = object.$$typeof;

    	    switch ($$typeof) {
    	      case REACT_ELEMENT_TYPE:
    	        var type = object.type;

    	        switch (type) {
    	          case REACT_ASYNC_MODE_TYPE:
    	          case REACT_CONCURRENT_MODE_TYPE:
    	          case REACT_FRAGMENT_TYPE:
    	          case REACT_PROFILER_TYPE:
    	          case REACT_STRICT_MODE_TYPE:
    	          case REACT_SUSPENSE_TYPE:
    	            return type;

    	          default:
    	            var $$typeofType = type && type.$$typeof;

    	            switch ($$typeofType) {
    	              case REACT_CONTEXT_TYPE:
    	              case REACT_FORWARD_REF_TYPE:
    	              case REACT_LAZY_TYPE:
    	              case REACT_MEMO_TYPE:
    	              case REACT_PROVIDER_TYPE:
    	                return $$typeofType;

    	              default:
    	                return $$typeof;
    	            }

    	        }

    	      case REACT_PORTAL_TYPE:
    	        return $$typeof;
    	    }
    	  }

    	  return undefined;
    	} // AsyncMode is deprecated along with isAsyncMode

    	var AsyncMode = REACT_ASYNC_MODE_TYPE;
    	var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
    	var ContextConsumer = REACT_CONTEXT_TYPE;
    	var ContextProvider = REACT_PROVIDER_TYPE;
    	var Element = REACT_ELEMENT_TYPE;
    	var ForwardRef = REACT_FORWARD_REF_TYPE;
    	var Fragment = REACT_FRAGMENT_TYPE;
    	var Lazy = REACT_LAZY_TYPE;
    	var Memo = REACT_MEMO_TYPE;
    	var Portal = REACT_PORTAL_TYPE;
    	var Profiler = REACT_PROFILER_TYPE;
    	var StrictMode = REACT_STRICT_MODE_TYPE;
    	var Suspense = REACT_SUSPENSE_TYPE;
    	var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

    	function isAsyncMode(object) {
    	  {
    	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
    	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

    	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    	    }
    	  }

    	  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
    	}
    	function isConcurrentMode(object) {
    	  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
    	}
    	function isContextConsumer(object) {
    	  return typeOf(object) === REACT_CONTEXT_TYPE;
    	}
    	function isContextProvider(object) {
    	  return typeOf(object) === REACT_PROVIDER_TYPE;
    	}
    	function isElement(object) {
    	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    	}
    	function isForwardRef(object) {
    	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
    	}
    	function isFragment(object) {
    	  return typeOf(object) === REACT_FRAGMENT_TYPE;
    	}
    	function isLazy(object) {
    	  return typeOf(object) === REACT_LAZY_TYPE;
    	}
    	function isMemo(object) {
    	  return typeOf(object) === REACT_MEMO_TYPE;
    	}
    	function isPortal(object) {
    	  return typeOf(object) === REACT_PORTAL_TYPE;
    	}
    	function isProfiler(object) {
    	  return typeOf(object) === REACT_PROFILER_TYPE;
    	}
    	function isStrictMode(object) {
    	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
    	}
    	function isSuspense(object) {
    	  return typeOf(object) === REACT_SUSPENSE_TYPE;
    	}

    	reactIs_development$1.AsyncMode = AsyncMode;
    	reactIs_development$1.ConcurrentMode = ConcurrentMode;
    	reactIs_development$1.ContextConsumer = ContextConsumer;
    	reactIs_development$1.ContextProvider = ContextProvider;
    	reactIs_development$1.Element = Element;
    	reactIs_development$1.ForwardRef = ForwardRef;
    	reactIs_development$1.Fragment = Fragment;
    	reactIs_development$1.Lazy = Lazy;
    	reactIs_development$1.Memo = Memo;
    	reactIs_development$1.Portal = Portal;
    	reactIs_development$1.Profiler = Profiler;
    	reactIs_development$1.StrictMode = StrictMode;
    	reactIs_development$1.Suspense = Suspense;
    	reactIs_development$1.isAsyncMode = isAsyncMode;
    	reactIs_development$1.isConcurrentMode = isConcurrentMode;
    	reactIs_development$1.isContextConsumer = isContextConsumer;
    	reactIs_development$1.isContextProvider = isContextProvider;
    	reactIs_development$1.isElement = isElement;
    	reactIs_development$1.isForwardRef = isForwardRef;
    	reactIs_development$1.isFragment = isFragment;
    	reactIs_development$1.isLazy = isLazy;
    	reactIs_development$1.isMemo = isMemo;
    	reactIs_development$1.isPortal = isPortal;
    	reactIs_development$1.isProfiler = isProfiler;
    	reactIs_development$1.isStrictMode = isStrictMode;
    	reactIs_development$1.isSuspense = isSuspense;
    	reactIs_development$1.isValidElementType = isValidElementType;
    	reactIs_development$1.typeOf = typeOf;
    	  })();
    	}
    	return reactIs_development$1;
    }

    var hasRequiredReactIs;

    function requireReactIs () {
    	if (hasRequiredReactIs) return reactIs$1.exports;
    	hasRequiredReactIs = 1;
    	(function (module) {

    		if (process.env.NODE_ENV === 'production') {
    		  module.exports = requireReactIs_production_min$1();
    		} else {
    		  module.exports = requireReactIs_development$1();
    		}
    } (reactIs$1));
    	return reactIs$1.exports;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var ReactPropTypesSecret_1;
    var hasRequiredReactPropTypesSecret;

    function requireReactPropTypesSecret () {
    	if (hasRequiredReactPropTypesSecret) return ReactPropTypesSecret_1;
    	hasRequiredReactPropTypesSecret = 1;

    	var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

    	ReactPropTypesSecret_1 = ReactPropTypesSecret;
    	return ReactPropTypesSecret_1;
    }

    var has;
    var hasRequiredHas;

    function requireHas () {
    	if (hasRequiredHas) return has;
    	hasRequiredHas = 1;
    	has = Function.call.bind(Object.prototype.hasOwnProperty);
    	return has;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var checkPropTypes_1;
    var hasRequiredCheckPropTypes;

    function requireCheckPropTypes () {
    	if (hasRequiredCheckPropTypes) return checkPropTypes_1;
    	hasRequiredCheckPropTypes = 1;

    	var printWarning = function() {};

    	if (process.env.NODE_ENV !== 'production') {
    	  var ReactPropTypesSecret = requireReactPropTypesSecret();
    	  var loggedTypeFailures = {};
    	  var has = requireHas();

    	  printWarning = function(text) {
    	    var message = 'Warning: ' + text;
    	    if (typeof console !== 'undefined') {
    	      console.error(message);
    	    }
    	    try {
    	      // --- Welcome to debugging React ---
    	      // This error was thrown as a convenience so that you can use this stack
    	      // to find the callsite that caused this warning to fire.
    	      throw new Error(message);
    	    } catch (x) { /**/ }
    	  };
    	}

    	/**
    	 * Assert that the values match with the type specs.
    	 * Error messages are memorized and will only be shown once.
    	 *
    	 * @param {object} typeSpecs Map of name to a ReactPropType
    	 * @param {object} values Runtime values that need to be type-checked
    	 * @param {string} location e.g. "prop", "context", "child context"
    	 * @param {string} componentName Name of the component for error messages.
    	 * @param {?Function} getStack Returns the component stack.
    	 * @private
    	 */
    	function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
    	  if (process.env.NODE_ENV !== 'production') {
    	    for (var typeSpecName in typeSpecs) {
    	      if (has(typeSpecs, typeSpecName)) {
    	        var error;
    	        // Prop type validation may throw. In case they do, we don't want to
    	        // fail the render phase where it didn't fail before. So we log it.
    	        // After these have been cleaned up, we'll let them throw.
    	        try {
    	          // This is intentionally an invariant that gets caught. It's the same
    	          // behavior as without this statement except with a better message.
    	          if (typeof typeSpecs[typeSpecName] !== 'function') {
    	            var err = Error(
    	              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
    	              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' +
    	              'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.'
    	            );
    	            err.name = 'Invariant Violation';
    	            throw err;
    	          }
    	          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret);
    	        } catch (ex) {
    	          error = ex;
    	        }
    	        if (error && !(error instanceof Error)) {
    	          printWarning(
    	            (componentName || 'React class') + ': type specification of ' +
    	            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
    	            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
    	            'You may have forgotten to pass an argument to the type checker ' +
    	            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
    	            'shape all require an argument).'
    	          );
    	        }
    	        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
    	          // Only monitor this failure once because there tends to be a lot of the
    	          // same error.
    	          loggedTypeFailures[error.message] = true;

    	          var stack = getStack ? getStack() : '';

    	          printWarning(
    	            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
    	          );
    	        }
    	      }
    	    }
    	  }
    	}

    	/**
    	 * Resets warning cache when testing.
    	 *
    	 * @private
    	 */
    	checkPropTypes.resetWarningCache = function() {
    	  if (process.env.NODE_ENV !== 'production') {
    	    loggedTypeFailures = {};
    	  }
    	};

    	checkPropTypes_1 = checkPropTypes;
    	return checkPropTypes_1;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var factoryWithTypeCheckers;
    var hasRequiredFactoryWithTypeCheckers;

    function requireFactoryWithTypeCheckers () {
    	if (hasRequiredFactoryWithTypeCheckers) return factoryWithTypeCheckers;
    	hasRequiredFactoryWithTypeCheckers = 1;

    	var ReactIs = requireReactIs();
    	var assign = requireObjectAssign();

    	var ReactPropTypesSecret = requireReactPropTypesSecret();
    	var has = requireHas();
    	var checkPropTypes = requireCheckPropTypes();

    	var printWarning = function() {};

    	if (process.env.NODE_ENV !== 'production') {
    	  printWarning = function(text) {
    	    var message = 'Warning: ' + text;
    	    if (typeof console !== 'undefined') {
    	      console.error(message);
    	    }
    	    try {
    	      // --- Welcome to debugging React ---
    	      // This error was thrown as a convenience so that you can use this stack
    	      // to find the callsite that caused this warning to fire.
    	      throw new Error(message);
    	    } catch (x) {}
    	  };
    	}

    	function emptyFunctionThatReturnsNull() {
    	  return null;
    	}

    	factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
    	  /* global Symbol */
    	  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    	  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

    	  /**
    	   * Returns the iterator method function contained on the iterable object.
    	   *
    	   * Be sure to invoke the function with the iterable as context:
    	   *
    	   *     var iteratorFn = getIteratorFn(myIterable);
    	   *     if (iteratorFn) {
    	   *       var iterator = iteratorFn.call(myIterable);
    	   *       ...
    	   *     }
    	   *
    	   * @param {?object} maybeIterable
    	   * @return {?function}
    	   */
    	  function getIteratorFn(maybeIterable) {
    	    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    	    if (typeof iteratorFn === 'function') {
    	      return iteratorFn;
    	    }
    	  }

    	  /**
    	   * Collection of methods that allow declaration and validation of props that are
    	   * supplied to React components. Example usage:
    	   *
    	   *   var Props = require('ReactPropTypes');
    	   *   var MyArticle = React.createClass({
    	   *     propTypes: {
    	   *       // An optional string prop named "description".
    	   *       description: Props.string,
    	   *
    	   *       // A required enum prop named "category".
    	   *       category: Props.oneOf(['News','Photos']).isRequired,
    	   *
    	   *       // A prop named "dialog" that requires an instance of Dialog.
    	   *       dialog: Props.instanceOf(Dialog).isRequired
    	   *     },
    	   *     render: function() { ... }
    	   *   });
    	   *
    	   * A more formal specification of how these methods are used:
    	   *
    	   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
    	   *   decl := ReactPropTypes.{type}(.isRequired)?
    	   *
    	   * Each and every declaration produces a function with the same signature. This
    	   * allows the creation of custom validation functions. For example:
    	   *
    	   *  var MyLink = React.createClass({
    	   *    propTypes: {
    	   *      // An optional string or URI prop named "href".
    	   *      href: function(props, propName, componentName) {
    	   *        var propValue = props[propName];
    	   *        if (propValue != null && typeof propValue !== 'string' &&
    	   *            !(propValue instanceof URI)) {
    	   *          return new Error(
    	   *            'Expected a string or an URI for ' + propName + ' in ' +
    	   *            componentName
    	   *          );
    	   *        }
    	   *      }
    	   *    },
    	   *    render: function() {...}
    	   *  });
    	   *
    	   * @internal
    	   */

    	  var ANONYMOUS = '<<anonymous>>';

    	  // Important!
    	  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
    	  var ReactPropTypes = {
    	    array: createPrimitiveTypeChecker('array'),
    	    bigint: createPrimitiveTypeChecker('bigint'),
    	    bool: createPrimitiveTypeChecker('boolean'),
    	    func: createPrimitiveTypeChecker('function'),
    	    number: createPrimitiveTypeChecker('number'),
    	    object: createPrimitiveTypeChecker('object'),
    	    string: createPrimitiveTypeChecker('string'),
    	    symbol: createPrimitiveTypeChecker('symbol'),

    	    any: createAnyTypeChecker(),
    	    arrayOf: createArrayOfTypeChecker,
    	    element: createElementTypeChecker(),
    	    elementType: createElementTypeTypeChecker(),
    	    instanceOf: createInstanceTypeChecker,
    	    node: createNodeChecker(),
    	    objectOf: createObjectOfTypeChecker,
    	    oneOf: createEnumTypeChecker,
    	    oneOfType: createUnionTypeChecker,
    	    shape: createShapeTypeChecker,
    	    exact: createStrictShapeTypeChecker,
    	  };

    	  /**
    	   * inlined Object.is polyfill to avoid requiring consumers ship their own
    	   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    	   */
    	  /*eslint-disable no-self-compare*/
    	  function is(x, y) {
    	    // SameValue algorithm
    	    if (x === y) {
    	      // Steps 1-5, 7-10
    	      // Steps 6.b-6.e: +0 != -0
    	      return x !== 0 || 1 / x === 1 / y;
    	    } else {
    	      // Step 6.a: NaN == NaN
    	      return x !== x && y !== y;
    	    }
    	  }
    	  /*eslint-enable no-self-compare*/

    	  /**
    	   * We use an Error-like object for backward compatibility as people may call
    	   * PropTypes directly and inspect their output. However, we don't use real
    	   * Errors anymore. We don't inspect their stack anyway, and creating them
    	   * is prohibitively expensive if they are created too often, such as what
    	   * happens in oneOfType() for any type before the one that matched.
    	   */
    	  function PropTypeError(message, data) {
    	    this.message = message;
    	    this.data = data && typeof data === 'object' ? data: {};
    	    this.stack = '';
    	  }
    	  // Make `instanceof Error` still work for returned errors.
    	  PropTypeError.prototype = Error.prototype;

    	  function createChainableTypeChecker(validate) {
    	    if (process.env.NODE_ENV !== 'production') {
    	      var manualPropTypeCallCache = {};
    	      var manualPropTypeWarningCount = 0;
    	    }
    	    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
    	      componentName = componentName || ANONYMOUS;
    	      propFullName = propFullName || propName;

    	      if (secret !== ReactPropTypesSecret) {
    	        if (throwOnDirectAccess) {
    	          // New behavior only for users of `prop-types` package
    	          var err = new Error(
    	            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
    	            'Use `PropTypes.checkPropTypes()` to call them. ' +
    	            'Read more at http://fb.me/use-check-prop-types'
    	          );
    	          err.name = 'Invariant Violation';
    	          throw err;
    	        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
    	          // Old behavior for people using React.PropTypes
    	          var cacheKey = componentName + ':' + propName;
    	          if (
    	            !manualPropTypeCallCache[cacheKey] &&
    	            // Avoid spamming the console because they are often not actionable except for lib authors
    	            manualPropTypeWarningCount < 3
    	          ) {
    	            printWarning(
    	              'You are manually calling a React.PropTypes validation ' +
    	              'function for the `' + propFullName + '` prop on `' + componentName + '`. This is deprecated ' +
    	              'and will throw in the standalone `prop-types` package. ' +
    	              'You may be seeing this warning due to a third-party PropTypes ' +
    	              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
    	            );
    	            manualPropTypeCallCache[cacheKey] = true;
    	            manualPropTypeWarningCount++;
    	          }
    	        }
    	      }
    	      if (props[propName] == null) {
    	        if (isRequired) {
    	          if (props[propName] === null) {
    	            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
    	          }
    	          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
    	        }
    	        return null;
    	      } else {
    	        return validate(props, propName, componentName, location, propFullName);
    	      }
    	    }

    	    var chainedCheckType = checkType.bind(null, false);
    	    chainedCheckType.isRequired = checkType.bind(null, true);

    	    return chainedCheckType;
    	  }

    	  function createPrimitiveTypeChecker(expectedType) {
    	    function validate(props, propName, componentName, location, propFullName, secret) {
    	      var propValue = props[propName];
    	      var propType = getPropType(propValue);
    	      if (propType !== expectedType) {
    	        // `propValue` being instance of, say, date/regexp, pass the 'object'
    	        // check, but we can offer a more precise error message here rather than
    	        // 'of type `object`'.
    	        var preciseType = getPreciseType(propValue);

    	        return new PropTypeError(
    	          'Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'),
    	          {expectedType: expectedType}
    	        );
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createAnyTypeChecker() {
    	    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
    	  }

    	  function createArrayOfTypeChecker(typeChecker) {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      if (typeof typeChecker !== 'function') {
    	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
    	      }
    	      var propValue = props[propName];
    	      if (!Array.isArray(propValue)) {
    	        var propType = getPropType(propValue);
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
    	      }
    	      for (var i = 0; i < propValue.length; i++) {
    	        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret);
    	        if (error instanceof Error) {
    	          return error;
    	        }
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createElementTypeChecker() {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      var propValue = props[propName];
    	      if (!isValidElement(propValue)) {
    	        var propType = getPropType(propValue);
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createElementTypeTypeChecker() {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      var propValue = props[propName];
    	      if (!ReactIs.isValidElementType(propValue)) {
    	        var propType = getPropType(propValue);
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createInstanceTypeChecker(expectedClass) {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      if (!(props[propName] instanceof expectedClass)) {
    	        var expectedClassName = expectedClass.name || ANONYMOUS;
    	        var actualClassName = getClassName(props[propName]);
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createEnumTypeChecker(expectedValues) {
    	    if (!Array.isArray(expectedValues)) {
    	      if (process.env.NODE_ENV !== 'production') {
    	        if (arguments.length > 1) {
    	          printWarning(
    	            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
    	            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
    	          );
    	        } else {
    	          printWarning('Invalid argument supplied to oneOf, expected an array.');
    	        }
    	      }
    	      return emptyFunctionThatReturnsNull;
    	    }

    	    function validate(props, propName, componentName, location, propFullName) {
    	      var propValue = props[propName];
    	      for (var i = 0; i < expectedValues.length; i++) {
    	        if (is(propValue, expectedValues[i])) {
    	          return null;
    	        }
    	      }

    	      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
    	        var type = getPreciseType(value);
    	        if (type === 'symbol') {
    	          return String(value);
    	        }
    	        return value;
    	      });
    	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createObjectOfTypeChecker(typeChecker) {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      if (typeof typeChecker !== 'function') {
    	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
    	      }
    	      var propValue = props[propName];
    	      var propType = getPropType(propValue);
    	      if (propType !== 'object') {
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
    	      }
    	      for (var key in propValue) {
    	        if (has(propValue, key)) {
    	          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
    	          if (error instanceof Error) {
    	            return error;
    	          }
    	        }
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createUnionTypeChecker(arrayOfTypeCheckers) {
    	    if (!Array.isArray(arrayOfTypeCheckers)) {
    	      process.env.NODE_ENV !== 'production' ? printWarning('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
    	      return emptyFunctionThatReturnsNull;
    	    }

    	    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
    	      var checker = arrayOfTypeCheckers[i];
    	      if (typeof checker !== 'function') {
    	        printWarning(
    	          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
    	          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
    	        );
    	        return emptyFunctionThatReturnsNull;
    	      }
    	    }

    	    function validate(props, propName, componentName, location, propFullName) {
    	      var expectedTypes = [];
    	      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
    	        var checker = arrayOfTypeCheckers[i];
    	        var checkerResult = checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret);
    	        if (checkerResult == null) {
    	          return null;
    	        }
    	        if (checkerResult.data && has(checkerResult.data, 'expectedType')) {
    	          expectedTypes.push(checkerResult.data.expectedType);
    	        }
    	      }
    	      var expectedTypesMessage = (expectedTypes.length > 0) ? ', expected one of type [' + expectedTypes.join(', ') + ']': '';
    	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`' + expectedTypesMessage + '.'));
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createNodeChecker() {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      if (!isNode(props[propName])) {
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function invalidValidatorError(componentName, location, propFullName, key, type) {
    	    return new PropTypeError(
    	      (componentName || 'React class') + ': ' + location + ' type `' + propFullName + '.' + key + '` is invalid; ' +
    	      'it must be a function, usually from the `prop-types` package, but received `' + type + '`.'
    	    );
    	  }

    	  function createShapeTypeChecker(shapeTypes) {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      var propValue = props[propName];
    	      var propType = getPropType(propValue);
    	      if (propType !== 'object') {
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
    	      }
    	      for (var key in shapeTypes) {
    	        var checker = shapeTypes[key];
    	        if (typeof checker !== 'function') {
    	          return invalidValidatorError(componentName, location, propFullName, key, getPreciseType(checker));
    	        }
    	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
    	        if (error) {
    	          return error;
    	        }
    	      }
    	      return null;
    	    }
    	    return createChainableTypeChecker(validate);
    	  }

    	  function createStrictShapeTypeChecker(shapeTypes) {
    	    function validate(props, propName, componentName, location, propFullName) {
    	      var propValue = props[propName];
    	      var propType = getPropType(propValue);
    	      if (propType !== 'object') {
    	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
    	      }
    	      // We need to check all keys in case some are required but missing from props.
    	      var allKeys = assign({}, props[propName], shapeTypes);
    	      for (var key in allKeys) {
    	        var checker = shapeTypes[key];
    	        if (has(shapeTypes, key) && typeof checker !== 'function') {
    	          return invalidValidatorError(componentName, location, propFullName, key, getPreciseType(checker));
    	        }
    	        if (!checker) {
    	          return new PropTypeError(
    	            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
    	            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
    	            '\nValid keys: ' + JSON.stringify(Object.keys(shapeTypes), null, '  ')
    	          );
    	        }
    	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
    	        if (error) {
    	          return error;
    	        }
    	      }
    	      return null;
    	    }

    	    return createChainableTypeChecker(validate);
    	  }

    	  function isNode(propValue) {
    	    switch (typeof propValue) {
    	      case 'number':
    	      case 'string':
    	      case 'undefined':
    	        return true;
    	      case 'boolean':
    	        return !propValue;
    	      case 'object':
    	        if (Array.isArray(propValue)) {
    	          return propValue.every(isNode);
    	        }
    	        if (propValue === null || isValidElement(propValue)) {
    	          return true;
    	        }

    	        var iteratorFn = getIteratorFn(propValue);
    	        if (iteratorFn) {
    	          var iterator = iteratorFn.call(propValue);
    	          var step;
    	          if (iteratorFn !== propValue.entries) {
    	            while (!(step = iterator.next()).done) {
    	              if (!isNode(step.value)) {
    	                return false;
    	              }
    	            }
    	          } else {
    	            // Iterator will provide entry [k,v] tuples rather than values.
    	            while (!(step = iterator.next()).done) {
    	              var entry = step.value;
    	              if (entry) {
    	                if (!isNode(entry[1])) {
    	                  return false;
    	                }
    	              }
    	            }
    	          }
    	        } else {
    	          return false;
    	        }

    	        return true;
    	      default:
    	        return false;
    	    }
    	  }

    	  function isSymbol(propType, propValue) {
    	    // Native Symbol.
    	    if (propType === 'symbol') {
    	      return true;
    	    }

    	    // falsy value can't be a Symbol
    	    if (!propValue) {
    	      return false;
    	    }

    	    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    	    if (propValue['@@toStringTag'] === 'Symbol') {
    	      return true;
    	    }

    	    // Fallback for non-spec compliant Symbols which are polyfilled.
    	    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
    	      return true;
    	    }

    	    return false;
    	  }

    	  // Equivalent of `typeof` but with special handling for array and regexp.
    	  function getPropType(propValue) {
    	    var propType = typeof propValue;
    	    if (Array.isArray(propValue)) {
    	      return 'array';
    	    }
    	    if (propValue instanceof RegExp) {
    	      // Old webkits (at least until Android 4.0) return 'function' rather than
    	      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
    	      // passes PropTypes.object.
    	      return 'object';
    	    }
    	    if (isSymbol(propType, propValue)) {
    	      return 'symbol';
    	    }
    	    return propType;
    	  }

    	  // This handles more types than `getPropType`. Only used for error messages.
    	  // See `createPrimitiveTypeChecker`.
    	  function getPreciseType(propValue) {
    	    if (typeof propValue === 'undefined' || propValue === null) {
    	      return '' + propValue;
    	    }
    	    var propType = getPropType(propValue);
    	    if (propType === 'object') {
    	      if (propValue instanceof Date) {
    	        return 'date';
    	      } else if (propValue instanceof RegExp) {
    	        return 'regexp';
    	      }
    	    }
    	    return propType;
    	  }

    	  // Returns a string that is postfixed to a warning about an invalid type.
    	  // For example, "undefined" or "of type array"
    	  function getPostfixForTypeWarning(value) {
    	    var type = getPreciseType(value);
    	    switch (type) {
    	      case 'array':
    	      case 'object':
    	        return 'an ' + type;
    	      case 'boolean':
    	      case 'date':
    	      case 'regexp':
    	        return 'a ' + type;
    	      default:
    	        return type;
    	    }
    	  }

    	  // Returns class name of the object, if any.
    	  function getClassName(propValue) {
    	    if (!propValue.constructor || !propValue.constructor.name) {
    	      return ANONYMOUS;
    	    }
    	    return propValue.constructor.name;
    	  }

    	  ReactPropTypes.checkPropTypes = checkPropTypes;
    	  ReactPropTypes.resetWarningCache = checkPropTypes.resetWarningCache;
    	  ReactPropTypes.PropTypes = ReactPropTypes;

    	  return ReactPropTypes;
    	};
    	return factoryWithTypeCheckers;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var factoryWithThrowingShims;
    var hasRequiredFactoryWithThrowingShims;

    function requireFactoryWithThrowingShims () {
    	if (hasRequiredFactoryWithThrowingShims) return factoryWithThrowingShims;
    	hasRequiredFactoryWithThrowingShims = 1;

    	var ReactPropTypesSecret = requireReactPropTypesSecret();

    	function emptyFunction() {}
    	function emptyFunctionWithReset() {}
    	emptyFunctionWithReset.resetWarningCache = emptyFunction;

    	factoryWithThrowingShims = function() {
    	  function shim(props, propName, componentName, location, propFullName, secret) {
    	    if (secret === ReactPropTypesSecret) {
    	      // It is still safe when called from React.
    	      return;
    	    }
    	    var err = new Error(
    	      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
    	      'Use PropTypes.checkPropTypes() to call them. ' +
    	      'Read more at http://fb.me/use-check-prop-types'
    	    );
    	    err.name = 'Invariant Violation';
    	    throw err;
    	  }	  shim.isRequired = shim;
    	  function getShim() {
    	    return shim;
    	  }	  // Important!
    	  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
    	  var ReactPropTypes = {
    	    array: shim,
    	    bigint: shim,
    	    bool: shim,
    	    func: shim,
    	    number: shim,
    	    object: shim,
    	    string: shim,
    	    symbol: shim,

    	    any: shim,
    	    arrayOf: getShim,
    	    element: shim,
    	    elementType: shim,
    	    instanceOf: getShim,
    	    node: shim,
    	    objectOf: getShim,
    	    oneOf: getShim,
    	    oneOfType: getShim,
    	    shape: getShim,
    	    exact: getShim,

    	    checkPropTypes: emptyFunctionWithReset,
    	    resetWarningCache: emptyFunction
    	  };

    	  ReactPropTypes.PropTypes = ReactPropTypes;

    	  return ReactPropTypes;
    	};
    	return factoryWithThrowingShims;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    if (process.env.NODE_ENV !== 'production') {
      var ReactIs = requireReactIs();

      // By explicitly using `prop-types` you are opting into new development behavior.
      // http://fb.me/prop-types-in-prod
      var throwOnDirectAccess = true;
      propTypes.exports = requireFactoryWithTypeCheckers()(ReactIs.isElement, throwOnDirectAccess);
    } else {
      // By explicitly using `prop-types` you are opting into new production behavior.
      // http://fb.me/prop-types-in-prod
      propTypes.exports = requireFactoryWithThrowingShims()();
    }

    var jsxRuntime = {exports: {}};

    var reactJsxRuntime_production_min = {};

    /** @license React v17.0.2
     * react-jsx-runtime.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactJsxRuntime_production_min;

    function requireReactJsxRuntime_production_min () {
    	if (hasRequiredReactJsxRuntime_production_min) return reactJsxRuntime_production_min;
    	hasRequiredReactJsxRuntime_production_min = 1;
    requireObjectAssign();var f=react.exports,g=60103;reactJsxRuntime_production_min.Fragment=60107;if("function"===typeof Symbol&&Symbol.for){var h=Symbol.for;g=h("react.element");reactJsxRuntime_production_min.Fragment=h("react.fragment");}var m=f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,n=Object.prototype.hasOwnProperty,p={key:!0,ref:!0,__self:!0,__source:!0};
    	function q(c,a,k){var b,d={},e=null,l=null;void 0!==k&&(e=""+k);void 0!==a.key&&(e=""+a.key);void 0!==a.ref&&(l=a.ref);for(b in a)n.call(a,b)&&!p.hasOwnProperty(b)&&(d[b]=a[b]);if(c&&c.defaultProps)for(b in a=c.defaultProps,a)void 0===d[b]&&(d[b]=a[b]);return {$$typeof:g,type:c,key:e,ref:l,props:d,_owner:m.current}}reactJsxRuntime_production_min.jsx=q;reactJsxRuntime_production_min.jsxs=q;
    	return reactJsxRuntime_production_min;
    }

    var reactJsxRuntime_development = {};

    /** @license React v17.0.2
     * react-jsx-runtime.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactJsxRuntime_development;

    function requireReactJsxRuntime_development () {
    	if (hasRequiredReactJsxRuntime_development) return reactJsxRuntime_development;
    	hasRequiredReactJsxRuntime_development = 1;
    	(function (exports) {

    		if (process.env.NODE_ENV !== "production") {
    		  (function() {

    		var React = react.exports;
    		var _assign = requireObjectAssign();

    		// ATTENTION
    		// When adding new symbols to this file,
    		// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
    		// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    		// nor polyfill, then a plain number is used for performance.
    		var REACT_ELEMENT_TYPE = 0xeac7;
    		var REACT_PORTAL_TYPE = 0xeaca;
    		exports.Fragment = 0xeacb;
    		var REACT_STRICT_MODE_TYPE = 0xeacc;
    		var REACT_PROFILER_TYPE = 0xead2;
    		var REACT_PROVIDER_TYPE = 0xeacd;
    		var REACT_CONTEXT_TYPE = 0xeace;
    		var REACT_FORWARD_REF_TYPE = 0xead0;
    		var REACT_SUSPENSE_TYPE = 0xead1;
    		var REACT_SUSPENSE_LIST_TYPE = 0xead8;
    		var REACT_MEMO_TYPE = 0xead3;
    		var REACT_LAZY_TYPE = 0xead4;
    		var REACT_BLOCK_TYPE = 0xead9;
    		var REACT_SERVER_BLOCK_TYPE = 0xeada;
    		var REACT_FUNDAMENTAL_TYPE = 0xead5;
    		var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
    		var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

    		if (typeof Symbol === 'function' && Symbol.for) {
    		  var symbolFor = Symbol.for;
    		  REACT_ELEMENT_TYPE = symbolFor('react.element');
    		  REACT_PORTAL_TYPE = symbolFor('react.portal');
    		  exports.Fragment = symbolFor('react.fragment');
    		  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
    		  REACT_PROFILER_TYPE = symbolFor('react.profiler');
    		  REACT_PROVIDER_TYPE = symbolFor('react.provider');
    		  REACT_CONTEXT_TYPE = symbolFor('react.context');
    		  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
    		  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
    		  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
    		  REACT_MEMO_TYPE = symbolFor('react.memo');
    		  REACT_LAZY_TYPE = symbolFor('react.lazy');
    		  REACT_BLOCK_TYPE = symbolFor('react.block');
    		  REACT_SERVER_BLOCK_TYPE = symbolFor('react.server.block');
    		  REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
    		  symbolFor('react.scope');
    		  symbolFor('react.opaque.id');
    		  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
    		  symbolFor('react.offscreen');
    		  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
    		}

    		var MAYBE_ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    		var FAUX_ITERATOR_SYMBOL = '@@iterator';
    		function getIteratorFn(maybeIterable) {
    		  if (maybeIterable === null || typeof maybeIterable !== 'object') {
    		    return null;
    		  }

    		  var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];

    		  if (typeof maybeIterator === 'function') {
    		    return maybeIterator;
    		  }

    		  return null;
    		}

    		var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;

    		function error(format) {
    		  {
    		    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    		      args[_key2 - 1] = arguments[_key2];
    		    }

    		    printWarning('error', format, args);
    		  }
    		}

    		function printWarning(level, format, args) {
    		  // When changing this logic, you might want to also
    		  // update consoleWithStackDev.www.js as well.
    		  {
    		    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
    		    var stack = ReactDebugCurrentFrame.getStackAddendum();

    		    if (stack !== '') {
    		      format += '%s';
    		      args = args.concat([stack]);
    		    }

    		    var argsWithFormat = args.map(function (item) {
    		      return '' + item;
    		    }); // Careful: RN currently depends on this prefix

    		    argsWithFormat.unshift('Warning: ' + format); // We intentionally don't use spread (or .apply) directly because it
    		    // breaks IE9: https://github.com/facebook/react/issues/13610
    		    // eslint-disable-next-line react-internal/no-production-logging

    		    Function.prototype.apply.call(console[level], console, argsWithFormat);
    		  }
    		}

    		// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

    		var enableScopeAPI = false; // Experimental Create Event Handle API.

    		function isValidElementType(type) {
    		  if (typeof type === 'string' || typeof type === 'function') {
    		    return true;
    		  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


    		  if (type === exports.Fragment || type === REACT_PROFILER_TYPE || type === REACT_DEBUG_TRACING_MODE_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI ) {
    		    return true;
    		  }

    		  if (typeof type === 'object' && type !== null) {
    		    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE) {
    		      return true;
    		    }
    		  }

    		  return false;
    		}

    		function getWrappedName(outerType, innerType, wrapperName) {
    		  var functionName = innerType.displayName || innerType.name || '';
    		  return outerType.displayName || (functionName !== '' ? wrapperName + "(" + functionName + ")" : wrapperName);
    		}

    		function getContextName(type) {
    		  return type.displayName || 'Context';
    		}

    		function getComponentName(type) {
    		  if (type == null) {
    		    // Host root, text node or just invalid type.
    		    return null;
    		  }

    		  {
    		    if (typeof type.tag === 'number') {
    		      error('Received an unexpected object in getComponentName(). ' + 'This is likely a bug in React. Please file an issue.');
    		    }
    		  }

    		  if (typeof type === 'function') {
    		    return type.displayName || type.name || null;
    		  }

    		  if (typeof type === 'string') {
    		    return type;
    		  }

    		  switch (type) {
    		    case exports.Fragment:
    		      return 'Fragment';

    		    case REACT_PORTAL_TYPE:
    		      return 'Portal';

    		    case REACT_PROFILER_TYPE:
    		      return 'Profiler';

    		    case REACT_STRICT_MODE_TYPE:
    		      return 'StrictMode';

    		    case REACT_SUSPENSE_TYPE:
    		      return 'Suspense';

    		    case REACT_SUSPENSE_LIST_TYPE:
    		      return 'SuspenseList';
    		  }

    		  if (typeof type === 'object') {
    		    switch (type.$$typeof) {
    		      case REACT_CONTEXT_TYPE:
    		        var context = type;
    		        return getContextName(context) + '.Consumer';

    		      case REACT_PROVIDER_TYPE:
    		        var provider = type;
    		        return getContextName(provider._context) + '.Provider';

    		      case REACT_FORWARD_REF_TYPE:
    		        return getWrappedName(type, type.render, 'ForwardRef');

    		      case REACT_MEMO_TYPE:
    		        return getComponentName(type.type);

    		      case REACT_BLOCK_TYPE:
    		        return getComponentName(type._render);

    		      case REACT_LAZY_TYPE:
    		        {
    		          var lazyComponent = type;
    		          var payload = lazyComponent._payload;
    		          var init = lazyComponent._init;

    		          try {
    		            return getComponentName(init(payload));
    		          } catch (x) {
    		            return null;
    		          }
    		        }
    		    }
    		  }

    		  return null;
    		}

    		// Helpers to patch console.logs to avoid logging during side-effect free
    		// replaying on render function. This currently only patches the object
    		// lazily which won't cover if the log function was extracted eagerly.
    		// We could also eagerly patch the method.
    		var disabledDepth = 0;
    		var prevLog;
    		var prevInfo;
    		var prevWarn;
    		var prevError;
    		var prevGroup;
    		var prevGroupCollapsed;
    		var prevGroupEnd;

    		function disabledLog() {}

    		disabledLog.__reactDisabledLog = true;
    		function disableLogs() {
    		  {
    		    if (disabledDepth === 0) {
    		      /* eslint-disable react-internal/no-production-logging */
    		      prevLog = console.log;
    		      prevInfo = console.info;
    		      prevWarn = console.warn;
    		      prevError = console.error;
    		      prevGroup = console.group;
    		      prevGroupCollapsed = console.groupCollapsed;
    		      prevGroupEnd = console.groupEnd; // https://github.com/facebook/react/issues/19099

    		      var props = {
    		        configurable: true,
    		        enumerable: true,
    		        value: disabledLog,
    		        writable: true
    		      }; // $FlowFixMe Flow thinks console is immutable.

    		      Object.defineProperties(console, {
    		        info: props,
    		        log: props,
    		        warn: props,
    		        error: props,
    		        group: props,
    		        groupCollapsed: props,
    		        groupEnd: props
    		      });
    		      /* eslint-enable react-internal/no-production-logging */
    		    }

    		    disabledDepth++;
    		  }
    		}
    		function reenableLogs() {
    		  {
    		    disabledDepth--;

    		    if (disabledDepth === 0) {
    		      /* eslint-disable react-internal/no-production-logging */
    		      var props = {
    		        configurable: true,
    		        enumerable: true,
    		        writable: true
    		      }; // $FlowFixMe Flow thinks console is immutable.

    		      Object.defineProperties(console, {
    		        log: _assign({}, props, {
    		          value: prevLog
    		        }),
    		        info: _assign({}, props, {
    		          value: prevInfo
    		        }),
    		        warn: _assign({}, props, {
    		          value: prevWarn
    		        }),
    		        error: _assign({}, props, {
    		          value: prevError
    		        }),
    		        group: _assign({}, props, {
    		          value: prevGroup
    		        }),
    		        groupCollapsed: _assign({}, props, {
    		          value: prevGroupCollapsed
    		        }),
    		        groupEnd: _assign({}, props, {
    		          value: prevGroupEnd
    		        })
    		      });
    		      /* eslint-enable react-internal/no-production-logging */
    		    }

    		    if (disabledDepth < 0) {
    		      error('disabledDepth fell below zero. ' + 'This is a bug in React. Please file an issue.');
    		    }
    		  }
    		}

    		var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
    		var prefix;
    		function describeBuiltInComponentFrame(name, source, ownerFn) {
    		  {
    		    if (prefix === undefined) {
    		      // Extract the VM specific prefix used by each line.
    		      try {
    		        throw Error();
    		      } catch (x) {
    		        var match = x.stack.trim().match(/\n( *(at )?)/);
    		        prefix = match && match[1] || '';
    		      }
    		    } // We use the prefix to ensure our stacks line up with native stack frames.


    		    return '\n' + prefix + name;
    		  }
    		}
    		var reentry = false;
    		var componentFrameCache;

    		{
    		  var PossiblyWeakMap = typeof WeakMap === 'function' ? WeakMap : Map;
    		  componentFrameCache = new PossiblyWeakMap();
    		}

    		function describeNativeComponentFrame(fn, construct) {
    		  // If something asked for a stack inside a fake render, it should get ignored.
    		  if (!fn || reentry) {
    		    return '';
    		  }

    		  {
    		    var frame = componentFrameCache.get(fn);

    		    if (frame !== undefined) {
    		      return frame;
    		    }
    		  }

    		  var control;
    		  reentry = true;
    		  var previousPrepareStackTrace = Error.prepareStackTrace; // $FlowFixMe It does accept undefined.

    		  Error.prepareStackTrace = undefined;
    		  var previousDispatcher;

    		  {
    		    previousDispatcher = ReactCurrentDispatcher.current; // Set the dispatcher in DEV because this might be call in the render function
    		    // for warnings.

    		    ReactCurrentDispatcher.current = null;
    		    disableLogs();
    		  }

    		  try {
    		    // This should throw.
    		    if (construct) {
    		      // Something should be setting the props in the constructor.
    		      var Fake = function () {
    		        throw Error();
    		      }; // $FlowFixMe


    		      Object.defineProperty(Fake.prototype, 'props', {
    		        set: function () {
    		          // We use a throwing setter instead of frozen or non-writable props
    		          // because that won't throw in a non-strict mode function.
    		          throw Error();
    		        }
    		      });

    		      if (typeof Reflect === 'object' && Reflect.construct) {
    		        // We construct a different control for this case to include any extra
    		        // frames added by the construct call.
    		        try {
    		          Reflect.construct(Fake, []);
    		        } catch (x) {
    		          control = x;
    		        }

    		        Reflect.construct(fn, [], Fake);
    		      } else {
    		        try {
    		          Fake.call();
    		        } catch (x) {
    		          control = x;
    		        }

    		        fn.call(Fake.prototype);
    		      }
    		    } else {
    		      try {
    		        throw Error();
    		      } catch (x) {
    		        control = x;
    		      }

    		      fn();
    		    }
    		  } catch (sample) {
    		    // This is inlined manually because closure doesn't do it for us.
    		    if (sample && control && typeof sample.stack === 'string') {
    		      // This extracts the first frame from the sample that isn't also in the control.
    		      // Skipping one frame that we assume is the frame that calls the two.
    		      var sampleLines = sample.stack.split('\n');
    		      var controlLines = control.stack.split('\n');
    		      var s = sampleLines.length - 1;
    		      var c = controlLines.length - 1;

    		      while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
    		        // We expect at least one stack frame to be shared.
    		        // Typically this will be the root most one. However, stack frames may be
    		        // cut off due to maximum stack limits. In this case, one maybe cut off
    		        // earlier than the other. We assume that the sample is longer or the same
    		        // and there for cut off earlier. So we should find the root most frame in
    		        // the sample somewhere in the control.
    		        c--;
    		      }

    		      for (; s >= 1 && c >= 0; s--, c--) {
    		        // Next we find the first one that isn't the same which should be the
    		        // frame that called our sample function and the control.
    		        if (sampleLines[s] !== controlLines[c]) {
    		          // In V8, the first line is describing the message but other VMs don't.
    		          // If we're about to return the first line, and the control is also on the same
    		          // line, that's a pretty good indicator that our sample threw at same line as
    		          // the control. I.e. before we entered the sample frame. So we ignore this result.
    		          // This can happen if you passed a class to function component, or non-function.
    		          if (s !== 1 || c !== 1) {
    		            do {
    		              s--;
    		              c--; // We may still have similar intermediate frames from the construct call.
    		              // The next one that isn't the same should be our match though.

    		              if (c < 0 || sampleLines[s] !== controlLines[c]) {
    		                // V8 adds a "new" prefix for native classes. Let's remove it to make it prettier.
    		                var _frame = '\n' + sampleLines[s].replace(' at new ', ' at ');

    		                {
    		                  if (typeof fn === 'function') {
    		                    componentFrameCache.set(fn, _frame);
    		                  }
    		                } // Return the line we found.


    		                return _frame;
    		              }
    		            } while (s >= 1 && c >= 0);
    		          }

    		          break;
    		        }
    		      }
    		    }
    		  } finally {
    		    reentry = false;

    		    {
    		      ReactCurrentDispatcher.current = previousDispatcher;
    		      reenableLogs();
    		    }

    		    Error.prepareStackTrace = previousPrepareStackTrace;
    		  } // Fallback to just using the name if we couldn't make it throw.


    		  var name = fn ? fn.displayName || fn.name : '';
    		  var syntheticFrame = name ? describeBuiltInComponentFrame(name) : '';

    		  {
    		    if (typeof fn === 'function') {
    		      componentFrameCache.set(fn, syntheticFrame);
    		    }
    		  }

    		  return syntheticFrame;
    		}
    		function describeFunctionComponentFrame(fn, source, ownerFn) {
    		  {
    		    return describeNativeComponentFrame(fn, false);
    		  }
    		}

    		function shouldConstruct(Component) {
    		  var prototype = Component.prototype;
    		  return !!(prototype && prototype.isReactComponent);
    		}

    		function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {

    		  if (type == null) {
    		    return '';
    		  }

    		  if (typeof type === 'function') {
    		    {
    		      return describeNativeComponentFrame(type, shouldConstruct(type));
    		    }
    		  }

    		  if (typeof type === 'string') {
    		    return describeBuiltInComponentFrame(type);
    		  }

    		  switch (type) {
    		    case REACT_SUSPENSE_TYPE:
    		      return describeBuiltInComponentFrame('Suspense');

    		    case REACT_SUSPENSE_LIST_TYPE:
    		      return describeBuiltInComponentFrame('SuspenseList');
    		  }

    		  if (typeof type === 'object') {
    		    switch (type.$$typeof) {
    		      case REACT_FORWARD_REF_TYPE:
    		        return describeFunctionComponentFrame(type.render);

    		      case REACT_MEMO_TYPE:
    		        // Memo may contain any component type so we recursively resolve it.
    		        return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);

    		      case REACT_BLOCK_TYPE:
    		        return describeFunctionComponentFrame(type._render);

    		      case REACT_LAZY_TYPE:
    		        {
    		          var lazyComponent = type;
    		          var payload = lazyComponent._payload;
    		          var init = lazyComponent._init;

    		          try {
    		            // Lazy may contain any component type so we recursively resolve it.
    		            return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
    		          } catch (x) {}
    		        }
    		    }
    		  }

    		  return '';
    		}

    		var loggedTypeFailures = {};
    		var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;

    		function setCurrentlyValidatingElement(element) {
    		  {
    		    if (element) {
    		      var owner = element._owner;
    		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
    		      ReactDebugCurrentFrame.setExtraStackFrame(stack);
    		    } else {
    		      ReactDebugCurrentFrame.setExtraStackFrame(null);
    		    }
    		  }
    		}

    		function checkPropTypes(typeSpecs, values, location, componentName, element) {
    		  {
    		    // $FlowFixMe This is okay but Flow doesn't know it.
    		    var has = Function.call.bind(Object.prototype.hasOwnProperty);

    		    for (var typeSpecName in typeSpecs) {
    		      if (has(typeSpecs, typeSpecName)) {
    		        var error$1 = void 0; // Prop type validation may throw. In case they do, we don't want to
    		        // fail the render phase where it didn't fail before. So we log it.
    		        // After these have been cleaned up, we'll let them throw.

    		        try {
    		          // This is intentionally an invariant that gets caught. It's the same
    		          // behavior as without this statement except with a better message.
    		          if (typeof typeSpecs[typeSpecName] !== 'function') {
    		            var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' + 'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.');
    		            err.name = 'Invariant Violation';
    		            throw err;
    		          }

    		          error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED');
    		        } catch (ex) {
    		          error$1 = ex;
    		        }

    		        if (error$1 && !(error$1 instanceof Error)) {
    		          setCurrentlyValidatingElement(element);

    		          error('%s: type specification of %s' + ' `%s` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a %s. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).', componentName || 'React class', location, typeSpecName, typeof error$1);

    		          setCurrentlyValidatingElement(null);
    		        }

    		        if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
    		          // Only monitor this failure once because there tends to be a lot of the
    		          // same error.
    		          loggedTypeFailures[error$1.message] = true;
    		          setCurrentlyValidatingElement(element);

    		          error('Failed %s type: %s', location, error$1.message);

    		          setCurrentlyValidatingElement(null);
    		        }
    		      }
    		    }
    		  }
    		}

    		var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
    		var hasOwnProperty = Object.prototype.hasOwnProperty;
    		var RESERVED_PROPS = {
    		  key: true,
    		  ref: true,
    		  __self: true,
    		  __source: true
    		};
    		var specialPropKeyWarningShown;
    		var specialPropRefWarningShown;
    		var didWarnAboutStringRefs;

    		{
    		  didWarnAboutStringRefs = {};
    		}

    		function hasValidRef(config) {
    		  {
    		    if (hasOwnProperty.call(config, 'ref')) {
    		      var getter = Object.getOwnPropertyDescriptor(config, 'ref').get;

    		      if (getter && getter.isReactWarning) {
    		        return false;
    		      }
    		    }
    		  }

    		  return config.ref !== undefined;
    		}

    		function hasValidKey(config) {
    		  {
    		    if (hasOwnProperty.call(config, 'key')) {
    		      var getter = Object.getOwnPropertyDescriptor(config, 'key').get;

    		      if (getter && getter.isReactWarning) {
    		        return false;
    		      }
    		    }
    		  }

    		  return config.key !== undefined;
    		}

    		function warnIfStringRefCannotBeAutoConverted(config, self) {
    		  {
    		    if (typeof config.ref === 'string' && ReactCurrentOwner.current && self && ReactCurrentOwner.current.stateNode !== self) {
    		      var componentName = getComponentName(ReactCurrentOwner.current.type);

    		      if (!didWarnAboutStringRefs[componentName]) {
    		        error('Component "%s" contains the string ref "%s". ' + 'Support for string refs will be removed in a future major release. ' + 'This case cannot be automatically converted to an arrow function. ' + 'We ask you to manually fix this case by using useRef() or createRef() instead. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-string-ref', getComponentName(ReactCurrentOwner.current.type), config.ref);

    		        didWarnAboutStringRefs[componentName] = true;
    		      }
    		    }
    		  }
    		}

    		function defineKeyPropWarningGetter(props, displayName) {
    		  {
    		    var warnAboutAccessingKey = function () {
    		      if (!specialPropKeyWarningShown) {
    		        specialPropKeyWarningShown = true;

    		        error('%s: `key` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
    		      }
    		    };

    		    warnAboutAccessingKey.isReactWarning = true;
    		    Object.defineProperty(props, 'key', {
    		      get: warnAboutAccessingKey,
    		      configurable: true
    		    });
    		  }
    		}

    		function defineRefPropWarningGetter(props, displayName) {
    		  {
    		    var warnAboutAccessingRef = function () {
    		      if (!specialPropRefWarningShown) {
    		        specialPropRefWarningShown = true;

    		        error('%s: `ref` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
    		      }
    		    };

    		    warnAboutAccessingRef.isReactWarning = true;
    		    Object.defineProperty(props, 'ref', {
    		      get: warnAboutAccessingRef,
    		      configurable: true
    		    });
    		  }
    		}
    		/**
    		 * Factory method to create a new React element. This no longer adheres to
    		 * the class pattern, so do not use new to call it. Also, instanceof check
    		 * will not work. Instead test $$typeof field against Symbol.for('react.element') to check
    		 * if something is a React Element.
    		 *
    		 * @param {*} type
    		 * @param {*} props
    		 * @param {*} key
    		 * @param {string|object} ref
    		 * @param {*} owner
    		 * @param {*} self A *temporary* helper to detect places where `this` is
    		 * different from the `owner` when React.createElement is called, so that we
    		 * can warn. We want to get rid of owner and replace string `ref`s with arrow
    		 * functions, and as long as `this` and owner are the same, there will be no
    		 * change in behavior.
    		 * @param {*} source An annotation object (added by a transpiler or otherwise)
    		 * indicating filename, line number, and/or other information.
    		 * @internal
    		 */


    		var ReactElement = function (type, key, ref, self, source, owner, props) {
    		  var element = {
    		    // This tag allows us to uniquely identify this as a React Element
    		    $$typeof: REACT_ELEMENT_TYPE,
    		    // Built-in properties that belong on the element
    		    type: type,
    		    key: key,
    		    ref: ref,
    		    props: props,
    		    // Record the component responsible for creating this element.
    		    _owner: owner
    		  };

    		  {
    		    // The validation flag is currently mutative. We put it on
    		    // an external backing store so that we can freeze the whole object.
    		    // This can be replaced with a WeakMap once they are implemented in
    		    // commonly used development environments.
    		    element._store = {}; // To make comparing ReactElements easier for testing purposes, we make
    		    // the validation flag non-enumerable (where possible, which should
    		    // include every environment we run tests in), so the test framework
    		    // ignores it.

    		    Object.defineProperty(element._store, 'validated', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: true,
    		      value: false
    		    }); // self and source are DEV only properties.

    		    Object.defineProperty(element, '_self', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: false,
    		      value: self
    		    }); // Two elements created in two different places should be considered
    		    // equal for testing purposes and therefore we hide it from enumeration.

    		    Object.defineProperty(element, '_source', {
    		      configurable: false,
    		      enumerable: false,
    		      writable: false,
    		      value: source
    		    });

    		    if (Object.freeze) {
    		      Object.freeze(element.props);
    		      Object.freeze(element);
    		    }
    		  }

    		  return element;
    		};
    		/**
    		 * https://github.com/reactjs/rfcs/pull/107
    		 * @param {*} type
    		 * @param {object} props
    		 * @param {string} key
    		 */

    		function jsxDEV(type, config, maybeKey, source, self) {
    		  {
    		    var propName; // Reserved names are extracted

    		    var props = {};
    		    var key = null;
    		    var ref = null; // Currently, key can be spread in as a prop. This causes a potential
    		    // issue if key is also explicitly declared (ie. <div {...props} key="Hi" />
    		    // or <div key="Hi" {...props} /> ). We want to deprecate key spread,
    		    // but as an intermediary step, we will use jsxDEV for everything except
    		    // <div {...props} key="Hi" />, because we aren't currently able to tell if
    		    // key is explicitly declared to be undefined or not.

    		    if (maybeKey !== undefined) {
    		      key = '' + maybeKey;
    		    }

    		    if (hasValidKey(config)) {
    		      key = '' + config.key;
    		    }

    		    if (hasValidRef(config)) {
    		      ref = config.ref;
    		      warnIfStringRefCannotBeAutoConverted(config, self);
    		    } // Remaining properties are added to a new props object


    		    for (propName in config) {
    		      if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
    		        props[propName] = config[propName];
    		      }
    		    } // Resolve default props


    		    if (type && type.defaultProps) {
    		      var defaultProps = type.defaultProps;

    		      for (propName in defaultProps) {
    		        if (props[propName] === undefined) {
    		          props[propName] = defaultProps[propName];
    		        }
    		      }
    		    }

    		    if (key || ref) {
    		      var displayName = typeof type === 'function' ? type.displayName || type.name || 'Unknown' : type;

    		      if (key) {
    		        defineKeyPropWarningGetter(props, displayName);
    		      }

    		      if (ref) {
    		        defineRefPropWarningGetter(props, displayName);
    		      }
    		    }

    		    return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
    		  }
    		}

    		var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
    		var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;

    		function setCurrentlyValidatingElement$1(element) {
    		  {
    		    if (element) {
    		      var owner = element._owner;
    		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
    		      ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
    		    } else {
    		      ReactDebugCurrentFrame$1.setExtraStackFrame(null);
    		    }
    		  }
    		}

    		var propTypesMisspellWarningShown;

    		{
    		  propTypesMisspellWarningShown = false;
    		}
    		/**
    		 * Verifies the object is a ReactElement.
    		 * See https://reactjs.org/docs/react-api.html#isvalidelement
    		 * @param {?object} object
    		 * @return {boolean} True if `object` is a ReactElement.
    		 * @final
    		 */

    		function isValidElement(object) {
    		  {
    		    return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    		  }
    		}

    		function getDeclarationErrorAddendum() {
    		  {
    		    if (ReactCurrentOwner$1.current) {
    		      var name = getComponentName(ReactCurrentOwner$1.current.type);

    		      if (name) {
    		        return '\n\nCheck the render method of `' + name + '`.';
    		      }
    		    }

    		    return '';
    		  }
    		}

    		function getSourceInfoErrorAddendum(source) {
    		  {
    		    if (source !== undefined) {
    		      var fileName = source.fileName.replace(/^.*[\\\/]/, '');
    		      var lineNumber = source.lineNumber;
    		      return '\n\nCheck your code at ' + fileName + ':' + lineNumber + '.';
    		    }

    		    return '';
    		  }
    		}
    		/**
    		 * Warn if there's no key explicitly set on dynamic arrays of children or
    		 * object keys are not valid. This allows us to keep track of children between
    		 * updates.
    		 */


    		var ownerHasKeyUseWarning = {};

    		function getCurrentComponentErrorInfo(parentType) {
    		  {
    		    var info = getDeclarationErrorAddendum();

    		    if (!info) {
    		      var parentName = typeof parentType === 'string' ? parentType : parentType.displayName || parentType.name;

    		      if (parentName) {
    		        info = "\n\nCheck the top-level render call using <" + parentName + ">.";
    		      }
    		    }

    		    return info;
    		  }
    		}
    		/**
    		 * Warn if the element doesn't have an explicit key assigned to it.
    		 * This element is in an array. The array could grow and shrink or be
    		 * reordered. All children that haven't already been validated are required to
    		 * have a "key" property assigned to it. Error statuses are cached so a warning
    		 * will only be shown once.
    		 *
    		 * @internal
    		 * @param {ReactElement} element Element that requires a key.
    		 * @param {*} parentType element's parent's type.
    		 */


    		function validateExplicitKey(element, parentType) {
    		  {
    		    if (!element._store || element._store.validated || element.key != null) {
    		      return;
    		    }

    		    element._store.validated = true;
    		    var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);

    		    if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
    		      return;
    		    }

    		    ownerHasKeyUseWarning[currentComponentErrorInfo] = true; // Usually the current owner is the offender, but if it accepts children as a
    		    // property, it may be the creator of the child that's responsible for
    		    // assigning it a key.

    		    var childOwner = '';

    		    if (element && element._owner && element._owner !== ReactCurrentOwner$1.current) {
    		      // Give the component that originally created this child.
    		      childOwner = " It was passed a child from " + getComponentName(element._owner.type) + ".";
    		    }

    		    setCurrentlyValidatingElement$1(element);

    		    error('Each child in a list should have a unique "key" prop.' + '%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);

    		    setCurrentlyValidatingElement$1(null);
    		  }
    		}
    		/**
    		 * Ensure that every element either is passed in a static location, in an
    		 * array with an explicit keys property defined, or in an object literal
    		 * with valid key property.
    		 *
    		 * @internal
    		 * @param {ReactNode} node Statically passed child of any type.
    		 * @param {*} parentType node's parent's type.
    		 */


    		function validateChildKeys(node, parentType) {
    		  {
    		    if (typeof node !== 'object') {
    		      return;
    		    }

    		    if (Array.isArray(node)) {
    		      for (var i = 0; i < node.length; i++) {
    		        var child = node[i];

    		        if (isValidElement(child)) {
    		          validateExplicitKey(child, parentType);
    		        }
    		      }
    		    } else if (isValidElement(node)) {
    		      // This element was passed in a valid location.
    		      if (node._store) {
    		        node._store.validated = true;
    		      }
    		    } else if (node) {
    		      var iteratorFn = getIteratorFn(node);

    		      if (typeof iteratorFn === 'function') {
    		        // Entry iterators used to provide implicit keys,
    		        // but now we print a separate warning for them later.
    		        if (iteratorFn !== node.entries) {
    		          var iterator = iteratorFn.call(node);
    		          var step;

    		          while (!(step = iterator.next()).done) {
    		            if (isValidElement(step.value)) {
    		              validateExplicitKey(step.value, parentType);
    		            }
    		          }
    		        }
    		      }
    		    }
    		  }
    		}
    		/**
    		 * Given an element, validate that its props follow the propTypes definition,
    		 * provided by the type.
    		 *
    		 * @param {ReactElement} element
    		 */


    		function validatePropTypes(element) {
    		  {
    		    var type = element.type;

    		    if (type === null || type === undefined || typeof type === 'string') {
    		      return;
    		    }

    		    var propTypes;

    		    if (typeof type === 'function') {
    		      propTypes = type.propTypes;
    		    } else if (typeof type === 'object' && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
    		    // Inner props are checked in the reconciler.
    		    type.$$typeof === REACT_MEMO_TYPE)) {
    		      propTypes = type.propTypes;
    		    } else {
    		      return;
    		    }

    		    if (propTypes) {
    		      // Intentionally inside to avoid triggering lazy initializers:
    		      var name = getComponentName(type);
    		      checkPropTypes(propTypes, element.props, 'prop', name, element);
    		    } else if (type.PropTypes !== undefined && !propTypesMisspellWarningShown) {
    		      propTypesMisspellWarningShown = true; // Intentionally inside to avoid triggering lazy initializers:

    		      var _name = getComponentName(type);

    		      error('Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?', _name || 'Unknown');
    		    }

    		    if (typeof type.getDefaultProps === 'function' && !type.getDefaultProps.isReactClassApproved) {
    		      error('getDefaultProps is only used on classic React.createClass ' + 'definitions. Use a static property named `defaultProps` instead.');
    		    }
    		  }
    		}
    		/**
    		 * Given a fragment, validate that it can only be provided with fragment props
    		 * @param {ReactElement} fragment
    		 */


    		function validateFragmentProps(fragment) {
    		  {
    		    var keys = Object.keys(fragment.props);

    		    for (var i = 0; i < keys.length; i++) {
    		      var key = keys[i];

    		      if (key !== 'children' && key !== 'key') {
    		        setCurrentlyValidatingElement$1(fragment);

    		        error('Invalid prop `%s` supplied to `React.Fragment`. ' + 'React.Fragment can only have `key` and `children` props.', key);

    		        setCurrentlyValidatingElement$1(null);
    		        break;
    		      }
    		    }

    		    if (fragment.ref !== null) {
    		      setCurrentlyValidatingElement$1(fragment);

    		      error('Invalid attribute `ref` supplied to `React.Fragment`.');

    		      setCurrentlyValidatingElement$1(null);
    		    }
    		  }
    		}

    		function jsxWithValidation(type, props, key, isStaticChildren, source, self) {
    		  {
    		    var validType = isValidElementType(type); // We warn in this case but don't throw. We expect the element creation to
    		    // succeed and there will likely be errors in render.

    		    if (!validType) {
    		      var info = '';

    		      if (type === undefined || typeof type === 'object' && type !== null && Object.keys(type).length === 0) {
    		        info += ' You likely forgot to export your component from the file ' + "it's defined in, or you might have mixed up default and named imports.";
    		      }

    		      var sourceInfo = getSourceInfoErrorAddendum(source);

    		      if (sourceInfo) {
    		        info += sourceInfo;
    		      } else {
    		        info += getDeclarationErrorAddendum();
    		      }

    		      var typeString;

    		      if (type === null) {
    		        typeString = 'null';
    		      } else if (Array.isArray(type)) {
    		        typeString = 'array';
    		      } else if (type !== undefined && type.$$typeof === REACT_ELEMENT_TYPE) {
    		        typeString = "<" + (getComponentName(type.type) || 'Unknown') + " />";
    		        info = ' Did you accidentally export a JSX literal instead of a component?';
    		      } else {
    		        typeString = typeof type;
    		      }

    		      error('React.jsx: type is invalid -- expected a string (for ' + 'built-in components) or a class/function (for composite ' + 'components) but got: %s.%s', typeString, info);
    		    }

    		    var element = jsxDEV(type, props, key, source, self); // The result can be nullish if a mock or a custom function is used.
    		    // TODO: Drop this when these are no longer allowed as the type argument.

    		    if (element == null) {
    		      return element;
    		    } // Skip key warning if the type isn't valid since our key validation logic
    		    // doesn't expect a non-string/function type and can throw confusing errors.
    		    // We don't want exception behavior to differ between dev and prod.
    		    // (Rendering will throw with a helpful message and as soon as the type is
    		    // fixed, the key warnings will appear.)


    		    if (validType) {
    		      var children = props.children;

    		      if (children !== undefined) {
    		        if (isStaticChildren) {
    		          if (Array.isArray(children)) {
    		            for (var i = 0; i < children.length; i++) {
    		              validateChildKeys(children[i], type);
    		            }

    		            if (Object.freeze) {
    		              Object.freeze(children);
    		            }
    		          } else {
    		            error('React.jsx: Static children should always be an array. ' + 'You are likely explicitly calling React.jsxs or React.jsxDEV. ' + 'Use the Babel transform instead.');
    		          }
    		        } else {
    		          validateChildKeys(children, type);
    		        }
    		      }
    		    }

    		    if (type === exports.Fragment) {
    		      validateFragmentProps(element);
    		    } else {
    		      validatePropTypes(element);
    		    }

    		    return element;
    		  }
    		} // These two functions exist to still get child warnings in dev
    		// even with the prod transform. This means that jsxDEV is purely
    		// opt-in behavior for better messages but that we won't stop
    		// giving you warnings if you use production apis.

    		function jsxWithValidationStatic(type, props, key) {
    		  {
    		    return jsxWithValidation(type, props, key, true);
    		  }
    		}
    		function jsxWithValidationDynamic(type, props, key) {
    		  {
    		    return jsxWithValidation(type, props, key, false);
    		  }
    		}

    		var jsx =  jsxWithValidationDynamic ; // we may want to special case jsxs internally to take advantage of static children.
    		// for now we can ship identical prod functions

    		var jsxs =  jsxWithValidationStatic ;

    		exports.jsx = jsx;
    		exports.jsxs = jsxs;
    		  })();
    		}
    } (reactJsxRuntime_development));
    	return reactJsxRuntime_development;
    }

    var hasRequiredJsxRuntime;

    function requireJsxRuntime () {
    	if (hasRequiredJsxRuntime) return jsxRuntime.exports;
    	hasRequiredJsxRuntime = 1;
    	(function (module) {

    		if (process.env.NODE_ENV === 'production') {
    		  module.exports = requireReactJsxRuntime_production_min();
    		} else {
    		  module.exports = requireReactJsxRuntime_development();
    		}
    } (jsxRuntime));
    	return jsxRuntime.exports;
    }

    var jsxRuntimeExports = requireJsxRuntime();

    function isEmpty$3(obj) {
      return obj === undefined || obj === null || Object.keys(obj).length === 0;
    }

    function GlobalStyles$1(props) {
      const {
        styles,
        defaultTheme = {}
      } = props;
      const globalStyles = typeof styles === 'function' ? themeInput => styles(isEmpty$3(themeInput) ? defaultTheme : themeInput) : styles;
      return /*#__PURE__*/jsxRuntimeExports.jsx(Global, {
        styles: globalStyles
      });
    }
    process.env.NODE_ENV !== "production" ? GlobalStyles$1.propTypes = {
      defaultTheme: propTypes.exports.object,
      styles: propTypes.exports.oneOfType([propTypes.exports.string, propTypes.exports.object, propTypes.exports.func])
    } : void 0;

    /** @license MUI v5.4.4
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    function styled$2(tag, options) {
      const stylesFactory = emStyled(tag, options);

      if (process.env.NODE_ENV !== 'production') {
        return (...styles) => {
          const component = typeof tag === 'string' ? `"${tag}"` : 'component';

          if (styles.length === 0) {
            console.error([`MUI: Seems like you called \`styled(${component})()\` without a \`style\` argument.`, 'You must provide a `styles` argument: `styled("div")(styleYouForgotToPass)`.'].join('\n'));
          } else if (styles.some(style => style === undefined)) {
            console.error(`MUI: the styled(${component})(...args) API requires all its args to be defined.`);
          }

          return stylesFactory(...styles);
        };
      }

      return stylesFactory;
    }

    const responsivePropType = process.env.NODE_ENV !== 'production' ? propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string, propTypes.exports.object, propTypes.exports.array]) : {};

    function chainPropTypes(propType1, propType2) {
      if (process.env.NODE_ENV === 'production') {
        return () => null;
      }

      return function validate(...args) {
        return propType1(...args) || propType2(...args);
      };
    }

    function isPlainObject(item) {
      return item !== null && typeof item === 'object' && item.constructor === Object;
    }
    function deepmerge(target, source, options = {
      clone: true
    }) {
      const output = options.clone ? _extends$1({}, target) : target;

      if (isPlainObject(target) && isPlainObject(source)) {
        Object.keys(source).forEach(key => {
          // Avoid prototype pollution
          if (key === '__proto__') {
            return;
          }

          if (isPlainObject(source[key]) && key in target && isPlainObject(target[key])) {
            // Since `output` is a clone of `target` and we have narrowed `target` in this block we can cast to the same type.
            output[key] = deepmerge(target[key], source[key], options);
          } else {
            output[key] = source[key];
          }
        });
      }

      return output;
    }

    function isClassComponent$1(elementType) {
      // elementType.prototype?.isReactComponent
      const {
        prototype = {}
      } = elementType;
      return Boolean(prototype.isReactComponent);
    }

    function acceptingRef(props, propName, componentName, location, propFullName) {
      const element = props[propName];
      const safePropName = propFullName || propName;

      if (element == null || // When server-side rendering React doesn't warn either.
      // This is not an accurate check for SSR.
      // This is only in place for emotion compat.
      // TODO: Revisit once https://github.com/facebook/react/issues/20047 is resolved.
      typeof window === 'undefined') {
        return null;
      }

      let warningHint;
      const elementType = element.type;
      /**
       * Blacklisting instead of whitelisting
       *
       * Blacklisting will miss some components, such as React.Fragment. Those will at least
       * trigger a warning in React.
       * We can't whitelist because there is no safe way to detect React.forwardRef
       * or class components. "Safe" means there's no public API.
       *
       */

      if (typeof elementType === 'function' && !isClassComponent$1(elementType)) {
        warningHint = 'Did you accidentally use a plain function component for an element instead?';
      }

      if (warningHint !== undefined) {
        return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an element that can hold a ref. ${warningHint} ` + 'For more information see https://mui.com/r/caveat-with-refs-guide');
      }

      return null;
    }

    const elementAcceptingRef = chainPropTypes(propTypes.exports.element, acceptingRef);
    elementAcceptingRef.isRequired = chainPropTypes(propTypes.exports.element.isRequired, acceptingRef);

    function isClassComponent(elementType) {
      // elementType.prototype?.isReactComponent
      const {
        prototype = {}
      } = elementType;
      return Boolean(prototype.isReactComponent);
    }

    function elementTypeAcceptingRef(props, propName, componentName, location, propFullName) {
      const propValue = props[propName];
      const safePropName = propFullName || propName;

      if (propValue == null || // When server-side rendering React doesn't warn either.
      // This is not an accurate check for SSR.
      // This is only in place for emotion compat.
      // TODO: Revisit once https://github.com/facebook/react/issues/20047 is resolved.
      typeof window === 'undefined') {
        return null;
      }

      let warningHint;
      /**
       * Blacklisting instead of whitelisting
       *
       * Blacklisting will miss some components, such as React.Fragment. Those will at least
       * trigger a warning in React.
       * We can't whitelist because there is no safe way to detect React.forwardRef
       * or class components. "Safe" means there's no public API.
       *
       */

      if (typeof propValue === 'function' && !isClassComponent(propValue)) {
        warningHint = 'Did you accidentally provide a plain function component instead?';
      }

      if (warningHint !== undefined) {
        return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an element type that can hold a ref. ${warningHint} ` + 'For more information see https://mui.com/r/caveat-with-refs-guide');
      }

      return null;
    }

    var elementTypeAcceptingRef$1 = chainPropTypes(propTypes.exports.elementType, elementTypeAcceptingRef);

    // This module is based on https://github.com/airbnb/prop-types-exact repository.
    // However, in order to reduce the number of dependencies and to remove some extra safe checks
    // the module was forked.
    const specialProperty = 'exact-prop: \u200b';
    function exactProp(propTypes) {
      if (process.env.NODE_ENV === 'production') {
        return propTypes;
      }

      return _extends$1({}, propTypes, {
        [specialProperty]: props => {
          const unsupportedProps = Object.keys(props).filter(prop => !propTypes.hasOwnProperty(prop));

          if (unsupportedProps.length > 0) {
            return new Error(`The following props are not supported: ${unsupportedProps.map(prop => `\`${prop}\``).join(', ')}. Please remove them.`);
          }

          return null;
        }
      });
    }

    /**
     * WARNING: Don't import this directly.
     * Use `MuiError` from `@mui/utils/macros/MuiError.macro` instead.
     * @param {number} code
     */
    function formatMuiErrorMessage(code) {
      // Apply babel-plugin-transform-template-literals in loose mode
      // loose mode is safe iff we're concatenating primitives
      // see https://babeljs.io/docs/en/babel-plugin-transform-template-literals#loose

      /* eslint-disable prefer-template */
      let url = 'https://mui.com/production-error/?code=' + code;

      for (let i = 1; i < arguments.length; i += 1) {
        // rest params over-transpile for this case
        // eslint-disable-next-line prefer-rest-params
        url += '&args[]=' + encodeURIComponent(arguments[i]);
      }

      return 'Minified MUI error #' + code + '; visit ' + url + ' for the full message.';
      /* eslint-enable prefer-template */
    }

    var reactIs = {exports: {}};

    var reactIs_production_min = {};

    /** @license React v17.0.2
     * react-is.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_production_min;

    function requireReactIs_production_min () {
    	if (hasRequiredReactIs_production_min) return reactIs_production_min;
    	hasRequiredReactIs_production_min = 1;
    var b=60103,c=60106,d=60107,e=60108,f=60114,g=60109,h=60110,k=60112,l=60113,m=60120,n=60115,p=60116,q=60121,r=60122,u=60117,v=60129,w=60131;
    	if("function"===typeof Symbol&&Symbol.for){var x=Symbol.for;b=x("react.element");c=x("react.portal");d=x("react.fragment");e=x("react.strict_mode");f=x("react.profiler");g=x("react.provider");h=x("react.context");k=x("react.forward_ref");l=x("react.suspense");m=x("react.suspense_list");n=x("react.memo");p=x("react.lazy");q=x("react.block");r=x("react.server.block");u=x("react.fundamental");v=x("react.debug_trace_mode");w=x("react.legacy_hidden");}
    	function y(a){if("object"===typeof a&&null!==a){var t=a.$$typeof;switch(t){case b:switch(a=a.type,a){case d:case f:case e:case l:case m:return a;default:switch(a=a&&a.$$typeof,a){case h:case k:case p:case n:case g:return a;default:return t}}case c:return t}}}var z=g,A=b,B=k,C=d,D=p,E=n,F=c,G=f,H=e,I=l;reactIs_production_min.ContextConsumer=h;reactIs_production_min.ContextProvider=z;reactIs_production_min.Element=A;reactIs_production_min.ForwardRef=B;reactIs_production_min.Fragment=C;reactIs_production_min.Lazy=D;reactIs_production_min.Memo=E;reactIs_production_min.Portal=F;reactIs_production_min.Profiler=G;reactIs_production_min.StrictMode=H;
    	reactIs_production_min.Suspense=I;reactIs_production_min.isAsyncMode=function(){return !1};reactIs_production_min.isConcurrentMode=function(){return !1};reactIs_production_min.isContextConsumer=function(a){return y(a)===h};reactIs_production_min.isContextProvider=function(a){return y(a)===g};reactIs_production_min.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===b};reactIs_production_min.isForwardRef=function(a){return y(a)===k};reactIs_production_min.isFragment=function(a){return y(a)===d};reactIs_production_min.isLazy=function(a){return y(a)===p};reactIs_production_min.isMemo=function(a){return y(a)===n};
    	reactIs_production_min.isPortal=function(a){return y(a)===c};reactIs_production_min.isProfiler=function(a){return y(a)===f};reactIs_production_min.isStrictMode=function(a){return y(a)===e};reactIs_production_min.isSuspense=function(a){return y(a)===l};reactIs_production_min.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===d||a===f||a===v||a===e||a===l||a===m||a===w||"object"===typeof a&&null!==a&&(a.$$typeof===p||a.$$typeof===n||a.$$typeof===g||a.$$typeof===h||a.$$typeof===k||a.$$typeof===u||a.$$typeof===q||a[0]===r)?!0:!1};
    	reactIs_production_min.typeOf=y;
    	return reactIs_production_min;
    }

    var reactIs_development = {};

    /** @license React v17.0.2
     * react-is.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactIs_development;

    function requireReactIs_development () {
    	if (hasRequiredReactIs_development) return reactIs_development;
    	hasRequiredReactIs_development = 1;

    	if (process.env.NODE_ENV !== "production") {
    	  (function() {

    	// ATTENTION
    	// When adding new symbols to this file,
    	// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
    	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    	// nor polyfill, then a plain number is used for performance.
    	var REACT_ELEMENT_TYPE = 0xeac7;
    	var REACT_PORTAL_TYPE = 0xeaca;
    	var REACT_FRAGMENT_TYPE = 0xeacb;
    	var REACT_STRICT_MODE_TYPE = 0xeacc;
    	var REACT_PROFILER_TYPE = 0xead2;
    	var REACT_PROVIDER_TYPE = 0xeacd;
    	var REACT_CONTEXT_TYPE = 0xeace;
    	var REACT_FORWARD_REF_TYPE = 0xead0;
    	var REACT_SUSPENSE_TYPE = 0xead1;
    	var REACT_SUSPENSE_LIST_TYPE = 0xead8;
    	var REACT_MEMO_TYPE = 0xead3;
    	var REACT_LAZY_TYPE = 0xead4;
    	var REACT_BLOCK_TYPE = 0xead9;
    	var REACT_SERVER_BLOCK_TYPE = 0xeada;
    	var REACT_FUNDAMENTAL_TYPE = 0xead5;
    	var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
    	var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

    	if (typeof Symbol === 'function' && Symbol.for) {
    	  var symbolFor = Symbol.for;
    	  REACT_ELEMENT_TYPE = symbolFor('react.element');
    	  REACT_PORTAL_TYPE = symbolFor('react.portal');
    	  REACT_FRAGMENT_TYPE = symbolFor('react.fragment');
    	  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
    	  REACT_PROFILER_TYPE = symbolFor('react.profiler');
    	  REACT_PROVIDER_TYPE = symbolFor('react.provider');
    	  REACT_CONTEXT_TYPE = symbolFor('react.context');
    	  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
    	  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
    	  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
    	  REACT_MEMO_TYPE = symbolFor('react.memo');
    	  REACT_LAZY_TYPE = symbolFor('react.lazy');
    	  REACT_BLOCK_TYPE = symbolFor('react.block');
    	  REACT_SERVER_BLOCK_TYPE = symbolFor('react.server.block');
    	  REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
    	  symbolFor('react.scope');
    	  symbolFor('react.opaque.id');
    	  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
    	  symbolFor('react.offscreen');
    	  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
    	}

    	// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

    	var enableScopeAPI = false; // Experimental Create Event Handle API.

    	function isValidElementType(type) {
    	  if (typeof type === 'string' || typeof type === 'function') {
    	    return true;
    	  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


    	  if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || type === REACT_DEBUG_TRACING_MODE_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI ) {
    	    return true;
    	  }

    	  if (typeof type === 'object' && type !== null) {
    	    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE) {
    	      return true;
    	    }
    	  }

    	  return false;
    	}

    	function typeOf(object) {
    	  if (typeof object === 'object' && object !== null) {
    	    var $$typeof = object.$$typeof;

    	    switch ($$typeof) {
    	      case REACT_ELEMENT_TYPE:
    	        var type = object.type;

    	        switch (type) {
    	          case REACT_FRAGMENT_TYPE:
    	          case REACT_PROFILER_TYPE:
    	          case REACT_STRICT_MODE_TYPE:
    	          case REACT_SUSPENSE_TYPE:
    	          case REACT_SUSPENSE_LIST_TYPE:
    	            return type;

    	          default:
    	            var $$typeofType = type && type.$$typeof;

    	            switch ($$typeofType) {
    	              case REACT_CONTEXT_TYPE:
    	              case REACT_FORWARD_REF_TYPE:
    	              case REACT_LAZY_TYPE:
    	              case REACT_MEMO_TYPE:
    	              case REACT_PROVIDER_TYPE:
    	                return $$typeofType;

    	              default:
    	                return $$typeof;
    	            }

    	        }

    	      case REACT_PORTAL_TYPE:
    	        return $$typeof;
    	    }
    	  }

    	  return undefined;
    	}
    	var ContextConsumer = REACT_CONTEXT_TYPE;
    	var ContextProvider = REACT_PROVIDER_TYPE;
    	var Element = REACT_ELEMENT_TYPE;
    	var ForwardRef = REACT_FORWARD_REF_TYPE;
    	var Fragment = REACT_FRAGMENT_TYPE;
    	var Lazy = REACT_LAZY_TYPE;
    	var Memo = REACT_MEMO_TYPE;
    	var Portal = REACT_PORTAL_TYPE;
    	var Profiler = REACT_PROFILER_TYPE;
    	var StrictMode = REACT_STRICT_MODE_TYPE;
    	var Suspense = REACT_SUSPENSE_TYPE;
    	var hasWarnedAboutDeprecatedIsAsyncMode = false;
    	var hasWarnedAboutDeprecatedIsConcurrentMode = false; // AsyncMode should be deprecated

    	function isAsyncMode(object) {
    	  {
    	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
    	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

    	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
    	    }
    	  }

    	  return false;
    	}
    	function isConcurrentMode(object) {
    	  {
    	    if (!hasWarnedAboutDeprecatedIsConcurrentMode) {
    	      hasWarnedAboutDeprecatedIsConcurrentMode = true; // Using console['warn'] to evade Babel and ESLint

    	      console['warn']('The ReactIs.isConcurrentMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
    	    }
    	  }

    	  return false;
    	}
    	function isContextConsumer(object) {
    	  return typeOf(object) === REACT_CONTEXT_TYPE;
    	}
    	function isContextProvider(object) {
    	  return typeOf(object) === REACT_PROVIDER_TYPE;
    	}
    	function isElement(object) {
    	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    	}
    	function isForwardRef(object) {
    	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
    	}
    	function isFragment(object) {
    	  return typeOf(object) === REACT_FRAGMENT_TYPE;
    	}
    	function isLazy(object) {
    	  return typeOf(object) === REACT_LAZY_TYPE;
    	}
    	function isMemo(object) {
    	  return typeOf(object) === REACT_MEMO_TYPE;
    	}
    	function isPortal(object) {
    	  return typeOf(object) === REACT_PORTAL_TYPE;
    	}
    	function isProfiler(object) {
    	  return typeOf(object) === REACT_PROFILER_TYPE;
    	}
    	function isStrictMode(object) {
    	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
    	}
    	function isSuspense(object) {
    	  return typeOf(object) === REACT_SUSPENSE_TYPE;
    	}

    	reactIs_development.ContextConsumer = ContextConsumer;
    	reactIs_development.ContextProvider = ContextProvider;
    	reactIs_development.Element = Element;
    	reactIs_development.ForwardRef = ForwardRef;
    	reactIs_development.Fragment = Fragment;
    	reactIs_development.Lazy = Lazy;
    	reactIs_development.Memo = Memo;
    	reactIs_development.Portal = Portal;
    	reactIs_development.Profiler = Profiler;
    	reactIs_development.StrictMode = StrictMode;
    	reactIs_development.Suspense = Suspense;
    	reactIs_development.isAsyncMode = isAsyncMode;
    	reactIs_development.isConcurrentMode = isConcurrentMode;
    	reactIs_development.isContextConsumer = isContextConsumer;
    	reactIs_development.isContextProvider = isContextProvider;
    	reactIs_development.isElement = isElement;
    	reactIs_development.isForwardRef = isForwardRef;
    	reactIs_development.isFragment = isFragment;
    	reactIs_development.isLazy = isLazy;
    	reactIs_development.isMemo = isMemo;
    	reactIs_development.isPortal = isPortal;
    	reactIs_development.isProfiler = isProfiler;
    	reactIs_development.isStrictMode = isStrictMode;
    	reactIs_development.isSuspense = isSuspense;
    	reactIs_development.isValidElementType = isValidElementType;
    	reactIs_development.typeOf = typeOf;
    	  })();
    	}
    	return reactIs_development;
    }

    (function (module) {

    	if (process.env.NODE_ENV === 'production') {
    	  module.exports = requireReactIs_production_min();
    	} else {
    	  module.exports = requireReactIs_development();
    	}
    } (reactIs));

    // https://github.com/JamesMGreene/Function.name/blob/58b314d4a983110c3682f1228f845d39ccca1817/Function.name.js#L3

    const fnNameMatchRegex = /^\s*function(?:\s|\s*\/\*.*\*\/\s*)+([^(\s/]*)\s*/;
    function getFunctionName(fn) {
      const match = `${fn}`.match(fnNameMatchRegex);
      const name = match && match[1];
      return name || '';
    }

    function getFunctionComponentName(Component, fallback = '') {
      return Component.displayName || Component.name || getFunctionName(Component) || fallback;
    }

    function getWrappedName(outerType, innerType, wrapperName) {
      const functionName = getFunctionComponentName(innerType);
      return outerType.displayName || (functionName !== '' ? `${wrapperName}(${functionName})` : wrapperName);
    }
    /**
     * cherry-pick from
     * https://github.com/facebook/react/blob/769b1f270e1251d9dbdce0fcbd9e92e502d059b8/packages/shared/getComponentName.js
     * originally forked from recompose/getDisplayName with added IE11 support
     */


    function getDisplayName(Component) {
      if (Component == null) {
        return undefined;
      }

      if (typeof Component === 'string') {
        return Component;
      }

      if (typeof Component === 'function') {
        return getFunctionComponentName(Component, 'Component');
      } // TypeScript can't have components as objects but they exist in the form of `memo` or `Suspense`


      if (typeof Component === 'object') {
        switch (Component.$$typeof) {
          case reactIs.exports.ForwardRef:
            return getWrappedName(Component, Component.render, 'ForwardRef');

          case reactIs.exports.Memo:
            return getWrappedName(Component, Component.type, 'memo');

          default:
            return undefined;
        }
      }

      return undefined;
    }

    function HTMLElementType(props, propName, componentName, location, propFullName) {
      if (process.env.NODE_ENV === 'production') {
        return null;
      }

      const propValue = props[propName];
      const safePropName = propFullName || propName;

      if (propValue == null) {
        return null;
      }

      if (propValue && propValue.nodeType !== 1) {
        return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an HTMLElement.`);
      }

      return null;
    }

    /* eslint-disable */
    // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
    typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();

    const refType = propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object]);

    // It should to be noted that this function isn't equivalent to `text-transform: capitalize`.
    //
    // A strict capitalization should uppercase the first letter of each word in the sentence.
    // We only handle the first word.
    function capitalize(string) {
      if (typeof string !== 'string') {
        throw new Error(process.env.NODE_ENV !== "production" ? `MUI: \`capitalize(string)\` expects a string argument.` : formatMuiErrorMessage(7));
      }

      return string.charAt(0).toUpperCase() + string.slice(1);
    }

    /**
     * Safe chained function.
     *
     * Will only create a new function if needed,
     * otherwise will pass back existing functions or null.
     */
    function createChainedFunction(...funcs) {
      return funcs.reduce((acc, func) => {
        if (func == null) {
          return acc;
        }

        return function chainedFunction(...args) {
          acc.apply(this, args);
          func.apply(this, args);
        };
      }, () => {});
    }

    // Corresponds to 10 frames at 60 Hz.
    // A few bytes payload overhead when lodash/debounce is ~3 kB and debounce ~300 B.
    function debounce$1(func, wait = 166) {
      let timeout;

      function debounced(...args) {
        const later = () => {
          func.apply(this, args);
        };

        clearTimeout(timeout);
        timeout = setTimeout(later, wait);
      }

      debounced.clear = () => {
        clearTimeout(timeout);
      };

      return debounced;
    }

    function deprecatedPropType(validator, reason) {
      if (process.env.NODE_ENV === 'production') {
        return () => null;
      }

      return (props, propName, componentName, location, propFullName) => {
        const componentNameSafe = componentName || '<<anonymous>>';
        const propFullNameSafe = propFullName || propName;

        if (typeof props[propName] !== 'undefined') {
          return new Error(`The ${location} \`${propFullNameSafe}\` of ` + `\`${componentNameSafe}\` is deprecated. ${reason}`);
        }

        return null;
      };
    }

    function isMuiElement(element, muiNames) {
      return /*#__PURE__*/react.exports.isValidElement(element) && muiNames.indexOf(element.type.muiName) !== -1;
    }

    function ownerDocument(node) {
      return node && node.ownerDocument || document;
    }

    function ownerWindow(node) {
      const doc = ownerDocument(node);
      return doc.defaultView || window;
    }

    function requirePropFactory(componentNameInError, Component) {
      if (process.env.NODE_ENV === 'production') {
        return () => null;
      } // eslint-disable-next-line react/forbid-foreign-prop-types


      const prevPropTypes = Component ? _extends$1({}, Component.propTypes) : null;

      const requireProp = requiredProp => (props, propName, componentName, location, propFullName, ...args) => {
        const propFullNameSafe = propFullName || propName;
        const defaultTypeChecker = prevPropTypes == null ? void 0 : prevPropTypes[propFullNameSafe];

        if (defaultTypeChecker) {
          const typeCheckerResult = defaultTypeChecker(props, propName, componentName, location, propFullName, ...args);

          if (typeCheckerResult) {
            return typeCheckerResult;
          }
        }

        if (typeof props[propName] !== 'undefined' && !props[requiredProp]) {
          return new Error(`The prop \`${propFullNameSafe}\` of ` + `\`${componentNameInError}\` can only be used together with the \`${requiredProp}\` prop.`);
        }

        return null;
      };

      return requireProp;
    }

    /**
     * TODO v5: consider making it private
     *
     * passes {value} to {ref}
     *
     * WARNING: Be sure to only call this inside a callback that is passed as a ref.
     * Otherwise, make sure to cleanup the previous {ref} if it changes. See
     * https://github.com/mui/material-ui/issues/13539
     *
     * Useful if you want to expose the ref of an inner component to the public API
     * while still using it inside the component.
     * @param ref A ref callback or ref object. If anything falsy, this is a no-op.
     */
    function setRef(ref, value) {
      if (typeof ref === 'function') {
        ref(value);
      } else if (ref) {
        ref.current = value;
      }
    }

    const useEnhancedEffect = typeof window !== 'undefined' ? react.exports.useLayoutEffect : react.exports.useEffect;

    let globalId = 0;

    function useGlobalId(idOverride) {
      const [defaultId, setDefaultId] = react.exports.useState(idOverride);
      const id = idOverride || defaultId;
      react.exports.useEffect(() => {
        if (defaultId == null) {
          // Fallback to this default id when possible.
          // Use the incrementing value for client-side rendering only.
          // We can't use it server-side.
          // If you want to use random values please consider the Birthday Problem: https://en.wikipedia.org/wiki/Birthday_problem
          globalId += 1;
          setDefaultId(`mui-${globalId}`);
        }
      }, [defaultId]);
      return id;
    } // eslint-disable-next-line no-useless-concat -- Workaround for https://github.com/webpack/webpack/issues/14814


    const maybeReactUseId = React$1['useId' + ''];
    /**
     *
     * @example <div id={useId()} />
     * @param idOverride
     * @returns {string}
     */

    function useId(idOverride) {
      if (maybeReactUseId !== undefined) {
        const reactId = maybeReactUseId();
        return idOverride != null ? idOverride : reactId;
      } // eslint-disable-next-line react-hooks/rules-of-hooks -- `React.useId` is invariant at runtime.


      return useGlobalId(idOverride);
    }

    function unsupportedProp(props, propName, componentName, location, propFullName) {
      if (process.env.NODE_ENV === 'production') {
        return null;
      }

      const propFullNameSafe = propFullName || propName;

      if (typeof props[propName] !== 'undefined') {
        return new Error(`The prop \`${propFullNameSafe}\` is not supported. Please remove it.`);
      }

      return null;
    }

    /* eslint-disable react-hooks/rules-of-hooks, react-hooks/exhaustive-deps */
    function useControlled({
      controlled,
      default: defaultProp,
      name,
      state = 'value'
    }) {
      // isControlled is ignored in the hook dependency lists as it should never change.
      const {
        current: isControlled
      } = react.exports.useRef(controlled !== undefined);
      const [valueState, setValue] = react.exports.useState(defaultProp);
      const value = isControlled ? controlled : valueState;

      if (process.env.NODE_ENV !== 'production') {
        react.exports.useEffect(() => {
          if (isControlled !== (controlled !== undefined)) {
            console.error([`MUI: A component is changing the ${isControlled ? '' : 'un'}controlled ${state} state of ${name} to be ${isControlled ? 'un' : ''}controlled.`, 'Elements should not switch from uncontrolled to controlled (or vice versa).', `Decide between using a controlled or uncontrolled ${name} ` + 'element for the lifetime of the component.', "The nature of the state is determined during the first render. It's considered controlled if the value is not `undefined`.", 'More info: https://fb.me/react-controlled-components'].join('\n'));
          }
        }, [state, name, controlled]);
        const {
          current: defaultValue
        } = react.exports.useRef(defaultProp);
        react.exports.useEffect(() => {
          if (!isControlled && defaultValue !== defaultProp) {
            console.error([`MUI: A component is changing the default ${state} state of an uncontrolled ${name} after being initialized. ` + `To suppress this warning opt to use a controlled ${name}.`].join('\n'));
          }
        }, [JSON.stringify(defaultProp)]);
      }

      const setValueIfUncontrolled = react.exports.useCallback(newValue => {
        if (!isControlled) {
          setValue(newValue);
        }
      }, []);
      return [value, setValueIfUncontrolled];
    }

    /**
     * https://github.com/facebook/react/issues/14099#issuecomment-440013892
     */

    function useEventCallback(fn) {
      const ref = react.exports.useRef(fn);
      useEnhancedEffect(() => {
        ref.current = fn;
      });
      return react.exports.useCallback((...args) => // @ts-expect-error hide `this`
      // tslint:disable-next-line:ban-comma-operator
      (0, ref.current)(...args), []);
    }

    function useForkRef(refA, refB) {
      /**
       * This will create a new function if the ref props change and are defined.
       * This means react will call the old forkRef with `null` and the new forkRef
       * with the ref. Cleanup naturally emerges from this behavior.
       */
      return react.exports.useMemo(() => {
        if (refA == null && refB == null) {
          return null;
        }

        return refValue => {
          setRef(refA, refValue);
          setRef(refB, refValue);
        };
      }, [refA, refB]);
    }

    // based on https://github.com/WICG/focus-visible/blob/v4.1.5/src/focus-visible.js
    let hadKeyboardEvent = true;
    let hadFocusVisibleRecently = false;
    let hadFocusVisibleRecentlyTimeout;
    const inputTypesWhitelist = {
      text: true,
      search: true,
      url: true,
      tel: true,
      email: true,
      password: true,
      number: true,
      date: true,
      month: true,
      week: true,
      time: true,
      datetime: true,
      'datetime-local': true
    };
    /**
     * Computes whether the given element should automatically trigger the
     * `focus-visible` class being added, i.e. whether it should always match
     * `:focus-visible` when focused.
     * @param {Element} node
     * @returns {boolean}
     */

    function focusTriggersKeyboardModality(node) {
      const {
        type,
        tagName
      } = node;

      if (tagName === 'INPUT' && inputTypesWhitelist[type] && !node.readOnly) {
        return true;
      }

      if (tagName === 'TEXTAREA' && !node.readOnly) {
        return true;
      }

      if (node.isContentEditable) {
        return true;
      }

      return false;
    }
    /**
     * Keep track of our keyboard modality state with `hadKeyboardEvent`.
     * If the most recent user interaction was via the keyboard;
     * and the key press did not include a meta, alt/option, or control key;
     * then the modality is keyboard. Otherwise, the modality is not keyboard.
     * @param {KeyboardEvent} event
     */


    function handleKeyDown(event) {
      if (event.metaKey || event.altKey || event.ctrlKey) {
        return;
      }

      hadKeyboardEvent = true;
    }
    /**
     * If at any point a user clicks with a pointing device, ensure that we change
     * the modality away from keyboard.
     * This avoids the situation where a user presses a key on an already focused
     * element, and then clicks on a different element, focusing it with a
     * pointing device, while we still think we're in keyboard modality.
     */


    function handlePointerDown() {
      hadKeyboardEvent = false;
    }

    function handleVisibilityChange() {
      if (this.visibilityState === 'hidden') {
        // If the tab becomes active again, the browser will handle calling focus
        // on the element (Safari actually calls it twice).
        // If this tab change caused a blur on an element with focus-visible,
        // re-apply the class when the user switches back to the tab.
        if (hadFocusVisibleRecently) {
          hadKeyboardEvent = true;
        }
      }
    }

    function prepare(doc) {
      doc.addEventListener('keydown', handleKeyDown, true);
      doc.addEventListener('mousedown', handlePointerDown, true);
      doc.addEventListener('pointerdown', handlePointerDown, true);
      doc.addEventListener('touchstart', handlePointerDown, true);
      doc.addEventListener('visibilitychange', handleVisibilityChange, true);
    }

    function isFocusVisible(event) {
      const {
        target
      } = event;

      try {
        return target.matches(':focus-visible');
      } catch (error) {// Browsers not implementing :focus-visible will throw a SyntaxError.
        // We use our own heuristic for those browsers.
        // Rethrow might be better if it's not the expected error but do we really
        // want to crash if focus-visible malfunctioned?
      } // No need for validFocusTarget check. The user does that by attaching it to
      // focusable events only.


      return hadKeyboardEvent || focusTriggersKeyboardModality(target);
    }

    function useIsFocusVisible() {
      const ref = react.exports.useCallback(node => {
        if (node != null) {
          prepare(node.ownerDocument);
        }
      }, []);
      const isFocusVisibleRef = react.exports.useRef(false);
      /**
       * Should be called if a blur event is fired
       */

      function handleBlurVisible() {
        // checking against potential state variable does not suffice if we focus and blur synchronously.
        // React wouldn't have time to trigger a re-render so `focusVisible` would be stale.
        // Ideally we would adjust `isFocusVisible(event)` to look at `relatedTarget` for blur events.
        // This doesn't work in IE11 due to https://github.com/facebook/react/issues/3751
        // TODO: check again if React releases their internal changes to focus event handling (https://github.com/facebook/react/pull/19186).
        if (isFocusVisibleRef.current) {
          // To detect a tab/window switch, we look for a blur event followed
          // rapidly by a visibility change.
          // If we don't see a visibility change within 100ms, it's probably a
          // regular focus change.
          hadFocusVisibleRecently = true;
          window.clearTimeout(hadFocusVisibleRecentlyTimeout);
          hadFocusVisibleRecentlyTimeout = window.setTimeout(() => {
            hadFocusVisibleRecently = false;
          }, 100);
          isFocusVisibleRef.current = false;
          return true;
        }

        return false;
      }
      /**
       * Should be called if a blur event is fired
       */


      function handleFocusVisible(event) {
        if (isFocusVisible(event)) {
          isFocusVisibleRef.current = true;
          return true;
        }

        return false;
      }

      return {
        isFocusVisibleRef,
        onFocus: handleFocusVisible,
        onBlur: handleBlurVisible,
        ref
      };
    }

    // A change of the browser zoom change the scrollbar size.
    // Credit https://github.com/twbs/bootstrap/blob/488fd8afc535ca3a6ad4dc581f5e89217b6a36ac/js/src/util/scrollbar.js#L14-L18
    function getScrollbarSize(doc) {
      // https://developer.mozilla.org/en-US/docs/Web/API/Window/innerWidth#usage_notes
      const documentWidth = doc.documentElement.clientWidth;
      return Math.abs(window.innerWidth - documentWidth);
    }

    function getTypeByValue(value) {
      const valueType = typeof value;

      switch (valueType) {
        case 'number':
          if (Number.isNaN(value)) {
            return 'NaN';
          }

          if (!Number.isFinite(value)) {
            return 'Infinity';
          }

          if (value !== Math.floor(value)) {
            return 'float';
          }

          return 'number';

        case 'object':
          if (value === null) {
            return 'null';
          }

          return value.constructor.name;

        default:
          return valueType;
      }
    } // IE 11 support

    function ponyfillIsInteger(x) {
      // eslint-disable-next-line no-restricted-globals
      return typeof x === 'number' && isFinite(x) && Math.floor(x) === x;
    }

    const isInteger = Number.isInteger || ponyfillIsInteger;

    function requiredInteger(props, propName, componentName, location) {
      const propValue = props[propName];

      if (propValue == null || !isInteger(propValue)) {
        const propType = getTypeByValue(propValue);
        return new RangeError(`Invalid ${location} \`${propName}\` of type \`${propType}\` supplied to \`${componentName}\`, expected \`integer\`.`);
      }

      return null;
    }

    function validator(props, propName, ...other) {
      const propValue = props[propName];

      if (propValue === undefined) {
        return null;
      }

      return requiredInteger(props, propName, ...other);
    }

    function validatorNoop() {
      return null;
    }

    validator.isRequired = requiredInteger;
    validatorNoop.isRequired = validatorNoop;
    var integerPropType = process.env.NODE_ENV === 'production' ? validatorNoop : validator;

    /**
     * Add keys, values of `defaultProps` that does not exist in `props`
     * @param {object} defaultProps
     * @param {object} props
     * @returns {object} resolved props
     */
    function resolveProps(defaultProps, props) {
      const output = _extends$1({}, props);

      Object.keys(defaultProps).forEach(propName => {
        if (output[propName] === undefined) {
          output[propName] = defaultProps[propName];
        }
      });
      return output;
    }

    function merge(acc, item) {
      if (!item) {
        return acc;
      }

      return deepmerge(acc, item, {
        clone: false // No need to clone deep, it's way faster.

      });
    }

    // For instance with the first breakpoint xs: [xs, sm[.

    const values$1 = {
      xs: 0,
      // phone
      sm: 600,
      // tablet
      md: 900,
      // small laptop
      lg: 1200,
      // desktop
      xl: 1536 // large screen

    };
    const defaultBreakpoints = {
      // Sorted ASC by size. That's important.
      // It can't be configured as it's used statically for propTypes.
      keys: ['xs', 'sm', 'md', 'lg', 'xl'],
      up: key => `@media (min-width:${values$1[key]}px)`
    };
    function handleBreakpoints(props, propValue, styleFromPropValue) {
      const theme = props.theme || {};

      if (Array.isArray(propValue)) {
        const themeBreakpoints = theme.breakpoints || defaultBreakpoints;
        return propValue.reduce((acc, item, index) => {
          acc[themeBreakpoints.up(themeBreakpoints.keys[index])] = styleFromPropValue(propValue[index]);
          return acc;
        }, {});
      }

      if (typeof propValue === 'object') {
        const themeBreakpoints = theme.breakpoints || defaultBreakpoints;
        return Object.keys(propValue).reduce((acc, breakpoint) => {
          // key is breakpoint
          if (Object.keys(themeBreakpoints.values || values$1).indexOf(breakpoint) !== -1) {
            const mediaKey = themeBreakpoints.up(breakpoint);
            acc[mediaKey] = styleFromPropValue(propValue[breakpoint], breakpoint);
          } else {
            const cssKey = breakpoint;
            acc[cssKey] = propValue[cssKey];
          }

          return acc;
        }, {});
      }

      const output = styleFromPropValue(propValue);
      return output;
    }

    function createEmptyBreakpointObject(breakpointsInput = {}) {
      var _breakpointsInput$key;

      const breakpointsInOrder = breakpointsInput == null ? void 0 : (_breakpointsInput$key = breakpointsInput.keys) == null ? void 0 : _breakpointsInput$key.reduce((acc, key) => {
        const breakpointStyleKey = breakpointsInput.up(key);
        acc[breakpointStyleKey] = {};
        return acc;
      }, {});
      return breakpointsInOrder || {};
    }
    function removeUnusedBreakpoints(breakpointKeys, style) {
      return breakpointKeys.reduce((acc, key) => {
        const breakpointOutput = acc[key];
        const isBreakpointUnused = !breakpointOutput || Object.keys(breakpointOutput).length === 0;

        if (isBreakpointUnused) {
          delete acc[key];
        }

        return acc;
      }, style);
    }
    // [1,2,3] => {xs: true, sm: true, md: true}
    // {xs: 1, sm: 2, md: 3} => {xs: true, sm: true, md: true}

    function computeBreakpointsBase(breakpointValues, themeBreakpoints) {
      // fixed value
      if (typeof breakpointValues !== 'object') {
        return {};
      }

      const base = {};
      const breakpointsKeys = Object.keys(themeBreakpoints);

      if (Array.isArray(breakpointValues)) {
        breakpointsKeys.forEach((breakpoint, i) => {
          if (i < breakpointValues.length) {
            base[breakpoint] = true;
          }
        });
      } else {
        breakpointsKeys.forEach(breakpoint => {
          if (breakpointValues[breakpoint] != null) {
            base[breakpoint] = true;
          }
        });
      }

      return base;
    }
    function resolveBreakpointValues({
      values: breakpointValues,
      breakpoints: themeBreakpoints,
      base: customBase
    }) {
      const base = customBase || computeBreakpointsBase(breakpointValues, themeBreakpoints);
      const keys = Object.keys(base);

      if (keys.length === 0) {
        return breakpointValues;
      }

      let previous;
      return keys.reduce((acc, breakpoint, i) => {
        if (Array.isArray(breakpointValues)) {
          acc[breakpoint] = breakpointValues[i] != null ? breakpointValues[i] : breakpointValues[previous];
          previous = i;
        } else {
          acc[breakpoint] = breakpointValues[breakpoint] != null ? breakpointValues[breakpoint] : breakpointValues[previous] || breakpointValues;
          previous = breakpoint;
        }

        return acc;
      }, {});
    }

    function getPath(obj, path) {
      if (!path || typeof path !== 'string') {
        return null;
      }

      return path.split('.').reduce((acc, item) => acc && acc[item] ? acc[item] : null, obj);
    }

    function getValue$1(themeMapping, transform, propValueFinal, userValue = propValueFinal) {
      let value;

      if (typeof themeMapping === 'function') {
        value = themeMapping(propValueFinal);
      } else if (Array.isArray(themeMapping)) {
        value = themeMapping[propValueFinal] || userValue;
      } else {
        value = getPath(themeMapping, propValueFinal) || userValue;
      }

      if (transform) {
        value = transform(value);
      }

      return value;
    }

    function style$2(options) {
      const {
        prop,
        cssProperty = options.prop,
        themeKey,
        transform
      } = options;

      const fn = props => {
        if (props[prop] == null) {
          return null;
        }

        const propValue = props[prop];
        const theme = props.theme;
        const themeMapping = getPath(theme, themeKey) || {};

        const styleFromPropValue = propValueFinal => {
          let value = getValue$1(themeMapping, transform, propValueFinal);

          if (propValueFinal === value && typeof propValueFinal === 'string') {
            // Haven't found value
            value = getValue$1(themeMapping, transform, `${prop}${propValueFinal === 'default' ? '' : capitalize(propValueFinal)}`, propValueFinal);
          }

          if (cssProperty === false) {
            return value;
          }

          return {
            [cssProperty]: value
          };
        };

        return handleBreakpoints(props, propValue, styleFromPropValue);
      };

      fn.propTypes = process.env.NODE_ENV !== 'production' ? {
        [prop]: responsivePropType
      } : {};
      fn.filterProps = [prop];
      return fn;
    }

    function compose(...styles) {
      const handlers = styles.reduce((acc, style) => {
        style.filterProps.forEach(prop => {
          acc[prop] = style;
        });
        return acc;
      }, {});

      const fn = props => {
        return Object.keys(props).reduce((acc, prop) => {
          if (handlers[prop]) {
            return merge(acc, handlers[prop](props));
          }

          return acc;
        }, {});
      };

      fn.propTypes = process.env.NODE_ENV !== 'production' ? styles.reduce((acc, style) => Object.assign(acc, style.propTypes), {}) : {};
      fn.filterProps = styles.reduce((acc, style) => acc.concat(style.filterProps), []);
      return fn;
    }

    function memoize(fn) {
      const cache = {};
      return arg => {
        if (cache[arg] === undefined) {
          cache[arg] = fn(arg);
        }

        return cache[arg];
      };
    }

    const properties = {
      m: 'margin',
      p: 'padding'
    };
    const directions = {
      t: 'Top',
      r: 'Right',
      b: 'Bottom',
      l: 'Left',
      x: ['Left', 'Right'],
      y: ['Top', 'Bottom']
    };
    const aliases = {
      marginX: 'mx',
      marginY: 'my',
      paddingX: 'px',
      paddingY: 'py'
    }; // memoize() impact:
    // From 300,000 ops/sec
    // To 350,000 ops/sec

    const getCssProperties = memoize(prop => {
      // It's not a shorthand notation.
      if (prop.length > 2) {
        if (aliases[prop]) {
          prop = aliases[prop];
        } else {
          return [prop];
        }
      }

      const [a, b] = prop.split('');
      const property = properties[a];
      const direction = directions[b] || '';
      return Array.isArray(direction) ? direction.map(dir => property + dir) : [property + direction];
    });
    const marginKeys = ['m', 'mt', 'mr', 'mb', 'ml', 'mx', 'my', 'margin', 'marginTop', 'marginRight', 'marginBottom', 'marginLeft', 'marginX', 'marginY', 'marginInline', 'marginInlineStart', 'marginInlineEnd', 'marginBlock', 'marginBlockStart', 'marginBlockEnd'];
    const paddingKeys = ['p', 'pt', 'pr', 'pb', 'pl', 'px', 'py', 'padding', 'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft', 'paddingX', 'paddingY', 'paddingInline', 'paddingInlineStart', 'paddingInlineEnd', 'paddingBlock', 'paddingBlockStart', 'paddingBlockEnd'];
    const spacingKeys = [...marginKeys, ...paddingKeys];
    function createUnaryUnit(theme, themeKey, defaultValue, propName) {
      const themeSpacing = getPath(theme, themeKey) || defaultValue;

      if (typeof themeSpacing === 'number') {
        return abs => {
          if (typeof abs === 'string') {
            return abs;
          }

          if (process.env.NODE_ENV !== 'production') {
            if (typeof abs !== 'number') {
              console.error(`MUI: Expected ${propName} argument to be a number or a string, got ${abs}.`);
            }
          }

          return themeSpacing * abs;
        };
      }

      if (Array.isArray(themeSpacing)) {
        return abs => {
          if (typeof abs === 'string') {
            return abs;
          }

          if (process.env.NODE_ENV !== 'production') {
            if (!Number.isInteger(abs)) {
              console.error([`MUI: The \`theme.${themeKey}\` array type cannot be combined with non integer values.` + `You should either use an integer value that can be used as index, or define the \`theme.${themeKey}\` as a number.`].join('\n'));
            } else if (abs > themeSpacing.length - 1) {
              console.error([`MUI: The value provided (${abs}) overflows.`, `The supported values are: ${JSON.stringify(themeSpacing)}.`, `${abs} > ${themeSpacing.length - 1}, you need to add the missing values.`].join('\n'));
            }
          }

          return themeSpacing[abs];
        };
      }

      if (typeof themeSpacing === 'function') {
        return themeSpacing;
      }

      if (process.env.NODE_ENV !== 'production') {
        console.error([`MUI: The \`theme.${themeKey}\` value (${themeSpacing}) is invalid.`, 'It should be a number, an array or a function.'].join('\n'));
      }

      return () => undefined;
    }
    function createUnarySpacing(theme) {
      return createUnaryUnit(theme, 'spacing', 8, 'spacing');
    }
    function getValue(transformer, propValue) {
      if (typeof propValue === 'string' || propValue == null) {
        return propValue;
      }

      const abs = Math.abs(propValue);
      const transformed = transformer(abs);

      if (propValue >= 0) {
        return transformed;
      }

      if (typeof transformed === 'number') {
        return -transformed;
      }

      return `-${transformed}`;
    }
    function getStyleFromPropValue(cssProperties, transformer) {
      return propValue => cssProperties.reduce((acc, cssProperty) => {
        acc[cssProperty] = getValue(transformer, propValue);
        return acc;
      }, {});
    }

    function resolveCssProperty(props, keys, prop, transformer) {
      // Using a hash computation over an array iteration could be faster, but with only 28 items,
      // it's doesn't worth the bundle size.
      if (keys.indexOf(prop) === -1) {
        return null;
      }

      const cssProperties = getCssProperties(prop);
      const styleFromPropValue = getStyleFromPropValue(cssProperties, transformer);
      const propValue = props[prop];
      return handleBreakpoints(props, propValue, styleFromPropValue);
    }

    function style$1(props, keys) {
      const transformer = createUnarySpacing(props.theme);
      return Object.keys(props).map(prop => resolveCssProperty(props, keys, prop, transformer)).reduce(merge, {});
    }
    process.env.NODE_ENV !== 'production' ? marginKeys.reduce((obj, key) => {
      obj[key] = responsivePropType;
      return obj;
    }, {}) : {};
    process.env.NODE_ENV !== 'production' ? paddingKeys.reduce((obj, key) => {
      obj[key] = responsivePropType;
      return obj;
    }, {}) : {};

    function spacing(props) {
      return style$1(props, spacingKeys);
    }

    spacing.propTypes = process.env.NODE_ENV !== 'production' ? spacingKeys.reduce((obj, key) => {
      obj[key] = responsivePropType;
      return obj;
    }, {}) : {};
    spacing.filterProps = spacingKeys;

    function getBorder(value) {
      if (typeof value !== 'number') {
        return value;
      }

      return `${value}px solid`;
    }

    const border = style$2({
      prop: 'border',
      themeKey: 'borders',
      transform: getBorder
    });
    const borderTop = style$2({
      prop: 'borderTop',
      themeKey: 'borders',
      transform: getBorder
    });
    const borderRight = style$2({
      prop: 'borderRight',
      themeKey: 'borders',
      transform: getBorder
    });
    const borderBottom = style$2({
      prop: 'borderBottom',
      themeKey: 'borders',
      transform: getBorder
    });
    const borderLeft = style$2({
      prop: 'borderLeft',
      themeKey: 'borders',
      transform: getBorder
    });
    const borderColor = style$2({
      prop: 'borderColor',
      themeKey: 'palette'
    });
    const borderTopColor = style$2({
      prop: 'borderTopColor',
      themeKey: 'palette'
    });
    const borderRightColor = style$2({
      prop: 'borderRightColor',
      themeKey: 'palette'
    });
    const borderBottomColor = style$2({
      prop: 'borderBottomColor',
      themeKey: 'palette'
    });
    const borderLeftColor = style$2({
      prop: 'borderLeftColor',
      themeKey: 'palette'
    });
    const borderRadius = props => {
      if (props.borderRadius !== undefined && props.borderRadius !== null) {
        const transformer = createUnaryUnit(props.theme, 'shape.borderRadius', 4, 'borderRadius');

        const styleFromPropValue = propValue => ({
          borderRadius: getValue(transformer, propValue)
        });

        return handleBreakpoints(props, props.borderRadius, styleFromPropValue);
      }

      return null;
    };
    borderRadius.propTypes = process.env.NODE_ENV !== 'production' ? {
      borderRadius: responsivePropType
    } : {};
    borderRadius.filterProps = ['borderRadius'];
    const borders = compose(border, borderTop, borderRight, borderBottom, borderLeft, borderColor, borderTopColor, borderRightColor, borderBottomColor, borderLeftColor, borderRadius);

    const displayPrint = style$2({
      prop: 'displayPrint',
      cssProperty: false,
      transform: value => ({
        '@media print': {
          display: value
        }
      })
    });
    const displayRaw = style$2({
      prop: 'display'
    });
    const overflow = style$2({
      prop: 'overflow'
    });
    const textOverflow = style$2({
      prop: 'textOverflow'
    });
    const visibility = style$2({
      prop: 'visibility'
    });
    const whiteSpace = style$2({
      prop: 'whiteSpace'
    });
    var display = compose(displayPrint, displayRaw, overflow, textOverflow, visibility, whiteSpace);

    const flexBasis = style$2({
      prop: 'flexBasis'
    });
    const flexDirection = style$2({
      prop: 'flexDirection'
    });
    const flexWrap = style$2({
      prop: 'flexWrap'
    });
    const justifyContent = style$2({
      prop: 'justifyContent'
    });
    const alignItems = style$2({
      prop: 'alignItems'
    });
    const alignContent = style$2({
      prop: 'alignContent'
    });
    const order$1 = style$2({
      prop: 'order'
    });
    const flex = style$2({
      prop: 'flex'
    });
    const flexGrow = style$2({
      prop: 'flexGrow'
    });
    const flexShrink = style$2({
      prop: 'flexShrink'
    });
    const alignSelf = style$2({
      prop: 'alignSelf'
    });
    const justifyItems = style$2({
      prop: 'justifyItems'
    });
    const justifySelf = style$2({
      prop: 'justifySelf'
    });
    const flexbox = compose(flexBasis, flexDirection, flexWrap, justifyContent, alignItems, alignContent, order$1, flex, flexGrow, flexShrink, alignSelf, justifyItems, justifySelf);

    const gap = props => {
      if (props.gap !== undefined && props.gap !== null) {
        const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'gap');

        const styleFromPropValue = propValue => ({
          gap: getValue(transformer, propValue)
        });

        return handleBreakpoints(props, props.gap, styleFromPropValue);
      }

      return null;
    };
    gap.propTypes = process.env.NODE_ENV !== 'production' ? {
      gap: responsivePropType
    } : {};
    gap.filterProps = ['gap'];
    const columnGap = props => {
      if (props.columnGap !== undefined && props.columnGap !== null) {
        const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'columnGap');

        const styleFromPropValue = propValue => ({
          columnGap: getValue(transformer, propValue)
        });

        return handleBreakpoints(props, props.columnGap, styleFromPropValue);
      }

      return null;
    };
    columnGap.propTypes = process.env.NODE_ENV !== 'production' ? {
      columnGap: responsivePropType
    } : {};
    columnGap.filterProps = ['columnGap'];
    const rowGap = props => {
      if (props.rowGap !== undefined && props.rowGap !== null) {
        const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'rowGap');

        const styleFromPropValue = propValue => ({
          rowGap: getValue(transformer, propValue)
        });

        return handleBreakpoints(props, props.rowGap, styleFromPropValue);
      }

      return null;
    };
    rowGap.propTypes = process.env.NODE_ENV !== 'production' ? {
      rowGap: responsivePropType
    } : {};
    rowGap.filterProps = ['rowGap'];
    const gridColumn = style$2({
      prop: 'gridColumn'
    });
    const gridRow = style$2({
      prop: 'gridRow'
    });
    const gridAutoFlow = style$2({
      prop: 'gridAutoFlow'
    });
    const gridAutoColumns = style$2({
      prop: 'gridAutoColumns'
    });
    const gridAutoRows = style$2({
      prop: 'gridAutoRows'
    });
    const gridTemplateColumns = style$2({
      prop: 'gridTemplateColumns'
    });
    const gridTemplateRows = style$2({
      prop: 'gridTemplateRows'
    });
    const gridTemplateAreas = style$2({
      prop: 'gridTemplateAreas'
    });
    const gridArea = style$2({
      prop: 'gridArea'
    });
    const grid = compose(gap, columnGap, rowGap, gridColumn, gridRow, gridAutoFlow, gridAutoColumns, gridAutoRows, gridTemplateColumns, gridTemplateRows, gridTemplateAreas, gridArea);

    const color = style$2({
      prop: 'color',
      themeKey: 'palette'
    });
    const bgcolor = style$2({
      prop: 'bgcolor',
      cssProperty: 'backgroundColor',
      themeKey: 'palette'
    });
    const backgroundColor = style$2({
      prop: 'backgroundColor',
      themeKey: 'palette'
    });
    const palette = compose(color, bgcolor, backgroundColor);

    const position = style$2({
      prop: 'position'
    });
    const zIndex$2 = style$2({
      prop: 'zIndex',
      themeKey: 'zIndex'
    });
    const top$1 = style$2({
      prop: 'top'
    });
    const right$1 = style$2({
      prop: 'right'
    });
    const bottom$1 = style$2({
      prop: 'bottom'
    });
    const left$1 = style$2({
      prop: 'left'
    });
    var positions = compose(position, zIndex$2, top$1, right$1, bottom$1, left$1);

    const boxShadow = style$2({
      prop: 'boxShadow',
      themeKey: 'shadows'
    });

    function transform(value) {
      return value <= 1 && value !== 0 ? `${value * 100}%` : value;
    }

    const width = style$2({
      prop: 'width',
      transform
    });
    const maxWidth = props => {
      if (props.maxWidth !== undefined && props.maxWidth !== null) {
        const styleFromPropValue = propValue => {
          var _props$theme, _props$theme$breakpoi, _props$theme$breakpoi2;

          const breakpoint = ((_props$theme = props.theme) == null ? void 0 : (_props$theme$breakpoi = _props$theme.breakpoints) == null ? void 0 : (_props$theme$breakpoi2 = _props$theme$breakpoi.values) == null ? void 0 : _props$theme$breakpoi2[propValue]) || values$1[propValue];
          return {
            maxWidth: breakpoint || transform(propValue)
          };
        };

        return handleBreakpoints(props, props.maxWidth, styleFromPropValue);
      }

      return null;
    };
    maxWidth.filterProps = ['maxWidth'];
    const minWidth = style$2({
      prop: 'minWidth',
      transform
    });
    const height = style$2({
      prop: 'height',
      transform
    });
    const maxHeight = style$2({
      prop: 'maxHeight',
      transform
    });
    const minHeight = style$2({
      prop: 'minHeight',
      transform
    });
    style$2({
      prop: 'size',
      cssProperty: 'width',
      transform
    });
    style$2({
      prop: 'size',
      cssProperty: 'height',
      transform
    });
    const boxSizing = style$2({
      prop: 'boxSizing'
    });
    const sizing = compose(width, maxWidth, minWidth, height, maxHeight, minHeight, boxSizing);

    const fontFamily = style$2({
      prop: 'fontFamily',
      themeKey: 'typography'
    });
    const fontSize = style$2({
      prop: 'fontSize',
      themeKey: 'typography'
    });
    const fontStyle = style$2({
      prop: 'fontStyle',
      themeKey: 'typography'
    });
    const fontWeight = style$2({
      prop: 'fontWeight',
      themeKey: 'typography'
    });
    const letterSpacing = style$2({
      prop: 'letterSpacing'
    });
    const textTransform = style$2({
      prop: 'textTransform'
    });
    const lineHeight = style$2({
      prop: 'lineHeight'
    });
    const textAlign = style$2({
      prop: 'textAlign'
    });
    const typographyVariant = style$2({
      prop: 'typography',
      cssProperty: false,
      themeKey: 'typography'
    });
    const typography = compose(typographyVariant, fontFamily, fontSize, fontStyle, fontWeight, letterSpacing, lineHeight, textAlign, textTransform);

    const filterPropsMapping = {
      borders: borders.filterProps,
      display: display.filterProps,
      flexbox: flexbox.filterProps,
      grid: grid.filterProps,
      positions: positions.filterProps,
      palette: palette.filterProps,
      shadows: boxShadow.filterProps,
      sizing: sizing.filterProps,
      spacing: spacing.filterProps,
      typography: typography.filterProps
    };
    const styleFunctionMapping = {
      borders,
      display,
      flexbox,
      grid,
      positions,
      palette,
      shadows: boxShadow,
      sizing,
      spacing,
      typography
    };
    const propToStyleFunction = Object.keys(filterPropsMapping).reduce((acc, styleFnName) => {
      filterPropsMapping[styleFnName].forEach(propName => {
        acc[propName] = styleFunctionMapping[styleFnName];
      });
      return acc;
    }, {});

    function objectsHaveSameKeys(...objects) {
      const allKeys = objects.reduce((keys, object) => keys.concat(Object.keys(object)), []);
      const union = new Set(allKeys);
      return objects.every(object => union.size === Object.keys(object).length);
    }

    function callIfFn(maybeFn, arg) {
      return typeof maybeFn === 'function' ? maybeFn(arg) : maybeFn;
    } // eslint-disable-next-line @typescript-eslint/naming-convention


    function unstable_createStyleFunctionSx(styleFunctionMapping$1 = styleFunctionMapping) {
      const propToStyleFunction = Object.keys(styleFunctionMapping$1).reduce((acc, styleFnName) => {
        styleFunctionMapping$1[styleFnName].filterProps.forEach(propName => {
          acc[propName] = styleFunctionMapping$1[styleFnName];
        });
        return acc;
      }, {});

      function getThemeValue(prop, value, theme) {
        const inputProps = {
          [prop]: value,
          theme
        };
        const styleFunction = propToStyleFunction[prop];
        return styleFunction ? styleFunction(inputProps) : {
          [prop]: value
        };
      }

      function styleFunctionSx(props) {
        const {
          sx,
          theme = {}
        } = props || {};

        if (!sx) {
          return null; // emotion & styled-components will neglect null
        }
        /*
         * Receive `sxInput` as object or callback
         * and then recursively check keys & values to create media query object styles.
         * (the result will be used in `styled`)
         */


        function traverse(sxInput) {
          let sxObject = sxInput;

          if (typeof sxInput === 'function') {
            sxObject = sxInput(theme);
          } else if (typeof sxInput !== 'object') {
            // value
            return sxInput;
          }

          if (!sxObject) {
            return null;
          }

          const emptyBreakpoints = createEmptyBreakpointObject(theme.breakpoints);
          const breakpointsKeys = Object.keys(emptyBreakpoints);
          let css = emptyBreakpoints;
          Object.keys(sxObject).forEach(styleKey => {
            const value = callIfFn(sxObject[styleKey], theme);

            if (value !== null && value !== undefined) {
              if (typeof value === 'object') {
                if (propToStyleFunction[styleKey]) {
                  css = merge(css, getThemeValue(styleKey, value, theme));
                } else {
                  const breakpointsValues = handleBreakpoints({
                    theme
                  }, value, x => ({
                    [styleKey]: x
                  }));

                  if (objectsHaveSameKeys(breakpointsValues, value)) {
                    css[styleKey] = styleFunctionSx({
                      sx: value,
                      theme
                    });
                  } else {
                    css = merge(css, breakpointsValues);
                  }
                }
              } else {
                css = merge(css, getThemeValue(styleKey, value, theme));
              }
            }
          });
          return removeUnusedBreakpoints(breakpointsKeys, css);
        }

        return Array.isArray(sx) ? sx.map(traverse) : traverse(sx);
      }

      return styleFunctionSx;
    }
    const styleFunctionSx = unstable_createStyleFunctionSx();
    styleFunctionSx.filterProps = ['sx'];

    const _excluded$P = ["sx"];

    const splitProps = props => {
      const result = {
        systemProps: {},
        otherProps: {}
      };
      Object.keys(props).forEach(prop => {
        if (propToStyleFunction[prop]) {
          result.systemProps[prop] = props[prop];
        } else {
          result.otherProps[prop] = props[prop];
        }
      });
      return result;
    };

    function extendSxProp(props) {
      const {
        sx: inSx
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$P);

      const {
        systemProps,
        otherProps
      } = splitProps(other);
      let finalSx;

      if (Array.isArray(inSx)) {
        finalSx = [systemProps, ...inSx];
      } else if (typeof inSx === 'function') {
        finalSx = (...args) => {
          const result = inSx(...args);

          if (!isPlainObject(result)) {
            return systemProps;
          }

          return _extends$1({}, systemProps, result);
        };
      } else {
        finalSx = _extends$1({}, systemProps, inSx);
      }

      return _extends$1({}, otherProps, {
        sx: finalSx
      });
    }

    function toVal(mix) {
    	var k, y, str='';

    	if (typeof mix === 'string' || typeof mix === 'number') {
    		str += mix;
    	} else if (typeof mix === 'object') {
    		if (Array.isArray(mix)) {
    			for (k=0; k < mix.length; k++) {
    				if (mix[k]) {
    					if (y = toVal(mix[k])) {
    						str && (str += ' ');
    						str += y;
    					}
    				}
    			}
    		} else {
    			for (k in mix) {
    				if (mix[k]) {
    					str && (str += ' ');
    					str += k;
    				}
    			}
    		}
    	}

    	return str;
    }

    function clsx () {
    	var i=0, tmp, x, str='';
    	while (i < arguments.length) {
    		if (tmp = arguments[i++]) {
    			if (x = toVal(tmp)) {
    				str && (str += ' ');
    				str += x;
    			}
    		}
    	}
    	return str;
    }

    const _excluded$O = ["values", "unit", "step"];

    const sortBreakpointsValues = values => {
      const breakpointsAsArray = Object.keys(values).map(key => ({
        key,
        val: values[key]
      })) || []; // Sort in ascending order

      breakpointsAsArray.sort((breakpoint1, breakpoint2) => breakpoint1.val - breakpoint2.val);
      return breakpointsAsArray.reduce((acc, obj) => {
        return _extends$1({}, acc, {
          [obj.key]: obj.val
        });
      }, {});
    }; // Keep in mind that @media is inclusive by the CSS specification.


    function createBreakpoints(breakpoints) {
      const {
        // The breakpoint **start** at this value.
        // For instance with the first breakpoint xs: [xs, sm).
        values = {
          xs: 0,
          // phone
          sm: 600,
          // tablet
          md: 900,
          // small laptop
          lg: 1200,
          // desktop
          xl: 1536 // large screen

        },
        unit = 'px',
        step = 5
      } = breakpoints,
            other = _objectWithoutPropertiesLoose(breakpoints, _excluded$O);

      const sortedValues = sortBreakpointsValues(values);
      const keys = Object.keys(sortedValues);

      function up(key) {
        const value = typeof values[key] === 'number' ? values[key] : key;
        return `@media (min-width:${value}${unit})`;
      }

      function down(key) {
        const value = typeof values[key] === 'number' ? values[key] : key;
        return `@media (max-width:${value - step / 100}${unit})`;
      }

      function between(start, end) {
        const endIndex = keys.indexOf(end);
        return `@media (min-width:${typeof values[start] === 'number' ? values[start] : start}${unit}) and ` + `(max-width:${(endIndex !== -1 && typeof values[keys[endIndex]] === 'number' ? values[keys[endIndex]] : end) - step / 100}${unit})`;
      }

      function only(key) {
        if (keys.indexOf(key) + 1 < keys.length) {
          return between(key, keys[keys.indexOf(key) + 1]);
        }

        return up(key);
      }

      function not(key) {
        // handle first and last key separately, for better readability
        const keyIndex = keys.indexOf(key);

        if (keyIndex === 0) {
          return up(keys[1]);
        }

        if (keyIndex === keys.length - 1) {
          return down(keys[keyIndex]);
        }

        return between(key, keys[keys.indexOf(key) + 1]).replace('@media', '@media not all and');
      }

      return _extends$1({
        keys,
        values: sortedValues,
        up,
        down,
        between,
        only,
        not,
        unit
      }, other);
    }

    const shape = {
      borderRadius: 4
    };

    /* tslint:enable:unified-signatures */
    function createSpacing(spacingInput = 8) {
      // Already transformed.
      if (spacingInput.mui) {
        return spacingInput;
      } // Material Design layouts are visually balanced. Most measurements align to an 8dp grid, which aligns both spacing and the overall layout.
      // Smaller components, such as icons, can align to a 4dp grid.
      // https://material.io/design/layout/understanding-layout.html#usage


      const transform = createUnarySpacing({
        spacing: spacingInput
      });

      const spacing = (...argsInput) => {
        if (process.env.NODE_ENV !== 'production') {
          if (!(argsInput.length <= 4)) {
            console.error(`MUI: Too many arguments provided, expected between 0 and 4, got ${argsInput.length}`);
          }
        }

        const args = argsInput.length === 0 ? [1] : argsInput;
        return args.map(argument => {
          const output = transform(argument);
          return typeof output === 'number' ? `${output}px` : output;
        }).join(' ');
      };

      spacing.mui = true;
      return spacing;
    }

    const _excluded$N = ["breakpoints", "palette", "spacing", "shape"];

    function createTheme$1(options = {}, ...args) {
      const {
        breakpoints: breakpointsInput = {},
        palette: paletteInput = {},
        spacing: spacingInput,
        shape: shapeInput = {}
      } = options,
            other = _objectWithoutPropertiesLoose(options, _excluded$N);

      const breakpoints = createBreakpoints(breakpointsInput);
      const spacing = createSpacing(spacingInput);
      let muiTheme = deepmerge({
        breakpoints,
        direction: 'ltr',
        components: {},
        // Inject component definitions.
        palette: _extends$1({
          mode: 'light'
        }, paletteInput),
        spacing,
        shape: _extends$1({}, shape, shapeInput)
      }, other);
      muiTheme = args.reduce((acc, argument) => deepmerge(acc, argument), muiTheme);
      return muiTheme;
    }

    const ThemeContext = /*#__PURE__*/react.exports.createContext(null);

    if (process.env.NODE_ENV !== 'production') {
      ThemeContext.displayName = 'ThemeContext';
    }

    function useTheme$3() {
      const theme = react.exports.useContext(ThemeContext);

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        react.exports.useDebugValue(theme);
      }

      return theme;
    }

    const hasSymbol = typeof Symbol === 'function' && Symbol.for;
    var nested = hasSymbol ? Symbol.for('mui.nested') : '__THEME_NESTED__';

    function mergeOuterLocalTheme(outerTheme, localTheme) {
      if (typeof localTheme === 'function') {
        const mergedTheme = localTheme(outerTheme);

        if (process.env.NODE_ENV !== 'production') {
          if (!mergedTheme) {
            console.error(['MUI: You should return an object from your theme function, i.e.', '<ThemeProvider theme={() => ({})} />'].join('\n'));
          }
        }

        return mergedTheme;
      }

      return _extends$1({}, outerTheme, localTheme);
    }
    /**
     * This component takes a `theme` prop.
     * It makes the `theme` available down the React tree thanks to React context.
     * This component should preferably be used at **the root of your component tree**.
     */


    function ThemeProvider$1(props) {
      const {
        children,
        theme: localTheme
      } = props;
      const outerTheme = useTheme$3();

      if (process.env.NODE_ENV !== 'production') {
        if (outerTheme === null && typeof localTheme === 'function') {
          console.error(['MUI: You are providing a theme function prop to the ThemeProvider component:', '<ThemeProvider theme={outerTheme => outerTheme} />', '', 'However, no outer theme is present.', 'Make sure a theme is already injected higher in the React tree ' + 'or provide a theme object.'].join('\n'));
        }
      }

      const theme = react.exports.useMemo(() => {
        const output = outerTheme === null ? localTheme : mergeOuterLocalTheme(outerTheme, localTheme);

        if (output != null) {
          output[nested] = outerTheme !== null;
        }

        return output;
      }, [localTheme, outerTheme]);
      return /*#__PURE__*/jsxRuntimeExports.jsx(ThemeContext.Provider, {
        value: theme,
        children: children
      });
    }

    process.env.NODE_ENV !== "production" ? ThemeProvider$1.propTypes = {
      /**
       * Your component tree.
       */
      children: propTypes.exports.node,

      /**
       * A theme object. You can provide a function to extend the outer theme.
       */
      theme: propTypes.exports.oneOfType([propTypes.exports.object, propTypes.exports.func]).isRequired
    } : void 0;

    if (process.env.NODE_ENV !== 'production') {
      process.env.NODE_ENV !== "production" ? ThemeProvider$1.propTypes = exactProp(ThemeProvider$1.propTypes) : void 0;
    }

    function isObjectEmpty(obj) {
      return Object.keys(obj).length === 0;
    }

    function useTheme$2(defaultTheme = null) {
      const contextTheme = useTheme$3();
      return !contextTheme || isObjectEmpty(contextTheme) ? defaultTheme : contextTheme;
    }

    const systemDefaultTheme$1 = createTheme$1();

    function useTheme$1(defaultTheme = systemDefaultTheme$1) {
      return useTheme$2(defaultTheme);
    }

    const _excluded$M = ["className", "component"];
    function createBox(options = {}) {
      const {
        defaultTheme,
        defaultClassName = 'MuiBox-root',
        generateClassName,
        styleFunctionSx: styleFunctionSx$1 = styleFunctionSx
      } = options;
      const BoxRoot = styled$2('div')(styleFunctionSx$1);
      const Box = /*#__PURE__*/react.exports.forwardRef(function Box(inProps, ref) {
        const theme = useTheme$1(defaultTheme);

        const _extendSxProp = extendSxProp(inProps),
              {
          className,
          component = 'div'
        } = _extendSxProp,
              other = _objectWithoutPropertiesLoose(_extendSxProp, _excluded$M);

        return /*#__PURE__*/jsxRuntimeExports.jsx(BoxRoot, _extends$1({
          as: component,
          ref: ref,
          className: clsx(className, generateClassName ? generateClassName(defaultClassName) : defaultClassName),
          theme: theme
        }, other));
      });
      process.env.NODE_ENV !== "production" ? Box.propTypes
      /* remove-proptypes */
      = {
        // ----------------------------- Warning --------------------------------
        // | These PropTypes are generated from the TypeScript type definitions |
        // |     To update them edit the d.ts file and run "yarn proptypes"     |
        // ----------------------------------------------------------------------

        /**
         * @ignore
         */
        children: propTypes.exports.node,

        /**
         * The component used for the root node.
         * Either a string to use a HTML element or a component.
         */
        component: propTypes.exports.elementType,

        /**
         * @ignore
         */
        sx: propTypes.exports.oneOfType([propTypes.exports.object, propTypes.exports.array, propTypes.exports.func])
      } : void 0;
      return Box;
    }

    createBox();

    const _excluded$L = ["variant"];

    function isEmpty$2(string) {
      return string.length === 0;
    }
    /**
     * Generates string classKey based on the properties provided. It starts with the
     * variant if defined, and then it appends all other properties in alphabetical order.
     * @param {object} props - the properties for which the classKey should be created.
     */


    function propsToClassKey(props) {
      const {
        variant
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$L);

      let classKey = variant || '';
      Object.keys(other).sort().forEach(key => {
        if (key === 'color') {
          classKey += isEmpty$2(classKey) ? props[key] : capitalize(props[key]);
        } else {
          classKey += `${isEmpty$2(classKey) ? key : capitalize(key)}${capitalize(props[key].toString())}`;
        }
      });
      return classKey;
    }

    const _excluded$K = ["name", "slot", "skipVariantsResolver", "skipSx", "overridesResolver"],
          _excluded2$4 = ["theme"],
          _excluded3 = ["theme"];

    function isEmpty$1(obj) {
      return Object.keys(obj).length === 0;
    }

    const getStyleOverrides = (name, theme) => {
      if (theme.components && theme.components[name] && theme.components[name].styleOverrides) {
        return theme.components[name].styleOverrides;
      }

      return null;
    };

    const getVariantStyles = (name, theme) => {
      let variants = [];

      if (theme && theme.components && theme.components[name] && theme.components[name].variants) {
        variants = theme.components[name].variants;
      }

      const variantsStyles = {};
      variants.forEach(definition => {
        const key = propsToClassKey(definition.props);
        variantsStyles[key] = definition.style;
      });
      return variantsStyles;
    };

    const variantsResolver = (props, styles, theme, name) => {
      var _theme$components, _theme$components$nam;

      const {
        ownerState = {}
      } = props;
      const variantsStyles = [];
      const themeVariants = theme == null ? void 0 : (_theme$components = theme.components) == null ? void 0 : (_theme$components$nam = _theme$components[name]) == null ? void 0 : _theme$components$nam.variants;

      if (themeVariants) {
        themeVariants.forEach(themeVariant => {
          let isMatch = true;
          Object.keys(themeVariant.props).forEach(key => {
            if (ownerState[key] !== themeVariant.props[key] && props[key] !== themeVariant.props[key]) {
              isMatch = false;
            }
          });

          if (isMatch) {
            variantsStyles.push(styles[propsToClassKey(themeVariant.props)]);
          }
        });
      }

      return variantsStyles;
    }; // Update /system/styled/#api in case if this changes


    function shouldForwardProp(prop) {
      return prop !== 'ownerState' && prop !== 'theme' && prop !== 'sx' && prop !== 'as';
    }
    const systemDefaultTheme = createTheme$1();

    const lowercaseFirstLetter = string => {
      return string.charAt(0).toLowerCase() + string.slice(1);
    };

    function createStyled(input = {}) {
      const {
        defaultTheme = systemDefaultTheme,
        rootShouldForwardProp = shouldForwardProp,
        slotShouldForwardProp = shouldForwardProp,
        styleFunctionSx: styleFunctionSx$1 = styleFunctionSx
      } = input;
      return (tag, inputOptions = {}) => {
        const {
          name: componentName,
          slot: componentSlot,
          skipVariantsResolver: inputSkipVariantsResolver,
          skipSx: inputSkipSx,
          overridesResolver
        } = inputOptions,
              options = _objectWithoutPropertiesLoose(inputOptions, _excluded$K); // if skipVariantsResolver option is defined, take the value, otherwise, true for root and false for other slots.


        const skipVariantsResolver = inputSkipVariantsResolver !== undefined ? inputSkipVariantsResolver : componentSlot && componentSlot !== 'Root' || false;
        const skipSx = inputSkipSx || false;
        let label;

        if (process.env.NODE_ENV !== 'production') {
          if (componentName) {
            label = `${componentName}-${lowercaseFirstLetter(componentSlot || 'Root')}`;
          }
        }

        let shouldForwardPropOption = shouldForwardProp;

        if (componentSlot === 'Root') {
          shouldForwardPropOption = rootShouldForwardProp;
        } else if (componentSlot) {
          // any other slot specified
          shouldForwardPropOption = slotShouldForwardProp;
        }

        const defaultStyledResolver = styled$2(tag, _extends$1({
          shouldForwardProp: shouldForwardPropOption,
          label
        }, options));

        const muiStyledResolver = (styleArg, ...expressions) => {
          const expressionsWithDefaultTheme = expressions ? expressions.map(stylesArg => {
            // On the server emotion doesn't use React.forwardRef for creating components, so the created
            // component stays as a function. This condition makes sure that we do not interpolate functions
            // which are basically components used as a selectors.
            // eslint-disable-next-line no-underscore-dangle
            return typeof stylesArg === 'function' && stylesArg.__emotion_real !== stylesArg ? _ref => {
              let {
                theme: themeInput
              } = _ref,
                  other = _objectWithoutPropertiesLoose(_ref, _excluded2$4);

              return stylesArg(_extends$1({
                theme: isEmpty$1(themeInput) ? defaultTheme : themeInput
              }, other));
            } : stylesArg;
          }) : [];
          let transformedStyleArg = styleArg;

          if (componentName && overridesResolver) {
            expressionsWithDefaultTheme.push(props => {
              const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
              const styleOverrides = getStyleOverrides(componentName, theme);

              if (styleOverrides) {
                const resolvedStyleOverrides = {};
                Object.entries(styleOverrides).forEach(([slotKey, slotStyle]) => {
                  resolvedStyleOverrides[slotKey] = typeof slotStyle === 'function' ? slotStyle(props) : slotStyle;
                });
                return overridesResolver(props, resolvedStyleOverrides);
              }

              return null;
            });
          }

          if (componentName && !skipVariantsResolver) {
            expressionsWithDefaultTheme.push(props => {
              const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
              return variantsResolver(props, getVariantStyles(componentName, theme), theme, componentName);
            });
          }

          if (!skipSx) {
            expressionsWithDefaultTheme.push(props => {
              const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
              return styleFunctionSx$1(_extends$1({}, props, {
                theme
              }));
            });
          }

          const numOfCustomFnsApplied = expressionsWithDefaultTheme.length - expressions.length;

          if (Array.isArray(styleArg) && numOfCustomFnsApplied > 0) {
            const placeholders = new Array(numOfCustomFnsApplied).fill(''); // If the type is array, than we need to add placeholders in the template for the overrides, variants and the sx styles.

            transformedStyleArg = [...styleArg, ...placeholders];
            transformedStyleArg.raw = [...styleArg.raw, ...placeholders];
          } else if (typeof styleArg === 'function' && // On the server emotion doesn't use React.forwardRef for creating components, so the created
          // component stays as a function. This condition makes sure that we do not interpolate functions
          // which are basically components used as a selectors.
          // eslint-disable-next-line no-underscore-dangle
          styleArg.__emotion_real !== styleArg) {
            // If the type is function, we need to define the default theme.
            transformedStyleArg = _ref2 => {
              let {
                theme: themeInput
              } = _ref2,
                  other = _objectWithoutPropertiesLoose(_ref2, _excluded3);

              return styleArg(_extends$1({
                theme: isEmpty$1(themeInput) ? defaultTheme : themeInput
              }, other));
            };
          }

          const Component = defaultStyledResolver(transformedStyleArg, ...expressionsWithDefaultTheme);

          if (process.env.NODE_ENV !== 'production') {
            let displayName;

            if (componentName) {
              displayName = `${componentName}${componentSlot || ''}`;
            }

            if (displayName === undefined) {
              displayName = `Styled(${getDisplayName(tag)})`;
            }

            Component.displayName = displayName;
          }

          return Component;
        };

        if (defaultStyledResolver.withConfig) {
          muiStyledResolver.withConfig = defaultStyledResolver.withConfig;
        }

        return muiStyledResolver;
      };
    }

    function getThemeProps(params) {
      const {
        theme,
        name,
        props
      } = params;

      if (!theme || !theme.components || !theme.components[name] || !theme.components[name].defaultProps) {
        return props;
      }

      return resolveProps(theme.components[name].defaultProps, props);
    }

    function useThemeProps$1({
      props,
      name,
      defaultTheme
    }) {
      const theme = useTheme$1(defaultTheme);
      const mergedProps = getThemeProps({
        theme,
        name,
        props
      });
      return mergedProps;
    }

    /**
     * Returns a number whose value is limited to the given range.
     * @param {number} value The value to be clamped
     * @param {number} min The lower boundary of the output range
     * @param {number} max The upper boundary of the output range
     * @returns {number} A number in the range [min, max]
     */
    function clamp(value, min = 0, max = 1) {
      if (process.env.NODE_ENV !== 'production') {
        if (value < min || value > max) {
          console.error(`MUI: The value provided ${value} is out of range [${min}, ${max}].`);
        }
      }

      return Math.min(Math.max(min, value), max);
    }
    /**
     * Converts a color from CSS hex format to CSS rgb format.
     * @param {string} color - Hex color, i.e. #nnn or #nnnnnn
     * @returns {string} A CSS rgb color string
     */


    function hexToRgb(color) {
      color = color.substr(1);
      const re = new RegExp(`.{1,${color.length >= 6 ? 2 : 1}}`, 'g');
      let colors = color.match(re);

      if (colors && colors[0].length === 1) {
        colors = colors.map(n => n + n);
      }

      return colors ? `rgb${colors.length === 4 ? 'a' : ''}(${colors.map((n, index) => {
    return index < 3 ? parseInt(n, 16) : Math.round(parseInt(n, 16) / 255 * 1000) / 1000;
  }).join(', ')})` : '';
    }
    /**
     * Returns an object with the type and values of a color.
     *
     * Note: Does not support rgb % values.
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
     * @returns {object} - A MUI color object: {type: string, values: number[]}
     */


    function decomposeColor(color) {
      // Idempotent
      if (color.type) {
        return color;
      }

      if (color.charAt(0) === '#') {
        return decomposeColor(hexToRgb(color));
      }

      const marker = color.indexOf('(');
      const type = color.substring(0, marker);

      if (['rgb', 'rgba', 'hsl', 'hsla', 'color'].indexOf(type) === -1) {
        throw new Error(process.env.NODE_ENV !== "production" ? `MUI: Unsupported \`${color}\` color.
The following formats are supported: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color().` : formatMuiErrorMessage(9, color));
      }

      let values = color.substring(marker + 1, color.length - 1);
      let colorSpace;

      if (type === 'color') {
        values = values.split(' ');
        colorSpace = values.shift();

        if (values.length === 4 && values[3].charAt(0) === '/') {
          values[3] = values[3].substr(1);
        }

        if (['srgb', 'display-p3', 'a98-rgb', 'prophoto-rgb', 'rec-2020'].indexOf(colorSpace) === -1) {
          throw new Error(process.env.NODE_ENV !== "production" ? `MUI: unsupported \`${colorSpace}\` color space.
The following color spaces are supported: srgb, display-p3, a98-rgb, prophoto-rgb, rec-2020.` : formatMuiErrorMessage(10, colorSpace));
        }
      } else {
        values = values.split(',');
      }

      values = values.map(value => parseFloat(value));
      return {
        type,
        values,
        colorSpace
      };
    }
    /**
     * Converts a color object with type and values to a string.
     * @param {object} color - Decomposed color
     * @param {string} color.type - One of: 'rgb', 'rgba', 'hsl', 'hsla'
     * @param {array} color.values - [n,n,n] or [n,n,n,n]
     * @returns {string} A CSS color string
     */

    function recomposeColor(color) {
      const {
        type,
        colorSpace
      } = color;
      let {
        values
      } = color;

      if (type.indexOf('rgb') !== -1) {
        // Only convert the first 3 values to int (i.e. not alpha)
        values = values.map((n, i) => i < 3 ? parseInt(n, 10) : n);
      } else if (type.indexOf('hsl') !== -1) {
        values[1] = `${values[1]}%`;
        values[2] = `${values[2]}%`;
      }

      if (type.indexOf('color') !== -1) {
        values = `${colorSpace} ${values.join(' ')}`;
      } else {
        values = `${values.join(', ')}`;
      }

      return `${type}(${values})`;
    }
    /**
     * Converts a color from hsl format to rgb format.
     * @param {string} color - HSL color values
     * @returns {string} rgb color values
     */

    function hslToRgb(color) {
      color = decomposeColor(color);
      const {
        values
      } = color;
      const h = values[0];
      const s = values[1] / 100;
      const l = values[2] / 100;
      const a = s * Math.min(l, 1 - l);

      const f = (n, k = (n + h / 30) % 12) => l - a * Math.max(Math.min(k - 3, 9 - k, 1), -1);

      let type = 'rgb';
      const rgb = [Math.round(f(0) * 255), Math.round(f(8) * 255), Math.round(f(4) * 255)];

      if (color.type === 'hsla') {
        type += 'a';
        rgb.push(values[3]);
      }

      return recomposeColor({
        type,
        values: rgb
      });
    }
    /**
     * The relative brightness of any point in a color space,
     * normalized to 0 for darkest black and 1 for lightest white.
     *
     * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
     * @returns {number} The relative brightness of the color in the range 0 - 1
     */

    function getLuminance(color) {
      color = decomposeColor(color);
      let rgb = color.type === 'hsl' ? decomposeColor(hslToRgb(color)).values : color.values;
      rgb = rgb.map(val => {
        if (color.type !== 'color') {
          val /= 255; // normalized
        }

        return val <= 0.03928 ? val / 12.92 : ((val + 0.055) / 1.055) ** 2.4;
      }); // Truncate at 3 digits

      return Number((0.2126 * rgb[0] + 0.7152 * rgb[1] + 0.0722 * rgb[2]).toFixed(3));
    }
    /**
     * Calculates the contrast ratio between two colors.
     *
     * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
     * @param {string} foreground - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
     * @param {string} background - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
     * @returns {number} A contrast ratio value in the range 0 - 21.
     */

    function getContrastRatio(foreground, background) {
      const lumA = getLuminance(foreground);
      const lumB = getLuminance(background);
      return (Math.max(lumA, lumB) + 0.05) / (Math.min(lumA, lumB) + 0.05);
    }
    /**
     * Sets the absolute transparency of a color.
     * Any existing alpha values are overwritten.
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
     * @param {number} value - value to set the alpha channel to in the range 0 - 1
     * @returns {string} A CSS color string. Hex input values are returned as rgb
     */

    function alpha(color, value) {
      color = decomposeColor(color);
      value = clamp(value);

      if (color.type === 'rgb' || color.type === 'hsl') {
        color.type += 'a';
      }

      if (color.type === 'color') {
        color.values[3] = `/${value}`;
      } else {
        color.values[3] = value;
      }

      return recomposeColor(color);
    }
    /**
     * Darkens a color.
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
     * @param {number} coefficient - multiplier in the range 0 - 1
     * @returns {string} A CSS color string. Hex input values are returned as rgb
     */

    function darken(color, coefficient) {
      color = decomposeColor(color);
      coefficient = clamp(coefficient);

      if (color.type.indexOf('hsl') !== -1) {
        color.values[2] *= 1 - coefficient;
      } else if (color.type.indexOf('rgb') !== -1 || color.type.indexOf('color') !== -1) {
        for (let i = 0; i < 3; i += 1) {
          color.values[i] *= 1 - coefficient;
        }
      }

      return recomposeColor(color);
    }
    /**
     * Lightens a color.
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
     * @param {number} coefficient - multiplier in the range 0 - 1
     * @returns {string} A CSS color string. Hex input values are returned as rgb
     */

    function lighten(color, coefficient) {
      color = decomposeColor(color);
      coefficient = clamp(coefficient);

      if (color.type.indexOf('hsl') !== -1) {
        color.values[2] += (100 - color.values[2]) * coefficient;
      } else if (color.type.indexOf('rgb') !== -1) {
        for (let i = 0; i < 3; i += 1) {
          color.values[i] += (255 - color.values[i]) * coefficient;
        }
      } else if (color.type.indexOf('color') !== -1) {
        for (let i = 0; i < 3; i += 1) {
          color.values[i] += (1 - color.values[i]) * coefficient;
        }
      }

      return recomposeColor(color);
    }
    /**
     * Darken or lighten a color, depending on its luminance.
     * Light colors are darkened, dark colors are lightened.
     * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
     * @param {number} coefficient=0.15 - multiplier in the range 0 - 1
     * @returns {string} A CSS color string. Hex input values are returned as rgb
     */

    function emphasize(color, coefficient = 0.15) {
      return getLuminance(color) > 0.5 ? darken(color, coefficient) : lighten(color, coefficient);
    }

    function InnerThemeProvider(props) {
      const theme = useTheme$1();
      return /*#__PURE__*/jsxRuntimeExports.jsx(ThemeContext$1.Provider, {
        value: typeof theme === 'object' ? theme : {},
        children: props.children
      });
    }

    process.env.NODE_ENV !== "production" ? InnerThemeProvider.propTypes = {
      /**
       * Your component tree.
       */
      children: propTypes.exports.node
    } : void 0;
    /**
     * This component makes the `theme` available down the React tree.
     * It should preferably be used at **the root of your component tree**.
     */

    function ThemeProvider(props) {
      const {
        children,
        theme: localTheme
      } = props;
      return /*#__PURE__*/jsxRuntimeExports.jsx(ThemeProvider$1, {
        theme: localTheme,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(InnerThemeProvider, {
          children: children
        })
      });
    }

    process.env.NODE_ENV !== "production" ? ThemeProvider.propTypes = {
      /**
       * Your component tree.
       */
      children: propTypes.exports.node,

      /**
       * A theme object. You can provide a function to extend the outer theme.
       */
      theme: propTypes.exports.oneOfType([propTypes.exports.object, propTypes.exports.func]).isRequired
    } : void 0;

    if (process.env.NODE_ENV !== 'production') {
      process.env.NODE_ENV !== "production" ? ThemeProvider.propTypes = exactProp(ThemeProvider.propTypes) : void 0;
    }

    /**
     * Determines if a given element is a DOM element name (i.e. not a React component).
     */
    function isHostComponent(element) {
      return typeof element === 'string';
    }

    function composeClasses(slots, getUtilityClass, classes) {
      const output = {};
      Object.keys(slots).forEach( // `Objet.keys(slots)` can't be wider than `T` because we infer `T` from `slots`.
      // @ts-expect-error https://github.com/microsoft/TypeScript/pull/12253#issuecomment-263132208
      slot => {
        output[slot] = slots[slot].reduce((acc, key) => {
          if (key) {
            if (classes && classes[key]) {
              acc.push(classes[key]);
            }

            acc.push(getUtilityClass(key));
          }

          return acc;
        }, []).join(' ');
      });
      return output;
    }

    const defaultGenerator = componentName => componentName;

    const createClassNameGenerator = () => {
      let generate = defaultGenerator;
      return {
        configure(generator) {
          generate = generator;
        },

        generate(componentName) {
          return generate(componentName);
        },

        reset() {
          generate = defaultGenerator;
        }

      };
    };

    const ClassNameGenerator = createClassNameGenerator();
    var ClassNameGenerator$1 = ClassNameGenerator;

    const globalStateClassesMapping = {
      active: 'Mui-active',
      checked: 'Mui-checked',
      completed: 'Mui-completed',
      disabled: 'Mui-disabled',
      error: 'Mui-error',
      expanded: 'Mui-expanded',
      focused: 'Mui-focused',
      focusVisible: 'Mui-focusVisible',
      required: 'Mui-required',
      selected: 'Mui-selected'
    };
    function generateUtilityClass(componentName, slot) {
      const globalStateClass = globalStateClassesMapping[slot];
      return globalStateClass || `${ClassNameGenerator$1.generate(componentName)}-${slot}`;
    }

    function generateUtilityClasses(componentName, slots) {
      const result = {};
      slots.forEach(slot => {
        result[slot] = generateUtilityClass(componentName, slot);
      });
      return result;
    }

    function getBackdropUtilityClass(slot) {
      return generateUtilityClass('MuiBackdrop', slot);
    }
    generateUtilityClasses('MuiBackdrop', ['root', 'invisible']);

    const _excluded$J = ["classes", "className", "invisible", "component", "components", "componentsProps", "theme"];

    const useUtilityClasses$v = ownerState => {
      const {
        classes,
        invisible
      } = ownerState;
      const slots = {
        root: ['root', invisible && 'invisible']
      };
      return composeClasses(slots, getBackdropUtilityClass, classes);
    };

    const BackdropUnstyled = /*#__PURE__*/react.exports.forwardRef(function BackdropUnstyled(props, ref) {
      const {
        classes: classesProp,
        className,
        invisible = false,
        component = 'div',
        components = {},
        componentsProps = {},

        /* eslint-disable react/prop-types */
        theme
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$J);

      const ownerState = _extends$1({}, props, {
        classes: classesProp,
        invisible
      });

      const classes = useUtilityClasses$v(ownerState);
      const Root = components.Root || component;
      const rootProps = componentsProps.root || {};
      return /*#__PURE__*/jsxRuntimeExports.jsx(Root, _extends$1({
        "aria-hidden": true
      }, rootProps, !isHostComponent(Root) && {
        as: component,
        ownerState: _extends$1({}, ownerState, rootProps.ownerState),
        theme
      }, {
        ref: ref
      }, other, {
        className: clsx(classes.root, rootProps.className, className)
      }));
    });
    process.env.NODE_ENV !== "production" ? BackdropUnstyled.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * The components used for each slot inside the Backdrop.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Backdrop.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        root: propTypes.exports.object
      }),

      /**
       * If `true`, the backdrop is invisible.
       * It can be used when rendering a popover or a custom select component.
       * @default false
       */
      invisible: propTypes.exports.bool
    } : void 0;
    var BackdropUnstyled$1 = BackdropUnstyled;

    function mapEventPropToEvent(eventProp) {
      return eventProp.substring(2).toLowerCase();
    }

    function clickedRootScrollbar(event, doc) {
      return doc.documentElement.clientWidth < event.clientX || doc.documentElement.clientHeight < event.clientY;
    }

    /**
     * Listen for click events that occur somewhere in the document, outside of the element itself.
     * For instance, if you need to hide a menu when people click anywhere else on your page.
     *
     * Demos:
     *
     * - [Click Away Listener](https://mui.com/components/click-away-listener/)
     * - [Menus](https://mui.com/components/menus/)
     *
     * API:
     *
     * - [ClickAwayListener API](https://mui.com/api/click-away-listener/)
     */
    function ClickAwayListener(props) {
      const {
        children,
        disableReactTree = false,
        mouseEvent = 'onClick',
        onClickAway,
        touchEvent = 'onTouchEnd'
      } = props;
      const movedRef = react.exports.useRef(false);
      const nodeRef = react.exports.useRef(null);
      const activatedRef = react.exports.useRef(false);
      const syntheticEventRef = react.exports.useRef(false);
      react.exports.useEffect(() => {
        // Ensure that this component is not "activated" synchronously.
        // https://github.com/facebook/react/issues/20074
        setTimeout(() => {
          activatedRef.current = true;
        }, 0);
        return () => {
          activatedRef.current = false;
        };
      }, []);
      const handleRef = useForkRef( // @ts-expect-error TODO upstream fix
      children.ref, nodeRef); // The handler doesn't take event.defaultPrevented into account:
      //
      // event.preventDefault() is meant to stop default behaviors like
      // clicking a checkbox to check it, hitting a button to submit a form,
      // and hitting left arrow to move the cursor in a text input etc.
      // Only special HTML elements have these default behaviors.

      const handleClickAway = useEventCallback(event => {
        // Given developers can stop the propagation of the synthetic event,
        // we can only be confident with a positive value.
        const insideReactTree = syntheticEventRef.current;
        syntheticEventRef.current = false;
        const doc = ownerDocument(nodeRef.current); // 1. IE11 support, which trigger the handleClickAway even after the unbind
        // 2. The child might render null.
        // 3. Behave like a blur listener.

        if (!activatedRef.current || !nodeRef.current || 'clientX' in event && clickedRootScrollbar(event, doc)) {
          return;
        } // Do not act if user performed touchmove


        if (movedRef.current) {
          movedRef.current = false;
          return;
        }

        let insideDOM; // If not enough, can use https://github.com/DieterHolvoet/event-propagation-path/blob/master/propagationPath.js

        if (event.composedPath) {
          insideDOM = event.composedPath().indexOf(nodeRef.current) > -1;
        } else {
          insideDOM = !doc.documentElement.contains( // @ts-expect-error returns `false` as intended when not dispatched from a Node
          event.target) || nodeRef.current.contains( // @ts-expect-error returns `false` as intended when not dispatched from a Node
          event.target);
        }

        if (!insideDOM && (disableReactTree || !insideReactTree)) {
          onClickAway(event);
        }
      }); // Keep track of mouse/touch events that bubbled up through the portal.

      const createHandleSynthetic = handlerName => event => {
        syntheticEventRef.current = true;
        const childrenPropsHandler = children.props[handlerName];

        if (childrenPropsHandler) {
          childrenPropsHandler(event);
        }
      };

      const childrenProps = {
        ref: handleRef
      };

      if (touchEvent !== false) {
        childrenProps[touchEvent] = createHandleSynthetic(touchEvent);
      }

      react.exports.useEffect(() => {
        if (touchEvent !== false) {
          const mappedTouchEvent = mapEventPropToEvent(touchEvent);
          const doc = ownerDocument(nodeRef.current);

          const handleTouchMove = () => {
            movedRef.current = true;
          };

          doc.addEventListener(mappedTouchEvent, handleClickAway);
          doc.addEventListener('touchmove', handleTouchMove);
          return () => {
            doc.removeEventListener(mappedTouchEvent, handleClickAway);
            doc.removeEventListener('touchmove', handleTouchMove);
          };
        }

        return undefined;
      }, [handleClickAway, touchEvent]);

      if (mouseEvent !== false) {
        childrenProps[mouseEvent] = createHandleSynthetic(mouseEvent);
      }

      react.exports.useEffect(() => {
        if (mouseEvent !== false) {
          const mappedMouseEvent = mapEventPropToEvent(mouseEvent);
          const doc = ownerDocument(nodeRef.current);
          doc.addEventListener(mappedMouseEvent, handleClickAway);
          return () => {
            doc.removeEventListener(mappedMouseEvent, handleClickAway);
          };
        }

        return undefined;
      }, [handleClickAway, mouseEvent]);
      return /*#__PURE__*/jsxRuntimeExports.jsx(react.exports.Fragment, {
        children: /*#__PURE__*/react.exports.cloneElement(children, childrenProps)
      });
    }

    process.env.NODE_ENV !== "production" ? ClickAwayListener.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit TypeScript types and run "yarn proptypes"  |
      // ----------------------------------------------------------------------

      /**
       * The wrapped element.
       */
      children: elementAcceptingRef.isRequired,

      /**
       * If `true`, the React tree is ignored and only the DOM tree is considered.
       * This prop changes how portaled elements are handled.
       * @default false
       */
      disableReactTree: propTypes.exports.bool,

      /**
       * The mouse event to listen to. You can disable the listener by providing `false`.
       * @default 'onClick'
       */
      mouseEvent: propTypes.exports.oneOf(['onClick', 'onMouseDown', 'onMouseUp', false]),

      /**
       * Callback fired when a "click away" event is detected.
       */
      onClickAway: propTypes.exports.func.isRequired,

      /**
       * The touch event to listen to. You can disable the listener by providing `false`.
       * @default 'onTouchEnd'
       */
      touchEvent: propTypes.exports.oneOf(['onTouchEnd', 'onTouchStart', false])
    } : void 0;

    if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line
      ClickAwayListener['propTypes' + ''] = exactProp(ClickAwayListener.propTypes);
    }

    var reactDom = {exports: {}};

    var reactDom_production_min = {};

    var scheduler = {exports: {}};

    var scheduler_production_min = {};

    /** @license React v0.20.2
     * scheduler.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredScheduler_production_min;

    function requireScheduler_production_min () {
    	if (hasRequiredScheduler_production_min) return scheduler_production_min;
    	hasRequiredScheduler_production_min = 1;
    	(function (exports) {
    var f,g,h,k;if("object"===typeof performance&&"function"===typeof performance.now){var l=performance;exports.unstable_now=function(){return l.now()};}else {var p=Date,q=p.now();exports.unstable_now=function(){return p.now()-q};}
    		if("undefined"===typeof window||"function"!==typeof MessageChannel){var t=null,u=null,w=function(){if(null!==t)try{var a=exports.unstable_now();t(!0,a);t=null;}catch(b){throw setTimeout(w,0),b;}};f=function(a){null!==t?setTimeout(f,0,a):(t=a,setTimeout(w,0));};g=function(a,b){u=setTimeout(a,b);};h=function(){clearTimeout(u);};exports.unstable_shouldYield=function(){return !1};k=exports.unstable_forceFrameRate=function(){};}else {var x=window.setTimeout,y=window.clearTimeout;if("undefined"!==typeof console){var z=
    		window.cancelAnimationFrame;"function"!==typeof window.requestAnimationFrame&&console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");"function"!==typeof z&&console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");}var A=!1,B=null,C=-1,D=5,E=0;exports.unstable_shouldYield=function(){return exports.unstable_now()>=
    		E};k=function(){};exports.unstable_forceFrameRate=function(a){0>a||125<a?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):D=0<a?Math.floor(1E3/a):5;};var F=new MessageChannel,G=F.port2;F.port1.onmessage=function(){if(null!==B){var a=exports.unstable_now();E=a+D;try{B(!0,a)?G.postMessage(null):(A=!1,B=null);}catch(b){throw G.postMessage(null),b;}}else A=!1;};f=function(a){B=a;A||(A=!0,G.postMessage(null));};g=function(a,b){C=
    		x(function(){a(exports.unstable_now());},b);};h=function(){y(C);C=-1;};}function H(a,b){var c=a.length;a.push(b);a:for(;;){var d=c-1>>>1,e=a[d];if(void 0!==e&&0<I(e,b))a[d]=b,a[c]=e,c=d;else break a}}function J(a){a=a[0];return void 0===a?null:a}
    		function K(a){var b=a[0];if(void 0!==b){var c=a.pop();if(c!==b){a[0]=c;a:for(var d=0,e=a.length;d<e;){var m=2*(d+1)-1,n=a[m],v=m+1,r=a[v];if(void 0!==n&&0>I(n,c))void 0!==r&&0>I(r,n)?(a[d]=r,a[v]=c,d=v):(a[d]=n,a[m]=c,d=m);else if(void 0!==r&&0>I(r,c))a[d]=r,a[v]=c,d=v;else break a}}return b}return null}function I(a,b){var c=a.sortIndex-b.sortIndex;return 0!==c?c:a.id-b.id}var L=[],M=[],N=1,O=null,P=3,Q=!1,R=!1,S=!1;
    		function T(a){for(var b=J(M);null!==b;){if(null===b.callback)K(M);else if(b.startTime<=a)K(M),b.sortIndex=b.expirationTime,H(L,b);else break;b=J(M);}}function U(a){S=!1;T(a);if(!R)if(null!==J(L))R=!0,f(V);else {var b=J(M);null!==b&&g(U,b.startTime-a);}}
    		function V(a,b){R=!1;S&&(S=!1,h());Q=!0;var c=P;try{T(b);for(O=J(L);null!==O&&(!(O.expirationTime>b)||a&&!exports.unstable_shouldYield());){var d=O.callback;if("function"===typeof d){O.callback=null;P=O.priorityLevel;var e=d(O.expirationTime<=b);b=exports.unstable_now();"function"===typeof e?O.callback=e:O===J(L)&&K(L);T(b);}else K(L);O=J(L);}if(null!==O)var m=!0;else {var n=J(M);null!==n&&g(U,n.startTime-b);m=!1;}return m}finally{O=null,P=c,Q=!1;}}var W=k;exports.unstable_IdlePriority=5;
    		exports.unstable_ImmediatePriority=1;exports.unstable_LowPriority=4;exports.unstable_NormalPriority=3;exports.unstable_Profiling=null;exports.unstable_UserBlockingPriority=2;exports.unstable_cancelCallback=function(a){a.callback=null;};exports.unstable_continueExecution=function(){R||Q||(R=!0,f(V));};exports.unstable_getCurrentPriorityLevel=function(){return P};exports.unstable_getFirstCallbackNode=function(){return J(L)};
    		exports.unstable_next=function(a){switch(P){case 1:case 2:case 3:var b=3;break;default:b=P;}var c=P;P=b;try{return a()}finally{P=c;}};exports.unstable_pauseExecution=function(){};exports.unstable_requestPaint=W;exports.unstable_runWithPriority=function(a,b){switch(a){case 1:case 2:case 3:case 4:case 5:break;default:a=3;}var c=P;P=a;try{return b()}finally{P=c;}};
    		exports.unstable_scheduleCallback=function(a,b,c){var d=exports.unstable_now();"object"===typeof c&&null!==c?(c=c.delay,c="number"===typeof c&&0<c?d+c:d):c=d;switch(a){case 1:var e=-1;break;case 2:e=250;break;case 5:e=1073741823;break;case 4:e=1E4;break;default:e=5E3;}e=c+e;a={id:N++,callback:b,priorityLevel:a,startTime:c,expirationTime:e,sortIndex:-1};c>d?(a.sortIndex=c,H(M,a),null===J(L)&&a===J(M)&&(S?h():S=!0,g(U,c-d))):(a.sortIndex=e,H(L,a),R||Q||(R=!0,f(V)));return a};
    		exports.unstable_wrapCallback=function(a){var b=P;return function(){var c=P;P=b;try{return a.apply(this,arguments)}finally{P=c;}}};
    } (scheduler_production_min));
    	return scheduler_production_min;
    }

    var scheduler_development = {};

    /** @license React v0.20.2
     * scheduler.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredScheduler_development;

    function requireScheduler_development () {
    	if (hasRequiredScheduler_development) return scheduler_development;
    	hasRequiredScheduler_development = 1;
    	(function (exports) {

    		if (process.env.NODE_ENV !== "production") {
    		  (function() {

    		var enableSchedulerDebugging = false;
    		var enableProfiling = false;

    		var requestHostCallback;
    		var requestHostTimeout;
    		var cancelHostTimeout;
    		var requestPaint;
    		var hasPerformanceNow = typeof performance === 'object' && typeof performance.now === 'function';

    		if (hasPerformanceNow) {
    		  var localPerformance = performance;

    		  exports.unstable_now = function () {
    		    return localPerformance.now();
    		  };
    		} else {
    		  var localDate = Date;
    		  var initialTime = localDate.now();

    		  exports.unstable_now = function () {
    		    return localDate.now() - initialTime;
    		  };
    		}

    		if ( // If Scheduler runs in a non-DOM environment, it falls back to a naive
    		// implementation using setTimeout.
    		typeof window === 'undefined' || // Check if MessageChannel is supported, too.
    		typeof MessageChannel !== 'function') {
    		  // If this accidentally gets imported in a non-browser environment, e.g. JavaScriptCore,
    		  // fallback to a naive implementation.
    		  var _callback = null;
    		  var _timeoutID = null;

    		  var _flushCallback = function () {
    		    if (_callback !== null) {
    		      try {
    		        var currentTime = exports.unstable_now();
    		        var hasRemainingTime = true;

    		        _callback(hasRemainingTime, currentTime);

    		        _callback = null;
    		      } catch (e) {
    		        setTimeout(_flushCallback, 0);
    		        throw e;
    		      }
    		    }
    		  };

    		  requestHostCallback = function (cb) {
    		    if (_callback !== null) {
    		      // Protect against re-entrancy.
    		      setTimeout(requestHostCallback, 0, cb);
    		    } else {
    		      _callback = cb;
    		      setTimeout(_flushCallback, 0);
    		    }
    		  };

    		  requestHostTimeout = function (cb, ms) {
    		    _timeoutID = setTimeout(cb, ms);
    		  };

    		  cancelHostTimeout = function () {
    		    clearTimeout(_timeoutID);
    		  };

    		  exports.unstable_shouldYield = function () {
    		    return false;
    		  };

    		  requestPaint = exports.unstable_forceFrameRate = function () {};
    		} else {
    		  // Capture local references to native APIs, in case a polyfill overrides them.
    		  var _setTimeout = window.setTimeout;
    		  var _clearTimeout = window.clearTimeout;

    		  if (typeof console !== 'undefined') {
    		    // TODO: Scheduler no longer requires these methods to be polyfilled. But
    		    // maybe we want to continue warning if they don't exist, to preserve the
    		    // option to rely on it in the future?
    		    var requestAnimationFrame = window.requestAnimationFrame;
    		    var cancelAnimationFrame = window.cancelAnimationFrame;

    		    if (typeof requestAnimationFrame !== 'function') {
    		      // Using console['error'] to evade Babel and ESLint
    		      console['error']("This browser doesn't support requestAnimationFrame. " + 'Make sure that you load a ' + 'polyfill in older browsers. https://reactjs.org/link/react-polyfills');
    		    }

    		    if (typeof cancelAnimationFrame !== 'function') {
    		      // Using console['error'] to evade Babel and ESLint
    		      console['error']("This browser doesn't support cancelAnimationFrame. " + 'Make sure that you load a ' + 'polyfill in older browsers. https://reactjs.org/link/react-polyfills');
    		    }
    		  }

    		  var isMessageLoopRunning = false;
    		  var scheduledHostCallback = null;
    		  var taskTimeoutID = -1; // Scheduler periodically yields in case there is other work on the main
    		  // thread, like user events. By default, it yields multiple times per frame.
    		  // It does not attempt to align with frame boundaries, since most tasks don't
    		  // need to be frame aligned; for those that do, use requestAnimationFrame.

    		  var yieldInterval = 5;
    		  var deadline = 0; // TODO: Make this configurable

    		  {
    		    // `isInputPending` is not available. Since we have no way of knowing if
    		    // there's pending input, always yield at the end of the frame.
    		    exports.unstable_shouldYield = function () {
    		      return exports.unstable_now() >= deadline;
    		    }; // Since we yield every frame regardless, `requestPaint` has no effect.


    		    requestPaint = function () {};
    		  }

    		  exports.unstable_forceFrameRate = function (fps) {
    		    if (fps < 0 || fps > 125) {
    		      // Using console['error'] to evade Babel and ESLint
    		      console['error']('forceFrameRate takes a positive int between 0 and 125, ' + 'forcing frame rates higher than 125 fps is not supported');
    		      return;
    		    }

    		    if (fps > 0) {
    		      yieldInterval = Math.floor(1000 / fps);
    		    } else {
    		      // reset the framerate
    		      yieldInterval = 5;
    		    }
    		  };

    		  var performWorkUntilDeadline = function () {
    		    if (scheduledHostCallback !== null) {
    		      var currentTime = exports.unstable_now(); // Yield after `yieldInterval` ms, regardless of where we are in the vsync
    		      // cycle. This means there's always time remaining at the beginning of
    		      // the message event.

    		      deadline = currentTime + yieldInterval;
    		      var hasTimeRemaining = true;

    		      try {
    		        var hasMoreWork = scheduledHostCallback(hasTimeRemaining, currentTime);

    		        if (!hasMoreWork) {
    		          isMessageLoopRunning = false;
    		          scheduledHostCallback = null;
    		        } else {
    		          // If there's more work, schedule the next message event at the end
    		          // of the preceding one.
    		          port.postMessage(null);
    		        }
    		      } catch (error) {
    		        // If a scheduler task throws, exit the current browser task so the
    		        // error can be observed.
    		        port.postMessage(null);
    		        throw error;
    		      }
    		    } else {
    		      isMessageLoopRunning = false;
    		    } // Yielding to the browser will give it a chance to paint, so we can
    		  };

    		  var channel = new MessageChannel();
    		  var port = channel.port2;
    		  channel.port1.onmessage = performWorkUntilDeadline;

    		  requestHostCallback = function (callback) {
    		    scheduledHostCallback = callback;

    		    if (!isMessageLoopRunning) {
    		      isMessageLoopRunning = true;
    		      port.postMessage(null);
    		    }
    		  };

    		  requestHostTimeout = function (callback, ms) {
    		    taskTimeoutID = _setTimeout(function () {
    		      callback(exports.unstable_now());
    		    }, ms);
    		  };

    		  cancelHostTimeout = function () {
    		    _clearTimeout(taskTimeoutID);

    		    taskTimeoutID = -1;
    		  };
    		}

    		function push(heap, node) {
    		  var index = heap.length;
    		  heap.push(node);
    		  siftUp(heap, node, index);
    		}
    		function peek(heap) {
    		  var first = heap[0];
    		  return first === undefined ? null : first;
    		}
    		function pop(heap) {
    		  var first = heap[0];

    		  if (first !== undefined) {
    		    var last = heap.pop();

    		    if (last !== first) {
    		      heap[0] = last;
    		      siftDown(heap, last, 0);
    		    }

    		    return first;
    		  } else {
    		    return null;
    		  }
    		}

    		function siftUp(heap, node, i) {
    		  var index = i;

    		  while (true) {
    		    var parentIndex = index - 1 >>> 1;
    		    var parent = heap[parentIndex];

    		    if (parent !== undefined && compare(parent, node) > 0) {
    		      // The parent is larger. Swap positions.
    		      heap[parentIndex] = node;
    		      heap[index] = parent;
    		      index = parentIndex;
    		    } else {
    		      // The parent is smaller. Exit.
    		      return;
    		    }
    		  }
    		}

    		function siftDown(heap, node, i) {
    		  var index = i;
    		  var length = heap.length;

    		  while (index < length) {
    		    var leftIndex = (index + 1) * 2 - 1;
    		    var left = heap[leftIndex];
    		    var rightIndex = leftIndex + 1;
    		    var right = heap[rightIndex]; // If the left or right node is smaller, swap with the smaller of those.

    		    if (left !== undefined && compare(left, node) < 0) {
    		      if (right !== undefined && compare(right, left) < 0) {
    		        heap[index] = right;
    		        heap[rightIndex] = node;
    		        index = rightIndex;
    		      } else {
    		        heap[index] = left;
    		        heap[leftIndex] = node;
    		        index = leftIndex;
    		      }
    		    } else if (right !== undefined && compare(right, node) < 0) {
    		      heap[index] = right;
    		      heap[rightIndex] = node;
    		      index = rightIndex;
    		    } else {
    		      // Neither child is smaller. Exit.
    		      return;
    		    }
    		  }
    		}

    		function compare(a, b) {
    		  // Compare sort index first, then task id.
    		  var diff = a.sortIndex - b.sortIndex;
    		  return diff !== 0 ? diff : a.id - b.id;
    		}

    		// TODO: Use symbols?
    		var ImmediatePriority = 1;
    		var UserBlockingPriority = 2;
    		var NormalPriority = 3;
    		var LowPriority = 4;
    		var IdlePriority = 5;

    		function markTaskErrored(task, ms) {
    		}

    		/* eslint-disable no-var */
    		// Math.pow(2, 30) - 1
    		// 0b111111111111111111111111111111

    		var maxSigned31BitInt = 1073741823; // Times out immediately

    		var IMMEDIATE_PRIORITY_TIMEOUT = -1; // Eventually times out

    		var USER_BLOCKING_PRIORITY_TIMEOUT = 250;
    		var NORMAL_PRIORITY_TIMEOUT = 5000;
    		var LOW_PRIORITY_TIMEOUT = 10000; // Never times out

    		var IDLE_PRIORITY_TIMEOUT = maxSigned31BitInt; // Tasks are stored on a min heap

    		var taskQueue = [];
    		var timerQueue = []; // Incrementing id counter. Used to maintain insertion order.

    		var taskIdCounter = 1; // Pausing the scheduler is useful for debugging.
    		var currentTask = null;
    		var currentPriorityLevel = NormalPriority; // This is set while performing work, to prevent re-entrancy.

    		var isPerformingWork = false;
    		var isHostCallbackScheduled = false;
    		var isHostTimeoutScheduled = false;

    		function advanceTimers(currentTime) {
    		  // Check for tasks that are no longer delayed and add them to the queue.
    		  var timer = peek(timerQueue);

    		  while (timer !== null) {
    		    if (timer.callback === null) {
    		      // Timer was cancelled.
    		      pop(timerQueue);
    		    } else if (timer.startTime <= currentTime) {
    		      // Timer fired. Transfer to the task queue.
    		      pop(timerQueue);
    		      timer.sortIndex = timer.expirationTime;
    		      push(taskQueue, timer);
    		    } else {
    		      // Remaining timers are pending.
    		      return;
    		    }

    		    timer = peek(timerQueue);
    		  }
    		}

    		function handleTimeout(currentTime) {
    		  isHostTimeoutScheduled = false;
    		  advanceTimers(currentTime);

    		  if (!isHostCallbackScheduled) {
    		    if (peek(taskQueue) !== null) {
    		      isHostCallbackScheduled = true;
    		      requestHostCallback(flushWork);
    		    } else {
    		      var firstTimer = peek(timerQueue);

    		      if (firstTimer !== null) {
    		        requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
    		      }
    		    }
    		  }
    		}

    		function flushWork(hasTimeRemaining, initialTime) {


    		  isHostCallbackScheduled = false;

    		  if (isHostTimeoutScheduled) {
    		    // We scheduled a timeout but it's no longer needed. Cancel it.
    		    isHostTimeoutScheduled = false;
    		    cancelHostTimeout();
    		  }

    		  isPerformingWork = true;
    		  var previousPriorityLevel = currentPriorityLevel;

    		  try {
    		    var currentTime; if (enableProfiling) ; else {
    		      // No catch in prod code path.
    		      return workLoop(hasTimeRemaining, initialTime);
    		    }
    		  } finally {
    		    currentTask = null;
    		    currentPriorityLevel = previousPriorityLevel;
    		    isPerformingWork = false;
    		  }
    		}

    		function workLoop(hasTimeRemaining, initialTime) {
    		  var currentTime = initialTime;
    		  advanceTimers(currentTime);
    		  currentTask = peek(taskQueue);

    		  while (currentTask !== null && !(enableSchedulerDebugging )) {
    		    if (currentTask.expirationTime > currentTime && (!hasTimeRemaining || exports.unstable_shouldYield())) {
    		      // This currentTask hasn't expired, and we've reached the deadline.
    		      break;
    		    }

    		    var callback = currentTask.callback;

    		    if (typeof callback === 'function') {
    		      currentTask.callback = null;
    		      currentPriorityLevel = currentTask.priorityLevel;
    		      var didUserCallbackTimeout = currentTask.expirationTime <= currentTime;

    		      var continuationCallback = callback(didUserCallbackTimeout);
    		      currentTime = exports.unstable_now();

    		      if (typeof continuationCallback === 'function') {
    		        currentTask.callback = continuationCallback;
    		      } else {

    		        if (currentTask === peek(taskQueue)) {
    		          pop(taskQueue);
    		        }
    		      }

    		      advanceTimers(currentTime);
    		    } else {
    		      pop(taskQueue);
    		    }

    		    currentTask = peek(taskQueue);
    		  } // Return whether there's additional work


    		  if (currentTask !== null) {
    		    return true;
    		  } else {
    		    var firstTimer = peek(timerQueue);

    		    if (firstTimer !== null) {
    		      requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
    		    }

    		    return false;
    		  }
    		}

    		function unstable_runWithPriority(priorityLevel, eventHandler) {
    		  switch (priorityLevel) {
    		    case ImmediatePriority:
    		    case UserBlockingPriority:
    		    case NormalPriority:
    		    case LowPriority:
    		    case IdlePriority:
    		      break;

    		    default:
    		      priorityLevel = NormalPriority;
    		  }

    		  var previousPriorityLevel = currentPriorityLevel;
    		  currentPriorityLevel = priorityLevel;

    		  try {
    		    return eventHandler();
    		  } finally {
    		    currentPriorityLevel = previousPriorityLevel;
    		  }
    		}

    		function unstable_next(eventHandler) {
    		  var priorityLevel;

    		  switch (currentPriorityLevel) {
    		    case ImmediatePriority:
    		    case UserBlockingPriority:
    		    case NormalPriority:
    		      // Shift down to normal priority
    		      priorityLevel = NormalPriority;
    		      break;

    		    default:
    		      // Anything lower than normal priority should remain at the current level.
    		      priorityLevel = currentPriorityLevel;
    		      break;
    		  }

    		  var previousPriorityLevel = currentPriorityLevel;
    		  currentPriorityLevel = priorityLevel;

    		  try {
    		    return eventHandler();
    		  } finally {
    		    currentPriorityLevel = previousPriorityLevel;
    		  }
    		}

    		function unstable_wrapCallback(callback) {
    		  var parentPriorityLevel = currentPriorityLevel;
    		  return function () {
    		    // This is a fork of runWithPriority, inlined for performance.
    		    var previousPriorityLevel = currentPriorityLevel;
    		    currentPriorityLevel = parentPriorityLevel;

    		    try {
    		      return callback.apply(this, arguments);
    		    } finally {
    		      currentPriorityLevel = previousPriorityLevel;
    		    }
    		  };
    		}

    		function unstable_scheduleCallback(priorityLevel, callback, options) {
    		  var currentTime = exports.unstable_now();
    		  var startTime;

    		  if (typeof options === 'object' && options !== null) {
    		    var delay = options.delay;

    		    if (typeof delay === 'number' && delay > 0) {
    		      startTime = currentTime + delay;
    		    } else {
    		      startTime = currentTime;
    		    }
    		  } else {
    		    startTime = currentTime;
    		  }

    		  var timeout;

    		  switch (priorityLevel) {
    		    case ImmediatePriority:
    		      timeout = IMMEDIATE_PRIORITY_TIMEOUT;
    		      break;

    		    case UserBlockingPriority:
    		      timeout = USER_BLOCKING_PRIORITY_TIMEOUT;
    		      break;

    		    case IdlePriority:
    		      timeout = IDLE_PRIORITY_TIMEOUT;
    		      break;

    		    case LowPriority:
    		      timeout = LOW_PRIORITY_TIMEOUT;
    		      break;

    		    case NormalPriority:
    		    default:
    		      timeout = NORMAL_PRIORITY_TIMEOUT;
    		      break;
    		  }

    		  var expirationTime = startTime + timeout;
    		  var newTask = {
    		    id: taskIdCounter++,
    		    callback: callback,
    		    priorityLevel: priorityLevel,
    		    startTime: startTime,
    		    expirationTime: expirationTime,
    		    sortIndex: -1
    		  };

    		  if (startTime > currentTime) {
    		    // This is a delayed task.
    		    newTask.sortIndex = startTime;
    		    push(timerQueue, newTask);

    		    if (peek(taskQueue) === null && newTask === peek(timerQueue)) {
    		      // All tasks are delayed, and this is the task with the earliest delay.
    		      if (isHostTimeoutScheduled) {
    		        // Cancel an existing timeout.
    		        cancelHostTimeout();
    		      } else {
    		        isHostTimeoutScheduled = true;
    		      } // Schedule a timeout.


    		      requestHostTimeout(handleTimeout, startTime - currentTime);
    		    }
    		  } else {
    		    newTask.sortIndex = expirationTime;
    		    push(taskQueue, newTask);
    		    // wait until the next time we yield.


    		    if (!isHostCallbackScheduled && !isPerformingWork) {
    		      isHostCallbackScheduled = true;
    		      requestHostCallback(flushWork);
    		    }
    		  }

    		  return newTask;
    		}

    		function unstable_pauseExecution() {
    		}

    		function unstable_continueExecution() {

    		  if (!isHostCallbackScheduled && !isPerformingWork) {
    		    isHostCallbackScheduled = true;
    		    requestHostCallback(flushWork);
    		  }
    		}

    		function unstable_getFirstCallbackNode() {
    		  return peek(taskQueue);
    		}

    		function unstable_cancelCallback(task) {
    		  // remove from the queue because you can't remove arbitrary nodes from an
    		  // array based heap, only the first one.)


    		  task.callback = null;
    		}

    		function unstable_getCurrentPriorityLevel() {
    		  return currentPriorityLevel;
    		}

    		var unstable_requestPaint = requestPaint;
    		var unstable_Profiling =  null;

    		exports.unstable_IdlePriority = IdlePriority;
    		exports.unstable_ImmediatePriority = ImmediatePriority;
    		exports.unstable_LowPriority = LowPriority;
    		exports.unstable_NormalPriority = NormalPriority;
    		exports.unstable_Profiling = unstable_Profiling;
    		exports.unstable_UserBlockingPriority = UserBlockingPriority;
    		exports.unstable_cancelCallback = unstable_cancelCallback;
    		exports.unstable_continueExecution = unstable_continueExecution;
    		exports.unstable_getCurrentPriorityLevel = unstable_getCurrentPriorityLevel;
    		exports.unstable_getFirstCallbackNode = unstable_getFirstCallbackNode;
    		exports.unstable_next = unstable_next;
    		exports.unstable_pauseExecution = unstable_pauseExecution;
    		exports.unstable_requestPaint = unstable_requestPaint;
    		exports.unstable_runWithPriority = unstable_runWithPriority;
    		exports.unstable_scheduleCallback = unstable_scheduleCallback;
    		exports.unstable_wrapCallback = unstable_wrapCallback;
    		  })();
    		}
    } (scheduler_development));
    	return scheduler_development;
    }

    var hasRequiredScheduler;

    function requireScheduler () {
    	if (hasRequiredScheduler) return scheduler.exports;
    	hasRequiredScheduler = 1;
    	(function (module) {

    		if (process.env.NODE_ENV === 'production') {
    		  module.exports = requireScheduler_production_min();
    		} else {
    		  module.exports = requireScheduler_development();
    		}
    } (scheduler));
    	return scheduler.exports;
    }

    /** @license React v17.0.2
     * react-dom.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactDom_production_min;

    function requireReactDom_production_min () {
    	if (hasRequiredReactDom_production_min) return reactDom_production_min;
    	hasRequiredReactDom_production_min = 1;
    var aa=react.exports,m=requireObjectAssign(),r=requireScheduler();function y(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return "Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}if(!aa)throw Error(y(227));var ba=new Set,ca={};function da(a,b){ea(a,b);ea(a+"Capture",b);}
    	function ea(a,b){ca[a]=b;for(a=0;a<b.length;a++)ba.add(b[a]);}
    	var fa=!("undefined"===typeof window||"undefined"===typeof window.document||"undefined"===typeof window.document.createElement),ha=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,ia=Object.prototype.hasOwnProperty,
    	ja={},ka={};function la(a){if(ia.call(ka,a))return !0;if(ia.call(ja,a))return !1;if(ha.test(a))return ka[a]=!0;ja[a]=!0;return !1}function ma(a,b,c,d){if(null!==c&&0===c.type)return !1;switch(typeof b){case "function":case "symbol":return !0;case "boolean":if(d)return !1;if(null!==c)return !c.acceptsBooleans;a=a.toLowerCase().slice(0,5);return "data-"!==a&&"aria-"!==a;default:return !1}}
    	function na(a,b,c,d){if(null===b||"undefined"===typeof b||ma(a,b,c,d))return !0;if(d)return !1;if(null!==c)switch(c.type){case 3:return !b;case 4:return !1===b;case 5:return isNaN(b);case 6:return isNaN(b)||1>b}return !1}function B(a,b,c,d,e,f,g){this.acceptsBooleans=2===b||3===b||4===b;this.attributeName=d;this.attributeNamespace=e;this.mustUseProperty=c;this.propertyName=a;this.type=b;this.sanitizeURL=f;this.removeEmptyString=g;}var D={};
    	"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a){D[a]=new B(a,0,!1,a,null,!1,!1);});[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach(function(a){var b=a[0];D[b]=new B(b,1,!1,a[1],null,!1,!1);});["contentEditable","draggable","spellCheck","value"].forEach(function(a){D[a]=new B(a,2,!1,a.toLowerCase(),null,!1,!1);});
    	["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach(function(a){D[a]=new B(a,2,!1,a,null,!1,!1);});"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a){D[a]=new B(a,3,!1,a.toLowerCase(),null,!1,!1);});
    	["checked","multiple","muted","selected"].forEach(function(a){D[a]=new B(a,3,!0,a,null,!1,!1);});["capture","download"].forEach(function(a){D[a]=new B(a,4,!1,a,null,!1,!1);});["cols","rows","size","span"].forEach(function(a){D[a]=new B(a,6,!1,a,null,!1,!1);});["rowSpan","start"].forEach(function(a){D[a]=new B(a,5,!1,a.toLowerCase(),null,!1,!1);});var oa=/[\-:]([a-z])/g;function pa(a){return a[1].toUpperCase()}
    	"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a){var b=a.replace(oa,
    	pa);D[b]=new B(b,1,!1,a,null,!1,!1);});"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a){var b=a.replace(oa,pa);D[b]=new B(b,1,!1,a,"http://www.w3.org/1999/xlink",!1,!1);});["xml:base","xml:lang","xml:space"].forEach(function(a){var b=a.replace(oa,pa);D[b]=new B(b,1,!1,a,"http://www.w3.org/XML/1998/namespace",!1,!1);});["tabIndex","crossOrigin"].forEach(function(a){D[a]=new B(a,1,!1,a.toLowerCase(),null,!1,!1);});
    	D.xlinkHref=new B("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1);["src","href","action","formAction"].forEach(function(a){D[a]=new B(a,1,!1,a.toLowerCase(),null,!0,!0);});
    	function qa(a,b,c,d){var e=D.hasOwnProperty(b)?D[b]:null;var f=null!==e?0===e.type:d?!1:!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1]?!1:!0;f||(na(b,c,e,d)&&(c=null),d||null===e?la(b)&&(null===c?a.removeAttribute(b):a.setAttribute(b,""+c)):e.mustUseProperty?a[e.propertyName]=null===c?3===e.type?!1:"":c:(b=e.attributeName,d=e.attributeNamespace,null===c?a.removeAttribute(b):(e=e.type,c=3===e||4===e&&!0===c?"":""+c,d?a.setAttributeNS(d,b,c):a.setAttribute(b,c))));}
    	var ra=aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,sa=60103,ta=60106,ua=60107,wa=60108,xa=60114,ya=60109,za=60110,Aa=60112,Ba=60113,Ca=60120,Da=60115,Ea=60116,Fa=60121,Ga=60128,Ha=60129,Ia=60130,Ja=60131;
    	if("function"===typeof Symbol&&Symbol.for){var E=Symbol.for;sa=E("react.element");ta=E("react.portal");ua=E("react.fragment");wa=E("react.strict_mode");xa=E("react.profiler");ya=E("react.provider");za=E("react.context");Aa=E("react.forward_ref");Ba=E("react.suspense");Ca=E("react.suspense_list");Da=E("react.memo");Ea=E("react.lazy");Fa=E("react.block");E("react.scope");Ga=E("react.opaque.id");Ha=E("react.debug_trace_mode");Ia=E("react.offscreen");Ja=E("react.legacy_hidden");}
    	var Ka="function"===typeof Symbol&&Symbol.iterator;function La(a){if(null===a||"object"!==typeof a)return null;a=Ka&&a[Ka]||a["@@iterator"];return "function"===typeof a?a:null}var Ma;function Na(a){if(void 0===Ma)try{throw Error();}catch(c){var b=c.stack.trim().match(/\n( *(at )?)/);Ma=b&&b[1]||"";}return "\n"+Ma+a}var Oa=!1;
    	function Pa(a,b){if(!a||Oa)return "";Oa=!0;var c=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(b)if(b=function(){throw Error();},Object.defineProperty(b.prototype,"props",{set:function(){throw Error();}}),"object"===typeof Reflect&&Reflect.construct){try{Reflect.construct(b,[]);}catch(k){var d=k;}Reflect.construct(a,[],b);}else {try{b.call();}catch(k){d=k;}a.call(b.prototype);}else {try{throw Error();}catch(k){d=k;}a();}}catch(k){if(k&&d&&"string"===typeof k.stack){for(var e=k.stack.split("\n"),
    	f=d.stack.split("\n"),g=e.length-1,h=f.length-1;1<=g&&0<=h&&e[g]!==f[h];)h--;for(;1<=g&&0<=h;g--,h--)if(e[g]!==f[h]){if(1!==g||1!==h){do if(g--,h--,0>h||e[g]!==f[h])return "\n"+e[g].replace(" at new "," at ");while(1<=g&&0<=h)}break}}}finally{Oa=!1,Error.prepareStackTrace=c;}return (a=a?a.displayName||a.name:"")?Na(a):""}
    	function Qa(a){switch(a.tag){case 5:return Na(a.type);case 16:return Na("Lazy");case 13:return Na("Suspense");case 19:return Na("SuspenseList");case 0:case 2:case 15:return a=Pa(a.type,!1),a;case 11:return a=Pa(a.type.render,!1),a;case 22:return a=Pa(a.type._render,!1),a;case 1:return a=Pa(a.type,!0),a;default:return ""}}
    	function Ra(a){if(null==a)return null;if("function"===typeof a)return a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case ua:return "Fragment";case ta:return "Portal";case xa:return "Profiler";case wa:return "StrictMode";case Ba:return "Suspense";case Ca:return "SuspenseList"}if("object"===typeof a)switch(a.$$typeof){case za:return (a.displayName||"Context")+".Consumer";case ya:return (a._context.displayName||"Context")+".Provider";case Aa:var b=a.render;b=b.displayName||b.name||"";
    	return a.displayName||(""!==b?"ForwardRef("+b+")":"ForwardRef");case Da:return Ra(a.type);case Fa:return Ra(a._render);case Ea:b=a._payload;a=a._init;try{return Ra(a(b))}catch(c){}}return null}function Sa(a){switch(typeof a){case "boolean":case "number":case "object":case "string":case "undefined":return a;default:return ""}}function Ta(a){var b=a.type;return (a=a.nodeName)&&"input"===a.toLowerCase()&&("checkbox"===b||"radio"===b)}
    	function Ua(a){var b=Ta(a)?"checked":"value",c=Object.getOwnPropertyDescriptor(a.constructor.prototype,b),d=""+a[b];if(!a.hasOwnProperty(b)&&"undefined"!==typeof c&&"function"===typeof c.get&&"function"===typeof c.set){var e=c.get,f=c.set;Object.defineProperty(a,b,{configurable:!0,get:function(){return e.call(this)},set:function(a){d=""+a;f.call(this,a);}});Object.defineProperty(a,b,{enumerable:c.enumerable});return {getValue:function(){return d},setValue:function(a){d=""+a;},stopTracking:function(){a._valueTracker=
    	null;delete a[b];}}}}function Va(a){a._valueTracker||(a._valueTracker=Ua(a));}function Wa(a){if(!a)return !1;var b=a._valueTracker;if(!b)return !0;var c=b.getValue();var d="";a&&(d=Ta(a)?a.checked?"true":"false":a.value);a=d;return a!==c?(b.setValue(a),!0):!1}function Xa(a){a=a||("undefined"!==typeof document?document:void 0);if("undefined"===typeof a)return null;try{return a.activeElement||a.body}catch(b){return a.body}}
    	function Ya(a,b){var c=b.checked;return m({},b,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=c?c:a._wrapperState.initialChecked})}function Za(a,b){var c=null==b.defaultValue?"":b.defaultValue,d=null!=b.checked?b.checked:b.defaultChecked;c=Sa(null!=b.value?b.value:c);a._wrapperState={initialChecked:d,initialValue:c,controlled:"checkbox"===b.type||"radio"===b.type?null!=b.checked:null!=b.value};}function $a(a,b){b=b.checked;null!=b&&qa(a,"checked",b,!1);}
    	function ab(a,b){$a(a,b);var c=Sa(b.value),d=b.type;if(null!=c)if("number"===d){if(0===c&&""===a.value||a.value!=c)a.value=""+c;}else a.value!==""+c&&(a.value=""+c);else if("submit"===d||"reset"===d){a.removeAttribute("value");return}b.hasOwnProperty("value")?bb(a,b.type,c):b.hasOwnProperty("defaultValue")&&bb(a,b.type,Sa(b.defaultValue));null==b.checked&&null!=b.defaultChecked&&(a.defaultChecked=!!b.defaultChecked);}
    	function cb(a,b,c){if(b.hasOwnProperty("value")||b.hasOwnProperty("defaultValue")){var d=b.type;if(!("submit"!==d&&"reset"!==d||void 0!==b.value&&null!==b.value))return;b=""+a._wrapperState.initialValue;c||b===a.value||(a.value=b);a.defaultValue=b;}c=a.name;""!==c&&(a.name="");a.defaultChecked=!!a._wrapperState.initialChecked;""!==c&&(a.name=c);}
    	function bb(a,b,c){if("number"!==b||Xa(a.ownerDocument)!==a)null==c?a.defaultValue=""+a._wrapperState.initialValue:a.defaultValue!==""+c&&(a.defaultValue=""+c);}function db(a){var b="";aa.Children.forEach(a,function(a){null!=a&&(b+=a);});return b}function eb(a,b){a=m({children:void 0},b);if(b=db(b.children))a.children=b;return a}
    	function fb(a,b,c,d){a=a.options;if(b){b={};for(var e=0;e<c.length;e++)b["$"+c[e]]=!0;for(c=0;c<a.length;c++)e=b.hasOwnProperty("$"+a[c].value),a[c].selected!==e&&(a[c].selected=e),e&&d&&(a[c].defaultSelected=!0);}else {c=""+Sa(c);b=null;for(e=0;e<a.length;e++){if(a[e].value===c){a[e].selected=!0;d&&(a[e].defaultSelected=!0);return}null!==b||a[e].disabled||(b=a[e]);}null!==b&&(b.selected=!0);}}
    	function gb(a,b){if(null!=b.dangerouslySetInnerHTML)throw Error(y(91));return m({},b,{value:void 0,defaultValue:void 0,children:""+a._wrapperState.initialValue})}function hb(a,b){var c=b.value;if(null==c){c=b.children;b=b.defaultValue;if(null!=c){if(null!=b)throw Error(y(92));if(Array.isArray(c)){if(!(1>=c.length))throw Error(y(93));c=c[0];}b=c;}null==b&&(b="");c=b;}a._wrapperState={initialValue:Sa(c)};}
    	function ib(a,b){var c=Sa(b.value),d=Sa(b.defaultValue);null!=c&&(c=""+c,c!==a.value&&(a.value=c),null==b.defaultValue&&a.defaultValue!==c&&(a.defaultValue=c));null!=d&&(a.defaultValue=""+d);}function jb(a){var b=a.textContent;b===a._wrapperState.initialValue&&""!==b&&null!==b&&(a.value=b);}var kb={html:"http://www.w3.org/1999/xhtml",mathml:"http://www.w3.org/1998/Math/MathML",svg:"http://www.w3.org/2000/svg"};
    	function lb(a){switch(a){case "svg":return "http://www.w3.org/2000/svg";case "math":return "http://www.w3.org/1998/Math/MathML";default:return "http://www.w3.org/1999/xhtml"}}function mb(a,b){return null==a||"http://www.w3.org/1999/xhtml"===a?lb(b):"http://www.w3.org/2000/svg"===a&&"foreignObject"===b?"http://www.w3.org/1999/xhtml":a}
    	var nb,ob=function(a){return "undefined"!==typeof MSApp&&MSApp.execUnsafeLocalFunction?function(b,c,d,e){MSApp.execUnsafeLocalFunction(function(){return a(b,c,d,e)});}:a}(function(a,b){if(a.namespaceURI!==kb.svg||"innerHTML"in a)a.innerHTML=b;else {nb=nb||document.createElement("div");nb.innerHTML="<svg>"+b.valueOf().toString()+"</svg>";for(b=nb.firstChild;a.firstChild;)a.removeChild(a.firstChild);for(;b.firstChild;)a.appendChild(b.firstChild);}});
    	function pb(a,b){if(b){var c=a.firstChild;if(c&&c===a.lastChild&&3===c.nodeType){c.nodeValue=b;return}}a.textContent=b;}
    	var qb={animationIterationCount:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,
    	floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},rb=["Webkit","ms","Moz","O"];Object.keys(qb).forEach(function(a){rb.forEach(function(b){b=b+a.charAt(0).toUpperCase()+a.substring(1);qb[b]=qb[a];});});function sb(a,b,c){return null==b||"boolean"===typeof b||""===b?"":c||"number"!==typeof b||0===b||qb.hasOwnProperty(a)&&qb[a]?(""+b).trim():b+"px"}
    	function tb(a,b){a=a.style;for(var c in b)if(b.hasOwnProperty(c)){var d=0===c.indexOf("--"),e=sb(c,b[c],d);"float"===c&&(c="cssFloat");d?a.setProperty(c,e):a[c]=e;}}var ub=m({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});
    	function vb(a,b){if(b){if(ub[a]&&(null!=b.children||null!=b.dangerouslySetInnerHTML))throw Error(y(137,a));if(null!=b.dangerouslySetInnerHTML){if(null!=b.children)throw Error(y(60));if(!("object"===typeof b.dangerouslySetInnerHTML&&"__html"in b.dangerouslySetInnerHTML))throw Error(y(61));}if(null!=b.style&&"object"!==typeof b.style)throw Error(y(62));}}
    	function wb(a,b){if(-1===a.indexOf("-"))return "string"===typeof b.is;switch(a){case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":return !1;default:return !0}}function xb(a){a=a.target||a.srcElement||window;a.correspondingUseElement&&(a=a.correspondingUseElement);return 3===a.nodeType?a.parentNode:a}var yb=null,zb=null,Ab=null;
    	function Bb(a){if(a=Cb(a)){if("function"!==typeof yb)throw Error(y(280));var b=a.stateNode;b&&(b=Db(b),yb(a.stateNode,a.type,b));}}function Eb(a){zb?Ab?Ab.push(a):Ab=[a]:zb=a;}function Fb(){if(zb){var a=zb,b=Ab;Ab=zb=null;Bb(a);if(b)for(a=0;a<b.length;a++)Bb(b[a]);}}function Gb(a,b){return a(b)}function Hb(a,b,c,d,e){return a(b,c,d,e)}function Ib(){}var Jb=Gb,Kb=!1,Lb=!1;function Mb(){if(null!==zb||null!==Ab)Ib(),Fb();}
    	function Nb(a,b,c){if(Lb)return a(b,c);Lb=!0;try{return Jb(a,b,c)}finally{Lb=!1,Mb();}}
    	function Ob(a,b){var c=a.stateNode;if(null===c)return null;var d=Db(c);if(null===d)return null;c=d[b];a:switch(b){case "onClick":case "onClickCapture":case "onDoubleClick":case "onDoubleClickCapture":case "onMouseDown":case "onMouseDownCapture":case "onMouseMove":case "onMouseMoveCapture":case "onMouseUp":case "onMouseUpCapture":case "onMouseEnter":(d=!d.disabled)||(a=a.type,d=!("button"===a||"input"===a||"select"===a||"textarea"===a));a=!d;break a;default:a=!1;}if(a)return null;if(c&&"function"!==
    	typeof c)throw Error(y(231,b,typeof c));return c}var Pb=!1;if(fa)try{var Qb={};Object.defineProperty(Qb,"passive",{get:function(){Pb=!0;}});window.addEventListener("test",Qb,Qb);window.removeEventListener("test",Qb,Qb);}catch(a){Pb=!1;}function Rb(a,b,c,d,e,f,g,h,k){var l=Array.prototype.slice.call(arguments,3);try{b.apply(c,l);}catch(n){this.onError(n);}}var Sb=!1,Tb=null,Ub=!1,Vb=null,Wb={onError:function(a){Sb=!0;Tb=a;}};function Xb(a,b,c,d,e,f,g,h,k){Sb=!1;Tb=null;Rb.apply(Wb,arguments);}
    	function Yb(a,b,c,d,e,f,g,h,k){Xb.apply(this,arguments);if(Sb){if(Sb){var l=Tb;Sb=!1;Tb=null;}else throw Error(y(198));Ub||(Ub=!0,Vb=l);}}function Zb(a){var b=a,c=a;if(a.alternate)for(;b.return;)b=b.return;else {a=b;do b=a,0!==(b.flags&1026)&&(c=b.return),a=b.return;while(a)}return 3===b.tag?c:null}function $b(a){if(13===a.tag){var b=a.memoizedState;null===b&&(a=a.alternate,null!==a&&(b=a.memoizedState));if(null!==b)return b.dehydrated}return null}function ac(a){if(Zb(a)!==a)throw Error(y(188));}
    	function bc(a){var b=a.alternate;if(!b){b=Zb(a);if(null===b)throw Error(y(188));return b!==a?null:a}for(var c=a,d=b;;){var e=c.return;if(null===e)break;var f=e.alternate;if(null===f){d=e.return;if(null!==d){c=d;continue}break}if(e.child===f.child){for(f=e.child;f;){if(f===c)return ac(e),a;if(f===d)return ac(e),b;f=f.sibling;}throw Error(y(188));}if(c.return!==d.return)c=e,d=f;else {for(var g=!1,h=e.child;h;){if(h===c){g=!0;c=e;d=f;break}if(h===d){g=!0;d=e;c=f;break}h=h.sibling;}if(!g){for(h=f.child;h;){if(h===
    	c){g=!0;c=f;d=e;break}if(h===d){g=!0;d=f;c=e;break}h=h.sibling;}if(!g)throw Error(y(189));}}if(c.alternate!==d)throw Error(y(190));}if(3!==c.tag)throw Error(y(188));return c.stateNode.current===c?a:b}function cc(a){a=bc(a);if(!a)return null;for(var b=a;;){if(5===b.tag||6===b.tag)return b;if(b.child)b.child.return=b,b=b.child;else {if(b===a)break;for(;!b.sibling;){if(!b.return||b.return===a)return null;b=b.return;}b.sibling.return=b.return;b=b.sibling;}}return null}
    	function dc(a,b){for(var c=a.alternate;null!==b;){if(b===a||b===c)return !0;b=b.return;}return !1}var ec,fc,gc,hc,ic=!1,jc=[],kc=null,lc=null,mc=null,nc=new Map,oc=new Map,pc=[],qc="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
    	function rc(a,b,c,d,e){return {blockedOn:a,domEventName:b,eventSystemFlags:c|16,nativeEvent:e,targetContainers:[d]}}function sc(a,b){switch(a){case "focusin":case "focusout":kc=null;break;case "dragenter":case "dragleave":lc=null;break;case "mouseover":case "mouseout":mc=null;break;case "pointerover":case "pointerout":nc.delete(b.pointerId);break;case "gotpointercapture":case "lostpointercapture":oc.delete(b.pointerId);}}
    	function tc(a,b,c,d,e,f){if(null===a||a.nativeEvent!==f)return a=rc(b,c,d,e,f),null!==b&&(b=Cb(b),null!==b&&fc(b)),a;a.eventSystemFlags|=d;b=a.targetContainers;null!==e&&-1===b.indexOf(e)&&b.push(e);return a}
    	function uc(a,b,c,d,e){switch(b){case "focusin":return kc=tc(kc,a,b,c,d,e),!0;case "dragenter":return lc=tc(lc,a,b,c,d,e),!0;case "mouseover":return mc=tc(mc,a,b,c,d,e),!0;case "pointerover":var f=e.pointerId;nc.set(f,tc(nc.get(f)||null,a,b,c,d,e));return !0;case "gotpointercapture":return f=e.pointerId,oc.set(f,tc(oc.get(f)||null,a,b,c,d,e)),!0}return !1}
    	function vc(a){var b=wc(a.target);if(null!==b){var c=Zb(b);if(null!==c)if(b=c.tag,13===b){if(b=$b(c),null!==b){a.blockedOn=b;hc(a.lanePriority,function(){r.unstable_runWithPriority(a.priority,function(){gc(c);});});return}}else if(3===b&&c.stateNode.hydrate){a.blockedOn=3===c.tag?c.stateNode.containerInfo:null;return}}a.blockedOn=null;}
    	function xc(a){if(null!==a.blockedOn)return !1;for(var b=a.targetContainers;0<b.length;){var c=yc(a.domEventName,a.eventSystemFlags,b[0],a.nativeEvent);if(null!==c)return b=Cb(c),null!==b&&fc(b),a.blockedOn=c,!1;b.shift();}return !0}function zc(a,b,c){xc(a)&&c.delete(b);}
    	function Ac(){for(ic=!1;0<jc.length;){var a=jc[0];if(null!==a.blockedOn){a=Cb(a.blockedOn);null!==a&&ec(a);break}for(var b=a.targetContainers;0<b.length;){var c=yc(a.domEventName,a.eventSystemFlags,b[0],a.nativeEvent);if(null!==c){a.blockedOn=c;break}b.shift();}null===a.blockedOn&&jc.shift();}null!==kc&&xc(kc)&&(kc=null);null!==lc&&xc(lc)&&(lc=null);null!==mc&&xc(mc)&&(mc=null);nc.forEach(zc);oc.forEach(zc);}
    	function Bc(a,b){a.blockedOn===b&&(a.blockedOn=null,ic||(ic=!0,r.unstable_scheduleCallback(r.unstable_NormalPriority,Ac)));}
    	function Cc(a){function b(b){return Bc(b,a)}if(0<jc.length){Bc(jc[0],a);for(var c=1;c<jc.length;c++){var d=jc[c];d.blockedOn===a&&(d.blockedOn=null);}}null!==kc&&Bc(kc,a);null!==lc&&Bc(lc,a);null!==mc&&Bc(mc,a);nc.forEach(b);oc.forEach(b);for(c=0;c<pc.length;c++)d=pc[c],d.blockedOn===a&&(d.blockedOn=null);for(;0<pc.length&&(c=pc[0],null===c.blockedOn);)vc(c),null===c.blockedOn&&pc.shift();}
    	function Dc(a,b){var c={};c[a.toLowerCase()]=b.toLowerCase();c["Webkit"+a]="webkit"+b;c["Moz"+a]="moz"+b;return c}var Ec={animationend:Dc("Animation","AnimationEnd"),animationiteration:Dc("Animation","AnimationIteration"),animationstart:Dc("Animation","AnimationStart"),transitionend:Dc("Transition","TransitionEnd")},Fc={},Gc={};
    	fa&&(Gc=document.createElement("div").style,"AnimationEvent"in window||(delete Ec.animationend.animation,delete Ec.animationiteration.animation,delete Ec.animationstart.animation),"TransitionEvent"in window||delete Ec.transitionend.transition);function Hc(a){if(Fc[a])return Fc[a];if(!Ec[a])return a;var b=Ec[a],c;for(c in b)if(b.hasOwnProperty(c)&&c in Gc)return Fc[a]=b[c];return a}
    	var Ic=Hc("animationend"),Jc=Hc("animationiteration"),Kc=Hc("animationstart"),Lc=Hc("transitionend"),Mc=new Map,Nc=new Map,Oc=["abort","abort",Ic,"animationEnd",Jc,"animationIteration",Kc,"animationStart","canplay","canPlay","canplaythrough","canPlayThrough","durationchange","durationChange","emptied","emptied","encrypted","encrypted","ended","ended","error","error","gotpointercapture","gotPointerCapture","load","load","loadeddata","loadedData","loadedmetadata","loadedMetadata","loadstart","loadStart",
    	"lostpointercapture","lostPointerCapture","playing","playing","progress","progress","seeking","seeking","stalled","stalled","suspend","suspend","timeupdate","timeUpdate",Lc,"transitionEnd","waiting","waiting"];function Pc(a,b){for(var c=0;c<a.length;c+=2){var d=a[c],e=a[c+1];e="on"+(e[0].toUpperCase()+e.slice(1));Nc.set(d,b);Mc.set(d,e);da(e,[d]);}}var Qc=r.unstable_now;Qc();var F=8;
    	function Rc(a){if(0!==(1&a))return F=15,1;if(0!==(2&a))return F=14,2;if(0!==(4&a))return F=13,4;var b=24&a;if(0!==b)return F=12,b;if(0!==(a&32))return F=11,32;b=192&a;if(0!==b)return F=10,b;if(0!==(a&256))return F=9,256;b=3584&a;if(0!==b)return F=8,b;if(0!==(a&4096))return F=7,4096;b=4186112&a;if(0!==b)return F=6,b;b=62914560&a;if(0!==b)return F=5,b;if(a&67108864)return F=4,67108864;if(0!==(a&134217728))return F=3,134217728;b=805306368&a;if(0!==b)return F=2,b;if(0!==(1073741824&a))return F=1,1073741824;
    	F=8;return a}function Sc(a){switch(a){case 99:return 15;case 98:return 10;case 97:case 96:return 8;case 95:return 2;default:return 0}}function Tc(a){switch(a){case 15:case 14:return 99;case 13:case 12:case 11:case 10:return 98;case 9:case 8:case 7:case 6:case 4:case 5:return 97;case 3:case 2:case 1:return 95;case 0:return 90;default:throw Error(y(358,a));}}
    	function Uc(a,b){var c=a.pendingLanes;if(0===c)return F=0;var d=0,e=0,f=a.expiredLanes,g=a.suspendedLanes,h=a.pingedLanes;if(0!==f)d=f,e=F=15;else if(f=c&134217727,0!==f){var k=f&~g;0!==k?(d=Rc(k),e=F):(h&=f,0!==h&&(d=Rc(h),e=F));}else f=c&~g,0!==f?(d=Rc(f),e=F):0!==h&&(d=Rc(h),e=F);if(0===d)return 0;d=31-Vc(d);d=c&((0>d?0:1<<d)<<1)-1;if(0!==b&&b!==d&&0===(b&g)){Rc(b);if(e<=F)return b;F=e;}b=a.entangledLanes;if(0!==b)for(a=a.entanglements,b&=d;0<b;)c=31-Vc(b),e=1<<c,d|=a[c],b&=~e;return d}
    	function Wc(a){a=a.pendingLanes&-1073741825;return 0!==a?a:a&1073741824?1073741824:0}function Xc(a,b){switch(a){case 15:return 1;case 14:return 2;case 12:return a=Yc(24&~b),0===a?Xc(10,b):a;case 10:return a=Yc(192&~b),0===a?Xc(8,b):a;case 8:return a=Yc(3584&~b),0===a&&(a=Yc(4186112&~b),0===a&&(a=512)),a;case 2:return b=Yc(805306368&~b),0===b&&(b=268435456),b}throw Error(y(358,a));}function Yc(a){return a&-a}function Zc(a){for(var b=[],c=0;31>c;c++)b.push(a);return b}
    	function $c(a,b,c){a.pendingLanes|=b;var d=b-1;a.suspendedLanes&=d;a.pingedLanes&=d;a=a.eventTimes;b=31-Vc(b);a[b]=c;}var Vc=Math.clz32?Math.clz32:ad,bd=Math.log,cd=Math.LN2;function ad(a){return 0===a?32:31-(bd(a)/cd|0)|0}var dd=r.unstable_UserBlockingPriority,ed=r.unstable_runWithPriority,fd=!0;function gd(a,b,c,d){Kb||Ib();var e=hd,f=Kb;Kb=!0;try{Hb(e,a,b,c,d);}finally{(Kb=f)||Mb();}}function id(a,b,c,d){ed(dd,hd.bind(null,a,b,c,d));}
    	function hd(a,b,c,d){if(fd){var e;if((e=0===(b&4))&&0<jc.length&&-1<qc.indexOf(a))a=rc(null,a,b,c,d),jc.push(a);else {var f=yc(a,b,c,d);if(null===f)e&&sc(a,d);else {if(e){if(-1<qc.indexOf(a)){a=rc(f,a,b,c,d);jc.push(a);return}if(uc(f,a,b,c,d))return;sc(a,d);}jd(a,b,d,null,c);}}}}
    	function yc(a,b,c,d){var e=xb(d);e=wc(e);if(null!==e){var f=Zb(e);if(null===f)e=null;else {var g=f.tag;if(13===g){e=$b(f);if(null!==e)return e;e=null;}else if(3===g){if(f.stateNode.hydrate)return 3===f.tag?f.stateNode.containerInfo:null;e=null;}else f!==e&&(e=null);}}jd(a,b,d,e,c);return null}var kd=null,ld=null,md=null;
    	function nd(){if(md)return md;var a,b=ld,c=b.length,d,e="value"in kd?kd.value:kd.textContent,f=e.length;for(a=0;a<c&&b[a]===e[a];a++);var g=c-a;for(d=1;d<=g&&b[c-d]===e[f-d];d++);return md=e.slice(a,1<d?1-d:void 0)}function od(a){var b=a.keyCode;"charCode"in a?(a=a.charCode,0===a&&13===b&&(a=13)):a=b;10===a&&(a=13);return 32<=a||13===a?a:0}function pd(){return !0}function qd(){return !1}
    	function rd(a){function b(b,d,e,f,g){this._reactName=b;this._targetInst=e;this.type=d;this.nativeEvent=f;this.target=g;this.currentTarget=null;for(var c in a)a.hasOwnProperty(c)&&(b=a[c],this[c]=b?b(f):f[c]);this.isDefaultPrevented=(null!=f.defaultPrevented?f.defaultPrevented:!1===f.returnValue)?pd:qd;this.isPropagationStopped=qd;return this}m(b.prototype,{preventDefault:function(){this.defaultPrevented=!0;var a=this.nativeEvent;a&&(a.preventDefault?a.preventDefault():"unknown"!==typeof a.returnValue&&
    	(a.returnValue=!1),this.isDefaultPrevented=pd);},stopPropagation:function(){var a=this.nativeEvent;a&&(a.stopPropagation?a.stopPropagation():"unknown"!==typeof a.cancelBubble&&(a.cancelBubble=!0),this.isPropagationStopped=pd);},persist:function(){},isPersistent:pd});return b}
    	var sd={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(a){return a.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},td=rd(sd),ud=m({},sd,{view:0,detail:0}),vd=rd(ud),wd,xd,yd,Ad=m({},ud,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:zd,button:0,buttons:0,relatedTarget:function(a){return void 0===a.relatedTarget?a.fromElement===a.srcElement?a.toElement:a.fromElement:a.relatedTarget},movementX:function(a){if("movementX"in
    	a)return a.movementX;a!==yd&&(yd&&"mousemove"===a.type?(wd=a.screenX-yd.screenX,xd=a.screenY-yd.screenY):xd=wd=0,yd=a);return wd},movementY:function(a){return "movementY"in a?a.movementY:xd}}),Bd=rd(Ad),Cd=m({},Ad,{dataTransfer:0}),Dd=rd(Cd),Ed=m({},ud,{relatedTarget:0}),Fd=rd(Ed),Gd=m({},sd,{animationName:0,elapsedTime:0,pseudoElement:0}),Hd=rd(Gd),Id=m({},sd,{clipboardData:function(a){return "clipboardData"in a?a.clipboardData:window.clipboardData}}),Jd=rd(Id),Kd=m({},sd,{data:0}),Ld=rd(Kd),Md={Esc:"Escape",
    	Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},Nd={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",
    	119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},Od={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function Pd(a){var b=this.nativeEvent;return b.getModifierState?b.getModifierState(a):(a=Od[a])?!!b[a]:!1}function zd(){return Pd}
    	var Qd=m({},ud,{key:function(a){if(a.key){var b=Md[a.key]||a.key;if("Unidentified"!==b)return b}return "keypress"===a.type?(a=od(a),13===a?"Enter":String.fromCharCode(a)):"keydown"===a.type||"keyup"===a.type?Nd[a.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:zd,charCode:function(a){return "keypress"===a.type?od(a):0},keyCode:function(a){return "keydown"===a.type||"keyup"===a.type?a.keyCode:0},which:function(a){return "keypress"===
    	a.type?od(a):"keydown"===a.type||"keyup"===a.type?a.keyCode:0}}),Rd=rd(Qd),Sd=m({},Ad,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0}),Td=rd(Sd),Ud=m({},ud,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:zd}),Vd=rd(Ud),Wd=m({},sd,{propertyName:0,elapsedTime:0,pseudoElement:0}),Xd=rd(Wd),Yd=m({},Ad,{deltaX:function(a){return "deltaX"in a?a.deltaX:"wheelDeltaX"in a?-a.wheelDeltaX:0},
    	deltaY:function(a){return "deltaY"in a?a.deltaY:"wheelDeltaY"in a?-a.wheelDeltaY:"wheelDelta"in a?-a.wheelDelta:0},deltaZ:0,deltaMode:0}),Zd=rd(Yd),$d=[9,13,27,32],ae=fa&&"CompositionEvent"in window,be=null;fa&&"documentMode"in document&&(be=document.documentMode);var ce=fa&&"TextEvent"in window&&!be,de=fa&&(!ae||be&&8<be&&11>=be),ee=String.fromCharCode(32),fe=!1;
    	function ge(a,b){switch(a){case "keyup":return -1!==$d.indexOf(b.keyCode);case "keydown":return 229!==b.keyCode;case "keypress":case "mousedown":case "focusout":return !0;default:return !1}}function he(a){a=a.detail;return "object"===typeof a&&"data"in a?a.data:null}var ie=!1;function je(a,b){switch(a){case "compositionend":return he(b);case "keypress":if(32!==b.which)return null;fe=!0;return ee;case "textInput":return a=b.data,a===ee&&fe?null:a;default:return null}}
    	function ke(a,b){if(ie)return "compositionend"===a||!ae&&ge(a,b)?(a=nd(),md=ld=kd=null,ie=!1,a):null;switch(a){case "paste":return null;case "keypress":if(!(b.ctrlKey||b.altKey||b.metaKey)||b.ctrlKey&&b.altKey){if(b.char&&1<b.char.length)return b.char;if(b.which)return String.fromCharCode(b.which)}return null;case "compositionend":return de&&"ko"!==b.locale?null:b.data;default:return null}}
    	var le={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function me(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return "input"===b?!!le[a.type]:"textarea"===b?!0:!1}function ne(a,b,c,d){Eb(d);b=oe(b,"onChange");0<b.length&&(c=new td("onChange","change",null,c,d),a.push({event:c,listeners:b}));}var pe=null,qe=null;function re(a){se(a,0);}function te(a){var b=ue(a);if(Wa(b))return a}
    	function ve(a,b){if("change"===a)return b}var we=!1;if(fa){var xe;if(fa){var ye="oninput"in document;if(!ye){var ze=document.createElement("div");ze.setAttribute("oninput","return;");ye="function"===typeof ze.oninput;}xe=ye;}else xe=!1;we=xe&&(!document.documentMode||9<document.documentMode);}function Ae(){pe&&(pe.detachEvent("onpropertychange",Be),qe=pe=null);}function Be(a){if("value"===a.propertyName&&te(qe)){var b=[];ne(b,qe,a,xb(a));a=re;if(Kb)a(b);else {Kb=!0;try{Gb(a,b);}finally{Kb=!1,Mb();}}}}
    	function Ce(a,b,c){"focusin"===a?(Ae(),pe=b,qe=c,pe.attachEvent("onpropertychange",Be)):"focusout"===a&&Ae();}function De(a){if("selectionchange"===a||"keyup"===a||"keydown"===a)return te(qe)}function Ee(a,b){if("click"===a)return te(b)}function Fe(a,b){if("input"===a||"change"===a)return te(b)}function Ge(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var He="function"===typeof Object.is?Object.is:Ge,Ie=Object.prototype.hasOwnProperty;
    	function Je(a,b){if(He(a,b))return !0;if("object"!==typeof a||null===a||"object"!==typeof b||null===b)return !1;var c=Object.keys(a),d=Object.keys(b);if(c.length!==d.length)return !1;for(d=0;d<c.length;d++)if(!Ie.call(b,c[d])||!He(a[c[d]],b[c[d]]))return !1;return !0}function Ke(a){for(;a&&a.firstChild;)a=a.firstChild;return a}
    	function Le(a,b){var c=Ke(a);a=0;for(var d;c;){if(3===c.nodeType){d=a+c.textContent.length;if(a<=b&&d>=b)return {node:c,offset:b-a};a=d;}a:{for(;c;){if(c.nextSibling){c=c.nextSibling;break a}c=c.parentNode;}c=void 0;}c=Ke(c);}}function Me(a,b){return a&&b?a===b?!0:a&&3===a.nodeType?!1:b&&3===b.nodeType?Me(a,b.parentNode):"contains"in a?a.contains(b):a.compareDocumentPosition?!!(a.compareDocumentPosition(b)&16):!1:!1}
    	function Ne(){for(var a=window,b=Xa();b instanceof a.HTMLIFrameElement;){try{var c="string"===typeof b.contentWindow.location.href;}catch(d){c=!1;}if(c)a=b.contentWindow;else break;b=Xa(a.document);}return b}function Oe(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return b&&("input"===b&&("text"===a.type||"search"===a.type||"tel"===a.type||"url"===a.type||"password"===a.type)||"textarea"===b||"true"===a.contentEditable)}
    	var Pe=fa&&"documentMode"in document&&11>=document.documentMode,Qe=null,Re=null,Se=null,Te=!1;
    	function Ue(a,b,c){var d=c.window===c?c.document:9===c.nodeType?c:c.ownerDocument;Te||null==Qe||Qe!==Xa(d)||(d=Qe,"selectionStart"in d&&Oe(d)?d={start:d.selectionStart,end:d.selectionEnd}:(d=(d.ownerDocument&&d.ownerDocument.defaultView||window).getSelection(),d={anchorNode:d.anchorNode,anchorOffset:d.anchorOffset,focusNode:d.focusNode,focusOffset:d.focusOffset}),Se&&Je(Se,d)||(Se=d,d=oe(Re,"onSelect"),0<d.length&&(b=new td("onSelect","select",null,b,c),a.push({event:b,listeners:d}),b.target=Qe)));}
    	Pc("cancel cancel click click close close contextmenu contextMenu copy copy cut cut auxclick auxClick dblclick doubleClick dragend dragEnd dragstart dragStart drop drop focusin focus focusout blur input input invalid invalid keydown keyDown keypress keyPress keyup keyUp mousedown mouseDown mouseup mouseUp paste paste pause pause play play pointercancel pointerCancel pointerdown pointerDown pointerup pointerUp ratechange rateChange reset reset seeked seeked submit submit touchcancel touchCancel touchend touchEnd touchstart touchStart volumechange volumeChange".split(" "),
    	0);Pc("drag drag dragenter dragEnter dragexit dragExit dragleave dragLeave dragover dragOver mousemove mouseMove mouseout mouseOut mouseover mouseOver pointermove pointerMove pointerout pointerOut pointerover pointerOver scroll scroll toggle toggle touchmove touchMove wheel wheel".split(" "),1);Pc(Oc,2);for(var Ve="change selectionchange textInput compositionstart compositionend compositionupdate".split(" "),We=0;We<Ve.length;We++)Nc.set(Ve[We],0);ea("onMouseEnter",["mouseout","mouseover"]);
    	ea("onMouseLeave",["mouseout","mouseover"]);ea("onPointerEnter",["pointerout","pointerover"]);ea("onPointerLeave",["pointerout","pointerover"]);da("onChange","change click focusin focusout input keydown keyup selectionchange".split(" "));da("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));da("onBeforeInput",["compositionend","keypress","textInput","paste"]);da("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" "));
    	da("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" "));da("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var Xe="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),Ye=new Set("cancel close invalid load scroll toggle".split(" ").concat(Xe));
    	function Ze(a,b,c){var d=a.type||"unknown-event";a.currentTarget=c;Yb(d,b,void 0,a);a.currentTarget=null;}
    	function se(a,b){b=0!==(b&4);for(var c=0;c<a.length;c++){var d=a[c],e=d.event;d=d.listeners;a:{var f=void 0;if(b)for(var g=d.length-1;0<=g;g--){var h=d[g],k=h.instance,l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;Ze(e,h,l);f=k;}else for(g=0;g<d.length;g++){h=d[g];k=h.instance;l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;Ze(e,h,l);f=k;}}}if(Ub)throw a=Vb,Ub=!1,Vb=null,a;}
    	function G(a,b){var c=$e(b),d=a+"__bubble";c.has(d)||(af(b,a,2,!1),c.add(d));}var bf="_reactListening"+Math.random().toString(36).slice(2);function cf(a){a[bf]||(a[bf]=!0,ba.forEach(function(b){Ye.has(b)||df(b,!1,a,null);df(b,!0,a,null);}));}
    	function df(a,b,c,d){var e=4<arguments.length&&void 0!==arguments[4]?arguments[4]:0,f=c;"selectionchange"===a&&9!==c.nodeType&&(f=c.ownerDocument);if(null!==d&&!b&&Ye.has(a)){if("scroll"!==a)return;e|=2;f=d;}var g=$e(f),h=a+"__"+(b?"capture":"bubble");g.has(h)||(b&&(e|=4),af(f,a,e,b),g.add(h));}
    	function af(a,b,c,d){var e=Nc.get(b);switch(void 0===e?2:e){case 0:e=gd;break;case 1:e=id;break;default:e=hd;}c=e.bind(null,b,c,a);e=void 0;!Pb||"touchstart"!==b&&"touchmove"!==b&&"wheel"!==b||(e=!0);d?void 0!==e?a.addEventListener(b,c,{capture:!0,passive:e}):a.addEventListener(b,c,!0):void 0!==e?a.addEventListener(b,c,{passive:e}):a.addEventListener(b,c,!1);}
    	function jd(a,b,c,d,e){var f=d;if(0===(b&1)&&0===(b&2)&&null!==d)a:for(;;){if(null===d)return;var g=d.tag;if(3===g||4===g){var h=d.stateNode.containerInfo;if(h===e||8===h.nodeType&&h.parentNode===e)break;if(4===g)for(g=d.return;null!==g;){var k=g.tag;if(3===k||4===k)if(k=g.stateNode.containerInfo,k===e||8===k.nodeType&&k.parentNode===e)return;g=g.return;}for(;null!==h;){g=wc(h);if(null===g)return;k=g.tag;if(5===k||6===k){d=f=g;continue a}h=h.parentNode;}}d=d.return;}Nb(function(){var d=f,e=xb(c),g=[];
    	a:{var h=Mc.get(a);if(void 0!==h){var k=td,x=a;switch(a){case "keypress":if(0===od(c))break a;case "keydown":case "keyup":k=Rd;break;case "focusin":x="focus";k=Fd;break;case "focusout":x="blur";k=Fd;break;case "beforeblur":case "afterblur":k=Fd;break;case "click":if(2===c.button)break a;case "auxclick":case "dblclick":case "mousedown":case "mousemove":case "mouseup":case "mouseout":case "mouseover":case "contextmenu":k=Bd;break;case "drag":case "dragend":case "dragenter":case "dragexit":case "dragleave":case "dragover":case "dragstart":case "drop":k=
    	Dd;break;case "touchcancel":case "touchend":case "touchmove":case "touchstart":k=Vd;break;case Ic:case Jc:case Kc:k=Hd;break;case Lc:k=Xd;break;case "scroll":k=vd;break;case "wheel":k=Zd;break;case "copy":case "cut":case "paste":k=Jd;break;case "gotpointercapture":case "lostpointercapture":case "pointercancel":case "pointerdown":case "pointermove":case "pointerout":case "pointerover":case "pointerup":k=Td;}var w=0!==(b&4),z=!w&&"scroll"===a,u=w?null!==h?h+"Capture":null:h;w=[];for(var t=d,q;null!==
    	t;){q=t;var v=q.stateNode;5===q.tag&&null!==v&&(q=v,null!==u&&(v=Ob(t,u),null!=v&&w.push(ef(t,v,q))));if(z)break;t=t.return;}0<w.length&&(h=new k(h,x,null,c,e),g.push({event:h,listeners:w}));}}if(0===(b&7)){a:{h="mouseover"===a||"pointerover"===a;k="mouseout"===a||"pointerout"===a;if(h&&0===(b&16)&&(x=c.relatedTarget||c.fromElement)&&(wc(x)||x[ff]))break a;if(k||h){h=e.window===e?e:(h=e.ownerDocument)?h.defaultView||h.parentWindow:window;if(k){if(x=c.relatedTarget||c.toElement,k=d,x=x?wc(x):null,null!==
    	x&&(z=Zb(x),x!==z||5!==x.tag&&6!==x.tag))x=null;}else k=null,x=d;if(k!==x){w=Bd;v="onMouseLeave";u="onMouseEnter";t="mouse";if("pointerout"===a||"pointerover"===a)w=Td,v="onPointerLeave",u="onPointerEnter",t="pointer";z=null==k?h:ue(k);q=null==x?h:ue(x);h=new w(v,t+"leave",k,c,e);h.target=z;h.relatedTarget=q;v=null;wc(e)===d&&(w=new w(u,t+"enter",x,c,e),w.target=q,w.relatedTarget=z,v=w);z=v;if(k&&x)b:{w=k;u=x;t=0;for(q=w;q;q=gf(q))t++;q=0;for(v=u;v;v=gf(v))q++;for(;0<t-q;)w=gf(w),t--;for(;0<q-t;)u=
    	gf(u),q--;for(;t--;){if(w===u||null!==u&&w===u.alternate)break b;w=gf(w);u=gf(u);}w=null;}else w=null;null!==k&&hf(g,h,k,w,!1);null!==x&&null!==z&&hf(g,z,x,w,!0);}}}a:{h=d?ue(d):window;k=h.nodeName&&h.nodeName.toLowerCase();if("select"===k||"input"===k&&"file"===h.type)var J=ve;else if(me(h))if(we)J=Fe;else {J=De;var K=Ce;}else (k=h.nodeName)&&"input"===k.toLowerCase()&&("checkbox"===h.type||"radio"===h.type)&&(J=Ee);if(J&&(J=J(a,d))){ne(g,J,c,e);break a}K&&K(a,h,d);"focusout"===a&&(K=h._wrapperState)&&
    	K.controlled&&"number"===h.type&&bb(h,"number",h.value);}K=d?ue(d):window;switch(a){case "focusin":if(me(K)||"true"===K.contentEditable)Qe=K,Re=d,Se=null;break;case "focusout":Se=Re=Qe=null;break;case "mousedown":Te=!0;break;case "contextmenu":case "mouseup":case "dragend":Te=!1;Ue(g,c,e);break;case "selectionchange":if(Pe)break;case "keydown":case "keyup":Ue(g,c,e);}var Q;if(ae)b:{switch(a){case "compositionstart":var L="onCompositionStart";break b;case "compositionend":L="onCompositionEnd";break b;
    	case "compositionupdate":L="onCompositionUpdate";break b}L=void 0;}else ie?ge(a,c)&&(L="onCompositionEnd"):"keydown"===a&&229===c.keyCode&&(L="onCompositionStart");L&&(de&&"ko"!==c.locale&&(ie||"onCompositionStart"!==L?"onCompositionEnd"===L&&ie&&(Q=nd()):(kd=e,ld="value"in kd?kd.value:kd.textContent,ie=!0)),K=oe(d,L),0<K.length&&(L=new Ld(L,a,null,c,e),g.push({event:L,listeners:K}),Q?L.data=Q:(Q=he(c),null!==Q&&(L.data=Q))));if(Q=ce?je(a,c):ke(a,c))d=oe(d,"onBeforeInput"),0<d.length&&(e=new Ld("onBeforeInput",
    	"beforeinput",null,c,e),g.push({event:e,listeners:d}),e.data=Q);}se(g,b);});}function ef(a,b,c){return {instance:a,listener:b,currentTarget:c}}function oe(a,b){for(var c=b+"Capture",d=[];null!==a;){var e=a,f=e.stateNode;5===e.tag&&null!==f&&(e=f,f=Ob(a,c),null!=f&&d.unshift(ef(a,f,e)),f=Ob(a,b),null!=f&&d.push(ef(a,f,e)));a=a.return;}return d}function gf(a){if(null===a)return null;do a=a.return;while(a&&5!==a.tag);return a?a:null}
    	function hf(a,b,c,d,e){for(var f=b._reactName,g=[];null!==c&&c!==d;){var h=c,k=h.alternate,l=h.stateNode;if(null!==k&&k===d)break;5===h.tag&&null!==l&&(h=l,e?(k=Ob(c,f),null!=k&&g.unshift(ef(c,k,h))):e||(k=Ob(c,f),null!=k&&g.push(ef(c,k,h))));c=c.return;}0!==g.length&&a.push({event:b,listeners:g});}function jf(){}var kf=null,lf=null;function mf(a,b){switch(a){case "button":case "input":case "select":case "textarea":return !!b.autoFocus}return !1}
    	function nf(a,b){return "textarea"===a||"option"===a||"noscript"===a||"string"===typeof b.children||"number"===typeof b.children||"object"===typeof b.dangerouslySetInnerHTML&&null!==b.dangerouslySetInnerHTML&&null!=b.dangerouslySetInnerHTML.__html}var of="function"===typeof setTimeout?setTimeout:void 0,pf="function"===typeof clearTimeout?clearTimeout:void 0;function qf(a){1===a.nodeType?a.textContent="":9===a.nodeType&&(a=a.body,null!=a&&(a.textContent=""));}
    	function rf(a){for(;null!=a;a=a.nextSibling){var b=a.nodeType;if(1===b||3===b)break}return a}function sf(a){a=a.previousSibling;for(var b=0;a;){if(8===a.nodeType){var c=a.data;if("$"===c||"$!"===c||"$?"===c){if(0===b)return a;b--;}else "/$"===c&&b++;}a=a.previousSibling;}return null}var tf=0;function uf(a){return {$$typeof:Ga,toString:a,valueOf:a}}var vf=Math.random().toString(36).slice(2),wf="__reactFiber$"+vf,xf="__reactProps$"+vf,ff="__reactContainer$"+vf,yf="__reactEvents$"+vf;
    	function wc(a){var b=a[wf];if(b)return b;for(var c=a.parentNode;c;){if(b=c[ff]||c[wf]){c=b.alternate;if(null!==b.child||null!==c&&null!==c.child)for(a=sf(a);null!==a;){if(c=a[wf])return c;a=sf(a);}return b}a=c;c=a.parentNode;}return null}function Cb(a){a=a[wf]||a[ff];return !a||5!==a.tag&&6!==a.tag&&13!==a.tag&&3!==a.tag?null:a}function ue(a){if(5===a.tag||6===a.tag)return a.stateNode;throw Error(y(33));}function Db(a){return a[xf]||null}
    	function $e(a){var b=a[yf];void 0===b&&(b=a[yf]=new Set);return b}var zf=[],Af=-1;function Bf(a){return {current:a}}function H(a){0>Af||(a.current=zf[Af],zf[Af]=null,Af--);}function I(a,b){Af++;zf[Af]=a.current;a.current=b;}var Cf={},M=Bf(Cf),N=Bf(!1),Df=Cf;
    	function Ef(a,b){var c=a.type.contextTypes;if(!c)return Cf;var d=a.stateNode;if(d&&d.__reactInternalMemoizedUnmaskedChildContext===b)return d.__reactInternalMemoizedMaskedChildContext;var e={},f;for(f in c)e[f]=b[f];d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=b,a.__reactInternalMemoizedMaskedChildContext=e);return e}function Ff(a){a=a.childContextTypes;return null!==a&&void 0!==a}function Gf(){H(N);H(M);}function Hf(a,b,c){if(M.current!==Cf)throw Error(y(168));I(M,b);I(N,c);}
    	function If(a,b,c){var d=a.stateNode;a=b.childContextTypes;if("function"!==typeof d.getChildContext)return c;d=d.getChildContext();for(var e in d)if(!(e in a))throw Error(y(108,Ra(b)||"Unknown",e));return m({},c,d)}function Jf(a){a=(a=a.stateNode)&&a.__reactInternalMemoizedMergedChildContext||Cf;Df=M.current;I(M,a);I(N,N.current);return !0}function Kf(a,b,c){var d=a.stateNode;if(!d)throw Error(y(169));c?(a=If(a,b,Df),d.__reactInternalMemoizedMergedChildContext=a,H(N),H(M),I(M,a)):H(N);I(N,c);}
    	var Lf=null,Mf=null,Nf=r.unstable_runWithPriority,Of=r.unstable_scheduleCallback,Pf=r.unstable_cancelCallback,Qf=r.unstable_shouldYield,Rf=r.unstable_requestPaint,Sf=r.unstable_now,Tf=r.unstable_getCurrentPriorityLevel,Uf=r.unstable_ImmediatePriority,Vf=r.unstable_UserBlockingPriority,Wf=r.unstable_NormalPriority,Xf=r.unstable_LowPriority,Yf=r.unstable_IdlePriority,Zf={},$f=void 0!==Rf?Rf:function(){},ag=null,bg=null,cg=!1,dg=Sf(),O=1E4>dg?Sf:function(){return Sf()-dg};
    	function eg(){switch(Tf()){case Uf:return 99;case Vf:return 98;case Wf:return 97;case Xf:return 96;case Yf:return 95;default:throw Error(y(332));}}function fg(a){switch(a){case 99:return Uf;case 98:return Vf;case 97:return Wf;case 96:return Xf;case 95:return Yf;default:throw Error(y(332));}}function gg(a,b){a=fg(a);return Nf(a,b)}function hg(a,b,c){a=fg(a);return Of(a,b,c)}function ig(){if(null!==bg){var a=bg;bg=null;Pf(a);}jg();}
    	function jg(){if(!cg&&null!==ag){cg=!0;var a=0;try{var b=ag;gg(99,function(){for(;a<b.length;a++){var c=b[a];do c=c(!0);while(null!==c)}});ag=null;}catch(c){throw null!==ag&&(ag=ag.slice(a+1)),Of(Uf,ig),c;}finally{cg=!1;}}}var kg=ra.ReactCurrentBatchConfig;function lg(a,b){if(a&&a.defaultProps){b=m({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}var mg=Bf(null),ng=null,og=null,pg=null;function qg(){pg=og=ng=null;}
    	function rg(a){var b=mg.current;H(mg);a.type._context._currentValue=b;}function sg(a,b){for(;null!==a;){var c=a.alternate;if((a.childLanes&b)===b)if(null===c||(c.childLanes&b)===b)break;else c.childLanes|=b;else a.childLanes|=b,null!==c&&(c.childLanes|=b);a=a.return;}}function tg(a,b){ng=a;pg=og=null;a=a.dependencies;null!==a&&null!==a.firstContext&&(0!==(a.lanes&b)&&(ug=!0),a.firstContext=null);}
    	function vg(a,b){if(pg!==a&&!1!==b&&0!==b){if("number"!==typeof b||1073741823===b)pg=a,b=1073741823;b={context:a,observedBits:b,next:null};if(null===og){if(null===ng)throw Error(y(308));og=b;ng.dependencies={lanes:0,firstContext:b,responders:null};}else og=og.next=b;}return a._currentValue}var wg=!1;function xg(a){a.updateQueue={baseState:a.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null},effects:null};}
    	function yg(a,b){a=a.updateQueue;b.updateQueue===a&&(b.updateQueue={baseState:a.baseState,firstBaseUpdate:a.firstBaseUpdate,lastBaseUpdate:a.lastBaseUpdate,shared:a.shared,effects:a.effects});}function zg(a,b){return {eventTime:a,lane:b,tag:0,payload:null,callback:null,next:null}}function Ag(a,b){a=a.updateQueue;if(null!==a){a=a.shared;var c=a.pending;null===c?b.next=b:(b.next=c.next,c.next=b);a.pending=b;}}
    	function Bg(a,b){var c=a.updateQueue,d=a.alternate;if(null!==d&&(d=d.updateQueue,c===d)){var e=null,f=null;c=c.firstBaseUpdate;if(null!==c){do{var g={eventTime:c.eventTime,lane:c.lane,tag:c.tag,payload:c.payload,callback:c.callback,next:null};null===f?e=f=g:f=f.next=g;c=c.next;}while(null!==c);null===f?e=f=b:f=f.next=b;}else e=f=b;c={baseState:d.baseState,firstBaseUpdate:e,lastBaseUpdate:f,shared:d.shared,effects:d.effects};a.updateQueue=c;return}a=c.lastBaseUpdate;null===a?c.firstBaseUpdate=b:a.next=
    	b;c.lastBaseUpdate=b;}
    	function Cg(a,b,c,d){var e=a.updateQueue;wg=!1;var f=e.firstBaseUpdate,g=e.lastBaseUpdate,h=e.shared.pending;if(null!==h){e.shared.pending=null;var k=h,l=k.next;k.next=null;null===g?f=l:g.next=l;g=k;var n=a.alternate;if(null!==n){n=n.updateQueue;var A=n.lastBaseUpdate;A!==g&&(null===A?n.firstBaseUpdate=l:A.next=l,n.lastBaseUpdate=k);}}if(null!==f){A=e.baseState;g=0;n=l=k=null;do{h=f.lane;var p=f.eventTime;if((d&h)===h){null!==n&&(n=n.next={eventTime:p,lane:0,tag:f.tag,payload:f.payload,callback:f.callback,
    	next:null});a:{var C=a,x=f;h=b;p=c;switch(x.tag){case 1:C=x.payload;if("function"===typeof C){A=C.call(p,A,h);break a}A=C;break a;case 3:C.flags=C.flags&-4097|64;case 0:C=x.payload;h="function"===typeof C?C.call(p,A,h):C;if(null===h||void 0===h)break a;A=m({},A,h);break a;case 2:wg=!0;}}null!==f.callback&&(a.flags|=32,h=e.effects,null===h?e.effects=[f]:h.push(f));}else p={eventTime:p,lane:h,tag:f.tag,payload:f.payload,callback:f.callback,next:null},null===n?(l=n=p,k=A):n=n.next=p,g|=h;f=f.next;if(null===
    	f)if(h=e.shared.pending,null===h)break;else f=h.next,h.next=null,e.lastBaseUpdate=h,e.shared.pending=null;}while(1);null===n&&(k=A);e.baseState=k;e.firstBaseUpdate=l;e.lastBaseUpdate=n;Dg|=g;a.lanes=g;a.memoizedState=A;}}function Eg(a,b,c){a=b.effects;b.effects=null;if(null!==a)for(b=0;b<a.length;b++){var d=a[b],e=d.callback;if(null!==e){d.callback=null;d=c;if("function"!==typeof e)throw Error(y(191,e));e.call(d);}}}var Fg=(new aa.Component).refs;
    	function Gg(a,b,c,d){b=a.memoizedState;c=c(d,b);c=null===c||void 0===c?b:m({},b,c);a.memoizedState=c;0===a.lanes&&(a.updateQueue.baseState=c);}
    	var Kg={isMounted:function(a){return (a=a._reactInternals)?Zb(a)===a:!1},enqueueSetState:function(a,b,c){a=a._reactInternals;var d=Hg(),e=Ig(a),f=zg(d,e);f.payload=b;void 0!==c&&null!==c&&(f.callback=c);Ag(a,f);Jg(a,e,d);},enqueueReplaceState:function(a,b,c){a=a._reactInternals;var d=Hg(),e=Ig(a),f=zg(d,e);f.tag=1;f.payload=b;void 0!==c&&null!==c&&(f.callback=c);Ag(a,f);Jg(a,e,d);},enqueueForceUpdate:function(a,b){a=a._reactInternals;var c=Hg(),d=Ig(a),e=zg(c,d);e.tag=2;void 0!==b&&null!==b&&(e.callback=
    	b);Ag(a,e);Jg(a,d,c);}};function Lg(a,b,c,d,e,f,g){a=a.stateNode;return "function"===typeof a.shouldComponentUpdate?a.shouldComponentUpdate(d,f,g):b.prototype&&b.prototype.isPureReactComponent?!Je(c,d)||!Je(e,f):!0}
    	function Mg(a,b,c){var d=!1,e=Cf;var f=b.contextType;"object"===typeof f&&null!==f?f=vg(f):(e=Ff(b)?Df:M.current,d=b.contextTypes,f=(d=null!==d&&void 0!==d)?Ef(a,e):Cf);b=new b(c,f);a.memoizedState=null!==b.state&&void 0!==b.state?b.state:null;b.updater=Kg;a.stateNode=b;b._reactInternals=a;d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=e,a.__reactInternalMemoizedMaskedChildContext=f);return b}
    	function Ng(a,b,c,d){a=b.state;"function"===typeof b.componentWillReceiveProps&&b.componentWillReceiveProps(c,d);"function"===typeof b.UNSAFE_componentWillReceiveProps&&b.UNSAFE_componentWillReceiveProps(c,d);b.state!==a&&Kg.enqueueReplaceState(b,b.state,null);}
    	function Og(a,b,c,d){var e=a.stateNode;e.props=c;e.state=a.memoizedState;e.refs=Fg;xg(a);var f=b.contextType;"object"===typeof f&&null!==f?e.context=vg(f):(f=Ff(b)?Df:M.current,e.context=Ef(a,f));Cg(a,c,e,d);e.state=a.memoizedState;f=b.getDerivedStateFromProps;"function"===typeof f&&(Gg(a,b,f,c),e.state=a.memoizedState);"function"===typeof b.getDerivedStateFromProps||"function"===typeof e.getSnapshotBeforeUpdate||"function"!==typeof e.UNSAFE_componentWillMount&&"function"!==typeof e.componentWillMount||
    	(b=e.state,"function"===typeof e.componentWillMount&&e.componentWillMount(),"function"===typeof e.UNSAFE_componentWillMount&&e.UNSAFE_componentWillMount(),b!==e.state&&Kg.enqueueReplaceState(e,e.state,null),Cg(a,c,e,d),e.state=a.memoizedState);"function"===typeof e.componentDidMount&&(a.flags|=4);}var Pg=Array.isArray;
    	function Qg(a,b,c){a=c.ref;if(null!==a&&"function"!==typeof a&&"object"!==typeof a){if(c._owner){c=c._owner;if(c){if(1!==c.tag)throw Error(y(309));var d=c.stateNode;}if(!d)throw Error(y(147,a));var e=""+a;if(null!==b&&null!==b.ref&&"function"===typeof b.ref&&b.ref._stringRef===e)return b.ref;b=function(a){var b=d.refs;b===Fg&&(b=d.refs={});null===a?delete b[e]:b[e]=a;};b._stringRef=e;return b}if("string"!==typeof a)throw Error(y(284));if(!c._owner)throw Error(y(290,a));}return a}
    	function Rg(a,b){if("textarea"!==a.type)throw Error(y(31,"[object Object]"===Object.prototype.toString.call(b)?"object with keys {"+Object.keys(b).join(", ")+"}":b));}
    	function Sg(a){function b(b,c){if(a){var d=b.lastEffect;null!==d?(d.nextEffect=c,b.lastEffect=c):b.firstEffect=b.lastEffect=c;c.nextEffect=null;c.flags=8;}}function c(c,d){if(!a)return null;for(;null!==d;)b(c,d),d=d.sibling;return null}function d(a,b){for(a=new Map;null!==b;)null!==b.key?a.set(b.key,b):a.set(b.index,b),b=b.sibling;return a}function e(a,b){a=Tg(a,b);a.index=0;a.sibling=null;return a}function f(b,c,d){b.index=d;if(!a)return c;d=b.alternate;if(null!==d)return d=d.index,d<c?(b.flags=2,
    	c):d;b.flags=2;return c}function g(b){a&&null===b.alternate&&(b.flags=2);return b}function h(a,b,c,d){if(null===b||6!==b.tag)return b=Ug(c,a.mode,d),b.return=a,b;b=e(b,c);b.return=a;return b}function k(a,b,c,d){if(null!==b&&b.elementType===c.type)return d=e(b,c.props),d.ref=Qg(a,b,c),d.return=a,d;d=Vg(c.type,c.key,c.props,null,a.mode,d);d.ref=Qg(a,b,c);d.return=a;return d}function l(a,b,c,d){if(null===b||4!==b.tag||b.stateNode.containerInfo!==c.containerInfo||b.stateNode.implementation!==c.implementation)return b=
    	Wg(c,a.mode,d),b.return=a,b;b=e(b,c.children||[]);b.return=a;return b}function n(a,b,c,d,f){if(null===b||7!==b.tag)return b=Xg(c,a.mode,d,f),b.return=a,b;b=e(b,c);b.return=a;return b}function A(a,b,c){if("string"===typeof b||"number"===typeof b)return b=Ug(""+b,a.mode,c),b.return=a,b;if("object"===typeof b&&null!==b){switch(b.$$typeof){case sa:return c=Vg(b.type,b.key,b.props,null,a.mode,c),c.ref=Qg(a,null,b),c.return=a,c;case ta:return b=Wg(b,a.mode,c),b.return=a,b}if(Pg(b)||La(b))return b=Xg(b,
    	a.mode,c,null),b.return=a,b;Rg(a,b);}return null}function p(a,b,c,d){var e=null!==b?b.key:null;if("string"===typeof c||"number"===typeof c)return null!==e?null:h(a,b,""+c,d);if("object"===typeof c&&null!==c){switch(c.$$typeof){case sa:return c.key===e?c.type===ua?n(a,b,c.props.children,d,e):k(a,b,c,d):null;case ta:return c.key===e?l(a,b,c,d):null}if(Pg(c)||La(c))return null!==e?null:n(a,b,c,d,null);Rg(a,c);}return null}function C(a,b,c,d,e){if("string"===typeof d||"number"===typeof d)return a=a.get(c)||
    	null,h(b,a,""+d,e);if("object"===typeof d&&null!==d){switch(d.$$typeof){case sa:return a=a.get(null===d.key?c:d.key)||null,d.type===ua?n(b,a,d.props.children,e,d.key):k(b,a,d,e);case ta:return a=a.get(null===d.key?c:d.key)||null,l(b,a,d,e)}if(Pg(d)||La(d))return a=a.get(c)||null,n(b,a,d,e,null);Rg(b,d);}return null}function x(e,g,h,k){for(var l=null,t=null,u=g,z=g=0,q=null;null!==u&&z<h.length;z++){u.index>z?(q=u,u=null):q=u.sibling;var n=p(e,u,h[z],k);if(null===n){null===u&&(u=q);break}a&&u&&null===
    	n.alternate&&b(e,u);g=f(n,g,z);null===t?l=n:t.sibling=n;t=n;u=q;}if(z===h.length)return c(e,u),l;if(null===u){for(;z<h.length;z++)u=A(e,h[z],k),null!==u&&(g=f(u,g,z),null===t?l=u:t.sibling=u,t=u);return l}for(u=d(e,u);z<h.length;z++)q=C(u,e,z,h[z],k),null!==q&&(a&&null!==q.alternate&&u.delete(null===q.key?z:q.key),g=f(q,g,z),null===t?l=q:t.sibling=q,t=q);a&&u.forEach(function(a){return b(e,a)});return l}function w(e,g,h,k){var l=La(h);if("function"!==typeof l)throw Error(y(150));h=l.call(h);if(null==
    	h)throw Error(y(151));for(var t=l=null,u=g,z=g=0,q=null,n=h.next();null!==u&&!n.done;z++,n=h.next()){u.index>z?(q=u,u=null):q=u.sibling;var w=p(e,u,n.value,k);if(null===w){null===u&&(u=q);break}a&&u&&null===w.alternate&&b(e,u);g=f(w,g,z);null===t?l=w:t.sibling=w;t=w;u=q;}if(n.done)return c(e,u),l;if(null===u){for(;!n.done;z++,n=h.next())n=A(e,n.value,k),null!==n&&(g=f(n,g,z),null===t?l=n:t.sibling=n,t=n);return l}for(u=d(e,u);!n.done;z++,n=h.next())n=C(u,e,z,n.value,k),null!==n&&(a&&null!==n.alternate&&
    	u.delete(null===n.key?z:n.key),g=f(n,g,z),null===t?l=n:t.sibling=n,t=n);a&&u.forEach(function(a){return b(e,a)});return l}return function(a,d,f,h){var k="object"===typeof f&&null!==f&&f.type===ua&&null===f.key;k&&(f=f.props.children);var l="object"===typeof f&&null!==f;if(l)switch(f.$$typeof){case sa:a:{l=f.key;for(k=d;null!==k;){if(k.key===l){switch(k.tag){case 7:if(f.type===ua){c(a,k.sibling);d=e(k,f.props.children);d.return=a;a=d;break a}break;default:if(k.elementType===f.type){c(a,k.sibling);
    	d=e(k,f.props);d.ref=Qg(a,k,f);d.return=a;a=d;break a}}c(a,k);break}else b(a,k);k=k.sibling;}f.type===ua?(d=Xg(f.props.children,a.mode,h,f.key),d.return=a,a=d):(h=Vg(f.type,f.key,f.props,null,a.mode,h),h.ref=Qg(a,d,f),h.return=a,a=h);}return g(a);case ta:a:{for(k=f.key;null!==d;){if(d.key===k)if(4===d.tag&&d.stateNode.containerInfo===f.containerInfo&&d.stateNode.implementation===f.implementation){c(a,d.sibling);d=e(d,f.children||[]);d.return=a;a=d;break a}else {c(a,d);break}else b(a,d);d=d.sibling;}d=
    	Wg(f,a.mode,h);d.return=a;a=d;}return g(a)}if("string"===typeof f||"number"===typeof f)return f=""+f,null!==d&&6===d.tag?(c(a,d.sibling),d=e(d,f),d.return=a,a=d):(c(a,d),d=Ug(f,a.mode,h),d.return=a,a=d),g(a);if(Pg(f))return x(a,d,f,h);if(La(f))return w(a,d,f,h);l&&Rg(a,f);if("undefined"===typeof f&&!k)switch(a.tag){case 1:case 22:case 0:case 11:case 15:throw Error(y(152,Ra(a.type)||"Component"));}return c(a,d)}}var Yg=Sg(!0),Zg=Sg(!1),$g={},ah=Bf($g),bh=Bf($g),ch=Bf($g);
    	function dh(a){if(a===$g)throw Error(y(174));return a}function eh(a,b){I(ch,b);I(bh,a);I(ah,$g);a=b.nodeType;switch(a){case 9:case 11:b=(b=b.documentElement)?b.namespaceURI:mb(null,"");break;default:a=8===a?b.parentNode:b,b=a.namespaceURI||null,a=a.tagName,b=mb(b,a);}H(ah);I(ah,b);}function fh(){H(ah);H(bh);H(ch);}function gh(a){dh(ch.current);var b=dh(ah.current);var c=mb(b,a.type);b!==c&&(I(bh,a),I(ah,c));}function hh(a){bh.current===a&&(H(ah),H(bh));}var P=Bf(0);
    	function ih(a){for(var b=a;null!==b;){if(13===b.tag){var c=b.memoizedState;if(null!==c&&(c=c.dehydrated,null===c||"$?"===c.data||"$!"===c.data))return b}else if(19===b.tag&&void 0!==b.memoizedProps.revealOrder){if(0!==(b.flags&64))return b}else if(null!==b.child){b.child.return=b;b=b.child;continue}if(b===a)break;for(;null===b.sibling;){if(null===b.return||b.return===a)return null;b=b.return;}b.sibling.return=b.return;b=b.sibling;}return null}var jh=null,kh=null,lh=!1;
    	function mh(a,b){var c=nh(5,null,null,0);c.elementType="DELETED";c.type="DELETED";c.stateNode=b;c.return=a;c.flags=8;null!==a.lastEffect?(a.lastEffect.nextEffect=c,a.lastEffect=c):a.firstEffect=a.lastEffect=c;}function oh(a,b){switch(a.tag){case 5:var c=a.type;b=1!==b.nodeType||c.toLowerCase()!==b.nodeName.toLowerCase()?null:b;return null!==b?(a.stateNode=b,!0):!1;case 6:return b=""===a.pendingProps||3!==b.nodeType?null:b,null!==b?(a.stateNode=b,!0):!1;case 13:return !1;default:return !1}}
    	function ph(a){if(lh){var b=kh;if(b){var c=b;if(!oh(a,b)){b=rf(c.nextSibling);if(!b||!oh(a,b)){a.flags=a.flags&-1025|2;lh=!1;jh=a;return}mh(jh,c);}jh=a;kh=rf(b.firstChild);}else a.flags=a.flags&-1025|2,lh=!1,jh=a;}}function qh(a){for(a=a.return;null!==a&&5!==a.tag&&3!==a.tag&&13!==a.tag;)a=a.return;jh=a;}
    	function rh(a){if(a!==jh)return !1;if(!lh)return qh(a),lh=!0,!1;var b=a.type;if(5!==a.tag||"head"!==b&&"body"!==b&&!nf(b,a.memoizedProps))for(b=kh;b;)mh(a,b),b=rf(b.nextSibling);qh(a);if(13===a.tag){a=a.memoizedState;a=null!==a?a.dehydrated:null;if(!a)throw Error(y(317));a:{a=a.nextSibling;for(b=0;a;){if(8===a.nodeType){var c=a.data;if("/$"===c){if(0===b){kh=rf(a.nextSibling);break a}b--;}else "$"!==c&&"$!"!==c&&"$?"!==c||b++;}a=a.nextSibling;}kh=null;}}else kh=jh?rf(a.stateNode.nextSibling):null;return !0}
    	function sh(){kh=jh=null;lh=!1;}var th=[];function uh(){for(var a=0;a<th.length;a++)th[a]._workInProgressVersionPrimary=null;th.length=0;}var vh=ra.ReactCurrentDispatcher,wh=ra.ReactCurrentBatchConfig,xh=0,R=null,S=null,T=null,yh=!1,zh=!1;function Ah(){throw Error(y(321));}function Bh(a,b){if(null===b)return !1;for(var c=0;c<b.length&&c<a.length;c++)if(!He(a[c],b[c]))return !1;return !0}
    	function Ch(a,b,c,d,e,f){xh=f;R=b;b.memoizedState=null;b.updateQueue=null;b.lanes=0;vh.current=null===a||null===a.memoizedState?Dh:Eh;a=c(d,e);if(zh){f=0;do{zh=!1;if(!(25>f))throw Error(y(301));f+=1;T=S=null;b.updateQueue=null;vh.current=Fh;a=c(d,e);}while(zh)}vh.current=Gh;b=null!==S&&null!==S.next;xh=0;T=S=R=null;yh=!1;if(b)throw Error(y(300));return a}function Hh(){var a={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};null===T?R.memoizedState=T=a:T=T.next=a;return T}
    	function Ih(){if(null===S){var a=R.alternate;a=null!==a?a.memoizedState:null;}else a=S.next;var b=null===T?R.memoizedState:T.next;if(null!==b)T=b,S=a;else {if(null===a)throw Error(y(310));S=a;a={memoizedState:S.memoizedState,baseState:S.baseState,baseQueue:S.baseQueue,queue:S.queue,next:null};null===T?R.memoizedState=T=a:T=T.next=a;}return T}function Jh(a,b){return "function"===typeof b?b(a):b}
    	function Kh(a){var b=Ih(),c=b.queue;if(null===c)throw Error(y(311));c.lastRenderedReducer=a;var d=S,e=d.baseQueue,f=c.pending;if(null!==f){if(null!==e){var g=e.next;e.next=f.next;f.next=g;}d.baseQueue=e=f;c.pending=null;}if(null!==e){e=e.next;d=d.baseState;var h=g=f=null,k=e;do{var l=k.lane;if((xh&l)===l)null!==h&&(h=h.next={lane:0,action:k.action,eagerReducer:k.eagerReducer,eagerState:k.eagerState,next:null}),d=k.eagerReducer===a?k.eagerState:a(d,k.action);else {var n={lane:l,action:k.action,eagerReducer:k.eagerReducer,
    	eagerState:k.eagerState,next:null};null===h?(g=h=n,f=d):h=h.next=n;R.lanes|=l;Dg|=l;}k=k.next;}while(null!==k&&k!==e);null===h?f=d:h.next=g;He(d,b.memoizedState)||(ug=!0);b.memoizedState=d;b.baseState=f;b.baseQueue=h;c.lastRenderedState=d;}return [b.memoizedState,c.dispatch]}
    	function Lh(a){var b=Ih(),c=b.queue;if(null===c)throw Error(y(311));c.lastRenderedReducer=a;var d=c.dispatch,e=c.pending,f=b.memoizedState;if(null!==e){c.pending=null;var g=e=e.next;do f=a(f,g.action),g=g.next;while(g!==e);He(f,b.memoizedState)||(ug=!0);b.memoizedState=f;null===b.baseQueue&&(b.baseState=f);c.lastRenderedState=f;}return [f,d]}
    	function Mh(a,b,c){var d=b._getVersion;d=d(b._source);var e=b._workInProgressVersionPrimary;if(null!==e)a=e===d;else if(a=a.mutableReadLanes,a=(xh&a)===a)b._workInProgressVersionPrimary=d,th.push(b);if(a)return c(b._source);th.push(b);throw Error(y(350));}
    	function Nh(a,b,c,d){var e=U;if(null===e)throw Error(y(349));var f=b._getVersion,g=f(b._source),h=vh.current,k=h.useState(function(){return Mh(e,b,c)}),l=k[1],n=k[0];k=T;var A=a.memoizedState,p=A.refs,C=p.getSnapshot,x=A.source;A=A.subscribe;var w=R;a.memoizedState={refs:p,source:b,subscribe:d};h.useEffect(function(){p.getSnapshot=c;p.setSnapshot=l;var a=f(b._source);if(!He(g,a)){a=c(b._source);He(n,a)||(l(a),a=Ig(w),e.mutableReadLanes|=a&e.pendingLanes);a=e.mutableReadLanes;e.entangledLanes|=a;for(var d=
    	e.entanglements,h=a;0<h;){var k=31-Vc(h),v=1<<k;d[k]|=a;h&=~v;}}},[c,b,d]);h.useEffect(function(){return d(b._source,function(){var a=p.getSnapshot,c=p.setSnapshot;try{c(a(b._source));var d=Ig(w);e.mutableReadLanes|=d&e.pendingLanes;}catch(q){c(function(){throw q;});}})},[b,d]);He(C,c)&&He(x,b)&&He(A,d)||(a={pending:null,dispatch:null,lastRenderedReducer:Jh,lastRenderedState:n},a.dispatch=l=Oh.bind(null,R,a),k.queue=a,k.baseQueue=null,n=Mh(e,b,c),k.memoizedState=k.baseState=n);return n}
    	function Ph(a,b,c){var d=Ih();return Nh(d,a,b,c)}function Qh(a){var b=Hh();"function"===typeof a&&(a=a());b.memoizedState=b.baseState=a;a=b.queue={pending:null,dispatch:null,lastRenderedReducer:Jh,lastRenderedState:a};a=a.dispatch=Oh.bind(null,R,a);return [b.memoizedState,a]}
    	function Rh(a,b,c,d){a={tag:a,create:b,destroy:c,deps:d,next:null};b=R.updateQueue;null===b?(b={lastEffect:null},R.updateQueue=b,b.lastEffect=a.next=a):(c=b.lastEffect,null===c?b.lastEffect=a.next=a:(d=c.next,c.next=a,a.next=d,b.lastEffect=a));return a}function Sh(a){var b=Hh();a={current:a};return b.memoizedState=a}function Th(){return Ih().memoizedState}function Uh(a,b,c,d){var e=Hh();R.flags|=a;e.memoizedState=Rh(1|b,c,void 0,void 0===d?null:d);}
    	function Vh(a,b,c,d){var e=Ih();d=void 0===d?null:d;var f=void 0;if(null!==S){var g=S.memoizedState;f=g.destroy;if(null!==d&&Bh(d,g.deps)){Rh(b,c,f,d);return}}R.flags|=a;e.memoizedState=Rh(1|b,c,f,d);}function Wh(a,b){return Uh(516,4,a,b)}function Xh(a,b){return Vh(516,4,a,b)}function Yh(a,b){return Vh(4,2,a,b)}function Zh(a,b){if("function"===typeof b)return a=a(),b(a),function(){b(null);};if(null!==b&&void 0!==b)return a=a(),b.current=a,function(){b.current=null;}}
    	function $h(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return Vh(4,2,Zh.bind(null,b,a),c)}function ai(){}function bi(a,b){var c=Ih();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Bh(b,d[1]))return d[0];c.memoizedState=[a,b];return a}function ci(a,b){var c=Ih();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Bh(b,d[1]))return d[0];a=a();c.memoizedState=[a,b];return a}
    	function di(a,b){var c=eg();gg(98>c?98:c,function(){a(!0);});gg(97<c?97:c,function(){var c=wh.transition;wh.transition=1;try{a(!1),b();}finally{wh.transition=c;}});}
    	function Oh(a,b,c){var d=Hg(),e=Ig(a),f={lane:e,action:c,eagerReducer:null,eagerState:null,next:null},g=b.pending;null===g?f.next=f:(f.next=g.next,g.next=f);b.pending=f;g=a.alternate;if(a===R||null!==g&&g===R)zh=yh=!0;else {if(0===a.lanes&&(null===g||0===g.lanes)&&(g=b.lastRenderedReducer,null!==g))try{var h=b.lastRenderedState,k=g(h,c);f.eagerReducer=g;f.eagerState=k;if(He(k,h))return}catch(l){}finally{}Jg(a,e,d);}}
    	var Gh={readContext:vg,useCallback:Ah,useContext:Ah,useEffect:Ah,useImperativeHandle:Ah,useLayoutEffect:Ah,useMemo:Ah,useReducer:Ah,useRef:Ah,useState:Ah,useDebugValue:Ah,useDeferredValue:Ah,useTransition:Ah,useMutableSource:Ah,useOpaqueIdentifier:Ah,unstable_isNewReconciler:!1},Dh={readContext:vg,useCallback:function(a,b){Hh().memoizedState=[a,void 0===b?null:b];return a},useContext:vg,useEffect:Wh,useImperativeHandle:function(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return Uh(4,2,Zh.bind(null,
    	b,a),c)},useLayoutEffect:function(a,b){return Uh(4,2,a,b)},useMemo:function(a,b){var c=Hh();b=void 0===b?null:b;a=a();c.memoizedState=[a,b];return a},useReducer:function(a,b,c){var d=Hh();b=void 0!==c?c(b):b;d.memoizedState=d.baseState=b;a=d.queue={pending:null,dispatch:null,lastRenderedReducer:a,lastRenderedState:b};a=a.dispatch=Oh.bind(null,R,a);return [d.memoizedState,a]},useRef:Sh,useState:Qh,useDebugValue:ai,useDeferredValue:function(a){var b=Qh(a),c=b[0],d=b[1];Wh(function(){var b=wh.transition;
    	wh.transition=1;try{d(a);}finally{wh.transition=b;}},[a]);return c},useTransition:function(){var a=Qh(!1),b=a[0];a=di.bind(null,a[1]);Sh(a);return [a,b]},useMutableSource:function(a,b,c){var d=Hh();d.memoizedState={refs:{getSnapshot:b,setSnapshot:null},source:a,subscribe:c};return Nh(d,a,b,c)},useOpaqueIdentifier:function(){if(lh){var a=!1,b=uf(function(){a||(a=!0,c("r:"+(tf++).toString(36)));throw Error(y(355));}),c=Qh(b)[1];0===(R.mode&2)&&(R.flags|=516,Rh(5,function(){c("r:"+(tf++).toString(36));},
    	void 0,null));return b}b="r:"+(tf++).toString(36);Qh(b);return b},unstable_isNewReconciler:!1},Eh={readContext:vg,useCallback:bi,useContext:vg,useEffect:Xh,useImperativeHandle:$h,useLayoutEffect:Yh,useMemo:ci,useReducer:Kh,useRef:Th,useState:function(){return Kh(Jh)},useDebugValue:ai,useDeferredValue:function(a){var b=Kh(Jh),c=b[0],d=b[1];Xh(function(){var b=wh.transition;wh.transition=1;try{d(a);}finally{wh.transition=b;}},[a]);return c},useTransition:function(){var a=Kh(Jh)[0];return [Th().current,
    	a]},useMutableSource:Ph,useOpaqueIdentifier:function(){return Kh(Jh)[0]},unstable_isNewReconciler:!1},Fh={readContext:vg,useCallback:bi,useContext:vg,useEffect:Xh,useImperativeHandle:$h,useLayoutEffect:Yh,useMemo:ci,useReducer:Lh,useRef:Th,useState:function(){return Lh(Jh)},useDebugValue:ai,useDeferredValue:function(a){var b=Lh(Jh),c=b[0],d=b[1];Xh(function(){var b=wh.transition;wh.transition=1;try{d(a);}finally{wh.transition=b;}},[a]);return c},useTransition:function(){var a=Lh(Jh)[0];return [Th().current,
    	a]},useMutableSource:Ph,useOpaqueIdentifier:function(){return Lh(Jh)[0]},unstable_isNewReconciler:!1},ei=ra.ReactCurrentOwner,ug=!1;function fi(a,b,c,d){b.child=null===a?Zg(b,null,c,d):Yg(b,a.child,c,d);}function gi(a,b,c,d,e){c=c.render;var f=b.ref;tg(b,e);d=Ch(a,b,c,d,f,e);if(null!==a&&!ug)return b.updateQueue=a.updateQueue,b.flags&=-517,a.lanes&=~e,hi(a,b,e);b.flags|=1;fi(a,b,d,e);return b.child}
    	function ii(a,b,c,d,e,f){if(null===a){var g=c.type;if("function"===typeof g&&!ji(g)&&void 0===g.defaultProps&&null===c.compare&&void 0===c.defaultProps)return b.tag=15,b.type=g,ki(a,b,g,d,e,f);a=Vg(c.type,null,d,b,b.mode,f);a.ref=b.ref;a.return=b;return b.child=a}g=a.child;if(0===(e&f)&&(e=g.memoizedProps,c=c.compare,c=null!==c?c:Je,c(e,d)&&a.ref===b.ref))return hi(a,b,f);b.flags|=1;a=Tg(g,d);a.ref=b.ref;a.return=b;return b.child=a}
    	function ki(a,b,c,d,e,f){if(null!==a&&Je(a.memoizedProps,d)&&a.ref===b.ref)if(ug=!1,0!==(f&e))0!==(a.flags&16384)&&(ug=!0);else return b.lanes=a.lanes,hi(a,b,f);return li(a,b,c,d,f)}
    	function mi(a,b,c){var d=b.pendingProps,e=d.children,f=null!==a?a.memoizedState:null;if("hidden"===d.mode||"unstable-defer-without-hiding"===d.mode)if(0===(b.mode&4))b.memoizedState={baseLanes:0},ni(b,c);else if(0!==(c&1073741824))b.memoizedState={baseLanes:0},ni(b,null!==f?f.baseLanes:c);else return a=null!==f?f.baseLanes|c:c,b.lanes=b.childLanes=1073741824,b.memoizedState={baseLanes:a},ni(b,a),null;else null!==f?(d=f.baseLanes|c,b.memoizedState=null):d=c,ni(b,d);fi(a,b,e,c);return b.child}
    	function oi(a,b){var c=b.ref;if(null===a&&null!==c||null!==a&&a.ref!==c)b.flags|=128;}function li(a,b,c,d,e){var f=Ff(c)?Df:M.current;f=Ef(b,f);tg(b,e);c=Ch(a,b,c,d,f,e);if(null!==a&&!ug)return b.updateQueue=a.updateQueue,b.flags&=-517,a.lanes&=~e,hi(a,b,e);b.flags|=1;fi(a,b,c,e);return b.child}
    	function pi(a,b,c,d,e){if(Ff(c)){var f=!0;Jf(b);}else f=!1;tg(b,e);if(null===b.stateNode)null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2),Mg(b,c,d),Og(b,c,d,e),d=!0;else if(null===a){var g=b.stateNode,h=b.memoizedProps;g.props=h;var k=g.context,l=c.contextType;"object"===typeof l&&null!==l?l=vg(l):(l=Ff(c)?Df:M.current,l=Ef(b,l));var n=c.getDerivedStateFromProps,A="function"===typeof n||"function"===typeof g.getSnapshotBeforeUpdate;A||"function"!==typeof g.UNSAFE_componentWillReceiveProps&&
    	"function"!==typeof g.componentWillReceiveProps||(h!==d||k!==l)&&Ng(b,g,d,l);wg=!1;var p=b.memoizedState;g.state=p;Cg(b,d,g,e);k=b.memoizedState;h!==d||p!==k||N.current||wg?("function"===typeof n&&(Gg(b,c,n,d),k=b.memoizedState),(h=wg||Lg(b,c,h,d,p,k,l))?(A||"function"!==typeof g.UNSAFE_componentWillMount&&"function"!==typeof g.componentWillMount||("function"===typeof g.componentWillMount&&g.componentWillMount(),"function"===typeof g.UNSAFE_componentWillMount&&g.UNSAFE_componentWillMount()),"function"===
    	typeof g.componentDidMount&&(b.flags|=4)):("function"===typeof g.componentDidMount&&(b.flags|=4),b.memoizedProps=d,b.memoizedState=k),g.props=d,g.state=k,g.context=l,d=h):("function"===typeof g.componentDidMount&&(b.flags|=4),d=!1);}else {g=b.stateNode;yg(a,b);h=b.memoizedProps;l=b.type===b.elementType?h:lg(b.type,h);g.props=l;A=b.pendingProps;p=g.context;k=c.contextType;"object"===typeof k&&null!==k?k=vg(k):(k=Ff(c)?Df:M.current,k=Ef(b,k));var C=c.getDerivedStateFromProps;(n="function"===typeof C||
    	"function"===typeof g.getSnapshotBeforeUpdate)||"function"!==typeof g.UNSAFE_componentWillReceiveProps&&"function"!==typeof g.componentWillReceiveProps||(h!==A||p!==k)&&Ng(b,g,d,k);wg=!1;p=b.memoizedState;g.state=p;Cg(b,d,g,e);var x=b.memoizedState;h!==A||p!==x||N.current||wg?("function"===typeof C&&(Gg(b,c,C,d),x=b.memoizedState),(l=wg||Lg(b,c,l,d,p,x,k))?(n||"function"!==typeof g.UNSAFE_componentWillUpdate&&"function"!==typeof g.componentWillUpdate||("function"===typeof g.componentWillUpdate&&g.componentWillUpdate(d,
    	x,k),"function"===typeof g.UNSAFE_componentWillUpdate&&g.UNSAFE_componentWillUpdate(d,x,k)),"function"===typeof g.componentDidUpdate&&(b.flags|=4),"function"===typeof g.getSnapshotBeforeUpdate&&(b.flags|=256)):("function"!==typeof g.componentDidUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=256),b.memoizedProps=d,b.memoizedState=x),g.props=d,g.state=x,g.context=k,d=l):("function"!==typeof g.componentDidUpdate||
    	h===a.memoizedProps&&p===a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=256),d=!1);}return qi(a,b,c,d,f,e)}
    	function qi(a,b,c,d,e,f){oi(a,b);var g=0!==(b.flags&64);if(!d&&!g)return e&&Kf(b,c,!1),hi(a,b,f);d=b.stateNode;ei.current=b;var h=g&&"function"!==typeof c.getDerivedStateFromError?null:d.render();b.flags|=1;null!==a&&g?(b.child=Yg(b,a.child,null,f),b.child=Yg(b,null,h,f)):fi(a,b,h,f);b.memoizedState=d.state;e&&Kf(b,c,!0);return b.child}function ri(a){var b=a.stateNode;b.pendingContext?Hf(a,b.pendingContext,b.pendingContext!==b.context):b.context&&Hf(a,b.context,!1);eh(a,b.containerInfo);}
    	var si={dehydrated:null,retryLane:0};
    	function ti(a,b,c){var d=b.pendingProps,e=P.current,f=!1,g;(g=0!==(b.flags&64))||(g=null!==a&&null===a.memoizedState?!1:0!==(e&2));g?(f=!0,b.flags&=-65):null!==a&&null===a.memoizedState||void 0===d.fallback||!0===d.unstable_avoidThisFallback||(e|=1);I(P,e&1);if(null===a){void 0!==d.fallback&&ph(b);a=d.children;e=d.fallback;if(f)return a=ui(b,a,e,c),b.child.memoizedState={baseLanes:c},b.memoizedState=si,a;if("number"===typeof d.unstable_expectedLoadTime)return a=ui(b,a,e,c),b.child.memoizedState={baseLanes:c},
    	b.memoizedState=si,b.lanes=33554432,a;c=vi({mode:"visible",children:a},b.mode,c,null);c.return=b;return b.child=c}if(null!==a.memoizedState){if(f)return d=wi(a,b,d.children,d.fallback,c),f=b.child,e=a.child.memoizedState,f.memoizedState=null===e?{baseLanes:c}:{baseLanes:e.baseLanes|c},f.childLanes=a.childLanes&~c,b.memoizedState=si,d;c=xi(a,b,d.children,c);b.memoizedState=null;return c}if(f)return d=wi(a,b,d.children,d.fallback,c),f=b.child,e=a.child.memoizedState,f.memoizedState=null===e?{baseLanes:c}:
    	{baseLanes:e.baseLanes|c},f.childLanes=a.childLanes&~c,b.memoizedState=si,d;c=xi(a,b,d.children,c);b.memoizedState=null;return c}function ui(a,b,c,d){var e=a.mode,f=a.child;b={mode:"hidden",children:b};0===(e&2)&&null!==f?(f.childLanes=0,f.pendingProps=b):f=vi(b,e,0,null);c=Xg(c,e,d,null);f.return=a;c.return=a;f.sibling=c;a.child=f;return c}
    	function xi(a,b,c,d){var e=a.child;a=e.sibling;c=Tg(e,{mode:"visible",children:c});0===(b.mode&2)&&(c.lanes=d);c.return=b;c.sibling=null;null!==a&&(a.nextEffect=null,a.flags=8,b.firstEffect=b.lastEffect=a);return b.child=c}
    	function wi(a,b,c,d,e){var f=b.mode,g=a.child;a=g.sibling;var h={mode:"hidden",children:c};0===(f&2)&&b.child!==g?(c=b.child,c.childLanes=0,c.pendingProps=h,g=c.lastEffect,null!==g?(b.firstEffect=c.firstEffect,b.lastEffect=g,g.nextEffect=null):b.firstEffect=b.lastEffect=null):c=Tg(g,h);null!==a?d=Tg(a,d):(d=Xg(d,f,e,null),d.flags|=2);d.return=b;c.return=b;c.sibling=d;b.child=c;return d}function yi(a,b){a.lanes|=b;var c=a.alternate;null!==c&&(c.lanes|=b);sg(a.return,b);}
    	function zi(a,b,c,d,e,f){var g=a.memoizedState;null===g?a.memoizedState={isBackwards:b,rendering:null,renderingStartTime:0,last:d,tail:c,tailMode:e,lastEffect:f}:(g.isBackwards=b,g.rendering=null,g.renderingStartTime=0,g.last=d,g.tail=c,g.tailMode=e,g.lastEffect=f);}
    	function Ai(a,b,c){var d=b.pendingProps,e=d.revealOrder,f=d.tail;fi(a,b,d.children,c);d=P.current;if(0!==(d&2))d=d&1|2,b.flags|=64;else {if(null!==a&&0!==(a.flags&64))a:for(a=b.child;null!==a;){if(13===a.tag)null!==a.memoizedState&&yi(a,c);else if(19===a.tag)yi(a,c);else if(null!==a.child){a.child.return=a;a=a.child;continue}if(a===b)break a;for(;null===a.sibling;){if(null===a.return||a.return===b)break a;a=a.return;}a.sibling.return=a.return;a=a.sibling;}d&=1;}I(P,d);if(0===(b.mode&2))b.memoizedState=
    	null;else switch(e){case "forwards":c=b.child;for(e=null;null!==c;)a=c.alternate,null!==a&&null===ih(a)&&(e=c),c=c.sibling;c=e;null===c?(e=b.child,b.child=null):(e=c.sibling,c.sibling=null);zi(b,!1,e,c,f,b.lastEffect);break;case "backwards":c=null;e=b.child;for(b.child=null;null!==e;){a=e.alternate;if(null!==a&&null===ih(a)){b.child=e;break}a=e.sibling;e.sibling=c;c=e;e=a;}zi(b,!0,c,null,f,b.lastEffect);break;case "together":zi(b,!1,null,null,void 0,b.lastEffect);break;default:b.memoizedState=null;}return b.child}
    	function hi(a,b,c){null!==a&&(b.dependencies=a.dependencies);Dg|=b.lanes;if(0!==(c&b.childLanes)){if(null!==a&&b.child!==a.child)throw Error(y(153));if(null!==b.child){a=b.child;c=Tg(a,a.pendingProps);b.child=c;for(c.return=b;null!==a.sibling;)a=a.sibling,c=c.sibling=Tg(a,a.pendingProps),c.return=b;c.sibling=null;}return b.child}return null}var Bi,Ci,Di,Ei;
    	Bi=function(a,b){for(var c=b.child;null!==c;){if(5===c.tag||6===c.tag)a.appendChild(c.stateNode);else if(4!==c.tag&&null!==c.child){c.child.return=c;c=c.child;continue}if(c===b)break;for(;null===c.sibling;){if(null===c.return||c.return===b)return;c=c.return;}c.sibling.return=c.return;c=c.sibling;}};Ci=function(){};
    	Di=function(a,b,c,d){var e=a.memoizedProps;if(e!==d){a=b.stateNode;dh(ah.current);var f=null;switch(c){case "input":e=Ya(a,e);d=Ya(a,d);f=[];break;case "option":e=eb(a,e);d=eb(a,d);f=[];break;case "select":e=m({},e,{value:void 0});d=m({},d,{value:void 0});f=[];break;case "textarea":e=gb(a,e);d=gb(a,d);f=[];break;default:"function"!==typeof e.onClick&&"function"===typeof d.onClick&&(a.onclick=jf);}vb(c,d);var g;c=null;for(l in e)if(!d.hasOwnProperty(l)&&e.hasOwnProperty(l)&&null!=e[l])if("style"===
    	l){var h=e[l];for(g in h)h.hasOwnProperty(g)&&(c||(c={}),c[g]="");}else "dangerouslySetInnerHTML"!==l&&"children"!==l&&"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&"autoFocus"!==l&&(ca.hasOwnProperty(l)?f||(f=[]):(f=f||[]).push(l,null));for(l in d){var k=d[l];h=null!=e?e[l]:void 0;if(d.hasOwnProperty(l)&&k!==h&&(null!=k||null!=h))if("style"===l)if(h){for(g in h)!h.hasOwnProperty(g)||k&&k.hasOwnProperty(g)||(c||(c={}),c[g]="");for(g in k)k.hasOwnProperty(g)&&h[g]!==k[g]&&(c||
    	(c={}),c[g]=k[g]);}else c||(f||(f=[]),f.push(l,c)),c=k;else "dangerouslySetInnerHTML"===l?(k=k?k.__html:void 0,h=h?h.__html:void 0,null!=k&&h!==k&&(f=f||[]).push(l,k)):"children"===l?"string"!==typeof k&&"number"!==typeof k||(f=f||[]).push(l,""+k):"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&(ca.hasOwnProperty(l)?(null!=k&&"onScroll"===l&&G("scroll",a),f||h===k||(f=[])):"object"===typeof k&&null!==k&&k.$$typeof===Ga?k.toString():(f=f||[]).push(l,k));}c&&(f=f||[]).push("style",
    	c);var l=f;if(b.updateQueue=l)b.flags|=4;}};Ei=function(a,b,c,d){c!==d&&(b.flags|=4);};function Fi(a,b){if(!lh)switch(a.tailMode){case "hidden":b=a.tail;for(var c=null;null!==b;)null!==b.alternate&&(c=b),b=b.sibling;null===c?a.tail=null:c.sibling=null;break;case "collapsed":c=a.tail;for(var d=null;null!==c;)null!==c.alternate&&(d=c),c=c.sibling;null===d?b||null===a.tail?a.tail=null:a.tail.sibling=null:d.sibling=null;}}
    	function Gi(a,b,c){var d=b.pendingProps;switch(b.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return null;case 1:return Ff(b.type)&&Gf(),null;case 3:fh();H(N);H(M);uh();d=b.stateNode;d.pendingContext&&(d.context=d.pendingContext,d.pendingContext=null);if(null===a||null===a.child)rh(b)?b.flags|=4:d.hydrate||(b.flags|=256);Ci(b);return null;case 5:hh(b);var e=dh(ch.current);c=b.type;if(null!==a&&null!=b.stateNode)Di(a,b,c,d,e),a.ref!==b.ref&&(b.flags|=128);else {if(!d){if(null===
    	b.stateNode)throw Error(y(166));return null}a=dh(ah.current);if(rh(b)){d=b.stateNode;c=b.type;var f=b.memoizedProps;d[wf]=b;d[xf]=f;switch(c){case "dialog":G("cancel",d);G("close",d);break;case "iframe":case "object":case "embed":G("load",d);break;case "video":case "audio":for(a=0;a<Xe.length;a++)G(Xe[a],d);break;case "source":G("error",d);break;case "img":case "image":case "link":G("error",d);G("load",d);break;case "details":G("toggle",d);break;case "input":Za(d,f);G("invalid",d);break;case "select":d._wrapperState=
    	{wasMultiple:!!f.multiple};G("invalid",d);break;case "textarea":hb(d,f),G("invalid",d);}vb(c,f);a=null;for(var g in f)f.hasOwnProperty(g)&&(e=f[g],"children"===g?"string"===typeof e?d.textContent!==e&&(a=["children",e]):"number"===typeof e&&d.textContent!==""+e&&(a=["children",""+e]):ca.hasOwnProperty(g)&&null!=e&&"onScroll"===g&&G("scroll",d));switch(c){case "input":Va(d);cb(d,f,!0);break;case "textarea":Va(d);jb(d);break;case "select":case "option":break;default:"function"===typeof f.onClick&&(d.onclick=
    	jf);}d=a;b.updateQueue=d;null!==d&&(b.flags|=4);}else {g=9===e.nodeType?e:e.ownerDocument;a===kb.html&&(a=lb(c));a===kb.html?"script"===c?(a=g.createElement("div"),a.innerHTML="<script>\x3c/script>",a=a.removeChild(a.firstChild)):"string"===typeof d.is?a=g.createElement(c,{is:d.is}):(a=g.createElement(c),"select"===c&&(g=a,d.multiple?g.multiple=!0:d.size&&(g.size=d.size))):a=g.createElementNS(a,c);a[wf]=b;a[xf]=d;Bi(a,b,!1,!1);b.stateNode=a;g=wb(c,d);switch(c){case "dialog":G("cancel",a);G("close",a);
    	e=d;break;case "iframe":case "object":case "embed":G("load",a);e=d;break;case "video":case "audio":for(e=0;e<Xe.length;e++)G(Xe[e],a);e=d;break;case "source":G("error",a);e=d;break;case "img":case "image":case "link":G("error",a);G("load",a);e=d;break;case "details":G("toggle",a);e=d;break;case "input":Za(a,d);e=Ya(a,d);G("invalid",a);break;case "option":e=eb(a,d);break;case "select":a._wrapperState={wasMultiple:!!d.multiple};e=m({},d,{value:void 0});G("invalid",a);break;case "textarea":hb(a,d);e=
    	gb(a,d);G("invalid",a);break;default:e=d;}vb(c,e);var h=e;for(f in h)if(h.hasOwnProperty(f)){var k=h[f];"style"===f?tb(a,k):"dangerouslySetInnerHTML"===f?(k=k?k.__html:void 0,null!=k&&ob(a,k)):"children"===f?"string"===typeof k?("textarea"!==c||""!==k)&&pb(a,k):"number"===typeof k&&pb(a,""+k):"suppressContentEditableWarning"!==f&&"suppressHydrationWarning"!==f&&"autoFocus"!==f&&(ca.hasOwnProperty(f)?null!=k&&"onScroll"===f&&G("scroll",a):null!=k&&qa(a,f,k,g));}switch(c){case "input":Va(a);cb(a,d,!1);
    	break;case "textarea":Va(a);jb(a);break;case "option":null!=d.value&&a.setAttribute("value",""+Sa(d.value));break;case "select":a.multiple=!!d.multiple;f=d.value;null!=f?fb(a,!!d.multiple,f,!1):null!=d.defaultValue&&fb(a,!!d.multiple,d.defaultValue,!0);break;default:"function"===typeof e.onClick&&(a.onclick=jf);}mf(c,d)&&(b.flags|=4);}null!==b.ref&&(b.flags|=128);}return null;case 6:if(a&&null!=b.stateNode)Ei(a,b,a.memoizedProps,d);else {if("string"!==typeof d&&null===b.stateNode)throw Error(y(166));
    	c=dh(ch.current);dh(ah.current);rh(b)?(d=b.stateNode,c=b.memoizedProps,d[wf]=b,d.nodeValue!==c&&(b.flags|=4)):(d=(9===c.nodeType?c:c.ownerDocument).createTextNode(d),d[wf]=b,b.stateNode=d);}return null;case 13:H(P);d=b.memoizedState;if(0!==(b.flags&64))return b.lanes=c,b;d=null!==d;c=!1;null===a?void 0!==b.memoizedProps.fallback&&rh(b):c=null!==a.memoizedState;if(d&&!c&&0!==(b.mode&2))if(null===a&&!0!==b.memoizedProps.unstable_avoidThisFallback||0!==(P.current&1))0===V&&(V=3);else {if(0===V||3===V)V=
    	4;null===U||0===(Dg&134217727)&&0===(Hi&134217727)||Ii(U,W);}if(d||c)b.flags|=4;return null;case 4:return fh(),Ci(b),null===a&&cf(b.stateNode.containerInfo),null;case 10:return rg(b),null;case 17:return Ff(b.type)&&Gf(),null;case 19:H(P);d=b.memoizedState;if(null===d)return null;f=0!==(b.flags&64);g=d.rendering;if(null===g)if(f)Fi(d,!1);else {if(0!==V||null!==a&&0!==(a.flags&64))for(a=b.child;null!==a;){g=ih(a);if(null!==g){b.flags|=64;Fi(d,!1);f=g.updateQueue;null!==f&&(b.updateQueue=f,b.flags|=4);
    	null===d.lastEffect&&(b.firstEffect=null);b.lastEffect=d.lastEffect;d=c;for(c=b.child;null!==c;)f=c,a=d,f.flags&=2,f.nextEffect=null,f.firstEffect=null,f.lastEffect=null,g=f.alternate,null===g?(f.childLanes=0,f.lanes=a,f.child=null,f.memoizedProps=null,f.memoizedState=null,f.updateQueue=null,f.dependencies=null,f.stateNode=null):(f.childLanes=g.childLanes,f.lanes=g.lanes,f.child=g.child,f.memoizedProps=g.memoizedProps,f.memoizedState=g.memoizedState,f.updateQueue=g.updateQueue,f.type=g.type,a=g.dependencies,
    	f.dependencies=null===a?null:{lanes:a.lanes,firstContext:a.firstContext}),c=c.sibling;I(P,P.current&1|2);return b.child}a=a.sibling;}null!==d.tail&&O()>Ji&&(b.flags|=64,f=!0,Fi(d,!1),b.lanes=33554432);}else {if(!f)if(a=ih(g),null!==a){if(b.flags|=64,f=!0,c=a.updateQueue,null!==c&&(b.updateQueue=c,b.flags|=4),Fi(d,!0),null===d.tail&&"hidden"===d.tailMode&&!g.alternate&&!lh)return b=b.lastEffect=d.lastEffect,null!==b&&(b.nextEffect=null),null}else 2*O()-d.renderingStartTime>Ji&&1073741824!==c&&(b.flags|=
    	64,f=!0,Fi(d,!1),b.lanes=33554432);d.isBackwards?(g.sibling=b.child,b.child=g):(c=d.last,null!==c?c.sibling=g:b.child=g,d.last=g);}return null!==d.tail?(c=d.tail,d.rendering=c,d.tail=c.sibling,d.lastEffect=b.lastEffect,d.renderingStartTime=O(),c.sibling=null,b=P.current,I(P,f?b&1|2:b&1),c):null;case 23:case 24:return Ki(),null!==a&&null!==a.memoizedState!==(null!==b.memoizedState)&&"unstable-defer-without-hiding"!==d.mode&&(b.flags|=4),null}throw Error(y(156,b.tag));}
    	function Li(a){switch(a.tag){case 1:Ff(a.type)&&Gf();var b=a.flags;return b&4096?(a.flags=b&-4097|64,a):null;case 3:fh();H(N);H(M);uh();b=a.flags;if(0!==(b&64))throw Error(y(285));a.flags=b&-4097|64;return a;case 5:return hh(a),null;case 13:return H(P),b=a.flags,b&4096?(a.flags=b&-4097|64,a):null;case 19:return H(P),null;case 4:return fh(),null;case 10:return rg(a),null;case 23:case 24:return Ki(),null;default:return null}}
    	function Mi(a,b){try{var c="",d=b;do c+=Qa(d),d=d.return;while(d);var e=c;}catch(f){e="\nError generating stack: "+f.message+"\n"+f.stack;}return {value:a,source:b,stack:e}}function Ni(a,b){try{console.error(b.value);}catch(c){setTimeout(function(){throw c;});}}var Oi="function"===typeof WeakMap?WeakMap:Map;function Pi(a,b,c){c=zg(-1,c);c.tag=3;c.payload={element:null};var d=b.value;c.callback=function(){Qi||(Qi=!0,Ri=d);Ni(a,b);};return c}
    	function Si(a,b,c){c=zg(-1,c);c.tag=3;var d=a.type.getDerivedStateFromError;if("function"===typeof d){var e=b.value;c.payload=function(){Ni(a,b);return d(e)};}var f=a.stateNode;null!==f&&"function"===typeof f.componentDidCatch&&(c.callback=function(){"function"!==typeof d&&(null===Ti?Ti=new Set([this]):Ti.add(this),Ni(a,b));var c=b.stack;this.componentDidCatch(b.value,{componentStack:null!==c?c:""});});return c}var Ui="function"===typeof WeakSet?WeakSet:Set;
    	function Vi(a){var b=a.ref;if(null!==b)if("function"===typeof b)try{b(null);}catch(c){Wi(a,c);}else b.current=null;}function Xi(a,b){switch(b.tag){case 0:case 11:case 15:case 22:return;case 1:if(b.flags&256&&null!==a){var c=a.memoizedProps,d=a.memoizedState;a=b.stateNode;b=a.getSnapshotBeforeUpdate(b.elementType===b.type?c:lg(b.type,c),d);a.__reactInternalSnapshotBeforeUpdate=b;}return;case 3:b.flags&256&&qf(b.stateNode.containerInfo);return;case 5:case 6:case 4:case 17:return}throw Error(y(163));}
    	function Yi(a,b,c){switch(c.tag){case 0:case 11:case 15:case 22:b=c.updateQueue;b=null!==b?b.lastEffect:null;if(null!==b){a=b=b.next;do{if(3===(a.tag&3)){var d=a.create;a.destroy=d();}a=a.next;}while(a!==b)}b=c.updateQueue;b=null!==b?b.lastEffect:null;if(null!==b){a=b=b.next;do{var e=a;d=e.next;e=e.tag;0!==(e&4)&&0!==(e&1)&&(Zi(c,a),$i(c,a));a=d;}while(a!==b)}return;case 1:a=c.stateNode;c.flags&4&&(null===b?a.componentDidMount():(d=c.elementType===c.type?b.memoizedProps:lg(c.type,b.memoizedProps),a.componentDidUpdate(d,
    	b.memoizedState,a.__reactInternalSnapshotBeforeUpdate)));b=c.updateQueue;null!==b&&Eg(c,b,a);return;case 3:b=c.updateQueue;if(null!==b){a=null;if(null!==c.child)switch(c.child.tag){case 5:a=c.child.stateNode;break;case 1:a=c.child.stateNode;}Eg(c,b,a);}return;case 5:a=c.stateNode;null===b&&c.flags&4&&mf(c.type,c.memoizedProps)&&a.focus();return;case 6:return;case 4:return;case 12:return;case 13:null===c.memoizedState&&(c=c.alternate,null!==c&&(c=c.memoizedState,null!==c&&(c=c.dehydrated,null!==c&&Cc(c))));
    	return;case 19:case 17:case 20:case 21:case 23:case 24:return}throw Error(y(163));}
    	function aj(a,b){for(var c=a;;){if(5===c.tag){var d=c.stateNode;if(b)d=d.style,"function"===typeof d.setProperty?d.setProperty("display","none","important"):d.display="none";else {d=c.stateNode;var e=c.memoizedProps.style;e=void 0!==e&&null!==e&&e.hasOwnProperty("display")?e.display:null;d.style.display=sb("display",e);}}else if(6===c.tag)c.stateNode.nodeValue=b?"":c.memoizedProps;else if((23!==c.tag&&24!==c.tag||null===c.memoizedState||c===a)&&null!==c.child){c.child.return=c;c=c.child;continue}if(c===
    	a)break;for(;null===c.sibling;){if(null===c.return||c.return===a)return;c=c.return;}c.sibling.return=c.return;c=c.sibling;}}
    	function bj(a,b){if(Mf&&"function"===typeof Mf.onCommitFiberUnmount)try{Mf.onCommitFiberUnmount(Lf,b);}catch(f){}switch(b.tag){case 0:case 11:case 14:case 15:case 22:a=b.updateQueue;if(null!==a&&(a=a.lastEffect,null!==a)){var c=a=a.next;do{var d=c,e=d.destroy;d=d.tag;if(void 0!==e)if(0!==(d&4))Zi(b,c);else {d=b;try{e();}catch(f){Wi(d,f);}}c=c.next;}while(c!==a)}break;case 1:Vi(b);a=b.stateNode;if("function"===typeof a.componentWillUnmount)try{a.props=b.memoizedProps,a.state=b.memoizedState,a.componentWillUnmount();}catch(f){Wi(b,
    	f);}break;case 5:Vi(b);break;case 4:cj(a,b);}}function dj(a){a.alternate=null;a.child=null;a.dependencies=null;a.firstEffect=null;a.lastEffect=null;a.memoizedProps=null;a.memoizedState=null;a.pendingProps=null;a.return=null;a.updateQueue=null;}function ej(a){return 5===a.tag||3===a.tag||4===a.tag}
    	function fj(a){a:{for(var b=a.return;null!==b;){if(ej(b))break a;b=b.return;}throw Error(y(160));}var c=b;b=c.stateNode;switch(c.tag){case 5:var d=!1;break;case 3:b=b.containerInfo;d=!0;break;case 4:b=b.containerInfo;d=!0;break;default:throw Error(y(161));}c.flags&16&&(pb(b,""),c.flags&=-17);a:b:for(c=a;;){for(;null===c.sibling;){if(null===c.return||ej(c.return)){c=null;break a}c=c.return;}c.sibling.return=c.return;for(c=c.sibling;5!==c.tag&&6!==c.tag&&18!==c.tag;){if(c.flags&2)continue b;if(null===
    	c.child||4===c.tag)continue b;else c.child.return=c,c=c.child;}if(!(c.flags&2)){c=c.stateNode;break a}}d?gj(a,c,b):hj(a,c,b);}
    	function gj(a,b,c){var d=a.tag,e=5===d||6===d;if(e)a=e?a.stateNode:a.stateNode.instance,b?8===c.nodeType?c.parentNode.insertBefore(a,b):c.insertBefore(a,b):(8===c.nodeType?(b=c.parentNode,b.insertBefore(a,c)):(b=c,b.appendChild(a)),c=c._reactRootContainer,null!==c&&void 0!==c||null!==b.onclick||(b.onclick=jf));else if(4!==d&&(a=a.child,null!==a))for(gj(a,b,c),a=a.sibling;null!==a;)gj(a,b,c),a=a.sibling;}
    	function hj(a,b,c){var d=a.tag,e=5===d||6===d;if(e)a=e?a.stateNode:a.stateNode.instance,b?c.insertBefore(a,b):c.appendChild(a);else if(4!==d&&(a=a.child,null!==a))for(hj(a,b,c),a=a.sibling;null!==a;)hj(a,b,c),a=a.sibling;}
    	function cj(a,b){for(var c=b,d=!1,e,f;;){if(!d){d=c.return;a:for(;;){if(null===d)throw Error(y(160));e=d.stateNode;switch(d.tag){case 5:f=!1;break a;case 3:e=e.containerInfo;f=!0;break a;case 4:e=e.containerInfo;f=!0;break a}d=d.return;}d=!0;}if(5===c.tag||6===c.tag){a:for(var g=a,h=c,k=h;;)if(bj(g,k),null!==k.child&&4!==k.tag)k.child.return=k,k=k.child;else {if(k===h)break a;for(;null===k.sibling;){if(null===k.return||k.return===h)break a;k=k.return;}k.sibling.return=k.return;k=k.sibling;}f?(g=e,h=c.stateNode,
    	8===g.nodeType?g.parentNode.removeChild(h):g.removeChild(h)):e.removeChild(c.stateNode);}else if(4===c.tag){if(null!==c.child){e=c.stateNode.containerInfo;f=!0;c.child.return=c;c=c.child;continue}}else if(bj(a,c),null!==c.child){c.child.return=c;c=c.child;continue}if(c===b)break;for(;null===c.sibling;){if(null===c.return||c.return===b)return;c=c.return;4===c.tag&&(d=!1);}c.sibling.return=c.return;c=c.sibling;}}
    	function ij(a,b){switch(b.tag){case 0:case 11:case 14:case 15:case 22:var c=b.updateQueue;c=null!==c?c.lastEffect:null;if(null!==c){var d=c=c.next;do 3===(d.tag&3)&&(a=d.destroy,d.destroy=void 0,void 0!==a&&a()),d=d.next;while(d!==c)}return;case 1:return;case 5:c=b.stateNode;if(null!=c){d=b.memoizedProps;var e=null!==a?a.memoizedProps:d;a=b.type;var f=b.updateQueue;b.updateQueue=null;if(null!==f){c[xf]=d;"input"===a&&"radio"===d.type&&null!=d.name&&$a(c,d);wb(a,e);b=wb(a,d);for(e=0;e<f.length;e+=
    	2){var g=f[e],h=f[e+1];"style"===g?tb(c,h):"dangerouslySetInnerHTML"===g?ob(c,h):"children"===g?pb(c,h):qa(c,g,h,b);}switch(a){case "input":ab(c,d);break;case "textarea":ib(c,d);break;case "select":a=c._wrapperState.wasMultiple,c._wrapperState.wasMultiple=!!d.multiple,f=d.value,null!=f?fb(c,!!d.multiple,f,!1):a!==!!d.multiple&&(null!=d.defaultValue?fb(c,!!d.multiple,d.defaultValue,!0):fb(c,!!d.multiple,d.multiple?[]:"",!1));}}}return;case 6:if(null===b.stateNode)throw Error(y(162));b.stateNode.nodeValue=
    	b.memoizedProps;return;case 3:c=b.stateNode;c.hydrate&&(c.hydrate=!1,Cc(c.containerInfo));return;case 12:return;case 13:null!==b.memoizedState&&(jj=O(),aj(b.child,!0));kj(b);return;case 19:kj(b);return;case 17:return;case 23:case 24:aj(b,null!==b.memoizedState);return}throw Error(y(163));}function kj(a){var b=a.updateQueue;if(null!==b){a.updateQueue=null;var c=a.stateNode;null===c&&(c=a.stateNode=new Ui);b.forEach(function(b){var d=lj.bind(null,a,b);c.has(b)||(c.add(b),b.then(d,d));});}}
    	function mj(a,b){return null!==a&&(a=a.memoizedState,null===a||null!==a.dehydrated)?(b=b.memoizedState,null!==b&&null===b.dehydrated):!1}var nj=Math.ceil,oj=ra.ReactCurrentDispatcher,pj=ra.ReactCurrentOwner,X=0,U=null,Y=null,W=0,qj=0,rj=Bf(0),V=0,sj=null,tj=0,Dg=0,Hi=0,uj=0,vj=null,jj=0,Ji=Infinity;function wj(){Ji=O()+500;}var Z=null,Qi=!1,Ri=null,Ti=null,xj=!1,yj=null,zj=90,Aj=[],Bj=[],Cj=null,Dj=0,Ej=null,Fj=-1,Gj=0,Hj=0,Ij=null,Jj=!1;function Hg(){return 0!==(X&48)?O():-1!==Fj?Fj:Fj=O()}
    	function Ig(a){a=a.mode;if(0===(a&2))return 1;if(0===(a&4))return 99===eg()?1:2;0===Gj&&(Gj=tj);if(0!==kg.transition){0!==Hj&&(Hj=null!==vj?vj.pendingLanes:0);a=Gj;var b=4186112&~Hj;b&=-b;0===b&&(a=4186112&~a,b=a&-a,0===b&&(b=8192));return b}a=eg();0!==(X&4)&&98===a?a=Xc(12,Gj):(a=Sc(a),a=Xc(a,Gj));return a}
    	function Jg(a,b,c){if(50<Dj)throw Dj=0,Ej=null,Error(y(185));a=Kj(a,b);if(null===a)return null;$c(a,b,c);a===U&&(Hi|=b,4===V&&Ii(a,W));var d=eg();1===b?0!==(X&8)&&0===(X&48)?Lj(a):(Mj(a,c),0===X&&(wj(),ig())):(0===(X&4)||98!==d&&99!==d||(null===Cj?Cj=new Set([a]):Cj.add(a)),Mj(a,c));vj=a;}function Kj(a,b){a.lanes|=b;var c=a.alternate;null!==c&&(c.lanes|=b);c=a;for(a=a.return;null!==a;)a.childLanes|=b,c=a.alternate,null!==c&&(c.childLanes|=b),c=a,a=a.return;return 3===c.tag?c.stateNode:null}
    	function Mj(a,b){for(var c=a.callbackNode,d=a.suspendedLanes,e=a.pingedLanes,f=a.expirationTimes,g=a.pendingLanes;0<g;){var h=31-Vc(g),k=1<<h,l=f[h];if(-1===l){if(0===(k&d)||0!==(k&e)){l=b;Rc(k);var n=F;f[h]=10<=n?l+250:6<=n?l+5E3:-1;}}else l<=b&&(a.expiredLanes|=k);g&=~k;}d=Uc(a,a===U?W:0);b=F;if(0===d)null!==c&&(c!==Zf&&Pf(c),a.callbackNode=null,a.callbackPriority=0);else {if(null!==c){if(a.callbackPriority===b)return;c!==Zf&&Pf(c);}15===b?(c=Lj.bind(null,a),null===ag?(ag=[c],bg=Of(Uf,jg)):ag.push(c),
    	c=Zf):14===b?c=hg(99,Lj.bind(null,a)):(c=Tc(b),c=hg(c,Nj.bind(null,a)));a.callbackPriority=b;a.callbackNode=c;}}
    	function Nj(a){Fj=-1;Hj=Gj=0;if(0!==(X&48))throw Error(y(327));var b=a.callbackNode;if(Oj()&&a.callbackNode!==b)return null;var c=Uc(a,a===U?W:0);if(0===c)return null;var d=c;var e=X;X|=16;var f=Pj();if(U!==a||W!==d)wj(),Qj(a,d);do try{Rj();break}catch(h){Sj(a,h);}while(1);qg();oj.current=f;X=e;null!==Y?d=0:(U=null,W=0,d=V);if(0!==(tj&Hi))Qj(a,0);else if(0!==d){2===d&&(X|=64,a.hydrate&&(a.hydrate=!1,qf(a.containerInfo)),c=Wc(a),0!==c&&(d=Tj(a,c)));if(1===d)throw b=sj,Qj(a,0),Ii(a,c),Mj(a,O()),b;a.finishedWork=
    	a.current.alternate;a.finishedLanes=c;switch(d){case 0:case 1:throw Error(y(345));case 2:Uj(a);break;case 3:Ii(a,c);if((c&62914560)===c&&(d=jj+500-O(),10<d)){if(0!==Uc(a,0))break;e=a.suspendedLanes;if((e&c)!==c){Hg();a.pingedLanes|=a.suspendedLanes&e;break}a.timeoutHandle=of(Uj.bind(null,a),d);break}Uj(a);break;case 4:Ii(a,c);if((c&4186112)===c)break;d=a.eventTimes;for(e=-1;0<c;){var g=31-Vc(c);f=1<<g;g=d[g];g>e&&(e=g);c&=~f;}c=e;c=O()-c;c=(120>c?120:480>c?480:1080>c?1080:1920>c?1920:3E3>c?3E3:4320>
    	c?4320:1960*nj(c/1960))-c;if(10<c){a.timeoutHandle=of(Uj.bind(null,a),c);break}Uj(a);break;case 5:Uj(a);break;default:throw Error(y(329));}}Mj(a,O());return a.callbackNode===b?Nj.bind(null,a):null}function Ii(a,b){b&=~uj;b&=~Hi;a.suspendedLanes|=b;a.pingedLanes&=~b;for(a=a.expirationTimes;0<b;){var c=31-Vc(b),d=1<<c;a[c]=-1;b&=~d;}}
    	function Lj(a){if(0!==(X&48))throw Error(y(327));Oj();if(a===U&&0!==(a.expiredLanes&W)){var b=W;var c=Tj(a,b);0!==(tj&Hi)&&(b=Uc(a,b),c=Tj(a,b));}else b=Uc(a,0),c=Tj(a,b);0!==a.tag&&2===c&&(X|=64,a.hydrate&&(a.hydrate=!1,qf(a.containerInfo)),b=Wc(a),0!==b&&(c=Tj(a,b)));if(1===c)throw c=sj,Qj(a,0),Ii(a,b),Mj(a,O()),c;a.finishedWork=a.current.alternate;a.finishedLanes=b;Uj(a);Mj(a,O());return null}
    	function Vj(){if(null!==Cj){var a=Cj;Cj=null;a.forEach(function(a){a.expiredLanes|=24&a.pendingLanes;Mj(a,O());});}ig();}function Wj(a,b){var c=X;X|=1;try{return a(b)}finally{X=c,0===X&&(wj(),ig());}}function Xj(a,b){var c=X;X&=-2;X|=8;try{return a(b)}finally{X=c,0===X&&(wj(),ig());}}function ni(a,b){I(rj,qj);qj|=b;tj|=b;}function Ki(){qj=rj.current;H(rj);}
    	function Qj(a,b){a.finishedWork=null;a.finishedLanes=0;var c=a.timeoutHandle;-1!==c&&(a.timeoutHandle=-1,pf(c));if(null!==Y)for(c=Y.return;null!==c;){var d=c;switch(d.tag){case 1:d=d.type.childContextTypes;null!==d&&void 0!==d&&Gf();break;case 3:fh();H(N);H(M);uh();break;case 5:hh(d);break;case 4:fh();break;case 13:H(P);break;case 19:H(P);break;case 10:rg(d);break;case 23:case 24:Ki();}c=c.return;}U=a;Y=Tg(a.current,null);W=qj=tj=b;V=0;sj=null;uj=Hi=Dg=0;}
    	function Sj(a,b){do{var c=Y;try{qg();vh.current=Gh;if(yh){for(var d=R.memoizedState;null!==d;){var e=d.queue;null!==e&&(e.pending=null);d=d.next;}yh=!1;}xh=0;T=S=R=null;zh=!1;pj.current=null;if(null===c||null===c.return){V=1;sj=b;Y=null;break}a:{var f=a,g=c.return,h=c,k=b;b=W;h.flags|=2048;h.firstEffect=h.lastEffect=null;if(null!==k&&"object"===typeof k&&"function"===typeof k.then){var l=k;if(0===(h.mode&2)){var n=h.alternate;n?(h.updateQueue=n.updateQueue,h.memoizedState=n.memoizedState,h.lanes=n.lanes):
    	(h.updateQueue=null,h.memoizedState=null);}var A=0!==(P.current&1),p=g;do{var C;if(C=13===p.tag){var x=p.memoizedState;if(null!==x)C=null!==x.dehydrated?!0:!1;else {var w=p.memoizedProps;C=void 0===w.fallback?!1:!0!==w.unstable_avoidThisFallback?!0:A?!1:!0;}}if(C){var z=p.updateQueue;if(null===z){var u=new Set;u.add(l);p.updateQueue=u;}else z.add(l);if(0===(p.mode&2)){p.flags|=64;h.flags|=16384;h.flags&=-2981;if(1===h.tag)if(null===h.alternate)h.tag=17;else {var t=zg(-1,1);t.tag=2;Ag(h,t);}h.lanes|=1;break a}k=
    	void 0;h=b;var q=f.pingCache;null===q?(q=f.pingCache=new Oi,k=new Set,q.set(l,k)):(k=q.get(l),void 0===k&&(k=new Set,q.set(l,k)));if(!k.has(h)){k.add(h);var v=Yj.bind(null,f,l,h);l.then(v,v);}p.flags|=4096;p.lanes=b;break a}p=p.return;}while(null!==p);k=Error((Ra(h.type)||"A React component")+" suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display.");}5!==V&&(V=2);k=Mi(k,h);p=
    	g;do{switch(p.tag){case 3:f=k;p.flags|=4096;b&=-b;p.lanes|=b;var J=Pi(p,f,b);Bg(p,J);break a;case 1:f=k;var K=p.type,Q=p.stateNode;if(0===(p.flags&64)&&("function"===typeof K.getDerivedStateFromError||null!==Q&&"function"===typeof Q.componentDidCatch&&(null===Ti||!Ti.has(Q)))){p.flags|=4096;b&=-b;p.lanes|=b;var L=Si(p,f,b);Bg(p,L);break a}}p=p.return;}while(null!==p)}Zj(c);}catch(va){b=va;Y===c&&null!==c&&(Y=c=c.return);continue}break}while(1)}
    	function Pj(){var a=oj.current;oj.current=Gh;return null===a?Gh:a}function Tj(a,b){var c=X;X|=16;var d=Pj();U===a&&W===b||Qj(a,b);do try{ak();break}catch(e){Sj(a,e);}while(1);qg();X=c;oj.current=d;if(null!==Y)throw Error(y(261));U=null;W=0;return V}function ak(){for(;null!==Y;)bk(Y);}function Rj(){for(;null!==Y&&!Qf();)bk(Y);}function bk(a){var b=ck(a.alternate,a,qj);a.memoizedProps=a.pendingProps;null===b?Zj(a):Y=b;pj.current=null;}
    	function Zj(a){var b=a;do{var c=b.alternate;a=b.return;if(0===(b.flags&2048)){c=Gi(c,b,qj);if(null!==c){Y=c;return}c=b;if(24!==c.tag&&23!==c.tag||null===c.memoizedState||0!==(qj&1073741824)||0===(c.mode&4)){for(var d=0,e=c.child;null!==e;)d|=e.lanes|e.childLanes,e=e.sibling;c.childLanes=d;}null!==a&&0===(a.flags&2048)&&(null===a.firstEffect&&(a.firstEffect=b.firstEffect),null!==b.lastEffect&&(null!==a.lastEffect&&(a.lastEffect.nextEffect=b.firstEffect),a.lastEffect=b.lastEffect),1<b.flags&&(null!==
    	a.lastEffect?a.lastEffect.nextEffect=b:a.firstEffect=b,a.lastEffect=b));}else {c=Li(b);if(null!==c){c.flags&=2047;Y=c;return}null!==a&&(a.firstEffect=a.lastEffect=null,a.flags|=2048);}b=b.sibling;if(null!==b){Y=b;return}Y=b=a;}while(null!==b);0===V&&(V=5);}function Uj(a){var b=eg();gg(99,dk.bind(null,a,b));return null}
    	function dk(a,b){do Oj();while(null!==yj);if(0!==(X&48))throw Error(y(327));var c=a.finishedWork;if(null===c)return null;a.finishedWork=null;a.finishedLanes=0;if(c===a.current)throw Error(y(177));a.callbackNode=null;var d=c.lanes|c.childLanes,e=d,f=a.pendingLanes&~e;a.pendingLanes=e;a.suspendedLanes=0;a.pingedLanes=0;a.expiredLanes&=e;a.mutableReadLanes&=e;a.entangledLanes&=e;e=a.entanglements;for(var g=a.eventTimes,h=a.expirationTimes;0<f;){var k=31-Vc(f),l=1<<k;e[k]=0;g[k]=-1;h[k]=-1;f&=~l;}null!==
    	Cj&&0===(d&24)&&Cj.has(a)&&Cj.delete(a);a===U&&(Y=U=null,W=0);1<c.flags?null!==c.lastEffect?(c.lastEffect.nextEffect=c,d=c.firstEffect):d=c:d=c.firstEffect;if(null!==d){e=X;X|=32;pj.current=null;kf=fd;g=Ne();if(Oe(g)){if("selectionStart"in g)h={start:g.selectionStart,end:g.selectionEnd};else a:if(h=(h=g.ownerDocument)&&h.defaultView||window,(l=h.getSelection&&h.getSelection())&&0!==l.rangeCount){h=l.anchorNode;f=l.anchorOffset;k=l.focusNode;l=l.focusOffset;try{h.nodeType,k.nodeType;}catch(va){h=null;
    	break a}var n=0,A=-1,p=-1,C=0,x=0,w=g,z=null;b:for(;;){for(var u;;){w!==h||0!==f&&3!==w.nodeType||(A=n+f);w!==k||0!==l&&3!==w.nodeType||(p=n+l);3===w.nodeType&&(n+=w.nodeValue.length);if(null===(u=w.firstChild))break;z=w;w=u;}for(;;){if(w===g)break b;z===h&&++C===f&&(A=n);z===k&&++x===l&&(p=n);if(null!==(u=w.nextSibling))break;w=z;z=w.parentNode;}w=u;}h=-1===A||-1===p?null:{start:A,end:p};}else h=null;h=h||{start:0,end:0};}else h=null;lf={focusedElem:g,selectionRange:h};fd=!1;Ij=null;Jj=!1;Z=d;do try{ek();}catch(va){if(null===
    	Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect;}while(null!==Z);Ij=null;Z=d;do try{for(g=a;null!==Z;){var t=Z.flags;t&16&&pb(Z.stateNode,"");if(t&128){var q=Z.alternate;if(null!==q){var v=q.ref;null!==v&&("function"===typeof v?v(null):v.current=null);}}switch(t&1038){case 2:fj(Z);Z.flags&=-3;break;case 6:fj(Z);Z.flags&=-3;ij(Z.alternate,Z);break;case 1024:Z.flags&=-1025;break;case 1028:Z.flags&=-1025;ij(Z.alternate,Z);break;case 4:ij(Z.alternate,Z);break;case 8:h=Z;cj(g,h);var J=h.alternate;dj(h);null!==
    	J&&dj(J);}Z=Z.nextEffect;}}catch(va){if(null===Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect;}while(null!==Z);v=lf;q=Ne();t=v.focusedElem;g=v.selectionRange;if(q!==t&&t&&t.ownerDocument&&Me(t.ownerDocument.documentElement,t)){null!==g&&Oe(t)&&(q=g.start,v=g.end,void 0===v&&(v=q),"selectionStart"in t?(t.selectionStart=q,t.selectionEnd=Math.min(v,t.value.length)):(v=(q=t.ownerDocument||document)&&q.defaultView||window,v.getSelection&&(v=v.getSelection(),h=t.textContent.length,J=Math.min(g.start,h),g=void 0===
    	g.end?J:Math.min(g.end,h),!v.extend&&J>g&&(h=g,g=J,J=h),h=Le(t,J),f=Le(t,g),h&&f&&(1!==v.rangeCount||v.anchorNode!==h.node||v.anchorOffset!==h.offset||v.focusNode!==f.node||v.focusOffset!==f.offset)&&(q=q.createRange(),q.setStart(h.node,h.offset),v.removeAllRanges(),J>g?(v.addRange(q),v.extend(f.node,f.offset)):(q.setEnd(f.node,f.offset),v.addRange(q))))));q=[];for(v=t;v=v.parentNode;)1===v.nodeType&&q.push({element:v,left:v.scrollLeft,top:v.scrollTop});"function"===typeof t.focus&&t.focus();for(t=
    	0;t<q.length;t++)v=q[t],v.element.scrollLeft=v.left,v.element.scrollTop=v.top;}fd=!!kf;lf=kf=null;a.current=c;Z=d;do try{for(t=a;null!==Z;){var K=Z.flags;K&36&&Yi(t,Z.alternate,Z);if(K&128){q=void 0;var Q=Z.ref;if(null!==Q){var L=Z.stateNode;switch(Z.tag){case 5:q=L;break;default:q=L;}"function"===typeof Q?Q(q):Q.current=q;}}Z=Z.nextEffect;}}catch(va){if(null===Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect;}while(null!==Z);Z=null;$f();X=e;}else a.current=c;if(xj)xj=!1,yj=a,zj=b;else for(Z=d;null!==Z;)b=
    	Z.nextEffect,Z.nextEffect=null,Z.flags&8&&(K=Z,K.sibling=null,K.stateNode=null),Z=b;d=a.pendingLanes;0===d&&(Ti=null);1===d?a===Ej?Dj++:(Dj=0,Ej=a):Dj=0;c=c.stateNode;if(Mf&&"function"===typeof Mf.onCommitFiberRoot)try{Mf.onCommitFiberRoot(Lf,c,void 0,64===(c.current.flags&64));}catch(va){}Mj(a,O());if(Qi)throw Qi=!1,a=Ri,Ri=null,a;if(0!==(X&8))return null;ig();return null}
    	function ek(){for(;null!==Z;){var a=Z.alternate;Jj||null===Ij||(0!==(Z.flags&8)?dc(Z,Ij)&&(Jj=!0):13===Z.tag&&mj(a,Z)&&dc(Z,Ij)&&(Jj=!0));var b=Z.flags;0!==(b&256)&&Xi(a,Z);0===(b&512)||xj||(xj=!0,hg(97,function(){Oj();return null}));Z=Z.nextEffect;}}function Oj(){if(90!==zj){var a=97<zj?97:zj;zj=90;return gg(a,fk)}return !1}function $i(a,b){Aj.push(b,a);xj||(xj=!0,hg(97,function(){Oj();return null}));}function Zi(a,b){Bj.push(b,a);xj||(xj=!0,hg(97,function(){Oj();return null}));}
    	function fk(){if(null===yj)return !1;var a=yj;yj=null;if(0!==(X&48))throw Error(y(331));var b=X;X|=32;var c=Bj;Bj=[];for(var d=0;d<c.length;d+=2){var e=c[d],f=c[d+1],g=e.destroy;e.destroy=void 0;if("function"===typeof g)try{g();}catch(k){if(null===f)throw Error(y(330));Wi(f,k);}}c=Aj;Aj=[];for(d=0;d<c.length;d+=2){e=c[d];f=c[d+1];try{var h=e.create;e.destroy=h();}catch(k){if(null===f)throw Error(y(330));Wi(f,k);}}for(h=a.current.firstEffect;null!==h;)a=h.nextEffect,h.nextEffect=null,h.flags&8&&(h.sibling=
    	null,h.stateNode=null),h=a;X=b;ig();return !0}function gk(a,b,c){b=Mi(c,b);b=Pi(a,b,1);Ag(a,b);b=Hg();a=Kj(a,1);null!==a&&($c(a,1,b),Mj(a,b));}
    	function Wi(a,b){if(3===a.tag)gk(a,a,b);else for(var c=a.return;null!==c;){if(3===c.tag){gk(c,a,b);break}else if(1===c.tag){var d=c.stateNode;if("function"===typeof c.type.getDerivedStateFromError||"function"===typeof d.componentDidCatch&&(null===Ti||!Ti.has(d))){a=Mi(b,a);var e=Si(c,a,1);Ag(c,e);e=Hg();c=Kj(c,1);if(null!==c)$c(c,1,e),Mj(c,e);else if("function"===typeof d.componentDidCatch&&(null===Ti||!Ti.has(d)))try{d.componentDidCatch(b,a);}catch(f){}break}}c=c.return;}}
    	function Yj(a,b,c){var d=a.pingCache;null!==d&&d.delete(b);b=Hg();a.pingedLanes|=a.suspendedLanes&c;U===a&&(W&c)===c&&(4===V||3===V&&(W&62914560)===W&&500>O()-jj?Qj(a,0):uj|=c);Mj(a,b);}function lj(a,b){var c=a.stateNode;null!==c&&c.delete(b);b=0;0===b&&(b=a.mode,0===(b&2)?b=1:0===(b&4)?b=99===eg()?1:2:(0===Gj&&(Gj=tj),b=Yc(62914560&~Gj),0===b&&(b=4194304)));c=Hg();a=Kj(a,b);null!==a&&($c(a,b,c),Mj(a,c));}var ck;
    	ck=function(a,b,c){var d=b.lanes;if(null!==a)if(a.memoizedProps!==b.pendingProps||N.current)ug=!0;else if(0!==(c&d))ug=0!==(a.flags&16384)?!0:!1;else {ug=!1;switch(b.tag){case 3:ri(b);sh();break;case 5:gh(b);break;case 1:Ff(b.type)&&Jf(b);break;case 4:eh(b,b.stateNode.containerInfo);break;case 10:d=b.memoizedProps.value;var e=b.type._context;I(mg,e._currentValue);e._currentValue=d;break;case 13:if(null!==b.memoizedState){if(0!==(c&b.child.childLanes))return ti(a,b,c);I(P,P.current&1);b=hi(a,b,c);return null!==
    	b?b.sibling:null}I(P,P.current&1);break;case 19:d=0!==(c&b.childLanes);if(0!==(a.flags&64)){if(d)return Ai(a,b,c);b.flags|=64;}e=b.memoizedState;null!==e&&(e.rendering=null,e.tail=null,e.lastEffect=null);I(P,P.current);if(d)break;else return null;case 23:case 24:return b.lanes=0,mi(a,b,c)}return hi(a,b,c)}else ug=!1;b.lanes=0;switch(b.tag){case 2:d=b.type;null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2);a=b.pendingProps;e=Ef(b,M.current);tg(b,c);e=Ch(null,b,d,a,e,c);b.flags|=1;if("object"===
    	typeof e&&null!==e&&"function"===typeof e.render&&void 0===e.$$typeof){b.tag=1;b.memoizedState=null;b.updateQueue=null;if(Ff(d)){var f=!0;Jf(b);}else f=!1;b.memoizedState=null!==e.state&&void 0!==e.state?e.state:null;xg(b);var g=d.getDerivedStateFromProps;"function"===typeof g&&Gg(b,d,g,a);e.updater=Kg;b.stateNode=e;e._reactInternals=b;Og(b,d,a,c);b=qi(null,b,d,!0,f,c);}else b.tag=0,fi(null,b,e,c),b=b.child;return b;case 16:e=b.elementType;a:{null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2);
    	a=b.pendingProps;f=e._init;e=f(e._payload);b.type=e;f=b.tag=hk(e);a=lg(e,a);switch(f){case 0:b=li(null,b,e,a,c);break a;case 1:b=pi(null,b,e,a,c);break a;case 11:b=gi(null,b,e,a,c);break a;case 14:b=ii(null,b,e,lg(e.type,a),d,c);break a}throw Error(y(306,e,""));}return b;case 0:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),li(a,b,d,e,c);case 1:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),pi(a,b,d,e,c);case 3:ri(b);d=b.updateQueue;if(null===a||null===d)throw Error(y(282));
    	d=b.pendingProps;e=b.memoizedState;e=null!==e?e.element:null;yg(a,b);Cg(b,d,null,c);d=b.memoizedState.element;if(d===e)sh(),b=hi(a,b,c);else {e=b.stateNode;if(f=e.hydrate)kh=rf(b.stateNode.containerInfo.firstChild),jh=b,f=lh=!0;if(f){a=e.mutableSourceEagerHydrationData;if(null!=a)for(e=0;e<a.length;e+=2)f=a[e],f._workInProgressVersionPrimary=a[e+1],th.push(f);c=Zg(b,null,d,c);for(b.child=c;c;)c.flags=c.flags&-3|1024,c=c.sibling;}else fi(a,b,d,c),sh();b=b.child;}return b;case 5:return gh(b),null===a&&
    	ph(b),d=b.type,e=b.pendingProps,f=null!==a?a.memoizedProps:null,g=e.children,nf(d,e)?g=null:null!==f&&nf(d,f)&&(b.flags|=16),oi(a,b),fi(a,b,g,c),b.child;case 6:return null===a&&ph(b),null;case 13:return ti(a,b,c);case 4:return eh(b,b.stateNode.containerInfo),d=b.pendingProps,null===a?b.child=Yg(b,null,d,c):fi(a,b,d,c),b.child;case 11:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),gi(a,b,d,e,c);case 7:return fi(a,b,b.pendingProps,c),b.child;case 8:return fi(a,b,b.pendingProps.children,
    	c),b.child;case 12:return fi(a,b,b.pendingProps.children,c),b.child;case 10:a:{d=b.type._context;e=b.pendingProps;g=b.memoizedProps;f=e.value;var h=b.type._context;I(mg,h._currentValue);h._currentValue=f;if(null!==g)if(h=g.value,f=He(h,f)?0:("function"===typeof d._calculateChangedBits?d._calculateChangedBits(h,f):1073741823)|0,0===f){if(g.children===e.children&&!N.current){b=hi(a,b,c);break a}}else for(h=b.child,null!==h&&(h.return=b);null!==h;){var k=h.dependencies;if(null!==k){g=h.child;for(var l=
    	k.firstContext;null!==l;){if(l.context===d&&0!==(l.observedBits&f)){1===h.tag&&(l=zg(-1,c&-c),l.tag=2,Ag(h,l));h.lanes|=c;l=h.alternate;null!==l&&(l.lanes|=c);sg(h.return,c);k.lanes|=c;break}l=l.next;}}else g=10===h.tag?h.type===b.type?null:h.child:h.child;if(null!==g)g.return=h;else for(g=h;null!==g;){if(g===b){g=null;break}h=g.sibling;if(null!==h){h.return=g.return;g=h;break}g=g.return;}h=g;}fi(a,b,e.children,c);b=b.child;}return b;case 9:return e=b.type,f=b.pendingProps,d=f.children,tg(b,c),e=vg(e,
    	f.unstable_observedBits),d=d(e),b.flags|=1,fi(a,b,d,c),b.child;case 14:return e=b.type,f=lg(e,b.pendingProps),f=lg(e.type,f),ii(a,b,e,f,d,c);case 15:return ki(a,b,b.type,b.pendingProps,d,c);case 17:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2),b.tag=1,Ff(d)?(a=!0,Jf(b)):a=!1,tg(b,c),Mg(b,d,e),Og(b,d,e,c),qi(null,b,d,!0,a,c);case 19:return Ai(a,b,c);case 23:return mi(a,b,c);case 24:return mi(a,b,c)}throw Error(y(156,b.tag));
    	};function ik(a,b,c,d){this.tag=a;this.key=c;this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null;this.index=0;this.ref=null;this.pendingProps=b;this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null;this.mode=d;this.flags=0;this.lastEffect=this.firstEffect=this.nextEffect=null;this.childLanes=this.lanes=0;this.alternate=null;}function nh(a,b,c,d){return new ik(a,b,c,d)}function ji(a){a=a.prototype;return !(!a||!a.isReactComponent)}
    	function hk(a){if("function"===typeof a)return ji(a)?1:0;if(void 0!==a&&null!==a){a=a.$$typeof;if(a===Aa)return 11;if(a===Da)return 14}return 2}
    	function Tg(a,b){var c=a.alternate;null===c?(c=nh(a.tag,b,a.key,a.mode),c.elementType=a.elementType,c.type=a.type,c.stateNode=a.stateNode,c.alternate=a,a.alternate=c):(c.pendingProps=b,c.type=a.type,c.flags=0,c.nextEffect=null,c.firstEffect=null,c.lastEffect=null);c.childLanes=a.childLanes;c.lanes=a.lanes;c.child=a.child;c.memoizedProps=a.memoizedProps;c.memoizedState=a.memoizedState;c.updateQueue=a.updateQueue;b=a.dependencies;c.dependencies=null===b?null:{lanes:b.lanes,firstContext:b.firstContext};
    	c.sibling=a.sibling;c.index=a.index;c.ref=a.ref;return c}
    	function Vg(a,b,c,d,e,f){var g=2;d=a;if("function"===typeof a)ji(a)&&(g=1);else if("string"===typeof a)g=5;else a:switch(a){case ua:return Xg(c.children,e,f,b);case Ha:g=8;e|=16;break;case wa:g=8;e|=1;break;case xa:return a=nh(12,c,b,e|8),a.elementType=xa,a.type=xa,a.lanes=f,a;case Ba:return a=nh(13,c,b,e),a.type=Ba,a.elementType=Ba,a.lanes=f,a;case Ca:return a=nh(19,c,b,e),a.elementType=Ca,a.lanes=f,a;case Ia:return vi(c,e,f,b);case Ja:return a=nh(24,c,b,e),a.elementType=Ja,a.lanes=f,a;default:if("object"===
    	typeof a&&null!==a)switch(a.$$typeof){case ya:g=10;break a;case za:g=9;break a;case Aa:g=11;break a;case Da:g=14;break a;case Ea:g=16;d=null;break a;case Fa:g=22;break a}throw Error(y(130,null==a?a:typeof a,""));}b=nh(g,c,b,e);b.elementType=a;b.type=d;b.lanes=f;return b}function Xg(a,b,c,d){a=nh(7,a,d,b);a.lanes=c;return a}function vi(a,b,c,d){a=nh(23,a,d,b);a.elementType=Ia;a.lanes=c;return a}function Ug(a,b,c){a=nh(6,a,null,b);a.lanes=c;return a}
    	function Wg(a,b,c){b=nh(4,null!==a.children?a.children:[],a.key,b);b.lanes=c;b.stateNode={containerInfo:a.containerInfo,pendingChildren:null,implementation:a.implementation};return b}
    	function jk(a,b,c){this.tag=b;this.containerInfo=a;this.finishedWork=this.pingCache=this.current=this.pendingChildren=null;this.timeoutHandle=-1;this.pendingContext=this.context=null;this.hydrate=c;this.callbackNode=null;this.callbackPriority=0;this.eventTimes=Zc(0);this.expirationTimes=Zc(-1);this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0;this.entanglements=Zc(0);this.mutableSourceEagerHydrationData=null;}
    	function kk(a,b,c){var d=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return {$$typeof:ta,key:null==d?null:""+d,children:a,containerInfo:b,implementation:c}}
    	function lk(a,b,c,d){var e=b.current,f=Hg(),g=Ig(e);a:if(c){c=c._reactInternals;b:{if(Zb(c)!==c||1!==c.tag)throw Error(y(170));var h=c;do{switch(h.tag){case 3:h=h.stateNode.context;break b;case 1:if(Ff(h.type)){h=h.stateNode.__reactInternalMemoizedMergedChildContext;break b}}h=h.return;}while(null!==h);throw Error(y(171));}if(1===c.tag){var k=c.type;if(Ff(k)){c=If(c,k,h);break a}}c=h;}else c=Cf;null===b.context?b.context=c:b.pendingContext=c;b=zg(f,g);b.payload={element:a};d=void 0===d?null:d;null!==
    	d&&(b.callback=d);Ag(e,b);Jg(e,g,f);return g}function mk(a){a=a.current;if(!a.child)return null;switch(a.child.tag){case 5:return a.child.stateNode;default:return a.child.stateNode}}function nk(a,b){a=a.memoizedState;if(null!==a&&null!==a.dehydrated){var c=a.retryLane;a.retryLane=0!==c&&c<b?c:b;}}function ok(a,b){nk(a,b);(a=a.alternate)&&nk(a,b);}function pk(){return null}
    	function qk(a,b,c){var d=null!=c&&null!=c.hydrationOptions&&c.hydrationOptions.mutableSources||null;c=new jk(a,b,null!=c&&!0===c.hydrate);b=nh(3,null,null,2===b?7:1===b?3:0);c.current=b;b.stateNode=c;xg(b);a[ff]=c.current;cf(8===a.nodeType?a.parentNode:a);if(d)for(a=0;a<d.length;a++){b=d[a];var e=b._getVersion;e=e(b._source);null==c.mutableSourceEagerHydrationData?c.mutableSourceEagerHydrationData=[b,e]:c.mutableSourceEagerHydrationData.push(b,e);}this._internalRoot=c;}
    	qk.prototype.render=function(a){lk(a,this._internalRoot,null,null);};qk.prototype.unmount=function(){var a=this._internalRoot,b=a.containerInfo;lk(null,a,null,function(){b[ff]=null;});};function rk(a){return !(!a||1!==a.nodeType&&9!==a.nodeType&&11!==a.nodeType&&(8!==a.nodeType||" react-mount-point-unstable "!==a.nodeValue))}
    	function sk(a,b){b||(b=a?9===a.nodeType?a.documentElement:a.firstChild:null,b=!(!b||1!==b.nodeType||!b.hasAttribute("data-reactroot")));if(!b)for(var c;c=a.lastChild;)a.removeChild(c);return new qk(a,0,b?{hydrate:!0}:void 0)}
    	function tk(a,b,c,d,e){var f=c._reactRootContainer;if(f){var g=f._internalRoot;if("function"===typeof e){var h=e;e=function(){var a=mk(g);h.call(a);};}lk(b,g,a,e);}else {f=c._reactRootContainer=sk(c,d);g=f._internalRoot;if("function"===typeof e){var k=e;e=function(){var a=mk(g);k.call(a);};}Xj(function(){lk(b,g,a,e);});}return mk(g)}ec=function(a){if(13===a.tag){var b=Hg();Jg(a,4,b);ok(a,4);}};fc=function(a){if(13===a.tag){var b=Hg();Jg(a,67108864,b);ok(a,67108864);}};
    	gc=function(a){if(13===a.tag){var b=Hg(),c=Ig(a);Jg(a,c,b);ok(a,c);}};hc=function(a,b){return b()};
    	yb=function(a,b,c){switch(b){case "input":ab(a,c);b=c.name;if("radio"===c.type&&null!=b){for(c=a;c.parentNode;)c=c.parentNode;c=c.querySelectorAll("input[name="+JSON.stringify(""+b)+'][type="radio"]');for(b=0;b<c.length;b++){var d=c[b];if(d!==a&&d.form===a.form){var e=Db(d);if(!e)throw Error(y(90));Wa(d);ab(d,e);}}}break;case "textarea":ib(a,c);break;case "select":b=c.value,null!=b&&fb(a,!!c.multiple,b,!1);}};Gb=Wj;
    	Hb=function(a,b,c,d,e){var f=X;X|=4;try{return gg(98,a.bind(null,b,c,d,e))}finally{X=f,0===X&&(wj(),ig());}};Ib=function(){0===(X&49)&&(Vj(),Oj());};Jb=function(a,b){var c=X;X|=2;try{return a(b)}finally{X=c,0===X&&(wj(),ig());}};function uk(a,b){var c=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!rk(b))throw Error(y(200));return kk(a,b,null,c)}var vk={Events:[Cb,ue,Db,Eb,Fb,Oj,{current:!1}]},wk={findFiberByHostInstance:wc,bundleType:0,version:"17.0.2",rendererPackageName:"react-dom"};
    	var xk={bundleType:wk.bundleType,version:wk.version,rendererPackageName:wk.rendererPackageName,rendererConfig:wk.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:ra.ReactCurrentDispatcher,findHostInstanceByFiber:function(a){a=cc(a);return null===a?null:a.stateNode},findFiberByHostInstance:wk.findFiberByHostInstance||
    	pk,findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null};if("undefined"!==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var yk=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!yk.isDisabled&&yk.supportsFiber)try{Lf=yk.inject(xk),Mf=yk;}catch(a){}}reactDom_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=vk;reactDom_production_min.createPortal=uk;
    	reactDom_production_min.findDOMNode=function(a){if(null==a)return null;if(1===a.nodeType)return a;var b=a._reactInternals;if(void 0===b){if("function"===typeof a.render)throw Error(y(188));throw Error(y(268,Object.keys(a)));}a=cc(b);a=null===a?null:a.stateNode;return a};reactDom_production_min.flushSync=function(a,b){var c=X;if(0!==(c&48))return a(b);X|=1;try{if(a)return gg(99,a.bind(null,b))}finally{X=c,ig();}};reactDom_production_min.hydrate=function(a,b,c){if(!rk(b))throw Error(y(200));return tk(null,a,b,!0,c)};
    	reactDom_production_min.render=function(a,b,c){if(!rk(b))throw Error(y(200));return tk(null,a,b,!1,c)};reactDom_production_min.unmountComponentAtNode=function(a){if(!rk(a))throw Error(y(40));return a._reactRootContainer?(Xj(function(){tk(null,null,a,!1,function(){a._reactRootContainer=null;a[ff]=null;});}),!0):!1};reactDom_production_min.unstable_batchedUpdates=Wj;reactDom_production_min.unstable_createPortal=function(a,b){return uk(a,b,2<arguments.length&&void 0!==arguments[2]?arguments[2]:null)};
    	reactDom_production_min.unstable_renderSubtreeIntoContainer=function(a,b,c,d){if(!rk(c))throw Error(y(200));if(null==a||void 0===a._reactInternals)throw Error(y(38));return tk(a,b,c,!1,d)};reactDom_production_min.version="17.0.2";
    	return reactDom_production_min;
    }

    var reactDom_development = {};

    var tracing = {exports: {}};

    var schedulerTracing_production_min = {};

    /** @license React v0.20.2
     * scheduler-tracing.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredSchedulerTracing_production_min;

    function requireSchedulerTracing_production_min () {
    	if (hasRequiredSchedulerTracing_production_min) return schedulerTracing_production_min;
    	hasRequiredSchedulerTracing_production_min = 1;
    var b=0;schedulerTracing_production_min.__interactionsRef=null;schedulerTracing_production_min.__subscriberRef=null;schedulerTracing_production_min.unstable_clear=function(a){return a()};schedulerTracing_production_min.unstable_getCurrent=function(){return null};schedulerTracing_production_min.unstable_getThreadID=function(){return ++b};schedulerTracing_production_min.unstable_subscribe=function(){};schedulerTracing_production_min.unstable_trace=function(a,d,c){return c()};schedulerTracing_production_min.unstable_unsubscribe=function(){};schedulerTracing_production_min.unstable_wrap=function(a){return a};
    	return schedulerTracing_production_min;
    }

    var schedulerTracing_development = {};

    /** @license React v0.20.2
     * scheduler-tracing.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredSchedulerTracing_development;

    function requireSchedulerTracing_development () {
    	if (hasRequiredSchedulerTracing_development) return schedulerTracing_development;
    	hasRequiredSchedulerTracing_development = 1;
    	(function (exports) {

    		if (process.env.NODE_ENV !== "production") {
    		  (function() {

    		var DEFAULT_THREAD_ID = 0; // Counters used to generate unique IDs.

    		var interactionIDCounter = 0;
    		var threadIDCounter = 0; // Set of currently traced interactions.
    		// Interactions "stack"–
    		// Meaning that newly traced interactions are appended to the previously active set.
    		// When an interaction goes out of scope, the previous set (if any) is restored.

    		exports.__interactionsRef = null; // Listener(s) to notify when interactions begin and end.

    		exports.__subscriberRef = null;

    		{
    		  exports.__interactionsRef = {
    		    current: new Set()
    		  };
    		  exports.__subscriberRef = {
    		    current: null
    		  };
    		}
    		function unstable_clear(callback) {

    		  var prevInteractions = exports.__interactionsRef.current;
    		  exports.__interactionsRef.current = new Set();

    		  try {
    		    return callback();
    		  } finally {
    		    exports.__interactionsRef.current = prevInteractions;
    		  }
    		}
    		function unstable_getCurrent() {
    		  {
    		    return exports.__interactionsRef.current;
    		  }
    		}
    		function unstable_getThreadID() {
    		  return ++threadIDCounter;
    		}
    		function unstable_trace(name, timestamp, callback) {
    		  var threadID = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : DEFAULT_THREAD_ID;

    		  var interaction = {
    		    __count: 1,
    		    id: interactionIDCounter++,
    		    name: name,
    		    timestamp: timestamp
    		  };
    		  var prevInteractions = exports.__interactionsRef.current; // Traced interactions should stack/accumulate.
    		  // To do that, clone the current interactions.
    		  // The previous set will be restored upon completion.

    		  var interactions = new Set(prevInteractions);
    		  interactions.add(interaction);
    		  exports.__interactionsRef.current = interactions;
    		  var subscriber = exports.__subscriberRef.current;
    		  var returnValue;

    		  try {
    		    if (subscriber !== null) {
    		      subscriber.onInteractionTraced(interaction);
    		    }
    		  } finally {
    		    try {
    		      if (subscriber !== null) {
    		        subscriber.onWorkStarted(interactions, threadID);
    		      }
    		    } finally {
    		      try {
    		        returnValue = callback();
    		      } finally {
    		        exports.__interactionsRef.current = prevInteractions;

    		        try {
    		          if (subscriber !== null) {
    		            subscriber.onWorkStopped(interactions, threadID);
    		          }
    		        } finally {
    		          interaction.__count--; // If no async work was scheduled for this interaction,
    		          // Notify subscribers that it's completed.

    		          if (subscriber !== null && interaction.__count === 0) {
    		            subscriber.onInteractionScheduledWorkCompleted(interaction);
    		          }
    		        }
    		      }
    		    }
    		  }

    		  return returnValue;
    		}
    		function unstable_wrap(callback) {
    		  var threadID = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_THREAD_ID;

    		  var wrappedInteractions = exports.__interactionsRef.current;
    		  var subscriber = exports.__subscriberRef.current;

    		  if (subscriber !== null) {
    		    subscriber.onWorkScheduled(wrappedInteractions, threadID);
    		  } // Update the pending async work count for the current interactions.
    		  // Update after calling subscribers in case of error.


    		  wrappedInteractions.forEach(function (interaction) {
    		    interaction.__count++;
    		  });
    		  var hasRun = false;

    		  function wrapped() {
    		    var prevInteractions = exports.__interactionsRef.current;
    		    exports.__interactionsRef.current = wrappedInteractions;
    		    subscriber = exports.__subscriberRef.current;

    		    try {
    		      var returnValue;

    		      try {
    		        if (subscriber !== null) {
    		          subscriber.onWorkStarted(wrappedInteractions, threadID);
    		        }
    		      } finally {
    		        try {
    		          returnValue = callback.apply(undefined, arguments);
    		        } finally {
    		          exports.__interactionsRef.current = prevInteractions;

    		          if (subscriber !== null) {
    		            subscriber.onWorkStopped(wrappedInteractions, threadID);
    		          }
    		        }
    		      }

    		      return returnValue;
    		    } finally {
    		      if (!hasRun) {
    		        // We only expect a wrapped function to be executed once,
    		        // But in the event that it's executed more than once–
    		        // Only decrement the outstanding interaction counts once.
    		        hasRun = true; // Update pending async counts for all wrapped interactions.
    		        // If this was the last scheduled async work for any of them,
    		        // Mark them as completed.

    		        wrappedInteractions.forEach(function (interaction) {
    		          interaction.__count--;

    		          if (subscriber !== null && interaction.__count === 0) {
    		            subscriber.onInteractionScheduledWorkCompleted(interaction);
    		          }
    		        });
    		      }
    		    }
    		  }

    		  wrapped.cancel = function cancel() {
    		    subscriber = exports.__subscriberRef.current;

    		    try {
    		      if (subscriber !== null) {
    		        subscriber.onWorkCanceled(wrappedInteractions, threadID);
    		      }
    		    } finally {
    		      // Update pending async counts for all wrapped interactions.
    		      // If this was the last scheduled async work for any of them,
    		      // Mark them as completed.
    		      wrappedInteractions.forEach(function (interaction) {
    		        interaction.__count--;

    		        if (subscriber && interaction.__count === 0) {
    		          subscriber.onInteractionScheduledWorkCompleted(interaction);
    		        }
    		      });
    		    }
    		  };

    		  return wrapped;
    		}

    		var subscribers = null;

    		{
    		  subscribers = new Set();
    		}

    		function unstable_subscribe(subscriber) {
    		  {
    		    subscribers.add(subscriber);

    		    if (subscribers.size === 1) {
    		      exports.__subscriberRef.current = {
    		        onInteractionScheduledWorkCompleted: onInteractionScheduledWorkCompleted,
    		        onInteractionTraced: onInteractionTraced,
    		        onWorkCanceled: onWorkCanceled,
    		        onWorkScheduled: onWorkScheduled,
    		        onWorkStarted: onWorkStarted,
    		        onWorkStopped: onWorkStopped
    		      };
    		    }
    		  }
    		}
    		function unstable_unsubscribe(subscriber) {
    		  {
    		    subscribers.delete(subscriber);

    		    if (subscribers.size === 0) {
    		      exports.__subscriberRef.current = null;
    		    }
    		  }
    		}

    		function onInteractionTraced(interaction) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onInteractionTraced(interaction);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		function onInteractionScheduledWorkCompleted(interaction) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onInteractionScheduledWorkCompleted(interaction);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		function onWorkScheduled(interactions, threadID) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onWorkScheduled(interactions, threadID);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		function onWorkStarted(interactions, threadID) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onWorkStarted(interactions, threadID);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		function onWorkStopped(interactions, threadID) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onWorkStopped(interactions, threadID);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		function onWorkCanceled(interactions, threadID) {
    		  var didCatchError = false;
    		  var caughtError = null;
    		  subscribers.forEach(function (subscriber) {
    		    try {
    		      subscriber.onWorkCanceled(interactions, threadID);
    		    } catch (error) {
    		      if (!didCatchError) {
    		        didCatchError = true;
    		        caughtError = error;
    		      }
    		    }
    		  });

    		  if (didCatchError) {
    		    throw caughtError;
    		  }
    		}

    		exports.unstable_clear = unstable_clear;
    		exports.unstable_getCurrent = unstable_getCurrent;
    		exports.unstable_getThreadID = unstable_getThreadID;
    		exports.unstable_subscribe = unstable_subscribe;
    		exports.unstable_trace = unstable_trace;
    		exports.unstable_unsubscribe = unstable_unsubscribe;
    		exports.unstable_wrap = unstable_wrap;
    		  })();
    		}
    } (schedulerTracing_development));
    	return schedulerTracing_development;
    }

    var hasRequiredTracing;

    function requireTracing () {
    	if (hasRequiredTracing) return tracing.exports;
    	hasRequiredTracing = 1;
    	(function (module) {

    		if (process.env.NODE_ENV === 'production') {
    		  module.exports = requireSchedulerTracing_production_min();
    		} else {
    		  module.exports = requireSchedulerTracing_development();
    		}
    } (tracing));
    	return tracing.exports;
    }

    /** @license React v17.0.2
     * react-dom.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var hasRequiredReactDom_development;

    function requireReactDom_development () {
    	if (hasRequiredReactDom_development) return reactDom_development;
    	hasRequiredReactDom_development = 1;

    	if (process.env.NODE_ENV !== "production") {
    	  (function() {

    	var React = react.exports;
    	var _assign = requireObjectAssign();
    	var Scheduler = requireScheduler();
    	var tracing = requireTracing();

    	var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;

    	// by calls to these methods by a Babel plugin.
    	//
    	// In PROD (or in packages without access to React internals),
    	// they are left as they are instead.

    	function warn(format) {
    	  {
    	    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    	      args[_key - 1] = arguments[_key];
    	    }

    	    printWarning('warn', format, args);
    	  }
    	}
    	function error(format) {
    	  {
    	    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    	      args[_key2 - 1] = arguments[_key2];
    	    }

    	    printWarning('error', format, args);
    	  }
    	}

    	function printWarning(level, format, args) {
    	  // When changing this logic, you might want to also
    	  // update consoleWithStackDev.www.js as well.
    	  {
    	    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
    	    var stack = ReactDebugCurrentFrame.getStackAddendum();

    	    if (stack !== '') {
    	      format += '%s';
    	      args = args.concat([stack]);
    	    }

    	    var argsWithFormat = args.map(function (item) {
    	      return '' + item;
    	    }); // Careful: RN currently depends on this prefix

    	    argsWithFormat.unshift('Warning: ' + format); // We intentionally don't use spread (or .apply) directly because it
    	    // breaks IE9: https://github.com/facebook/react/issues/13610
    	    // eslint-disable-next-line react-internal/no-production-logging

    	    Function.prototype.apply.call(console[level], console, argsWithFormat);
    	  }
    	}

    	if (!React) {
    	  {
    	    throw Error( "ReactDOM was loaded before React. Make sure you load the React package before loading ReactDOM." );
    	  }
    	}

    	var FunctionComponent = 0;
    	var ClassComponent = 1;
    	var IndeterminateComponent = 2; // Before we know whether it is function or class

    	var HostRoot = 3; // Root of a host tree. Could be nested inside another node.

    	var HostPortal = 4; // A subtree. Could be an entry point to a different renderer.

    	var HostComponent = 5;
    	var HostText = 6;
    	var Fragment = 7;
    	var Mode = 8;
    	var ContextConsumer = 9;
    	var ContextProvider = 10;
    	var ForwardRef = 11;
    	var Profiler = 12;
    	var SuspenseComponent = 13;
    	var MemoComponent = 14;
    	var SimpleMemoComponent = 15;
    	var LazyComponent = 16;
    	var IncompleteClassComponent = 17;
    	var DehydratedFragment = 18;
    	var SuspenseListComponent = 19;
    	var FundamentalComponent = 20;
    	var ScopeComponent = 21;
    	var Block = 22;
    	var OffscreenComponent = 23;
    	var LegacyHiddenComponent = 24;

    	// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

    	var enableProfilerTimer = true; // Record durations for commit and passive effects phases.

    	var enableFundamentalAPI = false; // Experimental Scope support.
    	var enableNewReconciler = false; // Errors that are thrown while unmounting (or after in the case of passive effects)
    	var warnAboutStringRefs = false;

    	var allNativeEvents = new Set();
    	/**
    	 * Mapping from registration name to event name
    	 */


    	var registrationNameDependencies = {};
    	/**
    	 * Mapping from lowercase registration names to the properly cased version,
    	 * used to warn in the case of missing event handlers. Available
    	 * only in true.
    	 * @type {Object}
    	 */

    	var possibleRegistrationNames =  {} ; // Trust the developer to only use possibleRegistrationNames in true

    	function registerTwoPhaseEvent(registrationName, dependencies) {
    	  registerDirectEvent(registrationName, dependencies);
    	  registerDirectEvent(registrationName + 'Capture', dependencies);
    	}
    	function registerDirectEvent(registrationName, dependencies) {
    	  {
    	    if (registrationNameDependencies[registrationName]) {
    	      error('EventRegistry: More than one plugin attempted to publish the same ' + 'registration name, `%s`.', registrationName);
    	    }
    	  }

    	  registrationNameDependencies[registrationName] = dependencies;

    	  {
    	    var lowerCasedName = registrationName.toLowerCase();
    	    possibleRegistrationNames[lowerCasedName] = registrationName;

    	    if (registrationName === 'onDoubleClick') {
    	      possibleRegistrationNames.ondblclick = registrationName;
    	    }
    	  }

    	  for (var i = 0; i < dependencies.length; i++) {
    	    allNativeEvents.add(dependencies[i]);
    	  }
    	}

    	var canUseDOM = !!(typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined');

    	// A reserved attribute.
    	// It is handled by React separately and shouldn't be written to the DOM.
    	var RESERVED = 0; // A simple string attribute.
    	// Attributes that aren't in the filter are presumed to have this type.

    	var STRING = 1; // A string attribute that accepts booleans in React. In HTML, these are called
    	// "enumerated" attributes with "true" and "false" as possible values.
    	// When true, it should be set to a "true" string.
    	// When false, it should be set to a "false" string.

    	var BOOLEANISH_STRING = 2; // A real boolean attribute.
    	// When true, it should be present (set either to an empty string or its name).
    	// When false, it should be omitted.

    	var BOOLEAN = 3; // An attribute that can be used as a flag as well as with a value.
    	// When true, it should be present (set either to an empty string or its name).
    	// When false, it should be omitted.
    	// For any other value, should be present with that value.

    	var OVERLOADED_BOOLEAN = 4; // An attribute that must be numeric or parse as a numeric.
    	// When falsy, it should be removed.

    	var NUMERIC = 5; // An attribute that must be positive numeric or parse as a positive numeric.
    	// When falsy, it should be removed.

    	var POSITIVE_NUMERIC = 6;

    	/* eslint-disable max-len */
    	var ATTRIBUTE_NAME_START_CHAR = ":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD";
    	/* eslint-enable max-len */

    	var ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + "\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040";
    	var ROOT_ATTRIBUTE_NAME = 'data-reactroot';
    	var VALID_ATTRIBUTE_NAME_REGEX = new RegExp('^[' + ATTRIBUTE_NAME_START_CHAR + '][' + ATTRIBUTE_NAME_CHAR + ']*$');
    	var hasOwnProperty = Object.prototype.hasOwnProperty;
    	var illegalAttributeNameCache = {};
    	var validatedAttributeNameCache = {};
    	function isAttributeNameSafe(attributeName) {
    	  if (hasOwnProperty.call(validatedAttributeNameCache, attributeName)) {
    	    return true;
    	  }

    	  if (hasOwnProperty.call(illegalAttributeNameCache, attributeName)) {
    	    return false;
    	  }

    	  if (VALID_ATTRIBUTE_NAME_REGEX.test(attributeName)) {
    	    validatedAttributeNameCache[attributeName] = true;
    	    return true;
    	  }

    	  illegalAttributeNameCache[attributeName] = true;

    	  {
    	    error('Invalid attribute name: `%s`', attributeName);
    	  }

    	  return false;
    	}
    	function shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag) {
    	  if (propertyInfo !== null) {
    	    return propertyInfo.type === RESERVED;
    	  }

    	  if (isCustomComponentTag) {
    	    return false;
    	  }

    	  if (name.length > 2 && (name[0] === 'o' || name[0] === 'O') && (name[1] === 'n' || name[1] === 'N')) {
    	    return true;
    	  }

    	  return false;
    	}
    	function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
    	  if (propertyInfo !== null && propertyInfo.type === RESERVED) {
    	    return false;
    	  }

    	  switch (typeof value) {
    	    case 'function': // $FlowIssue symbol is perfectly valid here

    	    case 'symbol':
    	      // eslint-disable-line
    	      return true;

    	    case 'boolean':
    	      {
    	        if (isCustomComponentTag) {
    	          return false;
    	        }

    	        if (propertyInfo !== null) {
    	          return !propertyInfo.acceptsBooleans;
    	        } else {
    	          var prefix = name.toLowerCase().slice(0, 5);
    	          return prefix !== 'data-' && prefix !== 'aria-';
    	        }
    	      }

    	    default:
    	      return false;
    	  }
    	}
    	function shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag) {
    	  if (value === null || typeof value === 'undefined') {
    	    return true;
    	  }

    	  if (shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag)) {
    	    return true;
    	  }

    	  if (isCustomComponentTag) {
    	    return false;
    	  }

    	  if (propertyInfo !== null) {

    	    switch (propertyInfo.type) {
    	      case BOOLEAN:
    	        return !value;

    	      case OVERLOADED_BOOLEAN:
    	        return value === false;

    	      case NUMERIC:
    	        return isNaN(value);

    	      case POSITIVE_NUMERIC:
    	        return isNaN(value) || value < 1;
    	    }
    	  }

    	  return false;
    	}
    	function getPropertyInfo(name) {
    	  return properties.hasOwnProperty(name) ? properties[name] : null;
    	}

    	function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL, removeEmptyString) {
    	  this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN;
    	  this.attributeName = attributeName;
    	  this.attributeNamespace = attributeNamespace;
    	  this.mustUseProperty = mustUseProperty;
    	  this.propertyName = name;
    	  this.type = type;
    	  this.sanitizeURL = sanitizeURL;
    	  this.removeEmptyString = removeEmptyString;
    	} // When adding attributes to this list, be sure to also add them to
    	// the `possibleStandardNames` module to ensure casing and incorrect
    	// name warnings.


    	var properties = {}; // These props are reserved by React. They shouldn't be written to the DOM.

    	var reservedProps = ['children', 'dangerouslySetInnerHTML', // TODO: This prevents the assignment of defaultValue to regular
    	// elements (not just inputs). Now that ReactDOMInput assigns to the
    	// defaultValue property -- do we need this?
    	'defaultValue', 'defaultChecked', 'innerHTML', 'suppressContentEditableWarning', 'suppressHydrationWarning', 'style'];
    	reservedProps.forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, RESERVED, false, // mustUseProperty
    	  name, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // A few React string attributes have a different name.
    	// This is a mapping from React prop names to the attribute names.

    	[['acceptCharset', 'accept-charset'], ['className', 'class'], ['htmlFor', 'for'], ['httpEquiv', 'http-equiv']].forEach(function (_ref) {
    	  var name = _ref[0],
    	      attributeName = _ref[1];
    	  properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    	  attributeName, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are "enumerated" HTML attributes that accept "true" and "false".
    	// In React, we let users pass `true` and `false` even though technically
    	// these aren't boolean attributes (they are coerced to strings).

    	['contentEditable', 'draggable', 'spellCheck', 'value'].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, BOOLEANISH_STRING, false, // mustUseProperty
    	  name.toLowerCase(), // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are "enumerated" SVG attributes that accept "true" and "false".
    	// In React, we let users pass `true` and `false` even though technically
    	// these aren't boolean attributes (they are coerced to strings).
    	// Since these are SVG attributes, their attribute names are case-sensitive.

    	['autoReverse', 'externalResourcesRequired', 'focusable', 'preserveAlpha'].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, BOOLEANISH_STRING, false, // mustUseProperty
    	  name, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are HTML boolean attributes.

    	['allowFullScreen', 'async', // Note: there is a special case that prevents it from being written to the DOM
    	// on the client side because the browsers are inconsistent. Instead we call focus().
    	'autoFocus', 'autoPlay', 'controls', 'default', 'defer', 'disabled', 'disablePictureInPicture', 'disableRemotePlayback', 'formNoValidate', 'hidden', 'loop', 'noModule', 'noValidate', 'open', 'playsInline', 'readOnly', 'required', 'reversed', 'scoped', 'seamless', // Microdata
    	'itemScope'].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, BOOLEAN, false, // mustUseProperty
    	  name.toLowerCase(), // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are the few React props that we set as DOM properties
    	// rather than attributes. These are all booleans.

    	['checked', // Note: `option.selected` is not updated if `select.multiple` is
    	// disabled with `removeAttribute`. We have special logic for handling this.
    	'multiple', 'muted', 'selected' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, BOOLEAN, true, // mustUseProperty
    	  name, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are HTML attributes that are "overloaded booleans": they behave like
    	// booleans, but can also accept a string value.

    	['capture', 'download' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, OVERLOADED_BOOLEAN, false, // mustUseProperty
    	  name, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are HTML attributes that must be positive numbers.

    	['cols', 'rows', 'size', 'span' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, POSITIVE_NUMERIC, false, // mustUseProperty
    	  name, // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These are HTML attributes that must be numbers.

    	['rowSpan', 'start'].forEach(function (name) {
    	  properties[name] = new PropertyInfoRecord(name, NUMERIC, false, // mustUseProperty
    	  name.toLowerCase(), // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	});
    	var CAMELIZE = /[\-\:]([a-z])/g;

    	var capitalize = function (token) {
    	  return token[1].toUpperCase();
    	}; // This is a list of all SVG attributes that need special casing, namespacing,
    	// or boolean value assignment. Regular attributes that just accept strings
    	// and have the same names are omitted, just like in the HTML attribute filter.
    	// Some of these attributes can be hard to find. This list was created by
    	// scraping the MDN documentation.


    	['accent-height', 'alignment-baseline', 'arabic-form', 'baseline-shift', 'cap-height', 'clip-path', 'clip-rule', 'color-interpolation', 'color-interpolation-filters', 'color-profile', 'color-rendering', 'dominant-baseline', 'enable-background', 'fill-opacity', 'fill-rule', 'flood-color', 'flood-opacity', 'font-family', 'font-size', 'font-size-adjust', 'font-stretch', 'font-style', 'font-variant', 'font-weight', 'glyph-name', 'glyph-orientation-horizontal', 'glyph-orientation-vertical', 'horiz-adv-x', 'horiz-origin-x', 'image-rendering', 'letter-spacing', 'lighting-color', 'marker-end', 'marker-mid', 'marker-start', 'overline-position', 'overline-thickness', 'paint-order', 'panose-1', 'pointer-events', 'rendering-intent', 'shape-rendering', 'stop-color', 'stop-opacity', 'strikethrough-position', 'strikethrough-thickness', 'stroke-dasharray', 'stroke-dashoffset', 'stroke-linecap', 'stroke-linejoin', 'stroke-miterlimit', 'stroke-opacity', 'stroke-width', 'text-anchor', 'text-decoration', 'text-rendering', 'underline-position', 'underline-thickness', 'unicode-bidi', 'unicode-range', 'units-per-em', 'v-alphabetic', 'v-hanging', 'v-ideographic', 'v-mathematical', 'vector-effect', 'vert-adv-y', 'vert-origin-x', 'vert-origin-y', 'word-spacing', 'writing-mode', 'xmlns:xlink', 'x-height' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (attributeName) {
    	  var name = attributeName.replace(CAMELIZE, capitalize);
    	  properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    	  attributeName, null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // String SVG attributes with the xlink namespace.

    	['xlink:actuate', 'xlink:arcrole', 'xlink:role', 'xlink:show', 'xlink:title', 'xlink:type' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (attributeName) {
    	  var name = attributeName.replace(CAMELIZE, capitalize);
    	  properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    	  attributeName, 'http://www.w3.org/1999/xlink', false, // sanitizeURL
    	  false);
    	}); // String SVG attributes with the xml namespace.

    	['xml:base', 'xml:lang', 'xml:space' // NOTE: if you add a camelCased prop to this list,
    	// you'll need to set attributeName to name.toLowerCase()
    	// instead in the assignment below.
    	].forEach(function (attributeName) {
    	  var name = attributeName.replace(CAMELIZE, capitalize);
    	  properties[name] = new PropertyInfoRecord(name, STRING, false, // mustUseProperty
    	  attributeName, 'http://www.w3.org/XML/1998/namespace', false, // sanitizeURL
    	  false);
    	}); // These attribute exists both in HTML and SVG.
    	// The attribute name is case-sensitive in SVG so we can't just use
    	// the React name like we do for attributes that exist only in HTML.

    	['tabIndex', 'crossOrigin'].forEach(function (attributeName) {
    	  properties[attributeName] = new PropertyInfoRecord(attributeName, STRING, false, // mustUseProperty
    	  attributeName.toLowerCase(), // attributeName
    	  null, // attributeNamespace
    	  false, // sanitizeURL
    	  false);
    	}); // These attributes accept URLs. These must not allow javascript: URLS.
    	// These will also need to accept Trusted Types object in the future.

    	var xlinkHref = 'xlinkHref';
    	properties[xlinkHref] = new PropertyInfoRecord('xlinkHref', STRING, false, // mustUseProperty
    	'xlink:href', 'http://www.w3.org/1999/xlink', true, // sanitizeURL
    	false);
    	['src', 'href', 'action', 'formAction'].forEach(function (attributeName) {
    	  properties[attributeName] = new PropertyInfoRecord(attributeName, STRING, false, // mustUseProperty
    	  attributeName.toLowerCase(), // attributeName
    	  null, // attributeNamespace
    	  true, // sanitizeURL
    	  true);
    	});

    	// and any newline or tab are filtered out as if they're not part of the URL.
    	// https://url.spec.whatwg.org/#url-parsing
    	// Tab or newline are defined as \r\n\t:
    	// https://infra.spec.whatwg.org/#ascii-tab-or-newline
    	// A C0 control is a code point in the range \u0000 NULL to \u001F
    	// INFORMATION SEPARATOR ONE, inclusive:
    	// https://infra.spec.whatwg.org/#c0-control-or-space

    	/* eslint-disable max-len */

    	var isJavaScriptProtocol = /^[\u0000-\u001F ]*j[\r\n\t]*a[\r\n\t]*v[\r\n\t]*a[\r\n\t]*s[\r\n\t]*c[\r\n\t]*r[\r\n\t]*i[\r\n\t]*p[\r\n\t]*t[\r\n\t]*\:/i;
    	var didWarn = false;

    	function sanitizeURL(url) {
    	  {
    	    if (!didWarn && isJavaScriptProtocol.test(url)) {
    	      didWarn = true;

    	      error('A future version of React will block javascript: URLs as a security precaution. ' + 'Use event handlers instead if you can. If you need to generate unsafe HTML try ' + 'using dangerouslySetInnerHTML instead. React was passed %s.', JSON.stringify(url));
    	    }
    	  }
    	}

    	/**
    	 * Get the value for a property on a node. Only used in DEV for SSR validation.
    	 * The "expected" argument is used as a hint of what the expected value is.
    	 * Some properties have multiple equivalent values.
    	 */
    	function getValueForProperty(node, name, expected, propertyInfo) {
    	  {
    	    if (propertyInfo.mustUseProperty) {
    	      var propertyName = propertyInfo.propertyName;
    	      return node[propertyName];
    	    } else {
    	      if ( propertyInfo.sanitizeURL) {
    	        // If we haven't fully disabled javascript: URLs, and if
    	        // the hydration is successful of a javascript: URL, we
    	        // still want to warn on the client.
    	        sanitizeURL('' + expected);
    	      }

    	      var attributeName = propertyInfo.attributeName;
    	      var stringValue = null;

    	      if (propertyInfo.type === OVERLOADED_BOOLEAN) {
    	        if (node.hasAttribute(attributeName)) {
    	          var value = node.getAttribute(attributeName);

    	          if (value === '') {
    	            return true;
    	          }

    	          if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
    	            return value;
    	          }

    	          if (value === '' + expected) {
    	            return expected;
    	          }

    	          return value;
    	        }
    	      } else if (node.hasAttribute(attributeName)) {
    	        if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
    	          // We had an attribute but shouldn't have had one, so read it
    	          // for the error message.
    	          return node.getAttribute(attributeName);
    	        }

    	        if (propertyInfo.type === BOOLEAN) {
    	          // If this was a boolean, it doesn't matter what the value is
    	          // the fact that we have it is the same as the expected.
    	          return expected;
    	        } // Even if this property uses a namespace we use getAttribute
    	        // because we assume its namespaced name is the same as our config.
    	        // To use getAttributeNS we need the local name which we don't have
    	        // in our config atm.


    	        stringValue = node.getAttribute(attributeName);
    	      }

    	      if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
    	        return stringValue === null ? expected : stringValue;
    	      } else if (stringValue === '' + expected) {
    	        return expected;
    	      } else {
    	        return stringValue;
    	      }
    	    }
    	  }
    	}
    	/**
    	 * Get the value for a attribute on a node. Only used in DEV for SSR validation.
    	 * The third argument is used as a hint of what the expected value is. Some
    	 * attributes have multiple equivalent values.
    	 */

    	function getValueForAttribute(node, name, expected) {
    	  {
    	    if (!isAttributeNameSafe(name)) {
    	      return;
    	    } // If the object is an opaque reference ID, it's expected that
    	    // the next prop is different than the server value, so just return
    	    // expected


    	    if (isOpaqueHydratingObject(expected)) {
    	      return expected;
    	    }

    	    if (!node.hasAttribute(name)) {
    	      return expected === undefined ? undefined : null;
    	    }

    	    var value = node.getAttribute(name);

    	    if (value === '' + expected) {
    	      return expected;
    	    }

    	    return value;
    	  }
    	}
    	/**
    	 * Sets the value for a property on a node.
    	 *
    	 * @param {DOMElement} node
    	 * @param {string} name
    	 * @param {*} value
    	 */

    	function setValueForProperty(node, name, value, isCustomComponentTag) {
    	  var propertyInfo = getPropertyInfo(name);

    	  if (shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag)) {
    	    return;
    	  }

    	  if (shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag)) {
    	    value = null;
    	  } // If the prop isn't in the special list, treat it as a simple attribute.


    	  if (isCustomComponentTag || propertyInfo === null) {
    	    if (isAttributeNameSafe(name)) {
    	      var _attributeName = name;

    	      if (value === null) {
    	        node.removeAttribute(_attributeName);
    	      } else {
    	        node.setAttribute(_attributeName,  '' + value);
    	      }
    	    }

    	    return;
    	  }

    	  var mustUseProperty = propertyInfo.mustUseProperty;

    	  if (mustUseProperty) {
    	    var propertyName = propertyInfo.propertyName;

    	    if (value === null) {
    	      var type = propertyInfo.type;
    	      node[propertyName] = type === BOOLEAN ? false : '';
    	    } else {
    	      // Contrary to `setAttribute`, object properties are properly
    	      // `toString`ed by IE8/9.
    	      node[propertyName] = value;
    	    }

    	    return;
    	  } // The rest are treated as attributes with special cases.


    	  var attributeName = propertyInfo.attributeName,
    	      attributeNamespace = propertyInfo.attributeNamespace;

    	  if (value === null) {
    	    node.removeAttribute(attributeName);
    	  } else {
    	    var _type = propertyInfo.type;
    	    var attributeValue;

    	    if (_type === BOOLEAN || _type === OVERLOADED_BOOLEAN && value === true) {
    	      // If attribute type is boolean, we know for sure it won't be an execution sink
    	      // and we won't require Trusted Type here.
    	      attributeValue = '';
    	    } else {
    	      // `setAttribute` with objects becomes only `[object]` in IE8/9,
    	      // ('' + value) makes it output the correct toString()-value.
    	      {
    	        attributeValue = '' + value;
    	      }

    	      if (propertyInfo.sanitizeURL) {
    	        sanitizeURL(attributeValue.toString());
    	      }
    	    }

    	    if (attributeNamespace) {
    	      node.setAttributeNS(attributeNamespace, attributeName, attributeValue);
    	    } else {
    	      node.setAttribute(attributeName, attributeValue);
    	    }
    	  }
    	}

    	// ATTENTION
    	// When adding new symbols to this file,
    	// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
    	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    	// nor polyfill, then a plain number is used for performance.
    	var REACT_ELEMENT_TYPE = 0xeac7;
    	var REACT_PORTAL_TYPE = 0xeaca;
    	var REACT_FRAGMENT_TYPE = 0xeacb;
    	var REACT_STRICT_MODE_TYPE = 0xeacc;
    	var REACT_PROFILER_TYPE = 0xead2;
    	var REACT_PROVIDER_TYPE = 0xeacd;
    	var REACT_CONTEXT_TYPE = 0xeace;
    	var REACT_FORWARD_REF_TYPE = 0xead0;
    	var REACT_SUSPENSE_TYPE = 0xead1;
    	var REACT_SUSPENSE_LIST_TYPE = 0xead8;
    	var REACT_MEMO_TYPE = 0xead3;
    	var REACT_LAZY_TYPE = 0xead4;
    	var REACT_BLOCK_TYPE = 0xead9;
    	var REACT_SCOPE_TYPE = 0xead7;
    	var REACT_OPAQUE_ID_TYPE = 0xeae0;
    	var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
    	var REACT_OFFSCREEN_TYPE = 0xeae2;
    	var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

    	if (typeof Symbol === 'function' && Symbol.for) {
    	  var symbolFor = Symbol.for;
    	  REACT_ELEMENT_TYPE = symbolFor('react.element');
    	  REACT_PORTAL_TYPE = symbolFor('react.portal');
    	  REACT_FRAGMENT_TYPE = symbolFor('react.fragment');
    	  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
    	  REACT_PROFILER_TYPE = symbolFor('react.profiler');
    	  REACT_PROVIDER_TYPE = symbolFor('react.provider');
    	  REACT_CONTEXT_TYPE = symbolFor('react.context');
    	  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
    	  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
    	  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
    	  REACT_MEMO_TYPE = symbolFor('react.memo');
    	  REACT_LAZY_TYPE = symbolFor('react.lazy');
    	  REACT_BLOCK_TYPE = symbolFor('react.block');
    	  symbolFor('react.server.block');
    	  symbolFor('react.fundamental');
    	  REACT_SCOPE_TYPE = symbolFor('react.scope');
    	  REACT_OPAQUE_ID_TYPE = symbolFor('react.opaque.id');
    	  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
    	  REACT_OFFSCREEN_TYPE = symbolFor('react.offscreen');
    	  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
    	}

    	var MAYBE_ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    	var FAUX_ITERATOR_SYMBOL = '@@iterator';
    	function getIteratorFn(maybeIterable) {
    	  if (maybeIterable === null || typeof maybeIterable !== 'object') {
    	    return null;
    	  }

    	  var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];

    	  if (typeof maybeIterator === 'function') {
    	    return maybeIterator;
    	  }

    	  return null;
    	}

    	// Helpers to patch console.logs to avoid logging during side-effect free
    	// replaying on render function. This currently only patches the object
    	// lazily which won't cover if the log function was extracted eagerly.
    	// We could also eagerly patch the method.
    	var disabledDepth = 0;
    	var prevLog;
    	var prevInfo;
    	var prevWarn;
    	var prevError;
    	var prevGroup;
    	var prevGroupCollapsed;
    	var prevGroupEnd;

    	function disabledLog() {}

    	disabledLog.__reactDisabledLog = true;
    	function disableLogs() {
    	  {
    	    if (disabledDepth === 0) {
    	      /* eslint-disable react-internal/no-production-logging */
    	      prevLog = console.log;
    	      prevInfo = console.info;
    	      prevWarn = console.warn;
    	      prevError = console.error;
    	      prevGroup = console.group;
    	      prevGroupCollapsed = console.groupCollapsed;
    	      prevGroupEnd = console.groupEnd; // https://github.com/facebook/react/issues/19099

    	      var props = {
    	        configurable: true,
    	        enumerable: true,
    	        value: disabledLog,
    	        writable: true
    	      }; // $FlowFixMe Flow thinks console is immutable.

    	      Object.defineProperties(console, {
    	        info: props,
    	        log: props,
    	        warn: props,
    	        error: props,
    	        group: props,
    	        groupCollapsed: props,
    	        groupEnd: props
    	      });
    	      /* eslint-enable react-internal/no-production-logging */
    	    }

    	    disabledDepth++;
    	  }
    	}
    	function reenableLogs() {
    	  {
    	    disabledDepth--;

    	    if (disabledDepth === 0) {
    	      /* eslint-disable react-internal/no-production-logging */
    	      var props = {
    	        configurable: true,
    	        enumerable: true,
    	        writable: true
    	      }; // $FlowFixMe Flow thinks console is immutable.

    	      Object.defineProperties(console, {
    	        log: _assign({}, props, {
    	          value: prevLog
    	        }),
    	        info: _assign({}, props, {
    	          value: prevInfo
    	        }),
    	        warn: _assign({}, props, {
    	          value: prevWarn
    	        }),
    	        error: _assign({}, props, {
    	          value: prevError
    	        }),
    	        group: _assign({}, props, {
    	          value: prevGroup
    	        }),
    	        groupCollapsed: _assign({}, props, {
    	          value: prevGroupCollapsed
    	        }),
    	        groupEnd: _assign({}, props, {
    	          value: prevGroupEnd
    	        })
    	      });
    	      /* eslint-enable react-internal/no-production-logging */
    	    }

    	    if (disabledDepth < 0) {
    	      error('disabledDepth fell below zero. ' + 'This is a bug in React. Please file an issue.');
    	    }
    	  }
    	}

    	var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
    	var prefix;
    	function describeBuiltInComponentFrame(name, source, ownerFn) {
    	  {
    	    if (prefix === undefined) {
    	      // Extract the VM specific prefix used by each line.
    	      try {
    	        throw Error();
    	      } catch (x) {
    	        var match = x.stack.trim().match(/\n( *(at )?)/);
    	        prefix = match && match[1] || '';
    	      }
    	    } // We use the prefix to ensure our stacks line up with native stack frames.


    	    return '\n' + prefix + name;
    	  }
    	}
    	var reentry = false;
    	var componentFrameCache;

    	{
    	  var PossiblyWeakMap = typeof WeakMap === 'function' ? WeakMap : Map;
    	  componentFrameCache = new PossiblyWeakMap();
    	}

    	function describeNativeComponentFrame(fn, construct) {
    	  // If something asked for a stack inside a fake render, it should get ignored.
    	  if (!fn || reentry) {
    	    return '';
    	  }

    	  {
    	    var frame = componentFrameCache.get(fn);

    	    if (frame !== undefined) {
    	      return frame;
    	    }
    	  }

    	  var control;
    	  reentry = true;
    	  var previousPrepareStackTrace = Error.prepareStackTrace; // $FlowFixMe It does accept undefined.

    	  Error.prepareStackTrace = undefined;
    	  var previousDispatcher;

    	  {
    	    previousDispatcher = ReactCurrentDispatcher.current; // Set the dispatcher in DEV because this might be call in the render function
    	    // for warnings.

    	    ReactCurrentDispatcher.current = null;
    	    disableLogs();
    	  }

    	  try {
    	    // This should throw.
    	    if (construct) {
    	      // Something should be setting the props in the constructor.
    	      var Fake = function () {
    	        throw Error();
    	      }; // $FlowFixMe


    	      Object.defineProperty(Fake.prototype, 'props', {
    	        set: function () {
    	          // We use a throwing setter instead of frozen or non-writable props
    	          // because that won't throw in a non-strict mode function.
    	          throw Error();
    	        }
    	      });

    	      if (typeof Reflect === 'object' && Reflect.construct) {
    	        // We construct a different control for this case to include any extra
    	        // frames added by the construct call.
    	        try {
    	          Reflect.construct(Fake, []);
    	        } catch (x) {
    	          control = x;
    	        }

    	        Reflect.construct(fn, [], Fake);
    	      } else {
    	        try {
    	          Fake.call();
    	        } catch (x) {
    	          control = x;
    	        }

    	        fn.call(Fake.prototype);
    	      }
    	    } else {
    	      try {
    	        throw Error();
    	      } catch (x) {
    	        control = x;
    	      }

    	      fn();
    	    }
    	  } catch (sample) {
    	    // This is inlined manually because closure doesn't do it for us.
    	    if (sample && control && typeof sample.stack === 'string') {
    	      // This extracts the first frame from the sample that isn't also in the control.
    	      // Skipping one frame that we assume is the frame that calls the two.
    	      var sampleLines = sample.stack.split('\n');
    	      var controlLines = control.stack.split('\n');
    	      var s = sampleLines.length - 1;
    	      var c = controlLines.length - 1;

    	      while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
    	        // We expect at least one stack frame to be shared.
    	        // Typically this will be the root most one. However, stack frames may be
    	        // cut off due to maximum stack limits. In this case, one maybe cut off
    	        // earlier than the other. We assume that the sample is longer or the same
    	        // and there for cut off earlier. So we should find the root most frame in
    	        // the sample somewhere in the control.
    	        c--;
    	      }

    	      for (; s >= 1 && c >= 0; s--, c--) {
    	        // Next we find the first one that isn't the same which should be the
    	        // frame that called our sample function and the control.
    	        if (sampleLines[s] !== controlLines[c]) {
    	          // In V8, the first line is describing the message but other VMs don't.
    	          // If we're about to return the first line, and the control is also on the same
    	          // line, that's a pretty good indicator that our sample threw at same line as
    	          // the control. I.e. before we entered the sample frame. So we ignore this result.
    	          // This can happen if you passed a class to function component, or non-function.
    	          if (s !== 1 || c !== 1) {
    	            do {
    	              s--;
    	              c--; // We may still have similar intermediate frames from the construct call.
    	              // The next one that isn't the same should be our match though.

    	              if (c < 0 || sampleLines[s] !== controlLines[c]) {
    	                // V8 adds a "new" prefix for native classes. Let's remove it to make it prettier.
    	                var _frame = '\n' + sampleLines[s].replace(' at new ', ' at ');

    	                {
    	                  if (typeof fn === 'function') {
    	                    componentFrameCache.set(fn, _frame);
    	                  }
    	                } // Return the line we found.


    	                return _frame;
    	              }
    	            } while (s >= 1 && c >= 0);
    	          }

    	          break;
    	        }
    	      }
    	    }
    	  } finally {
    	    reentry = false;

    	    {
    	      ReactCurrentDispatcher.current = previousDispatcher;
    	      reenableLogs();
    	    }

    	    Error.prepareStackTrace = previousPrepareStackTrace;
    	  } // Fallback to just using the name if we couldn't make it throw.


    	  var name = fn ? fn.displayName || fn.name : '';
    	  var syntheticFrame = name ? describeBuiltInComponentFrame(name) : '';

    	  {
    	    if (typeof fn === 'function') {
    	      componentFrameCache.set(fn, syntheticFrame);
    	    }
    	  }

    	  return syntheticFrame;
    	}

    	function describeClassComponentFrame(ctor, source, ownerFn) {
    	  {
    	    return describeNativeComponentFrame(ctor, true);
    	  }
    	}
    	function describeFunctionComponentFrame(fn, source, ownerFn) {
    	  {
    	    return describeNativeComponentFrame(fn, false);
    	  }
    	}

    	function shouldConstruct(Component) {
    	  var prototype = Component.prototype;
    	  return !!(prototype && prototype.isReactComponent);
    	}

    	function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {

    	  if (type == null) {
    	    return '';
    	  }

    	  if (typeof type === 'function') {
    	    {
    	      return describeNativeComponentFrame(type, shouldConstruct(type));
    	    }
    	  }

    	  if (typeof type === 'string') {
    	    return describeBuiltInComponentFrame(type);
    	  }

    	  switch (type) {
    	    case REACT_SUSPENSE_TYPE:
    	      return describeBuiltInComponentFrame('Suspense');

    	    case REACT_SUSPENSE_LIST_TYPE:
    	      return describeBuiltInComponentFrame('SuspenseList');
    	  }

    	  if (typeof type === 'object') {
    	    switch (type.$$typeof) {
    	      case REACT_FORWARD_REF_TYPE:
    	        return describeFunctionComponentFrame(type.render);

    	      case REACT_MEMO_TYPE:
    	        // Memo may contain any component type so we recursively resolve it.
    	        return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);

    	      case REACT_BLOCK_TYPE:
    	        return describeFunctionComponentFrame(type._render);

    	      case REACT_LAZY_TYPE:
    	        {
    	          var lazyComponent = type;
    	          var payload = lazyComponent._payload;
    	          var init = lazyComponent._init;

    	          try {
    	            // Lazy may contain any component type so we recursively resolve it.
    	            return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
    	          } catch (x) {}
    	        }
    	    }
    	  }

    	  return '';
    	}

    	function describeFiber(fiber) {
    	  fiber._debugOwner ? fiber._debugOwner.type : null ;
    	  fiber._debugSource ;

    	  switch (fiber.tag) {
    	    case HostComponent:
    	      return describeBuiltInComponentFrame(fiber.type);

    	    case LazyComponent:
    	      return describeBuiltInComponentFrame('Lazy');

    	    case SuspenseComponent:
    	      return describeBuiltInComponentFrame('Suspense');

    	    case SuspenseListComponent:
    	      return describeBuiltInComponentFrame('SuspenseList');

    	    case FunctionComponent:
    	    case IndeterminateComponent:
    	    case SimpleMemoComponent:
    	      return describeFunctionComponentFrame(fiber.type);

    	    case ForwardRef:
    	      return describeFunctionComponentFrame(fiber.type.render);

    	    case Block:
    	      return describeFunctionComponentFrame(fiber.type._render);

    	    case ClassComponent:
    	      return describeClassComponentFrame(fiber.type);

    	    default:
    	      return '';
    	  }
    	}

    	function getStackByFiberInDevAndProd(workInProgress) {
    	  try {
    	    var info = '';
    	    var node = workInProgress;

    	    do {
    	      info += describeFiber(node);
    	      node = node.return;
    	    } while (node);

    	    return info;
    	  } catch (x) {
    	    return '\nError generating stack: ' + x.message + '\n' + x.stack;
    	  }
    	}

    	function getWrappedName(outerType, innerType, wrapperName) {
    	  var functionName = innerType.displayName || innerType.name || '';
    	  return outerType.displayName || (functionName !== '' ? wrapperName + "(" + functionName + ")" : wrapperName);
    	}

    	function getContextName(type) {
    	  return type.displayName || 'Context';
    	}

    	function getComponentName(type) {
    	  if (type == null) {
    	    // Host root, text node or just invalid type.
    	    return null;
    	  }

    	  {
    	    if (typeof type.tag === 'number') {
    	      error('Received an unexpected object in getComponentName(). ' + 'This is likely a bug in React. Please file an issue.');
    	    }
    	  }

    	  if (typeof type === 'function') {
    	    return type.displayName || type.name || null;
    	  }

    	  if (typeof type === 'string') {
    	    return type;
    	  }

    	  switch (type) {
    	    case REACT_FRAGMENT_TYPE:
    	      return 'Fragment';

    	    case REACT_PORTAL_TYPE:
    	      return 'Portal';

    	    case REACT_PROFILER_TYPE:
    	      return 'Profiler';

    	    case REACT_STRICT_MODE_TYPE:
    	      return 'StrictMode';

    	    case REACT_SUSPENSE_TYPE:
    	      return 'Suspense';

    	    case REACT_SUSPENSE_LIST_TYPE:
    	      return 'SuspenseList';
    	  }

    	  if (typeof type === 'object') {
    	    switch (type.$$typeof) {
    	      case REACT_CONTEXT_TYPE:
    	        var context = type;
    	        return getContextName(context) + '.Consumer';

    	      case REACT_PROVIDER_TYPE:
    	        var provider = type;
    	        return getContextName(provider._context) + '.Provider';

    	      case REACT_FORWARD_REF_TYPE:
    	        return getWrappedName(type, type.render, 'ForwardRef');

    	      case REACT_MEMO_TYPE:
    	        return getComponentName(type.type);

    	      case REACT_BLOCK_TYPE:
    	        return getComponentName(type._render);

    	      case REACT_LAZY_TYPE:
    	        {
    	          var lazyComponent = type;
    	          var payload = lazyComponent._payload;
    	          var init = lazyComponent._init;

    	          try {
    	            return getComponentName(init(payload));
    	          } catch (x) {
    	            return null;
    	          }
    	        }
    	    }
    	  }

    	  return null;
    	}

    	var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
    	var current = null;
    	var isRendering = false;
    	function getCurrentFiberOwnerNameInDevOrNull() {
    	  {
    	    if (current === null) {
    	      return null;
    	    }

    	    var owner = current._debugOwner;

    	    if (owner !== null && typeof owner !== 'undefined') {
    	      return getComponentName(owner.type);
    	    }
    	  }

    	  return null;
    	}

    	function getCurrentFiberStackInDev() {
    	  {
    	    if (current === null) {
    	      return '';
    	    } // Safe because if current fiber exists, we are reconciling,
    	    // and it is guaranteed to be the work-in-progress version.


    	    return getStackByFiberInDevAndProd(current);
    	  }
    	}

    	function resetCurrentFiber() {
    	  {
    	    ReactDebugCurrentFrame.getCurrentStack = null;
    	    current = null;
    	    isRendering = false;
    	  }
    	}
    	function setCurrentFiber(fiber) {
    	  {
    	    ReactDebugCurrentFrame.getCurrentStack = getCurrentFiberStackInDev;
    	    current = fiber;
    	    isRendering = false;
    	  }
    	}
    	function setIsRendering(rendering) {
    	  {
    	    isRendering = rendering;
    	  }
    	}
    	function getIsRendering() {
    	  {
    	    return isRendering;
    	  }
    	}

    	// Flow does not allow string concatenation of most non-string types. To work
    	// around this limitation, we use an opaque type that can only be obtained by
    	// passing the value through getToStringValue first.
    	function toString(value) {
    	  return '' + value;
    	}
    	function getToStringValue(value) {
    	  switch (typeof value) {
    	    case 'boolean':
    	    case 'number':
    	    case 'object':
    	    case 'string':
    	    case 'undefined':
    	      return value;

    	    default:
    	      // function, symbol are assigned as empty strings
    	      return '';
    	  }
    	}

    	var hasReadOnlyValue = {
    	  button: true,
    	  checkbox: true,
    	  image: true,
    	  hidden: true,
    	  radio: true,
    	  reset: true,
    	  submit: true
    	};
    	function checkControlledValueProps(tagName, props) {
    	  {
    	    if (!(hasReadOnlyValue[props.type] || props.onChange || props.onInput || props.readOnly || props.disabled || props.value == null)) {
    	      error('You provided a `value` prop to a form field without an ' + '`onChange` handler. This will render a read-only field. If ' + 'the field should be mutable use `defaultValue`. Otherwise, ' + 'set either `onChange` or `readOnly`.');
    	    }

    	    if (!(props.onChange || props.readOnly || props.disabled || props.checked == null)) {
    	      error('You provided a `checked` prop to a form field without an ' + '`onChange` handler. This will render a read-only field. If ' + 'the field should be mutable use `defaultChecked`. Otherwise, ' + 'set either `onChange` or `readOnly`.');
    	    }
    	  }
    	}

    	function isCheckable(elem) {
    	  var type = elem.type;
    	  var nodeName = elem.nodeName;
    	  return nodeName && nodeName.toLowerCase() === 'input' && (type === 'checkbox' || type === 'radio');
    	}

    	function getTracker(node) {
    	  return node._valueTracker;
    	}

    	function detachTracker(node) {
    	  node._valueTracker = null;
    	}

    	function getValueFromNode(node) {
    	  var value = '';

    	  if (!node) {
    	    return value;
    	  }

    	  if (isCheckable(node)) {
    	    value = node.checked ? 'true' : 'false';
    	  } else {
    	    value = node.value;
    	  }

    	  return value;
    	}

    	function trackValueOnNode(node) {
    	  var valueField = isCheckable(node) ? 'checked' : 'value';
    	  var descriptor = Object.getOwnPropertyDescriptor(node.constructor.prototype, valueField);
    	  var currentValue = '' + node[valueField]; // if someone has already defined a value or Safari, then bail
    	  // and don't track value will cause over reporting of changes,
    	  // but it's better then a hard failure
    	  // (needed for certain tests that spyOn input values and Safari)

    	  if (node.hasOwnProperty(valueField) || typeof descriptor === 'undefined' || typeof descriptor.get !== 'function' || typeof descriptor.set !== 'function') {
    	    return;
    	  }

    	  var get = descriptor.get,
    	      set = descriptor.set;
    	  Object.defineProperty(node, valueField, {
    	    configurable: true,
    	    get: function () {
    	      return get.call(this);
    	    },
    	    set: function (value) {
    	      currentValue = '' + value;
    	      set.call(this, value);
    	    }
    	  }); // We could've passed this the first time
    	  // but it triggers a bug in IE11 and Edge 14/15.
    	  // Calling defineProperty() again should be equivalent.
    	  // https://github.com/facebook/react/issues/11768

    	  Object.defineProperty(node, valueField, {
    	    enumerable: descriptor.enumerable
    	  });
    	  var tracker = {
    	    getValue: function () {
    	      return currentValue;
    	    },
    	    setValue: function (value) {
    	      currentValue = '' + value;
    	    },
    	    stopTracking: function () {
    	      detachTracker(node);
    	      delete node[valueField];
    	    }
    	  };
    	  return tracker;
    	}

    	function track(node) {
    	  if (getTracker(node)) {
    	    return;
    	  } // TODO: Once it's just Fiber we can move this to node._wrapperState


    	  node._valueTracker = trackValueOnNode(node);
    	}
    	function updateValueIfChanged(node) {
    	  if (!node) {
    	    return false;
    	  }

    	  var tracker = getTracker(node); // if there is no tracker at this point it's unlikely
    	  // that trying again will succeed

    	  if (!tracker) {
    	    return true;
    	  }

    	  var lastValue = tracker.getValue();
    	  var nextValue = getValueFromNode(node);

    	  if (nextValue !== lastValue) {
    	    tracker.setValue(nextValue);
    	    return true;
    	  }

    	  return false;
    	}

    	function getActiveElement(doc) {
    	  doc = doc || (typeof document !== 'undefined' ? document : undefined);

    	  if (typeof doc === 'undefined') {
    	    return null;
    	  }

    	  try {
    	    return doc.activeElement || doc.body;
    	  } catch (e) {
    	    return doc.body;
    	  }
    	}

    	var didWarnValueDefaultValue = false;
    	var didWarnCheckedDefaultChecked = false;
    	var didWarnControlledToUncontrolled = false;
    	var didWarnUncontrolledToControlled = false;

    	function isControlled(props) {
    	  var usesChecked = props.type === 'checkbox' || props.type === 'radio';
    	  return usesChecked ? props.checked != null : props.value != null;
    	}
    	/**
    	 * Implements an <input> host component that allows setting these optional
    	 * props: `checked`, `value`, `defaultChecked`, and `defaultValue`.
    	 *
    	 * If `checked` or `value` are not supplied (or null/undefined), user actions
    	 * that affect the checked state or value will trigger updates to the element.
    	 *
    	 * If they are supplied (and not null/undefined), the rendered element will not
    	 * trigger updates to the element. Instead, the props must change in order for
    	 * the rendered element to be updated.
    	 *
    	 * The rendered element will be initialized as unchecked (or `defaultChecked`)
    	 * with an empty value (or `defaultValue`).
    	 *
    	 * See http://www.w3.org/TR/2012/WD-html5-20121025/the-input-element.html
    	 */


    	function getHostProps(element, props) {
    	  var node = element;
    	  var checked = props.checked;

    	  var hostProps = _assign({}, props, {
    	    defaultChecked: undefined,
    	    defaultValue: undefined,
    	    value: undefined,
    	    checked: checked != null ? checked : node._wrapperState.initialChecked
    	  });

    	  return hostProps;
    	}
    	function initWrapperState(element, props) {
    	  {
    	    checkControlledValueProps('input', props);

    	    if (props.checked !== undefined && props.defaultChecked !== undefined && !didWarnCheckedDefaultChecked) {
    	      error('%s contains an input of type %s with both checked and defaultChecked props. ' + 'Input elements must be either controlled or uncontrolled ' + '(specify either the checked prop, or the defaultChecked prop, but not ' + 'both). Decide between using a controlled or uncontrolled input ' + 'element and remove one of these props. More info: ' + 'https://reactjs.org/link/controlled-components', getCurrentFiberOwnerNameInDevOrNull() || 'A component', props.type);

    	      didWarnCheckedDefaultChecked = true;
    	    }

    	    if (props.value !== undefined && props.defaultValue !== undefined && !didWarnValueDefaultValue) {
    	      error('%s contains an input of type %s with both value and defaultValue props. ' + 'Input elements must be either controlled or uncontrolled ' + '(specify either the value prop, or the defaultValue prop, but not ' + 'both). Decide between using a controlled or uncontrolled input ' + 'element and remove one of these props. More info: ' + 'https://reactjs.org/link/controlled-components', getCurrentFiberOwnerNameInDevOrNull() || 'A component', props.type);

    	      didWarnValueDefaultValue = true;
    	    }
    	  }

    	  var node = element;
    	  var defaultValue = props.defaultValue == null ? '' : props.defaultValue;
    	  node._wrapperState = {
    	    initialChecked: props.checked != null ? props.checked : props.defaultChecked,
    	    initialValue: getToStringValue(props.value != null ? props.value : defaultValue),
    	    controlled: isControlled(props)
    	  };
    	}
    	function updateChecked(element, props) {
    	  var node = element;
    	  var checked = props.checked;

    	  if (checked != null) {
    	    setValueForProperty(node, 'checked', checked, false);
    	  }
    	}
    	function updateWrapper(element, props) {
    	  var node = element;

    	  {
    	    var controlled = isControlled(props);

    	    if (!node._wrapperState.controlled && controlled && !didWarnUncontrolledToControlled) {
    	      error('A component is changing an uncontrolled input to be controlled. ' + 'This is likely caused by the value changing from undefined to ' + 'a defined value, which should not happen. ' + 'Decide between using a controlled or uncontrolled input ' + 'element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components');

    	      didWarnUncontrolledToControlled = true;
    	    }

    	    if (node._wrapperState.controlled && !controlled && !didWarnControlledToUncontrolled) {
    	      error('A component is changing a controlled input to be uncontrolled. ' + 'This is likely caused by the value changing from a defined to ' + 'undefined, which should not happen. ' + 'Decide between using a controlled or uncontrolled input ' + 'element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components');

    	      didWarnControlledToUncontrolled = true;
    	    }
    	  }

    	  updateChecked(element, props);
    	  var value = getToStringValue(props.value);
    	  var type = props.type;

    	  if (value != null) {
    	    if (type === 'number') {
    	      if (value === 0 && node.value === '' || // We explicitly want to coerce to number here if possible.
    	      // eslint-disable-next-line
    	      node.value != value) {
    	        node.value = toString(value);
    	      }
    	    } else if (node.value !== toString(value)) {
    	      node.value = toString(value);
    	    }
    	  } else if (type === 'submit' || type === 'reset') {
    	    // Submit/reset inputs need the attribute removed completely to avoid
    	    // blank-text buttons.
    	    node.removeAttribute('value');
    	    return;
    	  }

    	  {
    	    // When syncing the value attribute, the value comes from a cascade of
    	    // properties:
    	    //  1. The value React property
    	    //  2. The defaultValue React property
    	    //  3. Otherwise there should be no change
    	    if (props.hasOwnProperty('value')) {
    	      setDefaultValue(node, props.type, value);
    	    } else if (props.hasOwnProperty('defaultValue')) {
    	      setDefaultValue(node, props.type, getToStringValue(props.defaultValue));
    	    }
    	  }

    	  {
    	    // When syncing the checked attribute, it only changes when it needs
    	    // to be removed, such as transitioning from a checkbox into a text input
    	    if (props.checked == null && props.defaultChecked != null) {
    	      node.defaultChecked = !!props.defaultChecked;
    	    }
    	  }
    	}
    	function postMountWrapper(element, props, isHydrating) {
    	  var node = element; // Do not assign value if it is already set. This prevents user text input
    	  // from being lost during SSR hydration.

    	  if (props.hasOwnProperty('value') || props.hasOwnProperty('defaultValue')) {
    	    var type = props.type;
    	    var isButton = type === 'submit' || type === 'reset'; // Avoid setting value attribute on submit/reset inputs as it overrides the
    	    // default value provided by the browser. See: #12872

    	    if (isButton && (props.value === undefined || props.value === null)) {
    	      return;
    	    }

    	    var initialValue = toString(node._wrapperState.initialValue); // Do not assign value if it is already set. This prevents user text input
    	    // from being lost during SSR hydration.

    	    if (!isHydrating) {
    	      {
    	        // When syncing the value attribute, the value property should use
    	        // the wrapperState._initialValue property. This uses:
    	        //
    	        //   1. The value React property when present
    	        //   2. The defaultValue React property when present
    	        //   3. An empty string
    	        if (initialValue !== node.value) {
    	          node.value = initialValue;
    	        }
    	      }
    	    }

    	    {
    	      // Otherwise, the value attribute is synchronized to the property,
    	      // so we assign defaultValue to the same thing as the value property
    	      // assignment step above.
    	      node.defaultValue = initialValue;
    	    }
    	  } // Normally, we'd just do `node.checked = node.checked` upon initial mount, less this bug
    	  // this is needed to work around a chrome bug where setting defaultChecked
    	  // will sometimes influence the value of checked (even after detachment).
    	  // Reference: https://bugs.chromium.org/p/chromium/issues/detail?id=608416
    	  // We need to temporarily unset name to avoid disrupting radio button groups.


    	  var name = node.name;

    	  if (name !== '') {
    	    node.name = '';
    	  }

    	  {
    	    // When syncing the checked attribute, both the checked property and
    	    // attribute are assigned at the same time using defaultChecked. This uses:
    	    //
    	    //   1. The checked React property when present
    	    //   2. The defaultChecked React property when present
    	    //   3. Otherwise, false
    	    node.defaultChecked = !node.defaultChecked;
    	    node.defaultChecked = !!node._wrapperState.initialChecked;
    	  }

    	  if (name !== '') {
    	    node.name = name;
    	  }
    	}
    	function restoreControlledState(element, props) {
    	  var node = element;
    	  updateWrapper(node, props);
    	  updateNamedCousins(node, props);
    	}

    	function updateNamedCousins(rootNode, props) {
    	  var name = props.name;

    	  if (props.type === 'radio' && name != null) {
    	    var queryRoot = rootNode;

    	    while (queryRoot.parentNode) {
    	      queryRoot = queryRoot.parentNode;
    	    } // If `rootNode.form` was non-null, then we could try `form.elements`,
    	    // but that sometimes behaves strangely in IE8. We could also try using
    	    // `form.getElementsByName`, but that will only return direct children
    	    // and won't include inputs that use the HTML5 `form=` attribute. Since
    	    // the input might not even be in a form. It might not even be in the
    	    // document. Let's just use the local `querySelectorAll` to ensure we don't
    	    // miss anything.


    	    var group = queryRoot.querySelectorAll('input[name=' + JSON.stringify('' + name) + '][type="radio"]');

    	    for (var i = 0; i < group.length; i++) {
    	      var otherNode = group[i];

    	      if (otherNode === rootNode || otherNode.form !== rootNode.form) {
    	        continue;
    	      } // This will throw if radio buttons rendered by different copies of React
    	      // and the same name are rendered into the same form (same as #1939).
    	      // That's probably okay; we don't support it just as we don't support
    	      // mixing React radio buttons with non-React ones.


    	      var otherProps = getFiberCurrentPropsFromNode(otherNode);

    	      if (!otherProps) {
    	        {
    	          throw Error( "ReactDOMInput: Mixing React and non-React radio inputs with the same `name` is not supported." );
    	        }
    	      } // We need update the tracked value on the named cousin since the value
    	      // was changed but the input saw no event or value set


    	      updateValueIfChanged(otherNode); // If this is a controlled radio button group, forcing the input that
    	      // was previously checked to update will cause it to be come re-checked
    	      // as appropriate.

    	      updateWrapper(otherNode, otherProps);
    	    }
    	  }
    	} // In Chrome, assigning defaultValue to certain input types triggers input validation.
    	// For number inputs, the display value loses trailing decimal points. For email inputs,
    	// Chrome raises "The specified value <x> is not a valid email address".
    	//
    	// Here we check to see if the defaultValue has actually changed, avoiding these problems
    	// when the user is inputting text
    	//
    	// https://github.com/facebook/react/issues/7253


    	function setDefaultValue(node, type, value) {
    	  if ( // Focused number inputs synchronize on blur. See ChangeEventPlugin.js
    	  type !== 'number' || getActiveElement(node.ownerDocument) !== node) {
    	    if (value == null) {
    	      node.defaultValue = toString(node._wrapperState.initialValue);
    	    } else if (node.defaultValue !== toString(value)) {
    	      node.defaultValue = toString(value);
    	    }
    	  }
    	}

    	var didWarnSelectedSetOnOption = false;
    	var didWarnInvalidChild = false;

    	function flattenChildren(children) {
    	  var content = ''; // Flatten children. We'll warn if they are invalid
    	  // during validateProps() which runs for hydration too.
    	  // Note that this would throw on non-element objects.
    	  // Elements are stringified (which is normally irrelevant
    	  // but matters for <fbt>).

    	  React.Children.forEach(children, function (child) {
    	    if (child == null) {
    	      return;
    	    }

    	    content += child; // Note: we don't warn about invalid children here.
    	    // Instead, this is done separately below so that
    	    // it happens during the hydration code path too.
    	  });
    	  return content;
    	}
    	/**
    	 * Implements an <option> host component that warns when `selected` is set.
    	 */


    	function validateProps(element, props) {
    	  {
    	    // This mirrors the code path above, but runs for hydration too.
    	    // Warn about invalid children here so that client and hydration are consistent.
    	    // TODO: this seems like it could cause a DEV-only throw for hydration
    	    // if children contains a non-element object. We should try to avoid that.
    	    if (typeof props.children === 'object' && props.children !== null) {
    	      React.Children.forEach(props.children, function (child) {
    	        if (child == null) {
    	          return;
    	        }

    	        if (typeof child === 'string' || typeof child === 'number') {
    	          return;
    	        }

    	        if (typeof child.type !== 'string') {
    	          return;
    	        }

    	        if (!didWarnInvalidChild) {
    	          didWarnInvalidChild = true;

    	          error('Only strings and numbers are supported as <option> children.');
    	        }
    	      });
    	    } // TODO: Remove support for `selected` in <option>.


    	    if (props.selected != null && !didWarnSelectedSetOnOption) {
    	      error('Use the `defaultValue` or `value` props on <select> instead of ' + 'setting `selected` on <option>.');

    	      didWarnSelectedSetOnOption = true;
    	    }
    	  }
    	}
    	function postMountWrapper$1(element, props) {
    	  // value="" should make a value attribute (#6219)
    	  if (props.value != null) {
    	    element.setAttribute('value', toString(getToStringValue(props.value)));
    	  }
    	}
    	function getHostProps$1(element, props) {
    	  var hostProps = _assign({
    	    children: undefined
    	  }, props);

    	  var content = flattenChildren(props.children);

    	  if (content) {
    	    hostProps.children = content;
    	  }

    	  return hostProps;
    	}

    	var didWarnValueDefaultValue$1;

    	{
    	  didWarnValueDefaultValue$1 = false;
    	}

    	function getDeclarationErrorAddendum() {
    	  var ownerName = getCurrentFiberOwnerNameInDevOrNull();

    	  if (ownerName) {
    	    return '\n\nCheck the render method of `' + ownerName + '`.';
    	  }

    	  return '';
    	}

    	var valuePropNames = ['value', 'defaultValue'];
    	/**
    	 * Validation function for `value` and `defaultValue`.
    	 */

    	function checkSelectPropTypes(props) {
    	  {
    	    checkControlledValueProps('select', props);

    	    for (var i = 0; i < valuePropNames.length; i++) {
    	      var propName = valuePropNames[i];

    	      if (props[propName] == null) {
    	        continue;
    	      }

    	      var isArray = Array.isArray(props[propName]);

    	      if (props.multiple && !isArray) {
    	        error('The `%s` prop supplied to <select> must be an array if ' + '`multiple` is true.%s', propName, getDeclarationErrorAddendum());
    	      } else if (!props.multiple && isArray) {
    	        error('The `%s` prop supplied to <select> must be a scalar ' + 'value if `multiple` is false.%s', propName, getDeclarationErrorAddendum());
    	      }
    	    }
    	  }
    	}

    	function updateOptions(node, multiple, propValue, setDefaultSelected) {
    	  var options = node.options;

    	  if (multiple) {
    	    var selectedValues = propValue;
    	    var selectedValue = {};

    	    for (var i = 0; i < selectedValues.length; i++) {
    	      // Prefix to avoid chaos with special keys.
    	      selectedValue['$' + selectedValues[i]] = true;
    	    }

    	    for (var _i = 0; _i < options.length; _i++) {
    	      var selected = selectedValue.hasOwnProperty('$' + options[_i].value);

    	      if (options[_i].selected !== selected) {
    	        options[_i].selected = selected;
    	      }

    	      if (selected && setDefaultSelected) {
    	        options[_i].defaultSelected = true;
    	      }
    	    }
    	  } else {
    	    // Do not set `select.value` as exact behavior isn't consistent across all
    	    // browsers for all cases.
    	    var _selectedValue = toString(getToStringValue(propValue));

    	    var defaultSelected = null;

    	    for (var _i2 = 0; _i2 < options.length; _i2++) {
    	      if (options[_i2].value === _selectedValue) {
    	        options[_i2].selected = true;

    	        if (setDefaultSelected) {
    	          options[_i2].defaultSelected = true;
    	        }

    	        return;
    	      }

    	      if (defaultSelected === null && !options[_i2].disabled) {
    	        defaultSelected = options[_i2];
    	      }
    	    }

    	    if (defaultSelected !== null) {
    	      defaultSelected.selected = true;
    	    }
    	  }
    	}
    	/**
    	 * Implements a <select> host component that allows optionally setting the
    	 * props `value` and `defaultValue`. If `multiple` is false, the prop must be a
    	 * stringable. If `multiple` is true, the prop must be an array of stringables.
    	 *
    	 * If `value` is not supplied (or null/undefined), user actions that change the
    	 * selected option will trigger updates to the rendered options.
    	 *
    	 * If it is supplied (and not null/undefined), the rendered options will not
    	 * update in response to user actions. Instead, the `value` prop must change in
    	 * order for the rendered options to update.
    	 *
    	 * If `defaultValue` is provided, any options with the supplied values will be
    	 * selected.
    	 */


    	function getHostProps$2(element, props) {
    	  return _assign({}, props, {
    	    value: undefined
    	  });
    	}
    	function initWrapperState$1(element, props) {
    	  var node = element;

    	  {
    	    checkSelectPropTypes(props);
    	  }

    	  node._wrapperState = {
    	    wasMultiple: !!props.multiple
    	  };

    	  {
    	    if (props.value !== undefined && props.defaultValue !== undefined && !didWarnValueDefaultValue$1) {
    	      error('Select elements must be either controlled or uncontrolled ' + '(specify either the value prop, or the defaultValue prop, but not ' + 'both). Decide between using a controlled or uncontrolled select ' + 'element and remove one of these props. More info: ' + 'https://reactjs.org/link/controlled-components');

    	      didWarnValueDefaultValue$1 = true;
    	    }
    	  }
    	}
    	function postMountWrapper$2(element, props) {
    	  var node = element;
    	  node.multiple = !!props.multiple;
    	  var value = props.value;

    	  if (value != null) {
    	    updateOptions(node, !!props.multiple, value, false);
    	  } else if (props.defaultValue != null) {
    	    updateOptions(node, !!props.multiple, props.defaultValue, true);
    	  }
    	}
    	function postUpdateWrapper(element, props) {
    	  var node = element;
    	  var wasMultiple = node._wrapperState.wasMultiple;
    	  node._wrapperState.wasMultiple = !!props.multiple;
    	  var value = props.value;

    	  if (value != null) {
    	    updateOptions(node, !!props.multiple, value, false);
    	  } else if (wasMultiple !== !!props.multiple) {
    	    // For simplicity, reapply `defaultValue` if `multiple` is toggled.
    	    if (props.defaultValue != null) {
    	      updateOptions(node, !!props.multiple, props.defaultValue, true);
    	    } else {
    	      // Revert the select back to its default unselected state.
    	      updateOptions(node, !!props.multiple, props.multiple ? [] : '', false);
    	    }
    	  }
    	}
    	function restoreControlledState$1(element, props) {
    	  var node = element;
    	  var value = props.value;

    	  if (value != null) {
    	    updateOptions(node, !!props.multiple, value, false);
    	  }
    	}

    	var didWarnValDefaultVal = false;

    	/**
    	 * Implements a <textarea> host component that allows setting `value`, and
    	 * `defaultValue`. This differs from the traditional DOM API because value is
    	 * usually set as PCDATA children.
    	 *
    	 * If `value` is not supplied (or null/undefined), user actions that affect the
    	 * value will trigger updates to the element.
    	 *
    	 * If `value` is supplied (and not null/undefined), the rendered element will
    	 * not trigger updates to the element. Instead, the `value` prop must change in
    	 * order for the rendered element to be updated.
    	 *
    	 * The rendered element will be initialized with an empty value, the prop
    	 * `defaultValue` if specified, or the children content (deprecated).
    	 */
    	function getHostProps$3(element, props) {
    	  var node = element;

    	  if (!(props.dangerouslySetInnerHTML == null)) {
    	    {
    	      throw Error( "`dangerouslySetInnerHTML` does not make sense on <textarea>." );
    	    }
    	  } // Always set children to the same thing. In IE9, the selection range will
    	  // get reset if `textContent` is mutated.  We could add a check in setTextContent
    	  // to only set the value if/when the value differs from the node value (which would
    	  // completely solve this IE9 bug), but Sebastian+Sophie seemed to like this
    	  // solution. The value can be a boolean or object so that's why it's forced
    	  // to be a string.


    	  var hostProps = _assign({}, props, {
    	    value: undefined,
    	    defaultValue: undefined,
    	    children: toString(node._wrapperState.initialValue)
    	  });

    	  return hostProps;
    	}
    	function initWrapperState$2(element, props) {
    	  var node = element;

    	  {
    	    checkControlledValueProps('textarea', props);

    	    if (props.value !== undefined && props.defaultValue !== undefined && !didWarnValDefaultVal) {
    	      error('%s contains a textarea with both value and defaultValue props. ' + 'Textarea elements must be either controlled or uncontrolled ' + '(specify either the value prop, or the defaultValue prop, but not ' + 'both). Decide between using a controlled or uncontrolled textarea ' + 'and remove one of these props. More info: ' + 'https://reactjs.org/link/controlled-components', getCurrentFiberOwnerNameInDevOrNull() || 'A component');

    	      didWarnValDefaultVal = true;
    	    }
    	  }

    	  var initialValue = props.value; // Only bother fetching default value if we're going to use it

    	  if (initialValue == null) {
    	    var children = props.children,
    	        defaultValue = props.defaultValue;

    	    if (children != null) {
    	      {
    	        error('Use the `defaultValue` or `value` props instead of setting ' + 'children on <textarea>.');
    	      }

    	      {
    	        if (!(defaultValue == null)) {
    	          {
    	            throw Error( "If you supply `defaultValue` on a <textarea>, do not pass children." );
    	          }
    	        }

    	        if (Array.isArray(children)) {
    	          if (!(children.length <= 1)) {
    	            {
    	              throw Error( "<textarea> can only have at most one child." );
    	            }
    	          }

    	          children = children[0];
    	        }

    	        defaultValue = children;
    	      }
    	    }

    	    if (defaultValue == null) {
    	      defaultValue = '';
    	    }

    	    initialValue = defaultValue;
    	  }

    	  node._wrapperState = {
    	    initialValue: getToStringValue(initialValue)
    	  };
    	}
    	function updateWrapper$1(element, props) {
    	  var node = element;
    	  var value = getToStringValue(props.value);
    	  var defaultValue = getToStringValue(props.defaultValue);

    	  if (value != null) {
    	    // Cast `value` to a string to ensure the value is set correctly. While
    	    // browsers typically do this as necessary, jsdom doesn't.
    	    var newValue = toString(value); // To avoid side effects (such as losing text selection), only set value if changed

    	    if (newValue !== node.value) {
    	      node.value = newValue;
    	    }

    	    if (props.defaultValue == null && node.defaultValue !== newValue) {
    	      node.defaultValue = newValue;
    	    }
    	  }

    	  if (defaultValue != null) {
    	    node.defaultValue = toString(defaultValue);
    	  }
    	}
    	function postMountWrapper$3(element, props) {
    	  var node = element; // This is in postMount because we need access to the DOM node, which is not
    	  // available until after the component has mounted.

    	  var textContent = node.textContent; // Only set node.value if textContent is equal to the expected
    	  // initial value. In IE10/IE11 there is a bug where the placeholder attribute
    	  // will populate textContent as well.
    	  // https://developer.microsoft.com/microsoft-edge/platform/issues/101525/

    	  if (textContent === node._wrapperState.initialValue) {
    	    if (textContent !== '' && textContent !== null) {
    	      node.value = textContent;
    	    }
    	  }
    	}
    	function restoreControlledState$2(element, props) {
    	  // DOM component is still mounted; update
    	  updateWrapper$1(element, props);
    	}

    	var HTML_NAMESPACE = 'http://www.w3.org/1999/xhtml';
    	var MATH_NAMESPACE = 'http://www.w3.org/1998/Math/MathML';
    	var SVG_NAMESPACE = 'http://www.w3.org/2000/svg';
    	var Namespaces = {
    	  html: HTML_NAMESPACE,
    	  mathml: MATH_NAMESPACE,
    	  svg: SVG_NAMESPACE
    	}; // Assumes there is no parent namespace.

    	function getIntrinsicNamespace(type) {
    	  switch (type) {
    	    case 'svg':
    	      return SVG_NAMESPACE;

    	    case 'math':
    	      return MATH_NAMESPACE;

    	    default:
    	      return HTML_NAMESPACE;
    	  }
    	}
    	function getChildNamespace(parentNamespace, type) {
    	  if (parentNamespace == null || parentNamespace === HTML_NAMESPACE) {
    	    // No (or default) parent namespace: potential entry point.
    	    return getIntrinsicNamespace(type);
    	  }

    	  if (parentNamespace === SVG_NAMESPACE && type === 'foreignObject') {
    	    // We're leaving SVG.
    	    return HTML_NAMESPACE;
    	  } // By default, pass namespace below.


    	  return parentNamespace;
    	}

    	/* globals MSApp */

    	/**
    	 * Create a function which has 'unsafe' privileges (required by windows8 apps)
    	 */
    	var createMicrosoftUnsafeLocalFunction = function (func) {
    	  if (typeof MSApp !== 'undefined' && MSApp.execUnsafeLocalFunction) {
    	    return function (arg0, arg1, arg2, arg3) {
    	      MSApp.execUnsafeLocalFunction(function () {
    	        return func(arg0, arg1, arg2, arg3);
    	      });
    	    };
    	  } else {
    	    return func;
    	  }
    	};

    	var reusableSVGContainer;
    	/**
    	 * Set the innerHTML property of a node
    	 *
    	 * @param {DOMElement} node
    	 * @param {string} html
    	 * @internal
    	 */

    	var setInnerHTML = createMicrosoftUnsafeLocalFunction(function (node, html) {
    	  if (node.namespaceURI === Namespaces.svg) {

    	    if (!('innerHTML' in node)) {
    	      // IE does not have innerHTML for SVG nodes, so instead we inject the
    	      // new markup in a temp node and then move the child nodes across into
    	      // the target node
    	      reusableSVGContainer = reusableSVGContainer || document.createElement('div');
    	      reusableSVGContainer.innerHTML = '<svg>' + html.valueOf().toString() + '</svg>';
    	      var svgNode = reusableSVGContainer.firstChild;

    	      while (node.firstChild) {
    	        node.removeChild(node.firstChild);
    	      }

    	      while (svgNode.firstChild) {
    	        node.appendChild(svgNode.firstChild);
    	      }

    	      return;
    	    }
    	  }

    	  node.innerHTML = html;
    	});

    	/**
    	 * HTML nodeType values that represent the type of the node
    	 */
    	var ELEMENT_NODE = 1;
    	var TEXT_NODE = 3;
    	var COMMENT_NODE = 8;
    	var DOCUMENT_NODE = 9;
    	var DOCUMENT_FRAGMENT_NODE = 11;

    	/**
    	 * Set the textContent property of a node. For text updates, it's faster
    	 * to set the `nodeValue` of the Text node directly instead of using
    	 * `.textContent` which will remove the existing node and create a new one.
    	 *
    	 * @param {DOMElement} node
    	 * @param {string} text
    	 * @internal
    	 */

    	var setTextContent = function (node, text) {
    	  if (text) {
    	    var firstChild = node.firstChild;

    	    if (firstChild && firstChild === node.lastChild && firstChild.nodeType === TEXT_NODE) {
    	      firstChild.nodeValue = text;
    	      return;
    	    }
    	  }

    	  node.textContent = text;
    	};

    	// List derived from Gecko source code:
    	// https://github.com/mozilla/gecko-dev/blob/4e638efc71/layout/style/test/property_database.js
    	var shorthandToLonghand = {
    	  animation: ['animationDelay', 'animationDirection', 'animationDuration', 'animationFillMode', 'animationIterationCount', 'animationName', 'animationPlayState', 'animationTimingFunction'],
    	  background: ['backgroundAttachment', 'backgroundClip', 'backgroundColor', 'backgroundImage', 'backgroundOrigin', 'backgroundPositionX', 'backgroundPositionY', 'backgroundRepeat', 'backgroundSize'],
    	  backgroundPosition: ['backgroundPositionX', 'backgroundPositionY'],
    	  border: ['borderBottomColor', 'borderBottomStyle', 'borderBottomWidth', 'borderImageOutset', 'borderImageRepeat', 'borderImageSlice', 'borderImageSource', 'borderImageWidth', 'borderLeftColor', 'borderLeftStyle', 'borderLeftWidth', 'borderRightColor', 'borderRightStyle', 'borderRightWidth', 'borderTopColor', 'borderTopStyle', 'borderTopWidth'],
    	  borderBlockEnd: ['borderBlockEndColor', 'borderBlockEndStyle', 'borderBlockEndWidth'],
    	  borderBlockStart: ['borderBlockStartColor', 'borderBlockStartStyle', 'borderBlockStartWidth'],
    	  borderBottom: ['borderBottomColor', 'borderBottomStyle', 'borderBottomWidth'],
    	  borderColor: ['borderBottomColor', 'borderLeftColor', 'borderRightColor', 'borderTopColor'],
    	  borderImage: ['borderImageOutset', 'borderImageRepeat', 'borderImageSlice', 'borderImageSource', 'borderImageWidth'],
    	  borderInlineEnd: ['borderInlineEndColor', 'borderInlineEndStyle', 'borderInlineEndWidth'],
    	  borderInlineStart: ['borderInlineStartColor', 'borderInlineStartStyle', 'borderInlineStartWidth'],
    	  borderLeft: ['borderLeftColor', 'borderLeftStyle', 'borderLeftWidth'],
    	  borderRadius: ['borderBottomLeftRadius', 'borderBottomRightRadius', 'borderTopLeftRadius', 'borderTopRightRadius'],
    	  borderRight: ['borderRightColor', 'borderRightStyle', 'borderRightWidth'],
    	  borderStyle: ['borderBottomStyle', 'borderLeftStyle', 'borderRightStyle', 'borderTopStyle'],
    	  borderTop: ['borderTopColor', 'borderTopStyle', 'borderTopWidth'],
    	  borderWidth: ['borderBottomWidth', 'borderLeftWidth', 'borderRightWidth', 'borderTopWidth'],
    	  columnRule: ['columnRuleColor', 'columnRuleStyle', 'columnRuleWidth'],
    	  columns: ['columnCount', 'columnWidth'],
    	  flex: ['flexBasis', 'flexGrow', 'flexShrink'],
    	  flexFlow: ['flexDirection', 'flexWrap'],
    	  font: ['fontFamily', 'fontFeatureSettings', 'fontKerning', 'fontLanguageOverride', 'fontSize', 'fontSizeAdjust', 'fontStretch', 'fontStyle', 'fontVariant', 'fontVariantAlternates', 'fontVariantCaps', 'fontVariantEastAsian', 'fontVariantLigatures', 'fontVariantNumeric', 'fontVariantPosition', 'fontWeight', 'lineHeight'],
    	  fontVariant: ['fontVariantAlternates', 'fontVariantCaps', 'fontVariantEastAsian', 'fontVariantLigatures', 'fontVariantNumeric', 'fontVariantPosition'],
    	  gap: ['columnGap', 'rowGap'],
    	  grid: ['gridAutoColumns', 'gridAutoFlow', 'gridAutoRows', 'gridTemplateAreas', 'gridTemplateColumns', 'gridTemplateRows'],
    	  gridArea: ['gridColumnEnd', 'gridColumnStart', 'gridRowEnd', 'gridRowStart'],
    	  gridColumn: ['gridColumnEnd', 'gridColumnStart'],
    	  gridColumnGap: ['columnGap'],
    	  gridGap: ['columnGap', 'rowGap'],
    	  gridRow: ['gridRowEnd', 'gridRowStart'],
    	  gridRowGap: ['rowGap'],
    	  gridTemplate: ['gridTemplateAreas', 'gridTemplateColumns', 'gridTemplateRows'],
    	  listStyle: ['listStyleImage', 'listStylePosition', 'listStyleType'],
    	  margin: ['marginBottom', 'marginLeft', 'marginRight', 'marginTop'],
    	  marker: ['markerEnd', 'markerMid', 'markerStart'],
    	  mask: ['maskClip', 'maskComposite', 'maskImage', 'maskMode', 'maskOrigin', 'maskPositionX', 'maskPositionY', 'maskRepeat', 'maskSize'],
    	  maskPosition: ['maskPositionX', 'maskPositionY'],
    	  outline: ['outlineColor', 'outlineStyle', 'outlineWidth'],
    	  overflow: ['overflowX', 'overflowY'],
    	  padding: ['paddingBottom', 'paddingLeft', 'paddingRight', 'paddingTop'],
    	  placeContent: ['alignContent', 'justifyContent'],
    	  placeItems: ['alignItems', 'justifyItems'],
    	  placeSelf: ['alignSelf', 'justifySelf'],
    	  textDecoration: ['textDecorationColor', 'textDecorationLine', 'textDecorationStyle'],
    	  textEmphasis: ['textEmphasisColor', 'textEmphasisStyle'],
    	  transition: ['transitionDelay', 'transitionDuration', 'transitionProperty', 'transitionTimingFunction'],
    	  wordWrap: ['overflowWrap']
    	};

    	/**
    	 * CSS properties which accept numbers but are not in units of "px".
    	 */
    	var isUnitlessNumber = {
    	  animationIterationCount: true,
    	  borderImageOutset: true,
    	  borderImageSlice: true,
    	  borderImageWidth: true,
    	  boxFlex: true,
    	  boxFlexGroup: true,
    	  boxOrdinalGroup: true,
    	  columnCount: true,
    	  columns: true,
    	  flex: true,
    	  flexGrow: true,
    	  flexPositive: true,
    	  flexShrink: true,
    	  flexNegative: true,
    	  flexOrder: true,
    	  gridArea: true,
    	  gridRow: true,
    	  gridRowEnd: true,
    	  gridRowSpan: true,
    	  gridRowStart: true,
    	  gridColumn: true,
    	  gridColumnEnd: true,
    	  gridColumnSpan: true,
    	  gridColumnStart: true,
    	  fontWeight: true,
    	  lineClamp: true,
    	  lineHeight: true,
    	  opacity: true,
    	  order: true,
    	  orphans: true,
    	  tabSize: true,
    	  widows: true,
    	  zIndex: true,
    	  zoom: true,
    	  // SVG-related properties
    	  fillOpacity: true,
    	  floodOpacity: true,
    	  stopOpacity: true,
    	  strokeDasharray: true,
    	  strokeDashoffset: true,
    	  strokeMiterlimit: true,
    	  strokeOpacity: true,
    	  strokeWidth: true
    	};
    	/**
    	 * @param {string} prefix vendor-specific prefix, eg: Webkit
    	 * @param {string} key style name, eg: transitionDuration
    	 * @return {string} style name prefixed with `prefix`, properly camelCased, eg:
    	 * WebkitTransitionDuration
    	 */

    	function prefixKey(prefix, key) {
    	  return prefix + key.charAt(0).toUpperCase() + key.substring(1);
    	}
    	/**
    	 * Support style names that may come passed in prefixed by adding permutations
    	 * of vendor prefixes.
    	 */


    	var prefixes = ['Webkit', 'ms', 'Moz', 'O']; // Using Object.keys here, or else the vanilla for-in loop makes IE8 go into an
    	// infinite loop, because it iterates over the newly added props too.

    	Object.keys(isUnitlessNumber).forEach(function (prop) {
    	  prefixes.forEach(function (prefix) {
    	    isUnitlessNumber[prefixKey(prefix, prop)] = isUnitlessNumber[prop];
    	  });
    	});

    	/**
    	 * Convert a value into the proper css writable value. The style name `name`
    	 * should be logical (no hyphens), as specified
    	 * in `CSSProperty.isUnitlessNumber`.
    	 *
    	 * @param {string} name CSS property name such as `topMargin`.
    	 * @param {*} value CSS property value such as `10px`.
    	 * @return {string} Normalized style value with dimensions applied.
    	 */

    	function dangerousStyleValue(name, value, isCustomProperty) {
    	  // Note that we've removed escapeTextForBrowser() calls here since the
    	  // whole string will be escaped when the attribute is injected into
    	  // the markup. If you provide unsafe user data here they can inject
    	  // arbitrary CSS which may be problematic (I couldn't repro this):
    	  // https://www.owasp.org/index.php/XSS_Filter_Evasion_Cheat_Sheet
    	  // http://www.thespanner.co.uk/2007/11/26/ultimate-xss-css-injection/
    	  // This is not an XSS hole but instead a potential CSS injection issue
    	  // which has lead to a greater discussion about how we're going to
    	  // trust URLs moving forward. See #2115901
    	  var isEmpty = value == null || typeof value === 'boolean' || value === '';

    	  if (isEmpty) {
    	    return '';
    	  }

    	  if (!isCustomProperty && typeof value === 'number' && value !== 0 && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name])) {
    	    return value + 'px'; // Presumes implicit 'px' suffix for unitless numbers
    	  }

    	  return ('' + value).trim();
    	}

    	var uppercasePattern = /([A-Z])/g;
    	var msPattern = /^ms-/;
    	/**
    	 * Hyphenates a camelcased CSS property name, for example:
    	 *
    	 *   > hyphenateStyleName('backgroundColor')
    	 *   < "background-color"
    	 *   > hyphenateStyleName('MozTransition')
    	 *   < "-moz-transition"
    	 *   > hyphenateStyleName('msTransition')
    	 *   < "-ms-transition"
    	 *
    	 * As Modernizr suggests (http://modernizr.com/docs/#prefixed), an `ms` prefix
    	 * is converted to `-ms-`.
    	 */

    	function hyphenateStyleName(name) {
    	  return name.replace(uppercasePattern, '-$1').toLowerCase().replace(msPattern, '-ms-');
    	}

    	var warnValidStyle = function () {};

    	{
    	  // 'msTransform' is correct, but the other prefixes should be capitalized
    	  var badVendoredStyleNamePattern = /^(?:webkit|moz|o)[A-Z]/;
    	  var msPattern$1 = /^-ms-/;
    	  var hyphenPattern = /-(.)/g; // style values shouldn't contain a semicolon

    	  var badStyleValueWithSemicolonPattern = /;\s*$/;
    	  var warnedStyleNames = {};
    	  var warnedStyleValues = {};
    	  var warnedForNaNValue = false;
    	  var warnedForInfinityValue = false;

    	  var camelize = function (string) {
    	    return string.replace(hyphenPattern, function (_, character) {
    	      return character.toUpperCase();
    	    });
    	  };

    	  var warnHyphenatedStyleName = function (name) {
    	    if (warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name]) {
    	      return;
    	    }

    	    warnedStyleNames[name] = true;

    	    error('Unsupported style property %s. Did you mean %s?', name, // As Andi Smith suggests
    	    // (http://www.andismith.com/blog/2012/02/modernizr-prefixed/), an `-ms` prefix
    	    // is converted to lowercase `ms`.
    	    camelize(name.replace(msPattern$1, 'ms-')));
    	  };

    	  var warnBadVendoredStyleName = function (name) {
    	    if (warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name]) {
    	      return;
    	    }

    	    warnedStyleNames[name] = true;

    	    error('Unsupported vendor-prefixed style property %s. Did you mean %s?', name, name.charAt(0).toUpperCase() + name.slice(1));
    	  };

    	  var warnStyleValueWithSemicolon = function (name, value) {
    	    if (warnedStyleValues.hasOwnProperty(value) && warnedStyleValues[value]) {
    	      return;
    	    }

    	    warnedStyleValues[value] = true;

    	    error("Style property values shouldn't contain a semicolon. " + 'Try "%s: %s" instead.', name, value.replace(badStyleValueWithSemicolonPattern, ''));
    	  };

    	  var warnStyleValueIsNaN = function (name, value) {
    	    if (warnedForNaNValue) {
    	      return;
    	    }

    	    warnedForNaNValue = true;

    	    error('`NaN` is an invalid value for the `%s` css style property.', name);
    	  };

    	  var warnStyleValueIsInfinity = function (name, value) {
    	    if (warnedForInfinityValue) {
    	      return;
    	    }

    	    warnedForInfinityValue = true;

    	    error('`Infinity` is an invalid value for the `%s` css style property.', name);
    	  };

    	  warnValidStyle = function (name, value) {
    	    if (name.indexOf('-') > -1) {
    	      warnHyphenatedStyleName(name);
    	    } else if (badVendoredStyleNamePattern.test(name)) {
    	      warnBadVendoredStyleName(name);
    	    } else if (badStyleValueWithSemicolonPattern.test(value)) {
    	      warnStyleValueWithSemicolon(name, value);
    	    }

    	    if (typeof value === 'number') {
    	      if (isNaN(value)) {
    	        warnStyleValueIsNaN(name, value);
    	      } else if (!isFinite(value)) {
    	        warnStyleValueIsInfinity(name, value);
    	      }
    	    }
    	  };
    	}

    	var warnValidStyle$1 = warnValidStyle;

    	/**
    	 * Operations for dealing with CSS properties.
    	 */

    	/**
    	 * This creates a string that is expected to be equivalent to the style
    	 * attribute generated by server-side rendering. It by-passes warnings and
    	 * security checks so it's not safe to use this value for anything other than
    	 * comparison. It is only used in DEV for SSR validation.
    	 */

    	function createDangerousStringForStyles(styles) {
    	  {
    	    var serialized = '';
    	    var delimiter = '';

    	    for (var styleName in styles) {
    	      if (!styles.hasOwnProperty(styleName)) {
    	        continue;
    	      }

    	      var styleValue = styles[styleName];

    	      if (styleValue != null) {
    	        var isCustomProperty = styleName.indexOf('--') === 0;
    	        serialized += delimiter + (isCustomProperty ? styleName : hyphenateStyleName(styleName)) + ':';
    	        serialized += dangerousStyleValue(styleName, styleValue, isCustomProperty);
    	        delimiter = ';';
    	      }
    	    }

    	    return serialized || null;
    	  }
    	}
    	/**
    	 * Sets the value for multiple styles on a node.  If a value is specified as
    	 * '' (empty string), the corresponding style property will be unset.
    	 *
    	 * @param {DOMElement} node
    	 * @param {object} styles
    	 */

    	function setValueForStyles(node, styles) {
    	  var style = node.style;

    	  for (var styleName in styles) {
    	    if (!styles.hasOwnProperty(styleName)) {
    	      continue;
    	    }

    	    var isCustomProperty = styleName.indexOf('--') === 0;

    	    {
    	      if (!isCustomProperty) {
    	        warnValidStyle$1(styleName, styles[styleName]);
    	      }
    	    }

    	    var styleValue = dangerousStyleValue(styleName, styles[styleName], isCustomProperty);

    	    if (styleName === 'float') {
    	      styleName = 'cssFloat';
    	    }

    	    if (isCustomProperty) {
    	      style.setProperty(styleName, styleValue);
    	    } else {
    	      style[styleName] = styleValue;
    	    }
    	  }
    	}

    	function isValueEmpty(value) {
    	  return value == null || typeof value === 'boolean' || value === '';
    	}
    	/**
    	 * Given {color: 'red', overflow: 'hidden'} returns {
    	 *   color: 'color',
    	 *   overflowX: 'overflow',
    	 *   overflowY: 'overflow',
    	 * }. This can be read as "the overflowY property was set by the overflow
    	 * shorthand". That is, the values are the property that each was derived from.
    	 */


    	function expandShorthandMap(styles) {
    	  var expanded = {};

    	  for (var key in styles) {
    	    var longhands = shorthandToLonghand[key] || [key];

    	    for (var i = 0; i < longhands.length; i++) {
    	      expanded[longhands[i]] = key;
    	    }
    	  }

    	  return expanded;
    	}
    	/**
    	 * When mixing shorthand and longhand property names, we warn during updates if
    	 * we expect an incorrect result to occur. In particular, we warn for:
    	 *
    	 * Updating a shorthand property (longhand gets overwritten):
    	 *   {font: 'foo', fontVariant: 'bar'} -> {font: 'baz', fontVariant: 'bar'}
    	 *   becomes .style.font = 'baz'
    	 * Removing a shorthand property (longhand gets lost too):
    	 *   {font: 'foo', fontVariant: 'bar'} -> {fontVariant: 'bar'}
    	 *   becomes .style.font = ''
    	 * Removing a longhand property (should revert to shorthand; doesn't):
    	 *   {font: 'foo', fontVariant: 'bar'} -> {font: 'foo'}
    	 *   becomes .style.fontVariant = ''
    	 */


    	function validateShorthandPropertyCollisionInDev(styleUpdates, nextStyles) {
    	  {
    	    if (!nextStyles) {
    	      return;
    	    }

    	    var expandedUpdates = expandShorthandMap(styleUpdates);
    	    var expandedStyles = expandShorthandMap(nextStyles);
    	    var warnedAbout = {};

    	    for (var key in expandedUpdates) {
    	      var originalKey = expandedUpdates[key];
    	      var correctOriginalKey = expandedStyles[key];

    	      if (correctOriginalKey && originalKey !== correctOriginalKey) {
    	        var warningKey = originalKey + ',' + correctOriginalKey;

    	        if (warnedAbout[warningKey]) {
    	          continue;
    	        }

    	        warnedAbout[warningKey] = true;

    	        error('%s a style property during rerender (%s) when a ' + 'conflicting property is set (%s) can lead to styling bugs. To ' + "avoid this, don't mix shorthand and non-shorthand properties " + 'for the same value; instead, replace the shorthand with ' + 'separate values.', isValueEmpty(styleUpdates[originalKey]) ? 'Removing' : 'Updating', originalKey, correctOriginalKey);
    	      }
    	    }
    	  }
    	}

    	// For HTML, certain tags should omit their close tag. We keep a list for
    	// those special-case tags.
    	var omittedCloseTags = {
    	  area: true,
    	  base: true,
    	  br: true,
    	  col: true,
    	  embed: true,
    	  hr: true,
    	  img: true,
    	  input: true,
    	  keygen: true,
    	  link: true,
    	  meta: true,
    	  param: true,
    	  source: true,
    	  track: true,
    	  wbr: true // NOTE: menuitem's close tag should be omitted, but that causes problems.

    	};

    	// `omittedCloseTags` except that `menuitem` should still have its closing tag.

    	var voidElementTags = _assign({
    	  menuitem: true
    	}, omittedCloseTags);

    	var HTML = '__html';

    	function assertValidProps(tag, props) {
    	  if (!props) {
    	    return;
    	  } // Note the use of `==` which checks for null or undefined.


    	  if (voidElementTags[tag]) {
    	    if (!(props.children == null && props.dangerouslySetInnerHTML == null)) {
    	      {
    	        throw Error( tag + " is a void element tag and must neither have `children` nor use `dangerouslySetInnerHTML`." );
    	      }
    	    }
    	  }

    	  if (props.dangerouslySetInnerHTML != null) {
    	    if (!(props.children == null)) {
    	      {
    	        throw Error( "Can only set one of `children` or `props.dangerouslySetInnerHTML`." );
    	      }
    	    }

    	    if (!(typeof props.dangerouslySetInnerHTML === 'object' && HTML in props.dangerouslySetInnerHTML)) {
    	      {
    	        throw Error( "`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information." );
    	      }
    	    }
    	  }

    	  {
    	    if (!props.suppressContentEditableWarning && props.contentEditable && props.children != null) {
    	      error('A component is `contentEditable` and contains `children` managed by ' + 'React. It is now your responsibility to guarantee that none of ' + 'those nodes are unexpectedly modified or duplicated. This is ' + 'probably not intentional.');
    	    }
    	  }

    	  if (!(props.style == null || typeof props.style === 'object')) {
    	    {
    	      throw Error( "The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX." );
    	    }
    	  }
    	}

    	function isCustomComponent(tagName, props) {
    	  if (tagName.indexOf('-') === -1) {
    	    return typeof props.is === 'string';
    	  }

    	  switch (tagName) {
    	    // These are reserved SVG and MathML elements.
    	    // We don't mind this list too much because we expect it to never grow.
    	    // The alternative is to track the namespace in a few places which is convoluted.
    	    // https://w3c.github.io/webcomponents/spec/custom/#custom-elements-core-concepts
    	    case 'annotation-xml':
    	    case 'color-profile':
    	    case 'font-face':
    	    case 'font-face-src':
    	    case 'font-face-uri':
    	    case 'font-face-format':
    	    case 'font-face-name':
    	    case 'missing-glyph':
    	      return false;

    	    default:
    	      return true;
    	  }
    	}

    	// When adding attributes to the HTML or SVG allowed attribute list, be sure to
    	// also add them to this module to ensure casing and incorrect name
    	// warnings.
    	var possibleStandardNames = {
    	  // HTML
    	  accept: 'accept',
    	  acceptcharset: 'acceptCharset',
    	  'accept-charset': 'acceptCharset',
    	  accesskey: 'accessKey',
    	  action: 'action',
    	  allowfullscreen: 'allowFullScreen',
    	  alt: 'alt',
    	  as: 'as',
    	  async: 'async',
    	  autocapitalize: 'autoCapitalize',
    	  autocomplete: 'autoComplete',
    	  autocorrect: 'autoCorrect',
    	  autofocus: 'autoFocus',
    	  autoplay: 'autoPlay',
    	  autosave: 'autoSave',
    	  capture: 'capture',
    	  cellpadding: 'cellPadding',
    	  cellspacing: 'cellSpacing',
    	  challenge: 'challenge',
    	  charset: 'charSet',
    	  checked: 'checked',
    	  children: 'children',
    	  cite: 'cite',
    	  class: 'className',
    	  classid: 'classID',
    	  classname: 'className',
    	  cols: 'cols',
    	  colspan: 'colSpan',
    	  content: 'content',
    	  contenteditable: 'contentEditable',
    	  contextmenu: 'contextMenu',
    	  controls: 'controls',
    	  controlslist: 'controlsList',
    	  coords: 'coords',
    	  crossorigin: 'crossOrigin',
    	  dangerouslysetinnerhtml: 'dangerouslySetInnerHTML',
    	  data: 'data',
    	  datetime: 'dateTime',
    	  default: 'default',
    	  defaultchecked: 'defaultChecked',
    	  defaultvalue: 'defaultValue',
    	  defer: 'defer',
    	  dir: 'dir',
    	  disabled: 'disabled',
    	  disablepictureinpicture: 'disablePictureInPicture',
    	  disableremoteplayback: 'disableRemotePlayback',
    	  download: 'download',
    	  draggable: 'draggable',
    	  enctype: 'encType',
    	  enterkeyhint: 'enterKeyHint',
    	  for: 'htmlFor',
    	  form: 'form',
    	  formmethod: 'formMethod',
    	  formaction: 'formAction',
    	  formenctype: 'formEncType',
    	  formnovalidate: 'formNoValidate',
    	  formtarget: 'formTarget',
    	  frameborder: 'frameBorder',
    	  headers: 'headers',
    	  height: 'height',
    	  hidden: 'hidden',
    	  high: 'high',
    	  href: 'href',
    	  hreflang: 'hrefLang',
    	  htmlfor: 'htmlFor',
    	  httpequiv: 'httpEquiv',
    	  'http-equiv': 'httpEquiv',
    	  icon: 'icon',
    	  id: 'id',
    	  innerhtml: 'innerHTML',
    	  inputmode: 'inputMode',
    	  integrity: 'integrity',
    	  is: 'is',
    	  itemid: 'itemID',
    	  itemprop: 'itemProp',
    	  itemref: 'itemRef',
    	  itemscope: 'itemScope',
    	  itemtype: 'itemType',
    	  keyparams: 'keyParams',
    	  keytype: 'keyType',
    	  kind: 'kind',
    	  label: 'label',
    	  lang: 'lang',
    	  list: 'list',
    	  loop: 'loop',
    	  low: 'low',
    	  manifest: 'manifest',
    	  marginwidth: 'marginWidth',
    	  marginheight: 'marginHeight',
    	  max: 'max',
    	  maxlength: 'maxLength',
    	  media: 'media',
    	  mediagroup: 'mediaGroup',
    	  method: 'method',
    	  min: 'min',
    	  minlength: 'minLength',
    	  multiple: 'multiple',
    	  muted: 'muted',
    	  name: 'name',
    	  nomodule: 'noModule',
    	  nonce: 'nonce',
    	  novalidate: 'noValidate',
    	  open: 'open',
    	  optimum: 'optimum',
    	  pattern: 'pattern',
    	  placeholder: 'placeholder',
    	  playsinline: 'playsInline',
    	  poster: 'poster',
    	  preload: 'preload',
    	  profile: 'profile',
    	  radiogroup: 'radioGroup',
    	  readonly: 'readOnly',
    	  referrerpolicy: 'referrerPolicy',
    	  rel: 'rel',
    	  required: 'required',
    	  reversed: 'reversed',
    	  role: 'role',
    	  rows: 'rows',
    	  rowspan: 'rowSpan',
    	  sandbox: 'sandbox',
    	  scope: 'scope',
    	  scoped: 'scoped',
    	  scrolling: 'scrolling',
    	  seamless: 'seamless',
    	  selected: 'selected',
    	  shape: 'shape',
    	  size: 'size',
    	  sizes: 'sizes',
    	  span: 'span',
    	  spellcheck: 'spellCheck',
    	  src: 'src',
    	  srcdoc: 'srcDoc',
    	  srclang: 'srcLang',
    	  srcset: 'srcSet',
    	  start: 'start',
    	  step: 'step',
    	  style: 'style',
    	  summary: 'summary',
    	  tabindex: 'tabIndex',
    	  target: 'target',
    	  title: 'title',
    	  type: 'type',
    	  usemap: 'useMap',
    	  value: 'value',
    	  width: 'width',
    	  wmode: 'wmode',
    	  wrap: 'wrap',
    	  // SVG
    	  about: 'about',
    	  accentheight: 'accentHeight',
    	  'accent-height': 'accentHeight',
    	  accumulate: 'accumulate',
    	  additive: 'additive',
    	  alignmentbaseline: 'alignmentBaseline',
    	  'alignment-baseline': 'alignmentBaseline',
    	  allowreorder: 'allowReorder',
    	  alphabetic: 'alphabetic',
    	  amplitude: 'amplitude',
    	  arabicform: 'arabicForm',
    	  'arabic-form': 'arabicForm',
    	  ascent: 'ascent',
    	  attributename: 'attributeName',
    	  attributetype: 'attributeType',
    	  autoreverse: 'autoReverse',
    	  azimuth: 'azimuth',
    	  basefrequency: 'baseFrequency',
    	  baselineshift: 'baselineShift',
    	  'baseline-shift': 'baselineShift',
    	  baseprofile: 'baseProfile',
    	  bbox: 'bbox',
    	  begin: 'begin',
    	  bias: 'bias',
    	  by: 'by',
    	  calcmode: 'calcMode',
    	  capheight: 'capHeight',
    	  'cap-height': 'capHeight',
    	  clip: 'clip',
    	  clippath: 'clipPath',
    	  'clip-path': 'clipPath',
    	  clippathunits: 'clipPathUnits',
    	  cliprule: 'clipRule',
    	  'clip-rule': 'clipRule',
    	  color: 'color',
    	  colorinterpolation: 'colorInterpolation',
    	  'color-interpolation': 'colorInterpolation',
    	  colorinterpolationfilters: 'colorInterpolationFilters',
    	  'color-interpolation-filters': 'colorInterpolationFilters',
    	  colorprofile: 'colorProfile',
    	  'color-profile': 'colorProfile',
    	  colorrendering: 'colorRendering',
    	  'color-rendering': 'colorRendering',
    	  contentscripttype: 'contentScriptType',
    	  contentstyletype: 'contentStyleType',
    	  cursor: 'cursor',
    	  cx: 'cx',
    	  cy: 'cy',
    	  d: 'd',
    	  datatype: 'datatype',
    	  decelerate: 'decelerate',
    	  descent: 'descent',
    	  diffuseconstant: 'diffuseConstant',
    	  direction: 'direction',
    	  display: 'display',
    	  divisor: 'divisor',
    	  dominantbaseline: 'dominantBaseline',
    	  'dominant-baseline': 'dominantBaseline',
    	  dur: 'dur',
    	  dx: 'dx',
    	  dy: 'dy',
    	  edgemode: 'edgeMode',
    	  elevation: 'elevation',
    	  enablebackground: 'enableBackground',
    	  'enable-background': 'enableBackground',
    	  end: 'end',
    	  exponent: 'exponent',
    	  externalresourcesrequired: 'externalResourcesRequired',
    	  fill: 'fill',
    	  fillopacity: 'fillOpacity',
    	  'fill-opacity': 'fillOpacity',
    	  fillrule: 'fillRule',
    	  'fill-rule': 'fillRule',
    	  filter: 'filter',
    	  filterres: 'filterRes',
    	  filterunits: 'filterUnits',
    	  floodopacity: 'floodOpacity',
    	  'flood-opacity': 'floodOpacity',
    	  floodcolor: 'floodColor',
    	  'flood-color': 'floodColor',
    	  focusable: 'focusable',
    	  fontfamily: 'fontFamily',
    	  'font-family': 'fontFamily',
    	  fontsize: 'fontSize',
    	  'font-size': 'fontSize',
    	  fontsizeadjust: 'fontSizeAdjust',
    	  'font-size-adjust': 'fontSizeAdjust',
    	  fontstretch: 'fontStretch',
    	  'font-stretch': 'fontStretch',
    	  fontstyle: 'fontStyle',
    	  'font-style': 'fontStyle',
    	  fontvariant: 'fontVariant',
    	  'font-variant': 'fontVariant',
    	  fontweight: 'fontWeight',
    	  'font-weight': 'fontWeight',
    	  format: 'format',
    	  from: 'from',
    	  fx: 'fx',
    	  fy: 'fy',
    	  g1: 'g1',
    	  g2: 'g2',
    	  glyphname: 'glyphName',
    	  'glyph-name': 'glyphName',
    	  glyphorientationhorizontal: 'glyphOrientationHorizontal',
    	  'glyph-orientation-horizontal': 'glyphOrientationHorizontal',
    	  glyphorientationvertical: 'glyphOrientationVertical',
    	  'glyph-orientation-vertical': 'glyphOrientationVertical',
    	  glyphref: 'glyphRef',
    	  gradienttransform: 'gradientTransform',
    	  gradientunits: 'gradientUnits',
    	  hanging: 'hanging',
    	  horizadvx: 'horizAdvX',
    	  'horiz-adv-x': 'horizAdvX',
    	  horizoriginx: 'horizOriginX',
    	  'horiz-origin-x': 'horizOriginX',
    	  ideographic: 'ideographic',
    	  imagerendering: 'imageRendering',
    	  'image-rendering': 'imageRendering',
    	  in2: 'in2',
    	  in: 'in',
    	  inlist: 'inlist',
    	  intercept: 'intercept',
    	  k1: 'k1',
    	  k2: 'k2',
    	  k3: 'k3',
    	  k4: 'k4',
    	  k: 'k',
    	  kernelmatrix: 'kernelMatrix',
    	  kernelunitlength: 'kernelUnitLength',
    	  kerning: 'kerning',
    	  keypoints: 'keyPoints',
    	  keysplines: 'keySplines',
    	  keytimes: 'keyTimes',
    	  lengthadjust: 'lengthAdjust',
    	  letterspacing: 'letterSpacing',
    	  'letter-spacing': 'letterSpacing',
    	  lightingcolor: 'lightingColor',
    	  'lighting-color': 'lightingColor',
    	  limitingconeangle: 'limitingConeAngle',
    	  local: 'local',
    	  markerend: 'markerEnd',
    	  'marker-end': 'markerEnd',
    	  markerheight: 'markerHeight',
    	  markermid: 'markerMid',
    	  'marker-mid': 'markerMid',
    	  markerstart: 'markerStart',
    	  'marker-start': 'markerStart',
    	  markerunits: 'markerUnits',
    	  markerwidth: 'markerWidth',
    	  mask: 'mask',
    	  maskcontentunits: 'maskContentUnits',
    	  maskunits: 'maskUnits',
    	  mathematical: 'mathematical',
    	  mode: 'mode',
    	  numoctaves: 'numOctaves',
    	  offset: 'offset',
    	  opacity: 'opacity',
    	  operator: 'operator',
    	  order: 'order',
    	  orient: 'orient',
    	  orientation: 'orientation',
    	  origin: 'origin',
    	  overflow: 'overflow',
    	  overlineposition: 'overlinePosition',
    	  'overline-position': 'overlinePosition',
    	  overlinethickness: 'overlineThickness',
    	  'overline-thickness': 'overlineThickness',
    	  paintorder: 'paintOrder',
    	  'paint-order': 'paintOrder',
    	  panose1: 'panose1',
    	  'panose-1': 'panose1',
    	  pathlength: 'pathLength',
    	  patterncontentunits: 'patternContentUnits',
    	  patterntransform: 'patternTransform',
    	  patternunits: 'patternUnits',
    	  pointerevents: 'pointerEvents',
    	  'pointer-events': 'pointerEvents',
    	  points: 'points',
    	  pointsatx: 'pointsAtX',
    	  pointsaty: 'pointsAtY',
    	  pointsatz: 'pointsAtZ',
    	  prefix: 'prefix',
    	  preservealpha: 'preserveAlpha',
    	  preserveaspectratio: 'preserveAspectRatio',
    	  primitiveunits: 'primitiveUnits',
    	  property: 'property',
    	  r: 'r',
    	  radius: 'radius',
    	  refx: 'refX',
    	  refy: 'refY',
    	  renderingintent: 'renderingIntent',
    	  'rendering-intent': 'renderingIntent',
    	  repeatcount: 'repeatCount',
    	  repeatdur: 'repeatDur',
    	  requiredextensions: 'requiredExtensions',
    	  requiredfeatures: 'requiredFeatures',
    	  resource: 'resource',
    	  restart: 'restart',
    	  result: 'result',
    	  results: 'results',
    	  rotate: 'rotate',
    	  rx: 'rx',
    	  ry: 'ry',
    	  scale: 'scale',
    	  security: 'security',
    	  seed: 'seed',
    	  shaperendering: 'shapeRendering',
    	  'shape-rendering': 'shapeRendering',
    	  slope: 'slope',
    	  spacing: 'spacing',
    	  specularconstant: 'specularConstant',
    	  specularexponent: 'specularExponent',
    	  speed: 'speed',
    	  spreadmethod: 'spreadMethod',
    	  startoffset: 'startOffset',
    	  stddeviation: 'stdDeviation',
    	  stemh: 'stemh',
    	  stemv: 'stemv',
    	  stitchtiles: 'stitchTiles',
    	  stopcolor: 'stopColor',
    	  'stop-color': 'stopColor',
    	  stopopacity: 'stopOpacity',
    	  'stop-opacity': 'stopOpacity',
    	  strikethroughposition: 'strikethroughPosition',
    	  'strikethrough-position': 'strikethroughPosition',
    	  strikethroughthickness: 'strikethroughThickness',
    	  'strikethrough-thickness': 'strikethroughThickness',
    	  string: 'string',
    	  stroke: 'stroke',
    	  strokedasharray: 'strokeDasharray',
    	  'stroke-dasharray': 'strokeDasharray',
    	  strokedashoffset: 'strokeDashoffset',
    	  'stroke-dashoffset': 'strokeDashoffset',
    	  strokelinecap: 'strokeLinecap',
    	  'stroke-linecap': 'strokeLinecap',
    	  strokelinejoin: 'strokeLinejoin',
    	  'stroke-linejoin': 'strokeLinejoin',
    	  strokemiterlimit: 'strokeMiterlimit',
    	  'stroke-miterlimit': 'strokeMiterlimit',
    	  strokewidth: 'strokeWidth',
    	  'stroke-width': 'strokeWidth',
    	  strokeopacity: 'strokeOpacity',
    	  'stroke-opacity': 'strokeOpacity',
    	  suppresscontenteditablewarning: 'suppressContentEditableWarning',
    	  suppresshydrationwarning: 'suppressHydrationWarning',
    	  surfacescale: 'surfaceScale',
    	  systemlanguage: 'systemLanguage',
    	  tablevalues: 'tableValues',
    	  targetx: 'targetX',
    	  targety: 'targetY',
    	  textanchor: 'textAnchor',
    	  'text-anchor': 'textAnchor',
    	  textdecoration: 'textDecoration',
    	  'text-decoration': 'textDecoration',
    	  textlength: 'textLength',
    	  textrendering: 'textRendering',
    	  'text-rendering': 'textRendering',
    	  to: 'to',
    	  transform: 'transform',
    	  typeof: 'typeof',
    	  u1: 'u1',
    	  u2: 'u2',
    	  underlineposition: 'underlinePosition',
    	  'underline-position': 'underlinePosition',
    	  underlinethickness: 'underlineThickness',
    	  'underline-thickness': 'underlineThickness',
    	  unicode: 'unicode',
    	  unicodebidi: 'unicodeBidi',
    	  'unicode-bidi': 'unicodeBidi',
    	  unicoderange: 'unicodeRange',
    	  'unicode-range': 'unicodeRange',
    	  unitsperem: 'unitsPerEm',
    	  'units-per-em': 'unitsPerEm',
    	  unselectable: 'unselectable',
    	  valphabetic: 'vAlphabetic',
    	  'v-alphabetic': 'vAlphabetic',
    	  values: 'values',
    	  vectoreffect: 'vectorEffect',
    	  'vector-effect': 'vectorEffect',
    	  version: 'version',
    	  vertadvy: 'vertAdvY',
    	  'vert-adv-y': 'vertAdvY',
    	  vertoriginx: 'vertOriginX',
    	  'vert-origin-x': 'vertOriginX',
    	  vertoriginy: 'vertOriginY',
    	  'vert-origin-y': 'vertOriginY',
    	  vhanging: 'vHanging',
    	  'v-hanging': 'vHanging',
    	  videographic: 'vIdeographic',
    	  'v-ideographic': 'vIdeographic',
    	  viewbox: 'viewBox',
    	  viewtarget: 'viewTarget',
    	  visibility: 'visibility',
    	  vmathematical: 'vMathematical',
    	  'v-mathematical': 'vMathematical',
    	  vocab: 'vocab',
    	  widths: 'widths',
    	  wordspacing: 'wordSpacing',
    	  'word-spacing': 'wordSpacing',
    	  writingmode: 'writingMode',
    	  'writing-mode': 'writingMode',
    	  x1: 'x1',
    	  x2: 'x2',
    	  x: 'x',
    	  xchannelselector: 'xChannelSelector',
    	  xheight: 'xHeight',
    	  'x-height': 'xHeight',
    	  xlinkactuate: 'xlinkActuate',
    	  'xlink:actuate': 'xlinkActuate',
    	  xlinkarcrole: 'xlinkArcrole',
    	  'xlink:arcrole': 'xlinkArcrole',
    	  xlinkhref: 'xlinkHref',
    	  'xlink:href': 'xlinkHref',
    	  xlinkrole: 'xlinkRole',
    	  'xlink:role': 'xlinkRole',
    	  xlinkshow: 'xlinkShow',
    	  'xlink:show': 'xlinkShow',
    	  xlinktitle: 'xlinkTitle',
    	  'xlink:title': 'xlinkTitle',
    	  xlinktype: 'xlinkType',
    	  'xlink:type': 'xlinkType',
    	  xmlbase: 'xmlBase',
    	  'xml:base': 'xmlBase',
    	  xmllang: 'xmlLang',
    	  'xml:lang': 'xmlLang',
    	  xmlns: 'xmlns',
    	  'xml:space': 'xmlSpace',
    	  xmlnsxlink: 'xmlnsXlink',
    	  'xmlns:xlink': 'xmlnsXlink',
    	  xmlspace: 'xmlSpace',
    	  y1: 'y1',
    	  y2: 'y2',
    	  y: 'y',
    	  ychannelselector: 'yChannelSelector',
    	  z: 'z',
    	  zoomandpan: 'zoomAndPan'
    	};

    	var ariaProperties = {
    	  'aria-current': 0,
    	  // state
    	  'aria-details': 0,
    	  'aria-disabled': 0,
    	  // state
    	  'aria-hidden': 0,
    	  // state
    	  'aria-invalid': 0,
    	  // state
    	  'aria-keyshortcuts': 0,
    	  'aria-label': 0,
    	  'aria-roledescription': 0,
    	  // Widget Attributes
    	  'aria-autocomplete': 0,
    	  'aria-checked': 0,
    	  'aria-expanded': 0,
    	  'aria-haspopup': 0,
    	  'aria-level': 0,
    	  'aria-modal': 0,
    	  'aria-multiline': 0,
    	  'aria-multiselectable': 0,
    	  'aria-orientation': 0,
    	  'aria-placeholder': 0,
    	  'aria-pressed': 0,
    	  'aria-readonly': 0,
    	  'aria-required': 0,
    	  'aria-selected': 0,
    	  'aria-sort': 0,
    	  'aria-valuemax': 0,
    	  'aria-valuemin': 0,
    	  'aria-valuenow': 0,
    	  'aria-valuetext': 0,
    	  // Live Region Attributes
    	  'aria-atomic': 0,
    	  'aria-busy': 0,
    	  'aria-live': 0,
    	  'aria-relevant': 0,
    	  // Drag-and-Drop Attributes
    	  'aria-dropeffect': 0,
    	  'aria-grabbed': 0,
    	  // Relationship Attributes
    	  'aria-activedescendant': 0,
    	  'aria-colcount': 0,
    	  'aria-colindex': 0,
    	  'aria-colspan': 0,
    	  'aria-controls': 0,
    	  'aria-describedby': 0,
    	  'aria-errormessage': 0,
    	  'aria-flowto': 0,
    	  'aria-labelledby': 0,
    	  'aria-owns': 0,
    	  'aria-posinset': 0,
    	  'aria-rowcount': 0,
    	  'aria-rowindex': 0,
    	  'aria-rowspan': 0,
    	  'aria-setsize': 0
    	};

    	var warnedProperties = {};
    	var rARIA = new RegExp('^(aria)-[' + ATTRIBUTE_NAME_CHAR + ']*$');
    	var rARIACamel = new RegExp('^(aria)[A-Z][' + ATTRIBUTE_NAME_CHAR + ']*$');
    	var hasOwnProperty$1 = Object.prototype.hasOwnProperty;

    	function validateProperty(tagName, name) {
    	  {
    	    if (hasOwnProperty$1.call(warnedProperties, name) && warnedProperties[name]) {
    	      return true;
    	    }

    	    if (rARIACamel.test(name)) {
    	      var ariaName = 'aria-' + name.slice(4).toLowerCase();
    	      var correctName = ariaProperties.hasOwnProperty(ariaName) ? ariaName : null; // If this is an aria-* attribute, but is not listed in the known DOM
    	      // DOM properties, then it is an invalid aria-* attribute.

    	      if (correctName == null) {
    	        error('Invalid ARIA attribute `%s`. ARIA attributes follow the pattern aria-* and must be lowercase.', name);

    	        warnedProperties[name] = true;
    	        return true;
    	      } // aria-* attributes should be lowercase; suggest the lowercase version.


    	      if (name !== correctName) {
    	        error('Invalid ARIA attribute `%s`. Did you mean `%s`?', name, correctName);

    	        warnedProperties[name] = true;
    	        return true;
    	      }
    	    }

    	    if (rARIA.test(name)) {
    	      var lowerCasedName = name.toLowerCase();
    	      var standardName = ariaProperties.hasOwnProperty(lowerCasedName) ? lowerCasedName : null; // If this is an aria-* attribute, but is not listed in the known DOM
    	      // DOM properties, then it is an invalid aria-* attribute.

    	      if (standardName == null) {
    	        warnedProperties[name] = true;
    	        return false;
    	      } // aria-* attributes should be lowercase; suggest the lowercase version.


    	      if (name !== standardName) {
    	        error('Unknown ARIA attribute `%s`. Did you mean `%s`?', name, standardName);

    	        warnedProperties[name] = true;
    	        return true;
    	      }
    	    }
    	  }

    	  return true;
    	}

    	function warnInvalidARIAProps(type, props) {
    	  {
    	    var invalidProps = [];

    	    for (var key in props) {
    	      var isValid = validateProperty(type, key);

    	      if (!isValid) {
    	        invalidProps.push(key);
    	      }
    	    }

    	    var unknownPropString = invalidProps.map(function (prop) {
    	      return '`' + prop + '`';
    	    }).join(', ');

    	    if (invalidProps.length === 1) {
    	      error('Invalid aria prop %s on <%s> tag. ' + 'For details, see https://reactjs.org/link/invalid-aria-props', unknownPropString, type);
    	    } else if (invalidProps.length > 1) {
    	      error('Invalid aria props %s on <%s> tag. ' + 'For details, see https://reactjs.org/link/invalid-aria-props', unknownPropString, type);
    	    }
    	  }
    	}

    	function validateProperties(type, props) {
    	  if (isCustomComponent(type, props)) {
    	    return;
    	  }

    	  warnInvalidARIAProps(type, props);
    	}

    	var didWarnValueNull = false;
    	function validateProperties$1(type, props) {
    	  {
    	    if (type !== 'input' && type !== 'textarea' && type !== 'select') {
    	      return;
    	    }

    	    if (props != null && props.value === null && !didWarnValueNull) {
    	      didWarnValueNull = true;

    	      if (type === 'select' && props.multiple) {
    	        error('`value` prop on `%s` should not be null. ' + 'Consider using an empty array when `multiple` is set to `true` ' + 'to clear the component or `undefined` for uncontrolled components.', type);
    	      } else {
    	        error('`value` prop on `%s` should not be null. ' + 'Consider using an empty string to clear the component or `undefined` ' + 'for uncontrolled components.', type);
    	      }
    	    }
    	  }
    	}

    	var validateProperty$1 = function () {};

    	{
    	  var warnedProperties$1 = {};
    	  var _hasOwnProperty = Object.prototype.hasOwnProperty;
    	  var EVENT_NAME_REGEX = /^on./;
    	  var INVALID_EVENT_NAME_REGEX = /^on[^A-Z]/;
    	  var rARIA$1 = new RegExp('^(aria)-[' + ATTRIBUTE_NAME_CHAR + ']*$');
    	  var rARIACamel$1 = new RegExp('^(aria)[A-Z][' + ATTRIBUTE_NAME_CHAR + ']*$');

    	  validateProperty$1 = function (tagName, name, value, eventRegistry) {
    	    if (_hasOwnProperty.call(warnedProperties$1, name) && warnedProperties$1[name]) {
    	      return true;
    	    }

    	    var lowerCasedName = name.toLowerCase();

    	    if (lowerCasedName === 'onfocusin' || lowerCasedName === 'onfocusout') {
    	      error('React uses onFocus and onBlur instead of onFocusIn and onFocusOut. ' + 'All React events are normalized to bubble, so onFocusIn and onFocusOut ' + 'are not needed/supported by React.');

    	      warnedProperties$1[name] = true;
    	      return true;
    	    } // We can't rely on the event system being injected on the server.


    	    if (eventRegistry != null) {
    	      var registrationNameDependencies = eventRegistry.registrationNameDependencies,
    	          possibleRegistrationNames = eventRegistry.possibleRegistrationNames;

    	      if (registrationNameDependencies.hasOwnProperty(name)) {
    	        return true;
    	      }

    	      var registrationName = possibleRegistrationNames.hasOwnProperty(lowerCasedName) ? possibleRegistrationNames[lowerCasedName] : null;

    	      if (registrationName != null) {
    	        error('Invalid event handler property `%s`. Did you mean `%s`?', name, registrationName);

    	        warnedProperties$1[name] = true;
    	        return true;
    	      }

    	      if (EVENT_NAME_REGEX.test(name)) {
    	        error('Unknown event handler property `%s`. It will be ignored.', name);

    	        warnedProperties$1[name] = true;
    	        return true;
    	      }
    	    } else if (EVENT_NAME_REGEX.test(name)) {
    	      // If no event plugins have been injected, we are in a server environment.
    	      // So we can't tell if the event name is correct for sure, but we can filter
    	      // out known bad ones like `onclick`. We can't suggest a specific replacement though.
    	      if (INVALID_EVENT_NAME_REGEX.test(name)) {
    	        error('Invalid event handler property `%s`. ' + 'React events use the camelCase naming convention, for example `onClick`.', name);
    	      }

    	      warnedProperties$1[name] = true;
    	      return true;
    	    } // Let the ARIA attribute hook validate ARIA attributes


    	    if (rARIA$1.test(name) || rARIACamel$1.test(name)) {
    	      return true;
    	    }

    	    if (lowerCasedName === 'innerhtml') {
    	      error('Directly setting property `innerHTML` is not permitted. ' + 'For more information, lookup documentation on `dangerouslySetInnerHTML`.');

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    if (lowerCasedName === 'aria') {
    	      error('The `aria` attribute is reserved for future use in React. ' + 'Pass individual `aria-` attributes instead.');

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    if (lowerCasedName === 'is' && value !== null && value !== undefined && typeof value !== 'string') {
    	      error('Received a `%s` for a string attribute `is`. If this is expected, cast ' + 'the value to a string.', typeof value);

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    if (typeof value === 'number' && isNaN(value)) {
    	      error('Received NaN for the `%s` attribute. If this is expected, cast ' + 'the value to a string.', name);

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    var propertyInfo = getPropertyInfo(name);
    	    var isReserved = propertyInfo !== null && propertyInfo.type === RESERVED; // Known attributes should match the casing specified in the property config.

    	    if (possibleStandardNames.hasOwnProperty(lowerCasedName)) {
    	      var standardName = possibleStandardNames[lowerCasedName];

    	      if (standardName !== name) {
    	        error('Invalid DOM property `%s`. Did you mean `%s`?', name, standardName);

    	        warnedProperties$1[name] = true;
    	        return true;
    	      }
    	    } else if (!isReserved && name !== lowerCasedName) {
    	      // Unknown attributes should have lowercase casing since that's how they
    	      // will be cased anyway with server rendering.
    	      error('React does not recognize the `%s` prop on a DOM element. If you ' + 'intentionally want it to appear in the DOM as a custom ' + 'attribute, spell it as lowercase `%s` instead. ' + 'If you accidentally passed it from a parent component, remove ' + 'it from the DOM element.', name, lowerCasedName);

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    if (typeof value === 'boolean' && shouldRemoveAttributeWithWarning(name, value, propertyInfo, false)) {
    	      if (value) {
    	        error('Received `%s` for a non-boolean attribute `%s`.\n\n' + 'If you want to write it to the DOM, pass a string instead: ' + '%s="%s" or %s={value.toString()}.', value, name, name, value, name);
    	      } else {
    	        error('Received `%s` for a non-boolean attribute `%s`.\n\n' + 'If you want to write it to the DOM, pass a string instead: ' + '%s="%s" or %s={value.toString()}.\n\n' + 'If you used to conditionally omit it with %s={condition && value}, ' + 'pass %s={condition ? value : undefined} instead.', value, name, name, value, name, name, name);
    	      }

    	      warnedProperties$1[name] = true;
    	      return true;
    	    } // Now that we've validated casing, do not validate
    	    // data types for reserved props


    	    if (isReserved) {
    	      return true;
    	    } // Warn when a known attribute is a bad type


    	    if (shouldRemoveAttributeWithWarning(name, value, propertyInfo, false)) {
    	      warnedProperties$1[name] = true;
    	      return false;
    	    } // Warn when passing the strings 'false' or 'true' into a boolean prop


    	    if ((value === 'false' || value === 'true') && propertyInfo !== null && propertyInfo.type === BOOLEAN) {
    	      error('Received the string `%s` for the boolean attribute `%s`. ' + '%s ' + 'Did you mean %s={%s}?', value, name, value === 'false' ? 'The browser will interpret it as a truthy value.' : 'Although this works, it will not work as expected if you pass the string "false".', name, value);

    	      warnedProperties$1[name] = true;
    	      return true;
    	    }

    	    return true;
    	  };
    	}

    	var warnUnknownProperties = function (type, props, eventRegistry) {
    	  {
    	    var unknownProps = [];

    	    for (var key in props) {
    	      var isValid = validateProperty$1(type, key, props[key], eventRegistry);

    	      if (!isValid) {
    	        unknownProps.push(key);
    	      }
    	    }

    	    var unknownPropString = unknownProps.map(function (prop) {
    	      return '`' + prop + '`';
    	    }).join(', ');

    	    if (unknownProps.length === 1) {
    	      error('Invalid value for prop %s on <%s> tag. Either remove it from the element, ' + 'or pass a string or number value to keep it in the DOM. ' + 'For details, see https://reactjs.org/link/attribute-behavior ', unknownPropString, type);
    	    } else if (unknownProps.length > 1) {
    	      error('Invalid values for props %s on <%s> tag. Either remove them from the element, ' + 'or pass a string or number value to keep them in the DOM. ' + 'For details, see https://reactjs.org/link/attribute-behavior ', unknownPropString, type);
    	    }
    	  }
    	};

    	function validateProperties$2(type, props, eventRegistry) {
    	  if (isCustomComponent(type, props)) {
    	    return;
    	  }

    	  warnUnknownProperties(type, props, eventRegistry);
    	}

    	var IS_EVENT_HANDLE_NON_MANAGED_NODE = 1;
    	var IS_NON_DELEGATED = 1 << 1;
    	var IS_CAPTURE_PHASE = 1 << 2;
    	var IS_REPLAYED = 1 << 4;
    	// set to LEGACY_FB_SUPPORT. LEGACY_FB_SUPPORT only gets set when
    	// we call willDeferLaterForLegacyFBSupport, thus not bailing out
    	// will result in endless cycles like an infinite loop.
    	// We also don't want to defer during event replaying.

    	var SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS = IS_EVENT_HANDLE_NON_MANAGED_NODE | IS_NON_DELEGATED | IS_CAPTURE_PHASE;

    	/**
    	 * Gets the target node from a native browser event by accounting for
    	 * inconsistencies in browser DOM APIs.
    	 *
    	 * @param {object} nativeEvent Native browser event.
    	 * @return {DOMEventTarget} Target node.
    	 */

    	function getEventTarget(nativeEvent) {
    	  // Fallback to nativeEvent.srcElement for IE9
    	  // https://github.com/facebook/react/issues/12506
    	  var target = nativeEvent.target || nativeEvent.srcElement || window; // Normalize SVG <use> element events #4963

    	  if (target.correspondingUseElement) {
    	    target = target.correspondingUseElement;
    	  } // Safari may fire events on text nodes (Node.TEXT_NODE is 3).
    	  // @see http://www.quirksmode.org/js/events_properties.html


    	  return target.nodeType === TEXT_NODE ? target.parentNode : target;
    	}

    	var restoreImpl = null;
    	var restoreTarget = null;
    	var restoreQueue = null;

    	function restoreStateOfTarget(target) {
    	  // We perform this translation at the end of the event loop so that we
    	  // always receive the correct fiber here
    	  var internalInstance = getInstanceFromNode(target);

    	  if (!internalInstance) {
    	    // Unmounted
    	    return;
    	  }

    	  if (!(typeof restoreImpl === 'function')) {
    	    {
    	      throw Error( "setRestoreImplementation() needs to be called to handle a target for controlled events. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }

    	  var stateNode = internalInstance.stateNode; // Guard against Fiber being unmounted.

    	  if (stateNode) {
    	    var _props = getFiberCurrentPropsFromNode(stateNode);

    	    restoreImpl(internalInstance.stateNode, internalInstance.type, _props);
    	  }
    	}

    	function setRestoreImplementation(impl) {
    	  restoreImpl = impl;
    	}
    	function enqueueStateRestore(target) {
    	  if (restoreTarget) {
    	    if (restoreQueue) {
    	      restoreQueue.push(target);
    	    } else {
    	      restoreQueue = [target];
    	    }
    	  } else {
    	    restoreTarget = target;
    	  }
    	}
    	function needsStateRestore() {
    	  return restoreTarget !== null || restoreQueue !== null;
    	}
    	function restoreStateIfNeeded() {
    	  if (!restoreTarget) {
    	    return;
    	  }

    	  var target = restoreTarget;
    	  var queuedTargets = restoreQueue;
    	  restoreTarget = null;
    	  restoreQueue = null;
    	  restoreStateOfTarget(target);

    	  if (queuedTargets) {
    	    for (var i = 0; i < queuedTargets.length; i++) {
    	      restoreStateOfTarget(queuedTargets[i]);
    	    }
    	  }
    	}

    	// the renderer. Such as when we're dispatching events or if third party
    	// libraries need to call batchedUpdates. Eventually, this API will go away when
    	// everything is batched by default. We'll then have a similar API to opt-out of
    	// scheduled work and instead do synchronous work.
    	// Defaults

    	var batchedUpdatesImpl = function (fn, bookkeeping) {
    	  return fn(bookkeeping);
    	};

    	var discreteUpdatesImpl = function (fn, a, b, c, d) {
    	  return fn(a, b, c, d);
    	};

    	var flushDiscreteUpdatesImpl = function () {};

    	var batchedEventUpdatesImpl = batchedUpdatesImpl;
    	var isInsideEventHandler = false;
    	var isBatchingEventUpdates = false;

    	function finishEventHandler() {
    	  // Here we wait until all updates have propagated, which is important
    	  // when using controlled components within layers:
    	  // https://github.com/facebook/react/issues/1698
    	  // Then we restore state of any controlled component.
    	  var controlledComponentsHavePendingUpdates = needsStateRestore();

    	  if (controlledComponentsHavePendingUpdates) {
    	    // If a controlled event was fired, we may need to restore the state of
    	    // the DOM node back to the controlled value. This is necessary when React
    	    // bails out of the update without touching the DOM.
    	    flushDiscreteUpdatesImpl();
    	    restoreStateIfNeeded();
    	  }
    	}

    	function batchedUpdates(fn, bookkeeping) {
    	  if (isInsideEventHandler) {
    	    // If we are currently inside another batch, we need to wait until it
    	    // fully completes before restoring state.
    	    return fn(bookkeeping);
    	  }

    	  isInsideEventHandler = true;

    	  try {
    	    return batchedUpdatesImpl(fn, bookkeeping);
    	  } finally {
    	    isInsideEventHandler = false;
    	    finishEventHandler();
    	  }
    	}
    	function batchedEventUpdates(fn, a, b) {
    	  if (isBatchingEventUpdates) {
    	    // If we are currently inside another batch, we need to wait until it
    	    // fully completes before restoring state.
    	    return fn(a, b);
    	  }

    	  isBatchingEventUpdates = true;

    	  try {
    	    return batchedEventUpdatesImpl(fn, a, b);
    	  } finally {
    	    isBatchingEventUpdates = false;
    	    finishEventHandler();
    	  }
    	}
    	function discreteUpdates(fn, a, b, c, d) {
    	  var prevIsInsideEventHandler = isInsideEventHandler;
    	  isInsideEventHandler = true;

    	  try {
    	    return discreteUpdatesImpl(fn, a, b, c, d);
    	  } finally {
    	    isInsideEventHandler = prevIsInsideEventHandler;

    	    if (!isInsideEventHandler) {
    	      finishEventHandler();
    	    }
    	  }
    	}
    	function flushDiscreteUpdatesIfNeeded(timeStamp) {
    	  {
    	    if (!isInsideEventHandler) {
    	      flushDiscreteUpdatesImpl();
    	    }
    	  }
    	}
    	function setBatchingImplementation(_batchedUpdatesImpl, _discreteUpdatesImpl, _flushDiscreteUpdatesImpl, _batchedEventUpdatesImpl) {
    	  batchedUpdatesImpl = _batchedUpdatesImpl;
    	  discreteUpdatesImpl = _discreteUpdatesImpl;
    	  flushDiscreteUpdatesImpl = _flushDiscreteUpdatesImpl;
    	  batchedEventUpdatesImpl = _batchedEventUpdatesImpl;
    	}

    	function isInteractive(tag) {
    	  return tag === 'button' || tag === 'input' || tag === 'select' || tag === 'textarea';
    	}

    	function shouldPreventMouseEvent(name, type, props) {
    	  switch (name) {
    	    case 'onClick':
    	    case 'onClickCapture':
    	    case 'onDoubleClick':
    	    case 'onDoubleClickCapture':
    	    case 'onMouseDown':
    	    case 'onMouseDownCapture':
    	    case 'onMouseMove':
    	    case 'onMouseMoveCapture':
    	    case 'onMouseUp':
    	    case 'onMouseUpCapture':
    	    case 'onMouseEnter':
    	      return !!(props.disabled && isInteractive(type));

    	    default:
    	      return false;
    	  }
    	}
    	/**
    	 * @param {object} inst The instance, which is the source of events.
    	 * @param {string} registrationName Name of listener (e.g. `onClick`).
    	 * @return {?function} The stored callback.
    	 */


    	function getListener(inst, registrationName) {
    	  var stateNode = inst.stateNode;

    	  if (stateNode === null) {
    	    // Work in progress (ex: onload events in incremental mode).
    	    return null;
    	  }

    	  var props = getFiberCurrentPropsFromNode(stateNode);

    	  if (props === null) {
    	    // Work in progress.
    	    return null;
    	  }

    	  var listener = props[registrationName];

    	  if (shouldPreventMouseEvent(registrationName, inst.type, props)) {
    	    return null;
    	  }

    	  if (!(!listener || typeof listener === 'function')) {
    	    {
    	      throw Error( "Expected `" + registrationName + "` listener to be a function, instead got a value of `" + typeof listener + "` type." );
    	    }
    	  }

    	  return listener;
    	}

    	var passiveBrowserEventsSupported = false; // Check if browser support events with passive listeners
    	// https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/addEventListener#Safely_detecting_option_support

    	if (canUseDOM) {
    	  try {
    	    var options = {}; // $FlowFixMe: Ignore Flow complaining about needing a value

    	    Object.defineProperty(options, 'passive', {
    	      get: function () {
    	        passiveBrowserEventsSupported = true;
    	      }
    	    });
    	    window.addEventListener('test', options, options);
    	    window.removeEventListener('test', options, options);
    	  } catch (e) {
    	    passiveBrowserEventsSupported = false;
    	  }
    	}

    	function invokeGuardedCallbackProd(name, func, context, a, b, c, d, e, f) {
    	  var funcArgs = Array.prototype.slice.call(arguments, 3);

    	  try {
    	    func.apply(context, funcArgs);
    	  } catch (error) {
    	    this.onError(error);
    	  }
    	}

    	var invokeGuardedCallbackImpl = invokeGuardedCallbackProd;

    	{
    	  // In DEV mode, we swap out invokeGuardedCallback for a special version
    	  // that plays more nicely with the browser's DevTools. The idea is to preserve
    	  // "Pause on exceptions" behavior. Because React wraps all user-provided
    	  // functions in invokeGuardedCallback, and the production version of
    	  // invokeGuardedCallback uses a try-catch, all user exceptions are treated
    	  // like caught exceptions, and the DevTools won't pause unless the developer
    	  // takes the extra step of enabling pause on caught exceptions. This is
    	  // unintuitive, though, because even though React has caught the error, from
    	  // the developer's perspective, the error is uncaught.
    	  //
    	  // To preserve the expected "Pause on exceptions" behavior, we don't use a
    	  // try-catch in DEV. Instead, we synchronously dispatch a fake event to a fake
    	  // DOM node, and call the user-provided callback from inside an event handler
    	  // for that fake event. If the callback throws, the error is "captured" using
    	  // a global event handler. But because the error happens in a different
    	  // event loop context, it does not interrupt the normal program flow.
    	  // Effectively, this gives us try-catch behavior without actually using
    	  // try-catch. Neat!
    	  // Check that the browser supports the APIs we need to implement our special
    	  // DEV version of invokeGuardedCallback
    	  if (typeof window !== 'undefined' && typeof window.dispatchEvent === 'function' && typeof document !== 'undefined' && typeof document.createEvent === 'function') {
    	    var fakeNode = document.createElement('react');

    	    invokeGuardedCallbackImpl = function invokeGuardedCallbackDev(name, func, context, a, b, c, d, e, f) {
    	      // If document doesn't exist we know for sure we will crash in this method
    	      // when we call document.createEvent(). However this can cause confusing
    	      // errors: https://github.com/facebookincubator/create-react-app/issues/3482
    	      // So we preemptively throw with a better message instead.
    	      if (!(typeof document !== 'undefined')) {
    	        {
    	          throw Error( "The `document` global was defined when React was initialized, but is not defined anymore. This can happen in a test environment if a component schedules an update from an asynchronous callback, but the test has already finished running. To solve this, you can either unmount the component at the end of your test (and ensure that any asynchronous operations get canceled in `componentWillUnmount`), or you can change the test itself to be asynchronous." );
    	        }
    	      }

    	      var evt = document.createEvent('Event');
    	      var didCall = false; // Keeps track of whether the user-provided callback threw an error. We
    	      // set this to true at the beginning, then set it to false right after
    	      // calling the function. If the function errors, `didError` will never be
    	      // set to false. This strategy works even if the browser is flaky and
    	      // fails to call our global error handler, because it doesn't rely on
    	      // the error event at all.

    	      var didError = true; // Keeps track of the value of window.event so that we can reset it
    	      // during the callback to let user code access window.event in the
    	      // browsers that support it.

    	      var windowEvent = window.event; // Keeps track of the descriptor of window.event to restore it after event
    	      // dispatching: https://github.com/facebook/react/issues/13688

    	      var windowEventDescriptor = Object.getOwnPropertyDescriptor(window, 'event');

    	      function restoreAfterDispatch() {
    	        // We immediately remove the callback from event listeners so that
    	        // nested `invokeGuardedCallback` calls do not clash. Otherwise, a
    	        // nested call would trigger the fake event handlers of any call higher
    	        // in the stack.
    	        fakeNode.removeEventListener(evtType, callCallback, false); // We check for window.hasOwnProperty('event') to prevent the
    	        // window.event assignment in both IE <= 10 as they throw an error
    	        // "Member not found" in strict mode, and in Firefox which does not
    	        // support window.event.

    	        if (typeof window.event !== 'undefined' && window.hasOwnProperty('event')) {
    	          window.event = windowEvent;
    	        }
    	      } // Create an event handler for our fake event. We will synchronously
    	      // dispatch our fake event using `dispatchEvent`. Inside the handler, we
    	      // call the user-provided callback.


    	      var funcArgs = Array.prototype.slice.call(arguments, 3);

    	      function callCallback() {
    	        didCall = true;
    	        restoreAfterDispatch();
    	        func.apply(context, funcArgs);
    	        didError = false;
    	      } // Create a global error event handler. We use this to capture the value
    	      // that was thrown. It's possible that this error handler will fire more
    	      // than once; for example, if non-React code also calls `dispatchEvent`
    	      // and a handler for that event throws. We should be resilient to most of
    	      // those cases. Even if our error event handler fires more than once, the
    	      // last error event is always used. If the callback actually does error,
    	      // we know that the last error event is the correct one, because it's not
    	      // possible for anything else to have happened in between our callback
    	      // erroring and the code that follows the `dispatchEvent` call below. If
    	      // the callback doesn't error, but the error event was fired, we know to
    	      // ignore it because `didError` will be false, as described above.


    	      var error; // Use this to track whether the error event is ever called.

    	      var didSetError = false;
    	      var isCrossOriginError = false;

    	      function handleWindowError(event) {
    	        error = event.error;
    	        didSetError = true;

    	        if (error === null && event.colno === 0 && event.lineno === 0) {
    	          isCrossOriginError = true;
    	        }

    	        if (event.defaultPrevented) {
    	          // Some other error handler has prevented default.
    	          // Browsers silence the error report if this happens.
    	          // We'll remember this to later decide whether to log it or not.
    	          if (error != null && typeof error === 'object') {
    	            try {
    	              error._suppressLogging = true;
    	            } catch (inner) {// Ignore.
    	            }
    	          }
    	        }
    	      } // Create a fake event type.


    	      var evtType = "react-" + (name ? name : 'invokeguardedcallback'); // Attach our event handlers

    	      window.addEventListener('error', handleWindowError);
    	      fakeNode.addEventListener(evtType, callCallback, false); // Synchronously dispatch our fake event. If the user-provided function
    	      // errors, it will trigger our global error handler.

    	      evt.initEvent(evtType, false, false);
    	      fakeNode.dispatchEvent(evt);

    	      if (windowEventDescriptor) {
    	        Object.defineProperty(window, 'event', windowEventDescriptor);
    	      }

    	      if (didCall && didError) {
    	        if (!didSetError) {
    	          // The callback errored, but the error event never fired.
    	          error = new Error('An error was thrown inside one of your components, but React ' + "doesn't know what it was. This is likely due to browser " + 'flakiness. React does its best to preserve the "Pause on ' + 'exceptions" behavior of the DevTools, which requires some ' + "DEV-mode only tricks. It's possible that these don't work in " + 'your browser. Try triggering the error in production mode, ' + 'or switching to a modern browser. If you suspect that this is ' + 'actually an issue with React, please file an issue.');
    	        } else if (isCrossOriginError) {
    	          error = new Error("A cross-origin error was thrown. React doesn't have access to " + 'the actual error object in development. ' + 'See https://reactjs.org/link/crossorigin-error for more information.');
    	        }

    	        this.onError(error);
    	      } // Remove our event listeners


    	      window.removeEventListener('error', handleWindowError);

    	      if (!didCall) {
    	        // Something went really wrong, and our event was not dispatched.
    	        // https://github.com/facebook/react/issues/16734
    	        // https://github.com/facebook/react/issues/16585
    	        // Fall back to the production implementation.
    	        restoreAfterDispatch();
    	        return invokeGuardedCallbackProd.apply(this, arguments);
    	      }
    	    };
    	  }
    	}

    	var invokeGuardedCallbackImpl$1 = invokeGuardedCallbackImpl;

    	var hasError = false;
    	var caughtError = null; // Used by event system to capture/rethrow the first error.

    	var hasRethrowError = false;
    	var rethrowError = null;
    	var reporter = {
    	  onError: function (error) {
    	    hasError = true;
    	    caughtError = error;
    	  }
    	};
    	/**
    	 * Call a function while guarding against errors that happens within it.
    	 * Returns an error if it throws, otherwise null.
    	 *
    	 * In production, this is implemented using a try-catch. The reason we don't
    	 * use a try-catch directly is so that we can swap out a different
    	 * implementation in DEV mode.
    	 *
    	 * @param {String} name of the guard to use for logging or debugging
    	 * @param {Function} func The function to invoke
    	 * @param {*} context The context to use when calling the function
    	 * @param {...*} args Arguments for function
    	 */

    	function invokeGuardedCallback(name, func, context, a, b, c, d, e, f) {
    	  hasError = false;
    	  caughtError = null;
    	  invokeGuardedCallbackImpl$1.apply(reporter, arguments);
    	}
    	/**
    	 * Same as invokeGuardedCallback, but instead of returning an error, it stores
    	 * it in a global so it can be rethrown by `rethrowCaughtError` later.
    	 * TODO: See if caughtError and rethrowError can be unified.
    	 *
    	 * @param {String} name of the guard to use for logging or debugging
    	 * @param {Function} func The function to invoke
    	 * @param {*} context The context to use when calling the function
    	 * @param {...*} args Arguments for function
    	 */

    	function invokeGuardedCallbackAndCatchFirstError(name, func, context, a, b, c, d, e, f) {
    	  invokeGuardedCallback.apply(this, arguments);

    	  if (hasError) {
    	    var error = clearCaughtError();

    	    if (!hasRethrowError) {
    	      hasRethrowError = true;
    	      rethrowError = error;
    	    }
    	  }
    	}
    	/**
    	 * During execution of guarded functions we will capture the first error which
    	 * we will rethrow to be handled by the top level error handler.
    	 */

    	function rethrowCaughtError() {
    	  if (hasRethrowError) {
    	    var error = rethrowError;
    	    hasRethrowError = false;
    	    rethrowError = null;
    	    throw error;
    	  }
    	}
    	function hasCaughtError() {
    	  return hasError;
    	}
    	function clearCaughtError() {
    	  if (hasError) {
    	    var error = caughtError;
    	    hasError = false;
    	    caughtError = null;
    	    return error;
    	  } else {
    	    {
    	      {
    	        throw Error( "clearCaughtError was called but no error was captured. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }
    	  }
    	}

    	/**
    	 * `ReactInstanceMap` maintains a mapping from a public facing stateful
    	 * instance (key) and the internal representation (value). This allows public
    	 * methods to accept the user facing instance as an argument and map them back
    	 * to internal methods.
    	 *
    	 * Note that this module is currently shared and assumed to be stateless.
    	 * If this becomes an actual Map, that will break.
    	 */
    	function get(key) {
    	  return key._reactInternals;
    	}
    	function has(key) {
    	  return key._reactInternals !== undefined;
    	}
    	function set(key, value) {
    	  key._reactInternals = value;
    	}

    	// Don't change these two values. They're used by React Dev Tools.
    	var NoFlags =
    	/*                      */
    	0;
    	var PerformedWork =
    	/*                */
    	1; // You can change the rest (and add more).

    	var Placement =
    	/*                    */
    	2;
    	var Update =
    	/*                       */
    	4;
    	var PlacementAndUpdate =
    	/*           */
    	6;
    	var Deletion =
    	/*                     */
    	8;
    	var ContentReset =
    	/*                 */
    	16;
    	var Callback =
    	/*                     */
    	32;
    	var DidCapture =
    	/*                   */
    	64;
    	var Ref =
    	/*                          */
    	128;
    	var Snapshot =
    	/*                     */
    	256;
    	var Passive =
    	/*                      */
    	512; // TODO (effects) Remove this bit once the new reconciler is synced to the old.

    	var PassiveUnmountPendingDev =
    	/*     */
    	8192;
    	var Hydrating =
    	/*                    */
    	1024;
    	var HydratingAndUpdate =
    	/*           */
    	1028; // Passive & Update & Callback & Ref & Snapshot

    	var LifecycleEffectMask =
    	/*          */
    	932; // Union of all host effects

    	var HostEffectMask =
    	/*               */
    	2047; // These are not really side effects, but we still reuse this field.

    	var Incomplete =
    	/*                   */
    	2048;
    	var ShouldCapture =
    	/*                */
    	4096;
    	var ForceUpdateForLegacySuspense =
    	/* */
    	16384; // Static tags describe aspects of a fiber that are not specific to a render,

    	var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
    	function getNearestMountedFiber(fiber) {
    	  var node = fiber;
    	  var nearestMounted = fiber;

    	  if (!fiber.alternate) {
    	    // If there is no alternate, this might be a new tree that isn't inserted
    	    // yet. If it is, then it will have a pending insertion effect on it.
    	    var nextNode = node;

    	    do {
    	      node = nextNode;

    	      if ((node.flags & (Placement | Hydrating)) !== NoFlags) {
    	        // This is an insertion or in-progress hydration. The nearest possible
    	        // mounted fiber is the parent but we need to continue to figure out
    	        // if that one is still mounted.
    	        nearestMounted = node.return;
    	      }

    	      nextNode = node.return;
    	    } while (nextNode);
    	  } else {
    	    while (node.return) {
    	      node = node.return;
    	    }
    	  }

    	  if (node.tag === HostRoot) {
    	    // TODO: Check if this was a nested HostRoot when used with
    	    // renderContainerIntoSubtree.
    	    return nearestMounted;
    	  } // If we didn't hit the root, that means that we're in an disconnected tree
    	  // that has been unmounted.


    	  return null;
    	}
    	function getSuspenseInstanceFromFiber(fiber) {
    	  if (fiber.tag === SuspenseComponent) {
    	    var suspenseState = fiber.memoizedState;

    	    if (suspenseState === null) {
    	      var current = fiber.alternate;

    	      if (current !== null) {
    	        suspenseState = current.memoizedState;
    	      }
    	    }

    	    if (suspenseState !== null) {
    	      return suspenseState.dehydrated;
    	    }
    	  }

    	  return null;
    	}
    	function getContainerFromFiber(fiber) {
    	  return fiber.tag === HostRoot ? fiber.stateNode.containerInfo : null;
    	}
    	function isFiberMounted(fiber) {
    	  return getNearestMountedFiber(fiber) === fiber;
    	}
    	function isMounted(component) {
    	  {
    	    var owner = ReactCurrentOwner.current;

    	    if (owner !== null && owner.tag === ClassComponent) {
    	      var ownerFiber = owner;
    	      var instance = ownerFiber.stateNode;

    	      if (!instance._warnedAboutRefsInRender) {
    	        error('%s is accessing isMounted inside its render() function. ' + 'render() should be a pure function of props and state. It should ' + 'never access something that requires stale data from the previous ' + 'render, such as refs. Move this logic to componentDidMount and ' + 'componentDidUpdate instead.', getComponentName(ownerFiber.type) || 'A component');
    	      }

    	      instance._warnedAboutRefsInRender = true;
    	    }
    	  }

    	  var fiber = get(component);

    	  if (!fiber) {
    	    return false;
    	  }

    	  return getNearestMountedFiber(fiber) === fiber;
    	}

    	function assertIsMounted(fiber) {
    	  if (!(getNearestMountedFiber(fiber) === fiber)) {
    	    {
    	      throw Error( "Unable to find node on an unmounted component." );
    	    }
    	  }
    	}

    	function findCurrentFiberUsingSlowPath(fiber) {
    	  var alternate = fiber.alternate;

    	  if (!alternate) {
    	    // If there is no alternate, then we only need to check if it is mounted.
    	    var nearestMounted = getNearestMountedFiber(fiber);

    	    if (!(nearestMounted !== null)) {
    	      {
    	        throw Error( "Unable to find node on an unmounted component." );
    	      }
    	    }

    	    if (nearestMounted !== fiber) {
    	      return null;
    	    }

    	    return fiber;
    	  } // If we have two possible branches, we'll walk backwards up to the root
    	  // to see what path the root points to. On the way we may hit one of the
    	  // special cases and we'll deal with them.


    	  var a = fiber;
    	  var b = alternate;

    	  while (true) {
    	    var parentA = a.return;

    	    if (parentA === null) {
    	      // We're at the root.
    	      break;
    	    }

    	    var parentB = parentA.alternate;

    	    if (parentB === null) {
    	      // There is no alternate. This is an unusual case. Currently, it only
    	      // happens when a Suspense component is hidden. An extra fragment fiber
    	      // is inserted in between the Suspense fiber and its children. Skip
    	      // over this extra fragment fiber and proceed to the next parent.
    	      var nextParent = parentA.return;

    	      if (nextParent !== null) {
    	        a = b = nextParent;
    	        continue;
    	      } // If there's no parent, we're at the root.


    	      break;
    	    } // If both copies of the parent fiber point to the same child, we can
    	    // assume that the child is current. This happens when we bailout on low
    	    // priority: the bailed out fiber's child reuses the current child.


    	    if (parentA.child === parentB.child) {
    	      var child = parentA.child;

    	      while (child) {
    	        if (child === a) {
    	          // We've determined that A is the current branch.
    	          assertIsMounted(parentA);
    	          return fiber;
    	        }

    	        if (child === b) {
    	          // We've determined that B is the current branch.
    	          assertIsMounted(parentA);
    	          return alternate;
    	        }

    	        child = child.sibling;
    	      } // We should never have an alternate for any mounting node. So the only
    	      // way this could possibly happen is if this was unmounted, if at all.


    	      {
    	        {
    	          throw Error( "Unable to find node on an unmounted component." );
    	        }
    	      }
    	    }

    	    if (a.return !== b.return) {
    	      // The return pointer of A and the return pointer of B point to different
    	      // fibers. We assume that return pointers never criss-cross, so A must
    	      // belong to the child set of A.return, and B must belong to the child
    	      // set of B.return.
    	      a = parentA;
    	      b = parentB;
    	    } else {
    	      // The return pointers point to the same fiber. We'll have to use the
    	      // default, slow path: scan the child sets of each parent alternate to see
    	      // which child belongs to which set.
    	      //
    	      // Search parent A's child set
    	      var didFindChild = false;
    	      var _child = parentA.child;

    	      while (_child) {
    	        if (_child === a) {
    	          didFindChild = true;
    	          a = parentA;
    	          b = parentB;
    	          break;
    	        }

    	        if (_child === b) {
    	          didFindChild = true;
    	          b = parentA;
    	          a = parentB;
    	          break;
    	        }

    	        _child = _child.sibling;
    	      }

    	      if (!didFindChild) {
    	        // Search parent B's child set
    	        _child = parentB.child;

    	        while (_child) {
    	          if (_child === a) {
    	            didFindChild = true;
    	            a = parentB;
    	            b = parentA;
    	            break;
    	          }

    	          if (_child === b) {
    	            didFindChild = true;
    	            b = parentB;
    	            a = parentA;
    	            break;
    	          }

    	          _child = _child.sibling;
    	        }

    	        if (!didFindChild) {
    	          {
    	            throw Error( "Child was not found in either parent set. This indicates a bug in React related to the return pointer. Please file an issue." );
    	          }
    	        }
    	      }
    	    }

    	    if (!(a.alternate === b)) {
    	      {
    	        throw Error( "Return fibers should always be each others' alternates. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }
    	  } // If the root is not a host container, we're in a disconnected tree. I.e.
    	  // unmounted.


    	  if (!(a.tag === HostRoot)) {
    	    {
    	      throw Error( "Unable to find node on an unmounted component." );
    	    }
    	  }

    	  if (a.stateNode.current === a) {
    	    // We've determined that A is the current branch.
    	    return fiber;
    	  } // Otherwise B has to be current branch.


    	  return alternate;
    	}
    	function findCurrentHostFiber(parent) {
    	  var currentParent = findCurrentFiberUsingSlowPath(parent);

    	  if (!currentParent) {
    	    return null;
    	  } // Next we'll drill down this component to find the first HostComponent/Text.


    	  var node = currentParent;

    	  while (true) {
    	    if (node.tag === HostComponent || node.tag === HostText) {
    	      return node;
    	    } else if (node.child) {
    	      node.child.return = node;
    	      node = node.child;
    	      continue;
    	    }

    	    if (node === currentParent) {
    	      return null;
    	    }

    	    while (!node.sibling) {
    	      if (!node.return || node.return === currentParent) {
    	        return null;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  } // Flow needs the return null here, but ESLint complains about it.
    	  // eslint-disable-next-line no-unreachable


    	  return null;
    	}
    	function findCurrentHostFiberWithNoPortals(parent) {
    	  var currentParent = findCurrentFiberUsingSlowPath(parent);

    	  if (!currentParent) {
    	    return null;
    	  } // Next we'll drill down this component to find the first HostComponent/Text.


    	  var node = currentParent;

    	  while (true) {
    	    if (node.tag === HostComponent || node.tag === HostText || enableFundamentalAPI ) {
    	      return node;
    	    } else if (node.child && node.tag !== HostPortal) {
    	      node.child.return = node;
    	      node = node.child;
    	      continue;
    	    }

    	    if (node === currentParent) {
    	      return null;
    	    }

    	    while (!node.sibling) {
    	      if (!node.return || node.return === currentParent) {
    	        return null;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  } // Flow needs the return null here, but ESLint complains about it.
    	  // eslint-disable-next-line no-unreachable


    	  return null;
    	}
    	function doesFiberContain(parentFiber, childFiber) {
    	  var node = childFiber;
    	  var parentFiberAlternate = parentFiber.alternate;

    	  while (node !== null) {
    	    if (node === parentFiber || node === parentFiberAlternate) {
    	      return true;
    	    }

    	    node = node.return;
    	  }

    	  return false;
    	}

    	var attemptUserBlockingHydration;
    	function setAttemptUserBlockingHydration(fn) {
    	  attemptUserBlockingHydration = fn;
    	}
    	var attemptContinuousHydration;
    	function setAttemptContinuousHydration(fn) {
    	  attemptContinuousHydration = fn;
    	}
    	var attemptHydrationAtCurrentPriority;
    	function setAttemptHydrationAtCurrentPriority(fn) {
    	  attemptHydrationAtCurrentPriority = fn;
    	}
    	var attemptHydrationAtPriority;
    	function setAttemptHydrationAtPriority(fn) {
    	  attemptHydrationAtPriority = fn;
    	} // TODO: Upgrade this definition once we're on a newer version of Flow that
    	var hasScheduledReplayAttempt = false; // The queue of discrete events to be replayed.

    	var queuedDiscreteEvents = []; // Indicates if any continuous event targets are non-null for early bailout.
    	// if the last target was dehydrated.

    	var queuedFocus = null;
    	var queuedDrag = null;
    	var queuedMouse = null; // For pointer events there can be one latest event per pointerId.

    	var queuedPointers = new Map();
    	var queuedPointerCaptures = new Map(); // We could consider replaying selectionchange and touchmoves too.

    	var queuedExplicitHydrationTargets = [];
    	function hasQueuedDiscreteEvents() {
    	  return queuedDiscreteEvents.length > 0;
    	}
    	var discreteReplayableEvents = ['mousedown', 'mouseup', 'touchcancel', 'touchend', 'touchstart', 'auxclick', 'dblclick', 'pointercancel', 'pointerdown', 'pointerup', 'dragend', 'dragstart', 'drop', 'compositionend', 'compositionstart', 'keydown', 'keypress', 'keyup', 'input', 'textInput', // Intentionally camelCase
    	'copy', 'cut', 'paste', 'click', 'change', 'contextmenu', 'reset', 'submit'];
    	function isReplayableDiscreteEvent(eventType) {
    	  return discreteReplayableEvents.indexOf(eventType) > -1;
    	}

    	function createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  return {
    	    blockedOn: blockedOn,
    	    domEventName: domEventName,
    	    eventSystemFlags: eventSystemFlags | IS_REPLAYED,
    	    nativeEvent: nativeEvent,
    	    targetContainers: [targetContainer]
    	  };
    	}

    	function queueDiscreteEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  var queuedEvent = createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent);
    	  queuedDiscreteEvents.push(queuedEvent);
    	} // Resets the replaying for this type of continuous event to no event.

    	function clearIfContinuousEvent(domEventName, nativeEvent) {
    	  switch (domEventName) {
    	    case 'focusin':
    	    case 'focusout':
    	      queuedFocus = null;
    	      break;

    	    case 'dragenter':
    	    case 'dragleave':
    	      queuedDrag = null;
    	      break;

    	    case 'mouseover':
    	    case 'mouseout':
    	      queuedMouse = null;
    	      break;

    	    case 'pointerover':
    	    case 'pointerout':
    	      {
    	        var pointerId = nativeEvent.pointerId;
    	        queuedPointers.delete(pointerId);
    	        break;
    	      }

    	    case 'gotpointercapture':
    	    case 'lostpointercapture':
    	      {
    	        var _pointerId = nativeEvent.pointerId;
    	        queuedPointerCaptures.delete(_pointerId);
    	        break;
    	      }
    	  }
    	}

    	function accumulateOrCreateContinuousQueuedReplayableEvent(existingQueuedEvent, blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  if (existingQueuedEvent === null || existingQueuedEvent.nativeEvent !== nativeEvent) {
    	    var queuedEvent = createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent);

    	    if (blockedOn !== null) {
    	      var _fiber2 = getInstanceFromNode(blockedOn);

    	      if (_fiber2 !== null) {
    	        // Attempt to increase the priority of this target.
    	        attemptContinuousHydration(_fiber2);
    	      }
    	    }

    	    return queuedEvent;
    	  } // If we have already queued this exact event, then it's because
    	  // the different event systems have different DOM event listeners.
    	  // We can accumulate the flags, and the targetContainers, and
    	  // store a single event to be replayed.


    	  existingQueuedEvent.eventSystemFlags |= eventSystemFlags;
    	  var targetContainers = existingQueuedEvent.targetContainers;

    	  if (targetContainer !== null && targetContainers.indexOf(targetContainer) === -1) {
    	    targetContainers.push(targetContainer);
    	  }

    	  return existingQueuedEvent;
    	}

    	function queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  // These set relatedTarget to null because the replayed event will be treated as if we
    	  // moved from outside the window (no target) onto the target once it hydrates.
    	  // Instead of mutating we could clone the event.
    	  switch (domEventName) {
    	    case 'focusin':
    	      {
    	        var focusEvent = nativeEvent;
    	        queuedFocus = accumulateOrCreateContinuousQueuedReplayableEvent(queuedFocus, blockedOn, domEventName, eventSystemFlags, targetContainer, focusEvent);
    	        return true;
    	      }

    	    case 'dragenter':
    	      {
    	        var dragEvent = nativeEvent;
    	        queuedDrag = accumulateOrCreateContinuousQueuedReplayableEvent(queuedDrag, blockedOn, domEventName, eventSystemFlags, targetContainer, dragEvent);
    	        return true;
    	      }

    	    case 'mouseover':
    	      {
    	        var mouseEvent = nativeEvent;
    	        queuedMouse = accumulateOrCreateContinuousQueuedReplayableEvent(queuedMouse, blockedOn, domEventName, eventSystemFlags, targetContainer, mouseEvent);
    	        return true;
    	      }

    	    case 'pointerover':
    	      {
    	        var pointerEvent = nativeEvent;
    	        var pointerId = pointerEvent.pointerId;
    	        queuedPointers.set(pointerId, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointers.get(pointerId) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, pointerEvent));
    	        return true;
    	      }

    	    case 'gotpointercapture':
    	      {
    	        var _pointerEvent = nativeEvent;
    	        var _pointerId2 = _pointerEvent.pointerId;
    	        queuedPointerCaptures.set(_pointerId2, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointerCaptures.get(_pointerId2) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, _pointerEvent));
    	        return true;
    	      }
    	  }

    	  return false;
    	} // Check if this target is unblocked. Returns true if it's unblocked.

    	function attemptExplicitHydrationTarget(queuedTarget) {
    	  // TODO: This function shares a lot of logic with attemptToDispatchEvent.
    	  // Try to unify them. It's a bit tricky since it would require two return
    	  // values.
    	  var targetInst = getClosestInstanceFromNode(queuedTarget.target);

    	  if (targetInst !== null) {
    	    var nearestMounted = getNearestMountedFiber(targetInst);

    	    if (nearestMounted !== null) {
    	      var tag = nearestMounted.tag;

    	      if (tag === SuspenseComponent) {
    	        var instance = getSuspenseInstanceFromFiber(nearestMounted);

    	        if (instance !== null) {
    	          // We're blocked on hydrating this boundary.
    	          // Increase its priority.
    	          queuedTarget.blockedOn = instance;
    	          attemptHydrationAtPriority(queuedTarget.lanePriority, function () {
    	            Scheduler.unstable_runWithPriority(queuedTarget.priority, function () {
    	              attemptHydrationAtCurrentPriority(nearestMounted);
    	            });
    	          });
    	          return;
    	        }
    	      } else if (tag === HostRoot) {
    	        var root = nearestMounted.stateNode;

    	        if (root.hydrate) {
    	          queuedTarget.blockedOn = getContainerFromFiber(nearestMounted); // We don't currently have a way to increase the priority of
    	          // a root other than sync.

    	          return;
    	        }
    	      }
    	    }
    	  }

    	  queuedTarget.blockedOn = null;
    	}

    	function attemptReplayContinuousQueuedEvent(queuedEvent) {
    	  if (queuedEvent.blockedOn !== null) {
    	    return false;
    	  }

    	  var targetContainers = queuedEvent.targetContainers;

    	  while (targetContainers.length > 0) {
    	    var targetContainer = targetContainers[0];
    	    var nextBlockedOn = attemptToDispatchEvent(queuedEvent.domEventName, queuedEvent.eventSystemFlags, targetContainer, queuedEvent.nativeEvent);

    	    if (nextBlockedOn !== null) {
    	      // We're still blocked. Try again later.
    	      var _fiber3 = getInstanceFromNode(nextBlockedOn);

    	      if (_fiber3 !== null) {
    	        attemptContinuousHydration(_fiber3);
    	      }

    	      queuedEvent.blockedOn = nextBlockedOn;
    	      return false;
    	    } // This target container was successfully dispatched. Try the next.


    	    targetContainers.shift();
    	  }

    	  return true;
    	}

    	function attemptReplayContinuousQueuedEventInMap(queuedEvent, key, map) {
    	  if (attemptReplayContinuousQueuedEvent(queuedEvent)) {
    	    map.delete(key);
    	  }
    	}

    	function replayUnblockedEvents() {
    	  hasScheduledReplayAttempt = false; // First replay discrete events.

    	  while (queuedDiscreteEvents.length > 0) {
    	    var nextDiscreteEvent = queuedDiscreteEvents[0];

    	    if (nextDiscreteEvent.blockedOn !== null) {
    	      // We're still blocked.
    	      // Increase the priority of this boundary to unblock
    	      // the next discrete event.
    	      var _fiber4 = getInstanceFromNode(nextDiscreteEvent.blockedOn);

    	      if (_fiber4 !== null) {
    	        attemptUserBlockingHydration(_fiber4);
    	      }

    	      break;
    	    }

    	    var targetContainers = nextDiscreteEvent.targetContainers;

    	    while (targetContainers.length > 0) {
    	      var targetContainer = targetContainers[0];
    	      var nextBlockedOn = attemptToDispatchEvent(nextDiscreteEvent.domEventName, nextDiscreteEvent.eventSystemFlags, targetContainer, nextDiscreteEvent.nativeEvent);

    	      if (nextBlockedOn !== null) {
    	        // We're still blocked. Try again later.
    	        nextDiscreteEvent.blockedOn = nextBlockedOn;
    	        break;
    	      } // This target container was successfully dispatched. Try the next.


    	      targetContainers.shift();
    	    }

    	    if (nextDiscreteEvent.blockedOn === null) {
    	      // We've successfully replayed the first event. Let's try the next one.
    	      queuedDiscreteEvents.shift();
    	    }
    	  } // Next replay any continuous events.


    	  if (queuedFocus !== null && attemptReplayContinuousQueuedEvent(queuedFocus)) {
    	    queuedFocus = null;
    	  }

    	  if (queuedDrag !== null && attemptReplayContinuousQueuedEvent(queuedDrag)) {
    	    queuedDrag = null;
    	  }

    	  if (queuedMouse !== null && attemptReplayContinuousQueuedEvent(queuedMouse)) {
    	    queuedMouse = null;
    	  }

    	  queuedPointers.forEach(attemptReplayContinuousQueuedEventInMap);
    	  queuedPointerCaptures.forEach(attemptReplayContinuousQueuedEventInMap);
    	}

    	function scheduleCallbackIfUnblocked(queuedEvent, unblocked) {
    	  if (queuedEvent.blockedOn === unblocked) {
    	    queuedEvent.blockedOn = null;

    	    if (!hasScheduledReplayAttempt) {
    	      hasScheduledReplayAttempt = true; // Schedule a callback to attempt replaying as many events as are
    	      // now unblocked. This first might not actually be unblocked yet.
    	      // We could check it early to avoid scheduling an unnecessary callback.

    	      Scheduler.unstable_scheduleCallback(Scheduler.unstable_NormalPriority, replayUnblockedEvents);
    	    }
    	  }
    	}

    	function retryIfBlockedOn(unblocked) {
    	  // Mark anything that was blocked on this as no longer blocked
    	  // and eligible for a replay.
    	  if (queuedDiscreteEvents.length > 0) {
    	    scheduleCallbackIfUnblocked(queuedDiscreteEvents[0], unblocked); // This is a exponential search for each boundary that commits. I think it's
    	    // worth it because we expect very few discrete events to queue up and once
    	    // we are actually fully unblocked it will be fast to replay them.

    	    for (var i = 1; i < queuedDiscreteEvents.length; i++) {
    	      var queuedEvent = queuedDiscreteEvents[i];

    	      if (queuedEvent.blockedOn === unblocked) {
    	        queuedEvent.blockedOn = null;
    	      }
    	    }
    	  }

    	  if (queuedFocus !== null) {
    	    scheduleCallbackIfUnblocked(queuedFocus, unblocked);
    	  }

    	  if (queuedDrag !== null) {
    	    scheduleCallbackIfUnblocked(queuedDrag, unblocked);
    	  }

    	  if (queuedMouse !== null) {
    	    scheduleCallbackIfUnblocked(queuedMouse, unblocked);
    	  }

    	  var unblock = function (queuedEvent) {
    	    return scheduleCallbackIfUnblocked(queuedEvent, unblocked);
    	  };

    	  queuedPointers.forEach(unblock);
    	  queuedPointerCaptures.forEach(unblock);

    	  for (var _i = 0; _i < queuedExplicitHydrationTargets.length; _i++) {
    	    var queuedTarget = queuedExplicitHydrationTargets[_i];

    	    if (queuedTarget.blockedOn === unblocked) {
    	      queuedTarget.blockedOn = null;
    	    }
    	  }

    	  while (queuedExplicitHydrationTargets.length > 0) {
    	    var nextExplicitTarget = queuedExplicitHydrationTargets[0];

    	    if (nextExplicitTarget.blockedOn !== null) {
    	      // We're still blocked.
    	      break;
    	    } else {
    	      attemptExplicitHydrationTarget(nextExplicitTarget);

    	      if (nextExplicitTarget.blockedOn === null) {
    	        // We're unblocked.
    	        queuedExplicitHydrationTargets.shift();
    	      }
    	    }
    	  }
    	}

    	var DiscreteEvent = 0;
    	var UserBlockingEvent = 1;
    	var ContinuousEvent = 2;

    	/**
    	 * Generate a mapping of standard vendor prefixes using the defined style property and event name.
    	 *
    	 * @param {string} styleProp
    	 * @param {string} eventName
    	 * @returns {object}
    	 */

    	function makePrefixMap(styleProp, eventName) {
    	  var prefixes = {};
    	  prefixes[styleProp.toLowerCase()] = eventName.toLowerCase();
    	  prefixes['Webkit' + styleProp] = 'webkit' + eventName;
    	  prefixes['Moz' + styleProp] = 'moz' + eventName;
    	  return prefixes;
    	}
    	/**
    	 * A list of event names to a configurable list of vendor prefixes.
    	 */


    	var vendorPrefixes = {
    	  animationend: makePrefixMap('Animation', 'AnimationEnd'),
    	  animationiteration: makePrefixMap('Animation', 'AnimationIteration'),
    	  animationstart: makePrefixMap('Animation', 'AnimationStart'),
    	  transitionend: makePrefixMap('Transition', 'TransitionEnd')
    	};
    	/**
    	 * Event names that have already been detected and prefixed (if applicable).
    	 */

    	var prefixedEventNames = {};
    	/**
    	 * Element to check for prefixes on.
    	 */

    	var style = {};
    	/**
    	 * Bootstrap if a DOM exists.
    	 */

    	if (canUseDOM) {
    	  style = document.createElement('div').style; // On some platforms, in particular some releases of Android 4.x,
    	  // the un-prefixed "animation" and "transition" properties are defined on the
    	  // style object but the events that fire will still be prefixed, so we need
    	  // to check if the un-prefixed events are usable, and if not remove them from the map.

    	  if (!('AnimationEvent' in window)) {
    	    delete vendorPrefixes.animationend.animation;
    	    delete vendorPrefixes.animationiteration.animation;
    	    delete vendorPrefixes.animationstart.animation;
    	  } // Same as above


    	  if (!('TransitionEvent' in window)) {
    	    delete vendorPrefixes.transitionend.transition;
    	  }
    	}
    	/**
    	 * Attempts to determine the correct vendor prefixed event name.
    	 *
    	 * @param {string} eventName
    	 * @returns {string}
    	 */


    	function getVendorPrefixedEventName(eventName) {
    	  if (prefixedEventNames[eventName]) {
    	    return prefixedEventNames[eventName];
    	  } else if (!vendorPrefixes[eventName]) {
    	    return eventName;
    	  }

    	  var prefixMap = vendorPrefixes[eventName];

    	  for (var styleProp in prefixMap) {
    	    if (prefixMap.hasOwnProperty(styleProp) && styleProp in style) {
    	      return prefixedEventNames[eventName] = prefixMap[styleProp];
    	    }
    	  }

    	  return eventName;
    	}

    	var ANIMATION_END = getVendorPrefixedEventName('animationend');
    	var ANIMATION_ITERATION = getVendorPrefixedEventName('animationiteration');
    	var ANIMATION_START = getVendorPrefixedEventName('animationstart');
    	var TRANSITION_END = getVendorPrefixedEventName('transitionend');

    	var topLevelEventsToReactNames = new Map();
    	var eventPriorities = new Map(); // We store most of the events in this module in pairs of two strings so we can re-use
    	// the code required to apply the same logic for event prioritization and that of the
    	// SimpleEventPlugin. This complicates things slightly, but the aim is to reduce code
    	// duplication (for which there would be quite a bit). For the events that are not needed
    	// for the SimpleEventPlugin (otherDiscreteEvents) we process them separately as an
    	// array of top level events.
    	// Lastly, we ignore prettier so we can keep the formatting sane.
    	// prettier-ignore

    	var discreteEventPairsForSimpleEventPlugin = ['cancel', 'cancel', 'click', 'click', 'close', 'close', 'contextmenu', 'contextMenu', 'copy', 'copy', 'cut', 'cut', 'auxclick', 'auxClick', 'dblclick', 'doubleClick', // Careful!
    	'dragend', 'dragEnd', 'dragstart', 'dragStart', 'drop', 'drop', 'focusin', 'focus', // Careful!
    	'focusout', 'blur', // Careful!
    	'input', 'input', 'invalid', 'invalid', 'keydown', 'keyDown', 'keypress', 'keyPress', 'keyup', 'keyUp', 'mousedown', 'mouseDown', 'mouseup', 'mouseUp', 'paste', 'paste', 'pause', 'pause', 'play', 'play', 'pointercancel', 'pointerCancel', 'pointerdown', 'pointerDown', 'pointerup', 'pointerUp', 'ratechange', 'rateChange', 'reset', 'reset', 'seeked', 'seeked', 'submit', 'submit', 'touchcancel', 'touchCancel', 'touchend', 'touchEnd', 'touchstart', 'touchStart', 'volumechange', 'volumeChange'];
    	var otherDiscreteEvents = ['change', 'selectionchange', 'textInput', 'compositionstart', 'compositionend', 'compositionupdate'];


    	var userBlockingPairsForSimpleEventPlugin = ['drag', 'drag', 'dragenter', 'dragEnter', 'dragexit', 'dragExit', 'dragleave', 'dragLeave', 'dragover', 'dragOver', 'mousemove', 'mouseMove', 'mouseout', 'mouseOut', 'mouseover', 'mouseOver', 'pointermove', 'pointerMove', 'pointerout', 'pointerOut', 'pointerover', 'pointerOver', 'scroll', 'scroll', 'toggle', 'toggle', 'touchmove', 'touchMove', 'wheel', 'wheel']; // prettier-ignore

    	var continuousPairsForSimpleEventPlugin = ['abort', 'abort', ANIMATION_END, 'animationEnd', ANIMATION_ITERATION, 'animationIteration', ANIMATION_START, 'animationStart', 'canplay', 'canPlay', 'canplaythrough', 'canPlayThrough', 'durationchange', 'durationChange', 'emptied', 'emptied', 'encrypted', 'encrypted', 'ended', 'ended', 'error', 'error', 'gotpointercapture', 'gotPointerCapture', 'load', 'load', 'loadeddata', 'loadedData', 'loadedmetadata', 'loadedMetadata', 'loadstart', 'loadStart', 'lostpointercapture', 'lostPointerCapture', 'playing', 'playing', 'progress', 'progress', 'seeking', 'seeking', 'stalled', 'stalled', 'suspend', 'suspend', 'timeupdate', 'timeUpdate', TRANSITION_END, 'transitionEnd', 'waiting', 'waiting'];
    	/**
    	 * Turns
    	 * ['abort', ...]
    	 *
    	 * into
    	 *
    	 * topLevelEventsToReactNames = new Map([
    	 *   ['abort', 'onAbort'],
    	 * ]);
    	 *
    	 * and registers them.
    	 */

    	function registerSimplePluginEventsAndSetTheirPriorities(eventTypes, priority) {
    	  // As the event types are in pairs of two, we need to iterate
    	  // through in twos. The events are in pairs of two to save code
    	  // and improve init perf of processing this array, as it will
    	  // result in far fewer object allocations and property accesses
    	  // if we only use three arrays to process all the categories of
    	  // instead of tuples.
    	  for (var i = 0; i < eventTypes.length; i += 2) {
    	    var topEvent = eventTypes[i];
    	    var event = eventTypes[i + 1];
    	    var capitalizedEvent = event[0].toUpperCase() + event.slice(1);
    	    var reactName = 'on' + capitalizedEvent;
    	    eventPriorities.set(topEvent, priority);
    	    topLevelEventsToReactNames.set(topEvent, reactName);
    	    registerTwoPhaseEvent(reactName, [topEvent]);
    	  }
    	}

    	function setEventPriorities(eventTypes, priority) {
    	  for (var i = 0; i < eventTypes.length; i++) {
    	    eventPriorities.set(eventTypes[i], priority);
    	  }
    	}

    	function getEventPriorityForPluginSystem(domEventName) {
    	  var priority = eventPriorities.get(domEventName); // Default to a ContinuousEvent. Note: we might
    	  // want to warn if we can't detect the priority
    	  // for the event.

    	  return priority === undefined ? ContinuousEvent : priority;
    	}
    	function registerSimpleEvents() {
    	  registerSimplePluginEventsAndSetTheirPriorities(discreteEventPairsForSimpleEventPlugin, DiscreteEvent);
    	  registerSimplePluginEventsAndSetTheirPriorities(userBlockingPairsForSimpleEventPlugin, UserBlockingEvent);
    	  registerSimplePluginEventsAndSetTheirPriorities(continuousPairsForSimpleEventPlugin, ContinuousEvent);
    	  setEventPriorities(otherDiscreteEvents, DiscreteEvent);
    	}

    	var Scheduler_now = Scheduler.unstable_now;

    	{
    	  // Provide explicit error message when production+profiling bundle of e.g.
    	  // react-dom is used with production (non-profiling) bundle of
    	  // scheduler/tracing
    	  if (!(tracing.__interactionsRef != null && tracing.__interactionsRef.current != null)) {
    	    {
    	      throw Error( "It is not supported to run the profiling version of a renderer (for example, `react-dom/profiling`) without also replacing the `scheduler/tracing` module with `scheduler/tracing-profiling`. Your bundler might have a setting for aliasing both modules. Learn more at https://reactjs.org/link/profiling" );
    	    }
    	  }
    	}
    	// ascending numbers so we can compare them like numbers. They start at 90 to
    	// avoid clashing with Scheduler's priorities.

    	var ImmediatePriority = 99;
    	var UserBlockingPriority = 98;
    	var NormalPriority = 97;
    	var LowPriority = 96;
    	var IdlePriority = 95; // NoPriority is the absence of priority. Also React-only.

    	var NoPriority = 90;
    	Scheduler_now(); // If the initial timestamp is reasonably small, use Scheduler's `now` directly.

    	var SyncLanePriority = 15;
    	var SyncBatchedLanePriority = 14;
    	var InputDiscreteHydrationLanePriority = 13;
    	var InputDiscreteLanePriority = 12;
    	var InputContinuousHydrationLanePriority = 11;
    	var InputContinuousLanePriority = 10;
    	var DefaultHydrationLanePriority = 9;
    	var DefaultLanePriority = 8;
    	var TransitionHydrationPriority = 7;
    	var TransitionPriority = 6;
    	var RetryLanePriority = 5;
    	var SelectiveHydrationLanePriority = 4;
    	var IdleHydrationLanePriority = 3;
    	var IdleLanePriority = 2;
    	var OffscreenLanePriority = 1;
    	var NoLanePriority = 0;
    	var TotalLanes = 31;
    	var NoLanes =
    	/*                        */
    	0;
    	var NoLane =
    	/*                          */
    	0;
    	var SyncLane =
    	/*                        */
    	1;
    	var SyncBatchedLane =
    	/*                 */
    	2;
    	var InputDiscreteHydrationLane =
    	/*      */
    	4;
    	var InputDiscreteLanes =
    	/*                    */
    	24;
    	var InputContinuousHydrationLane =
    	/*           */
    	32;
    	var InputContinuousLanes =
    	/*                  */
    	192;
    	var DefaultHydrationLane =
    	/*            */
    	256;
    	var DefaultLanes =
    	/*                   */
    	3584;
    	var TransitionHydrationLane =
    	/*                */
    	4096;
    	var TransitionLanes =
    	/*                       */
    	4186112;
    	var RetryLanes =
    	/*                            */
    	62914560;
    	var SomeRetryLane =
    	/*                  */
    	33554432;
    	var SelectiveHydrationLane =
    	/*          */
    	67108864;
    	var NonIdleLanes =
    	/*                                 */
    	134217727;
    	var IdleHydrationLane =
    	/*               */
    	134217728;
    	var IdleLanes =
    	/*                             */
    	805306368;
    	var OffscreenLane =
    	/*                   */
    	1073741824;
    	var NoTimestamp = -1;
    	function setCurrentUpdateLanePriority(newLanePriority) {
    	} // "Registers" used to "return" multiple values
    	// Used by getHighestPriorityLanes and getNextLanes:

    	var return_highestLanePriority = DefaultLanePriority;

    	function getHighestPriorityLanes(lanes) {
    	  if ((SyncLane & lanes) !== NoLanes) {
    	    return_highestLanePriority = SyncLanePriority;
    	    return SyncLane;
    	  }

    	  if ((SyncBatchedLane & lanes) !== NoLanes) {
    	    return_highestLanePriority = SyncBatchedLanePriority;
    	    return SyncBatchedLane;
    	  }

    	  if ((InputDiscreteHydrationLane & lanes) !== NoLanes) {
    	    return_highestLanePriority = InputDiscreteHydrationLanePriority;
    	    return InputDiscreteHydrationLane;
    	  }

    	  var inputDiscreteLanes = InputDiscreteLanes & lanes;

    	  if (inputDiscreteLanes !== NoLanes) {
    	    return_highestLanePriority = InputDiscreteLanePriority;
    	    return inputDiscreteLanes;
    	  }

    	  if ((lanes & InputContinuousHydrationLane) !== NoLanes) {
    	    return_highestLanePriority = InputContinuousHydrationLanePriority;
    	    return InputContinuousHydrationLane;
    	  }

    	  var inputContinuousLanes = InputContinuousLanes & lanes;

    	  if (inputContinuousLanes !== NoLanes) {
    	    return_highestLanePriority = InputContinuousLanePriority;
    	    return inputContinuousLanes;
    	  }

    	  if ((lanes & DefaultHydrationLane) !== NoLanes) {
    	    return_highestLanePriority = DefaultHydrationLanePriority;
    	    return DefaultHydrationLane;
    	  }

    	  var defaultLanes = DefaultLanes & lanes;

    	  if (defaultLanes !== NoLanes) {
    	    return_highestLanePriority = DefaultLanePriority;
    	    return defaultLanes;
    	  }

    	  if ((lanes & TransitionHydrationLane) !== NoLanes) {
    	    return_highestLanePriority = TransitionHydrationPriority;
    	    return TransitionHydrationLane;
    	  }

    	  var transitionLanes = TransitionLanes & lanes;

    	  if (transitionLanes !== NoLanes) {
    	    return_highestLanePriority = TransitionPriority;
    	    return transitionLanes;
    	  }

    	  var retryLanes = RetryLanes & lanes;

    	  if (retryLanes !== NoLanes) {
    	    return_highestLanePriority = RetryLanePriority;
    	    return retryLanes;
    	  }

    	  if (lanes & SelectiveHydrationLane) {
    	    return_highestLanePriority = SelectiveHydrationLanePriority;
    	    return SelectiveHydrationLane;
    	  }

    	  if ((lanes & IdleHydrationLane) !== NoLanes) {
    	    return_highestLanePriority = IdleHydrationLanePriority;
    	    return IdleHydrationLane;
    	  }

    	  var idleLanes = IdleLanes & lanes;

    	  if (idleLanes !== NoLanes) {
    	    return_highestLanePriority = IdleLanePriority;
    	    return idleLanes;
    	  }

    	  if ((OffscreenLane & lanes) !== NoLanes) {
    	    return_highestLanePriority = OffscreenLanePriority;
    	    return OffscreenLane;
    	  }

    	  {
    	    error('Should have found matching lanes. This is a bug in React.');
    	  } // This shouldn't be reachable, but as a fallback, return the entire bitmask.


    	  return_highestLanePriority = DefaultLanePriority;
    	  return lanes;
    	}

    	function schedulerPriorityToLanePriority(schedulerPriorityLevel) {
    	  switch (schedulerPriorityLevel) {
    	    case ImmediatePriority:
    	      return SyncLanePriority;

    	    case UserBlockingPriority:
    	      return InputContinuousLanePriority;

    	    case NormalPriority:
    	    case LowPriority:
    	      // TODO: Handle LowSchedulerPriority, somehow. Maybe the same lane as hydration.
    	      return DefaultLanePriority;

    	    case IdlePriority:
    	      return IdleLanePriority;

    	    default:
    	      return NoLanePriority;
    	  }
    	}
    	function lanePriorityToSchedulerPriority(lanePriority) {
    	  switch (lanePriority) {
    	    case SyncLanePriority:
    	    case SyncBatchedLanePriority:
    	      return ImmediatePriority;

    	    case InputDiscreteHydrationLanePriority:
    	    case InputDiscreteLanePriority:
    	    case InputContinuousHydrationLanePriority:
    	    case InputContinuousLanePriority:
    	      return UserBlockingPriority;

    	    case DefaultHydrationLanePriority:
    	    case DefaultLanePriority:
    	    case TransitionHydrationPriority:
    	    case TransitionPriority:
    	    case SelectiveHydrationLanePriority:
    	    case RetryLanePriority:
    	      return NormalPriority;

    	    case IdleHydrationLanePriority:
    	    case IdleLanePriority:
    	    case OffscreenLanePriority:
    	      return IdlePriority;

    	    case NoLanePriority:
    	      return NoPriority;

    	    default:
    	      {
    	        {
    	          throw Error( "Invalid update priority: " + lanePriority + ". This is a bug in React." );
    	        }
    	      }

    	  }
    	}
    	function getNextLanes(root, wipLanes) {
    	  // Early bailout if there's no pending work left.
    	  var pendingLanes = root.pendingLanes;

    	  if (pendingLanes === NoLanes) {
    	    return_highestLanePriority = NoLanePriority;
    	    return NoLanes;
    	  }

    	  var nextLanes = NoLanes;
    	  var nextLanePriority = NoLanePriority;
    	  var expiredLanes = root.expiredLanes;
    	  var suspendedLanes = root.suspendedLanes;
    	  var pingedLanes = root.pingedLanes; // Check if any work has expired.

    	  if (expiredLanes !== NoLanes) {
    	    nextLanes = expiredLanes;
    	    nextLanePriority = return_highestLanePriority = SyncLanePriority;
    	  } else {
    	    // Do not work on any idle work until all the non-idle work has finished,
    	    // even if the work is suspended.
    	    var nonIdlePendingLanes = pendingLanes & NonIdleLanes;

    	    if (nonIdlePendingLanes !== NoLanes) {
    	      var nonIdleUnblockedLanes = nonIdlePendingLanes & ~suspendedLanes;

    	      if (nonIdleUnblockedLanes !== NoLanes) {
    	        nextLanes = getHighestPriorityLanes(nonIdleUnblockedLanes);
    	        nextLanePriority = return_highestLanePriority;
    	      } else {
    	        var nonIdlePingedLanes = nonIdlePendingLanes & pingedLanes;

    	        if (nonIdlePingedLanes !== NoLanes) {
    	          nextLanes = getHighestPriorityLanes(nonIdlePingedLanes);
    	          nextLanePriority = return_highestLanePriority;
    	        }
    	      }
    	    } else {
    	      // The only remaining work is Idle.
    	      var unblockedLanes = pendingLanes & ~suspendedLanes;

    	      if (unblockedLanes !== NoLanes) {
    	        nextLanes = getHighestPriorityLanes(unblockedLanes);
    	        nextLanePriority = return_highestLanePriority;
    	      } else {
    	        if (pingedLanes !== NoLanes) {
    	          nextLanes = getHighestPriorityLanes(pingedLanes);
    	          nextLanePriority = return_highestLanePriority;
    	        }
    	      }
    	    }
    	  }

    	  if (nextLanes === NoLanes) {
    	    // This should only be reachable if we're suspended
    	    // TODO: Consider warning in this path if a fallback timer is not scheduled.
    	    return NoLanes;
    	  } // If there are higher priority lanes, we'll include them even if they
    	  // are suspended.


    	  nextLanes = pendingLanes & getEqualOrHigherPriorityLanes(nextLanes); // If we're already in the middle of a render, switching lanes will interrupt
    	  // it and we'll lose our progress. We should only do this if the new lanes are
    	  // higher priority.

    	  if (wipLanes !== NoLanes && wipLanes !== nextLanes && // If we already suspended with a delay, then interrupting is fine. Don't
    	  // bother waiting until the root is complete.
    	  (wipLanes & suspendedLanes) === NoLanes) {
    	    getHighestPriorityLanes(wipLanes);
    	    var wipLanePriority = return_highestLanePriority;

    	    if (nextLanePriority <= wipLanePriority) {
    	      return wipLanes;
    	    } else {
    	      return_highestLanePriority = nextLanePriority;
    	    }
    	  } // Check for entangled lanes and add them to the batch.
    	  //
    	  // A lane is said to be entangled with another when it's not allowed to render
    	  // in a batch that does not also include the other lane. Typically we do this
    	  // when multiple updates have the same source, and we only want to respond to
    	  // the most recent event from that source.
    	  //
    	  // Note that we apply entanglements *after* checking for partial work above.
    	  // This means that if a lane is entangled during an interleaved event while
    	  // it's already rendering, we won't interrupt it. This is intentional, since
    	  // entanglement is usually "best effort": we'll try our best to render the
    	  // lanes in the same batch, but it's not worth throwing out partially
    	  // completed work in order to do it.
    	  //
    	  // For those exceptions where entanglement is semantically important, like
    	  // useMutableSource, we should ensure that there is no partial work at the
    	  // time we apply the entanglement.


    	  var entangledLanes = root.entangledLanes;

    	  if (entangledLanes !== NoLanes) {
    	    var entanglements = root.entanglements;
    	    var lanes = nextLanes & entangledLanes;

    	    while (lanes > 0) {
    	      var index = pickArbitraryLaneIndex(lanes);
    	      var lane = 1 << index;
    	      nextLanes |= entanglements[index];
    	      lanes &= ~lane;
    	    }
    	  }

    	  return nextLanes;
    	}
    	function getMostRecentEventTime(root, lanes) {
    	  var eventTimes = root.eventTimes;
    	  var mostRecentEventTime = NoTimestamp;

    	  while (lanes > 0) {
    	    var index = pickArbitraryLaneIndex(lanes);
    	    var lane = 1 << index;
    	    var eventTime = eventTimes[index];

    	    if (eventTime > mostRecentEventTime) {
    	      mostRecentEventTime = eventTime;
    	    }

    	    lanes &= ~lane;
    	  }

    	  return mostRecentEventTime;
    	}

    	function computeExpirationTime(lane, currentTime) {
    	  // TODO: Expiration heuristic is constant per lane, so could use a map.
    	  getHighestPriorityLanes(lane);
    	  var priority = return_highestLanePriority;

    	  if (priority >= InputContinuousLanePriority) {
    	    // User interactions should expire slightly more quickly.
    	    //
    	    // NOTE: This is set to the corresponding constant as in Scheduler.js. When
    	    // we made it larger, a product metric in www regressed, suggesting there's
    	    // a user interaction that's being starved by a series of synchronous
    	    // updates. If that theory is correct, the proper solution is to fix the
    	    // starvation. However, this scenario supports the idea that expiration
    	    // times are an important safeguard when starvation does happen.
    	    //
    	    // Also note that, in the case of user input specifically, this will soon no
    	    // longer be an issue because we plan to make user input synchronous by
    	    // default (until you enter `startTransition`, of course.)
    	    //
    	    // If weren't planning to make these updates synchronous soon anyway, I
    	    // would probably make this number a configurable parameter.
    	    return currentTime + 250;
    	  } else if (priority >= TransitionPriority) {
    	    return currentTime + 5000;
    	  } else {
    	    // Anything idle priority or lower should never expire.
    	    return NoTimestamp;
    	  }
    	}

    	function markStarvedLanesAsExpired(root, currentTime) {
    	  // TODO: This gets called every time we yield. We can optimize by storing
    	  // the earliest expiration time on the root. Then use that to quickly bail out
    	  // of this function.
    	  var pendingLanes = root.pendingLanes;
    	  var suspendedLanes = root.suspendedLanes;
    	  var pingedLanes = root.pingedLanes;
    	  var expirationTimes = root.expirationTimes; // Iterate through the pending lanes and check if we've reached their
    	  // expiration time. If so, we'll assume the update is being starved and mark
    	  // it as expired to force it to finish.

    	  var lanes = pendingLanes;

    	  while (lanes > 0) {
    	    var index = pickArbitraryLaneIndex(lanes);
    	    var lane = 1 << index;
    	    var expirationTime = expirationTimes[index];

    	    if (expirationTime === NoTimestamp) {
    	      // Found a pending lane with no expiration time. If it's not suspended, or
    	      // if it's pinged, assume it's CPU-bound. Compute a new expiration time
    	      // using the current time.
    	      if ((lane & suspendedLanes) === NoLanes || (lane & pingedLanes) !== NoLanes) {
    	        // Assumes timestamps are monotonically increasing.
    	        expirationTimes[index] = computeExpirationTime(lane, currentTime);
    	      }
    	    } else if (expirationTime <= currentTime) {
    	      // This lane expired
    	      root.expiredLanes |= lane;
    	    }

    	    lanes &= ~lane;
    	  }
    	} // This returns the highest priority pending lanes regardless of whether they
    	function getLanesToRetrySynchronouslyOnError(root) {
    	  var everythingButOffscreen = root.pendingLanes & ~OffscreenLane;

    	  if (everythingButOffscreen !== NoLanes) {
    	    return everythingButOffscreen;
    	  }

    	  if (everythingButOffscreen & OffscreenLane) {
    	    return OffscreenLane;
    	  }

    	  return NoLanes;
    	}
    	function returnNextLanesPriority() {
    	  return return_highestLanePriority;
    	}
    	function includesNonIdleWork(lanes) {
    	  return (lanes & NonIdleLanes) !== NoLanes;
    	}
    	function includesOnlyRetries(lanes) {
    	  return (lanes & RetryLanes) === lanes;
    	}
    	function includesOnlyTransitions(lanes) {
    	  return (lanes & TransitionLanes) === lanes;
    	} // To ensure consistency across multiple updates in the same event, this should
    	// be a pure function, so that it always returns the same lane for given inputs.

    	function findUpdateLane(lanePriority, wipLanes) {
    	  switch (lanePriority) {
    	    case NoLanePriority:
    	      break;

    	    case SyncLanePriority:
    	      return SyncLane;

    	    case SyncBatchedLanePriority:
    	      return SyncBatchedLane;

    	    case InputDiscreteLanePriority:
    	      {
    	        var _lane = pickArbitraryLane(InputDiscreteLanes & ~wipLanes);

    	        if (_lane === NoLane) {
    	          // Shift to the next priority level
    	          return findUpdateLane(InputContinuousLanePriority, wipLanes);
    	        }

    	        return _lane;
    	      }

    	    case InputContinuousLanePriority:
    	      {
    	        var _lane2 = pickArbitraryLane(InputContinuousLanes & ~wipLanes);

    	        if (_lane2 === NoLane) {
    	          // Shift to the next priority level
    	          return findUpdateLane(DefaultLanePriority, wipLanes);
    	        }

    	        return _lane2;
    	      }

    	    case DefaultLanePriority:
    	      {
    	        var _lane3 = pickArbitraryLane(DefaultLanes & ~wipLanes);

    	        if (_lane3 === NoLane) {
    	          // If all the default lanes are already being worked on, look for a
    	          // lane in the transition range.
    	          _lane3 = pickArbitraryLane(TransitionLanes & ~wipLanes);

    	          if (_lane3 === NoLane) {
    	            // All the transition lanes are taken, too. This should be very
    	            // rare, but as a last resort, pick a default lane. This will have
    	            // the effect of interrupting the current work-in-progress render.
    	            _lane3 = pickArbitraryLane(DefaultLanes);
    	          }
    	        }

    	        return _lane3;
    	      }

    	    case TransitionPriority: // Should be handled by findTransitionLane instead

    	    case RetryLanePriority:
    	      // Should be handled by findRetryLane instead
    	      break;

    	    case IdleLanePriority:
    	      var lane = pickArbitraryLane(IdleLanes & ~wipLanes);

    	      if (lane === NoLane) {
    	        lane = pickArbitraryLane(IdleLanes);
    	      }

    	      return lane;
    	  }

    	  {
    	    {
    	      throw Error( "Invalid update priority: " + lanePriority + ". This is a bug in React." );
    	    }
    	  }
    	} // To ensure consistency across multiple updates in the same event, this should
    	// be pure function, so that it always returns the same lane for given inputs.

    	function findTransitionLane(wipLanes, pendingLanes) {
    	  // First look for lanes that are completely unclaimed, i.e. have no
    	  // pending work.
    	  var lane = pickArbitraryLane(TransitionLanes & ~pendingLanes);

    	  if (lane === NoLane) {
    	    // If all lanes have pending work, look for a lane that isn't currently
    	    // being worked on.
    	    lane = pickArbitraryLane(TransitionLanes & ~wipLanes);

    	    if (lane === NoLane) {
    	      // If everything is being worked on, pick any lane. This has the
    	      // effect of interrupting the current work-in-progress.
    	      lane = pickArbitraryLane(TransitionLanes);
    	    }
    	  }

    	  return lane;
    	} // To ensure consistency across multiple updates in the same event, this should
    	// be pure function, so that it always returns the same lane for given inputs.

    	function findRetryLane(wipLanes) {
    	  // This is a fork of `findUpdateLane` designed specifically for Suspense
    	  // "retries" — a special update that attempts to flip a Suspense boundary
    	  // from its placeholder state to its primary/resolved state.
    	  var lane = pickArbitraryLane(RetryLanes & ~wipLanes);

    	  if (lane === NoLane) {
    	    lane = pickArbitraryLane(RetryLanes);
    	  }

    	  return lane;
    	}

    	function getHighestPriorityLane(lanes) {
    	  return lanes & -lanes;
    	}

    	function getLowestPriorityLane(lanes) {
    	  // This finds the most significant non-zero bit.
    	  var index = 31 - clz32(lanes);
    	  return index < 0 ? NoLanes : 1 << index;
    	}

    	function getEqualOrHigherPriorityLanes(lanes) {
    	  return (getLowestPriorityLane(lanes) << 1) - 1;
    	}

    	function pickArbitraryLane(lanes) {
    	  // This wrapper function gets inlined. Only exists so to communicate that it
    	  // doesn't matter which bit is selected; you can pick any bit without
    	  // affecting the algorithms where its used. Here I'm using
    	  // getHighestPriorityLane because it requires the fewest operations.
    	  return getHighestPriorityLane(lanes);
    	}

    	function pickArbitraryLaneIndex(lanes) {
    	  return 31 - clz32(lanes);
    	}

    	function laneToIndex(lane) {
    	  return pickArbitraryLaneIndex(lane);
    	}

    	function includesSomeLane(a, b) {
    	  return (a & b) !== NoLanes;
    	}
    	function isSubsetOfLanes(set, subset) {
    	  return (set & subset) === subset;
    	}
    	function mergeLanes(a, b) {
    	  return a | b;
    	}
    	function removeLanes(set, subset) {
    	  return set & ~subset;
    	} // Seems redundant, but it changes the type from a single lane (used for
    	// updates) to a group of lanes (used for flushing work).

    	function laneToLanes(lane) {
    	  return lane;
    	}
    	function higherPriorityLane(a, b) {
    	  // This works because the bit ranges decrease in priority as you go left.
    	  return a !== NoLane && a < b ? a : b;
    	}
    	function createLaneMap(initial) {
    	  // Intentionally pushing one by one.
    	  // https://v8.dev/blog/elements-kinds#avoid-creating-holes
    	  var laneMap = [];

    	  for (var i = 0; i < TotalLanes; i++) {
    	    laneMap.push(initial);
    	  }

    	  return laneMap;
    	}
    	function markRootUpdated(root, updateLane, eventTime) {
    	  root.pendingLanes |= updateLane; // TODO: Theoretically, any update to any lane can unblock any other lane. But
    	  // it's not practical to try every single possible combination. We need a
    	  // heuristic to decide which lanes to attempt to render, and in which batches.
    	  // For now, we use the same heuristic as in the old ExpirationTimes model:
    	  // retry any lane at equal or lower priority, but don't try updates at higher
    	  // priority without also including the lower priority updates. This works well
    	  // when considering updates across different priority levels, but isn't
    	  // sufficient for updates within the same priority, since we want to treat
    	  // those updates as parallel.
    	  // Unsuspend any update at equal or lower priority.

    	  var higherPriorityLanes = updateLane - 1; // Turns 0b1000 into 0b0111

    	  root.suspendedLanes &= higherPriorityLanes;
    	  root.pingedLanes &= higherPriorityLanes;
    	  var eventTimes = root.eventTimes;
    	  var index = laneToIndex(updateLane); // We can always overwrite an existing timestamp because we prefer the most
    	  // recent event, and we assume time is monotonically increasing.

    	  eventTimes[index] = eventTime;
    	}
    	function markRootSuspended(root, suspendedLanes) {
    	  root.suspendedLanes |= suspendedLanes;
    	  root.pingedLanes &= ~suspendedLanes; // The suspended lanes are no longer CPU-bound. Clear their expiration times.

    	  var expirationTimes = root.expirationTimes;
    	  var lanes = suspendedLanes;

    	  while (lanes > 0) {
    	    var index = pickArbitraryLaneIndex(lanes);
    	    var lane = 1 << index;
    	    expirationTimes[index] = NoTimestamp;
    	    lanes &= ~lane;
    	  }
    	}
    	function markRootPinged(root, pingedLanes, eventTime) {
    	  root.pingedLanes |= root.suspendedLanes & pingedLanes;
    	}
    	function markDiscreteUpdatesExpired(root) {
    	  root.expiredLanes |= InputDiscreteLanes & root.pendingLanes;
    	}
    	function hasDiscreteLanes(lanes) {
    	  return (lanes & InputDiscreteLanes) !== NoLanes;
    	}
    	function markRootMutableRead(root, updateLane) {
    	  root.mutableReadLanes |= updateLane & root.pendingLanes;
    	}
    	function markRootFinished(root, remainingLanes) {
    	  var noLongerPendingLanes = root.pendingLanes & ~remainingLanes;
    	  root.pendingLanes = remainingLanes; // Let's try everything again

    	  root.suspendedLanes = 0;
    	  root.pingedLanes = 0;
    	  root.expiredLanes &= remainingLanes;
    	  root.mutableReadLanes &= remainingLanes;
    	  root.entangledLanes &= remainingLanes;
    	  var entanglements = root.entanglements;
    	  var eventTimes = root.eventTimes;
    	  var expirationTimes = root.expirationTimes; // Clear the lanes that no longer have pending work

    	  var lanes = noLongerPendingLanes;

    	  while (lanes > 0) {
    	    var index = pickArbitraryLaneIndex(lanes);
    	    var lane = 1 << index;
    	    entanglements[index] = NoLanes;
    	    eventTimes[index] = NoTimestamp;
    	    expirationTimes[index] = NoTimestamp;
    	    lanes &= ~lane;
    	  }
    	}
    	function markRootEntangled(root, entangledLanes) {
    	  root.entangledLanes |= entangledLanes;
    	  var entanglements = root.entanglements;
    	  var lanes = entangledLanes;

    	  while (lanes > 0) {
    	    var index = pickArbitraryLaneIndex(lanes);
    	    var lane = 1 << index;
    	    entanglements[index] |= entangledLanes;
    	    lanes &= ~lane;
    	  }
    	}
    	var clz32 = Math.clz32 ? Math.clz32 : clz32Fallback; // Count leading zeros. Only used on lanes, so assume input is an integer.
    	// Based on:
    	// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/clz32

    	var log = Math.log;
    	var LN2 = Math.LN2;

    	function clz32Fallback(lanes) {
    	  if (lanes === 0) {
    	    return 32;
    	  }

    	  return 31 - (log(lanes) / LN2 | 0) | 0;
    	}

    	// Intentionally not named imports because Rollup would use dynamic dispatch for
    	var UserBlockingPriority$1 = Scheduler.unstable_UserBlockingPriority,
    	    runWithPriority = Scheduler.unstable_runWithPriority; // TODO: can we stop exporting these?

    	var _enabled = true; // This is exported in FB builds for use by legacy FB layer infra.
    	// We'd like to remove this but it's not clear if this is safe.

    	function setEnabled(enabled) {
    	  _enabled = !!enabled;
    	}
    	function isEnabled() {
    	  return _enabled;
    	}
    	function createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags) {
    	  var eventPriority = getEventPriorityForPluginSystem(domEventName);
    	  var listenerWrapper;

    	  switch (eventPriority) {
    	    case DiscreteEvent:
    	      listenerWrapper = dispatchDiscreteEvent;
    	      break;

    	    case UserBlockingEvent:
    	      listenerWrapper = dispatchUserBlockingUpdate;
    	      break;

    	    case ContinuousEvent:
    	    default:
    	      listenerWrapper = dispatchEvent;
    	      break;
    	  }

    	  return listenerWrapper.bind(null, domEventName, eventSystemFlags, targetContainer);
    	}

    	function dispatchDiscreteEvent(domEventName, eventSystemFlags, container, nativeEvent) {
    	  {
    	    flushDiscreteUpdatesIfNeeded(nativeEvent.timeStamp);
    	  }

    	  discreteUpdates(dispatchEvent, domEventName, eventSystemFlags, container, nativeEvent);
    	}

    	function dispatchUserBlockingUpdate(domEventName, eventSystemFlags, container, nativeEvent) {
    	  {
    	    runWithPriority(UserBlockingPriority$1, dispatchEvent.bind(null, domEventName, eventSystemFlags, container, nativeEvent));
    	  }
    	}

    	function dispatchEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  if (!_enabled) {
    	    return;
    	  }

    	  var allowReplay = true;

    	  {
    	    // TODO: replaying capture phase events is currently broken
    	    // because we used to do it during top-level native bubble handlers
    	    // but now we use different bubble and capture handlers.
    	    // In eager mode, we attach capture listeners early, so we need
    	    // to filter them out until we fix the logic to handle them correctly.
    	    // This could've been outside the flag but I put it inside to reduce risk.
    	    allowReplay = (eventSystemFlags & IS_CAPTURE_PHASE) === 0;
    	  }

    	  if (allowReplay && hasQueuedDiscreteEvents() && isReplayableDiscreteEvent(domEventName)) {
    	    // If we already have a queue of discrete events, and this is another discrete
    	    // event, then we can't dispatch it regardless of its target, since they
    	    // need to dispatch in order.
    	    queueDiscreteEvent(null, // Flags that we're not actually blocked on anything as far as we know.
    	    domEventName, eventSystemFlags, targetContainer, nativeEvent);
    	    return;
    	  }

    	  var blockedOn = attemptToDispatchEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent);

    	  if (blockedOn === null) {
    	    // We successfully dispatched this event.
    	    if (allowReplay) {
    	      clearIfContinuousEvent(domEventName, nativeEvent);
    	    }

    	    return;
    	  }

    	  if (allowReplay) {
    	    if (isReplayableDiscreteEvent(domEventName)) {
    	      // This this to be replayed later once the target is available.
    	      queueDiscreteEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent);
    	      return;
    	    }

    	    if (queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent)) {
    	      return;
    	    } // We need to clear only if we didn't queue because
    	    // queueing is accummulative.


    	    clearIfContinuousEvent(domEventName, nativeEvent);
    	  } // This is not replayable so we'll invoke it but without a target,
    	  // in case the event system needs to trace it.


    	  dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, null, targetContainer);
    	} // Attempt dispatching an event. Returns a SuspenseInstance or Container if it's blocked.

    	function attemptToDispatchEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
    	  // TODO: Warn if _enabled is false.
    	  var nativeEventTarget = getEventTarget(nativeEvent);
    	  var targetInst = getClosestInstanceFromNode(nativeEventTarget);

    	  if (targetInst !== null) {
    	    var nearestMounted = getNearestMountedFiber(targetInst);

    	    if (nearestMounted === null) {
    	      // This tree has been unmounted already. Dispatch without a target.
    	      targetInst = null;
    	    } else {
    	      var tag = nearestMounted.tag;

    	      if (tag === SuspenseComponent) {
    	        var instance = getSuspenseInstanceFromFiber(nearestMounted);

    	        if (instance !== null) {
    	          // Queue the event to be replayed later. Abort dispatching since we
    	          // don't want this event dispatched twice through the event system.
    	          // TODO: If this is the first discrete event in the queue. Schedule an increased
    	          // priority for this boundary.
    	          return instance;
    	        } // This shouldn't happen, something went wrong but to avoid blocking
    	        // the whole system, dispatch the event without a target.
    	        // TODO: Warn.


    	        targetInst = null;
    	      } else if (tag === HostRoot) {
    	        var root = nearestMounted.stateNode;

    	        if (root.hydrate) {
    	          // If this happens during a replay something went wrong and it might block
    	          // the whole system.
    	          return getContainerFromFiber(nearestMounted);
    	        }

    	        targetInst = null;
    	      } else if (nearestMounted !== targetInst) {
    	        // If we get an event (ex: img onload) before committing that
    	        // component's mount, ignore it for now (that is, treat it as if it was an
    	        // event on a non-React tree). We might also consider queueing events and
    	        // dispatching them after the mount.
    	        targetInst = null;
    	      }
    	    }
    	  }

    	  dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer); // We're not blocked on anything.

    	  return null;
    	}

    	function addEventBubbleListener(target, eventType, listener) {
    	  target.addEventListener(eventType, listener, false);
    	  return listener;
    	}
    	function addEventCaptureListener(target, eventType, listener) {
    	  target.addEventListener(eventType, listener, true);
    	  return listener;
    	}
    	function addEventCaptureListenerWithPassiveFlag(target, eventType, listener, passive) {
    	  target.addEventListener(eventType, listener, {
    	    capture: true,
    	    passive: passive
    	  });
    	  return listener;
    	}
    	function addEventBubbleListenerWithPassiveFlag(target, eventType, listener, passive) {
    	  target.addEventListener(eventType, listener, {
    	    passive: passive
    	  });
    	  return listener;
    	}

    	/**
    	 * These variables store information about text content of a target node,
    	 * allowing comparison of content before and after a given event.
    	 *
    	 * Identify the node where selection currently begins, then observe
    	 * both its text content and its current position in the DOM. Since the
    	 * browser may natively replace the target node during composition, we can
    	 * use its position to find its replacement.
    	 *
    	 *
    	 */
    	var root = null;
    	var startText = null;
    	var fallbackText = null;
    	function initialize(nativeEventTarget) {
    	  root = nativeEventTarget;
    	  startText = getText();
    	  return true;
    	}
    	function reset() {
    	  root = null;
    	  startText = null;
    	  fallbackText = null;
    	}
    	function getData() {
    	  if (fallbackText) {
    	    return fallbackText;
    	  }

    	  var start;
    	  var startValue = startText;
    	  var startLength = startValue.length;
    	  var end;
    	  var endValue = getText();
    	  var endLength = endValue.length;

    	  for (start = 0; start < startLength; start++) {
    	    if (startValue[start] !== endValue[start]) {
    	      break;
    	    }
    	  }

    	  var minEnd = startLength - start;

    	  for (end = 1; end <= minEnd; end++) {
    	    if (startValue[startLength - end] !== endValue[endLength - end]) {
    	      break;
    	    }
    	  }

    	  var sliceTail = end > 1 ? 1 - end : undefined;
    	  fallbackText = endValue.slice(start, sliceTail);
    	  return fallbackText;
    	}
    	function getText() {
    	  if ('value' in root) {
    	    return root.value;
    	  }

    	  return root.textContent;
    	}

    	/**
    	 * `charCode` represents the actual "character code" and is safe to use with
    	 * `String.fromCharCode`. As such, only keys that correspond to printable
    	 * characters produce a valid `charCode`, the only exception to this is Enter.
    	 * The Tab-key is considered non-printable and does not have a `charCode`,
    	 * presumably because it does not produce a tab-character in browsers.
    	 *
    	 * @param {object} nativeEvent Native browser event.
    	 * @return {number} Normalized `charCode` property.
    	 */
    	function getEventCharCode(nativeEvent) {
    	  var charCode;
    	  var keyCode = nativeEvent.keyCode;

    	  if ('charCode' in nativeEvent) {
    	    charCode = nativeEvent.charCode; // FF does not set `charCode` for the Enter-key, check against `keyCode`.

    	    if (charCode === 0 && keyCode === 13) {
    	      charCode = 13;
    	    }
    	  } else {
    	    // IE8 does not implement `charCode`, but `keyCode` has the correct value.
    	    charCode = keyCode;
    	  } // IE and Edge (on Windows) and Chrome / Safari (on Windows and Linux)
    	  // report Enter as charCode 10 when ctrl is pressed.


    	  if (charCode === 10) {
    	    charCode = 13;
    	  } // Some non-printable keys are reported in `charCode`/`keyCode`, discard them.
    	  // Must not discard the (non-)printable Enter-key.


    	  if (charCode >= 32 || charCode === 13) {
    	    return charCode;
    	  }

    	  return 0;
    	}

    	function functionThatReturnsTrue() {
    	  return true;
    	}

    	function functionThatReturnsFalse() {
    	  return false;
    	} // This is intentionally a factory so that we have different returned constructors.
    	// If we had a single constructor, it would be megamorphic and engines would deopt.


    	function createSyntheticEvent(Interface) {
    	  /**
    	   * Synthetic events are dispatched by event plugins, typically in response to a
    	   * top-level event delegation handler.
    	   *
    	   * These systems should generally use pooling to reduce the frequency of garbage
    	   * collection. The system should check `isPersistent` to determine whether the
    	   * event should be released into the pool after being dispatched. Users that
    	   * need a persisted event should invoke `persist`.
    	   *
    	   * Synthetic events (and subclasses) implement the DOM Level 3 Events API by
    	   * normalizing browser quirks. Subclasses do not necessarily have to implement a
    	   * DOM interface; custom application-specific events can also subclass this.
    	   */
    	  function SyntheticBaseEvent(reactName, reactEventType, targetInst, nativeEvent, nativeEventTarget) {
    	    this._reactName = reactName;
    	    this._targetInst = targetInst;
    	    this.type = reactEventType;
    	    this.nativeEvent = nativeEvent;
    	    this.target = nativeEventTarget;
    	    this.currentTarget = null;

    	    for (var _propName in Interface) {
    	      if (!Interface.hasOwnProperty(_propName)) {
    	        continue;
    	      }

    	      var normalize = Interface[_propName];

    	      if (normalize) {
    	        this[_propName] = normalize(nativeEvent);
    	      } else {
    	        this[_propName] = nativeEvent[_propName];
    	      }
    	    }

    	    var defaultPrevented = nativeEvent.defaultPrevented != null ? nativeEvent.defaultPrevented : nativeEvent.returnValue === false;

    	    if (defaultPrevented) {
    	      this.isDefaultPrevented = functionThatReturnsTrue;
    	    } else {
    	      this.isDefaultPrevented = functionThatReturnsFalse;
    	    }

    	    this.isPropagationStopped = functionThatReturnsFalse;
    	    return this;
    	  }

    	  _assign(SyntheticBaseEvent.prototype, {
    	    preventDefault: function () {
    	      this.defaultPrevented = true;
    	      var event = this.nativeEvent;

    	      if (!event) {
    	        return;
    	      }

    	      if (event.preventDefault) {
    	        event.preventDefault(); // $FlowFixMe - flow is not aware of `unknown` in IE
    	      } else if (typeof event.returnValue !== 'unknown') {
    	        event.returnValue = false;
    	      }

    	      this.isDefaultPrevented = functionThatReturnsTrue;
    	    },
    	    stopPropagation: function () {
    	      var event = this.nativeEvent;

    	      if (!event) {
    	        return;
    	      }

    	      if (event.stopPropagation) {
    	        event.stopPropagation(); // $FlowFixMe - flow is not aware of `unknown` in IE
    	      } else if (typeof event.cancelBubble !== 'unknown') {
    	        // The ChangeEventPlugin registers a "propertychange" event for
    	        // IE. This event does not support bubbling or cancelling, and
    	        // any references to cancelBubble throw "Member not found".  A
    	        // typeof check of "unknown" circumvents this issue (and is also
    	        // IE specific).
    	        event.cancelBubble = true;
    	      }

    	      this.isPropagationStopped = functionThatReturnsTrue;
    	    },

    	    /**
    	     * We release all dispatched `SyntheticEvent`s after each event loop, adding
    	     * them back into the pool. This allows a way to hold onto a reference that
    	     * won't be added back into the pool.
    	     */
    	    persist: function () {// Modern event system doesn't use pooling.
    	    },

    	    /**
    	     * Checks if this event should be released back into the pool.
    	     *
    	     * @return {boolean} True if this should not be released, false otherwise.
    	     */
    	    isPersistent: functionThatReturnsTrue
    	  });

    	  return SyntheticBaseEvent;
    	}
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */


    	var EventInterface = {
    	  eventPhase: 0,
    	  bubbles: 0,
    	  cancelable: 0,
    	  timeStamp: function (event) {
    	    return event.timeStamp || Date.now();
    	  },
    	  defaultPrevented: 0,
    	  isTrusted: 0
    	};
    	var SyntheticEvent = createSyntheticEvent(EventInterface);

    	var UIEventInterface = _assign({}, EventInterface, {
    	  view: 0,
    	  detail: 0
    	});

    	var SyntheticUIEvent = createSyntheticEvent(UIEventInterface);
    	var lastMovementX;
    	var lastMovementY;
    	var lastMouseEvent;

    	function updateMouseMovementPolyfillState(event) {
    	  if (event !== lastMouseEvent) {
    	    if (lastMouseEvent && event.type === 'mousemove') {
    	      lastMovementX = event.screenX - lastMouseEvent.screenX;
    	      lastMovementY = event.screenY - lastMouseEvent.screenY;
    	    } else {
    	      lastMovementX = 0;
    	      lastMovementY = 0;
    	    }

    	    lastMouseEvent = event;
    	  }
    	}
    	/**
    	 * @interface MouseEvent
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */


    	var MouseEventInterface = _assign({}, UIEventInterface, {
    	  screenX: 0,
    	  screenY: 0,
    	  clientX: 0,
    	  clientY: 0,
    	  pageX: 0,
    	  pageY: 0,
    	  ctrlKey: 0,
    	  shiftKey: 0,
    	  altKey: 0,
    	  metaKey: 0,
    	  getModifierState: getEventModifierState,
    	  button: 0,
    	  buttons: 0,
    	  relatedTarget: function (event) {
    	    if (event.relatedTarget === undefined) return event.fromElement === event.srcElement ? event.toElement : event.fromElement;
    	    return event.relatedTarget;
    	  },
    	  movementX: function (event) {
    	    if ('movementX' in event) {
    	      return event.movementX;
    	    }

    	    updateMouseMovementPolyfillState(event);
    	    return lastMovementX;
    	  },
    	  movementY: function (event) {
    	    if ('movementY' in event) {
    	      return event.movementY;
    	    } // Don't need to call updateMouseMovementPolyfillState() here
    	    // because it's guaranteed to have already run when movementX
    	    // was copied.


    	    return lastMovementY;
    	  }
    	});

    	var SyntheticMouseEvent = createSyntheticEvent(MouseEventInterface);
    	/**
    	 * @interface DragEvent
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */

    	var DragEventInterface = _assign({}, MouseEventInterface, {
    	  dataTransfer: 0
    	});

    	var SyntheticDragEvent = createSyntheticEvent(DragEventInterface);
    	/**
    	 * @interface FocusEvent
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */

    	var FocusEventInterface = _assign({}, UIEventInterface, {
    	  relatedTarget: 0
    	});

    	var SyntheticFocusEvent = createSyntheticEvent(FocusEventInterface);
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/css3-animations/#AnimationEvent-interface
    	 * @see https://developer.mozilla.org/en-US/docs/Web/API/AnimationEvent
    	 */

    	var AnimationEventInterface = _assign({}, EventInterface, {
    	  animationName: 0,
    	  elapsedTime: 0,
    	  pseudoElement: 0
    	});

    	var SyntheticAnimationEvent = createSyntheticEvent(AnimationEventInterface);
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/clipboard-apis/
    	 */

    	var ClipboardEventInterface = _assign({}, EventInterface, {
    	  clipboardData: function (event) {
    	    return 'clipboardData' in event ? event.clipboardData : window.clipboardData;
    	  }
    	});

    	var SyntheticClipboardEvent = createSyntheticEvent(ClipboardEventInterface);
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/#events-compositionevents
    	 */

    	var CompositionEventInterface = _assign({}, EventInterface, {
    	  data: 0
    	});

    	var SyntheticCompositionEvent = createSyntheticEvent(CompositionEventInterface);
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/2013/WD-DOM-Level-3-Events-20131105
    	 *      /#events-inputevents
    	 */
    	// Happens to share the same list for now.

    	var SyntheticInputEvent = SyntheticCompositionEvent;
    	/**
    	 * Normalization of deprecated HTML5 `key` values
    	 * @see https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent#Key_names
    	 */

    	var normalizeKey = {
    	  Esc: 'Escape',
    	  Spacebar: ' ',
    	  Left: 'ArrowLeft',
    	  Up: 'ArrowUp',
    	  Right: 'ArrowRight',
    	  Down: 'ArrowDown',
    	  Del: 'Delete',
    	  Win: 'OS',
    	  Menu: 'ContextMenu',
    	  Apps: 'ContextMenu',
    	  Scroll: 'ScrollLock',
    	  MozPrintableKey: 'Unidentified'
    	};
    	/**
    	 * Translation from legacy `keyCode` to HTML5 `key`
    	 * Only special keys supported, all others depend on keyboard layout or browser
    	 * @see https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent#Key_names
    	 */

    	var translateToKey = {
    	  '8': 'Backspace',
    	  '9': 'Tab',
    	  '12': 'Clear',
    	  '13': 'Enter',
    	  '16': 'Shift',
    	  '17': 'Control',
    	  '18': 'Alt',
    	  '19': 'Pause',
    	  '20': 'CapsLock',
    	  '27': 'Escape',
    	  '32': ' ',
    	  '33': 'PageUp',
    	  '34': 'PageDown',
    	  '35': 'End',
    	  '36': 'Home',
    	  '37': 'ArrowLeft',
    	  '38': 'ArrowUp',
    	  '39': 'ArrowRight',
    	  '40': 'ArrowDown',
    	  '45': 'Insert',
    	  '46': 'Delete',
    	  '112': 'F1',
    	  '113': 'F2',
    	  '114': 'F3',
    	  '115': 'F4',
    	  '116': 'F5',
    	  '117': 'F6',
    	  '118': 'F7',
    	  '119': 'F8',
    	  '120': 'F9',
    	  '121': 'F10',
    	  '122': 'F11',
    	  '123': 'F12',
    	  '144': 'NumLock',
    	  '145': 'ScrollLock',
    	  '224': 'Meta'
    	};
    	/**
    	 * @param {object} nativeEvent Native browser event.
    	 * @return {string} Normalized `key` property.
    	 */

    	function getEventKey(nativeEvent) {
    	  if (nativeEvent.key) {
    	    // Normalize inconsistent values reported by browsers due to
    	    // implementations of a working draft specification.
    	    // FireFox implements `key` but returns `MozPrintableKey` for all
    	    // printable characters (normalized to `Unidentified`), ignore it.
    	    var key = normalizeKey[nativeEvent.key] || nativeEvent.key;

    	    if (key !== 'Unidentified') {
    	      return key;
    	    }
    	  } // Browser does not implement `key`, polyfill as much of it as we can.


    	  if (nativeEvent.type === 'keypress') {
    	    var charCode = getEventCharCode(nativeEvent); // The enter-key is technically both printable and non-printable and can
    	    // thus be captured by `keypress`, no other non-printable key should.

    	    return charCode === 13 ? 'Enter' : String.fromCharCode(charCode);
    	  }

    	  if (nativeEvent.type === 'keydown' || nativeEvent.type === 'keyup') {
    	    // While user keyboard layout determines the actual meaning of each
    	    // `keyCode` value, almost all function keys have a universal value.
    	    return translateToKey[nativeEvent.keyCode] || 'Unidentified';
    	  }

    	  return '';
    	}
    	/**
    	 * Translation from modifier key to the associated property in the event.
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/#keys-Modifiers
    	 */


    	var modifierKeyToProp = {
    	  Alt: 'altKey',
    	  Control: 'ctrlKey',
    	  Meta: 'metaKey',
    	  Shift: 'shiftKey'
    	}; // Older browsers (Safari <= 10, iOS Safari <= 10.2) do not support
    	// getModifierState. If getModifierState is not supported, we map it to a set of
    	// modifier keys exposed by the event. In this case, Lock-keys are not supported.

    	function modifierStateGetter(keyArg) {
    	  var syntheticEvent = this;
    	  var nativeEvent = syntheticEvent.nativeEvent;

    	  if (nativeEvent.getModifierState) {
    	    return nativeEvent.getModifierState(keyArg);
    	  }

    	  var keyProp = modifierKeyToProp[keyArg];
    	  return keyProp ? !!nativeEvent[keyProp] : false;
    	}

    	function getEventModifierState(nativeEvent) {
    	  return modifierStateGetter;
    	}
    	/**
    	 * @interface KeyboardEvent
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */


    	var KeyboardEventInterface = _assign({}, UIEventInterface, {
    	  key: getEventKey,
    	  code: 0,
    	  location: 0,
    	  ctrlKey: 0,
    	  shiftKey: 0,
    	  altKey: 0,
    	  metaKey: 0,
    	  repeat: 0,
    	  locale: 0,
    	  getModifierState: getEventModifierState,
    	  // Legacy Interface
    	  charCode: function (event) {
    	    // `charCode` is the result of a KeyPress event and represents the value of
    	    // the actual printable character.
    	    // KeyPress is deprecated, but its replacement is not yet final and not
    	    // implemented in any major browser. Only KeyPress has charCode.
    	    if (event.type === 'keypress') {
    	      return getEventCharCode(event);
    	    }

    	    return 0;
    	  },
    	  keyCode: function (event) {
    	    // `keyCode` is the result of a KeyDown/Up event and represents the value of
    	    // physical keyboard key.
    	    // The actual meaning of the value depends on the users' keyboard layout
    	    // which cannot be detected. Assuming that it is a US keyboard layout
    	    // provides a surprisingly accurate mapping for US and European users.
    	    // Due to this, it is left to the user to implement at this time.
    	    if (event.type === 'keydown' || event.type === 'keyup') {
    	      return event.keyCode;
    	    }

    	    return 0;
    	  },
    	  which: function (event) {
    	    // `which` is an alias for either `keyCode` or `charCode` depending on the
    	    // type of the event.
    	    if (event.type === 'keypress') {
    	      return getEventCharCode(event);
    	    }

    	    if (event.type === 'keydown' || event.type === 'keyup') {
    	      return event.keyCode;
    	    }

    	    return 0;
    	  }
    	});

    	var SyntheticKeyboardEvent = createSyntheticEvent(KeyboardEventInterface);
    	/**
    	 * @interface PointerEvent
    	 * @see http://www.w3.org/TR/pointerevents/
    	 */

    	var PointerEventInterface = _assign({}, MouseEventInterface, {
    	  pointerId: 0,
    	  width: 0,
    	  height: 0,
    	  pressure: 0,
    	  tangentialPressure: 0,
    	  tiltX: 0,
    	  tiltY: 0,
    	  twist: 0,
    	  pointerType: 0,
    	  isPrimary: 0
    	});

    	var SyntheticPointerEvent = createSyntheticEvent(PointerEventInterface);
    	/**
    	 * @interface TouchEvent
    	 * @see http://www.w3.org/TR/touch-events/
    	 */

    	var TouchEventInterface = _assign({}, UIEventInterface, {
    	  touches: 0,
    	  targetTouches: 0,
    	  changedTouches: 0,
    	  altKey: 0,
    	  metaKey: 0,
    	  ctrlKey: 0,
    	  shiftKey: 0,
    	  getModifierState: getEventModifierState
    	});

    	var SyntheticTouchEvent = createSyntheticEvent(TouchEventInterface);
    	/**
    	 * @interface Event
    	 * @see http://www.w3.org/TR/2009/WD-css3-transitions-20090320/#transition-events-
    	 * @see https://developer.mozilla.org/en-US/docs/Web/API/TransitionEvent
    	 */

    	var TransitionEventInterface = _assign({}, EventInterface, {
    	  propertyName: 0,
    	  elapsedTime: 0,
    	  pseudoElement: 0
    	});

    	var SyntheticTransitionEvent = createSyntheticEvent(TransitionEventInterface);
    	/**
    	 * @interface WheelEvent
    	 * @see http://www.w3.org/TR/DOM-Level-3-Events/
    	 */

    	var WheelEventInterface = _assign({}, MouseEventInterface, {
    	  deltaX: function (event) {
    	    return 'deltaX' in event ? event.deltaX : // Fallback to `wheelDeltaX` for Webkit and normalize (right is positive).
    	    'wheelDeltaX' in event ? -event.wheelDeltaX : 0;
    	  },
    	  deltaY: function (event) {
    	    return 'deltaY' in event ? event.deltaY : // Fallback to `wheelDeltaY` for Webkit and normalize (down is positive).
    	    'wheelDeltaY' in event ? -event.wheelDeltaY : // Fallback to `wheelDelta` for IE<9 and normalize (down is positive).
    	    'wheelDelta' in event ? -event.wheelDelta : 0;
    	  },
    	  deltaZ: 0,
    	  // Browsers without "deltaMode" is reporting in raw wheel delta where one
    	  // notch on the scroll is always +/- 120, roughly equivalent to pixels.
    	  // A good approximation of DOM_DELTA_LINE (1) is 5% of viewport size or
    	  // ~40 pixels, for DOM_DELTA_SCREEN (2) it is 87.5% of viewport size.
    	  deltaMode: 0
    	});

    	var SyntheticWheelEvent = createSyntheticEvent(WheelEventInterface);

    	var END_KEYCODES = [9, 13, 27, 32]; // Tab, Return, Esc, Space

    	var START_KEYCODE = 229;
    	var canUseCompositionEvent = canUseDOM && 'CompositionEvent' in window;
    	var documentMode = null;

    	if (canUseDOM && 'documentMode' in document) {
    	  documentMode = document.documentMode;
    	} // Webkit offers a very useful `textInput` event that can be used to
    	// directly represent `beforeInput`. The IE `textinput` event is not as
    	// useful, so we don't use it.


    	var canUseTextInputEvent = canUseDOM && 'TextEvent' in window && !documentMode; // In IE9+, we have access to composition events, but the data supplied
    	// by the native compositionend event may be incorrect. Japanese ideographic
    	// spaces, for instance (\u3000) are not recorded correctly.

    	var useFallbackCompositionData = canUseDOM && (!canUseCompositionEvent || documentMode && documentMode > 8 && documentMode <= 11);
    	var SPACEBAR_CODE = 32;
    	var SPACEBAR_CHAR = String.fromCharCode(SPACEBAR_CODE);

    	function registerEvents() {
    	  registerTwoPhaseEvent('onBeforeInput', ['compositionend', 'keypress', 'textInput', 'paste']);
    	  registerTwoPhaseEvent('onCompositionEnd', ['compositionend', 'focusout', 'keydown', 'keypress', 'keyup', 'mousedown']);
    	  registerTwoPhaseEvent('onCompositionStart', ['compositionstart', 'focusout', 'keydown', 'keypress', 'keyup', 'mousedown']);
    	  registerTwoPhaseEvent('onCompositionUpdate', ['compositionupdate', 'focusout', 'keydown', 'keypress', 'keyup', 'mousedown']);
    	} // Track whether we've ever handled a keypress on the space key.


    	var hasSpaceKeypress = false;
    	/**
    	 * Return whether a native keypress event is assumed to be a command.
    	 * This is required because Firefox fires `keypress` events for key commands
    	 * (cut, copy, select-all, etc.) even though no character is inserted.
    	 */

    	function isKeypressCommand(nativeEvent) {
    	  return (nativeEvent.ctrlKey || nativeEvent.altKey || nativeEvent.metaKey) && // ctrlKey && altKey is equivalent to AltGr, and is not a command.
    	  !(nativeEvent.ctrlKey && nativeEvent.altKey);
    	}
    	/**
    	 * Translate native top level events into event types.
    	 */


    	function getCompositionEventType(domEventName) {
    	  switch (domEventName) {
    	    case 'compositionstart':
    	      return 'onCompositionStart';

    	    case 'compositionend':
    	      return 'onCompositionEnd';

    	    case 'compositionupdate':
    	      return 'onCompositionUpdate';
    	  }
    	}
    	/**
    	 * Does our fallback best-guess model think this event signifies that
    	 * composition has begun?
    	 */


    	function isFallbackCompositionStart(domEventName, nativeEvent) {
    	  return domEventName === 'keydown' && nativeEvent.keyCode === START_KEYCODE;
    	}
    	/**
    	 * Does our fallback mode think that this event is the end of composition?
    	 */


    	function isFallbackCompositionEnd(domEventName, nativeEvent) {
    	  switch (domEventName) {
    	    case 'keyup':
    	      // Command keys insert or clear IME input.
    	      return END_KEYCODES.indexOf(nativeEvent.keyCode) !== -1;

    	    case 'keydown':
    	      // Expect IME keyCode on each keydown. If we get any other
    	      // code we must have exited earlier.
    	      return nativeEvent.keyCode !== START_KEYCODE;

    	    case 'keypress':
    	    case 'mousedown':
    	    case 'focusout':
    	      // Events are not possible without cancelling IME.
    	      return true;

    	    default:
    	      return false;
    	  }
    	}
    	/**
    	 * Google Input Tools provides composition data via a CustomEvent,
    	 * with the `data` property populated in the `detail` object. If this
    	 * is available on the event object, use it. If not, this is a plain
    	 * composition event and we have nothing special to extract.
    	 *
    	 * @param {object} nativeEvent
    	 * @return {?string}
    	 */


    	function getDataFromCustomEvent(nativeEvent) {
    	  var detail = nativeEvent.detail;

    	  if (typeof detail === 'object' && 'data' in detail) {
    	    return detail.data;
    	  }

    	  return null;
    	}
    	/**
    	 * Check if a composition event was triggered by Korean IME.
    	 * Our fallback mode does not work well with IE's Korean IME,
    	 * so just use native composition events when Korean IME is used.
    	 * Although CompositionEvent.locale property is deprecated,
    	 * it is available in IE, where our fallback mode is enabled.
    	 *
    	 * @param {object} nativeEvent
    	 * @return {boolean}
    	 */


    	function isUsingKoreanIME(nativeEvent) {
    	  return nativeEvent.locale === 'ko';
    	} // Track the current IME composition status, if any.


    	var isComposing = false;
    	/**
    	 * @return {?object} A SyntheticCompositionEvent.
    	 */

    	function extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
    	  var eventType;
    	  var fallbackData;

    	  if (canUseCompositionEvent) {
    	    eventType = getCompositionEventType(domEventName);
    	  } else if (!isComposing) {
    	    if (isFallbackCompositionStart(domEventName, nativeEvent)) {
    	      eventType = 'onCompositionStart';
    	    }
    	  } else if (isFallbackCompositionEnd(domEventName, nativeEvent)) {
    	    eventType = 'onCompositionEnd';
    	  }

    	  if (!eventType) {
    	    return null;
    	  }

    	  if (useFallbackCompositionData && !isUsingKoreanIME(nativeEvent)) {
    	    // The current composition is stored statically and must not be
    	    // overwritten while composition continues.
    	    if (!isComposing && eventType === 'onCompositionStart') {
    	      isComposing = initialize(nativeEventTarget);
    	    } else if (eventType === 'onCompositionEnd') {
    	      if (isComposing) {
    	        fallbackData = getData();
    	      }
    	    }
    	  }

    	  var listeners = accumulateTwoPhaseListeners(targetInst, eventType);

    	  if (listeners.length > 0) {
    	    var event = new SyntheticCompositionEvent(eventType, domEventName, null, nativeEvent, nativeEventTarget);
    	    dispatchQueue.push({
    	      event: event,
    	      listeners: listeners
    	    });

    	    if (fallbackData) {
    	      // Inject data generated from fallback path into the synthetic event.
    	      // This matches the property of native CompositionEventInterface.
    	      event.data = fallbackData;
    	    } else {
    	      var customData = getDataFromCustomEvent(nativeEvent);

    	      if (customData !== null) {
    	        event.data = customData;
    	      }
    	    }
    	  }
    	}

    	function getNativeBeforeInputChars(domEventName, nativeEvent) {
    	  switch (domEventName) {
    	    case 'compositionend':
    	      return getDataFromCustomEvent(nativeEvent);

    	    case 'keypress':
    	      /**
    	       * If native `textInput` events are available, our goal is to make
    	       * use of them. However, there is a special case: the spacebar key.
    	       * In Webkit, preventing default on a spacebar `textInput` event
    	       * cancels character insertion, but it *also* causes the browser
    	       * to fall back to its default spacebar behavior of scrolling the
    	       * page.
    	       *
    	       * Tracking at:
    	       * https://code.google.com/p/chromium/issues/detail?id=355103
    	       *
    	       * To avoid this issue, use the keypress event as if no `textInput`
    	       * event is available.
    	       */
    	      var which = nativeEvent.which;

    	      if (which !== SPACEBAR_CODE) {
    	        return null;
    	      }

    	      hasSpaceKeypress = true;
    	      return SPACEBAR_CHAR;

    	    case 'textInput':
    	      // Record the characters to be added to the DOM.
    	      var chars = nativeEvent.data; // If it's a spacebar character, assume that we have already handled
    	      // it at the keypress level and bail immediately. Android Chrome
    	      // doesn't give us keycodes, so we need to ignore it.

    	      if (chars === SPACEBAR_CHAR && hasSpaceKeypress) {
    	        return null;
    	      }

    	      return chars;

    	    default:
    	      // For other native event types, do nothing.
    	      return null;
    	  }
    	}
    	/**
    	 * For browsers that do not provide the `textInput` event, extract the
    	 * appropriate string to use for SyntheticInputEvent.
    	 */


    	function getFallbackBeforeInputChars(domEventName, nativeEvent) {
    	  // If we are currently composing (IME) and using a fallback to do so,
    	  // try to extract the composed characters from the fallback object.
    	  // If composition event is available, we extract a string only at
    	  // compositionevent, otherwise extract it at fallback events.
    	  if (isComposing) {
    	    if (domEventName === 'compositionend' || !canUseCompositionEvent && isFallbackCompositionEnd(domEventName, nativeEvent)) {
    	      var chars = getData();
    	      reset();
    	      isComposing = false;
    	      return chars;
    	    }

    	    return null;
    	  }

    	  switch (domEventName) {
    	    case 'paste':
    	      // If a paste event occurs after a keypress, throw out the input
    	      // chars. Paste events should not lead to BeforeInput events.
    	      return null;

    	    case 'keypress':
    	      /**
    	       * As of v27, Firefox may fire keypress events even when no character
    	       * will be inserted. A few possibilities:
    	       *
    	       * - `which` is `0`. Arrow keys, Esc key, etc.
    	       *
    	       * - `which` is the pressed key code, but no char is available.
    	       *   Ex: 'AltGr + d` in Polish. There is no modified character for
    	       *   this key combination and no character is inserted into the
    	       *   document, but FF fires the keypress for char code `100` anyway.
    	       *   No `input` event will occur.
    	       *
    	       * - `which` is the pressed key code, but a command combination is
    	       *   being used. Ex: `Cmd+C`. No character is inserted, and no
    	       *   `input` event will occur.
    	       */
    	      if (!isKeypressCommand(nativeEvent)) {
    	        // IE fires the `keypress` event when a user types an emoji via
    	        // Touch keyboard of Windows.  In such a case, the `char` property
    	        // holds an emoji character like `\uD83D\uDE0A`.  Because its length
    	        // is 2, the property `which` does not represent an emoji correctly.
    	        // In such a case, we directly return the `char` property instead of
    	        // using `which`.
    	        if (nativeEvent.char && nativeEvent.char.length > 1) {
    	          return nativeEvent.char;
    	        } else if (nativeEvent.which) {
    	          return String.fromCharCode(nativeEvent.which);
    	        }
    	      }

    	      return null;

    	    case 'compositionend':
    	      return useFallbackCompositionData && !isUsingKoreanIME(nativeEvent) ? null : nativeEvent.data;

    	    default:
    	      return null;
    	  }
    	}
    	/**
    	 * Extract a SyntheticInputEvent for `beforeInput`, based on either native
    	 * `textInput` or fallback behavior.
    	 *
    	 * @return {?object} A SyntheticInputEvent.
    	 */


    	function extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
    	  var chars;

    	  if (canUseTextInputEvent) {
    	    chars = getNativeBeforeInputChars(domEventName, nativeEvent);
    	  } else {
    	    chars = getFallbackBeforeInputChars(domEventName, nativeEvent);
    	  } // If no characters are being inserted, no BeforeInput event should
    	  // be fired.


    	  if (!chars) {
    	    return null;
    	  }

    	  var listeners = accumulateTwoPhaseListeners(targetInst, 'onBeforeInput');

    	  if (listeners.length > 0) {
    	    var event = new SyntheticInputEvent('onBeforeInput', 'beforeinput', null, nativeEvent, nativeEventTarget);
    	    dispatchQueue.push({
    	      event: event,
    	      listeners: listeners
    	    });
    	    event.data = chars;
    	  }
    	}
    	/**
    	 * Create an `onBeforeInput` event to match
    	 * http://www.w3.org/TR/2013/WD-DOM-Level-3-Events-20131105/#events-inputevents.
    	 *
    	 * This event plugin is based on the native `textInput` event
    	 * available in Chrome, Safari, Opera, and IE. This event fires after
    	 * `onKeyPress` and `onCompositionEnd`, but before `onInput`.
    	 *
    	 * `beforeInput` is spec'd but not implemented in any browsers, and
    	 * the `input` event does not provide any useful information about what has
    	 * actually been added, contrary to the spec. Thus, `textInput` is the best
    	 * available event to identify the characters that have actually been inserted
    	 * into the target node.
    	 *
    	 * This plugin is also responsible for emitting `composition` events, thus
    	 * allowing us to share composition fallback code for both `beforeInput` and
    	 * `composition` event types.
    	 */


    	function extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
    	  extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
    	  extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
    	}

    	/**
    	 * @see http://www.whatwg.org/specs/web-apps/current-work/multipage/the-input-element.html#input-type-attr-summary
    	 */
    	var supportedInputTypes = {
    	  color: true,
    	  date: true,
    	  datetime: true,
    	  'datetime-local': true,
    	  email: true,
    	  month: true,
    	  number: true,
    	  password: true,
    	  range: true,
    	  search: true,
    	  tel: true,
    	  text: true,
    	  time: true,
    	  url: true,
    	  week: true
    	};

    	function isTextInputElement(elem) {
    	  var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();

    	  if (nodeName === 'input') {
    	    return !!supportedInputTypes[elem.type];
    	  }

    	  if (nodeName === 'textarea') {
    	    return true;
    	  }

    	  return false;
    	}

    	/**
    	 * Checks if an event is supported in the current execution environment.
    	 *
    	 * NOTE: This will not work correctly for non-generic events such as `change`,
    	 * `reset`, `load`, `error`, and `select`.
    	 *
    	 * Borrows from Modernizr.
    	 *
    	 * @param {string} eventNameSuffix Event name, e.g. "click".
    	 * @return {boolean} True if the event is supported.
    	 * @internal
    	 * @license Modernizr 3.0.0pre (Custom Build) | MIT
    	 */

    	function isEventSupported(eventNameSuffix) {
    	  if (!canUseDOM) {
    	    return false;
    	  }

    	  var eventName = 'on' + eventNameSuffix;
    	  var isSupported = (eventName in document);

    	  if (!isSupported) {
    	    var element = document.createElement('div');
    	    element.setAttribute(eventName, 'return;');
    	    isSupported = typeof element[eventName] === 'function';
    	  }

    	  return isSupported;
    	}

    	function registerEvents$1() {
    	  registerTwoPhaseEvent('onChange', ['change', 'click', 'focusin', 'focusout', 'input', 'keydown', 'keyup', 'selectionchange']);
    	}

    	function createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, target) {
    	  // Flag this event loop as needing state restore.
    	  enqueueStateRestore(target);
    	  var listeners = accumulateTwoPhaseListeners(inst, 'onChange');

    	  if (listeners.length > 0) {
    	    var event = new SyntheticEvent('onChange', 'change', null, nativeEvent, target);
    	    dispatchQueue.push({
    	      event: event,
    	      listeners: listeners
    	    });
    	  }
    	}
    	/**
    	 * For IE shims
    	 */


    	var activeElement = null;
    	var activeElementInst = null;
    	/**
    	 * SECTION: handle `change` event
    	 */

    	function shouldUseChangeEvent(elem) {
    	  var nodeName = elem.nodeName && elem.nodeName.toLowerCase();
    	  return nodeName === 'select' || nodeName === 'input' && elem.type === 'file';
    	}

    	function manualDispatchChangeEvent(nativeEvent) {
    	  var dispatchQueue = [];
    	  createAndAccumulateChangeEvent(dispatchQueue, activeElementInst, nativeEvent, getEventTarget(nativeEvent)); // If change and propertychange bubbled, we'd just bind to it like all the
    	  // other events and have it go through ReactBrowserEventEmitter. Since it
    	  // doesn't, we manually listen for the events and so we have to enqueue and
    	  // process the abstract event manually.
    	  //
    	  // Batching is necessary here in order to ensure that all event handlers run
    	  // before the next rerender (including event handlers attached to ancestor
    	  // elements instead of directly on the input). Without this, controlled
    	  // components don't work properly in conjunction with event bubbling because
    	  // the component is rerendered and the value reverted before all the event
    	  // handlers can run. See https://github.com/facebook/react/issues/708.

    	  batchedUpdates(runEventInBatch, dispatchQueue);
    	}

    	function runEventInBatch(dispatchQueue) {
    	  processDispatchQueue(dispatchQueue, 0);
    	}

    	function getInstIfValueChanged(targetInst) {
    	  var targetNode = getNodeFromInstance(targetInst);

    	  if (updateValueIfChanged(targetNode)) {
    	    return targetInst;
    	  }
    	}

    	function getTargetInstForChangeEvent(domEventName, targetInst) {
    	  if (domEventName === 'change') {
    	    return targetInst;
    	  }
    	}
    	/**
    	 * SECTION: handle `input` event
    	 */


    	var isInputEventSupported = false;

    	if (canUseDOM) {
    	  // IE9 claims to support the input event but fails to trigger it when
    	  // deleting text, so we ignore its input events.
    	  isInputEventSupported = isEventSupported('input') && (!document.documentMode || document.documentMode > 9);
    	}
    	/**
    	 * (For IE <=9) Starts tracking propertychange events on the passed-in element
    	 * and override the value property so that we can distinguish user events from
    	 * value changes in JS.
    	 */


    	function startWatchingForValueChange(target, targetInst) {
    	  activeElement = target;
    	  activeElementInst = targetInst;
    	  activeElement.attachEvent('onpropertychange', handlePropertyChange);
    	}
    	/**
    	 * (For IE <=9) Removes the event listeners from the currently-tracked element,
    	 * if any exists.
    	 */


    	function stopWatchingForValueChange() {
    	  if (!activeElement) {
    	    return;
    	  }

    	  activeElement.detachEvent('onpropertychange', handlePropertyChange);
    	  activeElement = null;
    	  activeElementInst = null;
    	}
    	/**
    	 * (For IE <=9) Handles a propertychange event, sending a `change` event if
    	 * the value of the active element has changed.
    	 */


    	function handlePropertyChange(nativeEvent) {
    	  if (nativeEvent.propertyName !== 'value') {
    	    return;
    	  }

    	  if (getInstIfValueChanged(activeElementInst)) {
    	    manualDispatchChangeEvent(nativeEvent);
    	  }
    	}

    	function handleEventsForInputEventPolyfill(domEventName, target, targetInst) {
    	  if (domEventName === 'focusin') {
    	    // In IE9, propertychange fires for most input events but is buggy and
    	    // doesn't fire when text is deleted, but conveniently, selectionchange
    	    // appears to fire in all of the remaining cases so we catch those and
    	    // forward the event if the value has changed
    	    // In either case, we don't want to call the event handler if the value
    	    // is changed from JS so we redefine a setter for `.value` that updates
    	    // our activeElementValue variable, allowing us to ignore those changes
    	    //
    	    // stopWatching() should be a noop here but we call it just in case we
    	    // missed a blur event somehow.
    	    stopWatchingForValueChange();
    	    startWatchingForValueChange(target, targetInst);
    	  } else if (domEventName === 'focusout') {
    	    stopWatchingForValueChange();
    	  }
    	} // For IE8 and IE9.


    	function getTargetInstForInputEventPolyfill(domEventName, targetInst) {
    	  if (domEventName === 'selectionchange' || domEventName === 'keyup' || domEventName === 'keydown') {
    	    // On the selectionchange event, the target is just document which isn't
    	    // helpful for us so just check activeElement instead.
    	    //
    	    // 99% of the time, keydown and keyup aren't necessary. IE8 fails to fire
    	    // propertychange on the first input event after setting `value` from a
    	    // script and fires only keydown, keypress, keyup. Catching keyup usually
    	    // gets it and catching keydown lets us fire an event for the first
    	    // keystroke if user does a key repeat (it'll be a little delayed: right
    	    // before the second keystroke). Other input methods (e.g., paste) seem to
    	    // fire selectionchange normally.
    	    return getInstIfValueChanged(activeElementInst);
    	  }
    	}
    	/**
    	 * SECTION: handle `click` event
    	 */


    	function shouldUseClickEvent(elem) {
    	  // Use the `click` event to detect changes to checkbox and radio inputs.
    	  // This approach works across all browsers, whereas `change` does not fire
    	  // until `blur` in IE8.
    	  var nodeName = elem.nodeName;
    	  return nodeName && nodeName.toLowerCase() === 'input' && (elem.type === 'checkbox' || elem.type === 'radio');
    	}

    	function getTargetInstForClickEvent(domEventName, targetInst) {
    	  if (domEventName === 'click') {
    	    return getInstIfValueChanged(targetInst);
    	  }
    	}

    	function getTargetInstForInputOrChangeEvent(domEventName, targetInst) {
    	  if (domEventName === 'input' || domEventName === 'change') {
    	    return getInstIfValueChanged(targetInst);
    	  }
    	}

    	function handleControlledInputBlur(node) {
    	  var state = node._wrapperState;

    	  if (!state || !state.controlled || node.type !== 'number') {
    	    return;
    	  }

    	  {
    	    // If controlled, assign the value attribute to the current value on blur
    	    setDefaultValue(node, 'number', node.value);
    	  }
    	}
    	/**
    	 * This plugin creates an `onChange` event that normalizes change events
    	 * across form elements. This event fires at a time when it's possible to
    	 * change the element's value without seeing a flicker.
    	 *
    	 * Supported elements are:
    	 * - input (see `isTextInputElement`)
    	 * - textarea
    	 * - select
    	 */


    	function extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
    	  var targetNode = targetInst ? getNodeFromInstance(targetInst) : window;
    	  var getTargetInstFunc, handleEventFunc;

    	  if (shouldUseChangeEvent(targetNode)) {
    	    getTargetInstFunc = getTargetInstForChangeEvent;
    	  } else if (isTextInputElement(targetNode)) {
    	    if (isInputEventSupported) {
    	      getTargetInstFunc = getTargetInstForInputOrChangeEvent;
    	    } else {
    	      getTargetInstFunc = getTargetInstForInputEventPolyfill;
    	      handleEventFunc = handleEventsForInputEventPolyfill;
    	    }
    	  } else if (shouldUseClickEvent(targetNode)) {
    	    getTargetInstFunc = getTargetInstForClickEvent;
    	  }

    	  if (getTargetInstFunc) {
    	    var inst = getTargetInstFunc(domEventName, targetInst);

    	    if (inst) {
    	      createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, nativeEventTarget);
    	      return;
    	    }
    	  }

    	  if (handleEventFunc) {
    	    handleEventFunc(domEventName, targetNode, targetInst);
    	  } // When blurring, set the value attribute for number inputs


    	  if (domEventName === 'focusout') {
    	    handleControlledInputBlur(targetNode);
    	  }
    	}

    	function registerEvents$2() {
    	  registerDirectEvent('onMouseEnter', ['mouseout', 'mouseover']);
    	  registerDirectEvent('onMouseLeave', ['mouseout', 'mouseover']);
    	  registerDirectEvent('onPointerEnter', ['pointerout', 'pointerover']);
    	  registerDirectEvent('onPointerLeave', ['pointerout', 'pointerover']);
    	}
    	/**
    	 * For almost every interaction we care about, there will be both a top-level
    	 * `mouseover` and `mouseout` event that occurs. Only use `mouseout` so that
    	 * we do not extract duplicate events. However, moving the mouse into the
    	 * browser from outside will not fire a `mouseout` event. In this case, we use
    	 * the `mouseover` top-level event.
    	 */


    	function extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
    	  var isOverEvent = domEventName === 'mouseover' || domEventName === 'pointerover';
    	  var isOutEvent = domEventName === 'mouseout' || domEventName === 'pointerout';

    	  if (isOverEvent && (eventSystemFlags & IS_REPLAYED) === 0) {
    	    // If this is an over event with a target, we might have already dispatched
    	    // the event in the out event of the other target. If this is replayed,
    	    // then it's because we couldn't dispatch against this target previously
    	    // so we have to do it now instead.
    	    var related = nativeEvent.relatedTarget || nativeEvent.fromElement;

    	    if (related) {
    	      // If the related node is managed by React, we can assume that we have
    	      // already dispatched the corresponding events during its mouseout.
    	      if (getClosestInstanceFromNode(related) || isContainerMarkedAsRoot(related)) {
    	        return;
    	      }
    	    }
    	  }

    	  if (!isOutEvent && !isOverEvent) {
    	    // Must not be a mouse or pointer in or out - ignoring.
    	    return;
    	  }

    	  var win; // TODO: why is this nullable in the types but we read from it?

    	  if (nativeEventTarget.window === nativeEventTarget) {
    	    // `nativeEventTarget` is probably a window object.
    	    win = nativeEventTarget;
    	  } else {
    	    // TODO: Figure out why `ownerDocument` is sometimes undefined in IE8.
    	    var doc = nativeEventTarget.ownerDocument;

    	    if (doc) {
    	      win = doc.defaultView || doc.parentWindow;
    	    } else {
    	      win = window;
    	    }
    	  }

    	  var from;
    	  var to;

    	  if (isOutEvent) {
    	    var _related = nativeEvent.relatedTarget || nativeEvent.toElement;

    	    from = targetInst;
    	    to = _related ? getClosestInstanceFromNode(_related) : null;

    	    if (to !== null) {
    	      var nearestMounted = getNearestMountedFiber(to);

    	      if (to !== nearestMounted || to.tag !== HostComponent && to.tag !== HostText) {
    	        to = null;
    	      }
    	    }
    	  } else {
    	    // Moving to a node from outside the window.
    	    from = null;
    	    to = targetInst;
    	  }

    	  if (from === to) {
    	    // Nothing pertains to our managed components.
    	    return;
    	  }

    	  var SyntheticEventCtor = SyntheticMouseEvent;
    	  var leaveEventType = 'onMouseLeave';
    	  var enterEventType = 'onMouseEnter';
    	  var eventTypePrefix = 'mouse';

    	  if (domEventName === 'pointerout' || domEventName === 'pointerover') {
    	    SyntheticEventCtor = SyntheticPointerEvent;
    	    leaveEventType = 'onPointerLeave';
    	    enterEventType = 'onPointerEnter';
    	    eventTypePrefix = 'pointer';
    	  }

    	  var fromNode = from == null ? win : getNodeFromInstance(from);
    	  var toNode = to == null ? win : getNodeFromInstance(to);
    	  var leave = new SyntheticEventCtor(leaveEventType, eventTypePrefix + 'leave', from, nativeEvent, nativeEventTarget);
    	  leave.target = fromNode;
    	  leave.relatedTarget = toNode;
    	  var enter = null; // We should only process this nativeEvent if we are processing
    	  // the first ancestor. Next time, we will ignore the event.

    	  var nativeTargetInst = getClosestInstanceFromNode(nativeEventTarget);

    	  if (nativeTargetInst === targetInst) {
    	    var enterEvent = new SyntheticEventCtor(enterEventType, eventTypePrefix + 'enter', to, nativeEvent, nativeEventTarget);
    	    enterEvent.target = toNode;
    	    enterEvent.relatedTarget = fromNode;
    	    enter = enterEvent;
    	  }

    	  accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leave, enter, from, to);
    	}

    	/**
    	 * inlined Object.is polyfill to avoid requiring consumers ship their own
    	 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    	 */
    	function is(x, y) {
    	  return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y // eslint-disable-line no-self-compare
    	  ;
    	}

    	var objectIs = typeof Object.is === 'function' ? Object.is : is;

    	var hasOwnProperty$2 = Object.prototype.hasOwnProperty;
    	/**
    	 * Performs equality by iterating through keys on an object and returning false
    	 * when any key has values which are not strictly equal between the arguments.
    	 * Returns true when the values of all keys are strictly equal.
    	 */

    	function shallowEqual(objA, objB) {
    	  if (objectIs(objA, objB)) {
    	    return true;
    	  }

    	  if (typeof objA !== 'object' || objA === null || typeof objB !== 'object' || objB === null) {
    	    return false;
    	  }

    	  var keysA = Object.keys(objA);
    	  var keysB = Object.keys(objB);

    	  if (keysA.length !== keysB.length) {
    	    return false;
    	  } // Test for A's keys different from B.


    	  for (var i = 0; i < keysA.length; i++) {
    	    if (!hasOwnProperty$2.call(objB, keysA[i]) || !objectIs(objA[keysA[i]], objB[keysA[i]])) {
    	      return false;
    	    }
    	  }

    	  return true;
    	}

    	/**
    	 * Given any node return the first leaf node without children.
    	 *
    	 * @param {DOMElement|DOMTextNode} node
    	 * @return {DOMElement|DOMTextNode}
    	 */

    	function getLeafNode(node) {
    	  while (node && node.firstChild) {
    	    node = node.firstChild;
    	  }

    	  return node;
    	}
    	/**
    	 * Get the next sibling within a container. This will walk up the
    	 * DOM if a node's siblings have been exhausted.
    	 *
    	 * @param {DOMElement|DOMTextNode} node
    	 * @return {?DOMElement|DOMTextNode}
    	 */


    	function getSiblingNode(node) {
    	  while (node) {
    	    if (node.nextSibling) {
    	      return node.nextSibling;
    	    }

    	    node = node.parentNode;
    	  }
    	}
    	/**
    	 * Get object describing the nodes which contain characters at offset.
    	 *
    	 * @param {DOMElement|DOMTextNode} root
    	 * @param {number} offset
    	 * @return {?object}
    	 */


    	function getNodeForCharacterOffset(root, offset) {
    	  var node = getLeafNode(root);
    	  var nodeStart = 0;
    	  var nodeEnd = 0;

    	  while (node) {
    	    if (node.nodeType === TEXT_NODE) {
    	      nodeEnd = nodeStart + node.textContent.length;

    	      if (nodeStart <= offset && nodeEnd >= offset) {
    	        return {
    	          node: node,
    	          offset: offset - nodeStart
    	        };
    	      }

    	      nodeStart = nodeEnd;
    	    }

    	    node = getLeafNode(getSiblingNode(node));
    	  }
    	}

    	/**
    	 * @param {DOMElement} outerNode
    	 * @return {?object}
    	 */

    	function getOffsets(outerNode) {
    	  var ownerDocument = outerNode.ownerDocument;
    	  var win = ownerDocument && ownerDocument.defaultView || window;
    	  var selection = win.getSelection && win.getSelection();

    	  if (!selection || selection.rangeCount === 0) {
    	    return null;
    	  }

    	  var anchorNode = selection.anchorNode,
    	      anchorOffset = selection.anchorOffset,
    	      focusNode = selection.focusNode,
    	      focusOffset = selection.focusOffset; // In Firefox, anchorNode and focusNode can be "anonymous divs", e.g. the
    	  // up/down buttons on an <input type="number">. Anonymous divs do not seem to
    	  // expose properties, triggering a "Permission denied error" if any of its
    	  // properties are accessed. The only seemingly possible way to avoid erroring
    	  // is to access a property that typically works for non-anonymous divs and
    	  // catch any error that may otherwise arise. See
    	  // https://bugzilla.mozilla.org/show_bug.cgi?id=208427

    	  try {
    	    /* eslint-disable no-unused-expressions */
    	    anchorNode.nodeType;
    	    focusNode.nodeType;
    	    /* eslint-enable no-unused-expressions */
    	  } catch (e) {
    	    return null;
    	  }

    	  return getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset);
    	}
    	/**
    	 * Returns {start, end} where `start` is the character/codepoint index of
    	 * (anchorNode, anchorOffset) within the textContent of `outerNode`, and
    	 * `end` is the index of (focusNode, focusOffset).
    	 *
    	 * Returns null if you pass in garbage input but we should probably just crash.
    	 *
    	 * Exported only for testing.
    	 */

    	function getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset) {
    	  var length = 0;
    	  var start = -1;
    	  var end = -1;
    	  var indexWithinAnchor = 0;
    	  var indexWithinFocus = 0;
    	  var node = outerNode;
    	  var parentNode = null;

    	  outer: while (true) {
    	    var next = null;

    	    while (true) {
    	      if (node === anchorNode && (anchorOffset === 0 || node.nodeType === TEXT_NODE)) {
    	        start = length + anchorOffset;
    	      }

    	      if (node === focusNode && (focusOffset === 0 || node.nodeType === TEXT_NODE)) {
    	        end = length + focusOffset;
    	      }

    	      if (node.nodeType === TEXT_NODE) {
    	        length += node.nodeValue.length;
    	      }

    	      if ((next = node.firstChild) === null) {
    	        break;
    	      } // Moving from `node` to its first child `next`.


    	      parentNode = node;
    	      node = next;
    	    }

    	    while (true) {
    	      if (node === outerNode) {
    	        // If `outerNode` has children, this is always the second time visiting
    	        // it. If it has no children, this is still the first loop, and the only
    	        // valid selection is anchorNode and focusNode both equal to this node
    	        // and both offsets 0, in which case we will have handled above.
    	        break outer;
    	      }

    	      if (parentNode === anchorNode && ++indexWithinAnchor === anchorOffset) {
    	        start = length;
    	      }

    	      if (parentNode === focusNode && ++indexWithinFocus === focusOffset) {
    	        end = length;
    	      }

    	      if ((next = node.nextSibling) !== null) {
    	        break;
    	      }

    	      node = parentNode;
    	      parentNode = node.parentNode;
    	    } // Moving from `node` to its next sibling `next`.


    	    node = next;
    	  }

    	  if (start === -1 || end === -1) {
    	    // This should never happen. (Would happen if the anchor/focus nodes aren't
    	    // actually inside the passed-in node.)
    	    return null;
    	  }

    	  return {
    	    start: start,
    	    end: end
    	  };
    	}
    	/**
    	 * In modern non-IE browsers, we can support both forward and backward
    	 * selections.
    	 *
    	 * Note: IE10+ supports the Selection object, but it does not support
    	 * the `extend` method, which means that even in modern IE, it's not possible
    	 * to programmatically create a backward selection. Thus, for all IE
    	 * versions, we use the old IE API to create our selections.
    	 *
    	 * @param {DOMElement|DOMTextNode} node
    	 * @param {object} offsets
    	 */

    	function setOffsets(node, offsets) {
    	  var doc = node.ownerDocument || document;
    	  var win = doc && doc.defaultView || window; // Edge fails with "Object expected" in some scenarios.
    	  // (For instance: TinyMCE editor used in a list component that supports pasting to add more,
    	  // fails when pasting 100+ items)

    	  if (!win.getSelection) {
    	    return;
    	  }

    	  var selection = win.getSelection();
    	  var length = node.textContent.length;
    	  var start = Math.min(offsets.start, length);
    	  var end = offsets.end === undefined ? start : Math.min(offsets.end, length); // IE 11 uses modern selection, but doesn't support the extend method.
    	  // Flip backward selections, so we can set with a single range.

    	  if (!selection.extend && start > end) {
    	    var temp = end;
    	    end = start;
    	    start = temp;
    	  }

    	  var startMarker = getNodeForCharacterOffset(node, start);
    	  var endMarker = getNodeForCharacterOffset(node, end);

    	  if (startMarker && endMarker) {
    	    if (selection.rangeCount === 1 && selection.anchorNode === startMarker.node && selection.anchorOffset === startMarker.offset && selection.focusNode === endMarker.node && selection.focusOffset === endMarker.offset) {
    	      return;
    	    }

    	    var range = doc.createRange();
    	    range.setStart(startMarker.node, startMarker.offset);
    	    selection.removeAllRanges();

    	    if (start > end) {
    	      selection.addRange(range);
    	      selection.extend(endMarker.node, endMarker.offset);
    	    } else {
    	      range.setEnd(endMarker.node, endMarker.offset);
    	      selection.addRange(range);
    	    }
    	  }
    	}

    	function isTextNode(node) {
    	  return node && node.nodeType === TEXT_NODE;
    	}

    	function containsNode(outerNode, innerNode) {
    	  if (!outerNode || !innerNode) {
    	    return false;
    	  } else if (outerNode === innerNode) {
    	    return true;
    	  } else if (isTextNode(outerNode)) {
    	    return false;
    	  } else if (isTextNode(innerNode)) {
    	    return containsNode(outerNode, innerNode.parentNode);
    	  } else if ('contains' in outerNode) {
    	    return outerNode.contains(innerNode);
    	  } else if (outerNode.compareDocumentPosition) {
    	    return !!(outerNode.compareDocumentPosition(innerNode) & 16);
    	  } else {
    	    return false;
    	  }
    	}

    	function isInDocument(node) {
    	  return node && node.ownerDocument && containsNode(node.ownerDocument.documentElement, node);
    	}

    	function isSameOriginFrame(iframe) {
    	  try {
    	    // Accessing the contentDocument of a HTMLIframeElement can cause the browser
    	    // to throw, e.g. if it has a cross-origin src attribute.
    	    // Safari will show an error in the console when the access results in "Blocked a frame with origin". e.g:
    	    // iframe.contentDocument.defaultView;
    	    // A safety way is to access one of the cross origin properties: Window or Location
    	    // Which might result in "SecurityError" DOM Exception and it is compatible to Safari.
    	    // https://html.spec.whatwg.org/multipage/browsers.html#integration-with-idl
    	    return typeof iframe.contentWindow.location.href === 'string';
    	  } catch (err) {
    	    return false;
    	  }
    	}

    	function getActiveElementDeep() {
    	  var win = window;
    	  var element = getActiveElement();

    	  while (element instanceof win.HTMLIFrameElement) {
    	    if (isSameOriginFrame(element)) {
    	      win = element.contentWindow;
    	    } else {
    	      return element;
    	    }

    	    element = getActiveElement(win.document);
    	  }

    	  return element;
    	}
    	/**
    	 * @ReactInputSelection: React input selection module. Based on Selection.js,
    	 * but modified to be suitable for react and has a couple of bug fixes (doesn't
    	 * assume buttons have range selections allowed).
    	 * Input selection module for React.
    	 */

    	/**
    	 * @hasSelectionCapabilities: we get the element types that support selection
    	 * from https://html.spec.whatwg.org/#do-not-apply, looking at `selectionStart`
    	 * and `selectionEnd` rows.
    	 */


    	function hasSelectionCapabilities(elem) {
    	  var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();
    	  return nodeName && (nodeName === 'input' && (elem.type === 'text' || elem.type === 'search' || elem.type === 'tel' || elem.type === 'url' || elem.type === 'password') || nodeName === 'textarea' || elem.contentEditable === 'true');
    	}
    	function getSelectionInformation() {
    	  var focusedElem = getActiveElementDeep();
    	  return {
    	    focusedElem: focusedElem,
    	    selectionRange: hasSelectionCapabilities(focusedElem) ? getSelection(focusedElem) : null
    	  };
    	}
    	/**
    	 * @restoreSelection: If any selection information was potentially lost,
    	 * restore it. This is useful when performing operations that could remove dom
    	 * nodes and place them back in, resulting in focus being lost.
    	 */

    	function restoreSelection(priorSelectionInformation) {
    	  var curFocusedElem = getActiveElementDeep();
    	  var priorFocusedElem = priorSelectionInformation.focusedElem;
    	  var priorSelectionRange = priorSelectionInformation.selectionRange;

    	  if (curFocusedElem !== priorFocusedElem && isInDocument(priorFocusedElem)) {
    	    if (priorSelectionRange !== null && hasSelectionCapabilities(priorFocusedElem)) {
    	      setSelection(priorFocusedElem, priorSelectionRange);
    	    } // Focusing a node can change the scroll position, which is undesirable


    	    var ancestors = [];
    	    var ancestor = priorFocusedElem;

    	    while (ancestor = ancestor.parentNode) {
    	      if (ancestor.nodeType === ELEMENT_NODE) {
    	        ancestors.push({
    	          element: ancestor,
    	          left: ancestor.scrollLeft,
    	          top: ancestor.scrollTop
    	        });
    	      }
    	    }

    	    if (typeof priorFocusedElem.focus === 'function') {
    	      priorFocusedElem.focus();
    	    }

    	    for (var i = 0; i < ancestors.length; i++) {
    	      var info = ancestors[i];
    	      info.element.scrollLeft = info.left;
    	      info.element.scrollTop = info.top;
    	    }
    	  }
    	}
    	/**
    	 * @getSelection: Gets the selection bounds of a focused textarea, input or
    	 * contentEditable node.
    	 * -@input: Look up selection bounds of this input
    	 * -@return {start: selectionStart, end: selectionEnd}
    	 */

    	function getSelection(input) {
    	  var selection;

    	  if ('selectionStart' in input) {
    	    // Modern browser with input or textarea.
    	    selection = {
    	      start: input.selectionStart,
    	      end: input.selectionEnd
    	    };
    	  } else {
    	    // Content editable or old IE textarea.
    	    selection = getOffsets(input);
    	  }

    	  return selection || {
    	    start: 0,
    	    end: 0
    	  };
    	}
    	/**
    	 * @setSelection: Sets the selection bounds of a textarea or input and focuses
    	 * the input.
    	 * -@input     Set selection bounds of this input or textarea
    	 * -@offsets   Object of same form that is returned from get*
    	 */

    	function setSelection(input, offsets) {
    	  var start = offsets.start;
    	  var end = offsets.end;

    	  if (end === undefined) {
    	    end = start;
    	  }

    	  if ('selectionStart' in input) {
    	    input.selectionStart = start;
    	    input.selectionEnd = Math.min(end, input.value.length);
    	  } else {
    	    setOffsets(input, offsets);
    	  }
    	}

    	var skipSelectionChangeEvent = canUseDOM && 'documentMode' in document && document.documentMode <= 11;

    	function registerEvents$3() {
    	  registerTwoPhaseEvent('onSelect', ['focusout', 'contextmenu', 'dragend', 'focusin', 'keydown', 'keyup', 'mousedown', 'mouseup', 'selectionchange']);
    	}

    	var activeElement$1 = null;
    	var activeElementInst$1 = null;
    	var lastSelection = null;
    	var mouseDown = false;
    	/**
    	 * Get an object which is a unique representation of the current selection.
    	 *
    	 * The return value will not be consistent across nodes or browsers, but
    	 * two identical selections on the same node will return identical objects.
    	 */

    	function getSelection$1(node) {
    	  if ('selectionStart' in node && hasSelectionCapabilities(node)) {
    	    return {
    	      start: node.selectionStart,
    	      end: node.selectionEnd
    	    };
    	  } else {
    	    var win = node.ownerDocument && node.ownerDocument.defaultView || window;
    	    var selection = win.getSelection();
    	    return {
    	      anchorNode: selection.anchorNode,
    	      anchorOffset: selection.anchorOffset,
    	      focusNode: selection.focusNode,
    	      focusOffset: selection.focusOffset
    	    };
    	  }
    	}
    	/**
    	 * Get document associated with the event target.
    	 */


    	function getEventTargetDocument(eventTarget) {
    	  return eventTarget.window === eventTarget ? eventTarget.document : eventTarget.nodeType === DOCUMENT_NODE ? eventTarget : eventTarget.ownerDocument;
    	}
    	/**
    	 * Poll selection to see whether it's changed.
    	 *
    	 * @param {object} nativeEvent
    	 * @param {object} nativeEventTarget
    	 * @return {?SyntheticEvent}
    	 */


    	function constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget) {
    	  // Ensure we have the right element, and that the user is not dragging a
    	  // selection (this matches native `select` event behavior). In HTML5, select
    	  // fires only on input and textarea thus if there's no focused element we
    	  // won't dispatch.
    	  var doc = getEventTargetDocument(nativeEventTarget);

    	  if (mouseDown || activeElement$1 == null || activeElement$1 !== getActiveElement(doc)) {
    	    return;
    	  } // Only fire when selection has actually changed.


    	  var currentSelection = getSelection$1(activeElement$1);

    	  if (!lastSelection || !shallowEqual(lastSelection, currentSelection)) {
    	    lastSelection = currentSelection;
    	    var listeners = accumulateTwoPhaseListeners(activeElementInst$1, 'onSelect');

    	    if (listeners.length > 0) {
    	      var event = new SyntheticEvent('onSelect', 'select', null, nativeEvent, nativeEventTarget);
    	      dispatchQueue.push({
    	        event: event,
    	        listeners: listeners
    	      });
    	      event.target = activeElement$1;
    	    }
    	  }
    	}
    	/**
    	 * This plugin creates an `onSelect` event that normalizes select events
    	 * across form elements.
    	 *
    	 * Supported elements are:
    	 * - input (see `isTextInputElement`)
    	 * - textarea
    	 * - contentEditable
    	 *
    	 * This differs from native browser implementations in the following ways:
    	 * - Fires on contentEditable fields as well as inputs.
    	 * - Fires for collapsed selection.
    	 * - Fires after user input.
    	 */


    	function extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {

    	  var targetNode = targetInst ? getNodeFromInstance(targetInst) : window;

    	  switch (domEventName) {
    	    // Track the input node that has focus.
    	    case 'focusin':
    	      if (isTextInputElement(targetNode) || targetNode.contentEditable === 'true') {
    	        activeElement$1 = targetNode;
    	        activeElementInst$1 = targetInst;
    	        lastSelection = null;
    	      }

    	      break;

    	    case 'focusout':
    	      activeElement$1 = null;
    	      activeElementInst$1 = null;
    	      lastSelection = null;
    	      break;
    	    // Don't fire the event while the user is dragging. This matches the
    	    // semantics of the native select event.

    	    case 'mousedown':
    	      mouseDown = true;
    	      break;

    	    case 'contextmenu':
    	    case 'mouseup':
    	    case 'dragend':
    	      mouseDown = false;
    	      constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
    	      break;
    	    // Chrome and IE fire non-standard event when selection is changed (and
    	    // sometimes when it hasn't). IE's event fires out of order with respect
    	    // to key and input events on deletion, so we discard it.
    	    //
    	    // Firefox doesn't support selectionchange, so check selection status
    	    // after each key entry. The selection changes after keydown and before
    	    // keyup, but we check on keydown as well in the case of holding down a
    	    // key, when multiple keydown events are fired but only one keyup is.
    	    // This is also our approach for IE handling, for the reason above.

    	    case 'selectionchange':
    	      if (skipSelectionChangeEvent) {
    	        break;
    	      }

    	    // falls through

    	    case 'keydown':
    	    case 'keyup':
    	      constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
    	  }
    	}

    	function extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
    	  var reactName = topLevelEventsToReactNames.get(domEventName);

    	  if (reactName === undefined) {
    	    return;
    	  }

    	  var SyntheticEventCtor = SyntheticEvent;
    	  var reactEventType = domEventName;

    	  switch (domEventName) {
    	    case 'keypress':
    	      // Firefox creates a keypress event for function keys too. This removes
    	      // the unwanted keypress events. Enter is however both printable and
    	      // non-printable. One would expect Tab to be as well (but it isn't).
    	      if (getEventCharCode(nativeEvent) === 0) {
    	        return;
    	      }

    	    /* falls through */

    	    case 'keydown':
    	    case 'keyup':
    	      SyntheticEventCtor = SyntheticKeyboardEvent;
    	      break;

    	    case 'focusin':
    	      reactEventType = 'focus';
    	      SyntheticEventCtor = SyntheticFocusEvent;
    	      break;

    	    case 'focusout':
    	      reactEventType = 'blur';
    	      SyntheticEventCtor = SyntheticFocusEvent;
    	      break;

    	    case 'beforeblur':
    	    case 'afterblur':
    	      SyntheticEventCtor = SyntheticFocusEvent;
    	      break;

    	    case 'click':
    	      // Firefox creates a click event on right mouse clicks. This removes the
    	      // unwanted click events.
    	      if (nativeEvent.button === 2) {
    	        return;
    	      }

    	    /* falls through */

    	    case 'auxclick':
    	    case 'dblclick':
    	    case 'mousedown':
    	    case 'mousemove':
    	    case 'mouseup': // TODO: Disabled elements should not respond to mouse events

    	    /* falls through */

    	    case 'mouseout':
    	    case 'mouseover':
    	    case 'contextmenu':
    	      SyntheticEventCtor = SyntheticMouseEvent;
    	      break;

    	    case 'drag':
    	    case 'dragend':
    	    case 'dragenter':
    	    case 'dragexit':
    	    case 'dragleave':
    	    case 'dragover':
    	    case 'dragstart':
    	    case 'drop':
    	      SyntheticEventCtor = SyntheticDragEvent;
    	      break;

    	    case 'touchcancel':
    	    case 'touchend':
    	    case 'touchmove':
    	    case 'touchstart':
    	      SyntheticEventCtor = SyntheticTouchEvent;
    	      break;

    	    case ANIMATION_END:
    	    case ANIMATION_ITERATION:
    	    case ANIMATION_START:
    	      SyntheticEventCtor = SyntheticAnimationEvent;
    	      break;

    	    case TRANSITION_END:
    	      SyntheticEventCtor = SyntheticTransitionEvent;
    	      break;

    	    case 'scroll':
    	      SyntheticEventCtor = SyntheticUIEvent;
    	      break;

    	    case 'wheel':
    	      SyntheticEventCtor = SyntheticWheelEvent;
    	      break;

    	    case 'copy':
    	    case 'cut':
    	    case 'paste':
    	      SyntheticEventCtor = SyntheticClipboardEvent;
    	      break;

    	    case 'gotpointercapture':
    	    case 'lostpointercapture':
    	    case 'pointercancel':
    	    case 'pointerdown':
    	    case 'pointermove':
    	    case 'pointerout':
    	    case 'pointerover':
    	    case 'pointerup':
    	      SyntheticEventCtor = SyntheticPointerEvent;
    	      break;
    	  }

    	  var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0;

    	  {
    	    // Some events don't bubble in the browser.
    	    // In the past, React has always bubbled them, but this can be surprising.
    	    // We're going to try aligning closer to the browser behavior by not bubbling
    	    // them in React either. We'll start by not bubbling onScroll, and then expand.
    	    var accumulateTargetOnly = !inCapturePhase && // TODO: ideally, we'd eventually add all events from
    	    // nonDelegatedEvents list in DOMPluginEventSystem.
    	    // Then we can remove this special list.
    	    // This is a breaking change that can wait until React 18.
    	    domEventName === 'scroll';

    	    var _listeners = accumulateSinglePhaseListeners(targetInst, reactName, nativeEvent.type, inCapturePhase, accumulateTargetOnly);

    	    if (_listeners.length > 0) {
    	      // Intentionally create event lazily.
    	      var _event = new SyntheticEventCtor(reactName, reactEventType, null, nativeEvent, nativeEventTarget);

    	      dispatchQueue.push({
    	        event: _event,
    	        listeners: _listeners
    	      });
    	    }
    	  }
    	}

    	// TODO: remove top-level side effect.
    	registerSimpleEvents();
    	registerEvents$2();
    	registerEvents$1();
    	registerEvents$3();
    	registerEvents();

    	function extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
    	  // TODO: we should remove the concept of a "SimpleEventPlugin".
    	  // This is the basic functionality of the event system. All
    	  // the other plugins are essentially polyfills. So the plugin
    	  // should probably be inlined somewhere and have its logic
    	  // be core the to event system. This would potentially allow
    	  // us to ship builds of React without the polyfilled plugins below.
    	  extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
    	  var shouldProcessPolyfillPlugins = (eventSystemFlags & SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS) === 0; // We don't process these events unless we are in the
    	  // event's native "bubble" phase, which means that we're
    	  // not in the capture phase. That's because we emulate
    	  // the capture phase here still. This is a trade-off,
    	  // because in an ideal world we would not emulate and use
    	  // the phases properly, like we do with the SimpleEvent
    	  // plugin. However, the plugins below either expect
    	  // emulation (EnterLeave) or use state localized to that
    	  // plugin (BeforeInput, Change, Select). The state in
    	  // these modules complicates things, as you'll essentially
    	  // get the case where the capture phase event might change
    	  // state, only for the following bubble event to come in
    	  // later and not trigger anything as the state now
    	  // invalidates the heuristics of the event plugin. We
    	  // could alter all these plugins to work in such ways, but
    	  // that might cause other unknown side-effects that we
    	  // can't forsee right now.

    	  if (shouldProcessPolyfillPlugins) {
    	    extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
    	    extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
    	    extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
    	    extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
    	  }
    	} // List of events that need to be individually attached to media elements.


    	var mediaEventTypes = ['abort', 'canplay', 'canplaythrough', 'durationchange', 'emptied', 'encrypted', 'ended', 'error', 'loadeddata', 'loadedmetadata', 'loadstart', 'pause', 'play', 'playing', 'progress', 'ratechange', 'seeked', 'seeking', 'stalled', 'suspend', 'timeupdate', 'volumechange', 'waiting']; // We should not delegate these events to the container, but rather
    	// set them on the actual target element itself. This is primarily
    	// because these events do not consistently bubble in the DOM.

    	var nonDelegatedEvents = new Set(['cancel', 'close', 'invalid', 'load', 'scroll', 'toggle'].concat(mediaEventTypes));

    	function executeDispatch(event, listener, currentTarget) {
    	  var type = event.type || 'unknown-event';
    	  event.currentTarget = currentTarget;
    	  invokeGuardedCallbackAndCatchFirstError(type, listener, undefined, event);
    	  event.currentTarget = null;
    	}

    	function processDispatchQueueItemsInOrder(event, dispatchListeners, inCapturePhase) {
    	  var previousInstance;

    	  if (inCapturePhase) {
    	    for (var i = dispatchListeners.length - 1; i >= 0; i--) {
    	      var _dispatchListeners$i = dispatchListeners[i],
    	          instance = _dispatchListeners$i.instance,
    	          currentTarget = _dispatchListeners$i.currentTarget,
    	          listener = _dispatchListeners$i.listener;

    	      if (instance !== previousInstance && event.isPropagationStopped()) {
    	        return;
    	      }

    	      executeDispatch(event, listener, currentTarget);
    	      previousInstance = instance;
    	    }
    	  } else {
    	    for (var _i = 0; _i < dispatchListeners.length; _i++) {
    	      var _dispatchListeners$_i = dispatchListeners[_i],
    	          _instance = _dispatchListeners$_i.instance,
    	          _currentTarget = _dispatchListeners$_i.currentTarget,
    	          _listener = _dispatchListeners$_i.listener;

    	      if (_instance !== previousInstance && event.isPropagationStopped()) {
    	        return;
    	      }

    	      executeDispatch(event, _listener, _currentTarget);
    	      previousInstance = _instance;
    	    }
    	  }
    	}

    	function processDispatchQueue(dispatchQueue, eventSystemFlags) {
    	  var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0;

    	  for (var i = 0; i < dispatchQueue.length; i++) {
    	    var _dispatchQueue$i = dispatchQueue[i],
    	        event = _dispatchQueue$i.event,
    	        listeners = _dispatchQueue$i.listeners;
    	    processDispatchQueueItemsInOrder(event, listeners, inCapturePhase); //  event system doesn't use pooling.
    	  } // This would be a good time to rethrow if any of the event handlers threw.


    	  rethrowCaughtError();
    	}

    	function dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
    	  var nativeEventTarget = getEventTarget(nativeEvent);
    	  var dispatchQueue = [];
    	  extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
    	  processDispatchQueue(dispatchQueue, eventSystemFlags);
    	}

    	function listenToNonDelegatedEvent(domEventName, targetElement) {
    	  var isCapturePhaseListener = false;
    	  var listenerSet = getEventListenerSet(targetElement);
    	  var listenerSetKey = getListenerSetKey(domEventName, isCapturePhaseListener);

    	  if (!listenerSet.has(listenerSetKey)) {
    	    addTrappedEventListener(targetElement, domEventName, IS_NON_DELEGATED, isCapturePhaseListener);
    	    listenerSet.add(listenerSetKey);
    	  }
    	}
    	var listeningMarker = '_reactListening' + Math.random().toString(36).slice(2);
    	function listenToAllSupportedEvents(rootContainerElement) {
    	  {
    	    if (rootContainerElement[listeningMarker]) {
    	      // Performance optimization: don't iterate through events
    	      // for the same portal container or root node more than once.
    	      // TODO: once we remove the flag, we may be able to also
    	      // remove some of the bookkeeping maps used for laziness.
    	      return;
    	    }

    	    rootContainerElement[listeningMarker] = true;
    	    allNativeEvents.forEach(function (domEventName) {
    	      if (!nonDelegatedEvents.has(domEventName)) {
    	        listenToNativeEvent(domEventName, false, rootContainerElement, null);
    	      }

    	      listenToNativeEvent(domEventName, true, rootContainerElement, null);
    	    });
    	  }
    	}
    	function listenToNativeEvent(domEventName, isCapturePhaseListener, rootContainerElement, targetElement) {
    	  var eventSystemFlags = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
    	  var target = rootContainerElement; // selectionchange needs to be attached to the document
    	  // otherwise it won't capture incoming events that are only
    	  // triggered on the document directly.

    	  if (domEventName === 'selectionchange' && rootContainerElement.nodeType !== DOCUMENT_NODE) {
    	    target = rootContainerElement.ownerDocument;
    	  } // If the event can be delegated (or is capture phase), we can
    	  // register it to the root container. Otherwise, we should
    	  // register the event to the target element and mark it as
    	  // a non-delegated event.


    	  if (targetElement !== null && !isCapturePhaseListener && nonDelegatedEvents.has(domEventName)) {
    	    // For all non-delegated events, apart from scroll, we attach
    	    // their event listeners to the respective elements that their
    	    // events fire on. That means we can skip this step, as event
    	    // listener has already been added previously. However, we
    	    // special case the scroll event because the reality is that any
    	    // element can scroll.
    	    // TODO: ideally, we'd eventually apply the same logic to all
    	    // events from the nonDelegatedEvents list. Then we can remove
    	    // this special case and use the same logic for all events.
    	    if (domEventName !== 'scroll') {
    	      return;
    	    }

    	    eventSystemFlags |= IS_NON_DELEGATED;
    	    target = targetElement;
    	  }

    	  var listenerSet = getEventListenerSet(target);
    	  var listenerSetKey = getListenerSetKey(domEventName, isCapturePhaseListener); // If the listener entry is empty or we should upgrade, then
    	  // we need to trap an event listener onto the target.

    	  if (!listenerSet.has(listenerSetKey)) {
    	    if (isCapturePhaseListener) {
    	      eventSystemFlags |= IS_CAPTURE_PHASE;
    	    }

    	    addTrappedEventListener(target, domEventName, eventSystemFlags, isCapturePhaseListener);
    	    listenerSet.add(listenerSetKey);
    	  }
    	}

    	function addTrappedEventListener(targetContainer, domEventName, eventSystemFlags, isCapturePhaseListener, isDeferredListenerForLegacyFBSupport) {
    	  var listener = createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags); // If passive option is not supported, then the event will be
    	  // active and not passive.

    	  var isPassiveListener = undefined;

    	  if (passiveBrowserEventsSupported) {
    	    // Browsers introduced an intervention, making these events
    	    // passive by default on document. React doesn't bind them
    	    // to document anymore, but changing this now would undo
    	    // the performance wins from the change. So we emulate
    	    // the existing behavior manually on the roots now.
    	    // https://github.com/facebook/react/issues/19651
    	    if (domEventName === 'touchstart' || domEventName === 'touchmove' || domEventName === 'wheel') {
    	      isPassiveListener = true;
    	    }
    	  }

    	  targetContainer =  targetContainer;


    	  if (isCapturePhaseListener) {
    	    if (isPassiveListener !== undefined) {
    	      addEventCaptureListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener);
    	    } else {
    	      addEventCaptureListener(targetContainer, domEventName, listener);
    	    }
    	  } else {
    	    if (isPassiveListener !== undefined) {
    	      addEventBubbleListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener);
    	    } else {
    	      addEventBubbleListener(targetContainer, domEventName, listener);
    	    }
    	  }
    	}

    	function isMatchingRootContainer(grandContainer, targetContainer) {
    	  return grandContainer === targetContainer || grandContainer.nodeType === COMMENT_NODE && grandContainer.parentNode === targetContainer;
    	}

    	function dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
    	  var ancestorInst = targetInst;

    	  if ((eventSystemFlags & IS_EVENT_HANDLE_NON_MANAGED_NODE) === 0 && (eventSystemFlags & IS_NON_DELEGATED) === 0) {
    	    var targetContainerNode = targetContainer; // If we are using the legacy FB support flag, we

    	    if (targetInst !== null) {
    	      // The below logic attempts to work out if we need to change
    	      // the target fiber to a different ancestor. We had similar logic
    	      // in the legacy event system, except the big difference between
    	      // systems is that the modern event system now has an event listener
    	      // attached to each React Root and React Portal Root. Together,
    	      // the DOM nodes representing these roots are the "rootContainer".
    	      // To figure out which ancestor instance we should use, we traverse
    	      // up the fiber tree from the target instance and attempt to find
    	      // root boundaries that match that of our current "rootContainer".
    	      // If we find that "rootContainer", we find the parent fiber
    	      // sub-tree for that root and make that our ancestor instance.
    	      var node = targetInst;

    	      mainLoop: while (true) {
    	        if (node === null) {
    	          return;
    	        }

    	        var nodeTag = node.tag;

    	        if (nodeTag === HostRoot || nodeTag === HostPortal) {
    	          var container = node.stateNode.containerInfo;

    	          if (isMatchingRootContainer(container, targetContainerNode)) {
    	            break;
    	          }

    	          if (nodeTag === HostPortal) {
    	            // The target is a portal, but it's not the rootContainer we're looking for.
    	            // Normally portals handle their own events all the way down to the root.
    	            // So we should be able to stop now. However, we don't know if this portal
    	            // was part of *our* root.
    	            var grandNode = node.return;

    	            while (grandNode !== null) {
    	              var grandTag = grandNode.tag;

    	              if (grandTag === HostRoot || grandTag === HostPortal) {
    	                var grandContainer = grandNode.stateNode.containerInfo;

    	                if (isMatchingRootContainer(grandContainer, targetContainerNode)) {
    	                  // This is the rootContainer we're looking for and we found it as
    	                  // a parent of the Portal. That means we can ignore it because the
    	                  // Portal will bubble through to us.
    	                  return;
    	                }
    	              }

    	              grandNode = grandNode.return;
    	            }
    	          } // Now we need to find it's corresponding host fiber in the other
    	          // tree. To do this we can use getClosestInstanceFromNode, but we
    	          // need to validate that the fiber is a host instance, otherwise
    	          // we need to traverse up through the DOM till we find the correct
    	          // node that is from the other tree.


    	          while (container !== null) {
    	            var parentNode = getClosestInstanceFromNode(container);

    	            if (parentNode === null) {
    	              return;
    	            }

    	            var parentTag = parentNode.tag;

    	            if (parentTag === HostComponent || parentTag === HostText) {
    	              node = ancestorInst = parentNode;
    	              continue mainLoop;
    	            }

    	            container = container.parentNode;
    	          }
    	        }

    	        node = node.return;
    	      }
    	    }
    	  }

    	  batchedEventUpdates(function () {
    	    return dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, ancestorInst);
    	  });
    	}

    	function createDispatchListener(instance, listener, currentTarget) {
    	  return {
    	    instance: instance,
    	    listener: listener,
    	    currentTarget: currentTarget
    	  };
    	}

    	function accumulateSinglePhaseListeners(targetFiber, reactName, nativeEventType, inCapturePhase, accumulateTargetOnly) {
    	  var captureName = reactName !== null ? reactName + 'Capture' : null;
    	  var reactEventName = inCapturePhase ? captureName : reactName;
    	  var listeners = [];
    	  var instance = targetFiber;
    	  var lastHostComponent = null; // Accumulate all instances and listeners via the target -> root path.

    	  while (instance !== null) {
    	    var _instance2 = instance,
    	        stateNode = _instance2.stateNode,
    	        tag = _instance2.tag; // Handle listeners that are on HostComponents (i.e. <div>)

    	    if (tag === HostComponent && stateNode !== null) {
    	      lastHostComponent = stateNode; // createEventHandle listeners


    	      if (reactEventName !== null) {
    	        var listener = getListener(instance, reactEventName);

    	        if (listener != null) {
    	          listeners.push(createDispatchListener(instance, listener, lastHostComponent));
    	        }
    	      }
    	    } // If we are only accumulating events for the target, then we don't
    	    // continue to propagate through the React fiber tree to find other
    	    // listeners.


    	    if (accumulateTargetOnly) {
    	      break;
    	    }

    	    instance = instance.return;
    	  }

    	  return listeners;
    	} // We should only use this function for:
    	// - BeforeInputEventPlugin
    	// - ChangeEventPlugin
    	// - SelectEventPlugin
    	// This is because we only process these plugins
    	// in the bubble phase, so we need to accumulate two
    	// phase event listeners (via emulation).

    	function accumulateTwoPhaseListeners(targetFiber, reactName) {
    	  var captureName = reactName + 'Capture';
    	  var listeners = [];
    	  var instance = targetFiber; // Accumulate all instances and listeners via the target -> root path.

    	  while (instance !== null) {
    	    var _instance3 = instance,
    	        stateNode = _instance3.stateNode,
    	        tag = _instance3.tag; // Handle listeners that are on HostComponents (i.e. <div>)

    	    if (tag === HostComponent && stateNode !== null) {
    	      var currentTarget = stateNode;
    	      var captureListener = getListener(instance, captureName);

    	      if (captureListener != null) {
    	        listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
    	      }

    	      var bubbleListener = getListener(instance, reactName);

    	      if (bubbleListener != null) {
    	        listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
    	      }
    	    }

    	    instance = instance.return;
    	  }

    	  return listeners;
    	}

    	function getParent(inst) {
    	  if (inst === null) {
    	    return null;
    	  }

    	  do {
    	    inst = inst.return; // TODO: If this is a HostRoot we might want to bail out.
    	    // That is depending on if we want nested subtrees (layers) to bubble
    	    // events to their parent. We could also go through parentNode on the
    	    // host node but that wouldn't work for React Native and doesn't let us
    	    // do the portal feature.
    	  } while (inst && inst.tag !== HostComponent);

    	  if (inst) {
    	    return inst;
    	  }

    	  return null;
    	}
    	/**
    	 * Return the lowest common ancestor of A and B, or null if they are in
    	 * different trees.
    	 */


    	function getLowestCommonAncestor(instA, instB) {
    	  var nodeA = instA;
    	  var nodeB = instB;
    	  var depthA = 0;

    	  for (var tempA = nodeA; tempA; tempA = getParent(tempA)) {
    	    depthA++;
    	  }

    	  var depthB = 0;

    	  for (var tempB = nodeB; tempB; tempB = getParent(tempB)) {
    	    depthB++;
    	  } // If A is deeper, crawl up.


    	  while (depthA - depthB > 0) {
    	    nodeA = getParent(nodeA);
    	    depthA--;
    	  } // If B is deeper, crawl up.


    	  while (depthB - depthA > 0) {
    	    nodeB = getParent(nodeB);
    	    depthB--;
    	  } // Walk in lockstep until we find a match.


    	  var depth = depthA;

    	  while (depth--) {
    	    if (nodeA === nodeB || nodeB !== null && nodeA === nodeB.alternate) {
    	      return nodeA;
    	    }

    	    nodeA = getParent(nodeA);
    	    nodeB = getParent(nodeB);
    	  }

    	  return null;
    	}

    	function accumulateEnterLeaveListenersForEvent(dispatchQueue, event, target, common, inCapturePhase) {
    	  var registrationName = event._reactName;
    	  var listeners = [];
    	  var instance = target;

    	  while (instance !== null) {
    	    if (instance === common) {
    	      break;
    	    }

    	    var _instance4 = instance,
    	        alternate = _instance4.alternate,
    	        stateNode = _instance4.stateNode,
    	        tag = _instance4.tag;

    	    if (alternate !== null && alternate === common) {
    	      break;
    	    }

    	    if (tag === HostComponent && stateNode !== null) {
    	      var currentTarget = stateNode;

    	      if (inCapturePhase) {
    	        var captureListener = getListener(instance, registrationName);

    	        if (captureListener != null) {
    	          listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
    	        }
    	      } else if (!inCapturePhase) {
    	        var bubbleListener = getListener(instance, registrationName);

    	        if (bubbleListener != null) {
    	          listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
    	        }
    	      }
    	    }

    	    instance = instance.return;
    	  }

    	  if (listeners.length !== 0) {
    	    dispatchQueue.push({
    	      event: event,
    	      listeners: listeners
    	    });
    	  }
    	} // We should only use this function for:
    	// - EnterLeaveEventPlugin
    	// This is because we only process this plugin
    	// in the bubble phase, so we need to accumulate two
    	// phase event listeners.


    	function accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leaveEvent, enterEvent, from, to) {
    	  var common = from && to ? getLowestCommonAncestor(from, to) : null;

    	  if (from !== null) {
    	    accumulateEnterLeaveListenersForEvent(dispatchQueue, leaveEvent, from, common, false);
    	  }

    	  if (to !== null && enterEvent !== null) {
    	    accumulateEnterLeaveListenersForEvent(dispatchQueue, enterEvent, to, common, true);
    	  }
    	}
    	function getListenerSetKey(domEventName, capture) {
    	  return domEventName + "__" + (capture ? 'capture' : 'bubble');
    	}

    	var didWarnInvalidHydration = false;
    	var DANGEROUSLY_SET_INNER_HTML = 'dangerouslySetInnerHTML';
    	var SUPPRESS_CONTENT_EDITABLE_WARNING = 'suppressContentEditableWarning';
    	var SUPPRESS_HYDRATION_WARNING = 'suppressHydrationWarning';
    	var AUTOFOCUS = 'autoFocus';
    	var CHILDREN = 'children';
    	var STYLE = 'style';
    	var HTML$1 = '__html';
    	var HTML_NAMESPACE$1 = Namespaces.html;
    	var warnedUnknownTags;
    	var suppressHydrationWarning;
    	var validatePropertiesInDevelopment;
    	var warnForTextDifference;
    	var warnForPropDifference;
    	var warnForExtraAttributes;
    	var warnForInvalidEventListener;
    	var canDiffStyleForHydrationWarning;
    	var normalizeMarkupForTextOrAttribute;
    	var normalizeHTML;

    	{
    	  warnedUnknownTags = {
    	    // There are working polyfills for <dialog>. Let people use it.
    	    dialog: true,
    	    // Electron ships a custom <webview> tag to display external web content in
    	    // an isolated frame and process.
    	    // This tag is not present in non Electron environments such as JSDom which
    	    // is often used for testing purposes.
    	    // @see https://electronjs.org/docs/api/webview-tag
    	    webview: true
    	  };

    	  validatePropertiesInDevelopment = function (type, props) {
    	    validateProperties(type, props);
    	    validateProperties$1(type, props);
    	    validateProperties$2(type, props, {
    	      registrationNameDependencies: registrationNameDependencies,
    	      possibleRegistrationNames: possibleRegistrationNames
    	    });
    	  }; // IE 11 parses & normalizes the style attribute as opposed to other
    	  // browsers. It adds spaces and sorts the properties in some
    	  // non-alphabetical order. Handling that would require sorting CSS
    	  // properties in the client & server versions or applying
    	  // `expectedStyle` to a temporary DOM node to read its `style` attribute
    	  // normalized. Since it only affects IE, we're skipping style warnings
    	  // in that browser completely in favor of doing all that work.
    	  // See https://github.com/facebook/react/issues/11807


    	  canDiffStyleForHydrationWarning = canUseDOM && !document.documentMode; // HTML parsing normalizes CR and CRLF to LF.
    	  // It also can turn \u0000 into \uFFFD inside attributes.
    	  // https://www.w3.org/TR/html5/single-page.html#preprocessing-the-input-stream
    	  // If we have a mismatch, it might be caused by that.
    	  // We will still patch up in this case but not fire the warning.

    	  var NORMALIZE_NEWLINES_REGEX = /\r\n?/g;
    	  var NORMALIZE_NULL_AND_REPLACEMENT_REGEX = /\u0000|\uFFFD/g;

    	  normalizeMarkupForTextOrAttribute = function (markup) {
    	    var markupString = typeof markup === 'string' ? markup : '' + markup;
    	    return markupString.replace(NORMALIZE_NEWLINES_REGEX, '\n').replace(NORMALIZE_NULL_AND_REPLACEMENT_REGEX, '');
    	  };

    	  warnForTextDifference = function (serverText, clientText) {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    var normalizedClientText = normalizeMarkupForTextOrAttribute(clientText);
    	    var normalizedServerText = normalizeMarkupForTextOrAttribute(serverText);

    	    if (normalizedServerText === normalizedClientText) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Text content did not match. Server: "%s" Client: "%s"', normalizedServerText, normalizedClientText);
    	  };

    	  warnForPropDifference = function (propName, serverValue, clientValue) {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    var normalizedClientValue = normalizeMarkupForTextOrAttribute(clientValue);
    	    var normalizedServerValue = normalizeMarkupForTextOrAttribute(serverValue);

    	    if (normalizedServerValue === normalizedClientValue) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Prop `%s` did not match. Server: %s Client: %s', propName, JSON.stringify(normalizedServerValue), JSON.stringify(normalizedClientValue));
    	  };

    	  warnForExtraAttributes = function (attributeNames) {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;
    	    var names = [];
    	    attributeNames.forEach(function (name) {
    	      names.push(name);
    	    });

    	    error('Extra attributes from the server: %s', names);
    	  };

    	  warnForInvalidEventListener = function (registrationName, listener) {
    	    if (listener === false) {
    	      error('Expected `%s` listener to be a function, instead got `false`.\n\n' + 'If you used to conditionally omit it with %s={condition && value}, ' + 'pass %s={condition ? value : undefined} instead.', registrationName, registrationName, registrationName);
    	    } else {
    	      error('Expected `%s` listener to be a function, instead got a value of `%s` type.', registrationName, typeof listener);
    	    }
    	  }; // Parse the HTML and read it back to normalize the HTML string so that it
    	  // can be used for comparison.


    	  normalizeHTML = function (parent, html) {
    	    // We could have created a separate document here to avoid
    	    // re-initializing custom elements if they exist. But this breaks
    	    // how <noscript> is being handled. So we use the same document.
    	    // See the discussion in https://github.com/facebook/react/pull/11157.
    	    var testElement = parent.namespaceURI === HTML_NAMESPACE$1 ? parent.ownerDocument.createElement(parent.tagName) : parent.ownerDocument.createElementNS(parent.namespaceURI, parent.tagName);
    	    testElement.innerHTML = html;
    	    return testElement.innerHTML;
    	  };
    	}

    	function getOwnerDocumentFromRootContainer(rootContainerElement) {
    	  return rootContainerElement.nodeType === DOCUMENT_NODE ? rootContainerElement : rootContainerElement.ownerDocument;
    	}

    	function noop() {}

    	function trapClickOnNonInteractiveElement(node) {
    	  // Mobile Safari does not fire properly bubble click events on
    	  // non-interactive elements, which means delegated click listeners do not
    	  // fire. The workaround for this bug involves attaching an empty click
    	  // listener on the target node.
    	  // https://www.quirksmode.org/blog/archives/2010/09/click_event_del.html
    	  // Just set it using the onclick property so that we don't have to manage any
    	  // bookkeeping for it. Not sure if we need to clear it when the listener is
    	  // removed.
    	  // TODO: Only do this for the relevant Safaris maybe?
    	  node.onclick = noop;
    	}

    	function setInitialDOMProperties(tag, domElement, rootContainerElement, nextProps, isCustomComponentTag) {
    	  for (var propKey in nextProps) {
    	    if (!nextProps.hasOwnProperty(propKey)) {
    	      continue;
    	    }

    	    var nextProp = nextProps[propKey];

    	    if (propKey === STYLE) {
    	      {
    	        if (nextProp) {
    	          // Freeze the next style object so that we can assume it won't be
    	          // mutated. We have already warned for this in the past.
    	          Object.freeze(nextProp);
    	        }
    	      } // Relies on `updateStylesByID` not mutating `styleUpdates`.


    	      setValueForStyles(domElement, nextProp);
    	    } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
    	      var nextHtml = nextProp ? nextProp[HTML$1] : undefined;

    	      if (nextHtml != null) {
    	        setInnerHTML(domElement, nextHtml);
    	      }
    	    } else if (propKey === CHILDREN) {
    	      if (typeof nextProp === 'string') {
    	        // Avoid setting initial textContent when the text is empty. In IE11 setting
    	        // textContent on a <textarea> will cause the placeholder to not
    	        // show within the <textarea> until it has been focused and blurred again.
    	        // https://github.com/facebook/react/issues/6731#issuecomment-254874553
    	        var canSetTextContent = tag !== 'textarea' || nextProp !== '';

    	        if (canSetTextContent) {
    	          setTextContent(domElement, nextProp);
    	        }
    	      } else if (typeof nextProp === 'number') {
    	        setTextContent(domElement, '' + nextProp);
    	      }
    	    } else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING) ; else if (propKey === AUTOFOCUS) ; else if (registrationNameDependencies.hasOwnProperty(propKey)) {
    	      if (nextProp != null) {
    	        if ( typeof nextProp !== 'function') {
    	          warnForInvalidEventListener(propKey, nextProp);
    	        }

    	        if (propKey === 'onScroll') {
    	          listenToNonDelegatedEvent('scroll', domElement);
    	        }
    	      }
    	    } else if (nextProp != null) {
    	      setValueForProperty(domElement, propKey, nextProp, isCustomComponentTag);
    	    }
    	  }
    	}

    	function updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag) {
    	  // TODO: Handle wasCustomComponentTag
    	  for (var i = 0; i < updatePayload.length; i += 2) {
    	    var propKey = updatePayload[i];
    	    var propValue = updatePayload[i + 1];

    	    if (propKey === STYLE) {
    	      setValueForStyles(domElement, propValue);
    	    } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
    	      setInnerHTML(domElement, propValue);
    	    } else if (propKey === CHILDREN) {
    	      setTextContent(domElement, propValue);
    	    } else {
    	      setValueForProperty(domElement, propKey, propValue, isCustomComponentTag);
    	    }
    	  }
    	}

    	function createElement(type, props, rootContainerElement, parentNamespace) {
    	  var isCustomComponentTag; // We create tags in the namespace of their parent container, except HTML
    	  // tags get no namespace.

    	  var ownerDocument = getOwnerDocumentFromRootContainer(rootContainerElement);
    	  var domElement;
    	  var namespaceURI = parentNamespace;

    	  if (namespaceURI === HTML_NAMESPACE$1) {
    	    namespaceURI = getIntrinsicNamespace(type);
    	  }

    	  if (namespaceURI === HTML_NAMESPACE$1) {
    	    {
    	      isCustomComponentTag = isCustomComponent(type, props); // Should this check be gated by parent namespace? Not sure we want to
    	      // allow <SVG> or <mATH>.

    	      if (!isCustomComponentTag && type !== type.toLowerCase()) {
    	        error('<%s /> is using incorrect casing. ' + 'Use PascalCase for React components, ' + 'or lowercase for HTML elements.', type);
    	      }
    	    }

    	    if (type === 'script') {
    	      // Create the script via .innerHTML so its "parser-inserted" flag is
    	      // set to true and it does not execute
    	      var div = ownerDocument.createElement('div');

    	      div.innerHTML = '<script><' + '/script>'; // eslint-disable-line
    	      // This is guaranteed to yield a script element.

    	      var firstChild = div.firstChild;
    	      domElement = div.removeChild(firstChild);
    	    } else if (typeof props.is === 'string') {
    	      // $FlowIssue `createElement` should be updated for Web Components
    	      domElement = ownerDocument.createElement(type, {
    	        is: props.is
    	      });
    	    } else {
    	      // Separate else branch instead of using `props.is || undefined` above because of a Firefox bug.
    	      // See discussion in https://github.com/facebook/react/pull/6896
    	      // and discussion in https://bugzilla.mozilla.org/show_bug.cgi?id=1276240
    	      domElement = ownerDocument.createElement(type); // Normally attributes are assigned in `setInitialDOMProperties`, however the `multiple` and `size`
    	      // attributes on `select`s needs to be added before `option`s are inserted.
    	      // This prevents:
    	      // - a bug where the `select` does not scroll to the correct option because singular
    	      //  `select` elements automatically pick the first item #13222
    	      // - a bug where the `select` set the first item as selected despite the `size` attribute #14239
    	      // See https://github.com/facebook/react/issues/13222
    	      // and https://github.com/facebook/react/issues/14239

    	      if (type === 'select') {
    	        var node = domElement;

    	        if (props.multiple) {
    	          node.multiple = true;
    	        } else if (props.size) {
    	          // Setting a size greater than 1 causes a select to behave like `multiple=true`, where
    	          // it is possible that no option is selected.
    	          //
    	          // This is only necessary when a select in "single selection mode".
    	          node.size = props.size;
    	        }
    	      }
    	    }
    	  } else {
    	    domElement = ownerDocument.createElementNS(namespaceURI, type);
    	  }

    	  {
    	    if (namespaceURI === HTML_NAMESPACE$1) {
    	      if (!isCustomComponentTag && Object.prototype.toString.call(domElement) === '[object HTMLUnknownElement]' && !Object.prototype.hasOwnProperty.call(warnedUnknownTags, type)) {
    	        warnedUnknownTags[type] = true;

    	        error('The tag <%s> is unrecognized in this browser. ' + 'If you meant to render a React component, start its name with ' + 'an uppercase letter.', type);
    	      }
    	    }
    	  }

    	  return domElement;
    	}
    	function createTextNode(text, rootContainerElement) {
    	  return getOwnerDocumentFromRootContainer(rootContainerElement).createTextNode(text);
    	}
    	function setInitialProperties(domElement, tag, rawProps, rootContainerElement) {
    	  var isCustomComponentTag = isCustomComponent(tag, rawProps);

    	  {
    	    validatePropertiesInDevelopment(tag, rawProps);
    	  } // TODO: Make sure that we check isMounted before firing any of these events.


    	  var props;

    	  switch (tag) {
    	    case 'dialog':
    	      listenToNonDelegatedEvent('cancel', domElement);
    	      listenToNonDelegatedEvent('close', domElement);
    	      props = rawProps;
    	      break;

    	    case 'iframe':
    	    case 'object':
    	    case 'embed':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the load event.
    	      listenToNonDelegatedEvent('load', domElement);
    	      props = rawProps;
    	      break;

    	    case 'video':
    	    case 'audio':
    	      // We listen to these events in case to ensure emulated bubble
    	      // listeners still fire for all the media events.
    	      for (var i = 0; i < mediaEventTypes.length; i++) {
    	        listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
    	      }

    	      props = rawProps;
    	      break;

    	    case 'source':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the error event.
    	      listenToNonDelegatedEvent('error', domElement);
    	      props = rawProps;
    	      break;

    	    case 'img':
    	    case 'image':
    	    case 'link':
    	      // We listen to these events in case to ensure emulated bubble
    	      // listeners still fire for error and load events.
    	      listenToNonDelegatedEvent('error', domElement);
    	      listenToNonDelegatedEvent('load', domElement);
    	      props = rawProps;
    	      break;

    	    case 'details':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the toggle event.
    	      listenToNonDelegatedEvent('toggle', domElement);
    	      props = rawProps;
    	      break;

    	    case 'input':
    	      initWrapperState(domElement, rawProps);
    	      props = getHostProps(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;

    	    case 'option':
    	      validateProps(domElement, rawProps);
    	      props = getHostProps$1(domElement, rawProps);
    	      break;

    	    case 'select':
    	      initWrapperState$1(domElement, rawProps);
    	      props = getHostProps$2(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;

    	    case 'textarea':
    	      initWrapperState$2(domElement, rawProps);
    	      props = getHostProps$3(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;

    	    default:
    	      props = rawProps;
    	  }

    	  assertValidProps(tag, props);
    	  setInitialDOMProperties(tag, domElement, rootContainerElement, props, isCustomComponentTag);

    	  switch (tag) {
    	    case 'input':
    	      // TODO: Make sure we check if this is still unmounted or do any clean
    	      // up necessary since we never stop tracking anymore.
    	      track(domElement);
    	      postMountWrapper(domElement, rawProps, false);
    	      break;

    	    case 'textarea':
    	      // TODO: Make sure we check if this is still unmounted or do any clean
    	      // up necessary since we never stop tracking anymore.
    	      track(domElement);
    	      postMountWrapper$3(domElement);
    	      break;

    	    case 'option':
    	      postMountWrapper$1(domElement, rawProps);
    	      break;

    	    case 'select':
    	      postMountWrapper$2(domElement, rawProps);
    	      break;

    	    default:
    	      if (typeof props.onClick === 'function') {
    	        // TODO: This cast may not be sound for SVG, MathML or custom elements.
    	        trapClickOnNonInteractiveElement(domElement);
    	      }

    	      break;
    	  }
    	} // Calculate the diff between the two objects.

    	function diffProperties(domElement, tag, lastRawProps, nextRawProps, rootContainerElement) {
    	  {
    	    validatePropertiesInDevelopment(tag, nextRawProps);
    	  }

    	  var updatePayload = null;
    	  var lastProps;
    	  var nextProps;

    	  switch (tag) {
    	    case 'input':
    	      lastProps = getHostProps(domElement, lastRawProps);
    	      nextProps = getHostProps(domElement, nextRawProps);
    	      updatePayload = [];
    	      break;

    	    case 'option':
    	      lastProps = getHostProps$1(domElement, lastRawProps);
    	      nextProps = getHostProps$1(domElement, nextRawProps);
    	      updatePayload = [];
    	      break;

    	    case 'select':
    	      lastProps = getHostProps$2(domElement, lastRawProps);
    	      nextProps = getHostProps$2(domElement, nextRawProps);
    	      updatePayload = [];
    	      break;

    	    case 'textarea':
    	      lastProps = getHostProps$3(domElement, lastRawProps);
    	      nextProps = getHostProps$3(domElement, nextRawProps);
    	      updatePayload = [];
    	      break;

    	    default:
    	      lastProps = lastRawProps;
    	      nextProps = nextRawProps;

    	      if (typeof lastProps.onClick !== 'function' && typeof nextProps.onClick === 'function') {
    	        // TODO: This cast may not be sound for SVG, MathML or custom elements.
    	        trapClickOnNonInteractiveElement(domElement);
    	      }

    	      break;
    	  }

    	  assertValidProps(tag, nextProps);
    	  var propKey;
    	  var styleName;
    	  var styleUpdates = null;

    	  for (propKey in lastProps) {
    	    if (nextProps.hasOwnProperty(propKey) || !lastProps.hasOwnProperty(propKey) || lastProps[propKey] == null) {
    	      continue;
    	    }

    	    if (propKey === STYLE) {
    	      var lastStyle = lastProps[propKey];

    	      for (styleName in lastStyle) {
    	        if (lastStyle.hasOwnProperty(styleName)) {
    	          if (!styleUpdates) {
    	            styleUpdates = {};
    	          }

    	          styleUpdates[styleName] = '';
    	        }
    	      }
    	    } else if (propKey === DANGEROUSLY_SET_INNER_HTML || propKey === CHILDREN) ; else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING) ; else if (propKey === AUTOFOCUS) ; else if (registrationNameDependencies.hasOwnProperty(propKey)) {
    	      // This is a special case. If any listener updates we need to ensure
    	      // that the "current" fiber pointer gets updated so we need a commit
    	      // to update this element.
    	      if (!updatePayload) {
    	        updatePayload = [];
    	      }
    	    } else {
    	      // For all other deleted properties we add it to the queue. We use
    	      // the allowed property list in the commit phase instead.
    	      (updatePayload = updatePayload || []).push(propKey, null);
    	    }
    	  }

    	  for (propKey in nextProps) {
    	    var nextProp = nextProps[propKey];
    	    var lastProp = lastProps != null ? lastProps[propKey] : undefined;

    	    if (!nextProps.hasOwnProperty(propKey) || nextProp === lastProp || nextProp == null && lastProp == null) {
    	      continue;
    	    }

    	    if (propKey === STYLE) {
    	      {
    	        if (nextProp) {
    	          // Freeze the next style object so that we can assume it won't be
    	          // mutated. We have already warned for this in the past.
    	          Object.freeze(nextProp);
    	        }
    	      }

    	      if (lastProp) {
    	        // Unset styles on `lastProp` but not on `nextProp`.
    	        for (styleName in lastProp) {
    	          if (lastProp.hasOwnProperty(styleName) && (!nextProp || !nextProp.hasOwnProperty(styleName))) {
    	            if (!styleUpdates) {
    	              styleUpdates = {};
    	            }

    	            styleUpdates[styleName] = '';
    	          }
    	        } // Update styles that changed since `lastProp`.


    	        for (styleName in nextProp) {
    	          if (nextProp.hasOwnProperty(styleName) && lastProp[styleName] !== nextProp[styleName]) {
    	            if (!styleUpdates) {
    	              styleUpdates = {};
    	            }

    	            styleUpdates[styleName] = nextProp[styleName];
    	          }
    	        }
    	      } else {
    	        // Relies on `updateStylesByID` not mutating `styleUpdates`.
    	        if (!styleUpdates) {
    	          if (!updatePayload) {
    	            updatePayload = [];
    	          }

    	          updatePayload.push(propKey, styleUpdates);
    	        }

    	        styleUpdates = nextProp;
    	      }
    	    } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
    	      var nextHtml = nextProp ? nextProp[HTML$1] : undefined;
    	      var lastHtml = lastProp ? lastProp[HTML$1] : undefined;

    	      if (nextHtml != null) {
    	        if (lastHtml !== nextHtml) {
    	          (updatePayload = updatePayload || []).push(propKey, nextHtml);
    	        }
    	      }
    	    } else if (propKey === CHILDREN) {
    	      if (typeof nextProp === 'string' || typeof nextProp === 'number') {
    	        (updatePayload = updatePayload || []).push(propKey, '' + nextProp);
    	      }
    	    } else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING) ; else if (registrationNameDependencies.hasOwnProperty(propKey)) {
    	      if (nextProp != null) {
    	        // We eagerly listen to this even though we haven't committed yet.
    	        if ( typeof nextProp !== 'function') {
    	          warnForInvalidEventListener(propKey, nextProp);
    	        }

    	        if (propKey === 'onScroll') {
    	          listenToNonDelegatedEvent('scroll', domElement);
    	        }
    	      }

    	      if (!updatePayload && lastProp !== nextProp) {
    	        // This is a special case. If any listener updates we need to ensure
    	        // that the "current" props pointer gets updated so we need a commit
    	        // to update this element.
    	        updatePayload = [];
    	      }
    	    } else if (typeof nextProp === 'object' && nextProp !== null && nextProp.$$typeof === REACT_OPAQUE_ID_TYPE) {
    	      // If we encounter useOpaqueReference's opaque object, this means we are hydrating.
    	      // In this case, call the opaque object's toString function which generates a new client
    	      // ID so client and server IDs match and throws to rerender.
    	      nextProp.toString();
    	    } else {
    	      // For any other property we always add it to the queue and then we
    	      // filter it out using the allowed property list during the commit.
    	      (updatePayload = updatePayload || []).push(propKey, nextProp);
    	    }
    	  }

    	  if (styleUpdates) {
    	    {
    	      validateShorthandPropertyCollisionInDev(styleUpdates, nextProps[STYLE]);
    	    }

    	    (updatePayload = updatePayload || []).push(STYLE, styleUpdates);
    	  }

    	  return updatePayload;
    	} // Apply the diff.

    	function updateProperties(domElement, updatePayload, tag, lastRawProps, nextRawProps) {
    	  // Update checked *before* name.
    	  // In the middle of an update, it is possible to have multiple checked.
    	  // When a checked radio tries to change name, browser makes another radio's checked false.
    	  if (tag === 'input' && nextRawProps.type === 'radio' && nextRawProps.name != null) {
    	    updateChecked(domElement, nextRawProps);
    	  }

    	  var wasCustomComponentTag = isCustomComponent(tag, lastRawProps);
    	  var isCustomComponentTag = isCustomComponent(tag, nextRawProps); // Apply the diff.

    	  updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag); // TODO: Ensure that an update gets scheduled if any of the special props
    	  // changed.

    	  switch (tag) {
    	    case 'input':
    	      // Update the wrapper around inputs *after* updating props. This has to
    	      // happen after `updateDOMProperties`. Otherwise HTML5 input validations
    	      // raise warnings and prevent the new value from being assigned.
    	      updateWrapper(domElement, nextRawProps);
    	      break;

    	    case 'textarea':
    	      updateWrapper$1(domElement, nextRawProps);
    	      break;

    	    case 'select':
    	      // <select> value update needs to occur after <option> children
    	      // reconciliation
    	      postUpdateWrapper(domElement, nextRawProps);
    	      break;
    	  }
    	}

    	function getPossibleStandardName(propName) {
    	  {
    	    var lowerCasedName = propName.toLowerCase();

    	    if (!possibleStandardNames.hasOwnProperty(lowerCasedName)) {
    	      return null;
    	    }

    	    return possibleStandardNames[lowerCasedName] || null;
    	  }
    	}

    	function diffHydratedProperties(domElement, tag, rawProps, parentNamespace, rootContainerElement) {
    	  var isCustomComponentTag;
    	  var extraAttributeNames;

    	  {
    	    suppressHydrationWarning = rawProps[SUPPRESS_HYDRATION_WARNING] === true;
    	    isCustomComponentTag = isCustomComponent(tag, rawProps);
    	    validatePropertiesInDevelopment(tag, rawProps);
    	  } // TODO: Make sure that we check isMounted before firing any of these events.


    	  switch (tag) {
    	    case 'dialog':
    	      listenToNonDelegatedEvent('cancel', domElement);
    	      listenToNonDelegatedEvent('close', domElement);
    	      break;

    	    case 'iframe':
    	    case 'object':
    	    case 'embed':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the load event.
    	      listenToNonDelegatedEvent('load', domElement);
    	      break;

    	    case 'video':
    	    case 'audio':
    	      // We listen to these events in case to ensure emulated bubble
    	      // listeners still fire for all the media events.
    	      for (var i = 0; i < mediaEventTypes.length; i++) {
    	        listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
    	      }

    	      break;

    	    case 'source':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the error event.
    	      listenToNonDelegatedEvent('error', domElement);
    	      break;

    	    case 'img':
    	    case 'image':
    	    case 'link':
    	      // We listen to these events in case to ensure emulated bubble
    	      // listeners still fire for error and load events.
    	      listenToNonDelegatedEvent('error', domElement);
    	      listenToNonDelegatedEvent('load', domElement);
    	      break;

    	    case 'details':
    	      // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the toggle event.
    	      listenToNonDelegatedEvent('toggle', domElement);
    	      break;

    	    case 'input':
    	      initWrapperState(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;

    	    case 'option':
    	      validateProps(domElement, rawProps);
    	      break;

    	    case 'select':
    	      initWrapperState$1(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;

    	    case 'textarea':
    	      initWrapperState$2(domElement, rawProps); // We listen to this event in case to ensure emulated bubble
    	      // listeners still fire for the invalid event.

    	      listenToNonDelegatedEvent('invalid', domElement);

    	      break;
    	  }

    	  assertValidProps(tag, rawProps);

    	  {
    	    extraAttributeNames = new Set();
    	    var attributes = domElement.attributes;

    	    for (var _i = 0; _i < attributes.length; _i++) {
    	      var name = attributes[_i].name.toLowerCase();

    	      switch (name) {
    	        // Built-in SSR attribute is allowed
    	        case 'data-reactroot':
    	          break;
    	        // Controlled attributes are not validated
    	        // TODO: Only ignore them on controlled tags.

    	        case 'value':
    	          break;

    	        case 'checked':
    	          break;

    	        case 'selected':
    	          break;

    	        default:
    	          // Intentionally use the original name.
    	          // See discussion in https://github.com/facebook/react/pull/10676.
    	          extraAttributeNames.add(attributes[_i].name);
    	      }
    	    }
    	  }

    	  var updatePayload = null;

    	  for (var propKey in rawProps) {
    	    if (!rawProps.hasOwnProperty(propKey)) {
    	      continue;
    	    }

    	    var nextProp = rawProps[propKey];

    	    if (propKey === CHILDREN) {
    	      // For text content children we compare against textContent. This
    	      // might match additional HTML that is hidden when we read it using
    	      // textContent. E.g. "foo" will match "f<span>oo</span>" but that still
    	      // satisfies our requirement. Our requirement is not to produce perfect
    	      // HTML and attributes. Ideally we should preserve structure but it's
    	      // ok not to if the visible content is still enough to indicate what
    	      // even listeners these nodes might be wired up to.
    	      // TODO: Warn if there is more than a single textNode as a child.
    	      // TODO: Should we use domElement.firstChild.nodeValue to compare?
    	      if (typeof nextProp === 'string') {
    	        if (domElement.textContent !== nextProp) {
    	          if ( !suppressHydrationWarning) {
    	            warnForTextDifference(domElement.textContent, nextProp);
    	          }

    	          updatePayload = [CHILDREN, nextProp];
    	        }
    	      } else if (typeof nextProp === 'number') {
    	        if (domElement.textContent !== '' + nextProp) {
    	          if ( !suppressHydrationWarning) {
    	            warnForTextDifference(domElement.textContent, nextProp);
    	          }

    	          updatePayload = [CHILDREN, '' + nextProp];
    	        }
    	      }
    	    } else if (registrationNameDependencies.hasOwnProperty(propKey)) {
    	      if (nextProp != null) {
    	        if ( typeof nextProp !== 'function') {
    	          warnForInvalidEventListener(propKey, nextProp);
    	        }

    	        if (propKey === 'onScroll') {
    	          listenToNonDelegatedEvent('scroll', domElement);
    	        }
    	      }
    	    } else if ( // Convince Flow we've calculated it (it's DEV-only in this method.)
    	    typeof isCustomComponentTag === 'boolean') {
    	      // Validate that the properties correspond to their expected values.
    	      var serverValue = void 0;
    	      var propertyInfo = getPropertyInfo(propKey);

    	      if (suppressHydrationWarning) ; else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || // Controlled attributes are not validated
    	      // TODO: Only ignore them on controlled tags.
    	      propKey === 'value' || propKey === 'checked' || propKey === 'selected') ; else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
    	        var serverHTML = domElement.innerHTML;
    	        var nextHtml = nextProp ? nextProp[HTML$1] : undefined;

    	        if (nextHtml != null) {
    	          var expectedHTML = normalizeHTML(domElement, nextHtml);

    	          if (expectedHTML !== serverHTML) {
    	            warnForPropDifference(propKey, serverHTML, expectedHTML);
    	          }
    	        }
    	      } else if (propKey === STYLE) {
    	        // $FlowFixMe - Should be inferred as not undefined.
    	        extraAttributeNames.delete(propKey);

    	        if (canDiffStyleForHydrationWarning) {
    	          var expectedStyle = createDangerousStringForStyles(nextProp);
    	          serverValue = domElement.getAttribute('style');

    	          if (expectedStyle !== serverValue) {
    	            warnForPropDifference(propKey, serverValue, expectedStyle);
    	          }
    	        }
    	      } else if (isCustomComponentTag) {
    	        // $FlowFixMe - Should be inferred as not undefined.
    	        extraAttributeNames.delete(propKey.toLowerCase());
    	        serverValue = getValueForAttribute(domElement, propKey, nextProp);

    	        if (nextProp !== serverValue) {
    	          warnForPropDifference(propKey, serverValue, nextProp);
    	        }
    	      } else if (!shouldIgnoreAttribute(propKey, propertyInfo, isCustomComponentTag) && !shouldRemoveAttribute(propKey, nextProp, propertyInfo, isCustomComponentTag)) {
    	        var isMismatchDueToBadCasing = false;

    	        if (propertyInfo !== null) {
    	          // $FlowFixMe - Should be inferred as not undefined.
    	          extraAttributeNames.delete(propertyInfo.attributeName);
    	          serverValue = getValueForProperty(domElement, propKey, nextProp, propertyInfo);
    	        } else {
    	          var ownNamespace = parentNamespace;

    	          if (ownNamespace === HTML_NAMESPACE$1) {
    	            ownNamespace = getIntrinsicNamespace(tag);
    	          }

    	          if (ownNamespace === HTML_NAMESPACE$1) {
    	            // $FlowFixMe - Should be inferred as not undefined.
    	            extraAttributeNames.delete(propKey.toLowerCase());
    	          } else {
    	            var standardName = getPossibleStandardName(propKey);

    	            if (standardName !== null && standardName !== propKey) {
    	              // If an SVG prop is supplied with bad casing, it will
    	              // be successfully parsed from HTML, but will produce a mismatch
    	              // (and would be incorrectly rendered on the client).
    	              // However, we already warn about bad casing elsewhere.
    	              // So we'll skip the misleading extra mismatch warning in this case.
    	              isMismatchDueToBadCasing = true; // $FlowFixMe - Should be inferred as not undefined.

    	              extraAttributeNames.delete(standardName);
    	            } // $FlowFixMe - Should be inferred as not undefined.


    	            extraAttributeNames.delete(propKey);
    	          }

    	          serverValue = getValueForAttribute(domElement, propKey, nextProp);
    	        }

    	        if (nextProp !== serverValue && !isMismatchDueToBadCasing) {
    	          warnForPropDifference(propKey, serverValue, nextProp);
    	        }
    	      }
    	    }
    	  }

    	  {
    	    // $FlowFixMe - Should be inferred as not undefined.
    	    if (extraAttributeNames.size > 0 && !suppressHydrationWarning) {
    	      // $FlowFixMe - Should be inferred as not undefined.
    	      warnForExtraAttributes(extraAttributeNames);
    	    }
    	  }

    	  switch (tag) {
    	    case 'input':
    	      // TODO: Make sure we check if this is still unmounted or do any clean
    	      // up necessary since we never stop tracking anymore.
    	      track(domElement);
    	      postMountWrapper(domElement, rawProps, true);
    	      break;

    	    case 'textarea':
    	      // TODO: Make sure we check if this is still unmounted or do any clean
    	      // up necessary since we never stop tracking anymore.
    	      track(domElement);
    	      postMountWrapper$3(domElement);
    	      break;

    	    case 'select':
    	    case 'option':
    	      // For input and textarea we current always set the value property at
    	      // post mount to force it to diverge from attributes. However, for
    	      // option and select we don't quite do the same thing and select
    	      // is not resilient to the DOM state changing so we don't do that here.
    	      // TODO: Consider not doing this for input and textarea.
    	      break;

    	    default:
    	      if (typeof rawProps.onClick === 'function') {
    	        // TODO: This cast may not be sound for SVG, MathML or custom elements.
    	        trapClickOnNonInteractiveElement(domElement);
    	      }

    	      break;
    	  }

    	  return updatePayload;
    	}
    	function diffHydratedText(textNode, text) {
    	  var isDifferent = textNode.nodeValue !== text;
    	  return isDifferent;
    	}
    	function warnForUnmatchedText(textNode, text) {
    	  {
    	    warnForTextDifference(textNode.nodeValue, text);
    	  }
    	}
    	function warnForDeletedHydratableElement(parentNode, child) {
    	  {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Did not expect server HTML to contain a <%s> in <%s>.', child.nodeName.toLowerCase(), parentNode.nodeName.toLowerCase());
    	  }
    	}
    	function warnForDeletedHydratableText(parentNode, child) {
    	  {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Did not expect server HTML to contain the text node "%s" in <%s>.', child.nodeValue, parentNode.nodeName.toLowerCase());
    	  }
    	}
    	function warnForInsertedHydratedElement(parentNode, tag, props) {
    	  {
    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Expected server HTML to contain a matching <%s> in <%s>.', tag, parentNode.nodeName.toLowerCase());
    	  }
    	}
    	function warnForInsertedHydratedText(parentNode, text) {
    	  {
    	    if (text === '') {
    	      // We expect to insert empty text nodes since they're not represented in
    	      // the HTML.
    	      // TODO: Remove this special case if we can just avoid inserting empty
    	      // text nodes.
    	      return;
    	    }

    	    if (didWarnInvalidHydration) {
    	      return;
    	    }

    	    didWarnInvalidHydration = true;

    	    error('Expected server HTML to contain a matching text node for "%s" in <%s>.', text, parentNode.nodeName.toLowerCase());
    	  }
    	}
    	function restoreControlledState$3(domElement, tag, props) {
    	  switch (tag) {
    	    case 'input':
    	      restoreControlledState(domElement, props);
    	      return;

    	    case 'textarea':
    	      restoreControlledState$2(domElement, props);
    	      return;

    	    case 'select':
    	      restoreControlledState$1(domElement, props);
    	      return;
    	  }
    	}

    	var validateDOMNesting = function () {};

    	var updatedAncestorInfo = function () {};

    	{
    	  // This validation code was written based on the HTML5 parsing spec:
    	  // https://html.spec.whatwg.org/multipage/syntax.html#has-an-element-in-scope
    	  //
    	  // Note: this does not catch all invalid nesting, nor does it try to (as it's
    	  // not clear what practical benefit doing so provides); instead, we warn only
    	  // for cases where the parser will give a parse tree differing from what React
    	  // intended. For example, <b><div></div></b> is invalid but we don't warn
    	  // because it still parses correctly; we do warn for other cases like nested
    	  // <p> tags where the beginning of the second element implicitly closes the
    	  // first, causing a confusing mess.
    	  // https://html.spec.whatwg.org/multipage/syntax.html#special
    	  var specialTags = ['address', 'applet', 'area', 'article', 'aside', 'base', 'basefont', 'bgsound', 'blockquote', 'body', 'br', 'button', 'caption', 'center', 'col', 'colgroup', 'dd', 'details', 'dir', 'div', 'dl', 'dt', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'frame', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hgroup', 'hr', 'html', 'iframe', 'img', 'input', 'isindex', 'li', 'link', 'listing', 'main', 'marquee', 'menu', 'menuitem', 'meta', 'nav', 'noembed', 'noframes', 'noscript', 'object', 'ol', 'p', 'param', 'plaintext', 'pre', 'script', 'section', 'select', 'source', 'style', 'summary', 'table', 'tbody', 'td', 'template', 'textarea', 'tfoot', 'th', 'thead', 'title', 'tr', 'track', 'ul', 'wbr', 'xmp']; // https://html.spec.whatwg.org/multipage/syntax.html#has-an-element-in-scope

    	  var inScopeTags = ['applet', 'caption', 'html', 'table', 'td', 'th', 'marquee', 'object', 'template', // https://html.spec.whatwg.org/multipage/syntax.html#html-integration-point
    	  // TODO: Distinguish by namespace here -- for <title>, including it here
    	  // errs on the side of fewer warnings
    	  'foreignObject', 'desc', 'title']; // https://html.spec.whatwg.org/multipage/syntax.html#has-an-element-in-button-scope

    	  var buttonScopeTags = inScopeTags.concat(['button']); // https://html.spec.whatwg.org/multipage/syntax.html#generate-implied-end-tags

    	  var impliedEndTags = ['dd', 'dt', 'li', 'option', 'optgroup', 'p', 'rp', 'rt'];
    	  var emptyAncestorInfo = {
    	    current: null,
    	    formTag: null,
    	    aTagInScope: null,
    	    buttonTagInScope: null,
    	    nobrTagInScope: null,
    	    pTagInButtonScope: null,
    	    listItemTagAutoclosing: null,
    	    dlItemTagAutoclosing: null
    	  };

    	  updatedAncestorInfo = function (oldInfo, tag) {
    	    var ancestorInfo = _assign({}, oldInfo || emptyAncestorInfo);

    	    var info = {
    	      tag: tag
    	    };

    	    if (inScopeTags.indexOf(tag) !== -1) {
    	      ancestorInfo.aTagInScope = null;
    	      ancestorInfo.buttonTagInScope = null;
    	      ancestorInfo.nobrTagInScope = null;
    	    }

    	    if (buttonScopeTags.indexOf(tag) !== -1) {
    	      ancestorInfo.pTagInButtonScope = null;
    	    } // See rules for 'li', 'dd', 'dt' start tags in
    	    // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-inbody


    	    if (specialTags.indexOf(tag) !== -1 && tag !== 'address' && tag !== 'div' && tag !== 'p') {
    	      ancestorInfo.listItemTagAutoclosing = null;
    	      ancestorInfo.dlItemTagAutoclosing = null;
    	    }

    	    ancestorInfo.current = info;

    	    if (tag === 'form') {
    	      ancestorInfo.formTag = info;
    	    }

    	    if (tag === 'a') {
    	      ancestorInfo.aTagInScope = info;
    	    }

    	    if (tag === 'button') {
    	      ancestorInfo.buttonTagInScope = info;
    	    }

    	    if (tag === 'nobr') {
    	      ancestorInfo.nobrTagInScope = info;
    	    }

    	    if (tag === 'p') {
    	      ancestorInfo.pTagInButtonScope = info;
    	    }

    	    if (tag === 'li') {
    	      ancestorInfo.listItemTagAutoclosing = info;
    	    }

    	    if (tag === 'dd' || tag === 'dt') {
    	      ancestorInfo.dlItemTagAutoclosing = info;
    	    }

    	    return ancestorInfo;
    	  };
    	  /**
    	   * Returns whether
    	   */


    	  var isTagValidWithParent = function (tag, parentTag) {
    	    // First, let's check if we're in an unusual parsing mode...
    	    switch (parentTag) {
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-inselect
    	      case 'select':
    	        return tag === 'option' || tag === 'optgroup' || tag === '#text';

    	      case 'optgroup':
    	        return tag === 'option' || tag === '#text';
    	      // Strictly speaking, seeing an <option> doesn't mean we're in a <select>
    	      // but

    	      case 'option':
    	        return tag === '#text';
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-intd
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-incaption
    	      // No special behavior since these rules fall back to "in body" mode for
    	      // all except special table nodes which cause bad parsing behavior anyway.
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-intr

    	      case 'tr':
    	        return tag === 'th' || tag === 'td' || tag === 'style' || tag === 'script' || tag === 'template';
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-intbody

    	      case 'tbody':
    	      case 'thead':
    	      case 'tfoot':
    	        return tag === 'tr' || tag === 'style' || tag === 'script' || tag === 'template';
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-incolgroup

    	      case 'colgroup':
    	        return tag === 'col' || tag === 'template';
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-intable

    	      case 'table':
    	        return tag === 'caption' || tag === 'colgroup' || tag === 'tbody' || tag === 'tfoot' || tag === 'thead' || tag === 'style' || tag === 'script' || tag === 'template';
    	      // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-inhead

    	      case 'head':
    	        return tag === 'base' || tag === 'basefont' || tag === 'bgsound' || tag === 'link' || tag === 'meta' || tag === 'title' || tag === 'noscript' || tag === 'noframes' || tag === 'style' || tag === 'script' || tag === 'template';
    	      // https://html.spec.whatwg.org/multipage/semantics.html#the-html-element

    	      case 'html':
    	        return tag === 'head' || tag === 'body' || tag === 'frameset';

    	      case 'frameset':
    	        return tag === 'frame';

    	      case '#document':
    	        return tag === 'html';
    	    } // Probably in the "in body" parsing mode, so we outlaw only tag combos
    	    // where the parsing rules cause implicit opens or closes to be added.
    	    // https://html.spec.whatwg.org/multipage/syntax.html#parsing-main-inbody


    	    switch (tag) {
    	      case 'h1':
    	      case 'h2':
    	      case 'h3':
    	      case 'h4':
    	      case 'h5':
    	      case 'h6':
    	        return parentTag !== 'h1' && parentTag !== 'h2' && parentTag !== 'h3' && parentTag !== 'h4' && parentTag !== 'h5' && parentTag !== 'h6';

    	      case 'rp':
    	      case 'rt':
    	        return impliedEndTags.indexOf(parentTag) === -1;

    	      case 'body':
    	      case 'caption':
    	      case 'col':
    	      case 'colgroup':
    	      case 'frameset':
    	      case 'frame':
    	      case 'head':
    	      case 'html':
    	      case 'tbody':
    	      case 'td':
    	      case 'tfoot':
    	      case 'th':
    	      case 'thead':
    	      case 'tr':
    	        // These tags are only valid with a few parents that have special child
    	        // parsing rules -- if we're down here, then none of those matched and
    	        // so we allow it only if we don't know what the parent is, as all other
    	        // cases are invalid.
    	        return parentTag == null;
    	    }

    	    return true;
    	  };
    	  /**
    	   * Returns whether
    	   */


    	  var findInvalidAncestorForTag = function (tag, ancestorInfo) {
    	    switch (tag) {
    	      case 'address':
    	      case 'article':
    	      case 'aside':
    	      case 'blockquote':
    	      case 'center':
    	      case 'details':
    	      case 'dialog':
    	      case 'dir':
    	      case 'div':
    	      case 'dl':
    	      case 'fieldset':
    	      case 'figcaption':
    	      case 'figure':
    	      case 'footer':
    	      case 'header':
    	      case 'hgroup':
    	      case 'main':
    	      case 'menu':
    	      case 'nav':
    	      case 'ol':
    	      case 'p':
    	      case 'section':
    	      case 'summary':
    	      case 'ul':
    	      case 'pre':
    	      case 'listing':
    	      case 'table':
    	      case 'hr':
    	      case 'xmp':
    	      case 'h1':
    	      case 'h2':
    	      case 'h3':
    	      case 'h4':
    	      case 'h5':
    	      case 'h6':
    	        return ancestorInfo.pTagInButtonScope;

    	      case 'form':
    	        return ancestorInfo.formTag || ancestorInfo.pTagInButtonScope;

    	      case 'li':
    	        return ancestorInfo.listItemTagAutoclosing;

    	      case 'dd':
    	      case 'dt':
    	        return ancestorInfo.dlItemTagAutoclosing;

    	      case 'button':
    	        return ancestorInfo.buttonTagInScope;

    	      case 'a':
    	        // Spec says something about storing a list of markers, but it sounds
    	        // equivalent to this check.
    	        return ancestorInfo.aTagInScope;

    	      case 'nobr':
    	        return ancestorInfo.nobrTagInScope;
    	    }

    	    return null;
    	  };

    	  var didWarn$1 = {};

    	  validateDOMNesting = function (childTag, childText, ancestorInfo) {
    	    ancestorInfo = ancestorInfo || emptyAncestorInfo;
    	    var parentInfo = ancestorInfo.current;
    	    var parentTag = parentInfo && parentInfo.tag;

    	    if (childText != null) {
    	      if (childTag != null) {
    	        error('validateDOMNesting: when childText is passed, childTag should be null');
    	      }

    	      childTag = '#text';
    	    }

    	    var invalidParent = isTagValidWithParent(childTag, parentTag) ? null : parentInfo;
    	    var invalidAncestor = invalidParent ? null : findInvalidAncestorForTag(childTag, ancestorInfo);
    	    var invalidParentOrAncestor = invalidParent || invalidAncestor;

    	    if (!invalidParentOrAncestor) {
    	      return;
    	    }

    	    var ancestorTag = invalidParentOrAncestor.tag;
    	    var warnKey = !!invalidParent + '|' + childTag + '|' + ancestorTag;

    	    if (didWarn$1[warnKey]) {
    	      return;
    	    }

    	    didWarn$1[warnKey] = true;
    	    var tagDisplayName = childTag;
    	    var whitespaceInfo = '';

    	    if (childTag === '#text') {
    	      if (/\S/.test(childText)) {
    	        tagDisplayName = 'Text nodes';
    	      } else {
    	        tagDisplayName = 'Whitespace text nodes';
    	        whitespaceInfo = " Make sure you don't have any extra whitespace between tags on " + 'each line of your source code.';
    	      }
    	    } else {
    	      tagDisplayName = '<' + childTag + '>';
    	    }

    	    if (invalidParent) {
    	      var info = '';

    	      if (ancestorTag === 'table' && childTag === 'tr') {
    	        info += ' Add a <tbody>, <thead> or <tfoot> to your code to match the DOM tree generated by ' + 'the browser.';
    	      }

    	      error('validateDOMNesting(...): %s cannot appear as a child of <%s>.%s%s', tagDisplayName, ancestorTag, whitespaceInfo, info);
    	    } else {
    	      error('validateDOMNesting(...): %s cannot appear as a descendant of ' + '<%s>.', tagDisplayName, ancestorTag);
    	    }
    	  };
    	}

    	var SUPPRESS_HYDRATION_WARNING$1;

    	{
    	  SUPPRESS_HYDRATION_WARNING$1 = 'suppressHydrationWarning';
    	}

    	var SUSPENSE_START_DATA = '$';
    	var SUSPENSE_END_DATA = '/$';
    	var SUSPENSE_PENDING_START_DATA = '$?';
    	var SUSPENSE_FALLBACK_START_DATA = '$!';
    	var STYLE$1 = 'style';
    	var eventsEnabled = null;
    	var selectionInformation = null;

    	function shouldAutoFocusHostComponent(type, props) {
    	  switch (type) {
    	    case 'button':
    	    case 'input':
    	    case 'select':
    	    case 'textarea':
    	      return !!props.autoFocus;
    	  }

    	  return false;
    	}
    	function getRootHostContext(rootContainerInstance) {
    	  var type;
    	  var namespace;
    	  var nodeType = rootContainerInstance.nodeType;

    	  switch (nodeType) {
    	    case DOCUMENT_NODE:
    	    case DOCUMENT_FRAGMENT_NODE:
    	      {
    	        type = nodeType === DOCUMENT_NODE ? '#document' : '#fragment';
    	        var root = rootContainerInstance.documentElement;
    	        namespace = root ? root.namespaceURI : getChildNamespace(null, '');
    	        break;
    	      }

    	    default:
    	      {
    	        var container = nodeType === COMMENT_NODE ? rootContainerInstance.parentNode : rootContainerInstance;
    	        var ownNamespace = container.namespaceURI || null;
    	        type = container.tagName;
    	        namespace = getChildNamespace(ownNamespace, type);
    	        break;
    	      }
    	  }

    	  {
    	    var validatedTag = type.toLowerCase();
    	    var ancestorInfo = updatedAncestorInfo(null, validatedTag);
    	    return {
    	      namespace: namespace,
    	      ancestorInfo: ancestorInfo
    	    };
    	  }
    	}
    	function getChildHostContext(parentHostContext, type, rootContainerInstance) {
    	  {
    	    var parentHostContextDev = parentHostContext;
    	    var namespace = getChildNamespace(parentHostContextDev.namespace, type);
    	    var ancestorInfo = updatedAncestorInfo(parentHostContextDev.ancestorInfo, type);
    	    return {
    	      namespace: namespace,
    	      ancestorInfo: ancestorInfo
    	    };
    	  }
    	}
    	function getPublicInstance(instance) {
    	  return instance;
    	}
    	function prepareForCommit(containerInfo) {
    	  eventsEnabled = isEnabled();
    	  selectionInformation = getSelectionInformation();
    	  var activeInstance = null;

    	  setEnabled(false);
    	  return activeInstance;
    	}
    	function resetAfterCommit(containerInfo) {
    	  restoreSelection(selectionInformation);
    	  setEnabled(eventsEnabled);
    	  eventsEnabled = null;
    	  selectionInformation = null;
    	}
    	function createInstance(type, props, rootContainerInstance, hostContext, internalInstanceHandle) {
    	  var parentNamespace;

    	  {
    	    // TODO: take namespace into account when validating.
    	    var hostContextDev = hostContext;
    	    validateDOMNesting(type, null, hostContextDev.ancestorInfo);

    	    if (typeof props.children === 'string' || typeof props.children === 'number') {
    	      var string = '' + props.children;
    	      var ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
    	      validateDOMNesting(null, string, ownAncestorInfo);
    	    }

    	    parentNamespace = hostContextDev.namespace;
    	  }

    	  var domElement = createElement(type, props, rootContainerInstance, parentNamespace);
    	  precacheFiberNode(internalInstanceHandle, domElement);
    	  updateFiberProps(domElement, props);
    	  return domElement;
    	}
    	function appendInitialChild(parentInstance, child) {
    	  parentInstance.appendChild(child);
    	}
    	function finalizeInitialChildren(domElement, type, props, rootContainerInstance, hostContext) {
    	  setInitialProperties(domElement, type, props, rootContainerInstance);
    	  return shouldAutoFocusHostComponent(type, props);
    	}
    	function prepareUpdate(domElement, type, oldProps, newProps, rootContainerInstance, hostContext) {
    	  {
    	    var hostContextDev = hostContext;

    	    if (typeof newProps.children !== typeof oldProps.children && (typeof newProps.children === 'string' || typeof newProps.children === 'number')) {
    	      var string = '' + newProps.children;
    	      var ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
    	      validateDOMNesting(null, string, ownAncestorInfo);
    	    }
    	  }

    	  return diffProperties(domElement, type, oldProps, newProps);
    	}
    	function shouldSetTextContent(type, props) {
    	  return type === 'textarea' || type === 'option' || type === 'noscript' || typeof props.children === 'string' || typeof props.children === 'number' || typeof props.dangerouslySetInnerHTML === 'object' && props.dangerouslySetInnerHTML !== null && props.dangerouslySetInnerHTML.__html != null;
    	}
    	function createTextInstance(text, rootContainerInstance, hostContext, internalInstanceHandle) {
    	  {
    	    var hostContextDev = hostContext;
    	    validateDOMNesting(null, text, hostContextDev.ancestorInfo);
    	  }

    	  var textNode = createTextNode(text, rootContainerInstance);
    	  precacheFiberNode(internalInstanceHandle, textNode);
    	  return textNode;
    	}
    	// if a component just imports ReactDOM (e.g. for findDOMNode).
    	// Some environments might not have setTimeout or clearTimeout.

    	var scheduleTimeout = typeof setTimeout === 'function' ? setTimeout : undefined;
    	var cancelTimeout = typeof clearTimeout === 'function' ? clearTimeout : undefined;
    	var noTimeout = -1; // -------------------
    	function commitMount(domElement, type, newProps, internalInstanceHandle) {
    	  // Despite the naming that might imply otherwise, this method only
    	  // fires if there is an `Update` effect scheduled during mounting.
    	  // This happens if `finalizeInitialChildren` returns `true` (which it
    	  // does to implement the `autoFocus` attribute on the client). But
    	  // there are also other cases when this might happen (such as patching
    	  // up text content during hydration mismatch). So we'll check this again.
    	  if (shouldAutoFocusHostComponent(type, newProps)) {
    	    domElement.focus();
    	  }
    	}
    	function commitUpdate(domElement, updatePayload, type, oldProps, newProps, internalInstanceHandle) {
    	  // Update the props handle so that we know which props are the ones with
    	  // with current event handlers.
    	  updateFiberProps(domElement, newProps); // Apply the diff to the DOM node.

    	  updateProperties(domElement, updatePayload, type, oldProps, newProps);
    	}
    	function resetTextContent(domElement) {
    	  setTextContent(domElement, '');
    	}
    	function commitTextUpdate(textInstance, oldText, newText) {
    	  textInstance.nodeValue = newText;
    	}
    	function appendChild(parentInstance, child) {
    	  parentInstance.appendChild(child);
    	}
    	function appendChildToContainer(container, child) {
    	  var parentNode;

    	  if (container.nodeType === COMMENT_NODE) {
    	    parentNode = container.parentNode;
    	    parentNode.insertBefore(child, container);
    	  } else {
    	    parentNode = container;
    	    parentNode.appendChild(child);
    	  } // This container might be used for a portal.
    	  // If something inside a portal is clicked, that click should bubble
    	  // through the React tree. However, on Mobile Safari the click would
    	  // never bubble through the *DOM* tree unless an ancestor with onclick
    	  // event exists. So we wouldn't see it and dispatch it.
    	  // This is why we ensure that non React root containers have inline onclick
    	  // defined.
    	  // https://github.com/facebook/react/issues/11918


    	  var reactRootContainer = container._reactRootContainer;

    	  if ((reactRootContainer === null || reactRootContainer === undefined) && parentNode.onclick === null) {
    	    // TODO: This cast may not be sound for SVG, MathML or custom elements.
    	    trapClickOnNonInteractiveElement(parentNode);
    	  }
    	}
    	function insertBefore(parentInstance, child, beforeChild) {
    	  parentInstance.insertBefore(child, beforeChild);
    	}
    	function insertInContainerBefore(container, child, beforeChild) {
    	  if (container.nodeType === COMMENT_NODE) {
    	    container.parentNode.insertBefore(child, beforeChild);
    	  } else {
    	    container.insertBefore(child, beforeChild);
    	  }
    	}

    	function removeChild(parentInstance, child) {
    	  parentInstance.removeChild(child);
    	}
    	function removeChildFromContainer(container, child) {
    	  if (container.nodeType === COMMENT_NODE) {
    	    container.parentNode.removeChild(child);
    	  } else {
    	    container.removeChild(child);
    	  }
    	}
    	function hideInstance(instance) {
    	  // TODO: Does this work for all element types? What about MathML? Should we
    	  // pass host context to this method?
    	  instance = instance;
    	  var style = instance.style;

    	  if (typeof style.setProperty === 'function') {
    	    style.setProperty('display', 'none', 'important');
    	  } else {
    	    style.display = 'none';
    	  }
    	}
    	function hideTextInstance(textInstance) {
    	  textInstance.nodeValue = '';
    	}
    	function unhideInstance(instance, props) {
    	  instance = instance;
    	  var styleProp = props[STYLE$1];
    	  var display = styleProp !== undefined && styleProp !== null && styleProp.hasOwnProperty('display') ? styleProp.display : null;
    	  instance.style.display = dangerousStyleValue('display', display);
    	}
    	function unhideTextInstance(textInstance, text) {
    	  textInstance.nodeValue = text;
    	}
    	function clearContainer(container) {
    	  if (container.nodeType === ELEMENT_NODE) {
    	    container.textContent = '';
    	  } else if (container.nodeType === DOCUMENT_NODE) {
    	    var body = container.body;

    	    if (body != null) {
    	      body.textContent = '';
    	    }
    	  }
    	} // -------------------
    	function canHydrateInstance(instance, type, props) {
    	  if (instance.nodeType !== ELEMENT_NODE || type.toLowerCase() !== instance.nodeName.toLowerCase()) {
    	    return null;
    	  } // This has now been refined to an element node.


    	  return instance;
    	}
    	function canHydrateTextInstance(instance, text) {
    	  if (text === '' || instance.nodeType !== TEXT_NODE) {
    	    // Empty strings are not parsed by HTML so there won't be a correct match here.
    	    return null;
    	  } // This has now been refined to a text node.


    	  return instance;
    	}
    	function isSuspenseInstancePending(instance) {
    	  return instance.data === SUSPENSE_PENDING_START_DATA;
    	}
    	function isSuspenseInstanceFallback(instance) {
    	  return instance.data === SUSPENSE_FALLBACK_START_DATA;
    	}

    	function getNextHydratable(node) {
    	  // Skip non-hydratable nodes.
    	  for (; node != null; node = node.nextSibling) {
    	    var nodeType = node.nodeType;

    	    if (nodeType === ELEMENT_NODE || nodeType === TEXT_NODE) {
    	      break;
    	    }
    	  }

    	  return node;
    	}

    	function getNextHydratableSibling(instance) {
    	  return getNextHydratable(instance.nextSibling);
    	}
    	function getFirstHydratableChild(parentInstance) {
    	  return getNextHydratable(parentInstance.firstChild);
    	}
    	function hydrateInstance(instance, type, props, rootContainerInstance, hostContext, internalInstanceHandle) {
    	  precacheFiberNode(internalInstanceHandle, instance); // TODO: Possibly defer this until the commit phase where all the events
    	  // get attached.

    	  updateFiberProps(instance, props);
    	  var parentNamespace;

    	  {
    	    var hostContextDev = hostContext;
    	    parentNamespace = hostContextDev.namespace;
    	  }

    	  return diffHydratedProperties(instance, type, props, parentNamespace);
    	}
    	function hydrateTextInstance(textInstance, text, internalInstanceHandle) {
    	  precacheFiberNode(internalInstanceHandle, textInstance);
    	  return diffHydratedText(textInstance, text);
    	}
    	function getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance) {
    	  var node = suspenseInstance.nextSibling; // Skip past all nodes within this suspense boundary.
    	  // There might be nested nodes so we need to keep track of how
    	  // deep we are and only break out when we're back on top.

    	  var depth = 0;

    	  while (node) {
    	    if (node.nodeType === COMMENT_NODE) {
    	      var data = node.data;

    	      if (data === SUSPENSE_END_DATA) {
    	        if (depth === 0) {
    	          return getNextHydratableSibling(node);
    	        } else {
    	          depth--;
    	        }
    	      } else if (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) {
    	        depth++;
    	      }
    	    }

    	    node = node.nextSibling;
    	  } // TODO: Warn, we didn't find the end comment boundary.


    	  return null;
    	} // Returns the SuspenseInstance if this node is a direct child of a
    	// SuspenseInstance. I.e. if its previous sibling is a Comment with
    	// SUSPENSE_x_START_DATA. Otherwise, null.

    	function getParentSuspenseInstance(targetInstance) {
    	  var node = targetInstance.previousSibling; // Skip past all nodes within this suspense boundary.
    	  // There might be nested nodes so we need to keep track of how
    	  // deep we are and only break out when we're back on top.

    	  var depth = 0;

    	  while (node) {
    	    if (node.nodeType === COMMENT_NODE) {
    	      var data = node.data;

    	      if (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) {
    	        if (depth === 0) {
    	          return node;
    	        } else {
    	          depth--;
    	        }
    	      } else if (data === SUSPENSE_END_DATA) {
    	        depth++;
    	      }
    	    }

    	    node = node.previousSibling;
    	  }

    	  return null;
    	}
    	function commitHydratedContainer(container) {
    	  // Retry if any event replaying was blocked on this.
    	  retryIfBlockedOn(container);
    	}
    	function commitHydratedSuspenseInstance(suspenseInstance) {
    	  // Retry if any event replaying was blocked on this.
    	  retryIfBlockedOn(suspenseInstance);
    	}
    	function didNotMatchHydratedContainerTextInstance(parentContainer, textInstance, text) {
    	  {
    	    warnForUnmatchedText(textInstance, text);
    	  }
    	}
    	function didNotMatchHydratedTextInstance(parentType, parentProps, parentInstance, textInstance, text) {
    	  if ( parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
    	    warnForUnmatchedText(textInstance, text);
    	  }
    	}
    	function didNotHydrateContainerInstance(parentContainer, instance) {
    	  {
    	    if (instance.nodeType === ELEMENT_NODE) {
    	      warnForDeletedHydratableElement(parentContainer, instance);
    	    } else if (instance.nodeType === COMMENT_NODE) ; else {
    	      warnForDeletedHydratableText(parentContainer, instance);
    	    }
    	  }
    	}
    	function didNotHydrateInstance(parentType, parentProps, parentInstance, instance) {
    	  if ( parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
    	    if (instance.nodeType === ELEMENT_NODE) {
    	      warnForDeletedHydratableElement(parentInstance, instance);
    	    } else if (instance.nodeType === COMMENT_NODE) ; else {
    	      warnForDeletedHydratableText(parentInstance, instance);
    	    }
    	  }
    	}
    	function didNotFindHydratableContainerInstance(parentContainer, type, props) {
    	  {
    	    warnForInsertedHydratedElement(parentContainer, type);
    	  }
    	}
    	function didNotFindHydratableContainerTextInstance(parentContainer, text) {
    	  {
    	    warnForInsertedHydratedText(parentContainer, text);
    	  }
    	}
    	function didNotFindHydratableInstance(parentType, parentProps, parentInstance, type, props) {
    	  if ( parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
    	    warnForInsertedHydratedElement(parentInstance, type);
    	  }
    	}
    	function didNotFindHydratableTextInstance(parentType, parentProps, parentInstance, text) {
    	  if ( parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
    	    warnForInsertedHydratedText(parentInstance, text);
    	  }
    	}
    	function didNotFindHydratableSuspenseInstance(parentType, parentProps, parentInstance) {
    	  if ( parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) ;
    	}
    	var clientId = 0;
    	function makeClientIdInDEV(warnOnAccessInDEV) {
    	  var id = 'r:' + (clientId++).toString(36);
    	  return {
    	    toString: function () {
    	      warnOnAccessInDEV();
    	      return id;
    	    },
    	    valueOf: function () {
    	      warnOnAccessInDEV();
    	      return id;
    	    }
    	  };
    	}
    	function isOpaqueHydratingObject(value) {
    	  return value !== null && typeof value === 'object' && value.$$typeof === REACT_OPAQUE_ID_TYPE;
    	}
    	function makeOpaqueHydratingObject(attemptToReadValue) {
    	  return {
    	    $$typeof: REACT_OPAQUE_ID_TYPE,
    	    toString: attemptToReadValue,
    	    valueOf: attemptToReadValue
    	  };
    	}
    	function preparePortalMount(portalInstance) {
    	  {
    	    listenToAllSupportedEvents(portalInstance);
    	  }
    	}

    	var randomKey = Math.random().toString(36).slice(2);
    	var internalInstanceKey = '__reactFiber$' + randomKey;
    	var internalPropsKey = '__reactProps$' + randomKey;
    	var internalContainerInstanceKey = '__reactContainer$' + randomKey;
    	var internalEventHandlersKey = '__reactEvents$' + randomKey;
    	function precacheFiberNode(hostInst, node) {
    	  node[internalInstanceKey] = hostInst;
    	}
    	function markContainerAsRoot(hostRoot, node) {
    	  node[internalContainerInstanceKey] = hostRoot;
    	}
    	function unmarkContainerAsRoot(node) {
    	  node[internalContainerInstanceKey] = null;
    	}
    	function isContainerMarkedAsRoot(node) {
    	  return !!node[internalContainerInstanceKey];
    	} // Given a DOM node, return the closest HostComponent or HostText fiber ancestor.
    	// If the target node is part of a hydrated or not yet rendered subtree, then
    	// this may also return a SuspenseComponent or HostRoot to indicate that.
    	// Conceptually the HostRoot fiber is a child of the Container node. So if you
    	// pass the Container node as the targetNode, you will not actually get the
    	// HostRoot back. To get to the HostRoot, you need to pass a child of it.
    	// The same thing applies to Suspense boundaries.

    	function getClosestInstanceFromNode(targetNode) {
    	  var targetInst = targetNode[internalInstanceKey];

    	  if (targetInst) {
    	    // Don't return HostRoot or SuspenseComponent here.
    	    return targetInst;
    	  } // If the direct event target isn't a React owned DOM node, we need to look
    	  // to see if one of its parents is a React owned DOM node.


    	  var parentNode = targetNode.parentNode;

    	  while (parentNode) {
    	    // We'll check if this is a container root that could include
    	    // React nodes in the future. We need to check this first because
    	    // if we're a child of a dehydrated container, we need to first
    	    // find that inner container before moving on to finding the parent
    	    // instance. Note that we don't check this field on  the targetNode
    	    // itself because the fibers are conceptually between the container
    	    // node and the first child. It isn't surrounding the container node.
    	    // If it's not a container, we check if it's an instance.
    	    targetInst = parentNode[internalContainerInstanceKey] || parentNode[internalInstanceKey];

    	    if (targetInst) {
    	      // Since this wasn't the direct target of the event, we might have
    	      // stepped past dehydrated DOM nodes to get here. However they could
    	      // also have been non-React nodes. We need to answer which one.
    	      // If we the instance doesn't have any children, then there can't be
    	      // a nested suspense boundary within it. So we can use this as a fast
    	      // bailout. Most of the time, when people add non-React children to
    	      // the tree, it is using a ref to a child-less DOM node.
    	      // Normally we'd only need to check one of the fibers because if it
    	      // has ever gone from having children to deleting them or vice versa
    	      // it would have deleted the dehydrated boundary nested inside already.
    	      // However, since the HostRoot starts out with an alternate it might
    	      // have one on the alternate so we need to check in case this was a
    	      // root.
    	      var alternate = targetInst.alternate;

    	      if (targetInst.child !== null || alternate !== null && alternate.child !== null) {
    	        // Next we need to figure out if the node that skipped past is
    	        // nested within a dehydrated boundary and if so, which one.
    	        var suspenseInstance = getParentSuspenseInstance(targetNode);

    	        while (suspenseInstance !== null) {
    	          // We found a suspense instance. That means that we haven't
    	          // hydrated it yet. Even though we leave the comments in the
    	          // DOM after hydrating, and there are boundaries in the DOM
    	          // that could already be hydrated, we wouldn't have found them
    	          // through this pass since if the target is hydrated it would
    	          // have had an internalInstanceKey on it.
    	          // Let's get the fiber associated with the SuspenseComponent
    	          // as the deepest instance.
    	          var targetSuspenseInst = suspenseInstance[internalInstanceKey];

    	          if (targetSuspenseInst) {
    	            return targetSuspenseInst;
    	          } // If we don't find a Fiber on the comment, it might be because
    	          // we haven't gotten to hydrate it yet. There might still be a
    	          // parent boundary that hasn't above this one so we need to find
    	          // the outer most that is known.


    	          suspenseInstance = getParentSuspenseInstance(suspenseInstance); // If we don't find one, then that should mean that the parent
    	          // host component also hasn't hydrated yet. We can return it
    	          // below since it will bail out on the isMounted check later.
    	        }
    	      }

    	      return targetInst;
    	    }

    	    targetNode = parentNode;
    	    parentNode = targetNode.parentNode;
    	  }

    	  return null;
    	}
    	/**
    	 * Given a DOM node, return the ReactDOMComponent or ReactDOMTextComponent
    	 * instance, or null if the node was not rendered by this React.
    	 */

    	function getInstanceFromNode(node) {
    	  var inst = node[internalInstanceKey] || node[internalContainerInstanceKey];

    	  if (inst) {
    	    if (inst.tag === HostComponent || inst.tag === HostText || inst.tag === SuspenseComponent || inst.tag === HostRoot) {
    	      return inst;
    	    } else {
    	      return null;
    	    }
    	  }

    	  return null;
    	}
    	/**
    	 * Given a ReactDOMComponent or ReactDOMTextComponent, return the corresponding
    	 * DOM node.
    	 */

    	function getNodeFromInstance(inst) {
    	  if (inst.tag === HostComponent || inst.tag === HostText) {
    	    // In Fiber this, is just the state node right now. We assume it will be
    	    // a host component or host text.
    	    return inst.stateNode;
    	  } // Without this first invariant, passing a non-DOM-component triggers the next
    	  // invariant for a missing parent, which is super confusing.


    	  {
    	    {
    	      throw Error( "getNodeFromInstance: Invalid argument." );
    	    }
    	  }
    	}
    	function getFiberCurrentPropsFromNode(node) {
    	  return node[internalPropsKey] || null;
    	}
    	function updateFiberProps(node, props) {
    	  node[internalPropsKey] = props;
    	}
    	function getEventListenerSet(node) {
    	  var elementListenerSet = node[internalEventHandlersKey];

    	  if (elementListenerSet === undefined) {
    	    elementListenerSet = node[internalEventHandlersKey] = new Set();
    	  }

    	  return elementListenerSet;
    	}

    	var loggedTypeFailures = {};
    	var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;

    	function setCurrentlyValidatingElement(element) {
    	  {
    	    if (element) {
    	      var owner = element._owner;
    	      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
    	      ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
    	    } else {
    	      ReactDebugCurrentFrame$1.setExtraStackFrame(null);
    	    }
    	  }
    	}

    	function checkPropTypes(typeSpecs, values, location, componentName, element) {
    	  {
    	    // $FlowFixMe This is okay but Flow doesn't know it.
    	    var has = Function.call.bind(Object.prototype.hasOwnProperty);

    	    for (var typeSpecName in typeSpecs) {
    	      if (has(typeSpecs, typeSpecName)) {
    	        var error$1 = void 0; // Prop type validation may throw. In case they do, we don't want to
    	        // fail the render phase where it didn't fail before. So we log it.
    	        // After these have been cleaned up, we'll let them throw.

    	        try {
    	          // This is intentionally an invariant that gets caught. It's the same
    	          // behavior as without this statement except with a better message.
    	          if (typeof typeSpecs[typeSpecName] !== 'function') {
    	            var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' + 'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.');
    	            err.name = 'Invariant Violation';
    	            throw err;
    	          }

    	          error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED');
    	        } catch (ex) {
    	          error$1 = ex;
    	        }

    	        if (error$1 && !(error$1 instanceof Error)) {
    	          setCurrentlyValidatingElement(element);

    	          error('%s: type specification of %s' + ' `%s` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a %s. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).', componentName || 'React class', location, typeSpecName, typeof error$1);

    	          setCurrentlyValidatingElement(null);
    	        }

    	        if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
    	          // Only monitor this failure once because there tends to be a lot of the
    	          // same error.
    	          loggedTypeFailures[error$1.message] = true;
    	          setCurrentlyValidatingElement(element);

    	          error('Failed %s type: %s', location, error$1.message);

    	          setCurrentlyValidatingElement(null);
    	        }
    	      }
    	    }
    	  }
    	}

    	var valueStack = [];
    	var fiberStack;

    	{
    	  fiberStack = [];
    	}

    	var index = -1;

    	function createCursor(defaultValue) {
    	  return {
    	    current: defaultValue
    	  };
    	}

    	function pop(cursor, fiber) {
    	  if (index < 0) {
    	    {
    	      error('Unexpected pop.');
    	    }

    	    return;
    	  }

    	  {
    	    if (fiber !== fiberStack[index]) {
    	      error('Unexpected Fiber popped.');
    	    }
    	  }

    	  cursor.current = valueStack[index];
    	  valueStack[index] = null;

    	  {
    	    fiberStack[index] = null;
    	  }

    	  index--;
    	}

    	function push(cursor, value, fiber) {
    	  index++;
    	  valueStack[index] = cursor.current;

    	  {
    	    fiberStack[index] = fiber;
    	  }

    	  cursor.current = value;
    	}

    	var warnedAboutMissingGetChildContext;

    	{
    	  warnedAboutMissingGetChildContext = {};
    	}

    	var emptyContextObject = {};

    	{
    	  Object.freeze(emptyContextObject);
    	} // A cursor to the current merged context object on the stack.


    	var contextStackCursor = createCursor(emptyContextObject); // A cursor to a boolean indicating whether the context has changed.

    	var didPerformWorkStackCursor = createCursor(false); // Keep track of the previous context object that was on the stack.
    	// We use this to get access to the parent context after we have already
    	// pushed the next context provider, and now need to merge their contexts.

    	var previousContext = emptyContextObject;

    	function getUnmaskedContext(workInProgress, Component, didPushOwnContextIfProvider) {
    	  {
    	    if (didPushOwnContextIfProvider && isContextProvider(Component)) {
    	      // If the fiber is a context provider itself, when we read its context
    	      // we may have already pushed its own child context on the stack. A context
    	      // provider should not "see" its own child context. Therefore we read the
    	      // previous (parent) context instead for a context provider.
    	      return previousContext;
    	    }

    	    return contextStackCursor.current;
    	  }
    	}

    	function cacheContext(workInProgress, unmaskedContext, maskedContext) {
    	  {
    	    var instance = workInProgress.stateNode;
    	    instance.__reactInternalMemoizedUnmaskedChildContext = unmaskedContext;
    	    instance.__reactInternalMemoizedMaskedChildContext = maskedContext;
    	  }
    	}

    	function getMaskedContext(workInProgress, unmaskedContext) {
    	  {
    	    var type = workInProgress.type;
    	    var contextTypes = type.contextTypes;

    	    if (!contextTypes) {
    	      return emptyContextObject;
    	    } // Avoid recreating masked context unless unmasked context has changed.
    	    // Failing to do this will result in unnecessary calls to componentWillReceiveProps.
    	    // This may trigger infinite loops if componentWillReceiveProps calls setState.


    	    var instance = workInProgress.stateNode;

    	    if (instance && instance.__reactInternalMemoizedUnmaskedChildContext === unmaskedContext) {
    	      return instance.__reactInternalMemoizedMaskedChildContext;
    	    }

    	    var context = {};

    	    for (var key in contextTypes) {
    	      context[key] = unmaskedContext[key];
    	    }

    	    {
    	      var name = getComponentName(type) || 'Unknown';
    	      checkPropTypes(contextTypes, context, 'context', name);
    	    } // Cache unmasked context so we can avoid recreating masked context unless necessary.
    	    // Context is created before the class component is instantiated so check for instance.


    	    if (instance) {
    	      cacheContext(workInProgress, unmaskedContext, context);
    	    }

    	    return context;
    	  }
    	}

    	function hasContextChanged() {
    	  {
    	    return didPerformWorkStackCursor.current;
    	  }
    	}

    	function isContextProvider(type) {
    	  {
    	    var childContextTypes = type.childContextTypes;
    	    return childContextTypes !== null && childContextTypes !== undefined;
    	  }
    	}

    	function popContext(fiber) {
    	  {
    	    pop(didPerformWorkStackCursor, fiber);
    	    pop(contextStackCursor, fiber);
    	  }
    	}

    	function popTopLevelContextObject(fiber) {
    	  {
    	    pop(didPerformWorkStackCursor, fiber);
    	    pop(contextStackCursor, fiber);
    	  }
    	}

    	function pushTopLevelContextObject(fiber, context, didChange) {
    	  {
    	    if (!(contextStackCursor.current === emptyContextObject)) {
    	      {
    	        throw Error( "Unexpected context found on stack. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }

    	    push(contextStackCursor, context, fiber);
    	    push(didPerformWorkStackCursor, didChange, fiber);
    	  }
    	}

    	function processChildContext(fiber, type, parentContext) {
    	  {
    	    var instance = fiber.stateNode;
    	    var childContextTypes = type.childContextTypes; // TODO (bvaughn) Replace this behavior with an invariant() in the future.
    	    // It has only been added in Fiber to match the (unintentional) behavior in Stack.

    	    if (typeof instance.getChildContext !== 'function') {
    	      {
    	        var componentName = getComponentName(type) || 'Unknown';

    	        if (!warnedAboutMissingGetChildContext[componentName]) {
    	          warnedAboutMissingGetChildContext[componentName] = true;

    	          error('%s.childContextTypes is specified but there is no getChildContext() method ' + 'on the instance. You can either define getChildContext() on %s or remove ' + 'childContextTypes from it.', componentName, componentName);
    	        }
    	      }

    	      return parentContext;
    	    }

    	    var childContext = instance.getChildContext();

    	    for (var contextKey in childContext) {
    	      if (!(contextKey in childContextTypes)) {
    	        {
    	          throw Error( (getComponentName(type) || 'Unknown') + ".getChildContext(): key \"" + contextKey + "\" is not defined in childContextTypes." );
    	        }
    	      }
    	    }

    	    {
    	      var name = getComponentName(type) || 'Unknown';
    	      checkPropTypes(childContextTypes, childContext, 'child context', name);
    	    }

    	    return _assign({}, parentContext, childContext);
    	  }
    	}

    	function pushContextProvider(workInProgress) {
    	  {
    	    var instance = workInProgress.stateNode; // We push the context as early as possible to ensure stack integrity.
    	    // If the instance does not exist yet, we will push null at first,
    	    // and replace it on the stack later when invalidating the context.

    	    var memoizedMergedChildContext = instance && instance.__reactInternalMemoizedMergedChildContext || emptyContextObject; // Remember the parent context so we can merge with it later.
    	    // Inherit the parent's did-perform-work value to avoid inadvertently blocking updates.

    	    previousContext = contextStackCursor.current;
    	    push(contextStackCursor, memoizedMergedChildContext, workInProgress);
    	    push(didPerformWorkStackCursor, didPerformWorkStackCursor.current, workInProgress);
    	    return true;
    	  }
    	}

    	function invalidateContextProvider(workInProgress, type, didChange) {
    	  {
    	    var instance = workInProgress.stateNode;

    	    if (!instance) {
    	      {
    	        throw Error( "Expected to have an instance by this point. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }

    	    if (didChange) {
    	      // Merge parent and own context.
    	      // Skip this if we're not updating due to sCU.
    	      // This avoids unnecessarily recomputing memoized values.
    	      var mergedContext = processChildContext(workInProgress, type, previousContext);
    	      instance.__reactInternalMemoizedMergedChildContext = mergedContext; // Replace the old (or empty) context with the new one.
    	      // It is important to unwind the context in the reverse order.

    	      pop(didPerformWorkStackCursor, workInProgress);
    	      pop(contextStackCursor, workInProgress); // Now push the new context and mark that it has changed.

    	      push(contextStackCursor, mergedContext, workInProgress);
    	      push(didPerformWorkStackCursor, didChange, workInProgress);
    	    } else {
    	      pop(didPerformWorkStackCursor, workInProgress);
    	      push(didPerformWorkStackCursor, didChange, workInProgress);
    	    }
    	  }
    	}

    	function findCurrentUnmaskedContext(fiber) {
    	  {
    	    // Currently this is only used with renderSubtreeIntoContainer; not sure if it
    	    // makes sense elsewhere
    	    if (!(isFiberMounted(fiber) && fiber.tag === ClassComponent)) {
    	      {
    	        throw Error( "Expected subtree parent to be a mounted class component. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }

    	    var node = fiber;

    	    do {
    	      switch (node.tag) {
    	        case HostRoot:
    	          return node.stateNode.context;

    	        case ClassComponent:
    	          {
    	            var Component = node.type;

    	            if (isContextProvider(Component)) {
    	              return node.stateNode.__reactInternalMemoizedMergedChildContext;
    	            }

    	            break;
    	          }
    	      }

    	      node = node.return;
    	    } while (node !== null);

    	    {
    	      {
    	        throw Error( "Found unexpected detached subtree parent. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }
    	  }
    	}

    	var LegacyRoot = 0;
    	var BlockingRoot = 1;
    	var ConcurrentRoot = 2;

    	var rendererID = null;
    	var injectedHook = null;
    	var hasLoggedError = false;
    	var isDevToolsPresent = typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== 'undefined';
    	function injectInternals(internals) {
    	  if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === 'undefined') {
    	    // No DevTools
    	    return false;
    	  }

    	  var hook = __REACT_DEVTOOLS_GLOBAL_HOOK__;

    	  if (hook.isDisabled) {
    	    // This isn't a real property on the hook, but it can be set to opt out
    	    // of DevTools integration and associated warnings and logs.
    	    // https://github.com/facebook/react/issues/3877
    	    return true;
    	  }

    	  if (!hook.supportsFiber) {
    	    {
    	      error('The installed version of React DevTools is too old and will not work ' + 'with the current version of React. Please update React DevTools. ' + 'https://reactjs.org/link/react-devtools');
    	    } // DevTools exists, even though it doesn't support Fiber.


    	    return true;
    	  }

    	  try {
    	    rendererID = hook.inject(internals); // We have successfully injected, so now it is safe to set up hooks.

    	    injectedHook = hook;
    	  } catch (err) {
    	    // Catch all errors because it is unsafe to throw during initialization.
    	    {
    	      error('React instrumentation encountered an error: %s.', err);
    	    }
    	  } // DevTools exists


    	  return true;
    	}
    	function onScheduleRoot(root, children) {
    	  {
    	    if (injectedHook && typeof injectedHook.onScheduleFiberRoot === 'function') {
    	      try {
    	        injectedHook.onScheduleFiberRoot(rendererID, root, children);
    	      } catch (err) {
    	        if ( !hasLoggedError) {
    	          hasLoggedError = true;

    	          error('React instrumentation encountered an error: %s', err);
    	        }
    	      }
    	    }
    	  }
    	}
    	function onCommitRoot(root, priorityLevel) {
    	  if (injectedHook && typeof injectedHook.onCommitFiberRoot === 'function') {
    	    try {
    	      var didError = (root.current.flags & DidCapture) === DidCapture;

    	      if (enableProfilerTimer) {
    	        injectedHook.onCommitFiberRoot(rendererID, root, priorityLevel, didError);
    	      }
    	    } catch (err) {
    	      {
    	        if (!hasLoggedError) {
    	          hasLoggedError = true;

    	          error('React instrumentation encountered an error: %s', err);
    	        }
    	      }
    	    }
    	  }
    	}
    	function onCommitUnmount(fiber) {
    	  if (injectedHook && typeof injectedHook.onCommitFiberUnmount === 'function') {
    	    try {
    	      injectedHook.onCommitFiberUnmount(rendererID, fiber);
    	    } catch (err) {
    	      {
    	        if (!hasLoggedError) {
    	          hasLoggedError = true;

    	          error('React instrumentation encountered an error: %s', err);
    	        }
    	      }
    	    }
    	  }
    	}

    	var Scheduler_runWithPriority = Scheduler.unstable_runWithPriority,
    	    Scheduler_scheduleCallback = Scheduler.unstable_scheduleCallback,
    	    Scheduler_cancelCallback = Scheduler.unstable_cancelCallback,
    	    Scheduler_shouldYield = Scheduler.unstable_shouldYield,
    	    Scheduler_requestPaint = Scheduler.unstable_requestPaint,
    	    Scheduler_now$1 = Scheduler.unstable_now,
    	    Scheduler_getCurrentPriorityLevel = Scheduler.unstable_getCurrentPriorityLevel,
    	    Scheduler_ImmediatePriority = Scheduler.unstable_ImmediatePriority,
    	    Scheduler_UserBlockingPriority = Scheduler.unstable_UserBlockingPriority,
    	    Scheduler_NormalPriority = Scheduler.unstable_NormalPriority,
    	    Scheduler_LowPriority = Scheduler.unstable_LowPriority,
    	    Scheduler_IdlePriority = Scheduler.unstable_IdlePriority;

    	{
    	  // Provide explicit error message when production+profiling bundle of e.g.
    	  // react-dom is used with production (non-profiling) bundle of
    	  // scheduler/tracing
    	  if (!(tracing.__interactionsRef != null && tracing.__interactionsRef.current != null)) {
    	    {
    	      throw Error( "It is not supported to run the profiling version of a renderer (for example, `react-dom/profiling`) without also replacing the `scheduler/tracing` module with `scheduler/tracing-profiling`. Your bundler might have a setting for aliasing both modules. Learn more at https://reactjs.org/link/profiling" );
    	    }
    	  }
    	}

    	var fakeCallbackNode = {}; // Except for NoPriority, these correspond to Scheduler priorities. We use
    	// ascending numbers so we can compare them like numbers. They start at 90 to
    	// avoid clashing with Scheduler's priorities.

    	var ImmediatePriority$1 = 99;
    	var UserBlockingPriority$2 = 98;
    	var NormalPriority$1 = 97;
    	var LowPriority$1 = 96;
    	var IdlePriority$1 = 95; // NoPriority is the absence of priority. Also React-only.

    	var NoPriority$1 = 90;
    	var shouldYield = Scheduler_shouldYield;
    	var requestPaint = // Fall back gracefully if we're running an older version of Scheduler.
    	Scheduler_requestPaint !== undefined ? Scheduler_requestPaint : function () {};
    	var syncQueue = null;
    	var immediateQueueCallbackNode = null;
    	var isFlushingSyncQueue = false;
    	var initialTimeMs$1 = Scheduler_now$1(); // If the initial timestamp is reasonably small, use Scheduler's `now` directly.
    	// This will be the case for modern browsers that support `performance.now`. In
    	// older browsers, Scheduler falls back to `Date.now`, which returns a Unix
    	// timestamp. In that case, subtract the module initialization time to simulate
    	// the behavior of performance.now and keep our times small enough to fit
    	// within 32 bits.
    	// TODO: Consider lifting this into Scheduler.

    	var now = initialTimeMs$1 < 10000 ? Scheduler_now$1 : function () {
    	  return Scheduler_now$1() - initialTimeMs$1;
    	};
    	function getCurrentPriorityLevel() {
    	  switch (Scheduler_getCurrentPriorityLevel()) {
    	    case Scheduler_ImmediatePriority:
    	      return ImmediatePriority$1;

    	    case Scheduler_UserBlockingPriority:
    	      return UserBlockingPriority$2;

    	    case Scheduler_NormalPriority:
    	      return NormalPriority$1;

    	    case Scheduler_LowPriority:
    	      return LowPriority$1;

    	    case Scheduler_IdlePriority:
    	      return IdlePriority$1;

    	    default:
    	      {
    	        {
    	          throw Error( "Unknown priority level." );
    	        }
    	      }

    	  }
    	}

    	function reactPriorityToSchedulerPriority(reactPriorityLevel) {
    	  switch (reactPriorityLevel) {
    	    case ImmediatePriority$1:
    	      return Scheduler_ImmediatePriority;

    	    case UserBlockingPriority$2:
    	      return Scheduler_UserBlockingPriority;

    	    case NormalPriority$1:
    	      return Scheduler_NormalPriority;

    	    case LowPriority$1:
    	      return Scheduler_LowPriority;

    	    case IdlePriority$1:
    	      return Scheduler_IdlePriority;

    	    default:
    	      {
    	        {
    	          throw Error( "Unknown priority level." );
    	        }
    	      }

    	  }
    	}

    	function runWithPriority$1(reactPriorityLevel, fn) {
    	  var priorityLevel = reactPriorityToSchedulerPriority(reactPriorityLevel);
    	  return Scheduler_runWithPriority(priorityLevel, fn);
    	}
    	function scheduleCallback(reactPriorityLevel, callback, options) {
    	  var priorityLevel = reactPriorityToSchedulerPriority(reactPriorityLevel);
    	  return Scheduler_scheduleCallback(priorityLevel, callback, options);
    	}
    	function scheduleSyncCallback(callback) {
    	  // Push this callback into an internal queue. We'll flush these either in
    	  // the next tick, or earlier if something calls `flushSyncCallbackQueue`.
    	  if (syncQueue === null) {
    	    syncQueue = [callback]; // Flush the queue in the next tick, at the earliest.

    	    immediateQueueCallbackNode = Scheduler_scheduleCallback(Scheduler_ImmediatePriority, flushSyncCallbackQueueImpl);
    	  } else {
    	    // Push onto existing queue. Don't need to schedule a callback because
    	    // we already scheduled one when we created the queue.
    	    syncQueue.push(callback);
    	  }

    	  return fakeCallbackNode;
    	}
    	function cancelCallback(callbackNode) {
    	  if (callbackNode !== fakeCallbackNode) {
    	    Scheduler_cancelCallback(callbackNode);
    	  }
    	}
    	function flushSyncCallbackQueue() {
    	  if (immediateQueueCallbackNode !== null) {
    	    var node = immediateQueueCallbackNode;
    	    immediateQueueCallbackNode = null;
    	    Scheduler_cancelCallback(node);
    	  }

    	  flushSyncCallbackQueueImpl();
    	}

    	function flushSyncCallbackQueueImpl() {
    	  if (!isFlushingSyncQueue && syncQueue !== null) {
    	    // Prevent re-entrancy.
    	    isFlushingSyncQueue = true;
    	    var i = 0;

    	    {
    	      try {
    	        var _isSync2 = true;
    	        var _queue = syncQueue;
    	        runWithPriority$1(ImmediatePriority$1, function () {
    	          for (; i < _queue.length; i++) {
    	            var callback = _queue[i];

    	            do {
    	              callback = callback(_isSync2);
    	            } while (callback !== null);
    	          }
    	        });
    	        syncQueue = null;
    	      } catch (error) {
    	        // If something throws, leave the remaining callbacks on the queue.
    	        if (syncQueue !== null) {
    	          syncQueue = syncQueue.slice(i + 1);
    	        } // Resume flushing in the next tick


    	        Scheduler_scheduleCallback(Scheduler_ImmediatePriority, flushSyncCallbackQueue);
    	        throw error;
    	      } finally {
    	        isFlushingSyncQueue = false;
    	      }
    	    }
    	  }
    	}

    	// TODO: this is special because it gets imported during build.
    	var ReactVersion = '17.0.2';

    	var NoMode = 0;
    	var StrictMode = 1; // TODO: Remove BlockingMode and ConcurrentMode by reading from the root
    	// tag instead

    	var BlockingMode = 2;
    	var ConcurrentMode = 4;
    	var ProfileMode = 8;
    	var DebugTracingMode = 16;

    	var ReactCurrentBatchConfig = ReactSharedInternals.ReactCurrentBatchConfig;
    	var NoTransition = 0;
    	function requestCurrentTransition() {
    	  return ReactCurrentBatchConfig.transition;
    	}

    	var ReactStrictModeWarnings = {
    	  recordUnsafeLifecycleWarnings: function (fiber, instance) {},
    	  flushPendingUnsafeLifecycleWarnings: function () {},
    	  recordLegacyContextWarning: function (fiber, instance) {},
    	  flushLegacyContextWarning: function () {},
    	  discardPendingWarnings: function () {}
    	};

    	{
    	  var findStrictRoot = function (fiber) {
    	    var maybeStrictRoot = null;
    	    var node = fiber;

    	    while (node !== null) {
    	      if (node.mode & StrictMode) {
    	        maybeStrictRoot = node;
    	      }

    	      node = node.return;
    	    }

    	    return maybeStrictRoot;
    	  };

    	  var setToSortedString = function (set) {
    	    var array = [];
    	    set.forEach(function (value) {
    	      array.push(value);
    	    });
    	    return array.sort().join(', ');
    	  };

    	  var pendingComponentWillMountWarnings = [];
    	  var pendingUNSAFE_ComponentWillMountWarnings = [];
    	  var pendingComponentWillReceivePropsWarnings = [];
    	  var pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
    	  var pendingComponentWillUpdateWarnings = [];
    	  var pendingUNSAFE_ComponentWillUpdateWarnings = []; // Tracks components we have already warned about.

    	  var didWarnAboutUnsafeLifecycles = new Set();

    	  ReactStrictModeWarnings.recordUnsafeLifecycleWarnings = function (fiber, instance) {
    	    // Dedup strategy: Warn once per component.
    	    if (didWarnAboutUnsafeLifecycles.has(fiber.type)) {
    	      return;
    	    }

    	    if (typeof instance.componentWillMount === 'function' && // Don't warn about react-lifecycles-compat polyfilled components.
    	    instance.componentWillMount.__suppressDeprecationWarning !== true) {
    	      pendingComponentWillMountWarnings.push(fiber);
    	    }

    	    if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillMount === 'function') {
    	      pendingUNSAFE_ComponentWillMountWarnings.push(fiber);
    	    }

    	    if (typeof instance.componentWillReceiveProps === 'function' && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
    	      pendingComponentWillReceivePropsWarnings.push(fiber);
    	    }

    	    if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillReceiveProps === 'function') {
    	      pendingUNSAFE_ComponentWillReceivePropsWarnings.push(fiber);
    	    }

    	    if (typeof instance.componentWillUpdate === 'function' && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
    	      pendingComponentWillUpdateWarnings.push(fiber);
    	    }

    	    if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillUpdate === 'function') {
    	      pendingUNSAFE_ComponentWillUpdateWarnings.push(fiber);
    	    }
    	  };

    	  ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings = function () {
    	    // We do an initial pass to gather component names
    	    var componentWillMountUniqueNames = new Set();

    	    if (pendingComponentWillMountWarnings.length > 0) {
    	      pendingComponentWillMountWarnings.forEach(function (fiber) {
    	        componentWillMountUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingComponentWillMountWarnings = [];
    	    }

    	    var UNSAFE_componentWillMountUniqueNames = new Set();

    	    if (pendingUNSAFE_ComponentWillMountWarnings.length > 0) {
    	      pendingUNSAFE_ComponentWillMountWarnings.forEach(function (fiber) {
    	        UNSAFE_componentWillMountUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingUNSAFE_ComponentWillMountWarnings = [];
    	    }

    	    var componentWillReceivePropsUniqueNames = new Set();

    	    if (pendingComponentWillReceivePropsWarnings.length > 0) {
    	      pendingComponentWillReceivePropsWarnings.forEach(function (fiber) {
    	        componentWillReceivePropsUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingComponentWillReceivePropsWarnings = [];
    	    }

    	    var UNSAFE_componentWillReceivePropsUniqueNames = new Set();

    	    if (pendingUNSAFE_ComponentWillReceivePropsWarnings.length > 0) {
    	      pendingUNSAFE_ComponentWillReceivePropsWarnings.forEach(function (fiber) {
    	        UNSAFE_componentWillReceivePropsUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
    	    }

    	    var componentWillUpdateUniqueNames = new Set();

    	    if (pendingComponentWillUpdateWarnings.length > 0) {
    	      pendingComponentWillUpdateWarnings.forEach(function (fiber) {
    	        componentWillUpdateUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingComponentWillUpdateWarnings = [];
    	    }

    	    var UNSAFE_componentWillUpdateUniqueNames = new Set();

    	    if (pendingUNSAFE_ComponentWillUpdateWarnings.length > 0) {
    	      pendingUNSAFE_ComponentWillUpdateWarnings.forEach(function (fiber) {
    	        UNSAFE_componentWillUpdateUniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutUnsafeLifecycles.add(fiber.type);
    	      });
    	      pendingUNSAFE_ComponentWillUpdateWarnings = [];
    	    } // Finally, we flush all the warnings
    	    // UNSAFE_ ones before the deprecated ones, since they'll be 'louder'


    	    if (UNSAFE_componentWillMountUniqueNames.size > 0) {
    	      var sortedNames = setToSortedString(UNSAFE_componentWillMountUniqueNames);

    	      error('Using UNSAFE_componentWillMount in strict mode is not recommended and may indicate bugs in your code. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move code with side effects to componentDidMount, and set initial state in the constructor.\n' + '\nPlease update the following components: %s', sortedNames);
    	    }

    	    if (UNSAFE_componentWillReceivePropsUniqueNames.size > 0) {
    	      var _sortedNames = setToSortedString(UNSAFE_componentWillReceivePropsUniqueNames);

    	      error('Using UNSAFE_componentWillReceiveProps in strict mode is not recommended ' + 'and may indicate bugs in your code. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move data fetching code or side effects to componentDidUpdate.\n' + "* If you're updating state whenever props change, " + 'refactor your code to use memoization techniques or move it to ' + 'static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state\n' + '\nPlease update the following components: %s', _sortedNames);
    	    }

    	    if (UNSAFE_componentWillUpdateUniqueNames.size > 0) {
    	      var _sortedNames2 = setToSortedString(UNSAFE_componentWillUpdateUniqueNames);

    	      error('Using UNSAFE_componentWillUpdate in strict mode is not recommended ' + 'and may indicate bugs in your code. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move data fetching code or side effects to componentDidUpdate.\n' + '\nPlease update the following components: %s', _sortedNames2);
    	    }

    	    if (componentWillMountUniqueNames.size > 0) {
    	      var _sortedNames3 = setToSortedString(componentWillMountUniqueNames);

    	      warn('componentWillMount has been renamed, and is not recommended for use. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move code with side effects to componentDidMount, and set initial state in the constructor.\n' + '* Rename componentWillMount to UNSAFE_componentWillMount to suppress ' + 'this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. ' + 'To rename all deprecated lifecycles to their new names, you can run ' + '`npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n' + '\nPlease update the following components: %s', _sortedNames3);
    	    }

    	    if (componentWillReceivePropsUniqueNames.size > 0) {
    	      var _sortedNames4 = setToSortedString(componentWillReceivePropsUniqueNames);

    	      warn('componentWillReceiveProps has been renamed, and is not recommended for use. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move data fetching code or side effects to componentDidUpdate.\n' + "* If you're updating state whenever props change, refactor your " + 'code to use memoization techniques or move it to ' + 'static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state\n' + '* Rename componentWillReceiveProps to UNSAFE_componentWillReceiveProps to suppress ' + 'this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. ' + 'To rename all deprecated lifecycles to their new names, you can run ' + '`npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n' + '\nPlease update the following components: %s', _sortedNames4);
    	    }

    	    if (componentWillUpdateUniqueNames.size > 0) {
    	      var _sortedNames5 = setToSortedString(componentWillUpdateUniqueNames);

    	      warn('componentWillUpdate has been renamed, and is not recommended for use. ' + 'See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n' + '* Move data fetching code or side effects to componentDidUpdate.\n' + '* Rename componentWillUpdate to UNSAFE_componentWillUpdate to suppress ' + 'this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. ' + 'To rename all deprecated lifecycles to their new names, you can run ' + '`npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n' + '\nPlease update the following components: %s', _sortedNames5);
    	    }
    	  };

    	  var pendingLegacyContextWarning = new Map(); // Tracks components we have already warned about.

    	  var didWarnAboutLegacyContext = new Set();

    	  ReactStrictModeWarnings.recordLegacyContextWarning = function (fiber, instance) {
    	    var strictRoot = findStrictRoot(fiber);

    	    if (strictRoot === null) {
    	      error('Expected to find a StrictMode component in a strict mode tree. ' + 'This error is likely caused by a bug in React. Please file an issue.');

    	      return;
    	    } // Dedup strategy: Warn once per component.


    	    if (didWarnAboutLegacyContext.has(fiber.type)) {
    	      return;
    	    }

    	    var warningsForRoot = pendingLegacyContextWarning.get(strictRoot);

    	    if (fiber.type.contextTypes != null || fiber.type.childContextTypes != null || instance !== null && typeof instance.getChildContext === 'function') {
    	      if (warningsForRoot === undefined) {
    	        warningsForRoot = [];
    	        pendingLegacyContextWarning.set(strictRoot, warningsForRoot);
    	      }

    	      warningsForRoot.push(fiber);
    	    }
    	  };

    	  ReactStrictModeWarnings.flushLegacyContextWarning = function () {
    	    pendingLegacyContextWarning.forEach(function (fiberArray, strictRoot) {
    	      if (fiberArray.length === 0) {
    	        return;
    	      }

    	      var firstFiber = fiberArray[0];
    	      var uniqueNames = new Set();
    	      fiberArray.forEach(function (fiber) {
    	        uniqueNames.add(getComponentName(fiber.type) || 'Component');
    	        didWarnAboutLegacyContext.add(fiber.type);
    	      });
    	      var sortedNames = setToSortedString(uniqueNames);

    	      try {
    	        setCurrentFiber(firstFiber);

    	        error('Legacy context API has been detected within a strict-mode tree.' + '\n\nThe old API will be supported in all 16.x releases, but applications ' + 'using it should migrate to the new version.' + '\n\nPlease update the following components: %s' + '\n\nLearn more about this warning here: https://reactjs.org/link/legacy-context', sortedNames);
    	      } finally {
    	        resetCurrentFiber();
    	      }
    	    });
    	  };

    	  ReactStrictModeWarnings.discardPendingWarnings = function () {
    	    pendingComponentWillMountWarnings = [];
    	    pendingUNSAFE_ComponentWillMountWarnings = [];
    	    pendingComponentWillReceivePropsWarnings = [];
    	    pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
    	    pendingComponentWillUpdateWarnings = [];
    	    pendingUNSAFE_ComponentWillUpdateWarnings = [];
    	    pendingLegacyContextWarning = new Map();
    	  };
    	}

    	function resolveDefaultProps(Component, baseProps) {
    	  if (Component && Component.defaultProps) {
    	    // Resolve default props. Taken from ReactElement
    	    var props = _assign({}, baseProps);

    	    var defaultProps = Component.defaultProps;

    	    for (var propName in defaultProps) {
    	      if (props[propName] === undefined) {
    	        props[propName] = defaultProps[propName];
    	      }
    	    }

    	    return props;
    	  }

    	  return baseProps;
    	}

    	// Max 31 bit integer. The max integer size in V8 for 32-bit systems.
    	// Math.pow(2, 30) - 1
    	// 0b111111111111111111111111111111
    	var MAX_SIGNED_31_BIT_INT = 1073741823;

    	var valueCursor = createCursor(null);
    	var rendererSigil;

    	{
    	  // Use this to detect multiple renderers using the same context
    	  rendererSigil = {};
    	}

    	var currentlyRenderingFiber = null;
    	var lastContextDependency = null;
    	var lastContextWithAllBitsObserved = null;
    	var isDisallowedContextReadInDEV = false;
    	function resetContextDependencies() {
    	  // This is called right before React yields execution, to ensure `readContext`
    	  // cannot be called outside the render phase.
    	  currentlyRenderingFiber = null;
    	  lastContextDependency = null;
    	  lastContextWithAllBitsObserved = null;

    	  {
    	    isDisallowedContextReadInDEV = false;
    	  }
    	}
    	function enterDisallowedContextReadInDEV() {
    	  {
    	    isDisallowedContextReadInDEV = true;
    	  }
    	}
    	function exitDisallowedContextReadInDEV() {
    	  {
    	    isDisallowedContextReadInDEV = false;
    	  }
    	}
    	function pushProvider(providerFiber, nextValue) {
    	  var context = providerFiber.type._context;

    	  {
    	    push(valueCursor, context._currentValue, providerFiber);
    	    context._currentValue = nextValue;

    	    {
    	      if (context._currentRenderer !== undefined && context._currentRenderer !== null && context._currentRenderer !== rendererSigil) {
    	        error('Detected multiple renderers concurrently rendering the ' + 'same context provider. This is currently unsupported.');
    	      }

    	      context._currentRenderer = rendererSigil;
    	    }
    	  }
    	}
    	function popProvider(providerFiber) {
    	  var currentValue = valueCursor.current;
    	  pop(valueCursor, providerFiber);
    	  var context = providerFiber.type._context;

    	  {
    	    context._currentValue = currentValue;
    	  }
    	}
    	function calculateChangedBits(context, newValue, oldValue) {
    	  if (objectIs(oldValue, newValue)) {
    	    // No change
    	    return 0;
    	  } else {
    	    var changedBits = typeof context._calculateChangedBits === 'function' ? context._calculateChangedBits(oldValue, newValue) : MAX_SIGNED_31_BIT_INT;

    	    {
    	      if ((changedBits & MAX_SIGNED_31_BIT_INT) !== changedBits) {
    	        error('calculateChangedBits: Expected the return value to be a ' + '31-bit integer. Instead received: %s', changedBits);
    	      }
    	    }

    	    return changedBits | 0;
    	  }
    	}
    	function scheduleWorkOnParentPath(parent, renderLanes) {
    	  // Update the child lanes of all the ancestors, including the alternates.
    	  var node = parent;

    	  while (node !== null) {
    	    var alternate = node.alternate;

    	    if (!isSubsetOfLanes(node.childLanes, renderLanes)) {
    	      node.childLanes = mergeLanes(node.childLanes, renderLanes);

    	      if (alternate !== null) {
    	        alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes);
    	      }
    	    } else if (alternate !== null && !isSubsetOfLanes(alternate.childLanes, renderLanes)) {
    	      alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes);
    	    } else {
    	      // Neither alternate was updated, which means the rest of the
    	      // ancestor path already has sufficient priority.
    	      break;
    	    }

    	    node = node.return;
    	  }
    	}
    	function propagateContextChange(workInProgress, context, changedBits, renderLanes) {
    	  var fiber = workInProgress.child;

    	  if (fiber !== null) {
    	    // Set the return pointer of the child to the work-in-progress fiber.
    	    fiber.return = workInProgress;
    	  }

    	  while (fiber !== null) {
    	    var nextFiber = void 0; // Visit this fiber.

    	    var list = fiber.dependencies;

    	    if (list !== null) {
    	      nextFiber = fiber.child;
    	      var dependency = list.firstContext;

    	      while (dependency !== null) {
    	        // Check if the context matches.
    	        if (dependency.context === context && (dependency.observedBits & changedBits) !== 0) {
    	          // Match! Schedule an update on this fiber.
    	          if (fiber.tag === ClassComponent) {
    	            // Schedule a force update on the work-in-progress.
    	            var update = createUpdate(NoTimestamp, pickArbitraryLane(renderLanes));
    	            update.tag = ForceUpdate; // TODO: Because we don't have a work-in-progress, this will add the
    	            // update to the current fiber, too, which means it will persist even if
    	            // this render is thrown away. Since it's a race condition, not sure it's
    	            // worth fixing.

    	            enqueueUpdate(fiber, update);
    	          }

    	          fiber.lanes = mergeLanes(fiber.lanes, renderLanes);
    	          var alternate = fiber.alternate;

    	          if (alternate !== null) {
    	            alternate.lanes = mergeLanes(alternate.lanes, renderLanes);
    	          }

    	          scheduleWorkOnParentPath(fiber.return, renderLanes); // Mark the updated lanes on the list, too.

    	          list.lanes = mergeLanes(list.lanes, renderLanes); // Since we already found a match, we can stop traversing the
    	          // dependency list.

    	          break;
    	        }

    	        dependency = dependency.next;
    	      }
    	    } else if (fiber.tag === ContextProvider) {
    	      // Don't scan deeper if this is a matching provider
    	      nextFiber = fiber.type === workInProgress.type ? null : fiber.child;
    	    } else {
    	      // Traverse down.
    	      nextFiber = fiber.child;
    	    }

    	    if (nextFiber !== null) {
    	      // Set the return pointer of the child to the work-in-progress fiber.
    	      nextFiber.return = fiber;
    	    } else {
    	      // No child. Traverse to next sibling.
    	      nextFiber = fiber;

    	      while (nextFiber !== null) {
    	        if (nextFiber === workInProgress) {
    	          // We're back to the root of this subtree. Exit.
    	          nextFiber = null;
    	          break;
    	        }

    	        var sibling = nextFiber.sibling;

    	        if (sibling !== null) {
    	          // Set the return pointer of the sibling to the work-in-progress fiber.
    	          sibling.return = nextFiber.return;
    	          nextFiber = sibling;
    	          break;
    	        } // No more siblings. Traverse up.


    	        nextFiber = nextFiber.return;
    	      }
    	    }

    	    fiber = nextFiber;
    	  }
    	}
    	function prepareToReadContext(workInProgress, renderLanes) {
    	  currentlyRenderingFiber = workInProgress;
    	  lastContextDependency = null;
    	  lastContextWithAllBitsObserved = null;
    	  var dependencies = workInProgress.dependencies;

    	  if (dependencies !== null) {
    	    var firstContext = dependencies.firstContext;

    	    if (firstContext !== null) {
    	      if (includesSomeLane(dependencies.lanes, renderLanes)) {
    	        // Context list has a pending update. Mark that this fiber performed work.
    	        markWorkInProgressReceivedUpdate();
    	      } // Reset the work-in-progress list


    	      dependencies.firstContext = null;
    	    }
    	  }
    	}
    	function readContext(context, observedBits) {
    	  {
    	    // This warning would fire if you read context inside a Hook like useMemo.
    	    // Unlike the class check below, it's not enforced in production for perf.
    	    if (isDisallowedContextReadInDEV) {
    	      error('Context can only be read while React is rendering. ' + 'In classes, you can read it in the render method or getDerivedStateFromProps. ' + 'In function components, you can read it directly in the function body, but not ' + 'inside Hooks like useReducer() or useMemo().');
    	    }
    	  }

    	  if (lastContextWithAllBitsObserved === context) ; else if (observedBits === false || observedBits === 0) ; else {
    	    var resolvedObservedBits; // Avoid deopting on observable arguments or heterogeneous types.

    	    if (typeof observedBits !== 'number' || observedBits === MAX_SIGNED_31_BIT_INT) {
    	      // Observe all updates.
    	      lastContextWithAllBitsObserved = context;
    	      resolvedObservedBits = MAX_SIGNED_31_BIT_INT;
    	    } else {
    	      resolvedObservedBits = observedBits;
    	    }

    	    var contextItem = {
    	      context: context,
    	      observedBits: resolvedObservedBits,
    	      next: null
    	    };

    	    if (lastContextDependency === null) {
    	      if (!(currentlyRenderingFiber !== null)) {
    	        {
    	          throw Error( "Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo()." );
    	        }
    	      } // This is the first dependency for this component. Create a new list.


    	      lastContextDependency = contextItem;
    	      currentlyRenderingFiber.dependencies = {
    	        lanes: NoLanes,
    	        firstContext: contextItem,
    	        responders: null
    	      };
    	    } else {
    	      // Append a new context item.
    	      lastContextDependency = lastContextDependency.next = contextItem;
    	    }
    	  }

    	  return  context._currentValue ;
    	}

    	var UpdateState = 0;
    	var ReplaceState = 1;
    	var ForceUpdate = 2;
    	var CaptureUpdate = 3; // Global state that is reset at the beginning of calling `processUpdateQueue`.
    	// It should only be read right after calling `processUpdateQueue`, via
    	// `checkHasForceUpdateAfterProcessing`.

    	var hasForceUpdate = false;
    	var didWarnUpdateInsideUpdate;
    	var currentlyProcessingQueue;

    	{
    	  didWarnUpdateInsideUpdate = false;
    	  currentlyProcessingQueue = null;
    	}

    	function initializeUpdateQueue(fiber) {
    	  var queue = {
    	    baseState: fiber.memoizedState,
    	    firstBaseUpdate: null,
    	    lastBaseUpdate: null,
    	    shared: {
    	      pending: null
    	    },
    	    effects: null
    	  };
    	  fiber.updateQueue = queue;
    	}
    	function cloneUpdateQueue(current, workInProgress) {
    	  // Clone the update queue from current. Unless it's already a clone.
    	  var queue = workInProgress.updateQueue;
    	  var currentQueue = current.updateQueue;

    	  if (queue === currentQueue) {
    	    var clone = {
    	      baseState: currentQueue.baseState,
    	      firstBaseUpdate: currentQueue.firstBaseUpdate,
    	      lastBaseUpdate: currentQueue.lastBaseUpdate,
    	      shared: currentQueue.shared,
    	      effects: currentQueue.effects
    	    };
    	    workInProgress.updateQueue = clone;
    	  }
    	}
    	function createUpdate(eventTime, lane) {
    	  var update = {
    	    eventTime: eventTime,
    	    lane: lane,
    	    tag: UpdateState,
    	    payload: null,
    	    callback: null,
    	    next: null
    	  };
    	  return update;
    	}
    	function enqueueUpdate(fiber, update) {
    	  var updateQueue = fiber.updateQueue;

    	  if (updateQueue === null) {
    	    // Only occurs if the fiber has been unmounted.
    	    return;
    	  }

    	  var sharedQueue = updateQueue.shared;
    	  var pending = sharedQueue.pending;

    	  if (pending === null) {
    	    // This is the first update. Create a circular list.
    	    update.next = update;
    	  } else {
    	    update.next = pending.next;
    	    pending.next = update;
    	  }

    	  sharedQueue.pending = update;

    	  {
    	    if (currentlyProcessingQueue === sharedQueue && !didWarnUpdateInsideUpdate) {
    	      error('An update (setState, replaceState, or forceUpdate) was scheduled ' + 'from inside an update function. Update functions should be pure, ' + 'with zero side-effects. Consider using componentDidUpdate or a ' + 'callback.');

    	      didWarnUpdateInsideUpdate = true;
    	    }
    	  }
    	}
    	function enqueueCapturedUpdate(workInProgress, capturedUpdate) {
    	  // Captured updates are updates that are thrown by a child during the render
    	  // phase. They should be discarded if the render is aborted. Therefore,
    	  // we should only put them on the work-in-progress queue, not the current one.
    	  var queue = workInProgress.updateQueue; // Check if the work-in-progress queue is a clone.

    	  var current = workInProgress.alternate;

    	  if (current !== null) {
    	    var currentQueue = current.updateQueue;

    	    if (queue === currentQueue) {
    	      // The work-in-progress queue is the same as current. This happens when
    	      // we bail out on a parent fiber that then captures an error thrown by
    	      // a child. Since we want to append the update only to the work-in
    	      // -progress queue, we need to clone the updates. We usually clone during
    	      // processUpdateQueue, but that didn't happen in this case because we
    	      // skipped over the parent when we bailed out.
    	      var newFirst = null;
    	      var newLast = null;
    	      var firstBaseUpdate = queue.firstBaseUpdate;

    	      if (firstBaseUpdate !== null) {
    	        // Loop through the updates and clone them.
    	        var update = firstBaseUpdate;

    	        do {
    	          var clone = {
    	            eventTime: update.eventTime,
    	            lane: update.lane,
    	            tag: update.tag,
    	            payload: update.payload,
    	            callback: update.callback,
    	            next: null
    	          };

    	          if (newLast === null) {
    	            newFirst = newLast = clone;
    	          } else {
    	            newLast.next = clone;
    	            newLast = clone;
    	          }

    	          update = update.next;
    	        } while (update !== null); // Append the captured update the end of the cloned list.


    	        if (newLast === null) {
    	          newFirst = newLast = capturedUpdate;
    	        } else {
    	          newLast.next = capturedUpdate;
    	          newLast = capturedUpdate;
    	        }
    	      } else {
    	        // There are no base updates.
    	        newFirst = newLast = capturedUpdate;
    	      }

    	      queue = {
    	        baseState: currentQueue.baseState,
    	        firstBaseUpdate: newFirst,
    	        lastBaseUpdate: newLast,
    	        shared: currentQueue.shared,
    	        effects: currentQueue.effects
    	      };
    	      workInProgress.updateQueue = queue;
    	      return;
    	    }
    	  } // Append the update to the end of the list.


    	  var lastBaseUpdate = queue.lastBaseUpdate;

    	  if (lastBaseUpdate === null) {
    	    queue.firstBaseUpdate = capturedUpdate;
    	  } else {
    	    lastBaseUpdate.next = capturedUpdate;
    	  }

    	  queue.lastBaseUpdate = capturedUpdate;
    	}

    	function getStateFromUpdate(workInProgress, queue, update, prevState, nextProps, instance) {
    	  switch (update.tag) {
    	    case ReplaceState:
    	      {
    	        var payload = update.payload;

    	        if (typeof payload === 'function') {
    	          // Updater function
    	          {
    	            enterDisallowedContextReadInDEV();
    	          }

    	          var nextState = payload.call(instance, prevState, nextProps);

    	          {
    	            if ( workInProgress.mode & StrictMode) {
    	              disableLogs();

    	              try {
    	                payload.call(instance, prevState, nextProps);
    	              } finally {
    	                reenableLogs();
    	              }
    	            }

    	            exitDisallowedContextReadInDEV();
    	          }

    	          return nextState;
    	        } // State object


    	        return payload;
    	      }

    	    case CaptureUpdate:
    	      {
    	        workInProgress.flags = workInProgress.flags & ~ShouldCapture | DidCapture;
    	      }
    	    // Intentional fallthrough

    	    case UpdateState:
    	      {
    	        var _payload = update.payload;
    	        var partialState;

    	        if (typeof _payload === 'function') {
    	          // Updater function
    	          {
    	            enterDisallowedContextReadInDEV();
    	          }

    	          partialState = _payload.call(instance, prevState, nextProps);

    	          {
    	            if ( workInProgress.mode & StrictMode) {
    	              disableLogs();

    	              try {
    	                _payload.call(instance, prevState, nextProps);
    	              } finally {
    	                reenableLogs();
    	              }
    	            }

    	            exitDisallowedContextReadInDEV();
    	          }
    	        } else {
    	          // Partial state object
    	          partialState = _payload;
    	        }

    	        if (partialState === null || partialState === undefined) {
    	          // Null and undefined are treated as no-ops.
    	          return prevState;
    	        } // Merge the partial state and the previous state.


    	        return _assign({}, prevState, partialState);
    	      }

    	    case ForceUpdate:
    	      {
    	        hasForceUpdate = true;
    	        return prevState;
    	      }
    	  }

    	  return prevState;
    	}

    	function processUpdateQueue(workInProgress, props, instance, renderLanes) {
    	  // This is always non-null on a ClassComponent or HostRoot
    	  var queue = workInProgress.updateQueue;
    	  hasForceUpdate = false;

    	  {
    	    currentlyProcessingQueue = queue.shared;
    	  }

    	  var firstBaseUpdate = queue.firstBaseUpdate;
    	  var lastBaseUpdate = queue.lastBaseUpdate; // Check if there are pending updates. If so, transfer them to the base queue.

    	  var pendingQueue = queue.shared.pending;

    	  if (pendingQueue !== null) {
    	    queue.shared.pending = null; // The pending queue is circular. Disconnect the pointer between first
    	    // and last so that it's non-circular.

    	    var lastPendingUpdate = pendingQueue;
    	    var firstPendingUpdate = lastPendingUpdate.next;
    	    lastPendingUpdate.next = null; // Append pending updates to base queue

    	    if (lastBaseUpdate === null) {
    	      firstBaseUpdate = firstPendingUpdate;
    	    } else {
    	      lastBaseUpdate.next = firstPendingUpdate;
    	    }

    	    lastBaseUpdate = lastPendingUpdate; // If there's a current queue, and it's different from the base queue, then
    	    // we need to transfer the updates to that queue, too. Because the base
    	    // queue is a singly-linked list with no cycles, we can append to both
    	    // lists and take advantage of structural sharing.
    	    // TODO: Pass `current` as argument

    	    var current = workInProgress.alternate;

    	    if (current !== null) {
    	      // This is always non-null on a ClassComponent or HostRoot
    	      var currentQueue = current.updateQueue;
    	      var currentLastBaseUpdate = currentQueue.lastBaseUpdate;

    	      if (currentLastBaseUpdate !== lastBaseUpdate) {
    	        if (currentLastBaseUpdate === null) {
    	          currentQueue.firstBaseUpdate = firstPendingUpdate;
    	        } else {
    	          currentLastBaseUpdate.next = firstPendingUpdate;
    	        }

    	        currentQueue.lastBaseUpdate = lastPendingUpdate;
    	      }
    	    }
    	  } // These values may change as we process the queue.


    	  if (firstBaseUpdate !== null) {
    	    // Iterate through the list of updates to compute the result.
    	    var newState = queue.baseState; // TODO: Don't need to accumulate this. Instead, we can remove renderLanes
    	    // from the original lanes.

    	    var newLanes = NoLanes;
    	    var newBaseState = null;
    	    var newFirstBaseUpdate = null;
    	    var newLastBaseUpdate = null;
    	    var update = firstBaseUpdate;

    	    do {
    	      var updateLane = update.lane;
    	      var updateEventTime = update.eventTime;

    	      if (!isSubsetOfLanes(renderLanes, updateLane)) {
    	        // Priority is insufficient. Skip this update. If this is the first
    	        // skipped update, the previous update/state is the new base
    	        // update/state.
    	        var clone = {
    	          eventTime: updateEventTime,
    	          lane: updateLane,
    	          tag: update.tag,
    	          payload: update.payload,
    	          callback: update.callback,
    	          next: null
    	        };

    	        if (newLastBaseUpdate === null) {
    	          newFirstBaseUpdate = newLastBaseUpdate = clone;
    	          newBaseState = newState;
    	        } else {
    	          newLastBaseUpdate = newLastBaseUpdate.next = clone;
    	        } // Update the remaining priority in the queue.


    	        newLanes = mergeLanes(newLanes, updateLane);
    	      } else {
    	        // This update does have sufficient priority.
    	        if (newLastBaseUpdate !== null) {
    	          var _clone = {
    	            eventTime: updateEventTime,
    	            // This update is going to be committed so we never want uncommit
    	            // it. Using NoLane works because 0 is a subset of all bitmasks, so
    	            // this will never be skipped by the check above.
    	            lane: NoLane,
    	            tag: update.tag,
    	            payload: update.payload,
    	            callback: update.callback,
    	            next: null
    	          };
    	          newLastBaseUpdate = newLastBaseUpdate.next = _clone;
    	        } // Process this update.


    	        newState = getStateFromUpdate(workInProgress, queue, update, newState, props, instance);
    	        var callback = update.callback;

    	        if (callback !== null) {
    	          workInProgress.flags |= Callback;
    	          var effects = queue.effects;

    	          if (effects === null) {
    	            queue.effects = [update];
    	          } else {
    	            effects.push(update);
    	          }
    	        }
    	      }

    	      update = update.next;

    	      if (update === null) {
    	        pendingQueue = queue.shared.pending;

    	        if (pendingQueue === null) {
    	          break;
    	        } else {
    	          // An update was scheduled from inside a reducer. Add the new
    	          // pending updates to the end of the list and keep processing.
    	          var _lastPendingUpdate = pendingQueue; // Intentionally unsound. Pending updates form a circular list, but we
    	          // unravel them when transferring them to the base queue.

    	          var _firstPendingUpdate = _lastPendingUpdate.next;
    	          _lastPendingUpdate.next = null;
    	          update = _firstPendingUpdate;
    	          queue.lastBaseUpdate = _lastPendingUpdate;
    	          queue.shared.pending = null;
    	        }
    	      }
    	    } while (true);

    	    if (newLastBaseUpdate === null) {
    	      newBaseState = newState;
    	    }

    	    queue.baseState = newBaseState;
    	    queue.firstBaseUpdate = newFirstBaseUpdate;
    	    queue.lastBaseUpdate = newLastBaseUpdate; // Set the remaining expiration time to be whatever is remaining in the queue.
    	    // This should be fine because the only two other things that contribute to
    	    // expiration time are props and context. We're already in the middle of the
    	    // begin phase by the time we start processing the queue, so we've already
    	    // dealt with the props. Context in components that specify
    	    // shouldComponentUpdate is tricky; but we'll have to account for
    	    // that regardless.

    	    markSkippedUpdateLanes(newLanes);
    	    workInProgress.lanes = newLanes;
    	    workInProgress.memoizedState = newState;
    	  }

    	  {
    	    currentlyProcessingQueue = null;
    	  }
    	}

    	function callCallback(callback, context) {
    	  if (!(typeof callback === 'function')) {
    	    {
    	      throw Error( "Invalid argument passed as callback. Expected a function. Instead received: " + callback );
    	    }
    	  }

    	  callback.call(context);
    	}

    	function resetHasForceUpdateBeforeProcessing() {
    	  hasForceUpdate = false;
    	}
    	function checkHasForceUpdateAfterProcessing() {
    	  return hasForceUpdate;
    	}
    	function commitUpdateQueue(finishedWork, finishedQueue, instance) {
    	  // Commit the effects
    	  var effects = finishedQueue.effects;
    	  finishedQueue.effects = null;

    	  if (effects !== null) {
    	    for (var i = 0; i < effects.length; i++) {
    	      var effect = effects[i];
    	      var callback = effect.callback;

    	      if (callback !== null) {
    	        effect.callback = null;
    	        callCallback(callback, instance);
    	      }
    	    }
    	  }
    	}

    	var fakeInternalInstance = {};
    	var isArray = Array.isArray; // React.Component uses a shared frozen object by default.
    	// We'll use it to determine whether we need to initialize legacy refs.

    	var emptyRefsObject = new React.Component().refs;
    	var didWarnAboutStateAssignmentForComponent;
    	var didWarnAboutUninitializedState;
    	var didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate;
    	var didWarnAboutLegacyLifecyclesAndDerivedState;
    	var didWarnAboutUndefinedDerivedState;
    	var warnOnUndefinedDerivedState;
    	var warnOnInvalidCallback;
    	var didWarnAboutDirectlyAssigningPropsToState;
    	var didWarnAboutContextTypeAndContextTypes;
    	var didWarnAboutInvalidateContextType;

    	{
    	  didWarnAboutStateAssignmentForComponent = new Set();
    	  didWarnAboutUninitializedState = new Set();
    	  didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = new Set();
    	  didWarnAboutLegacyLifecyclesAndDerivedState = new Set();
    	  didWarnAboutDirectlyAssigningPropsToState = new Set();
    	  didWarnAboutUndefinedDerivedState = new Set();
    	  didWarnAboutContextTypeAndContextTypes = new Set();
    	  didWarnAboutInvalidateContextType = new Set();
    	  var didWarnOnInvalidCallback = new Set();

    	  warnOnInvalidCallback = function (callback, callerName) {
    	    if (callback === null || typeof callback === 'function') {
    	      return;
    	    }

    	    var key = callerName + '_' + callback;

    	    if (!didWarnOnInvalidCallback.has(key)) {
    	      didWarnOnInvalidCallback.add(key);

    	      error('%s(...): Expected the last optional `callback` argument to be a ' + 'function. Instead received: %s.', callerName, callback);
    	    }
    	  };

    	  warnOnUndefinedDerivedState = function (type, partialState) {
    	    if (partialState === undefined) {
    	      var componentName = getComponentName(type) || 'Component';

    	      if (!didWarnAboutUndefinedDerivedState.has(componentName)) {
    	        didWarnAboutUndefinedDerivedState.add(componentName);

    	        error('%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. ' + 'You have returned undefined.', componentName);
    	      }
    	    }
    	  }; // This is so gross but it's at least non-critical and can be removed if
    	  // it causes problems. This is meant to give a nicer error message for
    	  // ReactDOM15.unstable_renderSubtreeIntoContainer(reactDOM16Component,
    	  // ...)) which otherwise throws a "_processChildContext is not a function"
    	  // exception.


    	  Object.defineProperty(fakeInternalInstance, '_processChildContext', {
    	    enumerable: false,
    	    value: function () {
    	      {
    	        {
    	          throw Error( "_processChildContext is not available in React 16+. This likely means you have multiple copies of React and are attempting to nest a React 15 tree inside a React 16 tree using unstable_renderSubtreeIntoContainer, which isn't supported. Try to make sure you have only one copy of React (and ideally, switch to ReactDOM.createPortal)." );
    	        }
    	      }
    	    }
    	  });
    	  Object.freeze(fakeInternalInstance);
    	}

    	function applyDerivedStateFromProps(workInProgress, ctor, getDerivedStateFromProps, nextProps) {
    	  var prevState = workInProgress.memoizedState;

    	  {
    	    if ( workInProgress.mode & StrictMode) {
    	      disableLogs();

    	      try {
    	        // Invoke the function an extra time to help detect side-effects.
    	        getDerivedStateFromProps(nextProps, prevState);
    	      } finally {
    	        reenableLogs();
    	      }
    	    }
    	  }

    	  var partialState = getDerivedStateFromProps(nextProps, prevState);

    	  {
    	    warnOnUndefinedDerivedState(ctor, partialState);
    	  } // Merge the partial state and the previous state.


    	  var memoizedState = partialState === null || partialState === undefined ? prevState : _assign({}, prevState, partialState);
    	  workInProgress.memoizedState = memoizedState; // Once the update queue is empty, persist the derived state onto the
    	  // base state.

    	  if (workInProgress.lanes === NoLanes) {
    	    // Queue is always non-null for classes
    	    var updateQueue = workInProgress.updateQueue;
    	    updateQueue.baseState = memoizedState;
    	  }
    	}
    	var classComponentUpdater = {
    	  isMounted: isMounted,
    	  enqueueSetState: function (inst, payload, callback) {
    	    var fiber = get(inst);
    	    var eventTime = requestEventTime();
    	    var lane = requestUpdateLane(fiber);
    	    var update = createUpdate(eventTime, lane);
    	    update.payload = payload;

    	    if (callback !== undefined && callback !== null) {
    	      {
    	        warnOnInvalidCallback(callback, 'setState');
    	      }

    	      update.callback = callback;
    	    }

    	    enqueueUpdate(fiber, update);
    	    scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  },
    	  enqueueReplaceState: function (inst, payload, callback) {
    	    var fiber = get(inst);
    	    var eventTime = requestEventTime();
    	    var lane = requestUpdateLane(fiber);
    	    var update = createUpdate(eventTime, lane);
    	    update.tag = ReplaceState;
    	    update.payload = payload;

    	    if (callback !== undefined && callback !== null) {
    	      {
    	        warnOnInvalidCallback(callback, 'replaceState');
    	      }

    	      update.callback = callback;
    	    }

    	    enqueueUpdate(fiber, update);
    	    scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  },
    	  enqueueForceUpdate: function (inst, callback) {
    	    var fiber = get(inst);
    	    var eventTime = requestEventTime();
    	    var lane = requestUpdateLane(fiber);
    	    var update = createUpdate(eventTime, lane);
    	    update.tag = ForceUpdate;

    	    if (callback !== undefined && callback !== null) {
    	      {
    	        warnOnInvalidCallback(callback, 'forceUpdate');
    	      }

    	      update.callback = callback;
    	    }

    	    enqueueUpdate(fiber, update);
    	    scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  }
    	};

    	function checkShouldComponentUpdate(workInProgress, ctor, oldProps, newProps, oldState, newState, nextContext) {
    	  var instance = workInProgress.stateNode;

    	  if (typeof instance.shouldComponentUpdate === 'function') {
    	    {
    	      if ( workInProgress.mode & StrictMode) {
    	        disableLogs();

    	        try {
    	          // Invoke the function an extra time to help detect side-effects.
    	          instance.shouldComponentUpdate(newProps, newState, nextContext);
    	        } finally {
    	          reenableLogs();
    	        }
    	      }
    	    }

    	    var shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);

    	    {
    	      if (shouldUpdate === undefined) {
    	        error('%s.shouldComponentUpdate(): Returned undefined instead of a ' + 'boolean value. Make sure to return true or false.', getComponentName(ctor) || 'Component');
    	      }
    	    }

    	    return shouldUpdate;
    	  }

    	  if (ctor.prototype && ctor.prototype.isPureReactComponent) {
    	    return !shallowEqual(oldProps, newProps) || !shallowEqual(oldState, newState);
    	  }

    	  return true;
    	}

    	function checkClassInstance(workInProgress, ctor, newProps) {
    	  var instance = workInProgress.stateNode;

    	  {
    	    var name = getComponentName(ctor) || 'Component';
    	    var renderPresent = instance.render;

    	    if (!renderPresent) {
    	      if (ctor.prototype && typeof ctor.prototype.render === 'function') {
    	        error('%s(...): No `render` method found on the returned component ' + 'instance: did you accidentally return an object from the constructor?', name);
    	      } else {
    	        error('%s(...): No `render` method found on the returned component ' + 'instance: you may have forgotten to define `render`.', name);
    	      }
    	    }

    	    if (instance.getInitialState && !instance.getInitialState.isReactClassApproved && !instance.state) {
    	      error('getInitialState was defined on %s, a plain JavaScript class. ' + 'This is only supported for classes created using React.createClass. ' + 'Did you mean to define a state property instead?', name);
    	    }

    	    if (instance.getDefaultProps && !instance.getDefaultProps.isReactClassApproved) {
    	      error('getDefaultProps was defined on %s, a plain JavaScript class. ' + 'This is only supported for classes created using React.createClass. ' + 'Use a static property to define defaultProps instead.', name);
    	    }

    	    if (instance.propTypes) {
    	      error('propTypes was defined as an instance property on %s. Use a static ' + 'property to define propTypes instead.', name);
    	    }

    	    if (instance.contextType) {
    	      error('contextType was defined as an instance property on %s. Use a static ' + 'property to define contextType instead.', name);
    	    }

    	    {
    	      if (instance.contextTypes) {
    	        error('contextTypes was defined as an instance property on %s. Use a static ' + 'property to define contextTypes instead.', name);
    	      }

    	      if (ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor)) {
    	        didWarnAboutContextTypeAndContextTypes.add(ctor);

    	        error('%s declares both contextTypes and contextType static properties. ' + 'The legacy contextTypes property will be ignored.', name);
    	      }
    	    }

    	    if (typeof instance.componentShouldUpdate === 'function') {
    	      error('%s has a method called ' + 'componentShouldUpdate(). Did you mean shouldComponentUpdate()? ' + 'The name is phrased as a question because the function is ' + 'expected to return a value.', name);
    	    }

    	    if (ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate !== 'undefined') {
    	      error('%s has a method called shouldComponentUpdate(). ' + 'shouldComponentUpdate should not be used when extending React.PureComponent. ' + 'Please extend React.Component if shouldComponentUpdate is used.', getComponentName(ctor) || 'A pure component');
    	    }

    	    if (typeof instance.componentDidUnmount === 'function') {
    	      error('%s has a method called ' + 'componentDidUnmount(). But there is no such lifecycle method. ' + 'Did you mean componentWillUnmount()?', name);
    	    }

    	    if (typeof instance.componentDidReceiveProps === 'function') {
    	      error('%s has a method called ' + 'componentDidReceiveProps(). But there is no such lifecycle method. ' + 'If you meant to update the state in response to changing props, ' + 'use componentWillReceiveProps(). If you meant to fetch data or ' + 'run side-effects or mutations after React has updated the UI, use componentDidUpdate().', name);
    	    }

    	    if (typeof instance.componentWillRecieveProps === 'function') {
    	      error('%s has a method called ' + 'componentWillRecieveProps(). Did you mean componentWillReceiveProps()?', name);
    	    }

    	    if (typeof instance.UNSAFE_componentWillRecieveProps === 'function') {
    	      error('%s has a method called ' + 'UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?', name);
    	    }

    	    var hasMutatedProps = instance.props !== newProps;

    	    if (instance.props !== undefined && hasMutatedProps) {
    	      error('%s(...): When calling super() in `%s`, make sure to pass ' + "up the same props that your component's constructor was passed.", name, name);
    	    }

    	    if (instance.defaultProps) {
    	      error('Setting defaultProps as an instance property on %s is not supported and will be ignored.' + ' Instead, define defaultProps as a static property on %s.', name, name);
    	    }

    	    if (typeof instance.getSnapshotBeforeUpdate === 'function' && typeof instance.componentDidUpdate !== 'function' && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor)) {
    	      didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor);

    	      error('%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). ' + 'This component defines getSnapshotBeforeUpdate() only.', getComponentName(ctor));
    	    }

    	    if (typeof instance.getDerivedStateFromProps === 'function') {
    	      error('%s: getDerivedStateFromProps() is defined as an instance method ' + 'and will be ignored. Instead, declare it as a static method.', name);
    	    }

    	    if (typeof instance.getDerivedStateFromError === 'function') {
    	      error('%s: getDerivedStateFromError() is defined as an instance method ' + 'and will be ignored. Instead, declare it as a static method.', name);
    	    }

    	    if (typeof ctor.getSnapshotBeforeUpdate === 'function') {
    	      error('%s: getSnapshotBeforeUpdate() is defined as a static method ' + 'and will be ignored. Instead, declare it as an instance method.', name);
    	    }

    	    var _state = instance.state;

    	    if (_state && (typeof _state !== 'object' || isArray(_state))) {
    	      error('%s.state: must be set to an object or null', name);
    	    }

    	    if (typeof instance.getChildContext === 'function' && typeof ctor.childContextTypes !== 'object') {
    	      error('%s.getChildContext(): childContextTypes must be defined in order to ' + 'use getChildContext().', name);
    	    }
    	  }
    	}

    	function adoptClassInstance(workInProgress, instance) {
    	  instance.updater = classComponentUpdater;
    	  workInProgress.stateNode = instance; // The instance needs access to the fiber so that it can schedule updates

    	  set(instance, workInProgress);

    	  {
    	    instance._reactInternalInstance = fakeInternalInstance;
    	  }
    	}

    	function constructClassInstance(workInProgress, ctor, props) {
    	  var isLegacyContextConsumer = false;
    	  var unmaskedContext = emptyContextObject;
    	  var context = emptyContextObject;
    	  var contextType = ctor.contextType;

    	  {
    	    if ('contextType' in ctor) {
    	      var isValid = // Allow null for conditional declaration
    	      contextType === null || contextType !== undefined && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === undefined; // Not a <Context.Consumer>

    	      if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
    	        didWarnAboutInvalidateContextType.add(ctor);
    	        var addendum = '';

    	        if (contextType === undefined) {
    	          addendum = ' However, it is set to undefined. ' + 'This can be caused by a typo or by mixing up named and default imports. ' + 'This can also happen due to a circular dependency, so ' + 'try moving the createContext() call to a separate file.';
    	        } else if (typeof contextType !== 'object') {
    	          addendum = ' However, it is set to a ' + typeof contextType + '.';
    	        } else if (contextType.$$typeof === REACT_PROVIDER_TYPE) {
    	          addendum = ' Did you accidentally pass the Context.Provider instead?';
    	        } else if (contextType._context !== undefined) {
    	          // <Context.Consumer>
    	          addendum = ' Did you accidentally pass the Context.Consumer instead?';
    	        } else {
    	          addendum = ' However, it is set to an object with keys {' + Object.keys(contextType).join(', ') + '}.';
    	        }

    	        error('%s defines an invalid contextType. ' + 'contextType should point to the Context object returned by React.createContext().%s', getComponentName(ctor) || 'Component', addendum);
    	      }
    	    }
    	  }

    	  if (typeof contextType === 'object' && contextType !== null) {
    	    context = readContext(contextType);
    	  } else {
    	    unmaskedContext = getUnmaskedContext(workInProgress, ctor, true);
    	    var contextTypes = ctor.contextTypes;
    	    isLegacyContextConsumer = contextTypes !== null && contextTypes !== undefined;
    	    context = isLegacyContextConsumer ? getMaskedContext(workInProgress, unmaskedContext) : emptyContextObject;
    	  } // Instantiate twice to help detect side-effects.


    	  {
    	    if ( workInProgress.mode & StrictMode) {
    	      disableLogs();

    	      try {
    	        new ctor(props, context); // eslint-disable-line no-new
    	      } finally {
    	        reenableLogs();
    	      }
    	    }
    	  }

    	  var instance = new ctor(props, context);
    	  var state = workInProgress.memoizedState = instance.state !== null && instance.state !== undefined ? instance.state : null;
    	  adoptClassInstance(workInProgress, instance);

    	  {
    	    if (typeof ctor.getDerivedStateFromProps === 'function' && state === null) {
    	      var componentName = getComponentName(ctor) || 'Component';

    	      if (!didWarnAboutUninitializedState.has(componentName)) {
    	        didWarnAboutUninitializedState.add(componentName);

    	        error('`%s` uses `getDerivedStateFromProps` but its initial state is ' + '%s. This is not recommended. Instead, define the initial state by ' + 'assigning an object to `this.state` in the constructor of `%s`. ' + 'This ensures that `getDerivedStateFromProps` arguments have a consistent shape.', componentName, instance.state === null ? 'null' : 'undefined', componentName);
    	      }
    	    } // If new component APIs are defined, "unsafe" lifecycles won't be called.
    	    // Warn about these lifecycles if they are present.
    	    // Don't warn about react-lifecycles-compat polyfilled methods though.


    	    if (typeof ctor.getDerivedStateFromProps === 'function' || typeof instance.getSnapshotBeforeUpdate === 'function') {
    	      var foundWillMountName = null;
    	      var foundWillReceivePropsName = null;
    	      var foundWillUpdateName = null;

    	      if (typeof instance.componentWillMount === 'function' && instance.componentWillMount.__suppressDeprecationWarning !== true) {
    	        foundWillMountName = 'componentWillMount';
    	      } else if (typeof instance.UNSAFE_componentWillMount === 'function') {
    	        foundWillMountName = 'UNSAFE_componentWillMount';
    	      }

    	      if (typeof instance.componentWillReceiveProps === 'function' && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
    	        foundWillReceivePropsName = 'componentWillReceiveProps';
    	      } else if (typeof instance.UNSAFE_componentWillReceiveProps === 'function') {
    	        foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
    	      }

    	      if (typeof instance.componentWillUpdate === 'function' && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
    	        foundWillUpdateName = 'componentWillUpdate';
    	      } else if (typeof instance.UNSAFE_componentWillUpdate === 'function') {
    	        foundWillUpdateName = 'UNSAFE_componentWillUpdate';
    	      }

    	      if (foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
    	        var _componentName = getComponentName(ctor) || 'Component';

    	        var newApiName = typeof ctor.getDerivedStateFromProps === 'function' ? 'getDerivedStateFromProps()' : 'getSnapshotBeforeUpdate()';

    	        if (!didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName)) {
    	          didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName);

    	          error('Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' + '%s uses %s but also contains the following legacy lifecycles:%s%s%s\n\n' + 'The above lifecycles should be removed. Learn more about this warning here:\n' + 'https://reactjs.org/link/unsafe-component-lifecycles', _componentName, newApiName, foundWillMountName !== null ? "\n  " + foundWillMountName : '', foundWillReceivePropsName !== null ? "\n  " + foundWillReceivePropsName : '', foundWillUpdateName !== null ? "\n  " + foundWillUpdateName : '');
    	        }
    	      }
    	    }
    	  } // Cache unmasked context so we can avoid recreating masked context unless necessary.
    	  // ReactFiberContext usually updates this cache but can't for newly-created instances.


    	  if (isLegacyContextConsumer) {
    	    cacheContext(workInProgress, unmaskedContext, context);
    	  }

    	  return instance;
    	}

    	function callComponentWillMount(workInProgress, instance) {
    	  var oldState = instance.state;

    	  if (typeof instance.componentWillMount === 'function') {
    	    instance.componentWillMount();
    	  }

    	  if (typeof instance.UNSAFE_componentWillMount === 'function') {
    	    instance.UNSAFE_componentWillMount();
    	  }

    	  if (oldState !== instance.state) {
    	    {
    	      error('%s.componentWillMount(): Assigning directly to this.state is ' + "deprecated (except inside a component's " + 'constructor). Use setState instead.', getComponentName(workInProgress.type) || 'Component');
    	    }

    	    classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
    	  }
    	}

    	function callComponentWillReceiveProps(workInProgress, instance, newProps, nextContext) {
    	  var oldState = instance.state;

    	  if (typeof instance.componentWillReceiveProps === 'function') {
    	    instance.componentWillReceiveProps(newProps, nextContext);
    	  }

    	  if (typeof instance.UNSAFE_componentWillReceiveProps === 'function') {
    	    instance.UNSAFE_componentWillReceiveProps(newProps, nextContext);
    	  }

    	  if (instance.state !== oldState) {
    	    {
    	      var componentName = getComponentName(workInProgress.type) || 'Component';

    	      if (!didWarnAboutStateAssignmentForComponent.has(componentName)) {
    	        didWarnAboutStateAssignmentForComponent.add(componentName);

    	        error('%s.componentWillReceiveProps(): Assigning directly to ' + "this.state is deprecated (except inside a component's " + 'constructor). Use setState instead.', componentName);
    	      }
    	    }

    	    classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
    	  }
    	} // Invokes the mount life-cycles on a previously never rendered instance.


    	function mountClassInstance(workInProgress, ctor, newProps, renderLanes) {
    	  {
    	    checkClassInstance(workInProgress, ctor, newProps);
    	  }

    	  var instance = workInProgress.stateNode;
    	  instance.props = newProps;
    	  instance.state = workInProgress.memoizedState;
    	  instance.refs = emptyRefsObject;
    	  initializeUpdateQueue(workInProgress);
    	  var contextType = ctor.contextType;

    	  if (typeof contextType === 'object' && contextType !== null) {
    	    instance.context = readContext(contextType);
    	  } else {
    	    var unmaskedContext = getUnmaskedContext(workInProgress, ctor, true);
    	    instance.context = getMaskedContext(workInProgress, unmaskedContext);
    	  }

    	  {
    	    if (instance.state === newProps) {
    	      var componentName = getComponentName(ctor) || 'Component';

    	      if (!didWarnAboutDirectlyAssigningPropsToState.has(componentName)) {
    	        didWarnAboutDirectlyAssigningPropsToState.add(componentName);

    	        error('%s: It is not recommended to assign props directly to state ' + "because updates to props won't be reflected in state. " + 'In most cases, it is better to use props directly.', componentName);
    	      }
    	    }

    	    if (workInProgress.mode & StrictMode) {
    	      ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress, instance);
    	    }

    	    {
    	      ReactStrictModeWarnings.recordUnsafeLifecycleWarnings(workInProgress, instance);
    	    }
    	  }

    	  processUpdateQueue(workInProgress, newProps, instance, renderLanes);
    	  instance.state = workInProgress.memoizedState;
    	  var getDerivedStateFromProps = ctor.getDerivedStateFromProps;

    	  if (typeof getDerivedStateFromProps === 'function') {
    	    applyDerivedStateFromProps(workInProgress, ctor, getDerivedStateFromProps, newProps);
    	    instance.state = workInProgress.memoizedState;
    	  } // In order to support react-lifecycles-compat polyfilled components,
    	  // Unsafe lifecycles should not be invoked for components using the new APIs.


    	  if (typeof ctor.getDerivedStateFromProps !== 'function' && typeof instance.getSnapshotBeforeUpdate !== 'function' && (typeof instance.UNSAFE_componentWillMount === 'function' || typeof instance.componentWillMount === 'function')) {
    	    callComponentWillMount(workInProgress, instance); // If we had additional state updates during this life-cycle, let's
    	    // process them now.

    	    processUpdateQueue(workInProgress, newProps, instance, renderLanes);
    	    instance.state = workInProgress.memoizedState;
    	  }

    	  if (typeof instance.componentDidMount === 'function') {
    	    workInProgress.flags |= Update;
    	  }
    	}

    	function resumeMountClassInstance(workInProgress, ctor, newProps, renderLanes) {
    	  var instance = workInProgress.stateNode;
    	  var oldProps = workInProgress.memoizedProps;
    	  instance.props = oldProps;
    	  var oldContext = instance.context;
    	  var contextType = ctor.contextType;
    	  var nextContext = emptyContextObject;

    	  if (typeof contextType === 'object' && contextType !== null) {
    	    nextContext = readContext(contextType);
    	  } else {
    	    var nextLegacyUnmaskedContext = getUnmaskedContext(workInProgress, ctor, true);
    	    nextContext = getMaskedContext(workInProgress, nextLegacyUnmaskedContext);
    	  }

    	  var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
    	  var hasNewLifecycles = typeof getDerivedStateFromProps === 'function' || typeof instance.getSnapshotBeforeUpdate === 'function'; // Note: During these life-cycles, instance.props/instance.state are what
    	  // ever the previously attempted to render - not the "current". However,
    	  // during componentDidUpdate we pass the "current" props.
    	  // In order to support react-lifecycles-compat polyfilled components,
    	  // Unsafe lifecycles should not be invoked for components using the new APIs.

    	  if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === 'function' || typeof instance.componentWillReceiveProps === 'function')) {
    	    if (oldProps !== newProps || oldContext !== nextContext) {
    	      callComponentWillReceiveProps(workInProgress, instance, newProps, nextContext);
    	    }
    	  }

    	  resetHasForceUpdateBeforeProcessing();
    	  var oldState = workInProgress.memoizedState;
    	  var newState = instance.state = oldState;
    	  processUpdateQueue(workInProgress, newProps, instance, renderLanes);
    	  newState = workInProgress.memoizedState;

    	  if (oldProps === newProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
    	    // If an update was already in progress, we should schedule an Update
    	    // effect even though we're bailing out, so that cWU/cDU are called.
    	    if (typeof instance.componentDidMount === 'function') {
    	      workInProgress.flags |= Update;
    	    }

    	    return false;
    	  }

    	  if (typeof getDerivedStateFromProps === 'function') {
    	    applyDerivedStateFromProps(workInProgress, ctor, getDerivedStateFromProps, newProps);
    	    newState = workInProgress.memoizedState;
    	  }

    	  var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress, ctor, oldProps, newProps, oldState, newState, nextContext);

    	  if (shouldUpdate) {
    	    // In order to support react-lifecycles-compat polyfilled components,
    	    // Unsafe lifecycles should not be invoked for components using the new APIs.
    	    if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillMount === 'function' || typeof instance.componentWillMount === 'function')) {
    	      if (typeof instance.componentWillMount === 'function') {
    	        instance.componentWillMount();
    	      }

    	      if (typeof instance.UNSAFE_componentWillMount === 'function') {
    	        instance.UNSAFE_componentWillMount();
    	      }
    	    }

    	    if (typeof instance.componentDidMount === 'function') {
    	      workInProgress.flags |= Update;
    	    }
    	  } else {
    	    // If an update was already in progress, we should schedule an Update
    	    // effect even though we're bailing out, so that cWU/cDU are called.
    	    if (typeof instance.componentDidMount === 'function') {
    	      workInProgress.flags |= Update;
    	    } // If shouldComponentUpdate returned false, we should still update the
    	    // memoized state to indicate that this work can be reused.


    	    workInProgress.memoizedProps = newProps;
    	    workInProgress.memoizedState = newState;
    	  } // Update the existing instance's state, props, and context pointers even
    	  // if shouldComponentUpdate returns false.


    	  instance.props = newProps;
    	  instance.state = newState;
    	  instance.context = nextContext;
    	  return shouldUpdate;
    	} // Invokes the update life-cycles and returns false if it shouldn't rerender.


    	function updateClassInstance(current, workInProgress, ctor, newProps, renderLanes) {
    	  var instance = workInProgress.stateNode;
    	  cloneUpdateQueue(current, workInProgress);
    	  var unresolvedOldProps = workInProgress.memoizedProps;
    	  var oldProps = workInProgress.type === workInProgress.elementType ? unresolvedOldProps : resolveDefaultProps(workInProgress.type, unresolvedOldProps);
    	  instance.props = oldProps;
    	  var unresolvedNewProps = workInProgress.pendingProps;
    	  var oldContext = instance.context;
    	  var contextType = ctor.contextType;
    	  var nextContext = emptyContextObject;

    	  if (typeof contextType === 'object' && contextType !== null) {
    	    nextContext = readContext(contextType);
    	  } else {
    	    var nextUnmaskedContext = getUnmaskedContext(workInProgress, ctor, true);
    	    nextContext = getMaskedContext(workInProgress, nextUnmaskedContext);
    	  }

    	  var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
    	  var hasNewLifecycles = typeof getDerivedStateFromProps === 'function' || typeof instance.getSnapshotBeforeUpdate === 'function'; // Note: During these life-cycles, instance.props/instance.state are what
    	  // ever the previously attempted to render - not the "current". However,
    	  // during componentDidUpdate we pass the "current" props.
    	  // In order to support react-lifecycles-compat polyfilled components,
    	  // Unsafe lifecycles should not be invoked for components using the new APIs.

    	  if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === 'function' || typeof instance.componentWillReceiveProps === 'function')) {
    	    if (unresolvedOldProps !== unresolvedNewProps || oldContext !== nextContext) {
    	      callComponentWillReceiveProps(workInProgress, instance, newProps, nextContext);
    	    }
    	  }

    	  resetHasForceUpdateBeforeProcessing();
    	  var oldState = workInProgress.memoizedState;
    	  var newState = instance.state = oldState;
    	  processUpdateQueue(workInProgress, newProps, instance, renderLanes);
    	  newState = workInProgress.memoizedState;

    	  if (unresolvedOldProps === unresolvedNewProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
    	    // If an update was already in progress, we should schedule an Update
    	    // effect even though we're bailing out, so that cWU/cDU are called.
    	    if (typeof instance.componentDidUpdate === 'function') {
    	      if (unresolvedOldProps !== current.memoizedProps || oldState !== current.memoizedState) {
    	        workInProgress.flags |= Update;
    	      }
    	    }

    	    if (typeof instance.getSnapshotBeforeUpdate === 'function') {
    	      if (unresolvedOldProps !== current.memoizedProps || oldState !== current.memoizedState) {
    	        workInProgress.flags |= Snapshot;
    	      }
    	    }

    	    return false;
    	  }

    	  if (typeof getDerivedStateFromProps === 'function') {
    	    applyDerivedStateFromProps(workInProgress, ctor, getDerivedStateFromProps, newProps);
    	    newState = workInProgress.memoizedState;
    	  }

    	  var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress, ctor, oldProps, newProps, oldState, newState, nextContext);

    	  if (shouldUpdate) {
    	    // In order to support react-lifecycles-compat polyfilled components,
    	    // Unsafe lifecycles should not be invoked for components using the new APIs.
    	    if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillUpdate === 'function' || typeof instance.componentWillUpdate === 'function')) {
    	      if (typeof instance.componentWillUpdate === 'function') {
    	        instance.componentWillUpdate(newProps, newState, nextContext);
    	      }

    	      if (typeof instance.UNSAFE_componentWillUpdate === 'function') {
    	        instance.UNSAFE_componentWillUpdate(newProps, newState, nextContext);
    	      }
    	    }

    	    if (typeof instance.componentDidUpdate === 'function') {
    	      workInProgress.flags |= Update;
    	    }

    	    if (typeof instance.getSnapshotBeforeUpdate === 'function') {
    	      workInProgress.flags |= Snapshot;
    	    }
    	  } else {
    	    // If an update was already in progress, we should schedule an Update
    	    // effect even though we're bailing out, so that cWU/cDU are called.
    	    if (typeof instance.componentDidUpdate === 'function') {
    	      if (unresolvedOldProps !== current.memoizedProps || oldState !== current.memoizedState) {
    	        workInProgress.flags |= Update;
    	      }
    	    }

    	    if (typeof instance.getSnapshotBeforeUpdate === 'function') {
    	      if (unresolvedOldProps !== current.memoizedProps || oldState !== current.memoizedState) {
    	        workInProgress.flags |= Snapshot;
    	      }
    	    } // If shouldComponentUpdate returned false, we should still update the
    	    // memoized props/state to indicate that this work can be reused.


    	    workInProgress.memoizedProps = newProps;
    	    workInProgress.memoizedState = newState;
    	  } // Update the existing instance's state, props, and context pointers even
    	  // if shouldComponentUpdate returns false.


    	  instance.props = newProps;
    	  instance.state = newState;
    	  instance.context = nextContext;
    	  return shouldUpdate;
    	}

    	var didWarnAboutMaps;
    	var didWarnAboutGenerators;
    	var didWarnAboutStringRefs;
    	var ownerHasKeyUseWarning;
    	var ownerHasFunctionTypeWarning;

    	var warnForMissingKey = function (child, returnFiber) {};

    	{
    	  didWarnAboutMaps = false;
    	  didWarnAboutGenerators = false;
    	  didWarnAboutStringRefs = {};
    	  /**
    	   * Warn if there's no key explicitly set on dynamic arrays of children or
    	   * object keys are not valid. This allows us to keep track of children between
    	   * updates.
    	   */

    	  ownerHasKeyUseWarning = {};
    	  ownerHasFunctionTypeWarning = {};

    	  warnForMissingKey = function (child, returnFiber) {
    	    if (child === null || typeof child !== 'object') {
    	      return;
    	    }

    	    if (!child._store || child._store.validated || child.key != null) {
    	      return;
    	    }

    	    if (!(typeof child._store === 'object')) {
    	      {
    	        throw Error( "React Component in warnForMissingKey should have a _store. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }

    	    child._store.validated = true;
    	    var componentName = getComponentName(returnFiber.type) || 'Component';

    	    if (ownerHasKeyUseWarning[componentName]) {
    	      return;
    	    }

    	    ownerHasKeyUseWarning[componentName] = true;

    	    error('Each child in a list should have a unique ' + '"key" prop. See https://reactjs.org/link/warning-keys for ' + 'more information.');
    	  };
    	}

    	var isArray$1 = Array.isArray;

    	function coerceRef(returnFiber, current, element) {
    	  var mixedRef = element.ref;

    	  if (mixedRef !== null && typeof mixedRef !== 'function' && typeof mixedRef !== 'object') {
    	    {
    	      // TODO: Clean this up once we turn on the string ref warning for
    	      // everyone, because the strict mode case will no longer be relevant
    	      if ((returnFiber.mode & StrictMode || warnAboutStringRefs) && // We warn in ReactElement.js if owner and self are equal for string refs
    	      // because these cannot be automatically converted to an arrow function
    	      // using a codemod. Therefore, we don't have to warn about string refs again.
    	      !(element._owner && element._self && element._owner.stateNode !== element._self)) {
    	        var componentName = getComponentName(returnFiber.type) || 'Component';

    	        if (!didWarnAboutStringRefs[componentName]) {
    	          {
    	            error('A string ref, "%s", has been found within a strict mode tree. ' + 'String refs are a source of potential bugs and should be avoided. ' + 'We recommend using useRef() or createRef() instead. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-string-ref', mixedRef);
    	          }

    	          didWarnAboutStringRefs[componentName] = true;
    	        }
    	      }
    	    }

    	    if (element._owner) {
    	      var owner = element._owner;
    	      var inst;

    	      if (owner) {
    	        var ownerFiber = owner;

    	        if (!(ownerFiber.tag === ClassComponent)) {
    	          {
    	            throw Error( "Function components cannot have string refs. We recommend using useRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref" );
    	          }
    	        }

    	        inst = ownerFiber.stateNode;
    	      }

    	      if (!inst) {
    	        {
    	          throw Error( "Missing owner for string ref " + mixedRef + ". This error is likely caused by a bug in React. Please file an issue." );
    	        }
    	      }

    	      var stringRef = '' + mixedRef; // Check if previous string ref matches new string ref

    	      if (current !== null && current.ref !== null && typeof current.ref === 'function' && current.ref._stringRef === stringRef) {
    	        return current.ref;
    	      }

    	      var ref = function (value) {
    	        var refs = inst.refs;

    	        if (refs === emptyRefsObject) {
    	          // This is a lazy pooled frozen object, so we need to initialize.
    	          refs = inst.refs = {};
    	        }

    	        if (value === null) {
    	          delete refs[stringRef];
    	        } else {
    	          refs[stringRef] = value;
    	        }
    	      };

    	      ref._stringRef = stringRef;
    	      return ref;
    	    } else {
    	      if (!(typeof mixedRef === 'string')) {
    	        {
    	          throw Error( "Expected ref to be a function, a string, an object returned by React.createRef(), or null." );
    	        }
    	      }

    	      if (!element._owner) {
    	        {
    	          throw Error( "Element ref was specified as a string (" + mixedRef + ") but no owner was set. This could happen for one of the following reasons:\n1. You may be adding a ref to a function component\n2. You may be adding a ref to a component that was not created inside a component's render method\n3. You have multiple copies of React loaded\nSee https://reactjs.org/link/refs-must-have-owner for more information." );
    	        }
    	      }
    	    }
    	  }

    	  return mixedRef;
    	}

    	function throwOnInvalidObjectType(returnFiber, newChild) {
    	  if (returnFiber.type !== 'textarea') {
    	    {
    	      {
    	        throw Error( "Objects are not valid as a React child (found: " + (Object.prototype.toString.call(newChild) === '[object Object]' ? 'object with keys {' + Object.keys(newChild).join(', ') + '}' : newChild) + "). If you meant to render a collection of children, use an array instead." );
    	      }
    	    }
    	  }
    	}

    	function warnOnFunctionType(returnFiber) {
    	  {
    	    var componentName = getComponentName(returnFiber.type) || 'Component';

    	    if (ownerHasFunctionTypeWarning[componentName]) {
    	      return;
    	    }

    	    ownerHasFunctionTypeWarning[componentName] = true;

    	    error('Functions are not valid as a React child. This may happen if ' + 'you return a Component instead of <Component /> from render. ' + 'Or maybe you meant to call this function rather than return it.');
    	  }
    	} // We avoid inlining this to avoid potential deopts from using try/catch.
    	// to be able to optimize each path individually by branching early. This needs
    	// a compiler or we can do it manually. Helpers that don't need this branching
    	// live outside of this function.


    	function ChildReconciler(shouldTrackSideEffects) {
    	  function deleteChild(returnFiber, childToDelete) {
    	    if (!shouldTrackSideEffects) {
    	      // Noop.
    	      return;
    	    } // Deletions are added in reversed order so we add it to the front.
    	    // At this point, the return fiber's effect list is empty except for
    	    // deletions, so we can just append the deletion to the list. The remaining
    	    // effects aren't added until the complete phase. Once we implement
    	    // resuming, this may not be true.


    	    var last = returnFiber.lastEffect;

    	    if (last !== null) {
    	      last.nextEffect = childToDelete;
    	      returnFiber.lastEffect = childToDelete;
    	    } else {
    	      returnFiber.firstEffect = returnFiber.lastEffect = childToDelete;
    	    }

    	    childToDelete.nextEffect = null;
    	    childToDelete.flags = Deletion;
    	  }

    	  function deleteRemainingChildren(returnFiber, currentFirstChild) {
    	    if (!shouldTrackSideEffects) {
    	      // Noop.
    	      return null;
    	    } // TODO: For the shouldClone case, this could be micro-optimized a bit by
    	    // assuming that after the first child we've already added everything.


    	    var childToDelete = currentFirstChild;

    	    while (childToDelete !== null) {
    	      deleteChild(returnFiber, childToDelete);
    	      childToDelete = childToDelete.sibling;
    	    }

    	    return null;
    	  }

    	  function mapRemainingChildren(returnFiber, currentFirstChild) {
    	    // Add the remaining children to a temporary map so that we can find them by
    	    // keys quickly. Implicit (null) keys get added to this set with their index
    	    // instead.
    	    var existingChildren = new Map();
    	    var existingChild = currentFirstChild;

    	    while (existingChild !== null) {
    	      if (existingChild.key !== null) {
    	        existingChildren.set(existingChild.key, existingChild);
    	      } else {
    	        existingChildren.set(existingChild.index, existingChild);
    	      }

    	      existingChild = existingChild.sibling;
    	    }

    	    return existingChildren;
    	  }

    	  function useFiber(fiber, pendingProps) {
    	    // We currently set sibling to null and index to 0 here because it is easy
    	    // to forget to do before returning it. E.g. for the single child case.
    	    var clone = createWorkInProgress(fiber, pendingProps);
    	    clone.index = 0;
    	    clone.sibling = null;
    	    return clone;
    	  }

    	  function placeChild(newFiber, lastPlacedIndex, newIndex) {
    	    newFiber.index = newIndex;

    	    if (!shouldTrackSideEffects) {
    	      // Noop.
    	      return lastPlacedIndex;
    	    }

    	    var current = newFiber.alternate;

    	    if (current !== null) {
    	      var oldIndex = current.index;

    	      if (oldIndex < lastPlacedIndex) {
    	        // This is a move.
    	        newFiber.flags = Placement;
    	        return lastPlacedIndex;
    	      } else {
    	        // This item can stay in place.
    	        return oldIndex;
    	      }
    	    } else {
    	      // This is an insertion.
    	      newFiber.flags = Placement;
    	      return lastPlacedIndex;
    	    }
    	  }

    	  function placeSingleChild(newFiber) {
    	    // This is simpler for the single child case. We only need to do a
    	    // placement for inserting new children.
    	    if (shouldTrackSideEffects && newFiber.alternate === null) {
    	      newFiber.flags = Placement;
    	    }

    	    return newFiber;
    	  }

    	  function updateTextNode(returnFiber, current, textContent, lanes) {
    	    if (current === null || current.tag !== HostText) {
    	      // Insert
    	      var created = createFiberFromText(textContent, returnFiber.mode, lanes);
    	      created.return = returnFiber;
    	      return created;
    	    } else {
    	      // Update
    	      var existing = useFiber(current, textContent);
    	      existing.return = returnFiber;
    	      return existing;
    	    }
    	  }

    	  function updateElement(returnFiber, current, element, lanes) {
    	    if (current !== null) {
    	      if (current.elementType === element.type || ( // Keep this check inline so it only runs on the false path:
    	       isCompatibleFamilyForHotReloading(current, element) )) {
    	        // Move based on index
    	        var existing = useFiber(current, element.props);
    	        existing.ref = coerceRef(returnFiber, current, element);
    	        existing.return = returnFiber;

    	        {
    	          existing._debugSource = element._source;
    	          existing._debugOwner = element._owner;
    	        }

    	        return existing;
    	      }
    	    } // Insert


    	    var created = createFiberFromElement(element, returnFiber.mode, lanes);
    	    created.ref = coerceRef(returnFiber, current, element);
    	    created.return = returnFiber;
    	    return created;
    	  }

    	  function updatePortal(returnFiber, current, portal, lanes) {
    	    if (current === null || current.tag !== HostPortal || current.stateNode.containerInfo !== portal.containerInfo || current.stateNode.implementation !== portal.implementation) {
    	      // Insert
    	      var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
    	      created.return = returnFiber;
    	      return created;
    	    } else {
    	      // Update
    	      var existing = useFiber(current, portal.children || []);
    	      existing.return = returnFiber;
    	      return existing;
    	    }
    	  }

    	  function updateFragment(returnFiber, current, fragment, lanes, key) {
    	    if (current === null || current.tag !== Fragment) {
    	      // Insert
    	      var created = createFiberFromFragment(fragment, returnFiber.mode, lanes, key);
    	      created.return = returnFiber;
    	      return created;
    	    } else {
    	      // Update
    	      var existing = useFiber(current, fragment);
    	      existing.return = returnFiber;
    	      return existing;
    	    }
    	  }

    	  function createChild(returnFiber, newChild, lanes) {
    	    if (typeof newChild === 'string' || typeof newChild === 'number') {
    	      // Text nodes don't have keys. If the previous node is implicitly keyed
    	      // we can continue to replace it without aborting even if it is not a text
    	      // node.
    	      var created = createFiberFromText('' + newChild, returnFiber.mode, lanes);
    	      created.return = returnFiber;
    	      return created;
    	    }

    	    if (typeof newChild === 'object' && newChild !== null) {
    	      switch (newChild.$$typeof) {
    	        case REACT_ELEMENT_TYPE:
    	          {
    	            var _created = createFiberFromElement(newChild, returnFiber.mode, lanes);

    	            _created.ref = coerceRef(returnFiber, null, newChild);
    	            _created.return = returnFiber;
    	            return _created;
    	          }

    	        case REACT_PORTAL_TYPE:
    	          {
    	            var _created2 = createFiberFromPortal(newChild, returnFiber.mode, lanes);

    	            _created2.return = returnFiber;
    	            return _created2;
    	          }
    	      }

    	      if (isArray$1(newChild) || getIteratorFn(newChild)) {
    	        var _created3 = createFiberFromFragment(newChild, returnFiber.mode, lanes, null);

    	        _created3.return = returnFiber;
    	        return _created3;
    	      }

    	      throwOnInvalidObjectType(returnFiber, newChild);
    	    }

    	    {
    	      if (typeof newChild === 'function') {
    	        warnOnFunctionType(returnFiber);
    	      }
    	    }

    	    return null;
    	  }

    	  function updateSlot(returnFiber, oldFiber, newChild, lanes) {
    	    // Update the fiber if the keys match, otherwise return null.
    	    var key = oldFiber !== null ? oldFiber.key : null;

    	    if (typeof newChild === 'string' || typeof newChild === 'number') {
    	      // Text nodes don't have keys. If the previous node is implicitly keyed
    	      // we can continue to replace it without aborting even if it is not a text
    	      // node.
    	      if (key !== null) {
    	        return null;
    	      }

    	      return updateTextNode(returnFiber, oldFiber, '' + newChild, lanes);
    	    }

    	    if (typeof newChild === 'object' && newChild !== null) {
    	      switch (newChild.$$typeof) {
    	        case REACT_ELEMENT_TYPE:
    	          {
    	            if (newChild.key === key) {
    	              if (newChild.type === REACT_FRAGMENT_TYPE) {
    	                return updateFragment(returnFiber, oldFiber, newChild.props.children, lanes, key);
    	              }

    	              return updateElement(returnFiber, oldFiber, newChild, lanes);
    	            } else {
    	              return null;
    	            }
    	          }

    	        case REACT_PORTAL_TYPE:
    	          {
    	            if (newChild.key === key) {
    	              return updatePortal(returnFiber, oldFiber, newChild, lanes);
    	            } else {
    	              return null;
    	            }
    	          }
    	      }

    	      if (isArray$1(newChild) || getIteratorFn(newChild)) {
    	        if (key !== null) {
    	          return null;
    	        }

    	        return updateFragment(returnFiber, oldFiber, newChild, lanes, null);
    	      }

    	      throwOnInvalidObjectType(returnFiber, newChild);
    	    }

    	    {
    	      if (typeof newChild === 'function') {
    	        warnOnFunctionType(returnFiber);
    	      }
    	    }

    	    return null;
    	  }

    	  function updateFromMap(existingChildren, returnFiber, newIdx, newChild, lanes) {
    	    if (typeof newChild === 'string' || typeof newChild === 'number') {
    	      // Text nodes don't have keys, so we neither have to check the old nor
    	      // new node for the key. If both are text nodes, they match.
    	      var matchedFiber = existingChildren.get(newIdx) || null;
    	      return updateTextNode(returnFiber, matchedFiber, '' + newChild, lanes);
    	    }

    	    if (typeof newChild === 'object' && newChild !== null) {
    	      switch (newChild.$$typeof) {
    	        case REACT_ELEMENT_TYPE:
    	          {
    	            var _matchedFiber = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;

    	            if (newChild.type === REACT_FRAGMENT_TYPE) {
    	              return updateFragment(returnFiber, _matchedFiber, newChild.props.children, lanes, newChild.key);
    	            }

    	            return updateElement(returnFiber, _matchedFiber, newChild, lanes);
    	          }

    	        case REACT_PORTAL_TYPE:
    	          {
    	            var _matchedFiber2 = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;

    	            return updatePortal(returnFiber, _matchedFiber2, newChild, lanes);
    	          }

    	      }

    	      if (isArray$1(newChild) || getIteratorFn(newChild)) {
    	        var _matchedFiber3 = existingChildren.get(newIdx) || null;

    	        return updateFragment(returnFiber, _matchedFiber3, newChild, lanes, null);
    	      }

    	      throwOnInvalidObjectType(returnFiber, newChild);
    	    }

    	    {
    	      if (typeof newChild === 'function') {
    	        warnOnFunctionType(returnFiber);
    	      }
    	    }

    	    return null;
    	  }
    	  /**
    	   * Warns if there is a duplicate or missing key
    	   */


    	  function warnOnInvalidKey(child, knownKeys, returnFiber) {
    	    {
    	      if (typeof child !== 'object' || child === null) {
    	        return knownKeys;
    	      }

    	      switch (child.$$typeof) {
    	        case REACT_ELEMENT_TYPE:
    	        case REACT_PORTAL_TYPE:
    	          warnForMissingKey(child, returnFiber);
    	          var key = child.key;

    	          if (typeof key !== 'string') {
    	            break;
    	          }

    	          if (knownKeys === null) {
    	            knownKeys = new Set();
    	            knownKeys.add(key);
    	            break;
    	          }

    	          if (!knownKeys.has(key)) {
    	            knownKeys.add(key);
    	            break;
    	          }

    	          error('Encountered two children with the same key, `%s`. ' + 'Keys should be unique so that components maintain their identity ' + 'across updates. Non-unique keys may cause children to be ' + 'duplicated and/or omitted — the behavior is unsupported and ' + 'could change in a future version.', key);

    	          break;
    	      }
    	    }

    	    return knownKeys;
    	  }

    	  function reconcileChildrenArray(returnFiber, currentFirstChild, newChildren, lanes) {
    	    // This algorithm can't optimize by searching from both ends since we
    	    // don't have backpointers on fibers. I'm trying to see how far we can get
    	    // with that model. If it ends up not being worth the tradeoffs, we can
    	    // add it later.
    	    // Even with a two ended optimization, we'd want to optimize for the case
    	    // where there are few changes and brute force the comparison instead of
    	    // going for the Map. It'd like to explore hitting that path first in
    	    // forward-only mode and only go for the Map once we notice that we need
    	    // lots of look ahead. This doesn't handle reversal as well as two ended
    	    // search but that's unusual. Besides, for the two ended optimization to
    	    // work on Iterables, we'd need to copy the whole set.
    	    // In this first iteration, we'll just live with hitting the bad case
    	    // (adding everything to a Map) in for every insert/move.
    	    // If you change this code, also update reconcileChildrenIterator() which
    	    // uses the same algorithm.
    	    {
    	      // First, validate keys.
    	      var knownKeys = null;

    	      for (var i = 0; i < newChildren.length; i++) {
    	        var child = newChildren[i];
    	        knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
    	      }
    	    }

    	    var resultingFirstChild = null;
    	    var previousNewFiber = null;
    	    var oldFiber = currentFirstChild;
    	    var lastPlacedIndex = 0;
    	    var newIdx = 0;
    	    var nextOldFiber = null;

    	    for (; oldFiber !== null && newIdx < newChildren.length; newIdx++) {
    	      if (oldFiber.index > newIdx) {
    	        nextOldFiber = oldFiber;
    	        oldFiber = null;
    	      } else {
    	        nextOldFiber = oldFiber.sibling;
    	      }

    	      var newFiber = updateSlot(returnFiber, oldFiber, newChildren[newIdx], lanes);

    	      if (newFiber === null) {
    	        // TODO: This breaks on empty slots like null children. That's
    	        // unfortunate because it triggers the slow path all the time. We need
    	        // a better way to communicate whether this was a miss or null,
    	        // boolean, undefined, etc.
    	        if (oldFiber === null) {
    	          oldFiber = nextOldFiber;
    	        }

    	        break;
    	      }

    	      if (shouldTrackSideEffects) {
    	        if (oldFiber && newFiber.alternate === null) {
    	          // We matched the slot, but we didn't reuse the existing fiber, so we
    	          // need to delete the existing child.
    	          deleteChild(returnFiber, oldFiber);
    	        }
    	      }

    	      lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);

    	      if (previousNewFiber === null) {
    	        // TODO: Move out of the loop. This only happens for the first run.
    	        resultingFirstChild = newFiber;
    	      } else {
    	        // TODO: Defer siblings if we're not at the right index for this slot.
    	        // I.e. if we had null values before, then we want to defer this
    	        // for each null value. However, we also don't want to call updateSlot
    	        // with the previous one.
    	        previousNewFiber.sibling = newFiber;
    	      }

    	      previousNewFiber = newFiber;
    	      oldFiber = nextOldFiber;
    	    }

    	    if (newIdx === newChildren.length) {
    	      // We've reached the end of the new children. We can delete the rest.
    	      deleteRemainingChildren(returnFiber, oldFiber);
    	      return resultingFirstChild;
    	    }

    	    if (oldFiber === null) {
    	      // If we don't have any more existing children we can choose a fast path
    	      // since the rest will all be insertions.
    	      for (; newIdx < newChildren.length; newIdx++) {
    	        var _newFiber = createChild(returnFiber, newChildren[newIdx], lanes);

    	        if (_newFiber === null) {
    	          continue;
    	        }

    	        lastPlacedIndex = placeChild(_newFiber, lastPlacedIndex, newIdx);

    	        if (previousNewFiber === null) {
    	          // TODO: Move out of the loop. This only happens for the first run.
    	          resultingFirstChild = _newFiber;
    	        } else {
    	          previousNewFiber.sibling = _newFiber;
    	        }

    	        previousNewFiber = _newFiber;
    	      }

    	      return resultingFirstChild;
    	    } // Add all children to a key map for quick lookups.


    	    var existingChildren = mapRemainingChildren(returnFiber, oldFiber); // Keep scanning and use the map to restore deleted items as moves.

    	    for (; newIdx < newChildren.length; newIdx++) {
    	      var _newFiber2 = updateFromMap(existingChildren, returnFiber, newIdx, newChildren[newIdx], lanes);

    	      if (_newFiber2 !== null) {
    	        if (shouldTrackSideEffects) {
    	          if (_newFiber2.alternate !== null) {
    	            // The new fiber is a work in progress, but if there exists a
    	            // current, that means that we reused the fiber. We need to delete
    	            // it from the child list so that we don't add it to the deletion
    	            // list.
    	            existingChildren.delete(_newFiber2.key === null ? newIdx : _newFiber2.key);
    	          }
    	        }

    	        lastPlacedIndex = placeChild(_newFiber2, lastPlacedIndex, newIdx);

    	        if (previousNewFiber === null) {
    	          resultingFirstChild = _newFiber2;
    	        } else {
    	          previousNewFiber.sibling = _newFiber2;
    	        }

    	        previousNewFiber = _newFiber2;
    	      }
    	    }

    	    if (shouldTrackSideEffects) {
    	      // Any existing children that weren't consumed above were deleted. We need
    	      // to add them to the deletion list.
    	      existingChildren.forEach(function (child) {
    	        return deleteChild(returnFiber, child);
    	      });
    	    }

    	    return resultingFirstChild;
    	  }

    	  function reconcileChildrenIterator(returnFiber, currentFirstChild, newChildrenIterable, lanes) {
    	    // This is the same implementation as reconcileChildrenArray(),
    	    // but using the iterator instead.
    	    var iteratorFn = getIteratorFn(newChildrenIterable);

    	    if (!(typeof iteratorFn === 'function')) {
    	      {
    	        throw Error( "An object is not an iterable. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }

    	    {
    	      // We don't support rendering Generators because it's a mutation.
    	      // See https://github.com/facebook/react/issues/12995
    	      if (typeof Symbol === 'function' && // $FlowFixMe Flow doesn't know about toStringTag
    	      newChildrenIterable[Symbol.toStringTag] === 'Generator') {
    	        if (!didWarnAboutGenerators) {
    	          error('Using Generators as children is unsupported and will likely yield ' + 'unexpected results because enumerating a generator mutates it. ' + 'You may convert it to an array with `Array.from()` or the ' + '`[...spread]` operator before rendering. Keep in mind ' + 'you might need to polyfill these features for older browsers.');
    	        }

    	        didWarnAboutGenerators = true;
    	      } // Warn about using Maps as children


    	      if (newChildrenIterable.entries === iteratorFn) {
    	        if (!didWarnAboutMaps) {
    	          error('Using Maps as children is not supported. ' + 'Use an array of keyed ReactElements instead.');
    	        }

    	        didWarnAboutMaps = true;
    	      } // First, validate keys.
    	      // We'll get a different iterator later for the main pass.


    	      var _newChildren = iteratorFn.call(newChildrenIterable);

    	      if (_newChildren) {
    	        var knownKeys = null;

    	        var _step = _newChildren.next();

    	        for (; !_step.done; _step = _newChildren.next()) {
    	          var child = _step.value;
    	          knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
    	        }
    	      }
    	    }

    	    var newChildren = iteratorFn.call(newChildrenIterable);

    	    if (!(newChildren != null)) {
    	      {
    	        throw Error( "An iterable object provided no iterator." );
    	      }
    	    }

    	    var resultingFirstChild = null;
    	    var previousNewFiber = null;
    	    var oldFiber = currentFirstChild;
    	    var lastPlacedIndex = 0;
    	    var newIdx = 0;
    	    var nextOldFiber = null;
    	    var step = newChildren.next();

    	    for (; oldFiber !== null && !step.done; newIdx++, step = newChildren.next()) {
    	      if (oldFiber.index > newIdx) {
    	        nextOldFiber = oldFiber;
    	        oldFiber = null;
    	      } else {
    	        nextOldFiber = oldFiber.sibling;
    	      }

    	      var newFiber = updateSlot(returnFiber, oldFiber, step.value, lanes);

    	      if (newFiber === null) {
    	        // TODO: This breaks on empty slots like null children. That's
    	        // unfortunate because it triggers the slow path all the time. We need
    	        // a better way to communicate whether this was a miss or null,
    	        // boolean, undefined, etc.
    	        if (oldFiber === null) {
    	          oldFiber = nextOldFiber;
    	        }

    	        break;
    	      }

    	      if (shouldTrackSideEffects) {
    	        if (oldFiber && newFiber.alternate === null) {
    	          // We matched the slot, but we didn't reuse the existing fiber, so we
    	          // need to delete the existing child.
    	          deleteChild(returnFiber, oldFiber);
    	        }
    	      }

    	      lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);

    	      if (previousNewFiber === null) {
    	        // TODO: Move out of the loop. This only happens for the first run.
    	        resultingFirstChild = newFiber;
    	      } else {
    	        // TODO: Defer siblings if we're not at the right index for this slot.
    	        // I.e. if we had null values before, then we want to defer this
    	        // for each null value. However, we also don't want to call updateSlot
    	        // with the previous one.
    	        previousNewFiber.sibling = newFiber;
    	      }

    	      previousNewFiber = newFiber;
    	      oldFiber = nextOldFiber;
    	    }

    	    if (step.done) {
    	      // We've reached the end of the new children. We can delete the rest.
    	      deleteRemainingChildren(returnFiber, oldFiber);
    	      return resultingFirstChild;
    	    }

    	    if (oldFiber === null) {
    	      // If we don't have any more existing children we can choose a fast path
    	      // since the rest will all be insertions.
    	      for (; !step.done; newIdx++, step = newChildren.next()) {
    	        var _newFiber3 = createChild(returnFiber, step.value, lanes);

    	        if (_newFiber3 === null) {
    	          continue;
    	        }

    	        lastPlacedIndex = placeChild(_newFiber3, lastPlacedIndex, newIdx);

    	        if (previousNewFiber === null) {
    	          // TODO: Move out of the loop. This only happens for the first run.
    	          resultingFirstChild = _newFiber3;
    	        } else {
    	          previousNewFiber.sibling = _newFiber3;
    	        }

    	        previousNewFiber = _newFiber3;
    	      }

    	      return resultingFirstChild;
    	    } // Add all children to a key map for quick lookups.


    	    var existingChildren = mapRemainingChildren(returnFiber, oldFiber); // Keep scanning and use the map to restore deleted items as moves.

    	    for (; !step.done; newIdx++, step = newChildren.next()) {
    	      var _newFiber4 = updateFromMap(existingChildren, returnFiber, newIdx, step.value, lanes);

    	      if (_newFiber4 !== null) {
    	        if (shouldTrackSideEffects) {
    	          if (_newFiber4.alternate !== null) {
    	            // The new fiber is a work in progress, but if there exists a
    	            // current, that means that we reused the fiber. We need to delete
    	            // it from the child list so that we don't add it to the deletion
    	            // list.
    	            existingChildren.delete(_newFiber4.key === null ? newIdx : _newFiber4.key);
    	          }
    	        }

    	        lastPlacedIndex = placeChild(_newFiber4, lastPlacedIndex, newIdx);

    	        if (previousNewFiber === null) {
    	          resultingFirstChild = _newFiber4;
    	        } else {
    	          previousNewFiber.sibling = _newFiber4;
    	        }

    	        previousNewFiber = _newFiber4;
    	      }
    	    }

    	    if (shouldTrackSideEffects) {
    	      // Any existing children that weren't consumed above were deleted. We need
    	      // to add them to the deletion list.
    	      existingChildren.forEach(function (child) {
    	        return deleteChild(returnFiber, child);
    	      });
    	    }

    	    return resultingFirstChild;
    	  }

    	  function reconcileSingleTextNode(returnFiber, currentFirstChild, textContent, lanes) {
    	    // There's no need to check for keys on text nodes since we don't have a
    	    // way to define them.
    	    if (currentFirstChild !== null && currentFirstChild.tag === HostText) {
    	      // We already have an existing node so let's just update it and delete
    	      // the rest.
    	      deleteRemainingChildren(returnFiber, currentFirstChild.sibling);
    	      var existing = useFiber(currentFirstChild, textContent);
    	      existing.return = returnFiber;
    	      return existing;
    	    } // The existing first child is not a text node so we need to create one
    	    // and delete the existing ones.


    	    deleteRemainingChildren(returnFiber, currentFirstChild);
    	    var created = createFiberFromText(textContent, returnFiber.mode, lanes);
    	    created.return = returnFiber;
    	    return created;
    	  }

    	  function reconcileSingleElement(returnFiber, currentFirstChild, element, lanes) {
    	    var key = element.key;
    	    var child = currentFirstChild;

    	    while (child !== null) {
    	      // TODO: If key === null and child.key === null, then this only applies to
    	      // the first item in the list.
    	      if (child.key === key) {
    	        switch (child.tag) {
    	          case Fragment:
    	            {
    	              if (element.type === REACT_FRAGMENT_TYPE) {
    	                deleteRemainingChildren(returnFiber, child.sibling);
    	                var existing = useFiber(child, element.props.children);
    	                existing.return = returnFiber;

    	                {
    	                  existing._debugSource = element._source;
    	                  existing._debugOwner = element._owner;
    	                }

    	                return existing;
    	              }

    	              break;
    	            }

    	          case Block:

    	          // We intentionally fallthrough here if enableBlocksAPI is not on.
    	          // eslint-disable-next-lined no-fallthrough

    	          default:
    	            {
    	              if (child.elementType === element.type || ( // Keep this check inline so it only runs on the false path:
    	               isCompatibleFamilyForHotReloading(child, element) )) {
    	                deleteRemainingChildren(returnFiber, child.sibling);

    	                var _existing3 = useFiber(child, element.props);

    	                _existing3.ref = coerceRef(returnFiber, child, element);
    	                _existing3.return = returnFiber;

    	                {
    	                  _existing3._debugSource = element._source;
    	                  _existing3._debugOwner = element._owner;
    	                }

    	                return _existing3;
    	              }

    	              break;
    	            }
    	        } // Didn't match.


    	        deleteRemainingChildren(returnFiber, child);
    	        break;
    	      } else {
    	        deleteChild(returnFiber, child);
    	      }

    	      child = child.sibling;
    	    }

    	    if (element.type === REACT_FRAGMENT_TYPE) {
    	      var created = createFiberFromFragment(element.props.children, returnFiber.mode, lanes, element.key);
    	      created.return = returnFiber;
    	      return created;
    	    } else {
    	      var _created4 = createFiberFromElement(element, returnFiber.mode, lanes);

    	      _created4.ref = coerceRef(returnFiber, currentFirstChild, element);
    	      _created4.return = returnFiber;
    	      return _created4;
    	    }
    	  }

    	  function reconcileSinglePortal(returnFiber, currentFirstChild, portal, lanes) {
    	    var key = portal.key;
    	    var child = currentFirstChild;

    	    while (child !== null) {
    	      // TODO: If key === null and child.key === null, then this only applies to
    	      // the first item in the list.
    	      if (child.key === key) {
    	        if (child.tag === HostPortal && child.stateNode.containerInfo === portal.containerInfo && child.stateNode.implementation === portal.implementation) {
    	          deleteRemainingChildren(returnFiber, child.sibling);
    	          var existing = useFiber(child, portal.children || []);
    	          existing.return = returnFiber;
    	          return existing;
    	        } else {
    	          deleteRemainingChildren(returnFiber, child);
    	          break;
    	        }
    	      } else {
    	        deleteChild(returnFiber, child);
    	      }

    	      child = child.sibling;
    	    }

    	    var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
    	    created.return = returnFiber;
    	    return created;
    	  } // This API will tag the children with the side-effect of the reconciliation
    	  // itself. They will be added to the side-effect list as we pass through the
    	  // children and the parent.


    	  function reconcileChildFibers(returnFiber, currentFirstChild, newChild, lanes) {
    	    // This function is not recursive.
    	    // If the top level item is an array, we treat it as a set of children,
    	    // not as a fragment. Nested arrays on the other hand will be treated as
    	    // fragment nodes. Recursion happens at the normal flow.
    	    // Handle top level unkeyed fragments as if they were arrays.
    	    // This leads to an ambiguity between <>{[...]}</> and <>...</>.
    	    // We treat the ambiguous cases above the same.
    	    var isUnkeyedTopLevelFragment = typeof newChild === 'object' && newChild !== null && newChild.type === REACT_FRAGMENT_TYPE && newChild.key === null;

    	    if (isUnkeyedTopLevelFragment) {
    	      newChild = newChild.props.children;
    	    } // Handle object types


    	    var isObject = typeof newChild === 'object' && newChild !== null;

    	    if (isObject) {
    	      switch (newChild.$$typeof) {
    	        case REACT_ELEMENT_TYPE:
    	          return placeSingleChild(reconcileSingleElement(returnFiber, currentFirstChild, newChild, lanes));

    	        case REACT_PORTAL_TYPE:
    	          return placeSingleChild(reconcileSinglePortal(returnFiber, currentFirstChild, newChild, lanes));

    	      }
    	    }

    	    if (typeof newChild === 'string' || typeof newChild === 'number') {
    	      return placeSingleChild(reconcileSingleTextNode(returnFiber, currentFirstChild, '' + newChild, lanes));
    	    }

    	    if (isArray$1(newChild)) {
    	      return reconcileChildrenArray(returnFiber, currentFirstChild, newChild, lanes);
    	    }

    	    if (getIteratorFn(newChild)) {
    	      return reconcileChildrenIterator(returnFiber, currentFirstChild, newChild, lanes);
    	    }

    	    if (isObject) {
    	      throwOnInvalidObjectType(returnFiber, newChild);
    	    }

    	    {
    	      if (typeof newChild === 'function') {
    	        warnOnFunctionType(returnFiber);
    	      }
    	    }

    	    if (typeof newChild === 'undefined' && !isUnkeyedTopLevelFragment) {
    	      // If the new child is undefined, and the return fiber is a composite
    	      // component, throw an error. If Fiber return types are disabled,
    	      // we already threw above.
    	      switch (returnFiber.tag) {
    	        case ClassComponent:
    	          {
    	            {
    	              var instance = returnFiber.stateNode;

    	              if (instance.render._isMockFunction) {
    	                // We allow auto-mocks to proceed as if they're returning null.
    	                break;
    	              }
    	            }
    	          }
    	        // Intentionally fall through to the next case, which handles both
    	        // functions and classes
    	        // eslint-disable-next-lined no-fallthrough

    	        case Block:
    	        case FunctionComponent:
    	        case ForwardRef:
    	        case SimpleMemoComponent:
    	          {
    	            {
    	              {
    	                throw Error( (getComponentName(returnFiber.type) || 'Component') + "(...): Nothing was returned from render. This usually means a return statement is missing. Or, to render nothing, return null." );
    	              }
    	            }
    	          }
    	      }
    	    } // Remaining cases are all treated as empty.


    	    return deleteRemainingChildren(returnFiber, currentFirstChild);
    	  }

    	  return reconcileChildFibers;
    	}

    	var reconcileChildFibers = ChildReconciler(true);
    	var mountChildFibers = ChildReconciler(false);
    	function cloneChildFibers(current, workInProgress) {
    	  if (!(current === null || workInProgress.child === current.child)) {
    	    {
    	      throw Error( "Resuming work not yet implemented." );
    	    }
    	  }

    	  if (workInProgress.child === null) {
    	    return;
    	  }

    	  var currentChild = workInProgress.child;
    	  var newChild = createWorkInProgress(currentChild, currentChild.pendingProps);
    	  workInProgress.child = newChild;
    	  newChild.return = workInProgress;

    	  while (currentChild.sibling !== null) {
    	    currentChild = currentChild.sibling;
    	    newChild = newChild.sibling = createWorkInProgress(currentChild, currentChild.pendingProps);
    	    newChild.return = workInProgress;
    	  }

    	  newChild.sibling = null;
    	} // Reset a workInProgress child set to prepare it for a second pass.

    	function resetChildFibers(workInProgress, lanes) {
    	  var child = workInProgress.child;

    	  while (child !== null) {
    	    resetWorkInProgress(child, lanes);
    	    child = child.sibling;
    	  }
    	}

    	var NO_CONTEXT = {};
    	var contextStackCursor$1 = createCursor(NO_CONTEXT);
    	var contextFiberStackCursor = createCursor(NO_CONTEXT);
    	var rootInstanceStackCursor = createCursor(NO_CONTEXT);

    	function requiredContext(c) {
    	  if (!(c !== NO_CONTEXT)) {
    	    {
    	      throw Error( "Expected host context to exist. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }

    	  return c;
    	}

    	function getRootHostContainer() {
    	  var rootInstance = requiredContext(rootInstanceStackCursor.current);
    	  return rootInstance;
    	}

    	function pushHostContainer(fiber, nextRootInstance) {
    	  // Push current root instance onto the stack;
    	  // This allows us to reset root when portals are popped.
    	  push(rootInstanceStackCursor, nextRootInstance, fiber); // Track the context and the Fiber that provided it.
    	  // This enables us to pop only Fibers that provide unique contexts.

    	  push(contextFiberStackCursor, fiber, fiber); // Finally, we need to push the host context to the stack.
    	  // However, we can't just call getRootHostContext() and push it because
    	  // we'd have a different number of entries on the stack depending on
    	  // whether getRootHostContext() throws somewhere in renderer code or not.
    	  // So we push an empty value first. This lets us safely unwind on errors.

    	  push(contextStackCursor$1, NO_CONTEXT, fiber);
    	  var nextRootContext = getRootHostContext(nextRootInstance); // Now that we know this function doesn't throw, replace it.

    	  pop(contextStackCursor$1, fiber);
    	  push(contextStackCursor$1, nextRootContext, fiber);
    	}

    	function popHostContainer(fiber) {
    	  pop(contextStackCursor$1, fiber);
    	  pop(contextFiberStackCursor, fiber);
    	  pop(rootInstanceStackCursor, fiber);
    	}

    	function getHostContext() {
    	  var context = requiredContext(contextStackCursor$1.current);
    	  return context;
    	}

    	function pushHostContext(fiber) {
    	  requiredContext(rootInstanceStackCursor.current);
    	  var context = requiredContext(contextStackCursor$1.current);
    	  var nextContext = getChildHostContext(context, fiber.type); // Don't push this Fiber's context unless it's unique.

    	  if (context === nextContext) {
    	    return;
    	  } // Track the context and the Fiber that provided it.
    	  // This enables us to pop only Fibers that provide unique contexts.


    	  push(contextFiberStackCursor, fiber, fiber);
    	  push(contextStackCursor$1, nextContext, fiber);
    	}

    	function popHostContext(fiber) {
    	  // Do not pop unless this Fiber provided the current context.
    	  // pushHostContext() only pushes Fibers that provide unique contexts.
    	  if (contextFiberStackCursor.current !== fiber) {
    	    return;
    	  }

    	  pop(contextStackCursor$1, fiber);
    	  pop(contextFiberStackCursor, fiber);
    	}

    	var DefaultSuspenseContext = 0; // The Suspense Context is split into two parts. The lower bits is
    	// inherited deeply down the subtree. The upper bits only affect
    	// this immediate suspense boundary and gets reset each new
    	// boundary or suspense list.

    	var SubtreeSuspenseContextMask = 1; // Subtree Flags:
    	// InvisibleParentSuspenseContext indicates that one of our parent Suspense
    	// boundaries is not currently showing visible main content.
    	// Either because it is already showing a fallback or is not mounted at all.
    	// We can use this to determine if it is desirable to trigger a fallback at
    	// the parent. If not, then we might need to trigger undesirable boundaries
    	// and/or suspend the commit to avoid hiding the parent content.

    	var InvisibleParentSuspenseContext = 1; // Shallow Flags:
    	// ForceSuspenseFallback can be used by SuspenseList to force newly added
    	// items into their fallback state during one of the render passes.

    	var ForceSuspenseFallback = 2;
    	var suspenseStackCursor = createCursor(DefaultSuspenseContext);
    	function hasSuspenseContext(parentContext, flag) {
    	  return (parentContext & flag) !== 0;
    	}
    	function setDefaultShallowSuspenseContext(parentContext) {
    	  return parentContext & SubtreeSuspenseContextMask;
    	}
    	function setShallowSuspenseContext(parentContext, shallowContext) {
    	  return parentContext & SubtreeSuspenseContextMask | shallowContext;
    	}
    	function addSubtreeSuspenseContext(parentContext, subtreeContext) {
    	  return parentContext | subtreeContext;
    	}
    	function pushSuspenseContext(fiber, newContext) {
    	  push(suspenseStackCursor, newContext, fiber);
    	}
    	function popSuspenseContext(fiber) {
    	  pop(suspenseStackCursor, fiber);
    	}

    	function shouldCaptureSuspense(workInProgress, hasInvisibleParent) {
    	  // If it was the primary children that just suspended, capture and render the
    	  // fallback. Otherwise, don't capture and bubble to the next boundary.
    	  var nextState = workInProgress.memoizedState;

    	  if (nextState !== null) {
    	    if (nextState.dehydrated !== null) {
    	      // A dehydrated boundary always captures.
    	      return true;
    	    }

    	    return false;
    	  }

    	  var props = workInProgress.memoizedProps; // In order to capture, the Suspense component must have a fallback prop.

    	  if (props.fallback === undefined) {
    	    return false;
    	  } // Regular boundaries always capture.


    	  if (props.unstable_avoidThisFallback !== true) {
    	    return true;
    	  } // If it's a boundary we should avoid, then we prefer to bubble up to the
    	  // parent boundary if it is currently invisible.


    	  if (hasInvisibleParent) {
    	    return false;
    	  } // If the parent is not able to handle it, we must handle it.


    	  return true;
    	}
    	function findFirstSuspended(row) {
    	  var node = row;

    	  while (node !== null) {
    	    if (node.tag === SuspenseComponent) {
    	      var state = node.memoizedState;

    	      if (state !== null) {
    	        var dehydrated = state.dehydrated;

    	        if (dehydrated === null || isSuspenseInstancePending(dehydrated) || isSuspenseInstanceFallback(dehydrated)) {
    	          return node;
    	        }
    	      }
    	    } else if (node.tag === SuspenseListComponent && // revealOrder undefined can't be trusted because it don't
    	    // keep track of whether it suspended or not.
    	    node.memoizedProps.revealOrder !== undefined) {
    	      var didSuspend = (node.flags & DidCapture) !== NoFlags;

    	      if (didSuspend) {
    	        return node;
    	      }
    	    } else if (node.child !== null) {
    	      node.child.return = node;
    	      node = node.child;
    	      continue;
    	    }

    	    if (node === row) {
    	      return null;
    	    }

    	    while (node.sibling === null) {
    	      if (node.return === null || node.return === row) {
    	        return null;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  }

    	  return null;
    	}

    	var NoFlags$1 =
    	/*  */
    	0; // Represents whether effect should fire.

    	var HasEffect =
    	/* */
    	1; // Represents the phase in which the effect (not the clean-up) fires.

    	var Layout =
    	/*    */
    	2;
    	var Passive$1 =
    	/*   */
    	4;

    	// This may have been an insertion or a hydration.

    	var hydrationParentFiber = null;
    	var nextHydratableInstance = null;
    	var isHydrating = false;

    	function enterHydrationState(fiber) {

    	  var parentInstance = fiber.stateNode.containerInfo;
    	  nextHydratableInstance = getFirstHydratableChild(parentInstance);
    	  hydrationParentFiber = fiber;
    	  isHydrating = true;
    	  return true;
    	}

    	function deleteHydratableInstance(returnFiber, instance) {
    	  {
    	    switch (returnFiber.tag) {
    	      case HostRoot:
    	        didNotHydrateContainerInstance(returnFiber.stateNode.containerInfo, instance);
    	        break;

    	      case HostComponent:
    	        didNotHydrateInstance(returnFiber.type, returnFiber.memoizedProps, returnFiber.stateNode, instance);
    	        break;
    	    }
    	  }

    	  var childToDelete = createFiberFromHostInstanceForDeletion();
    	  childToDelete.stateNode = instance;
    	  childToDelete.return = returnFiber;
    	  childToDelete.flags = Deletion; // This might seem like it belongs on progressedFirstDeletion. However,
    	  // these children are not part of the reconciliation list of children.
    	  // Even if we abort and rereconcile the children, that will try to hydrate
    	  // again and the nodes are still in the host tree so these will be
    	  // recreated.

    	  if (returnFiber.lastEffect !== null) {
    	    returnFiber.lastEffect.nextEffect = childToDelete;
    	    returnFiber.lastEffect = childToDelete;
    	  } else {
    	    returnFiber.firstEffect = returnFiber.lastEffect = childToDelete;
    	  }
    	}

    	function insertNonHydratedInstance(returnFiber, fiber) {
    	  fiber.flags = fiber.flags & ~Hydrating | Placement;

    	  {
    	    switch (returnFiber.tag) {
    	      case HostRoot:
    	        {
    	          var parentContainer = returnFiber.stateNode.containerInfo;

    	          switch (fiber.tag) {
    	            case HostComponent:
    	              var type = fiber.type;
    	              fiber.pendingProps;
    	              didNotFindHydratableContainerInstance(parentContainer, type);
    	              break;

    	            case HostText:
    	              var text = fiber.pendingProps;
    	              didNotFindHydratableContainerTextInstance(parentContainer, text);
    	              break;
    	          }

    	          break;
    	        }

    	      case HostComponent:
    	        {
    	          var parentType = returnFiber.type;
    	          var parentProps = returnFiber.memoizedProps;
    	          var parentInstance = returnFiber.stateNode;

    	          switch (fiber.tag) {
    	            case HostComponent:
    	              var _type = fiber.type;
    	              fiber.pendingProps;
    	              didNotFindHydratableInstance(parentType, parentProps, parentInstance, _type);
    	              break;

    	            case HostText:
    	              var _text = fiber.pendingProps;
    	              didNotFindHydratableTextInstance(parentType, parentProps, parentInstance, _text);
    	              break;

    	            case SuspenseComponent:
    	              didNotFindHydratableSuspenseInstance(parentType, parentProps);
    	              break;
    	          }

    	          break;
    	        }

    	      default:
    	        return;
    	    }
    	  }
    	}

    	function tryHydrate(fiber, nextInstance) {
    	  switch (fiber.tag) {
    	    case HostComponent:
    	      {
    	        var type = fiber.type;
    	        fiber.pendingProps;
    	        var instance = canHydrateInstance(nextInstance, type);

    	        if (instance !== null) {
    	          fiber.stateNode = instance;
    	          return true;
    	        }

    	        return false;
    	      }

    	    case HostText:
    	      {
    	        var text = fiber.pendingProps;
    	        var textInstance = canHydrateTextInstance(nextInstance, text);

    	        if (textInstance !== null) {
    	          fiber.stateNode = textInstance;
    	          return true;
    	        }

    	        return false;
    	      }

    	    case SuspenseComponent:
    	      {

    	        return false;
    	      }

    	    default:
    	      return false;
    	  }
    	}

    	function tryToClaimNextHydratableInstance(fiber) {
    	  if (!isHydrating) {
    	    return;
    	  }

    	  var nextInstance = nextHydratableInstance;

    	  if (!nextInstance) {
    	    // Nothing to hydrate. Make it an insertion.
    	    insertNonHydratedInstance(hydrationParentFiber, fiber);
    	    isHydrating = false;
    	    hydrationParentFiber = fiber;
    	    return;
    	  }

    	  var firstAttemptedInstance = nextInstance;

    	  if (!tryHydrate(fiber, nextInstance)) {
    	    // If we can't hydrate this instance let's try the next one.
    	    // We use this as a heuristic. It's based on intuition and not data so it
    	    // might be flawed or unnecessary.
    	    nextInstance = getNextHydratableSibling(firstAttemptedInstance);

    	    if (!nextInstance || !tryHydrate(fiber, nextInstance)) {
    	      // Nothing to hydrate. Make it an insertion.
    	      insertNonHydratedInstance(hydrationParentFiber, fiber);
    	      isHydrating = false;
    	      hydrationParentFiber = fiber;
    	      return;
    	    } // We matched the next one, we'll now assume that the first one was
    	    // superfluous and we'll delete it. Since we can't eagerly delete it
    	    // we'll have to schedule a deletion. To do that, this node needs a dummy
    	    // fiber associated with it.


    	    deleteHydratableInstance(hydrationParentFiber, firstAttemptedInstance);
    	  }

    	  hydrationParentFiber = fiber;
    	  nextHydratableInstance = getFirstHydratableChild(nextInstance);
    	}

    	function prepareToHydrateHostInstance(fiber, rootContainerInstance, hostContext) {

    	  var instance = fiber.stateNode;
    	  var updatePayload = hydrateInstance(instance, fiber.type, fiber.memoizedProps, rootContainerInstance, hostContext, fiber); // TODO: Type this specific to this type of component.

    	  fiber.updateQueue = updatePayload; // If the update payload indicates that there is a change or if there
    	  // is a new ref we mark this as an update.

    	  if (updatePayload !== null) {
    	    return true;
    	  }

    	  return false;
    	}

    	function prepareToHydrateHostTextInstance(fiber) {

    	  var textInstance = fiber.stateNode;
    	  var textContent = fiber.memoizedProps;
    	  var shouldUpdate = hydrateTextInstance(textInstance, textContent, fiber);

    	  {
    	    if (shouldUpdate) {
    	      // We assume that prepareToHydrateHostTextInstance is called in a context where the
    	      // hydration parent is the parent host component of this host text.
    	      var returnFiber = hydrationParentFiber;

    	      if (returnFiber !== null) {
    	        switch (returnFiber.tag) {
    	          case HostRoot:
    	            {
    	              var parentContainer = returnFiber.stateNode.containerInfo;
    	              didNotMatchHydratedContainerTextInstance(parentContainer, textInstance, textContent);
    	              break;
    	            }

    	          case HostComponent:
    	            {
    	              var parentType = returnFiber.type;
    	              var parentProps = returnFiber.memoizedProps;
    	              var parentInstance = returnFiber.stateNode;
    	              didNotMatchHydratedTextInstance(parentType, parentProps, parentInstance, textInstance, textContent);
    	              break;
    	            }
    	        }
    	      }
    	    }
    	  }

    	  return shouldUpdate;
    	}

    	function skipPastDehydratedSuspenseInstance(fiber) {

    	  var suspenseState = fiber.memoizedState;
    	  var suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;

    	  if (!suspenseInstance) {
    	    {
    	      throw Error( "Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }

    	  return getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance);
    	}

    	function popToNextHostParent(fiber) {
    	  var parent = fiber.return;

    	  while (parent !== null && parent.tag !== HostComponent && parent.tag !== HostRoot && parent.tag !== SuspenseComponent) {
    	    parent = parent.return;
    	  }

    	  hydrationParentFiber = parent;
    	}

    	function popHydrationState(fiber) {

    	  if (fiber !== hydrationParentFiber) {
    	    // We're deeper than the current hydration context, inside an inserted
    	    // tree.
    	    return false;
    	  }

    	  if (!isHydrating) {
    	    // If we're not currently hydrating but we're in a hydration context, then
    	    // we were an insertion and now need to pop up reenter hydration of our
    	    // siblings.
    	    popToNextHostParent(fiber);
    	    isHydrating = true;
    	    return false;
    	  }

    	  var type = fiber.type; // If we have any remaining hydratable nodes, we need to delete them now.
    	  // We only do this deeper than head and body since they tend to have random
    	  // other nodes in them. We also ignore components with pure text content in
    	  // side of them.
    	  // TODO: Better heuristic.

    	  if (fiber.tag !== HostComponent || type !== 'head' && type !== 'body' && !shouldSetTextContent(type, fiber.memoizedProps)) {
    	    var nextInstance = nextHydratableInstance;

    	    while (nextInstance) {
    	      deleteHydratableInstance(fiber, nextInstance);
    	      nextInstance = getNextHydratableSibling(nextInstance);
    	    }
    	  }

    	  popToNextHostParent(fiber);

    	  if (fiber.tag === SuspenseComponent) {
    	    nextHydratableInstance = skipPastDehydratedSuspenseInstance(fiber);
    	  } else {
    	    nextHydratableInstance = hydrationParentFiber ? getNextHydratableSibling(fiber.stateNode) : null;
    	  }

    	  return true;
    	}

    	function resetHydrationState() {

    	  hydrationParentFiber = null;
    	  nextHydratableInstance = null;
    	  isHydrating = false;
    	}

    	function getIsHydrating() {
    	  return isHydrating;
    	}

    	// and should be reset before starting a new render.
    	// This tracks which mutable sources need to be reset after a render.

    	var workInProgressSources = [];
    	var rendererSigil$1;

    	{
    	  // Used to detect multiple renderers using the same mutable source.
    	  rendererSigil$1 = {};
    	}

    	function markSourceAsDirty(mutableSource) {
    	  workInProgressSources.push(mutableSource);
    	}
    	function resetWorkInProgressVersions() {
    	  for (var i = 0; i < workInProgressSources.length; i++) {
    	    var mutableSource = workInProgressSources[i];

    	    {
    	      mutableSource._workInProgressVersionPrimary = null;
    	    }
    	  }

    	  workInProgressSources.length = 0;
    	}
    	function getWorkInProgressVersion(mutableSource) {
    	  {
    	    return mutableSource._workInProgressVersionPrimary;
    	  }
    	}
    	function setWorkInProgressVersion(mutableSource, version) {
    	  {
    	    mutableSource._workInProgressVersionPrimary = version;
    	  }

    	  workInProgressSources.push(mutableSource);
    	}
    	function warnAboutMultipleRenderersDEV(mutableSource) {
    	  {
    	    {
    	      if (mutableSource._currentPrimaryRenderer == null) {
    	        mutableSource._currentPrimaryRenderer = rendererSigil$1;
    	      } else if (mutableSource._currentPrimaryRenderer !== rendererSigil$1) {
    	        error('Detected multiple renderers concurrently rendering the ' + 'same mutable source. This is currently unsupported.');
    	      }
    	    }
    	  }
    	} // Eager reads the version of a mutable source and stores it on the root.

    	var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher,
    	    ReactCurrentBatchConfig$1 = ReactSharedInternals.ReactCurrentBatchConfig;
    	var didWarnAboutMismatchedHooksForComponent;
    	var didWarnAboutUseOpaqueIdentifier;

    	{
    	  didWarnAboutUseOpaqueIdentifier = {};
    	  didWarnAboutMismatchedHooksForComponent = new Set();
    	}

    	// These are set right before calling the component.
    	var renderLanes = NoLanes; // The work-in-progress fiber. I've named it differently to distinguish it from
    	// the work-in-progress hook.

    	var currentlyRenderingFiber$1 = null; // Hooks are stored as a linked list on the fiber's memoizedState field. The
    	// current hook list is the list that belongs to the current fiber. The
    	// work-in-progress hook list is a new list that will be added to the
    	// work-in-progress fiber.

    	var currentHook = null;
    	var workInProgressHook = null; // Whether an update was scheduled at any point during the render phase. This
    	// does not get reset if we do another render pass; only when we're completely
    	// finished evaluating this component. This is an optimization so we know
    	// whether we need to clear render phase updates after a throw.

    	var didScheduleRenderPhaseUpdate = false; // Where an update was scheduled only during the current render pass. This
    	// gets reset after each attempt.
    	// TODO: Maybe there's some way to consolidate this with
    	// `didScheduleRenderPhaseUpdate`. Or with `numberOfReRenders`.

    	var didScheduleRenderPhaseUpdateDuringThisPass = false;
    	var RE_RENDER_LIMIT = 25; // In DEV, this is the name of the currently executing primitive hook

    	var currentHookNameInDev = null; // In DEV, this list ensures that hooks are called in the same order between renders.
    	// The list stores the order of hooks used during the initial render (mount).
    	// Subsequent renders (updates) reference this list.

    	var hookTypesDev = null;
    	var hookTypesUpdateIndexDev = -1; // In DEV, this tracks whether currently rendering component needs to ignore
    	// the dependencies for Hooks that need them (e.g. useEffect or useMemo).
    	// When true, such Hooks will always be "remounted". Only used during hot reload.

    	var ignorePreviousDependencies = false;

    	function mountHookTypesDev() {
    	  {
    	    var hookName = currentHookNameInDev;

    	    if (hookTypesDev === null) {
    	      hookTypesDev = [hookName];
    	    } else {
    	      hookTypesDev.push(hookName);
    	    }
    	  }
    	}

    	function updateHookTypesDev() {
    	  {
    	    var hookName = currentHookNameInDev;

    	    if (hookTypesDev !== null) {
    	      hookTypesUpdateIndexDev++;

    	      if (hookTypesDev[hookTypesUpdateIndexDev] !== hookName) {
    	        warnOnHookMismatchInDev(hookName);
    	      }
    	    }
    	  }
    	}

    	function checkDepsAreArrayDev(deps) {
    	  {
    	    if (deps !== undefined && deps !== null && !Array.isArray(deps)) {
    	      // Verify deps, but only on mount to avoid extra checks.
    	      // It's unlikely their type would change as usually you define them inline.
    	      error('%s received a final argument that is not an array (instead, received `%s`). When ' + 'specified, the final argument must be an array.', currentHookNameInDev, typeof deps);
    	    }
    	  }
    	}

    	function warnOnHookMismatchInDev(currentHookName) {
    	  {
    	    var componentName = getComponentName(currentlyRenderingFiber$1.type);

    	    if (!didWarnAboutMismatchedHooksForComponent.has(componentName)) {
    	      didWarnAboutMismatchedHooksForComponent.add(componentName);

    	      if (hookTypesDev !== null) {
    	        var table = '';
    	        var secondColumnStart = 30;

    	        for (var i = 0; i <= hookTypesUpdateIndexDev; i++) {
    	          var oldHookName = hookTypesDev[i];
    	          var newHookName = i === hookTypesUpdateIndexDev ? currentHookName : oldHookName;
    	          var row = i + 1 + ". " + oldHookName; // Extra space so second column lines up
    	          // lol @ IE not supporting String#repeat

    	          while (row.length < secondColumnStart) {
    	            row += ' ';
    	          }

    	          row += newHookName + '\n';
    	          table += row;
    	        }

    	        error('React has detected a change in the order of Hooks called by %s. ' + 'This will lead to bugs and errors if not fixed. ' + 'For more information, read the Rules of Hooks: https://reactjs.org/link/rules-of-hooks\n\n' + '   Previous render            Next render\n' + '   ------------------------------------------------------\n' + '%s' + '   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n', componentName, table);
    	      }
    	    }
    	  }
    	}

    	function throwInvalidHookError() {
    	  {
    	    {
    	      throw Error( "Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem." );
    	    }
    	  }
    	}

    	function areHookInputsEqual(nextDeps, prevDeps) {
    	  {
    	    if (ignorePreviousDependencies) {
    	      // Only true when this component is being hot reloaded.
    	      return false;
    	    }
    	  }

    	  if (prevDeps === null) {
    	    {
    	      error('%s received a final argument during this render, but not during ' + 'the previous render. Even though the final argument is optional, ' + 'its type cannot change between renders.', currentHookNameInDev);
    	    }

    	    return false;
    	  }

    	  {
    	    // Don't bother comparing lengths in prod because these arrays should be
    	    // passed inline.
    	    if (nextDeps.length !== prevDeps.length) {
    	      error('The final argument passed to %s changed size between renders. The ' + 'order and size of this array must remain constant.\n\n' + 'Previous: %s\n' + 'Incoming: %s', currentHookNameInDev, "[" + prevDeps.join(', ') + "]", "[" + nextDeps.join(', ') + "]");
    	    }
    	  }

    	  for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++) {
    	    if (objectIs(nextDeps[i], prevDeps[i])) {
    	      continue;
    	    }

    	    return false;
    	  }

    	  return true;
    	}

    	function renderWithHooks(current, workInProgress, Component, props, secondArg, nextRenderLanes) {
    	  renderLanes = nextRenderLanes;
    	  currentlyRenderingFiber$1 = workInProgress;

    	  {
    	    hookTypesDev = current !== null ? current._debugHookTypes : null;
    	    hookTypesUpdateIndexDev = -1; // Used for hot reloading:

    	    ignorePreviousDependencies = current !== null && current.type !== workInProgress.type;
    	  }

    	  workInProgress.memoizedState = null;
    	  workInProgress.updateQueue = null;
    	  workInProgress.lanes = NoLanes; // The following should have already been reset
    	  // currentHook = null;
    	  // workInProgressHook = null;
    	  // didScheduleRenderPhaseUpdate = false;
    	  // TODO Warn if no hooks are used at all during mount, then some are used during update.
    	  // Currently we will identify the update render as a mount because memoizedState === null.
    	  // This is tricky because it's valid for certain types of components (e.g. React.lazy)
    	  // Using memoizedState to differentiate between mount/update only works if at least one stateful hook is used.
    	  // Non-stateful hooks (e.g. context) don't get added to memoizedState,
    	  // so memoizedState would be null during updates and mounts.

    	  {
    	    if (current !== null && current.memoizedState !== null) {
    	      ReactCurrentDispatcher$1.current = HooksDispatcherOnUpdateInDEV;
    	    } else if (hookTypesDev !== null) {
    	      // This dispatcher handles an edge case where a component is updating,
    	      // but no stateful hooks have been used.
    	      // We want to match the production code behavior (which will use HooksDispatcherOnMount),
    	      // but with the extra DEV validation to ensure hooks ordering hasn't changed.
    	      // This dispatcher does that.
    	      ReactCurrentDispatcher$1.current = HooksDispatcherOnMountWithHookTypesInDEV;
    	    } else {
    	      ReactCurrentDispatcher$1.current = HooksDispatcherOnMountInDEV;
    	    }
    	  }

    	  var children = Component(props, secondArg); // Check if there was a render phase update

    	  if (didScheduleRenderPhaseUpdateDuringThisPass) {
    	    // Keep rendering in a loop for as long as render phase updates continue to
    	    // be scheduled. Use a counter to prevent infinite loops.
    	    var numberOfReRenders = 0;

    	    do {
    	      didScheduleRenderPhaseUpdateDuringThisPass = false;

    	      if (!(numberOfReRenders < RE_RENDER_LIMIT)) {
    	        {
    	          throw Error( "Too many re-renders. React limits the number of renders to prevent an infinite loop." );
    	        }
    	      }

    	      numberOfReRenders += 1;

    	      {
    	        // Even when hot reloading, allow dependencies to stabilize
    	        // after first render to prevent infinite render phase updates.
    	        ignorePreviousDependencies = false;
    	      } // Start over from the beginning of the list


    	      currentHook = null;
    	      workInProgressHook = null;
    	      workInProgress.updateQueue = null;

    	      {
    	        // Also validate hook order for cascading updates.
    	        hookTypesUpdateIndexDev = -1;
    	      }

    	      ReactCurrentDispatcher$1.current =  HooksDispatcherOnRerenderInDEV ;
    	      children = Component(props, secondArg);
    	    } while (didScheduleRenderPhaseUpdateDuringThisPass);
    	  } // We can assume the previous dispatcher is always this one, since we set it
    	  // at the beginning of the render phase and there's no re-entrancy.


    	  ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;

    	  {
    	    workInProgress._debugHookTypes = hookTypesDev;
    	  } // This check uses currentHook so that it works the same in DEV and prod bundles.
    	  // hookTypesDev could catch more cases (e.g. context) but only in DEV bundles.


    	  var didRenderTooFewHooks = currentHook !== null && currentHook.next !== null;
    	  renderLanes = NoLanes;
    	  currentlyRenderingFiber$1 = null;
    	  currentHook = null;
    	  workInProgressHook = null;

    	  {
    	    currentHookNameInDev = null;
    	    hookTypesDev = null;
    	    hookTypesUpdateIndexDev = -1;
    	  }

    	  didScheduleRenderPhaseUpdate = false;

    	  if (!!didRenderTooFewHooks) {
    	    {
    	      throw Error( "Rendered fewer hooks than expected. This may be caused by an accidental early return statement." );
    	    }
    	  }

    	  return children;
    	}
    	function bailoutHooks(current, workInProgress, lanes) {
    	  workInProgress.updateQueue = current.updateQueue;
    	  workInProgress.flags &= ~(Passive | Update);
    	  current.lanes = removeLanes(current.lanes, lanes);
    	}
    	function resetHooksAfterThrow() {
    	  // We can assume the previous dispatcher is always this one, since we set it
    	  // at the beginning of the render phase and there's no re-entrancy.
    	  ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;

    	  if (didScheduleRenderPhaseUpdate) {
    	    // There were render phase updates. These are only valid for this render
    	    // phase, which we are now aborting. Remove the updates from the queues so
    	    // they do not persist to the next render. Do not remove updates from hooks
    	    // that weren't processed.
    	    //
    	    // Only reset the updates from the queue if it has a clone. If it does
    	    // not have a clone, that means it wasn't processed, and the updates were
    	    // scheduled before we entered the render phase.
    	    var hook = currentlyRenderingFiber$1.memoizedState;

    	    while (hook !== null) {
    	      var queue = hook.queue;

    	      if (queue !== null) {
    	        queue.pending = null;
    	      }

    	      hook = hook.next;
    	    }

    	    didScheduleRenderPhaseUpdate = false;
    	  }

    	  renderLanes = NoLanes;
    	  currentlyRenderingFiber$1 = null;
    	  currentHook = null;
    	  workInProgressHook = null;

    	  {
    	    hookTypesDev = null;
    	    hookTypesUpdateIndexDev = -1;
    	    currentHookNameInDev = null;
    	    isUpdatingOpaqueValueInRenderPhase = false;
    	  }

    	  didScheduleRenderPhaseUpdateDuringThisPass = false;
    	}

    	function mountWorkInProgressHook() {
    	  var hook = {
    	    memoizedState: null,
    	    baseState: null,
    	    baseQueue: null,
    	    queue: null,
    	    next: null
    	  };

    	  if (workInProgressHook === null) {
    	    // This is the first hook in the list
    	    currentlyRenderingFiber$1.memoizedState = workInProgressHook = hook;
    	  } else {
    	    // Append to the end of the list
    	    workInProgressHook = workInProgressHook.next = hook;
    	  }

    	  return workInProgressHook;
    	}

    	function updateWorkInProgressHook() {
    	  // This function is used both for updates and for re-renders triggered by a
    	  // render phase update. It assumes there is either a current hook we can
    	  // clone, or a work-in-progress hook from a previous render pass that we can
    	  // use as a base. When we reach the end of the base list, we must switch to
    	  // the dispatcher used for mounts.
    	  var nextCurrentHook;

    	  if (currentHook === null) {
    	    var current = currentlyRenderingFiber$1.alternate;

    	    if (current !== null) {
    	      nextCurrentHook = current.memoizedState;
    	    } else {
    	      nextCurrentHook = null;
    	    }
    	  } else {
    	    nextCurrentHook = currentHook.next;
    	  }

    	  var nextWorkInProgressHook;

    	  if (workInProgressHook === null) {
    	    nextWorkInProgressHook = currentlyRenderingFiber$1.memoizedState;
    	  } else {
    	    nextWorkInProgressHook = workInProgressHook.next;
    	  }

    	  if (nextWorkInProgressHook !== null) {
    	    // There's already a work-in-progress. Reuse it.
    	    workInProgressHook = nextWorkInProgressHook;
    	    nextWorkInProgressHook = workInProgressHook.next;
    	    currentHook = nextCurrentHook;
    	  } else {
    	    // Clone from the current hook.
    	    if (!(nextCurrentHook !== null)) {
    	      {
    	        throw Error( "Rendered more hooks than during the previous render." );
    	      }
    	    }

    	    currentHook = nextCurrentHook;
    	    var newHook = {
    	      memoizedState: currentHook.memoizedState,
    	      baseState: currentHook.baseState,
    	      baseQueue: currentHook.baseQueue,
    	      queue: currentHook.queue,
    	      next: null
    	    };

    	    if (workInProgressHook === null) {
    	      // This is the first hook in the list.
    	      currentlyRenderingFiber$1.memoizedState = workInProgressHook = newHook;
    	    } else {
    	      // Append to the end of the list.
    	      workInProgressHook = workInProgressHook.next = newHook;
    	    }
    	  }

    	  return workInProgressHook;
    	}

    	function createFunctionComponentUpdateQueue() {
    	  return {
    	    lastEffect: null
    	  };
    	}

    	function basicStateReducer(state, action) {
    	  // $FlowFixMe: Flow doesn't like mixed types
    	  return typeof action === 'function' ? action(state) : action;
    	}

    	function mountReducer(reducer, initialArg, init) {
    	  var hook = mountWorkInProgressHook();
    	  var initialState;

    	  if (init !== undefined) {
    	    initialState = init(initialArg);
    	  } else {
    	    initialState = initialArg;
    	  }

    	  hook.memoizedState = hook.baseState = initialState;
    	  var queue = hook.queue = {
    	    pending: null,
    	    dispatch: null,
    	    lastRenderedReducer: reducer,
    	    lastRenderedState: initialState
    	  };
    	  var dispatch = queue.dispatch = dispatchAction.bind(null, currentlyRenderingFiber$1, queue);
    	  return [hook.memoizedState, dispatch];
    	}

    	function updateReducer(reducer, initialArg, init) {
    	  var hook = updateWorkInProgressHook();
    	  var queue = hook.queue;

    	  if (!(queue !== null)) {
    	    {
    	      throw Error( "Should have a queue. This is likely a bug in React. Please file an issue." );
    	    }
    	  }

    	  queue.lastRenderedReducer = reducer;
    	  var current = currentHook; // The last rebase update that is NOT part of the base state.

    	  var baseQueue = current.baseQueue; // The last pending update that hasn't been processed yet.

    	  var pendingQueue = queue.pending;

    	  if (pendingQueue !== null) {
    	    // We have new updates that haven't been processed yet.
    	    // We'll add them to the base queue.
    	    if (baseQueue !== null) {
    	      // Merge the pending queue and the base queue.
    	      var baseFirst = baseQueue.next;
    	      var pendingFirst = pendingQueue.next;
    	      baseQueue.next = pendingFirst;
    	      pendingQueue.next = baseFirst;
    	    }

    	    {
    	      if (current.baseQueue !== baseQueue) {
    	        // Internal invariant that should never happen, but feasibly could in
    	        // the future if we implement resuming, or some form of that.
    	        error('Internal error: Expected work-in-progress queue to be a clone. ' + 'This is a bug in React.');
    	      }
    	    }

    	    current.baseQueue = baseQueue = pendingQueue;
    	    queue.pending = null;
    	  }

    	  if (baseQueue !== null) {
    	    // We have a queue to process.
    	    var first = baseQueue.next;
    	    var newState = current.baseState;
    	    var newBaseState = null;
    	    var newBaseQueueFirst = null;
    	    var newBaseQueueLast = null;
    	    var update = first;

    	    do {
    	      var updateLane = update.lane;

    	      if (!isSubsetOfLanes(renderLanes, updateLane)) {
    	        // Priority is insufficient. Skip this update. If this is the first
    	        // skipped update, the previous update/state is the new base
    	        // update/state.
    	        var clone = {
    	          lane: updateLane,
    	          action: update.action,
    	          eagerReducer: update.eagerReducer,
    	          eagerState: update.eagerState,
    	          next: null
    	        };

    	        if (newBaseQueueLast === null) {
    	          newBaseQueueFirst = newBaseQueueLast = clone;
    	          newBaseState = newState;
    	        } else {
    	          newBaseQueueLast = newBaseQueueLast.next = clone;
    	        } // Update the remaining priority in the queue.
    	        // TODO: Don't need to accumulate this. Instead, we can remove
    	        // renderLanes from the original lanes.


    	        currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, updateLane);
    	        markSkippedUpdateLanes(updateLane);
    	      } else {
    	        // This update does have sufficient priority.
    	        if (newBaseQueueLast !== null) {
    	          var _clone = {
    	            // This update is going to be committed so we never want uncommit
    	            // it. Using NoLane works because 0 is a subset of all bitmasks, so
    	            // this will never be skipped by the check above.
    	            lane: NoLane,
    	            action: update.action,
    	            eagerReducer: update.eagerReducer,
    	            eagerState: update.eagerState,
    	            next: null
    	          };
    	          newBaseQueueLast = newBaseQueueLast.next = _clone;
    	        } // Process this update.


    	        if (update.eagerReducer === reducer) {
    	          // If this update was processed eagerly, and its reducer matches the
    	          // current reducer, we can use the eagerly computed state.
    	          newState = update.eagerState;
    	        } else {
    	          var action = update.action;
    	          newState = reducer(newState, action);
    	        }
    	      }

    	      update = update.next;
    	    } while (update !== null && update !== first);

    	    if (newBaseQueueLast === null) {
    	      newBaseState = newState;
    	    } else {
    	      newBaseQueueLast.next = newBaseQueueFirst;
    	    } // Mark that the fiber performed work, but only if the new state is
    	    // different from the current state.


    	    if (!objectIs(newState, hook.memoizedState)) {
    	      markWorkInProgressReceivedUpdate();
    	    }

    	    hook.memoizedState = newState;
    	    hook.baseState = newBaseState;
    	    hook.baseQueue = newBaseQueueLast;
    	    queue.lastRenderedState = newState;
    	  }

    	  var dispatch = queue.dispatch;
    	  return [hook.memoizedState, dispatch];
    	}

    	function rerenderReducer(reducer, initialArg, init) {
    	  var hook = updateWorkInProgressHook();
    	  var queue = hook.queue;

    	  if (!(queue !== null)) {
    	    {
    	      throw Error( "Should have a queue. This is likely a bug in React. Please file an issue." );
    	    }
    	  }

    	  queue.lastRenderedReducer = reducer; // This is a re-render. Apply the new render phase updates to the previous
    	  // work-in-progress hook.

    	  var dispatch = queue.dispatch;
    	  var lastRenderPhaseUpdate = queue.pending;
    	  var newState = hook.memoizedState;

    	  if (lastRenderPhaseUpdate !== null) {
    	    // The queue doesn't persist past this render pass.
    	    queue.pending = null;
    	    var firstRenderPhaseUpdate = lastRenderPhaseUpdate.next;
    	    var update = firstRenderPhaseUpdate;

    	    do {
    	      // Process this render phase update. We don't have to check the
    	      // priority because it will always be the same as the current
    	      // render's.
    	      var action = update.action;
    	      newState = reducer(newState, action);
    	      update = update.next;
    	    } while (update !== firstRenderPhaseUpdate); // Mark that the fiber performed work, but only if the new state is
    	    // different from the current state.


    	    if (!objectIs(newState, hook.memoizedState)) {
    	      markWorkInProgressReceivedUpdate();
    	    }

    	    hook.memoizedState = newState; // Don't persist the state accumulated from the render phase updates to
    	    // the base state unless the queue is empty.
    	    // TODO: Not sure if this is the desired semantics, but it's what we
    	    // do for gDSFP. I can't remember why.

    	    if (hook.baseQueue === null) {
    	      hook.baseState = newState;
    	    }

    	    queue.lastRenderedState = newState;
    	  }

    	  return [newState, dispatch];
    	}

    	function readFromUnsubcribedMutableSource(root, source, getSnapshot) {
    	  {
    	    warnAboutMultipleRenderersDEV(source);
    	  }

    	  var getVersion = source._getVersion;
    	  var version = getVersion(source._source); // Is it safe for this component to read from this source during the current render?

    	  var isSafeToReadFromSource = false; // Check the version first.
    	  // If this render has already been started with a specific version,
    	  // we can use it alone to determine if we can safely read from the source.

    	  var currentRenderVersion = getWorkInProgressVersion(source);

    	  if (currentRenderVersion !== null) {
    	    // It's safe to read if the store hasn't been mutated since the last time
    	    // we read something.
    	    isSafeToReadFromSource = currentRenderVersion === version;
    	  } else {
    	    // If there's no version, then this is the first time we've read from the
    	    // source during the current render pass, so we need to do a bit more work.
    	    // What we need to determine is if there are any hooks that already
    	    // subscribed to the source, and if so, whether there are any pending
    	    // mutations that haven't been synchronized yet.
    	    //
    	    // If there are no pending mutations, then `root.mutableReadLanes` will be
    	    // empty, and we know we can safely read.
    	    //
    	    // If there *are* pending mutations, we may still be able to safely read
    	    // if the currently rendering lanes are inclusive of the pending mutation
    	    // lanes, since that guarantees that the value we're about to read from
    	    // the source is consistent with the values that we read during the most
    	    // recent mutation.
    	    isSafeToReadFromSource = isSubsetOfLanes(renderLanes, root.mutableReadLanes);

    	    if (isSafeToReadFromSource) {
    	      // If it's safe to read from this source during the current render,
    	      // store the version in case other components read from it.
    	      // A changed version number will let those components know to throw and restart the render.
    	      setWorkInProgressVersion(source, version);
    	    }
    	  }

    	  if (isSafeToReadFromSource) {
    	    var snapshot = getSnapshot(source._source);

    	    {
    	      if (typeof snapshot === 'function') {
    	        error('Mutable source should not return a function as the snapshot value. ' + 'Functions may close over mutable values and cause tearing.');
    	      }
    	    }

    	    return snapshot;
    	  } else {
    	    // This handles the special case of a mutable source being shared between renderers.
    	    // In that case, if the source is mutated between the first and second renderer,
    	    // The second renderer don't know that it needs to reset the WIP version during unwind,
    	    // (because the hook only marks sources as dirty if it's written to their WIP version).
    	    // That would cause this tear check to throw again and eventually be visible to the user.
    	    // We can avoid this infinite loop by explicitly marking the source as dirty.
    	    //
    	    // This can lead to tearing in the first renderer when it resumes,
    	    // but there's nothing we can do about that (short of throwing here and refusing to continue the render).
    	    markSourceAsDirty(source);

    	    {
    	      {
    	        throw Error( "Cannot read from mutable source during the current render without tearing. This is a bug in React. Please file an issue." );
    	      }
    	    }
    	  }
    	}

    	function useMutableSource(hook, source, getSnapshot, subscribe) {
    	  var root = getWorkInProgressRoot();

    	  if (!(root !== null)) {
    	    {
    	      throw Error( "Expected a work-in-progress root. This is a bug in React. Please file an issue." );
    	    }
    	  }

    	  var getVersion = source._getVersion;
    	  var version = getVersion(source._source);
    	  var dispatcher = ReactCurrentDispatcher$1.current; // eslint-disable-next-line prefer-const

    	  var _dispatcher$useState = dispatcher.useState(function () {
    	    return readFromUnsubcribedMutableSource(root, source, getSnapshot);
    	  }),
    	      currentSnapshot = _dispatcher$useState[0],
    	      setSnapshot = _dispatcher$useState[1];

    	  var snapshot = currentSnapshot; // Grab a handle to the state hook as well.
    	  // We use it to clear the pending update queue if we have a new source.

    	  var stateHook = workInProgressHook;
    	  var memoizedState = hook.memoizedState;
    	  var refs = memoizedState.refs;
    	  var prevGetSnapshot = refs.getSnapshot;
    	  var prevSource = memoizedState.source;
    	  var prevSubscribe = memoizedState.subscribe;
    	  var fiber = currentlyRenderingFiber$1;
    	  hook.memoizedState = {
    	    refs: refs,
    	    source: source,
    	    subscribe: subscribe
    	  }; // Sync the values needed by our subscription handler after each commit.

    	  dispatcher.useEffect(function () {
    	    refs.getSnapshot = getSnapshot; // Normally the dispatch function for a state hook never changes,
    	    // but this hook recreates the queue in certain cases  to avoid updates from stale sources.
    	    // handleChange() below needs to reference the dispatch function without re-subscribing,
    	    // so we use a ref to ensure that it always has the latest version.

    	    refs.setSnapshot = setSnapshot; // Check for a possible change between when we last rendered now.

    	    var maybeNewVersion = getVersion(source._source);

    	    if (!objectIs(version, maybeNewVersion)) {
    	      var maybeNewSnapshot = getSnapshot(source._source);

    	      {
    	        if (typeof maybeNewSnapshot === 'function') {
    	          error('Mutable source should not return a function as the snapshot value. ' + 'Functions may close over mutable values and cause tearing.');
    	        }
    	      }

    	      if (!objectIs(snapshot, maybeNewSnapshot)) {
    	        setSnapshot(maybeNewSnapshot);
    	        var lane = requestUpdateLane(fiber);
    	        markRootMutableRead(root, lane);
    	      } // If the source mutated between render and now,
    	      // there may be state updates already scheduled from the old source.
    	      // Entangle the updates so that they render in the same batch.


    	      markRootEntangled(root, root.mutableReadLanes);
    	    }
    	  }, [getSnapshot, source, subscribe]); // If we got a new source or subscribe function, re-subscribe in a passive effect.

    	  dispatcher.useEffect(function () {
    	    var handleChange = function () {
    	      var latestGetSnapshot = refs.getSnapshot;
    	      var latestSetSnapshot = refs.setSnapshot;

    	      try {
    	        latestSetSnapshot(latestGetSnapshot(source._source)); // Record a pending mutable source update with the same expiration time.

    	        var lane = requestUpdateLane(fiber);
    	        markRootMutableRead(root, lane);
    	      } catch (error) {
    	        // A selector might throw after a source mutation.
    	        // e.g. it might try to read from a part of the store that no longer exists.
    	        // In this case we should still schedule an update with React.
    	        // Worst case the selector will throw again and then an error boundary will handle it.
    	        latestSetSnapshot(function () {
    	          throw error;
    	        });
    	      }
    	    };

    	    var unsubscribe = subscribe(source._source, handleChange);

    	    {
    	      if (typeof unsubscribe !== 'function') {
    	        error('Mutable source subscribe function must return an unsubscribe function.');
    	      }
    	    }

    	    return unsubscribe;
    	  }, [source, subscribe]); // If any of the inputs to useMutableSource change, reading is potentially unsafe.
    	  //
    	  // If either the source or the subscription have changed we can't can't trust the update queue.
    	  // Maybe the source changed in a way that the old subscription ignored but the new one depends on.
    	  //
    	  // If the getSnapshot function changed, we also shouldn't rely on the update queue.
    	  // It's possible that the underlying source was mutated between the when the last "change" event fired,
    	  // and when the current render (with the new getSnapshot function) is processed.
    	  //
    	  // In both cases, we need to throw away pending updates (since they are no longer relevant)
    	  // and treat reading from the source as we do in the mount case.

    	  if (!objectIs(prevGetSnapshot, getSnapshot) || !objectIs(prevSource, source) || !objectIs(prevSubscribe, subscribe)) {
    	    // Create a new queue and setState method,
    	    // So if there are interleaved updates, they get pushed to the older queue.
    	    // When this becomes current, the previous queue and dispatch method will be discarded,
    	    // including any interleaving updates that occur.
    	    var newQueue = {
    	      pending: null,
    	      dispatch: null,
    	      lastRenderedReducer: basicStateReducer,
    	      lastRenderedState: snapshot
    	    };
    	    newQueue.dispatch = setSnapshot = dispatchAction.bind(null, currentlyRenderingFiber$1, newQueue);
    	    stateHook.queue = newQueue;
    	    stateHook.baseQueue = null;
    	    snapshot = readFromUnsubcribedMutableSource(root, source, getSnapshot);
    	    stateHook.memoizedState = stateHook.baseState = snapshot;
    	  }

    	  return snapshot;
    	}

    	function mountMutableSource(source, getSnapshot, subscribe) {
    	  var hook = mountWorkInProgressHook();
    	  hook.memoizedState = {
    	    refs: {
    	      getSnapshot: getSnapshot,
    	      setSnapshot: null
    	    },
    	    source: source,
    	    subscribe: subscribe
    	  };
    	  return useMutableSource(hook, source, getSnapshot, subscribe);
    	}

    	function updateMutableSource(source, getSnapshot, subscribe) {
    	  var hook = updateWorkInProgressHook();
    	  return useMutableSource(hook, source, getSnapshot, subscribe);
    	}

    	function mountState(initialState) {
    	  var hook = mountWorkInProgressHook();

    	  if (typeof initialState === 'function') {
    	    // $FlowFixMe: Flow doesn't like mixed types
    	    initialState = initialState();
    	  }

    	  hook.memoizedState = hook.baseState = initialState;
    	  var queue = hook.queue = {
    	    pending: null,
    	    dispatch: null,
    	    lastRenderedReducer: basicStateReducer,
    	    lastRenderedState: initialState
    	  };
    	  var dispatch = queue.dispatch = dispatchAction.bind(null, currentlyRenderingFiber$1, queue);
    	  return [hook.memoizedState, dispatch];
    	}

    	function updateState(initialState) {
    	  return updateReducer(basicStateReducer);
    	}

    	function rerenderState(initialState) {
    	  return rerenderReducer(basicStateReducer);
    	}

    	function pushEffect(tag, create, destroy, deps) {
    	  var effect = {
    	    tag: tag,
    	    create: create,
    	    destroy: destroy,
    	    deps: deps,
    	    // Circular
    	    next: null
    	  };
    	  var componentUpdateQueue = currentlyRenderingFiber$1.updateQueue;

    	  if (componentUpdateQueue === null) {
    	    componentUpdateQueue = createFunctionComponentUpdateQueue();
    	    currentlyRenderingFiber$1.updateQueue = componentUpdateQueue;
    	    componentUpdateQueue.lastEffect = effect.next = effect;
    	  } else {
    	    var lastEffect = componentUpdateQueue.lastEffect;

    	    if (lastEffect === null) {
    	      componentUpdateQueue.lastEffect = effect.next = effect;
    	    } else {
    	      var firstEffect = lastEffect.next;
    	      lastEffect.next = effect;
    	      effect.next = firstEffect;
    	      componentUpdateQueue.lastEffect = effect;
    	    }
    	  }

    	  return effect;
    	}

    	function mountRef(initialValue) {
    	  var hook = mountWorkInProgressHook();
    	  var ref = {
    	    current: initialValue
    	  };

    	  {
    	    Object.seal(ref);
    	  }

    	  hook.memoizedState = ref;
    	  return ref;
    	}

    	function updateRef(initialValue) {
    	  var hook = updateWorkInProgressHook();
    	  return hook.memoizedState;
    	}

    	function mountEffectImpl(fiberFlags, hookFlags, create, deps) {
    	  var hook = mountWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  currentlyRenderingFiber$1.flags |= fiberFlags;
    	  hook.memoizedState = pushEffect(HasEffect | hookFlags, create, undefined, nextDeps);
    	}

    	function updateEffectImpl(fiberFlags, hookFlags, create, deps) {
    	  var hook = updateWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  var destroy = undefined;

    	  if (currentHook !== null) {
    	    var prevEffect = currentHook.memoizedState;
    	    destroy = prevEffect.destroy;

    	    if (nextDeps !== null) {
    	      var prevDeps = prevEffect.deps;

    	      if (areHookInputsEqual(nextDeps, prevDeps)) {
    	        pushEffect(hookFlags, create, destroy, nextDeps);
    	        return;
    	      }
    	    }
    	  }

    	  currentlyRenderingFiber$1.flags |= fiberFlags;
    	  hook.memoizedState = pushEffect(HasEffect | hookFlags, create, destroy, nextDeps);
    	}

    	function mountEffect(create, deps) {
    	  {
    	    // $FlowExpectedError - jest isn't a global, and isn't recognized outside of tests
    	    if ('undefined' !== typeof jest) {
    	      warnIfNotCurrentlyActingEffectsInDEV(currentlyRenderingFiber$1);
    	    }
    	  }

    	  return mountEffectImpl(Update | Passive, Passive$1, create, deps);
    	}

    	function updateEffect(create, deps) {
    	  {
    	    // $FlowExpectedError - jest isn't a global, and isn't recognized outside of tests
    	    if ('undefined' !== typeof jest) {
    	      warnIfNotCurrentlyActingEffectsInDEV(currentlyRenderingFiber$1);
    	    }
    	  }

    	  return updateEffectImpl(Update | Passive, Passive$1, create, deps);
    	}

    	function mountLayoutEffect(create, deps) {
    	  return mountEffectImpl(Update, Layout, create, deps);
    	}

    	function updateLayoutEffect(create, deps) {
    	  return updateEffectImpl(Update, Layout, create, deps);
    	}

    	function imperativeHandleEffect(create, ref) {
    	  if (typeof ref === 'function') {
    	    var refCallback = ref;

    	    var _inst = create();

    	    refCallback(_inst);
    	    return function () {
    	      refCallback(null);
    	    };
    	  } else if (ref !== null && ref !== undefined) {
    	    var refObject = ref;

    	    {
    	      if (!refObject.hasOwnProperty('current')) {
    	        error('Expected useImperativeHandle() first argument to either be a ' + 'ref callback or React.createRef() object. Instead received: %s.', 'an object with keys {' + Object.keys(refObject).join(', ') + '}');
    	      }
    	    }

    	    var _inst2 = create();

    	    refObject.current = _inst2;
    	    return function () {
    	      refObject.current = null;
    	    };
    	  }
    	}

    	function mountImperativeHandle(ref, create, deps) {
    	  {
    	    if (typeof create !== 'function') {
    	      error('Expected useImperativeHandle() second argument to be a function ' + 'that creates a handle. Instead received: %s.', create !== null ? typeof create : 'null');
    	    }
    	  } // TODO: If deps are provided, should we skip comparing the ref itself?


    	  var effectDeps = deps !== null && deps !== undefined ? deps.concat([ref]) : null;
    	  return mountEffectImpl(Update, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
    	}

    	function updateImperativeHandle(ref, create, deps) {
    	  {
    	    if (typeof create !== 'function') {
    	      error('Expected useImperativeHandle() second argument to be a function ' + 'that creates a handle. Instead received: %s.', create !== null ? typeof create : 'null');
    	    }
    	  } // TODO: If deps are provided, should we skip comparing the ref itself?


    	  var effectDeps = deps !== null && deps !== undefined ? deps.concat([ref]) : null;
    	  return updateEffectImpl(Update, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
    	}

    	function mountDebugValue(value, formatterFn) {// This hook is normally a no-op.
    	  // The react-debug-hooks package injects its own implementation
    	  // so that e.g. DevTools can display custom hook values.
    	}

    	var updateDebugValue = mountDebugValue;

    	function mountCallback(callback, deps) {
    	  var hook = mountWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  hook.memoizedState = [callback, nextDeps];
    	  return callback;
    	}

    	function updateCallback(callback, deps) {
    	  var hook = updateWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  var prevState = hook.memoizedState;

    	  if (prevState !== null) {
    	    if (nextDeps !== null) {
    	      var prevDeps = prevState[1];

    	      if (areHookInputsEqual(nextDeps, prevDeps)) {
    	        return prevState[0];
    	      }
    	    }
    	  }

    	  hook.memoizedState = [callback, nextDeps];
    	  return callback;
    	}

    	function mountMemo(nextCreate, deps) {
    	  var hook = mountWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  var nextValue = nextCreate();
    	  hook.memoizedState = [nextValue, nextDeps];
    	  return nextValue;
    	}

    	function updateMemo(nextCreate, deps) {
    	  var hook = updateWorkInProgressHook();
    	  var nextDeps = deps === undefined ? null : deps;
    	  var prevState = hook.memoizedState;

    	  if (prevState !== null) {
    	    // Assume these are defined. If they're not, areHookInputsEqual will warn.
    	    if (nextDeps !== null) {
    	      var prevDeps = prevState[1];

    	      if (areHookInputsEqual(nextDeps, prevDeps)) {
    	        return prevState[0];
    	      }
    	    }
    	  }

    	  var nextValue = nextCreate();
    	  hook.memoizedState = [nextValue, nextDeps];
    	  return nextValue;
    	}

    	function mountDeferredValue(value) {
    	  var _mountState = mountState(value),
    	      prevValue = _mountState[0],
    	      setValue = _mountState[1];

    	  mountEffect(function () {
    	    var prevTransition = ReactCurrentBatchConfig$1.transition;
    	    ReactCurrentBatchConfig$1.transition = 1;

    	    try {
    	      setValue(value);
    	    } finally {
    	      ReactCurrentBatchConfig$1.transition = prevTransition;
    	    }
    	  }, [value]);
    	  return prevValue;
    	}

    	function updateDeferredValue(value) {
    	  var _updateState = updateState(),
    	      prevValue = _updateState[0],
    	      setValue = _updateState[1];

    	  updateEffect(function () {
    	    var prevTransition = ReactCurrentBatchConfig$1.transition;
    	    ReactCurrentBatchConfig$1.transition = 1;

    	    try {
    	      setValue(value);
    	    } finally {
    	      ReactCurrentBatchConfig$1.transition = prevTransition;
    	    }
    	  }, [value]);
    	  return prevValue;
    	}

    	function rerenderDeferredValue(value) {
    	  var _rerenderState = rerenderState(),
    	      prevValue = _rerenderState[0],
    	      setValue = _rerenderState[1];

    	  updateEffect(function () {
    	    var prevTransition = ReactCurrentBatchConfig$1.transition;
    	    ReactCurrentBatchConfig$1.transition = 1;

    	    try {
    	      setValue(value);
    	    } finally {
    	      ReactCurrentBatchConfig$1.transition = prevTransition;
    	    }
    	  }, [value]);
    	  return prevValue;
    	}

    	function startTransition(setPending, callback) {
    	  var priorityLevel = getCurrentPriorityLevel();

    	  {
    	    runWithPriority$1(priorityLevel < UserBlockingPriority$2 ? UserBlockingPriority$2 : priorityLevel, function () {
    	      setPending(true);
    	    });
    	    runWithPriority$1(priorityLevel > NormalPriority$1 ? NormalPriority$1 : priorityLevel, function () {
    	      var prevTransition = ReactCurrentBatchConfig$1.transition;
    	      ReactCurrentBatchConfig$1.transition = 1;

    	      try {
    	        setPending(false);
    	        callback();
    	      } finally {
    	        ReactCurrentBatchConfig$1.transition = prevTransition;
    	      }
    	    });
    	  }
    	}

    	function mountTransition() {
    	  var _mountState2 = mountState(false),
    	      isPending = _mountState2[0],
    	      setPending = _mountState2[1]; // The `start` method can be stored on a ref, since `setPending`
    	  // never changes.


    	  var start = startTransition.bind(null, setPending);
    	  mountRef(start);
    	  return [start, isPending];
    	}

    	function updateTransition() {
    	  var _updateState2 = updateState(),
    	      isPending = _updateState2[0];

    	  var startRef = updateRef();
    	  var start = startRef.current;
    	  return [start, isPending];
    	}

    	function rerenderTransition() {
    	  var _rerenderState2 = rerenderState(),
    	      isPending = _rerenderState2[0];

    	  var startRef = updateRef();
    	  var start = startRef.current;
    	  return [start, isPending];
    	}

    	var isUpdatingOpaqueValueInRenderPhase = false;
    	function getIsUpdatingOpaqueValueInRenderPhaseInDEV() {
    	  {
    	    return isUpdatingOpaqueValueInRenderPhase;
    	  }
    	}

    	function warnOnOpaqueIdentifierAccessInDEV(fiber) {
    	  {
    	    // TODO: Should warn in effects and callbacks, too
    	    var name = getComponentName(fiber.type) || 'Unknown';

    	    if (getIsRendering() && !didWarnAboutUseOpaqueIdentifier[name]) {
    	      error('The object passed back from useOpaqueIdentifier is meant to be ' + 'passed through to attributes only. Do not read the ' + 'value directly.');

    	      didWarnAboutUseOpaqueIdentifier[name] = true;
    	    }
    	  }
    	}

    	function mountOpaqueIdentifier() {
    	  var makeId =  makeClientIdInDEV.bind(null, warnOnOpaqueIdentifierAccessInDEV.bind(null, currentlyRenderingFiber$1)) ;

    	  if (getIsHydrating()) {
    	    var didUpgrade = false;
    	    var fiber = currentlyRenderingFiber$1;

    	    var readValue = function () {
    	      if (!didUpgrade) {
    	        // Only upgrade once. This works even inside the render phase because
    	        // the update is added to a shared queue, which outlasts the
    	        // in-progress render.
    	        didUpgrade = true;

    	        {
    	          isUpdatingOpaqueValueInRenderPhase = true;
    	          setId(makeId());
    	          isUpdatingOpaqueValueInRenderPhase = false;
    	          warnOnOpaqueIdentifierAccessInDEV(fiber);
    	        }
    	      }

    	      {
    	        {
    	          throw Error( "The object passed back from useOpaqueIdentifier is meant to be passed through to attributes only. Do not read the value directly." );
    	        }
    	      }
    	    };

    	    var id = makeOpaqueHydratingObject(readValue);
    	    var setId = mountState(id)[1];

    	    if ((currentlyRenderingFiber$1.mode & BlockingMode) === NoMode) {
    	      currentlyRenderingFiber$1.flags |= Update | Passive;
    	      pushEffect(HasEffect | Passive$1, function () {
    	        setId(makeId());
    	      }, undefined, null);
    	    }

    	    return id;
    	  } else {
    	    var _id = makeId();

    	    mountState(_id);
    	    return _id;
    	  }
    	}

    	function updateOpaqueIdentifier() {
    	  var id = updateState()[0];
    	  return id;
    	}

    	function rerenderOpaqueIdentifier() {
    	  var id = rerenderState()[0];
    	  return id;
    	}

    	function dispatchAction(fiber, queue, action) {
    	  {
    	    if (typeof arguments[3] === 'function') {
    	      error("State updates from the useState() and useReducer() Hooks don't support the " + 'second callback argument. To execute a side effect after ' + 'rendering, declare it in the component body with useEffect().');
    	    }
    	  }

    	  var eventTime = requestEventTime();
    	  var lane = requestUpdateLane(fiber);
    	  var update = {
    	    lane: lane,
    	    action: action,
    	    eagerReducer: null,
    	    eagerState: null,
    	    next: null
    	  }; // Append the update to the end of the list.

    	  var pending = queue.pending;

    	  if (pending === null) {
    	    // This is the first update. Create a circular list.
    	    update.next = update;
    	  } else {
    	    update.next = pending.next;
    	    pending.next = update;
    	  }

    	  queue.pending = update;
    	  var alternate = fiber.alternate;

    	  if (fiber === currentlyRenderingFiber$1 || alternate !== null && alternate === currentlyRenderingFiber$1) {
    	    // This is a render phase update. Stash it in a lazily-created map of
    	    // queue -> linked list of updates. After this render pass, we'll restart
    	    // and apply the stashed updates on top of the work-in-progress hook.
    	    didScheduleRenderPhaseUpdateDuringThisPass = didScheduleRenderPhaseUpdate = true;
    	  } else {
    	    if (fiber.lanes === NoLanes && (alternate === null || alternate.lanes === NoLanes)) {
    	      // The queue is currently empty, which means we can eagerly compute the
    	      // next state before entering the render phase. If the new state is the
    	      // same as the current state, we may be able to bail out entirely.
    	      var lastRenderedReducer = queue.lastRenderedReducer;

    	      if (lastRenderedReducer !== null) {
    	        var prevDispatcher;

    	        {
    	          prevDispatcher = ReactCurrentDispatcher$1.current;
    	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
    	        }

    	        try {
    	          var currentState = queue.lastRenderedState;
    	          var eagerState = lastRenderedReducer(currentState, action); // Stash the eagerly computed state, and the reducer used to compute
    	          // it, on the update object. If the reducer hasn't changed by the
    	          // time we enter the render phase, then the eager state can be used
    	          // without calling the reducer again.

    	          update.eagerReducer = lastRenderedReducer;
    	          update.eagerState = eagerState;

    	          if (objectIs(eagerState, currentState)) {
    	            // Fast path. We can bail out without scheduling React to re-render.
    	            // It's still possible that we'll need to rebase this update later,
    	            // if the component re-renders for a different reason and by that
    	            // time the reducer has changed.
    	            return;
    	          }
    	        } catch (error) {// Suppress the error. It will throw again in the render phase.
    	        } finally {
    	          {
    	            ReactCurrentDispatcher$1.current = prevDispatcher;
    	          }
    	        }
    	      }
    	    }

    	    {
    	      // $FlowExpectedError - jest isn't a global, and isn't recognized outside of tests
    	      if ('undefined' !== typeof jest) {
    	        warnIfNotScopedWithMatchingAct(fiber);
    	        warnIfNotCurrentlyActingUpdatesInDev(fiber);
    	      }
    	    }

    	    scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  }
    	}

    	var ContextOnlyDispatcher = {
    	  readContext: readContext,
    	  useCallback: throwInvalidHookError,
    	  useContext: throwInvalidHookError,
    	  useEffect: throwInvalidHookError,
    	  useImperativeHandle: throwInvalidHookError,
    	  useLayoutEffect: throwInvalidHookError,
    	  useMemo: throwInvalidHookError,
    	  useReducer: throwInvalidHookError,
    	  useRef: throwInvalidHookError,
    	  useState: throwInvalidHookError,
    	  useDebugValue: throwInvalidHookError,
    	  useDeferredValue: throwInvalidHookError,
    	  useTransition: throwInvalidHookError,
    	  useMutableSource: throwInvalidHookError,
    	  useOpaqueIdentifier: throwInvalidHookError,
    	  unstable_isNewReconciler: enableNewReconciler
    	};
    	var HooksDispatcherOnMountInDEV = null;
    	var HooksDispatcherOnMountWithHookTypesInDEV = null;
    	var HooksDispatcherOnUpdateInDEV = null;
    	var HooksDispatcherOnRerenderInDEV = null;
    	var InvalidNestedHooksDispatcherOnMountInDEV = null;
    	var InvalidNestedHooksDispatcherOnUpdateInDEV = null;
    	var InvalidNestedHooksDispatcherOnRerenderInDEV = null;

    	{
    	  var warnInvalidContextAccess = function () {
    	    error('Context can only be read while React is rendering. ' + 'In classes, you can read it in the render method or getDerivedStateFromProps. ' + 'In function components, you can read it directly in the function body, but not ' + 'inside Hooks like useReducer() or useMemo().');
    	  };

    	  var warnInvalidHookAccess = function () {
    	    error('Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. ' + 'You can only call Hooks at the top level of your React function. ' + 'For more information, see ' + 'https://reactjs.org/link/rules-of-hooks');
    	  };

    	  HooksDispatcherOnMountInDEV = {
    	    readContext: function (context, observedBits) {
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      mountHookTypesDev();
    	      checkDepsAreArrayDev(deps);
    	      return mountCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      mountHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      mountHookTypesDev();
    	      checkDepsAreArrayDev(deps);
    	      return mountEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      mountHookTypesDev();
    	      checkDepsAreArrayDev(deps);
    	      return mountImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      mountHookTypesDev();
    	      checkDepsAreArrayDev(deps);
    	      return mountLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      mountHookTypesDev();
    	      checkDepsAreArrayDev(deps);
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      mountHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      mountHookTypesDev();
    	      return mountRef(initialValue);
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      mountHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      mountHookTypesDev();
    	      return mountDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      mountHookTypesDev();
    	      return mountDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      mountHookTypesDev();
    	      return mountTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      mountHookTypesDev();
    	      return mountMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      mountHookTypesDev();
    	      return mountOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  HooksDispatcherOnMountWithHookTypesInDEV = {
    	    readContext: function (context, observedBits) {
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      updateHookTypesDev();
    	      return mountCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      updateHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      updateHookTypesDev();
    	      return mountEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      updateHookTypesDev();
    	      return mountImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      updateHookTypesDev();
    	      return mountLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      updateHookTypesDev();
    	      return mountRef(initialValue);
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      updateHookTypesDev();
    	      return mountDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      updateHookTypesDev();
    	      return mountDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      updateHookTypesDev();
    	      return mountTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      updateHookTypesDev();
    	      return mountMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      updateHookTypesDev();
    	      return mountOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  HooksDispatcherOnUpdateInDEV = {
    	    readContext: function (context, observedBits) {
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      updateHookTypesDev();
    	      return updateCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      updateHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      updateHookTypesDev();
    	      return updateEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      updateHookTypesDev();
    	      return updateImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      updateHookTypesDev();
    	      return updateLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      updateHookTypesDev();
    	      return updateRef();
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      updateHookTypesDev();
    	      return updateDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      updateHookTypesDev();
    	      return updateDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      updateHookTypesDev();
    	      return updateTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      updateHookTypesDev();
    	      return updateMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      updateHookTypesDev();
    	      return updateOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  HooksDispatcherOnRerenderInDEV = {
    	    readContext: function (context, observedBits) {
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      updateHookTypesDev();
    	      return updateCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      updateHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      updateHookTypesDev();
    	      return updateEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      updateHookTypesDev();
    	      return updateImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      updateHookTypesDev();
    	      return updateLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;

    	      try {
    	        return updateMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;

    	      try {
    	        return rerenderReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      updateHookTypesDev();
    	      return updateRef();
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;

    	      try {
    	        return rerenderState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      updateHookTypesDev();
    	      return updateDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      updateHookTypesDev();
    	      return rerenderDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      updateHookTypesDev();
    	      return rerenderTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      updateHookTypesDev();
    	      return updateMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      updateHookTypesDev();
    	      return rerenderOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  InvalidNestedHooksDispatcherOnMountInDEV = {
    	    readContext: function (context, observedBits) {
    	      warnInvalidContextAccess();
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountRef(initialValue);
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;

    	      try {
    	        return mountState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      warnInvalidHookAccess();
    	      mountHookTypesDev();
    	      return mountOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  InvalidNestedHooksDispatcherOnUpdateInDEV = {
    	    readContext: function (context, observedBits) {
    	      warnInvalidContextAccess();
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateRef();
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	  InvalidNestedHooksDispatcherOnRerenderInDEV = {
    	    readContext: function (context, observedBits) {
    	      warnInvalidContextAccess();
    	      return readContext(context, observedBits);
    	    },
    	    useCallback: function (callback, deps) {
    	      currentHookNameInDev = 'useCallback';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateCallback(callback, deps);
    	    },
    	    useContext: function (context, observedBits) {
    	      currentHookNameInDev = 'useContext';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return readContext(context, observedBits);
    	    },
    	    useEffect: function (create, deps) {
    	      currentHookNameInDev = 'useEffect';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateEffect(create, deps);
    	    },
    	    useImperativeHandle: function (ref, create, deps) {
    	      currentHookNameInDev = 'useImperativeHandle';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateImperativeHandle(ref, create, deps);
    	    },
    	    useLayoutEffect: function (create, deps) {
    	      currentHookNameInDev = 'useLayoutEffect';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateLayoutEffect(create, deps);
    	    },
    	    useMemo: function (create, deps) {
    	      currentHookNameInDev = 'useMemo';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return updateMemo(create, deps);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useReducer: function (reducer, initialArg, init) {
    	      currentHookNameInDev = 'useReducer';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return rerenderReducer(reducer, initialArg, init);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useRef: function (initialValue) {
    	      currentHookNameInDev = 'useRef';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateRef();
    	    },
    	    useState: function (initialState) {
    	      currentHookNameInDev = 'useState';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      var prevDispatcher = ReactCurrentDispatcher$1.current;
    	      ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;

    	      try {
    	        return rerenderState(initialState);
    	      } finally {
    	        ReactCurrentDispatcher$1.current = prevDispatcher;
    	      }
    	    },
    	    useDebugValue: function (value, formatterFn) {
    	      currentHookNameInDev = 'useDebugValue';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateDebugValue();
    	    },
    	    useDeferredValue: function (value) {
    	      currentHookNameInDev = 'useDeferredValue';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return rerenderDeferredValue(value);
    	    },
    	    useTransition: function () {
    	      currentHookNameInDev = 'useTransition';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return rerenderTransition();
    	    },
    	    useMutableSource: function (source, getSnapshot, subscribe) {
    	      currentHookNameInDev = 'useMutableSource';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return updateMutableSource(source, getSnapshot, subscribe);
    	    },
    	    useOpaqueIdentifier: function () {
    	      currentHookNameInDev = 'useOpaqueIdentifier';
    	      warnInvalidHookAccess();
    	      updateHookTypesDev();
    	      return rerenderOpaqueIdentifier();
    	    },
    	    unstable_isNewReconciler: enableNewReconciler
    	  };
    	}

    	var now$1 = Scheduler.unstable_now;
    	var commitTime = 0;
    	var profilerStartTime = -1;

    	function getCommitTime() {
    	  return commitTime;
    	}

    	function recordCommitTime() {

    	  commitTime = now$1();
    	}

    	function startProfilerTimer(fiber) {

    	  profilerStartTime = now$1();

    	  if (fiber.actualStartTime < 0) {
    	    fiber.actualStartTime = now$1();
    	  }
    	}

    	function stopProfilerTimerIfRunning(fiber) {

    	  profilerStartTime = -1;
    	}

    	function stopProfilerTimerIfRunningAndRecordDelta(fiber, overrideBaseTime) {

    	  if (profilerStartTime >= 0) {
    	    var elapsedTime = now$1() - profilerStartTime;
    	    fiber.actualDuration += elapsedTime;

    	    if (overrideBaseTime) {
    	      fiber.selfBaseDuration = elapsedTime;
    	    }

    	    profilerStartTime = -1;
    	  }
    	}

    	function transferActualDuration(fiber) {
    	  // Transfer time spent rendering these children so we don't lose it
    	  // after we rerender. This is used as a helper in special cases
    	  // where we should count the work of multiple passes.
    	  var child = fiber.child;

    	  while (child) {
    	    fiber.actualDuration += child.actualDuration;
    	    child = child.sibling;
    	  }
    	}

    	var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
    	var didReceiveUpdate = false;
    	var didWarnAboutBadClass;
    	var didWarnAboutModulePatternComponent;
    	var didWarnAboutContextTypeOnFunctionComponent;
    	var didWarnAboutGetDerivedStateOnFunctionComponent;
    	var didWarnAboutFunctionRefs;
    	var didWarnAboutReassigningProps;
    	var didWarnAboutRevealOrder;
    	var didWarnAboutTailOptions;

    	{
    	  didWarnAboutBadClass = {};
    	  didWarnAboutModulePatternComponent = {};
    	  didWarnAboutContextTypeOnFunctionComponent = {};
    	  didWarnAboutGetDerivedStateOnFunctionComponent = {};
    	  didWarnAboutFunctionRefs = {};
    	  didWarnAboutReassigningProps = false;
    	  didWarnAboutRevealOrder = {};
    	  didWarnAboutTailOptions = {};
    	}

    	function reconcileChildren(current, workInProgress, nextChildren, renderLanes) {
    	  if (current === null) {
    	    // If this is a fresh new component that hasn't been rendered yet, we
    	    // won't update its child set by applying minimal side-effects. Instead,
    	    // we will add them all to the child before it gets rendered. That means
    	    // we can optimize this reconciliation pass by not tracking side-effects.
    	    workInProgress.child = mountChildFibers(workInProgress, null, nextChildren, renderLanes);
    	  } else {
    	    // If the current child is the same as the work in progress, it means that
    	    // we haven't yet started any work on these children. Therefore, we use
    	    // the clone algorithm to create a copy of all the current children.
    	    // If we had any progressed work already, that is invalid at this point so
    	    // let's throw it out.
    	    workInProgress.child = reconcileChildFibers(workInProgress, current.child, nextChildren, renderLanes);
    	  }
    	}

    	function forceUnmountCurrentAndReconcile(current, workInProgress, nextChildren, renderLanes) {
    	  // This function is fork of reconcileChildren. It's used in cases where we
    	  // want to reconcile without matching against the existing set. This has the
    	  // effect of all current children being unmounted; even if the type and key
    	  // are the same, the old child is unmounted and a new child is created.
    	  //
    	  // To do this, we're going to go through the reconcile algorithm twice. In
    	  // the first pass, we schedule a deletion for all the current children by
    	  // passing null.
    	  workInProgress.child = reconcileChildFibers(workInProgress, current.child, null, renderLanes); // In the second pass, we mount the new children. The trick here is that we
    	  // pass null in place of where we usually pass the current child set. This has
    	  // the effect of remounting all children regardless of whether their
    	  // identities match.

    	  workInProgress.child = reconcileChildFibers(workInProgress, null, nextChildren, renderLanes);
    	}

    	function updateForwardRef(current, workInProgress, Component, nextProps, renderLanes) {
    	  // TODO: current can be non-null here even if the component
    	  // hasn't yet mounted. This happens after the first render suspends.
    	  // We'll need to figure out if this is fine or can cause issues.
    	  {
    	    if (workInProgress.type !== workInProgress.elementType) {
    	      // Lazy component props can't be validated in createElement
    	      // because they're only guaranteed to be resolved here.
    	      var innerPropTypes = Component.propTypes;

    	      if (innerPropTypes) {
    	        checkPropTypes(innerPropTypes, nextProps, // Resolved props
    	        'prop', getComponentName(Component));
    	      }
    	    }
    	  }

    	  var render = Component.render;
    	  var ref = workInProgress.ref; // The rest is a fork of updateFunctionComponent

    	  var nextChildren;
    	  prepareToReadContext(workInProgress, renderLanes);

    	  {
    	    ReactCurrentOwner$1.current = workInProgress;
    	    setIsRendering(true);
    	    nextChildren = renderWithHooks(current, workInProgress, render, nextProps, ref, renderLanes);

    	    if ( workInProgress.mode & StrictMode) {
    	      disableLogs();

    	      try {
    	        nextChildren = renderWithHooks(current, workInProgress, render, nextProps, ref, renderLanes);
    	      } finally {
    	        reenableLogs();
    	      }
    	    }

    	    setIsRendering(false);
    	  }

    	  if (current !== null && !didReceiveUpdate) {
    	    bailoutHooks(current, workInProgress, renderLanes);
    	    return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function updateMemoComponent(current, workInProgress, Component, nextProps, updateLanes, renderLanes) {
    	  if (current === null) {
    	    var type = Component.type;

    	    if (isSimpleFunctionComponent(type) && Component.compare === null && // SimpleMemoComponent codepath doesn't resolve outer props either.
    	    Component.defaultProps === undefined) {
    	      var resolvedType = type;

    	      {
    	        resolvedType = resolveFunctionForHotReloading(type);
    	      } // If this is a plain function component without default props,
    	      // and with only the default shallow comparison, we upgrade it
    	      // to a SimpleMemoComponent to allow fast path updates.


    	      workInProgress.tag = SimpleMemoComponent;
    	      workInProgress.type = resolvedType;

    	      {
    	        validateFunctionComponentInDev(workInProgress, type);
    	      }

    	      return updateSimpleMemoComponent(current, workInProgress, resolvedType, nextProps, updateLanes, renderLanes);
    	    }

    	    {
    	      var innerPropTypes = type.propTypes;

    	      if (innerPropTypes) {
    	        // Inner memo component props aren't currently validated in createElement.
    	        // We could move it there, but we'd still need this for lazy code path.
    	        checkPropTypes(innerPropTypes, nextProps, // Resolved props
    	        'prop', getComponentName(type));
    	      }
    	    }

    	    var child = createFiberFromTypeAndProps(Component.type, null, nextProps, workInProgress, workInProgress.mode, renderLanes);
    	    child.ref = workInProgress.ref;
    	    child.return = workInProgress;
    	    workInProgress.child = child;
    	    return child;
    	  }

    	  {
    	    var _type = Component.type;
    	    var _innerPropTypes = _type.propTypes;

    	    if (_innerPropTypes) {
    	      // Inner memo component props aren't currently validated in createElement.
    	      // We could move it there, but we'd still need this for lazy code path.
    	      checkPropTypes(_innerPropTypes, nextProps, // Resolved props
    	      'prop', getComponentName(_type));
    	    }
    	  }

    	  var currentChild = current.child; // This is always exactly one child

    	  if (!includesSomeLane(updateLanes, renderLanes)) {
    	    // This will be the props with resolved defaultProps,
    	    // unlike current.memoizedProps which will be the unresolved ones.
    	    var prevProps = currentChild.memoizedProps; // Default to shallow comparison

    	    var compare = Component.compare;
    	    compare = compare !== null ? compare : shallowEqual;

    	    if (compare(prevProps, nextProps) && current.ref === workInProgress.ref) {
    	      return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	    }
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;
    	  var newChild = createWorkInProgress(currentChild, nextProps);
    	  newChild.ref = workInProgress.ref;
    	  newChild.return = workInProgress;
    	  workInProgress.child = newChild;
    	  return newChild;
    	}

    	function updateSimpleMemoComponent(current, workInProgress, Component, nextProps, updateLanes, renderLanes) {
    	  // TODO: current can be non-null here even if the component
    	  // hasn't yet mounted. This happens when the inner render suspends.
    	  // We'll need to figure out if this is fine or can cause issues.
    	  {
    	    if (workInProgress.type !== workInProgress.elementType) {
    	      // Lazy component props can't be validated in createElement
    	      // because they're only guaranteed to be resolved here.
    	      var outerMemoType = workInProgress.elementType;

    	      if (outerMemoType.$$typeof === REACT_LAZY_TYPE) {
    	        // We warn when you define propTypes on lazy()
    	        // so let's just skip over it to find memo() outer wrapper.
    	        // Inner props for memo are validated later.
    	        var lazyComponent = outerMemoType;
    	        var payload = lazyComponent._payload;
    	        var init = lazyComponent._init;

    	        try {
    	          outerMemoType = init(payload);
    	        } catch (x) {
    	          outerMemoType = null;
    	        } // Inner propTypes will be validated in the function component path.


    	        var outerPropTypes = outerMemoType && outerMemoType.propTypes;

    	        if (outerPropTypes) {
    	          checkPropTypes(outerPropTypes, nextProps, // Resolved (SimpleMemoComponent has no defaultProps)
    	          'prop', getComponentName(outerMemoType));
    	        }
    	      }
    	    }
    	  }

    	  if (current !== null) {
    	    var prevProps = current.memoizedProps;

    	    if (shallowEqual(prevProps, nextProps) && current.ref === workInProgress.ref && ( // Prevent bailout if the implementation changed due to hot reload.
    	     workInProgress.type === current.type )) {
    	      didReceiveUpdate = false;

    	      if (!includesSomeLane(renderLanes, updateLanes)) {
    	        // The pending lanes were cleared at the beginning of beginWork. We're
    	        // about to bail out, but there might be other lanes that weren't
    	        // included in the current render. Usually, the priority level of the
    	        // remaining updates is accumlated during the evaluation of the
    	        // component (i.e. when processing the update queue). But since since
    	        // we're bailing out early *without* evaluating the component, we need
    	        // to account for it here, too. Reset to the value of the current fiber.
    	        // NOTE: This only applies to SimpleMemoComponent, not MemoComponent,
    	        // because a MemoComponent fiber does not have hooks or an update queue;
    	        // rather, it wraps around an inner component, which may or may not
    	        // contains hooks.
    	        // TODO: Move the reset at in beginWork out of the common path so that
    	        // this is no longer necessary.
    	        workInProgress.lanes = current.lanes;
    	        return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	      } else if ((current.flags & ForceUpdateForLegacySuspense) !== NoFlags) {
    	        // This is a special case that only exists for legacy mode.
    	        // See https://github.com/facebook/react/pull/19216.
    	        didReceiveUpdate = true;
    	      }
    	    }
    	  }

    	  return updateFunctionComponent(current, workInProgress, Component, nextProps, renderLanes);
    	}

    	function updateOffscreenComponent(current, workInProgress, renderLanes) {
    	  var nextProps = workInProgress.pendingProps;
    	  var nextChildren = nextProps.children;
    	  var prevState = current !== null ? current.memoizedState : null;

    	  if (nextProps.mode === 'hidden' || nextProps.mode === 'unstable-defer-without-hiding') {
    	    if ((workInProgress.mode & ConcurrentMode) === NoMode) {
    	      // In legacy sync mode, don't defer the subtree. Render it now.
    	      // TODO: Figure out what we should do in Blocking mode.
    	      var nextState = {
    	        baseLanes: NoLanes
    	      };
    	      workInProgress.memoizedState = nextState;
    	      pushRenderLanes(workInProgress, renderLanes);
    	    } else if (!includesSomeLane(renderLanes, OffscreenLane)) {
    	      var nextBaseLanes;

    	      if (prevState !== null) {
    	        var prevBaseLanes = prevState.baseLanes;
    	        nextBaseLanes = mergeLanes(prevBaseLanes, renderLanes);
    	      } else {
    	        nextBaseLanes = renderLanes;
    	      } // Schedule this fiber to re-render at offscreen priority. Then bailout.


    	      {
    	        markSpawnedWork(OffscreenLane);
    	      }

    	      workInProgress.lanes = workInProgress.childLanes = laneToLanes(OffscreenLane);
    	      var _nextState = {
    	        baseLanes: nextBaseLanes
    	      };
    	      workInProgress.memoizedState = _nextState; // We're about to bail out, but we need to push this to the stack anyway
    	      // to avoid a push/pop misalignment.

    	      pushRenderLanes(workInProgress, nextBaseLanes);
    	      return null;
    	    } else {
    	      // Rendering at offscreen, so we can clear the base lanes.
    	      var _nextState2 = {
    	        baseLanes: NoLanes
    	      };
    	      workInProgress.memoizedState = _nextState2; // Push the lanes that were skipped when we bailed out.

    	      var subtreeRenderLanes = prevState !== null ? prevState.baseLanes : renderLanes;
    	      pushRenderLanes(workInProgress, subtreeRenderLanes);
    	    }
    	  } else {
    	    var _subtreeRenderLanes;

    	    if (prevState !== null) {
    	      _subtreeRenderLanes = mergeLanes(prevState.baseLanes, renderLanes); // Since we're not hidden anymore, reset the state

    	      workInProgress.memoizedState = null;
    	    } else {
    	      // We weren't previously hidden, and we still aren't, so there's nothing
    	      // special to do. Need to push to the stack regardless, though, to avoid
    	      // a push/pop misalignment.
    	      _subtreeRenderLanes = renderLanes;
    	    }

    	    pushRenderLanes(workInProgress, _subtreeRenderLanes);
    	  }

    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	} // Note: These happen to have identical begin phases, for now. We shouldn't hold
    	// ourselves to this constraint, though. If the behavior diverges, we should
    	// fork the function.


    	var updateLegacyHiddenComponent = updateOffscreenComponent;

    	function updateFragment(current, workInProgress, renderLanes) {
    	  var nextChildren = workInProgress.pendingProps;
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function updateMode(current, workInProgress, renderLanes) {
    	  var nextChildren = workInProgress.pendingProps.children;
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function updateProfiler(current, workInProgress, renderLanes) {
    	  {
    	    workInProgress.flags |= Update; // Reset effect durations for the next eventual effect phase.
    	    // These are reset during render to allow the DevTools commit hook a chance to read them,

    	    var stateNode = workInProgress.stateNode;
    	    stateNode.effectDuration = 0;
    	    stateNode.passiveEffectDuration = 0;
    	  }

    	  var nextProps = workInProgress.pendingProps;
    	  var nextChildren = nextProps.children;
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function markRef(current, workInProgress) {
    	  var ref = workInProgress.ref;

    	  if (current === null && ref !== null || current !== null && current.ref !== ref) {
    	    // Schedule a Ref effect
    	    workInProgress.flags |= Ref;
    	  }
    	}

    	function updateFunctionComponent(current, workInProgress, Component, nextProps, renderLanes) {
    	  {
    	    if (workInProgress.type !== workInProgress.elementType) {
    	      // Lazy component props can't be validated in createElement
    	      // because they're only guaranteed to be resolved here.
    	      var innerPropTypes = Component.propTypes;

    	      if (innerPropTypes) {
    	        checkPropTypes(innerPropTypes, nextProps, // Resolved props
    	        'prop', getComponentName(Component));
    	      }
    	    }
    	  }

    	  var context;

    	  {
    	    var unmaskedContext = getUnmaskedContext(workInProgress, Component, true);
    	    context = getMaskedContext(workInProgress, unmaskedContext);
    	  }

    	  var nextChildren;
    	  prepareToReadContext(workInProgress, renderLanes);

    	  {
    	    ReactCurrentOwner$1.current = workInProgress;
    	    setIsRendering(true);
    	    nextChildren = renderWithHooks(current, workInProgress, Component, nextProps, context, renderLanes);

    	    if ( workInProgress.mode & StrictMode) {
    	      disableLogs();

    	      try {
    	        nextChildren = renderWithHooks(current, workInProgress, Component, nextProps, context, renderLanes);
    	      } finally {
    	        reenableLogs();
    	      }
    	    }

    	    setIsRendering(false);
    	  }

    	  if (current !== null && !didReceiveUpdate) {
    	    bailoutHooks(current, workInProgress, renderLanes);
    	    return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function updateClassComponent(current, workInProgress, Component, nextProps, renderLanes) {
    	  {
    	    if (workInProgress.type !== workInProgress.elementType) {
    	      // Lazy component props can't be validated in createElement
    	      // because they're only guaranteed to be resolved here.
    	      var innerPropTypes = Component.propTypes;

    	      if (innerPropTypes) {
    	        checkPropTypes(innerPropTypes, nextProps, // Resolved props
    	        'prop', getComponentName(Component));
    	      }
    	    }
    	  } // Push context providers early to prevent context stack mismatches.
    	  // During mounting we don't know the child context yet as the instance doesn't exist.
    	  // We will invalidate the child context in finishClassComponent() right after rendering.


    	  var hasContext;

    	  if (isContextProvider(Component)) {
    	    hasContext = true;
    	    pushContextProvider(workInProgress);
    	  } else {
    	    hasContext = false;
    	  }

    	  prepareToReadContext(workInProgress, renderLanes);
    	  var instance = workInProgress.stateNode;
    	  var shouldUpdate;

    	  if (instance === null) {
    	    if (current !== null) {
    	      // A class component without an instance only mounts if it suspended
    	      // inside a non-concurrent tree, in an inconsistent state. We want to
    	      // treat it like a new mount, even though an empty version of it already
    	      // committed. Disconnect the alternate pointers.
    	      current.alternate = null;
    	      workInProgress.alternate = null; // Since this is conceptually a new fiber, schedule a Placement effect

    	      workInProgress.flags |= Placement;
    	    } // In the initial pass we might need to construct the instance.


    	    constructClassInstance(workInProgress, Component, nextProps);
    	    mountClassInstance(workInProgress, Component, nextProps, renderLanes);
    	    shouldUpdate = true;
    	  } else if (current === null) {
    	    // In a resume, we'll already have an instance we can reuse.
    	    shouldUpdate = resumeMountClassInstance(workInProgress, Component, nextProps, renderLanes);
    	  } else {
    	    shouldUpdate = updateClassInstance(current, workInProgress, Component, nextProps, renderLanes);
    	  }

    	  var nextUnitOfWork = finishClassComponent(current, workInProgress, Component, shouldUpdate, hasContext, renderLanes);

    	  {
    	    var inst = workInProgress.stateNode;

    	    if (shouldUpdate && inst.props !== nextProps) {
    	      if (!didWarnAboutReassigningProps) {
    	        error('It looks like %s is reassigning its own `this.props` while rendering. ' + 'This is not supported and can lead to confusing bugs.', getComponentName(workInProgress.type) || 'a component');
    	      }

    	      didWarnAboutReassigningProps = true;
    	    }
    	  }

    	  return nextUnitOfWork;
    	}

    	function finishClassComponent(current, workInProgress, Component, shouldUpdate, hasContext, renderLanes) {
    	  // Refs should update even if shouldComponentUpdate returns false
    	  markRef(current, workInProgress);
    	  var didCaptureError = (workInProgress.flags & DidCapture) !== NoFlags;

    	  if (!shouldUpdate && !didCaptureError) {
    	    // Context providers should defer to sCU for rendering
    	    if (hasContext) {
    	      invalidateContextProvider(workInProgress, Component, false);
    	    }

    	    return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	  }

    	  var instance = workInProgress.stateNode; // Rerender

    	  ReactCurrentOwner$1.current = workInProgress;
    	  var nextChildren;

    	  if (didCaptureError && typeof Component.getDerivedStateFromError !== 'function') {
    	    // If we captured an error, but getDerivedStateFromError is not defined,
    	    // unmount all the children. componentDidCatch will schedule an update to
    	    // re-render a fallback. This is temporary until we migrate everyone to
    	    // the new API.
    	    // TODO: Warn in a future release.
    	    nextChildren = null;

    	    {
    	      stopProfilerTimerIfRunning();
    	    }
    	  } else {
    	    {
    	      setIsRendering(true);
    	      nextChildren = instance.render();

    	      if ( workInProgress.mode & StrictMode) {
    	        disableLogs();

    	        try {
    	          instance.render();
    	        } finally {
    	          reenableLogs();
    	        }
    	      }

    	      setIsRendering(false);
    	    }
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;

    	  if (current !== null && didCaptureError) {
    	    // If we're recovering from an error, reconcile without reusing any of
    	    // the existing children. Conceptually, the normal children and the children
    	    // that are shown on error are two different sets, so we shouldn't reuse
    	    // normal children even if their identities match.
    	    forceUnmountCurrentAndReconcile(current, workInProgress, nextChildren, renderLanes);
    	  } else {
    	    reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  } // Memoize state using the values we just used to render.
    	  // TODO: Restructure so we never read values from the instance.


    	  workInProgress.memoizedState = instance.state; // The context might have changed so we need to recalculate it.

    	  if (hasContext) {
    	    invalidateContextProvider(workInProgress, Component, true);
    	  }

    	  return workInProgress.child;
    	}

    	function pushHostRootContext(workInProgress) {
    	  var root = workInProgress.stateNode;

    	  if (root.pendingContext) {
    	    pushTopLevelContextObject(workInProgress, root.pendingContext, root.pendingContext !== root.context);
    	  } else if (root.context) {
    	    // Should always be set
    	    pushTopLevelContextObject(workInProgress, root.context, false);
    	  }

    	  pushHostContainer(workInProgress, root.containerInfo);
    	}

    	function updateHostRoot(current, workInProgress, renderLanes) {
    	  pushHostRootContext(workInProgress);
    	  var updateQueue = workInProgress.updateQueue;

    	  if (!(current !== null && updateQueue !== null)) {
    	    {
    	      throw Error( "If the root does not have an updateQueue, we should have already bailed out. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }

    	  var nextProps = workInProgress.pendingProps;
    	  var prevState = workInProgress.memoizedState;
    	  var prevChildren = prevState !== null ? prevState.element : null;
    	  cloneUpdateQueue(current, workInProgress);
    	  processUpdateQueue(workInProgress, nextProps, null, renderLanes);
    	  var nextState = workInProgress.memoizedState; // Caution: React DevTools currently depends on this property
    	  // being called "element".

    	  var nextChildren = nextState.element;

    	  if (nextChildren === prevChildren) {
    	    resetHydrationState();
    	    return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	  }

    	  var root = workInProgress.stateNode;

    	  if (root.hydrate && enterHydrationState(workInProgress)) {
    	    // If we don't have any current children this might be the first pass.
    	    // We always try to hydrate. If this isn't a hydration pass there won't
    	    // be any children to hydrate which is effectively the same thing as
    	    // not hydrating.
    	    {
    	      var mutableSourceEagerHydrationData = root.mutableSourceEagerHydrationData;

    	      if (mutableSourceEagerHydrationData != null) {
    	        for (var i = 0; i < mutableSourceEagerHydrationData.length; i += 2) {
    	          var mutableSource = mutableSourceEagerHydrationData[i];
    	          var version = mutableSourceEagerHydrationData[i + 1];
    	          setWorkInProgressVersion(mutableSource, version);
    	        }
    	      }
    	    }

    	    var child = mountChildFibers(workInProgress, null, nextChildren, renderLanes);
    	    workInProgress.child = child;
    	    var node = child;

    	    while (node) {
    	      // Mark each child as hydrating. This is a fast path to know whether this
    	      // tree is part of a hydrating tree. This is used to determine if a child
    	      // node has fully mounted yet, and for scheduling event replaying.
    	      // Conceptually this is similar to Placement in that a new subtree is
    	      // inserted into the React tree here. It just happens to not need DOM
    	      // mutations because it already exists.
    	      node.flags = node.flags & ~Placement | Hydrating;
    	      node = node.sibling;
    	    }
    	  } else {
    	    // Otherwise reset hydration state in case we aborted and resumed another
    	    // root.
    	    reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	    resetHydrationState();
    	  }

    	  return workInProgress.child;
    	}

    	function updateHostComponent(current, workInProgress, renderLanes) {
    	  pushHostContext(workInProgress);

    	  if (current === null) {
    	    tryToClaimNextHydratableInstance(workInProgress);
    	  }

    	  var type = workInProgress.type;
    	  var nextProps = workInProgress.pendingProps;
    	  var prevProps = current !== null ? current.memoizedProps : null;
    	  var nextChildren = nextProps.children;
    	  var isDirectTextChild = shouldSetTextContent(type, nextProps);

    	  if (isDirectTextChild) {
    	    // We special case a direct text child of a host node. This is a common
    	    // case. We won't handle it as a reified child. We will instead handle
    	    // this in the host environment that also has access to this prop. That
    	    // avoids allocating another HostText fiber and traversing it.
    	    nextChildren = null;
    	  } else if (prevProps !== null && shouldSetTextContent(type, prevProps)) {
    	    // If we're switching from a direct text child to a normal child, or to
    	    // empty, we need to schedule the text content to be reset.
    	    workInProgress.flags |= ContentReset;
    	  }

    	  markRef(current, workInProgress);
    	  reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function updateHostText(current, workInProgress) {
    	  if (current === null) {
    	    tryToClaimNextHydratableInstance(workInProgress);
    	  } // Nothing to do here. This is terminal. We'll do the completion step
    	  // immediately after.


    	  return null;
    	}

    	function mountLazyComponent(_current, workInProgress, elementType, updateLanes, renderLanes) {
    	  if (_current !== null) {
    	    // A lazy component only mounts if it suspended inside a non-
    	    // concurrent tree, in an inconsistent state. We want to treat it like
    	    // a new mount, even though an empty version of it already committed.
    	    // Disconnect the alternate pointers.
    	    _current.alternate = null;
    	    workInProgress.alternate = null; // Since this is conceptually a new fiber, schedule a Placement effect

    	    workInProgress.flags |= Placement;
    	  }

    	  var props = workInProgress.pendingProps;
    	  var lazyComponent = elementType;
    	  var payload = lazyComponent._payload;
    	  var init = lazyComponent._init;
    	  var Component = init(payload); // Store the unwrapped component in the type.

    	  workInProgress.type = Component;
    	  var resolvedTag = workInProgress.tag = resolveLazyComponentTag(Component);
    	  var resolvedProps = resolveDefaultProps(Component, props);
    	  var child;

    	  switch (resolvedTag) {
    	    case FunctionComponent:
    	      {
    	        {
    	          validateFunctionComponentInDev(workInProgress, Component);
    	          workInProgress.type = Component = resolveFunctionForHotReloading(Component);
    	        }

    	        child = updateFunctionComponent(null, workInProgress, Component, resolvedProps, renderLanes);
    	        return child;
    	      }

    	    case ClassComponent:
    	      {
    	        {
    	          workInProgress.type = Component = resolveClassForHotReloading(Component);
    	        }

    	        child = updateClassComponent(null, workInProgress, Component, resolvedProps, renderLanes);
    	        return child;
    	      }

    	    case ForwardRef:
    	      {
    	        {
    	          workInProgress.type = Component = resolveForwardRefForHotReloading(Component);
    	        }

    	        child = updateForwardRef(null, workInProgress, Component, resolvedProps, renderLanes);
    	        return child;
    	      }

    	    case MemoComponent:
    	      {
    	        {
    	          if (workInProgress.type !== workInProgress.elementType) {
    	            var outerPropTypes = Component.propTypes;

    	            if (outerPropTypes) {
    	              checkPropTypes(outerPropTypes, resolvedProps, // Resolved for outer only
    	              'prop', getComponentName(Component));
    	            }
    	          }
    	        }

    	        child = updateMemoComponent(null, workInProgress, Component, resolveDefaultProps(Component.type, resolvedProps), // The inner type can have defaults too
    	        updateLanes, renderLanes);
    	        return child;
    	      }
    	  }

    	  var hint = '';

    	  {
    	    if (Component !== null && typeof Component === 'object' && Component.$$typeof === REACT_LAZY_TYPE) {
    	      hint = ' Did you wrap a component in React.lazy() more than once?';
    	    }
    	  } // This message intentionally doesn't mention ForwardRef or MemoComponent
    	  // because the fact that it's a separate type of work is an
    	  // implementation detail.


    	  {
    	    {
    	      throw Error( "Element type is invalid. Received a promise that resolves to: " + Component + ". Lazy element type must resolve to a class or function." + hint );
    	    }
    	  }
    	}

    	function mountIncompleteClassComponent(_current, workInProgress, Component, nextProps, renderLanes) {
    	  if (_current !== null) {
    	    // An incomplete component only mounts if it suspended inside a non-
    	    // concurrent tree, in an inconsistent state. We want to treat it like
    	    // a new mount, even though an empty version of it already committed.
    	    // Disconnect the alternate pointers.
    	    _current.alternate = null;
    	    workInProgress.alternate = null; // Since this is conceptually a new fiber, schedule a Placement effect

    	    workInProgress.flags |= Placement;
    	  } // Promote the fiber to a class and try rendering again.


    	  workInProgress.tag = ClassComponent; // The rest of this function is a fork of `updateClassComponent`
    	  // Push context providers early to prevent context stack mismatches.
    	  // During mounting we don't know the child context yet as the instance doesn't exist.
    	  // We will invalidate the child context in finishClassComponent() right after rendering.

    	  var hasContext;

    	  if (isContextProvider(Component)) {
    	    hasContext = true;
    	    pushContextProvider(workInProgress);
    	  } else {
    	    hasContext = false;
    	  }

    	  prepareToReadContext(workInProgress, renderLanes);
    	  constructClassInstance(workInProgress, Component, nextProps);
    	  mountClassInstance(workInProgress, Component, nextProps, renderLanes);
    	  return finishClassComponent(null, workInProgress, Component, true, hasContext, renderLanes);
    	}

    	function mountIndeterminateComponent(_current, workInProgress, Component, renderLanes) {
    	  if (_current !== null) {
    	    // An indeterminate component only mounts if it suspended inside a non-
    	    // concurrent tree, in an inconsistent state. We want to treat it like
    	    // a new mount, even though an empty version of it already committed.
    	    // Disconnect the alternate pointers.
    	    _current.alternate = null;
    	    workInProgress.alternate = null; // Since this is conceptually a new fiber, schedule a Placement effect

    	    workInProgress.flags |= Placement;
    	  }

    	  var props = workInProgress.pendingProps;
    	  var context;

    	  {
    	    var unmaskedContext = getUnmaskedContext(workInProgress, Component, false);
    	    context = getMaskedContext(workInProgress, unmaskedContext);
    	  }

    	  prepareToReadContext(workInProgress, renderLanes);
    	  var value;

    	  {
    	    if (Component.prototype && typeof Component.prototype.render === 'function') {
    	      var componentName = getComponentName(Component) || 'Unknown';

    	      if (!didWarnAboutBadClass[componentName]) {
    	        error("The <%s /> component appears to have a render method, but doesn't extend React.Component. " + 'This is likely to cause errors. Change %s to extend React.Component instead.', componentName, componentName);

    	        didWarnAboutBadClass[componentName] = true;
    	      }
    	    }

    	    if (workInProgress.mode & StrictMode) {
    	      ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress, null);
    	    }

    	    setIsRendering(true);
    	    ReactCurrentOwner$1.current = workInProgress;
    	    value = renderWithHooks(null, workInProgress, Component, props, context, renderLanes);
    	    setIsRendering(false);
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;

    	  {
    	    // Support for module components is deprecated and is removed behind a flag.
    	    // Whether or not it would crash later, we want to show a good message in DEV first.
    	    if (typeof value === 'object' && value !== null && typeof value.render === 'function' && value.$$typeof === undefined) {
    	      var _componentName = getComponentName(Component) || 'Unknown';

    	      if (!didWarnAboutModulePatternComponent[_componentName]) {
    	        error('The <%s /> component appears to be a function component that returns a class instance. ' + 'Change %s to a class that extends React.Component instead. ' + "If you can't use a class try assigning the prototype on the function as a workaround. " + "`%s.prototype = React.Component.prototype`. Don't use an arrow function since it " + 'cannot be called with `new` by React.', _componentName, _componentName, _componentName);

    	        didWarnAboutModulePatternComponent[_componentName] = true;
    	      }
    	    }
    	  }

    	  if ( // Run these checks in production only if the flag is off.
    	  // Eventually we'll delete this branch altogether.
    	   typeof value === 'object' && value !== null && typeof value.render === 'function' && value.$$typeof === undefined) {
    	    {
    	      var _componentName2 = getComponentName(Component) || 'Unknown';

    	      if (!didWarnAboutModulePatternComponent[_componentName2]) {
    	        error('The <%s /> component appears to be a function component that returns a class instance. ' + 'Change %s to a class that extends React.Component instead. ' + "If you can't use a class try assigning the prototype on the function as a workaround. " + "`%s.prototype = React.Component.prototype`. Don't use an arrow function since it " + 'cannot be called with `new` by React.', _componentName2, _componentName2, _componentName2);

    	        didWarnAboutModulePatternComponent[_componentName2] = true;
    	      }
    	    } // Proceed under the assumption that this is a class instance


    	    workInProgress.tag = ClassComponent; // Throw out any hooks that were used.

    	    workInProgress.memoizedState = null;
    	    workInProgress.updateQueue = null; // Push context providers early to prevent context stack mismatches.
    	    // During mounting we don't know the child context yet as the instance doesn't exist.
    	    // We will invalidate the child context in finishClassComponent() right after rendering.

    	    var hasContext = false;

    	    if (isContextProvider(Component)) {
    	      hasContext = true;
    	      pushContextProvider(workInProgress);
    	    } else {
    	      hasContext = false;
    	    }

    	    workInProgress.memoizedState = value.state !== null && value.state !== undefined ? value.state : null;
    	    initializeUpdateQueue(workInProgress);
    	    var getDerivedStateFromProps = Component.getDerivedStateFromProps;

    	    if (typeof getDerivedStateFromProps === 'function') {
    	      applyDerivedStateFromProps(workInProgress, Component, getDerivedStateFromProps, props);
    	    }

    	    adoptClassInstance(workInProgress, value);
    	    mountClassInstance(workInProgress, Component, props, renderLanes);
    	    return finishClassComponent(null, workInProgress, Component, true, hasContext, renderLanes);
    	  } else {
    	    // Proceed under the assumption that this is a function component
    	    workInProgress.tag = FunctionComponent;

    	    {

    	      if ( workInProgress.mode & StrictMode) {
    	        disableLogs();

    	        try {
    	          value = renderWithHooks(null, workInProgress, Component, props, context, renderLanes);
    	        } finally {
    	          reenableLogs();
    	        }
    	      }
    	    }

    	    reconcileChildren(null, workInProgress, value, renderLanes);

    	    {
    	      validateFunctionComponentInDev(workInProgress, Component);
    	    }

    	    return workInProgress.child;
    	  }
    	}

    	function validateFunctionComponentInDev(workInProgress, Component) {
    	  {
    	    if (Component) {
    	      if (Component.childContextTypes) {
    	        error('%s(...): childContextTypes cannot be defined on a function component.', Component.displayName || Component.name || 'Component');
    	      }
    	    }

    	    if (workInProgress.ref !== null) {
    	      var info = '';
    	      var ownerName = getCurrentFiberOwnerNameInDevOrNull();

    	      if (ownerName) {
    	        info += '\n\nCheck the render method of `' + ownerName + '`.';
    	      }

    	      var warningKey = ownerName || workInProgress._debugID || '';
    	      var debugSource = workInProgress._debugSource;

    	      if (debugSource) {
    	        warningKey = debugSource.fileName + ':' + debugSource.lineNumber;
    	      }

    	      if (!didWarnAboutFunctionRefs[warningKey]) {
    	        didWarnAboutFunctionRefs[warningKey] = true;

    	        error('Function components cannot be given refs. ' + 'Attempts to access this ref will fail. ' + 'Did you mean to use React.forwardRef()?%s', info);
    	      }
    	    }

    	    if (typeof Component.getDerivedStateFromProps === 'function') {
    	      var _componentName3 = getComponentName(Component) || 'Unknown';

    	      if (!didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3]) {
    	        error('%s: Function components do not support getDerivedStateFromProps.', _componentName3);

    	        didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] = true;
    	      }
    	    }

    	    if (typeof Component.contextType === 'object' && Component.contextType !== null) {
    	      var _componentName4 = getComponentName(Component) || 'Unknown';

    	      if (!didWarnAboutContextTypeOnFunctionComponent[_componentName4]) {
    	        error('%s: Function components do not support contextType.', _componentName4);

    	        didWarnAboutContextTypeOnFunctionComponent[_componentName4] = true;
    	      }
    	    }
    	  }
    	}

    	var SUSPENDED_MARKER = {
    	  dehydrated: null,
    	  retryLane: NoLane
    	};

    	function mountSuspenseOffscreenState(renderLanes) {
    	  return {
    	    baseLanes: renderLanes
    	  };
    	}

    	function updateSuspenseOffscreenState(prevOffscreenState, renderLanes) {
    	  return {
    	    baseLanes: mergeLanes(prevOffscreenState.baseLanes, renderLanes)
    	  };
    	} // TODO: Probably should inline this back


    	function shouldRemainOnFallback(suspenseContext, current, workInProgress, renderLanes) {
    	  // If we're already showing a fallback, there are cases where we need to
    	  // remain on that fallback regardless of whether the content has resolved.
    	  // For example, SuspenseList coordinates when nested content appears.
    	  if (current !== null) {
    	    var suspenseState = current.memoizedState;

    	    if (suspenseState === null) {
    	      // Currently showing content. Don't hide it, even if ForceSuspenseFallack
    	      // is true. More precise name might be "ForceRemainSuspenseFallback".
    	      // Note: This is a factoring smell. Can't remain on a fallback if there's
    	      // no fallback to remain on.
    	      return false;
    	    }
    	  } // Not currently showing content. Consult the Suspense context.


    	  return hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
    	}

    	function getRemainingWorkInPrimaryTree(current, renderLanes) {
    	  // TODO: Should not remove render lanes that were pinged during this render
    	  return removeLanes(current.childLanes, renderLanes);
    	}

    	function updateSuspenseComponent(current, workInProgress, renderLanes) {
    	  var nextProps = workInProgress.pendingProps; // This is used by DevTools to force a boundary to suspend.

    	  {
    	    if (shouldSuspend(workInProgress)) {
    	      workInProgress.flags |= DidCapture;
    	    }
    	  }

    	  var suspenseContext = suspenseStackCursor.current;
    	  var showFallback = false;
    	  var didSuspend = (workInProgress.flags & DidCapture) !== NoFlags;

    	  if (didSuspend || shouldRemainOnFallback(suspenseContext, current)) {
    	    // Something in this boundary's subtree already suspended. Switch to
    	    // rendering the fallback children.
    	    showFallback = true;
    	    workInProgress.flags &= ~DidCapture;
    	  } else {
    	    // Attempting the main content
    	    if (current === null || current.memoizedState !== null) {
    	      // This is a new mount or this boundary is already showing a fallback state.
    	      // Mark this subtree context as having at least one invisible parent that could
    	      // handle the fallback state.
    	      // Boundaries without fallbacks or should be avoided are not considered since
    	      // they cannot handle preferred fallback states.
    	      if (nextProps.fallback !== undefined && nextProps.unstable_avoidThisFallback !== true) {
    	        suspenseContext = addSubtreeSuspenseContext(suspenseContext, InvisibleParentSuspenseContext);
    	      }
    	    }
    	  }

    	  suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
    	  pushSuspenseContext(workInProgress, suspenseContext); // OK, the next part is confusing. We're about to reconcile the Suspense
    	  // boundary's children. This involves some custom reconcilation logic. Two
    	  // main reasons this is so complicated.
    	  //
    	  // First, Legacy Mode has different semantics for backwards compatibility. The
    	  // primary tree will commit in an inconsistent state, so when we do the
    	  // second pass to render the fallback, we do some exceedingly, uh, clever
    	  // hacks to make that not totally break. Like transferring effects and
    	  // deletions from hidden tree. In Concurrent Mode, it's much simpler,
    	  // because we bailout on the primary tree completely and leave it in its old
    	  // state, no effects. Same as what we do for Offscreen (except that
    	  // Offscreen doesn't have the first render pass).
    	  //
    	  // Second is hydration. During hydration, the Suspense fiber has a slightly
    	  // different layout, where the child points to a dehydrated fragment, which
    	  // contains the DOM rendered by the server.
    	  //
    	  // Third, even if you set all that aside, Suspense is like error boundaries in
    	  // that we first we try to render one tree, and if that fails, we render again
    	  // and switch to a different tree. Like a try/catch block. So we have to track
    	  // which branch we're currently rendering. Ideally we would model this using
    	  // a stack.

    	  if (current === null) {
    	    // Initial mount
    	    // If we're currently hydrating, try to hydrate this boundary.
    	    // But only if this has a fallback.
    	    if (nextProps.fallback !== undefined) {
    	      tryToClaimNextHydratableInstance(workInProgress); // This could've been a dehydrated suspense component.
    	    }

    	    var nextPrimaryChildren = nextProps.children;
    	    var nextFallbackChildren = nextProps.fallback;

    	    if (showFallback) {
    	      var fallbackFragment = mountSuspenseFallbackChildren(workInProgress, nextPrimaryChildren, nextFallbackChildren, renderLanes);
    	      var primaryChildFragment = workInProgress.child;
    	      primaryChildFragment.memoizedState = mountSuspenseOffscreenState(renderLanes);
    	      workInProgress.memoizedState = SUSPENDED_MARKER;
    	      return fallbackFragment;
    	    } else if (typeof nextProps.unstable_expectedLoadTime === 'number') {
    	      // This is a CPU-bound tree. Skip this tree and show a placeholder to
    	      // unblock the surrounding content. Then immediately retry after the
    	      // initial commit.
    	      var _fallbackFragment = mountSuspenseFallbackChildren(workInProgress, nextPrimaryChildren, nextFallbackChildren, renderLanes);

    	      var _primaryChildFragment = workInProgress.child;
    	      _primaryChildFragment.memoizedState = mountSuspenseOffscreenState(renderLanes);
    	      workInProgress.memoizedState = SUSPENDED_MARKER; // Since nothing actually suspended, there will nothing to ping this to
    	      // get it started back up to attempt the next item. While in terms of
    	      // priority this work has the same priority as this current render, it's
    	      // not part of the same transition once the transition has committed. If
    	      // it's sync, we still want to yield so that it can be painted.
    	      // Conceptually, this is really the same as pinging. We can use any
    	      // RetryLane even if it's the one currently rendering since we're leaving
    	      // it behind on this node.

    	      workInProgress.lanes = SomeRetryLane;

    	      {
    	        markSpawnedWork(SomeRetryLane);
    	      }

    	      return _fallbackFragment;
    	    } else {
    	      return mountSuspensePrimaryChildren(workInProgress, nextPrimaryChildren, renderLanes);
    	    }
    	  } else {
    	    // This is an update.
    	    // If the current fiber has a SuspenseState, that means it's already showing
    	    // a fallback.
    	    var prevState = current.memoizedState;

    	    if (prevState !== null) {

    	      if (showFallback) {
    	        var _nextFallbackChildren2 = nextProps.fallback;
    	        var _nextPrimaryChildren2 = nextProps.children;

    	        var _fallbackChildFragment = updateSuspenseFallbackChildren(current, workInProgress, _nextPrimaryChildren2, _nextFallbackChildren2, renderLanes);

    	        var _primaryChildFragment3 = workInProgress.child;
    	        var prevOffscreenState = current.child.memoizedState;
    	        _primaryChildFragment3.memoizedState = prevOffscreenState === null ? mountSuspenseOffscreenState(renderLanes) : updateSuspenseOffscreenState(prevOffscreenState, renderLanes);
    	        _primaryChildFragment3.childLanes = getRemainingWorkInPrimaryTree(current, renderLanes);
    	        workInProgress.memoizedState = SUSPENDED_MARKER;
    	        return _fallbackChildFragment;
    	      } else {
    	        var _nextPrimaryChildren3 = nextProps.children;

    	        var _primaryChildFragment4 = updateSuspensePrimaryChildren(current, workInProgress, _nextPrimaryChildren3, renderLanes);

    	        workInProgress.memoizedState = null;
    	        return _primaryChildFragment4;
    	      }
    	    } else {
    	      // The current tree is not already showing a fallback.
    	      if (showFallback) {
    	        // Timed out.
    	        var _nextFallbackChildren3 = nextProps.fallback;
    	        var _nextPrimaryChildren4 = nextProps.children;

    	        var _fallbackChildFragment2 = updateSuspenseFallbackChildren(current, workInProgress, _nextPrimaryChildren4, _nextFallbackChildren3, renderLanes);

    	        var _primaryChildFragment5 = workInProgress.child;
    	        var _prevOffscreenState = current.child.memoizedState;
    	        _primaryChildFragment5.memoizedState = _prevOffscreenState === null ? mountSuspenseOffscreenState(renderLanes) : updateSuspenseOffscreenState(_prevOffscreenState, renderLanes);
    	        _primaryChildFragment5.childLanes = getRemainingWorkInPrimaryTree(current, renderLanes); // Skip the primary children, and continue working on the
    	        // fallback children.

    	        workInProgress.memoizedState = SUSPENDED_MARKER;
    	        return _fallbackChildFragment2;
    	      } else {
    	        // Still haven't timed out. Continue rendering the children, like we
    	        // normally do.
    	        var _nextPrimaryChildren5 = nextProps.children;

    	        var _primaryChildFragment6 = updateSuspensePrimaryChildren(current, workInProgress, _nextPrimaryChildren5, renderLanes);

    	        workInProgress.memoizedState = null;
    	        return _primaryChildFragment6;
    	      }
    	    }
    	  }
    	}

    	function mountSuspensePrimaryChildren(workInProgress, primaryChildren, renderLanes) {
    	  var mode = workInProgress.mode;
    	  var primaryChildProps = {
    	    mode: 'visible',
    	    children: primaryChildren
    	  };
    	  var primaryChildFragment = createFiberFromOffscreen(primaryChildProps, mode, renderLanes, null);
    	  primaryChildFragment.return = workInProgress;
    	  workInProgress.child = primaryChildFragment;
    	  return primaryChildFragment;
    	}

    	function mountSuspenseFallbackChildren(workInProgress, primaryChildren, fallbackChildren, renderLanes) {
    	  var mode = workInProgress.mode;
    	  var progressedPrimaryFragment = workInProgress.child;
    	  var primaryChildProps = {
    	    mode: 'hidden',
    	    children: primaryChildren
    	  };
    	  var primaryChildFragment;
    	  var fallbackChildFragment;

    	  if ((mode & BlockingMode) === NoMode && progressedPrimaryFragment !== null) {
    	    // In legacy mode, we commit the primary tree as if it successfully
    	    // completed, even though it's in an inconsistent state.
    	    primaryChildFragment = progressedPrimaryFragment;
    	    primaryChildFragment.childLanes = NoLanes;
    	    primaryChildFragment.pendingProps = primaryChildProps;

    	    if ( workInProgress.mode & ProfileMode) {
    	      // Reset the durations from the first pass so they aren't included in the
    	      // final amounts. This seems counterintuitive, since we're intentionally
    	      // not measuring part of the render phase, but this makes it match what we
    	      // do in Concurrent Mode.
    	      primaryChildFragment.actualDuration = 0;
    	      primaryChildFragment.actualStartTime = -1;
    	      primaryChildFragment.selfBaseDuration = 0;
    	      primaryChildFragment.treeBaseDuration = 0;
    	    }

    	    fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes, null);
    	  } else {
    	    primaryChildFragment = createFiberFromOffscreen(primaryChildProps, mode, NoLanes, null);
    	    fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes, null);
    	  }

    	  primaryChildFragment.return = workInProgress;
    	  fallbackChildFragment.return = workInProgress;
    	  primaryChildFragment.sibling = fallbackChildFragment;
    	  workInProgress.child = primaryChildFragment;
    	  return fallbackChildFragment;
    	}

    	function createWorkInProgressOffscreenFiber(current, offscreenProps) {
    	  // The props argument to `createWorkInProgress` is `any` typed, so we use this
    	  // wrapper function to constrain it.
    	  return createWorkInProgress(current, offscreenProps);
    	}

    	function updateSuspensePrimaryChildren(current, workInProgress, primaryChildren, renderLanes) {
    	  var currentPrimaryChildFragment = current.child;
    	  var currentFallbackChildFragment = currentPrimaryChildFragment.sibling;
    	  var primaryChildFragment = createWorkInProgressOffscreenFiber(currentPrimaryChildFragment, {
    	    mode: 'visible',
    	    children: primaryChildren
    	  });

    	  if ((workInProgress.mode & BlockingMode) === NoMode) {
    	    primaryChildFragment.lanes = renderLanes;
    	  }

    	  primaryChildFragment.return = workInProgress;
    	  primaryChildFragment.sibling = null;

    	  if (currentFallbackChildFragment !== null) {
    	    // Delete the fallback child fragment
    	    currentFallbackChildFragment.nextEffect = null;
    	    currentFallbackChildFragment.flags = Deletion;
    	    workInProgress.firstEffect = workInProgress.lastEffect = currentFallbackChildFragment;
    	  }

    	  workInProgress.child = primaryChildFragment;
    	  return primaryChildFragment;
    	}

    	function updateSuspenseFallbackChildren(current, workInProgress, primaryChildren, fallbackChildren, renderLanes) {
    	  var mode = workInProgress.mode;
    	  var currentPrimaryChildFragment = current.child;
    	  var currentFallbackChildFragment = currentPrimaryChildFragment.sibling;
    	  var primaryChildProps = {
    	    mode: 'hidden',
    	    children: primaryChildren
    	  };
    	  var primaryChildFragment;

    	  if ( // In legacy mode, we commit the primary tree as if it successfully
    	  // completed, even though it's in an inconsistent state.
    	  (mode & BlockingMode) === NoMode && // Make sure we're on the second pass, i.e. the primary child fragment was
    	  // already cloned. In legacy mode, the only case where this isn't true is
    	  // when DevTools forces us to display a fallback; we skip the first render
    	  // pass entirely and go straight to rendering the fallback. (In Concurrent
    	  // Mode, SuspenseList can also trigger this scenario, but this is a legacy-
    	  // only codepath.)
    	  workInProgress.child !== currentPrimaryChildFragment) {
    	    var progressedPrimaryFragment = workInProgress.child;
    	    primaryChildFragment = progressedPrimaryFragment;
    	    primaryChildFragment.childLanes = NoLanes;
    	    primaryChildFragment.pendingProps = primaryChildProps;

    	    if ( workInProgress.mode & ProfileMode) {
    	      // Reset the durations from the first pass so they aren't included in the
    	      // final amounts. This seems counterintuitive, since we're intentionally
    	      // not measuring part of the render phase, but this makes it match what we
    	      // do in Concurrent Mode.
    	      primaryChildFragment.actualDuration = 0;
    	      primaryChildFragment.actualStartTime = -1;
    	      primaryChildFragment.selfBaseDuration = currentPrimaryChildFragment.selfBaseDuration;
    	      primaryChildFragment.treeBaseDuration = currentPrimaryChildFragment.treeBaseDuration;
    	    } // The fallback fiber was added as a deletion effect during the first pass.
    	    // However, since we're going to remain on the fallback, we no longer want
    	    // to delete it. So we need to remove it from the list. Deletions are stored
    	    // on the same list as effects. We want to keep the effects from the primary
    	    // tree. So we copy the primary child fragment's effect list, which does not
    	    // include the fallback deletion effect.


    	    var progressedLastEffect = primaryChildFragment.lastEffect;

    	    if (progressedLastEffect !== null) {
    	      workInProgress.firstEffect = primaryChildFragment.firstEffect;
    	      workInProgress.lastEffect = progressedLastEffect;
    	      progressedLastEffect.nextEffect = null;
    	    } else {
    	      // TODO: Reset this somewhere else? Lol legacy mode is so weird.
    	      workInProgress.firstEffect = workInProgress.lastEffect = null;
    	    }
    	  } else {
    	    primaryChildFragment = createWorkInProgressOffscreenFiber(currentPrimaryChildFragment, primaryChildProps);
    	  }

    	  var fallbackChildFragment;

    	  if (currentFallbackChildFragment !== null) {
    	    fallbackChildFragment = createWorkInProgress(currentFallbackChildFragment, fallbackChildren);
    	  } else {
    	    fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes, null); // Needs a placement effect because the parent (the Suspense boundary) already
    	    // mounted but this is a new fiber.

    	    fallbackChildFragment.flags |= Placement;
    	  }

    	  fallbackChildFragment.return = workInProgress;
    	  primaryChildFragment.return = workInProgress;
    	  primaryChildFragment.sibling = fallbackChildFragment;
    	  workInProgress.child = primaryChildFragment;
    	  return fallbackChildFragment;
    	}

    	function scheduleWorkOnFiber(fiber, renderLanes) {
    	  fiber.lanes = mergeLanes(fiber.lanes, renderLanes);
    	  var alternate = fiber.alternate;

    	  if (alternate !== null) {
    	    alternate.lanes = mergeLanes(alternate.lanes, renderLanes);
    	  }

    	  scheduleWorkOnParentPath(fiber.return, renderLanes);
    	}

    	function propagateSuspenseContextChange(workInProgress, firstChild, renderLanes) {
    	  // Mark any Suspense boundaries with fallbacks as having work to do.
    	  // If they were previously forced into fallbacks, they may now be able
    	  // to unblock.
    	  var node = firstChild;

    	  while (node !== null) {
    	    if (node.tag === SuspenseComponent) {
    	      var state = node.memoizedState;

    	      if (state !== null) {
    	        scheduleWorkOnFiber(node, renderLanes);
    	      }
    	    } else if (node.tag === SuspenseListComponent) {
    	      // If the tail is hidden there might not be an Suspense boundaries
    	      // to schedule work on. In this case we have to schedule it on the
    	      // list itself.
    	      // We don't have to traverse to the children of the list since
    	      // the list will propagate the change when it rerenders.
    	      scheduleWorkOnFiber(node, renderLanes);
    	    } else if (node.child !== null) {
    	      node.child.return = node;
    	      node = node.child;
    	      continue;
    	    }

    	    if (node === workInProgress) {
    	      return;
    	    }

    	    while (node.sibling === null) {
    	      if (node.return === null || node.return === workInProgress) {
    	        return;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  }
    	}

    	function findLastContentRow(firstChild) {
    	  // This is going to find the last row among these children that is already
    	  // showing content on the screen, as opposed to being in fallback state or
    	  // new. If a row has multiple Suspense boundaries, any of them being in the
    	  // fallback state, counts as the whole row being in a fallback state.
    	  // Note that the "rows" will be workInProgress, but any nested children
    	  // will still be current since we haven't rendered them yet. The mounted
    	  // order may not be the same as the new order. We use the new order.
    	  var row = firstChild;
    	  var lastContentRow = null;

    	  while (row !== null) {
    	    var currentRow = row.alternate; // New rows can't be content rows.

    	    if (currentRow !== null && findFirstSuspended(currentRow) === null) {
    	      lastContentRow = row;
    	    }

    	    row = row.sibling;
    	  }

    	  return lastContentRow;
    	}

    	function validateRevealOrder(revealOrder) {
    	  {
    	    if (revealOrder !== undefined && revealOrder !== 'forwards' && revealOrder !== 'backwards' && revealOrder !== 'together' && !didWarnAboutRevealOrder[revealOrder]) {
    	      didWarnAboutRevealOrder[revealOrder] = true;

    	      if (typeof revealOrder === 'string') {
    	        switch (revealOrder.toLowerCase()) {
    	          case 'together':
    	          case 'forwards':
    	          case 'backwards':
    	            {
    	              error('"%s" is not a valid value for revealOrder on <SuspenseList />. ' + 'Use lowercase "%s" instead.', revealOrder, revealOrder.toLowerCase());

    	              break;
    	            }

    	          case 'forward':
    	          case 'backward':
    	            {
    	              error('"%s" is not a valid value for revealOrder on <SuspenseList />. ' + 'React uses the -s suffix in the spelling. Use "%ss" instead.', revealOrder, revealOrder.toLowerCase());

    	              break;
    	            }

    	          default:
    	            error('"%s" is not a supported revealOrder on <SuspenseList />. ' + 'Did you mean "together", "forwards" or "backwards"?', revealOrder);

    	            break;
    	        }
    	      } else {
    	        error('%s is not a supported value for revealOrder on <SuspenseList />. ' + 'Did you mean "together", "forwards" or "backwards"?', revealOrder);
    	      }
    	    }
    	  }
    	}

    	function validateTailOptions(tailMode, revealOrder) {
    	  {
    	    if (tailMode !== undefined && !didWarnAboutTailOptions[tailMode]) {
    	      if (tailMode !== 'collapsed' && tailMode !== 'hidden') {
    	        didWarnAboutTailOptions[tailMode] = true;

    	        error('"%s" is not a supported value for tail on <SuspenseList />. ' + 'Did you mean "collapsed" or "hidden"?', tailMode);
    	      } else if (revealOrder !== 'forwards' && revealOrder !== 'backwards') {
    	        didWarnAboutTailOptions[tailMode] = true;

    	        error('<SuspenseList tail="%s" /> is only valid if revealOrder is ' + '"forwards" or "backwards". ' + 'Did you mean to specify revealOrder="forwards"?', tailMode);
    	      }
    	    }
    	  }
    	}

    	function validateSuspenseListNestedChild(childSlot, index) {
    	  {
    	    var isArray = Array.isArray(childSlot);
    	    var isIterable = !isArray && typeof getIteratorFn(childSlot) === 'function';

    	    if (isArray || isIterable) {
    	      var type = isArray ? 'array' : 'iterable';

    	      error('A nested %s was passed to row #%s in <SuspenseList />. Wrap it in ' + 'an additional SuspenseList to configure its revealOrder: ' + '<SuspenseList revealOrder=...> ... ' + '<SuspenseList revealOrder=...>{%s}</SuspenseList> ... ' + '</SuspenseList>', type, index, type);

    	      return false;
    	    }
    	  }

    	  return true;
    	}

    	function validateSuspenseListChildren(children, revealOrder) {
    	  {
    	    if ((revealOrder === 'forwards' || revealOrder === 'backwards') && children !== undefined && children !== null && children !== false) {
    	      if (Array.isArray(children)) {
    	        for (var i = 0; i < children.length; i++) {
    	          if (!validateSuspenseListNestedChild(children[i], i)) {
    	            return;
    	          }
    	        }
    	      } else {
    	        var iteratorFn = getIteratorFn(children);

    	        if (typeof iteratorFn === 'function') {
    	          var childrenIterator = iteratorFn.call(children);

    	          if (childrenIterator) {
    	            var step = childrenIterator.next();
    	            var _i = 0;

    	            for (; !step.done; step = childrenIterator.next()) {
    	              if (!validateSuspenseListNestedChild(step.value, _i)) {
    	                return;
    	              }

    	              _i++;
    	            }
    	          }
    	        } else {
    	          error('A single row was passed to a <SuspenseList revealOrder="%s" />. ' + 'This is not useful since it needs multiple rows. ' + 'Did you mean to pass multiple children or an array?', revealOrder);
    	        }
    	      }
    	    }
    	  }
    	}

    	function initSuspenseListRenderState(workInProgress, isBackwards, tail, lastContentRow, tailMode, lastEffectBeforeRendering) {
    	  var renderState = workInProgress.memoizedState;

    	  if (renderState === null) {
    	    workInProgress.memoizedState = {
    	      isBackwards: isBackwards,
    	      rendering: null,
    	      renderingStartTime: 0,
    	      last: lastContentRow,
    	      tail: tail,
    	      tailMode: tailMode,
    	      lastEffect: lastEffectBeforeRendering
    	    };
    	  } else {
    	    // We can reuse the existing object from previous renders.
    	    renderState.isBackwards = isBackwards;
    	    renderState.rendering = null;
    	    renderState.renderingStartTime = 0;
    	    renderState.last = lastContentRow;
    	    renderState.tail = tail;
    	    renderState.tailMode = tailMode;
    	    renderState.lastEffect = lastEffectBeforeRendering;
    	  }
    	} // This can end up rendering this component multiple passes.
    	// The first pass splits the children fibers into two sets. A head and tail.
    	// We first render the head. If anything is in fallback state, we do another
    	// pass through beginWork to rerender all children (including the tail) with
    	// the force suspend context. If the first render didn't have anything in
    	// in fallback state. Then we render each row in the tail one-by-one.
    	// That happens in the completeWork phase without going back to beginWork.


    	function updateSuspenseListComponent(current, workInProgress, renderLanes) {
    	  var nextProps = workInProgress.pendingProps;
    	  var revealOrder = nextProps.revealOrder;
    	  var tailMode = nextProps.tail;
    	  var newChildren = nextProps.children;
    	  validateRevealOrder(revealOrder);
    	  validateTailOptions(tailMode, revealOrder);
    	  validateSuspenseListChildren(newChildren, revealOrder);
    	  reconcileChildren(current, workInProgress, newChildren, renderLanes);
    	  var suspenseContext = suspenseStackCursor.current;
    	  var shouldForceFallback = hasSuspenseContext(suspenseContext, ForceSuspenseFallback);

    	  if (shouldForceFallback) {
    	    suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
    	    workInProgress.flags |= DidCapture;
    	  } else {
    	    var didSuspendBefore = current !== null && (current.flags & DidCapture) !== NoFlags;

    	    if (didSuspendBefore) {
    	      // If we previously forced a fallback, we need to schedule work
    	      // on any nested boundaries to let them know to try to render
    	      // again. This is the same as context updating.
    	      propagateSuspenseContextChange(workInProgress, workInProgress.child, renderLanes);
    	    }

    	    suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
    	  }

    	  pushSuspenseContext(workInProgress, suspenseContext);

    	  if ((workInProgress.mode & BlockingMode) === NoMode) {
    	    // In legacy mode, SuspenseList doesn't work so we just
    	    // use make it a noop by treating it as the default revealOrder.
    	    workInProgress.memoizedState = null;
    	  } else {
    	    switch (revealOrder) {
    	      case 'forwards':
    	        {
    	          var lastContentRow = findLastContentRow(workInProgress.child);
    	          var tail;

    	          if (lastContentRow === null) {
    	            // The whole list is part of the tail.
    	            // TODO: We could fast path by just rendering the tail now.
    	            tail = workInProgress.child;
    	            workInProgress.child = null;
    	          } else {
    	            // Disconnect the tail rows after the content row.
    	            // We're going to render them separately later.
    	            tail = lastContentRow.sibling;
    	            lastContentRow.sibling = null;
    	          }

    	          initSuspenseListRenderState(workInProgress, false, // isBackwards
    	          tail, lastContentRow, tailMode, workInProgress.lastEffect);
    	          break;
    	        }

    	      case 'backwards':
    	        {
    	          // We're going to find the first row that has existing content.
    	          // At the same time we're going to reverse the list of everything
    	          // we pass in the meantime. That's going to be our tail in reverse
    	          // order.
    	          var _tail = null;
    	          var row = workInProgress.child;
    	          workInProgress.child = null;

    	          while (row !== null) {
    	            var currentRow = row.alternate; // New rows can't be content rows.

    	            if (currentRow !== null && findFirstSuspended(currentRow) === null) {
    	              // This is the beginning of the main content.
    	              workInProgress.child = row;
    	              break;
    	            }

    	            var nextRow = row.sibling;
    	            row.sibling = _tail;
    	            _tail = row;
    	            row = nextRow;
    	          } // TODO: If workInProgress.child is null, we can continue on the tail immediately.


    	          initSuspenseListRenderState(workInProgress, true, // isBackwards
    	          _tail, null, // last
    	          tailMode, workInProgress.lastEffect);
    	          break;
    	        }

    	      case 'together':
    	        {
    	          initSuspenseListRenderState(workInProgress, false, // isBackwards
    	          null, // tail
    	          null, // last
    	          undefined, workInProgress.lastEffect);
    	          break;
    	        }

    	      default:
    	        {
    	          // The default reveal order is the same as not having
    	          // a boundary.
    	          workInProgress.memoizedState = null;
    	        }
    	    }
    	  }

    	  return workInProgress.child;
    	}

    	function updatePortalComponent(current, workInProgress, renderLanes) {
    	  pushHostContainer(workInProgress, workInProgress.stateNode.containerInfo);
    	  var nextChildren = workInProgress.pendingProps;

    	  if (current === null) {
    	    // Portals are special because we don't append the children during mount
    	    // but at commit. Therefore we need to track insertions which the normal
    	    // flow doesn't do during mount. This doesn't happen at the root because
    	    // the root always starts with a "current" with a null child.
    	    // TODO: Consider unifying this with how the root works.
    	    workInProgress.child = reconcileChildFibers(workInProgress, null, nextChildren, renderLanes);
    	  } else {
    	    reconcileChildren(current, workInProgress, nextChildren, renderLanes);
    	  }

    	  return workInProgress.child;
    	}

    	var hasWarnedAboutUsingNoValuePropOnContextProvider = false;

    	function updateContextProvider(current, workInProgress, renderLanes) {
    	  var providerType = workInProgress.type;
    	  var context = providerType._context;
    	  var newProps = workInProgress.pendingProps;
    	  var oldProps = workInProgress.memoizedProps;
    	  var newValue = newProps.value;

    	  {
    	    if (!('value' in newProps)) {
    	      if (!hasWarnedAboutUsingNoValuePropOnContextProvider) {
    	        hasWarnedAboutUsingNoValuePropOnContextProvider = true;

    	        error('The `value` prop is required for the `<Context.Provider>`. Did you misspell it or forget to pass it?');
    	      }
    	    }

    	    var providerPropTypes = workInProgress.type.propTypes;

    	    if (providerPropTypes) {
    	      checkPropTypes(providerPropTypes, newProps, 'prop', 'Context.Provider');
    	    }
    	  }

    	  pushProvider(workInProgress, newValue);

    	  if (oldProps !== null) {
    	    var oldValue = oldProps.value;
    	    var changedBits = calculateChangedBits(context, newValue, oldValue);

    	    if (changedBits === 0) {
    	      // No change. Bailout early if children are the same.
    	      if (oldProps.children === newProps.children && !hasContextChanged()) {
    	        return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	      }
    	    } else {
    	      // The context value changed. Search for matching consumers and schedule
    	      // them to update.
    	      propagateContextChange(workInProgress, context, changedBits, renderLanes);
    	    }
    	  }

    	  var newChildren = newProps.children;
    	  reconcileChildren(current, workInProgress, newChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	var hasWarnedAboutUsingContextAsConsumer = false;

    	function updateContextConsumer(current, workInProgress, renderLanes) {
    	  var context = workInProgress.type; // The logic below for Context differs depending on PROD or DEV mode. In
    	  // DEV mode, we create a separate object for Context.Consumer that acts
    	  // like a proxy to Context. This proxy object adds unnecessary code in PROD
    	  // so we use the old behaviour (Context.Consumer references Context) to
    	  // reduce size and overhead. The separate object references context via
    	  // a property called "_context", which also gives us the ability to check
    	  // in DEV mode if this property exists or not and warn if it does not.

    	  {
    	    if (context._context === undefined) {
    	      // This may be because it's a Context (rather than a Consumer).
    	      // Or it may be because it's older React where they're the same thing.
    	      // We only want to warn if we're sure it's a new React.
    	      if (context !== context.Consumer) {
    	        if (!hasWarnedAboutUsingContextAsConsumer) {
    	          hasWarnedAboutUsingContextAsConsumer = true;

    	          error('Rendering <Context> directly is not supported and will be removed in ' + 'a future major release. Did you mean to render <Context.Consumer> instead?');
    	        }
    	      }
    	    } else {
    	      context = context._context;
    	    }
    	  }

    	  var newProps = workInProgress.pendingProps;
    	  var render = newProps.children;

    	  {
    	    if (typeof render !== 'function') {
    	      error('A context consumer was rendered with multiple children, or a child ' + "that isn't a function. A context consumer expects a single child " + 'that is a function. If you did pass a function, make sure there ' + 'is no trailing or leading whitespace around it.');
    	    }
    	  }

    	  prepareToReadContext(workInProgress, renderLanes);
    	  var newValue = readContext(context, newProps.unstable_observedBits);
    	  var newChildren;

    	  {
    	    ReactCurrentOwner$1.current = workInProgress;
    	    setIsRendering(true);
    	    newChildren = render(newValue);
    	    setIsRendering(false);
    	  } // React DevTools reads this flag.


    	  workInProgress.flags |= PerformedWork;
    	  reconcileChildren(current, workInProgress, newChildren, renderLanes);
    	  return workInProgress.child;
    	}

    	function markWorkInProgressReceivedUpdate() {
    	  didReceiveUpdate = true;
    	}

    	function bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes) {
    	  if (current !== null) {
    	    // Reuse previous dependencies
    	    workInProgress.dependencies = current.dependencies;
    	  }

    	  {
    	    // Don't update "base" render times for bailouts.
    	    stopProfilerTimerIfRunning();
    	  }

    	  markSkippedUpdateLanes(workInProgress.lanes); // Check if the children have any pending work.

    	  if (!includesSomeLane(renderLanes, workInProgress.childLanes)) {
    	    // The children don't have any work either. We can skip them.
    	    // TODO: Once we add back resuming, we should check if the children are
    	    // a work-in-progress set. If so, we need to transfer their effects.
    	    return null;
    	  } else {
    	    // This fiber doesn't have work, but its subtree does. Clone the child
    	    // fibers and continue.
    	    cloneChildFibers(current, workInProgress);
    	    return workInProgress.child;
    	  }
    	}

    	function remountFiber(current, oldWorkInProgress, newWorkInProgress) {
    	  {
    	    var returnFiber = oldWorkInProgress.return;

    	    if (returnFiber === null) {
    	      throw new Error('Cannot swap the root fiber.');
    	    } // Disconnect from the old current.
    	    // It will get deleted.


    	    current.alternate = null;
    	    oldWorkInProgress.alternate = null; // Connect to the new tree.

    	    newWorkInProgress.index = oldWorkInProgress.index;
    	    newWorkInProgress.sibling = oldWorkInProgress.sibling;
    	    newWorkInProgress.return = oldWorkInProgress.return;
    	    newWorkInProgress.ref = oldWorkInProgress.ref; // Replace the child/sibling pointers above it.

    	    if (oldWorkInProgress === returnFiber.child) {
    	      returnFiber.child = newWorkInProgress;
    	    } else {
    	      var prevSibling = returnFiber.child;

    	      if (prevSibling === null) {
    	        throw new Error('Expected parent to have a child.');
    	      }

    	      while (prevSibling.sibling !== oldWorkInProgress) {
    	        prevSibling = prevSibling.sibling;

    	        if (prevSibling === null) {
    	          throw new Error('Expected to find the previous sibling.');
    	        }
    	      }

    	      prevSibling.sibling = newWorkInProgress;
    	    } // Delete the old fiber and place the new one.
    	    // Since the old fiber is disconnected, we have to schedule it manually.


    	    var last = returnFiber.lastEffect;

    	    if (last !== null) {
    	      last.nextEffect = current;
    	      returnFiber.lastEffect = current;
    	    } else {
    	      returnFiber.firstEffect = returnFiber.lastEffect = current;
    	    }

    	    current.nextEffect = null;
    	    current.flags = Deletion;
    	    newWorkInProgress.flags |= Placement; // Restart work from the new fiber.

    	    return newWorkInProgress;
    	  }
    	}

    	function beginWork(current, workInProgress, renderLanes) {
    	  var updateLanes = workInProgress.lanes;

    	  {
    	    if (workInProgress._debugNeedsRemount && current !== null) {
    	      // This will restart the begin phase with a new fiber.
    	      return remountFiber(current, workInProgress, createFiberFromTypeAndProps(workInProgress.type, workInProgress.key, workInProgress.pendingProps, workInProgress._debugOwner || null, workInProgress.mode, workInProgress.lanes));
    	    }
    	  }

    	  if (current !== null) {
    	    var oldProps = current.memoizedProps;
    	    var newProps = workInProgress.pendingProps;

    	    if (oldProps !== newProps || hasContextChanged() || ( // Force a re-render if the implementation changed due to hot reload:
    	     workInProgress.type !== current.type )) {
    	      // If props or context changed, mark the fiber as having performed work.
    	      // This may be unset if the props are determined to be equal later (memo).
    	      didReceiveUpdate = true;
    	    } else if (!includesSomeLane(renderLanes, updateLanes)) {
    	      didReceiveUpdate = false; // This fiber does not have any pending work. Bailout without entering
    	      // the begin phase. There's still some bookkeeping we that needs to be done
    	      // in this optimized path, mostly pushing stuff onto the stack.

    	      switch (workInProgress.tag) {
    	        case HostRoot:
    	          pushHostRootContext(workInProgress);
    	          resetHydrationState();
    	          break;

    	        case HostComponent:
    	          pushHostContext(workInProgress);
    	          break;

    	        case ClassComponent:
    	          {
    	            var Component = workInProgress.type;

    	            if (isContextProvider(Component)) {
    	              pushContextProvider(workInProgress);
    	            }

    	            break;
    	          }

    	        case HostPortal:
    	          pushHostContainer(workInProgress, workInProgress.stateNode.containerInfo);
    	          break;

    	        case ContextProvider:
    	          {
    	            var newValue = workInProgress.memoizedProps.value;
    	            pushProvider(workInProgress, newValue);
    	            break;
    	          }

    	        case Profiler:
    	          {
    	            // Profiler should only call onRender when one of its descendants actually rendered.
    	            var hasChildWork = includesSomeLane(renderLanes, workInProgress.childLanes);

    	            if (hasChildWork) {
    	              workInProgress.flags |= Update;
    	            } // Reset effect durations for the next eventual effect phase.
    	            // These are reset during render to allow the DevTools commit hook a chance to read them,


    	            var stateNode = workInProgress.stateNode;
    	            stateNode.effectDuration = 0;
    	            stateNode.passiveEffectDuration = 0;
    	          }

    	          break;

    	        case SuspenseComponent:
    	          {
    	            var state = workInProgress.memoizedState;

    	            if (state !== null) {
    	              // whether to retry the primary children, or to skip over it and
    	              // go straight to the fallback. Check the priority of the primary
    	              // child fragment.


    	              var primaryChildFragment = workInProgress.child;
    	              var primaryChildLanes = primaryChildFragment.childLanes;

    	              if (includesSomeLane(renderLanes, primaryChildLanes)) {
    	                // The primary children have pending work. Use the normal path
    	                // to attempt to render the primary children again.
    	                return updateSuspenseComponent(current, workInProgress, renderLanes);
    	              } else {
    	                // The primary child fragment does not have pending work marked
    	                // on it
    	                pushSuspenseContext(workInProgress, setDefaultShallowSuspenseContext(suspenseStackCursor.current)); // The primary children do not have pending work with sufficient
    	                // priority. Bailout.

    	                var child = bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);

    	                if (child !== null) {
    	                  // The fallback children have pending work. Skip over the
    	                  // primary children and work on the fallback.
    	                  return child.sibling;
    	                } else {
    	                  return null;
    	                }
    	              }
    	            } else {
    	              pushSuspenseContext(workInProgress, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
    	            }

    	            break;
    	          }

    	        case SuspenseListComponent:
    	          {
    	            var didSuspendBefore = (current.flags & DidCapture) !== NoFlags;

    	            var _hasChildWork = includesSomeLane(renderLanes, workInProgress.childLanes);

    	            if (didSuspendBefore) {
    	              if (_hasChildWork) {
    	                // If something was in fallback state last time, and we have all the
    	                // same children then we're still in progressive loading state.
    	                // Something might get unblocked by state updates or retries in the
    	                // tree which will affect the tail. So we need to use the normal
    	                // path to compute the correct tail.
    	                return updateSuspenseListComponent(current, workInProgress, renderLanes);
    	              } // If none of the children had any work, that means that none of
    	              // them got retried so they'll still be blocked in the same way
    	              // as before. We can fast bail out.


    	              workInProgress.flags |= DidCapture;
    	            } // If nothing suspended before and we're rendering the same children,
    	            // then the tail doesn't matter. Anything new that suspends will work
    	            // in the "together" mode, so we can continue from the state we had.


    	            var renderState = workInProgress.memoizedState;

    	            if (renderState !== null) {
    	              // Reset to the "together" mode in case we've started a different
    	              // update in the past but didn't complete it.
    	              renderState.rendering = null;
    	              renderState.tail = null;
    	              renderState.lastEffect = null;
    	            }

    	            pushSuspenseContext(workInProgress, suspenseStackCursor.current);

    	            if (_hasChildWork) {
    	              break;
    	            } else {
    	              // If none of the children had any work, that means that none of
    	              // them got retried so they'll still be blocked in the same way
    	              // as before. We can fast bail out.
    	              return null;
    	            }
    	          }

    	        case OffscreenComponent:
    	        case LegacyHiddenComponent:
    	          {
    	            // Need to check if the tree still needs to be deferred. This is
    	            // almost identical to the logic used in the normal update path,
    	            // so we'll just enter that. The only difference is we'll bail out
    	            // at the next level instead of this one, because the child props
    	            // have not changed. Which is fine.
    	            // TODO: Probably should refactor `beginWork` to split the bailout
    	            // path from the normal path. I'm tempted to do a labeled break here
    	            // but I won't :)
    	            workInProgress.lanes = NoLanes;
    	            return updateOffscreenComponent(current, workInProgress, renderLanes);
    	          }
    	      }

    	      return bailoutOnAlreadyFinishedWork(current, workInProgress, renderLanes);
    	    } else {
    	      if ((current.flags & ForceUpdateForLegacySuspense) !== NoFlags) {
    	        // This is a special case that only exists for legacy mode.
    	        // See https://github.com/facebook/react/pull/19216.
    	        didReceiveUpdate = true;
    	      } else {
    	        // An update was scheduled on this fiber, but there are no new props
    	        // nor legacy context. Set this to false. If an update queue or context
    	        // consumer produces a changed value, it will set this to true. Otherwise,
    	        // the component will assume the children have not changed and bail out.
    	        didReceiveUpdate = false;
    	      }
    	    }
    	  } else {
    	    didReceiveUpdate = false;
    	  } // Before entering the begin phase, clear pending update priority.
    	  // TODO: This assumes that we're about to evaluate the component and process
    	  // the update queue. However, there's an exception: SimpleMemoComponent
    	  // sometimes bails out later in the begin phase. This indicates that we should
    	  // move this assignment out of the common path and into each branch.


    	  workInProgress.lanes = NoLanes;

    	  switch (workInProgress.tag) {
    	    case IndeterminateComponent:
    	      {
    	        return mountIndeterminateComponent(current, workInProgress, workInProgress.type, renderLanes);
    	      }

    	    case LazyComponent:
    	      {
    	        var elementType = workInProgress.elementType;
    	        return mountLazyComponent(current, workInProgress, elementType, updateLanes, renderLanes);
    	      }

    	    case FunctionComponent:
    	      {
    	        var _Component = workInProgress.type;
    	        var unresolvedProps = workInProgress.pendingProps;
    	        var resolvedProps = workInProgress.elementType === _Component ? unresolvedProps : resolveDefaultProps(_Component, unresolvedProps);
    	        return updateFunctionComponent(current, workInProgress, _Component, resolvedProps, renderLanes);
    	      }

    	    case ClassComponent:
    	      {
    	        var _Component2 = workInProgress.type;
    	        var _unresolvedProps = workInProgress.pendingProps;

    	        var _resolvedProps = workInProgress.elementType === _Component2 ? _unresolvedProps : resolveDefaultProps(_Component2, _unresolvedProps);

    	        return updateClassComponent(current, workInProgress, _Component2, _resolvedProps, renderLanes);
    	      }

    	    case HostRoot:
    	      return updateHostRoot(current, workInProgress, renderLanes);

    	    case HostComponent:
    	      return updateHostComponent(current, workInProgress, renderLanes);

    	    case HostText:
    	      return updateHostText(current, workInProgress);

    	    case SuspenseComponent:
    	      return updateSuspenseComponent(current, workInProgress, renderLanes);

    	    case HostPortal:
    	      return updatePortalComponent(current, workInProgress, renderLanes);

    	    case ForwardRef:
    	      {
    	        var type = workInProgress.type;
    	        var _unresolvedProps2 = workInProgress.pendingProps;

    	        var _resolvedProps2 = workInProgress.elementType === type ? _unresolvedProps2 : resolveDefaultProps(type, _unresolvedProps2);

    	        return updateForwardRef(current, workInProgress, type, _resolvedProps2, renderLanes);
    	      }

    	    case Fragment:
    	      return updateFragment(current, workInProgress, renderLanes);

    	    case Mode:
    	      return updateMode(current, workInProgress, renderLanes);

    	    case Profiler:
    	      return updateProfiler(current, workInProgress, renderLanes);

    	    case ContextProvider:
    	      return updateContextProvider(current, workInProgress, renderLanes);

    	    case ContextConsumer:
    	      return updateContextConsumer(current, workInProgress, renderLanes);

    	    case MemoComponent:
    	      {
    	        var _type2 = workInProgress.type;
    	        var _unresolvedProps3 = workInProgress.pendingProps; // Resolve outer props first, then resolve inner props.

    	        var _resolvedProps3 = resolveDefaultProps(_type2, _unresolvedProps3);

    	        {
    	          if (workInProgress.type !== workInProgress.elementType) {
    	            var outerPropTypes = _type2.propTypes;

    	            if (outerPropTypes) {
    	              checkPropTypes(outerPropTypes, _resolvedProps3, // Resolved for outer only
    	              'prop', getComponentName(_type2));
    	            }
    	          }
    	        }

    	        _resolvedProps3 = resolveDefaultProps(_type2.type, _resolvedProps3);
    	        return updateMemoComponent(current, workInProgress, _type2, _resolvedProps3, updateLanes, renderLanes);
    	      }

    	    case SimpleMemoComponent:
    	      {
    	        return updateSimpleMemoComponent(current, workInProgress, workInProgress.type, workInProgress.pendingProps, updateLanes, renderLanes);
    	      }

    	    case IncompleteClassComponent:
    	      {
    	        var _Component3 = workInProgress.type;
    	        var _unresolvedProps4 = workInProgress.pendingProps;

    	        var _resolvedProps4 = workInProgress.elementType === _Component3 ? _unresolvedProps4 : resolveDefaultProps(_Component3, _unresolvedProps4);

    	        return mountIncompleteClassComponent(current, workInProgress, _Component3, _resolvedProps4, renderLanes);
    	      }

    	    case SuspenseListComponent:
    	      {
    	        return updateSuspenseListComponent(current, workInProgress, renderLanes);
    	      }

    	    case FundamentalComponent:
    	      {

    	        break;
    	      }

    	    case ScopeComponent:
    	      {

    	        break;
    	      }

    	    case Block:
    	      {

    	        break;
    	      }

    	    case OffscreenComponent:
    	      {
    	        return updateOffscreenComponent(current, workInProgress, renderLanes);
    	      }

    	    case LegacyHiddenComponent:
    	      {
    	        return updateLegacyHiddenComponent(current, workInProgress, renderLanes);
    	      }
    	  }

    	  {
    	    {
    	      throw Error( "Unknown unit of work tag (" + workInProgress.tag + "). This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function markUpdate(workInProgress) {
    	  // Tag the fiber with an update effect. This turns a Placement into
    	  // a PlacementAndUpdate.
    	  workInProgress.flags |= Update;
    	}

    	function markRef$1(workInProgress) {
    	  workInProgress.flags |= Ref;
    	}

    	var appendAllChildren;
    	var updateHostContainer;
    	var updateHostComponent$1;
    	var updateHostText$1;

    	{
    	  // Mutation mode
    	  appendAllChildren = function (parent, workInProgress, needsVisibilityToggle, isHidden) {
    	    // We only have the top Fiber that was created but we need recurse down its
    	    // children to find all the terminal nodes.
    	    var node = workInProgress.child;

    	    while (node !== null) {
    	      if (node.tag === HostComponent || node.tag === HostText) {
    	        appendInitialChild(parent, node.stateNode);
    	      } else if (node.tag === HostPortal) ; else if (node.child !== null) {
    	        node.child.return = node;
    	        node = node.child;
    	        continue;
    	      }

    	      if (node === workInProgress) {
    	        return;
    	      }

    	      while (node.sibling === null) {
    	        if (node.return === null || node.return === workInProgress) {
    	          return;
    	        }

    	        node = node.return;
    	      }

    	      node.sibling.return = node.return;
    	      node = node.sibling;
    	    }
    	  };

    	  updateHostContainer = function (workInProgress) {// Noop
    	  };

    	  updateHostComponent$1 = function (current, workInProgress, type, newProps, rootContainerInstance) {
    	    // If we have an alternate, that means this is an update and we need to
    	    // schedule a side-effect to do the updates.
    	    var oldProps = current.memoizedProps;

    	    if (oldProps === newProps) {
    	      // In mutation mode, this is sufficient for a bailout because
    	      // we won't touch this node even if children changed.
    	      return;
    	    } // If we get updated because one of our children updated, we don't
    	    // have newProps so we'll have to reuse them.
    	    // TODO: Split the update API as separate for the props vs. children.
    	    // Even better would be if children weren't special cased at all tho.


    	    var instance = workInProgress.stateNode;
    	    var currentHostContext = getHostContext(); // TODO: Experiencing an error where oldProps is null. Suggests a host
    	    // component is hitting the resume path. Figure out why. Possibly
    	    // related to `hidden`.

    	    var updatePayload = prepareUpdate(instance, type, oldProps, newProps, rootContainerInstance, currentHostContext); // TODO: Type this specific to this type of component.

    	    workInProgress.updateQueue = updatePayload; // If the update payload indicates that there is a change or if there
    	    // is a new ref we mark this as an update. All the work is done in commitWork.

    	    if (updatePayload) {
    	      markUpdate(workInProgress);
    	    }
    	  };

    	  updateHostText$1 = function (current, workInProgress, oldText, newText) {
    	    // If the text differs, mark it as an update. All the work in done in commitWork.
    	    if (oldText !== newText) {
    	      markUpdate(workInProgress);
    	    }
    	  };
    	}

    	function cutOffTailIfNeeded(renderState, hasRenderedATailFallback) {
    	  if (getIsHydrating()) {
    	    // If we're hydrating, we should consume as many items as we can
    	    // so we don't leave any behind.
    	    return;
    	  }

    	  switch (renderState.tailMode) {
    	    case 'hidden':
    	      {
    	        // Any insertions at the end of the tail list after this point
    	        // should be invisible. If there are already mounted boundaries
    	        // anything before them are not considered for collapsing.
    	        // Therefore we need to go through the whole tail to find if
    	        // there are any.
    	        var tailNode = renderState.tail;
    	        var lastTailNode = null;

    	        while (tailNode !== null) {
    	          if (tailNode.alternate !== null) {
    	            lastTailNode = tailNode;
    	          }

    	          tailNode = tailNode.sibling;
    	        } // Next we're simply going to delete all insertions after the
    	        // last rendered item.


    	        if (lastTailNode === null) {
    	          // All remaining items in the tail are insertions.
    	          renderState.tail = null;
    	        } else {
    	          // Detach the insertion after the last node that was already
    	          // inserted.
    	          lastTailNode.sibling = null;
    	        }

    	        break;
    	      }

    	    case 'collapsed':
    	      {
    	        // Any insertions at the end of the tail list after this point
    	        // should be invisible. If there are already mounted boundaries
    	        // anything before them are not considered for collapsing.
    	        // Therefore we need to go through the whole tail to find if
    	        // there are any.
    	        var _tailNode = renderState.tail;
    	        var _lastTailNode = null;

    	        while (_tailNode !== null) {
    	          if (_tailNode.alternate !== null) {
    	            _lastTailNode = _tailNode;
    	          }

    	          _tailNode = _tailNode.sibling;
    	        } // Next we're simply going to delete all insertions after the
    	        // last rendered item.


    	        if (_lastTailNode === null) {
    	          // All remaining items in the tail are insertions.
    	          if (!hasRenderedATailFallback && renderState.tail !== null) {
    	            // We suspended during the head. We want to show at least one
    	            // row at the tail. So we'll keep on and cut off the rest.
    	            renderState.tail.sibling = null;
    	          } else {
    	            renderState.tail = null;
    	          }
    	        } else {
    	          // Detach the insertion after the last node that was already
    	          // inserted.
    	          _lastTailNode.sibling = null;
    	        }

    	        break;
    	      }
    	  }
    	}

    	function completeWork(current, workInProgress, renderLanes) {
    	  var newProps = workInProgress.pendingProps;

    	  switch (workInProgress.tag) {
    	    case IndeterminateComponent:
    	    case LazyComponent:
    	    case SimpleMemoComponent:
    	    case FunctionComponent:
    	    case ForwardRef:
    	    case Fragment:
    	    case Mode:
    	    case Profiler:
    	    case ContextConsumer:
    	    case MemoComponent:
    	      return null;

    	    case ClassComponent:
    	      {
    	        var Component = workInProgress.type;

    	        if (isContextProvider(Component)) {
    	          popContext(workInProgress);
    	        }

    	        return null;
    	      }

    	    case HostRoot:
    	      {
    	        popHostContainer(workInProgress);
    	        popTopLevelContextObject(workInProgress);
    	        resetWorkInProgressVersions();
    	        var fiberRoot = workInProgress.stateNode;

    	        if (fiberRoot.pendingContext) {
    	          fiberRoot.context = fiberRoot.pendingContext;
    	          fiberRoot.pendingContext = null;
    	        }

    	        if (current === null || current.child === null) {
    	          // If we hydrated, pop so that we can delete any remaining children
    	          // that weren't hydrated.
    	          var wasHydrated = popHydrationState(workInProgress);

    	          if (wasHydrated) {
    	            // If we hydrated, then we'll need to schedule an update for
    	            // the commit side-effects on the root.
    	            markUpdate(workInProgress);
    	          } else if (!fiberRoot.hydrate) {
    	            // Schedule an effect to clear this container at the start of the next commit.
    	            // This handles the case of React rendering into a container with previous children.
    	            // It's also safe to do for updates too, because current.child would only be null
    	            // if the previous render was null (so the the container would already be empty).
    	            workInProgress.flags |= Snapshot;
    	          }
    	        }

    	        updateHostContainer(workInProgress);
    	        return null;
    	      }

    	    case HostComponent:
    	      {
    	        popHostContext(workInProgress);
    	        var rootContainerInstance = getRootHostContainer();
    	        var type = workInProgress.type;

    	        if (current !== null && workInProgress.stateNode != null) {
    	          updateHostComponent$1(current, workInProgress, type, newProps, rootContainerInstance);

    	          if (current.ref !== workInProgress.ref) {
    	            markRef$1(workInProgress);
    	          }
    	        } else {
    	          if (!newProps) {
    	            if (!(workInProgress.stateNode !== null)) {
    	              {
    	                throw Error( "We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue." );
    	              }
    	            } // This can happen when we abort work.


    	            return null;
    	          }

    	          var currentHostContext = getHostContext(); // TODO: Move createInstance to beginWork and keep it on a context
    	          // "stack" as the parent. Then append children as we go in beginWork
    	          // or completeWork depending on whether we want to add them top->down or
    	          // bottom->up. Top->down is faster in IE11.

    	          var _wasHydrated = popHydrationState(workInProgress);

    	          if (_wasHydrated) {
    	            // TODO: Move this and createInstance step into the beginPhase
    	            // to consolidate.
    	            if (prepareToHydrateHostInstance(workInProgress, rootContainerInstance, currentHostContext)) {
    	              // If changes to the hydrated node need to be applied at the
    	              // commit-phase we mark this as such.
    	              markUpdate(workInProgress);
    	            }
    	          } else {
    	            var instance = createInstance(type, newProps, rootContainerInstance, currentHostContext, workInProgress);
    	            appendAllChildren(instance, workInProgress, false, false);
    	            workInProgress.stateNode = instance; // Certain renderers require commit-time effects for initial mount.
    	            // (eg DOM renderer supports auto-focus for certain elements).
    	            // Make sure such renderers get scheduled for later work.

    	            if (finalizeInitialChildren(instance, type, newProps, rootContainerInstance)) {
    	              markUpdate(workInProgress);
    	            }
    	          }

    	          if (workInProgress.ref !== null) {
    	            // If there is a ref on a host node we need to schedule a callback
    	            markRef$1(workInProgress);
    	          }
    	        }

    	        return null;
    	      }

    	    case HostText:
    	      {
    	        var newText = newProps;

    	        if (current && workInProgress.stateNode != null) {
    	          var oldText = current.memoizedProps; // If we have an alternate, that means this is an update and we need
    	          // to schedule a side-effect to do the updates.

    	          updateHostText$1(current, workInProgress, oldText, newText);
    	        } else {
    	          if (typeof newText !== 'string') {
    	            if (!(workInProgress.stateNode !== null)) {
    	              {
    	                throw Error( "We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue." );
    	              }
    	            } // This can happen when we abort work.

    	          }

    	          var _rootContainerInstance = getRootHostContainer();

    	          var _currentHostContext = getHostContext();

    	          var _wasHydrated2 = popHydrationState(workInProgress);

    	          if (_wasHydrated2) {
    	            if (prepareToHydrateHostTextInstance(workInProgress)) {
    	              markUpdate(workInProgress);
    	            }
    	          } else {
    	            workInProgress.stateNode = createTextInstance(newText, _rootContainerInstance, _currentHostContext, workInProgress);
    	          }
    	        }

    	        return null;
    	      }

    	    case SuspenseComponent:
    	      {
    	        popSuspenseContext(workInProgress);
    	        var nextState = workInProgress.memoizedState;

    	        if ((workInProgress.flags & DidCapture) !== NoFlags) {
    	          // Something suspended. Re-render with the fallback children.
    	          workInProgress.lanes = renderLanes; // Do not reset the effect list.

    	          if ( (workInProgress.mode & ProfileMode) !== NoMode) {
    	            transferActualDuration(workInProgress);
    	          }

    	          return workInProgress;
    	        }

    	        var nextDidTimeout = nextState !== null;
    	        var prevDidTimeout = false;

    	        if (current === null) {
    	          if (workInProgress.memoizedProps.fallback !== undefined) {
    	            popHydrationState(workInProgress);
    	          }
    	        } else {
    	          var prevState = current.memoizedState;
    	          prevDidTimeout = prevState !== null;
    	        }

    	        if (nextDidTimeout && !prevDidTimeout) {
    	          // If this subtreee is running in blocking mode we can suspend,
    	          // otherwise we won't suspend.
    	          // TODO: This will still suspend a synchronous tree if anything
    	          // in the concurrent tree already suspended during this render.
    	          // This is a known bug.
    	          if ((workInProgress.mode & BlockingMode) !== NoMode) {
    	            // TODO: Move this back to throwException because this is too late
    	            // if this is a large tree which is common for initial loads. We
    	            // don't know if we should restart a render or not until we get
    	            // this marker, and this is too late.
    	            // If this render already had a ping or lower pri updates,
    	            // and this is the first time we know we're going to suspend we
    	            // should be able to immediately restart from within throwException.
    	            var hasInvisibleChildContext = current === null && workInProgress.memoizedProps.unstable_avoidThisFallback !== true;

    	            if (hasInvisibleChildContext || hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext)) {
    	              // If this was in an invisible tree or a new render, then showing
    	              // this boundary is ok.
    	              renderDidSuspend();
    	            } else {
    	              // Otherwise, we're going to have to hide content so we should
    	              // suspend for longer if possible.
    	              renderDidSuspendDelayIfPossible();
    	            }
    	          }
    	        }

    	        {
    	          // TODO: Only schedule updates if these values are non equal, i.e. it changed.
    	          if (nextDidTimeout || prevDidTimeout) {
    	            // If this boundary just timed out, schedule an effect to attach a
    	            // retry listener to the promise. This flag is also used to hide the
    	            // primary children. In mutation mode, we also need the flag to
    	            // *unhide* children that were previously hidden, so check if this
    	            // is currently timed out, too.
    	            workInProgress.flags |= Update;
    	          }
    	        }

    	        return null;
    	      }

    	    case HostPortal:
    	      popHostContainer(workInProgress);
    	      updateHostContainer(workInProgress);

    	      if (current === null) {
    	        preparePortalMount(workInProgress.stateNode.containerInfo);
    	      }

    	      return null;

    	    case ContextProvider:
    	      // Pop provider fiber
    	      popProvider(workInProgress);
    	      return null;

    	    case IncompleteClassComponent:
    	      {
    	        // Same as class component case. I put it down here so that the tags are
    	        // sequential to ensure this switch is compiled to a jump table.
    	        var _Component = workInProgress.type;

    	        if (isContextProvider(_Component)) {
    	          popContext(workInProgress);
    	        }

    	        return null;
    	      }

    	    case SuspenseListComponent:
    	      {
    	        popSuspenseContext(workInProgress);
    	        var renderState = workInProgress.memoizedState;

    	        if (renderState === null) {
    	          // We're running in the default, "independent" mode.
    	          // We don't do anything in this mode.
    	          return null;
    	        }

    	        var didSuspendAlready = (workInProgress.flags & DidCapture) !== NoFlags;
    	        var renderedTail = renderState.rendering;

    	        if (renderedTail === null) {
    	          // We just rendered the head.
    	          if (!didSuspendAlready) {
    	            // This is the first pass. We need to figure out if anything is still
    	            // suspended in the rendered set.
    	            // If new content unsuspended, but there's still some content that
    	            // didn't. Then we need to do a second pass that forces everything
    	            // to keep showing their fallbacks.
    	            // We might be suspended if something in this render pass suspended, or
    	            // something in the previous committed pass suspended. Otherwise,
    	            // there's no chance so we can skip the expensive call to
    	            // findFirstSuspended.
    	            var cannotBeSuspended = renderHasNotSuspendedYet() && (current === null || (current.flags & DidCapture) === NoFlags);

    	            if (!cannotBeSuspended) {
    	              var row = workInProgress.child;

    	              while (row !== null) {
    	                var suspended = findFirstSuspended(row);

    	                if (suspended !== null) {
    	                  didSuspendAlready = true;
    	                  workInProgress.flags |= DidCapture;
    	                  cutOffTailIfNeeded(renderState, false); // If this is a newly suspended tree, it might not get committed as
    	                  // part of the second pass. In that case nothing will subscribe to
    	                  // its thennables. Instead, we'll transfer its thennables to the
    	                  // SuspenseList so that it can retry if they resolve.
    	                  // There might be multiple of these in the list but since we're
    	                  // going to wait for all of them anyway, it doesn't really matter
    	                  // which ones gets to ping. In theory we could get clever and keep
    	                  // track of how many dependencies remain but it gets tricky because
    	                  // in the meantime, we can add/remove/change items and dependencies.
    	                  // We might bail out of the loop before finding any but that
    	                  // doesn't matter since that means that the other boundaries that
    	                  // we did find already has their listeners attached.

    	                  var newThennables = suspended.updateQueue;

    	                  if (newThennables !== null) {
    	                    workInProgress.updateQueue = newThennables;
    	                    workInProgress.flags |= Update;
    	                  } // Rerender the whole list, but this time, we'll force fallbacks
    	                  // to stay in place.
    	                  // Reset the effect list before doing the second pass since that's now invalid.


    	                  if (renderState.lastEffect === null) {
    	                    workInProgress.firstEffect = null;
    	                  }

    	                  workInProgress.lastEffect = renderState.lastEffect; // Reset the child fibers to their original state.

    	                  resetChildFibers(workInProgress, renderLanes); // Set up the Suspense Context to force suspense and immediately
    	                  // rerender the children.

    	                  pushSuspenseContext(workInProgress, setShallowSuspenseContext(suspenseStackCursor.current, ForceSuspenseFallback));
    	                  return workInProgress.child;
    	                }

    	                row = row.sibling;
    	              }
    	            }

    	            if (renderState.tail !== null && now() > getRenderTargetTime()) {
    	              // We have already passed our CPU deadline but we still have rows
    	              // left in the tail. We'll just give up further attempts to render
    	              // the main content and only render fallbacks.
    	              workInProgress.flags |= DidCapture;
    	              didSuspendAlready = true;
    	              cutOffTailIfNeeded(renderState, false); // Since nothing actually suspended, there will nothing to ping this
    	              // to get it started back up to attempt the next item. While in terms
    	              // of priority this work has the same priority as this current render,
    	              // it's not part of the same transition once the transition has
    	              // committed. If it's sync, we still want to yield so that it can be
    	              // painted. Conceptually, this is really the same as pinging.
    	              // We can use any RetryLane even if it's the one currently rendering
    	              // since we're leaving it behind on this node.

    	              workInProgress.lanes = SomeRetryLane;

    	              {
    	                markSpawnedWork(SomeRetryLane);
    	              }
    	            }
    	          } else {
    	            cutOffTailIfNeeded(renderState, false);
    	          } // Next we're going to render the tail.

    	        } else {
    	          // Append the rendered row to the child list.
    	          if (!didSuspendAlready) {
    	            var _suspended = findFirstSuspended(renderedTail);

    	            if (_suspended !== null) {
    	              workInProgress.flags |= DidCapture;
    	              didSuspendAlready = true; // Ensure we transfer the update queue to the parent so that it doesn't
    	              // get lost if this row ends up dropped during a second pass.

    	              var _newThennables = _suspended.updateQueue;

    	              if (_newThennables !== null) {
    	                workInProgress.updateQueue = _newThennables;
    	                workInProgress.flags |= Update;
    	              }

    	              cutOffTailIfNeeded(renderState, true); // This might have been modified.

    	              if (renderState.tail === null && renderState.tailMode === 'hidden' && !renderedTail.alternate && !getIsHydrating() // We don't cut it if we're hydrating.
    	              ) {
    	                  // We need to delete the row we just rendered.
    	                  // Reset the effect list to what it was before we rendered this
    	                  // child. The nested children have already appended themselves.
    	                  var lastEffect = workInProgress.lastEffect = renderState.lastEffect; // Remove any effects that were appended after this point.

    	                  if (lastEffect !== null) {
    	                    lastEffect.nextEffect = null;
    	                  } // We're done.


    	                  return null;
    	                }
    	            } else if ( // The time it took to render last row is greater than the remaining
    	            // time we have to render. So rendering one more row would likely
    	            // exceed it.
    	            now() * 2 - renderState.renderingStartTime > getRenderTargetTime() && renderLanes !== OffscreenLane) {
    	              // We have now passed our CPU deadline and we'll just give up further
    	              // attempts to render the main content and only render fallbacks.
    	              // The assumption is that this is usually faster.
    	              workInProgress.flags |= DidCapture;
    	              didSuspendAlready = true;
    	              cutOffTailIfNeeded(renderState, false); // Since nothing actually suspended, there will nothing to ping this
    	              // to get it started back up to attempt the next item. While in terms
    	              // of priority this work has the same priority as this current render,
    	              // it's not part of the same transition once the transition has
    	              // committed. If it's sync, we still want to yield so that it can be
    	              // painted. Conceptually, this is really the same as pinging.
    	              // We can use any RetryLane even if it's the one currently rendering
    	              // since we're leaving it behind on this node.

    	              workInProgress.lanes = SomeRetryLane;

    	              {
    	                markSpawnedWork(SomeRetryLane);
    	              }
    	            }
    	          }

    	          if (renderState.isBackwards) {
    	            // The effect list of the backwards tail will have been added
    	            // to the end. This breaks the guarantee that life-cycles fire in
    	            // sibling order but that isn't a strong guarantee promised by React.
    	            // Especially since these might also just pop in during future commits.
    	            // Append to the beginning of the list.
    	            renderedTail.sibling = workInProgress.child;
    	            workInProgress.child = renderedTail;
    	          } else {
    	            var previousSibling = renderState.last;

    	            if (previousSibling !== null) {
    	              previousSibling.sibling = renderedTail;
    	            } else {
    	              workInProgress.child = renderedTail;
    	            }

    	            renderState.last = renderedTail;
    	          }
    	        }

    	        if (renderState.tail !== null) {
    	          // We still have tail rows to render.
    	          // Pop a row.
    	          var next = renderState.tail;
    	          renderState.rendering = next;
    	          renderState.tail = next.sibling;
    	          renderState.lastEffect = workInProgress.lastEffect;
    	          renderState.renderingStartTime = now();
    	          next.sibling = null; // Restore the context.
    	          // TODO: We can probably just avoid popping it instead and only
    	          // setting it the first time we go from not suspended to suspended.

    	          var suspenseContext = suspenseStackCursor.current;

    	          if (didSuspendAlready) {
    	            suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
    	          } else {
    	            suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
    	          }

    	          pushSuspenseContext(workInProgress, suspenseContext); // Do a pass over the next row.

    	          return next;
    	        }

    	        return null;
    	      }

    	    case FundamentalComponent:
    	      {

    	        break;
    	      }

    	    case ScopeComponent:
    	      {

    	        break;
    	      }

    	    case Block:

    	      break;

    	    case OffscreenComponent:
    	    case LegacyHiddenComponent:
    	      {
    	        popRenderLanes(workInProgress);

    	        if (current !== null) {
    	          var _nextState = workInProgress.memoizedState;
    	          var _prevState = current.memoizedState;
    	          var prevIsHidden = _prevState !== null;
    	          var nextIsHidden = _nextState !== null;

    	          if (prevIsHidden !== nextIsHidden && newProps.mode !== 'unstable-defer-without-hiding') {
    	            workInProgress.flags |= Update;
    	          }
    	        }

    	        return null;
    	      }
    	  }

    	  {
    	    {
    	      throw Error( "Unknown unit of work tag (" + workInProgress.tag + "). This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function unwindWork(workInProgress, renderLanes) {
    	  switch (workInProgress.tag) {
    	    case ClassComponent:
    	      {
    	        var Component = workInProgress.type;

    	        if (isContextProvider(Component)) {
    	          popContext(workInProgress);
    	        }

    	        var flags = workInProgress.flags;

    	        if (flags & ShouldCapture) {
    	          workInProgress.flags = flags & ~ShouldCapture | DidCapture;

    	          if ( (workInProgress.mode & ProfileMode) !== NoMode) {
    	            transferActualDuration(workInProgress);
    	          }

    	          return workInProgress;
    	        }

    	        return null;
    	      }

    	    case HostRoot:
    	      {
    	        popHostContainer(workInProgress);
    	        popTopLevelContextObject(workInProgress);
    	        resetWorkInProgressVersions();
    	        var _flags = workInProgress.flags;

    	        if (!((_flags & DidCapture) === NoFlags)) {
    	          {
    	            throw Error( "The root failed to unmount after an error. This is likely a bug in React. Please file an issue." );
    	          }
    	        }

    	        workInProgress.flags = _flags & ~ShouldCapture | DidCapture;
    	        return workInProgress;
    	      }

    	    case HostComponent:
    	      {
    	        // TODO: popHydrationState
    	        popHostContext(workInProgress);
    	        return null;
    	      }

    	    case SuspenseComponent:
    	      {
    	        popSuspenseContext(workInProgress);

    	        var _flags2 = workInProgress.flags;

    	        if (_flags2 & ShouldCapture) {
    	          workInProgress.flags = _flags2 & ~ShouldCapture | DidCapture; // Captured a suspense effect. Re-render the boundary.

    	          if ( (workInProgress.mode & ProfileMode) !== NoMode) {
    	            transferActualDuration(workInProgress);
    	          }

    	          return workInProgress;
    	        }

    	        return null;
    	      }

    	    case SuspenseListComponent:
    	      {
    	        popSuspenseContext(workInProgress); // SuspenseList doesn't actually catch anything. It should've been
    	        // caught by a nested boundary. If not, it should bubble through.

    	        return null;
    	      }

    	    case HostPortal:
    	      popHostContainer(workInProgress);
    	      return null;

    	    case ContextProvider:
    	      popProvider(workInProgress);
    	      return null;

    	    case OffscreenComponent:
    	    case LegacyHiddenComponent:
    	      popRenderLanes(workInProgress);
    	      return null;

    	    default:
    	      return null;
    	  }
    	}

    	function unwindInterruptedWork(interruptedWork) {
    	  switch (interruptedWork.tag) {
    	    case ClassComponent:
    	      {
    	        var childContextTypes = interruptedWork.type.childContextTypes;

    	        if (childContextTypes !== null && childContextTypes !== undefined) {
    	          popContext(interruptedWork);
    	        }

    	        break;
    	      }

    	    case HostRoot:
    	      {
    	        popHostContainer(interruptedWork);
    	        popTopLevelContextObject(interruptedWork);
    	        resetWorkInProgressVersions();
    	        break;
    	      }

    	    case HostComponent:
    	      {
    	        popHostContext(interruptedWork);
    	        break;
    	      }

    	    case HostPortal:
    	      popHostContainer(interruptedWork);
    	      break;

    	    case SuspenseComponent:
    	      popSuspenseContext(interruptedWork);
    	      break;

    	    case SuspenseListComponent:
    	      popSuspenseContext(interruptedWork);
    	      break;

    	    case ContextProvider:
    	      popProvider(interruptedWork);
    	      break;

    	    case OffscreenComponent:
    	    case LegacyHiddenComponent:
    	      popRenderLanes(interruptedWork);
    	      break;
    	  }
    	}

    	function createCapturedValue(value, source) {
    	  // If the value is an error, call this function immediately after it is thrown
    	  // so the stack is accurate.
    	  return {
    	    value: value,
    	    source: source,
    	    stack: getStackByFiberInDevAndProd(source)
    	  };
    	}

    	// This module is forked in different environments.
    	// By default, return `true` to log errors to the console.
    	// Forks can return `false` if this isn't desirable.
    	function showErrorDialog(boundary, errorInfo) {
    	  return true;
    	}

    	function logCapturedError(boundary, errorInfo) {
    	  try {
    	    var logError = showErrorDialog(boundary, errorInfo); // Allow injected showErrorDialog() to prevent default console.error logging.
    	    // This enables renderers like ReactNative to better manage redbox behavior.

    	    if (logError === false) {
    	      return;
    	    }

    	    var error = errorInfo.value;

    	    if (true) {
    	      var source = errorInfo.source;
    	      var stack = errorInfo.stack;
    	      var componentStack = stack !== null ? stack : ''; // Browsers support silencing uncaught errors by calling
    	      // `preventDefault()` in window `error` handler.
    	      // We record this information as an expando on the error.

    	      if (error != null && error._suppressLogging) {
    	        if (boundary.tag === ClassComponent) {
    	          // The error is recoverable and was silenced.
    	          // Ignore it and don't print the stack addendum.
    	          // This is handy for testing error boundaries without noise.
    	          return;
    	        } // The error is fatal. Since the silencing might have
    	        // been accidental, we'll surface it anyway.
    	        // However, the browser would have silenced the original error
    	        // so we'll print it first, and then print the stack addendum.


    	        console['error'](error); // Don't transform to our wrapper
    	        // For a more detailed description of this block, see:
    	        // https://github.com/facebook/react/pull/13384
    	      }

    	      var componentName = source ? getComponentName(source.type) : null;
    	      var componentNameMessage = componentName ? "The above error occurred in the <" + componentName + "> component:" : 'The above error occurred in one of your React components:';
    	      var errorBoundaryMessage;
    	      var errorBoundaryName = getComponentName(boundary.type);

    	      if (errorBoundaryName) {
    	        errorBoundaryMessage = "React will try to recreate this component tree from scratch " + ("using the error boundary you provided, " + errorBoundaryName + ".");
    	      } else {
    	        errorBoundaryMessage = 'Consider adding an error boundary to your tree to customize error handling behavior.\n' + 'Visit https://reactjs.org/link/error-boundaries to learn more about error boundaries.';
    	      }

    	      var combinedMessage = componentNameMessage + "\n" + componentStack + "\n\n" + ("" + errorBoundaryMessage); // In development, we provide our own message with just the component stack.
    	      // We don't include the original error message and JS stack because the browser
    	      // has already printed it. Even if the application swallows the error, it is still
    	      // displayed by the browser thanks to the DEV-only fake event trick in ReactErrorUtils.

    	      console['error'](combinedMessage); // Don't transform to our wrapper
    	    }
    	  } catch (e) {
    	    // This method must not throw, or React internal state will get messed up.
    	    // If console.error is overridden, or logCapturedError() shows a dialog that throws,
    	    // we want to report this error outside of the normal stack as a last resort.
    	    // https://github.com/facebook/react/issues/13188
    	    setTimeout(function () {
    	      throw e;
    	    });
    	  }
    	}

    	var PossiblyWeakMap$1 = typeof WeakMap === 'function' ? WeakMap : Map;

    	function createRootErrorUpdate(fiber, errorInfo, lane) {
    	  var update = createUpdate(NoTimestamp, lane); // Unmount the root by rendering null.

    	  update.tag = CaptureUpdate; // Caution: React DevTools currently depends on this property
    	  // being called "element".

    	  update.payload = {
    	    element: null
    	  };
    	  var error = errorInfo.value;

    	  update.callback = function () {
    	    onUncaughtError(error);
    	    logCapturedError(fiber, errorInfo);
    	  };

    	  return update;
    	}

    	function createClassErrorUpdate(fiber, errorInfo, lane) {
    	  var update = createUpdate(NoTimestamp, lane);
    	  update.tag = CaptureUpdate;
    	  var getDerivedStateFromError = fiber.type.getDerivedStateFromError;

    	  if (typeof getDerivedStateFromError === 'function') {
    	    var error$1 = errorInfo.value;

    	    update.payload = function () {
    	      logCapturedError(fiber, errorInfo);
    	      return getDerivedStateFromError(error$1);
    	    };
    	  }

    	  var inst = fiber.stateNode;

    	  if (inst !== null && typeof inst.componentDidCatch === 'function') {
    	    update.callback = function callback() {
    	      {
    	        markFailedErrorBoundaryForHotReloading(fiber);
    	      }

    	      if (typeof getDerivedStateFromError !== 'function') {
    	        // To preserve the preexisting retry behavior of error boundaries,
    	        // we keep track of which ones already failed during this batch.
    	        // This gets reset before we yield back to the browser.
    	        // TODO: Warn in strict mode if getDerivedStateFromError is
    	        // not defined.
    	        markLegacyErrorBoundaryAsFailed(this); // Only log here if componentDidCatch is the only error boundary method defined

    	        logCapturedError(fiber, errorInfo);
    	      }

    	      var error$1 = errorInfo.value;
    	      var stack = errorInfo.stack;
    	      this.componentDidCatch(error$1, {
    	        componentStack: stack !== null ? stack : ''
    	      });

    	      {
    	        if (typeof getDerivedStateFromError !== 'function') {
    	          // If componentDidCatch is the only error boundary method defined,
    	          // then it needs to call setState to recover from errors.
    	          // If no state update is scheduled then the boundary will swallow the error.
    	          if (!includesSomeLane(fiber.lanes, SyncLane)) {
    	            error('%s: Error boundaries should implement getDerivedStateFromError(). ' + 'In that method, return a state update to display an error message or fallback UI.', getComponentName(fiber.type) || 'Unknown');
    	          }
    	        }
    	      }
    	    };
    	  } else {
    	    update.callback = function () {
    	      markFailedErrorBoundaryForHotReloading(fiber);
    	    };
    	  }

    	  return update;
    	}

    	function attachPingListener(root, wakeable, lanes) {
    	  // Attach a listener to the promise to "ping" the root and retry. But only if
    	  // one does not already exist for the lanes we're currently rendering (which
    	  // acts like a "thread ID" here).
    	  var pingCache = root.pingCache;
    	  var threadIDs;

    	  if (pingCache === null) {
    	    pingCache = root.pingCache = new PossiblyWeakMap$1();
    	    threadIDs = new Set();
    	    pingCache.set(wakeable, threadIDs);
    	  } else {
    	    threadIDs = pingCache.get(wakeable);

    	    if (threadIDs === undefined) {
    	      threadIDs = new Set();
    	      pingCache.set(wakeable, threadIDs);
    	    }
    	  }

    	  if (!threadIDs.has(lanes)) {
    	    // Memoize using the thread ID to prevent redundant listeners.
    	    threadIDs.add(lanes);
    	    var ping = pingSuspendedRoot.bind(null, root, wakeable, lanes);
    	    wakeable.then(ping, ping);
    	  }
    	}

    	function throwException(root, returnFiber, sourceFiber, value, rootRenderLanes) {
    	  // The source fiber did not complete.
    	  sourceFiber.flags |= Incomplete; // Its effect list is no longer valid.

    	  sourceFiber.firstEffect = sourceFiber.lastEffect = null;

    	  if (value !== null && typeof value === 'object' && typeof value.then === 'function') {
    	    // This is a wakeable.
    	    var wakeable = value;

    	    if ((sourceFiber.mode & BlockingMode) === NoMode) {
    	      // Reset the memoizedState to what it was before we attempted
    	      // to render it.
    	      var currentSource = sourceFiber.alternate;

    	      if (currentSource) {
    	        sourceFiber.updateQueue = currentSource.updateQueue;
    	        sourceFiber.memoizedState = currentSource.memoizedState;
    	        sourceFiber.lanes = currentSource.lanes;
    	      } else {
    	        sourceFiber.updateQueue = null;
    	        sourceFiber.memoizedState = null;
    	      }
    	    }

    	    var hasInvisibleParentBoundary = hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext); // Schedule the nearest Suspense to re-render the timed out view.

    	    var _workInProgress = returnFiber;

    	    do {
    	      if (_workInProgress.tag === SuspenseComponent && shouldCaptureSuspense(_workInProgress, hasInvisibleParentBoundary)) {
    	        // Found the nearest boundary.
    	        // Stash the promise on the boundary fiber. If the boundary times out, we'll
    	        // attach another listener to flip the boundary back to its normal state.
    	        var wakeables = _workInProgress.updateQueue;

    	        if (wakeables === null) {
    	          var updateQueue = new Set();
    	          updateQueue.add(wakeable);
    	          _workInProgress.updateQueue = updateQueue;
    	        } else {
    	          wakeables.add(wakeable);
    	        } // If the boundary is outside of blocking mode, we should *not*
    	        // suspend the commit. Pretend as if the suspended component rendered
    	        // null and keep rendering. In the commit phase, we'll schedule a
    	        // subsequent synchronous update to re-render the Suspense.
    	        //
    	        // Note: It doesn't matter whether the component that suspended was
    	        // inside a blocking mode tree. If the Suspense is outside of it, we
    	        // should *not* suspend the commit.


    	        if ((_workInProgress.mode & BlockingMode) === NoMode) {
    	          _workInProgress.flags |= DidCapture;
    	          sourceFiber.flags |= ForceUpdateForLegacySuspense; // We're going to commit this fiber even though it didn't complete.
    	          // But we shouldn't call any lifecycle methods or callbacks. Remove
    	          // all lifecycle effect tags.

    	          sourceFiber.flags &= ~(LifecycleEffectMask | Incomplete);

    	          if (sourceFiber.tag === ClassComponent) {
    	            var currentSourceFiber = sourceFiber.alternate;

    	            if (currentSourceFiber === null) {
    	              // This is a new mount. Change the tag so it's not mistaken for a
    	              // completed class component. For example, we should not call
    	              // componentWillUnmount if it is deleted.
    	              sourceFiber.tag = IncompleteClassComponent;
    	            } else {
    	              // When we try rendering again, we should not reuse the current fiber,
    	              // since it's known to be in an inconsistent state. Use a force update to
    	              // prevent a bail out.
    	              var update = createUpdate(NoTimestamp, SyncLane);
    	              update.tag = ForceUpdate;
    	              enqueueUpdate(sourceFiber, update);
    	            }
    	          } // The source fiber did not complete. Mark it with Sync priority to
    	          // indicate that it still has pending work.


    	          sourceFiber.lanes = mergeLanes(sourceFiber.lanes, SyncLane); // Exit without suspending.

    	          return;
    	        } // Confirmed that the boundary is in a concurrent mode tree. Continue
    	        // with the normal suspend path.
    	        //
    	        // After this we'll use a set of heuristics to determine whether this
    	        // render pass will run to completion or restart or "suspend" the commit.
    	        // The actual logic for this is spread out in different places.
    	        //
    	        // This first principle is that if we're going to suspend when we complete
    	        // a root, then we should also restart if we get an update or ping that
    	        // might unsuspend it, and vice versa. The only reason to suspend is
    	        // because you think you might want to restart before committing. However,
    	        // it doesn't make sense to restart only while in the period we're suspended.
    	        //
    	        // Restarting too aggressively is also not good because it starves out any
    	        // intermediate loading state. So we use heuristics to determine when.
    	        // Suspense Heuristics
    	        //
    	        // If nothing threw a Promise or all the same fallbacks are already showing,
    	        // then don't suspend/restart.
    	        //
    	        // If this is an initial render of a new tree of Suspense boundaries and
    	        // those trigger a fallback, then don't suspend/restart. We want to ensure
    	        // that we can show the initial loading state as quickly as possible.
    	        //
    	        // If we hit a "Delayed" case, such as when we'd switch from content back into
    	        // a fallback, then we should always suspend/restart. Transitions apply
    	        // to this case. If none is defined, JND is used instead.
    	        //
    	        // If we're already showing a fallback and it gets "retried", allowing us to show
    	        // another level, but there's still an inner boundary that would show a fallback,
    	        // then we suspend/restart for 500ms since the last time we showed a fallback
    	        // anywhere in the tree. This effectively throttles progressive loading into a
    	        // consistent train of commits. This also gives us an opportunity to restart to
    	        // get to the completed state slightly earlier.
    	        //
    	        // If there's ambiguity due to batching it's resolved in preference of:
    	        // 1) "delayed", 2) "initial render", 3) "retry".
    	        //
    	        // We want to ensure that a "busy" state doesn't get force committed. We want to
    	        // ensure that new initial loading states can commit as soon as possible.


    	        attachPingListener(root, wakeable, rootRenderLanes);
    	        _workInProgress.flags |= ShouldCapture;
    	        _workInProgress.lanes = rootRenderLanes;
    	        return;
    	      } // This boundary already captured during this render. Continue to the next
    	      // boundary.


    	      _workInProgress = _workInProgress.return;
    	    } while (_workInProgress !== null); // No boundary was found. Fallthrough to error mode.
    	    // TODO: Use invariant so the message is stripped in prod?


    	    value = new Error((getComponentName(sourceFiber.type) || 'A React component') + ' suspended while rendering, but no fallback UI was specified.\n' + '\n' + 'Add a <Suspense fallback=...> component higher in the tree to ' + 'provide a loading indicator or placeholder to display.');
    	  } // We didn't find a boundary that could handle this type of exception. Start
    	  // over and traverse parent path again, this time treating the exception
    	  // as an error.


    	  renderDidError();
    	  value = createCapturedValue(value, sourceFiber);
    	  var workInProgress = returnFiber;

    	  do {
    	    switch (workInProgress.tag) {
    	      case HostRoot:
    	        {
    	          var _errorInfo = value;
    	          workInProgress.flags |= ShouldCapture;
    	          var lane = pickArbitraryLane(rootRenderLanes);
    	          workInProgress.lanes = mergeLanes(workInProgress.lanes, lane);

    	          var _update = createRootErrorUpdate(workInProgress, _errorInfo, lane);

    	          enqueueCapturedUpdate(workInProgress, _update);
    	          return;
    	        }

    	      case ClassComponent:
    	        // Capture and retry
    	        var errorInfo = value;
    	        var ctor = workInProgress.type;
    	        var instance = workInProgress.stateNode;

    	        if ((workInProgress.flags & DidCapture) === NoFlags && (typeof ctor.getDerivedStateFromError === 'function' || instance !== null && typeof instance.componentDidCatch === 'function' && !isAlreadyFailedLegacyErrorBoundary(instance))) {
    	          workInProgress.flags |= ShouldCapture;

    	          var _lane = pickArbitraryLane(rootRenderLanes);

    	          workInProgress.lanes = mergeLanes(workInProgress.lanes, _lane); // Schedule the error boundary to re-render using updated state

    	          var _update2 = createClassErrorUpdate(workInProgress, errorInfo, _lane);

    	          enqueueCapturedUpdate(workInProgress, _update2);
    	          return;
    	        }

    	        break;
    	    }

    	    workInProgress = workInProgress.return;
    	  } while (workInProgress !== null);
    	}

    	var didWarnAboutUndefinedSnapshotBeforeUpdate = null;

    	{
    	  didWarnAboutUndefinedSnapshotBeforeUpdate = new Set();
    	}

    	var PossiblyWeakSet = typeof WeakSet === 'function' ? WeakSet : Set;

    	var callComponentWillUnmountWithTimer = function (current, instance) {
    	  instance.props = current.memoizedProps;
    	  instance.state = current.memoizedState;

    	  {
    	    instance.componentWillUnmount();
    	  }
    	}; // Capture errors so they don't interrupt unmounting.


    	function safelyCallComponentWillUnmount(current, instance) {
    	  {
    	    invokeGuardedCallback(null, callComponentWillUnmountWithTimer, null, current, instance);

    	    if (hasCaughtError()) {
    	      var unmountError = clearCaughtError();
    	      captureCommitPhaseError(current, unmountError);
    	    }
    	  }
    	}

    	function safelyDetachRef(current) {
    	  var ref = current.ref;

    	  if (ref !== null) {
    	    if (typeof ref === 'function') {
    	      {
    	        invokeGuardedCallback(null, ref, null, null);

    	        if (hasCaughtError()) {
    	          var refError = clearCaughtError();
    	          captureCommitPhaseError(current, refError);
    	        }
    	      }
    	    } else {
    	      ref.current = null;
    	    }
    	  }
    	}

    	function safelyCallDestroy(current, destroy) {
    	  {
    	    invokeGuardedCallback(null, destroy, null);

    	    if (hasCaughtError()) {
    	      var error = clearCaughtError();
    	      captureCommitPhaseError(current, error);
    	    }
    	  }
    	}

    	function commitBeforeMutationLifeCycles(current, finishedWork) {
    	  switch (finishedWork.tag) {
    	    case FunctionComponent:
    	    case ForwardRef:
    	    case SimpleMemoComponent:
    	    case Block:
    	      {
    	        return;
    	      }

    	    case ClassComponent:
    	      {
    	        if (finishedWork.flags & Snapshot) {
    	          if (current !== null) {
    	            var prevProps = current.memoizedProps;
    	            var prevState = current.memoizedState;
    	            var instance = finishedWork.stateNode; // We could update instance props and state here,
    	            // but instead we rely on them being set during last render.
    	            // TODO: revisit this when we implement resuming.

    	            {
    	              if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
    	                if (instance.props !== finishedWork.memoizedProps) {
    	                  error('Expected %s props to match memoized props before ' + 'getSnapshotBeforeUpdate. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.props`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }

    	                if (instance.state !== finishedWork.memoizedState) {
    	                  error('Expected %s state to match memoized state before ' + 'getSnapshotBeforeUpdate. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.state`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }
    	              }
    	            }

    	            var snapshot = instance.getSnapshotBeforeUpdate(finishedWork.elementType === finishedWork.type ? prevProps : resolveDefaultProps(finishedWork.type, prevProps), prevState);

    	            {
    	              var didWarnSet = didWarnAboutUndefinedSnapshotBeforeUpdate;

    	              if (snapshot === undefined && !didWarnSet.has(finishedWork.type)) {
    	                didWarnSet.add(finishedWork.type);

    	                error('%s.getSnapshotBeforeUpdate(): A snapshot value (or null) ' + 'must be returned. You have returned undefined.', getComponentName(finishedWork.type));
    	              }
    	            }

    	            instance.__reactInternalSnapshotBeforeUpdate = snapshot;
    	          }
    	        }

    	        return;
    	      }

    	    case HostRoot:
    	      {
    	        {
    	          if (finishedWork.flags & Snapshot) {
    	            var root = finishedWork.stateNode;
    	            clearContainer(root.containerInfo);
    	          }
    	        }

    	        return;
    	      }

    	    case HostComponent:
    	    case HostText:
    	    case HostPortal:
    	    case IncompleteClassComponent:
    	      // Nothing to do for these component types
    	      return;
    	  }

    	  {
    	    {
    	      throw Error( "This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function commitHookEffectListUnmount(tag, finishedWork) {
    	  var updateQueue = finishedWork.updateQueue;
    	  var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;

    	  if (lastEffect !== null) {
    	    var firstEffect = lastEffect.next;
    	    var effect = firstEffect;

    	    do {
    	      if ((effect.tag & tag) === tag) {
    	        // Unmount
    	        var destroy = effect.destroy;
    	        effect.destroy = undefined;

    	        if (destroy !== undefined) {
    	          destroy();
    	        }
    	      }

    	      effect = effect.next;
    	    } while (effect !== firstEffect);
    	  }
    	}

    	function commitHookEffectListMount(tag, finishedWork) {
    	  var updateQueue = finishedWork.updateQueue;
    	  var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;

    	  if (lastEffect !== null) {
    	    var firstEffect = lastEffect.next;
    	    var effect = firstEffect;

    	    do {
    	      if ((effect.tag & tag) === tag) {
    	        // Mount
    	        var create = effect.create;
    	        effect.destroy = create();

    	        {
    	          var destroy = effect.destroy;

    	          if (destroy !== undefined && typeof destroy !== 'function') {
    	            var addendum = void 0;

    	            if (destroy === null) {
    	              addendum = ' You returned null. If your effect does not require clean ' + 'up, return undefined (or nothing).';
    	            } else if (typeof destroy.then === 'function') {
    	              addendum = '\n\nIt looks like you wrote useEffect(async () => ...) or returned a Promise. ' + 'Instead, write the async function inside your effect ' + 'and call it immediately:\n\n' + 'useEffect(() => {\n' + '  async function fetchData() {\n' + '    // You can await here\n' + '    const response = await MyAPI.getData(someId);\n' + '    // ...\n' + '  }\n' + '  fetchData();\n' + "}, [someId]); // Or [] if effect doesn't need props or state\n\n" + 'Learn more about data fetching with Hooks: https://reactjs.org/link/hooks-data-fetching';
    	            } else {
    	              addendum = ' You returned: ' + destroy;
    	            }

    	            error('An effect function must not return anything besides a function, ' + 'which is used for clean-up.%s', addendum);
    	          }
    	        }
    	      }

    	      effect = effect.next;
    	    } while (effect !== firstEffect);
    	  }
    	}

    	function schedulePassiveEffects(finishedWork) {
    	  var updateQueue = finishedWork.updateQueue;
    	  var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;

    	  if (lastEffect !== null) {
    	    var firstEffect = lastEffect.next;
    	    var effect = firstEffect;

    	    do {
    	      var _effect = effect,
    	          next = _effect.next,
    	          tag = _effect.tag;

    	      if ((tag & Passive$1) !== NoFlags$1 && (tag & HasEffect) !== NoFlags$1) {
    	        enqueuePendingPassiveHookEffectUnmount(finishedWork, effect);
    	        enqueuePendingPassiveHookEffectMount(finishedWork, effect);
    	      }

    	      effect = next;
    	    } while (effect !== firstEffect);
    	  }
    	}

    	function commitLifeCycles(finishedRoot, current, finishedWork, committedLanes) {
    	  switch (finishedWork.tag) {
    	    case FunctionComponent:
    	    case ForwardRef:
    	    case SimpleMemoComponent:
    	    case Block:
    	      {
    	        // At this point layout effects have already been destroyed (during mutation phase).
    	        // This is done to prevent sibling component effects from interfering with each other,
    	        // e.g. a destroy function in one component should never override a ref set
    	        // by a create function in another component during the same commit.
    	        {
    	          commitHookEffectListMount(Layout | HasEffect, finishedWork);
    	        }

    	        schedulePassiveEffects(finishedWork);
    	        return;
    	      }

    	    case ClassComponent:
    	      {
    	        var instance = finishedWork.stateNode;

    	        if (finishedWork.flags & Update) {
    	          if (current === null) {
    	            // We could update instance props and state here,
    	            // but instead we rely on them being set during last render.
    	            // TODO: revisit this when we implement resuming.
    	            {
    	              if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
    	                if (instance.props !== finishedWork.memoizedProps) {
    	                  error('Expected %s props to match memoized props before ' + 'componentDidMount. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.props`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }

    	                if (instance.state !== finishedWork.memoizedState) {
    	                  error('Expected %s state to match memoized state before ' + 'componentDidMount. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.state`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }
    	              }
    	            }

    	            {
    	              instance.componentDidMount();
    	            }
    	          } else {
    	            var prevProps = finishedWork.elementType === finishedWork.type ? current.memoizedProps : resolveDefaultProps(finishedWork.type, current.memoizedProps);
    	            var prevState = current.memoizedState; // We could update instance props and state here,
    	            // but instead we rely on them being set during last render.
    	            // TODO: revisit this when we implement resuming.

    	            {
    	              if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
    	                if (instance.props !== finishedWork.memoizedProps) {
    	                  error('Expected %s props to match memoized props before ' + 'componentDidUpdate. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.props`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }

    	                if (instance.state !== finishedWork.memoizedState) {
    	                  error('Expected %s state to match memoized state before ' + 'componentDidUpdate. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.state`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	                }
    	              }
    	            }

    	            {
    	              instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
    	            }
    	          }
    	        } // TODO: I think this is now always non-null by the time it reaches the
    	        // commit phase. Consider removing the type check.


    	        var updateQueue = finishedWork.updateQueue;

    	        if (updateQueue !== null) {
    	          {
    	            if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
    	              if (instance.props !== finishedWork.memoizedProps) {
    	                error('Expected %s props to match memoized props before ' + 'processing the update queue. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.props`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	              }

    	              if (instance.state !== finishedWork.memoizedState) {
    	                error('Expected %s state to match memoized state before ' + 'processing the update queue. ' + 'This might either be because of a bug in React, or because ' + 'a component reassigns its own `this.state`. ' + 'Please file an issue.', getComponentName(finishedWork.type) || 'instance');
    	              }
    	            }
    	          } // We could update instance props and state here,
    	          // but instead we rely on them being set during last render.
    	          // TODO: revisit this when we implement resuming.


    	          commitUpdateQueue(finishedWork, updateQueue, instance);
    	        }

    	        return;
    	      }

    	    case HostRoot:
    	      {
    	        // TODO: I think this is now always non-null by the time it reaches the
    	        // commit phase. Consider removing the type check.
    	        var _updateQueue = finishedWork.updateQueue;

    	        if (_updateQueue !== null) {
    	          var _instance = null;

    	          if (finishedWork.child !== null) {
    	            switch (finishedWork.child.tag) {
    	              case HostComponent:
    	                _instance = getPublicInstance(finishedWork.child.stateNode);
    	                break;

    	              case ClassComponent:
    	                _instance = finishedWork.child.stateNode;
    	                break;
    	            }
    	          }

    	          commitUpdateQueue(finishedWork, _updateQueue, _instance);
    	        }

    	        return;
    	      }

    	    case HostComponent:
    	      {
    	        var _instance2 = finishedWork.stateNode; // Renderers may schedule work to be done after host components are mounted
    	        // (eg DOM renderer may schedule auto-focus for inputs and form controls).
    	        // These effects should only be committed when components are first mounted,
    	        // aka when there is no current/alternate.

    	        if (current === null && finishedWork.flags & Update) {
    	          var type = finishedWork.type;
    	          var props = finishedWork.memoizedProps;
    	          commitMount(_instance2, type, props);
    	        }

    	        return;
    	      }

    	    case HostText:
    	      {
    	        // We have no life-cycles associated with text.
    	        return;
    	      }

    	    case HostPortal:
    	      {
    	        // We have no life-cycles associated with portals.
    	        return;
    	      }

    	    case Profiler:
    	      {
    	        {
    	          var _finishedWork$memoize2 = finishedWork.memoizedProps;
    	              _finishedWork$memoize2.onCommit;
    	              var onRender = _finishedWork$memoize2.onRender;
    	          finishedWork.stateNode.effectDuration;
    	          var commitTime = getCommitTime();

    	          if (typeof onRender === 'function') {
    	            {
    	              onRender(finishedWork.memoizedProps.id, current === null ? 'mount' : 'update', finishedWork.actualDuration, finishedWork.treeBaseDuration, finishedWork.actualStartTime, commitTime, finishedRoot.memoizedInteractions);
    	            }
    	          }
    	        }

    	        return;
    	      }

    	    case SuspenseComponent:
    	      {
    	        commitSuspenseHydrationCallbacks(finishedRoot, finishedWork);
    	        return;
    	      }

    	    case SuspenseListComponent:
    	    case IncompleteClassComponent:
    	    case FundamentalComponent:
    	    case ScopeComponent:
    	    case OffscreenComponent:
    	    case LegacyHiddenComponent:
    	      return;
    	  }

    	  {
    	    {
    	      throw Error( "This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function hideOrUnhideAllChildren(finishedWork, isHidden) {
    	  {
    	    // We only have the top Fiber that was inserted but we need to recurse down its
    	    // children to find all the terminal nodes.
    	    var node = finishedWork;

    	    while (true) {
    	      if (node.tag === HostComponent) {
    	        var instance = node.stateNode;

    	        if (isHidden) {
    	          hideInstance(instance);
    	        } else {
    	          unhideInstance(node.stateNode, node.memoizedProps);
    	        }
    	      } else if (node.tag === HostText) {
    	        var _instance3 = node.stateNode;

    	        if (isHidden) {
    	          hideTextInstance(_instance3);
    	        } else {
    	          unhideTextInstance(_instance3, node.memoizedProps);
    	        }
    	      } else if ((node.tag === OffscreenComponent || node.tag === LegacyHiddenComponent) && node.memoizedState !== null && node !== finishedWork) ; else if (node.child !== null) {
    	        node.child.return = node;
    	        node = node.child;
    	        continue;
    	      }

    	      if (node === finishedWork) {
    	        return;
    	      }

    	      while (node.sibling === null) {
    	        if (node.return === null || node.return === finishedWork) {
    	          return;
    	        }

    	        node = node.return;
    	      }

    	      node.sibling.return = node.return;
    	      node = node.sibling;
    	    }
    	  }
    	}

    	function commitAttachRef(finishedWork) {
    	  var ref = finishedWork.ref;

    	  if (ref !== null) {
    	    var instance = finishedWork.stateNode;
    	    var instanceToUse;

    	    switch (finishedWork.tag) {
    	      case HostComponent:
    	        instanceToUse = getPublicInstance(instance);
    	        break;

    	      default:
    	        instanceToUse = instance;
    	    } // Moved outside to ensure DCE works with this flag

    	    if (typeof ref === 'function') {
    	      ref(instanceToUse);
    	    } else {
    	      {
    	        if (!ref.hasOwnProperty('current')) {
    	          error('Unexpected ref object provided for %s. ' + 'Use either a ref-setter function or React.createRef().', getComponentName(finishedWork.type));
    	        }
    	      }

    	      ref.current = instanceToUse;
    	    }
    	  }
    	}

    	function commitDetachRef(current) {
    	  var currentRef = current.ref;

    	  if (currentRef !== null) {
    	    if (typeof currentRef === 'function') {
    	      currentRef(null);
    	    } else {
    	      currentRef.current = null;
    	    }
    	  }
    	} // User-originating errors (lifecycles and refs) should not interrupt
    	// deletion, so don't let them throw. Host-originating errors should
    	// interrupt deletion, so it's okay


    	function commitUnmount(finishedRoot, current, renderPriorityLevel) {
    	  onCommitUnmount(current);

    	  switch (current.tag) {
    	    case FunctionComponent:
    	    case ForwardRef:
    	    case MemoComponent:
    	    case SimpleMemoComponent:
    	    case Block:
    	      {
    	        var updateQueue = current.updateQueue;

    	        if (updateQueue !== null) {
    	          var lastEffect = updateQueue.lastEffect;

    	          if (lastEffect !== null) {
    	            var firstEffect = lastEffect.next;
    	            var effect = firstEffect;

    	            do {
    	              var _effect2 = effect,
    	                  destroy = _effect2.destroy,
    	                  tag = _effect2.tag;

    	              if (destroy !== undefined) {
    	                if ((tag & Passive$1) !== NoFlags$1) {
    	                  enqueuePendingPassiveHookEffectUnmount(current, effect);
    	                } else {
    	                  {
    	                    safelyCallDestroy(current, destroy);
    	                  }
    	                }
    	              }

    	              effect = effect.next;
    	            } while (effect !== firstEffect);
    	          }
    	        }

    	        return;
    	      }

    	    case ClassComponent:
    	      {
    	        safelyDetachRef(current);
    	        var instance = current.stateNode;

    	        if (typeof instance.componentWillUnmount === 'function') {
    	          safelyCallComponentWillUnmount(current, instance);
    	        }

    	        return;
    	      }

    	    case HostComponent:
    	      {
    	        safelyDetachRef(current);
    	        return;
    	      }

    	    case HostPortal:
    	      {
    	        // TODO: this is recursive.
    	        // We are also not using this parent because
    	        // the portal will get pushed immediately.
    	        {
    	          unmountHostComponents(finishedRoot, current);
    	        }

    	        return;
    	      }

    	    case FundamentalComponent:
    	      {

    	        return;
    	      }

    	    case DehydratedFragment:
    	      {

    	        return;
    	      }

    	    case ScopeComponent:
    	      {

    	        return;
    	      }
    	  }
    	}

    	function commitNestedUnmounts(finishedRoot, root, renderPriorityLevel) {
    	  // While we're inside a removed host node we don't want to call
    	  // removeChild on the inner nodes because they're removed by the top
    	  // call anyway. We also want to call componentWillUnmount on all
    	  // composites before this host node is removed from the tree. Therefore
    	  // we do an inner loop while we're still inside the host node.
    	  var node = root;

    	  while (true) {
    	    commitUnmount(finishedRoot, node); // Visit children because they may contain more composite or host nodes.
    	    // Skip portals because commitUnmount() currently visits them recursively.

    	    if (node.child !== null && ( // If we use mutation we drill down into portals using commitUnmount above.
    	    // If we don't use mutation we drill down into portals here instead.
    	     node.tag !== HostPortal)) {
    	      node.child.return = node;
    	      node = node.child;
    	      continue;
    	    }

    	    if (node === root) {
    	      return;
    	    }

    	    while (node.sibling === null) {
    	      if (node.return === null || node.return === root) {
    	        return;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  }
    	}

    	function detachFiberMutation(fiber) {
    	  // Cut off the return pointers to disconnect it from the tree. Ideally, we
    	  // should clear the child pointer of the parent alternate to let this
    	  // get GC:ed but we don't know which for sure which parent is the current
    	  // one so we'll settle for GC:ing the subtree of this child. This child
    	  // itself will be GC:ed when the parent updates the next time.
    	  // Note: we cannot null out sibling here, otherwise it can cause issues
    	  // with findDOMNode and how it requires the sibling field to carry out
    	  // traversal in a later effect. See PR #16820. We now clear the sibling
    	  // field after effects, see: detachFiberAfterEffects.
    	  //
    	  // Don't disconnect stateNode now; it will be detached in detachFiberAfterEffects.
    	  // It may be required if the current component is an error boundary,
    	  // and one of its descendants throws while unmounting a passive effect.
    	  fiber.alternate = null;
    	  fiber.child = null;
    	  fiber.dependencies = null;
    	  fiber.firstEffect = null;
    	  fiber.lastEffect = null;
    	  fiber.memoizedProps = null;
    	  fiber.memoizedState = null;
    	  fiber.pendingProps = null;
    	  fiber.return = null;
    	  fiber.updateQueue = null;

    	  {
    	    fiber._debugOwner = null;
    	  }
    	}

    	function getHostParentFiber(fiber) {
    	  var parent = fiber.return;

    	  while (parent !== null) {
    	    if (isHostParent(parent)) {
    	      return parent;
    	    }

    	    parent = parent.return;
    	  }

    	  {
    	    {
    	      throw Error( "Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function isHostParent(fiber) {
    	  return fiber.tag === HostComponent || fiber.tag === HostRoot || fiber.tag === HostPortal;
    	}

    	function getHostSibling(fiber) {
    	  // We're going to search forward into the tree until we find a sibling host
    	  // node. Unfortunately, if multiple insertions are done in a row we have to
    	  // search past them. This leads to exponential search for the next sibling.
    	  // TODO: Find a more efficient way to do this.
    	  var node = fiber;

    	  siblings: while (true) {
    	    // If we didn't find anything, let's try the next sibling.
    	    while (node.sibling === null) {
    	      if (node.return === null || isHostParent(node.return)) {
    	        // If we pop out of the root or hit the parent the fiber we are the
    	        // last sibling.
    	        return null;
    	      }

    	      node = node.return;
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;

    	    while (node.tag !== HostComponent && node.tag !== HostText && node.tag !== DehydratedFragment) {
    	      // If it is not host node and, we might have a host node inside it.
    	      // Try to search down until we find one.
    	      if (node.flags & Placement) {
    	        // If we don't have a child, try the siblings instead.
    	        continue siblings;
    	      } // If we don't have a child, try the siblings instead.
    	      // We also skip portals because they are not part of this host tree.


    	      if (node.child === null || node.tag === HostPortal) {
    	        continue siblings;
    	      } else {
    	        node.child.return = node;
    	        node = node.child;
    	      }
    	    } // Check if this host node is stable or about to be placed.


    	    if (!(node.flags & Placement)) {
    	      // Found it!
    	      return node.stateNode;
    	    }
    	  }
    	}

    	function commitPlacement(finishedWork) {


    	  var parentFiber = getHostParentFiber(finishedWork); // Note: these two variables *must* always be updated together.

    	  var parent;
    	  var isContainer;
    	  var parentStateNode = parentFiber.stateNode;

    	  switch (parentFiber.tag) {
    	    case HostComponent:
    	      parent = parentStateNode;
    	      isContainer = false;
    	      break;

    	    case HostRoot:
    	      parent = parentStateNode.containerInfo;
    	      isContainer = true;
    	      break;

    	    case HostPortal:
    	      parent = parentStateNode.containerInfo;
    	      isContainer = true;
    	      break;

    	    case FundamentalComponent:

    	    // eslint-disable-next-line-no-fallthrough

    	    default:
    	      {
    	        {
    	          throw Error( "Invalid host parent fiber. This error is likely caused by a bug in React. Please file an issue." );
    	        }
    	      }

    	  }

    	  if (parentFiber.flags & ContentReset) {
    	    // Reset the text content of the parent before doing any insertions
    	    resetTextContent(parent); // Clear ContentReset from the effect tag

    	    parentFiber.flags &= ~ContentReset;
    	  }

    	  var before = getHostSibling(finishedWork); // We only have the top Fiber that was inserted but we need to recurse down its
    	  // children to find all the terminal nodes.

    	  if (isContainer) {
    	    insertOrAppendPlacementNodeIntoContainer(finishedWork, before, parent);
    	  } else {
    	    insertOrAppendPlacementNode(finishedWork, before, parent);
    	  }
    	}

    	function insertOrAppendPlacementNodeIntoContainer(node, before, parent) {
    	  var tag = node.tag;
    	  var isHost = tag === HostComponent || tag === HostText;

    	  if (isHost || enableFundamentalAPI ) {
    	    var stateNode = isHost ? node.stateNode : node.stateNode.instance;

    	    if (before) {
    	      insertInContainerBefore(parent, stateNode, before);
    	    } else {
    	      appendChildToContainer(parent, stateNode);
    	    }
    	  } else if (tag === HostPortal) ; else {
    	    var child = node.child;

    	    if (child !== null) {
    	      insertOrAppendPlacementNodeIntoContainer(child, before, parent);
    	      var sibling = child.sibling;

    	      while (sibling !== null) {
    	        insertOrAppendPlacementNodeIntoContainer(sibling, before, parent);
    	        sibling = sibling.sibling;
    	      }
    	    }
    	  }
    	}

    	function insertOrAppendPlacementNode(node, before, parent) {
    	  var tag = node.tag;
    	  var isHost = tag === HostComponent || tag === HostText;

    	  if (isHost || enableFundamentalAPI ) {
    	    var stateNode = isHost ? node.stateNode : node.stateNode.instance;

    	    if (before) {
    	      insertBefore(parent, stateNode, before);
    	    } else {
    	      appendChild(parent, stateNode);
    	    }
    	  } else if (tag === HostPortal) ; else {
    	    var child = node.child;

    	    if (child !== null) {
    	      insertOrAppendPlacementNode(child, before, parent);
    	      var sibling = child.sibling;

    	      while (sibling !== null) {
    	        insertOrAppendPlacementNode(sibling, before, parent);
    	        sibling = sibling.sibling;
    	      }
    	    }
    	  }
    	}

    	function unmountHostComponents(finishedRoot, current, renderPriorityLevel) {
    	  // We only have the top Fiber that was deleted but we need to recurse down its
    	  // children to find all the terminal nodes.
    	  var node = current; // Each iteration, currentParent is populated with node's host parent if not
    	  // currentParentIsValid.

    	  var currentParentIsValid = false; // Note: these two variables *must* always be updated together.

    	  var currentParent;
    	  var currentParentIsContainer;

    	  while (true) {
    	    if (!currentParentIsValid) {
    	      var parent = node.return;

    	      findParent: while (true) {
    	        if (!(parent !== null)) {
    	          {
    	            throw Error( "Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue." );
    	          }
    	        }

    	        var parentStateNode = parent.stateNode;

    	        switch (parent.tag) {
    	          case HostComponent:
    	            currentParent = parentStateNode;
    	            currentParentIsContainer = false;
    	            break findParent;

    	          case HostRoot:
    	            currentParent = parentStateNode.containerInfo;
    	            currentParentIsContainer = true;
    	            break findParent;

    	          case HostPortal:
    	            currentParent = parentStateNode.containerInfo;
    	            currentParentIsContainer = true;
    	            break findParent;

    	        }

    	        parent = parent.return;
    	      }

    	      currentParentIsValid = true;
    	    }

    	    if (node.tag === HostComponent || node.tag === HostText) {
    	      commitNestedUnmounts(finishedRoot, node); // After all the children have unmounted, it is now safe to remove the
    	      // node from the tree.

    	      if (currentParentIsContainer) {
    	        removeChildFromContainer(currentParent, node.stateNode);
    	      } else {
    	        removeChild(currentParent, node.stateNode);
    	      } // Don't visit children because we already visited them.

    	    } else if (node.tag === HostPortal) {
    	      if (node.child !== null) {
    	        // When we go into a portal, it becomes the parent to remove from.
    	        // We will reassign it back when we pop the portal on the way up.
    	        currentParent = node.stateNode.containerInfo;
    	        currentParentIsContainer = true; // Visit children because portals might contain host components.

    	        node.child.return = node;
    	        node = node.child;
    	        continue;
    	      }
    	    } else {
    	      commitUnmount(finishedRoot, node); // Visit children because we may find more host components below.

    	      if (node.child !== null) {
    	        node.child.return = node;
    	        node = node.child;
    	        continue;
    	      }
    	    }

    	    if (node === current) {
    	      return;
    	    }

    	    while (node.sibling === null) {
    	      if (node.return === null || node.return === current) {
    	        return;
    	      }

    	      node = node.return;

    	      if (node.tag === HostPortal) {
    	        // When we go out of the portal, we need to restore the parent.
    	        // Since we don't keep a stack of them, we will search for it.
    	        currentParentIsValid = false;
    	      }
    	    }

    	    node.sibling.return = node.return;
    	    node = node.sibling;
    	  }
    	}

    	function commitDeletion(finishedRoot, current, renderPriorityLevel) {
    	  {
    	    // Recursively delete all host nodes from the parent.
    	    // Detach refs and call componentWillUnmount() on the whole subtree.
    	    unmountHostComponents(finishedRoot, current);
    	  }

    	  var alternate = current.alternate;
    	  detachFiberMutation(current);

    	  if (alternate !== null) {
    	    detachFiberMutation(alternate);
    	  }
    	}

    	function commitWork(current, finishedWork) {

    	  switch (finishedWork.tag) {
    	    case FunctionComponent:
    	    case ForwardRef:
    	    case MemoComponent:
    	    case SimpleMemoComponent:
    	    case Block:
    	      {
    	        // Layout effects are destroyed during the mutation phase so that all
    	        // destroy functions for all fibers are called before any create functions.
    	        // This prevents sibling component effects from interfering with each other,
    	        // e.g. a destroy function in one component should never override a ref set
    	        // by a create function in another component during the same commit.
    	        {
    	          commitHookEffectListUnmount(Layout | HasEffect, finishedWork);
    	        }

    	        return;
    	      }

    	    case ClassComponent:
    	      {
    	        return;
    	      }

    	    case HostComponent:
    	      {
    	        var instance = finishedWork.stateNode;

    	        if (instance != null) {
    	          // Commit the work prepared earlier.
    	          var newProps = finishedWork.memoizedProps; // For hydration we reuse the update path but we treat the oldProps
    	          // as the newProps. The updatePayload will contain the real change in
    	          // this case.

    	          var oldProps = current !== null ? current.memoizedProps : newProps;
    	          var type = finishedWork.type; // TODO: Type the updateQueue to be specific to host components.

    	          var updatePayload = finishedWork.updateQueue;
    	          finishedWork.updateQueue = null;

    	          if (updatePayload !== null) {
    	            commitUpdate(instance, updatePayload, type, oldProps, newProps);
    	          }
    	        }

    	        return;
    	      }

    	    case HostText:
    	      {
    	        if (!(finishedWork.stateNode !== null)) {
    	          {
    	            throw Error( "This should have a text node initialized. This error is likely caused by a bug in React. Please file an issue." );
    	          }
    	        }

    	        var textInstance = finishedWork.stateNode;
    	        var newText = finishedWork.memoizedProps; // For hydration we reuse the update path but we treat the oldProps
    	        // as the newProps. The updatePayload will contain the real change in
    	        // this case.

    	        var oldText = current !== null ? current.memoizedProps : newText;
    	        commitTextUpdate(textInstance, oldText, newText);
    	        return;
    	      }

    	    case HostRoot:
    	      {
    	        {
    	          var _root = finishedWork.stateNode;

    	          if (_root.hydrate) {
    	            // We've just hydrated. No need to hydrate again.
    	            _root.hydrate = false;
    	            commitHydratedContainer(_root.containerInfo);
    	          }
    	        }

    	        return;
    	      }

    	    case Profiler:
    	      {
    	        return;
    	      }

    	    case SuspenseComponent:
    	      {
    	        commitSuspenseComponent(finishedWork);
    	        attachSuspenseRetryListeners(finishedWork);
    	        return;
    	      }

    	    case SuspenseListComponent:
    	      {
    	        attachSuspenseRetryListeners(finishedWork);
    	        return;
    	      }

    	    case IncompleteClassComponent:
    	      {
    	        return;
    	      }

    	    case FundamentalComponent:
    	      {

    	        break;
    	      }

    	    case ScopeComponent:
    	      {

    	        break;
    	      }

    	    case OffscreenComponent:
    	    case LegacyHiddenComponent:
    	      {
    	        var newState = finishedWork.memoizedState;
    	        var isHidden = newState !== null;
    	        hideOrUnhideAllChildren(finishedWork, isHidden);
    	        return;
    	      }
    	  }

    	  {
    	    {
    	      throw Error( "This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  }
    	}

    	function commitSuspenseComponent(finishedWork) {
    	  var newState = finishedWork.memoizedState;

    	  if (newState !== null) {
    	    markCommitTimeOfFallback();

    	    {
    	      // Hide the Offscreen component that contains the primary children. TODO:
    	      // Ideally, this effect would have been scheduled on the Offscreen fiber
    	      // itself. That's how unhiding works: the Offscreen component schedules an
    	      // effect on itself. However, in this case, the component didn't complete,
    	      // so the fiber was never added to the effect list in the normal path. We
    	      // could have appended it to the effect list in the Suspense component's
    	      // second pass, but doing it this way is less complicated. This would be
    	      // simpler if we got rid of the effect list and traversed the tree, like
    	      // we're planning to do.
    	      var primaryChildParent = finishedWork.child;
    	      hideOrUnhideAllChildren(primaryChildParent, true);
    	    }
    	  }
    	}

    	function commitSuspenseHydrationCallbacks(finishedRoot, finishedWork) {

    	  var newState = finishedWork.memoizedState;

    	  if (newState === null) {
    	    var current = finishedWork.alternate;

    	    if (current !== null) {
    	      var prevState = current.memoizedState;

    	      if (prevState !== null) {
    	        var suspenseInstance = prevState.dehydrated;

    	        if (suspenseInstance !== null) {
    	          commitHydratedSuspenseInstance(suspenseInstance);
    	        }
    	      }
    	    }
    	  }
    	}

    	function attachSuspenseRetryListeners(finishedWork) {
    	  // If this boundary just timed out, then it will have a set of wakeables.
    	  // For each wakeable, attach a listener so that when it resolves, React
    	  // attempts to re-render the boundary in the primary (pre-timeout) state.
    	  var wakeables = finishedWork.updateQueue;

    	  if (wakeables !== null) {
    	    finishedWork.updateQueue = null;
    	    var retryCache = finishedWork.stateNode;

    	    if (retryCache === null) {
    	      retryCache = finishedWork.stateNode = new PossiblyWeakSet();
    	    }

    	    wakeables.forEach(function (wakeable) {
    	      // Memoize using the boundary fiber to prevent redundant listeners.
    	      var retry = resolveRetryWakeable.bind(null, finishedWork, wakeable);

    	      if (!retryCache.has(wakeable)) {
    	        {
    	          if (wakeable.__reactDoNotTraceInteractions !== true) {
    	            retry = tracing.unstable_wrap(retry);
    	          }
    	        }

    	        retryCache.add(wakeable);
    	        wakeable.then(retry, retry);
    	      }
    	    });
    	  }
    	} // This function detects when a Suspense boundary goes from visible to hidden.
    	// It returns false if the boundary is already hidden.
    	// TODO: Use an effect tag.


    	function isSuspenseBoundaryBeingHidden(current, finishedWork) {
    	  if (current !== null) {
    	    var oldState = current.memoizedState;

    	    if (oldState === null || oldState.dehydrated !== null) {
    	      var newState = finishedWork.memoizedState;
    	      return newState !== null && newState.dehydrated === null;
    	    }
    	  }

    	  return false;
    	}

    	function commitResetTextContent(current) {

    	  resetTextContent(current.stateNode);
    	}

    	if (typeof Symbol === 'function' && Symbol.for) {
    	  var symbolFor$1 = Symbol.for;
    	  symbolFor$1('selector.component');
    	  symbolFor$1('selector.has_pseudo_class');
    	  symbolFor$1('selector.role');
    	  symbolFor$1('selector.test_id');
    	  symbolFor$1('selector.text');
    	}
    	var commitHooks = [];
    	function onCommitRoot$1() {
    	  {
    	    commitHooks.forEach(function (commitHook) {
    	      return commitHook();
    	    });
    	  }
    	}

    	var ceil = Math.ceil;
    	var ReactCurrentDispatcher$2 = ReactSharedInternals.ReactCurrentDispatcher,
    	    ReactCurrentOwner$2 = ReactSharedInternals.ReactCurrentOwner,
    	    IsSomeRendererActing = ReactSharedInternals.IsSomeRendererActing;
    	var NoContext =
    	/*             */
    	0;
    	var BatchedContext =
    	/*               */
    	1;
    	var EventContext =
    	/*                 */
    	2;
    	var DiscreteEventContext =
    	/*         */
    	4;
    	var LegacyUnbatchedContext =
    	/*       */
    	8;
    	var RenderContext =
    	/*                */
    	16;
    	var CommitContext =
    	/*                */
    	32;
    	var RetryAfterError =
    	/*       */
    	64;
    	var RootIncomplete = 0;
    	var RootFatalErrored = 1;
    	var RootErrored = 2;
    	var RootSuspended = 3;
    	var RootSuspendedWithDelay = 4;
    	var RootCompleted = 5; // Describes where we are in the React execution stack

    	var executionContext = NoContext; // The root we're working on

    	var workInProgressRoot = null; // The fiber we're working on

    	var workInProgress = null; // The lanes we're rendering

    	var workInProgressRootRenderLanes = NoLanes; // Stack that allows components to change the render lanes for its subtree
    	// This is a superset of the lanes we started working on at the root. The only
    	// case where it's different from `workInProgressRootRenderLanes` is when we
    	// enter a subtree that is hidden and needs to be unhidden: Suspense and
    	// Offscreen component.
    	//
    	// Most things in the work loop should deal with workInProgressRootRenderLanes.
    	// Most things in begin/complete phases should deal with subtreeRenderLanes.

    	var subtreeRenderLanes = NoLanes;
    	var subtreeRenderLanesCursor = createCursor(NoLanes); // Whether to root completed, errored, suspended, etc.

    	var workInProgressRootExitStatus = RootIncomplete; // A fatal error, if one is thrown

    	var workInProgressRootFatalError = null; // "Included" lanes refer to lanes that were worked on during this render. It's
    	// slightly different than `renderLanes` because `renderLanes` can change as you
    	// enter and exit an Offscreen tree. This value is the combination of all render
    	// lanes for the entire render phase.

    	var workInProgressRootIncludedLanes = NoLanes; // The work left over by components that were visited during this render. Only
    	// includes unprocessed updates, not work in bailed out children.

    	var workInProgressRootSkippedLanes = NoLanes; // Lanes that were updated (in an interleaved event) during this render.

    	var workInProgressRootUpdatedLanes = NoLanes; // Lanes that were pinged (in an interleaved event) during this render.

    	var workInProgressRootPingedLanes = NoLanes;
    	var mostRecentlyUpdatedRoot = null; // The most recent time we committed a fallback. This lets us ensure a train
    	// model where we don't commit new loading states in too quick succession.

    	var globalMostRecentFallbackTime = 0;
    	var FALLBACK_THROTTLE_MS = 500; // The absolute time for when we should start giving up on rendering
    	// more and prefer CPU suspense heuristics instead.

    	var workInProgressRootRenderTargetTime = Infinity; // How long a render is supposed to take before we start following CPU
    	// suspense heuristics and opt out of rendering more content.

    	var RENDER_TIMEOUT_MS = 500;

    	function resetRenderTimer() {
    	  workInProgressRootRenderTargetTime = now() + RENDER_TIMEOUT_MS;
    	}

    	function getRenderTargetTime() {
    	  return workInProgressRootRenderTargetTime;
    	}
    	var nextEffect = null;
    	var hasUncaughtError = false;
    	var firstUncaughtError = null;
    	var legacyErrorBoundariesThatAlreadyFailed = null;
    	var rootDoesHavePassiveEffects = false;
    	var rootWithPendingPassiveEffects = null;
    	var pendingPassiveEffectsRenderPriority = NoPriority$1;
    	var pendingPassiveEffectsLanes = NoLanes;
    	var pendingPassiveHookEffectsMount = [];
    	var pendingPassiveHookEffectsUnmount = [];
    	var rootsWithPendingDiscreteUpdates = null; // Use these to prevent an infinite loop of nested updates

    	var NESTED_UPDATE_LIMIT = 50;
    	var nestedUpdateCount = 0;
    	var rootWithNestedUpdates = null;
    	var NESTED_PASSIVE_UPDATE_LIMIT = 50;
    	var nestedPassiveUpdateCount = 0; // Marks the need to reschedule pending interactions at these lanes
    	// during the commit phase. This enables them to be traced across components
    	// that spawn new work during render. E.g. hidden boundaries, suspended SSR
    	// hydration or SuspenseList.
    	// TODO: Can use a bitmask instead of an array

    	var spawnedWorkDuringRender = null; // If two updates are scheduled within the same event, we should treat their
    	// event times as simultaneous, even if the actual clock time has advanced
    	// between the first and second call.

    	var currentEventTime = NoTimestamp;
    	var currentEventWipLanes = NoLanes;
    	var currentEventPendingLanes = NoLanes; // Dev only flag that tracks if passive effects are currently being flushed.
    	// We warn about state updates for unmounted components differently in this case.

    	var isFlushingPassiveEffects = false;
    	var focusedInstanceHandle = null;
    	var shouldFireAfterActiveInstanceBlur = false;
    	function getWorkInProgressRoot() {
    	  return workInProgressRoot;
    	}
    	function requestEventTime() {
    	  if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
    	    // We're inside React, so it's fine to read the actual time.
    	    return now();
    	  } // We're not inside React, so we may be in the middle of a browser event.


    	  if (currentEventTime !== NoTimestamp) {
    	    // Use the same start time for all updates until we enter React again.
    	    return currentEventTime;
    	  } // This is the first update since React yielded. Compute a new start time.


    	  currentEventTime = now();
    	  return currentEventTime;
    	}
    	function requestUpdateLane(fiber) {
    	  // Special cases
    	  var mode = fiber.mode;

    	  if ((mode & BlockingMode) === NoMode) {
    	    return SyncLane;
    	  } else if ((mode & ConcurrentMode) === NoMode) {
    	    return getCurrentPriorityLevel() === ImmediatePriority$1 ? SyncLane : SyncBatchedLane;
    	  } // The algorithm for assigning an update to a lane should be stable for all
    	  // updates at the same priority within the same event. To do this, the inputs
    	  // to the algorithm must be the same. For example, we use the `renderLanes`
    	  // to avoid choosing a lane that is already in the middle of rendering.
    	  //
    	  // However, the "included" lanes could be mutated in between updates in the
    	  // same event, like if you perform an update inside `flushSync`. Or any other
    	  // code path that might call `prepareFreshStack`.
    	  //
    	  // The trick we use is to cache the first of each of these inputs within an
    	  // event. Then reset the cached values once we can be sure the event is over.
    	  // Our heuristic for that is whenever we enter a concurrent work loop.
    	  //
    	  // We'll do the same for `currentEventPendingLanes` below.


    	  if (currentEventWipLanes === NoLanes) {
    	    currentEventWipLanes = workInProgressRootIncludedLanes;
    	  }

    	  var isTransition = requestCurrentTransition() !== NoTransition;

    	  if (isTransition) {
    	    if (currentEventPendingLanes !== NoLanes) {
    	      currentEventPendingLanes = mostRecentlyUpdatedRoot !== null ? mostRecentlyUpdatedRoot.pendingLanes : NoLanes;
    	    }

    	    return findTransitionLane(currentEventWipLanes, currentEventPendingLanes);
    	  } // TODO: Remove this dependency on the Scheduler priority.
    	  // To do that, we're replacing it with an update lane priority.


    	  var schedulerPriority = getCurrentPriorityLevel(); // The old behavior was using the priority level of the Scheduler.
    	  // This couples React to the Scheduler internals, so we're replacing it
    	  // with the currentUpdateLanePriority above. As an example of how this
    	  // could be problematic, if we're not inside `Scheduler.runWithPriority`,
    	  // then we'll get the priority of the current running Scheduler task,
    	  // which is probably not what we want.

    	  var lane;

    	  if ( // TODO: Temporary. We're removing the concept of discrete updates.
    	  (executionContext & DiscreteEventContext) !== NoContext && schedulerPriority === UserBlockingPriority$2) {
    	    lane = findUpdateLane(InputDiscreteLanePriority, currentEventWipLanes);
    	  } else {
    	    var schedulerLanePriority = schedulerPriorityToLanePriority(schedulerPriority);

    	    lane = findUpdateLane(schedulerLanePriority, currentEventWipLanes);
    	  }

    	  return lane;
    	}

    	function requestRetryLane(fiber) {
    	  // This is a fork of `requestUpdateLane` designed specifically for Suspense
    	  // "retries" — a special update that attempts to flip a Suspense boundary
    	  // from its placeholder state to its primary/resolved state.
    	  // Special cases
    	  var mode = fiber.mode;

    	  if ((mode & BlockingMode) === NoMode) {
    	    return SyncLane;
    	  } else if ((mode & ConcurrentMode) === NoMode) {
    	    return getCurrentPriorityLevel() === ImmediatePriority$1 ? SyncLane : SyncBatchedLane;
    	  } // See `requestUpdateLane` for explanation of `currentEventWipLanes`


    	  if (currentEventWipLanes === NoLanes) {
    	    currentEventWipLanes = workInProgressRootIncludedLanes;
    	  }

    	  return findRetryLane(currentEventWipLanes);
    	}

    	function scheduleUpdateOnFiber(fiber, lane, eventTime) {
    	  checkForNestedUpdates();
    	  warnAboutRenderPhaseUpdatesInDEV(fiber);
    	  var root = markUpdateLaneFromFiberToRoot(fiber, lane);

    	  if (root === null) {
    	    warnAboutUpdateOnUnmountedFiberInDEV(fiber);
    	    return null;
    	  } // Mark that the root has a pending update.


    	  markRootUpdated(root, lane, eventTime);

    	  if (root === workInProgressRoot) {
    	    // Received an update to a tree that's in the middle of rendering. Mark
    	    // that there was an interleaved update work on this root. Unless the
    	    // `deferRenderPhaseUpdateToNextBatch` flag is off and this is a render
    	    // phase update. In that case, we don't treat render phase updates as if
    	    // they were interleaved, for backwards compat reasons.
    	    {
    	      workInProgressRootUpdatedLanes = mergeLanes(workInProgressRootUpdatedLanes, lane);
    	    }

    	    if (workInProgressRootExitStatus === RootSuspendedWithDelay) {
    	      // The root already suspended with a delay, which means this render
    	      // definitely won't finish. Since we have a new update, let's mark it as
    	      // suspended now, right before marking the incoming update. This has the
    	      // effect of interrupting the current render and switching to the update.
    	      // TODO: Make sure this doesn't override pings that happen while we've
    	      // already started rendering.
    	      markRootSuspended$1(root, workInProgressRootRenderLanes);
    	    }
    	  } // TODO: requestUpdateLanePriority also reads the priority. Pass the
    	  // priority as an argument to that function and this one.


    	  var priorityLevel = getCurrentPriorityLevel();

    	  if (lane === SyncLane) {
    	    if ( // Check if we're inside unbatchedUpdates
    	    (executionContext & LegacyUnbatchedContext) !== NoContext && // Check if we're not already rendering
    	    (executionContext & (RenderContext | CommitContext)) === NoContext) {
    	      // Register pending interactions on the root to avoid losing traced interaction data.
    	      schedulePendingInteractions(root, lane); // This is a legacy edge case. The initial mount of a ReactDOM.render-ed
    	      // root inside of batchedUpdates should be synchronous, but layout updates
    	      // should be deferred until the end of the batch.

    	      performSyncWorkOnRoot(root);
    	    } else {
    	      ensureRootIsScheduled(root, eventTime);
    	      schedulePendingInteractions(root, lane);

    	      if (executionContext === NoContext) {
    	        // Flush the synchronous work now, unless we're already working or inside
    	        // a batch. This is intentionally inside scheduleUpdateOnFiber instead of
    	        // scheduleCallbackForFiber to preserve the ability to schedule a callback
    	        // without immediately flushing it. We only do this for user-initiated
    	        // updates, to preserve historical behavior of legacy mode.
    	        resetRenderTimer();
    	        flushSyncCallbackQueue();
    	      }
    	    }
    	  } else {
    	    // Schedule a discrete update but only if it's not Sync.
    	    if ((executionContext & DiscreteEventContext) !== NoContext && ( // Only updates at user-blocking priority or greater are considered
    	    // discrete, even inside a discrete event.
    	    priorityLevel === UserBlockingPriority$2 || priorityLevel === ImmediatePriority$1)) {
    	      // This is the result of a discrete event. Track the lowest priority
    	      // discrete update per root so we can flush them early, if needed.
    	      if (rootsWithPendingDiscreteUpdates === null) {
    	        rootsWithPendingDiscreteUpdates = new Set([root]);
    	      } else {
    	        rootsWithPendingDiscreteUpdates.add(root);
    	      }
    	    } // Schedule other updates after in case the callback is sync.


    	    ensureRootIsScheduled(root, eventTime);
    	    schedulePendingInteractions(root, lane);
    	  } // We use this when assigning a lane for a transition inside
    	  // `requestUpdateLane`. We assume it's the same as the root being updated,
    	  // since in the common case of a single root app it probably is. If it's not
    	  // the same root, then it's not a huge deal, we just might batch more stuff
    	  // together more than necessary.


    	  mostRecentlyUpdatedRoot = root;
    	} // This is split into a separate function so we can mark a fiber with pending
    	// work without treating it as a typical update that originates from an event;
    	// e.g. retrying a Suspense boundary isn't an update, but it does schedule work
    	// on a fiber.

    	function markUpdateLaneFromFiberToRoot(sourceFiber, lane) {
    	  // Update the source fiber's lanes
    	  sourceFiber.lanes = mergeLanes(sourceFiber.lanes, lane);
    	  var alternate = sourceFiber.alternate;

    	  if (alternate !== null) {
    	    alternate.lanes = mergeLanes(alternate.lanes, lane);
    	  }

    	  {
    	    if (alternate === null && (sourceFiber.flags & (Placement | Hydrating)) !== NoFlags) {
    	      warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber);
    	    }
    	  } // Walk the parent path to the root and update the child expiration time.


    	  var node = sourceFiber;
    	  var parent = sourceFiber.return;

    	  while (parent !== null) {
    	    parent.childLanes = mergeLanes(parent.childLanes, lane);
    	    alternate = parent.alternate;

    	    if (alternate !== null) {
    	      alternate.childLanes = mergeLanes(alternate.childLanes, lane);
    	    } else {
    	      {
    	        if ((parent.flags & (Placement | Hydrating)) !== NoFlags) {
    	          warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber);
    	        }
    	      }
    	    }

    	    node = parent;
    	    parent = parent.return;
    	  }

    	  if (node.tag === HostRoot) {
    	    var root = node.stateNode;
    	    return root;
    	  } else {
    	    return null;
    	  }
    	} // Use this function to schedule a task for a root. There's only one task per
    	// root; if a task was already scheduled, we'll check to make sure the priority
    	// of the existing task is the same as the priority of the next level that the
    	// root has work on. This function is called on every update, and right before
    	// exiting a task.


    	function ensureRootIsScheduled(root, currentTime) {
    	  var existingCallbackNode = root.callbackNode; // Check if any lanes are being starved by other work. If so, mark them as
    	  // expired so we know to work on those next.

    	  markStarvedLanesAsExpired(root, currentTime); // Determine the next lanes to work on, and their priority.

    	  var nextLanes = getNextLanes(root, root === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes); // This returns the priority level computed during the `getNextLanes` call.

    	  var newCallbackPriority = returnNextLanesPriority();

    	  if (nextLanes === NoLanes) {
    	    // Special case: There's nothing to work on.
    	    if (existingCallbackNode !== null) {
    	      cancelCallback(existingCallbackNode);
    	      root.callbackNode = null;
    	      root.callbackPriority = NoLanePriority;
    	    }

    	    return;
    	  } // Check if there's an existing task. We may be able to reuse it.


    	  if (existingCallbackNode !== null) {
    	    var existingCallbackPriority = root.callbackPriority;

    	    if (existingCallbackPriority === newCallbackPriority) {
    	      // The priority hasn't changed. We can reuse the existing task. Exit.
    	      return;
    	    } // The priority changed. Cancel the existing callback. We'll schedule a new
    	    // one below.


    	    cancelCallback(existingCallbackNode);
    	  } // Schedule a new callback.


    	  var newCallbackNode;

    	  if (newCallbackPriority === SyncLanePriority) {
    	    // Special case: Sync React callbacks are scheduled on a special
    	    // internal queue
    	    newCallbackNode = scheduleSyncCallback(performSyncWorkOnRoot.bind(null, root));
    	  } else if (newCallbackPriority === SyncBatchedLanePriority) {
    	    newCallbackNode = scheduleCallback(ImmediatePriority$1, performSyncWorkOnRoot.bind(null, root));
    	  } else {
    	    var schedulerPriorityLevel = lanePriorityToSchedulerPriority(newCallbackPriority);
    	    newCallbackNode = scheduleCallback(schedulerPriorityLevel, performConcurrentWorkOnRoot.bind(null, root));
    	  }

    	  root.callbackPriority = newCallbackPriority;
    	  root.callbackNode = newCallbackNode;
    	} // This is the entry point for every concurrent task, i.e. anything that
    	// goes through Scheduler.


    	function performConcurrentWorkOnRoot(root) {
    	  // Since we know we're in a React event, we can clear the current
    	  // event time. The next update will compute a new event time.
    	  currentEventTime = NoTimestamp;
    	  currentEventWipLanes = NoLanes;
    	  currentEventPendingLanes = NoLanes;

    	  if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
    	    {
    	      throw Error( "Should not already be working." );
    	    }
    	  } // Flush any pending passive effects before deciding which lanes to work on,
    	  // in case they schedule additional work.


    	  var originalCallbackNode = root.callbackNode;
    	  var didFlushPassiveEffects = flushPassiveEffects();

    	  if (didFlushPassiveEffects) {
    	    // Something in the passive effect phase may have canceled the current task.
    	    // Check if the task node for this root was changed.
    	    if (root.callbackNode !== originalCallbackNode) {
    	      // The current task was canceled. Exit. We don't need to call
    	      // `ensureRootIsScheduled` because the check above implies either that
    	      // there's a new task, or that there's no remaining work on this root.
    	      return null;
    	    }
    	  } // Determine the next expiration time to work on, using the fields stored
    	  // on the root.


    	  var lanes = getNextLanes(root, root === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes);

    	  if (lanes === NoLanes) {
    	    // Defensive coding. This is never expected to happen.
    	    return null;
    	  }

    	  var exitStatus = renderRootConcurrent(root, lanes);

    	  if (includesSomeLane(workInProgressRootIncludedLanes, workInProgressRootUpdatedLanes)) {
    	    // The render included lanes that were updated during the render phase.
    	    // For example, when unhiding a hidden tree, we include all the lanes
    	    // that were previously skipped when the tree was hidden. That set of
    	    // lanes is a superset of the lanes we started rendering with.
    	    //
    	    // So we'll throw out the current work and restart.
    	    prepareFreshStack(root, NoLanes);
    	  } else if (exitStatus !== RootIncomplete) {
    	    if (exitStatus === RootErrored) {
    	      executionContext |= RetryAfterError; // If an error occurred during hydration,
    	      // discard server response and fall back to client side render.

    	      if (root.hydrate) {
    	        root.hydrate = false;
    	        clearContainer(root.containerInfo);
    	      } // If something threw an error, try rendering one more time. We'll render
    	      // synchronously to block concurrent data mutations, and we'll includes
    	      // all pending updates are included. If it still fails after the second
    	      // attempt, we'll give up and commit the resulting tree.


    	      lanes = getLanesToRetrySynchronouslyOnError(root);

    	      if (lanes !== NoLanes) {
    	        exitStatus = renderRootSync(root, lanes);
    	      }
    	    }

    	    if (exitStatus === RootFatalErrored) {
    	      var fatalError = workInProgressRootFatalError;
    	      prepareFreshStack(root, NoLanes);
    	      markRootSuspended$1(root, lanes);
    	      ensureRootIsScheduled(root, now());
    	      throw fatalError;
    	    } // We now have a consistent tree. The next step is either to commit it,
    	    // or, if something suspended, wait to commit it after a timeout.


    	    var finishedWork = root.current.alternate;
    	    root.finishedWork = finishedWork;
    	    root.finishedLanes = lanes;
    	    finishConcurrentRender(root, exitStatus, lanes);
    	  }

    	  ensureRootIsScheduled(root, now());

    	  if (root.callbackNode === originalCallbackNode) {
    	    // The task node scheduled for this root is the same one that's
    	    // currently executed. Need to return a continuation.
    	    return performConcurrentWorkOnRoot.bind(null, root);
    	  }

    	  return null;
    	}

    	function finishConcurrentRender(root, exitStatus, lanes) {
    	  switch (exitStatus) {
    	    case RootIncomplete:
    	    case RootFatalErrored:
    	      {
    	        {
    	          {
    	            throw Error( "Root did not complete. This is a bug in React." );
    	          }
    	        }
    	      }
    	    // Flow knows about invariant, so it complains if I add a break
    	    // statement, but eslint doesn't know about invariant, so it complains
    	    // if I do. eslint-disable-next-line no-fallthrough

    	    case RootErrored:
    	      {
    	        // We should have already attempted to retry this tree. If we reached
    	        // this point, it errored again. Commit it.
    	        commitRoot(root);
    	        break;
    	      }

    	    case RootSuspended:
    	      {
    	        markRootSuspended$1(root, lanes); // We have an acceptable loading state. We need to figure out if we
    	        // should immediately commit it or wait a bit.

    	        if (includesOnlyRetries(lanes) && // do not delay if we're inside an act() scope
    	        !shouldForceFlushFallbacksInDEV()) {
    	          // This render only included retries, no updates. Throttle committing
    	          // retries so that we don't show too many loading states too quickly.
    	          var msUntilTimeout = globalMostRecentFallbackTime + FALLBACK_THROTTLE_MS - now(); // Don't bother with a very short suspense time.

    	          if (msUntilTimeout > 10) {
    	            var nextLanes = getNextLanes(root, NoLanes);

    	            if (nextLanes !== NoLanes) {
    	              // There's additional work on this root.
    	              break;
    	            }

    	            var suspendedLanes = root.suspendedLanes;

    	            if (!isSubsetOfLanes(suspendedLanes, lanes)) {
    	              // We should prefer to render the fallback of at the last
    	              // suspended level. Ping the last suspended level to try
    	              // rendering it again.
    	              // FIXME: What if the suspended lanes are Idle? Should not restart.
    	              requestEventTime();
    	              markRootPinged(root, suspendedLanes);
    	              break;
    	            } // The render is suspended, it hasn't timed out, and there's no
    	            // lower priority work to do. Instead of committing the fallback
    	            // immediately, wait for more data to arrive.


    	            root.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root), msUntilTimeout);
    	            break;
    	          }
    	        } // The work expired. Commit immediately.


    	        commitRoot(root);
    	        break;
    	      }

    	    case RootSuspendedWithDelay:
    	      {
    	        markRootSuspended$1(root, lanes);

    	        if (includesOnlyTransitions(lanes)) {
    	          // This is a transition, so we should exit without committing a
    	          // placeholder and without scheduling a timeout. Delay indefinitely
    	          // until we receive more data.
    	          break;
    	        }

    	        {
    	          // This is not a transition, but we did trigger an avoided state.
    	          // Schedule a placeholder to display after a short delay, using the Just
    	          // Noticeable Difference.
    	          // TODO: Is the JND optimization worth the added complexity? If this is
    	          // the only reason we track the event time, then probably not.
    	          // Consider removing.
    	          var mostRecentEventTime = getMostRecentEventTime(root, lanes);
    	          var eventTimeMs = mostRecentEventTime;
    	          var timeElapsedMs = now() - eventTimeMs;

    	          var _msUntilTimeout = jnd(timeElapsedMs) - timeElapsedMs; // Don't bother with a very short suspense time.


    	          if (_msUntilTimeout > 10) {
    	            // Instead of committing the fallback immediately, wait for more data
    	            // to arrive.
    	            root.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root), _msUntilTimeout);
    	            break;
    	          }
    	        } // Commit the placeholder.


    	        commitRoot(root);
    	        break;
    	      }

    	    case RootCompleted:
    	      {
    	        // The work completed. Ready to commit.
    	        commitRoot(root);
    	        break;
    	      }

    	    default:
    	      {
    	        {
    	          {
    	            throw Error( "Unknown root exit status." );
    	          }
    	        }
    	      }
    	  }
    	}

    	function markRootSuspended$1(root, suspendedLanes) {
    	  // When suspending, we should always exclude lanes that were pinged or (more
    	  // rarely, since we try to avoid it) updated during the render phase.
    	  // TODO: Lol maybe there's a better way to factor this besides this
    	  // obnoxiously named function :)
    	  suspendedLanes = removeLanes(suspendedLanes, workInProgressRootPingedLanes);
    	  suspendedLanes = removeLanes(suspendedLanes, workInProgressRootUpdatedLanes);
    	  markRootSuspended(root, suspendedLanes);
    	} // This is the entry point for synchronous tasks that don't go
    	// through Scheduler


    	function performSyncWorkOnRoot(root) {
    	  if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
    	    {
    	      throw Error( "Should not already be working." );
    	    }
    	  }

    	  flushPassiveEffects();
    	  var lanes;
    	  var exitStatus;

    	  if (root === workInProgressRoot && includesSomeLane(root.expiredLanes, workInProgressRootRenderLanes)) {
    	    // There's a partial tree, and at least one of its lanes has expired. Finish
    	    // rendering it before rendering the rest of the expired work.
    	    lanes = workInProgressRootRenderLanes;
    	    exitStatus = renderRootSync(root, lanes);

    	    if (includesSomeLane(workInProgressRootIncludedLanes, workInProgressRootUpdatedLanes)) {
    	      // The render included lanes that were updated during the render phase.
    	      // For example, when unhiding a hidden tree, we include all the lanes
    	      // that were previously skipped when the tree was hidden. That set of
    	      // lanes is a superset of the lanes we started rendering with.
    	      //
    	      // Note that this only happens when part of the tree is rendered
    	      // concurrently. If the whole tree is rendered synchronously, then there
    	      // are no interleaved events.
    	      lanes = getNextLanes(root, lanes);
    	      exitStatus = renderRootSync(root, lanes);
    	    }
    	  } else {
    	    lanes = getNextLanes(root, NoLanes);
    	    exitStatus = renderRootSync(root, lanes);
    	  }

    	  if (root.tag !== LegacyRoot && exitStatus === RootErrored) {
    	    executionContext |= RetryAfterError; // If an error occurred during hydration,
    	    // discard server response and fall back to client side render.

    	    if (root.hydrate) {
    	      root.hydrate = false;
    	      clearContainer(root.containerInfo);
    	    } // If something threw an error, try rendering one more time. We'll render
    	    // synchronously to block concurrent data mutations, and we'll includes
    	    // all pending updates are included. If it still fails after the second
    	    // attempt, we'll give up and commit the resulting tree.


    	    lanes = getLanesToRetrySynchronouslyOnError(root);

    	    if (lanes !== NoLanes) {
    	      exitStatus = renderRootSync(root, lanes);
    	    }
    	  }

    	  if (exitStatus === RootFatalErrored) {
    	    var fatalError = workInProgressRootFatalError;
    	    prepareFreshStack(root, NoLanes);
    	    markRootSuspended$1(root, lanes);
    	    ensureRootIsScheduled(root, now());
    	    throw fatalError;
    	  } // We now have a consistent tree. Because this is a sync render, we
    	  // will commit it even if something suspended.


    	  var finishedWork = root.current.alternate;
    	  root.finishedWork = finishedWork;
    	  root.finishedLanes = lanes;
    	  commitRoot(root); // Before exiting, make sure there's a callback scheduled for the next
    	  // pending level.

    	  ensureRootIsScheduled(root, now());
    	  return null;
    	}
    	function flushDiscreteUpdates() {
    	  // TODO: Should be able to flush inside batchedUpdates, but not inside `act`.
    	  // However, `act` uses `batchedUpdates`, so there's no way to distinguish
    	  // those two cases. Need to fix this before exposing flushDiscreteUpdates
    	  // as a public API.
    	  if ((executionContext & (BatchedContext | RenderContext | CommitContext)) !== NoContext) {
    	    {
    	      if ((executionContext & RenderContext) !== NoContext) {
    	        error('unstable_flushDiscreteUpdates: Cannot flush updates when React is ' + 'already rendering.');
    	      }
    	    } // We're already rendering, so we can't synchronously flush pending work.
    	    // This is probably a nested event dispatch triggered by a lifecycle/effect,
    	    // like `el.focus()`. Exit.


    	    return;
    	  }

    	  flushPendingDiscreteUpdates(); // If the discrete updates scheduled passive effects, flush them now so that
    	  // they fire before the next serial event.

    	  flushPassiveEffects();
    	}

    	function flushPendingDiscreteUpdates() {
    	  if (rootsWithPendingDiscreteUpdates !== null) {
    	    // For each root with pending discrete updates, schedule a callback to
    	    // immediately flush them.
    	    var roots = rootsWithPendingDiscreteUpdates;
    	    rootsWithPendingDiscreteUpdates = null;
    	    roots.forEach(function (root) {
    	      markDiscreteUpdatesExpired(root);
    	      ensureRootIsScheduled(root, now());
    	    });
    	  } // Now flush the immediate queue.


    	  flushSyncCallbackQueue();
    	}

    	function batchedUpdates$1(fn, a) {
    	  var prevExecutionContext = executionContext;
    	  executionContext |= BatchedContext;

    	  try {
    	    return fn(a);
    	  } finally {
    	    executionContext = prevExecutionContext;

    	    if (executionContext === NoContext) {
    	      // Flush the immediate callbacks that were scheduled during this batch
    	      resetRenderTimer();
    	      flushSyncCallbackQueue();
    	    }
    	  }
    	}
    	function batchedEventUpdates$1(fn, a) {
    	  var prevExecutionContext = executionContext;
    	  executionContext |= EventContext;

    	  try {
    	    return fn(a);
    	  } finally {
    	    executionContext = prevExecutionContext;

    	    if (executionContext === NoContext) {
    	      // Flush the immediate callbacks that were scheduled during this batch
    	      resetRenderTimer();
    	      flushSyncCallbackQueue();
    	    }
    	  }
    	}
    	function discreteUpdates$1(fn, a, b, c, d) {
    	  var prevExecutionContext = executionContext;
    	  executionContext |= DiscreteEventContext;

    	  {
    	    try {
    	      return runWithPriority$1(UserBlockingPriority$2, fn.bind(null, a, b, c, d));
    	    } finally {
    	      executionContext = prevExecutionContext;

    	      if (executionContext === NoContext) {
    	        // Flush the immediate callbacks that were scheduled during this batch
    	        resetRenderTimer();
    	        flushSyncCallbackQueue();
    	      }
    	    }
    	  }
    	}
    	function unbatchedUpdates(fn, a) {
    	  var prevExecutionContext = executionContext;
    	  executionContext &= ~BatchedContext;
    	  executionContext |= LegacyUnbatchedContext;

    	  try {
    	    return fn(a);
    	  } finally {
    	    executionContext = prevExecutionContext;

    	    if (executionContext === NoContext) {
    	      // Flush the immediate callbacks that were scheduled during this batch
    	      resetRenderTimer();
    	      flushSyncCallbackQueue();
    	    }
    	  }
    	}
    	function flushSync(fn, a) {
    	  var prevExecutionContext = executionContext;

    	  if ((prevExecutionContext & (RenderContext | CommitContext)) !== NoContext) {
    	    {
    	      error('flushSync was called from inside a lifecycle method. React cannot ' + 'flush when React is already rendering. Consider moving this call to ' + 'a scheduler task or micro task.');
    	    }

    	    return fn(a);
    	  }

    	  executionContext |= BatchedContext;

    	  {
    	    try {
    	      if (fn) {
    	        return runWithPriority$1(ImmediatePriority$1, fn.bind(null, a));
    	      } else {
    	        return undefined;
    	      }
    	    } finally {
    	      executionContext = prevExecutionContext; // Flush the immediate callbacks that were scheduled during this batch.
    	      // Note that this will happen even if batchedUpdates is higher up
    	      // the stack.

    	      flushSyncCallbackQueue();
    	    }
    	  }
    	}
    	function pushRenderLanes(fiber, lanes) {
    	  push(subtreeRenderLanesCursor, subtreeRenderLanes, fiber);
    	  subtreeRenderLanes = mergeLanes(subtreeRenderLanes, lanes);
    	  workInProgressRootIncludedLanes = mergeLanes(workInProgressRootIncludedLanes, lanes);
    	}
    	function popRenderLanes(fiber) {
    	  subtreeRenderLanes = subtreeRenderLanesCursor.current;
    	  pop(subtreeRenderLanesCursor, fiber);
    	}

    	function prepareFreshStack(root, lanes) {
    	  root.finishedWork = null;
    	  root.finishedLanes = NoLanes;
    	  var timeoutHandle = root.timeoutHandle;

    	  if (timeoutHandle !== noTimeout) {
    	    // The root previous suspended and scheduled a timeout to commit a fallback
    	    // state. Now that we have additional work, cancel the timeout.
    	    root.timeoutHandle = noTimeout; // $FlowFixMe Complains noTimeout is not a TimeoutID, despite the check above

    	    cancelTimeout(timeoutHandle);
    	  }

    	  if (workInProgress !== null) {
    	    var interruptedWork = workInProgress.return;

    	    while (interruptedWork !== null) {
    	      unwindInterruptedWork(interruptedWork);
    	      interruptedWork = interruptedWork.return;
    	    }
    	  }

    	  workInProgressRoot = root;
    	  workInProgress = createWorkInProgress(root.current, null);
    	  workInProgressRootRenderLanes = subtreeRenderLanes = workInProgressRootIncludedLanes = lanes;
    	  workInProgressRootExitStatus = RootIncomplete;
    	  workInProgressRootFatalError = null;
    	  workInProgressRootSkippedLanes = NoLanes;
    	  workInProgressRootUpdatedLanes = NoLanes;
    	  workInProgressRootPingedLanes = NoLanes;

    	  {
    	    spawnedWorkDuringRender = null;
    	  }

    	  {
    	    ReactStrictModeWarnings.discardPendingWarnings();
    	  }
    	}

    	function handleError(root, thrownValue) {
    	  do {
    	    var erroredWork = workInProgress;

    	    try {
    	      // Reset module-level state that was set during the render phase.
    	      resetContextDependencies();
    	      resetHooksAfterThrow();
    	      resetCurrentFiber(); // TODO: I found and added this missing line while investigating a
    	      // separate issue. Write a regression test using string refs.

    	      ReactCurrentOwner$2.current = null;

    	      if (erroredWork === null || erroredWork.return === null) {
    	        // Expected to be working on a non-root fiber. This is a fatal error
    	        // because there's no ancestor that can handle it; the root is
    	        // supposed to capture all errors that weren't caught by an error
    	        // boundary.
    	        workInProgressRootExitStatus = RootFatalErrored;
    	        workInProgressRootFatalError = thrownValue; // Set `workInProgress` to null. This represents advancing to the next
    	        // sibling, or the parent if there are no siblings. But since the root
    	        // has no siblings nor a parent, we set it to null. Usually this is
    	        // handled by `completeUnitOfWork` or `unwindWork`, but since we're
    	        // intentionally not calling those, we need set it here.
    	        // TODO: Consider calling `unwindWork` to pop the contexts.

    	        workInProgress = null;
    	        return;
    	      }

    	      if (enableProfilerTimer && erroredWork.mode & ProfileMode) {
    	        // Record the time spent rendering before an error was thrown. This
    	        // avoids inaccurate Profiler durations in the case of a
    	        // suspended render.
    	        stopProfilerTimerIfRunningAndRecordDelta(erroredWork, true);
    	      }

    	      throwException(root, erroredWork.return, erroredWork, thrownValue, workInProgressRootRenderLanes);
    	      completeUnitOfWork(erroredWork);
    	    } catch (yetAnotherThrownValue) {
    	      // Something in the return path also threw.
    	      thrownValue = yetAnotherThrownValue;

    	      if (workInProgress === erroredWork && erroredWork !== null) {
    	        // If this boundary has already errored, then we had trouble processing
    	        // the error. Bubble it to the next boundary.
    	        erroredWork = erroredWork.return;
    	        workInProgress = erroredWork;
    	      } else {
    	        erroredWork = workInProgress;
    	      }

    	      continue;
    	    } // Return to the normal work loop.


    	    return;
    	  } while (true);
    	}

    	function pushDispatcher() {
    	  var prevDispatcher = ReactCurrentDispatcher$2.current;
    	  ReactCurrentDispatcher$2.current = ContextOnlyDispatcher;

    	  if (prevDispatcher === null) {
    	    // The React isomorphic package does not include a default dispatcher.
    	    // Instead the first renderer will lazily attach one, in order to give
    	    // nicer error messages.
    	    return ContextOnlyDispatcher;
    	  } else {
    	    return prevDispatcher;
    	  }
    	}

    	function popDispatcher(prevDispatcher) {
    	  ReactCurrentDispatcher$2.current = prevDispatcher;
    	}

    	function pushInteractions(root) {
    	  {
    	    var prevInteractions = tracing.__interactionsRef.current;
    	    tracing.__interactionsRef.current = root.memoizedInteractions;
    	    return prevInteractions;
    	  }
    	}

    	function popInteractions(prevInteractions) {
    	  {
    	    tracing.__interactionsRef.current = prevInteractions;
    	  }
    	}

    	function markCommitTimeOfFallback() {
    	  globalMostRecentFallbackTime = now();
    	}
    	function markSkippedUpdateLanes(lane) {
    	  workInProgressRootSkippedLanes = mergeLanes(lane, workInProgressRootSkippedLanes);
    	}
    	function renderDidSuspend() {
    	  if (workInProgressRootExitStatus === RootIncomplete) {
    	    workInProgressRootExitStatus = RootSuspended;
    	  }
    	}
    	function renderDidSuspendDelayIfPossible() {
    	  if (workInProgressRootExitStatus === RootIncomplete || workInProgressRootExitStatus === RootSuspended) {
    	    workInProgressRootExitStatus = RootSuspendedWithDelay;
    	  } // Check if there are updates that we skipped tree that might have unblocked
    	  // this render.


    	  if (workInProgressRoot !== null && (includesNonIdleWork(workInProgressRootSkippedLanes) || includesNonIdleWork(workInProgressRootUpdatedLanes))) {
    	    // Mark the current render as suspended so that we switch to working on
    	    // the updates that were skipped. Usually we only suspend at the end of
    	    // the render phase.
    	    // TODO: We should probably always mark the root as suspended immediately
    	    // (inside this function), since by suspending at the end of the render
    	    // phase introduces a potential mistake where we suspend lanes that were
    	    // pinged or updated while we were rendering.
    	    markRootSuspended$1(workInProgressRoot, workInProgressRootRenderLanes);
    	  }
    	}
    	function renderDidError() {
    	  if (workInProgressRootExitStatus !== RootCompleted) {
    	    workInProgressRootExitStatus = RootErrored;
    	  }
    	} // Called during render to determine if anything has suspended.
    	// Returns false if we're not sure.

    	function renderHasNotSuspendedYet() {
    	  // If something errored or completed, we can't really be sure,
    	  // so those are false.
    	  return workInProgressRootExitStatus === RootIncomplete;
    	}

    	function renderRootSync(root, lanes) {
    	  var prevExecutionContext = executionContext;
    	  executionContext |= RenderContext;
    	  var prevDispatcher = pushDispatcher(); // If the root or lanes have changed, throw out the existing stack
    	  // and prepare a fresh one. Otherwise we'll continue where we left off.

    	  if (workInProgressRoot !== root || workInProgressRootRenderLanes !== lanes) {
    	    prepareFreshStack(root, lanes);
    	    startWorkOnPendingInteractions(root, lanes);
    	  }

    	  var prevInteractions = pushInteractions(root);

    	  do {
    	    try {
    	      workLoopSync();
    	      break;
    	    } catch (thrownValue) {
    	      handleError(root, thrownValue);
    	    }
    	  } while (true);

    	  resetContextDependencies();

    	  {
    	    popInteractions(prevInteractions);
    	  }

    	  executionContext = prevExecutionContext;
    	  popDispatcher(prevDispatcher);

    	  if (workInProgress !== null) {
    	    // This is a sync render, so we should have finished the whole tree.
    	    {
    	      {
    	        throw Error( "Cannot commit an incomplete root. This error is likely caused by a bug in React. Please file an issue." );
    	      }
    	    }
    	  }


    	  workInProgressRoot = null;
    	  workInProgressRootRenderLanes = NoLanes;
    	  return workInProgressRootExitStatus;
    	} // The work loop is an extremely hot path. Tell Closure not to inline it.

    	/** @noinline */


    	function workLoopSync() {
    	  // Already timed out, so perform work without checking if we need to yield.
    	  while (workInProgress !== null) {
    	    performUnitOfWork(workInProgress);
    	  }
    	}

    	function renderRootConcurrent(root, lanes) {
    	  var prevExecutionContext = executionContext;
    	  executionContext |= RenderContext;
    	  var prevDispatcher = pushDispatcher(); // If the root or lanes have changed, throw out the existing stack
    	  // and prepare a fresh one. Otherwise we'll continue where we left off.

    	  if (workInProgressRoot !== root || workInProgressRootRenderLanes !== lanes) {
    	    resetRenderTimer();
    	    prepareFreshStack(root, lanes);
    	    startWorkOnPendingInteractions(root, lanes);
    	  }

    	  var prevInteractions = pushInteractions(root);

    	  do {
    	    try {
    	      workLoopConcurrent();
    	      break;
    	    } catch (thrownValue) {
    	      handleError(root, thrownValue);
    	    }
    	  } while (true);

    	  resetContextDependencies();

    	  {
    	    popInteractions(prevInteractions);
    	  }

    	  popDispatcher(prevDispatcher);
    	  executionContext = prevExecutionContext;


    	  if (workInProgress !== null) {

    	    return RootIncomplete;
    	  } else {


    	    workInProgressRoot = null;
    	    workInProgressRootRenderLanes = NoLanes; // Return the final exit status.

    	    return workInProgressRootExitStatus;
    	  }
    	}
    	/** @noinline */


    	function workLoopConcurrent() {
    	  // Perform work until Scheduler asks us to yield
    	  while (workInProgress !== null && !shouldYield()) {
    	    performUnitOfWork(workInProgress);
    	  }
    	}

    	function performUnitOfWork(unitOfWork) {
    	  // The current, flushed, state of this fiber is the alternate. Ideally
    	  // nothing should rely on this, but relying on it here means that we don't
    	  // need an additional field on the work in progress.
    	  var current = unitOfWork.alternate;
    	  setCurrentFiber(unitOfWork);
    	  var next;

    	  if ( (unitOfWork.mode & ProfileMode) !== NoMode) {
    	    startProfilerTimer(unitOfWork);
    	    next = beginWork$1(current, unitOfWork, subtreeRenderLanes);
    	    stopProfilerTimerIfRunningAndRecordDelta(unitOfWork, true);
    	  } else {
    	    next = beginWork$1(current, unitOfWork, subtreeRenderLanes);
    	  }

    	  resetCurrentFiber();
    	  unitOfWork.memoizedProps = unitOfWork.pendingProps;

    	  if (next === null) {
    	    // If this doesn't spawn new work, complete the current work.
    	    completeUnitOfWork(unitOfWork);
    	  } else {
    	    workInProgress = next;
    	  }

    	  ReactCurrentOwner$2.current = null;
    	}

    	function completeUnitOfWork(unitOfWork) {
    	  // Attempt to complete the current unit of work, then move to the next
    	  // sibling. If there are no more siblings, return to the parent fiber.
    	  var completedWork = unitOfWork;

    	  do {
    	    // The current, flushed, state of this fiber is the alternate. Ideally
    	    // nothing should rely on this, but relying on it here means that we don't
    	    // need an additional field on the work in progress.
    	    var current = completedWork.alternate;
    	    var returnFiber = completedWork.return; // Check if the work completed or if something threw.

    	    if ((completedWork.flags & Incomplete) === NoFlags) {
    	      setCurrentFiber(completedWork);
    	      var next = void 0;

    	      if ( (completedWork.mode & ProfileMode) === NoMode) {
    	        next = completeWork(current, completedWork, subtreeRenderLanes);
    	      } else {
    	        startProfilerTimer(completedWork);
    	        next = completeWork(current, completedWork, subtreeRenderLanes); // Update render duration assuming we didn't error.

    	        stopProfilerTimerIfRunningAndRecordDelta(completedWork, false);
    	      }

    	      resetCurrentFiber();

    	      if (next !== null) {
    	        // Completing this fiber spawned new work. Work on that next.
    	        workInProgress = next;
    	        return;
    	      }

    	      resetChildLanes(completedWork);

    	      if (returnFiber !== null && // Do not append effects to parents if a sibling failed to complete
    	      (returnFiber.flags & Incomplete) === NoFlags) {
    	        // Append all the effects of the subtree and this fiber onto the effect
    	        // list of the parent. The completion order of the children affects the
    	        // side-effect order.
    	        if (returnFiber.firstEffect === null) {
    	          returnFiber.firstEffect = completedWork.firstEffect;
    	        }

    	        if (completedWork.lastEffect !== null) {
    	          if (returnFiber.lastEffect !== null) {
    	            returnFiber.lastEffect.nextEffect = completedWork.firstEffect;
    	          }

    	          returnFiber.lastEffect = completedWork.lastEffect;
    	        } // If this fiber had side-effects, we append it AFTER the children's
    	        // side-effects. We can perform certain side-effects earlier if needed,
    	        // by doing multiple passes over the effect list. We don't want to
    	        // schedule our own side-effect on our own list because if end up
    	        // reusing children we'll schedule this effect onto itself since we're
    	        // at the end.


    	        var flags = completedWork.flags; // Skip both NoWork and PerformedWork tags when creating the effect
    	        // list. PerformedWork effect is read by React DevTools but shouldn't be
    	        // committed.

    	        if (flags > PerformedWork) {
    	          if (returnFiber.lastEffect !== null) {
    	            returnFiber.lastEffect.nextEffect = completedWork;
    	          } else {
    	            returnFiber.firstEffect = completedWork;
    	          }

    	          returnFiber.lastEffect = completedWork;
    	        }
    	      }
    	    } else {
    	      // This fiber did not complete because something threw. Pop values off
    	      // the stack without entering the complete phase. If this is a boundary,
    	      // capture values if possible.
    	      var _next = unwindWork(completedWork); // Because this fiber did not complete, don't reset its expiration time.


    	      if (_next !== null) {
    	        // If completing this work spawned new work, do that next. We'll come
    	        // back here again.
    	        // Since we're restarting, remove anything that is not a host effect
    	        // from the effect tag.
    	        _next.flags &= HostEffectMask;
    	        workInProgress = _next;
    	        return;
    	      }

    	      if ( (completedWork.mode & ProfileMode) !== NoMode) {
    	        // Record the render duration for the fiber that errored.
    	        stopProfilerTimerIfRunningAndRecordDelta(completedWork, false); // Include the time spent working on failed children before continuing.

    	        var actualDuration = completedWork.actualDuration;
    	        var child = completedWork.child;

    	        while (child !== null) {
    	          actualDuration += child.actualDuration;
    	          child = child.sibling;
    	        }

    	        completedWork.actualDuration = actualDuration;
    	      }

    	      if (returnFiber !== null) {
    	        // Mark the parent fiber as incomplete and clear its effect list.
    	        returnFiber.firstEffect = returnFiber.lastEffect = null;
    	        returnFiber.flags |= Incomplete;
    	      }
    	    }

    	    var siblingFiber = completedWork.sibling;

    	    if (siblingFiber !== null) {
    	      // If there is more work to do in this returnFiber, do that next.
    	      workInProgress = siblingFiber;
    	      return;
    	    } // Otherwise, return to the parent


    	    completedWork = returnFiber; // Update the next thing we're working on in case something throws.

    	    workInProgress = completedWork;
    	  } while (completedWork !== null); // We've reached the root.


    	  if (workInProgressRootExitStatus === RootIncomplete) {
    	    workInProgressRootExitStatus = RootCompleted;
    	  }
    	}

    	function resetChildLanes(completedWork) {
    	  if ( // TODO: Move this check out of the hot path by moving `resetChildLanes`
    	  // to switch statement in `completeWork`.
    	  (completedWork.tag === LegacyHiddenComponent || completedWork.tag === OffscreenComponent) && completedWork.memoizedState !== null && !includesSomeLane(subtreeRenderLanes, OffscreenLane) && (completedWork.mode & ConcurrentMode) !== NoLanes) {
    	    // The children of this component are hidden. Don't bubble their
    	    // expiration times.
    	    return;
    	  }

    	  var newChildLanes = NoLanes; // Bubble up the earliest expiration time.

    	  if ( (completedWork.mode & ProfileMode) !== NoMode) {
    	    // In profiling mode, resetChildExpirationTime is also used to reset
    	    // profiler durations.
    	    var actualDuration = completedWork.actualDuration;
    	    var treeBaseDuration = completedWork.selfBaseDuration; // When a fiber is cloned, its actualDuration is reset to 0. This value will
    	    // only be updated if work is done on the fiber (i.e. it doesn't bailout).
    	    // When work is done, it should bubble to the parent's actualDuration. If
    	    // the fiber has not been cloned though, (meaning no work was done), then
    	    // this value will reflect the amount of time spent working on a previous
    	    // render. In that case it should not bubble. We determine whether it was
    	    // cloned by comparing the child pointer.

    	    var shouldBubbleActualDurations = completedWork.alternate === null || completedWork.child !== completedWork.alternate.child;
    	    var child = completedWork.child;

    	    while (child !== null) {
    	      newChildLanes = mergeLanes(newChildLanes, mergeLanes(child.lanes, child.childLanes));

    	      if (shouldBubbleActualDurations) {
    	        actualDuration += child.actualDuration;
    	      }

    	      treeBaseDuration += child.treeBaseDuration;
    	      child = child.sibling;
    	    }

    	    var isTimedOutSuspense = completedWork.tag === SuspenseComponent && completedWork.memoizedState !== null;

    	    if (isTimedOutSuspense) {
    	      // Don't count time spent in a timed out Suspense subtree as part of the base duration.
    	      var primaryChildFragment = completedWork.child;

    	      if (primaryChildFragment !== null) {
    	        treeBaseDuration -= primaryChildFragment.treeBaseDuration;
    	      }
    	    }

    	    completedWork.actualDuration = actualDuration;
    	    completedWork.treeBaseDuration = treeBaseDuration;
    	  } else {
    	    var _child = completedWork.child;

    	    while (_child !== null) {
    	      newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child.lanes, _child.childLanes));
    	      _child = _child.sibling;
    	    }
    	  }

    	  completedWork.childLanes = newChildLanes;
    	}

    	function commitRoot(root) {
    	  var renderPriorityLevel = getCurrentPriorityLevel();
    	  runWithPriority$1(ImmediatePriority$1, commitRootImpl.bind(null, root, renderPriorityLevel));
    	  return null;
    	}

    	function commitRootImpl(root, renderPriorityLevel) {
    	  do {
    	    // `flushPassiveEffects` will call `flushSyncUpdateQueue` at the end, which
    	    // means `flushPassiveEffects` will sometimes result in additional
    	    // passive effects. So we need to keep flushing in a loop until there are
    	    // no more pending effects.
    	    // TODO: Might be better if `flushPassiveEffects` did not automatically
    	    // flush synchronous work at the end, to avoid factoring hazards like this.
    	    flushPassiveEffects();
    	  } while (rootWithPendingPassiveEffects !== null);

    	  flushRenderPhaseStrictModeWarningsInDEV();

    	  if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
    	    {
    	      throw Error( "Should not already be working." );
    	    }
    	  }

    	  var finishedWork = root.finishedWork;
    	  var lanes = root.finishedLanes;

    	  if (finishedWork === null) {

    	    return null;
    	  }

    	  root.finishedWork = null;
    	  root.finishedLanes = NoLanes;

    	  if (!(finishedWork !== root.current)) {
    	    {
    	      throw Error( "Cannot commit the same tree as before. This error is likely caused by a bug in React. Please file an issue." );
    	    }
    	  } // commitRoot never returns a continuation; it always finishes synchronously.
    	  // So we can clear these now to allow a new callback to be scheduled.


    	  root.callbackNode = null; // Update the first and last pending times on this root. The new first
    	  // pending time is whatever is left on the root fiber.

    	  var remainingLanes = mergeLanes(finishedWork.lanes, finishedWork.childLanes);
    	  markRootFinished(root, remainingLanes); // Clear already finished discrete updates in case that a later call of
    	  // `flushDiscreteUpdates` starts a useless render pass which may cancels
    	  // a scheduled timeout.

    	  if (rootsWithPendingDiscreteUpdates !== null) {
    	    if (!hasDiscreteLanes(remainingLanes) && rootsWithPendingDiscreteUpdates.has(root)) {
    	      rootsWithPendingDiscreteUpdates.delete(root);
    	    }
    	  }

    	  if (root === workInProgressRoot) {
    	    // We can reset these now that they are finished.
    	    workInProgressRoot = null;
    	    workInProgress = null;
    	    workInProgressRootRenderLanes = NoLanes;
    	  } // Get the list of effects.


    	  var firstEffect;

    	  if (finishedWork.flags > PerformedWork) {
    	    // A fiber's effect list consists only of its children, not itself. So if
    	    // the root has an effect, we need to add it to the end of the list. The
    	    // resulting list is the set that would belong to the root's parent, if it
    	    // had one; that is, all the effects in the tree including the root.
    	    if (finishedWork.lastEffect !== null) {
    	      finishedWork.lastEffect.nextEffect = finishedWork;
    	      firstEffect = finishedWork.firstEffect;
    	    } else {
    	      firstEffect = finishedWork;
    	    }
    	  } else {
    	    // There is no effect on the root.
    	    firstEffect = finishedWork.firstEffect;
    	  }

    	  if (firstEffect !== null) {

    	    var prevExecutionContext = executionContext;
    	    executionContext |= CommitContext;
    	    var prevInteractions = pushInteractions(root); // Reset this to null before calling lifecycles

    	    ReactCurrentOwner$2.current = null; // The commit phase is broken into several sub-phases. We do a separate pass
    	    // of the effect list for each phase: all mutation effects come before all
    	    // layout effects, and so on.
    	    // The first phase a "before mutation" phase. We use this phase to read the
    	    // state of the host tree right before we mutate it. This is where
    	    // getSnapshotBeforeUpdate is called.

    	    focusedInstanceHandle = prepareForCommit(root.containerInfo);
    	    shouldFireAfterActiveInstanceBlur = false;
    	    nextEffect = firstEffect;

    	    do {
    	      {
    	        invokeGuardedCallback(null, commitBeforeMutationEffects, null);

    	        if (hasCaughtError()) {
    	          if (!(nextEffect !== null)) {
    	            {
    	              throw Error( "Should be working on an effect." );
    	            }
    	          }

    	          var error = clearCaughtError();
    	          captureCommitPhaseError(nextEffect, error);
    	          nextEffect = nextEffect.nextEffect;
    	        }
    	      }
    	    } while (nextEffect !== null); // We no longer need to track the active instance fiber


    	    focusedInstanceHandle = null;

    	    {
    	      // Mark the current commit time to be shared by all Profilers in this
    	      // batch. This enables them to be grouped later.
    	      recordCommitTime();
    	    } // The next phase is the mutation phase, where we mutate the host tree.


    	    nextEffect = firstEffect;

    	    do {
    	      {
    	        invokeGuardedCallback(null, commitMutationEffects, null, root, renderPriorityLevel);

    	        if (hasCaughtError()) {
    	          if (!(nextEffect !== null)) {
    	            {
    	              throw Error( "Should be working on an effect." );
    	            }
    	          }

    	          var _error = clearCaughtError();

    	          captureCommitPhaseError(nextEffect, _error);
    	          nextEffect = nextEffect.nextEffect;
    	        }
    	      }
    	    } while (nextEffect !== null);

    	    resetAfterCommit(root.containerInfo); // The work-in-progress tree is now the current tree. This must come after
    	    // the mutation phase, so that the previous tree is still current during
    	    // componentWillUnmount, but before the layout phase, so that the finished
    	    // work is current during componentDidMount/Update.

    	    root.current = finishedWork; // The next phase is the layout phase, where we call effects that read
    	    // the host tree after it's been mutated. The idiomatic use case for this is
    	    // layout, but class component lifecycles also fire here for legacy reasons.

    	    nextEffect = firstEffect;

    	    do {
    	      {
    	        invokeGuardedCallback(null, commitLayoutEffects, null, root, lanes);

    	        if (hasCaughtError()) {
    	          if (!(nextEffect !== null)) {
    	            {
    	              throw Error( "Should be working on an effect." );
    	            }
    	          }

    	          var _error2 = clearCaughtError();

    	          captureCommitPhaseError(nextEffect, _error2);
    	          nextEffect = nextEffect.nextEffect;
    	        }
    	      }
    	    } while (nextEffect !== null);

    	    nextEffect = null; // Tell Scheduler to yield at the end of the frame, so the browser has an
    	    // opportunity to paint.

    	    requestPaint();

    	    {
    	      popInteractions(prevInteractions);
    	    }

    	    executionContext = prevExecutionContext;
    	  } else {
    	    // No effects.
    	    root.current = finishedWork; // Measure these anyway so the flamegraph explicitly shows that there were
    	    // no effects.
    	    // TODO: Maybe there's a better way to report this.

    	    {
    	      recordCommitTime();
    	    }
    	  }

    	  var rootDidHavePassiveEffects = rootDoesHavePassiveEffects;

    	  if (rootDoesHavePassiveEffects) {
    	    // This commit has passive effects. Stash a reference to them. But don't
    	    // schedule a callback until after flushing layout work.
    	    rootDoesHavePassiveEffects = false;
    	    rootWithPendingPassiveEffects = root;
    	    pendingPassiveEffectsLanes = lanes;
    	    pendingPassiveEffectsRenderPriority = renderPriorityLevel;
    	  } else {
    	    // We are done with the effect chain at this point so let's clear the
    	    // nextEffect pointers to assist with GC. If we have passive effects, we'll
    	    // clear this in flushPassiveEffects.
    	    nextEffect = firstEffect;

    	    while (nextEffect !== null) {
    	      var nextNextEffect = nextEffect.nextEffect;
    	      nextEffect.nextEffect = null;

    	      if (nextEffect.flags & Deletion) {
    	        detachFiberAfterEffects(nextEffect);
    	      }

    	      nextEffect = nextNextEffect;
    	    }
    	  } // Read this again, since an effect might have updated it


    	  remainingLanes = root.pendingLanes; // Check if there's remaining work on this root

    	  if (remainingLanes !== NoLanes) {
    	    {
    	      if (spawnedWorkDuringRender !== null) {
    	        var expirationTimes = spawnedWorkDuringRender;
    	        spawnedWorkDuringRender = null;

    	        for (var i = 0; i < expirationTimes.length; i++) {
    	          scheduleInteractions(root, expirationTimes[i], root.memoizedInteractions);
    	        }
    	      }

    	      schedulePendingInteractions(root, remainingLanes);
    	    }
    	  } else {
    	    // If there's no remaining work, we can clear the set of already failed
    	    // error boundaries.
    	    legacyErrorBoundariesThatAlreadyFailed = null;
    	  }

    	  {
    	    if (!rootDidHavePassiveEffects) {
    	      // If there are no passive effects, then we can complete the pending interactions.
    	      // Otherwise, we'll wait until after the passive effects are flushed.
    	      // Wait to do this until after remaining work has been scheduled,
    	      // so that we don't prematurely signal complete for interactions when there's e.g. hidden work.
    	      finishPendingInteractions(root, lanes);
    	    }
    	  }

    	  if (remainingLanes === SyncLane) {
    	    // Count the number of times the root synchronously re-renders without
    	    // finishing. If there are too many, it indicates an infinite update loop.
    	    if (root === rootWithNestedUpdates) {
    	      nestedUpdateCount++;
    	    } else {
    	      nestedUpdateCount = 0;
    	      rootWithNestedUpdates = root;
    	    }
    	  } else {
    	    nestedUpdateCount = 0;
    	  }

    	  onCommitRoot(finishedWork.stateNode, renderPriorityLevel);

    	  {
    	    onCommitRoot$1();
    	  } // Always call this before exiting `commitRoot`, to ensure that any
    	  // additional work on this root is scheduled.


    	  ensureRootIsScheduled(root, now());

    	  if (hasUncaughtError) {
    	    hasUncaughtError = false;
    	    var _error3 = firstUncaughtError;
    	    firstUncaughtError = null;
    	    throw _error3;
    	  }

    	  if ((executionContext & LegacyUnbatchedContext) !== NoContext) {
    	    // a ReactDOM.render-ed root inside of batchedUpdates. The commit fired
    	    // synchronously, but layout updates should be deferred until the end
    	    // of the batch.


    	    return null;
    	  } // If layout work was scheduled, flush it now.


    	  flushSyncCallbackQueue();

    	  return null;
    	}

    	function commitBeforeMutationEffects() {
    	  while (nextEffect !== null) {
    	    var current = nextEffect.alternate;

    	    if (!shouldFireAfterActiveInstanceBlur && focusedInstanceHandle !== null) {
    	      if ((nextEffect.flags & Deletion) !== NoFlags) {
    	        if (doesFiberContain(nextEffect, focusedInstanceHandle)) {
    	          shouldFireAfterActiveInstanceBlur = true;
    	        }
    	      } else {
    	        // TODO: Move this out of the hot path using a dedicated effect tag.
    	        if (nextEffect.tag === SuspenseComponent && isSuspenseBoundaryBeingHidden(current, nextEffect) && doesFiberContain(nextEffect, focusedInstanceHandle)) {
    	          shouldFireAfterActiveInstanceBlur = true;
    	        }
    	      }
    	    }

    	    var flags = nextEffect.flags;

    	    if ((flags & Snapshot) !== NoFlags) {
    	      setCurrentFiber(nextEffect);
    	      commitBeforeMutationLifeCycles(current, nextEffect);
    	      resetCurrentFiber();
    	    }

    	    if ((flags & Passive) !== NoFlags) {
    	      // If there are passive effects, schedule a callback to flush at
    	      // the earliest opportunity.
    	      if (!rootDoesHavePassiveEffects) {
    	        rootDoesHavePassiveEffects = true;
    	        scheduleCallback(NormalPriority$1, function () {
    	          flushPassiveEffects();
    	          return null;
    	        });
    	      }
    	    }

    	    nextEffect = nextEffect.nextEffect;
    	  }
    	}

    	function commitMutationEffects(root, renderPriorityLevel) {
    	  // TODO: Should probably move the bulk of this function to commitWork.
    	  while (nextEffect !== null) {
    	    setCurrentFiber(nextEffect);
    	    var flags = nextEffect.flags;

    	    if (flags & ContentReset) {
    	      commitResetTextContent(nextEffect);
    	    }

    	    if (flags & Ref) {
    	      var current = nextEffect.alternate;

    	      if (current !== null) {
    	        commitDetachRef(current);
    	      }
    	    } // The following switch statement is only concerned about placement,
    	    // updates, and deletions. To avoid needing to add a case for every possible
    	    // bitmap value, we remove the secondary effects from the effect tag and
    	    // switch on that value.


    	    var primaryFlags = flags & (Placement | Update | Deletion | Hydrating);

    	    switch (primaryFlags) {
    	      case Placement:
    	        {
    	          commitPlacement(nextEffect); // Clear the "placement" from effect tag so that we know that this is
    	          // inserted, before any life-cycles like componentDidMount gets called.
    	          // TODO: findDOMNode doesn't rely on this any more but isMounted does
    	          // and isMounted is deprecated anyway so we should be able to kill this.

    	          nextEffect.flags &= ~Placement;
    	          break;
    	        }

    	      case PlacementAndUpdate:
    	        {
    	          // Placement
    	          commitPlacement(nextEffect); // Clear the "placement" from effect tag so that we know that this is
    	          // inserted, before any life-cycles like componentDidMount gets called.

    	          nextEffect.flags &= ~Placement; // Update

    	          var _current = nextEffect.alternate;
    	          commitWork(_current, nextEffect);
    	          break;
    	        }

    	      case Hydrating:
    	        {
    	          nextEffect.flags &= ~Hydrating;
    	          break;
    	        }

    	      case HydratingAndUpdate:
    	        {
    	          nextEffect.flags &= ~Hydrating; // Update

    	          var _current2 = nextEffect.alternate;
    	          commitWork(_current2, nextEffect);
    	          break;
    	        }

    	      case Update:
    	        {
    	          var _current3 = nextEffect.alternate;
    	          commitWork(_current3, nextEffect);
    	          break;
    	        }

    	      case Deletion:
    	        {
    	          commitDeletion(root, nextEffect);
    	          break;
    	        }
    	    }

    	    resetCurrentFiber();
    	    nextEffect = nextEffect.nextEffect;
    	  }
    	}

    	function commitLayoutEffects(root, committedLanes) {


    	  while (nextEffect !== null) {
    	    setCurrentFiber(nextEffect);
    	    var flags = nextEffect.flags;

    	    if (flags & (Update | Callback)) {
    	      var current = nextEffect.alternate;
    	      commitLifeCycles(root, current, nextEffect);
    	    }

    	    {
    	      if (flags & Ref) {
    	        commitAttachRef(nextEffect);
    	      }
    	    }

    	    resetCurrentFiber();
    	    nextEffect = nextEffect.nextEffect;
    	  }
    	}

    	function flushPassiveEffects() {
    	  // Returns whether passive effects were flushed.
    	  if (pendingPassiveEffectsRenderPriority !== NoPriority$1) {
    	    var priorityLevel = pendingPassiveEffectsRenderPriority > NormalPriority$1 ? NormalPriority$1 : pendingPassiveEffectsRenderPriority;
    	    pendingPassiveEffectsRenderPriority = NoPriority$1;

    	    {
    	      return runWithPriority$1(priorityLevel, flushPassiveEffectsImpl);
    	    }
    	  }

    	  return false;
    	}
    	function enqueuePendingPassiveHookEffectMount(fiber, effect) {
    	  pendingPassiveHookEffectsMount.push(effect, fiber);

    	  if (!rootDoesHavePassiveEffects) {
    	    rootDoesHavePassiveEffects = true;
    	    scheduleCallback(NormalPriority$1, function () {
    	      flushPassiveEffects();
    	      return null;
    	    });
    	  }
    	}
    	function enqueuePendingPassiveHookEffectUnmount(fiber, effect) {
    	  pendingPassiveHookEffectsUnmount.push(effect, fiber);

    	  {
    	    fiber.flags |= PassiveUnmountPendingDev;
    	    var alternate = fiber.alternate;

    	    if (alternate !== null) {
    	      alternate.flags |= PassiveUnmountPendingDev;
    	    }
    	  }

    	  if (!rootDoesHavePassiveEffects) {
    	    rootDoesHavePassiveEffects = true;
    	    scheduleCallback(NormalPriority$1, function () {
    	      flushPassiveEffects();
    	      return null;
    	    });
    	  }
    	}

    	function invokePassiveEffectCreate(effect) {
    	  var create = effect.create;
    	  effect.destroy = create();
    	}

    	function flushPassiveEffectsImpl() {
    	  if (rootWithPendingPassiveEffects === null) {
    	    return false;
    	  }

    	  var root = rootWithPendingPassiveEffects;
    	  var lanes = pendingPassiveEffectsLanes;
    	  rootWithPendingPassiveEffects = null;
    	  pendingPassiveEffectsLanes = NoLanes;

    	  if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
    	    {
    	      throw Error( "Cannot flush passive effects while already rendering." );
    	    }
    	  }

    	  {
    	    isFlushingPassiveEffects = true;
    	  }

    	  var prevExecutionContext = executionContext;
    	  executionContext |= CommitContext;
    	  var prevInteractions = pushInteractions(root); // It's important that ALL pending passive effect destroy functions are called
    	  // before ANY passive effect create functions are called.
    	  // Otherwise effects in sibling components might interfere with each other.
    	  // e.g. a destroy function in one component may unintentionally override a ref
    	  // value set by a create function in another component.
    	  // Layout effects have the same constraint.
    	  // First pass: Destroy stale passive effects.

    	  var unmountEffects = pendingPassiveHookEffectsUnmount;
    	  pendingPassiveHookEffectsUnmount = [];

    	  for (var i = 0; i < unmountEffects.length; i += 2) {
    	    var _effect = unmountEffects[i];
    	    var fiber = unmountEffects[i + 1];
    	    var destroy = _effect.destroy;
    	    _effect.destroy = undefined;

    	    {
    	      fiber.flags &= ~PassiveUnmountPendingDev;
    	      var alternate = fiber.alternate;

    	      if (alternate !== null) {
    	        alternate.flags &= ~PassiveUnmountPendingDev;
    	      }
    	    }

    	    if (typeof destroy === 'function') {
    	      {
    	        setCurrentFiber(fiber);

    	        {
    	          invokeGuardedCallback(null, destroy, null);
    	        }

    	        if (hasCaughtError()) {
    	          if (!(fiber !== null)) {
    	            {
    	              throw Error( "Should be working on an effect." );
    	            }
    	          }

    	          var error = clearCaughtError();
    	          captureCommitPhaseError(fiber, error);
    	        }

    	        resetCurrentFiber();
    	      }
    	    }
    	  } // Second pass: Create new passive effects.


    	  var mountEffects = pendingPassiveHookEffectsMount;
    	  pendingPassiveHookEffectsMount = [];

    	  for (var _i = 0; _i < mountEffects.length; _i += 2) {
    	    var _effect2 = mountEffects[_i];
    	    var _fiber = mountEffects[_i + 1];

    	    {
    	      setCurrentFiber(_fiber);

    	      {
    	        invokeGuardedCallback(null, invokePassiveEffectCreate, null, _effect2);
    	      }

    	      if (hasCaughtError()) {
    	        if (!(_fiber !== null)) {
    	          {
    	            throw Error( "Should be working on an effect." );
    	          }
    	        }

    	        var _error4 = clearCaughtError();

    	        captureCommitPhaseError(_fiber, _error4);
    	      }

    	      resetCurrentFiber();
    	    }
    	  } // Note: This currently assumes there are no passive effects on the root fiber
    	  // because the root is not part of its own effect list.
    	  // This could change in the future.


    	  var effect = root.current.firstEffect;

    	  while (effect !== null) {
    	    var nextNextEffect = effect.nextEffect; // Remove nextEffect pointer to assist GC

    	    effect.nextEffect = null;

    	    if (effect.flags & Deletion) {
    	      detachFiberAfterEffects(effect);
    	    }

    	    effect = nextNextEffect;
    	  }

    	  {
    	    popInteractions(prevInteractions);
    	    finishPendingInteractions(root, lanes);
    	  }

    	  {
    	    isFlushingPassiveEffects = false;
    	  }

    	  executionContext = prevExecutionContext;
    	  flushSyncCallbackQueue(); // If additional passive effects were scheduled, increment a counter. If this
    	  // exceeds the limit, we'll fire a warning.

    	  nestedPassiveUpdateCount = rootWithPendingPassiveEffects === null ? 0 : nestedPassiveUpdateCount + 1;
    	  return true;
    	}

    	function isAlreadyFailedLegacyErrorBoundary(instance) {
    	  return legacyErrorBoundariesThatAlreadyFailed !== null && legacyErrorBoundariesThatAlreadyFailed.has(instance);
    	}
    	function markLegacyErrorBoundaryAsFailed(instance) {
    	  if (legacyErrorBoundariesThatAlreadyFailed === null) {
    	    legacyErrorBoundariesThatAlreadyFailed = new Set([instance]);
    	  } else {
    	    legacyErrorBoundariesThatAlreadyFailed.add(instance);
    	  }
    	}

    	function prepareToThrowUncaughtError(error) {
    	  if (!hasUncaughtError) {
    	    hasUncaughtError = true;
    	    firstUncaughtError = error;
    	  }
    	}

    	var onUncaughtError = prepareToThrowUncaughtError;

    	function captureCommitPhaseErrorOnRoot(rootFiber, sourceFiber, error) {
    	  var errorInfo = createCapturedValue(error, sourceFiber);
    	  var update = createRootErrorUpdate(rootFiber, errorInfo, SyncLane);
    	  enqueueUpdate(rootFiber, update);
    	  var eventTime = requestEventTime();
    	  var root = markUpdateLaneFromFiberToRoot(rootFiber, SyncLane);

    	  if (root !== null) {
    	    markRootUpdated(root, SyncLane, eventTime);
    	    ensureRootIsScheduled(root, eventTime);
    	    schedulePendingInteractions(root, SyncLane);
    	  }
    	}

    	function captureCommitPhaseError(sourceFiber, error) {
    	  if (sourceFiber.tag === HostRoot) {
    	    // Error was thrown at the root. There is no parent, so the root
    	    // itself should capture it.
    	    captureCommitPhaseErrorOnRoot(sourceFiber, sourceFiber, error);
    	    return;
    	  }

    	  var fiber = sourceFiber.return;

    	  while (fiber !== null) {
    	    if (fiber.tag === HostRoot) {
    	      captureCommitPhaseErrorOnRoot(fiber, sourceFiber, error);
    	      return;
    	    } else if (fiber.tag === ClassComponent) {
    	      var ctor = fiber.type;
    	      var instance = fiber.stateNode;

    	      if (typeof ctor.getDerivedStateFromError === 'function' || typeof instance.componentDidCatch === 'function' && !isAlreadyFailedLegacyErrorBoundary(instance)) {
    	        var errorInfo = createCapturedValue(error, sourceFiber);
    	        var update = createClassErrorUpdate(fiber, errorInfo, SyncLane);
    	        enqueueUpdate(fiber, update);
    	        var eventTime = requestEventTime();
    	        var root = markUpdateLaneFromFiberToRoot(fiber, SyncLane);

    	        if (root !== null) {
    	          markRootUpdated(root, SyncLane, eventTime);
    	          ensureRootIsScheduled(root, eventTime);
    	          schedulePendingInteractions(root, SyncLane);
    	        } else {
    	          // This component has already been unmounted.
    	          // We can't schedule any follow up work for the root because the fiber is already unmounted,
    	          // but we can still call the log-only boundary so the error isn't swallowed.
    	          //
    	          // TODO This is only a temporary bandaid for the old reconciler fork.
    	          // We can delete this special case once the new fork is merged.
    	          if (typeof instance.componentDidCatch === 'function' && !isAlreadyFailedLegacyErrorBoundary(instance)) {
    	            try {
    	              instance.componentDidCatch(error, errorInfo);
    	            } catch (errorToIgnore) {// TODO Ignore this error? Rethrow it?
    	              // This is kind of an edge case.
    	            }
    	          }
    	        }

    	        return;
    	      }
    	    }

    	    fiber = fiber.return;
    	  }
    	}
    	function pingSuspendedRoot(root, wakeable, pingedLanes) {
    	  var pingCache = root.pingCache;

    	  if (pingCache !== null) {
    	    // The wakeable resolved, so we no longer need to memoize, because it will
    	    // never be thrown again.
    	    pingCache.delete(wakeable);
    	  }

    	  var eventTime = requestEventTime();
    	  markRootPinged(root, pingedLanes);

    	  if (workInProgressRoot === root && isSubsetOfLanes(workInProgressRootRenderLanes, pingedLanes)) {
    	    // Received a ping at the same priority level at which we're currently
    	    // rendering. We might want to restart this render. This should mirror
    	    // the logic of whether or not a root suspends once it completes.
    	    // TODO: If we're rendering sync either due to Sync, Batched or expired,
    	    // we should probably never restart.
    	    // If we're suspended with delay, or if it's a retry, we'll always suspend
    	    // so we can always restart.
    	    if (workInProgressRootExitStatus === RootSuspendedWithDelay || workInProgressRootExitStatus === RootSuspended && includesOnlyRetries(workInProgressRootRenderLanes) && now() - globalMostRecentFallbackTime < FALLBACK_THROTTLE_MS) {
    	      // Restart from the root.
    	      prepareFreshStack(root, NoLanes);
    	    } else {
    	      // Even though we can't restart right now, we might get an
    	      // opportunity later. So we mark this render as having a ping.
    	      workInProgressRootPingedLanes = mergeLanes(workInProgressRootPingedLanes, pingedLanes);
    	    }
    	  }

    	  ensureRootIsScheduled(root, eventTime);
    	  schedulePendingInteractions(root, pingedLanes);
    	}

    	function retryTimedOutBoundary(boundaryFiber, retryLane) {
    	  // The boundary fiber (a Suspense component or SuspenseList component)
    	  // previously was rendered in its fallback state. One of the promises that
    	  // suspended it has resolved, which means at least part of the tree was
    	  // likely unblocked. Try rendering again, at a new expiration time.
    	  if (retryLane === NoLane) {
    	    retryLane = requestRetryLane(boundaryFiber);
    	  } // TODO: Special case idle priority?


    	  var eventTime = requestEventTime();
    	  var root = markUpdateLaneFromFiberToRoot(boundaryFiber, retryLane);

    	  if (root !== null) {
    	    markRootUpdated(root, retryLane, eventTime);
    	    ensureRootIsScheduled(root, eventTime);
    	    schedulePendingInteractions(root, retryLane);
    	  }
    	}
    	function resolveRetryWakeable(boundaryFiber, wakeable) {
    	  var retryLane = NoLane; // Default

    	  var retryCache;

    	  {
    	    retryCache = boundaryFiber.stateNode;
    	  }

    	  if (retryCache !== null) {
    	    // The wakeable resolved, so we no longer need to memoize, because it will
    	    // never be thrown again.
    	    retryCache.delete(wakeable);
    	  }

    	  retryTimedOutBoundary(boundaryFiber, retryLane);
    	} // Computes the next Just Noticeable Difference (JND) boundary.
    	// The theory is that a person can't tell the difference between small differences in time.
    	// Therefore, if we wait a bit longer than necessary that won't translate to a noticeable
    	// difference in the experience. However, waiting for longer might mean that we can avoid
    	// showing an intermediate loading state. The longer we have already waited, the harder it
    	// is to tell small differences in time. Therefore, the longer we've already waited,
    	// the longer we can wait additionally. At some point we have to give up though.
    	// We pick a train model where the next boundary commits at a consistent schedule.
    	// These particular numbers are vague estimates. We expect to adjust them based on research.

    	function jnd(timeElapsed) {
    	  return timeElapsed < 120 ? 120 : timeElapsed < 480 ? 480 : timeElapsed < 1080 ? 1080 : timeElapsed < 1920 ? 1920 : timeElapsed < 3000 ? 3000 : timeElapsed < 4320 ? 4320 : ceil(timeElapsed / 1960) * 1960;
    	}

    	function checkForNestedUpdates() {
    	  if (nestedUpdateCount > NESTED_UPDATE_LIMIT) {
    	    nestedUpdateCount = 0;
    	    rootWithNestedUpdates = null;

    	    {
    	      {
    	        throw Error( "Maximum update depth exceeded. This can happen when a component repeatedly calls setState inside componentWillUpdate or componentDidUpdate. React limits the number of nested updates to prevent infinite loops." );
    	      }
    	    }
    	  }

    	  {
    	    if (nestedPassiveUpdateCount > NESTED_PASSIVE_UPDATE_LIMIT) {
    	      nestedPassiveUpdateCount = 0;

    	      error('Maximum update depth exceeded. This can happen when a component ' + "calls setState inside useEffect, but useEffect either doesn't " + 'have a dependency array, or one of the dependencies changes on ' + 'every render.');
    	    }
    	  }
    	}

    	function flushRenderPhaseStrictModeWarningsInDEV() {
    	  {
    	    ReactStrictModeWarnings.flushLegacyContextWarning();

    	    {
    	      ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings();
    	    }
    	  }
    	}

    	var didWarnStateUpdateForNotYetMountedComponent = null;

    	function warnAboutUpdateOnNotYetMountedFiberInDEV(fiber) {
    	  {
    	    if ((executionContext & RenderContext) !== NoContext) {
    	      // We let the other warning about render phase updates deal with this one.
    	      return;
    	    }

    	    if (!(fiber.mode & (BlockingMode | ConcurrentMode))) {
    	      return;
    	    }

    	    var tag = fiber.tag;

    	    if (tag !== IndeterminateComponent && tag !== HostRoot && tag !== ClassComponent && tag !== FunctionComponent && tag !== ForwardRef && tag !== MemoComponent && tag !== SimpleMemoComponent && tag !== Block) {
    	      // Only warn for user-defined components, not internal ones like Suspense.
    	      return;
    	    } // We show the whole stack but dedupe on the top component's name because
    	    // the problematic code almost always lies inside that component.


    	    var componentName = getComponentName(fiber.type) || 'ReactComponent';

    	    if (didWarnStateUpdateForNotYetMountedComponent !== null) {
    	      if (didWarnStateUpdateForNotYetMountedComponent.has(componentName)) {
    	        return;
    	      }

    	      didWarnStateUpdateForNotYetMountedComponent.add(componentName);
    	    } else {
    	      didWarnStateUpdateForNotYetMountedComponent = new Set([componentName]);
    	    }

    	    var previousFiber = current;

    	    try {
    	      setCurrentFiber(fiber);

    	      error("Can't perform a React state update on a component that hasn't mounted yet. " + 'This indicates that you have a side-effect in your render function that ' + 'asynchronously later calls tries to update the component. Move this work to ' + 'useEffect instead.');
    	    } finally {
    	      if (previousFiber) {
    	        setCurrentFiber(fiber);
    	      } else {
    	        resetCurrentFiber();
    	      }
    	    }
    	  }
    	}

    	var didWarnStateUpdateForUnmountedComponent = null;

    	function warnAboutUpdateOnUnmountedFiberInDEV(fiber) {
    	  {
    	    var tag = fiber.tag;

    	    if (tag !== HostRoot && tag !== ClassComponent && tag !== FunctionComponent && tag !== ForwardRef && tag !== MemoComponent && tag !== SimpleMemoComponent && tag !== Block) {
    	      // Only warn for user-defined components, not internal ones like Suspense.
    	      return;
    	    } // If there are pending passive effects unmounts for this Fiber,
    	    // we can assume that they would have prevented this update.


    	    if ((fiber.flags & PassiveUnmountPendingDev) !== NoFlags) {
    	      return;
    	    } // We show the whole stack but dedupe on the top component's name because
    	    // the problematic code almost always lies inside that component.


    	    var componentName = getComponentName(fiber.type) || 'ReactComponent';

    	    if (didWarnStateUpdateForUnmountedComponent !== null) {
    	      if (didWarnStateUpdateForUnmountedComponent.has(componentName)) {
    	        return;
    	      }

    	      didWarnStateUpdateForUnmountedComponent.add(componentName);
    	    } else {
    	      didWarnStateUpdateForUnmountedComponent = new Set([componentName]);
    	    }

    	    if (isFlushingPassiveEffects) ; else {
    	      var previousFiber = current;

    	      try {
    	        setCurrentFiber(fiber);

    	        error("Can't perform a React state update on an unmounted component. This " + 'is a no-op, but it indicates a memory leak in your application. To ' + 'fix, cancel all subscriptions and asynchronous tasks in %s.', tag === ClassComponent ? 'the componentWillUnmount method' : 'a useEffect cleanup function');
    	      } finally {
    	        if (previousFiber) {
    	          setCurrentFiber(fiber);
    	        } else {
    	          resetCurrentFiber();
    	        }
    	      }
    	    }
    	  }
    	}

    	var beginWork$1;

    	{
    	  var dummyFiber = null;

    	  beginWork$1 = function (current, unitOfWork, lanes) {
    	    // If a component throws an error, we replay it again in a synchronously
    	    // dispatched event, so that the debugger will treat it as an uncaught
    	    // error See ReactErrorUtils for more information.
    	    // Before entering the begin phase, copy the work-in-progress onto a dummy
    	    // fiber. If beginWork throws, we'll use this to reset the state.
    	    var originalWorkInProgressCopy = assignFiberPropertiesInDEV(dummyFiber, unitOfWork);

    	    try {
    	      return beginWork(current, unitOfWork, lanes);
    	    } catch (originalError) {
    	      if (originalError !== null && typeof originalError === 'object' && typeof originalError.then === 'function') {
    	        // Don't replay promises. Treat everything else like an error.
    	        throw originalError;
    	      } // Keep this code in sync with handleError; any changes here must have
    	      // corresponding changes there.


    	      resetContextDependencies();
    	      resetHooksAfterThrow(); // Don't reset current debug fiber, since we're about to work on the
    	      // same fiber again.
    	      // Unwind the failed stack frame

    	      unwindInterruptedWork(unitOfWork); // Restore the original properties of the fiber.

    	      assignFiberPropertiesInDEV(unitOfWork, originalWorkInProgressCopy);

    	      if ( unitOfWork.mode & ProfileMode) {
    	        // Reset the profiler timer.
    	        startProfilerTimer(unitOfWork);
    	      } // Run beginWork again.


    	      invokeGuardedCallback(null, beginWork, null, current, unitOfWork, lanes);

    	      if (hasCaughtError()) {
    	        var replayError = clearCaughtError(); // `invokeGuardedCallback` sometimes sets an expando `_suppressLogging`.
    	        // Rethrow this error instead of the original one.

    	        throw replayError;
    	      } else {
    	        // This branch is reachable if the render phase is impure.
    	        throw originalError;
    	      }
    	    }
    	  };
    	}

    	var didWarnAboutUpdateInRender = false;
    	var didWarnAboutUpdateInRenderForAnotherComponent;

    	{
    	  didWarnAboutUpdateInRenderForAnotherComponent = new Set();
    	}

    	function warnAboutRenderPhaseUpdatesInDEV(fiber) {
    	  {
    	    if (isRendering && (executionContext & RenderContext) !== NoContext && !getIsUpdatingOpaqueValueInRenderPhaseInDEV()) {
    	      switch (fiber.tag) {
    	        case FunctionComponent:
    	        case ForwardRef:
    	        case SimpleMemoComponent:
    	          {
    	            var renderingComponentName = workInProgress && getComponentName(workInProgress.type) || 'Unknown'; // Dedupe by the rendering component because it's the one that needs to be fixed.

    	            var dedupeKey = renderingComponentName;

    	            if (!didWarnAboutUpdateInRenderForAnotherComponent.has(dedupeKey)) {
    	              didWarnAboutUpdateInRenderForAnotherComponent.add(dedupeKey);
    	              var setStateComponentName = getComponentName(fiber.type) || 'Unknown';

    	              error('Cannot update a component (`%s`) while rendering a ' + 'different component (`%s`). To locate the bad setState() call inside `%s`, ' + 'follow the stack trace as described in https://reactjs.org/link/setstate-in-render', setStateComponentName, renderingComponentName, renderingComponentName);
    	            }

    	            break;
    	          }

    	        case ClassComponent:
    	          {
    	            if (!didWarnAboutUpdateInRender) {
    	              error('Cannot update during an existing state transition (such as ' + 'within `render`). Render methods should be a pure ' + 'function of props and state.');

    	              didWarnAboutUpdateInRender = true;
    	            }

    	            break;
    	          }
    	      }
    	    }
    	  }
    	} // a 'shared' variable that changes when act() opens/closes in tests.


    	var IsThisRendererActing = {
    	  current: false
    	};
    	function warnIfNotScopedWithMatchingAct(fiber) {
    	  {
    	    if ( IsSomeRendererActing.current === true && IsThisRendererActing.current !== true) {
    	      var previousFiber = current;

    	      try {
    	        setCurrentFiber(fiber);

    	        error("It looks like you're using the wrong act() around your test interactions.\n" + 'Be sure to use the matching version of act() corresponding to your renderer:\n\n' + '// for react-dom:\n' + // Break up imports to avoid accidentally parsing them as dependencies.
    	        'import {act} fr' + "om 'react-dom/test-utils';\n" + '// ...\n' + 'act(() => ...);\n\n' + '// for react-test-renderer:\n' + // Break up imports to avoid accidentally parsing them as dependencies.
    	        'import TestRenderer fr' + "om react-test-renderer';\n" + 'const {act} = TestRenderer;\n' + '// ...\n' + 'act(() => ...);');
    	      } finally {
    	        if (previousFiber) {
    	          setCurrentFiber(fiber);
    	        } else {
    	          resetCurrentFiber();
    	        }
    	      }
    	    }
    	  }
    	}
    	function warnIfNotCurrentlyActingEffectsInDEV(fiber) {
    	  {
    	    if ( (fiber.mode & StrictMode) !== NoMode && IsSomeRendererActing.current === false && IsThisRendererActing.current === false) {
    	      error('An update to %s ran an effect, but was not wrapped in act(...).\n\n' + 'When testing, code that causes React state updates should be ' + 'wrapped into act(...):\n\n' + 'act(() => {\n' + '  /* fire events that update state */\n' + '});\n' + '/* assert on the output */\n\n' + "This ensures that you're testing the behavior the user would see " + 'in the browser.' + ' Learn more at https://reactjs.org/link/wrap-tests-with-act', getComponentName(fiber.type));
    	    }
    	  }
    	}

    	function warnIfNotCurrentlyActingUpdatesInDEV(fiber) {
    	  {
    	    if ( executionContext === NoContext && IsSomeRendererActing.current === false && IsThisRendererActing.current === false) {
    	      var previousFiber = current;

    	      try {
    	        setCurrentFiber(fiber);

    	        error('An update to %s inside a test was not wrapped in act(...).\n\n' + 'When testing, code that causes React state updates should be ' + 'wrapped into act(...):\n\n' + 'act(() => {\n' + '  /* fire events that update state */\n' + '});\n' + '/* assert on the output */\n\n' + "This ensures that you're testing the behavior the user would see " + 'in the browser.' + ' Learn more at https://reactjs.org/link/wrap-tests-with-act', getComponentName(fiber.type));
    	      } finally {
    	        if (previousFiber) {
    	          setCurrentFiber(fiber);
    	        } else {
    	          resetCurrentFiber();
    	        }
    	      }
    	    }
    	  }
    	}

    	var warnIfNotCurrentlyActingUpdatesInDev = warnIfNotCurrentlyActingUpdatesInDEV; // In tests, we want to enforce a mocked scheduler.

    	var didWarnAboutUnmockedScheduler = false; // TODO Before we release concurrent mode, revisit this and decide whether a mocked
    	// scheduler is the actual recommendation. The alternative could be a testing build,
    	// a new lib, or whatever; we dunno just yet. This message is for early adopters
    	// to get their tests right.

    	function warnIfUnmockedScheduler(fiber) {
    	  {
    	    if (didWarnAboutUnmockedScheduler === false && Scheduler.unstable_flushAllWithoutAsserting === undefined) {
    	      if (fiber.mode & BlockingMode || fiber.mode & ConcurrentMode) {
    	        didWarnAboutUnmockedScheduler = true;

    	        error('In Concurrent or Sync modes, the "scheduler" module needs to be mocked ' + 'to guarantee consistent behaviour across tests and browsers. ' + 'For example, with jest: \n' + // Break up requires to avoid accidentally parsing them as dependencies.
    	        "jest.mock('scheduler', () => require" + "('scheduler/unstable_mock'));\n\n" + 'For more info, visit https://reactjs.org/link/mock-scheduler');
    	      }
    	    }
    	  }
    	}

    	function computeThreadID(root, lane) {
    	  // Interaction threads are unique per root and expiration time.
    	  // NOTE: Intentionally unsound cast. All that matters is that it's a number
    	  // and it represents a batch of work. Could make a helper function instead,
    	  // but meh this is fine for now.
    	  return lane * 1000 + root.interactionThreadID;
    	}

    	function markSpawnedWork(lane) {

    	  if (spawnedWorkDuringRender === null) {
    	    spawnedWorkDuringRender = [lane];
    	  } else {
    	    spawnedWorkDuringRender.push(lane);
    	  }
    	}

    	function scheduleInteractions(root, lane, interactions) {

    	  if (interactions.size > 0) {
    	    var pendingInteractionMap = root.pendingInteractionMap;
    	    var pendingInteractions = pendingInteractionMap.get(lane);

    	    if (pendingInteractions != null) {
    	      interactions.forEach(function (interaction) {
    	        if (!pendingInteractions.has(interaction)) {
    	          // Update the pending async work count for previously unscheduled interaction.
    	          interaction.__count++;
    	        }

    	        pendingInteractions.add(interaction);
    	      });
    	    } else {
    	      pendingInteractionMap.set(lane, new Set(interactions)); // Update the pending async work count for the current interactions.

    	      interactions.forEach(function (interaction) {
    	        interaction.__count++;
    	      });
    	    }

    	    var subscriber = tracing.__subscriberRef.current;

    	    if (subscriber !== null) {
    	      var threadID = computeThreadID(root, lane);
    	      subscriber.onWorkScheduled(interactions, threadID);
    	    }
    	  }
    	}

    	function schedulePendingInteractions(root, lane) {

    	  scheduleInteractions(root, lane, tracing.__interactionsRef.current);
    	}

    	function startWorkOnPendingInteractions(root, lanes) {
    	  // we can accurately attribute time spent working on it, And so that cascading
    	  // work triggered during the render phase will be associated with it.


    	  var interactions = new Set();
    	  root.pendingInteractionMap.forEach(function (scheduledInteractions, scheduledLane) {
    	    if (includesSomeLane(lanes, scheduledLane)) {
    	      scheduledInteractions.forEach(function (interaction) {
    	        return interactions.add(interaction);
    	      });
    	    }
    	  }); // Store the current set of interactions on the FiberRoot for a few reasons:
    	  // We can re-use it in hot functions like performConcurrentWorkOnRoot()
    	  // without having to recalculate it. We will also use it in commitWork() to
    	  // pass to any Profiler onRender() hooks. This also provides DevTools with a
    	  // way to access it when the onCommitRoot() hook is called.

    	  root.memoizedInteractions = interactions;

    	  if (interactions.size > 0) {
    	    var subscriber = tracing.__subscriberRef.current;

    	    if (subscriber !== null) {
    	      var threadID = computeThreadID(root, lanes);

    	      try {
    	        subscriber.onWorkStarted(interactions, threadID);
    	      } catch (error) {
    	        // If the subscriber throws, rethrow it in a separate task
    	        scheduleCallback(ImmediatePriority$1, function () {
    	          throw error;
    	        });
    	      }
    	    }
    	  }
    	}

    	function finishPendingInteractions(root, committedLanes) {

    	  var remainingLanesAfterCommit = root.pendingLanes;
    	  var subscriber;

    	  try {
    	    subscriber = tracing.__subscriberRef.current;

    	    if (subscriber !== null && root.memoizedInteractions.size > 0) {
    	      // FIXME: More than one lane can finish in a single commit.
    	      var threadID = computeThreadID(root, committedLanes);
    	      subscriber.onWorkStopped(root.memoizedInteractions, threadID);
    	    }
    	  } catch (error) {
    	    // If the subscriber throws, rethrow it in a separate task
    	    scheduleCallback(ImmediatePriority$1, function () {
    	      throw error;
    	    });
    	  } finally {
    	    // Clear completed interactions from the pending Map.
    	    // Unless the render was suspended or cascading work was scheduled,
    	    // In which case– leave pending interactions until the subsequent render.
    	    var pendingInteractionMap = root.pendingInteractionMap;
    	    pendingInteractionMap.forEach(function (scheduledInteractions, lane) {
    	      // Only decrement the pending interaction count if we're done.
    	      // If there's still work at the current priority,
    	      // That indicates that we are waiting for suspense data.
    	      if (!includesSomeLane(remainingLanesAfterCommit, lane)) {
    	        pendingInteractionMap.delete(lane);
    	        scheduledInteractions.forEach(function (interaction) {
    	          interaction.__count--;

    	          if (subscriber !== null && interaction.__count === 0) {
    	            try {
    	              subscriber.onInteractionScheduledWorkCompleted(interaction);
    	            } catch (error) {
    	              // If the subscriber throws, rethrow it in a separate task
    	              scheduleCallback(ImmediatePriority$1, function () {
    	                throw error;
    	              });
    	            }
    	          }
    	        });
    	      }
    	    });
    	  }
    	} // `act` testing API

    	function shouldForceFlushFallbacksInDEV() {
    	  // Never force flush in production. This function should get stripped out.
    	  return  actingUpdatesScopeDepth > 0;
    	}
    	// so we can tell if any async act() calls try to run in parallel.


    	var actingUpdatesScopeDepth = 0;

    	function detachFiberAfterEffects(fiber) {
    	  fiber.sibling = null;
    	  fiber.stateNode = null;
    	}

    	var resolveFamily = null; // $FlowFixMe Flow gets confused by a WeakSet feature check below.

    	var failedBoundaries = null;
    	var setRefreshHandler = function (handler) {
    	  {
    	    resolveFamily = handler;
    	  }
    	};
    	function resolveFunctionForHotReloading(type) {
    	  {
    	    if (resolveFamily === null) {
    	      // Hot reloading is disabled.
    	      return type;
    	    }

    	    var family = resolveFamily(type);

    	    if (family === undefined) {
    	      return type;
    	    } // Use the latest known implementation.


    	    return family.current;
    	  }
    	}
    	function resolveClassForHotReloading(type) {
    	  // No implementation differences.
    	  return resolveFunctionForHotReloading(type);
    	}
    	function resolveForwardRefForHotReloading(type) {
    	  {
    	    if (resolveFamily === null) {
    	      // Hot reloading is disabled.
    	      return type;
    	    }

    	    var family = resolveFamily(type);

    	    if (family === undefined) {
    	      // Check if we're dealing with a real forwardRef. Don't want to crash early.
    	      if (type !== null && type !== undefined && typeof type.render === 'function') {
    	        // ForwardRef is special because its resolved .type is an object,
    	        // but it's possible that we only have its inner render function in the map.
    	        // If that inner render function is different, we'll build a new forwardRef type.
    	        var currentRender = resolveFunctionForHotReloading(type.render);

    	        if (type.render !== currentRender) {
    	          var syntheticType = {
    	            $$typeof: REACT_FORWARD_REF_TYPE,
    	            render: currentRender
    	          };

    	          if (type.displayName !== undefined) {
    	            syntheticType.displayName = type.displayName;
    	          }

    	          return syntheticType;
    	        }
    	      }

    	      return type;
    	    } // Use the latest known implementation.


    	    return family.current;
    	  }
    	}
    	function isCompatibleFamilyForHotReloading(fiber, element) {
    	  {
    	    if (resolveFamily === null) {
    	      // Hot reloading is disabled.
    	      return false;
    	    }

    	    var prevType = fiber.elementType;
    	    var nextType = element.type; // If we got here, we know types aren't === equal.

    	    var needsCompareFamilies = false;
    	    var $$typeofNextType = typeof nextType === 'object' && nextType !== null ? nextType.$$typeof : null;

    	    switch (fiber.tag) {
    	      case ClassComponent:
    	        {
    	          if (typeof nextType === 'function') {
    	            needsCompareFamilies = true;
    	          }

    	          break;
    	        }

    	      case FunctionComponent:
    	        {
    	          if (typeof nextType === 'function') {
    	            needsCompareFamilies = true;
    	          } else if ($$typeofNextType === REACT_LAZY_TYPE) {
    	            // We don't know the inner type yet.
    	            // We're going to assume that the lazy inner type is stable,
    	            // and so it is sufficient to avoid reconciling it away.
    	            // We're not going to unwrap or actually use the new lazy type.
    	            needsCompareFamilies = true;
    	          }

    	          break;
    	        }

    	      case ForwardRef:
    	        {
    	          if ($$typeofNextType === REACT_FORWARD_REF_TYPE) {
    	            needsCompareFamilies = true;
    	          } else if ($$typeofNextType === REACT_LAZY_TYPE) {
    	            needsCompareFamilies = true;
    	          }

    	          break;
    	        }

    	      case MemoComponent:
    	      case SimpleMemoComponent:
    	        {
    	          if ($$typeofNextType === REACT_MEMO_TYPE) {
    	            // TODO: if it was but can no longer be simple,
    	            // we shouldn't set this.
    	            needsCompareFamilies = true;
    	          } else if ($$typeofNextType === REACT_LAZY_TYPE) {
    	            needsCompareFamilies = true;
    	          }

    	          break;
    	        }

    	      default:
    	        return false;
    	    } // Check if both types have a family and it's the same one.


    	    if (needsCompareFamilies) {
    	      // Note: memo() and forwardRef() we'll compare outer rather than inner type.
    	      // This means both of them need to be registered to preserve state.
    	      // If we unwrapped and compared the inner types for wrappers instead,
    	      // then we would risk falsely saying two separate memo(Foo)
    	      // calls are equivalent because they wrap the same Foo function.
    	      var prevFamily = resolveFamily(prevType);

    	      if (prevFamily !== undefined && prevFamily === resolveFamily(nextType)) {
    	        return true;
    	      }
    	    }

    	    return false;
    	  }
    	}
    	function markFailedErrorBoundaryForHotReloading(fiber) {
    	  {
    	    if (resolveFamily === null) {
    	      // Hot reloading is disabled.
    	      return;
    	    }

    	    if (typeof WeakSet !== 'function') {
    	      return;
    	    }

    	    if (failedBoundaries === null) {
    	      failedBoundaries = new WeakSet();
    	    }

    	    failedBoundaries.add(fiber);
    	  }
    	}
    	var scheduleRefresh = function (root, update) {
    	  {
    	    if (resolveFamily === null) {
    	      // Hot reloading is disabled.
    	      return;
    	    }

    	    var staleFamilies = update.staleFamilies,
    	        updatedFamilies = update.updatedFamilies;
    	    flushPassiveEffects();
    	    flushSync(function () {
    	      scheduleFibersWithFamiliesRecursively(root.current, updatedFamilies, staleFamilies);
    	    });
    	  }
    	};
    	var scheduleRoot = function (root, element) {
    	  {
    	    if (root.context !== emptyContextObject) {
    	      // Super edge case: root has a legacy _renderSubtree context
    	      // but we don't know the parentComponent so we can't pass it.
    	      // Just ignore. We'll delete this with _renderSubtree code path later.
    	      return;
    	    }

    	    flushPassiveEffects();
    	    flushSync(function () {
    	      updateContainer(element, root, null, null);
    	    });
    	  }
    	};

    	function scheduleFibersWithFamiliesRecursively(fiber, updatedFamilies, staleFamilies) {
    	  {
    	    var alternate = fiber.alternate,
    	        child = fiber.child,
    	        sibling = fiber.sibling,
    	        tag = fiber.tag,
    	        type = fiber.type;
    	    var candidateType = null;

    	    switch (tag) {
    	      case FunctionComponent:
    	      case SimpleMemoComponent:
    	      case ClassComponent:
    	        candidateType = type;
    	        break;

    	      case ForwardRef:
    	        candidateType = type.render;
    	        break;
    	    }

    	    if (resolveFamily === null) {
    	      throw new Error('Expected resolveFamily to be set during hot reload.');
    	    }

    	    var needsRender = false;
    	    var needsRemount = false;

    	    if (candidateType !== null) {
    	      var family = resolveFamily(candidateType);

    	      if (family !== undefined) {
    	        if (staleFamilies.has(family)) {
    	          needsRemount = true;
    	        } else if (updatedFamilies.has(family)) {
    	          if (tag === ClassComponent) {
    	            needsRemount = true;
    	          } else {
    	            needsRender = true;
    	          }
    	        }
    	      }
    	    }

    	    if (failedBoundaries !== null) {
    	      if (failedBoundaries.has(fiber) || alternate !== null && failedBoundaries.has(alternate)) {
    	        needsRemount = true;
    	      }
    	    }

    	    if (needsRemount) {
    	      fiber._debugNeedsRemount = true;
    	    }

    	    if (needsRemount || needsRender) {
    	      scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	    }

    	    if (child !== null && !needsRemount) {
    	      scheduleFibersWithFamiliesRecursively(child, updatedFamilies, staleFamilies);
    	    }

    	    if (sibling !== null) {
    	      scheduleFibersWithFamiliesRecursively(sibling, updatedFamilies, staleFamilies);
    	    }
    	  }
    	}

    	var findHostInstancesForRefresh = function (root, families) {
    	  {
    	    var hostInstances = new Set();
    	    var types = new Set(families.map(function (family) {
    	      return family.current;
    	    }));
    	    findHostInstancesForMatchingFibersRecursively(root.current, types, hostInstances);
    	    return hostInstances;
    	  }
    	};

    	function findHostInstancesForMatchingFibersRecursively(fiber, types, hostInstances) {
    	  {
    	    var child = fiber.child,
    	        sibling = fiber.sibling,
    	        tag = fiber.tag,
    	        type = fiber.type;
    	    var candidateType = null;

    	    switch (tag) {
    	      case FunctionComponent:
    	      case SimpleMemoComponent:
    	      case ClassComponent:
    	        candidateType = type;
    	        break;

    	      case ForwardRef:
    	        candidateType = type.render;
    	        break;
    	    }

    	    var didMatch = false;

    	    if (candidateType !== null) {
    	      if (types.has(candidateType)) {
    	        didMatch = true;
    	      }
    	    }

    	    if (didMatch) {
    	      // We have a match. This only drills down to the closest host components.
    	      // There's no need to search deeper because for the purpose of giving
    	      // visual feedback, "flashing" outermost parent rectangles is sufficient.
    	      findHostInstancesForFiberShallowly(fiber, hostInstances);
    	    } else {
    	      // If there's no match, maybe there will be one further down in the child tree.
    	      if (child !== null) {
    	        findHostInstancesForMatchingFibersRecursively(child, types, hostInstances);
    	      }
    	    }

    	    if (sibling !== null) {
    	      findHostInstancesForMatchingFibersRecursively(sibling, types, hostInstances);
    	    }
    	  }
    	}

    	function findHostInstancesForFiberShallowly(fiber, hostInstances) {
    	  {
    	    var foundHostInstances = findChildHostInstancesForFiberShallowly(fiber, hostInstances);

    	    if (foundHostInstances) {
    	      return;
    	    } // If we didn't find any host children, fallback to closest host parent.


    	    var node = fiber;

    	    while (true) {
    	      switch (node.tag) {
    	        case HostComponent:
    	          hostInstances.add(node.stateNode);
    	          return;

    	        case HostPortal:
    	          hostInstances.add(node.stateNode.containerInfo);
    	          return;

    	        case HostRoot:
    	          hostInstances.add(node.stateNode.containerInfo);
    	          return;
    	      }

    	      if (node.return === null) {
    	        throw new Error('Expected to reach root first.');
    	      }

    	      node = node.return;
    	    }
    	  }
    	}

    	function findChildHostInstancesForFiberShallowly(fiber, hostInstances) {
    	  {
    	    var node = fiber;
    	    var foundHostInstances = false;

    	    while (true) {
    	      if (node.tag === HostComponent) {
    	        // We got a match.
    	        foundHostInstances = true;
    	        hostInstances.add(node.stateNode); // There may still be more, so keep searching.
    	      } else if (node.child !== null) {
    	        node.child.return = node;
    	        node = node.child;
    	        continue;
    	      }

    	      if (node === fiber) {
    	        return foundHostInstances;
    	      }

    	      while (node.sibling === null) {
    	        if (node.return === null || node.return === fiber) {
    	          return foundHostInstances;
    	        }

    	        node = node.return;
    	      }

    	      node.sibling.return = node.return;
    	      node = node.sibling;
    	    }
    	  }

    	  return false;
    	}

    	var hasBadMapPolyfill;

    	{
    	  hasBadMapPolyfill = false;

    	  try {
    	    var nonExtensibleObject = Object.preventExtensions({});
    	    /* eslint-disable no-new */

    	    new Map([[nonExtensibleObject, null]]);
    	    new Set([nonExtensibleObject]);
    	    /* eslint-enable no-new */
    	  } catch (e) {
    	    // TODO: Consider warning about bad polyfills
    	    hasBadMapPolyfill = true;
    	  }
    	}

    	var debugCounter = 1;

    	function FiberNode(tag, pendingProps, key, mode) {
    	  // Instance
    	  this.tag = tag;
    	  this.key = key;
    	  this.elementType = null;
    	  this.type = null;
    	  this.stateNode = null; // Fiber

    	  this.return = null;
    	  this.child = null;
    	  this.sibling = null;
    	  this.index = 0;
    	  this.ref = null;
    	  this.pendingProps = pendingProps;
    	  this.memoizedProps = null;
    	  this.updateQueue = null;
    	  this.memoizedState = null;
    	  this.dependencies = null;
    	  this.mode = mode; // Effects

    	  this.flags = NoFlags;
    	  this.nextEffect = null;
    	  this.firstEffect = null;
    	  this.lastEffect = null;
    	  this.lanes = NoLanes;
    	  this.childLanes = NoLanes;
    	  this.alternate = null;

    	  {
    	    // Note: The following is done to avoid a v8 performance cliff.
    	    //
    	    // Initializing the fields below to smis and later updating them with
    	    // double values will cause Fibers to end up having separate shapes.
    	    // This behavior/bug has something to do with Object.preventExtension().
    	    // Fortunately this only impacts DEV builds.
    	    // Unfortunately it makes React unusably slow for some applications.
    	    // To work around this, initialize the fields below with doubles.
    	    //
    	    // Learn more about this here:
    	    // https://github.com/facebook/react/issues/14365
    	    // https://bugs.chromium.org/p/v8/issues/detail?id=8538
    	    this.actualDuration = Number.NaN;
    	    this.actualStartTime = Number.NaN;
    	    this.selfBaseDuration = Number.NaN;
    	    this.treeBaseDuration = Number.NaN; // It's okay to replace the initial doubles with smis after initialization.
    	    // This won't trigger the performance cliff mentioned above,
    	    // and it simplifies other profiler code (including DevTools).

    	    this.actualDuration = 0;
    	    this.actualStartTime = -1;
    	    this.selfBaseDuration = 0;
    	    this.treeBaseDuration = 0;
    	  }

    	  {
    	    // This isn't directly used but is handy for debugging internals:
    	    this._debugID = debugCounter++;
    	    this._debugSource = null;
    	    this._debugOwner = null;
    	    this._debugNeedsRemount = false;
    	    this._debugHookTypes = null;

    	    if (!hasBadMapPolyfill && typeof Object.preventExtensions === 'function') {
    	      Object.preventExtensions(this);
    	    }
    	  }
    	} // This is a constructor function, rather than a POJO constructor, still
    	// please ensure we do the following:
    	// 1) Nobody should add any instance methods on this. Instance methods can be
    	//    more difficult to predict when they get optimized and they are almost
    	//    never inlined properly in static compilers.
    	// 2) Nobody should rely on `instanceof Fiber` for type testing. We should
    	//    always know when it is a fiber.
    	// 3) We might want to experiment with using numeric keys since they are easier
    	//    to optimize in a non-JIT environment.
    	// 4) We can easily go from a constructor to a createFiber object literal if that
    	//    is faster.
    	// 5) It should be easy to port this to a C struct and keep a C implementation
    	//    compatible.


    	var createFiber = function (tag, pendingProps, key, mode) {
    	  // $FlowFixMe: the shapes are exact here but Flow doesn't like constructors
    	  return new FiberNode(tag, pendingProps, key, mode);
    	};

    	function shouldConstruct$1(Component) {
    	  var prototype = Component.prototype;
    	  return !!(prototype && prototype.isReactComponent);
    	}

    	function isSimpleFunctionComponent(type) {
    	  return typeof type === 'function' && !shouldConstruct$1(type) && type.defaultProps === undefined;
    	}
    	function resolveLazyComponentTag(Component) {
    	  if (typeof Component === 'function') {
    	    return shouldConstruct$1(Component) ? ClassComponent : FunctionComponent;
    	  } else if (Component !== undefined && Component !== null) {
    	    var $$typeof = Component.$$typeof;

    	    if ($$typeof === REACT_FORWARD_REF_TYPE) {
    	      return ForwardRef;
    	    }

    	    if ($$typeof === REACT_MEMO_TYPE) {
    	      return MemoComponent;
    	    }
    	  }

    	  return IndeterminateComponent;
    	} // This is used to create an alternate fiber to do work on.

    	function createWorkInProgress(current, pendingProps) {
    	  var workInProgress = current.alternate;

    	  if (workInProgress === null) {
    	    // We use a double buffering pooling technique because we know that we'll
    	    // only ever need at most two versions of a tree. We pool the "other" unused
    	    // node that we're free to reuse. This is lazily created to avoid allocating
    	    // extra objects for things that are never updated. It also allow us to
    	    // reclaim the extra memory if needed.
    	    workInProgress = createFiber(current.tag, pendingProps, current.key, current.mode);
    	    workInProgress.elementType = current.elementType;
    	    workInProgress.type = current.type;
    	    workInProgress.stateNode = current.stateNode;

    	    {
    	      // DEV-only fields
    	      workInProgress._debugID = current._debugID;
    	      workInProgress._debugSource = current._debugSource;
    	      workInProgress._debugOwner = current._debugOwner;
    	      workInProgress._debugHookTypes = current._debugHookTypes;
    	    }

    	    workInProgress.alternate = current;
    	    current.alternate = workInProgress;
    	  } else {
    	    workInProgress.pendingProps = pendingProps; // Needed because Blocks store data on type.

    	    workInProgress.type = current.type; // We already have an alternate.
    	    // Reset the effect tag.

    	    workInProgress.flags = NoFlags; // The effect list is no longer valid.

    	    workInProgress.nextEffect = null;
    	    workInProgress.firstEffect = null;
    	    workInProgress.lastEffect = null;

    	    {
    	      // We intentionally reset, rather than copy, actualDuration & actualStartTime.
    	      // This prevents time from endlessly accumulating in new commits.
    	      // This has the downside of resetting values for different priority renders,
    	      // But works for yielding (the common case) and should support resuming.
    	      workInProgress.actualDuration = 0;
    	      workInProgress.actualStartTime = -1;
    	    }
    	  }

    	  workInProgress.childLanes = current.childLanes;
    	  workInProgress.lanes = current.lanes;
    	  workInProgress.child = current.child;
    	  workInProgress.memoizedProps = current.memoizedProps;
    	  workInProgress.memoizedState = current.memoizedState;
    	  workInProgress.updateQueue = current.updateQueue; // Clone the dependencies object. This is mutated during the render phase, so
    	  // it cannot be shared with the current fiber.

    	  var currentDependencies = current.dependencies;
    	  workInProgress.dependencies = currentDependencies === null ? null : {
    	    lanes: currentDependencies.lanes,
    	    firstContext: currentDependencies.firstContext
    	  }; // These will be overridden during the parent's reconciliation

    	  workInProgress.sibling = current.sibling;
    	  workInProgress.index = current.index;
    	  workInProgress.ref = current.ref;

    	  {
    	    workInProgress.selfBaseDuration = current.selfBaseDuration;
    	    workInProgress.treeBaseDuration = current.treeBaseDuration;
    	  }

    	  {
    	    workInProgress._debugNeedsRemount = current._debugNeedsRemount;

    	    switch (workInProgress.tag) {
    	      case IndeterminateComponent:
    	      case FunctionComponent:
    	      case SimpleMemoComponent:
    	        workInProgress.type = resolveFunctionForHotReloading(current.type);
    	        break;

    	      case ClassComponent:
    	        workInProgress.type = resolveClassForHotReloading(current.type);
    	        break;

    	      case ForwardRef:
    	        workInProgress.type = resolveForwardRefForHotReloading(current.type);
    	        break;
    	    }
    	  }

    	  return workInProgress;
    	} // Used to reuse a Fiber for a second pass.

    	function resetWorkInProgress(workInProgress, renderLanes) {
    	  // This resets the Fiber to what createFiber or createWorkInProgress would
    	  // have set the values to before during the first pass. Ideally this wouldn't
    	  // be necessary but unfortunately many code paths reads from the workInProgress
    	  // when they should be reading from current and writing to workInProgress.
    	  // We assume pendingProps, index, key, ref, return are still untouched to
    	  // avoid doing another reconciliation.
    	  // Reset the effect tag but keep any Placement tags, since that's something
    	  // that child fiber is setting, not the reconciliation.
    	  workInProgress.flags &= Placement; // The effect list is no longer valid.

    	  workInProgress.nextEffect = null;
    	  workInProgress.firstEffect = null;
    	  workInProgress.lastEffect = null;
    	  var current = workInProgress.alternate;

    	  if (current === null) {
    	    // Reset to createFiber's initial values.
    	    workInProgress.childLanes = NoLanes;
    	    workInProgress.lanes = renderLanes;
    	    workInProgress.child = null;
    	    workInProgress.memoizedProps = null;
    	    workInProgress.memoizedState = null;
    	    workInProgress.updateQueue = null;
    	    workInProgress.dependencies = null;
    	    workInProgress.stateNode = null;

    	    {
    	      // Note: We don't reset the actualTime counts. It's useful to accumulate
    	      // actual time across multiple render passes.
    	      workInProgress.selfBaseDuration = 0;
    	      workInProgress.treeBaseDuration = 0;
    	    }
    	  } else {
    	    // Reset to the cloned values that createWorkInProgress would've.
    	    workInProgress.childLanes = current.childLanes;
    	    workInProgress.lanes = current.lanes;
    	    workInProgress.child = current.child;
    	    workInProgress.memoizedProps = current.memoizedProps;
    	    workInProgress.memoizedState = current.memoizedState;
    	    workInProgress.updateQueue = current.updateQueue; // Needed because Blocks store data on type.

    	    workInProgress.type = current.type; // Clone the dependencies object. This is mutated during the render phase, so
    	    // it cannot be shared with the current fiber.

    	    var currentDependencies = current.dependencies;
    	    workInProgress.dependencies = currentDependencies === null ? null : {
    	      lanes: currentDependencies.lanes,
    	      firstContext: currentDependencies.firstContext
    	    };

    	    {
    	      // Note: We don't reset the actualTime counts. It's useful to accumulate
    	      // actual time across multiple render passes.
    	      workInProgress.selfBaseDuration = current.selfBaseDuration;
    	      workInProgress.treeBaseDuration = current.treeBaseDuration;
    	    }
    	  }

    	  return workInProgress;
    	}
    	function createHostRootFiber(tag) {
    	  var mode;

    	  if (tag === ConcurrentRoot) {
    	    mode = ConcurrentMode | BlockingMode | StrictMode;
    	  } else if (tag === BlockingRoot) {
    	    mode = BlockingMode | StrictMode;
    	  } else {
    	    mode = NoMode;
    	  }

    	  if ( isDevToolsPresent) {
    	    // Always collect profile timings when DevTools are present.
    	    // This enables DevTools to start capturing timing at any point–
    	    // Without some nodes in the tree having empty base times.
    	    mode |= ProfileMode;
    	  }

    	  return createFiber(HostRoot, null, null, mode);
    	}
    	function createFiberFromTypeAndProps(type, // React$ElementType
    	key, pendingProps, owner, mode, lanes) {
    	  var fiberTag = IndeterminateComponent; // The resolved type is set if we know what the final type will be. I.e. it's not lazy.

    	  var resolvedType = type;

    	  if (typeof type === 'function') {
    	    if (shouldConstruct$1(type)) {
    	      fiberTag = ClassComponent;

    	      {
    	        resolvedType = resolveClassForHotReloading(resolvedType);
    	      }
    	    } else {
    	      {
    	        resolvedType = resolveFunctionForHotReloading(resolvedType);
    	      }
    	    }
    	  } else if (typeof type === 'string') {
    	    fiberTag = HostComponent;
    	  } else {
    	    getTag: switch (type) {
    	      case REACT_FRAGMENT_TYPE:
    	        return createFiberFromFragment(pendingProps.children, mode, lanes, key);

    	      case REACT_DEBUG_TRACING_MODE_TYPE:
    	        fiberTag = Mode;
    	        mode |= DebugTracingMode;
    	        break;

    	      case REACT_STRICT_MODE_TYPE:
    	        fiberTag = Mode;
    	        mode |= StrictMode;
    	        break;

    	      case REACT_PROFILER_TYPE:
    	        return createFiberFromProfiler(pendingProps, mode, lanes, key);

    	      case REACT_SUSPENSE_TYPE:
    	        return createFiberFromSuspense(pendingProps, mode, lanes, key);

    	      case REACT_SUSPENSE_LIST_TYPE:
    	        return createFiberFromSuspenseList(pendingProps, mode, lanes, key);

    	      case REACT_OFFSCREEN_TYPE:
    	        return createFiberFromOffscreen(pendingProps, mode, lanes, key);

    	      case REACT_LEGACY_HIDDEN_TYPE:
    	        return createFiberFromLegacyHidden(pendingProps, mode, lanes, key);

    	      case REACT_SCOPE_TYPE:

    	      // eslint-disable-next-line no-fallthrough

    	      default:
    	        {
    	          if (typeof type === 'object' && type !== null) {
    	            switch (type.$$typeof) {
    	              case REACT_PROVIDER_TYPE:
    	                fiberTag = ContextProvider;
    	                break getTag;

    	              case REACT_CONTEXT_TYPE:
    	                // This is a consumer
    	                fiberTag = ContextConsumer;
    	                break getTag;

    	              case REACT_FORWARD_REF_TYPE:
    	                fiberTag = ForwardRef;

    	                {
    	                  resolvedType = resolveForwardRefForHotReloading(resolvedType);
    	                }

    	                break getTag;

    	              case REACT_MEMO_TYPE:
    	                fiberTag = MemoComponent;
    	                break getTag;

    	              case REACT_LAZY_TYPE:
    	                fiberTag = LazyComponent;
    	                resolvedType = null;
    	                break getTag;

    	              case REACT_BLOCK_TYPE:
    	                fiberTag = Block;
    	                break getTag;
    	            }
    	          }

    	          var info = '';

    	          {
    	            if (type === undefined || typeof type === 'object' && type !== null && Object.keys(type).length === 0) {
    	              info += ' You likely forgot to export your component from the file ' + "it's defined in, or you might have mixed up default and " + 'named imports.';
    	            }

    	            var ownerName = owner ? getComponentName(owner.type) : null;

    	            if (ownerName) {
    	              info += '\n\nCheck the render method of `' + ownerName + '`.';
    	            }
    	          }

    	          {
    	            {
    	              throw Error( "Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: " + (type == null ? type : typeof type) + "." + info );
    	            }
    	          }
    	        }
    	    }
    	  }

    	  var fiber = createFiber(fiberTag, pendingProps, key, mode);
    	  fiber.elementType = type;
    	  fiber.type = resolvedType;
    	  fiber.lanes = lanes;

    	  {
    	    fiber._debugOwner = owner;
    	  }

    	  return fiber;
    	}
    	function createFiberFromElement(element, mode, lanes) {
    	  var owner = null;

    	  {
    	    owner = element._owner;
    	  }

    	  var type = element.type;
    	  var key = element.key;
    	  var pendingProps = element.props;
    	  var fiber = createFiberFromTypeAndProps(type, key, pendingProps, owner, mode, lanes);

    	  {
    	    fiber._debugSource = element._source;
    	    fiber._debugOwner = element._owner;
    	  }

    	  return fiber;
    	}
    	function createFiberFromFragment(elements, mode, lanes, key) {
    	  var fiber = createFiber(Fragment, elements, key, mode);
    	  fiber.lanes = lanes;
    	  return fiber;
    	}

    	function createFiberFromProfiler(pendingProps, mode, lanes, key) {
    	  {
    	    if (typeof pendingProps.id !== 'string') {
    	      error('Profiler must specify an "id" as a prop');
    	    }
    	  }

    	  var fiber = createFiber(Profiler, pendingProps, key, mode | ProfileMode); // TODO: The Profiler fiber shouldn't have a type. It has a tag.

    	  fiber.elementType = REACT_PROFILER_TYPE;
    	  fiber.type = REACT_PROFILER_TYPE;
    	  fiber.lanes = lanes;

    	  {
    	    fiber.stateNode = {
    	      effectDuration: 0,
    	      passiveEffectDuration: 0
    	    };
    	  }

    	  return fiber;
    	}

    	function createFiberFromSuspense(pendingProps, mode, lanes, key) {
    	  var fiber = createFiber(SuspenseComponent, pendingProps, key, mode); // TODO: The SuspenseComponent fiber shouldn't have a type. It has a tag.
    	  // This needs to be fixed in getComponentName so that it relies on the tag
    	  // instead.

    	  fiber.type = REACT_SUSPENSE_TYPE;
    	  fiber.elementType = REACT_SUSPENSE_TYPE;
    	  fiber.lanes = lanes;
    	  return fiber;
    	}
    	function createFiberFromSuspenseList(pendingProps, mode, lanes, key) {
    	  var fiber = createFiber(SuspenseListComponent, pendingProps, key, mode);

    	  {
    	    // TODO: The SuspenseListComponent fiber shouldn't have a type. It has a tag.
    	    // This needs to be fixed in getComponentName so that it relies on the tag
    	    // instead.
    	    fiber.type = REACT_SUSPENSE_LIST_TYPE;
    	  }

    	  fiber.elementType = REACT_SUSPENSE_LIST_TYPE;
    	  fiber.lanes = lanes;
    	  return fiber;
    	}
    	function createFiberFromOffscreen(pendingProps, mode, lanes, key) {
    	  var fiber = createFiber(OffscreenComponent, pendingProps, key, mode); // TODO: The OffscreenComponent fiber shouldn't have a type. It has a tag.
    	  // This needs to be fixed in getComponentName so that it relies on the tag
    	  // instead.

    	  {
    	    fiber.type = REACT_OFFSCREEN_TYPE;
    	  }

    	  fiber.elementType = REACT_OFFSCREEN_TYPE;
    	  fiber.lanes = lanes;
    	  return fiber;
    	}
    	function createFiberFromLegacyHidden(pendingProps, mode, lanes, key) {
    	  var fiber = createFiber(LegacyHiddenComponent, pendingProps, key, mode); // TODO: The LegacyHidden fiber shouldn't have a type. It has a tag.
    	  // This needs to be fixed in getComponentName so that it relies on the tag
    	  // instead.

    	  {
    	    fiber.type = REACT_LEGACY_HIDDEN_TYPE;
    	  }

    	  fiber.elementType = REACT_LEGACY_HIDDEN_TYPE;
    	  fiber.lanes = lanes;
    	  return fiber;
    	}
    	function createFiberFromText(content, mode, lanes) {
    	  var fiber = createFiber(HostText, content, null, mode);
    	  fiber.lanes = lanes;
    	  return fiber;
    	}
    	function createFiberFromHostInstanceForDeletion() {
    	  var fiber = createFiber(HostComponent, null, null, NoMode); // TODO: These should not need a type.

    	  fiber.elementType = 'DELETED';
    	  fiber.type = 'DELETED';
    	  return fiber;
    	}
    	function createFiberFromPortal(portal, mode, lanes) {
    	  var pendingProps = portal.children !== null ? portal.children : [];
    	  var fiber = createFiber(HostPortal, pendingProps, portal.key, mode);
    	  fiber.lanes = lanes;
    	  fiber.stateNode = {
    	    containerInfo: portal.containerInfo,
    	    pendingChildren: null,
    	    // Used by persistent updates
    	    implementation: portal.implementation
    	  };
    	  return fiber;
    	} // Used for stashing WIP properties to replay failed work in DEV.

    	function assignFiberPropertiesInDEV(target, source) {
    	  if (target === null) {
    	    // This Fiber's initial properties will always be overwritten.
    	    // We only use a Fiber to ensure the same hidden class so DEV isn't slow.
    	    target = createFiber(IndeterminateComponent, null, null, NoMode);
    	  } // This is intentionally written as a list of all properties.
    	  // We tried to use Object.assign() instead but this is called in
    	  // the hottest path, and Object.assign() was too slow:
    	  // https://github.com/facebook/react/issues/12502
    	  // This code is DEV-only so size is not a concern.


    	  target.tag = source.tag;
    	  target.key = source.key;
    	  target.elementType = source.elementType;
    	  target.type = source.type;
    	  target.stateNode = source.stateNode;
    	  target.return = source.return;
    	  target.child = source.child;
    	  target.sibling = source.sibling;
    	  target.index = source.index;
    	  target.ref = source.ref;
    	  target.pendingProps = source.pendingProps;
    	  target.memoizedProps = source.memoizedProps;
    	  target.updateQueue = source.updateQueue;
    	  target.memoizedState = source.memoizedState;
    	  target.dependencies = source.dependencies;
    	  target.mode = source.mode;
    	  target.flags = source.flags;
    	  target.nextEffect = source.nextEffect;
    	  target.firstEffect = source.firstEffect;
    	  target.lastEffect = source.lastEffect;
    	  target.lanes = source.lanes;
    	  target.childLanes = source.childLanes;
    	  target.alternate = source.alternate;

    	  {
    	    target.actualDuration = source.actualDuration;
    	    target.actualStartTime = source.actualStartTime;
    	    target.selfBaseDuration = source.selfBaseDuration;
    	    target.treeBaseDuration = source.treeBaseDuration;
    	  }

    	  target._debugID = source._debugID;
    	  target._debugSource = source._debugSource;
    	  target._debugOwner = source._debugOwner;
    	  target._debugNeedsRemount = source._debugNeedsRemount;
    	  target._debugHookTypes = source._debugHookTypes;
    	  return target;
    	}

    	function FiberRootNode(containerInfo, tag, hydrate) {
    	  this.tag = tag;
    	  this.containerInfo = containerInfo;
    	  this.pendingChildren = null;
    	  this.current = null;
    	  this.pingCache = null;
    	  this.finishedWork = null;
    	  this.timeoutHandle = noTimeout;
    	  this.context = null;
    	  this.pendingContext = null;
    	  this.hydrate = hydrate;
    	  this.callbackNode = null;
    	  this.callbackPriority = NoLanePriority;
    	  this.eventTimes = createLaneMap(NoLanes);
    	  this.expirationTimes = createLaneMap(NoTimestamp);
    	  this.pendingLanes = NoLanes;
    	  this.suspendedLanes = NoLanes;
    	  this.pingedLanes = NoLanes;
    	  this.expiredLanes = NoLanes;
    	  this.mutableReadLanes = NoLanes;
    	  this.finishedLanes = NoLanes;
    	  this.entangledLanes = NoLanes;
    	  this.entanglements = createLaneMap(NoLanes);

    	  {
    	    this.mutableSourceEagerHydrationData = null;
    	  }

    	  {
    	    this.interactionThreadID = tracing.unstable_getThreadID();
    	    this.memoizedInteractions = new Set();
    	    this.pendingInteractionMap = new Map();
    	  }

    	  {
    	    switch (tag) {
    	      case BlockingRoot:
    	        this._debugRootType = 'createBlockingRoot()';
    	        break;

    	      case ConcurrentRoot:
    	        this._debugRootType = 'createRoot()';
    	        break;

    	      case LegacyRoot:
    	        this._debugRootType = 'createLegacyRoot()';
    	        break;
    	    }
    	  }
    	}

    	function createFiberRoot(containerInfo, tag, hydrate, hydrationCallbacks) {
    	  var root = new FiberRootNode(containerInfo, tag, hydrate);
    	  // stateNode is any.


    	  var uninitializedFiber = createHostRootFiber(tag);
    	  root.current = uninitializedFiber;
    	  uninitializedFiber.stateNode = root;
    	  initializeUpdateQueue(uninitializedFiber);
    	  return root;
    	}

    	// This ensures that the version used for server rendering matches the one
    	// that is eventually read during hydration.
    	// If they don't match there's a potential tear and a full deopt render is required.

    	function registerMutableSourceForHydration(root, mutableSource) {
    	  var getVersion = mutableSource._getVersion;
    	  var version = getVersion(mutableSource._source); // TODO Clear this data once all pending hydration work is finished.
    	  // Retaining it forever may interfere with GC.

    	  if (root.mutableSourceEagerHydrationData == null) {
    	    root.mutableSourceEagerHydrationData = [mutableSource, version];
    	  } else {
    	    root.mutableSourceEagerHydrationData.push(mutableSource, version);
    	  }
    	}

    	function createPortal(children, containerInfo, // TODO: figure out the API for cross-renderer implementation.
    	implementation) {
    	  var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    	  return {
    	    // This tag allow us to uniquely identify this as a React Portal
    	    $$typeof: REACT_PORTAL_TYPE,
    	    key: key == null ? null : '' + key,
    	    children: children,
    	    containerInfo: containerInfo,
    	    implementation: implementation
    	  };
    	}

    	var didWarnAboutNestedUpdates;
    	var didWarnAboutFindNodeInStrictMode;

    	{
    	  didWarnAboutNestedUpdates = false;
    	  didWarnAboutFindNodeInStrictMode = {};
    	}

    	function getContextForSubtree(parentComponent) {
    	  if (!parentComponent) {
    	    return emptyContextObject;
    	  }

    	  var fiber = get(parentComponent);
    	  var parentContext = findCurrentUnmaskedContext(fiber);

    	  if (fiber.tag === ClassComponent) {
    	    var Component = fiber.type;

    	    if (isContextProvider(Component)) {
    	      return processChildContext(fiber, Component, parentContext);
    	    }
    	  }

    	  return parentContext;
    	}

    	function findHostInstanceWithWarning(component, methodName) {
    	  {
    	    var fiber = get(component);

    	    if (fiber === undefined) {
    	      if (typeof component.render === 'function') {
    	        {
    	          {
    	            throw Error( "Unable to find node on an unmounted component." );
    	          }
    	        }
    	      } else {
    	        {
    	          {
    	            throw Error( "Argument appears to not be a ReactComponent. Keys: " + Object.keys(component) );
    	          }
    	        }
    	      }
    	    }

    	    var hostFiber = findCurrentHostFiber(fiber);

    	    if (hostFiber === null) {
    	      return null;
    	    }

    	    if (hostFiber.mode & StrictMode) {
    	      var componentName = getComponentName(fiber.type) || 'Component';

    	      if (!didWarnAboutFindNodeInStrictMode[componentName]) {
    	        didWarnAboutFindNodeInStrictMode[componentName] = true;
    	        var previousFiber = current;

    	        try {
    	          setCurrentFiber(hostFiber);

    	          if (fiber.mode & StrictMode) {
    	            error('%s is deprecated in StrictMode. ' + '%s was passed an instance of %s which is inside StrictMode. ' + 'Instead, add a ref directly to the element you want to reference. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-find-node', methodName, methodName, componentName);
    	          } else {
    	            error('%s is deprecated in StrictMode. ' + '%s was passed an instance of %s which renders StrictMode children. ' + 'Instead, add a ref directly to the element you want to reference. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-find-node', methodName, methodName, componentName);
    	          }
    	        } finally {
    	          // Ideally this should reset to previous but this shouldn't be called in
    	          // render and there's another warning for that anyway.
    	          if (previousFiber) {
    	            setCurrentFiber(previousFiber);
    	          } else {
    	            resetCurrentFiber();
    	          }
    	        }
    	      }
    	    }

    	    return hostFiber.stateNode;
    	  }
    	}

    	function createContainer(containerInfo, tag, hydrate, hydrationCallbacks) {
    	  return createFiberRoot(containerInfo, tag, hydrate);
    	}
    	function updateContainer(element, container, parentComponent, callback) {
    	  {
    	    onScheduleRoot(container, element);
    	  }

    	  var current$1 = container.current;
    	  var eventTime = requestEventTime();

    	  {
    	    // $FlowExpectedError - jest isn't a global, and isn't recognized outside of tests
    	    if ('undefined' !== typeof jest) {
    	      warnIfUnmockedScheduler(current$1);
    	      warnIfNotScopedWithMatchingAct(current$1);
    	    }
    	  }

    	  var lane = requestUpdateLane(current$1);

    	  var context = getContextForSubtree(parentComponent);

    	  if (container.context === null) {
    	    container.context = context;
    	  } else {
    	    container.pendingContext = context;
    	  }

    	  {
    	    if (isRendering && current !== null && !didWarnAboutNestedUpdates) {
    	      didWarnAboutNestedUpdates = true;

    	      error('Render methods should be a pure function of props and state; ' + 'triggering nested component updates from render is not allowed. ' + 'If necessary, trigger nested updates in componentDidUpdate.\n\n' + 'Check the render method of %s.', getComponentName(current.type) || 'Unknown');
    	    }
    	  }

    	  var update = createUpdate(eventTime, lane); // Caution: React DevTools currently depends on this property
    	  // being called "element".

    	  update.payload = {
    	    element: element
    	  };
    	  callback = callback === undefined ? null : callback;

    	  if (callback !== null) {
    	    {
    	      if (typeof callback !== 'function') {
    	        error('render(...): Expected the last optional `callback` argument to be a ' + 'function. Instead received: %s.', callback);
    	      }
    	    }

    	    update.callback = callback;
    	  }

    	  enqueueUpdate(current$1, update);
    	  scheduleUpdateOnFiber(current$1, lane, eventTime);
    	  return lane;
    	}
    	function getPublicRootInstance(container) {
    	  var containerFiber = container.current;

    	  if (!containerFiber.child) {
    	    return null;
    	  }

    	  switch (containerFiber.child.tag) {
    	    case HostComponent:
    	      return getPublicInstance(containerFiber.child.stateNode);

    	    default:
    	      return containerFiber.child.stateNode;
    	  }
    	}

    	function markRetryLaneImpl(fiber, retryLane) {
    	  var suspenseState = fiber.memoizedState;

    	  if (suspenseState !== null && suspenseState.dehydrated !== null) {
    	    suspenseState.retryLane = higherPriorityLane(suspenseState.retryLane, retryLane);
    	  }
    	} // Increases the priority of thennables when they resolve within this boundary.


    	function markRetryLaneIfNotHydrated(fiber, retryLane) {
    	  markRetryLaneImpl(fiber, retryLane);
    	  var alternate = fiber.alternate;

    	  if (alternate) {
    	    markRetryLaneImpl(alternate, retryLane);
    	  }
    	}

    	function attemptUserBlockingHydration$1(fiber) {
    	  if (fiber.tag !== SuspenseComponent) {
    	    // We ignore HostRoots here because we can't increase
    	    // their priority and they should not suspend on I/O,
    	    // since you have to wrap anything that might suspend in
    	    // Suspense.
    	    return;
    	  }

    	  var eventTime = requestEventTime();
    	  var lane = InputDiscreteHydrationLane;
    	  scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  markRetryLaneIfNotHydrated(fiber, lane);
    	}
    	function attemptContinuousHydration$1(fiber) {
    	  if (fiber.tag !== SuspenseComponent) {
    	    // We ignore HostRoots here because we can't increase
    	    // their priority and they should not suspend on I/O,
    	    // since you have to wrap anything that might suspend in
    	    // Suspense.
    	    return;
    	  }

    	  var eventTime = requestEventTime();
    	  var lane = SelectiveHydrationLane;
    	  scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  markRetryLaneIfNotHydrated(fiber, lane);
    	}
    	function attemptHydrationAtCurrentPriority$1(fiber) {
    	  if (fiber.tag !== SuspenseComponent) {
    	    // We ignore HostRoots here because we can't increase
    	    // their priority other than synchronously flush it.
    	    return;
    	  }

    	  var eventTime = requestEventTime();
    	  var lane = requestUpdateLane(fiber);
    	  scheduleUpdateOnFiber(fiber, lane, eventTime);
    	  markRetryLaneIfNotHydrated(fiber, lane);
    	}
    	function runWithPriority$2(priority, fn) {

    	  try {
    	    setCurrentUpdateLanePriority(priority);
    	    return fn();
    	  } finally {
    	  }
    	}
    	function findHostInstanceWithNoPortals(fiber) {
    	  var hostFiber = findCurrentHostFiberWithNoPortals(fiber);

    	  if (hostFiber === null) {
    	    return null;
    	  }

    	  if (hostFiber.tag === FundamentalComponent) {
    	    return hostFiber.stateNode.instance;
    	  }

    	  return hostFiber.stateNode;
    	}

    	var shouldSuspendImpl = function (fiber) {
    	  return false;
    	};

    	function shouldSuspend(fiber) {
    	  return shouldSuspendImpl(fiber);
    	}
    	var overrideHookState = null;
    	var overrideHookStateDeletePath = null;
    	var overrideHookStateRenamePath = null;
    	var overrideProps = null;
    	var overridePropsDeletePath = null;
    	var overridePropsRenamePath = null;
    	var scheduleUpdate = null;
    	var setSuspenseHandler = null;

    	{
    	  var copyWithDeleteImpl = function (obj, path, index) {
    	    var key = path[index];
    	    var updated = Array.isArray(obj) ? obj.slice() : _assign({}, obj);

    	    if (index + 1 === path.length) {
    	      if (Array.isArray(updated)) {
    	        updated.splice(key, 1);
    	      } else {
    	        delete updated[key];
    	      }

    	      return updated;
    	    } // $FlowFixMe number or string is fine here


    	    updated[key] = copyWithDeleteImpl(obj[key], path, index + 1);
    	    return updated;
    	  };

    	  var copyWithDelete = function (obj, path) {
    	    return copyWithDeleteImpl(obj, path, 0);
    	  };

    	  var copyWithRenameImpl = function (obj, oldPath, newPath, index) {
    	    var oldKey = oldPath[index];
    	    var updated = Array.isArray(obj) ? obj.slice() : _assign({}, obj);

    	    if (index + 1 === oldPath.length) {
    	      var newKey = newPath[index]; // $FlowFixMe number or string is fine here

    	      updated[newKey] = updated[oldKey];

    	      if (Array.isArray(updated)) {
    	        updated.splice(oldKey, 1);
    	      } else {
    	        delete updated[oldKey];
    	      }
    	    } else {
    	      // $FlowFixMe number or string is fine here
    	      updated[oldKey] = copyWithRenameImpl( // $FlowFixMe number or string is fine here
    	      obj[oldKey], oldPath, newPath, index + 1);
    	    }

    	    return updated;
    	  };

    	  var copyWithRename = function (obj, oldPath, newPath) {
    	    if (oldPath.length !== newPath.length) {
    	      warn('copyWithRename() expects paths of the same length');

    	      return;
    	    } else {
    	      for (var i = 0; i < newPath.length - 1; i++) {
    	        if (oldPath[i] !== newPath[i]) {
    	          warn('copyWithRename() expects paths to be the same except for the deepest key');

    	          return;
    	        }
    	      }
    	    }

    	    return copyWithRenameImpl(obj, oldPath, newPath, 0);
    	  };

    	  var copyWithSetImpl = function (obj, path, index, value) {
    	    if (index >= path.length) {
    	      return value;
    	    }

    	    var key = path[index];
    	    var updated = Array.isArray(obj) ? obj.slice() : _assign({}, obj); // $FlowFixMe number or string is fine here

    	    updated[key] = copyWithSetImpl(obj[key], path, index + 1, value);
    	    return updated;
    	  };

    	  var copyWithSet = function (obj, path, value) {
    	    return copyWithSetImpl(obj, path, 0, value);
    	  };

    	  var findHook = function (fiber, id) {
    	    // For now, the "id" of stateful hooks is just the stateful hook index.
    	    // This may change in the future with e.g. nested hooks.
    	    var currentHook = fiber.memoizedState;

    	    while (currentHook !== null && id > 0) {
    	      currentHook = currentHook.next;
    	      id--;
    	    }

    	    return currentHook;
    	  }; // Support DevTools editable values for useState and useReducer.


    	  overrideHookState = function (fiber, id, path, value) {
    	    var hook = findHook(fiber, id);

    	    if (hook !== null) {
    	      var newState = copyWithSet(hook.memoizedState, path, value);
    	      hook.memoizedState = newState;
    	      hook.baseState = newState; // We aren't actually adding an update to the queue,
    	      // because there is no update we can add for useReducer hooks that won't trigger an error.
    	      // (There's no appropriate action type for DevTools overrides.)
    	      // As a result though, React will see the scheduled update as a noop and bailout.
    	      // Shallow cloning props works as a workaround for now to bypass the bailout check.

    	      fiber.memoizedProps = _assign({}, fiber.memoizedProps);
    	      scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	    }
    	  };

    	  overrideHookStateDeletePath = function (fiber, id, path) {
    	    var hook = findHook(fiber, id);

    	    if (hook !== null) {
    	      var newState = copyWithDelete(hook.memoizedState, path);
    	      hook.memoizedState = newState;
    	      hook.baseState = newState; // We aren't actually adding an update to the queue,
    	      // because there is no update we can add for useReducer hooks that won't trigger an error.
    	      // (There's no appropriate action type for DevTools overrides.)
    	      // As a result though, React will see the scheduled update as a noop and bailout.
    	      // Shallow cloning props works as a workaround for now to bypass the bailout check.

    	      fiber.memoizedProps = _assign({}, fiber.memoizedProps);
    	      scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	    }
    	  };

    	  overrideHookStateRenamePath = function (fiber, id, oldPath, newPath) {
    	    var hook = findHook(fiber, id);

    	    if (hook !== null) {
    	      var newState = copyWithRename(hook.memoizedState, oldPath, newPath);
    	      hook.memoizedState = newState;
    	      hook.baseState = newState; // We aren't actually adding an update to the queue,
    	      // because there is no update we can add for useReducer hooks that won't trigger an error.
    	      // (There's no appropriate action type for DevTools overrides.)
    	      // As a result though, React will see the scheduled update as a noop and bailout.
    	      // Shallow cloning props works as a workaround for now to bypass the bailout check.

    	      fiber.memoizedProps = _assign({}, fiber.memoizedProps);
    	      scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	    }
    	  }; // Support DevTools props for function components, forwardRef, memo, host components, etc.


    	  overrideProps = function (fiber, path, value) {
    	    fiber.pendingProps = copyWithSet(fiber.memoizedProps, path, value);

    	    if (fiber.alternate) {
    	      fiber.alternate.pendingProps = fiber.pendingProps;
    	    }

    	    scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	  };

    	  overridePropsDeletePath = function (fiber, path) {
    	    fiber.pendingProps = copyWithDelete(fiber.memoizedProps, path);

    	    if (fiber.alternate) {
    	      fiber.alternate.pendingProps = fiber.pendingProps;
    	    }

    	    scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	  };

    	  overridePropsRenamePath = function (fiber, oldPath, newPath) {
    	    fiber.pendingProps = copyWithRename(fiber.memoizedProps, oldPath, newPath);

    	    if (fiber.alternate) {
    	      fiber.alternate.pendingProps = fiber.pendingProps;
    	    }

    	    scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	  };

    	  scheduleUpdate = function (fiber) {
    	    scheduleUpdateOnFiber(fiber, SyncLane, NoTimestamp);
    	  };

    	  setSuspenseHandler = function (newShouldSuspendImpl) {
    	    shouldSuspendImpl = newShouldSuspendImpl;
    	  };
    	}

    	function findHostInstanceByFiber(fiber) {
    	  var hostFiber = findCurrentHostFiber(fiber);

    	  if (hostFiber === null) {
    	    return null;
    	  }

    	  return hostFiber.stateNode;
    	}

    	function emptyFindFiberByHostInstance(instance) {
    	  return null;
    	}

    	function getCurrentFiberForDevTools() {
    	  return current;
    	}

    	function injectIntoDevTools(devToolsConfig) {
    	  var findFiberByHostInstance = devToolsConfig.findFiberByHostInstance;
    	  var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
    	  return injectInternals({
    	    bundleType: devToolsConfig.bundleType,
    	    version: devToolsConfig.version,
    	    rendererPackageName: devToolsConfig.rendererPackageName,
    	    rendererConfig: devToolsConfig.rendererConfig,
    	    overrideHookState: overrideHookState,
    	    overrideHookStateDeletePath: overrideHookStateDeletePath,
    	    overrideHookStateRenamePath: overrideHookStateRenamePath,
    	    overrideProps: overrideProps,
    	    overridePropsDeletePath: overridePropsDeletePath,
    	    overridePropsRenamePath: overridePropsRenamePath,
    	    setSuspenseHandler: setSuspenseHandler,
    	    scheduleUpdate: scheduleUpdate,
    	    currentDispatcherRef: ReactCurrentDispatcher,
    	    findHostInstanceByFiber: findHostInstanceByFiber,
    	    findFiberByHostInstance: findFiberByHostInstance || emptyFindFiberByHostInstance,
    	    // React Refresh
    	    findHostInstancesForRefresh:  findHostInstancesForRefresh ,
    	    scheduleRefresh:  scheduleRefresh ,
    	    scheduleRoot:  scheduleRoot ,
    	    setRefreshHandler:  setRefreshHandler ,
    	    // Enables DevTools to append owner stacks to error messages in DEV mode.
    	    getCurrentFiber:  getCurrentFiberForDevTools 
    	  });
    	}

    	function ReactDOMBlockingRoot(container, tag, options) {
    	  this._internalRoot = createRootImpl(container, tag, options);
    	}

    	ReactDOMBlockingRoot.prototype.render = function (children) {
    	  var root = this._internalRoot;

    	  {
    	    if (typeof arguments[1] === 'function') {
    	      error('render(...): does not support the second callback argument. ' + 'To execute a side effect after rendering, declare it in a component body with useEffect().');
    	    }

    	    var container = root.containerInfo;

    	    if (container.nodeType !== COMMENT_NODE) {
    	      var hostInstance = findHostInstanceWithNoPortals(root.current);

    	      if (hostInstance) {
    	        if (hostInstance.parentNode !== container) {
    	          error('render(...): It looks like the React-rendered content of the ' + 'root container was removed without using React. This is not ' + 'supported and will cause errors. Instead, call ' + "root.unmount() to empty a root's container.");
    	        }
    	      }
    	    }
    	  }

    	  updateContainer(children, root, null, null);
    	};

    	ReactDOMBlockingRoot.prototype.unmount = function () {
    	  {
    	    if (typeof arguments[0] === 'function') {
    	      error('unmount(...): does not support a callback argument. ' + 'To execute a side effect after rendering, declare it in a component body with useEffect().');
    	    }
    	  }

    	  var root = this._internalRoot;
    	  var container = root.containerInfo;
    	  updateContainer(null, root, null, function () {
    	    unmarkContainerAsRoot(container);
    	  });
    	};

    	function createRootImpl(container, tag, options) {
    	  // Tag is either LegacyRoot or Concurrent Root
    	  var hydrate = options != null && options.hydrate === true;
    	  options != null && options.hydrationOptions || null;
    	  var mutableSources = options != null && options.hydrationOptions != null && options.hydrationOptions.mutableSources || null;
    	  var root = createContainer(container, tag, hydrate);
    	  markContainerAsRoot(root.current, container);
    	  container.nodeType;

    	  {
    	    var rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
    	    listenToAllSupportedEvents(rootContainerElement);
    	  }

    	  if (mutableSources) {
    	    for (var i = 0; i < mutableSources.length; i++) {
    	      var mutableSource = mutableSources[i];
    	      registerMutableSourceForHydration(root, mutableSource);
    	    }
    	  }

    	  return root;
    	}
    	function createLegacyRoot(container, options) {
    	  return new ReactDOMBlockingRoot(container, LegacyRoot, options);
    	}
    	function isValidContainer(node) {
    	  return !!(node && (node.nodeType === ELEMENT_NODE || node.nodeType === DOCUMENT_NODE || node.nodeType === DOCUMENT_FRAGMENT_NODE || node.nodeType === COMMENT_NODE && node.nodeValue === ' react-mount-point-unstable '));
    	}

    	var ReactCurrentOwner$3 = ReactSharedInternals.ReactCurrentOwner;
    	var topLevelUpdateWarnings;
    	var warnedAboutHydrateAPI = false;

    	{
    	  topLevelUpdateWarnings = function (container) {
    	    if (container._reactRootContainer && container.nodeType !== COMMENT_NODE) {
    	      var hostInstance = findHostInstanceWithNoPortals(container._reactRootContainer._internalRoot.current);

    	      if (hostInstance) {
    	        if (hostInstance.parentNode !== container) {
    	          error('render(...): It looks like the React-rendered content of this ' + 'container was removed without using React. This is not ' + 'supported and will cause errors. Instead, call ' + 'ReactDOM.unmountComponentAtNode to empty a container.');
    	        }
    	      }
    	    }

    	    var isRootRenderedBySomeReact = !!container._reactRootContainer;
    	    var rootEl = getReactRootElementInContainer(container);
    	    var hasNonRootReactChild = !!(rootEl && getInstanceFromNode(rootEl));

    	    if (hasNonRootReactChild && !isRootRenderedBySomeReact) {
    	      error('render(...): Replacing React-rendered children with a new root ' + 'component. If you intended to update the children of this node, ' + 'you should instead have the existing children update their state ' + 'and render the new components instead of calling ReactDOM.render.');
    	    }

    	    if (container.nodeType === ELEMENT_NODE && container.tagName && container.tagName.toUpperCase() === 'BODY') {
    	      error('render(): Rendering components directly into document.body is ' + 'discouraged, since its children are often manipulated by third-party ' + 'scripts and browser extensions. This may lead to subtle ' + 'reconciliation issues. Try rendering into a container element created ' + 'for your app.');
    	    }
    	  };
    	}

    	function getReactRootElementInContainer(container) {
    	  if (!container) {
    	    return null;
    	  }

    	  if (container.nodeType === DOCUMENT_NODE) {
    	    return container.documentElement;
    	  } else {
    	    return container.firstChild;
    	  }
    	}

    	function shouldHydrateDueToLegacyHeuristic(container) {
    	  var rootElement = getReactRootElementInContainer(container);
    	  return !!(rootElement && rootElement.nodeType === ELEMENT_NODE && rootElement.hasAttribute(ROOT_ATTRIBUTE_NAME));
    	}

    	function legacyCreateRootFromDOMContainer(container, forceHydrate) {
    	  var shouldHydrate = forceHydrate || shouldHydrateDueToLegacyHeuristic(container); // First clear any existing content.

    	  if (!shouldHydrate) {
    	    var warned = false;
    	    var rootSibling;

    	    while (rootSibling = container.lastChild) {
    	      {
    	        if (!warned && rootSibling.nodeType === ELEMENT_NODE && rootSibling.hasAttribute(ROOT_ATTRIBUTE_NAME)) {
    	          warned = true;

    	          error('render(): Target node has markup rendered by React, but there ' + 'are unrelated nodes as well. This is most commonly caused by ' + 'white-space inserted around server-rendered markup.');
    	        }
    	      }

    	      container.removeChild(rootSibling);
    	    }
    	  }

    	  {
    	    if (shouldHydrate && !forceHydrate && !warnedAboutHydrateAPI) {
    	      warnedAboutHydrateAPI = true;

    	      warn('render(): Calling ReactDOM.render() to hydrate server-rendered markup ' + 'will stop working in React v18. Replace the ReactDOM.render() call ' + 'with ReactDOM.hydrate() if you want React to attach to the server HTML.');
    	    }
    	  }

    	  return createLegacyRoot(container, shouldHydrate ? {
    	    hydrate: true
    	  } : undefined);
    	}

    	function warnOnInvalidCallback$1(callback, callerName) {
    	  {
    	    if (callback !== null && typeof callback !== 'function') {
    	      error('%s(...): Expected the last optional `callback` argument to be a ' + 'function. Instead received: %s.', callerName, callback);
    	    }
    	  }
    	}

    	function legacyRenderSubtreeIntoContainer(parentComponent, children, container, forceHydrate, callback) {
    	  {
    	    topLevelUpdateWarnings(container);
    	    warnOnInvalidCallback$1(callback === undefined ? null : callback, 'render');
    	  } // TODO: Without `any` type, Flow says "Property cannot be accessed on any
    	  // member of intersection type." Whyyyyyy.


    	  var root = container._reactRootContainer;
    	  var fiberRoot;

    	  if (!root) {
    	    // Initial mount
    	    root = container._reactRootContainer = legacyCreateRootFromDOMContainer(container, forceHydrate);
    	    fiberRoot = root._internalRoot;

    	    if (typeof callback === 'function') {
    	      var originalCallback = callback;

    	      callback = function () {
    	        var instance = getPublicRootInstance(fiberRoot);
    	        originalCallback.call(instance);
    	      };
    	    } // Initial mount should not be batched.


    	    unbatchedUpdates(function () {
    	      updateContainer(children, fiberRoot, parentComponent, callback);
    	    });
    	  } else {
    	    fiberRoot = root._internalRoot;

    	    if (typeof callback === 'function') {
    	      var _originalCallback = callback;

    	      callback = function () {
    	        var instance = getPublicRootInstance(fiberRoot);

    	        _originalCallback.call(instance);
    	      };
    	    } // Update


    	    updateContainer(children, fiberRoot, parentComponent, callback);
    	  }

    	  return getPublicRootInstance(fiberRoot);
    	}

    	function findDOMNode(componentOrElement) {
    	  {
    	    var owner = ReactCurrentOwner$3.current;

    	    if (owner !== null && owner.stateNode !== null) {
    	      var warnedAboutRefsInRender = owner.stateNode._warnedAboutRefsInRender;

    	      if (!warnedAboutRefsInRender) {
    	        error('%s is accessing findDOMNode inside its render(). ' + 'render() should be a pure function of props and state. It should ' + 'never access something that requires stale data from the previous ' + 'render, such as refs. Move this logic to componentDidMount and ' + 'componentDidUpdate instead.', getComponentName(owner.type) || 'A component');
    	      }

    	      owner.stateNode._warnedAboutRefsInRender = true;
    	    }
    	  }

    	  if (componentOrElement == null) {
    	    return null;
    	  }

    	  if (componentOrElement.nodeType === ELEMENT_NODE) {
    	    return componentOrElement;
    	  }

    	  {
    	    return findHostInstanceWithWarning(componentOrElement, 'findDOMNode');
    	  }
    	}
    	function hydrate(element, container, callback) {
    	  if (!isValidContainer(container)) {
    	    {
    	      throw Error( "Target container is not a DOM element." );
    	    }
    	  }

    	  {
    	    var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === undefined;

    	    if (isModernRoot) {
    	      error('You are calling ReactDOM.hydrate() on a container that was previously ' + 'passed to ReactDOM.createRoot(). This is not supported. ' + 'Did you mean to call createRoot(container, {hydrate: true}).render(element)?');
    	    }
    	  } // TODO: throw or warn if we couldn't hydrate?


    	  return legacyRenderSubtreeIntoContainer(null, element, container, true, callback);
    	}
    	function render(element, container, callback) {
    	  if (!isValidContainer(container)) {
    	    {
    	      throw Error( "Target container is not a DOM element." );
    	    }
    	  }

    	  {
    	    var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === undefined;

    	    if (isModernRoot) {
    	      error('You are calling ReactDOM.render() on a container that was previously ' + 'passed to ReactDOM.createRoot(). This is not supported. ' + 'Did you mean to call root.render(element)?');
    	    }
    	  }

    	  return legacyRenderSubtreeIntoContainer(null, element, container, false, callback);
    	}
    	function unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {
    	  if (!isValidContainer(containerNode)) {
    	    {
    	      throw Error( "Target container is not a DOM element." );
    	    }
    	  }

    	  if (!(parentComponent != null && has(parentComponent))) {
    	    {
    	      throw Error( "parentComponent must be a valid React Component" );
    	    }
    	  }

    	  return legacyRenderSubtreeIntoContainer(parentComponent, element, containerNode, false, callback);
    	}
    	function unmountComponentAtNode(container) {
    	  if (!isValidContainer(container)) {
    	    {
    	      throw Error( "unmountComponentAtNode(...): Target container is not a DOM element." );
    	    }
    	  }

    	  {
    	    var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === undefined;

    	    if (isModernRoot) {
    	      error('You are calling ReactDOM.unmountComponentAtNode() on a container that was previously ' + 'passed to ReactDOM.createRoot(). This is not supported. Did you mean to call root.unmount()?');
    	    }
    	  }

    	  if (container._reactRootContainer) {
    	    {
    	      var rootEl = getReactRootElementInContainer(container);
    	      var renderedByDifferentReact = rootEl && !getInstanceFromNode(rootEl);

    	      if (renderedByDifferentReact) {
    	        error("unmountComponentAtNode(): The node you're attempting to unmount " + 'was rendered by another copy of React.');
    	      }
    	    } // Unmount should not be batched.


    	    unbatchedUpdates(function () {
    	      legacyRenderSubtreeIntoContainer(null, null, container, false, function () {
    	        // $FlowFixMe This should probably use `delete container._reactRootContainer`
    	        container._reactRootContainer = null;
    	        unmarkContainerAsRoot(container);
    	      });
    	    }); // If you call unmountComponentAtNode twice in quick succession, you'll
    	    // get `true` twice. That's probably fine?

    	    return true;
    	  } else {
    	    {
    	      var _rootEl = getReactRootElementInContainer(container);

    	      var hasNonRootReactChild = !!(_rootEl && getInstanceFromNode(_rootEl)); // Check if the container itself is a React root node.

    	      var isContainerReactRoot = container.nodeType === ELEMENT_NODE && isValidContainer(container.parentNode) && !!container.parentNode._reactRootContainer;

    	      if (hasNonRootReactChild) {
    	        error("unmountComponentAtNode(): The node you're attempting to unmount " + 'was rendered by React and is not a top-level container. %s', isContainerReactRoot ? 'You may have accidentally passed in a React root node instead ' + 'of its container.' : 'Instead, have the parent component update its state and ' + 'rerender in order to remove this component.');
    	      }
    	    }

    	    return false;
    	  }
    	}

    	setAttemptUserBlockingHydration(attemptUserBlockingHydration$1);
    	setAttemptContinuousHydration(attemptContinuousHydration$1);
    	setAttemptHydrationAtCurrentPriority(attemptHydrationAtCurrentPriority$1);
    	setAttemptHydrationAtPriority(runWithPriority$2);
    	var didWarnAboutUnstableCreatePortal = false;

    	{
    	  if (typeof Map !== 'function' || // $FlowIssue Flow incorrectly thinks Map has no prototype
    	  Map.prototype == null || typeof Map.prototype.forEach !== 'function' || typeof Set !== 'function' || // $FlowIssue Flow incorrectly thinks Set has no prototype
    	  Set.prototype == null || typeof Set.prototype.clear !== 'function' || typeof Set.prototype.forEach !== 'function') {
    	    error('React depends on Map and Set built-in types. Make sure that you load a ' + 'polyfill in older browsers. https://reactjs.org/link/react-polyfills');
    	  }
    	}

    	setRestoreImplementation(restoreControlledState$3);
    	setBatchingImplementation(batchedUpdates$1, discreteUpdates$1, flushDiscreteUpdates, batchedEventUpdates$1);

    	function createPortal$1(children, container) {
    	  var key = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    	  if (!isValidContainer(container)) {
    	    {
    	      throw Error( "Target container is not a DOM element." );
    	    }
    	  } // TODO: pass ReactDOM portal implementation as third argument
    	  // $FlowFixMe The Flow type is opaque but there's no way to actually create it.


    	  return createPortal(children, container, null, key);
    	}

    	function renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {

    	  return unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback);
    	}

    	function unstable_createPortal(children, container) {
    	  var key = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    	  {
    	    if (!didWarnAboutUnstableCreatePortal) {
    	      didWarnAboutUnstableCreatePortal = true;

    	      warn('The ReactDOM.unstable_createPortal() alias has been deprecated, ' + 'and will be removed in React 18+. Update your code to use ' + 'ReactDOM.createPortal() instead. It has the exact same API, ' + 'but without the "unstable_" prefix.');
    	    }
    	  }

    	  return createPortal$1(children, container, key);
    	}

    	var Internals = {
    	  // Keep in sync with ReactTestUtils.js, and ReactTestUtilsAct.js.
    	  // This is an array for better minification.
    	  Events: [getInstanceFromNode, getNodeFromInstance, getFiberCurrentPropsFromNode, enqueueStateRestore, restoreStateIfNeeded, flushPassiveEffects, // TODO: This is related to `act`, not events. Move to separate key?
    	  IsThisRendererActing]
    	};
    	var foundDevTools = injectIntoDevTools({
    	  findFiberByHostInstance: getClosestInstanceFromNode,
    	  bundleType:  1 ,
    	  version: ReactVersion,
    	  rendererPackageName: 'react-dom'
    	});

    	{
    	  if (!foundDevTools && canUseDOM && window.top === window.self) {
    	    // If we're in Chrome or Firefox, provide a download link if not installed.
    	    if (navigator.userAgent.indexOf('Chrome') > -1 && navigator.userAgent.indexOf('Edge') === -1 || navigator.userAgent.indexOf('Firefox') > -1) {
    	      var protocol = window.location.protocol; // Don't warn in exotic cases like chrome-extension://.

    	      if (/^(https?|file):$/.test(protocol)) {
    	        // eslint-disable-next-line react-internal/no-production-logging
    	        console.info('%cDownload the React DevTools ' + 'for a better development experience: ' + 'https://reactjs.org/link/react-devtools' + (protocol === 'file:' ? '\nYou might need to use a local HTTP server (instead of file://): ' + 'https://reactjs.org/link/react-devtools-faq' : ''), 'font-weight:bold');
    	      }
    	    }
    	  }
    	}

    	reactDom_development.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = Internals;
    	reactDom_development.createPortal = createPortal$1;
    	reactDom_development.findDOMNode = findDOMNode;
    	reactDom_development.flushSync = flushSync;
    	reactDom_development.hydrate = hydrate;
    	reactDom_development.render = render;
    	reactDom_development.unmountComponentAtNode = unmountComponentAtNode;
    	reactDom_development.unstable_batchedUpdates = batchedUpdates$1;
    	reactDom_development.unstable_createPortal = unstable_createPortal;
    	reactDom_development.unstable_renderSubtreeIntoContainer = renderSubtreeIntoContainer;
    	reactDom_development.version = ReactVersion;
    	  })();
    	}
    	return reactDom_development;
    }

    (function (module) {

    	function checkDCE() {
    	  /* global __REACT_DEVTOOLS_GLOBAL_HOOK__ */
    	  if (
    	    typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === 'undefined' ||
    	    typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE !== 'function'
    	  ) {
    	    return;
    	  }
    	  if (process.env.NODE_ENV !== 'production') {
    	    // This branch is unreachable because this function is only called
    	    // in production, but the condition is true only in development.
    	    // Therefore if the branch is still here, dead code elimination wasn't
    	    // properly applied.
    	    // Don't change the message. React DevTools relies on it. Also make sure
    	    // this message doesn't occur elsewhere in this function, or it will cause
    	    // a false positive.
    	    throw new Error('^_^');
    	  }
    	  try {
    	    // Verify that the code above has been dead code eliminated (DCE'd).
    	    __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
    	  } catch (err) {
    	    // DevTools shouldn't crash React, no matter what.
    	    // We should still report in case we break this code.
    	    console.error(err);
    	  }
    	}

    	if (process.env.NODE_ENV === 'production') {
    	  // DCE check should happen before ReactDOM bundle executes so that
    	  // DevTools can report bad minification during injection.
    	  checkDCE();
    	  module.exports = requireReactDom_production_min();
    	} else {
    	  module.exports = requireReactDom_development();
    	}
    } (reactDom));

    var ReactDOM = /*@__PURE__*/getDefaultExportFromCjs(reactDom.exports);

    function getContainer$1(container) {
      return typeof container === 'function' ? container() : container;
    }
    /**
     * Portals provide a first-class way to render children into a DOM node
     * that exists outside the DOM hierarchy of the parent component.
     */


    const Portal = /*#__PURE__*/react.exports.forwardRef(function Portal(props, ref) {
      const {
        children,
        container,
        disablePortal = false
      } = props;
      const [mountNode, setMountNode] = react.exports.useState(null);
      const handleRef = useForkRef( /*#__PURE__*/react.exports.isValidElement(children) ? children.ref : null, ref);
      useEnhancedEffect(() => {
        if (!disablePortal) {
          setMountNode(getContainer$1(container) || document.body);
        }
      }, [container, disablePortal]);
      useEnhancedEffect(() => {
        if (mountNode && !disablePortal) {
          setRef(ref, mountNode);
          return () => {
            setRef(ref, null);
          };
        }

        return undefined;
      }, [ref, mountNode, disablePortal]);

      if (disablePortal) {
        if ( /*#__PURE__*/react.exports.isValidElement(children)) {
          return /*#__PURE__*/react.exports.cloneElement(children, {
            ref: handleRef
          });
        }

        return children;
      }

      return mountNode ? /*#__PURE__*/reactDom.exports.createPortal(children, mountNode) : mountNode;
    });
    process.env.NODE_ENV !== "production" ? Portal.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The children to render into the `container`.
       */
      children: propTypes.exports.node,

      /**
       * An HTML element or function that returns one.
       * The `container` will have the portal children appended to it.
       *
       * By default, it uses the body of the top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * The `children` will be under the DOM hierarchy of the parent component.
       * @default false
       */
      disablePortal: propTypes.exports.bool
    } : void 0;

    if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line
      Portal['propTypes' + ''] = exactProp(Portal.propTypes);
    }

    var Portal$1 = Portal;

    // Is a vertical scrollbar displayed?
    function isOverflowing(container) {
      const doc = ownerDocument(container);

      if (doc.body === container) {
        return ownerWindow(container).innerWidth > doc.documentElement.clientWidth;
      }

      return container.scrollHeight > container.clientHeight;
    }

    function ariaHidden(element, show) {
      if (show) {
        element.setAttribute('aria-hidden', 'true');
      } else {
        element.removeAttribute('aria-hidden');
      }
    }

    function getPaddingRight(element) {
      return parseInt(ownerWindow(element).getComputedStyle(element).paddingRight, 10) || 0;
    }

    function ariaHiddenSiblings(container, mountElement, currentElement, elementsToExclude = [], show) {
      const blacklist = [mountElement, currentElement, ...elementsToExclude];
      const blacklistTagNames = ['TEMPLATE', 'SCRIPT', 'STYLE'];
      [].forEach.call(container.children, element => {
        if (blacklist.indexOf(element) === -1 && blacklistTagNames.indexOf(element.tagName) === -1) {
          ariaHidden(element, show);
        }
      });
    }

    function findIndexOf(items, callback) {
      let idx = -1;
      items.some((item, index) => {
        if (callback(item)) {
          idx = index;
          return true;
        }

        return false;
      });
      return idx;
    }

    function handleContainer(containerInfo, props) {
      const restoreStyle = [];
      const container = containerInfo.container;

      if (!props.disableScrollLock) {
        if (isOverflowing(container)) {
          // Compute the size before applying overflow hidden to avoid any scroll jumps.
          const scrollbarSize = getScrollbarSize(ownerDocument(container));
          restoreStyle.push({
            value: container.style.paddingRight,
            property: 'padding-right',
            el: container
          }); // Use computed style, here to get the real padding to add our scrollbar width.

          container.style.paddingRight = `${getPaddingRight(container) + scrollbarSize}px`; // .mui-fixed is a global helper.

          const fixedElements = ownerDocument(container).querySelectorAll('.mui-fixed');
          [].forEach.call(fixedElements, element => {
            restoreStyle.push({
              value: element.style.paddingRight,
              property: 'padding-right',
              el: element
            });
            element.style.paddingRight = `${getPaddingRight(element) + scrollbarSize}px`;
          });
        } // Improve Gatsby support
        // https://css-tricks.com/snippets/css/force-vertical-scrollbar/


        const parent = container.parentElement;
        const containerWindow = ownerWindow(container);
        const scrollContainer = (parent == null ? void 0 : parent.nodeName) === 'HTML' && containerWindow.getComputedStyle(parent).overflowY === 'scroll' ? parent : container; // Block the scroll even if no scrollbar is visible to account for mobile keyboard
        // screensize shrink.

        restoreStyle.push({
          value: scrollContainer.style.overflow,
          property: 'overflow',
          el: scrollContainer
        }, {
          value: scrollContainer.style.overflowX,
          property: 'overflow-x',
          el: scrollContainer
        }, {
          value: scrollContainer.style.overflowY,
          property: 'overflow-y',
          el: scrollContainer
        });
        scrollContainer.style.overflow = 'hidden';
      }

      const restore = () => {
        restoreStyle.forEach(({
          value,
          el,
          property
        }) => {
          if (value) {
            el.style.setProperty(property, value);
          } else {
            el.style.removeProperty(property);
          }
        });
      };

      return restore;
    }

    function getHiddenSiblings(container) {
      const hiddenSiblings = [];
      [].forEach.call(container.children, element => {
        if (element.getAttribute('aria-hidden') === 'true') {
          hiddenSiblings.push(element);
        }
      });
      return hiddenSiblings;
    }

    /**
     * @ignore - do not document.
     *
     * Proper state management for containers and the modals in those containers.
     * Simplified, but inspired by react-overlay's ModalManager class.
     * Used by the Modal to ensure proper styling of containers.
     */
    class ModalManager {
      constructor() {
        this.containers = void 0;
        this.modals = void 0;
        this.modals = [];
        this.containers = [];
      }

      add(modal, container) {
        let modalIndex = this.modals.indexOf(modal);

        if (modalIndex !== -1) {
          return modalIndex;
        }

        modalIndex = this.modals.length;
        this.modals.push(modal); // If the modal we are adding is already in the DOM.

        if (modal.modalRef) {
          ariaHidden(modal.modalRef, false);
        }

        const hiddenSiblings = getHiddenSiblings(container);
        ariaHiddenSiblings(container, modal.mount, modal.modalRef, hiddenSiblings, true);
        const containerIndex = findIndexOf(this.containers, item => item.container === container);

        if (containerIndex !== -1) {
          this.containers[containerIndex].modals.push(modal);
          return modalIndex;
        }

        this.containers.push({
          modals: [modal],
          container,
          restore: null,
          hiddenSiblings
        });
        return modalIndex;
      }

      mount(modal, props) {
        const containerIndex = findIndexOf(this.containers, item => item.modals.indexOf(modal) !== -1);
        const containerInfo = this.containers[containerIndex];

        if (!containerInfo.restore) {
          containerInfo.restore = handleContainer(containerInfo, props);
        }
      }

      remove(modal) {
        const modalIndex = this.modals.indexOf(modal);

        if (modalIndex === -1) {
          return modalIndex;
        }

        const containerIndex = findIndexOf(this.containers, item => item.modals.indexOf(modal) !== -1);
        const containerInfo = this.containers[containerIndex];
        containerInfo.modals.splice(containerInfo.modals.indexOf(modal), 1);
        this.modals.splice(modalIndex, 1); // If that was the last modal in a container, clean up the container.

        if (containerInfo.modals.length === 0) {
          // The modal might be closed before it had the chance to be mounted in the DOM.
          if (containerInfo.restore) {
            containerInfo.restore();
          }

          if (modal.modalRef) {
            // In case the modal wasn't in the DOM yet.
            ariaHidden(modal.modalRef, true);
          }

          ariaHiddenSiblings(containerInfo.container, modal.mount, modal.modalRef, containerInfo.hiddenSiblings, false);
          this.containers.splice(containerIndex, 1);
        } else {
          // Otherwise make sure the next top modal is visible to a screen reader.
          const nextTop = containerInfo.modals[containerInfo.modals.length - 1]; // as soon as a modal is adding its modalRef is undefined. it can't set
          // aria-hidden because the dom element doesn't exist either
          // when modal was unmounted before modalRef gets null

          if (nextTop.modalRef) {
            ariaHidden(nextTop.modalRef, false);
          }
        }

        return modalIndex;
      }

      isTopModal(modal) {
        return this.modals.length > 0 && this.modals[this.modals.length - 1] === modal;
      }

    }

    /* eslint-disable @typescript-eslint/naming-convention, consistent-return, jsx-a11y/no-noninteractive-tabindex */
    const candidatesSelector = ['input', 'select', 'textarea', 'a[href]', 'button', '[tabindex]', 'audio[controls]', 'video[controls]', '[contenteditable]:not([contenteditable="false"])'].join(',');

    function getTabIndex(node) {
      const tabindexAttr = parseInt(node.getAttribute('tabindex'), 10);

      if (!Number.isNaN(tabindexAttr)) {
        return tabindexAttr;
      } // Browsers do not return `tabIndex` correctly for contentEditable nodes;
      // https://bugs.chromium.org/p/chromium/issues/detail?id=661108&q=contenteditable%20tabindex&can=2
      // so if they don't have a tabindex attribute specifically set, assume it's 0.
      // in Chrome, <details/>, <audio controls/> and <video controls/> elements get a default
      //  `tabIndex` of -1 when the 'tabindex' attribute isn't specified in the DOM,
      //  yet they are still part of the regular tab order; in FF, they get a default
      //  `tabIndex` of 0; since Chrome still puts those elements in the regular tab
      //  order, consider their tab index to be 0.


      if (node.contentEditable === 'true' || (node.nodeName === 'AUDIO' || node.nodeName === 'VIDEO' || node.nodeName === 'DETAILS') && node.getAttribute('tabindex') === null) {
        return 0;
      }

      return node.tabIndex;
    }

    function isNonTabbableRadio(node) {
      if (node.tagName !== 'INPUT' || node.type !== 'radio') {
        return false;
      }

      if (!node.name) {
        return false;
      }

      const getRadio = selector => node.ownerDocument.querySelector(`input[type="radio"]${selector}`);

      let roving = getRadio(`[name="${node.name}"]:checked`);

      if (!roving) {
        roving = getRadio(`[name="${node.name}"]`);
      }

      return roving !== node;
    }

    function isNodeMatchingSelectorFocusable(node) {
      if (node.disabled || node.tagName === 'INPUT' && node.type === 'hidden' || isNonTabbableRadio(node)) {
        return false;
      }

      return true;
    }

    function defaultGetTabbable(root) {
      const regularTabNodes = [];
      const orderedTabNodes = [];
      Array.from(root.querySelectorAll(candidatesSelector)).forEach((node, i) => {
        const nodeTabIndex = getTabIndex(node);

        if (nodeTabIndex === -1 || !isNodeMatchingSelectorFocusable(node)) {
          return;
        }

        if (nodeTabIndex === 0) {
          regularTabNodes.push(node);
        } else {
          orderedTabNodes.push({
            documentOrder: i,
            tabIndex: nodeTabIndex,
            node
          });
        }
      });
      return orderedTabNodes.sort((a, b) => a.tabIndex === b.tabIndex ? a.documentOrder - b.documentOrder : a.tabIndex - b.tabIndex).map(a => a.node).concat(regularTabNodes);
    }

    function defaultIsEnabled() {
      return true;
    }
    /**
     * Utility component that locks focus inside the component.
     */


    function Unstable_TrapFocus(props) {
      const {
        children,
        disableAutoFocus = false,
        disableEnforceFocus = false,
        disableRestoreFocus = false,
        getTabbable = defaultGetTabbable,
        isEnabled = defaultIsEnabled,
        open
      } = props;
      const ignoreNextEnforceFocus = react.exports.useRef();
      const sentinelStart = react.exports.useRef(null);
      const sentinelEnd = react.exports.useRef(null);
      const nodeToRestore = react.exports.useRef(null);
      const reactFocusEventTarget = react.exports.useRef(null); // This variable is useful when disableAutoFocus is true.
      // It waits for the active element to move into the component to activate.

      const activated = react.exports.useRef(false);
      const rootRef = react.exports.useRef(null);
      const handleRef = useForkRef(children.ref, rootRef);
      const lastKeydown = react.exports.useRef(null);
      react.exports.useEffect(() => {
        // We might render an empty child.
        if (!open || !rootRef.current) {
          return;
        }

        activated.current = !disableAutoFocus;
      }, [disableAutoFocus, open]);
      react.exports.useEffect(() => {
        // We might render an empty child.
        if (!open || !rootRef.current) {
          return;
        }

        const doc = ownerDocument(rootRef.current);

        if (!rootRef.current.contains(doc.activeElement)) {
          if (!rootRef.current.hasAttribute('tabIndex')) {
            if (process.env.NODE_ENV !== 'production') {
              console.error(['MUI: The modal content node does not accept focus.', 'For the benefit of assistive technologies, ' + 'the tabIndex of the node is being set to "-1".'].join('\n'));
            }

            rootRef.current.setAttribute('tabIndex', -1);
          }

          if (activated.current) {
            rootRef.current.focus();
          }
        }

        return () => {
          // restoreLastFocus()
          if (!disableRestoreFocus) {
            // In IE11 it is possible for document.activeElement to be null resulting
            // in nodeToRestore.current being null.
            // Not all elements in IE11 have a focus method.
            // Once IE11 support is dropped the focus() call can be unconditional.
            if (nodeToRestore.current && nodeToRestore.current.focus) {
              ignoreNextEnforceFocus.current = true;
              nodeToRestore.current.focus();
            }

            nodeToRestore.current = null;
          }
        }; // Missing `disableRestoreFocus` which is fine.
        // We don't support changing that prop on an open TrapFocus
        // eslint-disable-next-line react-hooks/exhaustive-deps
      }, [open]);
      react.exports.useEffect(() => {
        // We might render an empty child.
        if (!open || !rootRef.current) {
          return;
        }

        const doc = ownerDocument(rootRef.current);

        const contain = nativeEvent => {
          const {
            current: rootElement
          } = rootRef; // Cleanup functions are executed lazily in React 17.
          // Contain can be called between the component being unmounted and its cleanup function being run.

          if (rootElement === null) {
            return;
          }

          if (!doc.hasFocus() || disableEnforceFocus || !isEnabled() || ignoreNextEnforceFocus.current) {
            ignoreNextEnforceFocus.current = false;
            return;
          }

          if (!rootElement.contains(doc.activeElement)) {
            // if the focus event is not coming from inside the children's react tree, reset the refs
            if (nativeEvent && reactFocusEventTarget.current !== nativeEvent.target || doc.activeElement !== reactFocusEventTarget.current) {
              reactFocusEventTarget.current = null;
            } else if (reactFocusEventTarget.current !== null) {
              return;
            }

            if (!activated.current) {
              return;
            }

            let tabbable = [];

            if (doc.activeElement === sentinelStart.current || doc.activeElement === sentinelEnd.current) {
              tabbable = getTabbable(rootRef.current);
            }

            if (tabbable.length > 0) {
              var _lastKeydown$current, _lastKeydown$current2;

              const isShiftTab = Boolean(((_lastKeydown$current = lastKeydown.current) == null ? void 0 : _lastKeydown$current.shiftKey) && ((_lastKeydown$current2 = lastKeydown.current) == null ? void 0 : _lastKeydown$current2.key) === 'Tab');
              const focusNext = tabbable[0];
              const focusPrevious = tabbable[tabbable.length - 1];

              if (isShiftTab) {
                focusPrevious.focus();
              } else {
                focusNext.focus();
              }
            } else {
              rootElement.focus();
            }
          }
        };

        const loopFocus = nativeEvent => {
          lastKeydown.current = nativeEvent;

          if (disableEnforceFocus || !isEnabled() || nativeEvent.key !== 'Tab') {
            return;
          } // Make sure the next tab starts from the right place.
          // doc.activeElement referes to the origin.


          if (doc.activeElement === rootRef.current && nativeEvent.shiftKey) {
            // We need to ignore the next contain as
            // it will try to move the focus back to the rootRef element.
            ignoreNextEnforceFocus.current = true;
            sentinelEnd.current.focus();
          }
        };

        doc.addEventListener('focusin', contain);
        doc.addEventListener('keydown', loopFocus, true); // With Edge, Safari and Firefox, no focus related events are fired when the focused area stops being a focused area.
        // e.g. https://bugzilla.mozilla.org/show_bug.cgi?id=559561.
        // Instead, we can look if the active element was restored on the BODY element.
        //
        // The whatwg spec defines how the browser should behave but does not explicitly mention any events:
        // https://html.spec.whatwg.org/multipage/interaction.html#focus-fixup-rule.

        const interval = setInterval(() => {
          if (doc.activeElement.tagName === 'BODY') {
            contain();
          }
        }, 50);
        return () => {
          clearInterval(interval);
          doc.removeEventListener('focusin', contain);
          doc.removeEventListener('keydown', loopFocus, true);
        };
      }, [disableAutoFocus, disableEnforceFocus, disableRestoreFocus, isEnabled, open, getTabbable]);

      const onFocus = event => {
        if (nodeToRestore.current === null) {
          nodeToRestore.current = event.relatedTarget;
        }

        activated.current = true;
        reactFocusEventTarget.current = event.target;
        const childrenPropsHandler = children.props.onFocus;

        if (childrenPropsHandler) {
          childrenPropsHandler(event);
        }
      };

      const handleFocusSentinel = event => {
        if (nodeToRestore.current === null) {
          nodeToRestore.current = event.relatedTarget;
        }

        activated.current = true;
      };

      return /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
        children: [/*#__PURE__*/jsxRuntimeExports.jsx("div", {
          tabIndex: 0,
          onFocus: handleFocusSentinel,
          ref: sentinelStart,
          "data-test": "sentinelStart"
        }), /*#__PURE__*/react.exports.cloneElement(children, {
          ref: handleRef,
          onFocus
        }), /*#__PURE__*/jsxRuntimeExports.jsx("div", {
          tabIndex: 0,
          onFocus: handleFocusSentinel,
          ref: sentinelEnd,
          "data-test": "sentinelEnd"
        })]
      });
    }

    process.env.NODE_ENV !== "production" ? Unstable_TrapFocus.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * A single child content element.
       */
      children: elementAcceptingRef,

      /**
       * If `true`, the trap focus will not automatically shift focus to itself when it opens, and
       * replace it to the last focused element when it closes.
       * This also works correctly with any trap focus children that have the `disableAutoFocus` prop.
       *
       * Generally this should never be set to `true` as it makes the trap focus less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableAutoFocus: propTypes.exports.bool,

      /**
       * If `true`, the trap focus will not prevent focus from leaving the trap focus while open.
       *
       * Generally this should never be set to `true` as it makes the trap focus less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableEnforceFocus: propTypes.exports.bool,

      /**
       * If `true`, the trap focus will not restore focus to previously focused element once
       * trap focus is hidden or unmounted.
       * @default false
       */
      disableRestoreFocus: propTypes.exports.bool,

      /**
       * Returns an array of ordered tabbable nodes (i.e. in tab order) within the root.
       * For instance, you can provide the "tabbable" npm dependency.
       * @param {HTMLElement} root
       */
      getTabbable: propTypes.exports.func,

      /**
       * This prop extends the `open` prop.
       * It allows to toggle the open state without having to wait for a rerender when changing the `open` prop.
       * This prop should be memoized.
       * It can be used to support multiple trap focus mounted at the same time.
       * @default function defaultIsEnabled() {
       *   return true;
       * }
       */
      isEnabled: propTypes.exports.func,

      /**
       * If `true`, focus is locked.
       */
      open: propTypes.exports.bool.isRequired
    } : void 0;

    if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line
      Unstable_TrapFocus['propTypes' + ''] = exactProp(Unstable_TrapFocus.propTypes);
    }

    function getModalUtilityClass(slot) {
      return generateUtilityClass('MuiModal', slot);
    }
    generateUtilityClasses('MuiModal', ['root', 'hidden']);

    const _excluded$I = ["BackdropComponent", "BackdropProps", "children", "classes", "className", "closeAfterTransition", "component", "components", "componentsProps", "container", "disableAutoFocus", "disableEnforceFocus", "disableEscapeKeyDown", "disablePortal", "disableRestoreFocus", "disableScrollLock", "hideBackdrop", "keepMounted", "manager", "onBackdropClick", "onClose", "onKeyDown", "open", "theme", "onTransitionEnter", "onTransitionExited"];

    const useUtilityClasses$u = ownerState => {
      const {
        open,
        exited,
        classes
      } = ownerState;
      const slots = {
        root: ['root', !open && exited && 'hidden']
      };
      return composeClasses(slots, getModalUtilityClass, classes);
    };

    function getContainer(container) {
      return typeof container === 'function' ? container() : container;
    }

    function getHasTransition(props) {
      return props.children ? props.children.props.hasOwnProperty('in') : false;
    } // A modal manager used to track and manage the state of open Modals.
    // Modals don't open on the server so this won't conflict with concurrent requests.


    const defaultManager = new ModalManager();
    /**
     * Modal is a lower-level construct that is leveraged by the following components:
     *
     * - [Dialog](/api/dialog/)
     * - [Drawer](/api/drawer/)
     * - [Menu](/api/menu/)
     * - [Popover](/api/popover/)
     *
     * If you are creating a modal dialog, you probably want to use the [Dialog](/api/dialog/) component
     * rather than directly using Modal.
     *
     * This component shares many concepts with [react-overlays](https://react-bootstrap.github.io/react-overlays/#modals).
     */

    const ModalUnstyled = /*#__PURE__*/react.exports.forwardRef(function ModalUnstyled(props, ref) {
      const {
        BackdropComponent,
        BackdropProps,
        children,
        classes: classesProp,
        className,
        closeAfterTransition = false,
        component = 'div',
        components = {},
        componentsProps = {},
        container,
        disableAutoFocus = false,
        disableEnforceFocus = false,
        disableEscapeKeyDown = false,
        disablePortal = false,
        disableRestoreFocus = false,
        disableScrollLock = false,
        hideBackdrop = false,
        keepMounted = false,
        // private
        // eslint-disable-next-line react/prop-types
        manager = defaultManager,
        onBackdropClick,
        onClose,
        onKeyDown,
        open,

        /* eslint-disable react/prop-types */
        theme,
        onTransitionEnter,
        onTransitionExited
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$I);

      const [exited, setExited] = react.exports.useState(true);
      const modal = react.exports.useRef({});
      const mountNodeRef = react.exports.useRef(null);
      const modalRef = react.exports.useRef(null);
      const handleRef = useForkRef(modalRef, ref);
      const hasTransition = getHasTransition(props);

      const getDoc = () => ownerDocument(mountNodeRef.current);

      const getModal = () => {
        modal.current.modalRef = modalRef.current;
        modal.current.mountNode = mountNodeRef.current;
        return modal.current;
      };

      const handleMounted = () => {
        manager.mount(getModal(), {
          disableScrollLock
        }); // Fix a bug on Chrome where the scroll isn't initially 0.

        modalRef.current.scrollTop = 0;
      };

      const handleOpen = useEventCallback(() => {
        const resolvedContainer = getContainer(container) || getDoc().body;
        manager.add(getModal(), resolvedContainer); // The element was already mounted.

        if (modalRef.current) {
          handleMounted();
        }
      });
      const isTopModal = react.exports.useCallback(() => manager.isTopModal(getModal()), [manager]);
      const handlePortalRef = useEventCallback(node => {
        mountNodeRef.current = node;

        if (!node) {
          return;
        }

        if (open && isTopModal()) {
          handleMounted();
        } else {
          ariaHidden(modalRef.current, true);
        }
      });
      const handleClose = react.exports.useCallback(() => {
        manager.remove(getModal());
      }, [manager]);
      react.exports.useEffect(() => {
        return () => {
          handleClose();
        };
      }, [handleClose]);
      react.exports.useEffect(() => {
        if (open) {
          handleOpen();
        } else if (!hasTransition || !closeAfterTransition) {
          handleClose();
        }
      }, [open, handleClose, hasTransition, closeAfterTransition, handleOpen]);

      const ownerState = _extends$1({}, props, {
        classes: classesProp,
        closeAfterTransition,
        disableAutoFocus,
        disableEnforceFocus,
        disableEscapeKeyDown,
        disablePortal,
        disableRestoreFocus,
        disableScrollLock,
        exited,
        hideBackdrop,
        keepMounted
      });

      const classes = useUtilityClasses$u(ownerState);

      if (!keepMounted && !open && (!hasTransition || exited)) {
        return null;
      }

      const handleEnter = () => {
        setExited(false);

        if (onTransitionEnter) {
          onTransitionEnter();
        }
      };

      const handleExited = () => {
        setExited(true);

        if (onTransitionExited) {
          onTransitionExited();
        }

        if (closeAfterTransition) {
          handleClose();
        }
      };

      const handleBackdropClick = event => {
        if (event.target !== event.currentTarget) {
          return;
        }

        if (onBackdropClick) {
          onBackdropClick(event);
        }

        if (onClose) {
          onClose(event, 'backdropClick');
        }
      };

      const handleKeyDown = event => {
        if (onKeyDown) {
          onKeyDown(event);
        } // The handler doesn't take event.defaultPrevented into account:
        //
        // event.preventDefault() is meant to stop default behaviors like
        // clicking a checkbox to check it, hitting a button to submit a form,
        // and hitting left arrow to move the cursor in a text input etc.
        // Only special HTML elements have these default behaviors.


        if (event.key !== 'Escape' || !isTopModal()) {
          return;
        }

        if (!disableEscapeKeyDown) {
          // Swallow the event, in case someone is listening for the escape key on the body.
          event.stopPropagation();

          if (onClose) {
            onClose(event, 'escapeKeyDown');
          }
        }
      };

      const childProps = {};

      if (children.props.tabIndex === undefined) {
        childProps.tabIndex = '-1';
      } // It's a Transition like component


      if (hasTransition) {
        childProps.onEnter = createChainedFunction(handleEnter, children.props.onEnter);
        childProps.onExited = createChainedFunction(handleExited, children.props.onExited);
      }

      const Root = components.Root || component;
      const rootProps = componentsProps.root || {};
      return /*#__PURE__*/jsxRuntimeExports.jsx(Portal$1, {
        ref: handlePortalRef,
        container: container,
        disablePortal: disablePortal,
        children: /*#__PURE__*/jsxRuntimeExports.jsxs(Root, _extends$1({
          role: "presentation"
        }, rootProps, !isHostComponent(Root) && {
          as: component,
          ownerState: _extends$1({}, ownerState, rootProps.ownerState),
          theme
        }, other, {
          ref: handleRef,
          onKeyDown: handleKeyDown,
          className: clsx(classes.root, rootProps.className, className),
          children: [!hideBackdrop && BackdropComponent ? /*#__PURE__*/jsxRuntimeExports.jsx(BackdropComponent, _extends$1({
            open: open,
            onClick: handleBackdropClick
          }, BackdropProps)) : null, /*#__PURE__*/jsxRuntimeExports.jsx(Unstable_TrapFocus, {
            disableEnforceFocus: disableEnforceFocus,
            disableAutoFocus: disableAutoFocus,
            disableRestoreFocus: disableRestoreFocus,
            isEnabled: isTopModal,
            open: open,
            children: /*#__PURE__*/react.exports.cloneElement(children, childProps)
          })]
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? ModalUnstyled.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * A backdrop component. This prop enables custom backdrop rendering.
       */
      BackdropComponent: propTypes.exports.elementType,

      /**
       * Props applied to the [`BackdropUnstyled`](/api/backdrop-unstyled/) element.
       */
      BackdropProps: propTypes.exports.object,

      /**
       * A single child content element.
       */
      children: elementAcceptingRef.isRequired,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * When set to true the Modal waits until a nested Transition is completed before closing.
       * @default false
       */
      closeAfterTransition: propTypes.exports.bool,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * The components used for each slot inside the Modal.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Modal.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        root: propTypes.exports.object
      }),

      /**
       * An HTML element or function that returns one.
       * The `container` will have the portal children appended to it.
       *
       * By default, it uses the body of the top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * If `true`, the modal will not automatically shift focus to itself when it opens, and
       * replace it to the last focused element when it closes.
       * This also works correctly with any modal children that have the `disableAutoFocus` prop.
       *
       * Generally this should never be set to `true` as it makes the modal less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableAutoFocus: propTypes.exports.bool,

      /**
       * If `true`, the modal will not prevent focus from leaving the modal while open.
       *
       * Generally this should never be set to `true` as it makes the modal less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableEnforceFocus: propTypes.exports.bool,

      /**
       * If `true`, hitting escape will not fire the `onClose` callback.
       * @default false
       */
      disableEscapeKeyDown: propTypes.exports.bool,

      /**
       * The `children` will be under the DOM hierarchy of the parent component.
       * @default false
       */
      disablePortal: propTypes.exports.bool,

      /**
       * If `true`, the modal will not restore focus to previously focused element once
       * modal is hidden or unmounted.
       * @default false
       */
      disableRestoreFocus: propTypes.exports.bool,

      /**
       * Disable the scroll lock behavior.
       * @default false
       */
      disableScrollLock: propTypes.exports.bool,

      /**
       * If `true`, the backdrop is not rendered.
       * @default false
       */
      hideBackdrop: propTypes.exports.bool,

      /**
       * Always keep the children in the DOM.
       * This prop can be useful in SEO situation or
       * when you want to maximize the responsiveness of the Modal.
       * @default false
       */
      keepMounted: propTypes.exports.bool,

      /**
       * Callback fired when the backdrop is clicked.
       */
      onBackdropClick: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be closed.
       * The `reason` parameter can optionally be used to control the response to `onClose`.
       *
       * @param {object} event The event source of the callback.
       * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`.
       */
      onClose: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyDown: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired
    } : void 0;
    var ModalUnstyled$1 = ModalUnstyled;

    var top = 'top';
    var bottom = 'bottom';
    var right = 'right';
    var left = 'left';
    var auto = 'auto';
    var basePlacements = [top, bottom, right, left];
    var start = 'start';
    var end = 'end';
    var clippingParents = 'clippingParents';
    var viewport = 'viewport';
    var popper = 'popper';
    var reference = 'reference';
    var variationPlacements = /*#__PURE__*/basePlacements.reduce(function (acc, placement) {
      return acc.concat([placement + "-" + start, placement + "-" + end]);
    }, []);
    var placements = /*#__PURE__*/[].concat(basePlacements, [auto]).reduce(function (acc, placement) {
      return acc.concat([placement, placement + "-" + start, placement + "-" + end]);
    }, []); // modifiers that need to read the DOM

    var beforeRead = 'beforeRead';
    var read = 'read';
    var afterRead = 'afterRead'; // pure-logic modifiers

    var beforeMain = 'beforeMain';
    var main = 'main';
    var afterMain = 'afterMain'; // modifier with the purpose to write to the DOM (or write into a framework state)

    var beforeWrite = 'beforeWrite';
    var write = 'write';
    var afterWrite = 'afterWrite';
    var modifierPhases = [beforeRead, read, afterRead, beforeMain, main, afterMain, beforeWrite, write, afterWrite];

    function getNodeName(element) {
      return element ? (element.nodeName || '').toLowerCase() : null;
    }

    function getWindow(node) {
      if (node == null) {
        return window;
      }

      if (node.toString() !== '[object Window]') {
        var ownerDocument = node.ownerDocument;
        return ownerDocument ? ownerDocument.defaultView || window : window;
      }

      return node;
    }

    function isElement(node) {
      var OwnElement = getWindow(node).Element;
      return node instanceof OwnElement || node instanceof Element;
    }

    function isHTMLElement(node) {
      var OwnElement = getWindow(node).HTMLElement;
      return node instanceof OwnElement || node instanceof HTMLElement;
    }

    function isShadowRoot(node) {
      // IE 11 has no ShadowRoot
      if (typeof ShadowRoot === 'undefined') {
        return false;
      }

      var OwnElement = getWindow(node).ShadowRoot;
      return node instanceof OwnElement || node instanceof ShadowRoot;
    }

    // and applies them to the HTMLElements such as popper and arrow

    function applyStyles(_ref) {
      var state = _ref.state;
      Object.keys(state.elements).forEach(function (name) {
        var style = state.styles[name] || {};
        var attributes = state.attributes[name] || {};
        var element = state.elements[name]; // arrow is optional + virtual elements

        if (!isHTMLElement(element) || !getNodeName(element)) {
          return;
        } // Flow doesn't support to extend this property, but it's the most
        // effective way to apply styles to an HTMLElement
        // $FlowFixMe[cannot-write]


        Object.assign(element.style, style);
        Object.keys(attributes).forEach(function (name) {
          var value = attributes[name];

          if (value === false) {
            element.removeAttribute(name);
          } else {
            element.setAttribute(name, value === true ? '' : value);
          }
        });
      });
    }

    function effect$2(_ref2) {
      var state = _ref2.state;
      var initialStyles = {
        popper: {
          position: state.options.strategy,
          left: '0',
          top: '0',
          margin: '0'
        },
        arrow: {
          position: 'absolute'
        },
        reference: {}
      };
      Object.assign(state.elements.popper.style, initialStyles.popper);
      state.styles = initialStyles;

      if (state.elements.arrow) {
        Object.assign(state.elements.arrow.style, initialStyles.arrow);
      }

      return function () {
        Object.keys(state.elements).forEach(function (name) {
          var element = state.elements[name];
          var attributes = state.attributes[name] || {};
          var styleProperties = Object.keys(state.styles.hasOwnProperty(name) ? state.styles[name] : initialStyles[name]); // Set all values to an empty string to unset them

          var style = styleProperties.reduce(function (style, property) {
            style[property] = '';
            return style;
          }, {}); // arrow is optional + virtual elements

          if (!isHTMLElement(element) || !getNodeName(element)) {
            return;
          }

          Object.assign(element.style, style);
          Object.keys(attributes).forEach(function (attribute) {
            element.removeAttribute(attribute);
          });
        });
      };
    } // eslint-disable-next-line import/no-unused-modules


    var applyStyles$1 = {
      name: 'applyStyles',
      enabled: true,
      phase: 'write',
      fn: applyStyles,
      effect: effect$2,
      requires: ['computeStyles']
    };

    function getBasePlacement(placement) {
      return placement.split('-')[0];
    }

    var round$2 = Math.round;
    function getBoundingClientRect(element, includeScale) {
      if (includeScale === void 0) {
        includeScale = false;
      }

      var rect = element.getBoundingClientRect();
      var scaleX = 1;
      var scaleY = 1;

      if (isHTMLElement(element) && includeScale) {
        // Fallback to 1 in case both values are `0`
        scaleX = rect.width / element.offsetWidth || 1;
        scaleY = rect.height / element.offsetHeight || 1;
      }

      return {
        width: round$2(rect.width / scaleX),
        height: round$2(rect.height / scaleY),
        top: round$2(rect.top / scaleY),
        right: round$2(rect.right / scaleX),
        bottom: round$2(rect.bottom / scaleY),
        left: round$2(rect.left / scaleX),
        x: round$2(rect.left / scaleX),
        y: round$2(rect.top / scaleY)
      };
    }

    // means it doesn't take into account transforms.

    function getLayoutRect(element) {
      var clientRect = getBoundingClientRect(element); // Use the clientRect sizes if it's not been transformed.
      // Fixes https://github.com/popperjs/popper-core/issues/1223

      var width = element.offsetWidth;
      var height = element.offsetHeight;

      if (Math.abs(clientRect.width - width) <= 1) {
        width = clientRect.width;
      }

      if (Math.abs(clientRect.height - height) <= 1) {
        height = clientRect.height;
      }

      return {
        x: element.offsetLeft,
        y: element.offsetTop,
        width: width,
        height: height
      };
    }

    function contains(parent, child) {
      var rootNode = child.getRootNode && child.getRootNode(); // First, attempt with faster native method

      if (parent.contains(child)) {
        return true;
      } // then fallback to custom implementation with Shadow DOM support
      else if (rootNode && isShadowRoot(rootNode)) {
          var next = child;

          do {
            if (next && parent.isSameNode(next)) {
              return true;
            } // $FlowFixMe[prop-missing]: need a better way to handle this...


            next = next.parentNode || next.host;
          } while (next);
        } // Give up, the result is false


      return false;
    }

    function getComputedStyle(element) {
      return getWindow(element).getComputedStyle(element);
    }

    function isTableElement(element) {
      return ['table', 'td', 'th'].indexOf(getNodeName(element)) >= 0;
    }

    function getDocumentElement(element) {
      // $FlowFixMe[incompatible-return]: assume body is always available
      return ((isElement(element) ? element.ownerDocument : // $FlowFixMe[prop-missing]
      element.document) || window.document).documentElement;
    }

    function getParentNode(element) {
      if (getNodeName(element) === 'html') {
        return element;
      }

      return (// this is a quicker (but less type safe) way to save quite some bytes from the bundle
        // $FlowFixMe[incompatible-return]
        // $FlowFixMe[prop-missing]
        element.assignedSlot || // step into the shadow DOM of the parent of a slotted node
        element.parentNode || ( // DOM Element detected
        isShadowRoot(element) ? element.host : null) || // ShadowRoot detected
        // $FlowFixMe[incompatible-call]: HTMLElement is a Node
        getDocumentElement(element) // fallback

      );
    }

    function getTrueOffsetParent(element) {
      if (!isHTMLElement(element) || // https://github.com/popperjs/popper-core/issues/837
      getComputedStyle(element).position === 'fixed') {
        return null;
      }

      return element.offsetParent;
    } // `.offsetParent` reports `null` for fixed elements, while absolute elements
    // return the containing block


    function getContainingBlock(element) {
      var isFirefox = navigator.userAgent.toLowerCase().indexOf('firefox') !== -1;
      var isIE = navigator.userAgent.indexOf('Trident') !== -1;

      if (isIE && isHTMLElement(element)) {
        // In IE 9, 10 and 11 fixed elements containing block is always established by the viewport
        var elementCss = getComputedStyle(element);

        if (elementCss.position === 'fixed') {
          return null;
        }
      }

      var currentNode = getParentNode(element);

      while (isHTMLElement(currentNode) && ['html', 'body'].indexOf(getNodeName(currentNode)) < 0) {
        var css = getComputedStyle(currentNode); // This is non-exhaustive but covers the most common CSS properties that
        // create a containing block.
        // https://developer.mozilla.org/en-US/docs/Web/CSS/Containing_block#identifying_the_containing_block

        if (css.transform !== 'none' || css.perspective !== 'none' || css.contain === 'paint' || ['transform', 'perspective'].indexOf(css.willChange) !== -1 || isFirefox && css.willChange === 'filter' || isFirefox && css.filter && css.filter !== 'none') {
          return currentNode;
        } else {
          currentNode = currentNode.parentNode;
        }
      }

      return null;
    } // Gets the closest ancestor positioned element. Handles some edge cases,
    // such as table ancestors and cross browser bugs.


    function getOffsetParent(element) {
      var window = getWindow(element);
      var offsetParent = getTrueOffsetParent(element);

      while (offsetParent && isTableElement(offsetParent) && getComputedStyle(offsetParent).position === 'static') {
        offsetParent = getTrueOffsetParent(offsetParent);
      }

      if (offsetParent && (getNodeName(offsetParent) === 'html' || getNodeName(offsetParent) === 'body' && getComputedStyle(offsetParent).position === 'static')) {
        return window;
      }

      return offsetParent || getContainingBlock(element) || window;
    }

    function getMainAxisFromPlacement(placement) {
      return ['top', 'bottom'].indexOf(placement) >= 0 ? 'x' : 'y';
    }

    var max = Math.max;
    var min = Math.min;
    var round$1 = Math.round;

    function within(min$1, value, max$1) {
      return max(min$1, min(value, max$1));
    }

    function getFreshSideObject() {
      return {
        top: 0,
        right: 0,
        bottom: 0,
        left: 0
      };
    }

    function mergePaddingObject(paddingObject) {
      return Object.assign({}, getFreshSideObject(), paddingObject);
    }

    function expandToHashMap(value, keys) {
      return keys.reduce(function (hashMap, key) {
        hashMap[key] = value;
        return hashMap;
      }, {});
    }

    var toPaddingObject = function toPaddingObject(padding, state) {
      padding = typeof padding === 'function' ? padding(Object.assign({}, state.rects, {
        placement: state.placement
      })) : padding;
      return mergePaddingObject(typeof padding !== 'number' ? padding : expandToHashMap(padding, basePlacements));
    };

    function arrow(_ref) {
      var _state$modifiersData$;

      var state = _ref.state,
          name = _ref.name,
          options = _ref.options;
      var arrowElement = state.elements.arrow;
      var popperOffsets = state.modifiersData.popperOffsets;
      var basePlacement = getBasePlacement(state.placement);
      var axis = getMainAxisFromPlacement(basePlacement);
      var isVertical = [left, right].indexOf(basePlacement) >= 0;
      var len = isVertical ? 'height' : 'width';

      if (!arrowElement || !popperOffsets) {
        return;
      }

      var paddingObject = toPaddingObject(options.padding, state);
      var arrowRect = getLayoutRect(arrowElement);
      var minProp = axis === 'y' ? top : left;
      var maxProp = axis === 'y' ? bottom : right;
      var endDiff = state.rects.reference[len] + state.rects.reference[axis] - popperOffsets[axis] - state.rects.popper[len];
      var startDiff = popperOffsets[axis] - state.rects.reference[axis];
      var arrowOffsetParent = getOffsetParent(arrowElement);
      var clientSize = arrowOffsetParent ? axis === 'y' ? arrowOffsetParent.clientHeight || 0 : arrowOffsetParent.clientWidth || 0 : 0;
      var centerToReference = endDiff / 2 - startDiff / 2; // Make sure the arrow doesn't overflow the popper if the center point is
      // outside of the popper bounds

      var min = paddingObject[minProp];
      var max = clientSize - arrowRect[len] - paddingObject[maxProp];
      var center = clientSize / 2 - arrowRect[len] / 2 + centerToReference;
      var offset = within(min, center, max); // Prevents breaking syntax highlighting...

      var axisProp = axis;
      state.modifiersData[name] = (_state$modifiersData$ = {}, _state$modifiersData$[axisProp] = offset, _state$modifiersData$.centerOffset = offset - center, _state$modifiersData$);
    }

    function effect$1(_ref2) {
      var state = _ref2.state,
          options = _ref2.options;
      var _options$element = options.element,
          arrowElement = _options$element === void 0 ? '[data-popper-arrow]' : _options$element;

      if (arrowElement == null) {
        return;
      } // CSS selector


      if (typeof arrowElement === 'string') {
        arrowElement = state.elements.popper.querySelector(arrowElement);

        if (!arrowElement) {
          return;
        }
      }

      if (process.env.NODE_ENV !== "production") {
        if (!isHTMLElement(arrowElement)) {
          console.error(['Popper: "arrow" element must be an HTMLElement (not an SVGElement).', 'To use an SVG arrow, wrap it in an HTMLElement that will be used as', 'the arrow.'].join(' '));
        }
      }

      if (!contains(state.elements.popper, arrowElement)) {
        if (process.env.NODE_ENV !== "production") {
          console.error(['Popper: "arrow" modifier\'s `element` must be a child of the popper', 'element.'].join(' '));
        }

        return;
      }

      state.elements.arrow = arrowElement;
    } // eslint-disable-next-line import/no-unused-modules


    var arrow$1 = {
      name: 'arrow',
      enabled: true,
      phase: 'main',
      fn: arrow,
      effect: effect$1,
      requires: ['popperOffsets'],
      requiresIfExists: ['preventOverflow']
    };

    var unsetSides = {
      top: 'auto',
      right: 'auto',
      bottom: 'auto',
      left: 'auto'
    }; // Round the offsets to the nearest suitable subpixel based on the DPR.
    // Zooming can change the DPR, but it seems to report a value that will
    // cleanly divide the values into the appropriate subpixels.

    function roundOffsetsByDPR(_ref) {
      var x = _ref.x,
          y = _ref.y;
      var win = window;
      var dpr = win.devicePixelRatio || 1;
      return {
        x: round$1(round$1(x * dpr) / dpr) || 0,
        y: round$1(round$1(y * dpr) / dpr) || 0
      };
    }

    function mapToStyles(_ref2) {
      var _Object$assign2;

      var popper = _ref2.popper,
          popperRect = _ref2.popperRect,
          placement = _ref2.placement,
          offsets = _ref2.offsets,
          position = _ref2.position,
          gpuAcceleration = _ref2.gpuAcceleration,
          adaptive = _ref2.adaptive,
          roundOffsets = _ref2.roundOffsets;

      var _ref3 = roundOffsets === true ? roundOffsetsByDPR(offsets) : typeof roundOffsets === 'function' ? roundOffsets(offsets) : offsets,
          _ref3$x = _ref3.x,
          x = _ref3$x === void 0 ? 0 : _ref3$x,
          _ref3$y = _ref3.y,
          y = _ref3$y === void 0 ? 0 : _ref3$y;

      var hasX = offsets.hasOwnProperty('x');
      var hasY = offsets.hasOwnProperty('y');
      var sideX = left;
      var sideY = top;
      var win = window;

      if (adaptive) {
        var offsetParent = getOffsetParent(popper);
        var heightProp = 'clientHeight';
        var widthProp = 'clientWidth';

        if (offsetParent === getWindow(popper)) {
          offsetParent = getDocumentElement(popper);

          if (getComputedStyle(offsetParent).position !== 'static') {
            heightProp = 'scrollHeight';
            widthProp = 'scrollWidth';
          }
        } // $FlowFixMe[incompatible-cast]: force type refinement, we compare offsetParent with window above, but Flow doesn't detect it


        offsetParent = offsetParent;

        if (placement === top) {
          sideY = bottom; // $FlowFixMe[prop-missing]

          y -= offsetParent[heightProp] - popperRect.height;
          y *= gpuAcceleration ? 1 : -1;
        }

        if (placement === left) {
          sideX = right; // $FlowFixMe[prop-missing]

          x -= offsetParent[widthProp] - popperRect.width;
          x *= gpuAcceleration ? 1 : -1;
        }
      }

      var commonStyles = Object.assign({
        position: position
      }, adaptive && unsetSides);

      if (gpuAcceleration) {
        var _Object$assign;

        return Object.assign({}, commonStyles, (_Object$assign = {}, _Object$assign[sideY] = hasY ? '0' : '', _Object$assign[sideX] = hasX ? '0' : '', _Object$assign.transform = (win.devicePixelRatio || 1) < 2 ? "translate(" + x + "px, " + y + "px)" : "translate3d(" + x + "px, " + y + "px, 0)", _Object$assign));
      }

      return Object.assign({}, commonStyles, (_Object$assign2 = {}, _Object$assign2[sideY] = hasY ? y + "px" : '', _Object$assign2[sideX] = hasX ? x + "px" : '', _Object$assign2.transform = '', _Object$assign2));
    }

    function computeStyles(_ref4) {
      var state = _ref4.state,
          options = _ref4.options;
      var _options$gpuAccelerat = options.gpuAcceleration,
          gpuAcceleration = _options$gpuAccelerat === void 0 ? true : _options$gpuAccelerat,
          _options$adaptive = options.adaptive,
          adaptive = _options$adaptive === void 0 ? true : _options$adaptive,
          _options$roundOffsets = options.roundOffsets,
          roundOffsets = _options$roundOffsets === void 0 ? true : _options$roundOffsets;

      if (process.env.NODE_ENV !== "production") {
        var transitionProperty = getComputedStyle(state.elements.popper).transitionProperty || '';

        if (adaptive && ['transform', 'top', 'right', 'bottom', 'left'].some(function (property) {
          return transitionProperty.indexOf(property) >= 0;
        })) {
          console.warn(['Popper: Detected CSS transitions on at least one of the following', 'CSS properties: "transform", "top", "right", "bottom", "left".', '\n\n', 'Disable the "computeStyles" modifier\'s `adaptive` option to allow', 'for smooth transitions, or remove these properties from the CSS', 'transition declaration on the popper element if only transitioning', 'opacity or background-color for example.', '\n\n', 'We recommend using the popper element as a wrapper around an inner', 'element that can have any CSS property transitioned for animations.'].join(' '));
        }
      }

      var commonStyles = {
        placement: getBasePlacement(state.placement),
        popper: state.elements.popper,
        popperRect: state.rects.popper,
        gpuAcceleration: gpuAcceleration
      };

      if (state.modifiersData.popperOffsets != null) {
        state.styles.popper = Object.assign({}, state.styles.popper, mapToStyles(Object.assign({}, commonStyles, {
          offsets: state.modifiersData.popperOffsets,
          position: state.options.strategy,
          adaptive: adaptive,
          roundOffsets: roundOffsets
        })));
      }

      if (state.modifiersData.arrow != null) {
        state.styles.arrow = Object.assign({}, state.styles.arrow, mapToStyles(Object.assign({}, commonStyles, {
          offsets: state.modifiersData.arrow,
          position: 'absolute',
          adaptive: false,
          roundOffsets: roundOffsets
        })));
      }

      state.attributes.popper = Object.assign({}, state.attributes.popper, {
        'data-popper-placement': state.placement
      });
    } // eslint-disable-next-line import/no-unused-modules


    var computeStyles$1 = {
      name: 'computeStyles',
      enabled: true,
      phase: 'beforeWrite',
      fn: computeStyles,
      data: {}
    };

    var passive = {
      passive: true
    };

    function effect(_ref) {
      var state = _ref.state,
          instance = _ref.instance,
          options = _ref.options;
      var _options$scroll = options.scroll,
          scroll = _options$scroll === void 0 ? true : _options$scroll,
          _options$resize = options.resize,
          resize = _options$resize === void 0 ? true : _options$resize;
      var window = getWindow(state.elements.popper);
      var scrollParents = [].concat(state.scrollParents.reference, state.scrollParents.popper);

      if (scroll) {
        scrollParents.forEach(function (scrollParent) {
          scrollParent.addEventListener('scroll', instance.update, passive);
        });
      }

      if (resize) {
        window.addEventListener('resize', instance.update, passive);
      }

      return function () {
        if (scroll) {
          scrollParents.forEach(function (scrollParent) {
            scrollParent.removeEventListener('scroll', instance.update, passive);
          });
        }

        if (resize) {
          window.removeEventListener('resize', instance.update, passive);
        }
      };
    } // eslint-disable-next-line import/no-unused-modules


    var eventListeners = {
      name: 'eventListeners',
      enabled: true,
      phase: 'write',
      fn: function fn() {},
      effect: effect,
      data: {}
    };

    var hash$1 = {
      left: 'right',
      right: 'left',
      bottom: 'top',
      top: 'bottom'
    };
    function getOppositePlacement(placement) {
      return placement.replace(/left|right|bottom|top/g, function (matched) {
        return hash$1[matched];
      });
    }

    var hash = {
      start: 'end',
      end: 'start'
    };
    function getOppositeVariationPlacement(placement) {
      return placement.replace(/start|end/g, function (matched) {
        return hash[matched];
      });
    }

    function getWindowScroll(node) {
      var win = getWindow(node);
      var scrollLeft = win.pageXOffset;
      var scrollTop = win.pageYOffset;
      return {
        scrollLeft: scrollLeft,
        scrollTop: scrollTop
      };
    }

    function getWindowScrollBarX(element) {
      // If <html> has a CSS width greater than the viewport, then this will be
      // incorrect for RTL.
      // Popper 1 is broken in this case and never had a bug report so let's assume
      // it's not an issue. I don't think anyone ever specifies width on <html>
      // anyway.
      // Browsers where the left scrollbar doesn't cause an issue report `0` for
      // this (e.g. Edge 2019, IE11, Safari)
      return getBoundingClientRect(getDocumentElement(element)).left + getWindowScroll(element).scrollLeft;
    }

    function getViewportRect(element) {
      var win = getWindow(element);
      var html = getDocumentElement(element);
      var visualViewport = win.visualViewport;
      var width = html.clientWidth;
      var height = html.clientHeight;
      var x = 0;
      var y = 0; // NB: This isn't supported on iOS <= 12. If the keyboard is open, the popper
      // can be obscured underneath it.
      // Also, `html.clientHeight` adds the bottom bar height in Safari iOS, even
      // if it isn't open, so if this isn't available, the popper will be detected
      // to overflow the bottom of the screen too early.

      if (visualViewport) {
        width = visualViewport.width;
        height = visualViewport.height; // Uses Layout Viewport (like Chrome; Safari does not currently)
        // In Chrome, it returns a value very close to 0 (+/-) but contains rounding
        // errors due to floating point numbers, so we need to check precision.
        // Safari returns a number <= 0, usually < -1 when pinch-zoomed
        // Feature detection fails in mobile emulation mode in Chrome.
        // Math.abs(win.innerWidth / visualViewport.scale - visualViewport.width) <
        // 0.001
        // Fallback here: "Not Safari" userAgent

        if (!/^((?!chrome|android).)*safari/i.test(navigator.userAgent)) {
          x = visualViewport.offsetLeft;
          y = visualViewport.offsetTop;
        }
      }

      return {
        width: width,
        height: height,
        x: x + getWindowScrollBarX(element),
        y: y
      };
    }

    // of the `<html>` and `<body>` rect bounds if horizontally scrollable

    function getDocumentRect(element) {
      var _element$ownerDocumen;

      var html = getDocumentElement(element);
      var winScroll = getWindowScroll(element);
      var body = (_element$ownerDocumen = element.ownerDocument) == null ? void 0 : _element$ownerDocumen.body;
      var width = max(html.scrollWidth, html.clientWidth, body ? body.scrollWidth : 0, body ? body.clientWidth : 0);
      var height = max(html.scrollHeight, html.clientHeight, body ? body.scrollHeight : 0, body ? body.clientHeight : 0);
      var x = -winScroll.scrollLeft + getWindowScrollBarX(element);
      var y = -winScroll.scrollTop;

      if (getComputedStyle(body || html).direction === 'rtl') {
        x += max(html.clientWidth, body ? body.clientWidth : 0) - width;
      }

      return {
        width: width,
        height: height,
        x: x,
        y: y
      };
    }

    function isScrollParent(element) {
      // Firefox wants us to check `-x` and `-y` variations as well
      var _getComputedStyle = getComputedStyle(element),
          overflow = _getComputedStyle.overflow,
          overflowX = _getComputedStyle.overflowX,
          overflowY = _getComputedStyle.overflowY;

      return /auto|scroll|overlay|hidden/.test(overflow + overflowY + overflowX);
    }

    function getScrollParent(node) {
      if (['html', 'body', '#document'].indexOf(getNodeName(node)) >= 0) {
        // $FlowFixMe[incompatible-return]: assume body is always available
        return node.ownerDocument.body;
      }

      if (isHTMLElement(node) && isScrollParent(node)) {
        return node;
      }

      return getScrollParent(getParentNode(node));
    }

    /*
    given a DOM element, return the list of all scroll parents, up the list of ancesors
    until we get to the top window object. This list is what we attach scroll listeners
    to, because if any of these parent elements scroll, we'll need to re-calculate the
    reference element's position.
    */

    function listScrollParents(element, list) {
      var _element$ownerDocumen;

      if (list === void 0) {
        list = [];
      }

      var scrollParent = getScrollParent(element);
      var isBody = scrollParent === ((_element$ownerDocumen = element.ownerDocument) == null ? void 0 : _element$ownerDocumen.body);
      var win = getWindow(scrollParent);
      var target = isBody ? [win].concat(win.visualViewport || [], isScrollParent(scrollParent) ? scrollParent : []) : scrollParent;
      var updatedList = list.concat(target);
      return isBody ? updatedList : // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
      updatedList.concat(listScrollParents(getParentNode(target)));
    }

    function rectToClientRect(rect) {
      return Object.assign({}, rect, {
        left: rect.x,
        top: rect.y,
        right: rect.x + rect.width,
        bottom: rect.y + rect.height
      });
    }

    function getInnerBoundingClientRect(element) {
      var rect = getBoundingClientRect(element);
      rect.top = rect.top + element.clientTop;
      rect.left = rect.left + element.clientLeft;
      rect.bottom = rect.top + element.clientHeight;
      rect.right = rect.left + element.clientWidth;
      rect.width = element.clientWidth;
      rect.height = element.clientHeight;
      rect.x = rect.left;
      rect.y = rect.top;
      return rect;
    }

    function getClientRectFromMixedType(element, clippingParent) {
      return clippingParent === viewport ? rectToClientRect(getViewportRect(element)) : isHTMLElement(clippingParent) ? getInnerBoundingClientRect(clippingParent) : rectToClientRect(getDocumentRect(getDocumentElement(element)));
    } // A "clipping parent" is an overflowable container with the characteristic of
    // clipping (or hiding) overflowing elements with a position different from
    // `initial`


    function getClippingParents(element) {
      var clippingParents = listScrollParents(getParentNode(element));
      var canEscapeClipping = ['absolute', 'fixed'].indexOf(getComputedStyle(element).position) >= 0;
      var clipperElement = canEscapeClipping && isHTMLElement(element) ? getOffsetParent(element) : element;

      if (!isElement(clipperElement)) {
        return [];
      } // $FlowFixMe[incompatible-return]: https://github.com/facebook/flow/issues/1414


      return clippingParents.filter(function (clippingParent) {
        return isElement(clippingParent) && contains(clippingParent, clipperElement) && getNodeName(clippingParent) !== 'body';
      });
    } // Gets the maximum area that the element is visible in due to any number of
    // clipping parents


    function getClippingRect(element, boundary, rootBoundary) {
      var mainClippingParents = boundary === 'clippingParents' ? getClippingParents(element) : [].concat(boundary);
      var clippingParents = [].concat(mainClippingParents, [rootBoundary]);
      var firstClippingParent = clippingParents[0];
      var clippingRect = clippingParents.reduce(function (accRect, clippingParent) {
        var rect = getClientRectFromMixedType(element, clippingParent);
        accRect.top = max(rect.top, accRect.top);
        accRect.right = min(rect.right, accRect.right);
        accRect.bottom = min(rect.bottom, accRect.bottom);
        accRect.left = max(rect.left, accRect.left);
        return accRect;
      }, getClientRectFromMixedType(element, firstClippingParent));
      clippingRect.width = clippingRect.right - clippingRect.left;
      clippingRect.height = clippingRect.bottom - clippingRect.top;
      clippingRect.x = clippingRect.left;
      clippingRect.y = clippingRect.top;
      return clippingRect;
    }

    function getVariation(placement) {
      return placement.split('-')[1];
    }

    function computeOffsets(_ref) {
      var reference = _ref.reference,
          element = _ref.element,
          placement = _ref.placement;
      var basePlacement = placement ? getBasePlacement(placement) : null;
      var variation = placement ? getVariation(placement) : null;
      var commonX = reference.x + reference.width / 2 - element.width / 2;
      var commonY = reference.y + reference.height / 2 - element.height / 2;
      var offsets;

      switch (basePlacement) {
        case top:
          offsets = {
            x: commonX,
            y: reference.y - element.height
          };
          break;

        case bottom:
          offsets = {
            x: commonX,
            y: reference.y + reference.height
          };
          break;

        case right:
          offsets = {
            x: reference.x + reference.width,
            y: commonY
          };
          break;

        case left:
          offsets = {
            x: reference.x - element.width,
            y: commonY
          };
          break;

        default:
          offsets = {
            x: reference.x,
            y: reference.y
          };
      }

      var mainAxis = basePlacement ? getMainAxisFromPlacement(basePlacement) : null;

      if (mainAxis != null) {
        var len = mainAxis === 'y' ? 'height' : 'width';

        switch (variation) {
          case start:
            offsets[mainAxis] = offsets[mainAxis] - (reference[len] / 2 - element[len] / 2);
            break;

          case end:
            offsets[mainAxis] = offsets[mainAxis] + (reference[len] / 2 - element[len] / 2);
            break;
        }
      }

      return offsets;
    }

    function detectOverflow(state, options) {
      if (options === void 0) {
        options = {};
      }

      var _options = options,
          _options$placement = _options.placement,
          placement = _options$placement === void 0 ? state.placement : _options$placement,
          _options$boundary = _options.boundary,
          boundary = _options$boundary === void 0 ? clippingParents : _options$boundary,
          _options$rootBoundary = _options.rootBoundary,
          rootBoundary = _options$rootBoundary === void 0 ? viewport : _options$rootBoundary,
          _options$elementConte = _options.elementContext,
          elementContext = _options$elementConte === void 0 ? popper : _options$elementConte,
          _options$altBoundary = _options.altBoundary,
          altBoundary = _options$altBoundary === void 0 ? false : _options$altBoundary,
          _options$padding = _options.padding,
          padding = _options$padding === void 0 ? 0 : _options$padding;
      var paddingObject = mergePaddingObject(typeof padding !== 'number' ? padding : expandToHashMap(padding, basePlacements));
      var altContext = elementContext === popper ? reference : popper;
      var referenceElement = state.elements.reference;
      var popperRect = state.rects.popper;
      var element = state.elements[altBoundary ? altContext : elementContext];
      var clippingClientRect = getClippingRect(isElement(element) ? element : element.contextElement || getDocumentElement(state.elements.popper), boundary, rootBoundary);
      var referenceClientRect = getBoundingClientRect(referenceElement);
      var popperOffsets = computeOffsets({
        reference: referenceClientRect,
        element: popperRect,
        strategy: 'absolute',
        placement: placement
      });
      var popperClientRect = rectToClientRect(Object.assign({}, popperRect, popperOffsets));
      var elementClientRect = elementContext === popper ? popperClientRect : referenceClientRect; // positive = overflowing the clipping rect
      // 0 or negative = within the clipping rect

      var overflowOffsets = {
        top: clippingClientRect.top - elementClientRect.top + paddingObject.top,
        bottom: elementClientRect.bottom - clippingClientRect.bottom + paddingObject.bottom,
        left: clippingClientRect.left - elementClientRect.left + paddingObject.left,
        right: elementClientRect.right - clippingClientRect.right + paddingObject.right
      };
      var offsetData = state.modifiersData.offset; // Offsets can be applied only to the popper element

      if (elementContext === popper && offsetData) {
        var offset = offsetData[placement];
        Object.keys(overflowOffsets).forEach(function (key) {
          var multiply = [right, bottom].indexOf(key) >= 0 ? 1 : -1;
          var axis = [top, bottom].indexOf(key) >= 0 ? 'y' : 'x';
          overflowOffsets[key] += offset[axis] * multiply;
        });
      }

      return overflowOffsets;
    }

    function computeAutoPlacement(state, options) {
      if (options === void 0) {
        options = {};
      }

      var _options = options,
          placement = _options.placement,
          boundary = _options.boundary,
          rootBoundary = _options.rootBoundary,
          padding = _options.padding,
          flipVariations = _options.flipVariations,
          _options$allowedAutoP = _options.allowedAutoPlacements,
          allowedAutoPlacements = _options$allowedAutoP === void 0 ? placements : _options$allowedAutoP;
      var variation = getVariation(placement);
      var placements$1 = variation ? flipVariations ? variationPlacements : variationPlacements.filter(function (placement) {
        return getVariation(placement) === variation;
      }) : basePlacements;
      var allowedPlacements = placements$1.filter(function (placement) {
        return allowedAutoPlacements.indexOf(placement) >= 0;
      });

      if (allowedPlacements.length === 0) {
        allowedPlacements = placements$1;

        if (process.env.NODE_ENV !== "production") {
          console.error(['Popper: The `allowedAutoPlacements` option did not allow any', 'placements. Ensure the `placement` option matches the variation', 'of the allowed placements.', 'For example, "auto" cannot be used to allow "bottom-start".', 'Use "auto-start" instead.'].join(' '));
        }
      } // $FlowFixMe[incompatible-type]: Flow seems to have problems with two array unions...


      var overflows = allowedPlacements.reduce(function (acc, placement) {
        acc[placement] = detectOverflow(state, {
          placement: placement,
          boundary: boundary,
          rootBoundary: rootBoundary,
          padding: padding
        })[getBasePlacement(placement)];
        return acc;
      }, {});
      return Object.keys(overflows).sort(function (a, b) {
        return overflows[a] - overflows[b];
      });
    }

    function getExpandedFallbackPlacements(placement) {
      if (getBasePlacement(placement) === auto) {
        return [];
      }

      var oppositePlacement = getOppositePlacement(placement);
      return [getOppositeVariationPlacement(placement), oppositePlacement, getOppositeVariationPlacement(oppositePlacement)];
    }

    function flip(_ref) {
      var state = _ref.state,
          options = _ref.options,
          name = _ref.name;

      if (state.modifiersData[name]._skip) {
        return;
      }

      var _options$mainAxis = options.mainAxis,
          checkMainAxis = _options$mainAxis === void 0 ? true : _options$mainAxis,
          _options$altAxis = options.altAxis,
          checkAltAxis = _options$altAxis === void 0 ? true : _options$altAxis,
          specifiedFallbackPlacements = options.fallbackPlacements,
          padding = options.padding,
          boundary = options.boundary,
          rootBoundary = options.rootBoundary,
          altBoundary = options.altBoundary,
          _options$flipVariatio = options.flipVariations,
          flipVariations = _options$flipVariatio === void 0 ? true : _options$flipVariatio,
          allowedAutoPlacements = options.allowedAutoPlacements;
      var preferredPlacement = state.options.placement;
      var basePlacement = getBasePlacement(preferredPlacement);
      var isBasePlacement = basePlacement === preferredPlacement;
      var fallbackPlacements = specifiedFallbackPlacements || (isBasePlacement || !flipVariations ? [getOppositePlacement(preferredPlacement)] : getExpandedFallbackPlacements(preferredPlacement));
      var placements = [preferredPlacement].concat(fallbackPlacements).reduce(function (acc, placement) {
        return acc.concat(getBasePlacement(placement) === auto ? computeAutoPlacement(state, {
          placement: placement,
          boundary: boundary,
          rootBoundary: rootBoundary,
          padding: padding,
          flipVariations: flipVariations,
          allowedAutoPlacements: allowedAutoPlacements
        }) : placement);
      }, []);
      var referenceRect = state.rects.reference;
      var popperRect = state.rects.popper;
      var checksMap = new Map();
      var makeFallbackChecks = true;
      var firstFittingPlacement = placements[0];

      for (var i = 0; i < placements.length; i++) {
        var placement = placements[i];

        var _basePlacement = getBasePlacement(placement);

        var isStartVariation = getVariation(placement) === start;
        var isVertical = [top, bottom].indexOf(_basePlacement) >= 0;
        var len = isVertical ? 'width' : 'height';
        var overflow = detectOverflow(state, {
          placement: placement,
          boundary: boundary,
          rootBoundary: rootBoundary,
          altBoundary: altBoundary,
          padding: padding
        });
        var mainVariationSide = isVertical ? isStartVariation ? right : left : isStartVariation ? bottom : top;

        if (referenceRect[len] > popperRect[len]) {
          mainVariationSide = getOppositePlacement(mainVariationSide);
        }

        var altVariationSide = getOppositePlacement(mainVariationSide);
        var checks = [];

        if (checkMainAxis) {
          checks.push(overflow[_basePlacement] <= 0);
        }

        if (checkAltAxis) {
          checks.push(overflow[mainVariationSide] <= 0, overflow[altVariationSide] <= 0);
        }

        if (checks.every(function (check) {
          return check;
        })) {
          firstFittingPlacement = placement;
          makeFallbackChecks = false;
          break;
        }

        checksMap.set(placement, checks);
      }

      if (makeFallbackChecks) {
        // `2` may be desired in some cases – research later
        var numberOfChecks = flipVariations ? 3 : 1;

        var _loop = function _loop(_i) {
          var fittingPlacement = placements.find(function (placement) {
            var checks = checksMap.get(placement);

            if (checks) {
              return checks.slice(0, _i).every(function (check) {
                return check;
              });
            }
          });

          if (fittingPlacement) {
            firstFittingPlacement = fittingPlacement;
            return "break";
          }
        };

        for (var _i = numberOfChecks; _i > 0; _i--) {
          var _ret = _loop(_i);

          if (_ret === "break") break;
        }
      }

      if (state.placement !== firstFittingPlacement) {
        state.modifiersData[name]._skip = true;
        state.placement = firstFittingPlacement;
        state.reset = true;
      }
    } // eslint-disable-next-line import/no-unused-modules


    var flip$1 = {
      name: 'flip',
      enabled: true,
      phase: 'main',
      fn: flip,
      requiresIfExists: ['offset'],
      data: {
        _skip: false
      }
    };

    function getSideOffsets(overflow, rect, preventedOffsets) {
      if (preventedOffsets === void 0) {
        preventedOffsets = {
          x: 0,
          y: 0
        };
      }

      return {
        top: overflow.top - rect.height - preventedOffsets.y,
        right: overflow.right - rect.width + preventedOffsets.x,
        bottom: overflow.bottom - rect.height + preventedOffsets.y,
        left: overflow.left - rect.width - preventedOffsets.x
      };
    }

    function isAnySideFullyClipped(overflow) {
      return [top, right, bottom, left].some(function (side) {
        return overflow[side] >= 0;
      });
    }

    function hide(_ref) {
      var state = _ref.state,
          name = _ref.name;
      var referenceRect = state.rects.reference;
      var popperRect = state.rects.popper;
      var preventedOffsets = state.modifiersData.preventOverflow;
      var referenceOverflow = detectOverflow(state, {
        elementContext: 'reference'
      });
      var popperAltOverflow = detectOverflow(state, {
        altBoundary: true
      });
      var referenceClippingOffsets = getSideOffsets(referenceOverflow, referenceRect);
      var popperEscapeOffsets = getSideOffsets(popperAltOverflow, popperRect, preventedOffsets);
      var isReferenceHidden = isAnySideFullyClipped(referenceClippingOffsets);
      var hasPopperEscaped = isAnySideFullyClipped(popperEscapeOffsets);
      state.modifiersData[name] = {
        referenceClippingOffsets: referenceClippingOffsets,
        popperEscapeOffsets: popperEscapeOffsets,
        isReferenceHidden: isReferenceHidden,
        hasPopperEscaped: hasPopperEscaped
      };
      state.attributes.popper = Object.assign({}, state.attributes.popper, {
        'data-popper-reference-hidden': isReferenceHidden,
        'data-popper-escaped': hasPopperEscaped
      });
    } // eslint-disable-next-line import/no-unused-modules


    var hide$1 = {
      name: 'hide',
      enabled: true,
      phase: 'main',
      requiresIfExists: ['preventOverflow'],
      fn: hide
    };

    function distanceAndSkiddingToXY(placement, rects, offset) {
      var basePlacement = getBasePlacement(placement);
      var invertDistance = [left, top].indexOf(basePlacement) >= 0 ? -1 : 1;

      var _ref = typeof offset === 'function' ? offset(Object.assign({}, rects, {
        placement: placement
      })) : offset,
          skidding = _ref[0],
          distance = _ref[1];

      skidding = skidding || 0;
      distance = (distance || 0) * invertDistance;
      return [left, right].indexOf(basePlacement) >= 0 ? {
        x: distance,
        y: skidding
      } : {
        x: skidding,
        y: distance
      };
    }

    function offset(_ref2) {
      var state = _ref2.state,
          options = _ref2.options,
          name = _ref2.name;
      var _options$offset = options.offset,
          offset = _options$offset === void 0 ? [0, 0] : _options$offset;
      var data = placements.reduce(function (acc, placement) {
        acc[placement] = distanceAndSkiddingToXY(placement, state.rects, offset);
        return acc;
      }, {});
      var _data$state$placement = data[state.placement],
          x = _data$state$placement.x,
          y = _data$state$placement.y;

      if (state.modifiersData.popperOffsets != null) {
        state.modifiersData.popperOffsets.x += x;
        state.modifiersData.popperOffsets.y += y;
      }

      state.modifiersData[name] = data;
    } // eslint-disable-next-line import/no-unused-modules


    var offset$1 = {
      name: 'offset',
      enabled: true,
      phase: 'main',
      requires: ['popperOffsets'],
      fn: offset
    };

    function popperOffsets(_ref) {
      var state = _ref.state,
          name = _ref.name;
      // Offsets are the actual position the popper needs to have to be
      // properly positioned near its reference element
      // This is the most basic placement, and will be adjusted by
      // the modifiers in the next step
      state.modifiersData[name] = computeOffsets({
        reference: state.rects.reference,
        element: state.rects.popper,
        strategy: 'absolute',
        placement: state.placement
      });
    } // eslint-disable-next-line import/no-unused-modules


    var popperOffsets$1 = {
      name: 'popperOffsets',
      enabled: true,
      phase: 'read',
      fn: popperOffsets,
      data: {}
    };

    function getAltAxis(axis) {
      return axis === 'x' ? 'y' : 'x';
    }

    function preventOverflow(_ref) {
      var state = _ref.state,
          options = _ref.options,
          name = _ref.name;
      var _options$mainAxis = options.mainAxis,
          checkMainAxis = _options$mainAxis === void 0 ? true : _options$mainAxis,
          _options$altAxis = options.altAxis,
          checkAltAxis = _options$altAxis === void 0 ? false : _options$altAxis,
          boundary = options.boundary,
          rootBoundary = options.rootBoundary,
          altBoundary = options.altBoundary,
          padding = options.padding,
          _options$tether = options.tether,
          tether = _options$tether === void 0 ? true : _options$tether,
          _options$tetherOffset = options.tetherOffset,
          tetherOffset = _options$tetherOffset === void 0 ? 0 : _options$tetherOffset;
      var overflow = detectOverflow(state, {
        boundary: boundary,
        rootBoundary: rootBoundary,
        padding: padding,
        altBoundary: altBoundary
      });
      var basePlacement = getBasePlacement(state.placement);
      var variation = getVariation(state.placement);
      var isBasePlacement = !variation;
      var mainAxis = getMainAxisFromPlacement(basePlacement);
      var altAxis = getAltAxis(mainAxis);
      var popperOffsets = state.modifiersData.popperOffsets;
      var referenceRect = state.rects.reference;
      var popperRect = state.rects.popper;
      var tetherOffsetValue = typeof tetherOffset === 'function' ? tetherOffset(Object.assign({}, state.rects, {
        placement: state.placement
      })) : tetherOffset;
      var data = {
        x: 0,
        y: 0
      };

      if (!popperOffsets) {
        return;
      }

      if (checkMainAxis || checkAltAxis) {
        var mainSide = mainAxis === 'y' ? top : left;
        var altSide = mainAxis === 'y' ? bottom : right;
        var len = mainAxis === 'y' ? 'height' : 'width';
        var offset = popperOffsets[mainAxis];
        var min$1 = popperOffsets[mainAxis] + overflow[mainSide];
        var max$1 = popperOffsets[mainAxis] - overflow[altSide];
        var additive = tether ? -popperRect[len] / 2 : 0;
        var minLen = variation === start ? referenceRect[len] : popperRect[len];
        var maxLen = variation === start ? -popperRect[len] : -referenceRect[len]; // We need to include the arrow in the calculation so the arrow doesn't go
        // outside the reference bounds

        var arrowElement = state.elements.arrow;
        var arrowRect = tether && arrowElement ? getLayoutRect(arrowElement) : {
          width: 0,
          height: 0
        };
        var arrowPaddingObject = state.modifiersData['arrow#persistent'] ? state.modifiersData['arrow#persistent'].padding : getFreshSideObject();
        var arrowPaddingMin = arrowPaddingObject[mainSide];
        var arrowPaddingMax = arrowPaddingObject[altSide]; // If the reference length is smaller than the arrow length, we don't want
        // to include its full size in the calculation. If the reference is small
        // and near the edge of a boundary, the popper can overflow even if the
        // reference is not overflowing as well (e.g. virtual elements with no
        // width or height)

        var arrowLen = within(0, referenceRect[len], arrowRect[len]);
        var minOffset = isBasePlacement ? referenceRect[len] / 2 - additive - arrowLen - arrowPaddingMin - tetherOffsetValue : minLen - arrowLen - arrowPaddingMin - tetherOffsetValue;
        var maxOffset = isBasePlacement ? -referenceRect[len] / 2 + additive + arrowLen + arrowPaddingMax + tetherOffsetValue : maxLen + arrowLen + arrowPaddingMax + tetherOffsetValue;
        var arrowOffsetParent = state.elements.arrow && getOffsetParent(state.elements.arrow);
        var clientOffset = arrowOffsetParent ? mainAxis === 'y' ? arrowOffsetParent.clientTop || 0 : arrowOffsetParent.clientLeft || 0 : 0;
        var offsetModifierValue = state.modifiersData.offset ? state.modifiersData.offset[state.placement][mainAxis] : 0;
        var tetherMin = popperOffsets[mainAxis] + minOffset - offsetModifierValue - clientOffset;
        var tetherMax = popperOffsets[mainAxis] + maxOffset - offsetModifierValue;

        if (checkMainAxis) {
          var preventedOffset = within(tether ? min(min$1, tetherMin) : min$1, offset, tether ? max(max$1, tetherMax) : max$1);
          popperOffsets[mainAxis] = preventedOffset;
          data[mainAxis] = preventedOffset - offset;
        }

        if (checkAltAxis) {
          var _mainSide = mainAxis === 'x' ? top : left;

          var _altSide = mainAxis === 'x' ? bottom : right;

          var _offset = popperOffsets[altAxis];

          var _min = _offset + overflow[_mainSide];

          var _max = _offset - overflow[_altSide];

          var _preventedOffset = within(tether ? min(_min, tetherMin) : _min, _offset, tether ? max(_max, tetherMax) : _max);

          popperOffsets[altAxis] = _preventedOffset;
          data[altAxis] = _preventedOffset - _offset;
        }
      }

      state.modifiersData[name] = data;
    } // eslint-disable-next-line import/no-unused-modules


    var preventOverflow$1 = {
      name: 'preventOverflow',
      enabled: true,
      phase: 'main',
      fn: preventOverflow,
      requiresIfExists: ['offset']
    };

    function getHTMLElementScroll(element) {
      return {
        scrollLeft: element.scrollLeft,
        scrollTop: element.scrollTop
      };
    }

    function getNodeScroll(node) {
      if (node === getWindow(node) || !isHTMLElement(node)) {
        return getWindowScroll(node);
      } else {
        return getHTMLElementScroll(node);
      }
    }

    function isElementScaled(element) {
      var rect = element.getBoundingClientRect();
      var scaleX = rect.width / element.offsetWidth || 1;
      var scaleY = rect.height / element.offsetHeight || 1;
      return scaleX !== 1 || scaleY !== 1;
    } // Returns the composite rect of an element relative to its offsetParent.
    // Composite means it takes into account transforms as well as layout.


    function getCompositeRect(elementOrVirtualElement, offsetParent, isFixed) {
      if (isFixed === void 0) {
        isFixed = false;
      }

      var isOffsetParentAnElement = isHTMLElement(offsetParent);
      var offsetParentIsScaled = isHTMLElement(offsetParent) && isElementScaled(offsetParent);
      var documentElement = getDocumentElement(offsetParent);
      var rect = getBoundingClientRect(elementOrVirtualElement, offsetParentIsScaled);
      var scroll = {
        scrollLeft: 0,
        scrollTop: 0
      };
      var offsets = {
        x: 0,
        y: 0
      };

      if (isOffsetParentAnElement || !isOffsetParentAnElement && !isFixed) {
        if (getNodeName(offsetParent) !== 'body' || // https://github.com/popperjs/popper-core/issues/1078
        isScrollParent(documentElement)) {
          scroll = getNodeScroll(offsetParent);
        }

        if (isHTMLElement(offsetParent)) {
          offsets = getBoundingClientRect(offsetParent, true);
          offsets.x += offsetParent.clientLeft;
          offsets.y += offsetParent.clientTop;
        } else if (documentElement) {
          offsets.x = getWindowScrollBarX(documentElement);
        }
      }

      return {
        x: rect.left + scroll.scrollLeft - offsets.x,
        y: rect.top + scroll.scrollTop - offsets.y,
        width: rect.width,
        height: rect.height
      };
    }

    function order(modifiers) {
      var map = new Map();
      var visited = new Set();
      var result = [];
      modifiers.forEach(function (modifier) {
        map.set(modifier.name, modifier);
      }); // On visiting object, check for its dependencies and visit them recursively

      function sort(modifier) {
        visited.add(modifier.name);
        var requires = [].concat(modifier.requires || [], modifier.requiresIfExists || []);
        requires.forEach(function (dep) {
          if (!visited.has(dep)) {
            var depModifier = map.get(dep);

            if (depModifier) {
              sort(depModifier);
            }
          }
        });
        result.push(modifier);
      }

      modifiers.forEach(function (modifier) {
        if (!visited.has(modifier.name)) {
          // check for visited object
          sort(modifier);
        }
      });
      return result;
    }

    function orderModifiers(modifiers) {
      // order based on dependencies
      var orderedModifiers = order(modifiers); // order based on phase

      return modifierPhases.reduce(function (acc, phase) {
        return acc.concat(orderedModifiers.filter(function (modifier) {
          return modifier.phase === phase;
        }));
      }, []);
    }

    function debounce(fn) {
      var pending;
      return function () {
        if (!pending) {
          pending = new Promise(function (resolve) {
            Promise.resolve().then(function () {
              pending = undefined;
              resolve(fn());
            });
          });
        }

        return pending;
      };
    }

    function format(str) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      return [].concat(args).reduce(function (p, c) {
        return p.replace(/%s/, c);
      }, str);
    }

    var INVALID_MODIFIER_ERROR = 'Popper: modifier "%s" provided an invalid %s property, expected %s but got %s';
    var MISSING_DEPENDENCY_ERROR = 'Popper: modifier "%s" requires "%s", but "%s" modifier is not available';
    var VALID_PROPERTIES = ['name', 'enabled', 'phase', 'fn', 'effect', 'requires', 'options'];
    function validateModifiers(modifiers) {
      modifiers.forEach(function (modifier) {
        Object.keys(modifier).forEach(function (key) {
          switch (key) {
            case 'name':
              if (typeof modifier.name !== 'string') {
                console.error(format(INVALID_MODIFIER_ERROR, String(modifier.name), '"name"', '"string"', "\"" + String(modifier.name) + "\""));
              }

              break;

            case 'enabled':
              if (typeof modifier.enabled !== 'boolean') {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"enabled"', '"boolean"', "\"" + String(modifier.enabled) + "\""));
              }

            case 'phase':
              if (modifierPhases.indexOf(modifier.phase) < 0) {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"phase"', "either " + modifierPhases.join(', '), "\"" + String(modifier.phase) + "\""));
              }

              break;

            case 'fn':
              if (typeof modifier.fn !== 'function') {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"fn"', '"function"', "\"" + String(modifier.fn) + "\""));
              }

              break;

            case 'effect':
              if (typeof modifier.effect !== 'function') {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"effect"', '"function"', "\"" + String(modifier.fn) + "\""));
              }

              break;

            case 'requires':
              if (!Array.isArray(modifier.requires)) {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"requires"', '"array"', "\"" + String(modifier.requires) + "\""));
              }

              break;

            case 'requiresIfExists':
              if (!Array.isArray(modifier.requiresIfExists)) {
                console.error(format(INVALID_MODIFIER_ERROR, modifier.name, '"requiresIfExists"', '"array"', "\"" + String(modifier.requiresIfExists) + "\""));
              }

              break;

            case 'options':
            case 'data':
              break;

            default:
              console.error("PopperJS: an invalid property has been provided to the \"" + modifier.name + "\" modifier, valid properties are " + VALID_PROPERTIES.map(function (s) {
                return "\"" + s + "\"";
              }).join(', ') + "; but \"" + key + "\" was provided.");
          }

          modifier.requires && modifier.requires.forEach(function (requirement) {
            if (modifiers.find(function (mod) {
              return mod.name === requirement;
            }) == null) {
              console.error(format(MISSING_DEPENDENCY_ERROR, String(modifier.name), requirement, requirement));
            }
          });
        });
      });
    }

    function uniqueBy(arr, fn) {
      var identifiers = new Set();
      return arr.filter(function (item) {
        var identifier = fn(item);

        if (!identifiers.has(identifier)) {
          identifiers.add(identifier);
          return true;
        }
      });
    }

    function mergeByName(modifiers) {
      var merged = modifiers.reduce(function (merged, current) {
        var existing = merged[current.name];
        merged[current.name] = existing ? Object.assign({}, existing, current, {
          options: Object.assign({}, existing.options, current.options),
          data: Object.assign({}, existing.data, current.data)
        }) : current;
        return merged;
      }, {}); // IE11 does not support Object.values

      return Object.keys(merged).map(function (key) {
        return merged[key];
      });
    }

    var INVALID_ELEMENT_ERROR = 'Popper: Invalid reference or popper argument provided. They must be either a DOM element or virtual element.';
    var INFINITE_LOOP_ERROR = 'Popper: An infinite loop in the modifiers cycle has been detected! The cycle has been interrupted to prevent a browser crash.';
    var DEFAULT_OPTIONS = {
      placement: 'bottom',
      modifiers: [],
      strategy: 'absolute'
    };

    function areValidElements() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return !args.some(function (element) {
        return !(element && typeof element.getBoundingClientRect === 'function');
      });
    }

    function popperGenerator(generatorOptions) {
      if (generatorOptions === void 0) {
        generatorOptions = {};
      }

      var _generatorOptions = generatorOptions,
          _generatorOptions$def = _generatorOptions.defaultModifiers,
          defaultModifiers = _generatorOptions$def === void 0 ? [] : _generatorOptions$def,
          _generatorOptions$def2 = _generatorOptions.defaultOptions,
          defaultOptions = _generatorOptions$def2 === void 0 ? DEFAULT_OPTIONS : _generatorOptions$def2;
      return function createPopper(reference, popper, options) {
        if (options === void 0) {
          options = defaultOptions;
        }

        var state = {
          placement: 'bottom',
          orderedModifiers: [],
          options: Object.assign({}, DEFAULT_OPTIONS, defaultOptions),
          modifiersData: {},
          elements: {
            reference: reference,
            popper: popper
          },
          attributes: {},
          styles: {}
        };
        var effectCleanupFns = [];
        var isDestroyed = false;
        var instance = {
          state: state,
          setOptions: function setOptions(options) {
            cleanupModifierEffects();
            state.options = Object.assign({}, defaultOptions, state.options, options);
            state.scrollParents = {
              reference: isElement(reference) ? listScrollParents(reference) : reference.contextElement ? listScrollParents(reference.contextElement) : [],
              popper: listScrollParents(popper)
            }; // Orders the modifiers based on their dependencies and `phase`
            // properties

            var orderedModifiers = orderModifiers(mergeByName([].concat(defaultModifiers, state.options.modifiers))); // Strip out disabled modifiers

            state.orderedModifiers = orderedModifiers.filter(function (m) {
              return m.enabled;
            }); // Validate the provided modifiers so that the consumer will get warned
            // if one of the modifiers is invalid for any reason

            if (process.env.NODE_ENV !== "production") {
              var modifiers = uniqueBy([].concat(orderedModifiers, state.options.modifiers), function (_ref) {
                var name = _ref.name;
                return name;
              });
              validateModifiers(modifiers);

              if (getBasePlacement(state.options.placement) === auto) {
                var flipModifier = state.orderedModifiers.find(function (_ref2) {
                  var name = _ref2.name;
                  return name === 'flip';
                });

                if (!flipModifier) {
                  console.error(['Popper: "auto" placements require the "flip" modifier be', 'present and enabled to work.'].join(' '));
                }
              }

              var _getComputedStyle = getComputedStyle(popper),
                  marginTop = _getComputedStyle.marginTop,
                  marginRight = _getComputedStyle.marginRight,
                  marginBottom = _getComputedStyle.marginBottom,
                  marginLeft = _getComputedStyle.marginLeft; // We no longer take into account `margins` on the popper, and it can
              // cause bugs with positioning, so we'll warn the consumer


              if ([marginTop, marginRight, marginBottom, marginLeft].some(function (margin) {
                return parseFloat(margin);
              })) {
                console.warn(['Popper: CSS "margin" styles cannot be used to apply padding', 'between the popper and its reference element or boundary.', 'To replicate margin, use the `offset` modifier, as well as', 'the `padding` option in the `preventOverflow` and `flip`', 'modifiers.'].join(' '));
              }
            }

            runModifierEffects();
            return instance.update();
          },
          // Sync update – it will always be executed, even if not necessary. This
          // is useful for low frequency updates where sync behavior simplifies the
          // logic.
          // For high frequency updates (e.g. `resize` and `scroll` events), always
          // prefer the async Popper#update method
          forceUpdate: function forceUpdate() {
            if (isDestroyed) {
              return;
            }

            var _state$elements = state.elements,
                reference = _state$elements.reference,
                popper = _state$elements.popper; // Don't proceed if `reference` or `popper` are not valid elements
            // anymore

            if (!areValidElements(reference, popper)) {
              if (process.env.NODE_ENV !== "production") {
                console.error(INVALID_ELEMENT_ERROR);
              }

              return;
            } // Store the reference and popper rects to be read by modifiers


            state.rects = {
              reference: getCompositeRect(reference, getOffsetParent(popper), state.options.strategy === 'fixed'),
              popper: getLayoutRect(popper)
            }; // Modifiers have the ability to reset the current update cycle. The
            // most common use case for this is the `flip` modifier changing the
            // placement, which then needs to re-run all the modifiers, because the
            // logic was previously ran for the previous placement and is therefore
            // stale/incorrect

            state.reset = false;
            state.placement = state.options.placement; // On each update cycle, the `modifiersData` property for each modifier
            // is filled with the initial data specified by the modifier. This means
            // it doesn't persist and is fresh on each update.
            // To ensure persistent data, use `${name}#persistent`

            state.orderedModifiers.forEach(function (modifier) {
              return state.modifiersData[modifier.name] = Object.assign({}, modifier.data);
            });
            var __debug_loops__ = 0;

            for (var index = 0; index < state.orderedModifiers.length; index++) {
              if (process.env.NODE_ENV !== "production") {
                __debug_loops__ += 1;

                if (__debug_loops__ > 100) {
                  console.error(INFINITE_LOOP_ERROR);
                  break;
                }
              }

              if (state.reset === true) {
                state.reset = false;
                index = -1;
                continue;
              }

              var _state$orderedModifie = state.orderedModifiers[index],
                  fn = _state$orderedModifie.fn,
                  _state$orderedModifie2 = _state$orderedModifie.options,
                  _options = _state$orderedModifie2 === void 0 ? {} : _state$orderedModifie2,
                  name = _state$orderedModifie.name;

              if (typeof fn === 'function') {
                state = fn({
                  state: state,
                  options: _options,
                  name: name,
                  instance: instance
                }) || state;
              }
            }
          },
          // Async and optimistically optimized update – it will not be executed if
          // not necessary (debounced to run at most once-per-tick)
          update: debounce(function () {
            return new Promise(function (resolve) {
              instance.forceUpdate();
              resolve(state);
            });
          }),
          destroy: function destroy() {
            cleanupModifierEffects();
            isDestroyed = true;
          }
        };

        if (!areValidElements(reference, popper)) {
          if (process.env.NODE_ENV !== "production") {
            console.error(INVALID_ELEMENT_ERROR);
          }

          return instance;
        }

        instance.setOptions(options).then(function (state) {
          if (!isDestroyed && options.onFirstUpdate) {
            options.onFirstUpdate(state);
          }
        }); // Modifiers have the ability to execute arbitrary code before the first
        // update cycle runs. They will be executed in the same order as the update
        // cycle. This is useful when a modifier adds some persistent data that
        // other modifiers need to use, but the modifier is run after the dependent
        // one.

        function runModifierEffects() {
          state.orderedModifiers.forEach(function (_ref3) {
            var name = _ref3.name,
                _ref3$options = _ref3.options,
                options = _ref3$options === void 0 ? {} : _ref3$options,
                effect = _ref3.effect;

            if (typeof effect === 'function') {
              var cleanupFn = effect({
                state: state,
                name: name,
                instance: instance,
                options: options
              });

              var noopFn = function noopFn() {};

              effectCleanupFns.push(cleanupFn || noopFn);
            }
          });
        }

        function cleanupModifierEffects() {
          effectCleanupFns.forEach(function (fn) {
            return fn();
          });
          effectCleanupFns = [];
        }

        return instance;
      };
    }

    var defaultModifiers = [eventListeners, popperOffsets$1, computeStyles$1, applyStyles$1, offset$1, flip$1, preventOverflow$1, arrow$1, hide$1];
    var createPopper = /*#__PURE__*/popperGenerator({
      defaultModifiers: defaultModifiers
    }); // eslint-disable-next-line import/no-unused-modules

    const _excluded$H = ["anchorEl", "children", "direction", "disablePortal", "modifiers", "open", "ownerState", "placement", "popperOptions", "popperRef", "TransitionProps"],
          _excluded2$3 = ["anchorEl", "children", "container", "direction", "disablePortal", "keepMounted", "modifiers", "open", "placement", "popperOptions", "popperRef", "style", "transition"];

    function flipPlacement(placement, direction) {
      if (direction === 'ltr') {
        return placement;
      }

      switch (placement) {
        case 'bottom-end':
          return 'bottom-start';

        case 'bottom-start':
          return 'bottom-end';

        case 'top-end':
          return 'top-start';

        case 'top-start':
          return 'top-end';

        default:
          return placement;
      }
    }

    function resolveAnchorEl$1(anchorEl) {
      return typeof anchorEl === 'function' ? anchorEl() : anchorEl;
    }

    const defaultPopperOptions = {};
    /* eslint-disable react/prop-types */

    const PopperTooltip = /*#__PURE__*/react.exports.forwardRef(function PopperTooltip(props, ref) {
      const {
        anchorEl,
        children,
        direction,
        disablePortal,
        modifiers,
        open,
        placement: initialPlacement,
        popperOptions,
        popperRef: popperRefProp,
        TransitionProps
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$H);

      const tooltipRef = react.exports.useRef(null);
      const ownRef = useForkRef(tooltipRef, ref);
      const popperRef = react.exports.useRef(null);
      const handlePopperRef = useForkRef(popperRef, popperRefProp);
      const handlePopperRefRef = react.exports.useRef(handlePopperRef);
      useEnhancedEffect(() => {
        handlePopperRefRef.current = handlePopperRef;
      }, [handlePopperRef]);
      react.exports.useImperativeHandle(popperRefProp, () => popperRef.current, []);
      const rtlPlacement = flipPlacement(initialPlacement, direction);
      /**
       * placement initialized from prop but can change during lifetime if modifiers.flip.
       * modifiers.flip is essentially a flip for controlled/uncontrolled behavior
       */

      const [placement, setPlacement] = react.exports.useState(rtlPlacement);
      react.exports.useEffect(() => {
        if (popperRef.current) {
          popperRef.current.forceUpdate();
        }
      });
      useEnhancedEffect(() => {
        if (!anchorEl || !open) {
          return undefined;
        }

        const handlePopperUpdate = data => {
          setPlacement(data.placement);
        };

        const resolvedAnchorEl = resolveAnchorEl$1(anchorEl);

        if (process.env.NODE_ENV !== 'production') {
          if (resolvedAnchorEl && resolvedAnchorEl.nodeType === 1) {
            const box = resolvedAnchorEl.getBoundingClientRect();

            if (process.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
              console.warn(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
            }
          }
        }

        let popperModifiers = [{
          name: 'preventOverflow',
          options: {
            altBoundary: disablePortal
          }
        }, {
          name: 'flip',
          options: {
            altBoundary: disablePortal
          }
        }, {
          name: 'onUpdate',
          enabled: true,
          phase: 'afterWrite',
          fn: ({
            state
          }) => {
            handlePopperUpdate(state);
          }
        }];

        if (modifiers != null) {
          popperModifiers = popperModifiers.concat(modifiers);
        }

        if (popperOptions && popperOptions.modifiers != null) {
          popperModifiers = popperModifiers.concat(popperOptions.modifiers);
        }

        const popper = createPopper(resolveAnchorEl$1(anchorEl), tooltipRef.current, _extends$1({
          placement: rtlPlacement
        }, popperOptions, {
          modifiers: popperModifiers
        }));
        handlePopperRefRef.current(popper);
        return () => {
          popper.destroy();
          handlePopperRefRef.current(null);
        };
      }, [anchorEl, disablePortal, modifiers, open, popperOptions, rtlPlacement]);
      const childProps = {
        placement
      };

      if (TransitionProps !== null) {
        childProps.TransitionProps = TransitionProps;
      }

      return /*#__PURE__*/jsxRuntimeExports.jsx("div", _extends$1({
        ref: ownRef,
        role: "tooltip"
      }, other, {
        children: typeof children === 'function' ? children(childProps) : children
      }));
    });
    /* eslint-enable react/prop-types */

    /**
     * Poppers rely on the 3rd party library [Popper.js](https://popper.js.org/docs/v2/) for positioning.
     */

    const PopperUnstyled = /*#__PURE__*/react.exports.forwardRef(function PopperUnstyled(props, ref) {
      const {
        anchorEl,
        children,
        container: containerProp,
        direction = 'ltr',
        disablePortal = false,
        keepMounted = false,
        modifiers,
        open,
        placement = 'bottom',
        popperOptions = defaultPopperOptions,
        popperRef,
        style,
        transition = false
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded2$3);

      const [exited, setExited] = react.exports.useState(true);

      const handleEnter = () => {
        setExited(false);
      };

      const handleExited = () => {
        setExited(true);
      };

      if (!keepMounted && !open && (!transition || exited)) {
        return null;
      } // If the container prop is provided, use that
      // If the anchorEl prop is provided, use its parent body element as the container
      // If neither are provided let the Modal take care of choosing the container


      const container = containerProp || (anchorEl ? ownerDocument(resolveAnchorEl$1(anchorEl)).body : undefined);
      return /*#__PURE__*/jsxRuntimeExports.jsx(Portal$1, {
        disablePortal: disablePortal,
        container: container,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(PopperTooltip, _extends$1({
          anchorEl: anchorEl,
          direction: direction,
          disablePortal: disablePortal,
          modifiers: modifiers,
          ref: ref,
          open: transition ? !exited : open,
          placement: placement,
          popperOptions: popperOptions,
          popperRef: popperRef
        }, other, {
          style: _extends$1({
            // Prevents scroll issue, waiting for Popper.js to add this style once initiated.
            position: 'fixed',
            // Fix Popper.js display issue
            top: 0,
            left: 0,
            display: !open && keepMounted && (!transition || exited) ? 'none' : null
          }, style),
          TransitionProps: transition ? {
            in: open,
            onEnter: handleEnter,
            onExited: handleExited
          } : null,
          children: children
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? PopperUnstyled.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * An HTML element, [virtualElement](https://popper.js.org/docs/v2/virtual-elements/),
       * or a function that returns either.
       * It's used to set the position of the popper.
       * The return value will passed as the reference object of the Popper instance.
       */
      anchorEl: chainPropTypes(propTypes.exports.oneOfType([HTMLElementType, propTypes.exports.object, propTypes.exports.func]), props => {
        if (props.open) {
          const resolvedAnchorEl = resolveAnchorEl$1(props.anchorEl);

          if (resolvedAnchorEl && resolvedAnchorEl.nodeType === 1) {
            const box = resolvedAnchorEl.getBoundingClientRect();

            if (process.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
              return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
            }
          } else if (!resolvedAnchorEl || typeof resolvedAnchorEl.getBoundingClientRect !== 'function' || resolvedAnchorEl.contextElement != null && resolvedAnchorEl.contextElement.nodeType !== 1) {
            return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'It should be an HTML element instance or a virtualElement ', '(https://popper.js.org/docs/v2/virtual-elements/).'].join('\n'));
          }
        }

        return null;
      }),

      /**
       * Popper render function or node.
       */
      children: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.node, propTypes.exports.func]),

      /**
       * An HTML element or function that returns one.
       * The `container` will have the portal children appended to it.
       *
       * By default, it uses the body of the top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * Direction of the text.
       * @default 'ltr'
       */
      direction: propTypes.exports.oneOf(['ltr', 'rtl']),

      /**
       * The `children` will be under the DOM hierarchy of the parent component.
       * @default false
       */
      disablePortal: propTypes.exports.bool,

      /**
       * Always keep the children in the DOM.
       * This prop can be useful in SEO situation or
       * when you want to maximize the responsiveness of the Popper.
       * @default false
       */
      keepMounted: propTypes.exports.bool,

      /**
       * Popper.js is based on a "plugin-like" architecture,
       * most of its features are fully encapsulated "modifiers".
       *
       * A modifier is a function that is called each time Popper.js needs to
       * compute the position of the popper.
       * For this reason, modifiers should be very performant to avoid bottlenecks.
       * To learn how to create a modifier, [read the modifiers documentation](https://popper.js.org/docs/v2/modifiers/).
       */
      modifiers: propTypes.exports.arrayOf(propTypes.exports.shape({
        data: propTypes.exports.object,
        effect: propTypes.exports.func,
        enabled: propTypes.exports.bool,
        fn: propTypes.exports.func,
        name: propTypes.exports.any,
        options: propTypes.exports.object,
        phase: propTypes.exports.oneOf(['afterMain', 'afterRead', 'afterWrite', 'beforeMain', 'beforeRead', 'beforeWrite', 'main', 'read', 'write']),
        requires: propTypes.exports.arrayOf(propTypes.exports.string),
        requiresIfExists: propTypes.exports.arrayOf(propTypes.exports.string)
      })),

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * Popper placement.
       * @default 'bottom'
       */
      placement: propTypes.exports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),

      /**
       * Options provided to the [`Popper.js`](https://popper.js.org/docs/v2/constructors/#options) instance.
       * @default {}
       */
      popperOptions: propTypes.exports.shape({
        modifiers: propTypes.exports.array,
        onFirstUpdate: propTypes.exports.func,
        placement: propTypes.exports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
        strategy: propTypes.exports.oneOf(['absolute', 'fixed'])
      }),

      /**
       * A ref that points to the used popper instance.
       */
      popperRef: refType,

      /**
       * @ignore
       */
      style: propTypes.exports.object,

      /**
       * Help supporting a react-transition-group/Transition component.
       * @default false
       */
      transition: propTypes.exports.bool
    } : void 0;
    var PopperUnstyled$1 = PopperUnstyled;

    const _excluded$G = ["onChange", "maxRows", "minRows", "style", "value"];

    function getStyleValue(computedStyle, property) {
      return parseInt(computedStyle[property], 10) || 0;
    }

    const styles$2 = {
      shadow: {
        // Visibility needed to hide the extra text area on iPads
        visibility: 'hidden',
        // Remove from the content flow
        position: 'absolute',
        // Ignore the scrollbar width
        overflow: 'hidden',
        height: 0,
        top: 0,
        left: 0,
        // Create a new layer, increase the isolation of the computed values
        transform: 'translateZ(0)'
      }
    };
    const TextareaAutosize = /*#__PURE__*/react.exports.forwardRef(function TextareaAutosize(props, ref) {
      const {
        onChange,
        maxRows,
        minRows = 1,
        style,
        value
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$G);

      const {
        current: isControlled
      } = react.exports.useRef(value != null);
      const inputRef = react.exports.useRef(null);
      const handleRef = useForkRef(ref, inputRef);
      const shadowRef = react.exports.useRef(null);
      const renders = react.exports.useRef(0);
      const [state, setState] = react.exports.useState({});
      const syncHeight = react.exports.useCallback(() => {
        const input = inputRef.current;
        const containerWindow = ownerWindow(input);
        const computedStyle = containerWindow.getComputedStyle(input); // If input's width is shrunk and it's not visible, don't sync height.

        if (computedStyle.width === '0px') {
          return;
        }

        const inputShallow = shadowRef.current;
        inputShallow.style.width = computedStyle.width;
        inputShallow.value = input.value || props.placeholder || 'x';

        if (inputShallow.value.slice(-1) === '\n') {
          // Certain fonts which overflow the line height will cause the textarea
          // to report a different scrollHeight depending on whether the last line
          // is empty. Make it non-empty to avoid this issue.
          inputShallow.value += ' ';
        }

        const boxSizing = computedStyle['box-sizing'];
        const padding = getStyleValue(computedStyle, 'padding-bottom') + getStyleValue(computedStyle, 'padding-top');
        const border = getStyleValue(computedStyle, 'border-bottom-width') + getStyleValue(computedStyle, 'border-top-width'); // The height of the inner content

        const innerHeight = inputShallow.scrollHeight; // Measure height of a textarea with a single row

        inputShallow.value = 'x';
        const singleRowHeight = inputShallow.scrollHeight; // The height of the outer content

        let outerHeight = innerHeight;

        if (minRows) {
          outerHeight = Math.max(Number(minRows) * singleRowHeight, outerHeight);
        }

        if (maxRows) {
          outerHeight = Math.min(Number(maxRows) * singleRowHeight, outerHeight);
        }

        outerHeight = Math.max(outerHeight, singleRowHeight); // Take the box sizing into account for applying this value as a style.

        const outerHeightStyle = outerHeight + (boxSizing === 'border-box' ? padding + border : 0);
        const overflow = Math.abs(outerHeight - innerHeight) <= 1;
        setState(prevState => {
          // Need a large enough difference to update the height.
          // This prevents infinite rendering loop.
          if (renders.current < 20 && (outerHeightStyle > 0 && Math.abs((prevState.outerHeightStyle || 0) - outerHeightStyle) > 1 || prevState.overflow !== overflow)) {
            renders.current += 1;
            return {
              overflow,
              outerHeightStyle
            };
          }

          if (process.env.NODE_ENV !== 'production') {
            if (renders.current === 20) {
              console.error(['MUI: Too many re-renders. The layout is unstable.', 'TextareaAutosize limits the number of renders to prevent an infinite loop.'].join('\n'));
            }
          }

          return prevState;
        });
      }, [maxRows, minRows, props.placeholder]);
      react.exports.useEffect(() => {
        const handleResize = debounce$1(() => {
          renders.current = 0;
          syncHeight();
        });
        const containerWindow = ownerWindow(inputRef.current);
        containerWindow.addEventListener('resize', handleResize);
        let resizeObserver;

        if (typeof ResizeObserver !== 'undefined') {
          resizeObserver = new ResizeObserver(handleResize);
          resizeObserver.observe(inputRef.current);
        }

        return () => {
          handleResize.clear();
          containerWindow.removeEventListener('resize', handleResize);

          if (resizeObserver) {
            resizeObserver.disconnect();
          }
        };
      }, [syncHeight]);
      useEnhancedEffect(() => {
        syncHeight();
      });
      react.exports.useEffect(() => {
        renders.current = 0;
      }, [value]);

      const handleChange = event => {
        renders.current = 0;

        if (!isControlled) {
          syncHeight();
        }

        if (onChange) {
          onChange(event);
        }
      };

      return /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
        children: [/*#__PURE__*/jsxRuntimeExports.jsx("textarea", _extends$1({
          value: value,
          onChange: handleChange,
          ref: handleRef // Apply the rows prop to get a "correct" first SSR paint
          ,
          rows: minRows,
          style: _extends$1({
            height: state.outerHeightStyle,
            // Need a large enough difference to allow scrolling.
            // This prevents infinite rendering loop.
            overflow: state.overflow ? 'hidden' : null
          }, style)
        }, other)), /*#__PURE__*/jsxRuntimeExports.jsx("textarea", {
          "aria-hidden": true,
          className: props.className,
          readOnly: true,
          ref: shadowRef,
          tabIndex: -1,
          style: _extends$1({}, styles$2.shadow, style, {
            padding: 0
          })
        })]
      });
    });
    process.env.NODE_ENV !== "production" ? TextareaAutosize.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * Maximum number of rows to display.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display.
       * @default 1
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * @ignore
       */
      onChange: propTypes.exports.func,

      /**
       * @ignore
       */
      placeholder: propTypes.exports.string,

      /**
       * @ignore
       */
      style: propTypes.exports.object,

      /**
       * @ignore
       */
      value: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.string), propTypes.exports.number, propTypes.exports.string])
    } : void 0;
    var TextareaAutosize$1 = TextareaAutosize;

    function createMixins(breakpoints, spacing, mixins) {
      return _extends$1({
        toolbar: {
          minHeight: 56,
          [`${breakpoints.up('xs')} and (orientation: landscape)`]: {
            minHeight: 48
          },
          [breakpoints.up('sm')]: {
            minHeight: 64
          }
        }
      }, mixins);
    }

    const _excluded$F = ["mode", "contrastThreshold", "tonalOffset"];
    const light = {
      // The colors used to style the text.
      text: {
        // The most important text.
        primary: 'rgba(0, 0, 0, 0.87)',
        // Secondary text.
        secondary: 'rgba(0, 0, 0, 0.6)',
        // Disabled text have even lower visual prominence.
        disabled: 'rgba(0, 0, 0, 0.38)'
      },
      // The color used to divide different elements.
      divider: 'rgba(0, 0, 0, 0.12)',
      // The background colors used to style the surfaces.
      // Consistency between these values is important.
      background: {
        paper: common$1.white,
        default: common$1.white
      },
      // The colors used to style the action elements.
      action: {
        // The color of an active action like an icon button.
        active: 'rgba(0, 0, 0, 0.54)',
        // The color of an hovered action.
        hover: 'rgba(0, 0, 0, 0.04)',
        hoverOpacity: 0.04,
        // The color of a selected action.
        selected: 'rgba(0, 0, 0, 0.08)',
        selectedOpacity: 0.08,
        // The color of a disabled action.
        disabled: 'rgba(0, 0, 0, 0.26)',
        // The background color of a disabled action.
        disabledBackground: 'rgba(0, 0, 0, 0.12)',
        disabledOpacity: 0.38,
        focus: 'rgba(0, 0, 0, 0.12)',
        focusOpacity: 0.12,
        activatedOpacity: 0.12
      }
    };
    const dark = {
      text: {
        primary: common$1.white,
        secondary: 'rgba(255, 255, 255, 0.7)',
        disabled: 'rgba(255, 255, 255, 0.5)',
        icon: 'rgba(255, 255, 255, 0.5)'
      },
      divider: 'rgba(255, 255, 255, 0.12)',
      background: {
        paper: '#121212',
        default: '#121212'
      },
      action: {
        active: common$1.white,
        hover: 'rgba(255, 255, 255, 0.08)',
        hoverOpacity: 0.08,
        selected: 'rgba(255, 255, 255, 0.16)',
        selectedOpacity: 0.16,
        disabled: 'rgba(255, 255, 255, 0.3)',
        disabledBackground: 'rgba(255, 255, 255, 0.12)',
        disabledOpacity: 0.38,
        focus: 'rgba(255, 255, 255, 0.12)',
        focusOpacity: 0.12,
        activatedOpacity: 0.24
      }
    };

    function addLightOrDark(intent, direction, shade, tonalOffset) {
      const tonalOffsetLight = tonalOffset.light || tonalOffset;
      const tonalOffsetDark = tonalOffset.dark || tonalOffset * 1.5;

      if (!intent[direction]) {
        if (intent.hasOwnProperty(shade)) {
          intent[direction] = intent[shade];
        } else if (direction === 'light') {
          intent.light = lighten(intent.main, tonalOffsetLight);
        } else if (direction === 'dark') {
          intent.dark = darken(intent.main, tonalOffsetDark);
        }
      }
    }

    function getDefaultPrimary(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: blue$1[200],
          light: blue$1[50],
          dark: blue$1[400]
        };
      }

      return {
        main: blue$1[700],
        light: blue$1[400],
        dark: blue$1[800]
      };
    }

    function getDefaultSecondary(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: purple$1[200],
          light: purple$1[50],
          dark: purple$1[400]
        };
      }

      return {
        main: purple$1[500],
        light: purple$1[300],
        dark: purple$1[700]
      };
    }

    function getDefaultError(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: red$1[500],
          light: red$1[300],
          dark: red$1[700]
        };
      }

      return {
        main: red$1[700],
        light: red$1[400],
        dark: red$1[800]
      };
    }

    function getDefaultInfo(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: lightBlue$1[400],
          light: lightBlue$1[300],
          dark: lightBlue$1[700]
        };
      }

      return {
        main: lightBlue$1[700],
        light: lightBlue$1[500],
        dark: lightBlue$1[900]
      };
    }

    function getDefaultSuccess(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: green$1[400],
          light: green$1[300],
          dark: green$1[700]
        };
      }

      return {
        main: green$1[800],
        light: green$1[500],
        dark: green$1[900]
      };
    }

    function getDefaultWarning(mode = 'light') {
      if (mode === 'dark') {
        return {
          main: orange$1[400],
          light: orange$1[300],
          dark: orange$1[700]
        };
      }

      return {
        main: '#ed6c02',
        // closest to orange[800] that pass 3:1.
        light: orange$1[500],
        dark: orange$1[900]
      };
    }

    function createPalette(palette) {
      const {
        mode = 'light',
        contrastThreshold = 3,
        tonalOffset = 0.2
      } = palette,
            other = _objectWithoutPropertiesLoose(palette, _excluded$F);

      const primary = palette.primary || getDefaultPrimary(mode);
      const secondary = palette.secondary || getDefaultSecondary(mode);
      const error = palette.error || getDefaultError(mode);
      const info = palette.info || getDefaultInfo(mode);
      const success = palette.success || getDefaultSuccess(mode);
      const warning = palette.warning || getDefaultWarning(mode); // Use the same logic as
      // Bootstrap: https://github.com/twbs/bootstrap/blob/1d6e3710dd447de1a200f29e8fa521f8a0908f70/scss/_functions.scss#L59
      // and material-components-web https://github.com/material-components/material-components-web/blob/ac46b8863c4dab9fc22c4c662dc6bd1b65dd652f/packages/mdc-theme/_functions.scss#L54

      function getContrastText(background) {
        const contrastText = getContrastRatio(background, dark.text.primary) >= contrastThreshold ? dark.text.primary : light.text.primary;

        if (process.env.NODE_ENV !== 'production') {
          const contrast = getContrastRatio(background, contrastText);

          if (contrast < 3) {
            console.error([`MUI: The contrast ratio of ${contrast}:1 for ${contrastText} on ${background}`, 'falls below the WCAG recommended absolute minimum contrast ratio of 3:1.', 'https://www.w3.org/TR/2008/REC-WCAG20-20081211/#visual-audio-contrast-contrast'].join('\n'));
          }
        }

        return contrastText;
      }

      const augmentColor = ({
        color,
        name,
        mainShade = 500,
        lightShade = 300,
        darkShade = 700
      }) => {
        color = _extends$1({}, color);

        if (!color.main && color[mainShade]) {
          color.main = color[mainShade];
        }

        if (!color.hasOwnProperty('main')) {
          throw new Error(process.env.NODE_ENV !== "production" ? `MUI: The color${name ? ` (${name})` : ''} provided to augmentColor(color) is invalid.
The color object needs to have a \`main\` property or a \`${mainShade}\` property.` : formatMuiErrorMessage(11, name ? ` (${name})` : '', mainShade));
        }

        if (typeof color.main !== 'string') {
          throw new Error(process.env.NODE_ENV !== "production" ? `MUI: The color${name ? ` (${name})` : ''} provided to augmentColor(color) is invalid.
\`color.main\` should be a string, but \`${JSON.stringify(color.main)}\` was provided instead.

Did you intend to use one of the following approaches?

import { green } from "@mui/material/colors";

const theme1 = createTheme({ palette: {
  primary: green,
} });

const theme2 = createTheme({ palette: {
  primary: { main: green[500] },
} });` : formatMuiErrorMessage(12, name ? ` (${name})` : '', JSON.stringify(color.main)));
        }

        addLightOrDark(color, 'light', lightShade, tonalOffset);
        addLightOrDark(color, 'dark', darkShade, tonalOffset);

        if (!color.contrastText) {
          color.contrastText = getContrastText(color.main);
        }

        return color;
      };

      const modes = {
        dark,
        light
      };

      if (process.env.NODE_ENV !== 'production') {
        if (!modes[mode]) {
          console.error(`MUI: The palette mode \`${mode}\` is not supported.`);
        }
      }

      const paletteOutput = deepmerge(_extends$1({
        // A collection of common colors.
        common: common$1,
        // The palette mode, can be light or dark.
        mode,
        // The colors used to represent primary interface elements for a user.
        primary: augmentColor({
          color: primary,
          name: 'primary'
        }),
        // The colors used to represent secondary interface elements for a user.
        secondary: augmentColor({
          color: secondary,
          name: 'secondary',
          mainShade: 'A400',
          lightShade: 'A200',
          darkShade: 'A700'
        }),
        // The colors used to represent interface elements that the user should be made aware of.
        error: augmentColor({
          color: error,
          name: 'error'
        }),
        // The colors used to represent potentially dangerous actions or important messages.
        warning: augmentColor({
          color: warning,
          name: 'warning'
        }),
        // The colors used to present information to the user that is neutral and not necessarily important.
        info: augmentColor({
          color: info,
          name: 'info'
        }),
        // The colors used to indicate the successful completion of an action that user triggered.
        success: augmentColor({
          color: success,
          name: 'success'
        }),
        // The grey colors.
        grey: grey$1,
        // Used by `getContrastText()` to maximize the contrast between
        // the background and the text.
        contrastThreshold,
        // Takes a background color and returns the text color that maximizes the contrast.
        getContrastText,
        // Generate a rich color object.
        augmentColor,
        // Used by the functions below to shift a color's luminance by approximately
        // two indexes within its tonal palette.
        // E.g., shift from Red 500 to Red 300 or Red 700.
        tonalOffset
      }, modes[mode]), other);
      return paletteOutput;
    }

    const _excluded$E = ["fontFamily", "fontSize", "fontWeightLight", "fontWeightRegular", "fontWeightMedium", "fontWeightBold", "htmlFontSize", "allVariants", "pxToRem"];

    function round(value) {
      return Math.round(value * 1e5) / 1e5;
    }

    const caseAllCaps = {
      textTransform: 'uppercase'
    };
    const defaultFontFamily = '"Roboto", "Helvetica", "Arial", sans-serif';
    /**
     * @see @link{https://material.io/design/typography/the-type-system.html}
     * @see @link{https://material.io/design/typography/understanding-typography.html}
     */

    function createTypography(palette, typography) {
      const _ref = typeof typography === 'function' ? typography(palette) : typography,
            {
        fontFamily = defaultFontFamily,
        // The default font size of the Material Specification.
        fontSize = 14,
        // px
        fontWeightLight = 300,
        fontWeightRegular = 400,
        fontWeightMedium = 500,
        fontWeightBold = 700,
        // Tell MUI what's the font-size on the html element.
        // 16px is the default font-size used by browsers.
        htmlFontSize = 16,
        // Apply the CSS properties to all the variants.
        allVariants,
        pxToRem: pxToRem2
      } = _ref,
            other = _objectWithoutPropertiesLoose(_ref, _excluded$E);

      if (process.env.NODE_ENV !== 'production') {
        if (typeof fontSize !== 'number') {
          console.error('MUI: `fontSize` is required to be a number.');
        }

        if (typeof htmlFontSize !== 'number') {
          console.error('MUI: `htmlFontSize` is required to be a number.');
        }
      }

      const coef = fontSize / 14;

      const pxToRem = pxToRem2 || (size => `${size / htmlFontSize * coef}rem`);

      const buildVariant = (fontWeight, size, lineHeight, letterSpacing, casing) => _extends$1({
        fontFamily,
        fontWeight,
        fontSize: pxToRem(size),
        // Unitless following https://meyerweb.com/eric/thoughts/2006/02/08/unitless-line-heights/
        lineHeight
      }, fontFamily === defaultFontFamily ? {
        letterSpacing: `${round(letterSpacing / size)}em`
      } : {}, casing, allVariants);

      const variants = {
        h1: buildVariant(fontWeightLight, 96, 1.167, -1.5),
        h2: buildVariant(fontWeightLight, 60, 1.2, -0.5),
        h3: buildVariant(fontWeightRegular, 48, 1.167, 0),
        h4: buildVariant(fontWeightRegular, 34, 1.235, 0.25),
        h5: buildVariant(fontWeightRegular, 24, 1.334, 0),
        h6: buildVariant(fontWeightMedium, 20, 1.6, 0.15),
        subtitle1: buildVariant(fontWeightRegular, 16, 1.75, 0.15),
        subtitle2: buildVariant(fontWeightMedium, 14, 1.57, 0.1),
        body1: buildVariant(fontWeightRegular, 16, 1.5, 0.15),
        body2: buildVariant(fontWeightRegular, 14, 1.43, 0.15),
        button: buildVariant(fontWeightMedium, 14, 1.75, 0.4, caseAllCaps),
        caption: buildVariant(fontWeightRegular, 12, 1.66, 0.4),
        overline: buildVariant(fontWeightRegular, 12, 2.66, 1, caseAllCaps)
      };
      return deepmerge(_extends$1({
        htmlFontSize,
        pxToRem,
        fontFamily,
        fontSize,
        fontWeightLight,
        fontWeightRegular,
        fontWeightMedium,
        fontWeightBold
      }, variants), other, {
        clone: false // No need to clone deep

      });
    }

    const shadowKeyUmbraOpacity = 0.2;
    const shadowKeyPenumbraOpacity = 0.14;
    const shadowAmbientShadowOpacity = 0.12;

    function createShadow(...px) {
      return [`${px[0]}px ${px[1]}px ${px[2]}px ${px[3]}px rgba(0,0,0,${shadowKeyUmbraOpacity})`, `${px[4]}px ${px[5]}px ${px[6]}px ${px[7]}px rgba(0,0,0,${shadowKeyPenumbraOpacity})`, `${px[8]}px ${px[9]}px ${px[10]}px ${px[11]}px rgba(0,0,0,${shadowAmbientShadowOpacity})`].join(',');
    } // Values from https://github.com/material-components/material-components-web/blob/be8747f94574669cb5e7add1a7c54fa41a89cec7/packages/mdc-elevation/_variables.scss


    const shadows = ['none', createShadow(0, 2, 1, -1, 0, 1, 1, 0, 0, 1, 3, 0), createShadow(0, 3, 1, -2, 0, 2, 2, 0, 0, 1, 5, 0), createShadow(0, 3, 3, -2, 0, 3, 4, 0, 0, 1, 8, 0), createShadow(0, 2, 4, -1, 0, 4, 5, 0, 0, 1, 10, 0), createShadow(0, 3, 5, -1, 0, 5, 8, 0, 0, 1, 14, 0), createShadow(0, 3, 5, -1, 0, 6, 10, 0, 0, 1, 18, 0), createShadow(0, 4, 5, -2, 0, 7, 10, 1, 0, 2, 16, 1), createShadow(0, 5, 5, -3, 0, 8, 10, 1, 0, 3, 14, 2), createShadow(0, 5, 6, -3, 0, 9, 12, 1, 0, 3, 16, 2), createShadow(0, 6, 6, -3, 0, 10, 14, 1, 0, 4, 18, 3), createShadow(0, 6, 7, -4, 0, 11, 15, 1, 0, 4, 20, 3), createShadow(0, 7, 8, -4, 0, 12, 17, 2, 0, 5, 22, 4), createShadow(0, 7, 8, -4, 0, 13, 19, 2, 0, 5, 24, 4), createShadow(0, 7, 9, -4, 0, 14, 21, 2, 0, 5, 26, 4), createShadow(0, 8, 9, -5, 0, 15, 22, 2, 0, 6, 28, 5), createShadow(0, 8, 10, -5, 0, 16, 24, 2, 0, 6, 30, 5), createShadow(0, 8, 11, -5, 0, 17, 26, 2, 0, 6, 32, 5), createShadow(0, 9, 11, -5, 0, 18, 28, 2, 0, 7, 34, 6), createShadow(0, 9, 12, -6, 0, 19, 29, 2, 0, 7, 36, 6), createShadow(0, 10, 13, -6, 0, 20, 31, 3, 0, 8, 38, 7), createShadow(0, 10, 13, -6, 0, 21, 33, 3, 0, 8, 40, 7), createShadow(0, 10, 14, -6, 0, 22, 35, 3, 0, 8, 42, 7), createShadow(0, 11, 14, -7, 0, 23, 36, 3, 0, 9, 44, 8), createShadow(0, 11, 15, -7, 0, 24, 38, 3, 0, 9, 46, 8)];
    var shadows$1 = shadows;

    const _excluded$D = ["duration", "easing", "delay"];
    // Follow https://material.google.com/motion/duration-easing.html#duration-easing-natural-easing-curves
    // to learn the context in which each easing should be used.
    const easing = {
      // This is the most common easing curve.
      easeInOut: 'cubic-bezier(0.4, 0, 0.2, 1)',
      // Objects enter the screen at full velocity from off-screen and
      // slowly decelerate to a resting point.
      easeOut: 'cubic-bezier(0.0, 0, 0.2, 1)',
      // Objects leave the screen at full velocity. They do not decelerate when off-screen.
      easeIn: 'cubic-bezier(0.4, 0, 1, 1)',
      // The sharp curve is used by objects that may return to the screen at any time.
      sharp: 'cubic-bezier(0.4, 0, 0.6, 1)'
    }; // Follow https://material.io/guidelines/motion/duration-easing.html#duration-easing-common-durations
    // to learn when use what timing

    const duration = {
      shortest: 150,
      shorter: 200,
      short: 250,
      // most basic recommended timing
      standard: 300,
      // this is to be used in complex animations
      complex: 375,
      // recommended when something is entering screen
      enteringScreen: 225,
      // recommended when something is leaving screen
      leavingScreen: 195
    };

    function formatMs(milliseconds) {
      return `${Math.round(milliseconds)}ms`;
    }

    function getAutoHeightDuration(height) {
      if (!height) {
        return 0;
      }

      const constant = height / 36; // https://www.wolframalpha.com/input/?i=(4+%2B+15+*+(x+%2F+36+)+**+0.25+%2B+(x+%2F+36)+%2F+5)+*+10

      return Math.round((4 + 15 * constant ** 0.25 + constant / 5) * 10);
    }

    function createTransitions(inputTransitions) {
      const mergedEasing = _extends$1({}, easing, inputTransitions.easing);

      const mergedDuration = _extends$1({}, duration, inputTransitions.duration);

      const create = (props = ['all'], options = {}) => {
        const {
          duration: durationOption = mergedDuration.standard,
          easing: easingOption = mergedEasing.easeInOut,
          delay = 0
        } = options,
              other = _objectWithoutPropertiesLoose(options, _excluded$D);

        if (process.env.NODE_ENV !== 'production') {
          const isString = value => typeof value === 'string'; // IE11 support, replace with Number.isNaN
          // eslint-disable-next-line no-restricted-globals


          const isNumber = value => !isNaN(parseFloat(value));

          if (!isString(props) && !Array.isArray(props)) {
            console.error('MUI: Argument "props" must be a string or Array.');
          }

          if (!isNumber(durationOption) && !isString(durationOption)) {
            console.error(`MUI: Argument "duration" must be a number or a string but found ${durationOption}.`);
          }

          if (!isString(easingOption)) {
            console.error('MUI: Argument "easing" must be a string.');
          }

          if (!isNumber(delay) && !isString(delay)) {
            console.error('MUI: Argument "delay" must be a number or a string.');
          }

          if (Object.keys(other).length !== 0) {
            console.error(`MUI: Unrecognized argument(s) [${Object.keys(other).join(',')}].`);
          }
        }

        return (Array.isArray(props) ? props : [props]).map(animatedProp => `${animatedProp} ${typeof durationOption === 'string' ? durationOption : formatMs(durationOption)} ${easingOption} ${typeof delay === 'string' ? delay : formatMs(delay)}`).join(',');
      };

      return _extends$1({
        getAutoHeightDuration,
        create
      }, inputTransitions, {
        easing: mergedEasing,
        duration: mergedDuration
      });
    }

    // We need to centralize the zIndex definitions as they work
    // like global values in the browser.
    const zIndex = {
      mobileStepper: 1000,
      speedDial: 1050,
      appBar: 1100,
      drawer: 1200,
      modal: 1300,
      snackbar: 1400,
      tooltip: 1500
    };
    var zIndex$1 = zIndex;

    const _excluded$C = ["breakpoints", "mixins", "spacing", "palette", "transitions", "typography", "shape"];

    function createTheme(options = {}, ...args) {
      const {
        mixins: mixinsInput = {},
        palette: paletteInput = {},
        transitions: transitionsInput = {},
        typography: typographyInput = {}
      } = options,
            other = _objectWithoutPropertiesLoose(options, _excluded$C);

      const palette = createPalette(paletteInput);
      const systemTheme = createTheme$1(options);
      let muiTheme = deepmerge(systemTheme, {
        mixins: createMixins(systemTheme.breakpoints, systemTheme.spacing, mixinsInput),
        palette,
        // Don't use [...shadows] until you've verified its transpiled code is not invoking the iterator protocol.
        shadows: shadows$1.slice(),
        typography: createTypography(palette, typographyInput),
        transitions: createTransitions(transitionsInput),
        zIndex: _extends$1({}, zIndex$1)
      });
      muiTheme = deepmerge(muiTheme, other);
      muiTheme = args.reduce((acc, argument) => deepmerge(acc, argument), muiTheme);

      if (process.env.NODE_ENV !== 'production') {
        const stateClasses = ['active', 'checked', 'completed', 'disabled', 'error', 'expanded', 'focused', 'focusVisible', 'required', 'selected'];

        const traverse = (node, component) => {
          let key; // eslint-disable-next-line guard-for-in, no-restricted-syntax

          for (key in node) {
            const child = node[key];

            if (stateClasses.indexOf(key) !== -1 && Object.keys(child).length > 0) {
              if (process.env.NODE_ENV !== 'production') {
                const stateClass = generateUtilityClass('', key);
                console.error([`MUI: The \`${component}\` component increases ` + `the CSS specificity of the \`${key}\` internal state.`, 'You can not override it like this: ', JSON.stringify(node, null, 2), '', `Instead, you need to use the '&.${stateClass}' syntax:`, JSON.stringify({
                  root: {
                    [`&.${stateClass}`]: child
                  }
                }, null, 2), '', 'https://mui.com/r/state-classes-guide'].join('\n'));
              } // Remove the style to prevent global conflicts.


              node[key] = {};
            }
          }
        };

        Object.keys(muiTheme.components).forEach(component => {
          const styleOverrides = muiTheme.components[component].styleOverrides;

          if (styleOverrides && component.indexOf('Mui') === 0) {
            traverse(styleOverrides, component);
          }
        });
      }

      return muiTheme;
    }

    const defaultTheme$1 = createTheme();

    function useTheme() {
      const theme = useTheme$1(defaultTheme$1);

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        react.exports.useDebugValue(theme);
      }

      return theme;
    }

    function useThemeProps({
      props,
      name
    }) {
      return useThemeProps$1({
        props,
        name,
        defaultTheme: defaultTheme$1
      });
    }

    const rootShouldForwardProp = prop => shouldForwardProp(prop) && prop !== 'classes';
    const slotShouldForwardProp = shouldForwardProp;
    const styled = createStyled({
      defaultTheme: defaultTheme$1,
      rootShouldForwardProp
    });
    var styled$1 = styled;

    function getSvgIconUtilityClass(slot) {
      return generateUtilityClass('MuiSvgIcon', slot);
    }
    generateUtilityClasses('MuiSvgIcon', ['root', 'colorPrimary', 'colorSecondary', 'colorAction', 'colorError', 'colorDisabled', 'fontSizeInherit', 'fontSizeSmall', 'fontSizeMedium', 'fontSizeLarge']);

    const _excluded$B = ["children", "className", "color", "component", "fontSize", "htmlColor", "inheritViewBox", "titleAccess", "viewBox"];

    const useUtilityClasses$t = ownerState => {
      const {
        color,
        fontSize,
        classes
      } = ownerState;
      const slots = {
        root: ['root', color !== 'inherit' && `color${capitalize(color)}`, `fontSize${capitalize(fontSize)}`]
      };
      return composeClasses(slots, getSvgIconUtilityClass, classes);
    };

    const SvgIconRoot = styled$1('svg', {
      name: 'MuiSvgIcon',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.color !== 'inherit' && styles[`color${capitalize(ownerState.color)}`], styles[`fontSize${capitalize(ownerState.fontSize)}`]];
      }
    })(({
      theme,
      ownerState
    }) => {
      var _theme$transitions, _theme$transitions$cr, _theme$transitions2, _theme$transitions2$d, _theme$typography, _theme$typography$pxT, _theme$typography2, _theme$typography2$px, _theme$typography3, _theme$typography3$px, _theme$palette$ownerS, _theme$palette, _theme$palette$ownerS2, _theme$palette2, _theme$palette2$actio, _theme$palette3, _theme$palette3$actio;

      return {
        userSelect: 'none',
        width: '1em',
        height: '1em',
        display: 'inline-block',
        fill: 'currentColor',
        flexShrink: 0,
        transition: (_theme$transitions = theme.transitions) == null ? void 0 : (_theme$transitions$cr = _theme$transitions.create) == null ? void 0 : _theme$transitions$cr.call(_theme$transitions, 'fill', {
          duration: (_theme$transitions2 = theme.transitions) == null ? void 0 : (_theme$transitions2$d = _theme$transitions2.duration) == null ? void 0 : _theme$transitions2$d.shorter
        }),
        fontSize: {
          inherit: 'inherit',
          small: ((_theme$typography = theme.typography) == null ? void 0 : (_theme$typography$pxT = _theme$typography.pxToRem) == null ? void 0 : _theme$typography$pxT.call(_theme$typography, 20)) || '1.25rem',
          medium: ((_theme$typography2 = theme.typography) == null ? void 0 : (_theme$typography2$px = _theme$typography2.pxToRem) == null ? void 0 : _theme$typography2$px.call(_theme$typography2, 24)) || '1.5rem',
          large: ((_theme$typography3 = theme.typography) == null ? void 0 : (_theme$typography3$px = _theme$typography3.pxToRem) == null ? void 0 : _theme$typography3$px.call(_theme$typography3, 35)) || '2.1875'
        }[ownerState.fontSize],
        // TODO v5 deprecate, v6 remove for sx
        color: (_theme$palette$ownerS = (_theme$palette = theme.palette) == null ? void 0 : (_theme$palette$ownerS2 = _theme$palette[ownerState.color]) == null ? void 0 : _theme$palette$ownerS2.main) != null ? _theme$palette$ownerS : {
          action: (_theme$palette2 = theme.palette) == null ? void 0 : (_theme$palette2$actio = _theme$palette2.action) == null ? void 0 : _theme$palette2$actio.active,
          disabled: (_theme$palette3 = theme.palette) == null ? void 0 : (_theme$palette3$actio = _theme$palette3.action) == null ? void 0 : _theme$palette3$actio.disabled,
          inherit: undefined
        }[ownerState.color]
      };
    });
    const SvgIcon = /*#__PURE__*/react.exports.forwardRef(function SvgIcon(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiSvgIcon'
      });

      const {
        children,
        className,
        color = 'inherit',
        component = 'svg',
        fontSize = 'medium',
        htmlColor,
        inheritViewBox = false,
        titleAccess,
        viewBox = '0 0 24 24'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$B);

      const ownerState = _extends$1({}, props, {
        color,
        component,
        fontSize,
        inheritViewBox,
        viewBox
      });

      const more = {};

      if (!inheritViewBox) {
        more.viewBox = viewBox;
      }

      const classes = useUtilityClasses$t(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(SvgIconRoot, _extends$1({
        as: component,
        className: clsx(classes.root, className),
        ownerState: ownerState,
        focusable: "false",
        color: htmlColor,
        "aria-hidden": titleAccess ? undefined : true,
        role: titleAccess ? 'img' : undefined,
        ref: ref
      }, more, other, {
        children: [children, titleAccess ? /*#__PURE__*/jsxRuntimeExports.jsx("title", {
          children: titleAccess
        }) : null]
      }));
    });
    process.env.NODE_ENV !== "production" ? SvgIcon.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Node passed into the SVG element.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * You can use the `htmlColor` prop to apply a color attribute to the SVG element.
       * @default 'inherit'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['inherit', 'action', 'disabled', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * The fontSize applied to the icon. Defaults to 24px, but can be configure to inherit font size.
       * @default 'medium'
       */
      fontSize: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['inherit', 'large', 'medium', 'small']), propTypes.exports.string]),

      /**
       * Applies a color attribute to the SVG element.
       */
      htmlColor: propTypes.exports.string,

      /**
       * If `true`, the root node will inherit the custom `component`'s viewBox and the `viewBox`
       * prop will be ignored.
       * Useful when you want to reference a custom `component` and have `SvgIcon` pass that
       * `component`'s viewBox to the root node.
       * @default false
       */
      inheritViewBox: propTypes.exports.bool,

      /**
       * The shape-rendering attribute. The behavior of the different options is described on the
       * [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/shape-rendering).
       * If you are having issues with blurry icons you should investigate this prop.
       */
      shapeRendering: propTypes.exports.string,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Provides a human-readable title for the element that contains it.
       * https://www.w3.org/TR/SVG-access/#Equivalent
       */
      titleAccess: propTypes.exports.string,

      /**
       * Allows you to redefine what the coordinates without units mean inside an SVG element.
       * For example, if the SVG element is 500 (width) by 200 (height),
       * and you pass viewBox="0 0 50 20",
       * this means that the coordinates inside the SVG will go from the top left corner (0,0)
       * to bottom right (50,20) and each unit will be worth 10px.
       * @default '0 0 24 24'
       */
      viewBox: propTypes.exports.string
    } : void 0;
    SvgIcon.muiName = 'SvgIcon';
    var SvgIcon$1 = SvgIcon;

    function createSvgIcon$1(path, displayName) {
      const Component = (props, ref) => /*#__PURE__*/jsxRuntimeExports.jsx(SvgIcon$1, _extends$1({
        "data-testid": `${displayName}Icon`,
        ref: ref
      }, props, {
        children: path
      }));

      if (process.env.NODE_ENV !== 'production') {
        // Need to set `displayName` on the inner component for React.memo.
        // React prior to 16.14 ignores `displayName` on the wrapper.
        Component.displayName = `${displayName}Icon`;
      }

      Component.muiName = SvgIcon$1.muiName;
      return /*#__PURE__*/react.exports.memo( /*#__PURE__*/react.exports.forwardRef(Component));
    }

    var utils = /*#__PURE__*/Object.freeze({
        __proto__: null,
        capitalize: capitalize,
        createChainedFunction: createChainedFunction,
        createSvgIcon: createSvgIcon$1,
        debounce: debounce$1,
        deprecatedPropType: deprecatedPropType,
        isMuiElement: isMuiElement,
        ownerDocument: ownerDocument,
        ownerWindow: ownerWindow,
        requirePropFactory: requirePropFactory,
        setRef: setRef,
        unstable_useEnhancedEffect: useEnhancedEffect,
        unstable_useId: useId,
        unsupportedProp: unsupportedProp,
        useControlled: useControlled,
        useEventCallback: useEventCallback,
        useForkRef: useForkRef,
        useIsFocusVisible: useIsFocusVisible,
        unstable_ClassNameGenerator: ClassNameGenerator$1
    });

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype);
      subClass.prototype.constructor = subClass;
      _setPrototypeOf(subClass, superClass);
    }

    /**
     * Checks if a given element has a CSS class.
     * 
     * @param element the element
     * @param className the CSS class name
     */
    function hasClass(element, className) {
      if (element.classList) return !!className && element.classList.contains(className);
      return (" " + (element.className.baseVal || element.className) + " ").indexOf(" " + className + " ") !== -1;
    }

    /**
     * Adds a CSS class to a given element.
     * 
     * @param element the element
     * @param className the CSS class name
     */

    function addClass(element, className) {
      if (element.classList) element.classList.add(className);else if (!hasClass(element, className)) if (typeof element.className === 'string') element.className = element.className + " " + className;else element.setAttribute('class', (element.className && element.className.baseVal || '') + " " + className);
    }

    function replaceClassName(origClass, classToRemove) {
      return origClass.replace(new RegExp("(^|\\s)" + classToRemove + "(?:\\s|$)", 'g'), '$1').replace(/\s+/g, ' ').replace(/^\s*|\s*$/g, '');
    }
    /**
     * Removes a CSS class from a given element.
     * 
     * @param element the element
     * @param className the CSS class name
     */


    function removeClass$1(element, className) {
      if (element.classList) {
        element.classList.remove(className);
      } else if (typeof element.className === 'string') {
        element.className = replaceClassName(element.className, className);
      } else {
        element.setAttribute('class', replaceClassName(element.className && element.className.baseVal || '', className));
      }
    }

    var config = {
      disabled: false
    };

    var timeoutsShape = process.env.NODE_ENV !== 'production' ? propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.shape({
      enter: propTypes.exports.number,
      exit: propTypes.exports.number,
      appear: propTypes.exports.number
    }).isRequired]) : null;
    var classNamesShape = process.env.NODE_ENV !== 'production' ? propTypes.exports.oneOfType([propTypes.exports.string, propTypes.exports.shape({
      enter: propTypes.exports.string,
      exit: propTypes.exports.string,
      active: propTypes.exports.string
    }), propTypes.exports.shape({
      enter: propTypes.exports.string,
      enterDone: propTypes.exports.string,
      enterActive: propTypes.exports.string,
      exit: propTypes.exports.string,
      exitDone: propTypes.exports.string,
      exitActive: propTypes.exports.string
    })]) : null;

    var TransitionGroupContext = React.createContext(null);

    var UNMOUNTED = 'unmounted';
    var EXITED = 'exited';
    var ENTERING = 'entering';
    var ENTERED = 'entered';
    var EXITING = 'exiting';
    /**
     * The Transition component lets you describe a transition from one component
     * state to another _over time_ with a simple declarative API. Most commonly
     * it's used to animate the mounting and unmounting of a component, but can also
     * be used to describe in-place transition states as well.
     *
     * ---
     *
     * **Note**: `Transition` is a platform-agnostic base component. If you're using
     * transitions in CSS, you'll probably want to use
     * [`CSSTransition`](https://reactcommunity.org/react-transition-group/css-transition)
     * instead. It inherits all the features of `Transition`, but contains
     * additional features necessary to play nice with CSS transitions (hence the
     * name of the component).
     *
     * ---
     *
     * By default the `Transition` component does not alter the behavior of the
     * component it renders, it only tracks "enter" and "exit" states for the
     * components. It's up to you to give meaning and effect to those states. For
     * example we can add styles to a component when it enters or exits:
     *
     * ```jsx
     * import { Transition } from 'react-transition-group';
     *
     * const duration = 300;
     *
     * const defaultStyle = {
     *   transition: `opacity ${duration}ms ease-in-out`,
     *   opacity: 0,
     * }
     *
     * const transitionStyles = {
     *   entering: { opacity: 1 },
     *   entered:  { opacity: 1 },
     *   exiting:  { opacity: 0 },
     *   exited:  { opacity: 0 },
     * };
     *
     * const Fade = ({ in: inProp }) => (
     *   <Transition in={inProp} timeout={duration}>
     *     {state => (
     *       <div style={{
     *         ...defaultStyle,
     *         ...transitionStyles[state]
     *       }}>
     *         I'm a fade Transition!
     *       </div>
     *     )}
     *   </Transition>
     * );
     * ```
     *
     * There are 4 main states a Transition can be in:
     *  - `'entering'`
     *  - `'entered'`
     *  - `'exiting'`
     *  - `'exited'`
     *
     * Transition state is toggled via the `in` prop. When `true` the component
     * begins the "Enter" stage. During this stage, the component will shift from
     * its current transition state, to `'entering'` for the duration of the
     * transition and then to the `'entered'` stage once it's complete. Let's take
     * the following example (we'll use the
     * [useState](https://reactjs.org/docs/hooks-reference.html#usestate) hook):
     *
     * ```jsx
     * function App() {
     *   const [inProp, setInProp] = useState(false);
     *   return (
     *     <div>
     *       <Transition in={inProp} timeout={500}>
     *         {state => (
     *           // ...
     *         )}
     *       </Transition>
     *       <button onClick={() => setInProp(true)}>
     *         Click to Enter
     *       </button>
     *     </div>
     *   );
     * }
     * ```
     *
     * When the button is clicked the component will shift to the `'entering'` state
     * and stay there for 500ms (the value of `timeout`) before it finally switches
     * to `'entered'`.
     *
     * When `in` is `false` the same thing happens except the state moves from
     * `'exiting'` to `'exited'`.
     */

    var Transition = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(Transition, _React$Component);

      function Transition(props, context) {
        var _this;

        _this = _React$Component.call(this, props, context) || this;
        var parentGroup = context; // In the context of a TransitionGroup all enters are really appears

        var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
        var initialStatus;
        _this.appearStatus = null;

        if (props.in) {
          if (appear) {
            initialStatus = EXITED;
            _this.appearStatus = ENTERING;
          } else {
            initialStatus = ENTERED;
          }
        } else {
          if (props.unmountOnExit || props.mountOnEnter) {
            initialStatus = UNMOUNTED;
          } else {
            initialStatus = EXITED;
          }
        }

        _this.state = {
          status: initialStatus
        };
        _this.nextCallback = null;
        return _this;
      }

      Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
        var nextIn = _ref.in;

        if (nextIn && prevState.status === UNMOUNTED) {
          return {
            status: EXITED
          };
        }

        return null;
      } // getSnapshotBeforeUpdate(prevProps) {
      //   let nextStatus = null
      //   if (prevProps !== this.props) {
      //     const { status } = this.state
      //     if (this.props.in) {
      //       if (status !== ENTERING && status !== ENTERED) {
      //         nextStatus = ENTERING
      //       }
      //     } else {
      //       if (status === ENTERING || status === ENTERED) {
      //         nextStatus = EXITING
      //       }
      //     }
      //   }
      //   return { nextStatus }
      // }
      ;

      var _proto = Transition.prototype;

      _proto.componentDidMount = function componentDidMount() {
        this.updateStatus(true, this.appearStatus);
      };

      _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        var nextStatus = null;

        if (prevProps !== this.props) {
          var status = this.state.status;

          if (this.props.in) {
            if (status !== ENTERING && status !== ENTERED) {
              nextStatus = ENTERING;
            }
          } else {
            if (status === ENTERING || status === ENTERED) {
              nextStatus = EXITING;
            }
          }
        }

        this.updateStatus(false, nextStatus);
      };

      _proto.componentWillUnmount = function componentWillUnmount() {
        this.cancelNextCallback();
      };

      _proto.getTimeouts = function getTimeouts() {
        var timeout = this.props.timeout;
        var exit, enter, appear;
        exit = enter = appear = timeout;

        if (timeout != null && typeof timeout !== 'number') {
          exit = timeout.exit;
          enter = timeout.enter; // TODO: remove fallback for next major

          appear = timeout.appear !== undefined ? timeout.appear : enter;
        }

        return {
          exit: exit,
          enter: enter,
          appear: appear
        };
      };

      _proto.updateStatus = function updateStatus(mounting, nextStatus) {
        if (mounting === void 0) {
          mounting = false;
        }

        if (nextStatus !== null) {
          // nextStatus will always be ENTERING or EXITING.
          this.cancelNextCallback();

          if (nextStatus === ENTERING) {
            this.performEnter(mounting);
          } else {
            this.performExit();
          }
        } else if (this.props.unmountOnExit && this.state.status === EXITED) {
          this.setState({
            status: UNMOUNTED
          });
        }
      };

      _proto.performEnter = function performEnter(mounting) {
        var _this2 = this;

        var enter = this.props.enter;
        var appearing = this.context ? this.context.isMounting : mounting;

        var _ref2 = this.props.nodeRef ? [appearing] : [ReactDOM.findDOMNode(this), appearing],
            maybeNode = _ref2[0],
            maybeAppearing = _ref2[1];

        var timeouts = this.getTimeouts();
        var enterTimeout = appearing ? timeouts.appear : timeouts.enter; // no enter animation skip right to ENTERED
        // if we are mounting and running this it means appear _must_ be set

        if (!mounting && !enter || config.disabled) {
          this.safeSetState({
            status: ENTERED
          }, function () {
            _this2.props.onEntered(maybeNode);
          });
          return;
        }

        this.props.onEnter(maybeNode, maybeAppearing);
        this.safeSetState({
          status: ENTERING
        }, function () {
          _this2.props.onEntering(maybeNode, maybeAppearing);

          _this2.onTransitionEnd(enterTimeout, function () {
            _this2.safeSetState({
              status: ENTERED
            }, function () {
              _this2.props.onEntered(maybeNode, maybeAppearing);
            });
          });
        });
      };

      _proto.performExit = function performExit() {
        var _this3 = this;

        var exit = this.props.exit;
        var timeouts = this.getTimeouts();
        var maybeNode = this.props.nodeRef ? undefined : ReactDOM.findDOMNode(this); // no exit animation skip right to EXITED

        if (!exit || config.disabled) {
          this.safeSetState({
            status: EXITED
          }, function () {
            _this3.props.onExited(maybeNode);
          });
          return;
        }

        this.props.onExit(maybeNode);
        this.safeSetState({
          status: EXITING
        }, function () {
          _this3.props.onExiting(maybeNode);

          _this3.onTransitionEnd(timeouts.exit, function () {
            _this3.safeSetState({
              status: EXITED
            }, function () {
              _this3.props.onExited(maybeNode);
            });
          });
        });
      };

      _proto.cancelNextCallback = function cancelNextCallback() {
        if (this.nextCallback !== null) {
          this.nextCallback.cancel();
          this.nextCallback = null;
        }
      };

      _proto.safeSetState = function safeSetState(nextState, callback) {
        // This shouldn't be necessary, but there are weird race conditions with
        // setState callbacks and unmounting in testing, so always make sure that
        // we can cancel any pending setState callbacks after we unmount.
        callback = this.setNextCallback(callback);
        this.setState(nextState, callback);
      };

      _proto.setNextCallback = function setNextCallback(callback) {
        var _this4 = this;

        var active = true;

        this.nextCallback = function (event) {
          if (active) {
            active = false;
            _this4.nextCallback = null;
            callback(event);
          }
        };

        this.nextCallback.cancel = function () {
          active = false;
        };

        return this.nextCallback;
      };

      _proto.onTransitionEnd = function onTransitionEnd(timeout, handler) {
        this.setNextCallback(handler);
        var node = this.props.nodeRef ? this.props.nodeRef.current : ReactDOM.findDOMNode(this);
        var doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;

        if (!node || doesNotHaveTimeoutOrListener) {
          setTimeout(this.nextCallback, 0);
          return;
        }

        if (this.props.addEndListener) {
          var _ref3 = this.props.nodeRef ? [this.nextCallback] : [node, this.nextCallback],
              maybeNode = _ref3[0],
              maybeNextCallback = _ref3[1];

          this.props.addEndListener(maybeNode, maybeNextCallback);
        }

        if (timeout != null) {
          setTimeout(this.nextCallback, timeout);
        }
      };

      _proto.render = function render() {
        var status = this.state.status;

        if (status === UNMOUNTED) {
          return null;
        }

        var _this$props = this.props,
            children = _this$props.children;
            _this$props.in;
            _this$props.mountOnEnter;
            _this$props.unmountOnExit;
            _this$props.appear;
            _this$props.enter;
            _this$props.exit;
            _this$props.timeout;
            _this$props.addEndListener;
            _this$props.onEnter;
            _this$props.onEntering;
            _this$props.onEntered;
            _this$props.onExit;
            _this$props.onExiting;
            _this$props.onExited;
            _this$props.nodeRef;
            var childProps = _objectWithoutPropertiesLoose(_this$props, ["children", "in", "mountOnEnter", "unmountOnExit", "appear", "enter", "exit", "timeout", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "nodeRef"]);

        return (
          /*#__PURE__*/
          // allows for nested Transitions
          React.createElement(TransitionGroupContext.Provider, {
            value: null
          }, typeof children === 'function' ? children(status, childProps) : React.cloneElement(React.Children.only(children), childProps))
        );
      };

      return Transition;
    }(React.Component);

    Transition.contextType = TransitionGroupContext;
    Transition.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * A React reference to DOM element that need to transition:
       * https://stackoverflow.com/a/51127130/4671932
       *
       *   - When `nodeRef` prop is used, `node` is not passed to callback functions
       *      (e.g. `onEnter`) because user already has direct access to the node.
       *   - When changing `key` prop of `Transition` in a `TransitionGroup` a new
       *     `nodeRef` need to be provided to `Transition` with changed `key` prop
       *     (see
       *     [test/CSSTransition-test.js](https://github.com/reactjs/react-transition-group/blob/13435f897b3ab71f6e19d724f145596f5910581c/test/CSSTransition-test.js#L362-L437)).
       */
      nodeRef: propTypes.exports.shape({
        current: typeof Element === 'undefined' ? propTypes.exports.any : function (propValue, key, componentName, location, propFullName, secret) {
          var value = propValue[key];
          return propTypes.exports.instanceOf(value && 'ownerDocument' in value ? value.ownerDocument.defaultView.Element : Element)(propValue, key, componentName, location, propFullName, secret);
        }
      }),

      /**
       * A `function` child can be used instead of a React element. This function is
       * called with the current transition status (`'entering'`, `'entered'`,
       * `'exiting'`, `'exited'`), which can be used to apply context
       * specific props to a component.
       *
       * ```jsx
       * <Transition in={this.state.in} timeout={150}>
       *   {state => (
       *     <MyComponent className={`fade fade-${state}`} />
       *   )}
       * </Transition>
       * ```
       */
      children: propTypes.exports.oneOfType([propTypes.exports.func.isRequired, propTypes.exports.element.isRequired]).isRequired,

      /**
       * Show the component; triggers the enter or exit states
       */
      in: propTypes.exports.bool,

      /**
       * By default the child component is mounted immediately along with
       * the parent `Transition` component. If you want to "lazy mount" the component on the
       * first `in={true}` you can set `mountOnEnter`. After the first enter transition the component will stay
       * mounted, even on "exited", unless you also specify `unmountOnExit`.
       */
      mountOnEnter: propTypes.exports.bool,

      /**
       * By default the child component stays mounted after it reaches the `'exited'` state.
       * Set `unmountOnExit` if you'd prefer to unmount the component after it finishes exiting.
       */
      unmountOnExit: propTypes.exports.bool,

      /**
       * By default the child component does not perform the enter transition when
       * it first mounts, regardless of the value of `in`. If you want this
       * behavior, set both `appear` and `in` to `true`.
       *
       * > **Note**: there are no special appear states like `appearing`/`appeared`, this prop
       * > only adds an additional enter transition. However, in the
       * > `<CSSTransition>` component that first enter transition does result in
       * > additional `.appear-*` classes, that way you can choose to style it
       * > differently.
       */
      appear: propTypes.exports.bool,

      /**
       * Enable or disable enter transitions.
       */
      enter: propTypes.exports.bool,

      /**
       * Enable or disable exit transitions.
       */
      exit: propTypes.exports.bool,

      /**
       * The duration of the transition, in milliseconds.
       * Required unless `addEndListener` is provided.
       *
       * You may specify a single timeout for all transitions:
       *
       * ```jsx
       * timeout={500}
       * ```
       *
       * or individually:
       *
       * ```jsx
       * timeout={{
       *  appear: 500,
       *  enter: 300,
       *  exit: 500,
       * }}
       * ```
       *
       * - `appear` defaults to the value of `enter`
       * - `enter` defaults to `0`
       * - `exit` defaults to `0`
       *
       * @type {number | { enter?: number, exit?: number, appear?: number }}
       */
      timeout: function timeout(props) {
        var pt = timeoutsShape;
        if (!props.addEndListener) pt = pt.isRequired;

        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        return pt.apply(void 0, [props].concat(args));
      },

      /**
       * Add a custom transition end trigger. Called with the transitioning
       * DOM node and a `done` callback. Allows for more fine grained transition end
       * logic. Timeouts are still used as a fallback if provided.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * ```jsx
       * addEndListener={(node, done) => {
       *   // use the css transitionend event to mark the finish of a transition
       *   node.addEventListener('transitionend', done, false);
       * }}
       * ```
       */
      addEndListener: propTypes.exports.func,

      /**
       * Callback fired before the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEnter: propTypes.exports.func,

      /**
       * Callback fired after the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: propTypes.exports.func,

      /**
       * Callback fired after the "entered" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEntered: propTypes.exports.func,

      /**
       * Callback fired before the "exiting" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExit: propTypes.exports.func,

      /**
       * Callback fired after the "exiting" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExiting: propTypes.exports.func,

      /**
       * Callback fired after the "exited" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExited: propTypes.exports.func
    } : {}; // Name the function so it is clearer in the documentation

    function noop() {}

    Transition.defaultProps = {
      in: false,
      mountOnEnter: false,
      unmountOnExit: false,
      appear: false,
      enter: true,
      exit: true,
      onEnter: noop,
      onEntering: noop,
      onEntered: noop,
      onExit: noop,
      onExiting: noop,
      onExited: noop
    };
    Transition.UNMOUNTED = UNMOUNTED;
    Transition.EXITED = EXITED;
    Transition.ENTERING = ENTERING;
    Transition.ENTERED = ENTERED;
    Transition.EXITING = EXITING;

    var _addClass = function addClass$1(node, classes) {
      return node && classes && classes.split(' ').forEach(function (c) {
        return addClass(node, c);
      });
    };

    var removeClass = function removeClass(node, classes) {
      return node && classes && classes.split(' ').forEach(function (c) {
        return removeClass$1(node, c);
      });
    };
    /**
     * A transition component inspired by the excellent
     * [ng-animate](https://docs.angularjs.org/api/ngAnimate) library, you should
     * use it if you're using CSS transitions or animations. It's built upon the
     * [`Transition`](https://reactcommunity.org/react-transition-group/transition)
     * component, so it inherits all of its props.
     *
     * `CSSTransition` applies a pair of class names during the `appear`, `enter`,
     * and `exit` states of the transition. The first class is applied and then a
     * second `*-active` class in order to activate the CSS transition. After the
     * transition, matching `*-done` class names are applied to persist the
     * transition state.
     *
     * ```jsx
     * function App() {
     *   const [inProp, setInProp] = useState(false);
     *   return (
     *     <div>
     *       <CSSTransition in={inProp} timeout={200} classNames="my-node">
     *         <div>
     *           {"I'll receive my-node-* classes"}
     *         </div>
     *       </CSSTransition>
     *       <button type="button" onClick={() => setInProp(true)}>
     *         Click to Enter
     *       </button>
     *     </div>
     *   );
     * }
     * ```
     *
     * When the `in` prop is set to `true`, the child component will first receive
     * the class `example-enter`, then the `example-enter-active` will be added in
     * the next tick. `CSSTransition` [forces a
     * reflow](https://github.com/reactjs/react-transition-group/blob/5007303e729a74be66a21c3e2205e4916821524b/src/CSSTransition.js#L208-L215)
     * between before adding the `example-enter-active`. This is an important trick
     * because it allows us to transition between `example-enter` and
     * `example-enter-active` even though they were added immediately one after
     * another. Most notably, this is what makes it possible for us to animate
     * _appearance_.
     *
     * ```css
     * .my-node-enter {
     *   opacity: 0;
     * }
     * .my-node-enter-active {
     *   opacity: 1;
     *   transition: opacity 200ms;
     * }
     * .my-node-exit {
     *   opacity: 1;
     * }
     * .my-node-exit-active {
     *   opacity: 0;
     *   transition: opacity 200ms;
     * }
     * ```
     *
     * `*-active` classes represent which styles you want to animate **to**, so it's
     * important to add `transition` declaration only to them, otherwise transitions
     * might not behave as intended! This might not be obvious when the transitions
     * are symmetrical, i.e. when `*-enter-active` is the same as `*-exit`, like in
     * the example above (minus `transition`), but it becomes apparent in more
     * complex transitions.
     *
     * **Note**: If you're using the
     * [`appear`](http://reactcommunity.org/react-transition-group/transition#Transition-prop-appear)
     * prop, make sure to define styles for `.appear-*` classes as well.
     */


    var CSSTransition = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(CSSTransition, _React$Component);

      function CSSTransition() {
        var _this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
        _this.appliedClasses = {
          appear: {},
          enter: {},
          exit: {}
        };

        _this.onEnter = function (maybeNode, maybeAppearing) {
          var _this$resolveArgument = _this.resolveArguments(maybeNode, maybeAppearing),
              node = _this$resolveArgument[0],
              appearing = _this$resolveArgument[1];

          _this.removeClasses(node, 'exit');

          _this.addClass(node, appearing ? 'appear' : 'enter', 'base');

          if (_this.props.onEnter) {
            _this.props.onEnter(maybeNode, maybeAppearing);
          }
        };

        _this.onEntering = function (maybeNode, maybeAppearing) {
          var _this$resolveArgument2 = _this.resolveArguments(maybeNode, maybeAppearing),
              node = _this$resolveArgument2[0],
              appearing = _this$resolveArgument2[1];

          var type = appearing ? 'appear' : 'enter';

          _this.addClass(node, type, 'active');

          if (_this.props.onEntering) {
            _this.props.onEntering(maybeNode, maybeAppearing);
          }
        };

        _this.onEntered = function (maybeNode, maybeAppearing) {
          var _this$resolveArgument3 = _this.resolveArguments(maybeNode, maybeAppearing),
              node = _this$resolveArgument3[0],
              appearing = _this$resolveArgument3[1];

          var type = appearing ? 'appear' : 'enter';

          _this.removeClasses(node, type);

          _this.addClass(node, type, 'done');

          if (_this.props.onEntered) {
            _this.props.onEntered(maybeNode, maybeAppearing);
          }
        };

        _this.onExit = function (maybeNode) {
          var _this$resolveArgument4 = _this.resolveArguments(maybeNode),
              node = _this$resolveArgument4[0];

          _this.removeClasses(node, 'appear');

          _this.removeClasses(node, 'enter');

          _this.addClass(node, 'exit', 'base');

          if (_this.props.onExit) {
            _this.props.onExit(maybeNode);
          }
        };

        _this.onExiting = function (maybeNode) {
          var _this$resolveArgument5 = _this.resolveArguments(maybeNode),
              node = _this$resolveArgument5[0];

          _this.addClass(node, 'exit', 'active');

          if (_this.props.onExiting) {
            _this.props.onExiting(maybeNode);
          }
        };

        _this.onExited = function (maybeNode) {
          var _this$resolveArgument6 = _this.resolveArguments(maybeNode),
              node = _this$resolveArgument6[0];

          _this.removeClasses(node, 'exit');

          _this.addClass(node, 'exit', 'done');

          if (_this.props.onExited) {
            _this.props.onExited(maybeNode);
          }
        };

        _this.resolveArguments = function (maybeNode, maybeAppearing) {
          return _this.props.nodeRef ? [_this.props.nodeRef.current, maybeNode] // here `maybeNode` is actually `appearing`
          : [maybeNode, maybeAppearing];
        };

        _this.getClassNames = function (type) {
          var classNames = _this.props.classNames;
          var isStringClassNames = typeof classNames === 'string';
          var prefix = isStringClassNames && classNames ? classNames + "-" : '';
          var baseClassName = isStringClassNames ? "" + prefix + type : classNames[type];
          var activeClassName = isStringClassNames ? baseClassName + "-active" : classNames[type + "Active"];
          var doneClassName = isStringClassNames ? baseClassName + "-done" : classNames[type + "Done"];
          return {
            baseClassName: baseClassName,
            activeClassName: activeClassName,
            doneClassName: doneClassName
          };
        };

        return _this;
      }

      var _proto = CSSTransition.prototype;

      _proto.addClass = function addClass(node, type, phase) {
        var className = this.getClassNames(type)[phase + "ClassName"];

        var _this$getClassNames = this.getClassNames('enter'),
            doneClassName = _this$getClassNames.doneClassName;

        if (type === 'appear' && phase === 'done' && doneClassName) {
          className += " " + doneClassName;
        } // This is to force a repaint,
        // which is necessary in order to transition styles when adding a class name.


        if (phase === 'active') {
          /* eslint-disable no-unused-expressions */
          node && node.scrollTop;
        }

        if (className) {
          this.appliedClasses[type][phase] = className;

          _addClass(node, className);
        }
      };

      _proto.removeClasses = function removeClasses(node, type) {
        var _this$appliedClasses$ = this.appliedClasses[type],
            baseClassName = _this$appliedClasses$.base,
            activeClassName = _this$appliedClasses$.active,
            doneClassName = _this$appliedClasses$.done;
        this.appliedClasses[type] = {};

        if (baseClassName) {
          removeClass(node, baseClassName);
        }

        if (activeClassName) {
          removeClass(node, activeClassName);
        }

        if (doneClassName) {
          removeClass(node, doneClassName);
        }
      };

      _proto.render = function render() {
        var _this$props = this.props;
            _this$props.classNames;
            var props = _objectWithoutPropertiesLoose(_this$props, ["classNames"]);

        return /*#__PURE__*/React.createElement(Transition, _extends$1({}, props, {
          onEnter: this.onEnter,
          onEntered: this.onEntered,
          onEntering: this.onEntering,
          onExit: this.onExit,
          onExiting: this.onExiting,
          onExited: this.onExited
        }));
      };

      return CSSTransition;
    }(React.Component);

    CSSTransition.defaultProps = {
      classNames: ''
    };
    CSSTransition.propTypes = process.env.NODE_ENV !== "production" ? _extends$1({}, Transition.propTypes, {
      /**
       * The animation classNames applied to the component as it appears, enters,
       * exits or has finished the transition. A single name can be provided, which
       * will be suffixed for each stage, e.g. `classNames="fade"` applies:
       *
       * - `fade-appear`, `fade-appear-active`, `fade-appear-done`
       * - `fade-enter`, `fade-enter-active`, `fade-enter-done`
       * - `fade-exit`, `fade-exit-active`, `fade-exit-done`
       *
       * A few details to note about how these classes are applied:
       *
       * 1. They are _joined_ with the ones that are already defined on the child
       *    component, so if you want to add some base styles, you can use
       *    `className` without worrying that it will be overridden.
       *
       * 2. If the transition component mounts with `in={false}`, no classes are
       *    applied yet. You might be expecting `*-exit-done`, but if you think
       *    about it, a component cannot finish exiting if it hasn't entered yet.
       *
       * 2. `fade-appear-done` and `fade-enter-done` will _both_ be applied. This
       *    allows you to define different behavior for when appearing is done and
       *    when regular entering is done, using selectors like
       *    `.fade-enter-done:not(.fade-appear-done)`. For example, you could apply
       *    an epic entrance animation when element first appears in the DOM using
       *    [Animate.css](https://daneden.github.io/animate.css/). Otherwise you can
       *    simply use `fade-enter-done` for defining both cases.
       *
       * Each individual classNames can also be specified independently like:
       *
       * ```js
       * classNames={{
       *  appear: 'my-appear',
       *  appearActive: 'my-active-appear',
       *  appearDone: 'my-done-appear',
       *  enter: 'my-enter',
       *  enterActive: 'my-active-enter',
       *  enterDone: 'my-done-enter',
       *  exit: 'my-exit',
       *  exitActive: 'my-active-exit',
       *  exitDone: 'my-done-exit',
       * }}
       * ```
       *
       * If you want to set these classes using CSS Modules:
       *
       * ```js
       * import styles from './styles.css';
       * ```
       *
       * you might want to use camelCase in your CSS file, that way could simply
       * spread them instead of listing them one by one:
       *
       * ```js
       * classNames={{ ...styles }}
       * ```
       *
       * @type {string | {
       *  appear?: string,
       *  appearActive?: string,
       *  appearDone?: string,
       *  enter?: string,
       *  enterActive?: string,
       *  enterDone?: string,
       *  exit?: string,
       *  exitActive?: string,
       *  exitDone?: string,
       * }}
       */
      classNames: classNamesShape,

      /**
       * A `<Transition>` callback fired immediately after the 'enter' or 'appear' class is
       * applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEnter: propTypes.exports.func,

      /**
       * A `<Transition>` callback fired immediately after the 'enter-active' or
       * 'appear-active' class is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: propTypes.exports.func,

      /**
       * A `<Transition>` callback fired immediately after the 'enter' or
       * 'appear' classes are **removed** and the `done` class is added to the DOM node.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntered: propTypes.exports.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit' class is
       * applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExit: propTypes.exports.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit-active' is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExiting: propTypes.exports.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit' classes
       * are **removed** and the `exit-done` class is added to the DOM node.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExited: propTypes.exports.func
    }) : {};

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return self;
    }

    /**
     * Given `this.props.children`, return an object mapping key to child.
     *
     * @param {*} children `this.props.children`
     * @return {object} Mapping of key to child
     */

    function getChildMapping(children, mapFn) {
      var mapper = function mapper(child) {
        return mapFn && react.exports.isValidElement(child) ? mapFn(child) : child;
      };

      var result = Object.create(null);
      if (children) react.exports.Children.map(children, function (c) {
        return c;
      }).forEach(function (child) {
        // run the map function here instead so that the key is the computed one
        result[child.key] = mapper(child);
      });
      return result;
    }
    /**
     * When you're adding or removing children some may be added or removed in the
     * same render pass. We want to show *both* since we want to simultaneously
     * animate elements in and out. This function takes a previous set of keys
     * and a new set of keys and merges them with its best guess of the correct
     * ordering. In the future we may expose some of the utilities in
     * ReactMultiChild to make this easy, but for now React itself does not
     * directly have this concept of the union of prevChildren and nextChildren
     * so we implement it here.
     *
     * @param {object} prev prev children as returned from
     * `ReactTransitionChildMapping.getChildMapping()`.
     * @param {object} next next children as returned from
     * `ReactTransitionChildMapping.getChildMapping()`.
     * @return {object} a key set that contains all keys in `prev` and all keys
     * in `next` in a reasonable order.
     */

    function mergeChildMappings(prev, next) {
      prev = prev || {};
      next = next || {};

      function getValueForKey(key) {
        return key in next ? next[key] : prev[key];
      } // For each key of `next`, the list of keys to insert before that key in
      // the combined list


      var nextKeysPending = Object.create(null);
      var pendingKeys = [];

      for (var prevKey in prev) {
        if (prevKey in next) {
          if (pendingKeys.length) {
            nextKeysPending[prevKey] = pendingKeys;
            pendingKeys = [];
          }
        } else {
          pendingKeys.push(prevKey);
        }
      }

      var i;
      var childMapping = {};

      for (var nextKey in next) {
        if (nextKeysPending[nextKey]) {
          for (i = 0; i < nextKeysPending[nextKey].length; i++) {
            var pendingNextKey = nextKeysPending[nextKey][i];
            childMapping[nextKeysPending[nextKey][i]] = getValueForKey(pendingNextKey);
          }
        }

        childMapping[nextKey] = getValueForKey(nextKey);
      } // Finally, add the keys which didn't appear before any key in `next`


      for (i = 0; i < pendingKeys.length; i++) {
        childMapping[pendingKeys[i]] = getValueForKey(pendingKeys[i]);
      }

      return childMapping;
    }

    function getProp(child, prop, props) {
      return props[prop] != null ? props[prop] : child.props[prop];
    }

    function getInitialChildMapping(props, onExited) {
      return getChildMapping(props.children, function (child) {
        return react.exports.cloneElement(child, {
          onExited: onExited.bind(null, child),
          in: true,
          appear: getProp(child, 'appear', props),
          enter: getProp(child, 'enter', props),
          exit: getProp(child, 'exit', props)
        });
      });
    }
    function getNextChildMapping(nextProps, prevChildMapping, onExited) {
      var nextChildMapping = getChildMapping(nextProps.children);
      var children = mergeChildMappings(prevChildMapping, nextChildMapping);
      Object.keys(children).forEach(function (key) {
        var child = children[key];
        if (!react.exports.isValidElement(child)) return;
        var hasPrev = (key in prevChildMapping);
        var hasNext = (key in nextChildMapping);
        var prevChild = prevChildMapping[key];
        var isLeaving = react.exports.isValidElement(prevChild) && !prevChild.props.in; // item is new (entering)

        if (hasNext && (!hasPrev || isLeaving)) {
          // console.log('entering', key)
          children[key] = react.exports.cloneElement(child, {
            onExited: onExited.bind(null, child),
            in: true,
            exit: getProp(child, 'exit', nextProps),
            enter: getProp(child, 'enter', nextProps)
          });
        } else if (!hasNext && hasPrev && !isLeaving) {
          // item is old (exiting)
          // console.log('leaving', key)
          children[key] = react.exports.cloneElement(child, {
            in: false
          });
        } else if (hasNext && hasPrev && react.exports.isValidElement(prevChild)) {
          // item hasn't changed transition states
          // copy over the last transition props;
          // console.log('unchanged', key)
          children[key] = react.exports.cloneElement(child, {
            onExited: onExited.bind(null, child),
            in: prevChild.props.in,
            exit: getProp(child, 'exit', nextProps),
            enter: getProp(child, 'enter', nextProps)
          });
        }
      });
      return children;
    }

    var values = Object.values || function (obj) {
      return Object.keys(obj).map(function (k) {
        return obj[k];
      });
    };

    var defaultProps = {
      component: 'div',
      childFactory: function childFactory(child) {
        return child;
      }
    };
    /**
     * The `<TransitionGroup>` component manages a set of transition components
     * (`<Transition>` and `<CSSTransition>`) in a list. Like with the transition
     * components, `<TransitionGroup>` is a state machine for managing the mounting
     * and unmounting of components over time.
     *
     * Consider the example below. As items are removed or added to the TodoList the
     * `in` prop is toggled automatically by the `<TransitionGroup>`.
     *
     * Note that `<TransitionGroup>`  does not define any animation behavior!
     * Exactly _how_ a list item animates is up to the individual transition
     * component. This means you can mix and match animations across different list
     * items.
     */

    var TransitionGroup = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(TransitionGroup, _React$Component);

      function TransitionGroup(props, context) {
        var _this;

        _this = _React$Component.call(this, props, context) || this;

        var handleExited = _this.handleExited.bind(_assertThisInitialized(_this)); // Initial children should all be entering, dependent on appear


        _this.state = {
          contextValue: {
            isMounting: true
          },
          handleExited: handleExited,
          firstRender: true
        };
        return _this;
      }

      var _proto = TransitionGroup.prototype;

      _proto.componentDidMount = function componentDidMount() {
        this.mounted = true;
        this.setState({
          contextValue: {
            isMounting: false
          }
        });
      };

      _proto.componentWillUnmount = function componentWillUnmount() {
        this.mounted = false;
      };

      TransitionGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, _ref) {
        var prevChildMapping = _ref.children,
            handleExited = _ref.handleExited,
            firstRender = _ref.firstRender;
        return {
          children: firstRender ? getInitialChildMapping(nextProps, handleExited) : getNextChildMapping(nextProps, prevChildMapping, handleExited),
          firstRender: false
        };
      } // node is `undefined` when user provided `nodeRef` prop
      ;

      _proto.handleExited = function handleExited(child, node) {
        var currentChildMapping = getChildMapping(this.props.children);
        if (child.key in currentChildMapping) return;

        if (child.props.onExited) {
          child.props.onExited(node);
        }

        if (this.mounted) {
          this.setState(function (state) {
            var children = _extends$1({}, state.children);

            delete children[child.key];
            return {
              children: children
            };
          });
        }
      };

      _proto.render = function render() {
        var _this$props = this.props,
            Component = _this$props.component,
            childFactory = _this$props.childFactory,
            props = _objectWithoutPropertiesLoose(_this$props, ["component", "childFactory"]);

        var contextValue = this.state.contextValue;
        var children = values(this.state.children).map(childFactory);
        delete props.appear;
        delete props.enter;
        delete props.exit;

        if (Component === null) {
          return /*#__PURE__*/React.createElement(TransitionGroupContext.Provider, {
            value: contextValue
          }, children);
        }

        return /*#__PURE__*/React.createElement(TransitionGroupContext.Provider, {
          value: contextValue
        }, /*#__PURE__*/React.createElement(Component, props, children));
      };

      return TransitionGroup;
    }(React.Component);

    TransitionGroup.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * `<TransitionGroup>` renders a `<div>` by default. You can change this
       * behavior by providing a `component` prop.
       * If you use React v16+ and would like to avoid a wrapping `<div>` element
       * you can pass in `component={null}`. This is useful if the wrapping div
       * borks your css styles.
       */
      component: propTypes.exports.any,

      /**
       * A set of `<Transition>` components, that are toggled `in` and out as they
       * leave. the `<TransitionGroup>` will inject specific transition props, so
       * remember to spread them through if you are wrapping the `<Transition>` as
       * with our `<Fade>` example.
       *
       * While this component is meant for multiple `Transition` or `CSSTransition`
       * children, sometimes you may want to have a single transition child with
       * content that you want to be transitioned out and in when you change it
       * (e.g. routes, images etc.) In that case you can change the `key` prop of
       * the transition child as you change its content, this will cause
       * `TransitionGroup` to transition the child out and back in.
       */
      children: propTypes.exports.node,

      /**
       * A convenience prop that enables or disables appear animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      appear: propTypes.exports.bool,

      /**
       * A convenience prop that enables or disables enter animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      enter: propTypes.exports.bool,

      /**
       * A convenience prop that enables or disables exit animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      exit: propTypes.exports.bool,

      /**
       * You may need to apply reactive updates to a child as it is exiting.
       * This is generally done by using `cloneElement` however in the case of an exiting
       * child the element has already been removed and not accessible to the consumer.
       *
       * If you do need to update a child as it leaves you can provide a `childFactory`
       * to wrap every child, even the ones that are leaving.
       *
       * @type Function(child: ReactElement) -> ReactElement
       */
      childFactory: propTypes.exports.func
    } : {};
    TransitionGroup.defaultProps = defaultProps;

    /**
     * The `<ReplaceTransition>` component is a specialized `Transition` component
     * that animates between two children.
     *
     * ```jsx
     * <ReplaceTransition in>
     *   <Fade><div>I appear first</div></Fade>
     *   <Fade><div>I replace the above</div></Fade>
     * </ReplaceTransition>
     * ```
     */

    var ReplaceTransition = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(ReplaceTransition, _React$Component);

      function ReplaceTransition() {
        var _this;

        for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
          _args[_key] = arguments[_key];
        }

        _this = _React$Component.call.apply(_React$Component, [this].concat(_args)) || this;

        _this.handleEnter = function () {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          return _this.handleLifecycle('onEnter', 0, args);
        };

        _this.handleEntering = function () {
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          return _this.handleLifecycle('onEntering', 0, args);
        };

        _this.handleEntered = function () {
          for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
          }

          return _this.handleLifecycle('onEntered', 0, args);
        };

        _this.handleExit = function () {
          for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
            args[_key5] = arguments[_key5];
          }

          return _this.handleLifecycle('onExit', 1, args);
        };

        _this.handleExiting = function () {
          for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
            args[_key6] = arguments[_key6];
          }

          return _this.handleLifecycle('onExiting', 1, args);
        };

        _this.handleExited = function () {
          for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
            args[_key7] = arguments[_key7];
          }

          return _this.handleLifecycle('onExited', 1, args);
        };

        return _this;
      }

      var _proto = ReplaceTransition.prototype;

      _proto.handleLifecycle = function handleLifecycle(handler, idx, originalArgs) {
        var _child$props;

        var children = this.props.children;
        var child = React.Children.toArray(children)[idx];
        if (child.props[handler]) (_child$props = child.props)[handler].apply(_child$props, originalArgs);

        if (this.props[handler]) {
          var maybeNode = child.props.nodeRef ? undefined : ReactDOM.findDOMNode(this);
          this.props[handler](maybeNode);
        }
      };

      _proto.render = function render() {
        var _this$props = this.props,
            children = _this$props.children,
            inProp = _this$props.in,
            props = _objectWithoutPropertiesLoose(_this$props, ["children", "in"]);

        var _React$Children$toArr = React.Children.toArray(children),
            first = _React$Children$toArr[0],
            second = _React$Children$toArr[1];

        delete props.onEnter;
        delete props.onEntering;
        delete props.onEntered;
        delete props.onExit;
        delete props.onExiting;
        delete props.onExited;
        return /*#__PURE__*/React.createElement(TransitionGroup, props, inProp ? React.cloneElement(first, {
          key: 'first',
          onEnter: this.handleEnter,
          onEntering: this.handleEntering,
          onEntered: this.handleEntered
        }) : React.cloneElement(second, {
          key: 'second',
          onEnter: this.handleExit,
          onEntering: this.handleExiting,
          onEntered: this.handleExited
        }));
      };

      return ReplaceTransition;
    }(React.Component);

    ReplaceTransition.propTypes = process.env.NODE_ENV !== "production" ? {
      in: propTypes.exports.bool.isRequired,
      children: function children(props, propName) {
        if (React.Children.count(props[propName]) !== 2) return new Error("\"" + propName + "\" must be exactly two transition components.");
        return null;
      }
    } : {};

    var _leaveRenders, _enterRenders;

    function areChildrenDifferent(oldChildren, newChildren) {
      if (oldChildren === newChildren) return false;

      if (React.isValidElement(oldChildren) && React.isValidElement(newChildren) && oldChildren.key != null && oldChildren.key === newChildren.key) {
        return false;
      }

      return true;
    }
    /**
     * Enum of modes for SwitchTransition component
     * @enum { string }
     */


    var modes = {
      out: 'out-in',
      in: 'in-out'
    };

    var callHook = function callHook(element, name, cb) {
      return function () {
        var _element$props;

        element.props[name] && (_element$props = element.props)[name].apply(_element$props, arguments);
        cb();
      };
    };

    var leaveRenders = (_leaveRenders = {}, _leaveRenders[modes.out] = function (_ref) {
      var current = _ref.current,
          changeState = _ref.changeState;
      return React.cloneElement(current, {
        in: false,
        onExited: callHook(current, 'onExited', function () {
          changeState(ENTERING, null);
        })
      });
    }, _leaveRenders[modes.in] = function (_ref2) {
      var current = _ref2.current,
          changeState = _ref2.changeState,
          children = _ref2.children;
      return [current, React.cloneElement(children, {
        in: true,
        onEntered: callHook(children, 'onEntered', function () {
          changeState(ENTERING);
        })
      })];
    }, _leaveRenders);
    var enterRenders = (_enterRenders = {}, _enterRenders[modes.out] = function (_ref3) {
      var children = _ref3.children,
          changeState = _ref3.changeState;
      return React.cloneElement(children, {
        in: true,
        onEntered: callHook(children, 'onEntered', function () {
          changeState(ENTERED, React.cloneElement(children, {
            in: true
          }));
        })
      });
    }, _enterRenders[modes.in] = function (_ref4) {
      var current = _ref4.current,
          children = _ref4.children,
          changeState = _ref4.changeState;
      return [React.cloneElement(current, {
        in: false,
        onExited: callHook(current, 'onExited', function () {
          changeState(ENTERED, React.cloneElement(children, {
            in: true
          }));
        })
      }), React.cloneElement(children, {
        in: true
      })];
    }, _enterRenders);
    /**
     * A transition component inspired by the [vue transition modes](https://vuejs.org/v2/guide/transitions.html#Transition-Modes).
     * You can use it when you want to control the render between state transitions.
     * Based on the selected mode and the child's key which is the `Transition` or `CSSTransition` component, the `SwitchTransition` makes a consistent transition between them.
     *
     * If the `out-in` mode is selected, the `SwitchTransition` waits until the old child leaves and then inserts a new child.
     * If the `in-out` mode is selected, the `SwitchTransition` inserts a new child first, waits for the new child to enter and then removes the old child.
     *
     * **Note**: If you want the animation to happen simultaneously
     * (that is, to have the old child removed and a new child inserted **at the same time**),
     * you should use
     * [`TransitionGroup`](https://reactcommunity.org/react-transition-group/transition-group)
     * instead.
     *
     * ```jsx
     * function App() {
     *  const [state, setState] = useState(false);
     *  return (
     *    <SwitchTransition>
     *      <CSSTransition
     *        key={state ? "Goodbye, world!" : "Hello, world!"}
     *        addEndListener={(node, done) => node.addEventListener("transitionend", done, false)}
     *        classNames='fade'
     *      >
     *        <button onClick={() => setState(state => !state)}>
     *          {state ? "Goodbye, world!" : "Hello, world!"}
     *        </button>
     *      </CSSTransition>
     *    </SwitchTransition>
     *  );
     * }
     * ```
     *
     * ```css
     * .fade-enter{
     *    opacity: 0;
     * }
     * .fade-exit{
     *    opacity: 1;
     * }
     * .fade-enter-active{
     *    opacity: 1;
     * }
     * .fade-exit-active{
     *    opacity: 0;
     * }
     * .fade-enter-active,
     * .fade-exit-active{
     *    transition: opacity 500ms;
     * }
     * ```
     */

    var SwitchTransition = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(SwitchTransition, _React$Component);

      function SwitchTransition() {
        var _this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
        _this.state = {
          status: ENTERED,
          current: null
        };
        _this.appeared = false;

        _this.changeState = function (status, current) {
          if (current === void 0) {
            current = _this.state.current;
          }

          _this.setState({
            status: status,
            current: current
          });
        };

        return _this;
      }

      var _proto = SwitchTransition.prototype;

      _proto.componentDidMount = function componentDidMount() {
        this.appeared = true;
      };

      SwitchTransition.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
        if (props.children == null) {
          return {
            current: null
          };
        }

        if (state.status === ENTERING && props.mode === modes.in) {
          return {
            status: ENTERING
          };
        }

        if (state.current && areChildrenDifferent(state.current, props.children)) {
          return {
            status: EXITING
          };
        }

        return {
          current: React.cloneElement(props.children, {
            in: true
          })
        };
      };

      _proto.render = function render() {
        var _this$props = this.props,
            children = _this$props.children,
            mode = _this$props.mode,
            _this$state = this.state,
            status = _this$state.status,
            current = _this$state.current;
        var data = {
          children: children,
          current: current,
          changeState: this.changeState,
          status: status
        };
        var component;

        switch (status) {
          case ENTERING:
            component = enterRenders[mode](data);
            break;

          case EXITING:
            component = leaveRenders[mode](data);
            break;

          case ENTERED:
            component = current;
        }

        return /*#__PURE__*/React.createElement(TransitionGroupContext.Provider, {
          value: {
            isMounting: !this.appeared
          }
        }, component);
      };

      return SwitchTransition;
    }(React.Component);

    SwitchTransition.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * Transition modes.
       * `out-in`: Current element transitions out first, then when complete, the new element transitions in.
       * `in-out`: New element transitions in first, then when complete, the current element transitions out.
       *
       * @type {'out-in'|'in-out'}
       */
      mode: propTypes.exports.oneOf([modes.in, modes.out]),

      /**
       * Any `Transition` or `CSSTransition` component.
       */
      children: propTypes.exports.oneOfType([propTypes.exports.element.isRequired])
    } : {};
    SwitchTransition.defaultProps = {
      mode: modes.out
    };

    const reflow = node => node.scrollTop;
    function getTransitionProps(props, options) {
      var _style$transitionDura, _style$transitionTimi;

      const {
        timeout,
        easing,
        style = {}
      } = props;
      return {
        duration: (_style$transitionDura = style.transitionDuration) != null ? _style$transitionDura : typeof timeout === 'number' ? timeout : timeout[options.mode] || 0,
        easing: (_style$transitionTimi = style.transitionTimingFunction) != null ? _style$transitionTimi : typeof easing === 'object' ? easing[options.mode] : easing,
        delay: style.transitionDelay
      };
    }

    function getPaperUtilityClass(slot) {
      return generateUtilityClass('MuiPaper', slot);
    }
    generateUtilityClasses('MuiPaper', ['root', 'rounded', 'outlined', 'elevation', 'elevation0', 'elevation1', 'elevation2', 'elevation3', 'elevation4', 'elevation5', 'elevation6', 'elevation7', 'elevation8', 'elevation9', 'elevation10', 'elevation11', 'elevation12', 'elevation13', 'elevation14', 'elevation15', 'elevation16', 'elevation17', 'elevation18', 'elevation19', 'elevation20', 'elevation21', 'elevation22', 'elevation23', 'elevation24']);

    const _excluded$A = ["className", "component", "elevation", "square", "variant"];

    const getOverlayAlpha = elevation => {
      let alphaValue;

      if (elevation < 1) {
        alphaValue = 5.11916 * elevation ** 2;
      } else {
        alphaValue = 4.5 * Math.log(elevation + 1) + 2;
      }

      return (alphaValue / 100).toFixed(2);
    };

    const useUtilityClasses$s = ownerState => {
      const {
        square,
        elevation,
        variant,
        classes
      } = ownerState;
      const slots = {
        root: ['root', variant, !square && 'rounded', variant === 'elevation' && `elevation${elevation}`]
      };
      return composeClasses(slots, getPaperUtilityClass, classes);
    };

    const PaperRoot = styled$1('div', {
      name: 'MuiPaper',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, styles[ownerState.variant], !ownerState.square && styles.rounded, ownerState.variant === 'elevation' && styles[`elevation${ownerState.elevation}`]];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      backgroundColor: theme.palette.background.paper,
      color: theme.palette.text.primary,
      transition: theme.transitions.create('box-shadow')
    }, !ownerState.square && {
      borderRadius: theme.shape.borderRadius
    }, ownerState.variant === 'outlined' && {
      border: `1px solid ${theme.palette.divider}`
    }, ownerState.variant === 'elevation' && _extends$1({
      boxShadow: theme.shadows[ownerState.elevation]
    }, theme.palette.mode === 'dark' && {
      backgroundImage: `linear-gradient(${alpha('#fff', getOverlayAlpha(ownerState.elevation))}, ${alpha('#fff', getOverlayAlpha(ownerState.elevation))})`
    })));
    const Paper = /*#__PURE__*/react.exports.forwardRef(function Paper(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiPaper'
      });

      const {
        className,
        component = 'div',
        elevation = 1,
        square = false,
        variant = 'elevation'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$A);

      const ownerState = _extends$1({}, props, {
        component,
        elevation,
        square,
        variant
      });

      const classes = useUtilityClasses$s(ownerState);

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        const theme = useTheme();

        if (theme.shadows[elevation] === undefined) {
          console.error([`MUI: The elevation provided <Paper elevation={${elevation}}> is not available in the theme.`, `Please make sure that \`theme.shadows[${elevation}]\` is defined.`].join('\n'));
        }
      }

      return /*#__PURE__*/jsxRuntimeExports.jsx(PaperRoot, _extends$1({
        as: component,
        ownerState: ownerState,
        className: clsx(classes.root, className),
        ref: ref
      }, other));
    });
    process.env.NODE_ENV !== "production" ? Paper.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * Shadow depth, corresponds to `dp` in the spec.
       * It accepts values between 0 and 24 inclusive.
       * @default 1
       */
      elevation: chainPropTypes(integerPropType, props => {
        const {
          elevation,
          variant
        } = props;

        if (elevation > 0 && variant === 'outlined') {
          return new Error(`MUI: Combining \`elevation={${elevation}}\` with \`variant="${variant}"\` has no effect. Either use \`elevation={0}\` or use a different \`variant\`.`);
        }

        return null;
      }),

      /**
       * If `true`, rounded corners are disabled.
       * @default false
       */
      square: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The variant to use.
       * @default 'elevation'
       */
      variant: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['elevation', 'outlined']), propTypes.exports.string])
    } : void 0;
    var Paper$1 = Paper;

    function Ripple(props) {
      const {
        className,
        classes,
        pulsate = false,
        rippleX,
        rippleY,
        rippleSize,
        in: inProp,
        onExited,
        timeout
      } = props;
      const [leaving, setLeaving] = react.exports.useState(false);
      const rippleClassName = clsx(className, classes.ripple, classes.rippleVisible, pulsate && classes.ripplePulsate);
      const rippleStyles = {
        width: rippleSize,
        height: rippleSize,
        top: -(rippleSize / 2) + rippleY,
        left: -(rippleSize / 2) + rippleX
      };
      const childClassName = clsx(classes.child, leaving && classes.childLeaving, pulsate && classes.childPulsate);

      if (!inProp && !leaving) {
        setLeaving(true);
      }

      react.exports.useEffect(() => {
        if (!inProp && onExited != null) {
          // react-transition-group#onExited
          const timeoutId = setTimeout(onExited, timeout);
          return () => {
            clearTimeout(timeoutId);
          };
        }

        return undefined;
      }, [onExited, inProp, timeout]);
      return /*#__PURE__*/jsxRuntimeExports.jsx("span", {
        className: rippleClassName,
        style: rippleStyles,
        children: /*#__PURE__*/jsxRuntimeExports.jsx("span", {
          className: childClassName
        })
      });
    }

    process.env.NODE_ENV !== "production" ? Ripple.propTypes = {
      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object.isRequired,
      className: propTypes.exports.string,

      /**
       * @ignore - injected from TransitionGroup
       */
      in: propTypes.exports.bool,

      /**
       * @ignore - injected from TransitionGroup
       */
      onExited: propTypes.exports.func,

      /**
       * If `true`, the ripple pulsates, typically indicating the keyboard focus state of an element.
       */
      pulsate: propTypes.exports.bool,

      /**
       * Diameter of the ripple.
       */
      rippleSize: propTypes.exports.number,

      /**
       * Horizontal position of the ripple center.
       */
      rippleX: propTypes.exports.number,

      /**
       * Vertical position of the ripple center.
       */
      rippleY: propTypes.exports.number,

      /**
       * exit delay
       */
      timeout: propTypes.exports.number.isRequired
    } : void 0;

    const touchRippleClasses = generateUtilityClasses('MuiTouchRipple', ['root', 'ripple', 'rippleVisible', 'ripplePulsate', 'child', 'childLeaving', 'childPulsate']);
    var touchRippleClasses$1 = touchRippleClasses;

    const _excluded$z = ["center", "classes", "className"];

    let _ = t => t,
        _t,
        _t2,
        _t3,
        _t4;
    const DURATION = 550;
    const DELAY_RIPPLE = 80;
    const enterKeyframe = keyframes(_t || (_t = _`
  0% {
    transform: scale(0);
    opacity: 0.1;
  }

  100% {
    transform: scale(1);
    opacity: 0.3;
  }
`));
    const exitKeyframe = keyframes(_t2 || (_t2 = _`
  0% {
    opacity: 1;
  }

  100% {
    opacity: 0;
  }
`));
    const pulsateKeyframe = keyframes(_t3 || (_t3 = _`
  0% {
    transform: scale(1);
  }

  50% {
    transform: scale(0.92);
  }

  100% {
    transform: scale(1);
  }
`));
    const TouchRippleRoot = styled$1('span', {
      name: 'MuiTouchRipple',
      slot: 'Root'
    })({
      overflow: 'hidden',
      pointerEvents: 'none',
      position: 'absolute',
      zIndex: 0,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      borderRadius: 'inherit'
    }); // This `styled()` function invokes keyframes. `styled-components` only supports keyframes
    // in string templates. Do not convert these styles in JS object as it will break.

    const TouchRippleRipple = styled$1(Ripple, {
      name: 'MuiTouchRipple',
      slot: 'Ripple'
    })(_t4 || (_t4 = _`
  opacity: 0;
  position: absolute;

  &.${0} {
    opacity: 0.3;
    transform: scale(1);
    animation-name: ${0};
    animation-duration: ${0}ms;
    animation-timing-function: ${0};
  }

  &.${0} {
    animation-duration: ${0}ms;
  }

  & .${0} {
    opacity: 1;
    display: block;
    width: 100%;
    height: 100%;
    border-radius: 50%;
    background-color: currentColor;
  }

  & .${0} {
    opacity: 0;
    animation-name: ${0};
    animation-duration: ${0}ms;
    animation-timing-function: ${0};
  }

  & .${0} {
    position: absolute;
    /* @noflip */
    left: 0px;
    top: 0;
    animation-name: ${0};
    animation-duration: 2500ms;
    animation-timing-function: ${0};
    animation-iteration-count: infinite;
    animation-delay: 200ms;
  }
`), touchRippleClasses$1.rippleVisible, enterKeyframe, DURATION, ({
      theme
    }) => theme.transitions.easing.easeInOut, touchRippleClasses$1.ripplePulsate, ({
      theme
    }) => theme.transitions.duration.shorter, touchRippleClasses$1.child, touchRippleClasses$1.childLeaving, exitKeyframe, DURATION, ({
      theme
    }) => theme.transitions.easing.easeInOut, touchRippleClasses$1.childPulsate, pulsateKeyframe, ({
      theme
    }) => theme.transitions.easing.easeInOut);
    /**
     * @ignore - internal component.
     *
     * TODO v5: Make private
     */

    const TouchRipple = /*#__PURE__*/react.exports.forwardRef(function TouchRipple(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiTouchRipple'
      });

      const {
        center: centerProp = false,
        classes = {},
        className
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$z);

      const [ripples, setRipples] = react.exports.useState([]);
      const nextKey = react.exports.useRef(0);
      const rippleCallback = react.exports.useRef(null);
      react.exports.useEffect(() => {
        if (rippleCallback.current) {
          rippleCallback.current();
          rippleCallback.current = null;
        }
      }, [ripples]); // Used to filter out mouse emulated events on mobile.

      const ignoringMouseDown = react.exports.useRef(false); // We use a timer in order to only show the ripples for touch "click" like events.
      // We don't want to display the ripple for touch scroll events.

      const startTimer = react.exports.useRef(null); // This is the hook called once the previous timeout is ready.

      const startTimerCommit = react.exports.useRef(null);
      const container = react.exports.useRef(null);
      react.exports.useEffect(() => {
        return () => {
          clearTimeout(startTimer.current);
        };
      }, []);
      const startCommit = react.exports.useCallback(params => {
        const {
          pulsate,
          rippleX,
          rippleY,
          rippleSize,
          cb
        } = params;
        setRipples(oldRipples => [...oldRipples, /*#__PURE__*/jsxRuntimeExports.jsx(TouchRippleRipple, {
          classes: {
            ripple: clsx(classes.ripple, touchRippleClasses$1.ripple),
            rippleVisible: clsx(classes.rippleVisible, touchRippleClasses$1.rippleVisible),
            ripplePulsate: clsx(classes.ripplePulsate, touchRippleClasses$1.ripplePulsate),
            child: clsx(classes.child, touchRippleClasses$1.child),
            childLeaving: clsx(classes.childLeaving, touchRippleClasses$1.childLeaving),
            childPulsate: clsx(classes.childPulsate, touchRippleClasses$1.childPulsate)
          },
          timeout: DURATION,
          pulsate: pulsate,
          rippleX: rippleX,
          rippleY: rippleY,
          rippleSize: rippleSize
        }, nextKey.current)]);
        nextKey.current += 1;
        rippleCallback.current = cb;
      }, [classes]);
      const start = react.exports.useCallback((event = {}, options = {}, cb) => {
        const {
          pulsate = false,
          center = centerProp || options.pulsate,
          fakeElement = false // For test purposes

        } = options;

        if (event.type === 'mousedown' && ignoringMouseDown.current) {
          ignoringMouseDown.current = false;
          return;
        }

        if (event.type === 'touchstart') {
          ignoringMouseDown.current = true;
        }

        const element = fakeElement ? null : container.current;
        const rect = element ? element.getBoundingClientRect() : {
          width: 0,
          height: 0,
          left: 0,
          top: 0
        }; // Get the size of the ripple

        let rippleX;
        let rippleY;
        let rippleSize;

        if (center || event.clientX === 0 && event.clientY === 0 || !event.clientX && !event.touches) {
          rippleX = Math.round(rect.width / 2);
          rippleY = Math.round(rect.height / 2);
        } else {
          const {
            clientX,
            clientY
          } = event.touches ? event.touches[0] : event;
          rippleX = Math.round(clientX - rect.left);
          rippleY = Math.round(clientY - rect.top);
        }

        if (center) {
          rippleSize = Math.sqrt((2 * rect.width ** 2 + rect.height ** 2) / 3); // For some reason the animation is broken on Mobile Chrome if the size is even.

          if (rippleSize % 2 === 0) {
            rippleSize += 1;
          }
        } else {
          const sizeX = Math.max(Math.abs((element ? element.clientWidth : 0) - rippleX), rippleX) * 2 + 2;
          const sizeY = Math.max(Math.abs((element ? element.clientHeight : 0) - rippleY), rippleY) * 2 + 2;
          rippleSize = Math.sqrt(sizeX ** 2 + sizeY ** 2);
        } // Touche devices


        if (event.touches) {
          // check that this isn't another touchstart due to multitouch
          // otherwise we will only clear a single timer when unmounting while two
          // are running
          if (startTimerCommit.current === null) {
            // Prepare the ripple effect.
            startTimerCommit.current = () => {
              startCommit({
                pulsate,
                rippleX,
                rippleY,
                rippleSize,
                cb
              });
            }; // Delay the execution of the ripple effect.


            startTimer.current = setTimeout(() => {
              if (startTimerCommit.current) {
                startTimerCommit.current();
                startTimerCommit.current = null;
              }
            }, DELAY_RIPPLE); // We have to make a tradeoff with this value.
          }
        } else {
          startCommit({
            pulsate,
            rippleX,
            rippleY,
            rippleSize,
            cb
          });
        }
      }, [centerProp, startCommit]);
      const pulsate = react.exports.useCallback(() => {
        start({}, {
          pulsate: true
        });
      }, [start]);
      const stop = react.exports.useCallback((event, cb) => {
        clearTimeout(startTimer.current); // The touch interaction occurs too quickly.
        // We still want to show ripple effect.

        if (event.type === 'touchend' && startTimerCommit.current) {
          startTimerCommit.current();
          startTimerCommit.current = null;
          startTimer.current = setTimeout(() => {
            stop(event, cb);
          });
          return;
        }

        startTimerCommit.current = null;
        setRipples(oldRipples => {
          if (oldRipples.length > 0) {
            return oldRipples.slice(1);
          }

          return oldRipples;
        });
        rippleCallback.current = cb;
      }, []);
      react.exports.useImperativeHandle(ref, () => ({
        pulsate,
        start,
        stop
      }), [pulsate, start, stop]);
      return /*#__PURE__*/jsxRuntimeExports.jsx(TouchRippleRoot, _extends$1({
        className: clsx(classes.root, touchRippleClasses$1.root, className),
        ref: container
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(TransitionGroup, {
          component: null,
          exit: true,
          children: ripples
        })
      }));
    });
    process.env.NODE_ENV !== "production" ? TouchRipple.propTypes = {
      /**
       * If `true`, the ripple starts at the center of the component
       * rather than at the point of interaction.
       */
      center: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string
    } : void 0;
    var TouchRipple$1 = TouchRipple;

    function getButtonBaseUtilityClass(slot) {
      return generateUtilityClass('MuiButtonBase', slot);
    }
    const buttonBaseClasses = generateUtilityClasses('MuiButtonBase', ['root', 'disabled', 'focusVisible']);
    var buttonBaseClasses$1 = buttonBaseClasses;

    const _excluded$y = ["action", "centerRipple", "children", "className", "component", "disabled", "disableRipple", "disableTouchRipple", "focusRipple", "focusVisibleClassName", "LinkComponent", "onBlur", "onClick", "onContextMenu", "onDragLeave", "onFocus", "onFocusVisible", "onKeyDown", "onKeyUp", "onMouseDown", "onMouseLeave", "onMouseUp", "onTouchEnd", "onTouchMove", "onTouchStart", "tabIndex", "TouchRippleProps", "touchRippleRef", "type"];

    const useUtilityClasses$r = ownerState => {
      const {
        disabled,
        focusVisible,
        focusVisibleClassName,
        classes
      } = ownerState;
      const slots = {
        root: ['root', disabled && 'disabled', focusVisible && 'focusVisible']
      };
      const composedClasses = composeClasses(slots, getButtonBaseUtilityClass, classes);

      if (focusVisible && focusVisibleClassName) {
        composedClasses.root += ` ${focusVisibleClassName}`;
      }

      return composedClasses;
    };

    const ButtonBaseRoot = styled$1('button', {
      name: 'MuiButtonBase',
      slot: 'Root',
      overridesResolver: (props, styles) => styles.root
    })({
      display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center',
      position: 'relative',
      boxSizing: 'border-box',
      WebkitTapHighlightColor: 'transparent',
      backgroundColor: 'transparent',
      // Reset default value
      // We disable the focus ring for mouse, touch and keyboard users.
      outline: 0,
      border: 0,
      margin: 0,
      // Remove the margin in Safari
      borderRadius: 0,
      padding: 0,
      // Remove the padding in Firefox
      cursor: 'pointer',
      userSelect: 'none',
      verticalAlign: 'middle',
      MozAppearance: 'none',
      // Reset
      WebkitAppearance: 'none',
      // Reset
      textDecoration: 'none',
      // So we take precedent over the style of a native <a /> element.
      color: 'inherit',
      '&::-moz-focus-inner': {
        borderStyle: 'none' // Remove Firefox dotted outline.

      },
      [`&.${buttonBaseClasses$1.disabled}`]: {
        pointerEvents: 'none',
        // Disable link interactions
        cursor: 'default'
      },
      '@media print': {
        colorAdjust: 'exact'
      }
    });
    /**
     * `ButtonBase` contains as few styles as possible.
     * It aims to be a simple building block for creating a button.
     * It contains a load of style reset and some focus/ripple logic.
     */

    const ButtonBase = /*#__PURE__*/react.exports.forwardRef(function ButtonBase(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiButtonBase'
      });

      const {
        action,
        centerRipple = false,
        children,
        className,
        component = 'button',
        disabled = false,
        disableRipple = false,
        disableTouchRipple = false,
        focusRipple = false,
        LinkComponent = 'a',
        onBlur,
        onClick,
        onContextMenu,
        onDragLeave,
        onFocus,
        onFocusVisible,
        onKeyDown,
        onKeyUp,
        onMouseDown,
        onMouseLeave,
        onMouseUp,
        onTouchEnd,
        onTouchMove,
        onTouchStart,
        tabIndex = 0,
        TouchRippleProps,
        touchRippleRef,
        type
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$y);

      const buttonRef = react.exports.useRef(null);
      const rippleRef = react.exports.useRef(null);
      const handleRippleRef = useForkRef(rippleRef, touchRippleRef);
      const {
        isFocusVisibleRef,
        onFocus: handleFocusVisible,
        onBlur: handleBlurVisible,
        ref: focusVisibleRef
      } = useIsFocusVisible();
      const [focusVisible, setFocusVisible] = react.exports.useState(false);

      if (disabled && focusVisible) {
        setFocusVisible(false);
      }

      react.exports.useImperativeHandle(action, () => ({
        focusVisible: () => {
          setFocusVisible(true);
          buttonRef.current.focus();
        }
      }), []);
      react.exports.useEffect(() => {
        if (focusVisible && focusRipple && !disableRipple) {
          rippleRef.current.pulsate();
        }
      }, [disableRipple, focusRipple, focusVisible]);

      function useRippleHandler(rippleAction, eventCallback, skipRippleAction = disableTouchRipple) {
        return useEventCallback(event => {
          if (eventCallback) {
            eventCallback(event);
          }

          const ignore = skipRippleAction;

          if (!ignore && rippleRef.current) {
            rippleRef.current[rippleAction](event);
          }

          return true;
        });
      }

      const handleMouseDown = useRippleHandler('start', onMouseDown);
      const handleContextMenu = useRippleHandler('stop', onContextMenu);
      const handleDragLeave = useRippleHandler('stop', onDragLeave);
      const handleMouseUp = useRippleHandler('stop', onMouseUp);
      const handleMouseLeave = useRippleHandler('stop', event => {
        if (focusVisible) {
          event.preventDefault();
        }

        if (onMouseLeave) {
          onMouseLeave(event);
        }
      });
      const handleTouchStart = useRippleHandler('start', onTouchStart);
      const handleTouchEnd = useRippleHandler('stop', onTouchEnd);
      const handleTouchMove = useRippleHandler('stop', onTouchMove);
      const handleBlur = useRippleHandler('stop', event => {
        handleBlurVisible(event);

        if (isFocusVisibleRef.current === false) {
          setFocusVisible(false);
        }

        if (onBlur) {
          onBlur(event);
        }
      }, false);
      const handleFocus = useEventCallback(event => {
        // Fix for https://github.com/facebook/react/issues/7769
        if (!buttonRef.current) {
          buttonRef.current = event.currentTarget;
        }

        handleFocusVisible(event);

        if (isFocusVisibleRef.current === true) {
          setFocusVisible(true);

          if (onFocusVisible) {
            onFocusVisible(event);
          }
        }

        if (onFocus) {
          onFocus(event);
        }
      });

      const isNonNativeButton = () => {
        const button = buttonRef.current;
        return component && component !== 'button' && !(button.tagName === 'A' && button.href);
      };
      /**
       * IE11 shim for https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/repeat
       */


      const keydownRef = react.exports.useRef(false);
      const handleKeyDown = useEventCallback(event => {
        // Check if key is already down to avoid repeats being counted as multiple activations
        if (focusRipple && !keydownRef.current && focusVisible && rippleRef.current && event.key === ' ') {
          keydownRef.current = true;
          rippleRef.current.stop(event, () => {
            rippleRef.current.start(event);
          });
        }

        if (event.target === event.currentTarget && isNonNativeButton() && event.key === ' ') {
          event.preventDefault();
        }

        if (onKeyDown) {
          onKeyDown(event);
        } // Keyboard accessibility for non interactive elements


        if (event.target === event.currentTarget && isNonNativeButton() && event.key === 'Enter' && !disabled) {
          event.preventDefault();

          if (onClick) {
            onClick(event);
          }
        }
      });
      const handleKeyUp = useEventCallback(event => {
        // calling preventDefault in keyUp on a <button> will not dispatch a click event if Space is pressed
        // https://codesandbox.io/s/button-keyup-preventdefault-dn7f0
        if (focusRipple && event.key === ' ' && rippleRef.current && focusVisible && !event.defaultPrevented) {
          keydownRef.current = false;
          rippleRef.current.stop(event, () => {
            rippleRef.current.pulsate(event);
          });
        }

        if (onKeyUp) {
          onKeyUp(event);
        } // Keyboard accessibility for non interactive elements


        if (onClick && event.target === event.currentTarget && isNonNativeButton() && event.key === ' ' && !event.defaultPrevented) {
          onClick(event);
        }
      });
      let ComponentProp = component;

      if (ComponentProp === 'button' && (other.href || other.to)) {
        ComponentProp = LinkComponent;
      }

      const buttonProps = {};

      if (ComponentProp === 'button') {
        buttonProps.type = type === undefined ? 'button' : type;
        buttonProps.disabled = disabled;
      } else {
        if (!other.href && !other.to) {
          buttonProps.role = 'button';
        }

        if (disabled) {
          buttonProps['aria-disabled'] = disabled;
        }
      }

      const handleOwnRef = useForkRef(focusVisibleRef, buttonRef);
      const handleRef = useForkRef(ref, handleOwnRef);
      const [mountedState, setMountedState] = react.exports.useState(false);
      react.exports.useEffect(() => {
        setMountedState(true);
      }, []);
      const enableTouchRipple = mountedState && !disableRipple && !disabled;

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        react.exports.useEffect(() => {
          if (enableTouchRipple && !rippleRef.current) {
            console.error(['MUI: The `component` prop provided to ButtonBase is invalid.', 'Please make sure the children prop is rendered in this custom component.'].join('\n'));
          }
        }, [enableTouchRipple]);
      }

      const ownerState = _extends$1({}, props, {
        centerRipple,
        component,
        disabled,
        disableRipple,
        disableTouchRipple,
        focusRipple,
        tabIndex,
        focusVisible
      });

      const classes = useUtilityClasses$r(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(ButtonBaseRoot, _extends$1({
        as: ComponentProp,
        className: clsx(classes.root, className),
        ownerState: ownerState,
        onBlur: handleBlur,
        onClick: onClick,
        onContextMenu: handleContextMenu,
        onFocus: handleFocus,
        onKeyDown: handleKeyDown,
        onKeyUp: handleKeyUp,
        onMouseDown: handleMouseDown,
        onMouseLeave: handleMouseLeave,
        onMouseUp: handleMouseUp,
        onDragLeave: handleDragLeave,
        onTouchEnd: handleTouchEnd,
        onTouchMove: handleTouchMove,
        onTouchStart: handleTouchStart,
        ref: handleRef,
        tabIndex: disabled ? -1 : tabIndex,
        type: type
      }, buttonProps, other, {
        children: [children, enableTouchRipple ?
        /*#__PURE__*/

        /* TouchRipple is only needed client-side, x2 boost on the server. */
        jsxRuntimeExports.jsx(TouchRipple$1, _extends$1({
          ref: handleRippleRef,
          center: centerRipple
        }, TouchRippleProps)) : null]
      }));
    });
    process.env.NODE_ENV !== "production" ? ButtonBase.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * A ref for imperative actions.
       * It currently only supports `focusVisible()` action.
       */
      action: refType,

      /**
       * If `true`, the ripples are centered.
       * They won't start at the cursor interaction position.
       * @default false
       */
      centerRipple: propTypes.exports.bool,

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: elementTypeAcceptingRef$1,

      /**
       * If `true`, the component is disabled.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the ripple effect is disabled.
       *
       * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
       * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
       * @default false
       */
      disableRipple: propTypes.exports.bool,

      /**
       * If `true`, the touch ripple effect is disabled.
       * @default false
       */
      disableTouchRipple: propTypes.exports.bool,

      /**
       * If `true`, the base button will have a keyboard focus ripple.
       * @default false
       */
      focusRipple: propTypes.exports.bool,

      /**
       * This prop can help identify which element has keyboard focus.
       * The class name will be applied when the element gains the focus through keyboard interaction.
       * It's a polyfill for the [CSS :focus-visible selector](https://drafts.csswg.org/selectors-4/#the-focus-visible-pseudo).
       * The rationale for using this feature [is explained here](https://github.com/WICG/focus-visible/blob/HEAD/explainer.md).
       * A [polyfill can be used](https://github.com/WICG/focus-visible) to apply a `focus-visible` class to other components
       * if needed.
       */
      focusVisibleClassName: propTypes.exports.string,

      /**
       * @ignore
       */
      href: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .any,

      /**
       * The component used to render a link when the `href` prop is provided.
       * @default 'a'
       */
      LinkComponent: propTypes.exports.elementType,

      /**
       * @ignore
       */
      onBlur: propTypes.exports.func,

      /**
       * @ignore
       */
      onClick: propTypes.exports.func,

      /**
       * @ignore
       */
      onContextMenu: propTypes.exports.func,

      /**
       * @ignore
       */
      onDragLeave: propTypes.exports.func,

      /**
       * @ignore
       */
      onFocus: propTypes.exports.func,

      /**
       * Callback fired when the component is focused with a keyboard.
       * We trigger a `onFocus` callback too.
       */
      onFocusVisible: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyDown: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyUp: propTypes.exports.func,

      /**
       * @ignore
       */
      onMouseDown: propTypes.exports.func,

      /**
       * @ignore
       */
      onMouseLeave: propTypes.exports.func,

      /**
       * @ignore
       */
      onMouseUp: propTypes.exports.func,

      /**
       * @ignore
       */
      onTouchEnd: propTypes.exports.func,

      /**
       * @ignore
       */
      onTouchMove: propTypes.exports.func,

      /**
       * @ignore
       */
      onTouchStart: propTypes.exports.func,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * @default 0
       */
      tabIndex: propTypes.exports.number,

      /**
       * Props applied to the `TouchRipple` element.
       */
      TouchRippleProps: propTypes.exports.object,

      /**
       * A ref that points to the `TouchRipple` element.
       */
      touchRippleRef: propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.shape({
        current: propTypes.exports.shape({
          pulsate: propTypes.exports.func.isRequired,
          start: propTypes.exports.func.isRequired,
          stop: propTypes.exports.func.isRequired
        })
      })]),

      /**
       * @ignore
       */
      type: propTypes.exports.oneOfType([propTypes.exports.oneOf(['button', 'reset', 'submit']), propTypes.exports.string])
    } : void 0;
    var ButtonBase$1 = ButtonBase;

    function getTypographyUtilityClass(slot) {
      return generateUtilityClass('MuiTypography', slot);
    }
    generateUtilityClasses('MuiTypography', ['root', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'subtitle1', 'subtitle2', 'body1', 'body2', 'inherit', 'button', 'caption', 'overline', 'alignLeft', 'alignRight', 'alignCenter', 'alignJustify', 'noWrap', 'gutterBottom', 'paragraph']);

    const _excluded$x = ["align", "className", "component", "gutterBottom", "noWrap", "paragraph", "variant", "variantMapping"];

    const useUtilityClasses$q = ownerState => {
      const {
        align,
        gutterBottom,
        noWrap,
        paragraph,
        variant,
        classes
      } = ownerState;
      const slots = {
        root: ['root', variant, ownerState.align !== 'inherit' && `align${capitalize(align)}`, gutterBottom && 'gutterBottom', noWrap && 'noWrap', paragraph && 'paragraph']
      };
      return composeClasses(slots, getTypographyUtilityClass, classes);
    };

    const TypographyRoot = styled$1('span', {
      name: 'MuiTypography',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.variant && styles[ownerState.variant], ownerState.align !== 'inherit' && styles[`align${capitalize(ownerState.align)}`], ownerState.noWrap && styles.noWrap, ownerState.gutterBottom && styles.gutterBottom, ownerState.paragraph && styles.paragraph];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      margin: 0
    }, ownerState.variant && theme.typography[ownerState.variant], ownerState.align !== 'inherit' && {
      textAlign: ownerState.align
    }, ownerState.noWrap && {
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      whiteSpace: 'nowrap'
    }, ownerState.gutterBottom && {
      marginBottom: '0.35em'
    }, ownerState.paragraph && {
      marginBottom: 16
    }));
    const defaultVariantMapping = {
      h1: 'h1',
      h2: 'h2',
      h3: 'h3',
      h4: 'h4',
      h5: 'h5',
      h6: 'h6',
      subtitle1: 'h6',
      subtitle2: 'h6',
      body1: 'p',
      body2: 'p',
      inherit: 'p'
    }; // TODO v6: deprecate these color values in v5.x and remove the transformation in v6

    const colorTransformations = {
      primary: 'primary.main',
      textPrimary: 'text.primary',
      secondary: 'secondary.main',
      textSecondary: 'text.secondary',
      error: 'error.main'
    };

    const transformDeprecatedColors = color => {
      return colorTransformations[color] || color;
    };

    const Typography = /*#__PURE__*/react.exports.forwardRef(function Typography(inProps, ref) {
      const themeProps = useThemeProps({
        props: inProps,
        name: 'MuiTypography'
      });
      const color = transformDeprecatedColors(themeProps.color);
      const props = extendSxProp(_extends$1({}, themeProps, {
        color
      }));

      const {
        align = 'inherit',
        className,
        component,
        gutterBottom = false,
        noWrap = false,
        paragraph = false,
        variant = 'body1',
        variantMapping = defaultVariantMapping
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$x);

      const ownerState = _extends$1({}, props, {
        align,
        color,
        className,
        component,
        gutterBottom,
        noWrap,
        paragraph,
        variant,
        variantMapping
      });

      const Component = component || (paragraph ? 'p' : variantMapping[variant] || defaultVariantMapping[variant]) || 'span';
      const classes = useUtilityClasses$q(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(TypographyRoot, _extends$1({
        as: Component,
        ref: ref,
        ownerState: ownerState,
        className: clsx(classes.root, className)
      }, other));
    });
    process.env.NODE_ENV !== "production" ? Typography.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Set the text-align on the component.
       * @default 'inherit'
       */
      align: propTypes.exports.oneOf(['center', 'inherit', 'justify', 'left', 'right']),

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, the text will have a bottom margin.
       * @default false
       */
      gutterBottom: propTypes.exports.bool,

      /**
       * If `true`, the text will not wrap, but instead will truncate with a text overflow ellipsis.
       *
       * Note that text overflow can only happen with block or inline-block level elements
       * (the element needs to have a width in order to overflow).
       * @default false
       */
      noWrap: propTypes.exports.bool,

      /**
       * If `true`, the element will be a paragraph element.
       * @default false
       */
      paragraph: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Applies the theme typography styles.
       * @default 'body1'
       */
      variant: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['body1', 'body2', 'button', 'caption', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'inherit', 'overline', 'subtitle1', 'subtitle2']), propTypes.exports.string]),

      /**
       * The component maps the variant prop to a range of different HTML element types.
       * For instance, subtitle1 to `<h6>`.
       * If you wish to change that mapping, you can provide your own.
       * Alternatively, you can use the `component` prop.
       * @default {
       *   h1: 'h1',
       *   h2: 'h2',
       *   h3: 'h3',
       *   h4: 'h4',
       *   h5: 'h5',
       *   h6: 'h6',
       *   subtitle1: 'h6',
       *   subtitle2: 'h6',
       *   body1: 'p',
       *   body2: 'p',
       *   inherit: 'p',
       * }
       */
      variantMapping: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .object
    } : void 0;
    var Typography$1 = Typography;

    /**
     *
     * Demos:
     *
     * - [Autocomplete](https://mui.com/components/autocomplete/)
     * - [Menus](https://mui.com/components/menus/)
     * - [Popper](https://mui.com/components/popper/)
     *
     * API:
     *
     * - [Popper API](https://mui.com/api/popper/)
     */
    const Popper = /*#__PURE__*/react.exports.forwardRef(function Popper(props, ref) {
      const theme = useTheme$2();
      return /*#__PURE__*/jsxRuntimeExports.jsx(PopperUnstyled$1, _extends$1({
        direction: theme == null ? void 0 : theme.direction
      }, props, {
        ref: ref
      }));
    });
    process.env.NODE_ENV !== "production" ? Popper.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit TypeScript types and run "yarn proptypes"  |
      // ----------------------------------------------------------------------

      /**
       * An HTML element, [virtualElement](https://popper.js.org/docs/v2/virtual-elements/),
       * or a function that returns either.
       * It's used to set the position of the popper.
       * The return value will passed as the reference object of the Popper instance.
       */
      anchorEl: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.object, propTypes.exports.func]),

      /**
       * Popper render function or node.
       */
      children: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.node, propTypes.exports.func]),

      /**
       * An HTML element or function that returns one.
       * The `container` will have the portal children appended to it.
       *
       * By default, it uses the body of the top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * The `children` will be under the DOM hierarchy of the parent component.
       * @default false
       */
      disablePortal: propTypes.exports.bool,

      /**
       * Always keep the children in the DOM.
       * This prop can be useful in SEO situation or
       * when you want to maximize the responsiveness of the Popper.
       * @default false
       */
      keepMounted: propTypes.exports.bool,

      /**
       * Popper.js is based on a "plugin-like" architecture,
       * most of its features are fully encapsulated "modifiers".
       *
       * A modifier is a function that is called each time Popper.js needs to
       * compute the position of the popper.
       * For this reason, modifiers should be very performant to avoid bottlenecks.
       * To learn how to create a modifier, [read the modifiers documentation](https://popper.js.org/docs/v2/modifiers/).
       */
      modifiers: propTypes.exports.arrayOf(propTypes.exports.shape({
        data: propTypes.exports.object,
        effect: propTypes.exports.func,
        enabled: propTypes.exports.bool,
        fn: propTypes.exports.func,
        name: propTypes.exports.any,
        options: propTypes.exports.object,
        phase: propTypes.exports.oneOf(['afterMain', 'afterRead', 'afterWrite', 'beforeMain', 'beforeRead', 'beforeWrite', 'main', 'read', 'write']),
        requires: propTypes.exports.arrayOf(propTypes.exports.string),
        requiresIfExists: propTypes.exports.arrayOf(propTypes.exports.string)
      })),

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * Popper placement.
       * @default 'bottom'
       */
      placement: propTypes.exports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),

      /**
       * Options provided to the [`Popper.js`](https://popper.js.org/docs/v2/constructors/#options) instance.
       * @default {}
       */
      popperOptions: propTypes.exports.shape({
        modifiers: propTypes.exports.array,
        onFirstUpdate: propTypes.exports.func,
        placement: propTypes.exports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
        strategy: propTypes.exports.oneOf(['absolute', 'fixed'])
      }),

      /**
       * A ref that points to the used popper instance.
       */
      popperRef: refType,

      /**
       * Help supporting a react-transition-group/Transition component.
       * @default false
       */
      transition: propTypes.exports.bool
    } : void 0;
    var Popper$1 = Popper;

    var CancelIcon = createSvgIcon$1( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
      d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm5 13.59L15.59 17 12 13.41 8.41 17 7 15.59 10.59 12 7 8.41 8.41 7 12 10.59 15.59 7 17 8.41 13.41 12 17 15.59z"
    }), 'Cancel');

    function getChipUtilityClass(slot) {
      return generateUtilityClass('MuiChip', slot);
    }
    const chipClasses = generateUtilityClasses('MuiChip', ['root', 'sizeSmall', 'sizeMedium', 'colorPrimary', 'colorSecondary', 'disabled', 'clickable', 'clickableColorPrimary', 'clickableColorSecondary', 'deletable', 'deletableColorPrimary', 'deletableColorSecondary', 'outlined', 'filled', 'outlinedPrimary', 'outlinedSecondary', 'avatar', 'avatarSmall', 'avatarMedium', 'avatarColorPrimary', 'avatarColorSecondary', 'icon', 'iconSmall', 'iconMedium', 'iconColorPrimary', 'iconColorSecondary', 'label', 'labelSmall', 'labelMedium', 'deleteIcon', 'deleteIconSmall', 'deleteIconMedium', 'deleteIconColorPrimary', 'deleteIconColorSecondary', 'deleteIconOutlinedColorPrimary', 'deleteIconOutlinedColorSecondary', 'focusVisible']);
    var chipClasses$1 = chipClasses;

    const _excluded$w = ["avatar", "className", "clickable", "color", "component", "deleteIcon", "disabled", "icon", "label", "onClick", "onDelete", "onKeyDown", "onKeyUp", "size", "variant"];

    const useUtilityClasses$p = ownerState => {
      const {
        classes,
        disabled,
        size,
        color,
        onDelete,
        clickable,
        variant
      } = ownerState;
      const slots = {
        root: ['root', variant, disabled && 'disabled', `size${capitalize(size)}`, `color${capitalize(color)}`, clickable && 'clickable', clickable && `clickableColor${capitalize(color)}`, onDelete && 'deletable', onDelete && `deletableColor${capitalize(color)}`, `${variant}${capitalize(color)}`],
        label: ['label', `label${capitalize(size)}`],
        avatar: ['avatar', `avatar${capitalize(size)}`, `avatarColor${capitalize(color)}`],
        icon: ['icon', `icon${capitalize(size)}`, `iconColor${capitalize(color)}`],
        deleteIcon: ['deleteIcon', `deleteIcon${capitalize(size)}`, `deleteIconColor${capitalize(color)}`, `deleteIconOutlinedColor${capitalize(color)}`]
      };
      return composeClasses(slots, getChipUtilityClass, classes);
    };

    const ChipRoot = styled$1('div', {
      name: 'MuiChip',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        const {
          color,
          clickable,
          onDelete,
          size,
          variant
        } = ownerState;
        return [{
          [`& .${chipClasses$1.avatar}`]: styles.avatar
        }, {
          [`& .${chipClasses$1.avatar}`]: styles[`avatar${capitalize(size)}`]
        }, {
          [`& .${chipClasses$1.avatar}`]: styles[`avatarColor${capitalize(color)}`]
        }, {
          [`& .${chipClasses$1.icon}`]: styles.icon
        }, {
          [`& .${chipClasses$1.icon}`]: styles[`icon${capitalize(size)}`]
        }, {
          [`& .${chipClasses$1.icon}`]: styles[`iconColor${capitalize(color)}`]
        }, {
          [`& .${chipClasses$1.deleteIcon}`]: styles.deleteIcon
        }, {
          [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIcon${capitalize(size)}`]
        }, {
          [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIconColor${capitalize(color)}`]
        }, {
          [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIconOutlinedColor${capitalize(color)}`]
        }, styles.root, styles[`size${capitalize(size)}`], styles[`color${capitalize(color)}`], clickable && styles.clickable, clickable && color !== 'default' && styles[`clickableColor${capitalize(color)})`], onDelete && styles.deletable, onDelete && color !== 'default' && styles[`deletableColor${capitalize(color)}`], styles[variant], variant === 'outlined' && styles[`outlined${capitalize(color)}`]];
      }
    })(({
      theme,
      ownerState
    }) => {
      const deleteIconColor = alpha(theme.palette.text.primary, 0.26);
      return _extends$1({
        maxWidth: '100%',
        fontFamily: theme.typography.fontFamily,
        fontSize: theme.typography.pxToRem(13),
        display: 'inline-flex',
        alignItems: 'center',
        justifyContent: 'center',
        height: 32,
        color: theme.palette.text.primary,
        backgroundColor: theme.palette.action.selected,
        borderRadius: 32 / 2,
        whiteSpace: 'nowrap',
        transition: theme.transitions.create(['background-color', 'box-shadow']),
        // label will inherit this from root, then `clickable` class overrides this for both
        cursor: 'default',
        // We disable the focus ring for mouse, touch and keyboard users.
        outline: 0,
        textDecoration: 'none',
        border: 0,
        // Remove `button` border
        padding: 0,
        // Remove `button` padding
        verticalAlign: 'middle',
        boxSizing: 'border-box',
        [`&.${chipClasses$1.disabled}`]: {
          opacity: theme.palette.action.disabledOpacity,
          pointerEvents: 'none'
        },
        [`& .${chipClasses$1.avatar}`]: {
          marginLeft: 5,
          marginRight: -6,
          width: 24,
          height: 24,
          color: theme.palette.mode === 'light' ? theme.palette.grey[700] : theme.palette.grey[300],
          fontSize: theme.typography.pxToRem(12)
        },
        [`& .${chipClasses$1.avatarColorPrimary}`]: {
          color: theme.palette.primary.contrastText,
          backgroundColor: theme.palette.primary.dark
        },
        [`& .${chipClasses$1.avatarColorSecondary}`]: {
          color: theme.palette.secondary.contrastText,
          backgroundColor: theme.palette.secondary.dark
        },
        [`& .${chipClasses$1.avatarSmall}`]: {
          marginLeft: 4,
          marginRight: -4,
          width: 18,
          height: 18,
          fontSize: theme.typography.pxToRem(10)
        },
        [`& .${chipClasses$1.icon}`]: _extends$1({
          color: theme.palette.mode === 'light' ? theme.palette.grey[700] : theme.palette.grey[300],
          marginLeft: 5,
          marginRight: -6
        }, ownerState.size === 'small' && {
          fontSize: 18,
          marginLeft: 4,
          marginRight: -4
        }, ownerState.color !== 'default' && {
          color: 'inherit'
        }),
        [`& .${chipClasses$1.deleteIcon}`]: _extends$1({
          WebkitTapHighlightColor: 'transparent',
          color: deleteIconColor,
          fontSize: 22,
          cursor: 'pointer',
          margin: '0 5px 0 -6px',
          '&:hover': {
            color: alpha(deleteIconColor, 0.4)
          }
        }, ownerState.size === 'small' && {
          fontSize: 16,
          marginRight: 4,
          marginLeft: -4
        }, ownerState.color !== 'default' && {
          color: alpha(theme.palette[ownerState.color].contrastText, 0.7),
          '&:hover, &:active': {
            color: theme.palette[ownerState.color].contrastText
          }
        })
      }, ownerState.size === 'small' && {
        height: 24
      }, ownerState.color !== 'default' && {
        backgroundColor: theme.palette[ownerState.color].main,
        color: theme.palette[ownerState.color].contrastText
      }, ownerState.onDelete && {
        [`&.${chipClasses$1.focusVisible}`]: {
          backgroundColor: alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
        }
      }, ownerState.onDelete && ownerState.color !== 'default' && {
        [`&.${chipClasses$1.focusVisible}`]: {
          backgroundColor: theme.palette[ownerState.color].dark
        }
      });
    }, ({
      theme,
      ownerState
    }) => _extends$1({}, ownerState.clickable && {
      userSelect: 'none',
      WebkitTapHighlightColor: 'transparent',
      cursor: 'pointer',
      '&:hover': {
        backgroundColor: alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity)
      },
      [`&.${chipClasses$1.focusVisible}`]: {
        backgroundColor: alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
      },
      '&:active': {
        boxShadow: theme.shadows[1]
      }
    }, ownerState.clickable && ownerState.color !== 'default' && {
      [`&:hover, &.${chipClasses$1.focusVisible}`]: {
        backgroundColor: theme.palette[ownerState.color].dark
      }
    }), ({
      theme,
      ownerState
    }) => _extends$1({}, ownerState.variant === 'outlined' && {
      backgroundColor: 'transparent',
      border: `1px solid ${theme.palette.mode === 'light' ? theme.palette.grey[400] : theme.palette.grey[700]}`,
      [`&.${chipClasses$1.clickable}:hover`]: {
        backgroundColor: theme.palette.action.hover
      },
      [`&.${chipClasses$1.focusVisible}`]: {
        backgroundColor: theme.palette.action.focus
      },
      [`& .${chipClasses$1.avatar}`]: {
        marginLeft: 4
      },
      [`& .${chipClasses$1.avatarSmall}`]: {
        marginLeft: 2
      },
      [`& .${chipClasses$1.icon}`]: {
        marginLeft: 4
      },
      [`& .${chipClasses$1.iconSmall}`]: {
        marginLeft: 2
      },
      [`& .${chipClasses$1.deleteIcon}`]: {
        marginRight: 5
      },
      [`& .${chipClasses$1.deleteIconSmall}`]: {
        marginRight: 3
      }
    }, ownerState.variant === 'outlined' && ownerState.color !== 'default' && {
      color: theme.palette[ownerState.color].main,
      border: `1px solid ${alpha(theme.palette[ownerState.color].main, 0.7)}`,
      [`&.${chipClasses$1.clickable}:hover`]: {
        backgroundColor: alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity)
      },
      [`&.${chipClasses$1.focusVisible}`]: {
        backgroundColor: alpha(theme.palette[ownerState.color].main, theme.palette.action.focusOpacity)
      },
      [`& .${chipClasses$1.deleteIcon}`]: {
        color: alpha(theme.palette[ownerState.color].main, 0.7),
        '&:hover, &:active': {
          color: theme.palette[ownerState.color].main
        }
      }
    }));
    const ChipLabel = styled$1('span', {
      name: 'MuiChip',
      slot: 'Label',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        const {
          size
        } = ownerState;
        return [styles.label, styles[`label${capitalize(size)}`]];
      }
    })(({
      ownerState
    }) => _extends$1({
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      paddingLeft: 12,
      paddingRight: 12,
      whiteSpace: 'nowrap'
    }, ownerState.size === 'small' && {
      paddingLeft: 8,
      paddingRight: 8
    }));

    function isDeleteKeyboardEvent(keyboardEvent) {
      return keyboardEvent.key === 'Backspace' || keyboardEvent.key === 'Delete';
    }
    /**
     * Chips represent complex entities in small blocks, such as a contact.
     */


    const Chip = /*#__PURE__*/react.exports.forwardRef(function Chip(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiChip'
      });

      const {
        avatar: avatarProp,
        className,
        clickable: clickableProp,
        color = 'default',
        component: ComponentProp,
        deleteIcon: deleteIconProp,
        disabled = false,
        icon: iconProp,
        label,
        onClick,
        onDelete,
        onKeyDown,
        onKeyUp,
        size = 'medium',
        variant = 'filled'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$w);

      const chipRef = react.exports.useRef(null);
      const handleRef = useForkRef(chipRef, ref);

      const handleDeleteIconClick = event => {
        // Stop the event from bubbling up to the `Chip`
        event.stopPropagation();

        if (onDelete) {
          onDelete(event);
        }
      };

      const handleKeyDown = event => {
        // Ignore events from children of `Chip`.
        if (event.currentTarget === event.target && isDeleteKeyboardEvent(event)) {
          // Will be handled in keyUp, otherwise some browsers
          // might init navigation
          event.preventDefault();
        }

        if (onKeyDown) {
          onKeyDown(event);
        }
      };

      const handleKeyUp = event => {
        // Ignore events from children of `Chip`.
        if (event.currentTarget === event.target) {
          if (onDelete && isDeleteKeyboardEvent(event)) {
            onDelete(event);
          } else if (event.key === 'Escape' && chipRef.current) {
            chipRef.current.blur();
          }
        }

        if (onKeyUp) {
          onKeyUp(event);
        }
      };

      const clickable = clickableProp !== false && onClick ? true : clickableProp;
      const small = size === 'small';
      const component = clickable || onDelete ? ButtonBase$1 : ComponentProp || 'div';

      const ownerState = _extends$1({}, props, {
        component,
        disabled,
        size,
        color,
        onDelete: !!onDelete,
        clickable,
        variant
      });

      const classes = useUtilityClasses$p(ownerState);
      const moreProps = component === ButtonBase$1 ? _extends$1({
        component: ComponentProp || 'div',
        focusVisibleClassName: classes.focusVisible
      }, onDelete && {
        disableRipple: true
      }) : {};
      let deleteIcon = null;

      if (onDelete) {
        const customClasses = clsx(color !== 'default' && (variant === 'outlined' ? classes[`deleteIconOutlinedColor${capitalize(color)}`] : classes[`deleteIconColor${capitalize(color)}`]), small && classes.deleteIconSmall);
        deleteIcon = deleteIconProp && /*#__PURE__*/react.exports.isValidElement(deleteIconProp) ? /*#__PURE__*/react.exports.cloneElement(deleteIconProp, {
          className: clsx(deleteIconProp.props.className, classes.deleteIcon, customClasses),
          onClick: handleDeleteIconClick
        }) : /*#__PURE__*/jsxRuntimeExports.jsx(CancelIcon, {
          className: clsx(classes.deleteIcon, customClasses),
          onClick: handleDeleteIconClick
        });
      }

      let avatar = null;

      if (avatarProp && /*#__PURE__*/react.exports.isValidElement(avatarProp)) {
        avatar = /*#__PURE__*/react.exports.cloneElement(avatarProp, {
          className: clsx(classes.avatar, avatarProp.props.className)
        });
      }

      let icon = null;

      if (iconProp && /*#__PURE__*/react.exports.isValidElement(iconProp)) {
        icon = /*#__PURE__*/react.exports.cloneElement(iconProp, {
          className: clsx(classes.icon, iconProp.props.className)
        });
      }

      if (process.env.NODE_ENV !== 'production') {
        if (avatar && icon) {
          console.error('MUI: The Chip component can not handle the avatar ' + 'and the icon prop at the same time. Pick one.');
        }
      }

      return /*#__PURE__*/jsxRuntimeExports.jsxs(ChipRoot, _extends$1({
        as: component,
        className: clsx(classes.root, className),
        disabled: clickable && disabled ? true : undefined,
        onClick: onClick,
        onKeyDown: handleKeyDown,
        onKeyUp: handleKeyUp,
        ref: handleRef,
        ownerState: ownerState
      }, moreProps, other, {
        children: [avatar || icon, /*#__PURE__*/jsxRuntimeExports.jsx(ChipLabel, {
          className: clsx(classes.label),
          ownerState: ownerState,
          children: label
        }), deleteIcon]
      }));
    });
    process.env.NODE_ENV !== "production" ? Chip.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The Avatar element to display.
       */
      avatar: propTypes.exports.element,

      /**
       * This prop isn't supported.
       * Use the `component` prop if you need to change the children structure.
       */
      children: unsupportedProp,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * If `true`, the chip will appear clickable, and will raise when pressed,
       * even if the onClick prop is not defined.
       * If `false`, the chip will not appear clickable, even if onClick prop is defined.
       * This can be used, for example,
       * along with the component prop to indicate an anchor Chip is clickable.
       * Note: this controls the UI and does not affect the onClick event.
       */
      clickable: propTypes.exports.bool,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * @default 'default'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * Override the default delete icon element. Shown only if `onDelete` is set.
       */
      deleteIcon: propTypes.exports.element,

      /**
       * If `true`, the component is disabled.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * Icon element.
       */
      icon: propTypes.exports.element,

      /**
       * The content of the component.
       */
      label: propTypes.exports.node,

      /**
       * @ignore
       */
      onClick: propTypes.exports.func,

      /**
       * Callback fired when the delete icon is clicked.
       * If set, the delete icon will be shown.
       */
      onDelete: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyDown: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyUp: propTypes.exports.func,

      /**
       * The size of the component.
       * @default 'medium'
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['medium', 'small']), propTypes.exports.string]),

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The variant to use.
       * @default 'filled'
       */
      variant: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['filled', 'outlined']), propTypes.exports.string])
    } : void 0;
    var Chip$1 = Chip;

    function formControlState({
      props,
      states,
      muiFormControl
    }) {
      return states.reduce((acc, state) => {
        acc[state] = props[state];

        if (muiFormControl) {
          if (typeof props[state] === 'undefined') {
            acc[state] = muiFormControl[state];
          }
        }

        return acc;
      }, {});
    }

    /**
     * @ignore - internal component.
     */

    const FormControlContext = /*#__PURE__*/react.exports.createContext();

    if (process.env.NODE_ENV !== 'production') {
      FormControlContext.displayName = 'FormControlContext';
    }

    function useFormControl() {
      return react.exports.useContext(FormControlContext);
    }

    function GlobalStyles(props) {
      return /*#__PURE__*/jsxRuntimeExports.jsx(GlobalStyles$1, _extends$1({}, props, {
        defaultTheme: defaultTheme$1
      }));
    }

    process.env.NODE_ENV !== "production" ? GlobalStyles.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The styles you want to apply globally.
       */
      styles: propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.number, propTypes.exports.object, propTypes.exports.shape({
        __emotion_styles: propTypes.exports.any.isRequired
      }), propTypes.exports.string, propTypes.exports.bool])
    } : void 0;

    // Supports determination of isControlled().
    // Controlled input accepts its current value as a prop.
    //
    // @see https://facebook.github.io/react/docs/forms.html#controlled-components
    // @param value
    // @returns {boolean} true if string (including '') or number (including zero)
    function hasValue(value) {
      return value != null && !(Array.isArray(value) && value.length === 0);
    } // Determine if field is empty or filled.
    // Response determines if label is presented above field or as placeholder.
    //
    // @param obj
    // @param SSR
    // @returns {boolean} False when not present or empty string.
    //                    True when any number or string with length.

    function isFilled(obj, SSR = false) {
      return obj && (hasValue(obj.value) && obj.value !== '' || SSR && hasValue(obj.defaultValue) && obj.defaultValue !== '');
    } // Determine if an Input is adorned on start.
    // It's corresponding to the left with LTR.
    //
    // @param obj
    // @returns {boolean} False when no adornments.
    //                    True when adorned at the start.

    function isAdornedStart(obj) {
      return obj.startAdornment;
    }

    function getInputBaseUtilityClass(slot) {
      return generateUtilityClass('MuiInputBase', slot);
    }
    const inputBaseClasses = generateUtilityClasses('MuiInputBase', ['root', 'formControl', 'focused', 'disabled', 'adornedStart', 'adornedEnd', 'error', 'sizeSmall', 'multiline', 'colorSecondary', 'fullWidth', 'hiddenLabel', 'input', 'inputSizeSmall', 'inputMultiline', 'inputTypeSearch', 'inputAdornedStart', 'inputAdornedEnd', 'inputHiddenLabel']);
    var inputBaseClasses$1 = inputBaseClasses;

    const _excluded$v = ["aria-describedby", "autoComplete", "autoFocus", "className", "color", "components", "componentsProps", "defaultValue", "disabled", "disableInjectingGlobalStyles", "endAdornment", "error", "fullWidth", "id", "inputComponent", "inputProps", "inputRef", "margin", "maxRows", "minRows", "multiline", "name", "onBlur", "onChange", "onClick", "onFocus", "onKeyDown", "onKeyUp", "placeholder", "readOnly", "renderSuffix", "rows", "size", "startAdornment", "type", "value"];
    const rootOverridesResolver = (props, styles) => {
      const {
        ownerState
      } = props;
      return [styles.root, ownerState.formControl && styles.formControl, ownerState.startAdornment && styles.adornedStart, ownerState.endAdornment && styles.adornedEnd, ownerState.error && styles.error, ownerState.size === 'small' && styles.sizeSmall, ownerState.multiline && styles.multiline, ownerState.color && styles[`color${capitalize(ownerState.color)}`], ownerState.fullWidth && styles.fullWidth, ownerState.hiddenLabel && styles.hiddenLabel];
    };
    const inputOverridesResolver = (props, styles) => {
      const {
        ownerState
      } = props;
      return [styles.input, ownerState.size === 'small' && styles.inputSizeSmall, ownerState.multiline && styles.inputMultiline, ownerState.type === 'search' && styles.inputTypeSearch, ownerState.startAdornment && styles.inputAdornedStart, ownerState.endAdornment && styles.inputAdornedEnd, ownerState.hiddenLabel && styles.inputHiddenLabel];
    };

    const useUtilityClasses$o = ownerState => {
      const {
        classes,
        color,
        disabled,
        error,
        endAdornment,
        focused,
        formControl,
        fullWidth,
        hiddenLabel,
        multiline,
        size,
        startAdornment,
        type
      } = ownerState;
      const slots = {
        root: ['root', `color${capitalize(color)}`, disabled && 'disabled', error && 'error', fullWidth && 'fullWidth', focused && 'focused', formControl && 'formControl', size === 'small' && 'sizeSmall', multiline && 'multiline', startAdornment && 'adornedStart', endAdornment && 'adornedEnd', hiddenLabel && 'hiddenLabel'],
        input: ['input', disabled && 'disabled', type === 'search' && 'inputTypeSearch', multiline && 'inputMultiline', size === 'small' && 'inputSizeSmall', hiddenLabel && 'inputHiddenLabel', startAdornment && 'inputAdornedStart', endAdornment && 'inputAdornedEnd']
      };
      return composeClasses(slots, getInputBaseUtilityClass, classes);
    };

    const InputBaseRoot = styled$1('div', {
      name: 'MuiInputBase',
      slot: 'Root',
      overridesResolver: rootOverridesResolver
    })(({
      theme,
      ownerState
    }) => _extends$1({}, theme.typography.body1, {
      color: theme.palette.text.primary,
      lineHeight: '1.4375em',
      // 23px
      boxSizing: 'border-box',
      // Prevent padding issue with fullWidth.
      position: 'relative',
      cursor: 'text',
      display: 'inline-flex',
      alignItems: 'center',
      [`&.${inputBaseClasses$1.disabled}`]: {
        color: theme.palette.text.disabled,
        cursor: 'default'
      }
    }, ownerState.multiline && _extends$1({
      padding: '4px 0 5px'
    }, ownerState.size === 'small' && {
      paddingTop: 1
    }), ownerState.fullWidth && {
      width: '100%'
    }));
    const InputBaseComponent = styled$1('input', {
      name: 'MuiInputBase',
      slot: 'Input',
      overridesResolver: inputOverridesResolver
    })(({
      theme,
      ownerState
    }) => {
      const light = theme.palette.mode === 'light';
      const placeholder = {
        color: 'currentColor',
        opacity: light ? 0.42 : 0.5,
        transition: theme.transitions.create('opacity', {
          duration: theme.transitions.duration.shorter
        })
      };
      const placeholderHidden = {
        opacity: '0 !important'
      };
      const placeholderVisible = {
        opacity: light ? 0.42 : 0.5
      };
      return _extends$1({
        font: 'inherit',
        letterSpacing: 'inherit',
        color: 'currentColor',
        padding: '4px 0 5px',
        border: 0,
        boxSizing: 'content-box',
        background: 'none',
        height: '1.4375em',
        // Reset 23pxthe native input line-height
        margin: 0,
        // Reset for Safari
        WebkitTapHighlightColor: 'transparent',
        display: 'block',
        // Make the flex item shrink with Firefox
        minWidth: 0,
        width: '100%',
        // Fix IE11 width issue
        animationName: 'mui-auto-fill-cancel',
        animationDuration: '10ms',
        '&::-webkit-input-placeholder': placeholder,
        '&::-moz-placeholder': placeholder,
        // Firefox 19+
        '&:-ms-input-placeholder': placeholder,
        // IE11
        '&::-ms-input-placeholder': placeholder,
        // Edge
        '&:focus': {
          outline: 0
        },
        // Reset Firefox invalid required input style
        '&:invalid': {
          boxShadow: 'none'
        },
        '&::-webkit-search-decoration': {
          // Remove the padding when type=search.
          WebkitAppearance: 'none'
        },
        // Show and hide the placeholder logic
        [`label[data-shrink=false] + .${inputBaseClasses$1.formControl} &`]: {
          '&::-webkit-input-placeholder': placeholderHidden,
          '&::-moz-placeholder': placeholderHidden,
          // Firefox 19+
          '&:-ms-input-placeholder': placeholderHidden,
          // IE11
          '&::-ms-input-placeholder': placeholderHidden,
          // Edge
          '&:focus::-webkit-input-placeholder': placeholderVisible,
          '&:focus::-moz-placeholder': placeholderVisible,
          // Firefox 19+
          '&:focus:-ms-input-placeholder': placeholderVisible,
          // IE11
          '&:focus::-ms-input-placeholder': placeholderVisible // Edge

        },
        [`&.${inputBaseClasses$1.disabled}`]: {
          opacity: 1,
          // Reset iOS opacity
          WebkitTextFillColor: theme.palette.text.disabled // Fix opacity Safari bug

        },
        '&:-webkit-autofill': {
          animationDuration: '5000s',
          animationName: 'mui-auto-fill'
        }
      }, ownerState.size === 'small' && {
        paddingTop: 1
      }, ownerState.multiline && {
        height: 'auto',
        resize: 'none',
        padding: 0,
        paddingTop: 0
      }, ownerState.type === 'search' && {
        // Improve type search style.
        MozAppearance: 'textfield'
      });
    });

    const inputGlobalStyles = /*#__PURE__*/jsxRuntimeExports.jsx(GlobalStyles, {
      styles: {
        '@keyframes mui-auto-fill': {
          from: {
            display: 'block'
          }
        },
        '@keyframes mui-auto-fill-cancel': {
          from: {
            display: 'block'
          }
        }
      }
    });
    /**
     * `InputBase` contains as few styles as possible.
     * It aims to be a simple building block for creating an input.
     * It contains a load of style reset and some state logic.
     */


    const InputBase = /*#__PURE__*/react.exports.forwardRef(function InputBase(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiInputBase'
      });

      const {
        'aria-describedby': ariaDescribedby,
        autoComplete,
        autoFocus,
        className,
        components = {},
        componentsProps = {},
        defaultValue,
        disabled,
        disableInjectingGlobalStyles,
        endAdornment,
        fullWidth = false,
        id,
        inputComponent = 'input',
        inputProps: inputPropsProp = {},
        inputRef: inputRefProp,
        maxRows,
        minRows,
        multiline = false,
        name,
        onBlur,
        onChange,
        onClick,
        onFocus,
        onKeyDown,
        onKeyUp,
        placeholder,
        readOnly,
        renderSuffix,
        rows,
        startAdornment,
        type = 'text',
        value: valueProp
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$v);

      const value = inputPropsProp.value != null ? inputPropsProp.value : valueProp;
      const {
        current: isControlled
      } = react.exports.useRef(value != null);
      const inputRef = react.exports.useRef();
      const handleInputRefWarning = react.exports.useCallback(instance => {
        if (process.env.NODE_ENV !== 'production') {
          if (instance && instance.nodeName !== 'INPUT' && !instance.focus) {
            console.error(['MUI: You have provided a `inputComponent` to the input component', 'that does not correctly handle the `ref` prop.', 'Make sure the `ref` prop is called with a HTMLInputElement.'].join('\n'));
          }
        }
      }, []);
      const handleInputPropsRefProp = useForkRef(inputPropsProp.ref, handleInputRefWarning);
      const handleInputRefProp = useForkRef(inputRefProp, handleInputPropsRefProp);
      const handleInputRef = useForkRef(inputRef, handleInputRefProp);
      const [focused, setFocused] = react.exports.useState(false);
      const muiFormControl = useFormControl();

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        react.exports.useEffect(() => {
          if (muiFormControl) {
            return muiFormControl.registerEffect();
          }

          return undefined;
        }, [muiFormControl]);
      }

      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['color', 'disabled', 'error', 'hiddenLabel', 'size', 'required', 'filled']
      });
      fcs.focused = muiFormControl ? muiFormControl.focused : focused; // The blur won't fire when the disabled state is set on a focused input.
      // We need to book keep the focused state manually.

      react.exports.useEffect(() => {
        if (!muiFormControl && disabled && focused) {
          setFocused(false);

          if (onBlur) {
            onBlur();
          }
        }
      }, [muiFormControl, disabled, focused, onBlur]);
      const onFilled = muiFormControl && muiFormControl.onFilled;
      const onEmpty = muiFormControl && muiFormControl.onEmpty;
      const checkDirty = react.exports.useCallback(obj => {
        if (isFilled(obj)) {
          if (onFilled) {
            onFilled();
          }
        } else if (onEmpty) {
          onEmpty();
        }
      }, [onFilled, onEmpty]);
      useEnhancedEffect(() => {
        if (isControlled) {
          checkDirty({
            value
          });
        }
      }, [value, checkDirty, isControlled]);

      const handleFocus = event => {
        // Fix a bug with IE11 where the focus/blur events are triggered
        // while the component is disabled.
        if (fcs.disabled) {
          event.stopPropagation();
          return;
        }

        if (onFocus) {
          onFocus(event);
        }

        if (inputPropsProp.onFocus) {
          inputPropsProp.onFocus(event);
        }

        if (muiFormControl && muiFormControl.onFocus) {
          muiFormControl.onFocus(event);
        } else {
          setFocused(true);
        }
      };

      const handleBlur = event => {
        if (onBlur) {
          onBlur(event);
        }

        if (inputPropsProp.onBlur) {
          inputPropsProp.onBlur(event);
        }

        if (muiFormControl && muiFormControl.onBlur) {
          muiFormControl.onBlur(event);
        } else {
          setFocused(false);
        }
      };

      const handleChange = (event, ...args) => {
        if (!isControlled) {
          const element = event.target || inputRef.current;

          if (element == null) {
            throw new Error(process.env.NODE_ENV !== "production" ? `MUI: Expected valid input target. Did you use a custom \`inputComponent\` and forget to forward refs? See https://mui.com/r/input-component-ref-interface for more info.` : formatMuiErrorMessage(1));
          }

          checkDirty({
            value: element.value
          });
        }

        if (inputPropsProp.onChange) {
          inputPropsProp.onChange(event, ...args);
        } // Perform in the willUpdate


        if (onChange) {
          onChange(event, ...args);
        }
      }; // Check the input state on mount, in case it was filled by the user
      // or auto filled by the browser before the hydration (for SSR).


      react.exports.useEffect(() => {
        checkDirty(inputRef.current); // eslint-disable-next-line react-hooks/exhaustive-deps
      }, []);

      const handleClick = event => {
        if (inputRef.current && event.currentTarget === event.target) {
          inputRef.current.focus();
        }

        if (onClick) {
          onClick(event);
        }
      };

      let InputComponent = inputComponent;
      let inputProps = inputPropsProp;

      if (multiline && InputComponent === 'input') {
        if (rows) {
          if (process.env.NODE_ENV !== 'production') {
            if (minRows || maxRows) {
              console.warn('MUI: You can not use the `minRows` or `maxRows` props when the input `rows` prop is set.');
            }
          }

          inputProps = _extends$1({
            type: undefined,
            minRows: rows,
            maxRows: rows
          }, inputProps);
        } else {
          inputProps = _extends$1({
            type: undefined,
            maxRows,
            minRows
          }, inputProps);
        }

        InputComponent = TextareaAutosize$1;
      }

      const handleAutoFill = event => {
        // Provide a fake value as Chrome might not let you access it for security reasons.
        checkDirty(event.animationName === 'mui-auto-fill-cancel' ? inputRef.current : {
          value: 'x'
        });
      };

      react.exports.useEffect(() => {
        if (muiFormControl) {
          muiFormControl.setAdornedStart(Boolean(startAdornment));
        }
      }, [muiFormControl, startAdornment]);

      const ownerState = _extends$1({}, props, {
        color: fcs.color || 'primary',
        disabled: fcs.disabled,
        endAdornment,
        error: fcs.error,
        focused: fcs.focused,
        formControl: muiFormControl,
        fullWidth,
        hiddenLabel: fcs.hiddenLabel,
        multiline,
        size: fcs.size,
        startAdornment,
        type
      });

      const classes = useUtilityClasses$o(ownerState);
      const Root = components.Root || InputBaseRoot;
      const rootProps = componentsProps.root || {};
      const Input = components.Input || InputBaseComponent;
      inputProps = _extends$1({}, inputProps, componentsProps.input);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
        children: [!disableInjectingGlobalStyles && inputGlobalStyles, /*#__PURE__*/jsxRuntimeExports.jsxs(Root, _extends$1({}, rootProps, !isHostComponent(Root) && {
          ownerState: _extends$1({}, ownerState, rootProps.ownerState)
        }, {
          ref: ref,
          onClick: handleClick
        }, other, {
          className: clsx(classes.root, rootProps.className, className),
          children: [startAdornment, /*#__PURE__*/jsxRuntimeExports.jsx(FormControlContext.Provider, {
            value: null,
            children: /*#__PURE__*/jsxRuntimeExports.jsx(Input, _extends$1({
              ownerState: ownerState,
              "aria-invalid": fcs.error,
              "aria-describedby": ariaDescribedby,
              autoComplete: autoComplete,
              autoFocus: autoFocus,
              defaultValue: defaultValue,
              disabled: fcs.disabled,
              id: id,
              onAnimationStart: handleAutoFill,
              name: name,
              placeholder: placeholder,
              readOnly: readOnly,
              required: fcs.required,
              rows: rows,
              value: value,
              onKeyDown: onKeyDown,
              onKeyUp: onKeyUp,
              type: type
            }, inputProps, !isHostComponent(Input) && {
              as: InputComponent,
              ownerState: _extends$1({}, ownerState, inputProps.ownerState)
            }, {
              ref: handleInputRef,
              className: clsx(classes.input, inputProps.className),
              onBlur: handleBlur,
              onChange: handleChange,
              onFocus: handleFocus
            }))
          }), endAdornment, renderSuffix ? renderSuffix(_extends$1({}, fcs, {
            startAdornment
          })) : null]
        }))]
      });
    });
    process.env.NODE_ENV !== "production" ? InputBase.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * @ignore
       */
      'aria-describedby': propTypes.exports.string,

      /**
       * This prop helps users to fill forms faster, especially on mobile devices.
       * The name can be confusing, as it's more like an autofill.
       * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
       */
      autoComplete: propTypes.exports.string,

      /**
       * If `true`, the `input` element is focused during the first mount.
       */
      autoFocus: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The components used for each slot inside the InputBase.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Input: propTypes.exports.elementType,
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Input.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        input: propTypes.exports.object,
        root: propTypes.exports.object
      }),

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the component is disabled.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, GlobalStyles for the auto-fill keyframes will not be injected/removed on mount/unmount. Make sure to inject them at the top of your application.
       * This option is intended to help with boosting the initial rendering performance if you are loading a big amount of Input components at once.
       * @default false
       */
      disableInjectingGlobalStyles: propTypes.exports.bool,

      /**
       * End `InputAdornment` for this component.
       */
      endAdornment: propTypes.exports.node,

      /**
       * If `true`, the `input` will indicate an error.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the `input` will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * The component used for the `input` element.
       * Either a string to use a HTML element or a component.
       * @default 'input'
       */
      inputComponent: elementTypeAcceptingRef$1,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       * @default {}
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
       */
      margin: propTypes.exports.oneOf(['dense', 'none']),

      /**
       * Maximum number of rows to display when multiline option is set to true.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display when multiline option is set to true.
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * If `true`, a `textarea` element is rendered.
       * @default false
       */
      multiline: propTypes.exports.bool,

      /**
       * Name attribute of the `input` element.
       */
      name: propTypes.exports.string,

      /**
       * Callback fired when the `input` is blurred.
       *
       * Notice that the first argument (event) might be undefined.
       */
      onBlur: propTypes.exports.func,

      /**
       * Callback fired when the value is changed.
       *
       * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * @ignore
       */
      onClick: propTypes.exports.func,

      /**
       * @ignore
       */
      onFocus: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyDown: propTypes.exports.func,

      /**
       * @ignore
       */
      onKeyUp: propTypes.exports.func,

      /**
       * The short hint displayed in the `input` before the user enters a value.
       */
      placeholder: propTypes.exports.string,

      /**
       * It prevents the user from changing the value of the field
       * (not from interacting with the field).
       */
      readOnly: propTypes.exports.bool,

      /**
       * @ignore
       */
      renderSuffix: propTypes.exports.func,

      /**
       * If `true`, the `input` element is required.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      required: propTypes.exports.bool,

      /**
       * Number of rows to display when multiline option is set to true.
       */
      rows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * The size of the component.
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['medium', 'small']), propTypes.exports.string]),

      /**
       * Start `InputAdornment` for this component.
       */
      startAdornment: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
       * @default 'text'
       */
      type: propTypes.exports.string,

      /**
       * The value of the `input` element, required for a controlled component.
       */
      value: propTypes.exports.any
    } : void 0;
    var InputBase$1 = InputBase;

    function getInputUtilityClass(slot) {
      return generateUtilityClass('MuiInput', slot);
    }

    const inputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiInput', ['root', 'underline', 'input']));

    var inputClasses$1 = inputClasses;

    function getOutlinedInputUtilityClass(slot) {
      return generateUtilityClass('MuiOutlinedInput', slot);
    }

    const outlinedInputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiOutlinedInput', ['root', 'notchedOutline', 'input']));

    var outlinedInputClasses$1 = outlinedInputClasses;

    function getFilledInputUtilityClass(slot) {
      return generateUtilityClass('MuiFilledInput', slot);
    }

    const filledInputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiFilledInput', ['root', 'underline', 'input']));

    var filledInputClasses$1 = filledInputClasses;

    var ArrowDropDownIcon = createSvgIcon$1( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
      d: "M7 10l5 5 5-5z"
    }), 'ArrowDropDown');

    const _excluded$u = ["addEndListener", "appear", "children", "easing", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "style", "timeout", "TransitionComponent"];
    const styles$1 = {
      entering: {
        opacity: 1
      },
      entered: {
        opacity: 1
      }
    };
    /**
     * The Fade transition is used by the [Modal](/components/modal/) component.
     * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
     */

    const Fade = /*#__PURE__*/react.exports.forwardRef(function Fade(props, ref) {
      const theme = useTheme();
      const defaultTimeout = {
        enter: theme.transitions.duration.enteringScreen,
        exit: theme.transitions.duration.leavingScreen
      };

      const {
        addEndListener,
        appear = true,
        children,
        easing,
        in: inProp,
        onEnter,
        onEntered,
        onEntering,
        onExit,
        onExited,
        onExiting,
        style,
        timeout = defaultTimeout,
        // eslint-disable-next-line react/prop-types
        TransitionComponent = Transition
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$u);
      const nodeRef = react.exports.useRef(null);
      const foreignRef = useForkRef(children.ref, ref);
      const handleRef = useForkRef(nodeRef, foreignRef);

      const normalizedTransitionCallback = callback => maybeIsAppearing => {
        if (callback) {
          const node = nodeRef.current; // onEnterXxx and onExitXxx callbacks have a different arguments.length value.

          if (maybeIsAppearing === undefined) {
            callback(node);
          } else {
            callback(node, maybeIsAppearing);
          }
        }
      };

      const handleEntering = normalizedTransitionCallback(onEntering);
      const handleEnter = normalizedTransitionCallback((node, isAppearing) => {
        reflow(node); // So the animation always start from the start.

        const transitionProps = getTransitionProps({
          style,
          timeout,
          easing
        }, {
          mode: 'enter'
        });
        node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
        node.style.transition = theme.transitions.create('opacity', transitionProps);

        if (onEnter) {
          onEnter(node, isAppearing);
        }
      });
      const handleEntered = normalizedTransitionCallback(onEntered);
      const handleExiting = normalizedTransitionCallback(onExiting);
      const handleExit = normalizedTransitionCallback(node => {
        const transitionProps = getTransitionProps({
          style,
          timeout,
          easing
        }, {
          mode: 'exit'
        });
        node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
        node.style.transition = theme.transitions.create('opacity', transitionProps);

        if (onExit) {
          onExit(node);
        }
      });
      const handleExited = normalizedTransitionCallback(onExited);

      const handleAddEndListener = next => {
        if (addEndListener) {
          // Old call signature before `react-transition-group` implemented `nodeRef`
          addEndListener(nodeRef.current, next);
        }
      };

      return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
        appear: appear,
        in: inProp,
        nodeRef: nodeRef ,
        onEnter: handleEnter,
        onEntered: handleEntered,
        onEntering: handleEntering,
        onExit: handleExit,
        onExited: handleExited,
        onExiting: handleExiting,
        addEndListener: handleAddEndListener,
        timeout: timeout
      }, other, {
        children: (state, childProps) => {
          return /*#__PURE__*/react.exports.cloneElement(children, _extends$1({
            style: _extends$1({
              opacity: 0,
              visibility: state === 'exited' && !inProp ? 'hidden' : undefined
            }, styles$1[state], style, children.props.style),
            ref: handleRef
          }, childProps));
        }
      }));
    });
    process.env.NODE_ENV !== "production" ? Fade.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Add a custom transition end trigger. Called with the transitioning DOM
       * node and a done callback. Allows for more fine grained transition end
       * logic. Note: Timeouts are still used as a fallback if provided.
       */
      addEndListener: propTypes.exports.func,

      /**
       * Perform the enter transition when it first mounts if `in` is also `true`.
       * Set this to `false` to disable this behavior.
       * @default true
       */
      appear: propTypes.exports.bool,

      /**
       * A single child content element.
       */
      children: elementAcceptingRef.isRequired,

      /**
       * The transition timing function.
       * You may specify a single easing or a object containing enter and exit values.
       */
      easing: propTypes.exports.oneOfType([propTypes.exports.shape({
        enter: propTypes.exports.string,
        exit: propTypes.exports.string
      }), propTypes.exports.string]),

      /**
       * If `true`, the component will transition in.
       */
      in: propTypes.exports.bool,

      /**
       * @ignore
       */
      onEnter: propTypes.exports.func,

      /**
       * @ignore
       */
      onEntered: propTypes.exports.func,

      /**
       * @ignore
       */
      onEntering: propTypes.exports.func,

      /**
       * @ignore
       */
      onExit: propTypes.exports.func,

      /**
       * @ignore
       */
      onExited: propTypes.exports.func,

      /**
       * @ignore
       */
      onExiting: propTypes.exports.func,

      /**
       * @ignore
       */
      style: propTypes.exports.object,

      /**
       * The duration for the transition, in milliseconds.
       * You may specify a single timeout for all transitions, or individually with an object.
       * @default {
       *   enter: theme.transitions.duration.enteringScreen,
       *   exit: theme.transitions.duration.leavingScreen,
       * }
       */
      timeout: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.shape({
        appear: propTypes.exports.number,
        enter: propTypes.exports.number,
        exit: propTypes.exports.number
      })])
    } : void 0;
    var Fade$1 = Fade;

    const _excluded$t = ["children", "components", "componentsProps", "className", "invisible", "open", "transitionDuration", "TransitionComponent"];

    const extendUtilityClasses$1 = ownerState => {
      const {
        classes
      } = ownerState;
      return classes;
    };

    const BackdropRoot = styled$1('div', {
      name: 'MuiBackdrop',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.invisible && styles.invisible];
      }
    })(({
      ownerState
    }) => _extends$1({
      position: 'fixed',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      right: 0,
      bottom: 0,
      top: 0,
      left: 0,
      backgroundColor: 'rgba(0, 0, 0, 0.5)',
      WebkitTapHighlightColor: 'transparent'
    }, ownerState.invisible && {
      backgroundColor: 'transparent'
    }));
    const Backdrop = /*#__PURE__*/react.exports.forwardRef(function Backdrop(inProps, ref) {
      var _componentsProps$root;

      const props = useThemeProps({
        props: inProps,
        name: 'MuiBackdrop'
      });

      const {
        children,
        components = {},
        componentsProps = {},
        className,
        invisible = false,
        open,
        transitionDuration,
        // eslint-disable-next-line react/prop-types
        TransitionComponent = Fade$1
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$t);

      const ownerState = _extends$1({}, props, {
        invisible
      });

      const classes = extendUtilityClasses$1(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
        in: open,
        timeout: transitionDuration
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(BackdropUnstyled$1, {
          className: className,
          invisible: invisible,
          components: _extends$1({
            Root: BackdropRoot
          }, components),
          componentsProps: {
            root: _extends$1({}, componentsProps.root, (!components.Root || !isHostComponent(components.Root)) && {
              ownerState: _extends$1({}, (_componentsProps$root = componentsProps.root) == null ? void 0 : _componentsProps$root.ownerState)
            })
          },
          classes: classes,
          ref: ref,
          children: children
        })
      }));
    });
    process.env.NODE_ENV !== "production" ? Backdrop.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The components used for each slot inside the Backdrop.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Backdrop.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        root: propTypes.exports.object
      }),

      /**
       * If `true`, the backdrop is invisible.
       * It can be used when rendering a popover or a custom select component.
       * @default false
       */
      invisible: propTypes.exports.bool,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The duration for the transition, in milliseconds.
       * You may specify a single timeout for all transitions, or individually with an object.
       */
      transitionDuration: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.shape({
        appear: propTypes.exports.number,
        enter: propTypes.exports.number,
        exit: propTypes.exports.number
      })])
    } : void 0;
    var Backdrop$1 = Backdrop;

    const defaultTheme = createTheme();
    /**
     * @ignore - do not document.
     */

    const Box = createBox({
      defaultTheme,
      defaultClassName: 'MuiBox-root',
      generateClassName: ClassNameGenerator$1.generate
    });
    var Box$1 = Box;

    var MoreHorizIcon = createSvgIcon$1( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
      d: "M6 10c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm12 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm-6 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
    }), 'MoreHoriz');

    const BreadcrumbCollapsedButton = styled$1(ButtonBase$1)(({
      theme
    }) => _extends$1({
      display: 'flex',
      marginLeft: `calc(${theme.spacing(1)} * 0.5)`,
      marginRight: `calc(${theme.spacing(1)} * 0.5)`
    }, theme.palette.mode === 'light' ? {
      backgroundColor: theme.palette.grey[100],
      color: theme.palette.grey[700]
    } : {
      backgroundColor: theme.palette.grey[700],
      color: theme.palette.grey[100]
    }, {
      borderRadius: 2,
      '&:hover, &:focus': _extends$1({}, theme.palette.mode === 'light' ? {
        backgroundColor: theme.palette.grey[200]
      } : {
        backgroundColor: theme.palette.grey[600]
      }),
      '&:active': _extends$1({
        boxShadow: theme.shadows[0]
      }, theme.palette.mode === 'light' ? {
        backgroundColor: emphasize(theme.palette.grey[200], 0.12)
      } : {
        backgroundColor: emphasize(theme.palette.grey[600], 0.12)
      })
    }));
    const BreadcrumbCollapsedIcon = styled$1(MoreHorizIcon)({
      width: 24,
      height: 16
    });
    /**
     * @ignore - internal component.
     */

    function BreadcrumbCollapsed(props) {
      const ownerState = props;
      return /*#__PURE__*/jsxRuntimeExports.jsx("li", {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbCollapsedButton, _extends$1({
          focusRipple: true
        }, props, {
          ownerState: ownerState,
          children: /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbCollapsedIcon, {
            ownerState: ownerState
          })
        }))
      });
    }

    process.env.NODE_ENV !== "production" ? BreadcrumbCollapsed.propTypes = {
      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.object
    } : void 0;

    function getBreadcrumbsUtilityClass(slot) {
      return generateUtilityClass('MuiBreadcrumbs', slot);
    }
    const breadcrumbsClasses = generateUtilityClasses('MuiBreadcrumbs', ['root', 'ol', 'li', 'separator']);
    var breadcrumbsClasses$1 = breadcrumbsClasses;

    const _excluded$s = ["children", "className", "component", "expandText", "itemsAfterCollapse", "itemsBeforeCollapse", "maxItems", "separator"];

    const useUtilityClasses$n = ownerState => {
      const {
        classes
      } = ownerState;
      const slots = {
        root: ['root'],
        li: ['li'],
        ol: ['ol'],
        separator: ['separator']
      };
      return composeClasses(slots, getBreadcrumbsUtilityClass, classes);
    };

    const BreadcrumbsRoot = styled$1(Typography$1, {
      name: 'MuiBreadcrumbs',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        return [{
          [`& .${breadcrumbsClasses$1.li}`]: styles.li
        }, styles.root];
      }
    })({});
    const BreadcrumbsOl = styled$1('ol', {
      name: 'MuiBreadcrumbs',
      slot: 'Ol',
      overridesResolver: (props, styles) => styles.ol
    })({
      display: 'flex',
      flexWrap: 'wrap',
      alignItems: 'center',
      padding: 0,
      margin: 0,
      listStyle: 'none'
    });
    const BreadcrumbsSeparator = styled$1('li', {
      name: 'MuiBreadcrumbs',
      slot: 'Separator',
      overridesResolver: (props, styles) => styles.separator
    })({
      display: 'flex',
      userSelect: 'none',
      marginLeft: 8,
      marginRight: 8
    });

    function insertSeparators(items, className, separator, ownerState) {
      return items.reduce((acc, current, index) => {
        if (index < items.length - 1) {
          acc = acc.concat(current, /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbsSeparator, {
            "aria-hidden": true,
            className: className,
            ownerState: ownerState,
            children: separator
          }, `separator-${index}`));
        } else {
          acc.push(current);
        }

        return acc;
      }, []);
    }

    const Breadcrumbs = /*#__PURE__*/react.exports.forwardRef(function Breadcrumbs(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiBreadcrumbs'
      });

      const {
        children,
        className,
        component = 'nav',
        expandText = 'Show path',
        itemsAfterCollapse = 1,
        itemsBeforeCollapse = 1,
        maxItems = 8,
        separator = '/'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$s);

      const [expanded, setExpanded] = react.exports.useState(false);

      const ownerState = _extends$1({}, props, {
        component,
        expanded,
        expandText,
        itemsAfterCollapse,
        itemsBeforeCollapse,
        maxItems,
        separator
      });

      const classes = useUtilityClasses$n(ownerState);
      const listRef = react.exports.useRef(null);

      const renderItemsBeforeAndAfter = allItems => {
        const handleClickExpand = () => {
          setExpanded(true); // The clicked element received the focus but gets removed from the DOM.
          // Let's keep the focus in the component after expanding.
          // Moving it to the <ol> or <nav> does not cause any announcement in NVDA.
          // By moving it to some link/button at least we have some announcement.

          const focusable = listRef.current.querySelector('a[href],button,[tabindex]');

          if (focusable) {
            focusable.focus();
          }
        }; // This defends against someone passing weird input, to ensure that if all
        // items would be shown anyway, we just show all items without the EllipsisItem


        if (itemsBeforeCollapse + itemsAfterCollapse >= allItems.length) {
          if (process.env.NODE_ENV !== 'production') {
            console.error(['MUI: You have provided an invalid combination of props to the Breadcrumbs.', `itemsAfterCollapse={${itemsAfterCollapse}} + itemsBeforeCollapse={${itemsBeforeCollapse}} >= maxItems={${maxItems}}`].join('\n'));
          }

          return allItems;
        }

        return [...allItems.slice(0, itemsBeforeCollapse), /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbCollapsed, {
          "aria-label": expandText,
          onClick: handleClickExpand
        }, "ellipsis"), ...allItems.slice(allItems.length - itemsAfterCollapse, allItems.length)];
      };

      const allItems = react.exports.Children.toArray(children).filter(child => {
        if (process.env.NODE_ENV !== 'production') {
          if (reactIs.exports.isFragment(child)) {
            console.error(["MUI: The Breadcrumbs component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
          }
        }

        return /*#__PURE__*/react.exports.isValidElement(child);
      }).map((child, index) => /*#__PURE__*/jsxRuntimeExports.jsx("li", {
        className: classes.li,
        children: child
      }, `child-${index}`));
      return /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbsRoot, _extends$1({
        ref: ref,
        component: component,
        color: "text.secondary",
        className: clsx(classes.root, className),
        ownerState: ownerState
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(BreadcrumbsOl, {
          className: classes.ol,
          ref: listRef,
          ownerState: ownerState,
          children: insertSeparators(expanded || maxItems && allItems.length <= maxItems ? allItems : renderItemsBeforeAndAfter(allItems), classes.separator, separator, ownerState)
        })
      }));
    });
    process.env.NODE_ENV !== "production" ? Breadcrumbs.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * Override the default label for the expand button.
       *
       * For localization purposes, you can use the provided [translations](/guides/localization/).
       * @default 'Show path'
       */
      expandText: propTypes.exports.string,

      /**
       * If max items is exceeded, the number of items to show after the ellipsis.
       * @default 1
       */
      itemsAfterCollapse: integerPropType,

      /**
       * If max items is exceeded, the number of items to show before the ellipsis.
       * @default 1
       */
      itemsBeforeCollapse: integerPropType,

      /**
       * Specifies the maximum number of breadcrumbs to display. When there are more
       * than the maximum number, only the first `itemsBeforeCollapse` and last `itemsAfterCollapse`
       * will be shown, with an ellipsis in between.
       * @default 8
       */
      maxItems: integerPropType,

      /**
       * Custom separator node.
       * @default '/'
       */
      separator: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var Breadcrumbs$1 = Breadcrumbs;

    function getButtonUtilityClass(slot) {
      return generateUtilityClass('MuiButton', slot);
    }
    const buttonClasses = generateUtilityClasses('MuiButton', ['root', 'text', 'textInherit', 'textPrimary', 'textSecondary', 'outlined', 'outlinedInherit', 'outlinedPrimary', 'outlinedSecondary', 'contained', 'containedInherit', 'containedPrimary', 'containedSecondary', 'disableElevation', 'focusVisible', 'disabled', 'colorInherit', 'textSizeSmall', 'textSizeMedium', 'textSizeLarge', 'outlinedSizeSmall', 'outlinedSizeMedium', 'outlinedSizeLarge', 'containedSizeSmall', 'containedSizeMedium', 'containedSizeLarge', 'sizeMedium', 'sizeSmall', 'sizeLarge', 'fullWidth', 'startIcon', 'endIcon', 'iconSizeSmall', 'iconSizeMedium', 'iconSizeLarge']);
    var buttonClasses$1 = buttonClasses;

    /**
     * @ignore - internal component.
     */
    const ButtonGroupContext = /*#__PURE__*/react.exports.createContext({});

    if (process.env.NODE_ENV !== 'production') {
      ButtonGroupContext.displayName = 'ButtonGroupContext';
    }

    var ButtonGroupContext$1 = ButtonGroupContext;

    const _excluded$r = ["children", "color", "component", "className", "disabled", "disableElevation", "disableFocusRipple", "endIcon", "focusVisibleClassName", "fullWidth", "size", "startIcon", "type", "variant"];

    const useUtilityClasses$m = ownerState => {
      const {
        color,
        disableElevation,
        fullWidth,
        size,
        variant,
        classes
      } = ownerState;
      const slots = {
        root: ['root', variant, `${variant}${capitalize(color)}`, `size${capitalize(size)}`, `${variant}Size${capitalize(size)}`, color === 'inherit' && 'colorInherit', disableElevation && 'disableElevation', fullWidth && 'fullWidth'],
        label: ['label'],
        startIcon: ['startIcon', `iconSize${capitalize(size)}`],
        endIcon: ['endIcon', `iconSize${capitalize(size)}`]
      };
      const composedClasses = composeClasses(slots, getButtonUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const commonIconStyles = ownerState => _extends$1({}, ownerState.size === 'small' && {
      '& > *:nth-of-type(1)': {
        fontSize: 18
      }
    }, ownerState.size === 'medium' && {
      '& > *:nth-of-type(1)': {
        fontSize: 20
      }
    }, ownerState.size === 'large' && {
      '& > *:nth-of-type(1)': {
        fontSize: 22
      }
    });

    const ButtonRoot = styled$1(ButtonBase$1, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiButton',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, styles[ownerState.variant], styles[`${ownerState.variant}${capitalize(ownerState.color)}`], styles[`size${capitalize(ownerState.size)}`], styles[`${ownerState.variant}Size${capitalize(ownerState.size)}`], ownerState.color === 'inherit' && styles.colorInherit, ownerState.disableElevation && styles.disableElevation, ownerState.fullWidth && styles.fullWidth];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({}, theme.typography.button, {
      minWidth: 64,
      padding: '6px 16px',
      borderRadius: theme.shape.borderRadius,
      transition: theme.transitions.create(['background-color', 'box-shadow', 'border-color', 'color'], {
        duration: theme.transitions.duration.short
      }),
      '&:hover': _extends$1({
        textDecoration: 'none',
        backgroundColor: alpha(theme.palette.text.primary, theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }, ownerState.variant === 'text' && ownerState.color !== 'inherit' && {
        backgroundColor: alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }, ownerState.variant === 'outlined' && ownerState.color !== 'inherit' && {
        border: `1px solid ${theme.palette[ownerState.color].main}`,
        backgroundColor: alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }, ownerState.variant === 'contained' && {
        backgroundColor: theme.palette.grey.A100,
        boxShadow: theme.shadows[4],
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          boxShadow: theme.shadows[2],
          backgroundColor: theme.palette.grey[300]
        }
      }, ownerState.variant === 'contained' && ownerState.color !== 'inherit' && {
        backgroundColor: theme.palette[ownerState.color].dark,
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: theme.palette[ownerState.color].main
        }
      }),
      '&:active': _extends$1({}, ownerState.variant === 'contained' && {
        boxShadow: theme.shadows[8]
      }),
      [`&.${buttonClasses$1.focusVisible}`]: _extends$1({}, ownerState.variant === 'contained' && {
        boxShadow: theme.shadows[6]
      }),
      [`&.${buttonClasses$1.disabled}`]: _extends$1({
        color: theme.palette.action.disabled
      }, ownerState.variant === 'outlined' && {
        border: `1px solid ${theme.palette.action.disabledBackground}`
      }, ownerState.variant === 'outlined' && ownerState.color === 'secondary' && {
        border: `1px solid ${theme.palette.action.disabled}`
      }, ownerState.variant === 'contained' && {
        color: theme.palette.action.disabled,
        boxShadow: theme.shadows[0],
        backgroundColor: theme.palette.action.disabledBackground
      })
    }, ownerState.variant === 'text' && {
      padding: '6px 8px'
    }, ownerState.variant === 'text' && ownerState.color !== 'inherit' && {
      color: theme.palette[ownerState.color].main
    }, ownerState.variant === 'outlined' && {
      padding: '5px 15px',
      border: `1px solid ${theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)'}`
    }, ownerState.variant === 'outlined' && ownerState.color !== 'inherit' && {
      color: theme.palette[ownerState.color].main,
      border: `1px solid ${alpha(theme.palette[ownerState.color].main, 0.5)}`
    }, ownerState.variant === 'contained' && {
      color: theme.palette.getContrastText(theme.palette.grey[300]),
      backgroundColor: theme.palette.grey[300],
      boxShadow: theme.shadows[2]
    }, ownerState.variant === 'contained' && ownerState.color !== 'inherit' && {
      color: theme.palette[ownerState.color].contrastText,
      backgroundColor: theme.palette[ownerState.color].main
    }, ownerState.color === 'inherit' && {
      color: 'inherit',
      borderColor: 'currentColor'
    }, ownerState.size === 'small' && ownerState.variant === 'text' && {
      padding: '4px 5px',
      fontSize: theme.typography.pxToRem(13)
    }, ownerState.size === 'large' && ownerState.variant === 'text' && {
      padding: '8px 11px',
      fontSize: theme.typography.pxToRem(15)
    }, ownerState.size === 'small' && ownerState.variant === 'outlined' && {
      padding: '3px 9px',
      fontSize: theme.typography.pxToRem(13)
    }, ownerState.size === 'large' && ownerState.variant === 'outlined' && {
      padding: '7px 21px',
      fontSize: theme.typography.pxToRem(15)
    }, ownerState.size === 'small' && ownerState.variant === 'contained' && {
      padding: '4px 10px',
      fontSize: theme.typography.pxToRem(13)
    }, ownerState.size === 'large' && ownerState.variant === 'contained' && {
      padding: '8px 22px',
      fontSize: theme.typography.pxToRem(15)
    }, ownerState.fullWidth && {
      width: '100%'
    }), ({
      ownerState
    }) => ownerState.disableElevation && {
      boxShadow: 'none',
      '&:hover': {
        boxShadow: 'none'
      },
      [`&.${buttonClasses$1.focusVisible}`]: {
        boxShadow: 'none'
      },
      '&:active': {
        boxShadow: 'none'
      },
      [`&.${buttonClasses$1.disabled}`]: {
        boxShadow: 'none'
      }
    });
    const ButtonStartIcon = styled$1('span', {
      name: 'MuiButton',
      slot: 'StartIcon',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.startIcon, styles[`iconSize${capitalize(ownerState.size)}`]];
      }
    })(({
      ownerState
    }) => _extends$1({
      display: 'inherit',
      marginRight: 8,
      marginLeft: -4
    }, ownerState.size === 'small' && {
      marginLeft: -2
    }, commonIconStyles(ownerState)));
    const ButtonEndIcon = styled$1('span', {
      name: 'MuiButton',
      slot: 'EndIcon',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.endIcon, styles[`iconSize${capitalize(ownerState.size)}`]];
      }
    })(({
      ownerState
    }) => _extends$1({
      display: 'inherit',
      marginRight: -4,
      marginLeft: 8
    }, ownerState.size === 'small' && {
      marginRight: -2
    }, commonIconStyles(ownerState)));
    const Button = /*#__PURE__*/react.exports.forwardRef(function Button(inProps, ref) {
      // props priority: `inProps` > `contextProps` > `themeDefaultProps`
      const contextProps = react.exports.useContext(ButtonGroupContext$1);
      const resolvedProps = resolveProps(contextProps, inProps);
      const props = useThemeProps({
        props: resolvedProps,
        name: 'MuiButton'
      });

      const {
        children,
        color = 'primary',
        component = 'button',
        className,
        disabled = false,
        disableElevation = false,
        disableFocusRipple = false,
        endIcon: endIconProp,
        focusVisibleClassName,
        fullWidth = false,
        size = 'medium',
        startIcon: startIconProp,
        type,
        variant = 'text'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$r);

      const ownerState = _extends$1({}, props, {
        color,
        component,
        disabled,
        disableElevation,
        disableFocusRipple,
        fullWidth,
        size,
        type,
        variant
      });

      const classes = useUtilityClasses$m(ownerState);

      const startIcon = startIconProp && /*#__PURE__*/jsxRuntimeExports.jsx(ButtonStartIcon, {
        className: classes.startIcon,
        ownerState: ownerState,
        children: startIconProp
      });

      const endIcon = endIconProp && /*#__PURE__*/jsxRuntimeExports.jsx(ButtonEndIcon, {
        className: classes.endIcon,
        ownerState: ownerState,
        children: endIconProp
      });

      return /*#__PURE__*/jsxRuntimeExports.jsxs(ButtonRoot, _extends$1({
        ownerState: ownerState,
        className: clsx(className, contextProps.className),
        component: component,
        disabled: disabled,
        focusRipple: !disableFocusRipple,
        focusVisibleClassName: clsx(classes.focusVisible, focusVisibleClassName),
        ref: ref,
        type: type
      }, other, {
        classes: classes,
        children: [startIcon, children, endIcon]
      }));
    });
    process.env.NODE_ENV !== "production" ? Button.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * @default 'primary'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['inherit', 'primary', 'secondary', 'success', 'error', 'info', 'warning']), propTypes.exports.string]),

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, the component is disabled.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, no elevation is used.
       * @default false
       */
      disableElevation: propTypes.exports.bool,

      /**
       * If `true`, the  keyboard focus ripple is disabled.
       * @default false
       */
      disableFocusRipple: propTypes.exports.bool,

      /**
       * If `true`, the ripple effect is disabled.
       *
       * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
       * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
       * @default false
       */
      disableRipple: propTypes.exports.bool,

      /**
       * Element placed after the children.
       */
      endIcon: propTypes.exports.node,

      /**
       * @ignore
       */
      focusVisibleClassName: propTypes.exports.string,

      /**
       * If `true`, the button will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * The URL to link to when the button is clicked.
       * If defined, an `a` element will be used as the root node.
       */
      href: propTypes.exports.string,

      /**
       * The size of the component.
       * `small` is equivalent to the dense button styling.
       * @default 'medium'
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['small', 'medium', 'large']), propTypes.exports.string]),

      /**
       * Element placed before the children.
       */
      startIcon: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * @ignore
       */
      type: propTypes.exports.oneOfType([propTypes.exports.oneOf(['button', 'reset', 'submit']), propTypes.exports.string]),

      /**
       * The variant to use.
       * @default 'text'
       */
      variant: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['contained', 'outlined', 'text']), propTypes.exports.string])
    } : void 0;
    var Button$1 = Button;

    function getSwitchBaseUtilityClass(slot) {
      return generateUtilityClass('PrivateSwitchBase', slot);
    }
    generateUtilityClasses('PrivateSwitchBase', ['root', 'checked', 'disabled', 'input', 'edgeStart', 'edgeEnd']);

    const _excluded$q = ["autoFocus", "checked", "checkedIcon", "className", "defaultChecked", "disabled", "disableFocusRipple", "edge", "icon", "id", "inputProps", "inputRef", "name", "onBlur", "onChange", "onFocus", "readOnly", "required", "tabIndex", "type", "value"];

    const useUtilityClasses$l = ownerState => {
      const {
        classes,
        checked,
        disabled,
        edge
      } = ownerState;
      const slots = {
        root: ['root', checked && 'checked', disabled && 'disabled', edge && `edge${capitalize(edge)}`],
        input: ['input']
      };
      return composeClasses(slots, getSwitchBaseUtilityClass, classes);
    };

    const SwitchBaseRoot = styled$1(ButtonBase$1)(({
      ownerState
    }) => _extends$1({
      padding: 9,
      borderRadius: '50%'
    }, ownerState.edge === 'start' && {
      marginLeft: ownerState.size === 'small' ? -3 : -12
    }, ownerState.edge === 'end' && {
      marginRight: ownerState.size === 'small' ? -3 : -12
    }));
    const SwitchBaseInput = styled$1('input')({
      cursor: 'inherit',
      position: 'absolute',
      opacity: 0,
      width: '100%',
      height: '100%',
      top: 0,
      left: 0,
      margin: 0,
      padding: 0,
      zIndex: 1
    });
    /**
     * @ignore - internal component.
     */

    const SwitchBase = /*#__PURE__*/react.exports.forwardRef(function SwitchBase(props, ref) {
      const {
        autoFocus,
        checked: checkedProp,
        checkedIcon,
        className,
        defaultChecked,
        disabled: disabledProp,
        disableFocusRipple = false,
        edge = false,
        icon,
        id,
        inputProps,
        inputRef,
        name,
        onBlur,
        onChange,
        onFocus,
        readOnly,
        required,
        tabIndex,
        type,
        value
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$q);

      const [checked, setCheckedState] = useControlled({
        controlled: checkedProp,
        default: Boolean(defaultChecked),
        name: 'SwitchBase',
        state: 'checked'
      });
      const muiFormControl = useFormControl();

      const handleFocus = event => {
        if (onFocus) {
          onFocus(event);
        }

        if (muiFormControl && muiFormControl.onFocus) {
          muiFormControl.onFocus(event);
        }
      };

      const handleBlur = event => {
        if (onBlur) {
          onBlur(event);
        }

        if (muiFormControl && muiFormControl.onBlur) {
          muiFormControl.onBlur(event);
        }
      };

      const handleInputChange = event => {
        // Workaround for https://github.com/facebook/react/issues/9023
        if (event.nativeEvent.defaultPrevented) {
          return;
        }

        const newChecked = event.target.checked;
        setCheckedState(newChecked);

        if (onChange) {
          // TODO v6: remove the second argument.
          onChange(event, newChecked);
        }
      };

      let disabled = disabledProp;

      if (muiFormControl) {
        if (typeof disabled === 'undefined') {
          disabled = muiFormControl.disabled;
        }
      }

      const hasLabelFor = type === 'checkbox' || type === 'radio';

      const ownerState = _extends$1({}, props, {
        checked,
        disabled,
        disableFocusRipple,
        edge
      });

      const classes = useUtilityClasses$l(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(SwitchBaseRoot, _extends$1({
        component: "span",
        className: clsx(classes.root, className),
        centerRipple: true,
        focusRipple: !disableFocusRipple,
        disabled: disabled,
        tabIndex: null,
        role: undefined,
        onFocus: handleFocus,
        onBlur: handleBlur,
        ownerState: ownerState,
        ref: ref
      }, other, {
        children: [/*#__PURE__*/jsxRuntimeExports.jsx(SwitchBaseInput, _extends$1({
          autoFocus: autoFocus,
          checked: checkedProp,
          defaultChecked: defaultChecked,
          className: classes.input,
          disabled: disabled,
          id: hasLabelFor && id,
          name: name,
          onChange: handleInputChange,
          readOnly: readOnly,
          ref: inputRef,
          required: required,
          ownerState: ownerState,
          tabIndex: tabIndex,
          type: type
        }, type === 'checkbox' && value === undefined ? {} : {
          value
        }, inputProps)), checked ? checkedIcon : icon]
      }));
    }); // NB: If changed, please update Checkbox, Switch and Radio
    // so that the API documentation is updated.

    process.env.NODE_ENV !== "production" ? SwitchBase.propTypes = {
      /**
       * If `true`, the `input` element is focused during the first mount.
       */
      autoFocus: propTypes.exports.bool,

      /**
       * If `true`, the component is checked.
       */
      checked: propTypes.exports.bool,

      /**
       * The icon to display when the component is checked.
       */
      checkedIcon: propTypes.exports.node.isRequired,

      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * @ignore
       */
      defaultChecked: propTypes.exports.bool,

      /**
       * If `true`, the component is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the  keyboard focus ripple is disabled.
       * @default false
       */
      disableFocusRipple: propTypes.exports.bool,

      /**
       * If given, uses a negative margin to counteract the padding on one
       * side (this is often helpful for aligning the left or right
       * side of the icon with content above or below, without ruining the border
       * size and shape).
       * @default false
       */
      edge: propTypes.exports.oneOf(['end', 'start', false]),

      /**
       * The icon to display when the component is unchecked.
       */
      icon: propTypes.exports.node.isRequired,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /*
       * @ignore
       */
      name: propTypes.exports.string,

      /**
       * @ignore
       */
      onBlur: propTypes.exports.func,

      /**
       * Callback fired when the state is changed.
       *
       * @param {object} event The event source of the callback.
       * You can pull out the new checked state by accessing `event.target.checked` (boolean).
       */
      onChange: propTypes.exports.func,

      /**
       * @ignore
       */
      onFocus: propTypes.exports.func,

      /**
       * It prevents the user from changing the value of the field
       * (not from interacting with the field).
       */
      readOnly: propTypes.exports.bool,

      /**
       * If `true`, the `input` element is required.
       */
      required: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.object,

      /**
       * @ignore
       */
      tabIndex: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * The input component prop `type`.
       */
      type: propTypes.exports.string.isRequired,

      /**
       * The value of the component.
       */
      value: propTypes.exports.any
    } : void 0;
    var SwitchBase$1 = SwitchBase;

    const _excluded$p = ["BackdropComponent", "closeAfterTransition", "children", "components", "componentsProps", "disableAutoFocus", "disableEnforceFocus", "disableEscapeKeyDown", "disablePortal", "disableRestoreFocus", "disableScrollLock", "hideBackdrop", "keepMounted"];

    const extendUtilityClasses = ownerState => {
      return ownerState.classes;
    };

    const ModalRoot = styled$1('div', {
      name: 'MuiModal',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, !ownerState.open && ownerState.exited && styles.hidden];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      position: 'fixed',
      zIndex: theme.zIndex.modal,
      right: 0,
      bottom: 0,
      top: 0,
      left: 0
    }, !ownerState.open && ownerState.exited && {
      visibility: 'hidden'
    }));
    const ModalBackdrop = styled$1(Backdrop$1, {
      name: 'MuiModal',
      slot: 'Backdrop',
      overridesResolver: (props, styles) => {
        return styles.backdrop;
      }
    })({
      zIndex: -1
    });
    /**
     * Modal is a lower-level construct that is leveraged by the following components:
     *
     * - [Dialog](/api/dialog/)
     * - [Drawer](/api/drawer/)
     * - [Menu](/api/menu/)
     * - [Popover](/api/popover/)
     *
     * If you are creating a modal dialog, you probably want to use the [Dialog](/api/dialog/) component
     * rather than directly using Modal.
     *
     * This component shares many concepts with [react-overlays](https://react-bootstrap.github.io/react-overlays/#modals).
     */

    const Modal = /*#__PURE__*/react.exports.forwardRef(function Modal(inProps, ref) {
      var _componentsProps$root;

      const props = useThemeProps({
        name: 'MuiModal',
        props: inProps
      });

      const {
        BackdropComponent = ModalBackdrop,
        closeAfterTransition = false,
        children,
        components = {},
        componentsProps = {},
        disableAutoFocus = false,
        disableEnforceFocus = false,
        disableEscapeKeyDown = false,
        disablePortal = false,
        disableRestoreFocus = false,
        disableScrollLock = false,
        hideBackdrop = false,
        keepMounted = false
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$p);

      const [exited, setExited] = react.exports.useState(true);
      const commonProps = {
        closeAfterTransition,
        disableAutoFocus,
        disableEnforceFocus,
        disableEscapeKeyDown,
        disablePortal,
        disableRestoreFocus,
        disableScrollLock,
        hideBackdrop,
        keepMounted
      };

      const ownerState = _extends$1({}, props, commonProps, {
        exited
      });

      const classes = extendUtilityClasses(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(ModalUnstyled$1, _extends$1({
        components: _extends$1({
          Root: ModalRoot
        }, components),
        componentsProps: {
          root: _extends$1({}, componentsProps.root, (!components.Root || !isHostComponent(components.Root)) && {
            ownerState: _extends$1({}, (_componentsProps$root = componentsProps.root) == null ? void 0 : _componentsProps$root.ownerState)
          })
        },
        BackdropComponent: BackdropComponent,
        onTransitionEnter: () => setExited(false),
        onTransitionExited: () => setExited(true),
        ref: ref
      }, other, {
        classes: classes
      }, commonProps, {
        children: children
      }));
    });
    process.env.NODE_ENV !== "production" ? Modal.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * A backdrop component. This prop enables custom backdrop rendering.
       * @default styled(Backdrop, {
       *   name: 'MuiModal',
       *   slot: 'Backdrop',
       *   overridesResolver: (props, styles) => {
       *     return styles.backdrop;
       *   },
       * })({
       *   zIndex: -1,
       * })
       */
      BackdropComponent: propTypes.exports.elementType,

      /**
       * Props applied to the [`Backdrop`](/api/backdrop/) element.
       */
      BackdropProps: propTypes.exports.object,

      /**
       * A single child content element.
       */
      children: elementAcceptingRef.isRequired,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * When set to true the Modal waits until a nested Transition is completed before closing.
       * @default false
       */
      closeAfterTransition: propTypes.exports.bool,

      /**
       * The components used for each slot inside the Modal.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Modal.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        root: propTypes.exports.object
      }),

      /**
       * An HTML element or function that returns one.
       * The `container` will have the portal children appended to it.
       *
       * By default, it uses the body of the top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * If `true`, the modal will not automatically shift focus to itself when it opens, and
       * replace it to the last focused element when it closes.
       * This also works correctly with any modal children that have the `disableAutoFocus` prop.
       *
       * Generally this should never be set to `true` as it makes the modal less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableAutoFocus: propTypes.exports.bool,

      /**
       * If `true`, the modal will not prevent focus from leaving the modal while open.
       *
       * Generally this should never be set to `true` as it makes the modal less
       * accessible to assistive technologies, like screen readers.
       * @default false
       */
      disableEnforceFocus: propTypes.exports.bool,

      /**
       * If `true`, hitting escape will not fire the `onClose` callback.
       * @default false
       */
      disableEscapeKeyDown: propTypes.exports.bool,

      /**
       * The `children` will be under the DOM hierarchy of the parent component.
       * @default false
       */
      disablePortal: propTypes.exports.bool,

      /**
       * If `true`, the modal will not restore focus to previously focused element once
       * modal is hidden or unmounted.
       * @default false
       */
      disableRestoreFocus: propTypes.exports.bool,

      /**
       * Disable the scroll lock behavior.
       * @default false
       */
      disableScrollLock: propTypes.exports.bool,

      /**
       * If `true`, the backdrop is not rendered.
       * @default false
       */
      hideBackdrop: propTypes.exports.bool,

      /**
       * Always keep the children in the DOM.
       * This prop can be useful in SEO situation or
       * when you want to maximize the responsiveness of the Modal.
       * @default false
       */
      keepMounted: propTypes.exports.bool,

      /**
       * Callback fired when the backdrop is clicked.
       */
      onBackdropClick: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be closed.
       * The `reason` parameter can optionally be used to control the response to `onClose`.
       *
       * @param {object} event The event source of the callback.
       * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`.
       */
      onClose: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var Modal$1 = Modal;

    const dividerClasses = generateUtilityClasses('MuiDivider', ['root', 'absolute', 'fullWidth', 'inset', 'middle', 'flexItem', 'light', 'vertical', 'withChildren', 'withChildrenVertical', 'textAlignRight', 'textAlignLeft', 'wrapper', 'wrapperVertical']);
    var dividerClasses$1 = dividerClasses;

    const _excluded$o = ["disableUnderline", "components", "componentsProps", "fullWidth", "hiddenLabel", "inputComponent", "multiline", "type"];

    const useUtilityClasses$k = ownerState => {
      const {
        classes,
        disableUnderline
      } = ownerState;
      const slots = {
        root: ['root', !disableUnderline && 'underline'],
        input: ['input']
      };
      const composedClasses = composeClasses(slots, getFilledInputUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const FilledInputRoot = styled$1(InputBaseRoot, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiFilledInput',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [...rootOverridesResolver(props, styles), !ownerState.disableUnderline && styles.underline];
      }
    })(({
      theme,
      ownerState
    }) => {
      const light = theme.palette.mode === 'light';
      const bottomLineColor = light ? 'rgba(0, 0, 0, 0.42)' : 'rgba(255, 255, 255, 0.7)';
      const backgroundColor = light ? 'rgba(0, 0, 0, 0.06)' : 'rgba(255, 255, 255, 0.09)';
      return _extends$1({
        position: 'relative',
        backgroundColor,
        borderTopLeftRadius: theme.shape.borderRadius,
        borderTopRightRadius: theme.shape.borderRadius,
        transition: theme.transitions.create('background-color', {
          duration: theme.transitions.duration.shorter,
          easing: theme.transitions.easing.easeOut
        }),
        '&:hover': {
          backgroundColor: light ? 'rgba(0, 0, 0, 0.09)' : 'rgba(255, 255, 255, 0.13)',
          // Reset on touch devices, it doesn't add specificity
          '@media (hover: none)': {
            backgroundColor
          }
        },
        [`&.${filledInputClasses$1.focused}`]: {
          backgroundColor
        },
        [`&.${filledInputClasses$1.disabled}`]: {
          backgroundColor: light ? 'rgba(0, 0, 0, 0.12)' : 'rgba(255, 255, 255, 0.12)'
        }
      }, !ownerState.disableUnderline && {
        '&:after': {
          borderBottom: `2px solid ${theme.palette[ownerState.color].main}`,
          left: 0,
          bottom: 0,
          // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
          content: '""',
          position: 'absolute',
          right: 0,
          transform: 'scaleX(0)',
          transition: theme.transitions.create('transform', {
            duration: theme.transitions.duration.shorter,
            easing: theme.transitions.easing.easeOut
          }),
          pointerEvents: 'none' // Transparent to the hover style.

        },
        [`&.${filledInputClasses$1.focused}:after`]: {
          transform: 'scaleX(1)'
        },
        [`&.${filledInputClasses$1.error}:after`]: {
          borderBottomColor: theme.palette.error.main,
          transform: 'scaleX(1)' // error is always underlined in red

        },
        '&:before': {
          borderBottom: `1px solid ${bottomLineColor}`,
          left: 0,
          bottom: 0,
          // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
          content: '"\\00a0"',
          position: 'absolute',
          right: 0,
          transition: theme.transitions.create('border-bottom-color', {
            duration: theme.transitions.duration.shorter
          }),
          pointerEvents: 'none' // Transparent to the hover style.

        },
        [`&:hover:not(.${filledInputClasses$1.disabled}):before`]: {
          borderBottom: `1px solid ${theme.palette.text.primary}`
        },
        [`&.${filledInputClasses$1.disabled}:before`]: {
          borderBottomStyle: 'dotted'
        }
      }, ownerState.startAdornment && {
        paddingLeft: 12
      }, ownerState.endAdornment && {
        paddingRight: 12
      }, ownerState.multiline && _extends$1({
        padding: '25px 12px 8px'
      }, ownerState.size === 'small' && {
        paddingTop: 21,
        paddingBottom: 4
      }, ownerState.hiddenLabel && {
        paddingTop: 16,
        paddingBottom: 17
      }));
    });
    const FilledInputInput = styled$1(InputBaseComponent, {
      name: 'MuiFilledInput',
      slot: 'Input',
      overridesResolver: inputOverridesResolver
    })(({
      theme,
      ownerState
    }) => _extends$1({
      paddingTop: 25,
      paddingRight: 12,
      paddingBottom: 8,
      paddingLeft: 12,
      '&:-webkit-autofill': {
        WebkitBoxShadow: theme.palette.mode === 'light' ? null : '0 0 0 100px #266798 inset',
        WebkitTextFillColor: theme.palette.mode === 'light' ? null : '#fff',
        caretColor: theme.palette.mode === 'light' ? null : '#fff',
        borderTopLeftRadius: 'inherit',
        borderTopRightRadius: 'inherit'
      }
    }, ownerState.size === 'small' && {
      paddingTop: 21,
      paddingBottom: 4
    }, ownerState.hiddenLabel && {
      paddingTop: 16,
      paddingBottom: 17
    }, ownerState.multiline && {
      paddingTop: 0,
      paddingBottom: 0,
      paddingLeft: 0,
      paddingRight: 0
    }, ownerState.startAdornment && {
      paddingLeft: 0
    }, ownerState.endAdornment && {
      paddingRight: 0
    }, ownerState.hiddenLabel && ownerState.size === 'small' && {
      paddingTop: 8,
      paddingBottom: 9
    }));
    const FilledInput = /*#__PURE__*/react.exports.forwardRef(function FilledInput(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiFilledInput'
      });

      const {
        components = {},
        componentsProps: componentsPropsProp,
        fullWidth = false,
        // declare here to prevent spreading to DOM
        inputComponent = 'input',
        multiline = false,
        type = 'text'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$o);

      const ownerState = _extends$1({}, props, {
        fullWidth,
        inputComponent,
        multiline,
        type
      });

      const classes = useUtilityClasses$k(props);
      const filledInputComponentsProps = {
        root: {
          ownerState
        },
        input: {
          ownerState
        }
      };
      const componentsProps = componentsPropsProp ? deepmerge(componentsPropsProp, filledInputComponentsProps) : filledInputComponentsProps;
      return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
        components: _extends$1({
          Root: FilledInputRoot,
          Input: FilledInputInput
        }, components),
        componentsProps: componentsProps,
        fullWidth: fullWidth,
        inputComponent: inputComponent,
        multiline: multiline,
        ref: ref,
        type: type
      }, other, {
        classes: classes
      }));
    });
    process.env.NODE_ENV !== "production" ? FilledInput.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * This prop helps users to fill forms faster, especially on mobile devices.
       * The name can be confusing, as it's more like an autofill.
       * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
       */
      autoComplete: propTypes.exports.string,

      /**
       * If `true`, the `input` element is focused during the first mount.
       */
      autoFocus: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary']), propTypes.exports.string]),

      /**
       * The components used for each slot inside the InputBase.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Input: propTypes.exports.elementType,
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Input.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        input: propTypes.exports.object,
        root: propTypes.exports.object
      }),

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the component is disabled.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the input will not have an underline.
       */
      disableUnderline: propTypes.exports.bool,

      /**
       * End `InputAdornment` for this component.
       */
      endAdornment: propTypes.exports.node,

      /**
       * If `true`, the `input` will indicate an error.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the `input` will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * If `true`, the label is hidden.
       * This is used to increase density for a `FilledInput`.
       * Be sure to add `aria-label` to the `input` element.
       * @default false
       */
      hiddenLabel: propTypes.exports.bool,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * The component used for the `input` element.
       * Either a string to use a HTML element or a component.
       * @default 'input'
       */
      inputComponent: propTypes.exports.elementType,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       * @default {}
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
       */
      margin: propTypes.exports.oneOf(['dense', 'none']),

      /**
       * Maximum number of rows to display when multiline option is set to true.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display when multiline option is set to true.
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * If `true`, a `textarea` element is rendered.
       * @default false
       */
      multiline: propTypes.exports.bool,

      /**
       * Name attribute of the `input` element.
       */
      name: propTypes.exports.string,

      /**
       * Callback fired when the value is changed.
       *
       * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * The short hint displayed in the `input` before the user enters a value.
       */
      placeholder: propTypes.exports.string,

      /**
       * It prevents the user from changing the value of the field
       * (not from interacting with the field).
       */
      readOnly: propTypes.exports.bool,

      /**
       * If `true`, the `input` element is required.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      required: propTypes.exports.bool,

      /**
       * Number of rows to display when multiline option is set to true.
       */
      rows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Start `InputAdornment` for this component.
       */
      startAdornment: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
       * @default 'text'
       */
      type: propTypes.exports.string,

      /**
       * The value of the `input` element, required for a controlled component.
       */
      value: propTypes.exports.any
    } : void 0;
    FilledInput.muiName = 'Input';
    var FilledInput$1 = FilledInput;

    function getFormControlUtilityClasses(slot) {
      return generateUtilityClass('MuiFormControl', slot);
    }
    generateUtilityClasses('MuiFormControl', ['root', 'marginNone', 'marginNormal', 'marginDense', 'fullWidth', 'disabled']);

    const _excluded$n = ["children", "className", "color", "component", "disabled", "error", "focused", "fullWidth", "hiddenLabel", "margin", "required", "size", "variant"];

    const useUtilityClasses$j = ownerState => {
      const {
        classes,
        margin,
        fullWidth
      } = ownerState;
      const slots = {
        root: ['root', margin !== 'none' && `margin${capitalize(margin)}`, fullWidth && 'fullWidth']
      };
      return composeClasses(slots, getFormControlUtilityClasses, classes);
    };

    const FormControlRoot = styled$1('div', {
      name: 'MuiFormControl',
      slot: 'Root',
      overridesResolver: ({
        ownerState
      }, styles) => {
        return _extends$1({}, styles.root, styles[`margin${capitalize(ownerState.margin)}`], ownerState.fullWidth && styles.fullWidth);
      }
    })(({
      ownerState
    }) => _extends$1({
      display: 'inline-flex',
      flexDirection: 'column',
      position: 'relative',
      // Reset fieldset default style.
      minWidth: 0,
      padding: 0,
      margin: 0,
      border: 0,
      verticalAlign: 'top'
    }, ownerState.margin === 'normal' && {
      marginTop: 16,
      marginBottom: 8
    }, ownerState.margin === 'dense' && {
      marginTop: 8,
      marginBottom: 4
    }, ownerState.fullWidth && {
      width: '100%'
    }));
    /**
     * Provides context such as filled/focused/error/required for form inputs.
     * Relying on the context provides high flexibility and ensures that the state always stays
     * consistent across the children of the `FormControl`.
     * This context is used by the following components:
     *
     *  - FormLabel
     *  - FormHelperText
     *  - Input
     *  - InputLabel
     *
     * You can find one composition example below and more going to [the demos](/components/text-fields/#components).
     *
     * ```jsx
     * <FormControl>
     *   <InputLabel htmlFor="my-input">Email address</InputLabel>
     *   <Input id="my-input" aria-describedby="my-helper-text" />
     *   <FormHelperText id="my-helper-text">We'll never share your email.</FormHelperText>
     * </FormControl>
     * ```
     *
     * ⚠️ Only one `InputBase` can be used within a FormControl because it create visual inconsistencies.
     * For instance, only one input can be focused at the same time, the state shouldn't be shared.
     */

    const FormControl = /*#__PURE__*/react.exports.forwardRef(function FormControl(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiFormControl'
      });

      const {
        children,
        className,
        color = 'primary',
        component = 'div',
        disabled = false,
        error = false,
        focused: visuallyFocused,
        fullWidth = false,
        hiddenLabel = false,
        margin = 'none',
        required = false,
        size = 'medium',
        variant = 'outlined'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$n);

      const ownerState = _extends$1({}, props, {
        color,
        component,
        disabled,
        error,
        fullWidth,
        hiddenLabel,
        margin,
        required,
        size,
        variant
      });

      const classes = useUtilityClasses$j(ownerState);
      const [adornedStart, setAdornedStart] = react.exports.useState(() => {
        // We need to iterate through the children and find the Input in order
        // to fully support server-side rendering.
        let initialAdornedStart = false;

        if (children) {
          react.exports.Children.forEach(children, child => {
            if (!isMuiElement(child, ['Input', 'Select'])) {
              return;
            }

            const input = isMuiElement(child, ['Select']) ? child.props.input : child;

            if (input && isAdornedStart(input.props)) {
              initialAdornedStart = true;
            }
          });
        }

        return initialAdornedStart;
      });
      const [filled, setFilled] = react.exports.useState(() => {
        // We need to iterate through the children and find the Input in order
        // to fully support server-side rendering.
        let initialFilled = false;

        if (children) {
          react.exports.Children.forEach(children, child => {
            if (!isMuiElement(child, ['Input', 'Select'])) {
              return;
            }

            if (isFilled(child.props, true)) {
              initialFilled = true;
            }
          });
        }

        return initialFilled;
      });
      const [focusedState, setFocused] = react.exports.useState(false);

      if (disabled && focusedState) {
        setFocused(false);
      }

      const focused = visuallyFocused !== undefined && !disabled ? visuallyFocused : focusedState;
      let registerEffect;

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        const registeredInput = react.exports.useRef(false);

        registerEffect = () => {
          if (registeredInput.current) {
            console.error(['MUI: There are multiple `InputBase` components inside a FormControl.', 'This creates visual inconsistencies, only use one `InputBase`.'].join('\n'));
          }

          registeredInput.current = true;
          return () => {
            registeredInput.current = false;
          };
        };
      }

      const onFilled = react.exports.useCallback(() => {
        setFilled(true);
      }, []);
      const onEmpty = react.exports.useCallback(() => {
        setFilled(false);
      }, []);
      const childContext = {
        adornedStart,
        setAdornedStart,
        color,
        disabled,
        error,
        filled,
        focused,
        fullWidth,
        hiddenLabel,
        size,
        onBlur: () => {
          setFocused(false);
        },
        onEmpty,
        onFilled,
        onFocus: () => {
          setFocused(true);
        },
        registerEffect,
        required,
        variant
      };
      return /*#__PURE__*/jsxRuntimeExports.jsx(FormControlContext.Provider, {
        value: childContext,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(FormControlRoot, _extends$1({
          as: component,
          ownerState: ownerState,
          className: clsx(classes.root, className),
          ref: ref
        }, other, {
          children: children
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? FormControl.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * @default 'primary'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, the label, input and helper text should be displayed in a disabled state.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the label is displayed in an error state.
       * @default false
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the component is displayed in focused state.
       */
      focused: propTypes.exports.bool,

      /**
       * If `true`, the component will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * If `true`, the label is hidden.
       * This is used to increase density for a `FilledInput`.
       * Be sure to add `aria-label` to the `input` element.
       * @default false
       */
      hiddenLabel: propTypes.exports.bool,

      /**
       * If `dense` or `normal`, will adjust vertical spacing of this and contained components.
       * @default 'none'
       */
      margin: propTypes.exports.oneOf(['dense', 'none', 'normal']),

      /**
       * If `true`, the label will indicate that the `input` is required.
       * @default false
       */
      required: propTypes.exports.bool,

      /**
       * The size of the component.
       * @default 'medium'
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['medium', 'small']), propTypes.exports.string]),

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The variant to use.
       * @default 'outlined'
       */
      variant: propTypes.exports.oneOf(['filled', 'outlined', 'standard'])
    } : void 0;
    var FormControl$1 = FormControl;

    function getFormControlLabelUtilityClasses(slot) {
      return generateUtilityClass('MuiFormControlLabel', slot);
    }
    const formControlLabelClasses = generateUtilityClasses('MuiFormControlLabel', ['root', 'labelPlacementStart', 'labelPlacementTop', 'labelPlacementBottom', 'disabled', 'label', 'error']);
    var formControlLabelClasses$1 = formControlLabelClasses;

    const _excluded$m = ["checked", "className", "componentsProps", "control", "disabled", "disableTypography", "inputRef", "label", "labelPlacement", "name", "onChange", "value"];

    const useUtilityClasses$i = ownerState => {
      const {
        classes,
        disabled,
        labelPlacement,
        error
      } = ownerState;
      const slots = {
        root: ['root', disabled && 'disabled', `labelPlacement${capitalize(labelPlacement)}`, error && 'error'],
        label: ['label', disabled && 'disabled']
      };
      return composeClasses(slots, getFormControlLabelUtilityClasses, classes);
    };

    const FormControlLabelRoot = styled$1('label', {
      name: 'MuiFormControlLabel',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [{
          [`& .${formControlLabelClasses$1.label}`]: styles.label
        }, styles.root, styles[`labelPlacement${capitalize(ownerState.labelPlacement)}`]];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      display: 'inline-flex',
      alignItems: 'center',
      cursor: 'pointer',
      // For correct alignment with the text.
      verticalAlign: 'middle',
      WebkitTapHighlightColor: 'transparent',
      marginLeft: -11,
      marginRight: 16,
      // used for row presentation of radio/checkbox
      [`&.${formControlLabelClasses$1.disabled}`]: {
        cursor: 'default'
      }
    }, ownerState.labelPlacement === 'start' && {
      flexDirection: 'row-reverse',
      marginLeft: 16,
      // used for row presentation of radio/checkbox
      marginRight: -11
    }, ownerState.labelPlacement === 'top' && {
      flexDirection: 'column-reverse',
      marginLeft: 16
    }, ownerState.labelPlacement === 'bottom' && {
      flexDirection: 'column',
      marginLeft: 16
    }, {
      [`& .${formControlLabelClasses$1.label}`]: {
        [`&.${formControlLabelClasses$1.disabled}`]: {
          color: theme.palette.text.disabled
        }
      }
    }));
    /**
     * Drop-in replacement of the `Radio`, `Switch` and `Checkbox` component.
     * Use this component if you want to display an extra label.
     */

    const FormControlLabel = /*#__PURE__*/react.exports.forwardRef(function FormControlLabel(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiFormControlLabel'
      });

      const {
        className,
        componentsProps = {},
        control,
        disabled: disabledProp,
        disableTypography,
        label,
        labelPlacement = 'end'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$m);

      const muiFormControl = useFormControl();
      let disabled = disabledProp;

      if (typeof disabled === 'undefined' && typeof control.props.disabled !== 'undefined') {
        disabled = control.props.disabled;
      }

      if (typeof disabled === 'undefined' && muiFormControl) {
        disabled = muiFormControl.disabled;
      }

      const controlProps = {
        disabled
      };
      ['checked', 'name', 'onChange', 'value', 'inputRef'].forEach(key => {
        if (typeof control.props[key] === 'undefined' && typeof props[key] !== 'undefined') {
          controlProps[key] = props[key];
        }
      });
      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['error']
      });

      const ownerState = _extends$1({}, props, {
        disabled,
        label,
        labelPlacement,
        error: fcs.error
      });

      const classes = useUtilityClasses$i(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(FormControlLabelRoot, _extends$1({
        className: clsx(classes.root, className),
        ownerState: ownerState,
        ref: ref
      }, other, {
        children: [/*#__PURE__*/react.exports.cloneElement(control, controlProps), label.type === Typography$1 || disableTypography ? label : /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
          component: "span",
          className: classes.label
        }, componentsProps.typography, {
          children: label
        }))]
      }));
    });
    process.env.NODE_ENV !== "production" ? FormControlLabel.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * If `true`, the component appears selected.
       */
      checked: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The props used for each slot inside.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        typography: propTypes.exports.object
      }),

      /**
       * A control element. For instance, it can be a `Radio`, a `Switch` or a `Checkbox`.
       */
      control: propTypes.exports.element.isRequired,

      /**
       * If `true`, the control is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the label is rendered as it is passed without an additional typography node.
       */
      disableTypography: propTypes.exports.bool,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * A text or an element to be used in an enclosing label element.
       */
      label: propTypes.exports.oneOfType([propTypes.exports.element, propTypes.exports.number, propTypes.exports.string]).isRequired,

      /**
       * The position of the label.
       * @default 'end'
       */
      labelPlacement: propTypes.exports.oneOf(['bottom', 'end', 'start', 'top']),

      /**
       * @ignore
       */
      name: propTypes.exports.string,

      /**
       * Callback fired when the state is changed.
       *
       * @param {React.SyntheticEvent} event The event source of the callback.
       * You can pull out the new checked state by accessing `event.target.checked` (boolean).
       */
      onChange: propTypes.exports.func,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The value of the component.
       */
      value: propTypes.exports.any
    } : void 0;
    var FormControlLabel$1 = FormControlLabel;

    function getFormHelperTextUtilityClasses(slot) {
      return generateUtilityClass('MuiFormHelperText', slot);
    }
    const formHelperTextClasses = generateUtilityClasses('MuiFormHelperText', ['root', 'error', 'disabled', 'sizeSmall', 'sizeMedium', 'contained', 'focused', 'filled', 'required']);
    var formHelperTextClasses$1 = formHelperTextClasses;

    var _span$2;

    const _excluded$l = ["children", "className", "component", "disabled", "error", "filled", "focused", "margin", "required", "variant"];

    const useUtilityClasses$h = ownerState => {
      const {
        classes,
        contained,
        size,
        disabled,
        error,
        filled,
        focused,
        required
      } = ownerState;
      const slots = {
        root: ['root', disabled && 'disabled', error && 'error', size && `size${capitalize(size)}`, contained && 'contained', focused && 'focused', filled && 'filled', required && 'required']
      };
      return composeClasses(slots, getFormHelperTextUtilityClasses, classes);
    };

    const FormHelperTextRoot = styled$1('p', {
      name: 'MuiFormHelperText',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.size && styles[`size${capitalize(ownerState.size)}`], ownerState.contained && styles.contained, ownerState.filled && styles.filled];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      color: theme.palette.text.secondary
    }, theme.typography.caption, {
      textAlign: 'left',
      marginTop: 3,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0,
      [`&.${formHelperTextClasses$1.disabled}`]: {
        color: theme.palette.text.disabled
      },
      [`&.${formHelperTextClasses$1.error}`]: {
        color: theme.palette.error.main
      }
    }, ownerState.size === 'small' && {
      marginTop: 4
    }, ownerState.contained && {
      marginLeft: 14,
      marginRight: 14
    }));
    const FormHelperText = /*#__PURE__*/react.exports.forwardRef(function FormHelperText(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiFormHelperText'
      });

      const {
        children,
        className,
        component = 'p'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$l);

      const muiFormControl = useFormControl();
      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['variant', 'size', 'disabled', 'error', 'filled', 'focused', 'required']
      });

      const ownerState = _extends$1({}, props, {
        component,
        contained: fcs.variant === 'filled' || fcs.variant === 'outlined',
        variant: fcs.variant,
        size: fcs.size,
        disabled: fcs.disabled,
        error: fcs.error,
        filled: fcs.filled,
        focused: fcs.focused,
        required: fcs.required
      });

      const classes = useUtilityClasses$h(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(FormHelperTextRoot, _extends$1({
        as: component,
        ownerState: ownerState,
        className: clsx(classes.root, className),
        ref: ref
      }, other, {
        children: children === ' ' ? // notranslate needed while Google Translate will not fix zero-width space issue
        _span$2 || (_span$2 = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
          className: "notranslate",
          children: "\u200B"
        })) : children
      }));
    });
    process.env.NODE_ENV !== "production" ? FormHelperText.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       *
       * If `' '` is provided, the component reserves one line height for displaying a future message.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, the helper text should be displayed in a disabled state.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, helper text should be displayed in an error state.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the helper text should use filled classes key.
       */
      filled: propTypes.exports.bool,

      /**
       * If `true`, the helper text should use focused classes key.
       */
      focused: propTypes.exports.bool,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       */
      margin: propTypes.exports.oneOf(['dense']),

      /**
       * If `true`, the helper text should use required classes key.
       */
      required: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The variant to use.
       */
      variant: propTypes.exports.oneOf(['filled', 'outlined', 'standard'])
    } : void 0;
    var FormHelperText$1 = FormHelperText;

    function getFormLabelUtilityClasses(slot) {
      return generateUtilityClass('MuiFormLabel', slot);
    }
    const formLabelClasses = generateUtilityClasses('MuiFormLabel', ['root', 'colorSecondary', 'focused', 'disabled', 'error', 'filled', 'required', 'asterisk']);
    var formLabelClasses$1 = formLabelClasses;

    const _excluded$k = ["children", "className", "color", "component", "disabled", "error", "filled", "focused", "required"];

    const useUtilityClasses$g = ownerState => {
      const {
        classes,
        color,
        focused,
        disabled,
        error,
        filled,
        required
      } = ownerState;
      const slots = {
        root: ['root', `color${capitalize(color)}`, disabled && 'disabled', error && 'error', filled && 'filled', focused && 'focused', required && 'required'],
        asterisk: ['asterisk', error && 'error']
      };
      return composeClasses(slots, getFormLabelUtilityClasses, classes);
    };

    const FormLabelRoot = styled$1('label', {
      name: 'MuiFormLabel',
      slot: 'Root',
      overridesResolver: ({
        ownerState
      }, styles) => {
        return _extends$1({}, styles.root, ownerState.color === 'secondary' && styles.colorSecondary, ownerState.filled && styles.filled);
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      color: theme.palette.text.secondary
    }, theme.typography.body1, {
      lineHeight: '1.4375em',
      padding: 0,
      position: 'relative',
      [`&.${formLabelClasses$1.focused}`]: {
        color: theme.palette[ownerState.color].main
      },
      [`&.${formLabelClasses$1.disabled}`]: {
        color: theme.palette.text.disabled
      },
      [`&.${formLabelClasses$1.error}`]: {
        color: theme.palette.error.main
      }
    }));
    const AsteriskComponent = styled$1('span', {
      name: 'MuiFormLabel',
      slot: 'Asterisk',
      overridesResolver: (props, styles) => styles.asterisk
    })(({
      theme
    }) => ({
      [`&.${formLabelClasses$1.error}`]: {
        color: theme.palette.error.main
      }
    }));
    const FormLabel = /*#__PURE__*/react.exports.forwardRef(function FormLabel(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiFormLabel'
      });

      const {
        children,
        className,
        component = 'label'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$k);

      const muiFormControl = useFormControl();
      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['color', 'required', 'focused', 'disabled', 'error', 'filled']
      });

      const ownerState = _extends$1({}, props, {
        color: fcs.color || 'primary',
        component,
        disabled: fcs.disabled,
        error: fcs.error,
        filled: fcs.filled,
        focused: fcs.focused,
        required: fcs.required
      });

      const classes = useUtilityClasses$g(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(FormLabelRoot, _extends$1({
        as: component,
        ownerState: ownerState,
        className: clsx(classes.root, className),
        ref: ref
      }, other, {
        children: [children, fcs.required && /*#__PURE__*/jsxRuntimeExports.jsxs(AsteriskComponent, {
          ownerState: ownerState,
          "aria-hidden": true,
          className: classes.asterisk,
          children: ["\u2009", '*']
        })]
      }));
    });
    process.env.NODE_ENV !== "production" ? FormLabel.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['error', 'info', 'primary', 'secondary', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, the label should be displayed in a disabled state.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the label is displayed in an error state.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the label should use filled classes key.
       */
      filled: propTypes.exports.bool,

      /**
       * If `true`, the input of this label is focused (used by `FormGroup` components).
       */
      focused: propTypes.exports.bool,

      /**
       * If `true`, the label will indicate that the `input` is required.
       */
      required: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var FormLabel$1 = FormLabel;

    const _excluded$j = ["addEndListener", "appear", "children", "easing", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "style", "timeout", "TransitionComponent"];

    function getScale(value) {
      return `scale(${value}, ${value ** 2})`;
    }

    const styles = {
      entering: {
        opacity: 1,
        transform: getScale(1)
      },
      entered: {
        opacity: 1,
        transform: 'none'
      }
    };
    /**
     * The Grow transition is used by the [Tooltip](/components/tooltips/) and
     * [Popover](/components/popover/) components.
     * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
     */

    const Grow = /*#__PURE__*/react.exports.forwardRef(function Grow(props, ref) {
      const {
        addEndListener,
        appear = true,
        children,
        easing,
        in: inProp,
        onEnter,
        onEntered,
        onEntering,
        onExit,
        onExited,
        onExiting,
        style,
        timeout = 'auto',
        // eslint-disable-next-line react/prop-types
        TransitionComponent = Transition
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$j);

      const timer = react.exports.useRef();
      const autoTimeout = react.exports.useRef();
      const theme = useTheme();
      const nodeRef = react.exports.useRef(null);
      const foreignRef = useForkRef(children.ref, ref);
      const handleRef = useForkRef(nodeRef, foreignRef);

      const normalizedTransitionCallback = callback => maybeIsAppearing => {
        if (callback) {
          const node = nodeRef.current; // onEnterXxx and onExitXxx callbacks have a different arguments.length value.

          if (maybeIsAppearing === undefined) {
            callback(node);
          } else {
            callback(node, maybeIsAppearing);
          }
        }
      };

      const handleEntering = normalizedTransitionCallback(onEntering);
      const handleEnter = normalizedTransitionCallback((node, isAppearing) => {
        reflow(node); // So the animation always start from the start.

        const {
          duration: transitionDuration,
          delay,
          easing: transitionTimingFunction
        } = getTransitionProps({
          style,
          timeout,
          easing
        }, {
          mode: 'enter'
        });
        let duration;

        if (timeout === 'auto') {
          duration = theme.transitions.getAutoHeightDuration(node.clientHeight);
          autoTimeout.current = duration;
        } else {
          duration = transitionDuration;
        }

        node.style.transition = [theme.transitions.create('opacity', {
          duration,
          delay
        }), theme.transitions.create('transform', {
          duration: duration * 0.666,
          delay,
          easing: transitionTimingFunction
        })].join(',');

        if (onEnter) {
          onEnter(node, isAppearing);
        }
      });
      const handleEntered = normalizedTransitionCallback(onEntered);
      const handleExiting = normalizedTransitionCallback(onExiting);
      const handleExit = normalizedTransitionCallback(node => {
        const {
          duration: transitionDuration,
          delay,
          easing: transitionTimingFunction
        } = getTransitionProps({
          style,
          timeout,
          easing
        }, {
          mode: 'exit'
        });
        let duration;

        if (timeout === 'auto') {
          duration = theme.transitions.getAutoHeightDuration(node.clientHeight);
          autoTimeout.current = duration;
        } else {
          duration = transitionDuration;
        }

        node.style.transition = [theme.transitions.create('opacity', {
          duration,
          delay
        }), theme.transitions.create('transform', {
          duration: duration * 0.666,
          delay: delay || duration * 0.333,
          easing: transitionTimingFunction
        })].join(',');
        node.style.opacity = '0';
        node.style.transform = getScale(0.75);

        if (onExit) {
          onExit(node);
        }
      });
      const handleExited = normalizedTransitionCallback(onExited);

      const handleAddEndListener = next => {
        if (timeout === 'auto') {
          timer.current = setTimeout(next, autoTimeout.current || 0);
        }

        if (addEndListener) {
          // Old call signature before `react-transition-group` implemented `nodeRef`
          addEndListener(nodeRef.current, next);
        }
      };

      react.exports.useEffect(() => {
        return () => {
          clearTimeout(timer.current);
        };
      }, []);
      return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
        appear: appear,
        in: inProp,
        nodeRef: nodeRef,
        onEnter: handleEnter,
        onEntered: handleEntered,
        onEntering: handleEntering,
        onExit: handleExit,
        onExited: handleExited,
        onExiting: handleExiting,
        addEndListener: handleAddEndListener,
        timeout: timeout === 'auto' ? null : timeout
      }, other, {
        children: (state, childProps) => {
          return /*#__PURE__*/react.exports.cloneElement(children, _extends$1({
            style: _extends$1({
              opacity: 0,
              transform: getScale(0.75),
              visibility: state === 'exited' && !inProp ? 'hidden' : undefined
            }, styles[state], style, children.props.style),
            ref: handleRef
          }, childProps));
        }
      }));
    });
    process.env.NODE_ENV !== "production" ? Grow.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Add a custom transition end trigger. Called with the transitioning DOM
       * node and a done callback. Allows for more fine grained transition end
       * logic. Note: Timeouts are still used as a fallback if provided.
       */
      addEndListener: propTypes.exports.func,

      /**
       * Perform the enter transition when it first mounts if `in` is also `true`.
       * Set this to `false` to disable this behavior.
       * @default true
       */
      appear: propTypes.exports.bool,

      /**
       * A single child content element.
       */
      children: elementAcceptingRef.isRequired,

      /**
       * The transition timing function.
       * You may specify a single easing or a object containing enter and exit values.
       */
      easing: propTypes.exports.oneOfType([propTypes.exports.shape({
        enter: propTypes.exports.string,
        exit: propTypes.exports.string
      }), propTypes.exports.string]),

      /**
       * If `true`, the component will transition in.
       */
      in: propTypes.exports.bool,

      /**
       * @ignore
       */
      onEnter: propTypes.exports.func,

      /**
       * @ignore
       */
      onEntered: propTypes.exports.func,

      /**
       * @ignore
       */
      onEntering: propTypes.exports.func,

      /**
       * @ignore
       */
      onExit: propTypes.exports.func,

      /**
       * @ignore
       */
      onExited: propTypes.exports.func,

      /**
       * @ignore
       */
      onExiting: propTypes.exports.func,

      /**
       * @ignore
       */
      style: propTypes.exports.object,

      /**
       * The duration for the transition, in milliseconds.
       * You may specify a single timeout for all transitions, or individually with an object.
       *
       * Set to 'auto' to automatically calculate transition time based on height.
       * @default 'auto'
       */
      timeout: propTypes.exports.oneOfType([propTypes.exports.oneOf(['auto']), propTypes.exports.number, propTypes.exports.shape({
        appear: propTypes.exports.number,
        enter: propTypes.exports.number,
        exit: propTypes.exports.number
      })])
    } : void 0;
    Grow.muiSupportAuto = true;
    var Grow$1 = Grow;

    const _excluded$i = ["disableUnderline", "components", "componentsProps", "fullWidth", "inputComponent", "multiline", "type"];

    const useUtilityClasses$f = ownerState => {
      const {
        classes,
        disableUnderline
      } = ownerState;
      const slots = {
        root: ['root', !disableUnderline && 'underline'],
        input: ['input']
      };
      const composedClasses = composeClasses(slots, getInputUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const InputRoot = styled$1(InputBaseRoot, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiInput',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [...rootOverridesResolver(props, styles), !ownerState.disableUnderline && styles.underline];
      }
    })(({
      theme,
      ownerState
    }) => {
      const light = theme.palette.mode === 'light';
      const bottomLineColor = light ? 'rgba(0, 0, 0, 0.42)' : 'rgba(255, 255, 255, 0.7)';
      return _extends$1({
        position: 'relative'
      }, ownerState.formControl && {
        'label + &': {
          marginTop: 16
        }
      }, !ownerState.disableUnderline && {
        '&:after': {
          borderBottom: `2px solid ${theme.palette[ownerState.color].main}`,
          left: 0,
          bottom: 0,
          // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
          content: '""',
          position: 'absolute',
          right: 0,
          transform: 'scaleX(0)',
          transition: theme.transitions.create('transform', {
            duration: theme.transitions.duration.shorter,
            easing: theme.transitions.easing.easeOut
          }),
          pointerEvents: 'none' // Transparent to the hover style.

        },
        [`&.${inputClasses$1.focused}:after`]: {
          transform: 'scaleX(1)'
        },
        [`&.${inputClasses$1.error}:after`]: {
          borderBottomColor: theme.palette.error.main,
          transform: 'scaleX(1)' // error is always underlined in red

        },
        '&:before': {
          borderBottom: `1px solid ${bottomLineColor}`,
          left: 0,
          bottom: 0,
          // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
          content: '"\\00a0"',
          position: 'absolute',
          right: 0,
          transition: theme.transitions.create('border-bottom-color', {
            duration: theme.transitions.duration.shorter
          }),
          pointerEvents: 'none' // Transparent to the hover style.

        },
        [`&:hover:not(.${inputClasses$1.disabled}):before`]: {
          borderBottom: `2px solid ${theme.palette.text.primary}`,
          // Reset on touch devices, it doesn't add specificity
          '@media (hover: none)': {
            borderBottom: `1px solid ${bottomLineColor}`
          }
        },
        [`&.${inputClasses$1.disabled}:before`]: {
          borderBottomStyle: 'dotted'
        }
      });
    });
    const InputInput = styled$1(InputBaseComponent, {
      name: 'MuiInput',
      slot: 'Input',
      overridesResolver: inputOverridesResolver
    })({});
    const Input = /*#__PURE__*/react.exports.forwardRef(function Input(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiInput'
      });

      const {
        disableUnderline,
        components = {},
        componentsProps: componentsPropsProp,
        fullWidth = false,
        inputComponent = 'input',
        multiline = false,
        type = 'text'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$i);

      const classes = useUtilityClasses$f(props);
      const ownerState = {
        disableUnderline
      };
      const inputComponentsProps = {
        root: {
          ownerState
        }
      };
      const componentsProps = componentsPropsProp ? deepmerge(componentsPropsProp, inputComponentsProps) : inputComponentsProps;
      return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
        components: _extends$1({
          Root: InputRoot,
          Input: InputInput
        }, components),
        componentsProps: componentsProps,
        fullWidth: fullWidth,
        inputComponent: inputComponent,
        multiline: multiline,
        ref: ref,
        type: type
      }, other, {
        classes: classes
      }));
    });
    process.env.NODE_ENV !== "production" ? Input.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * This prop helps users to fill forms faster, especially on mobile devices.
       * The name can be confusing, as it's more like an autofill.
       * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
       */
      autoComplete: propTypes.exports.string,

      /**
       * If `true`, the `input` element is focused during the first mount.
       */
      autoFocus: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary']), propTypes.exports.string]),

      /**
       * The components used for each slot inside the InputBase.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Input: propTypes.exports.elementType,
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Input.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        input: propTypes.exports.object,
        root: propTypes.exports.object
      }),

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the component is disabled.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the `input` will not have an underline.
       */
      disableUnderline: propTypes.exports.bool,

      /**
       * End `InputAdornment` for this component.
       */
      endAdornment: propTypes.exports.node,

      /**
       * If `true`, the `input` will indicate an error.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the `input` will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * The component used for the `input` element.
       * Either a string to use a HTML element or a component.
       * @default 'input'
       */
      inputComponent: propTypes.exports.elementType,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       * @default {}
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
       */
      margin: propTypes.exports.oneOf(['dense', 'none']),

      /**
       * Maximum number of rows to display when multiline option is set to true.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display when multiline option is set to true.
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * If `true`, a `textarea` element is rendered.
       * @default false
       */
      multiline: propTypes.exports.bool,

      /**
       * Name attribute of the `input` element.
       */
      name: propTypes.exports.string,

      /**
       * Callback fired when the value is changed.
       *
       * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * The short hint displayed in the `input` before the user enters a value.
       */
      placeholder: propTypes.exports.string,

      /**
       * It prevents the user from changing the value of the field
       * (not from interacting with the field).
       */
      readOnly: propTypes.exports.bool,

      /**
       * If `true`, the `input` element is required.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      required: propTypes.exports.bool,

      /**
       * Number of rows to display when multiline option is set to true.
       */
      rows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Start `InputAdornment` for this component.
       */
      startAdornment: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
       * @default 'text'
       */
      type: propTypes.exports.string,

      /**
       * The value of the `input` element, required for a controlled component.
       */
      value: propTypes.exports.any
    } : void 0;
    Input.muiName = 'Input';
    var Input$1 = Input;

    function getInputLabelUtilityClasses(slot) {
      return generateUtilityClass('MuiInputLabel', slot);
    }
    generateUtilityClasses('MuiInputLabel', ['root', 'focused', 'disabled', 'error', 'required', 'asterisk', 'formControl', 'sizeSmall', 'shrink', 'animated', 'standard', 'filled', 'outlined']);

    const _excluded$h = ["disableAnimation", "margin", "shrink", "variant"];

    const useUtilityClasses$e = ownerState => {
      const {
        classes,
        formControl,
        size,
        shrink,
        disableAnimation,
        variant,
        required
      } = ownerState;
      const slots = {
        root: ['root', formControl && 'formControl', !disableAnimation && 'animated', shrink && 'shrink', size === 'small' && 'sizeSmall', variant],
        asterisk: [required && 'asterisk']
      };
      const composedClasses = composeClasses(slots, getInputLabelUtilityClasses, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const InputLabelRoot = styled$1(FormLabel$1, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiInputLabel',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [{
          [`& .${formLabelClasses$1.asterisk}`]: styles.asterisk
        }, styles.root, ownerState.formControl && styles.formControl, ownerState.size === 'small' && styles.sizeSmall, ownerState.shrink && styles.shrink, !ownerState.disableAnimation && styles.animated, styles[ownerState.variant]];
      }
    })(({
      theme,
      ownerState
    }) => _extends$1({
      display: 'block',
      transformOrigin: 'top left',
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      maxWidth: '100%'
    }, ownerState.formControl && {
      position: 'absolute',
      left: 0,
      top: 0,
      // slight alteration to spec spacing to match visual spec result
      transform: 'translate(0, 20px) scale(1)'
    }, ownerState.size === 'small' && {
      // Compensation for the `Input.inputSizeSmall` style.
      transform: 'translate(0, 17px) scale(1)'
    }, ownerState.shrink && {
      transform: 'translate(0, -1.5px) scale(0.75)',
      transformOrigin: 'top left',
      maxWidth: '133%'
    }, !ownerState.disableAnimation && {
      transition: theme.transitions.create(['color', 'transform', 'max-width'], {
        duration: theme.transitions.duration.shorter,
        easing: theme.transitions.easing.easeOut
      })
    }, ownerState.variant === 'filled' && _extends$1({
      // Chrome's autofill feature gives the input field a yellow background.
      // Since the input field is behind the label in the HTML tree,
      // the input field is drawn last and hides the label with an opaque background color.
      // zIndex: 1 will raise the label above opaque background-colors of input.
      zIndex: 1,
      pointerEvents: 'none',
      transform: 'translate(12px, 16px) scale(1)',
      maxWidth: 'calc(100% - 24px)'
    }, ownerState.size === 'small' && {
      transform: 'translate(12px, 13px) scale(1)'
    }, ownerState.shrink && _extends$1({
      userSelect: 'none',
      pointerEvents: 'auto',
      transform: 'translate(12px, 7px) scale(0.75)',
      maxWidth: 'calc(133% - 24px)'
    }, ownerState.size === 'small' && {
      transform: 'translate(12px, 4px) scale(0.75)'
    })), ownerState.variant === 'outlined' && _extends$1({
      // see comment above on filled.zIndex
      zIndex: 1,
      pointerEvents: 'none',
      transform: 'translate(14px, 16px) scale(1)',
      maxWidth: 'calc(100% - 24px)'
    }, ownerState.size === 'small' && {
      transform: 'translate(14px, 9px) scale(1)'
    }, ownerState.shrink && {
      userSelect: 'none',
      pointerEvents: 'auto',
      maxWidth: 'calc(133% - 24px)',
      transform: 'translate(14px, -9px) scale(0.75)'
    })));
    const InputLabel = /*#__PURE__*/react.exports.forwardRef(function InputLabel(inProps, ref) {
      const props = useThemeProps({
        name: 'MuiInputLabel',
        props: inProps
      });

      const {
        disableAnimation = false,
        shrink: shrinkProp
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$h);

      const muiFormControl = useFormControl();
      let shrink = shrinkProp;

      if (typeof shrink === 'undefined' && muiFormControl) {
        shrink = muiFormControl.filled || muiFormControl.focused || muiFormControl.adornedStart;
      }

      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['size', 'variant', 'required']
      });

      const ownerState = _extends$1({}, props, {
        disableAnimation,
        formControl: muiFormControl,
        shrink,
        size: fcs.size,
        variant: fcs.variant,
        required: fcs.required
      });

      const classes = useUtilityClasses$e(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(InputLabelRoot, _extends$1({
        "data-shrink": shrink,
        ownerState: ownerState,
        ref: ref
      }, other, {
        classes: classes
      }));
    });
    process.env.NODE_ENV !== "production" ? InputLabel.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['error', 'info', 'primary', 'secondary', 'success', 'warning']), propTypes.exports.string]),

      /**
       * If `true`, the transition animation is disabled.
       * @default false
       */
      disableAnimation: propTypes.exports.bool,

      /**
       * If `true`, the component is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the label is displayed in an error state.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the `input` of this label is focused.
       */
      focused: propTypes.exports.bool,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       */
      margin: propTypes.exports.oneOf(['dense']),

      /**
       * if `true`, the label will indicate that the `input` is required.
       */
      required: propTypes.exports.bool,

      /**
       * If `true`, the label is shrunk.
       */
      shrink: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The variant to use.
       */
      variant: propTypes.exports.oneOf(['filled', 'outlined', 'standard'])
    } : void 0;
    var InputLabel$1 = InputLabel;

    /**
     * @ignore - internal component.
     */

    const ListContext = /*#__PURE__*/react.exports.createContext({});

    if (process.env.NODE_ENV !== 'production') {
      ListContext.displayName = 'ListContext';
    }

    var ListContext$1 = ListContext;

    function getListUtilityClass(slot) {
      return generateUtilityClass('MuiList', slot);
    }
    generateUtilityClasses('MuiList', ['root', 'padding', 'dense', 'subheader']);

    const _excluded$g = ["children", "className", "component", "dense", "disablePadding", "subheader"];

    const useUtilityClasses$d = ownerState => {
      const {
        classes,
        disablePadding,
        dense,
        subheader
      } = ownerState;
      const slots = {
        root: ['root', !disablePadding && 'padding', dense && 'dense', subheader && 'subheader']
      };
      return composeClasses(slots, getListUtilityClass, classes);
    };

    const ListRoot = styled$1('ul', {
      name: 'MuiList',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, !ownerState.disablePadding && styles.padding, ownerState.dense && styles.dense, ownerState.subheader && styles.subheader];
      }
    })(({
      ownerState
    }) => _extends$1({
      listStyle: 'none',
      margin: 0,
      padding: 0,
      position: 'relative'
    }, !ownerState.disablePadding && {
      paddingTop: 8,
      paddingBottom: 8
    }, ownerState.subheader && {
      paddingTop: 0
    }));
    const List = /*#__PURE__*/react.exports.forwardRef(function List(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiList'
      });

      const {
        children,
        className,
        component = 'ul',
        dense = false,
        disablePadding = false,
        subheader
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$g);

      const context = react.exports.useMemo(() => ({
        dense
      }), [dense]);

      const ownerState = _extends$1({}, props, {
        component,
        dense,
        disablePadding
      });

      const classes = useUtilityClasses$d(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
        value: context,
        children: /*#__PURE__*/jsxRuntimeExports.jsxs(ListRoot, _extends$1({
          as: component,
          className: clsx(classes.root, className),
          ref: ref,
          ownerState: ownerState
        }, other, {
          children: [subheader, children]
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? List.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, compact vertical padding designed for keyboard and mouse input is used for
       * the list and list items.
       * The prop is available to descendant components as the `dense` context.
       * @default false
       */
      dense: propTypes.exports.bool,

      /**
       * If `true`, vertical padding is removed from the list.
       * @default false
       */
      disablePadding: propTypes.exports.bool,

      /**
       * The content of the subheader, normally `ListSubheader`.
       */
      subheader: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var List$1 = List;

    function getListItemUtilityClass(slot) {
      return generateUtilityClass('MuiListItem', slot);
    }
    const listItemClasses = generateUtilityClasses('MuiListItem', ['root', 'container', 'focusVisible', 'dense', 'alignItemsFlexStart', 'disabled', 'divider', 'gutters', 'padding', 'button', 'secondaryAction', 'selected']);
    var listItemClasses$1 = listItemClasses;

    function getListItemButtonUtilityClass(slot) {
      return generateUtilityClass('MuiListItemButton', slot);
    }
    const listItemButtonClasses = generateUtilityClasses('MuiListItemButton', ['root', 'focusVisible', 'dense', 'alignItemsFlexStart', 'disabled', 'divider', 'gutters', 'selected']);
    var listItemButtonClasses$1 = listItemButtonClasses;

    const _excluded$f = ["alignItems", "autoFocus", "component", "children", "dense", "disableGutters", "divider", "focusVisibleClassName", "selected"];
    const overridesResolver$2 = (props, styles) => {
      const {
        ownerState
      } = props;
      return [styles.root, ownerState.dense && styles.dense, ownerState.alignItems === 'flex-start' && styles.alignItemsFlexStart, ownerState.divider && styles.divider, !ownerState.disableGutters && styles.gutters];
    };

    const useUtilityClasses$c = ownerState => {
      const {
        alignItems,
        classes,
        dense,
        disabled,
        disableGutters,
        divider,
        selected
      } = ownerState;
      const slots = {
        root: ['root', dense && 'dense', !disableGutters && 'gutters', divider && 'divider', disabled && 'disabled', alignItems === 'flex-start' && 'alignItemsFlexStart', selected && 'selected']
      };
      const composedClasses = composeClasses(slots, getListItemButtonUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const ListItemButtonRoot = styled$1(ButtonBase$1, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiListItemButton',
      slot: 'Root',
      overridesResolver: overridesResolver$2
    })(({
      theme,
      ownerState
    }) => _extends$1({
      display: 'flex',
      flexGrow: 1,
      justifyContent: 'flex-start',
      alignItems: 'center',
      position: 'relative',
      textDecoration: 'none',
      boxSizing: 'border-box',
      textAlign: 'left',
      paddingTop: 8,
      paddingBottom: 8,
      transition: theme.transitions.create('background-color', {
        duration: theme.transitions.duration.shortest
      }),
      '&:hover': {
        textDecoration: 'none',
        backgroundColor: theme.palette.action.hover,
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      },
      [`&.${listItemButtonClasses$1.selected}`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
        [`&.${listItemButtonClasses$1.focusVisible}`]: {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
        }
      },
      [`&.${listItemButtonClasses$1.selected}:hover`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity)
        }
      },
      [`&.${listItemButtonClasses$1.focusVisible}`]: {
        backgroundColor: theme.palette.action.focus
      },
      [`&.${listItemButtonClasses$1.disabled}`]: {
        opacity: theme.palette.action.disabledOpacity
      }
    }, ownerState.divider && {
      borderBottom: `1px solid ${theme.palette.divider}`,
      backgroundClip: 'padding-box'
    }, ownerState.alignItems === 'flex-start' && {
      alignItems: 'flex-start'
    }, !ownerState.disableGutters && {
      paddingLeft: 16,
      paddingRight: 16
    }, ownerState.dense && {
      paddingTop: 4,
      paddingBottom: 4
    }));
    const ListItemButton = /*#__PURE__*/react.exports.forwardRef(function ListItemButton(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiListItemButton'
      });

      const {
        alignItems = 'center',
        autoFocus = false,
        component = 'div',
        children,
        dense = false,
        disableGutters = false,
        divider = false,
        focusVisibleClassName,
        selected = false
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$f);

      const context = react.exports.useContext(ListContext$1);
      const childContext = {
        dense: dense || context.dense || false,
        alignItems,
        disableGutters
      };
      const listItemRef = react.exports.useRef(null);
      useEnhancedEffect(() => {
        if (autoFocus) {
          if (listItemRef.current) {
            listItemRef.current.focus();
          } else if (process.env.NODE_ENV !== 'production') {
            console.error('MUI: Unable to set focus to a ListItemButton whose component has not been rendered.');
          }
        }
      }, [autoFocus]);

      const ownerState = _extends$1({}, props, {
        alignItems,
        dense: childContext.dense,
        disableGutters,
        divider,
        selected
      });

      const classes = useUtilityClasses$c(ownerState);
      const handleRef = useForkRef(listItemRef, ref);
      return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
        value: childContext,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(ListItemButtonRoot, _extends$1({
          ref: handleRef,
          component: component,
          focusVisibleClassName: clsx(classes.focusVisible, focusVisibleClassName),
          ownerState: ownerState
        }, other, {
          classes: classes,
          children: children
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? ListItemButton.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Defines the `align-items` style property.
       * @default 'center'
       */
      alignItems: propTypes.exports.oneOf(['center', 'flex-start']),

      /**
       * If `true`, the list item is focused during the first mount.
       * Focus will also be triggered if the value changes from false to true.
       * @default false
       */
      autoFocus: propTypes.exports.bool,

      /**
       * The content of the component if a `ListItemSecondaryAction` is used it must
       * be the last child.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, compact vertical padding designed for keyboard and mouse input is used.
       * The prop defaults to the value inherited from the parent List component.
       * @default false
       */
      dense: propTypes.exports.bool,

      /**
       * If `true`, the component is disabled.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the left and right padding is removed.
       * @default false
       */
      disableGutters: propTypes.exports.bool,

      /**
       * If `true`, a 1px light border is added to the bottom of the list item.
       * @default false
       */
      divider: propTypes.exports.bool,

      /**
       * This prop can help identify which element has keyboard focus.
       * The class name will be applied when the element gains the focus through keyboard interaction.
       * It's a polyfill for the [CSS :focus-visible selector](https://drafts.csswg.org/selectors-4/#the-focus-visible-pseudo).
       * The rationale for using this feature [is explained here](https://github.com/WICG/focus-visible/blob/HEAD/explainer.md).
       * A [polyfill can be used](https://github.com/WICG/focus-visible) to apply a `focus-visible` class to other components
       * if needed.
       */
      focusVisibleClassName: propTypes.exports.string,

      /**
       * Use to apply selected styling.
       * @default false
       */
      selected: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var ListItemButton$1 = ListItemButton;

    function getListItemSecondaryActionClassesUtilityClass(slot) {
      return generateUtilityClass('MuiListItemSecondaryAction', slot);
    }
    generateUtilityClasses('MuiListItemSecondaryAction', ['root', 'disableGutters']);

    const _excluded$e = ["className"];

    const useUtilityClasses$b = ownerState => {
      const {
        disableGutters,
        classes
      } = ownerState;
      const slots = {
        root: ['root', disableGutters && 'disableGutters']
      };
      return composeClasses(slots, getListItemSecondaryActionClassesUtilityClass, classes);
    };

    const ListItemSecondaryActionRoot = styled$1('div', {
      name: 'MuiListItemSecondaryAction',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.disableGutters && styles.disableGutters];
      }
    })(({
      ownerState
    }) => _extends$1({
      position: 'absolute',
      right: 16,
      top: '50%',
      transform: 'translateY(-50%)'
    }, ownerState.disableGutters && {
      right: 0
    }));
    /**
     * Must be used as the last child of ListItem to function properly.
     */

    const ListItemSecondaryAction = /*#__PURE__*/react.exports.forwardRef(function ListItemSecondaryAction(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiListItemSecondaryAction'
      });

      const {
        className
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$e);

      const context = react.exports.useContext(ListContext$1);

      const ownerState = _extends$1({}, props, {
        disableGutters: context.disableGutters
      });

      const classes = useUtilityClasses$b(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsx(ListItemSecondaryActionRoot, _extends$1({
        className: clsx(classes.root, className),
        ownerState: ownerState,
        ref: ref
      }, other));
    });
    process.env.NODE_ENV !== "production" ? ListItemSecondaryAction.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component, normally an `IconButton` or selection control.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    ListItemSecondaryAction.muiName = 'ListItemSecondaryAction';
    var ListItemSecondaryAction$1 = ListItemSecondaryAction;

    const _excluded$d = ["className"],
          _excluded2$2 = ["alignItems", "autoFocus", "button", "children", "className", "component", "components", "componentsProps", "ContainerComponent", "ContainerProps", "dense", "disabled", "disableGutters", "disablePadding", "divider", "focusVisibleClassName", "secondaryAction", "selected"];
    const overridesResolver$1 = (props, styles) => {
      const {
        ownerState
      } = props;
      return [styles.root, ownerState.dense && styles.dense, ownerState.alignItems === 'flex-start' && styles.alignItemsFlexStart, ownerState.divider && styles.divider, !ownerState.disableGutters && styles.gutters, !ownerState.disablePadding && styles.padding, ownerState.button && styles.button, ownerState.hasSecondaryAction && styles.secondaryAction];
    };

    const useUtilityClasses$a = ownerState => {
      const {
        alignItems,
        button,
        classes,
        dense,
        disabled,
        disableGutters,
        disablePadding,
        divider,
        hasSecondaryAction,
        selected
      } = ownerState;
      const slots = {
        root: ['root', dense && 'dense', !disableGutters && 'gutters', !disablePadding && 'padding', divider && 'divider', disabled && 'disabled', button && 'button', alignItems === 'flex-start' && 'alignItemsFlexStart', hasSecondaryAction && 'secondaryAction', selected && 'selected'],
        container: ['container']
      };
      return composeClasses(slots, getListItemUtilityClass, classes);
    };

    const ListItemRoot = styled$1('div', {
      name: 'MuiListItem',
      slot: 'Root',
      overridesResolver: overridesResolver$1
    })(({
      theme,
      ownerState
    }) => _extends$1({
      display: 'flex',
      justifyContent: 'flex-start',
      alignItems: 'center',
      position: 'relative',
      textDecoration: 'none',
      width: '100%',
      boxSizing: 'border-box',
      textAlign: 'left'
    }, !ownerState.disablePadding && _extends$1({
      paddingTop: 8,
      paddingBottom: 8
    }, ownerState.dense && {
      paddingTop: 4,
      paddingBottom: 4
    }, !ownerState.disableGutters && {
      paddingLeft: 16,
      paddingRight: 16
    }, !!ownerState.secondaryAction && {
      // Add some space to avoid collision as `ListItemSecondaryAction`
      // is absolutely positioned.
      paddingRight: 48
    }), !!ownerState.secondaryAction && {
      [`& > .${listItemButtonClasses$1.root}`]: {
        paddingRight: 48
      }
    }, {
      [`&.${listItemClasses$1.focusVisible}`]: {
        backgroundColor: theme.palette.action.focus
      },
      [`&.${listItemClasses$1.selected}`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
        [`&.${listItemClasses$1.focusVisible}`]: {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
        }
      },
      [`&.${listItemClasses$1.disabled}`]: {
        opacity: theme.palette.action.disabledOpacity
      }
    }, ownerState.alignItems === 'flex-start' && {
      alignItems: 'flex-start'
    }, ownerState.divider && {
      borderBottom: `1px solid ${theme.palette.divider}`,
      backgroundClip: 'padding-box'
    }, ownerState.button && {
      transition: theme.transitions.create('background-color', {
        duration: theme.transitions.duration.shortest
      }),
      '&:hover': {
        textDecoration: 'none',
        backgroundColor: theme.palette.action.hover,
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      },
      [`&.${listItemClasses$1.selected}:hover`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity)
        }
      }
    }, ownerState.hasSecondaryAction && {
      // Add some space to avoid collision as `ListItemSecondaryAction`
      // is absolutely positioned.
      paddingRight: 48
    }));
    const ListItemContainer = styled$1('li', {
      name: 'MuiListItem',
      slot: 'Container',
      overridesResolver: (props, styles) => styles.container
    })({
      position: 'relative'
    });
    /**
     * Uses an additional container component if `ListItemSecondaryAction` is the last child.
     */

    const ListItem = /*#__PURE__*/react.exports.forwardRef(function ListItem(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiListItem'
      });

      const {
        alignItems = 'center',
        autoFocus = false,
        button = false,
        children: childrenProp,
        className,
        component: componentProp,
        components = {},
        componentsProps = {},
        ContainerComponent = 'li',
        ContainerProps: {
          className: ContainerClassName
        } = {},
        dense = false,
        disabled = false,
        disableGutters = false,
        disablePadding = false,
        divider = false,
        focusVisibleClassName,
        secondaryAction,
        selected = false
      } = props,
            ContainerProps = _objectWithoutPropertiesLoose(props.ContainerProps, _excluded$d),
            other = _objectWithoutPropertiesLoose(props, _excluded2$2);

      const context = react.exports.useContext(ListContext$1);
      const childContext = {
        dense: dense || context.dense || false,
        alignItems,
        disableGutters
      };
      const listItemRef = react.exports.useRef(null);
      useEnhancedEffect(() => {
        if (autoFocus) {
          if (listItemRef.current) {
            listItemRef.current.focus();
          } else if (process.env.NODE_ENV !== 'production') {
            console.error('MUI: Unable to set focus to a ListItem whose component has not been rendered.');
          }
        }
      }, [autoFocus]);
      const children = react.exports.Children.toArray(childrenProp); // v4 implementation, deprecated in v5, will be removed in v6

      const hasSecondaryAction = children.length && isMuiElement(children[children.length - 1], ['ListItemSecondaryAction']);

      const ownerState = _extends$1({}, props, {
        alignItems,
        autoFocus,
        button,
        dense: childContext.dense,
        disabled,
        disableGutters,
        disablePadding,
        divider,
        hasSecondaryAction,
        selected
      });

      const classes = useUtilityClasses$a(ownerState);
      const handleRef = useForkRef(listItemRef, ref);
      const Root = components.Root || ListItemRoot;
      const rootProps = componentsProps.root || {};

      const componentProps = _extends$1({
        className: clsx(classes.root, rootProps.className, className),
        disabled
      }, other);

      let Component = componentProp || 'li';

      if (button) {
        componentProps.component = componentProp || 'div';
        componentProps.focusVisibleClassName = clsx(listItemClasses$1.focusVisible, focusVisibleClassName);
        Component = ButtonBase$1;
      } // v4 implementation, deprecated in v5, will be removed in v6


      if (hasSecondaryAction) {
        // Use div by default.
        Component = !componentProps.component && !componentProp ? 'div' : Component; // Avoid nesting of li > li.

        if (ContainerComponent === 'li') {
          if (Component === 'li') {
            Component = 'div';
          } else if (componentProps.component === 'li') {
            componentProps.component = 'div';
          }
        }

        return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
          value: childContext,
          children: /*#__PURE__*/jsxRuntimeExports.jsxs(ListItemContainer, _extends$1({
            as: ContainerComponent,
            className: clsx(classes.container, ContainerClassName),
            ref: handleRef,
            ownerState: ownerState
          }, ContainerProps, {
            children: [/*#__PURE__*/jsxRuntimeExports.jsx(Root, _extends$1({}, rootProps, !isHostComponent(Root) && {
              as: Component,
              ownerState: _extends$1({}, ownerState, rootProps.ownerState)
            }, componentProps, {
              children: children
            })), children.pop()]
          }))
        });
      }

      return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
        value: childContext,
        children: /*#__PURE__*/jsxRuntimeExports.jsxs(Root, _extends$1({}, rootProps, {
          as: Component,
          ref: handleRef,
          ownerState: ownerState
        }, !isHostComponent(Root) && {
          ownerState: _extends$1({}, ownerState, rootProps.ownerState)
        }, componentProps, {
          children: [children, secondaryAction && /*#__PURE__*/jsxRuntimeExports.jsx(ListItemSecondaryAction$1, {
            children: secondaryAction
          })]
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? ListItem.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Defines the `align-items` style property.
       * @default 'center'
       */
      alignItems: propTypes.exports.oneOf(['center', 'flex-start']),

      /**
       * If `true`, the list item is focused during the first mount.
       * Focus will also be triggered if the value changes from false to true.
       * @default false
       * @deprecated checkout [ListItemButton](/api/list-item-button/) instead
       */
      autoFocus: propTypes.exports.bool,

      /**
       * If `true`, the list item is a button (using `ButtonBase`). Props intended
       * for `ButtonBase` can then be applied to `ListItem`.
       * @default false
       * @deprecated checkout [ListItemButton](/api/list-item-button/) instead
       */
      button: propTypes.exports.bool,

      /**
       * The content of the component if a `ListItemSecondaryAction` is used it must
       * be the last child.
       */
      children: chainPropTypes(propTypes.exports.node, props => {
        const children = react.exports.Children.toArray(props.children); // React.Children.toArray(props.children).findLastIndex(isListItemSecondaryAction)

        let secondaryActionIndex = -1;

        for (let i = children.length - 1; i >= 0; i -= 1) {
          const child = children[i];

          if (isMuiElement(child, ['ListItemSecondaryAction'])) {
            secondaryActionIndex = i;
            break;
          }
        } //  is ListItemSecondaryAction the last child of ListItem


        if (secondaryActionIndex !== -1 && secondaryActionIndex !== children.length - 1) {
          return new Error('MUI: You used an element after ListItemSecondaryAction. ' + 'For ListItem to detect that it has a secondary action ' + 'you must pass it as the last child to ListItem.');
        }

        return null;
      }),

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * The components used for each slot inside the InputBase.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Root: propTypes.exports.elementType
      }),

      /**
       * The props used for each slot inside the Input.
       * @default {}
       */
      componentsProps: propTypes.exports.shape({
        root: propTypes.exports.object
      }),

      /**
       * The container component used when a `ListItemSecondaryAction` is the last child.
       * @default 'li'
       * @deprecated
       */
      ContainerComponent: elementTypeAcceptingRef$1,

      /**
       * Props applied to the container component if used.
       * @default {}
       * @deprecated
       */
      ContainerProps: propTypes.exports.object,

      /**
       * If `true`, compact vertical padding designed for keyboard and mouse input is used.
       * The prop defaults to the value inherited from the parent List component.
       * @default false
       */
      dense: propTypes.exports.bool,

      /**
       * If `true`, the component is disabled.
       * @default false
       * @deprecated checkout [ListItemButton](/api/list-item-button/) instead
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the left and right padding is removed.
       * @default false
       */
      disableGutters: propTypes.exports.bool,

      /**
       * If `true`, all padding is removed.
       * @default false
       */
      disablePadding: propTypes.exports.bool,

      /**
       * If `true`, a 1px light border is added to the bottom of the list item.
       * @default false
       */
      divider: propTypes.exports.bool,

      /**
       * @ignore
       */
      focusVisibleClassName: propTypes.exports.string,

      /**
       * The element to display at the end of ListItem.
       */
      secondaryAction: propTypes.exports.node,

      /**
       * Use to apply selected styling.
       * @default false
       * @deprecated checkout [ListItemButton](/api/list-item-button/) instead
       */
      selected: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var ListItem$1 = ListItem;

    const listItemIconClasses = generateUtilityClasses('MuiListItemIcon', ['root', 'alignItemsFlexStart']);
    var listItemIconClasses$1 = listItemIconClasses;

    function getListItemTextUtilityClass(slot) {
      return generateUtilityClass('MuiListItemText', slot);
    }
    const listItemTextClasses = generateUtilityClasses('MuiListItemText', ['root', 'multiline', 'dense', 'inset', 'primary', 'secondary']);
    var listItemTextClasses$1 = listItemTextClasses;

    const _excluded$c = ["children", "className", "disableTypography", "inset", "primary", "primaryTypographyProps", "secondary", "secondaryTypographyProps"];

    const useUtilityClasses$9 = ownerState => {
      const {
        classes,
        inset,
        primary,
        secondary,
        dense
      } = ownerState;
      const slots = {
        root: ['root', inset && 'inset', dense && 'dense', primary && secondary && 'multiline'],
        primary: ['primary'],
        secondary: ['secondary']
      };
      return composeClasses(slots, getListItemTextUtilityClass, classes);
    };

    const ListItemTextRoot = styled$1('div', {
      name: 'MuiListItemText',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [{
          [`& .${listItemTextClasses$1.primary}`]: styles.primary
        }, {
          [`& .${listItemTextClasses$1.secondary}`]: styles.secondary
        }, styles.root, ownerState.inset && styles.inset, ownerState.primary && ownerState.secondary && styles.multiline, ownerState.dense && styles.dense];
      }
    })(({
      ownerState
    }) => _extends$1({
      flex: '1 1 auto',
      minWidth: 0,
      marginTop: 4,
      marginBottom: 4
    }, ownerState.primary && ownerState.secondary && {
      marginTop: 6,
      marginBottom: 6
    }, ownerState.inset && {
      paddingLeft: 56
    }));
    const ListItemText = /*#__PURE__*/react.exports.forwardRef(function ListItemText(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiListItemText'
      });

      const {
        children,
        className,
        disableTypography = false,
        inset = false,
        primary: primaryProp,
        primaryTypographyProps,
        secondary: secondaryProp,
        secondaryTypographyProps
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$c);

      const {
        dense
      } = react.exports.useContext(ListContext$1);
      let primary = primaryProp != null ? primaryProp : children;
      let secondary = secondaryProp;

      const ownerState = _extends$1({}, props, {
        disableTypography,
        inset,
        primary: !!primary,
        secondary: !!secondary,
        dense
      });

      const classes = useUtilityClasses$9(ownerState);

      if (primary != null && primary.type !== Typography$1 && !disableTypography) {
        primary = /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
          variant: dense ? 'body2' : 'body1',
          className: classes.primary,
          component: "span",
          display: "block"
        }, primaryTypographyProps, {
          children: primary
        }));
      }

      if (secondary != null && secondary.type !== Typography$1 && !disableTypography) {
        secondary = /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
          variant: "body2",
          className: classes.secondary,
          color: "text.secondary",
          display: "block"
        }, secondaryTypographyProps, {
          children: secondary
        }));
      }

      return /*#__PURE__*/jsxRuntimeExports.jsxs(ListItemTextRoot, _extends$1({
        className: clsx(classes.root, className),
        ownerState: ownerState,
        ref: ref
      }, other, {
        children: [primary, secondary]
      }));
    });
    process.env.NODE_ENV !== "production" ? ListItemText.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * Alias for the `primary` prop.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * If `true`, the children won't be wrapped by a Typography component.
       * This can be useful to render an alternative Typography variant by wrapping
       * the `children` (or `primary`) text, and optional `secondary` text
       * with the Typography component.
       * @default false
       */
      disableTypography: propTypes.exports.bool,

      /**
       * If `true`, the children are indented.
       * This should be used if there is no left avatar or left icon.
       * @default false
       */
      inset: propTypes.exports.bool,

      /**
       * The main content element.
       */
      primary: propTypes.exports.node,

      /**
       * These props will be forwarded to the primary typography component
       * (as long as disableTypography is not `true`).
       */
      primaryTypographyProps: propTypes.exports.object,

      /**
       * The secondary content element.
       */
      secondary: propTypes.exports.node,

      /**
       * These props will be forwarded to the secondary typography component
       * (as long as disableTypography is not `true`).
       */
      secondaryTypographyProps: propTypes.exports.object,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var ListItemText$1 = ListItemText;

    const _excluded$b = ["actions", "autoFocus", "autoFocusItem", "children", "className", "disabledItemsFocusable", "disableListWrap", "onKeyDown", "variant"];

    function nextItem(list, item, disableListWrap) {
      if (list === item) {
        return list.firstChild;
      }

      if (item && item.nextElementSibling) {
        return item.nextElementSibling;
      }

      return disableListWrap ? null : list.firstChild;
    }

    function previousItem(list, item, disableListWrap) {
      if (list === item) {
        return disableListWrap ? list.firstChild : list.lastChild;
      }

      if (item && item.previousElementSibling) {
        return item.previousElementSibling;
      }

      return disableListWrap ? null : list.lastChild;
    }

    function textCriteriaMatches(nextFocus, textCriteria) {
      if (textCriteria === undefined) {
        return true;
      }

      let text = nextFocus.innerText;

      if (text === undefined) {
        // jsdom doesn't support innerText
        text = nextFocus.textContent;
      }

      text = text.trim().toLowerCase();

      if (text.length === 0) {
        return false;
      }

      if (textCriteria.repeating) {
        return text[0] === textCriteria.keys[0];
      }

      return text.indexOf(textCriteria.keys.join('')) === 0;
    }

    function moveFocus(list, currentFocus, disableListWrap, disabledItemsFocusable, traversalFunction, textCriteria) {
      let wrappedOnce = false;
      let nextFocus = traversalFunction(list, currentFocus, currentFocus ? disableListWrap : false);

      while (nextFocus) {
        // Prevent infinite loop.
        if (nextFocus === list.firstChild) {
          if (wrappedOnce) {
            return false;
          }

          wrappedOnce = true;
        } // Same logic as useAutocomplete.js


        const nextFocusDisabled = disabledItemsFocusable ? false : nextFocus.disabled || nextFocus.getAttribute('aria-disabled') === 'true';

        if (!nextFocus.hasAttribute('tabindex') || !textCriteriaMatches(nextFocus, textCriteria) || nextFocusDisabled) {
          // Move to the next element.
          nextFocus = traversalFunction(list, nextFocus, disableListWrap);
        } else {
          nextFocus.focus();
          return true;
        }
      }

      return false;
    }
    /**
     * A permanently displayed menu following https://www.w3.org/TR/wai-aria-practices/#menubutton.
     * It's exposed to help customization of the [`Menu`](/api/menu/) component if you
     * use it separately you need to move focus into the component manually. Once
     * the focus is placed inside the component it is fully keyboard accessible.
     */


    const MenuList = /*#__PURE__*/react.exports.forwardRef(function MenuList(props, ref) {
      const {
        // private
        // eslint-disable-next-line react/prop-types
        actions,
        autoFocus = false,
        autoFocusItem = false,
        children,
        className,
        disabledItemsFocusable = false,
        disableListWrap = false,
        onKeyDown,
        variant = 'selectedMenu'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$b);

      const listRef = react.exports.useRef(null);
      const textCriteriaRef = react.exports.useRef({
        keys: [],
        repeating: true,
        previousKeyMatched: true,
        lastTime: null
      });
      useEnhancedEffect(() => {
        if (autoFocus) {
          listRef.current.focus();
        }
      }, [autoFocus]);
      react.exports.useImperativeHandle(actions, () => ({
        adjustStyleForScrollbar: (containerElement, theme) => {
          // Let's ignore that piece of logic if users are already overriding the width
          // of the menu.
          const noExplicitWidth = !listRef.current.style.width;

          if (containerElement.clientHeight < listRef.current.clientHeight && noExplicitWidth) {
            const scrollbarSize = `${getScrollbarSize(ownerDocument(containerElement))}px`;
            listRef.current.style[theme.direction === 'rtl' ? 'paddingLeft' : 'paddingRight'] = scrollbarSize;
            listRef.current.style.width = `calc(100% + ${scrollbarSize})`;
          }

          return listRef.current;
        }
      }), []);

      const handleKeyDown = event => {
        const list = listRef.current;
        const key = event.key;
        /**
         * @type {Element} - will always be defined since we are in a keydown handler
         * attached to an element. A keydown event is either dispatched to the activeElement
         * or document.body or document.documentElement. Only the first case will
         * trigger this specific handler.
         */

        const currentFocus = ownerDocument(list).activeElement;

        if (key === 'ArrowDown') {
          // Prevent scroll of the page
          event.preventDefault();
          moveFocus(list, currentFocus, disableListWrap, disabledItemsFocusable, nextItem);
        } else if (key === 'ArrowUp') {
          event.preventDefault();
          moveFocus(list, currentFocus, disableListWrap, disabledItemsFocusable, previousItem);
        } else if (key === 'Home') {
          event.preventDefault();
          moveFocus(list, null, disableListWrap, disabledItemsFocusable, nextItem);
        } else if (key === 'End') {
          event.preventDefault();
          moveFocus(list, null, disableListWrap, disabledItemsFocusable, previousItem);
        } else if (key.length === 1) {
          const criteria = textCriteriaRef.current;
          const lowerKey = key.toLowerCase();
          const currTime = performance.now();

          if (criteria.keys.length > 0) {
            // Reset
            if (currTime - criteria.lastTime > 500) {
              criteria.keys = [];
              criteria.repeating = true;
              criteria.previousKeyMatched = true;
            } else if (criteria.repeating && lowerKey !== criteria.keys[0]) {
              criteria.repeating = false;
            }
          }

          criteria.lastTime = currTime;
          criteria.keys.push(lowerKey);
          const keepFocusOnCurrent = currentFocus && !criteria.repeating && textCriteriaMatches(currentFocus, criteria);

          if (criteria.previousKeyMatched && (keepFocusOnCurrent || moveFocus(list, currentFocus, false, disabledItemsFocusable, nextItem, criteria))) {
            event.preventDefault();
          } else {
            criteria.previousKeyMatched = false;
          }
        }

        if (onKeyDown) {
          onKeyDown(event);
        }
      };

      const handleRef = useForkRef(listRef, ref);
      /**
       * the index of the item should receive focus
       * in a `variant="selectedMenu"` it's the first `selected` item
       * otherwise it's the very first item.
       */

      let activeItemIndex = -1; // since we inject focus related props into children we have to do a lookahead
      // to check if there is a `selected` item. We're looking for the last `selected`
      // item and use the first valid item as a fallback

      react.exports.Children.forEach(children, (child, index) => {
        if (! /*#__PURE__*/react.exports.isValidElement(child)) {
          return;
        }

        if (process.env.NODE_ENV !== 'production') {
          if (reactIs.exports.isFragment(child)) {
            console.error(["MUI: The Menu component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
          }
        }

        if (!child.props.disabled) {
          if (variant === 'selectedMenu' && child.props.selected) {
            activeItemIndex = index;
          } else if (activeItemIndex === -1) {
            activeItemIndex = index;
          }
        }
      });
      const items = react.exports.Children.map(children, (child, index) => {
        if (index === activeItemIndex) {
          const newChildProps = {};

          if (autoFocusItem) {
            newChildProps.autoFocus = true;
          }

          if (child.props.tabIndex === undefined && variant === 'selectedMenu') {
            newChildProps.tabIndex = 0;
          }

          return /*#__PURE__*/react.exports.cloneElement(child, newChildProps);
        }

        return child;
      });
      return /*#__PURE__*/jsxRuntimeExports.jsx(List$1, _extends$1({
        role: "menu",
        ref: handleRef,
        className: className,
        onKeyDown: handleKeyDown,
        tabIndex: autoFocus ? 0 : -1
      }, other, {
        children: items
      }));
    });
    process.env.NODE_ENV !== "production" ? MenuList.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * If `true`, will focus the `[role="menu"]` container and move into tab order.
       * @default false
       */
      autoFocus: propTypes.exports.bool,

      /**
       * If `true`, will focus the first menuitem if `variant="menu"` or selected item
       * if `variant="selectedMenu"`.
       * @default false
       */
      autoFocusItem: propTypes.exports.bool,

      /**
       * MenuList contents, normally `MenuItem`s.
       */
      children: propTypes.exports.node,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * If `true`, will allow focus on disabled items.
       * @default false
       */
      disabledItemsFocusable: propTypes.exports.bool,

      /**
       * If `true`, the menu items will not wrap focus.
       * @default false
       */
      disableListWrap: propTypes.exports.bool,

      /**
       * @ignore
       */
      onKeyDown: propTypes.exports.func,

      /**
       * The variant to use. Use `menu` to prevent selected items from impacting the initial focus
       * and the vertical alignment relative to the anchor element.
       * @default 'selectedMenu'
       */
      variant: propTypes.exports.oneOf(['menu', 'selectedMenu'])
    } : void 0;
    var MenuList$1 = MenuList;

    function getPopoverUtilityClass(slot) {
      return generateUtilityClass('MuiPopover', slot);
    }
    generateUtilityClasses('MuiPopover', ['root', 'paper']);

    const _excluded$a = ["onEntering"],
          _excluded2$1 = ["action", "anchorEl", "anchorOrigin", "anchorPosition", "anchorReference", "children", "className", "container", "elevation", "marginThreshold", "open", "PaperProps", "transformOrigin", "TransitionComponent", "transitionDuration", "TransitionProps"];
    function getOffsetTop(rect, vertical) {
      let offset = 0;

      if (typeof vertical === 'number') {
        offset = vertical;
      } else if (vertical === 'center') {
        offset = rect.height / 2;
      } else if (vertical === 'bottom') {
        offset = rect.height;
      }

      return offset;
    }
    function getOffsetLeft(rect, horizontal) {
      let offset = 0;

      if (typeof horizontal === 'number') {
        offset = horizontal;
      } else if (horizontal === 'center') {
        offset = rect.width / 2;
      } else if (horizontal === 'right') {
        offset = rect.width;
      }

      return offset;
    }

    function getTransformOriginValue(transformOrigin) {
      return [transformOrigin.horizontal, transformOrigin.vertical].map(n => typeof n === 'number' ? `${n}px` : n).join(' ');
    }

    function resolveAnchorEl(anchorEl) {
      return typeof anchorEl === 'function' ? anchorEl() : anchorEl;
    }

    const useUtilityClasses$8 = ownerState => {
      const {
        classes
      } = ownerState;
      const slots = {
        root: ['root'],
        paper: ['paper']
      };
      return composeClasses(slots, getPopoverUtilityClass, classes);
    };

    const PopoverRoot = styled$1(Modal$1, {
      name: 'MuiPopover',
      slot: 'Root',
      overridesResolver: (props, styles) => styles.root
    })({});
    const PopoverPaper = styled$1(Paper$1, {
      name: 'MuiPopover',
      slot: 'Paper',
      overridesResolver: (props, styles) => styles.paper
    })({
      position: 'absolute',
      overflowY: 'auto',
      overflowX: 'hidden',
      // So we see the popover when it's empty.
      // It's most likely on issue on userland.
      minWidth: 16,
      minHeight: 16,
      maxWidth: 'calc(100% - 32px)',
      maxHeight: 'calc(100% - 32px)',
      // We disable the focus ring for mouse, touch and keyboard users.
      outline: 0
    });
    const Popover = /*#__PURE__*/react.exports.forwardRef(function Popover(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiPopover'
      });

      const {
        action,
        anchorEl,
        anchorOrigin = {
          vertical: 'top',
          horizontal: 'left'
        },
        anchorPosition,
        anchorReference = 'anchorEl',
        children,
        className,
        container: containerProp,
        elevation = 8,
        marginThreshold = 16,
        open,
        PaperProps = {},
        transformOrigin = {
          vertical: 'top',
          horizontal: 'left'
        },
        TransitionComponent = Grow$1,
        transitionDuration: transitionDurationProp = 'auto',
        TransitionProps: {
          onEntering
        } = {}
      } = props,
            TransitionProps = _objectWithoutPropertiesLoose(props.TransitionProps, _excluded$a),
            other = _objectWithoutPropertiesLoose(props, _excluded2$1);

      const paperRef = react.exports.useRef();
      const handlePaperRef = useForkRef(paperRef, PaperProps.ref);

      const ownerState = _extends$1({}, props, {
        anchorOrigin,
        anchorReference,
        elevation,
        marginThreshold,
        PaperProps,
        transformOrigin,
        TransitionComponent,
        transitionDuration: transitionDurationProp,
        TransitionProps
      });

      const classes = useUtilityClasses$8(ownerState); // Returns the top/left offset of the position
      // to attach to on the anchor element (or body if none is provided)

      const getAnchorOffset = react.exports.useCallback(() => {
        if (anchorReference === 'anchorPosition') {
          if (process.env.NODE_ENV !== 'production') {
            if (!anchorPosition) {
              console.error('MUI: You need to provide a `anchorPosition` prop when using ' + '<Popover anchorReference="anchorPosition" />.');
            }
          }

          return anchorPosition;
        }

        const resolvedAnchorEl = resolveAnchorEl(anchorEl); // If an anchor element wasn't provided, just use the parent body element of this Popover

        const anchorElement = resolvedAnchorEl && resolvedAnchorEl.nodeType === 1 ? resolvedAnchorEl : ownerDocument(paperRef.current).body;
        const anchorRect = anchorElement.getBoundingClientRect();

        if (process.env.NODE_ENV !== 'production') {
          const box = anchorElement.getBoundingClientRect();

          if (process.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
            console.warn(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
          }
        }

        return {
          top: anchorRect.top + getOffsetTop(anchorRect, anchorOrigin.vertical),
          left: anchorRect.left + getOffsetLeft(anchorRect, anchorOrigin.horizontal)
        };
      }, [anchorEl, anchorOrigin.horizontal, anchorOrigin.vertical, anchorPosition, anchorReference]); // Returns the base transform origin using the element

      const getTransformOrigin = react.exports.useCallback(elemRect => {
        return {
          vertical: getOffsetTop(elemRect, transformOrigin.vertical),
          horizontal: getOffsetLeft(elemRect, transformOrigin.horizontal)
        };
      }, [transformOrigin.horizontal, transformOrigin.vertical]);
      const getPositioningStyle = react.exports.useCallback(element => {
        const elemRect = {
          width: element.offsetWidth,
          height: element.offsetHeight
        }; // Get the transform origin point on the element itself

        const elemTransformOrigin = getTransformOrigin(elemRect);

        if (anchorReference === 'none') {
          return {
            top: null,
            left: null,
            transformOrigin: getTransformOriginValue(elemTransformOrigin)
          };
        } // Get the offset of the anchoring element


        const anchorOffset = getAnchorOffset(); // Calculate element positioning

        let top = anchorOffset.top - elemTransformOrigin.vertical;
        let left = anchorOffset.left - elemTransformOrigin.horizontal;
        const bottom = top + elemRect.height;
        const right = left + elemRect.width; // Use the parent window of the anchorEl if provided

        const containerWindow = ownerWindow(resolveAnchorEl(anchorEl)); // Window thresholds taking required margin into account

        const heightThreshold = containerWindow.innerHeight - marginThreshold;
        const widthThreshold = containerWindow.innerWidth - marginThreshold; // Check if the vertical axis needs shifting

        if (top < marginThreshold) {
          const diff = top - marginThreshold;
          top -= diff;
          elemTransformOrigin.vertical += diff;
        } else if (bottom > heightThreshold) {
          const diff = bottom - heightThreshold;
          top -= diff;
          elemTransformOrigin.vertical += diff;
        }

        if (process.env.NODE_ENV !== 'production') {
          if (elemRect.height > heightThreshold && elemRect.height && heightThreshold) {
            console.error(['MUI: The popover component is too tall.', `Some part of it can not be seen on the screen (${elemRect.height - heightThreshold}px).`, 'Please consider adding a `max-height` to improve the user-experience.'].join('\n'));
          }
        } // Check if the horizontal axis needs shifting


        if (left < marginThreshold) {
          const diff = left - marginThreshold;
          left -= diff;
          elemTransformOrigin.horizontal += diff;
        } else if (right > widthThreshold) {
          const diff = right - widthThreshold;
          left -= diff;
          elemTransformOrigin.horizontal += diff;
        }

        return {
          top: `${Math.round(top)}px`,
          left: `${Math.round(left)}px`,
          transformOrigin: getTransformOriginValue(elemTransformOrigin)
        };
      }, [anchorEl, anchorReference, getAnchorOffset, getTransformOrigin, marginThreshold]);
      const setPositioningStyles = react.exports.useCallback(() => {
        const element = paperRef.current;

        if (!element) {
          return;
        }

        const positioning = getPositioningStyle(element);

        if (positioning.top !== null) {
          element.style.top = positioning.top;
        }

        if (positioning.left !== null) {
          element.style.left = positioning.left;
        }

        element.style.transformOrigin = positioning.transformOrigin;
      }, [getPositioningStyle]);

      const handleEntering = (element, isAppearing) => {
        if (onEntering) {
          onEntering(element, isAppearing);
        }

        setPositioningStyles();
      };

      react.exports.useEffect(() => {
        if (open) {
          setPositioningStyles();
        }
      });
      react.exports.useImperativeHandle(action, () => open ? {
        updatePosition: () => {
          setPositioningStyles();
        }
      } : null, [open, setPositioningStyles]);
      react.exports.useEffect(() => {
        if (!open) {
          return undefined;
        }

        const handleResize = debounce$1(() => {
          setPositioningStyles();
        });
        const containerWindow = ownerWindow(anchorEl);
        containerWindow.addEventListener('resize', handleResize);
        return () => {
          handleResize.clear();
          containerWindow.removeEventListener('resize', handleResize);
        };
      }, [anchorEl, open, setPositioningStyles]);
      let transitionDuration = transitionDurationProp;

      if (transitionDurationProp === 'auto' && !TransitionComponent.muiSupportAuto) {
        transitionDuration = undefined;
      } // If the container prop is provided, use that
      // If the anchorEl prop is provided, use its parent body element as the container
      // If neither are provided let the Modal take care of choosing the container


      const container = containerProp || (anchorEl ? ownerDocument(resolveAnchorEl(anchorEl)).body : undefined);
      return /*#__PURE__*/jsxRuntimeExports.jsx(PopoverRoot, _extends$1({
        BackdropProps: {
          invisible: true
        },
        className: clsx(classes.root, className),
        container: container,
        open: open,
        ref: ref,
        ownerState: ownerState
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
          appear: true,
          in: open,
          onEntering: handleEntering,
          timeout: transitionDuration
        }, TransitionProps, {
          children: /*#__PURE__*/jsxRuntimeExports.jsx(PopoverPaper, _extends$1({
            elevation: elevation
          }, PaperProps, {
            ref: handlePaperRef,
            className: clsx(classes.paper, PaperProps.className),
            children: children
          }))
        }))
      }));
    });
    process.env.NODE_ENV !== "production" ? Popover.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * A ref for imperative actions.
       * It currently only supports updatePosition() action.
       */
      action: refType,

      /**
       * An HTML element, or a function that returns one.
       * It's used to set the position of the popover.
       */
      anchorEl: chainPropTypes(propTypes.exports.oneOfType([HTMLElementType, propTypes.exports.func]), props => {
        if (props.open && (!props.anchorReference || props.anchorReference === 'anchorEl')) {
          const resolvedAnchorEl = resolveAnchorEl(props.anchorEl);

          if (resolvedAnchorEl && resolvedAnchorEl.nodeType === 1) {
            const box = resolvedAnchorEl.getBoundingClientRect();

            if (process.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
              return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
            }
          } else {
            return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', `It should be an Element instance but it's \`${resolvedAnchorEl}\` instead.`].join('\n'));
          }
        }

        return null;
      }),

      /**
       * This is the point on the anchor where the popover's
       * `anchorEl` will attach to. This is not used when the
       * anchorReference is 'anchorPosition'.
       *
       * Options:
       * vertical: [top, center, bottom];
       * horizontal: [left, center, right].
       * @default {
       *   vertical: 'top',
       *   horizontal: 'left',
       * }
       */
      anchorOrigin: propTypes.exports.shape({
        horizontal: propTypes.exports.oneOfType([propTypes.exports.oneOf(['center', 'left', 'right']), propTypes.exports.number]).isRequired,
        vertical: propTypes.exports.oneOfType([propTypes.exports.oneOf(['bottom', 'center', 'top']), propTypes.exports.number]).isRequired
      }),

      /**
       * This is the position that may be used to set the position of the popover.
       * The coordinates are relative to the application's client area.
       */
      anchorPosition: propTypes.exports.shape({
        left: propTypes.exports.number.isRequired,
        top: propTypes.exports.number.isRequired
      }),

      /**
       * This determines which anchor prop to refer to when setting
       * the position of the popover.
       * @default 'anchorEl'
       */
      anchorReference: propTypes.exports.oneOf(['anchorEl', 'anchorPosition', 'none']),

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * An HTML element, component instance, or function that returns either.
       * The `container` will passed to the Modal component.
       *
       * By default, it uses the body of the anchorEl's top-level document object,
       * so it's simply `document.body` most of the time.
       */
      container: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * The elevation of the popover.
       * @default 8
       */
      elevation: integerPropType,

      /**
       * Specifies how close to the edge of the window the popover can appear.
       * @default 16
       */
      marginThreshold: propTypes.exports.number,

      /**
       * Callback fired when the component requests to be closed.
       * The `reason` parameter can optionally be used to control the response to `onClose`.
       */
      onClose: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * Props applied to the [`Paper`](/api/paper/) element.
       * @default {}
       */
      PaperProps: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .shape({
        component: elementTypeAcceptingRef$1
      }),

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * This is the point on the popover which
       * will attach to the anchor's origin.
       *
       * Options:
       * vertical: [top, center, bottom, x(px)];
       * horizontal: [left, center, right, x(px)].
       * @default {
       *   vertical: 'top',
       *   horizontal: 'left',
       * }
       */
      transformOrigin: propTypes.exports.shape({
        horizontal: propTypes.exports.oneOfType([propTypes.exports.oneOf(['center', 'left', 'right']), propTypes.exports.number]).isRequired,
        vertical: propTypes.exports.oneOfType([propTypes.exports.oneOf(['bottom', 'center', 'top']), propTypes.exports.number]).isRequired
      }),

      /**
       * The component used for the transition.
       * [Follow this guide](/components/transitions/#transitioncomponent-prop) to learn more about the requirements for this component.
       * @default Grow
       */
      TransitionComponent: propTypes.exports.elementType,

      /**
       * Set to 'auto' to automatically calculate transition time based on height.
       * @default 'auto'
       */
      transitionDuration: propTypes.exports.oneOfType([propTypes.exports.oneOf(['auto']), propTypes.exports.number, propTypes.exports.shape({
        appear: propTypes.exports.number,
        enter: propTypes.exports.number,
        exit: propTypes.exports.number
      })]),

      /**
       * Props applied to the transition element.
       * By default, the element is based on this [`Transition`](http://reactcommunity.org/react-transition-group/transition/) component.
       * @default {}
       */
      TransitionProps: propTypes.exports.object
    } : void 0;
    var Popover$1 = Popover;

    function getMenuUtilityClass(slot) {
      return generateUtilityClass('MuiMenu', slot);
    }
    generateUtilityClasses('MuiMenu', ['root', 'paper', 'list']);

    const _excluded$9 = ["onEntering"],
          _excluded2 = ["autoFocus", "children", "disableAutoFocusItem", "MenuListProps", "onClose", "open", "PaperProps", "PopoverClasses", "transitionDuration", "TransitionProps", "variant"];
    const RTL_ORIGIN = {
      vertical: 'top',
      horizontal: 'right'
    };
    const LTR_ORIGIN = {
      vertical: 'top',
      horizontal: 'left'
    };

    const useUtilityClasses$7 = ownerState => {
      const {
        classes
      } = ownerState;
      const slots = {
        root: ['root'],
        paper: ['paper'],
        list: ['list']
      };
      return composeClasses(slots, getMenuUtilityClass, classes);
    };

    const MenuRoot = styled$1(Popover$1, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiMenu',
      slot: 'Root',
      overridesResolver: (props, styles) => styles.root
    })({});
    const MenuPaper = styled$1(Paper$1, {
      name: 'MuiMenu',
      slot: 'Paper',
      overridesResolver: (props, styles) => styles.paper
    })({
      // specZ: The maximum height of a simple menu should be one or more rows less than the view
      // height. This ensures a tapable area outside of the simple menu with which to dismiss
      // the menu.
      maxHeight: 'calc(100% - 96px)',
      // Add iOS momentum scrolling for iOS < 13.0
      WebkitOverflowScrolling: 'touch'
    });
    const MenuMenuList = styled$1(MenuList$1, {
      name: 'MuiMenu',
      slot: 'List',
      overridesResolver: (props, styles) => styles.list
    })({
      // We disable the focus ring for mouse, touch and keyboard users.
      outline: 0
    });
    const Menu = /*#__PURE__*/react.exports.forwardRef(function Menu(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiMenu'
      });

      const {
        autoFocus = true,
        children,
        disableAutoFocusItem = false,
        MenuListProps = {},
        onClose,
        open,
        PaperProps = {},
        PopoverClasses,
        transitionDuration = 'auto',
        TransitionProps: {
          onEntering
        } = {},
        variant = 'selectedMenu'
      } = props,
            TransitionProps = _objectWithoutPropertiesLoose(props.TransitionProps, _excluded$9),
            other = _objectWithoutPropertiesLoose(props, _excluded2);

      const theme = useTheme();
      const isRtl = theme.direction === 'rtl';

      const ownerState = _extends$1({}, props, {
        autoFocus,
        disableAutoFocusItem,
        MenuListProps,
        onEntering,
        PaperProps,
        transitionDuration,
        TransitionProps,
        variant
      });

      const classes = useUtilityClasses$7(ownerState);
      const autoFocusItem = autoFocus && !disableAutoFocusItem && open;
      const menuListActionsRef = react.exports.useRef(null);

      const handleEntering = (element, isAppearing) => {
        if (menuListActionsRef.current) {
          menuListActionsRef.current.adjustStyleForScrollbar(element, theme);
        }

        if (onEntering) {
          onEntering(element, isAppearing);
        }
      };

      const handleListKeyDown = event => {
        if (event.key === 'Tab') {
          event.preventDefault();

          if (onClose) {
            onClose(event, 'tabKeyDown');
          }
        }
      };
      /**
       * the index of the item should receive focus
       * in a `variant="selectedMenu"` it's the first `selected` item
       * otherwise it's the very first item.
       */


      let activeItemIndex = -1; // since we inject focus related props into children we have to do a lookahead
      // to check if there is a `selected` item. We're looking for the last `selected`
      // item and use the first valid item as a fallback

      react.exports.Children.map(children, (child, index) => {
        if (! /*#__PURE__*/react.exports.isValidElement(child)) {
          return;
        }

        if (process.env.NODE_ENV !== 'production') {
          if (reactIs.exports.isFragment(child)) {
            console.error(["MUI: The Menu component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
          }
        }

        if (!child.props.disabled) {
          if (variant === 'selectedMenu' && child.props.selected) {
            activeItemIndex = index;
          } else if (activeItemIndex === -1) {
            activeItemIndex = index;
          }
        }
      });
      return /*#__PURE__*/jsxRuntimeExports.jsx(MenuRoot, _extends$1({
        classes: PopoverClasses,
        onClose: onClose,
        anchorOrigin: {
          vertical: 'bottom',
          horizontal: isRtl ? 'right' : 'left'
        },
        transformOrigin: isRtl ? RTL_ORIGIN : LTR_ORIGIN,
        PaperProps: _extends$1({
          component: MenuPaper
        }, PaperProps, {
          classes: _extends$1({}, PaperProps.classes, {
            root: classes.paper
          })
        }),
        className: classes.root,
        open: open,
        ref: ref,
        transitionDuration: transitionDuration,
        TransitionProps: _extends$1({
          onEntering: handleEntering
        }, TransitionProps),
        ownerState: ownerState
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(MenuMenuList, _extends$1({
          onKeyDown: handleListKeyDown,
          actions: menuListActionsRef,
          autoFocus: autoFocus && (activeItemIndex === -1 || disableAutoFocusItem),
          autoFocusItem: autoFocusItem,
          variant: variant
        }, MenuListProps, {
          className: clsx(classes.list, MenuListProps.className),
          children: children
        }))
      }));
    });
    process.env.NODE_ENV !== "production" ? Menu.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * An HTML element, or a function that returns one.
       * It's used to set the position of the menu.
       */
      anchorEl: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([HTMLElementType, propTypes.exports.func]),

      /**
       * If `true` (Default) will focus the `[role="menu"]` if no focusable child is found. Disabled
       * children are not focusable. If you set this prop to `false` focus will be placed
       * on the parent modal container. This has severe accessibility implications
       * and should only be considered if you manage focus otherwise.
       * @default true
       */
      autoFocus: propTypes.exports.bool,

      /**
       * Menu contents, normally `MenuItem`s.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * When opening the menu will not focus the active item but the `[role="menu"]`
       * unless `autoFocus` is also set to `false`. Not using the default means not
       * following WAI-ARIA authoring practices. Please be considerate about possible
       * accessibility implications.
       * @default false
       */
      disableAutoFocusItem: propTypes.exports.bool,

      /**
       * Props applied to the [`MenuList`](/api/menu-list/) element.
       * @default {}
       */
      MenuListProps: propTypes.exports.object,

      /**
       * Callback fired when the component requests to be closed.
       *
       * @param {object} event The event source of the callback.
       * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`, `"tabKeyDown"`.
       */
      onClose: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool.isRequired,

      /**
       * @ignore
       */
      PaperProps: propTypes.exports.object,

      /**
       * `classes` prop applied to the [`Popover`](/api/popover/) element.
       */
      PopoverClasses: propTypes.exports.object,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The length of the transition in `ms`, or 'auto'
       * @default 'auto'
       */
      transitionDuration: propTypes.exports.oneOfType([propTypes.exports.oneOf(['auto']), propTypes.exports.number, propTypes.exports.shape({
        appear: propTypes.exports.number,
        enter: propTypes.exports.number,
        exit: propTypes.exports.number
      })]),

      /**
       * Props applied to the transition element.
       * By default, the element is based on this [`Transition`](http://reactcommunity.org/react-transition-group/transition/) component.
       * @default {}
       */
      TransitionProps: propTypes.exports.object,

      /**
       * The variant to use. Use `menu` to prevent selected items from impacting the initial focus.
       * @default 'selectedMenu'
       */
      variant: propTypes.exports.oneOf(['menu', 'selectedMenu'])
    } : void 0;
    var Menu$1 = Menu;

    function getMenuItemUtilityClass(slot) {
      return generateUtilityClass('MuiMenuItem', slot);
    }
    const menuItemClasses = generateUtilityClasses('MuiMenuItem', ['root', 'focusVisible', 'dense', 'disabled', 'divider', 'gutters', 'selected']);
    var menuItemClasses$1 = menuItemClasses;

    const _excluded$8 = ["autoFocus", "component", "dense", "divider", "disableGutters", "focusVisibleClassName", "role", "tabIndex"];
    const overridesResolver = (props, styles) => {
      const {
        ownerState
      } = props;
      return [styles.root, ownerState.dense && styles.dense, ownerState.divider && styles.divider, !ownerState.disableGutters && styles.gutters];
    };

    const useUtilityClasses$6 = ownerState => {
      const {
        disabled,
        dense,
        divider,
        disableGutters,
        selected,
        classes
      } = ownerState;
      const slots = {
        root: ['root', dense && 'dense', disabled && 'disabled', !disableGutters && 'gutters', divider && 'divider', selected && 'selected']
      };
      const composedClasses = composeClasses(slots, getMenuItemUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const MenuItemRoot = styled$1(ButtonBase$1, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiMenuItem',
      slot: 'Root',
      overridesResolver
    })(({
      theme,
      ownerState
    }) => _extends$1({}, theme.typography.body1, {
      display: 'flex',
      justifyContent: 'flex-start',
      alignItems: 'center',
      position: 'relative',
      textDecoration: 'none',
      minHeight: 48,
      paddingTop: 6,
      paddingBottom: 6,
      boxSizing: 'border-box',
      whiteSpace: 'nowrap'
    }, !ownerState.disableGutters && {
      paddingLeft: 16,
      paddingRight: 16
    }, ownerState.divider && {
      borderBottom: `1px solid ${theme.palette.divider}`,
      backgroundClip: 'padding-box'
    }, {
      '&:hover': {
        textDecoration: 'none',
        backgroundColor: theme.palette.action.hover,
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      },
      [`&.${menuItemClasses$1.selected}`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
        [`&.${menuItemClasses$1.focusVisible}`]: {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
        }
      },
      [`&.${menuItemClasses$1.selected}:hover`]: {
        backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity)
        }
      },
      [`&.${menuItemClasses$1.focusVisible}`]: {
        backgroundColor: theme.palette.action.focus
      },
      [`&.${menuItemClasses$1.disabled}`]: {
        opacity: theme.palette.action.disabledOpacity
      },
      [`& + .${dividerClasses$1.root}`]: {
        marginTop: theme.spacing(1),
        marginBottom: theme.spacing(1)
      },
      [`& + .${dividerClasses$1.inset}`]: {
        marginLeft: 52
      },
      [`& .${listItemTextClasses$1.root}`]: {
        marginTop: 0,
        marginBottom: 0
      },
      [`& .${listItemTextClasses$1.inset}`]: {
        paddingLeft: 36
      },
      [`& .${listItemIconClasses$1.root}`]: {
        minWidth: 36
      }
    }, !ownerState.dense && {
      [theme.breakpoints.up('sm')]: {
        minHeight: 'auto'
      }
    }, ownerState.dense && _extends$1({
      minHeight: 32,
      // https://material.io/components/menus#specs > Dense
      paddingTop: 4,
      paddingBottom: 4
    }, theme.typography.body2, {
      [`& .${listItemIconClasses$1.root} svg`]: {
        fontSize: '1.25rem'
      }
    })));
    const MenuItem = /*#__PURE__*/react.exports.forwardRef(function MenuItem(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiMenuItem'
      });

      const {
        autoFocus = false,
        component = 'li',
        dense = false,
        divider = false,
        disableGutters = false,
        focusVisibleClassName,
        role = 'menuitem',
        tabIndex: tabIndexProp
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$8);

      const context = react.exports.useContext(ListContext$1);
      const childContext = {
        dense: dense || context.dense || false,
        disableGutters
      };
      const menuItemRef = react.exports.useRef(null);
      useEnhancedEffect(() => {
        if (autoFocus) {
          if (menuItemRef.current) {
            menuItemRef.current.focus();
          } else if (process.env.NODE_ENV !== 'production') {
            console.error('MUI: Unable to set focus to a MenuItem whose component has not been rendered.');
          }
        }
      }, [autoFocus]);

      const ownerState = _extends$1({}, props, {
        dense: childContext.dense,
        divider,
        disableGutters
      });

      const classes = useUtilityClasses$6(props);
      const handleRef = useForkRef(menuItemRef, ref);
      let tabIndex;

      if (!props.disabled) {
        tabIndex = tabIndexProp !== undefined ? tabIndexProp : -1;
      }

      return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
        value: childContext,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(MenuItemRoot, _extends$1({
          ref: handleRef,
          role: role,
          tabIndex: tabIndex,
          component: component,
          focusVisibleClassName: clsx(classes.focusVisible, focusVisibleClassName)
        }, other, {
          ownerState: ownerState,
          classes: classes
        }))
      });
    });
    process.env.NODE_ENV !== "production" ? MenuItem.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * If `true`, the list item is focused during the first mount.
       * Focus will also be triggered if the value changes from false to true.
       * @default false
       */
      autoFocus: propTypes.exports.bool,

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * If `true`, compact vertical padding designed for keyboard and mouse input is used.
       * The prop defaults to the value inherited from the parent Menu component.
       * @default false
       */
      dense: propTypes.exports.bool,

      /**
       * @ignore
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the left and right padding is removed.
       * @default false
       */
      disableGutters: propTypes.exports.bool,

      /**
       * If `true`, a 1px light border is added to the bottom of the menu item.
       * @default false
       */
      divider: propTypes.exports.bool,

      /**
       * This prop can help identify which element has keyboard focus.
       * The class name will be applied when the element gains the focus through keyboard interaction.
       * It's a polyfill for the [CSS :focus-visible selector](https://drafts.csswg.org/selectors-4/#the-focus-visible-pseudo).
       * The rationale for using this feature [is explained here](https://github.com/WICG/focus-visible/blob/HEAD/explainer.md).
       * A [polyfill can be used](https://github.com/WICG/focus-visible) to apply a `focus-visible` class to other components
       * if needed.
       */
      focusVisibleClassName: propTypes.exports.string,

      /**
       * @ignore
       */
      role: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .string,

      /**
       * @ignore
       */
      selected: propTypes.exports.bool,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * @default 0
       */
      tabIndex: propTypes.exports.number
    } : void 0;
    var MenuItem$1 = MenuItem;

    function getNativeSelectUtilityClasses(slot) {
      return generateUtilityClass('MuiNativeSelect', slot);
    }
    const nativeSelectClasses = generateUtilityClasses('MuiNativeSelect', ['root', 'select', 'multiple', 'filled', 'outlined', 'standard', 'disabled', 'icon', 'iconOpen', 'iconFilled', 'iconOutlined', 'iconStandard', 'nativeInput']);
    var nativeSelectClasses$1 = nativeSelectClasses;

    const _excluded$7 = ["className", "disabled", "IconComponent", "inputRef", "variant"];

    const useUtilityClasses$5 = ownerState => {
      const {
        classes,
        variant,
        disabled,
        multiple,
        open
      } = ownerState;
      const slots = {
        select: ['select', variant, disabled && 'disabled', multiple && 'multiple'],
        icon: ['icon', `icon${capitalize(variant)}`, open && 'iconOpen', disabled && 'disabled']
      };
      return composeClasses(slots, getNativeSelectUtilityClasses, classes);
    };

    const nativeSelectSelectStyles = ({
      ownerState,
      theme
    }) => _extends$1({
      MozAppearance: 'none',
      // Reset
      WebkitAppearance: 'none',
      // Reset
      // When interacting quickly, the text can end up selected.
      // Native select can't be selected either.
      userSelect: 'none',
      borderRadius: 0,
      // Reset
      cursor: 'pointer',
      '&:focus': {
        // Show that it's not an text input
        backgroundColor: theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.05)' : 'rgba(255, 255, 255, 0.05)',
        borderRadius: 0 // Reset Chrome style

      },
      // Remove IE11 arrow
      '&::-ms-expand': {
        display: 'none'
      },
      [`&.${nativeSelectClasses$1.disabled}`]: {
        cursor: 'default'
      },
      '&[multiple]': {
        height: 'auto'
      },
      '&:not([multiple]) option, &:not([multiple]) optgroup': {
        backgroundColor: theme.palette.background.paper
      },
      // Bump specificity to allow extending custom inputs
      '&&&': {
        paddingRight: 24,
        minWidth: 16 // So it doesn't collapse.

      }
    }, ownerState.variant === 'filled' && {
      '&&&': {
        paddingRight: 32
      }
    }, ownerState.variant === 'outlined' && {
      borderRadius: theme.shape.borderRadius,
      '&:focus': {
        borderRadius: theme.shape.borderRadius // Reset the reset for Chrome style

      },
      '&&&': {
        paddingRight: 32
      }
    });
    const NativeSelectSelect = styled$1('select', {
      name: 'MuiNativeSelect',
      slot: 'Select',
      shouldForwardProp: rootShouldForwardProp,
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.select, styles[ownerState.variant], {
          [`&.${nativeSelectClasses$1.multiple}`]: styles.multiple
        }];
      }
    })(nativeSelectSelectStyles);
    const nativeSelectIconStyles = ({
      ownerState,
      theme
    }) => _extends$1({
      // We use a position absolute over a flexbox in order to forward the pointer events
      // to the input and to support wrapping tags..
      position: 'absolute',
      right: 0,
      top: 'calc(50% - .5em)',
      // Center vertically, height is 1em
      pointerEvents: 'none',
      // Don't block pointer events on the select under the icon.
      color: theme.palette.action.active,
      [`&.${nativeSelectClasses$1.disabled}`]: {
        color: theme.palette.action.disabled
      }
    }, ownerState.open && {
      transform: 'rotate(180deg)'
    }, ownerState.variant === 'filled' && {
      right: 7
    }, ownerState.variant === 'outlined' && {
      right: 7
    });
    const NativeSelectIcon = styled$1('svg', {
      name: 'MuiNativeSelect',
      slot: 'Icon',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.icon, ownerState.variant && styles[`icon${capitalize(ownerState.variant)}`], ownerState.open && styles.iconOpen];
      }
    })(nativeSelectIconStyles);
    /**
     * @ignore - internal component.
     */

    const NativeSelectInput = /*#__PURE__*/react.exports.forwardRef(function NativeSelectInput(props, ref) {
      const {
        className,
        disabled,
        IconComponent,
        inputRef,
        variant = 'standard'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$7);

      const ownerState = _extends$1({}, props, {
        disabled,
        variant
      });

      const classes = useUtilityClasses$5(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
        children: [/*#__PURE__*/jsxRuntimeExports.jsx(NativeSelectSelect, _extends$1({
          ownerState: ownerState,
          className: clsx(classes.select, className),
          disabled: disabled,
          ref: inputRef || ref
        }, other)), props.multiple ? null : /*#__PURE__*/jsxRuntimeExports.jsx(NativeSelectIcon, {
          as: IconComponent,
          ownerState: ownerState,
          className: classes.icon
        })]
      });
    });
    process.env.NODE_ENV !== "production" ? NativeSelectInput.propTypes = {
      /**
       * The option elements to populate the select with.
       * Can be some `<option>` elements.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object,

      /**
       * The CSS class name of the select element.
       */
      className: propTypes.exports.string,

      /**
       * If `true`, the select is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * The icon that displays the arrow.
       */
      IconComponent: propTypes.exports.elementType.isRequired,

      /**
       * Use that prop to pass a ref to the native select element.
       * @deprecated
       */
      inputRef: refType,

      /**
       * @ignore
       */
      multiple: propTypes.exports.bool,

      /**
       * Name attribute of the `select` or hidden `input` element.
       */
      name: propTypes.exports.string,

      /**
       * Callback fired when a menu item is selected.
       *
       * @param {object} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * The input value.
       */
      value: propTypes.exports.any,

      /**
       * The variant to use.
       */
      variant: propTypes.exports.oneOf(['standard', 'outlined', 'filled'])
    } : void 0;
    var NativeSelectInput$1 = NativeSelectInput;

    var _span$1;

    const _excluded$6 = ["children", "classes", "className", "label", "notched"];
    const NotchedOutlineRoot$1 = styled$1('fieldset')({
      textAlign: 'left',
      position: 'absolute',
      bottom: 0,
      right: 0,
      top: -5,
      left: 0,
      margin: 0,
      padding: '0 8px',
      pointerEvents: 'none',
      borderRadius: 'inherit',
      borderStyle: 'solid',
      borderWidth: 1,
      overflow: 'hidden',
      minWidth: '0%'
    });
    const NotchedOutlineLegend = styled$1('legend')(({
      ownerState,
      theme
    }) => _extends$1({
      float: 'unset',
      // Fix conflict with bootstrap
      overflow: 'hidden'
    }, !ownerState.withLabel && {
      padding: 0,
      lineHeight: '11px',
      // sync with `height` in `legend` styles
      transition: theme.transitions.create('width', {
        duration: 150,
        easing: theme.transitions.easing.easeOut
      })
    }, ownerState.withLabel && _extends$1({
      display: 'block',
      // Fix conflict with normalize.css and sanitize.css
      width: 'auto',
      // Fix conflict with bootstrap
      padding: 0,
      height: 11,
      // sync with `lineHeight` in `legend` styles
      fontSize: '0.75em',
      visibility: 'hidden',
      maxWidth: 0.01,
      transition: theme.transitions.create('max-width', {
        duration: 50,
        easing: theme.transitions.easing.easeOut
      }),
      whiteSpace: 'nowrap',
      '& > span': {
        paddingLeft: 5,
        paddingRight: 5,
        display: 'inline-block'
      }
    }, ownerState.notched && {
      maxWidth: '100%',
      transition: theme.transitions.create('max-width', {
        duration: 100,
        easing: theme.transitions.easing.easeOut,
        delay: 50
      })
    })));
    /**
     * @ignore - internal component.
     */

    function NotchedOutline(props) {
      const {
        className,
        label,
        notched
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$6);

      const withLabel = label != null && label !== '';

      const ownerState = _extends$1({}, props, {
        notched,
        withLabel
      });

      return /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineRoot$1, _extends$1({
        "aria-hidden": true,
        className: className,
        ownerState: ownerState
      }, other, {
        children: /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineLegend, {
          ownerState: ownerState,
          children: withLabel ? /*#__PURE__*/jsxRuntimeExports.jsx("span", {
            children: label
          }) : // notranslate needed while Google Translate will not fix zero-width space issue
          _span$1 || (_span$1 = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
            className: "notranslate",
            children: "\u200B"
          }))
        })
      }));
    }
    process.env.NODE_ENV !== "production" ? NotchedOutline.propTypes = {
      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The label.
       */
      label: propTypes.exports.node,

      /**
       * If `true`, the outline is notched to accommodate the label.
       */
      notched: propTypes.exports.bool.isRequired,

      /**
       * @ignore
       */
      style: propTypes.exports.object
    } : void 0;

    const _excluded$5 = ["components", "fullWidth", "inputComponent", "label", "multiline", "notched", "type"];

    const useUtilityClasses$4 = ownerState => {
      const {
        classes
      } = ownerState;
      const slots = {
        root: ['root'],
        notchedOutline: ['notchedOutline'],
        input: ['input']
      };
      const composedClasses = composeClasses(slots, getOutlinedInputUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const OutlinedInputRoot = styled$1(InputBaseRoot, {
      shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
      name: 'MuiOutlinedInput',
      slot: 'Root',
      overridesResolver: rootOverridesResolver
    })(({
      theme,
      ownerState
    }) => {
      const borderColor = theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)';
      return _extends$1({
        position: 'relative',
        borderRadius: theme.shape.borderRadius,
        [`&:hover .${outlinedInputClasses$1.notchedOutline}`]: {
          borderColor: theme.palette.text.primary
        },
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          [`&:hover .${outlinedInputClasses$1.notchedOutline}`]: {
            borderColor
          }
        },
        [`&.${outlinedInputClasses$1.focused} .${outlinedInputClasses$1.notchedOutline}`]: {
          borderColor: theme.palette[ownerState.color].main,
          borderWidth: 2
        },
        [`&.${outlinedInputClasses$1.error} .${outlinedInputClasses$1.notchedOutline}`]: {
          borderColor: theme.palette.error.main
        },
        [`&.${outlinedInputClasses$1.disabled} .${outlinedInputClasses$1.notchedOutline}`]: {
          borderColor: theme.palette.action.disabled
        }
      }, ownerState.startAdornment && {
        paddingLeft: 14
      }, ownerState.endAdornment && {
        paddingRight: 14
      }, ownerState.multiline && _extends$1({
        padding: '16.5px 14px'
      }, ownerState.size === 'small' && {
        padding: '8.5px 14px'
      }));
    });
    const NotchedOutlineRoot = styled$1(NotchedOutline, {
      name: 'MuiOutlinedInput',
      slot: 'NotchedOutline',
      overridesResolver: (props, styles) => styles.notchedOutline
    })(({
      theme
    }) => ({
      borderColor: theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)'
    }));
    const OutlinedInputInput = styled$1(InputBaseComponent, {
      name: 'MuiOutlinedInput',
      slot: 'Input',
      overridesResolver: inputOverridesResolver
    })(({
      theme,
      ownerState
    }) => _extends$1({
      padding: '16.5px 14px',
      '&:-webkit-autofill': {
        WebkitBoxShadow: theme.palette.mode === 'light' ? null : '0 0 0 100px #266798 inset',
        WebkitTextFillColor: theme.palette.mode === 'light' ? null : '#fff',
        caretColor: theme.palette.mode === 'light' ? null : '#fff',
        borderRadius: 'inherit'
      }
    }, ownerState.size === 'small' && {
      padding: '8.5px 14px'
    }, ownerState.multiline && {
      padding: 0
    }, ownerState.startAdornment && {
      paddingLeft: 0
    }, ownerState.endAdornment && {
      paddingRight: 0
    }));
    const OutlinedInput = /*#__PURE__*/react.exports.forwardRef(function OutlinedInput(inProps, ref) {
      var _React$Fragment;

      const props = useThemeProps({
        props: inProps,
        name: 'MuiOutlinedInput'
      });

      const {
        components = {},
        fullWidth = false,
        inputComponent = 'input',
        label,
        multiline = false,
        notched,
        type = 'text'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$5);

      const classes = useUtilityClasses$4(props);
      const muiFormControl = useFormControl();
      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['required']
      });
      return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
        components: _extends$1({
          Root: OutlinedInputRoot,
          Input: OutlinedInputInput
        }, components),
        renderSuffix: state => /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineRoot, {
          className: classes.notchedOutline,
          label: label != null && label !== '' && fcs.required ? _React$Fragment || (_React$Fragment = /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
            children: [label, "\xA0", '*']
          })) : label,
          notched: typeof notched !== 'undefined' ? notched : Boolean(state.startAdornment || state.filled || state.focused)
        }),
        fullWidth: fullWidth,
        inputComponent: inputComponent,
        multiline: multiline,
        ref: ref,
        type: type
      }, other, {
        classes: _extends$1({}, classes, {
          notchedOutline: null
        })
      }));
    });
    process.env.NODE_ENV !== "production" ? OutlinedInput.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * This prop helps users to fill forms faster, especially on mobile devices.
       * The name can be confusing, as it's more like an autofill.
       * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
       */
      autoComplete: propTypes.exports.string,

      /**
       * If `true`, the `input` element is focused during the first mount.
       */
      autoFocus: propTypes.exports.bool,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary']), propTypes.exports.string]),

      /**
       * The components used for each slot inside the InputBase.
       * Either a string to use a HTML element or a component.
       * @default {}
       */
      components: propTypes.exports.shape({
        Input: propTypes.exports.elementType,
        Root: propTypes.exports.elementType
      }),

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the component is disabled.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      disabled: propTypes.exports.bool,

      /**
       * End `InputAdornment` for this component.
       */
      endAdornment: propTypes.exports.node,

      /**
       * If `true`, the `input` will indicate an error.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      error: propTypes.exports.bool,

      /**
       * If `true`, the `input` will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * The component used for the `input` element.
       * Either a string to use a HTML element or a component.
       * @default 'input'
       */
      inputComponent: propTypes.exports.elementType,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       * @default {}
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * The label of the `input`. It is only used for layout. The actual labelling
       * is handled by `InputLabel`.
       */
      label: propTypes.exports.node,

      /**
       * If `dense`, will adjust vertical spacing. This is normally obtained via context from
       * FormControl.
       * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
       */
      margin: propTypes.exports.oneOf(['dense', 'none']),

      /**
       * Maximum number of rows to display when multiline option is set to true.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display when multiline option is set to true.
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * If `true`, a `textarea` element is rendered.
       * @default false
       */
      multiline: propTypes.exports.bool,

      /**
       * Name attribute of the `input` element.
       */
      name: propTypes.exports.string,

      /**
       * If `true`, the outline is notched to accommodate the label.
       */
      notched: propTypes.exports.bool,

      /**
       * Callback fired when the value is changed.
       *
       * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * The short hint displayed in the `input` before the user enters a value.
       */
      placeholder: propTypes.exports.string,

      /**
       * It prevents the user from changing the value of the field
       * (not from interacting with the field).
       */
      readOnly: propTypes.exports.bool,

      /**
       * If `true`, the `input` element is required.
       * The prop defaults to the value (`false`) inherited from the parent FormControl component.
       */
      required: propTypes.exports.bool,

      /**
       * Number of rows to display when multiline option is set to true.
       */
      rows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Start `InputAdornment` for this component.
       */
      startAdornment: propTypes.exports.node,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
       * @default 'text'
       */
      type: propTypes.exports.string,

      /**
       * The value of the `input` element, required for a controlled component.
       */
      value: propTypes.exports.any
    } : void 0;
    OutlinedInput.muiName = 'Input';
    var OutlinedInput$1 = OutlinedInput;

    function getSelectUtilityClasses(slot) {
      return generateUtilityClass('MuiSelect', slot);
    }
    const selectClasses = generateUtilityClasses('MuiSelect', ['select', 'multiple', 'filled', 'outlined', 'standard', 'disabled', 'focused', 'icon', 'iconOpen', 'iconFilled', 'iconOutlined', 'iconStandard', 'nativeInput']);
    var selectClasses$1 = selectClasses;

    var _span;

    const _excluded$4 = ["aria-describedby", "aria-label", "autoFocus", "autoWidth", "children", "className", "defaultOpen", "defaultValue", "disabled", "displayEmpty", "IconComponent", "inputRef", "labelId", "MenuProps", "multiple", "name", "onBlur", "onChange", "onClose", "onFocus", "onOpen", "open", "readOnly", "renderValue", "SelectDisplayProps", "tabIndex", "type", "value", "variant"];
    const SelectSelect = styled$1('div', {
      name: 'MuiSelect',
      slot: 'Select',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [// Win specificity over the input base
        {
          [`&.${selectClasses$1.select}`]: styles.select
        }, {
          [`&.${selectClasses$1.select}`]: styles[ownerState.variant]
        }, {
          [`&.${selectClasses$1.multiple}`]: styles.multiple
        }];
      }
    })(nativeSelectSelectStyles, {
      // Win specificity over the input base
      [`&.${selectClasses$1.select}`]: {
        height: 'auto',
        // Resets for multiple select with chips
        minHeight: '1.4375em',
        // Required for select\text-field height consistency
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden'
      }
    });
    const SelectIcon = styled$1('svg', {
      name: 'MuiSelect',
      slot: 'Icon',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.icon, ownerState.variant && styles[`icon${capitalize(ownerState.variant)}`], ownerState.open && styles.iconOpen];
      }
    })(nativeSelectIconStyles);
    const SelectNativeInput = styled$1('input', {
      shouldForwardProp: prop => slotShouldForwardProp(prop) && prop !== 'classes',
      name: 'MuiSelect',
      slot: 'NativeInput',
      overridesResolver: (props, styles) => styles.nativeInput
    })({
      bottom: 0,
      left: 0,
      position: 'absolute',
      opacity: 0,
      pointerEvents: 'none',
      width: '100%',
      boxSizing: 'border-box'
    });

    function areEqualValues(a, b) {
      if (typeof b === 'object' && b !== null) {
        return a === b;
      } // The value could be a number, the DOM will stringify it anyway.


      return String(a) === String(b);
    }

    function isEmpty(display) {
      return display == null || typeof display === 'string' && !display.trim();
    }

    const useUtilityClasses$3 = ownerState => {
      const {
        classes,
        variant,
        disabled,
        multiple,
        open
      } = ownerState;
      const slots = {
        select: ['select', variant, disabled && 'disabled', multiple && 'multiple'],
        icon: ['icon', `icon${capitalize(variant)}`, open && 'iconOpen', disabled && 'disabled'],
        nativeInput: ['nativeInput']
      };
      return composeClasses(slots, getSelectUtilityClasses, classes);
    };
    /**
     * @ignore - internal component.
     */


    const SelectInput = /*#__PURE__*/react.exports.forwardRef(function SelectInput(props, ref) {
      const {
        'aria-describedby': ariaDescribedby,
        'aria-label': ariaLabel,
        autoFocus,
        autoWidth,
        children,
        className,
        defaultOpen,
        defaultValue,
        disabled,
        displayEmpty,
        IconComponent,
        inputRef: inputRefProp,
        labelId,
        MenuProps = {},
        multiple,
        name,
        onBlur,
        onChange,
        onClose,
        onFocus,
        onOpen,
        open: openProp,
        readOnly,
        renderValue,
        SelectDisplayProps = {},
        tabIndex: tabIndexProp,
        value: valueProp,
        variant = 'standard'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$4);

      const [value, setValueState] = useControlled({
        controlled: valueProp,
        default: defaultValue,
        name: 'Select'
      });
      const [openState, setOpenState] = useControlled({
        controlled: openProp,
        default: defaultOpen,
        name: 'Select'
      });
      const inputRef = react.exports.useRef(null);
      const displayRef = react.exports.useRef(null);
      const [displayNode, setDisplayNode] = react.exports.useState(null);
      const {
        current: isOpenControlled
      } = react.exports.useRef(openProp != null);
      const [menuMinWidthState, setMenuMinWidthState] = react.exports.useState();
      const handleRef = useForkRef(ref, inputRefProp);
      const handleDisplayRef = react.exports.useCallback(node => {
        displayRef.current = node;

        if (node) {
          setDisplayNode(node);
        }
      }, []);
      react.exports.useImperativeHandle(handleRef, () => ({
        focus: () => {
          displayRef.current.focus();
        },
        node: inputRef.current,
        value
      }), [value]); // Resize menu on `defaultOpen` automatic toggle.

      react.exports.useEffect(() => {
        if (defaultOpen && openState && displayNode && !isOpenControlled) {
          setMenuMinWidthState(autoWidth ? null : displayNode.clientWidth);
          displayRef.current.focus();
        } // eslint-disable-next-line react-hooks/exhaustive-deps

      }, [displayNode, autoWidth]); // `isOpenControlled` is ignored because the component should never switch between controlled and uncontrolled modes.
      // `defaultOpen` and `openState` are ignored to avoid unnecessary callbacks.

      react.exports.useEffect(() => {
        if (autoFocus) {
          displayRef.current.focus();
        }
      }, [autoFocus]);
      react.exports.useEffect(() => {
        if (!labelId) {
          return undefined;
        }

        const label = ownerDocument(displayRef.current).getElementById(labelId);

        if (label) {
          const handler = () => {
            if (getSelection().isCollapsed) {
              displayRef.current.focus();
            }
          };

          label.addEventListener('click', handler);
          return () => {
            label.removeEventListener('click', handler);
          };
        }

        return undefined;
      }, [labelId]);

      const update = (open, event) => {
        if (open) {
          if (onOpen) {
            onOpen(event);
          }
        } else if (onClose) {
          onClose(event);
        }

        if (!isOpenControlled) {
          setMenuMinWidthState(autoWidth ? null : displayNode.clientWidth);
          setOpenState(open);
        }
      };

      const handleMouseDown = event => {
        // Ignore everything but left-click
        if (event.button !== 0) {
          return;
        } // Hijack the default focus behavior.


        event.preventDefault();
        displayRef.current.focus();
        update(true, event);
      };

      const handleClose = event => {
        update(false, event);
      };

      const childrenArray = react.exports.Children.toArray(children); // Support autofill.

      const handleChange = event => {
        const index = childrenArray.map(child => child.props.value).indexOf(event.target.value);

        if (index === -1) {
          return;
        }

        const child = childrenArray[index];
        setValueState(child.props.value);

        if (onChange) {
          onChange(event, child);
        }
      };

      const handleItemClick = child => event => {
        let newValue; // We use the tabindex attribute to signal the available options.

        if (!event.currentTarget.hasAttribute('tabindex')) {
          return;
        }

        if (multiple) {
          newValue = Array.isArray(value) ? value.slice() : [];
          const itemIndex = value.indexOf(child.props.value);

          if (itemIndex === -1) {
            newValue.push(child.props.value);
          } else {
            newValue.splice(itemIndex, 1);
          }
        } else {
          newValue = child.props.value;
        }

        if (child.props.onClick) {
          child.props.onClick(event);
        }

        if (value !== newValue) {
          setValueState(newValue);

          if (onChange) {
            // Redefine target to allow name and value to be read.
            // This allows seamless integration with the most popular form libraries.
            // https://github.com/mui/material-ui/issues/13485#issuecomment-676048492
            // Clone the event to not override `target` of the original event.
            const nativeEvent = event.nativeEvent || event;
            const clonedEvent = new nativeEvent.constructor(nativeEvent.type, nativeEvent);
            Object.defineProperty(clonedEvent, 'target', {
              writable: true,
              value: {
                value: newValue,
                name
              }
            });
            onChange(clonedEvent, child);
          }
        }

        if (!multiple) {
          update(false, event);
        }
      };

      const handleKeyDown = event => {
        if (!readOnly) {
          const validKeys = [' ', 'ArrowUp', 'ArrowDown', // The native select doesn't respond to enter on MacOS, but it's recommended by
          // https://www.w3.org/TR/wai-aria-practices/examples/listbox/listbox-collapsible.html
          'Enter'];

          if (validKeys.indexOf(event.key) !== -1) {
            event.preventDefault();
            update(true, event);
          }
        }
      };

      const open = displayNode !== null && openState;

      const handleBlur = event => {
        // if open event.stopImmediatePropagation
        if (!open && onBlur) {
          // Preact support, target is read only property on a native event.
          Object.defineProperty(event, 'target', {
            writable: true,
            value: {
              value,
              name
            }
          });
          onBlur(event);
        }
      };

      delete other['aria-invalid'];
      let display;
      let displaySingle;
      const displayMultiple = [];
      let computeDisplay = false;
      let foundMatch = false; // No need to display any value if the field is empty.

      if (isFilled({
        value
      }) || displayEmpty) {
        if (renderValue) {
          display = renderValue(value);
        } else {
          computeDisplay = true;
        }
      }

      const items = childrenArray.map(child => {
        if (! /*#__PURE__*/react.exports.isValidElement(child)) {
          return null;
        }

        if (process.env.NODE_ENV !== 'production') {
          if (reactIs.exports.isFragment(child)) {
            console.error(["MUI: The Select component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
          }
        }

        let selected;

        if (multiple) {
          if (!Array.isArray(value)) {
            throw new Error(process.env.NODE_ENV !== "production" ? `MUI: The \`value\` prop must be an array when using the \`Select\` component with \`multiple\`.` : formatMuiErrorMessage(2));
          }

          selected = value.some(v => areEqualValues(v, child.props.value));

          if (selected && computeDisplay) {
            displayMultiple.push(child.props.children);
          }
        } else {
          selected = areEqualValues(value, child.props.value);

          if (selected && computeDisplay) {
            displaySingle = child.props.children;
          }
        }

        if (selected) {
          foundMatch = true;
        }

        return /*#__PURE__*/react.exports.cloneElement(child, {
          'aria-selected': selected ? 'true' : 'false',
          onClick: handleItemClick(child),
          onKeyUp: event => {
            if (event.key === ' ') {
              // otherwise our MenuItems dispatches a click event
              // it's not behavior of the native <option> and causes
              // the select to close immediately since we open on space keydown
              event.preventDefault();
            }

            if (child.props.onKeyUp) {
              child.props.onKeyUp(event);
            }
          },
          role: 'option',
          selected,
          value: undefined,
          // The value is most likely not a valid HTML attribute.
          'data-value': child.props.value // Instead, we provide it as a data attribute.

        });
      });

      if (process.env.NODE_ENV !== 'production') {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        react.exports.useEffect(() => {
          if (!foundMatch && !multiple && value !== '') {
            const values = childrenArray.map(child => child.props.value);
            console.warn([`MUI: You have provided an out-of-range value \`${value}\` for the select ${name ? `(name="${name}") ` : ''}component.`, "Consider providing a value that matches one of the available options or ''.", `The available values are ${values.filter(x => x != null).map(x => `\`${x}\``).join(', ') || '""'}.`].join('\n'));
          }
        }, [foundMatch, childrenArray, multiple, name, value]);
      }

      if (computeDisplay) {
        if (multiple) {
          if (displayMultiple.length === 0) {
            display = null;
          } else {
            display = displayMultiple.reduce((output, child, index) => {
              output.push(child);

              if (index < displayMultiple.length - 1) {
                output.push(', ');
              }

              return output;
            }, []);
          }
        } else {
          display = displaySingle;
        }
      } // Avoid performing a layout computation in the render method.


      let menuMinWidth = menuMinWidthState;

      if (!autoWidth && isOpenControlled && displayNode) {
        menuMinWidth = displayNode.clientWidth;
      }

      let tabIndex;

      if (typeof tabIndexProp !== 'undefined') {
        tabIndex = tabIndexProp;
      } else {
        tabIndex = disabled ? null : 0;
      }

      const buttonId = SelectDisplayProps.id || (name ? `mui-component-select-${name}` : undefined);

      const ownerState = _extends$1({}, props, {
        variant,
        value,
        open
      });

      const classes = useUtilityClasses$3(ownerState);
      return /*#__PURE__*/jsxRuntimeExports.jsxs(react.exports.Fragment, {
        children: [/*#__PURE__*/jsxRuntimeExports.jsx(SelectSelect, _extends$1({
          ref: handleDisplayRef,
          tabIndex: tabIndex,
          role: "button",
          "aria-disabled": disabled ? 'true' : undefined,
          "aria-expanded": open ? 'true' : 'false',
          "aria-haspopup": "listbox",
          "aria-label": ariaLabel,
          "aria-labelledby": [labelId, buttonId].filter(Boolean).join(' ') || undefined,
          "aria-describedby": ariaDescribedby,
          onKeyDown: handleKeyDown,
          onMouseDown: disabled || readOnly ? null : handleMouseDown,
          onBlur: handleBlur,
          onFocus: onFocus
        }, SelectDisplayProps, {
          ownerState: ownerState,
          className: clsx(classes.select, className, SelectDisplayProps.className) // The id is required for proper a11y
          ,
          id: buttonId,
          children: isEmpty(display) ? // notranslate needed while Google Translate will not fix zero-width space issue
          _span || (_span = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
            className: "notranslate",
            children: "\u200B"
          })) : display
        })), /*#__PURE__*/jsxRuntimeExports.jsx(SelectNativeInput, _extends$1({
          value: Array.isArray(value) ? value.join(',') : value,
          name: name,
          ref: inputRef,
          "aria-hidden": true,
          onChange: handleChange,
          tabIndex: -1,
          disabled: disabled,
          className: classes.nativeInput,
          autoFocus: autoFocus,
          ownerState: ownerState
        }, other)), /*#__PURE__*/jsxRuntimeExports.jsx(SelectIcon, {
          as: IconComponent,
          className: classes.icon,
          ownerState: ownerState
        }), /*#__PURE__*/jsxRuntimeExports.jsx(Menu$1, _extends$1({
          id: `menu-${name || ''}`,
          anchorEl: displayNode,
          open: open,
          onClose: handleClose,
          anchorOrigin: {
            vertical: 'bottom',
            horizontal: 'center'
          },
          transformOrigin: {
            vertical: 'top',
            horizontal: 'center'
          }
        }, MenuProps, {
          MenuListProps: _extends$1({
            'aria-labelledby': labelId,
            role: 'listbox',
            disableListWrap: true
          }, MenuProps.MenuListProps),
          PaperProps: _extends$1({}, MenuProps.PaperProps, {
            style: _extends$1({
              minWidth: menuMinWidth
            }, MenuProps.PaperProps != null ? MenuProps.PaperProps.style : null)
          }),
          children: items
        }))]
      });
    });
    process.env.NODE_ENV !== "production" ? SelectInput.propTypes = {
      /**
       * @ignore
       */
      'aria-describedby': propTypes.exports.string,

      /**
       * @ignore
       */
      'aria-label': propTypes.exports.string,

      /**
       * @ignore
       */
      autoFocus: propTypes.exports.bool,

      /**
       * If `true`, the width of the popover will automatically be set according to the items inside the
       * menu, otherwise it will be at least the width of the select input.
       */
      autoWidth: propTypes.exports.bool,

      /**
       * The option elements to populate the select with.
       * Can be some `<MenuItem>` elements.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       * See [CSS API](#css) below for more details.
       */
      classes: propTypes.exports.object,

      /**
       * The CSS class name of the select element.
       */
      className: propTypes.exports.string,

      /**
       * If `true`, the component is toggled on mount. Use when the component open state is not controlled.
       * You can only use it when the `native` prop is `false` (default).
       */
      defaultOpen: propTypes.exports.bool,

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the select is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the selected item is displayed even if its value is empty.
       */
      displayEmpty: propTypes.exports.bool,

      /**
       * The icon that displays the arrow.
       */
      IconComponent: propTypes.exports.elementType.isRequired,

      /**
       * Imperative handle implementing `{ value: T, node: HTMLElement, focus(): void }`
       * Equivalent to `ref`
       */
      inputRef: refType,

      /**
       * The ID of an element that acts as an additional label. The Select will
       * be labelled by the additional label and the selected value.
       */
      labelId: propTypes.exports.string,

      /**
       * Props applied to the [`Menu`](/api/menu/) element.
       */
      MenuProps: propTypes.exports.object,

      /**
       * If `true`, `value` must be an array and the menu will support multiple selections.
       */
      multiple: propTypes.exports.bool,

      /**
       * Name attribute of the `select` or hidden `input` element.
       */
      name: propTypes.exports.string,

      /**
       * @ignore
       */
      onBlur: propTypes.exports.func,

      /**
       * Callback fired when a menu item is selected.
       *
       * @param {object} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (any).
       * @param {object} [child] The react element that was selected.
       */
      onChange: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be closed.
       * Use in controlled mode (see open).
       *
       * @param {object} event The event source of the callback.
       */
      onClose: propTypes.exports.func,

      /**
       * @ignore
       */
      onFocus: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be opened.
       * Use in controlled mode (see open).
       *
       * @param {object} event The event source of the callback.
       */
      onOpen: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       */
      open: propTypes.exports.bool,

      /**
       * @ignore
       */
      readOnly: propTypes.exports.bool,

      /**
       * Render the selected value.
       *
       * @param {any} value The `value` provided to the component.
       * @returns {ReactNode}
       */
      renderValue: propTypes.exports.func,

      /**
       * Props applied to the clickable div element.
       */
      SelectDisplayProps: propTypes.exports.object,

      /**
       * @ignore
       */
      tabIndex: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * @ignore
       */
      type: propTypes.exports.any,

      /**
       * The input value.
       */
      value: propTypes.exports.any,

      /**
       * The variant to use.
       */
      variant: propTypes.exports.oneOf(['standard', 'outlined', 'filled'])
    } : void 0;
    var SelectInput$1 = SelectInput;

    var _StyledInput, _StyledFilledInput;

    const _excluded$3 = ["autoWidth", "children", "classes", "className", "defaultOpen", "displayEmpty", "IconComponent", "id", "input", "inputProps", "label", "labelId", "MenuProps", "multiple", "native", "onClose", "onOpen", "open", "renderValue", "SelectDisplayProps", "variant"];

    const useUtilityClasses$2 = ownerState => {
      const {
        classes
      } = ownerState;
      return classes;
    };

    const styledRootConfig = {
      name: 'MuiSelect',
      overridesResolver: (props, styles) => styles.root,
      shouldForwardProp: prop => rootShouldForwardProp(prop) && prop !== 'variant',
      slot: 'Root'
    };
    const StyledInput = styled$1(Input$1, styledRootConfig)('');
    const StyledOutlinedInput = styled$1(OutlinedInput$1, styledRootConfig)('');
    const StyledFilledInput = styled$1(FilledInput$1, styledRootConfig)('');
    const Select = /*#__PURE__*/react.exports.forwardRef(function Select(inProps, ref) {
      const props = useThemeProps({
        name: 'MuiSelect',
        props: inProps
      });

      const {
        autoWidth = false,
        children,
        classes: classesProp = {},
        className,
        defaultOpen = false,
        displayEmpty = false,
        IconComponent = ArrowDropDownIcon,
        id,
        input,
        inputProps,
        label,
        labelId,
        MenuProps,
        multiple = false,
        native = false,
        onClose,
        onOpen,
        open,
        renderValue,
        SelectDisplayProps,
        variant: variantProp = 'outlined'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$3);

      const inputComponent = native ? NativeSelectInput$1 : SelectInput$1;
      const muiFormControl = useFormControl();
      const fcs = formControlState({
        props,
        muiFormControl,
        states: ['variant']
      });
      const variant = fcs.variant || variantProp;
      const InputComponent = input || {
        standard: _StyledInput || (_StyledInput = /*#__PURE__*/jsxRuntimeExports.jsx(StyledInput, {})),
        outlined: /*#__PURE__*/jsxRuntimeExports.jsx(StyledOutlinedInput, {
          label: label
        }),
        filled: _StyledFilledInput || (_StyledFilledInput = /*#__PURE__*/jsxRuntimeExports.jsx(StyledFilledInput, {}))
      }[variant];

      const ownerState = _extends$1({}, props, {
        variant,
        classes: classesProp
      });

      const classes = useUtilityClasses$2(ownerState);
      const inputComponentRef = useForkRef(ref, InputComponent.ref);
      return /*#__PURE__*/react.exports.cloneElement(InputComponent, _extends$1({
        // Most of the logic is implemented in `SelectInput`.
        // The `Select` component is a simple API wrapper to expose something better to play with.
        inputComponent,
        inputProps: _extends$1({
          children,
          IconComponent,
          variant,
          type: undefined,
          // We render a select. We can ignore the type provided by the `Input`.
          multiple
        }, native ? {
          id
        } : {
          autoWidth,
          defaultOpen,
          displayEmpty,
          labelId,
          MenuProps,
          onClose,
          onOpen,
          open,
          renderValue,
          SelectDisplayProps: _extends$1({
            id
          }, SelectDisplayProps)
        }, inputProps, {
          classes: inputProps ? deepmerge(classes, inputProps.classes) : classes
        }, input ? input.props.inputProps : {})
      }, multiple && native && variant === 'outlined' ? {
        notched: true
      } : {}, {
        ref: inputComponentRef,
        className: clsx(InputComponent.props.className, className),
        variant
      }, other));
    });
    process.env.NODE_ENV !== "production" ? Select.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * If `true`, the width of the popover will automatically be set according to the items inside the
       * menu, otherwise it will be at least the width of the select input.
       * @default false
       */
      autoWidth: propTypes.exports.bool,

      /**
       * The option elements to populate the select with.
       * Can be some `MenuItem` when `native` is false and `option` when `native` is true.
       *
       * ⚠️The `MenuItem` elements **must** be direct descendants when `native` is false.
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       * @default {}
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * If `true`, the component is initially open. Use when the component open state is not controlled (i.e. the `open` prop is not defined).
       * You can only use it when the `native` prop is `false` (default).
       * @default false
       */
      defaultOpen: propTypes.exports.bool,

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, a value is displayed even if no items are selected.
       *
       * In order to display a meaningful value, a function can be passed to the `renderValue` prop which
       * returns the value to be displayed when no items are selected.
       *
       * ⚠️ When using this prop, make sure the label doesn't overlap with the empty displayed value.
       * The label should either be hidden or forced to a shrunk state.
       * @default false
       */
      displayEmpty: propTypes.exports.bool,

      /**
       * The icon that displays the arrow.
       * @default ArrowDropDownIcon
       */
      IconComponent: propTypes.exports.elementType,

      /**
       * The `id` of the wrapper element or the `select` element when `native`.
       */
      id: propTypes.exports.string,

      /**
       * An `Input` element; does not have to be a material-ui specific `Input`.
       */
      input: propTypes.exports.element,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       * When `native` is `true`, the attributes are applied on the `select` element.
       */
      inputProps: propTypes.exports.object,

      /**
       * See [OutlinedInput#label](/api/outlined-input/#props)
       */
      label: propTypes.exports.node,

      /**
       * The ID of an element that acts as an additional label. The Select will
       * be labelled by the additional label and the selected value.
       */
      labelId: propTypes.exports.string,

      /**
       * Props applied to the [`Menu`](/api/menu/) element.
       */
      MenuProps: propTypes.exports.object,

      /**
       * If `true`, `value` must be an array and the menu will support multiple selections.
       * @default false
       */
      multiple: propTypes.exports.bool,

      /**
       * If `true`, the component uses a native `select` element.
       * @default false
       */
      native: propTypes.exports.bool,

      /**
       * Callback fired when a menu item is selected.
       *
       * @param {SelectChangeEvent<T>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (any).
       * **Warning**: This is a generic event not a change event unless the change event is caused by browser autofill.
       * @param {object} [child] The react element that was selected when `native` is `false` (default).
       */
      onChange: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be closed.
       * Use in controlled mode (see open).
       *
       * @param {object} event The event source of the callback.
       */
      onClose: propTypes.exports.func,

      /**
       * Callback fired when the component requests to be opened.
       * Use in controlled mode (see open).
       *
       * @param {object} event The event source of the callback.
       */
      onOpen: propTypes.exports.func,

      /**
       * If `true`, the component is shown.
       * You can only use it when the `native` prop is `false` (default).
       */
      open: propTypes.exports.bool,

      /**
       * Render the selected value.
       * You can only use it when the `native` prop is `false` (default).
       *
       * @param {any} value The `value` provided to the component.
       * @returns {ReactNode}
       */
      renderValue: propTypes.exports.func,

      /**
       * Props applied to the clickable div element.
       */
      SelectDisplayProps: propTypes.exports.object,

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The `input` value. Providing an empty string will select no options.
       * Set to an empty string `''` if you don't want any of the available options to be selected.
       *
       * If the value is an object it must have reference equality with the option in order to be selected.
       * If the value is not an object, the string representation must match with the string representation of the option in order to be selected.
       */
      value: propTypes.exports.any,

      /**
       * The variant to use.
       * @default 'outlined'
       */
      variant: propTypes.exports.oneOf(['filled', 'outlined', 'standard'])
    } : void 0;
    Select.muiName = 'Select';
    var Select$1 = Select;

    const _excluded$2 = ["component", "direction", "spacing", "divider", "children"];

    function joinChildren(children, separator) {
      const childrenArray = react.exports.Children.toArray(children).filter(Boolean);
      return childrenArray.reduce((output, child, index) => {
        output.push(child);

        if (index < childrenArray.length - 1) {
          output.push( /*#__PURE__*/react.exports.cloneElement(separator, {
            key: `separator-${index}`
          }));
        }

        return output;
      }, []);
    }

    const getSideFromDirection = direction => {
      return {
        row: 'Left',
        'row-reverse': 'Right',
        column: 'Top',
        'column-reverse': 'Bottom'
      }[direction];
    };

    const style = ({
      ownerState,
      theme
    }) => {
      let styles = _extends$1({
        display: 'flex'
      }, handleBreakpoints({
        theme
      }, resolveBreakpointValues({
        values: ownerState.direction,
        breakpoints: theme.breakpoints.values
      }), propValue => ({
        flexDirection: propValue
      })));

      if (ownerState.spacing) {
        const transformer = createUnarySpacing(theme);
        const base = Object.keys(theme.breakpoints.values).reduce((acc, breakpoint) => {
          if (ownerState.spacing[breakpoint] != null || ownerState.direction[breakpoint] != null) {
            acc[breakpoint] = true;
          }

          return acc;
        }, {});
        const directionValues = resolveBreakpointValues({
          values: ownerState.direction,
          base
        });
        const spacingValues = resolveBreakpointValues({
          values: ownerState.spacing,
          base
        });

        const styleFromPropValue = (propValue, breakpoint) => {
          return {
            '& > :not(style) + :not(style)': {
              margin: 0,
              [`margin${getSideFromDirection(breakpoint ? directionValues[breakpoint] : ownerState.direction)}`]: getValue(transformer, propValue)
            }
          };
        };

        styles = deepmerge(styles, handleBreakpoints({
          theme
        }, spacingValues, styleFromPropValue));
      }

      return styles;
    };
    const StackRoot = styled$1('div', {
      name: 'MuiStack',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        return [styles.root];
      }
    })(style);
    const Stack = /*#__PURE__*/react.exports.forwardRef(function Stack(inProps, ref) {
      const themeProps = useThemeProps({
        props: inProps,
        name: 'MuiStack'
      });
      const props = extendSxProp(themeProps);

      const {
        component = 'div',
        direction = 'column',
        spacing = 0,
        divider,
        children
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$2);

      const ownerState = {
        direction,
        spacing
      };
      return /*#__PURE__*/jsxRuntimeExports.jsx(StackRoot, _extends$1({
        as: component,
        ownerState: ownerState,
        ref: ref
      }, other, {
        children: divider ? joinChildren(children, divider) : children
      }));
    });
    process.env.NODE_ENV !== "production" ? Stack.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * The content of the component.
       */
      children: propTypes.exports.node,

      /**
       * The component used for the root node.
       * Either a string to use a HTML element or a component.
       */
      component: propTypes.exports.elementType,

      /**
       * Defines the `flex-direction` style property.
       * It is applied for all screen sizes.
       * @default 'column'
       */
      direction: propTypes.exports.oneOfType([propTypes.exports.oneOf(['column-reverse', 'column', 'row-reverse', 'row']), propTypes.exports.arrayOf(propTypes.exports.oneOf(['column-reverse', 'column', 'row-reverse', 'row'])), propTypes.exports.object]),

      /**
       * Add an element between each child.
       */
      divider: propTypes.exports.node,

      /**
       * Defines the space between immediate children.
       * @default 0
       */
      spacing: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string])), propTypes.exports.number, propTypes.exports.object, propTypes.exports.string]),

      /**
       * The system prop, which allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object])
    } : void 0;
    var Stack$1 = Stack;

    function getSwitchUtilityClass(slot) {
      return generateUtilityClass('MuiSwitch', slot);
    }
    const switchClasses = generateUtilityClasses('MuiSwitch', ['root', 'edgeStart', 'edgeEnd', 'switchBase', 'colorPrimary', 'colorSecondary', 'sizeSmall', 'sizeMedium', 'checked', 'disabled', 'input', 'thumb', 'track']);
    var switchClasses$1 = switchClasses;

    const _excluded$1 = ["className", "color", "edge", "size", "sx"];

    const useUtilityClasses$1 = ownerState => {
      const {
        classes,
        edge,
        size,
        color,
        checked,
        disabled
      } = ownerState;
      const slots = {
        root: ['root', edge && `edge${capitalize(edge)}`, `size${capitalize(size)}`],
        switchBase: ['switchBase', `color${capitalize(color)}`, checked && 'checked', disabled && 'disabled'],
        thumb: ['thumb'],
        track: ['track'],
        input: ['input']
      };
      const composedClasses = composeClasses(slots, getSwitchUtilityClass, classes);
      return _extends$1({}, classes, composedClasses);
    };

    const SwitchRoot = styled$1('span', {
      name: 'MuiSwitch',
      slot: 'Root',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.root, ownerState.edge && styles[`edge${capitalize(ownerState.edge)}`], styles[`size${capitalize(ownerState.size)}`]];
      }
    })(({
      ownerState
    }) => _extends$1({
      display: 'inline-flex',
      width: 34 + 12 * 2,
      height: 14 + 12 * 2,
      overflow: 'hidden',
      padding: 12,
      boxSizing: 'border-box',
      position: 'relative',
      flexShrink: 0,
      zIndex: 0,
      // Reset the stacking context.
      verticalAlign: 'middle',
      // For correct alignment with the text.
      '@media print': {
        colorAdjust: 'exact'
      }
    }, ownerState.edge === 'start' && {
      marginLeft: -8
    }, ownerState.edge === 'end' && {
      marginRight: -8
    }, ownerState.size === 'small' && {
      width: 40,
      height: 24,
      padding: 7,
      [`& .${switchClasses$1.thumb}`]: {
        width: 16,
        height: 16
      },
      [`& .${switchClasses$1.switchBase}`]: {
        padding: 4,
        [`&.${switchClasses$1.checked}`]: {
          transform: 'translateX(16px)'
        }
      }
    }));
    const SwitchSwitchBase = styled$1(SwitchBase$1, {
      name: 'MuiSwitch',
      slot: 'SwitchBase',
      overridesResolver: (props, styles) => {
        const {
          ownerState
        } = props;
        return [styles.switchBase, {
          [`& .${switchClasses$1.input}`]: styles.input
        }, ownerState.color !== 'default' && styles[`color${capitalize(ownerState.color)}`]];
      }
    })(({
      theme
    }) => ({
      position: 'absolute',
      top: 0,
      left: 0,
      zIndex: 1,
      // Render above the focus ripple.
      color: theme.palette.mode === 'light' ? theme.palette.common.white : theme.palette.grey[300],
      transition: theme.transitions.create(['left', 'transform'], {
        duration: theme.transitions.duration.shortest
      }),
      [`&.${switchClasses$1.checked}`]: {
        transform: 'translateX(20px)'
      },
      [`&.${switchClasses$1.disabled}`]: {
        color: theme.palette.mode === 'light' ? theme.palette.grey[100] : theme.palette.grey[600]
      },
      [`&.${switchClasses$1.checked} + .${switchClasses$1.track}`]: {
        opacity: 0.5
      },
      [`&.${switchClasses$1.disabled} + .${switchClasses$1.track}`]: {
        opacity: theme.palette.mode === 'light' ? 0.12 : 0.2
      },
      [`& .${switchClasses$1.input}`]: {
        left: '-100%',
        width: '300%'
      }
    }), ({
      theme,
      ownerState
    }) => _extends$1({
      '&:hover': {
        backgroundColor: alpha(theme.palette.action.active, theme.palette.action.hoverOpacity),
        // Reset on touch devices, it doesn't add specificity
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }
    }, ownerState.color !== 'default' && {
      [`&.${switchClasses$1.checked}`]: {
        color: theme.palette[ownerState.color].main,
        '&:hover': {
          backgroundColor: alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
          '@media (hover: none)': {
            backgroundColor: 'transparent'
          }
        },
        [`&.${switchClasses$1.disabled}`]: {
          color: theme.palette.mode === 'light' ? lighten(theme.palette[ownerState.color].main, 0.62) : darken(theme.palette[ownerState.color].main, 0.55)
        }
      },
      [`&.${switchClasses$1.checked} + .${switchClasses$1.track}`]: {
        backgroundColor: theme.palette[ownerState.color].main
      }
    }));
    const SwitchTrack = styled$1('span', {
      name: 'MuiSwitch',
      slot: 'Track',
      overridesResolver: (props, styles) => styles.track
    })(({
      theme
    }) => ({
      height: '100%',
      width: '100%',
      borderRadius: 14 / 2,
      zIndex: -1,
      transition: theme.transitions.create(['opacity', 'background-color'], {
        duration: theme.transitions.duration.shortest
      }),
      backgroundColor: theme.palette.mode === 'light' ? theme.palette.common.black : theme.palette.common.white,
      opacity: theme.palette.mode === 'light' ? 0.38 : 0.3
    }));
    const SwitchThumb = styled$1('span', {
      name: 'MuiSwitch',
      slot: 'Thumb',
      overridesResolver: (props, styles) => styles.thumb
    })(({
      theme
    }) => ({
      boxShadow: theme.shadows[1],
      backgroundColor: 'currentColor',
      width: 20,
      height: 20,
      borderRadius: '50%'
    }));
    const Switch = /*#__PURE__*/react.exports.forwardRef(function Switch(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiSwitch'
      });

      const {
        className,
        color = 'primary',
        edge = false,
        size = 'medium',
        sx
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded$1);

      const ownerState = _extends$1({}, props, {
        color,
        edge,
        size
      });

      const classes = useUtilityClasses$1(ownerState);

      const icon = /*#__PURE__*/jsxRuntimeExports.jsx(SwitchThumb, {
        className: classes.thumb,
        ownerState: ownerState
      });

      return /*#__PURE__*/jsxRuntimeExports.jsxs(SwitchRoot, {
        className: clsx(classes.root, className),
        sx: sx,
        ownerState: ownerState,
        children: [/*#__PURE__*/jsxRuntimeExports.jsx(SwitchSwitchBase, _extends$1({
          type: "checkbox",
          icon: icon,
          checkedIcon: icon,
          ref: ref,
          ownerState: ownerState
        }, other, {
          classes: _extends$1({}, classes, {
            root: classes.switchBase
          })
        })), /*#__PURE__*/jsxRuntimeExports.jsx(SwitchTrack, {
          className: classes.track,
          ownerState: ownerState
        })]
      });
    });
    process.env.NODE_ENV !== "production" ? Switch.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * If `true`, the component is checked.
       */
      checked: propTypes.exports.bool,

      /**
       * The icon to display when the component is checked.
       */
      checkedIcon: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * @default 'primary'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The default checked state. Use when the component is not controlled.
       */
      defaultChecked: propTypes.exports.bool,

      /**
       * If `true`, the component is disabled.
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the ripple effect is disabled.
       */
      disableRipple: propTypes.exports.bool,

      /**
       * If given, uses a negative margin to counteract the padding on one
       * side (this is often helpful for aligning the left or right
       * side of the icon with content above or below, without ruining the border
       * size and shape).
       * @default false
       */
      edge: propTypes.exports.oneOf(['end', 'start', false]),

      /**
       * The icon to display when the component is unchecked.
       */
      icon: propTypes.exports.node,

      /**
       * The id of the `input` element.
       */
      id: propTypes.exports.string,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       */
      inputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * Callback fired when the state is changed.
       *
       * @param {React.ChangeEvent<HTMLInputElement>} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       * You can pull out the new checked state by accessing `event.target.checked` (boolean).
       */
      onChange: propTypes.exports.func,

      /**
       * If `true`, the `input` element is required.
       */
      required: propTypes.exports.bool,

      /**
       * The size of the component.
       * `small` is equivalent to the dense switch styling.
       * @default 'medium'
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['medium', 'small']), propTypes.exports.string]),

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * The value of the component. The DOM API casts this to a string.
       * The browser uses "on" as the default value.
       */
      value: propTypes.exports.any
    } : void 0;
    var Switch$1 = Switch;

    function getTextFieldUtilityClass(slot) {
      return generateUtilityClass('MuiTextField', slot);
    }
    generateUtilityClasses('MuiTextField', ['root']);

    const _excluded = ["autoComplete", "autoFocus", "children", "className", "color", "defaultValue", "disabled", "error", "FormHelperTextProps", "fullWidth", "helperText", "id", "InputLabelProps", "inputProps", "InputProps", "inputRef", "label", "maxRows", "minRows", "multiline", "name", "onBlur", "onChange", "onFocus", "placeholder", "required", "rows", "select", "SelectProps", "type", "value", "variant"];
    const variantComponent = {
      standard: Input$1,
      filled: FilledInput$1,
      outlined: OutlinedInput$1
    };

    const useUtilityClasses = ownerState => {
      const {
        classes
      } = ownerState;
      const slots = {
        root: ['root']
      };
      return composeClasses(slots, getTextFieldUtilityClass, classes);
    };

    const TextFieldRoot = styled$1(FormControl$1, {
      name: 'MuiTextField',
      slot: 'Root',
      overridesResolver: (props, styles) => styles.root
    })({});
    /**
     * The `TextField` is a convenience wrapper for the most common cases (80%).
     * It cannot be all things to all people, otherwise the API would grow out of control.
     *
     * ## Advanced Configuration
     *
     * It's important to understand that the text field is a simple abstraction
     * on top of the following components:
     *
     * - [FormControl](/api/form-control/)
     * - [InputLabel](/api/input-label/)
     * - [FilledInput](/api/filled-input/)
     * - [OutlinedInput](/api/outlined-input/)
     * - [Input](/api/input/)
     * - [FormHelperText](/api/form-helper-text/)
     *
     * If you wish to alter the props applied to the `input` element, you can do so as follows:
     *
     * ```jsx
     * const inputProps = {
     *   step: 300,
     * };
     *
     * return <TextField id="time" type="time" inputProps={inputProps} />;
     * ```
     *
     * For advanced cases, please look at the source of TextField by clicking on the
     * "Edit this page" button above. Consider either:
     *
     * - using the upper case props for passing values directly to the components
     * - using the underlying components directly as shown in the demos
     */

    const TextField = /*#__PURE__*/react.exports.forwardRef(function TextField(inProps, ref) {
      const props = useThemeProps({
        props: inProps,
        name: 'MuiTextField'
      });

      const {
        autoComplete,
        autoFocus = false,
        children,
        className,
        color = 'primary',
        defaultValue,
        disabled = false,
        error = false,
        FormHelperTextProps,
        fullWidth = false,
        helperText,
        id: idOverride,
        InputLabelProps,
        inputProps,
        InputProps,
        inputRef,
        label,
        maxRows,
        minRows,
        multiline = false,
        name,
        onBlur,
        onChange,
        onFocus,
        placeholder,
        required = false,
        rows,
        select = false,
        SelectProps,
        type,
        value,
        variant = 'outlined'
      } = props,
            other = _objectWithoutPropertiesLoose(props, _excluded);

      const ownerState = _extends$1({}, props, {
        autoFocus,
        color,
        disabled,
        error,
        fullWidth,
        multiline,
        required,
        select,
        variant
      });

      const classes = useUtilityClasses(ownerState);

      if (process.env.NODE_ENV !== 'production') {
        if (select && !children) {
          console.error('MUI: `children` must be passed when using the `TextField` component with `select`.');
        }
      }

      const InputMore = {};

      if (variant === 'outlined') {
        if (InputLabelProps && typeof InputLabelProps.shrink !== 'undefined') {
          InputMore.notched = InputLabelProps.shrink;
        }

        InputMore.label = label;
      }

      if (select) {
        // unset defaults from textbox inputs
        if (!SelectProps || !SelectProps.native) {
          InputMore.id = undefined;
        }

        InputMore['aria-describedby'] = undefined;
      }

      const id = useId(idOverride);
      const helperTextId = helperText && id ? `${id}-helper-text` : undefined;
      const inputLabelId = label && id ? `${id}-label` : undefined;
      const InputComponent = variantComponent[variant];

      const InputElement = /*#__PURE__*/jsxRuntimeExports.jsx(InputComponent, _extends$1({
        "aria-describedby": helperTextId,
        autoComplete: autoComplete,
        autoFocus: autoFocus,
        defaultValue: defaultValue,
        fullWidth: fullWidth,
        multiline: multiline,
        name: name,
        rows: rows,
        maxRows: maxRows,
        minRows: minRows,
        type: type,
        value: value,
        id: id,
        inputRef: inputRef,
        onBlur: onBlur,
        onChange: onChange,
        onFocus: onFocus,
        placeholder: placeholder,
        inputProps: inputProps
      }, InputMore, InputProps));

      return /*#__PURE__*/jsxRuntimeExports.jsxs(TextFieldRoot, _extends$1({
        className: clsx(classes.root, className),
        disabled: disabled,
        error: error,
        fullWidth: fullWidth,
        ref: ref,
        required: required,
        color: color,
        variant: variant,
        ownerState: ownerState
      }, other, {
        children: [label != null && label !== '' && /*#__PURE__*/jsxRuntimeExports.jsx(InputLabel$1, _extends$1({
          htmlFor: id,
          id: inputLabelId
        }, InputLabelProps, {
          children: label
        })), select ? /*#__PURE__*/jsxRuntimeExports.jsx(Select$1, _extends$1({
          "aria-describedby": helperTextId,
          id: id,
          labelId: inputLabelId,
          value: value,
          input: InputElement
        }, SelectProps, {
          children: children
        })) : InputElement, helperText && /*#__PURE__*/jsxRuntimeExports.jsx(FormHelperText$1, _extends$1({
          id: helperTextId
        }, FormHelperTextProps, {
          children: helperText
        }))]
      }));
    });
    process.env.NODE_ENV !== "production" ? TextField.propTypes
    /* remove-proptypes */
    = {
      // ----------------------------- Warning --------------------------------
      // | These PropTypes are generated from the TypeScript type definitions |
      // |     To update them edit the d.ts file and run "yarn proptypes"     |
      // ----------------------------------------------------------------------

      /**
       * This prop helps users to fill forms faster, especially on mobile devices.
       * The name can be confusing, as it's more like an autofill.
       * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
       */
      autoComplete: propTypes.exports.string,

      /**
       * If `true`, the `input` element is focused during the first mount.
       * @default false
       */
      autoFocus: propTypes.exports.bool,

      /**
       * @ignore
       */
      children: propTypes.exports.node,

      /**
       * Override or extend the styles applied to the component.
       */
      classes: propTypes.exports.object,

      /**
       * @ignore
       */
      className: propTypes.exports.string,

      /**
       * The color of the component. It supports those theme colors that make sense for this component.
       * @default 'primary'
       */
      color: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypes.exports.string]),

      /**
       * The default value. Use when the component is not controlled.
       */
      defaultValue: propTypes.exports.any,

      /**
       * If `true`, the component is disabled.
       * @default false
       */
      disabled: propTypes.exports.bool,

      /**
       * If `true`, the label is displayed in an error state.
       * @default false
       */
      error: propTypes.exports.bool,

      /**
       * Props applied to the [`FormHelperText`](/api/form-helper-text/) element.
       */
      FormHelperTextProps: propTypes.exports.object,

      /**
       * If `true`, the input will take up the full width of its container.
       * @default false
       */
      fullWidth: propTypes.exports.bool,

      /**
       * The helper text content.
       */
      helperText: propTypes.exports.node,

      /**
       * The id of the `input` element.
       * Use this prop to make `label` and `helperText` accessible for screen readers.
       */
      id: propTypes.exports.string,

      /**
       * Props applied to the [`InputLabel`](/api/input-label/) element.
       * Pointer events like `onClick` are enabled if and only if `shrink` is `true`.
       */
      InputLabelProps: propTypes.exports.object,

      /**
       * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
       */
      inputProps: propTypes.exports.object,

      /**
       * Props applied to the Input element.
       * It will be a [`FilledInput`](/api/filled-input/),
       * [`OutlinedInput`](/api/outlined-input/) or [`Input`](/api/input/)
       * component depending on the `variant` prop value.
       */
      InputProps: propTypes.exports.object,

      /**
       * Pass a ref to the `input` element.
       */
      inputRef: refType,

      /**
       * The label content.
       */
      label: propTypes.exports.node,

      /**
       * If `dense` or `normal`, will adjust vertical spacing of this and contained components.
       * @default 'none'
       */
      margin: propTypes.exports.oneOf(['dense', 'none', 'normal']),

      /**
       * Maximum number of rows to display when multiline option is set to true.
       */
      maxRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Minimum number of rows to display when multiline option is set to true.
       */
      minRows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * If `true`, a `textarea` element is rendered instead of an input.
       * @default false
       */
      multiline: propTypes.exports.bool,

      /**
       * Name attribute of the `input` element.
       */
      name: propTypes.exports.string,

      /**
       * @ignore
       */
      onBlur: propTypes.exports.func,

      /**
       * Callback fired when the value is changed.
       *
       * @param {object} event The event source of the callback.
       * You can pull out the new value by accessing `event.target.value` (string).
       */
      onChange: propTypes.exports.func,

      /**
       * @ignore
       */
      onFocus: propTypes.exports.func,

      /**
       * The short hint displayed in the `input` before the user enters a value.
       */
      placeholder: propTypes.exports.string,

      /**
       * If `true`, the label is displayed as required and the `input` element is required.
       * @default false
       */
      required: propTypes.exports.bool,

      /**
       * Number of rows to display when multiline option is set to true.
       */
      rows: propTypes.exports.oneOfType([propTypes.exports.number, propTypes.exports.string]),

      /**
       * Render a [`Select`](/api/select/) element while passing the Input element to `Select` as `input` parameter.
       * If this option is set you must pass the options of the select as children.
       * @default false
       */
      select: propTypes.exports.bool,

      /**
       * Props applied to the [`Select`](/api/select/) element.
       */
      SelectProps: propTypes.exports.object,

      /**
       * The size of the component.
       */
      size: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .oneOfType([propTypes.exports.oneOf(['medium', 'small']), propTypes.exports.string]),

      /**
       * The system prop that allows defining system overrides as well as additional CSS styles.
       */
      sx: propTypes.exports.oneOfType([propTypes.exports.arrayOf(propTypes.exports.oneOfType([propTypes.exports.func, propTypes.exports.object, propTypes.exports.bool])), propTypes.exports.func, propTypes.exports.object]),

      /**
       * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
       */
      type: propTypes.exports
      /* @typescript-to-proptypes-ignore */
      .string,

      /**
       * The value of the `input` element, required for a controlled component.
       */
      value: propTypes.exports.any,

      /**
       * The variant to use.
       * @default 'outlined'
       */
      variant: propTypes.exports.oneOf(['filled', 'outlined', 'standard'])
    } : void 0;
    var TextField$1 = TextField;

    var DeleteForever = {};

    var interopRequireDefault = {exports: {}};

    (function (module) {
    	function _interopRequireDefault(obj) {
    	  return obj && obj.__esModule ? obj : {
    	    "default": obj
    	  };
    	}

    	module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
    } (interopRequireDefault));

    var createSvgIcon = {};

    var require$$0 = /*@__PURE__*/getAugmentedNamespace(utils);

    var hasRequiredCreateSvgIcon;

    function requireCreateSvgIcon () {
    	if (hasRequiredCreateSvgIcon) return createSvgIcon;
    	hasRequiredCreateSvgIcon = 1;
    	(function (exports) {

    		Object.defineProperty(exports, "__esModule", {
    		  value: true
    		});
    		Object.defineProperty(exports, "default", {
    		  enumerable: true,
    		  get: function () {
    		    return _utils.createSvgIcon;
    		  }
    		});

    		var _utils = require$$0;
    } (createSvgIcon));
    	return createSvgIcon;
    }

    var _interopRequireDefault$3 = interopRequireDefault.exports;

    Object.defineProperty(DeleteForever, "__esModule", {
      value: true
    });
    var default_1$3 = DeleteForever.default = void 0;

    var _createSvgIcon$3 = _interopRequireDefault$3(requireCreateSvgIcon());

    var _jsxRuntime$3 = requireJsxRuntime();

    var _default$3 = (0, _createSvgIcon$3.default)( /*#__PURE__*/(0, _jsxRuntime$3.jsx)("path", {
      d: "M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zm2.46-7.12 1.41-1.41L12 12.59l2.12-2.12 1.41 1.41L13.41 14l2.12 2.12-1.41 1.41L12 15.41l-2.12 2.12-1.41-1.41L10.59 14l-2.13-2.12zM15.5 4l-1-1h-5l-1 1H5v2h14V4z"
    }), 'DeleteForever');

    default_1$3 = DeleteForever.default = _default$3;

    function typeFromValue(value) {
        switch (typeof value) {
            case 'number':
                return 'number';
            case 'string':
                return 'string';
            case 'boolean':
                return 'boolean';
            default:
                if (value === null || value === undefined)
                    return 'null';
                if (Array.isArray(value))
                    return 'array';
                return 'object';
        }
    }

    function valueFromType(type) {
        switch (type) {
            case 'number':
                return 0;
            case 'string':
                return '';
            case 'boolean':
                return false;
            case 'array':
                return [];
            case 'object':
                return {};
            default:
                return null;
        }
    }

    var Add = {};

    var _interopRequireDefault$2 = interopRequireDefault.exports;

    Object.defineProperty(Add, "__esModule", {
      value: true
    });
    var default_1$2 = Add.default = void 0;

    var _createSvgIcon$2 = _interopRequireDefault$2(requireCreateSvgIcon());

    var _jsxRuntime$2 = requireJsxRuntime();

    var _default$2 = (0, _createSvgIcon$2.default)( /*#__PURE__*/(0, _jsxRuntime$2.jsx)("path", {
      d: "M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z"
    }), 'Add');

    default_1$2 = Add.default = _default$2;

    var ArrayActions;
    (function (ArrayActions) {
        ArrayActions["ADD_ITEM"] = "ADD_ITEM";
        ArrayActions["MOVE_ITEM"] = "MOVE_ITEM";
        ArrayActions["CLONE_ITEM"] = "CLONE_ITEM";
        ArrayActions["DELETE_ITEM"] = "DELETE_ITEM";
        ArrayActions["CHANGE_ITEM"] = "CHANGE_ITEM";
        ArrayActions["SET"] = "SET";
    })(ArrayActions || (ArrayActions = {}));
    function arrayReducer(arr, action) {
        switch (action.action) {
            case ArrayActions.ADD_ITEM: {
                return __spreadArray(__spreadArray([], __read(arr), false), [action.value], false);
            }
            case ArrayActions.MOVE_ITEM: {
                var newArr = __spreadArray([], __read(arr), false);
                var existingItems = newArr.splice(action.index, 1);
                newArr.splice(action.targetIndex, 0, existingItems[0]);
                return newArr;
            }
            case ArrayActions.CLONE_ITEM: {
                return __spreadArray(__spreadArray(__spreadArray([], __read(arr.slice(0, action.index)), false), [arr[action.index]], false), __read(arr.slice(action.index)), false);
            }
            case ArrayActions.DELETE_ITEM: {
                return __spreadArray(__spreadArray([], __read(arr.slice(0, action.index)), false), __read(arr.slice(action.index + 1)), false);
            }
            case ArrayActions.CHANGE_ITEM: {
                var newArr = __spreadArray([], __read(arr), false);
                newArr[action.index] = action.value;
                return newArr;
            }
            case ArrayActions.SET: {
                return action.value;
            }
            default: {
                return [];
            }
        }
    }

    function valueToString(value) {
        var result = '';
        switch (typeof value) {
            case 'number': {
                result = value.toString();
                break;
            }
            case 'string': {
                result = value;
                break;
            }
            case 'boolean': {
                result = value ? 'True' : 'False';
                break;
            }
            default: {
                if (value === null || value === undefined) {
                    result = 'None';
                    break;
                }
                if (Array.isArray(value)) {
                    result = value.map(function (item) { return valueToString(item); }).join(', ');
                    break;
                }
                result = "(".concat(Object.keys(value)
                    .map(function (key) { return "".concat(key, ": ").concat(valueToString(value[key])); })
                    .join(', '), ")");
                break;
            }
        }
        // limit the number of chars we print to screen (gets truncated anyway)
        return result.substring(0, 100) || '[Empty]';
    }

    var listWrapStyle$1 = {
        width: '100%',
        flex: 1,
        border: 1,
        borderColor: 'grey.500',
        borderRadius: 1,
        boxSizing: 'border-box',
        overflow: 'auto',
        position: 'relative',
        minHeight: 100,
    };
    var listStyle$1 = {
        position: 'absolute',
        width: '100%',
    };
    var listItemTextTypographyStyle$1 = {
        align: 'left',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
    };
    function ArrayEditor(_a) {
        var onChange = _a.onChange, value = _a.value, newItemValue = _a.newItemValue, onEdit = _a.onEdit;
        var _b = __read(react.exports.useReducer(arrayReducer, value), 2), arr = _b[0], dispatch = _b[1];
        react.exports.useEffect(function () {
            onChange(arr);
        }, [arr, onChange]);
        react.exports.useEffect(function () {
            dispatch({ action: ArrayActions.SET, value: value });
        }, [value]);
        var onAdd = function () {
            dispatch({ action: ArrayActions.ADD_ITEM, value: newItemValue(arr) });
        };
        return (React.createElement(Stack$1, { display: "flex", width: "100%", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", spacing: 1, flex: 1 },
            React.createElement(Box$1, { sx: listWrapStyle$1 },
                React.createElement(List$1, { dense: true, sx: listStyle$1 }, arr.map(function (itemValue, index) { return (
                // we do want to use the index here as the key as the items may not be unique
                // eslint-disable-next-line react/no-array-index-key
                React.createElement(ListItem$1, { key: index, disablePadding: true },
                    React.createElement(ListItemButton$1, { onClick: function () { return onEdit(index); } },
                        React.createElement(ListItemText$1, { primaryTypographyProps: listItemTextTypographyStyle$1, primary: valueToString(itemValue) })))); }))),
            React.createElement(Button$1, { endIcon: React.createElement(default_1$2, null), color: "primary", variant: "outlined", fullWidth: true, onClick: onAdd }, "Add new")));
    }

    function BooleanEditor(_a) {
        var label = _a.label, value = _a.value, onChange = _a.onChange;
        return (React.createElement(FormControlLabel$1, { label: label, control: React.createElement(Switch$1, { checked: value, onChange: function (_e, checked) { return onChange(checked); } }) }));
    }

    function NumberEditor(_a) {
        var value = _a.value, onChange = _a.onChange, label = _a.label;
        var _b = __read(react.exports.useState(value.toString()), 2), inputValue = _b[0], setInputValue = _b[1];
        react.exports.useEffect(function () {
            setInputValue(value.toString());
        }, [value]);
        var updateValue = function (newInputValue) {
            setInputValue(newInputValue);
            var newValue = parseFloat(newInputValue);
            if (!Number.isNaN(newValue) && Number.isFinite(newValue)) {
                onChange(newValue);
            }
        };
        return (React.createElement(TextField$1, { size: "small", label: label, fullWidth: true, inputProps: { inputMode: 'numeric', pattern: '[0-9]*' }, InputLabelProps: { shrink: true }, value: inputValue, onChange: function (e) { return updateValue(e.target.value); } }));
    }

    function cloneValue(value) {
        if (Array.isArray(value)) {
            return __spreadArray([], __read(value), false);
        }
        if (typeof value === 'object' && value !== null) {
            return __assign({}, value);
        }
        return value;
    }

    var ObjectActions;
    (function (ObjectActions) {
        ObjectActions["ADD_ITEM"] = "ADD_ITEM";
        ObjectActions["CLONE_ITEM"] = "CLONE_ITEM";
        ObjectActions["DELETE_ITEM"] = "DELETE_ITEM";
        ObjectActions["UPDATE_ITEM"] = "UPDATE_ITEM";
        ObjectActions["UPDATE_KEY"] = "UPDATE_KEY";
        ObjectActions["SET"] = "SET";
    })(ObjectActions || (ObjectActions = {}));
    function objectReducer(obj, action) {
        var _a, _b, _c;
        switch (action.action) {
            case ObjectActions.ADD_ITEM: {
                return __assign(__assign({}, obj), (_a = {}, _a[action.key] = action.value, _a));
            }
            case ObjectActions.CLONE_ITEM: {
                return __assign(__assign({}, obj), (_b = {}, _b["".concat(action.key, "_copy")] = cloneValue(obj[action.key]), _b));
            }
            case ObjectActions.DELETE_ITEM: {
                var newObj = __assign({}, obj);
                delete newObj[action.key];
                return newObj;
            }
            case ObjectActions.UPDATE_ITEM: {
                return __assign(__assign({}, obj), (_c = {}, _c[action.key] = action.value, _c));
            }
            case ObjectActions.UPDATE_KEY: {
                var newObj2 = __assign({}, obj);
                var existingValue = newObj2[action.key];
                delete newObj2[action.key];
                newObj2[action.newKey] = existingValue;
                return newObj2;
            }
            case ObjectActions.SET: {
                return action.value;
            }
            default: {
                return {};
            }
        }
    }

    var listWrapStyle = {
        width: '100%',
        flex: 1,
        border: 1,
        borderColor: 'grey.500',
        borderRadius: 1,
        boxSizing: 'border-box',
        overflow: 'auto',
        position: 'relative',
        minHeight: 100,
    };
    var listStyle = {
        position: 'absolute',
        width: '100%',
    };
    var listItemButtonStyle = {
        width: '100%',
    };
    var listItemTextStyle = {
        flexBasis: '50%',
    };
    var listItemTextTypographyStyle = {
        align: 'left',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
    };
    function ObjectEditor(_a) {
        var value = _a.value, onChange = _a.onChange, onEdit = _a.onEdit, newItemKey = _a.newItemKey, newItemValue = _a.newItemValue;
        var _b = __read(react.exports.useReducer(objectReducer, value), 2), obj = _b[0], dispatch = _b[1];
        react.exports.useEffect(function () {
            onChange(obj);
            // do not trigger an update when the change func is updated
            // eslint-disable-next-line react-hooks/exhaustive-deps
        }, [obj]);
        react.exports.useEffect(function () {
            dispatch({ action: ObjectActions.SET, value: value });
        }, [value]);
        var onAdd = function () {
            dispatch({
                action: ObjectActions.ADD_ITEM,
                key: newItemKey(obj),
                value: newItemValue(obj),
            });
        };
        return (React.createElement(Stack$1, { display: "flex", width: "100%", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", spacing: 1, flex: 1 },
            React.createElement(Box$1, { sx: listWrapStyle },
                React.createElement(List$1, { dense: true, sx: listStyle }, Object.keys(obj).map(function (key) { return (React.createElement(ListItem$1, { key: key, disablePadding: true },
                    React.createElement(ListItemButton$1, { sx: listItemButtonStyle, onClick: function () { return onEdit(key); } },
                        React.createElement(ListItemText$1, { sx: listItemTextStyle, primaryTypographyProps: listItemTextTypographyStyle, primary: key }),
                        React.createElement(ListItemText$1, { sx: listItemTextStyle, secondaryTypographyProps: listItemTextTypographyStyle, secondary: valueToString(obj[key]) })))); }))),
            React.createElement(Button$1, { endIcon: React.createElement(default_1$2, null), color: "primary", variant: "outlined", fullWidth: true, onClick: onAdd }, "Add new")));
    }

    function StringEditor(_a) {
        var label = _a.label, value = _a.value, onChange = _a.onChange;
        return (React.createElement(TextField$1, { sx: {
                '& .MuiInputBase-root': {
                    flex: 1,
                },
            }, label: label, margin: "dense", fullWidth: true, style: { flex: 1 }, InputLabelProps: { shrink: true }, inputProps: { style: { height: '100%', overflow: 'auto' } }, hiddenLabel: true, autoCorrect: "off", spellCheck: "false", autoComplete: "off", multiline: true, variant: "outlined", value: value, onChange: function (e) { return onChange(e.target.value); } }));
    }

    var types = [
        { name: 'Number', value: 'number' },
        { name: 'String', value: 'string' },
        { name: 'Boolean', value: 'boolean' },
        { name: 'Array', value: 'array' },
        { name: 'Object', value: 'object' },
        { name: 'Null', value: 'null' },
    ];
    var typeByValue = types.reduce(function (acc, item) {
        acc[item.value] = item;
        return acc;
    }, {});
    function ValueEditor(_a) {
        var value = _a.value, onChange = _a.onChange, newArrayItemValue = _a.newArrayItemValue, onEdit = _a.onEdit, newObjectItemValue = _a.newObjectItemValue, newObjectItemKey = _a.newObjectItemKey;
        var updateValue = function (type) {
            onChange(valueFromType(type));
        };
        var valueType = typeFromValue(value);
        var valueEditor = (function () {
            switch (valueType) {
                case 'number':
                    return React.createElement(NumberEditor, { label: "Value", value: value, onChange: onChange });
                case 'string':
                    return React.createElement(StringEditor, { label: "Value", value: value, onChange: onChange });
                case 'boolean':
                    return React.createElement(BooleanEditor, { label: "Value", value: value, onChange: onChange });
                case 'array':
                    return (React.createElement(Stack$1, { display: "flex", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", width: "100%", flex: "1", spacing: 1 },
                        React.createElement(InputLabel$1, null,
                            "Items (",
                            value.length,
                            ")"),
                        React.createElement(ArrayEditor, { newItemValue: newArrayItemValue, onEdit: onEdit, value: value, onChange: onChange })));
                case 'object':
                    return (React.createElement(Stack$1, { display: "flex", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", width: "100%", flex: "1", spacing: 1 },
                        React.createElement(InputLabel$1, null,
                            "Properties (",
                            Object.keys(value).length,
                            ")"),
                        React.createElement(ObjectEditor, { newItemValue: newObjectItemValue, newItemKey: newObjectItemKey, value: value, onEdit: onEdit, onChange: onChange })));
                default:
                    return '';
            }
        })();
        return (React.createElement(React.Fragment, null,
            React.createElement(TextField$1, { select: true, label: "Type", size: "small", fullWidth: true, value: typeByValue[valueType].value, onChange: function (e) { return updateValue(e.target.value); } }, types.map(function (typeObj) { return (React.createElement(MenuItem$1, { key: typeObj.value, value: typeObj.value }, typeObj.name)); })),
            valueEditor));
    }

    // returns new object for the path given with the leaf reference changed
    function deleteChild(parent, path) {
        var newParent = cloneValue(parent);
        var leaf = newParent;
        for (var i = 0; i < path.length - 1; i += 1) {
            if (leaf === null || typeof leaf !== 'object') {
                leaf = {};
            }
            else {
                leaf = __assign({}, leaf);
            }
            if (Array.isArray(leaf)) {
                leaf = leaf[+path[i]];
            }
            else {
                leaf = leaf[path[i]];
            }
        }
        var lastKey = path[path.length - 1];
        if (Array.isArray(leaf)) {
            leaf.splice(+lastKey, 1);
        }
        else if (typeof leaf === 'object' && leaf !== null) {
            delete leaf[lastKey];
        }
        return newParent;
    }

    function getChild(parent, path) {
        var _a;
        var childObj = parent;
        for (var i = 0; i < path.length; i += 1) {
            var field = path[i];
            if (typeof childObj !== 'object') {
                throw new Error("Could not get child ".concat(field, " of ").concat(childObj));
            }
            if (Array.isArray(childObj)) {
                childObj = childObj[+field];
            }
            else {
                childObj = (_a = childObj === null || childObj === void 0 ? void 0 : childObj[field]) !== null && _a !== void 0 ? _a : null;
            }
        }
        return childObj;
    }

    // returns new object for each parent for the path given with the leaf reference changed
    function setChild(parent, path, value) {
        var leaf = parent;
        for (var i = 0; i < path.length; i += 1) {
            var part = path[i];
            if (typeof leaf !== 'object' || leaf === null) {
                break;
            }
            if (Array.isArray(leaf)) {
                leaf = leaf[+part];
            }
            else {
                leaf = leaf[part];
            }
        }
        if (leaf === value) {
            return parent;
        }
        if (!path.length) {
            return value;
        }
        var newParent = cloneValue(parent);
        leaf = newParent;
        for (var i = 0; i < path.length - 1; i += 1) {
            if (typeof leaf !== 'object' || leaf === null) {
                leaf = {};
            }
            else {
                leaf = __assign({}, leaf);
            }
            if (Array.isArray(leaf)) {
                leaf = leaf[+path[i]];
            }
            else {
                leaf = leaf[path[i]];
            }
        }
        if (typeof leaf !== 'object' || leaf === null) {
            leaf = {};
        }
        var lastKey = path[path.length - 1];
        if (Array.isArray(leaf)) {
            leaf[+lastKey] = value;
        }
        else {
            leaf[lastKey] = value;
        }
        return newParent;
    }

    var Home = {};

    var _interopRequireDefault$1 = interopRequireDefault.exports;

    Object.defineProperty(Home, "__esModule", {
      value: true
    });
    var default_1$1 = Home.default = void 0;

    var _createSvgIcon$1 = _interopRequireDefault$1(requireCreateSvgIcon());

    var _jsxRuntime$1 = requireJsxRuntime();

    var _default$1 = (0, _createSvgIcon$1.default)( /*#__PURE__*/(0, _jsxRuntime$1.jsx)("path", {
      d: "M10 20v-6h4v6h5v-8h3L12 3 2 12h3v8z"
    }), 'Home');

    default_1$1 = Home.default = _default$1;

    var ExpandMore = {};

    var _interopRequireDefault = interopRequireDefault.exports;

    Object.defineProperty(ExpandMore, "__esModule", {
      value: true
    });
    var default_1 = ExpandMore.default = void 0;

    var _createSvgIcon = _interopRequireDefault(requireCreateSvgIcon());

    var _jsxRuntime = requireJsxRuntime();

    var _default = (0, _createSvgIcon.default)( /*#__PURE__*/(0, _jsxRuntime.jsx)("path", {
      d: "M16.59 8.59 12 13.17 7.41 8.59 6 10l6 6 6-6z"
    }), 'ExpandMore');

    default_1 = ExpandMore.default = _default;

    var ChipBreadcrumb = styled$1(Chip$1)(function (_a) {
        var theme = _a.theme;
        var backgroundColor = theme.palette.mode === 'light' ? theme.palette.grey[100] : theme.palette.grey[800];
        return {
            backgroundColor: backgroundColor,
            height: theme.spacing(3),
            color: theme.palette.text.primary,
            fontWeight: theme.typography.fontWeightRegular,
            '&:hover, &:focus': {
                backgroundColor: emphasize(backgroundColor, 0.06),
            },
            '&:active': {
                boxShadow: theme.shadows[1],
                backgroundColor: emphasize(backgroundColor, 0.12),
            },
        };
    });

    function LevelBreadcrumb(_a) {
        var items = _a.items, onSelect = _a.onSelect, icon = _a.icon, item = _a.item;
        var _b = __read(React.useState(undefined), 2), anchorEl = _b[0], setAnchorEl = _b[1];
        var openMenu = function (e) {
            setAnchorEl(e.target);
        };
        var closeMenu = function () {
            setAnchorEl(undefined);
        };
        var selectMenuItem = function (selectedItem) {
            closeMenu();
            onSelect(selectedItem);
        };
        var handleListKeyDown = function (e) {
            if (e.key === 'Tab') {
                e.preventDefault();
                closeMenu();
            }
            else if (e.key === 'Escape') {
                closeMenu();
            }
        };
        return (items === null || items === void 0 ? void 0 : items.length) ? (React.createElement("div", { style: { position: 'relative' } },
            React.createElement(ChipBreadcrumb, { icon: icon, label: item, onClick: function () { return onSelect(item); }, deleteIcon: React.createElement(default_1, null), onDelete: openMenu, "aria-controls": "basic-menu", "aria-haspopup": "true", "aria-expanded": anchorEl ? 'true' : undefined }),
            React.createElement(Popper$1, { open: Boolean(anchorEl), role: undefined, anchorEl: anchorEl, placement: "bottom" },
                React.createElement(Paper$1, null,
                    React.createElement(ClickAwayListener, { onClickAway: closeMenu },
                        React.createElement(MenuList$1, { dense: true, autoFocusItem: Boolean(anchorEl), onKeyDown: handleListKeyDown }, items === null || items === void 0 ? void 0 : items.map(function (listItem) { return (React.createElement(MenuItem$1, { key: listItem, onClick: function () { return selectMenuItem(listItem); } }, listItem)); }))))))) : (React.createElement(ChipBreadcrumb, { icon: icon, label: item, onClick: function () { return onSelect(item); } }));
    }
    LevelBreadcrumb.defaultProps = {
        icon: undefined,
        items: [],
    };

    function LevelSelector(_a) {
        var obj = _a.obj, path = _a.path, setPath = _a.setPath;
        var subobj = obj;
        var paths = path.map(function (pathItem) {
            var items = new Array();
            if (Array.isArray(subobj)) {
                var keys = Array.from(subobj.keys());
                var itemIndex = parseInt(pathItem.toString(), 10);
                items = __spreadArray(__spreadArray([], __read(keys.slice(0, itemIndex)), false), __read(keys.slice(itemIndex + 1)), false);
                subobj = subobj[itemIndex];
            }
            else if (typeof subobj === 'object' && subobj !== null) {
                var keys = new Set(Object.keys(subobj));
                keys.delete(pathItem.toString());
                items = Array.from(keys);
                subobj = subobj[pathItem];
            }
            return {
                items: items,
                pathItem: pathItem,
            };
        });
        return (React.createElement(Breadcrumbs$1, { "aria-label": "breadcrumb" },
            React.createElement(LevelBreadcrumb, { item: "Root", icon: React.createElement(default_1$1, { fontSize: "small" }), onSelect: function () { return setPath([]); } }),
            paths.map(function (pathPart, index) { return (React.createElement(LevelBreadcrumb, { key: pathPart.pathItem, item: pathPart.pathItem, onSelect: function (selectedItem) { return setPath(__spreadArray(__spreadArray([], __read(path.slice(0, index)), false), [selectedItem], false)); }, items: pathPart.items })); })));
    }

    var newArrayItemValue = function (subobj) {
        if (subobj.length > 0) {
            var lastItem = subobj[subobj.length - 1];
            return valueFromType(typeFromValue(lastItem));
        }
        return '';
    };
    var newObjectItemValue = function (subobj) {
        var objKeys = Object.keys(subobj);
        if (objKeys.length > 0) {
            var lastItem = subobj[objKeys[objKeys.length - 1]];
            return valueFromType(typeFromValue(lastItem));
        }
        return '';
    };
    var newObjectItemKey = function (subobj) {
        // create a new property name that uses the last property name with new number of the end
        var objKeys = Object.keys(subobj);
        var i = 1;
        var newKey = "item".concat(i);
        while (objKeys.includes(newKey)) {
            i += 1;
            newKey = "item".concat(i);
        }
        return newKey;
    };
    function Editor(_a) {
        var value = _a.value, onChange = _a.onChange;
        var _b = __read(react.exports.useState([]), 2), path = _b[0], setPath = _b[1];
        var _c = __read(react.exports.useState(value), 2), obj = _c[0], setObj = _c[1];
        var _d = __read(react.exports.useState(path[path.length - 1]), 2), propName = _d[0], setPropName = _d[1];
        react.exports.useEffect(function () {
            setPropName(path[path.length - 1]);
        }, [path]);
        react.exports.useEffect(function () {
            setObj(value);
        }, [value]);
        var setNewPropName = function () {
            var newPath = path.slice(0, path.length - 1);
            if (propName !== undefined) {
                newPath.push(propName);
            }
            var existingItem = getChild(obj, path);
            var newObj = setChild(deleteChild(obj, path), newPath, existingItem);
            setObj(newObj);
            setPath(newPath);
            onChange(newObj);
        };
        var updateObj = react.exports.useCallback(function (subobj) {
            var newObj = setChild(obj, path, subobj);
            setObj(newObj);
            onChange(newObj);
        }, [obj, path, onChange]);
        var deleteCurrent = function () {
            var newObj = deleteChild(obj, path);
            setObj(newObj);
            setPath(path.slice(0, path.length - 1));
            onChange(newObj);
        };
        return (React.createElement(Stack$1, { width: "100%", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", spacing: 2 },
            React.createElement(LevelSelector, { path: path, setPath: setPath, obj: obj }),
            React.createElement(Stack$1, { display: "flex", flex: "1", width: "100%", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", spacing: 2 },
                React.createElement(Stack$1, { display: "flex", direction: "column", justifyContent: "flex-start", alignItems: "flex-start", width: "100%", flex: "1", spacing: 2 },
                    typeof propName === 'string' ? (React.createElement(TextField$1, { size: "small", fullWidth: true, label: "Property Name", value: propName, InputLabelProps: { shrink: true }, onChange: function (e) { return setPropName(e.target.value); }, onBlur: setNewPropName })) : undefined,
                    React.createElement(ValueEditor, { newArrayItemValue: newArrayItemValue, newObjectItemValue: newObjectItemValue, newObjectItemKey: newObjectItemKey, value: getChild(obj, path), onEdit: function (index) { return setPath(__spreadArray(__spreadArray([], __read(path), false), [index], false)); }, onChange: updateObj })),
                path.length > 0 ? (React.createElement(Box$1, { width: "100%" },
                    React.createElement(Button$1, { endIcon: React.createElement(default_1$3, null), color: "error", variant: "outlined", fullWidth: true, onClick: deleteCurrent }, "Delete"))) : undefined)));
    }

    function JSONTextEditor(_a) {
        var value = _a.value, onChange = _a.onChange;
        var _b = __read(react.exports.useState(JSON.stringify(value, null, '    ')), 2), textareaValue = _b[0], setTextareaValue = _b[1];
        var _c = __read(react.exports.useState(true), 2), isValid = _c[0], setIsValid = _c[1];
        var updateValue = function (newValue) {
            setTextareaValue(newValue);
            try {
                var parsedResult = JSON.parse(newValue);
                setIsValid(true);
                onChange(parsedResult);
            }
            catch (err) {
                setIsValid(false);
            }
        };
        react.exports.useEffect(function () {
            setTextareaValue(JSON.stringify(value, null, '    '));
            setIsValid(true);
        }, [value]);
        return (React.createElement(TextField$1, { sx: {
                '& .MuiInputBase-root': {
                    flex: 1,
                },
            }, margin: "dense", fullWidth: true, style: { flex: 1, margin: 0 }, inputProps: { style: { height: '100%', overflow: 'auto' } }, error: !isValid, hiddenLabel: true, autoCorrect: "off", spellCheck: "false", autoComplete: "off", multiline: true, variant: "outlined", onChange: function (e) { return updateValue(e.target.value); }, value: textareaValue }));
    }

    exports.Editor = Editor;
    exports.JSONTextEditor = JSONTextEditor;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
